/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/base/common/async","vs/base/common/strings","vs/platform/log/common/log","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/network","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/uuid","vs/base/common/extpath","vs/base/common/glob","vs/workbench/api/common/extHostCommands","vs/workbench/services/search/common/search","vs/platform/registry/common/platform","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/process","child_process","vs/base/common/iterator","vs/base/common/hash","vs/editor/common/core/position","vs/base/common/marshalling","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/decorators","vs/base/common/assert","vs/base/common/themables","net","os","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Se=function(me){for(var e=[],C=0,T=me.length;C<T;C++)e[C]=ke[me[C]];return e};define(ke[159],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=e.$S=void 0,e.$S=!1;class C{static get(){const f=new Map,R=new Map,L=new Map,b=new Map;function y(v,S){v.has(S.detail)||v.set(S.detail,-S.timestamp)}function g(v,S){const w=v.get(S.detail);w&&(w>=0||v.set(S.detail,w+S.timestamp))}let A=[];typeof me=="function"&&typeof me.getStats=="function"&&(A=me.getStats().slice(0).sort((v,S)=>v.timestamp-S.timestamp));for(const v of A)switch(v.type){case 10:y(f,v);break;case 11:case 12:g(f,v);break;case 21:y(R,v);break;case 22:g(R,v);break;case 33:y(L,v);break;case 34:g(L,v);break;case 31:y(b,v);break;case 32:g(b,v);break}let I=0;L.forEach(v=>I+=v);function $(v){const S=[];return v.forEach((w,l)=>S.push([l,w])),S}return{amdLoad:$(f),amdInvoke:$(R),nodeRequire:$(L),nodeEval:$(b),nodeRequireTotal:I}}static toMarkdownTable(f,R){let L="";const b=[];return f.forEach((y,g)=>{b[g]=y.length}),R.forEach(y=>{y.forEach((g,A)=>{typeof g>"u"&&(g=y[A]="-");const I=g.toString().length;b[A]=Math.max(I,b[A])})}),f.forEach((y,g)=>{L+=`| ${y+" ".repeat(b[g]-y.toString().length)} `}),L+=`|
`,f.forEach((y,g)=>{L+=`| ${"-".repeat(b[g])} `}),L+=`|
`,R.forEach(y=>{y.forEach((g,A)=>{typeof g<"u"&&(L+=`| ${g+" ".repeat(b[A]-g.toString().length)} `)}),L+=`|
`}),L}}e.$T=C}),define(ke[121],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=void 0;function C(w,l,o){const i=T(w,l);if(i!==-1)return w[i]}e.$eb=C;function T(w,l,o=w.length-1){for(let i=o;i>=0;i--){const n=w[i];if(l(n))return i}return-1}e.$fb=T;function f(w,l){const o=R(w,l);return o===-1?void 0:w[o]}e.$gb=f;function R(w,l,o=0,i=w.length){let n=o,r=i;for(;n<r;){const a=Math.floor((n+r)/2);l(w[a])?n=a+1:r=a}return n-1}e.$hb=R;function L(w,l){const o=b(w,l);return o===w.length?void 0:w[o]}e.$ib=L;function b(w,l,o=0,i=w.length){let n=o,r=i;for(;n<r;){const a=Math.floor((n+r)/2);l(w[a])?r=a:n=a+1}return n}e.$jb=b;function y(w,l,o=0,i=w.length){const n=b(w,l,o,i);return n===w.length?-1:n}e.$kb=y;class g{static{this.assertInvariants=!1}constructor(l){this.e=l,this.c=0}findLastMonotonous(l){if(g.assertInvariants){if(this.d){for(const i of this.e)if(this.d(i)&&!l(i))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=l}const o=R(this.e,l,this.c);return this.c=o+1,o===-1?void 0:this.e[o]}}e.$lb=g;function A(w,l){if(w.length===0)return;let o=w[0];for(let i=1;i<w.length;i++){const n=w[i];l(n,o)>0&&(o=n)}return o}e.$mb=A;function I(w,l){if(w.length===0)return;let o=w[0];for(let i=1;i<w.length;i++){const n=w[i];l(n,o)>=0&&(o=n)}return o}e.$nb=I;function $(w,l){return A(w,(o,i)=>-l(o,i))}e.$ob=$;function v(w,l){if(w.length===0)return-1;let o=0;for(let i=1;i<w.length;i++){const n=w[i];l(n,w[o])>0&&(o=i)}return o}e.$pb=v;function S(w,l){for(const o of w){const i=l(o);if(i!==void 0)return i}}e.$qb=S}),define(ke[73],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M=e.$L=e.$K=e.$J=void 0;function C(L,b){const y=Object.create(null);for(const g of L){const A=b(g);let I=y[A];I||(I=y[A]=[]),I.push(g)}return y}e.$J=C;function T(L,b){const y=[],g=[];for(const A of L)b.has(A)||y.push(A);for(const A of b)L.has(A)||g.push(A);return{removed:y,added:g}}e.$K=T;function f(L,b){const y=[],g=[];for(const[A,I]of L)b.has(A)||y.push(I);for(const[A,I]of b)L.has(A)||g.push(I);return{removed:y,added:g}}e.$L=f;function R(L,b){const y=new Set;for(const g of b)L.has(g)&&y.add(g);return y}e.$M=R}),define(ke[59],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ph=e.$oh=e.$nh=void 0;function C(L){return(b,y,g)=>{let A=null,I=null;if(typeof g.value=="function"?(A="value",I=g.value):typeof g.get=="function"&&(A="get",I=g.get),!I)throw new Error("not supported");g[A]=L(I,y)}}function T(L,b,y){let g=null,A=null;if(typeof y.value=="function"?(g="value",A=y.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(g="get",A=y.get),!A)throw new Error("not supported");const I=`$memoize$${b}`;y[g]=function(...$){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,$)}),this[I]}}e.$nh=T;function f(L,b,y){return C((g,A)=>{const I=`$debounce$${A}`,$=`$debounce$result$${A}`;return function(...v){this[$]||(this[$]=y?y():void 0),clearTimeout(this[I]),b&&(this[$]=b(this[$],...v),v=[this[$]]),this[I]=setTimeout(()=>{g.apply(this,v),this[$]=y?y():void 0},L)}})}e.$oh=f;function R(L,b,y){return C((g,A)=>{const I=`$throttle$timer$${A}`,$=`$throttle$result$${A}`,v=`$throttle$lastRun$${A}`,S=`$throttle$pending$${A}`;return function(...w){if(this[$]||(this[$]=y?y():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),b&&(this[$]=b(this[$],...w)),this[S])return;const l=this[v]+L;l<=Date.now()?(this[v]=Date.now(),g.apply(this,[this[$]]),this[$]=y?y():void 0):(this[S]=!0,this[I]=setTimeout(()=>{this[S]=!1,this[v]=Date.now(),g.apply(this,[this[$]]),this[$]=y?y():void 0},l-Date.now()))}})}e.$ph=R}),define(ke[8],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.setUnexpectedErrorHandler=e.$W=e.$V=void 0;class C{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?n.isErrorNoTelemetry(t)?new n(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(s=>{s(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$V=C,e.$W=new C;function T(a){e.$W.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=T;function f(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Y=f;function R(a){g(a)||e.$W.onUnexpectedError(a)}e.$Z=R;function L(a){g(a)||e.$W.onUnexpectedExternalError(a)}e.$1=L;function b(a){if(a instanceof Error){const{name:t,message:s}=a,d=a.stacktrace||a.stack;return{$isError:!0,name:t,message:s,stack:d,noTelemetry:n.isErrorNoTelemetry(a)}}return a}e.$2=b;const y="Canceled";function g(a){return a instanceof A?!0:a instanceof Error&&a.name===y&&a.message===y}e.$3=g;class A extends Error{constructor(){super(y),this.name=this.message}}e.$4=A;function I(){const a=new Error(y);return a.name=a.message,a}e.$5=I;function $(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.$6=$;function v(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.$7=v;class S extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=S;function w(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.$9=w;class l extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$0=l;class o extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$$=o;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=i;class n extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof n)return t;const s=new n;return s.message=t.message,s.stack=t.stack,s}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$ab=n;class r extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,r.prototype)}}e.$bb=r}),define(ke[19],Se([1,0,8,121]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.CompareResult=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.top=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=void 0;function f(H,x=0){return H[H.length-(1+x)]}e.$rb=f;function R(H){if(H.length===0)throw new Error("Invalid tail call");return[H.slice(0,H.length-1),H[H.length-1]]}e.$sb=R;function L(H,x,Y=($e,ie)=>$e===ie){if(H===x)return!0;if(!H||!x||H.length!==x.length)return!1;for(let $e=0,ie=H.length;$e<ie;$e++)if(!Y(H[$e],x[$e]))return!1;return!0}e.$tb=L;function b(H,x){const Y=H.length-1;x<Y&&(H[x]=H[Y]),H.pop()}e.$ub=b;function y(H,x,Y){return g(H.length,$e=>Y(H[$e],x))}e.$vb=y;function g(H,x){let Y=0,$e=H-1;for(;Y<=$e;){const ie=(Y+$e)/2|0,fe=x(ie);if(fe<0)Y=ie+1;else if(fe>0)$e=ie-1;else return ie}return-(Y+1)}e.$wb=g;function A(H,x,Y){if(H=H|0,H>=x.length)throw new TypeError("invalid index");const $e=x[Math.floor(x.length*Math.random())],ie=[],fe=[],te=[];for(const de of x){const pe=Y(de,$e);pe<0?ie.push(de):pe>0?fe.push(de):te.push(de)}return H<ie.length?A(H,ie,Y):H<ie.length+te.length?te[0]:A(H-(ie.length+te.length),fe,Y)}e.$xb=A;function I(H,x){const Y=[];let $e;for(const ie of H.slice(0).sort(x))!$e||x($e[0],ie)!==0?($e=[ie],Y.push($e)):$e.push(ie);return Y}e.$yb=I;function*$(H,x){let Y,$e;for(const ie of H)$e!==void 0&&x($e,ie)?Y.push(ie):(Y&&(yield Y),Y=[ie]),$e=ie;Y&&(yield Y)}e.$zb=$;function v(H,x){for(let Y=0;Y<=H.length;Y++)x(Y===0?void 0:H[Y-1],Y===H.length?void 0:H[Y])}e.$Ab=v;function S(H,x){for(let Y=0;Y<H.length;Y++)x(Y===0?void 0:H[Y-1],H[Y],Y+1===H.length?void 0:H[Y+1])}e.$Bb=S;function w(H,x,Y){const $e=[];function ie(de,pe,Pe){if(pe===0&&Pe.length===0)return;const B=$e[$e.length-1];B&&B.start+B.deleteCount===de?(B.deleteCount+=pe,B.toInsert.push(...Pe)):$e.push({start:de,deleteCount:pe,toInsert:Pe})}let fe=0,te=0;for(;;){if(fe===H.length){ie(fe,0,x.slice(te));break}if(te===x.length){ie(fe,H.length-fe,[]);break}const de=H[fe],pe=x[te],Pe=Y(de,pe);Pe===0?(fe+=1,te+=1):Pe<0?(ie(fe,1,[]),fe+=1):Pe>0&&(ie(fe,0,[pe]),te+=1)}return $e}e.$Cb=w;function l(H,x,Y){const $e=w(H,x,Y),ie=[],fe=[];for(const te of $e)ie.push(...H.slice(te.start,te.start+te.deleteCount)),fe.push(...te.toInsert);return{removed:ie,added:fe}}e.$Db=l;function o(H,x,Y){if(Y===0)return[];const $e=H.slice(0,Y).sort(x);return n(H,x,$e,Y,H.length),$e}e.top=o;function i(H,x,Y,$e,ie){return Y===0?Promise.resolve([]):new Promise((fe,te)=>{(async()=>{const de=H.length,pe=H.slice(0,Y).sort(x);for(let Pe=Y,B=Math.min(Y+$e,de);Pe<de;Pe=B,B=Math.min(B+$e,de)){if(Pe>Y&&await new Promise(Z=>setTimeout(Z)),ie&&ie.isCancellationRequested)throw new C.$4;n(H,x,pe,Pe,B)}return pe})().then(fe,te)})}e.$Fb=i;function n(H,x,Y,$e,ie){for(const fe=Y.length;$e<ie;$e++){const te=H[$e];if(x(te,Y[fe-1])<0){Y.pop();const de=(0,T.$jb)(Y,pe=>x(te,pe)<0);Y.splice(de,0,te)}}}function r(H){return H.filter(x=>!!x)}e.$Gb=r;function a(H){let x=0;for(let Y=0;Y<H.length;Y++)H[Y]&&(H[x]=H[Y],x+=1);H.length=x}e.$Hb=a;function t(H,x,Y){H.splice(Y,0,H.splice(x,1)[0])}e.$Ib=t;function s(H){return!Array.isArray(H)||H.length===0}e.$Jb=s;function d(H){return Array.isArray(H)&&H.length>0}e.$Kb=d;function c(H,x=Y=>Y){const Y=new Set;return H.filter($e=>{const ie=x($e);return Y.has(ie)?!1:(Y.add(ie),!0)})}e.$Lb=c;function u(H){const x=new Set;return Y=>{const $e=H(Y);return x.has($e)?!1:(x.add($e),!0)}}e.$Mb=u;function h(H,x){return H.length>0?H[0]:x}e.$Nb=h;function E(H,x){return H.length>0?H[H.length-1]:x}e.$Ob=E;function D(H,x,Y=($e,ie)=>$e===ie){let $e=0;for(let ie=0,fe=Math.min(H.length,x.length);ie<fe&&Y(H[ie],x[ie]);ie++)$e++;return $e}e.$Pb=D;function m(H){return[].concat(...H)}e.$Qb=m;function p(H,x){let Y=typeof x=="number"?H:0;typeof x=="number"?Y=H:(Y=0,x=H);const $e=[];if(Y<=x)for(let ie=Y;ie<x;ie++)$e.push(ie);else for(let ie=Y;ie>x;ie--)$e.push(ie);return $e}e.$Rb=p;function k(H,x,Y){return H.reduce(($e,ie)=>($e[x(ie)]=Y?Y(ie):ie,$e),Object.create(null))}e.$Sb=k;function P(H,x){return H.push(x),()=>z(H,x)}e.$Tb=P;function z(H,x){const Y=H.indexOf(x);if(Y>-1)return H.splice(Y,1),x}e.$Ub=z;function j(H,x,Y){const $e=H.slice(0,x),ie=H.slice(x);return $e.concat(Y,ie)}e.$Vb=j;function M(H,x){let Y;if(typeof x=="number"){let $e=x;Y=()=>{const ie=Math.sin($e++)*179426549;return ie-Math.floor(ie)}}else Y=Math.random;for(let $e=H.length-1;$e>0;$e-=1){const ie=Math.floor(Y()*($e+1)),fe=H[$e];H[$e]=H[ie],H[ie]=fe}}e.$Wb=M;function O(H,x){const Y=H.indexOf(x);Y>-1&&(H.splice(Y,1),H.unshift(x))}e.$Xb=O;function F(H,x){const Y=H.indexOf(x);Y>-1&&(H.splice(Y,1),H.push(x))}e.$Yb=F;function N(H,x){for(const Y of x)H.push(Y)}e.$Zb=N;function W(H,x){return Array.isArray(H)?H.map(x):x(H)}e.$1b=W;function X(H){return Array.isArray(H)?H:[H]}e.$2b=X;function ce(H){return H[Math.floor(Math.random()*H.length)]}e.$3b=ce;function J(H,x,Y){const $e=G(H,x),ie=H.length,fe=Y.length;H.length=ie+fe;for(let te=ie-1;te>=$e;te--)H[te+fe]=H[te];for(let te=0;te<fe;te++)H[te+$e]=Y[te]}e.$4b=J;function Q(H,x,Y,$e){const ie=G(H,x);let fe=H.splice(ie,Y);return fe===void 0&&(fe=[]),J(H,ie,$e),fe}e.$5b=Q;function G(H,x){return x<0?Math.max(x+H.length,0):Math.min(x,H.length)}var oe;(function(H){function x(fe){return fe<0}H.isLessThan=x;function Y(fe){return fe<=0}H.isLessThanOrEqual=Y;function $e(fe){return fe>0}H.isGreaterThan=$e;function ie(fe){return fe===0}H.isNeitherLessOrGreaterThan=ie,H.greaterThan=1,H.lessThan=-1,H.neitherLessOrGreaterThan=0})(oe||(e.CompareResult=oe={}));function _(H,x){return(Y,$e)=>x(H(Y),H($e))}e.$6b=_;function Ee(...H){return(x,Y)=>{for(const $e of H){const ie=$e(x,Y);if(!oe.isNeitherLessOrGreaterThan(ie))return ie}return oe.neitherLessOrGreaterThan}}e.$7b=Ee;const he=(H,x)=>H-x;e.$8b=he;const q=(H,x)=>(0,e.$8b)(H?1:0,x?1:0);e.$9b=q;function U(H){return(x,Y)=>-H(x,Y)}e.$0b=U;class ne{constructor(x){this.g=x,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(x){let Y=this.c;for(;Y<this.g.length&&x(this.g[Y]);)Y++;const $e=Y===this.c?null:this.g.slice(this.c,Y);return this.c=Y,$e}takeFromEndWhile(x){let Y=this.d;for(;Y>=0&&x(this.g[Y]);)Y--;const $e=Y===this.d?null:this.g.slice(Y+1,this.d+1);return this.d=Y,$e}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const x=this.g[this.c];return this.c++,x}removeLast(){const x=this.g[this.d];return this.d--,x}takeCount(x){const Y=this.g.slice(this.c,this.c+x);return this.c+=x,Y}}e.$$b=ne;class be{static{this.empty=new be(x=>{})}constructor(x){this.iterate=x}forEach(x){this.iterate(Y=>(x(Y),!0))}toArray(){const x=[];return this.iterate(Y=>(x.push(Y),!0)),x}filter(x){return new be(Y=>this.iterate($e=>x($e)?Y($e):!0))}map(x){return new be(Y=>this.iterate($e=>Y(x($e))))}some(x){let Y=!1;return this.iterate($e=>(Y=x($e),!Y)),Y}findFirst(x){let Y;return this.iterate($e=>x($e)?(Y=$e,!1):!0),Y}findLast(x){let Y;return this.iterate($e=>(x($e)&&(Y=$e),!0)),Y}findLastMaxBy(x){let Y,$e=!0;return this.iterate(ie=>(($e||oe.isGreaterThan(x(ie,Y)))&&($e=!1,Y=ie),!0)),Y}}e.$_b=be}),define(ke[60],Se([1,0,8]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$6c=e.$5c=e.$4c=e.ok=void 0;function T(y,g){if(!y)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}e.ok=T;function f(y,g="Unreachable"){throw new Error(g)}e.$4c=f;function R(y){if(!y)throw new C.$bb("Assertion Failed")}e.$5c=R;function L(y){if(!y()){debugger;y(),(0,C.$Z)(new C.$bb("Assertion Failed"))}}e.$6c=L;function b(y,g){let A=0;for(;A<y.length-1;){const I=y[A],$=y[A+1];if(!g(I,$))return!1;A++}return!0}e.$7c=b}),define(ke[74],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=void 0;function C(T,f){const R=this;let L=!1,b;return function(){if(L)return b;if(L=!0,f)try{b=T.apply(R,arguments)}finally{f()}else b=T.apply(R,arguments);return b}}e.$cb=C}),define(ke[122],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HM=e.$GM=void 0;class C{constructor(f){this.a=f,this.b=0}nextId(){return this.a+ ++this.b}}e.$GM=C,e.$HM=new C("id#")}),define(ke[51],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var C;(function(T){function f(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}T.is=f;const R=Object.freeze([]);function L(){return R}T.empty=L;function*b(a){yield a}T.single=b;function y(a){return f(a)?a:b(a)}T.wrap=y;function g(a){return a||R}T.from=g;function*A(a){for(let t=a.length-1;t>=0;t--)yield a[t]}T.reverse=A;function I(a){return!a||a[Symbol.iterator]().next().done===!0}T.isEmpty=I;function $(a){return a[Symbol.iterator]().next().value}T.first=$;function v(a,t){for(const s of a)if(t(s))return!0;return!1}T.some=v;function S(a,t){for(const s of a)if(t(s))return s}T.find=S;function*w(a,t){for(const s of a)t(s)&&(yield s)}T.filter=w;function*l(a,t){let s=0;for(const d of a)yield t(d,s++)}T.map=l;function*o(...a){for(const t of a)for(const s of t)yield s}T.concat=o;function i(a,t,s){let d=s;for(const c of a)d=t(d,c);return d}T.reduce=i;function*n(a,t,s=a.length){for(t<0&&(t+=a.length),s<0?s+=a.length:s>a.length&&(s=a.length);t<s;t++)yield a[t]}T.slice=n;function r(a,t=Number.POSITIVE_INFINITY){const s=[];if(t===0)return[s,a];const d=a[Symbol.iterator]();for(let c=0;c<t;c++){const u=d.next();if(u.done)return[s,T.empty()];s.push(u.value)}return[s,{[Symbol.iterator](){return d}}]}T.consume=r})(C||(e.Iterable=C={}))}),define(ke[160],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var C;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(C||(e.ScanError=C={}));var T;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(T||(e.SyntaxKind=T={}));var f;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(f||(e.ParseErrorCode=f={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function L(t,s=!1){let d=0;const c=t.length;let u="",h=0,E=16,D=0;function m(O){let F=0,N=0;for(;F<O;){const W=t.charCodeAt(d);if(W>=48&&W<=57)N=N*16+W-48;else if(W>=65&&W<=70)N=N*16+W-65+10;else if(W>=97&&W<=102)N=N*16+W-97+10;else break;d++,F++}return F<O&&(N=-1),N}function p(O){d=O,u="",h=0,E=16,D=0}function k(){const O=d;if(t.charCodeAt(d)===48)d++;else for(d++;d<t.length&&g(t.charCodeAt(d));)d++;if(d<t.length&&t.charCodeAt(d)===46)if(d++,d<t.length&&g(t.charCodeAt(d)))for(d++;d<t.length&&g(t.charCodeAt(d));)d++;else return D=3,t.substring(O,d);let F=d;if(d<t.length&&(t.charCodeAt(d)===69||t.charCodeAt(d)===101))if(d++,(d<t.length&&t.charCodeAt(d)===43||t.charCodeAt(d)===45)&&d++,d<t.length&&g(t.charCodeAt(d))){for(d++;d<t.length&&g(t.charCodeAt(d));)d++;F=d}else D=3;return t.substring(O,F)}function P(){let O="",F=d;for(;;){if(d>=c){O+=t.substring(F,d),D=2;break}const N=t.charCodeAt(d);if(N===34){O+=t.substring(F,d),d++;break}if(N===92){if(O+=t.substring(F,d),d++,d>=c){D=2;break}switch(t.charCodeAt(d++)){case 34:O+='"';break;case 92:O+="\\";break;case 47:O+="/";break;case 98:O+="\b";break;case 102:O+="\f";break;case 110:O+=`
`;break;case 114:O+="\r";break;case 116:O+="	";break;case 117:{const X=m(4);X>=0?O+=String.fromCharCode(X):D=4;break}default:D=5}F=d;continue}if(N>=0&&N<=31)if(y(N)){O+=t.substring(F,d),D=2;break}else D=6;d++}return O}function z(){if(u="",D=0,h=d,d>=c)return h=c,E=17;let O=t.charCodeAt(d);if(b(O)){do d++,u+=String.fromCharCode(O),O=t.charCodeAt(d);while(b(O));return E=15}if(y(O))return d++,u+=String.fromCharCode(O),O===13&&t.charCodeAt(d)===10&&(d++,u+=`
`),E=14;switch(O){case 123:return d++,E=1;case 125:return d++,E=2;case 91:return d++,E=3;case 93:return d++,E=4;case 58:return d++,E=6;case 44:return d++,E=5;case 34:return d++,u=P(),E=10;case 47:{const F=d-1;if(t.charCodeAt(d+1)===47){for(d+=2;d<c&&!y(t.charCodeAt(d));)d++;return u=t.substring(F,d),E=12}if(t.charCodeAt(d+1)===42){d+=2;const N=c-1;let W=!1;for(;d<N;){if(t.charCodeAt(d)===42&&t.charCodeAt(d+1)===47){d+=2,W=!0;break}d++}return W||(d++,D=1),u=t.substring(F,d),E=13}return u+=String.fromCharCode(O),d++,E=16}case 45:if(u+=String.fromCharCode(O),d++,d===c||!g(t.charCodeAt(d)))return E=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=k(),E=11;default:for(;d<c&&j(O);)d++,O=t.charCodeAt(d);if(h!==d){switch(u=t.substring(h,d),u){case"true":return E=8;case"false":return E=9;case"null":return E=7}return E=16}return u+=String.fromCharCode(O),d++,E=16}}function j(O){if(b(O)||y(O))return!1;switch(O){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let O;do O=z();while(O>=12&&O<=15);return O}return{setPosition:p,getPosition:()=>d,scan:s?M:z,getToken:()=>E,getTokenValue:()=>u,getTokenOffset:()=>h,getTokenLength:()=>d-h,getTokenError:()=>D}}e.$1m=L;function b(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function g(t){return t>=48&&t<=57}var A;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(A||(A={}));function I(t,s){const d=[],c=new Object;let u;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let E=!1;function D(m,p,k,P){h.value=m,h.offset=p,h.length=k,h.type=P,h.colonOffset=void 0,u=h}try{n(t,{onObjectBegin:(m,p)=>{if(s<=m)throw c;u=void 0,E=s>m,d.push("")},onObjectProperty:(m,p,k)=>{if(s<p||(D(m,p,k,"property"),d[d.length-1]=m,s<=p+k))throw c},onObjectEnd:(m,p)=>{if(s<=m)throw c;u=void 0,d.pop()},onArrayBegin:(m,p)=>{if(s<=m)throw c;u=void 0,d.push(0)},onArrayEnd:(m,p)=>{if(s<=m)throw c;u=void 0,d.pop()},onLiteralValue:(m,p,k)=>{if(s<p||(D(m,p,k,a(m)),s<=p+k))throw c},onSeparator:(m,p,k)=>{if(s<=p)throw c;if(m===":"&&u&&u.type==="property")u.colonOffset=p,E=!1,u=void 0;else if(m===","){const P=d[d.length-1];typeof P=="number"?d[d.length-1]=P+1:(E=!0,d[d.length-1]=""),u=void 0}}})}catch(m){if(m!==c)throw m}return{path:d,previousNode:u,isAtPropertyKey:E,matches:m=>{let p=0;for(let k=0;p<m.length&&k<d.length;k++)if(m[p]===d[k]||m[p]==="*")p++;else if(m[p]!=="**")return!1;return p===m.length}}}e.$2m=I;function $(t,s=[],d=R.DEFAULT){let c=null,u=[];const h=[];function E(m){Array.isArray(u)?u.push(m):c!==null&&(u[c]=m)}return n(t,{onObjectBegin:()=>{const m={};E(m),h.push(u),u=m,c=null},onObjectProperty:m=>{c=m},onObjectEnd:()=>{u=h.pop()},onArrayBegin:()=>{const m=[];E(m),h.push(u),u=m,c=null},onArrayEnd:()=>{u=h.pop()},onLiteralValue:E,onError:(m,p,k)=>{s.push({error:m,offset:p,length:k})}},d),u[0]}e.$3m=$;function v(t,s=[],d=R.DEFAULT){let c={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(m){c.type==="property"&&(c.length=m-c.offset,c=c.parent)}function h(m){return c.children.push(m),m}n(t,{onObjectBegin:m=>{c=h({type:"object",offset:m,length:-1,parent:c,children:[]})},onObjectProperty:(m,p,k)=>{c=h({type:"property",offset:p,length:-1,parent:c,children:[]}),c.children.push({type:"string",value:m,offset:p,length:k,parent:c})},onObjectEnd:(m,p)=>{c.length=m+p-c.offset,c=c.parent,u(m+p)},onArrayBegin:(m,p)=>{c=h({type:"array",offset:m,length:-1,parent:c,children:[]})},onArrayEnd:(m,p)=>{c.length=m+p-c.offset,c=c.parent,u(m+p)},onLiteralValue:(m,p,k)=>{h({type:a(m),offset:p,length:k,parent:c,value:m}),u(p+k)},onSeparator:(m,p,k)=>{c.type==="property"&&(m===":"?c.colonOffset=p:m===","&&u(p))},onError:(m,p,k)=>{s.push({error:m,offset:p,length:k})}},d);const D=c.children[0];return D&&delete D.parent,D}e.$4m=v;function S(t,s){if(!t)return;let d=t;for(const c of s)if(typeof c=="string"){if(d.type!=="object"||!Array.isArray(d.children))return;let u=!1;for(const h of d.children)if(Array.isArray(h.children)&&h.children[0].value===c){d=h.children[1],u=!0;break}if(!u)return}else{const u=c;if(d.type!=="array"||u<0||!Array.isArray(d.children)||u>=d.children.length)return;d=d.children[u]}return d}e.$5m=S;function w(t){if(!t.parent||!t.parent.children)return[];const s=w(t.parent);if(t.parent.type==="property"){const d=t.parent.children[0].value;s.push(d)}else if(t.parent.type==="array"){const d=t.parent.children.indexOf(t);d!==-1&&s.push(d)}return s}e.$6m=w;function l(t){switch(t.type){case"array":return t.children.map(l);case"object":{const s=Object.create(null);for(const d of t.children){const c=d.children[1];c&&(s[d.children[0].value]=l(c))}return s}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$7m=l;function o(t,s,d=!1){return s>=t.offset&&s<t.offset+t.length||d&&s===t.offset+t.length}e.$8m=o;function i(t,s,d=!1){if(o(t,s,d)){const c=t.children;if(Array.isArray(c))for(let u=0;u<c.length&&c[u].offset<=s;u++){const h=i(c[u],s,d);if(h)return h}return t}}e.$9m=i;function n(t,s,d=R.DEFAULT){const c=L(t,!1);function u(_){return _?()=>_(c.getTokenOffset(),c.getTokenLength()):()=>!0}function h(_){return _?Ee=>_(Ee,c.getTokenOffset(),c.getTokenLength()):()=>!0}const E=u(s.onObjectBegin),D=h(s.onObjectProperty),m=u(s.onObjectEnd),p=u(s.onArrayBegin),k=u(s.onArrayEnd),P=h(s.onLiteralValue),z=h(s.onSeparator),j=u(s.onComment),M=h(s.onError),O=d&&d.disallowComments,F=d&&d.allowTrailingComma;function N(){for(;;){const _=c.scan();switch(c.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:O||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(_){case 12:case 13:O?W(10):j();break;case 16:W(1);break;case 15:case 14:break;default:return _}}}function W(_,Ee=[],he=[]){if(M(_),Ee.length+he.length>0){let q=c.getToken();for(;q!==17;){if(Ee.indexOf(q)!==-1){N();break}else if(he.indexOf(q)!==-1)break;q=N()}}}function X(_){const Ee=c.getTokenValue();return _?P(Ee):D(Ee),N(),!0}function ce(){switch(c.getToken()){case 11:{let _=0;try{_=JSON.parse(c.getTokenValue()),typeof _!="number"&&(W(2),_=0)}catch{W(2)}P(_);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return N(),!0}function J(){return c.getToken()!==10?(W(3,[],[2,5]),!1):(X(!1),c.getToken()===6?(z(":"),N(),oe()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function Q(){E(),N();let _=!1;for(;c.getToken()!==2&&c.getToken()!==17;){if(c.getToken()===5){if(_||W(4,[],[]),z(","),N(),c.getToken()===2&&F)break}else _&&W(6,[],[]);J()||W(4,[],[2,5]),_=!0}return m(),c.getToken()!==2?W(7,[2],[]):N(),!0}function G(){p(),N();let _=!1;for(;c.getToken()!==4&&c.getToken()!==17;){if(c.getToken()===5){if(_||W(4,[],[]),z(","),N(),c.getToken()===4&&F)break}else _&&W(6,[],[]);oe()||W(4,[],[4,5]),_=!0}return k(),c.getToken()!==4?W(8,[4],[]):N(),!0}function oe(){switch(c.getToken()){case 3:return G();case 1:return Q();case 10:return X(!0);default:return ce()}}return N(),c.getToken()===17?d.allowEmptyContent?!0:(W(4,[],[]),!1):oe()?(c.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.$0m=n;function r(t,s){const d=L(t),c=[];let u,h=0,E;do switch(E=d.getPosition(),u=d.scan(),u){case 12:case 13:case 17:h!==E&&c.push(t.substring(h,E)),s!==void 0&&c.push(d.getTokenValue().replace(/[^\r\n]/g,s)),h=d.getPosition();break}while(u!==17);return c.join("")}e.$$m=r;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$_m=a}),define(ke[48],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=void 0;class C{constructor(f){this.d=f,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(f){this.c=f}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$U=C}),define(ke[75],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=void 0;class C{static{this.Undefined=new C(void 0)}constructor(R){this.element=R,this.next=C.Undefined,this.prev=C.Undefined}}class T{constructor(){this.a=C.Undefined,this.b=C.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===C.Undefined}clear(){let R=this.a;for(;R!==C.Undefined;){const L=R.next;R.prev=C.Undefined,R.next=C.Undefined,R=L}this.a=C.Undefined,this.b=C.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,L){const b=new C(R);if(this.a===C.Undefined)this.a=b,this.b=b;else if(L){const g=this.b;this.b=b,b.prev=g,g.next=b}else{const g=this.a;this.a=b,b.next=g,g.prev=b}this.c+=1;let y=!1;return()=>{y||(y=!0,this.e(b))}}shift(){if(this.a!==C.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==C.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==C.Undefined&&R.next!==C.Undefined){const L=R.prev;L.next=R.next,R.next.prev=L}else R.prev===C.Undefined&&R.next===C.Undefined?(this.a=C.Undefined,this.b=C.Undefined):R.next===C.Undefined?(this.b=this.b.prev,this.b.next=C.Undefined):R.prev===C.Undefined&&(this.a=this.a.next,this.a.prev=C.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==C.Undefined;)yield R.element,R=R.next}}e.$2c=T}),define(ke[28],Se([1,0]),function(me,e){"use strict";var C,T,f;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.Touch=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=void 0;function R(i,n,r){let a=i.get(n);return a===void 0&&(a=r,i.set(n,a)),a}e.$wc=R;function L(i){const n=[];return i.forEach((r,a)=>{n.push(`${a} => ${r}`)}),`Map(${i.size}) {${n.join(", ")}}`}e.$xc=L;function b(i){const n=[];return i.forEach(r=>{n.push(r)}),`Set(${i.size}) {${n.join(", ")}}`}e.$yc=b;class y{constructor(n,r){this.uri=n,this.value=r}}function g(i){return Array.isArray(i)}class A{static{this.a=n=>n.toString()}constructor(n,r){if(this[C]="ResourceMap",n instanceof A)this.b=new Map(n.b),this.c=r??A.a;else if(g(n)){this.b=new Map,this.c=r??A.a;for(const[a,t]of n)this.set(a,t)}else this.b=new Map,this.c=n??A.a}set(n,r){return this.b.set(this.c(n),new y(n,r)),this}get(n){return this.b.get(this.c(n))?.value}has(n){return this.b.has(this.c(n))}get size(){return this.b.size}clear(){this.b.clear()}delete(n){return this.b.delete(this.c(n))}forEach(n,r){typeof r<"u"&&(n=n.bind(r));for(const[a,t]of this.b)n(t.value,t.uri,this)}*values(){for(const n of this.b.values())yield n.value}*keys(){for(const n of this.b.values())yield n.uri}*entries(){for(const n of this.b.values())yield[n.uri,n.value]}*[(C=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.b)yield[n.uri,n.value]}}e.$zc=A;class I{constructor(n,r){this[T]="ResourceSet",!n||typeof n=="function"?this.a=new A(n):(this.a=new A(r),n.forEach(this.add,this))}get size(){return this.a.size}add(n){return this.a.set(n,n),this}clear(){this.a.clear()}delete(n){return this.a.delete(n)}forEach(n,r){this.a.forEach((a,t)=>n.call(r,t,t,this))}has(n){return this.a.has(n)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ac=I;var $;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})($||(e.Touch=$={}));class v{constructor(){this[f]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(n){return this.a.has(n)}get(n,r=0){const a=this.a.get(n);if(a)return r!==0&&this.j(a,r),a.value}set(n,r,a=0){let t=this.a.get(n);if(t)t.value=r,a!==0&&this.j(t,a);else{switch(t={key:n,value:r,next:void 0,previous:void 0},a){case 0:this.h(t);break;case 1:this.g(t);break;case 2:this.h(t);break;default:this.h(t);break}this.a.set(n,t),this.d++}return this}delete(n){return!!this.remove(n)}remove(n){const r=this.a.get(n);if(r)return this.a.delete(n),this.i(r),this.d--,r.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const n=this.b;return this.a.delete(n.key),this.i(n),this.d--,n.value}forEach(n,r){const a=this.e;let t=this.b;for(;t;){if(r?n.bind(r)(t.value,t.key,this):n(t.value,t.key,this),this.e!==a)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const n=this,r=this.e;let a=this.b;const t={[Symbol.iterator](){return t},next(){if(n.e!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const s={value:a.key,done:!1};return a=a.next,s}else return{value:void 0,done:!0}}};return t}values(){const n=this,r=this.e;let a=this.b;const t={[Symbol.iterator](){return t},next(){if(n.e!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const s={value:a.value,done:!1};return a=a.next,s}else return{value:void 0,done:!0}}};return t}entries(){const n=this,r=this.e;let a=this.b;const t={[Symbol.iterator](){return t},next(){if(n.e!==r)throw new Error("LinkedMap got modified during iteration.");if(a){const s={value:[a.key,a.value],done:!1};return a=a.next,s}else return{value:void 0,done:!0}}};return t}[(f=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(n){if(n>=this.size)return;if(n===0){this.clear();return}let r=this.b,a=this.size;for(;r&&a>n;)this.a.delete(r.key),r=r.next,a--;this.b=r,this.d=a,r&&(r.previous=void 0),this.e++}g(n){if(!this.b&&!this.c)this.c=n;else if(this.b)n.next=this.b,this.b.previous=n;else throw new Error("Invalid list");this.b=n,this.e++}h(n){if(!this.b&&!this.c)this.b=n;else if(this.c)n.previous=this.c,this.c.next=n;else throw new Error("Invalid list");this.c=n,this.e++}i(n){if(n===this.b&&n===this.c)this.b=void 0,this.c=void 0;else if(n===this.b){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.b=n.next}else if(n===this.c){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.c=n.previous}else{const r=n.next,a=n.previous;if(!r||!a)throw new Error("Invalid list");r.previous=a,a.next=r}n.next=void 0,n.previous=void 0,this.e++}j(n,r){if(!this.b||!this.c)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(n===this.b)return;const a=n.next,t=n.previous;n===this.c?(t.next=void 0,this.c=t):(a.previous=t,t.next=a),n.previous=void 0,n.next=this.b,this.b.previous=n,this.b=n,this.e++}else if(r===2){if(n===this.c)return;const a=n.next,t=n.previous;n===this.b?(a.previous=void 0,this.b=a):(a.previous=t,t.next=a),n.next=void 0,n.previous=this.c,this.c.next=n,this.c=n,this.e++}}}toJSON(){const n=[];return this.forEach((r,a)=>{n.push([a,r])}),n}fromJSON(n){this.clear();for(const[r,a]of n)this.set(r,a)}}e.$Bc=v;class S extends v{constructor(n,r=1){super(),this.k=n,this.l=Math.min(Math.max(0,r),1)}get limit(){return this.k}set limit(n){this.k=n,this.m()}get ratio(){return this.l}set ratio(n){this.l=Math.min(Math.max(0,n),1),this.m()}get(n,r=2){return super.get(n,r)}peek(n){return super.get(n,0)}set(n,r){return super.set(n,r,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Cc=S;class w{constructor(){this.a=new Map}add(n){return this.a.set(n,(this.a.get(n)||0)+1),this}delete(n){let r=this.a.get(n)||0;return r===0?!1:(r--,r===0?this.a.delete(n):this.a.set(n,r),!0)}has(n){return this.a.has(n)}}e.$Dc=w;class l{constructor(n){if(this.a=new Map,this.b=new Map,n)for(const[r,a]of n)this.set(r,a)}clear(){this.a.clear(),this.b.clear()}set(n,r){this.a.set(n,r),this.b.set(r,n)}get(n){return this.a.get(n)}getKey(n){return this.b.get(n)}delete(n){const r=this.a.get(n);return r===void 0?!1:(this.a.delete(n),this.b.delete(r),!0)}forEach(n,r){this.a.forEach((a,t)=>{n.call(r,a,t,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Ec=l;class o{constructor(){this.a=new Map}add(n,r){let a=this.a.get(n);a||(a=new Set,this.a.set(n,a)),a.add(r)}delete(n,r){const a=this.a.get(n);a&&(a.delete(r),a.size===0&&this.a.delete(n))}forEach(n,r){const a=this.a.get(n);a&&a.forEach(r)}get(n){const r=this.a.get(n);return r||new Set}}e.$Fc=o}),define(ke[3],Se([1,0,19,73,28,74,51]),function(me,e,C,T,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=void 0;const b=!1;let y=null;class g{constructor(){this.b=new Map}static{this.a=0}c(P){let z=this.b.get(P);return z||(z={parent:null,source:null,isSingleton:!1,value:P,idx:g.a++},this.b.set(P,z)),z}trackDisposable(P){const z=this.c(P);z.source||(z.source=new Error().stack)}setParent(P,z){const j=this.c(P);j.parent=z}markAsDisposed(P){this.b.delete(P)}markAsSingleton(P){this.c(P).isSingleton=!0}f(P,z){const j=z.get(P);if(j)return j;const M=P.parent?this.f(this.c(P.parent),z):P;return z.set(P,M),M}getTrackedDisposables(){const P=new Map;return[...this.b.entries()].filter(([,j])=>j.source!==null&&!this.f(j,P).isSingleton).flatMap(([j])=>j)}computeLeakingDisposables(P=10,z){let j;if(z)j=z;else{const W=new Map,X=[...this.b.values()].filter(J=>J.source!==null&&!this.f(J,W).isSingleton);if(X.length===0)return;const ce=new Set(X.map(J=>J.value));if(j=X.filter(J=>!(J.parent&&ce.has(J.parent))),j.length===0)throw new Error("There are cyclic diposable chains!")}if(!j)return;function M(W){function X(J,Q){for(;J.length>0&&Q.some(G=>typeof G=="string"?G===J[0]:J[0].match(G));)J.shift()}const ce=W.source.split(`
`).map(J=>J.trim().replace("at ","")).filter(J=>J!=="");return X(ce,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ce.reverse()}const O=new f.$Fc;for(const W of j){const X=M(W);for(let ce=0;ce<=X.length;ce++)O.add(X.slice(0,ce).join(`
`),W)}j.sort((0,C.$6b)(W=>W.idx,C.$8b));let F="",N=0;for(const W of j.slice(0,P)){N++;const X=M(W),ce=[];for(let J=0;J<X.length;J++){let Q=X[J];Q=`(shared with ${O.get(X.slice(0,J+1).join(`
`)).size}/${j.length} leaks) at ${Q}`;const oe=O.get(X.slice(0,J).join(`
`)),_=(0,T.$J)([...oe].map(Ee=>M(Ee)[J]),Ee=>Ee);delete _[X[J]];for(const[Ee,he]of Object.entries(_))ce.unshift(`    - stacktraces of ${he.length} other leaks continue with ${Ee}`);ce.unshift(Q)}F+=`


==================== Leaking disposable ${N}/${j.length}: ${W.value.constructor.name} ====================
${ce.join(`
`)}
============================================================

`}return j.length>P&&(F+=`


... and ${j.length-P} more leaking disposables

`),{leaks:j,details:F}}}e.$Gc=g;function A(k){y=k}if(e.$Hc=A,b){const k="__is_disposable_tracked__";A(new class{trackDisposable(P){const z=new Error("Potentially leaked disposable").stack;setTimeout(()=>{P[k]||console.log(z)},3e3)}setParent(P,z){if(P&&P!==t.None)try{P[k]=!0}catch{}}markAsDisposed(P){if(P&&P!==t.None)try{P[k]=!0}catch{}}markAsSingleton(P){}})}function I(k){return y?.trackDisposable(k),k}e.$Ic=I;function $(k){y?.markAsDisposed(k)}e.$Jc=$;function v(k,P){y?.setParent(k,P)}function S(k,P){if(y)for(const z of k)y.setParent(z,P)}function w(k){return y?.markAsSingleton(k),k}e.$Kc=w;function l(k){return typeof k.dispose=="function"&&k.dispose.length===0}e.$Lc=l;function o(k){if(L.Iterable.is(k)){const P=[];for(const z of k)if(z)try{z.dispose()}catch(j){P.push(j)}if(P.length===1)throw P[0];if(P.length>1)throw new AggregateError(P,"Encountered errors while disposing of store");return Array.isArray(k)?[]:k}else if(k)return k.dispose(),k}e.$Mc=o;function i(k){for(const P of k)l(P)&&P.dispose();return[]}e.$Nc=i;function n(...k){const P=r(()=>o(k));return S(k,P),P}e.$Oc=n;function r(k){const P=I({dispose:(0,R.$cb)(()=>{$(P),k()})});return P}e.$Pc=r;class a{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,I(this)}dispose(){this.g||($(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{o(this.f)}finally{this.f.clear()}}add(P){if(!P)return P;if(P===this)throw new Error("Cannot register a disposable on itself!");return v(P,this),this.g?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(P),P}delete(P){if(P){if(P===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(P),P.dispose()}}deleteAndLeak(P){P&&this.f.has(P)&&(this.f.delete(P),v(P,null))}}e.$Qc=a;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new a,I(this),v(this.q,this)}dispose(){$(this),this.q.dispose()}B(P){if(P===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(P)}}e.$Rc=t;class s{constructor(){this.b=!1,I(this)}get value(){return this.b?void 0:this.a}set value(P){this.b||P===this.a||(this.a?.dispose(),P&&v(P,this),this.a=P)}clear(){this.value=void 0}dispose(){this.b=!0,$(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const P=this.a;return this.a=void 0,P&&v(P,null),P}}e.$Sc=s;class d{constructor(P){this.a=new s,this.b=!1,this.a.value=P}get value(){return this.a.value}set value(P){this.b||P===this.a.value||(this.a.value=P)}dispose(){this.b=!0,this.a.dispose()}}e.$Tc=d;class c{constructor(P){this.b=P,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Uc=c;class u{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(P){let z=P;return this.unset=()=>z=void 0,this.isset=()=>z!==void 0,this.dispose=()=>{z&&(z(),z=void 0,$(this))},this}}e.$Vc=u;class h{constructor(){this.a=new Map}acquire(P,...z){let j=this.a.get(P);j||(j={counter:0,object:this.b(P,...z)},this.a.set(P,j));const{object:M}=j,O=(0,R.$cb)(()=>{--j.counter===0&&(this.c(P,j.object),this.a.delete(P))});return j.counter++,{object:M,dispose:O}}}e.$Wc=h;class E{constructor(P){this.a=P}async acquire(P,...z){const j=this.a.acquire(P,...z);try{return{object:await j.object,dispose:()=>j.dispose()}}catch(M){throw j.dispose(),M}}}e.$Xc=E;class D{constructor(P){this.object=P}dispose(){}}e.$Yc=D;function m(k){const P=new a;try{k(P)}finally{P.dispose()}}e.$Zc=m;class p{constructor(){this.a=new Map,this.b=!1,I(this)}dispose(){$(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{o(this.a.values())}finally{this.a.clear()}}has(P){return this.a.has(P)}get size(){return this.a.size}get(P){return this.a.get(P)}set(P,z,j=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),j||this.a.get(P)?.dispose(),this.a.set(P,z)}deleteAndDispose(P){this.a.get(P)?.dispose(),this.a.delete(P)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$1c=p}),function(me,e){typeof define=="function"&&define.amd?define(ke[161],Se([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(me=typeof globalThis<"u"?globalThis:me||self,e(me.marked={}))}(this,function(me){"use strict";function e(x,Y){for(var $e=0;$e<Y.length;$e++){var ie=Y[$e];ie.enumerable=ie.enumerable||!1,ie.configurable=!0,"value"in ie&&(ie.writable=!0),Object.defineProperty(x,ie.key,ie)}}function C(x,Y,$e){return Y&&e(x.prototype,Y),$e&&e(x,$e),Object.defineProperty(x,"prototype",{writable:!1}),x}function T(x,Y){if(x){if(typeof x=="string")return f(x,Y);var $e=Object.prototype.toString.call(x).slice(8,-1);if($e==="Object"&&x.constructor&&($e=x.constructor.name),$e==="Map"||$e==="Set")return Array.from(x);if($e==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test($e))return f(x,Y)}}function f(x,Y){(Y==null||Y>x.length)&&(Y=x.length);for(var $e=0,ie=new Array(Y);$e<Y;$e++)ie[$e]=x[$e];return ie}function R(x,Y){var $e=typeof Symbol<"u"&&x[Symbol.iterator]||x["@@iterator"];if($e)return($e=$e.call(x)).next.bind($e);if(Array.isArray(x)||($e=T(x))||Y&&x&&typeof x.length=="number"){$e&&(x=$e);var ie=0;return function(){return ie>=x.length?{done:!0}:{done:!1,value:x[ie++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function L(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}me.defaults=L();function b(x){me.defaults=x}var y=/[&<>"']/,g=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,$={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=function(Y){return $[Y]};function S(x,Y){if(Y){if(y.test(x))return x.replace(g,v)}else if(A.test(x))return x.replace(I,v);return x}var w=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function l(x){return x.replace(w,function(Y,$e){return $e=$e.toLowerCase(),$e==="colon"?":":$e.charAt(0)==="#"?$e.charAt(1)==="x"?String.fromCharCode(parseInt($e.substring(2),16)):String.fromCharCode(+$e.substring(1)):""})}var o=/(^|[^\[])\^/g;function i(x,Y){x=typeof x=="string"?x:x.source,Y=Y||"";var $e={replace:function(fe,te){return te=te.source||te,te=te.replace(o,"$1"),x=x.replace(fe,te),$e},getRegex:function(){return new RegExp(x,Y)}};return $e}var n=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function a(x,Y,$e){if(x){var ie;try{ie=decodeURIComponent(l($e)).replace(n,"").toLowerCase()}catch{return null}if(ie.indexOf("javascript:")===0||ie.indexOf("vbscript:")===0||ie.indexOf("data:")===0)return null}Y&&!r.test($e)&&($e=u(Y,$e));try{$e=encodeURI($e).replace(/%25/g,"%")}catch{return null}return $e}var t={},s=/^[^:]+:\/*[^/]*$/,d=/^([^:]+:)[\s\S]*$/,c=/^([^:]+:\/*[^/]*)[\s\S]*$/;function u(x,Y){t[" "+x]||(s.test(x)?t[" "+x]=x+"/":t[" "+x]=m(x,"/",!0)),x=t[" "+x];var $e=x.indexOf(":")===-1;return Y.substring(0,2)==="//"?$e?Y:x.replace(d,"$1")+Y:Y.charAt(0)==="/"?$e?Y:x.replace(c,"$1")+Y:x+Y}var h={exec:function(){}};function E(x){for(var Y=1,$e,ie;Y<arguments.length;Y++){$e=arguments[Y];for(ie in $e)Object.prototype.hasOwnProperty.call($e,ie)&&(x[ie]=$e[ie])}return x}function D(x,Y){var $e=x.replace(/\|/g,function(te,de,pe){for(var Pe=!1,B=de;--B>=0&&pe[B]==="\\";)Pe=!Pe;return Pe?"|":" |"}),ie=$e.split(/ \|/),fe=0;if(ie[0].trim()||ie.shift(),ie.length>0&&!ie[ie.length-1].trim()&&ie.pop(),ie.length>Y)ie.splice(Y);else for(;ie.length<Y;)ie.push("");for(;fe<ie.length;fe++)ie[fe]=ie[fe].trim().replace(/\\\|/g,"|");return ie}function m(x,Y,$e){var ie=x.length;if(ie===0)return"";for(var fe=0;fe<ie;){var te=x.charAt(ie-fe-1);if(te===Y&&!$e)fe++;else if(te!==Y&&$e)fe++;else break}return x.slice(0,ie-fe)}function p(x,Y){if(x.indexOf(Y[1])===-1)return-1;for(var $e=x.length,ie=0,fe=0;fe<$e;fe++)if(x[fe]==="\\")fe++;else if(x[fe]===Y[0])ie++;else if(x[fe]===Y[1]&&(ie--,ie<0))return fe;return-1}function k(x){x&&x.sanitize&&!x.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(x,Y){if(Y<1)return"";for(var $e="";Y>1;)Y&1&&($e+=x),Y>>=1,x+=x;return $e+x}function z(x,Y,$e,ie){var fe=Y.href,te=Y.title?S(Y.title):null,de=x[1].replace(/\\([\[\]])/g,"$1");if(x[0].charAt(0)!=="!"){ie.state.inLink=!0;var pe={type:"link",raw:$e,href:fe,title:te,text:de,tokens:ie.inlineTokens(de)};return ie.state.inLink=!1,pe}return{type:"image",raw:$e,href:fe,title:te,text:S(de)}}function j(x,Y){var $e=x.match(/^(\s+)(?:```)/);if($e===null)return Y;var ie=$e[1];return Y.split(`
`).map(function(fe){var te=fe.match(/^\s+/);if(te===null)return fe;var de=te[0];return de.length>=ie.length?fe.slice(ie.length):fe}).join(`
`)}var M=function(){function x($e){this.options=$e||me.defaults}var Y=x.prototype;return Y.space=function(ie){var fe=this.rules.block.newline.exec(ie);if(fe&&fe[0].length>0)return{type:"space",raw:fe[0]}},Y.code=function(ie){var fe=this.rules.block.code.exec(ie);if(fe){var te=fe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:fe[0],codeBlockStyle:"indented",text:this.options.pedantic?te:m(te,`
`)}}},Y.fences=function(ie){var fe=this.rules.block.fences.exec(ie);if(fe){var te=fe[0],de=j(te,fe[3]||"");return{type:"code",raw:te,lang:fe[2]?fe[2].trim():fe[2],text:de}}},Y.heading=function(ie){var fe=this.rules.block.heading.exec(ie);if(fe){var te=fe[2].trim();if(/#$/.test(te)){var de=m(te,"#");(this.options.pedantic||!de||/ $/.test(de))&&(te=de.trim())}return{type:"heading",raw:fe[0],depth:fe[1].length,text:te,tokens:this.lexer.inline(te)}}},Y.hr=function(ie){var fe=this.rules.block.hr.exec(ie);if(fe)return{type:"hr",raw:fe[0]}},Y.blockquote=function(ie){var fe=this.rules.block.blockquote.exec(ie);if(fe){var te=fe[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:fe[0],tokens:this.lexer.blockTokens(te,[]),text:te}}},Y.list=function(ie){var fe=this.rules.block.list.exec(ie);if(fe){var te,de,pe,Pe,B,Z,re,ae,ee,ge,ye,ze,We=fe[1].trim(),et=We.length>1,Ye={type:"list",raw:"",ordered:et,start:et?+We.slice(0,-1):"",loose:!1,items:[]};We=et?"\\d{1,9}\\"+We.slice(-1):"\\"+We,this.options.pedantic&&(We=et?We:"[*+-]");for(var rt=new RegExp("^( {0,3}"+We+")((?:[	 ][^\\n]*)?(?:\\n|$))");ie&&(ze=!1,!(!(fe=rt.exec(ie))||this.rules.block.hr.test(ie)));){if(te=fe[0],ie=ie.substring(te.length),ae=fe[2].split(`
`,1)[0],ee=ie.split(`
`,1)[0],this.options.pedantic?(Pe=2,ye=ae.trimLeft()):(Pe=fe[2].search(/[^ ]/),Pe=Pe>4?1:Pe,ye=ae.slice(Pe),Pe+=fe[1].length),Z=!1,!ae&&/^ *$/.test(ee)&&(te+=ee+`
`,ie=ie.substring(ee.length+1),ze=!0),!ze)for(var nt=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Ae=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ne=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}(?:```|~~~)"),Ve=new RegExp("^ {0,"+Math.min(3,Pe-1)+"}#");ie&&(ge=ie.split(`
`,1)[0],ae=ge,this.options.pedantic&&(ae=ae.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ne.test(ae)||Ve.test(ae)||nt.test(ae)||Ae.test(ie)));){if(ae.search(/[^ ]/)>=Pe||!ae.trim())ye+=`
`+ae.slice(Pe);else if(!Z)ye+=`
`+ae;else break;!Z&&!ae.trim()&&(Z=!0),te+=ge+`
`,ie=ie.substring(ge.length+1)}Ye.loose||(re?Ye.loose=!0:/\n *\n *$/.test(te)&&(re=!0)),this.options.gfm&&(de=/^\[[ xX]\] /.exec(ye),de&&(pe=de[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),Ye.items.push({type:"list_item",raw:te,task:!!de,checked:pe,loose:!1,text:ye}),Ye.raw+=te}Ye.items[Ye.items.length-1].raw=te.trimRight(),Ye.items[Ye.items.length-1].text=ye.trimRight(),Ye.raw=Ye.raw.trimRight();var Le=Ye.items.length;for(B=0;B<Le;B++){this.lexer.state.top=!1,Ye.items[B].tokens=this.lexer.blockTokens(Ye.items[B].text,[]);var Xe=Ye.items[B].tokens.filter(function(ue){return ue.type==="space"}),le=Xe.every(function(ue){for(var Ie=ue.raw.split(""),Ke=0,Ge=R(Ie),_e;!(_e=Ge()).done;){var st=_e.value;if(st===`
`&&(Ke+=1),Ke>1)return!0}return!1});!Ye.loose&&Xe.length&&le&&(Ye.loose=!0,Ye.items[B].loose=!0)}return Ye}},Y.html=function(ie){var fe=this.rules.block.html.exec(ie);if(fe){var te={type:"html",raw:fe[0],pre:!this.options.sanitizer&&(fe[1]==="pre"||fe[1]==="script"||fe[1]==="style"),text:fe[0]};if(this.options.sanitize){var de=this.options.sanitizer?this.options.sanitizer(fe[0]):S(fe[0]);te.type="paragraph",te.text=de,te.tokens=this.lexer.inline(de)}return te}},Y.def=function(ie){var fe=this.rules.block.def.exec(ie);if(fe){fe[3]&&(fe[3]=fe[3].substring(1,fe[3].length-1));var te=fe[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:te,raw:fe[0],href:fe[2],title:fe[3]}}},Y.table=function(ie){var fe=this.rules.block.table.exec(ie);if(fe){var te={type:"table",header:D(fe[1]).map(function(re){return{text:re}}),align:fe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:fe[3]&&fe[3].trim()?fe[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(te.header.length===te.align.length){te.raw=fe[0];var de=te.align.length,pe,Pe,B,Z;for(pe=0;pe<de;pe++)/^ *-+: *$/.test(te.align[pe])?te.align[pe]="right":/^ *:-+: *$/.test(te.align[pe])?te.align[pe]="center":/^ *:-+ *$/.test(te.align[pe])?te.align[pe]="left":te.align[pe]=null;for(de=te.rows.length,pe=0;pe<de;pe++)te.rows[pe]=D(te.rows[pe],te.header.length).map(function(re){return{text:re}});for(de=te.header.length,Pe=0;Pe<de;Pe++)te.header[Pe].tokens=this.lexer.inline(te.header[Pe].text);for(de=te.rows.length,Pe=0;Pe<de;Pe++)for(Z=te.rows[Pe],B=0;B<Z.length;B++)Z[B].tokens=this.lexer.inline(Z[B].text);return te}}},Y.lheading=function(ie){var fe=this.rules.block.lheading.exec(ie);if(fe)return{type:"heading",raw:fe[0],depth:fe[2].charAt(0)==="="?1:2,text:fe[1],tokens:this.lexer.inline(fe[1])}},Y.paragraph=function(ie){var fe=this.rules.block.paragraph.exec(ie);if(fe){var te=fe[1].charAt(fe[1].length-1)===`
`?fe[1].slice(0,-1):fe[1];return{type:"paragraph",raw:fe[0],text:te,tokens:this.lexer.inline(te)}}},Y.text=function(ie){var fe=this.rules.block.text.exec(ie);if(fe)return{type:"text",raw:fe[0],text:fe[0],tokens:this.lexer.inline(fe[0])}},Y.escape=function(ie){var fe=this.rules.inline.escape.exec(ie);if(fe)return{type:"escape",raw:fe[0],text:S(fe[1])}},Y.tag=function(ie){var fe=this.rules.inline.tag.exec(ie);if(fe)return!this.lexer.state.inLink&&/^<a /i.test(fe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(fe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(fe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(fe[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:fe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):S(fe[0]):fe[0]}},Y.link=function(ie){var fe=this.rules.inline.link.exec(ie);if(fe){var te=fe[2].trim();if(!this.options.pedantic&&/^</.test(te)){if(!/>$/.test(te))return;var de=m(te.slice(0,-1),"\\");if((te.length-de.length)%2===0)return}else{var pe=p(fe[2],"()");if(pe>-1){var Pe=fe[0].indexOf("!")===0?5:4,B=Pe+fe[1].length+pe;fe[2]=fe[2].substring(0,pe),fe[0]=fe[0].substring(0,B).trim(),fe[3]=""}}var Z=fe[2],re="";if(this.options.pedantic){var ae=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Z);ae&&(Z=ae[1],re=ae[3])}else re=fe[3]?fe[3].slice(1,-1):"";return Z=Z.trim(),/^</.test(Z)&&(this.options.pedantic&&!/>$/.test(te)?Z=Z.slice(1):Z=Z.slice(1,-1)),z(fe,{href:Z&&Z.replace(this.rules.inline._escapes,"$1"),title:re&&re.replace(this.rules.inline._escapes,"$1")},fe[0],this.lexer)}},Y.reflink=function(ie,fe){var te;if((te=this.rules.inline.reflink.exec(ie))||(te=this.rules.inline.nolink.exec(ie))){var de=(te[2]||te[1]).replace(/\s+/g," ");if(de=fe[de.toLowerCase()],!de||!de.href){var pe=te[0].charAt(0);return{type:"text",raw:pe,text:pe}}return z(te,de,te[0],this.lexer)}},Y.emStrong=function(ie,fe,te){te===void 0&&(te="");var de=this.rules.inline.emStrong.lDelim.exec(ie);if(de&&!(de[3]&&te.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var pe=de[1]||de[2]||"";if(!pe||pe&&(te===""||this.rules.inline.punctuation.exec(te))){var Pe=de[0].length-1,B,Z,re=Pe,ae=0,ee=de[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ee.lastIndex=0,fe=fe.slice(-1*ie.length+Pe);(de=ee.exec(fe))!=null;)if(B=de[1]||de[2]||de[3]||de[4]||de[5]||de[6],!!B){if(Z=B.length,de[3]||de[4]){re+=Z;continue}else if((de[5]||de[6])&&Pe%3&&!((Pe+Z)%3)){ae+=Z;continue}if(re-=Z,!(re>0)){if(Z=Math.min(Z,Z+re+ae),Math.min(Pe,Z)%2){var ge=ie.slice(1,Pe+de.index+Z);return{type:"em",raw:ie.slice(0,Pe+de.index+Z+1),text:ge,tokens:this.lexer.inlineTokens(ge)}}var ye=ie.slice(2,Pe+de.index+Z-1);return{type:"strong",raw:ie.slice(0,Pe+de.index+Z+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}}}}},Y.codespan=function(ie){var fe=this.rules.inline.code.exec(ie);if(fe){var te=fe[2].replace(/\n/g," "),de=/[^ ]/.test(te),pe=/^ /.test(te)&&/ $/.test(te);return de&&pe&&(te=te.substring(1,te.length-1)),te=S(te,!0),{type:"codespan",raw:fe[0],text:te}}},Y.br=function(ie){var fe=this.rules.inline.br.exec(ie);if(fe)return{type:"br",raw:fe[0]}},Y.del=function(ie){var fe=this.rules.inline.del.exec(ie);if(fe)return{type:"del",raw:fe[0],text:fe[2],tokens:this.lexer.inlineTokens(fe[2])}},Y.autolink=function(ie,fe){var te=this.rules.inline.autolink.exec(ie);if(te){var de,pe;return te[2]==="@"?(de=S(this.options.mangle?fe(te[1]):te[1]),pe="mailto:"+de):(de=S(te[1]),pe=de),{type:"link",raw:te[0],text:de,href:pe,tokens:[{type:"text",raw:de,text:de}]}}},Y.url=function(ie,fe){var te;if(te=this.rules.inline.url.exec(ie)){var de,pe;if(te[2]==="@")de=S(this.options.mangle?fe(te[0]):te[0]),pe="mailto:"+de;else{var Pe;do Pe=te[0],te[0]=this.rules.inline._backpedal.exec(te[0])[0];while(Pe!==te[0]);de=S(te[0]),te[1]==="www."?pe="http://"+de:pe=de}return{type:"link",raw:te[0],text:de,href:pe,tokens:[{type:"text",raw:de,text:de}]}}},Y.inlineText=function(ie,fe){var te=this.rules.inline.text.exec(ie);if(te){var de;return this.lexer.state.inRawBlock?de=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(te[0]):S(te[0]):te[0]:de=S(this.options.smartypants?fe(te[0]):te[0]),{type:"text",raw:te[0],text:de}}},x}(),O={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:h,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};O._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,O._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,O.def=i(O.def).replace("label",O._label).replace("title",O._title).getRegex(),O.bullet=/(?:[*+-]|\d{1,9}[.)])/,O.listItemStart=i(/^( *)(bull) */).replace("bull",O.bullet).getRegex(),O.list=i(O.list).replace(/bull/g,O.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+O.def.source+")").getRegex(),O._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",O._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,O.html=i(O.html,"i").replace("comment",O._comment).replace("tag",O._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),O.paragraph=i(O._paragraph).replace("hr",O.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",O._tag).getRegex(),O.blockquote=i(O.blockquote).replace("paragraph",O.paragraph).getRegex(),O.normal=E({},O),O.gfm=E({},O.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),O.gfm.table=i(O.gfm.table).replace("hr",O.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",O._tag).getRegex(),O.gfm.paragraph=i(O._paragraph).replace("hr",O.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",O.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",O._tag).getRegex(),O.pedantic=E({},O.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",O._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:h,paragraph:i(O.normal._paragraph).replace("hr",O.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",O.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var F={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:h,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:h,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};F._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",F.punctuation=i(F.punctuation).replace(/punctuation/g,F._punctuation).getRegex(),F.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,F.escapedEmSt=/\\\*|\\_/g,F._comment=i(O._comment).replace("(?:-->|$)","-->").getRegex(),F.emStrong.lDelim=i(F.emStrong.lDelim).replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimAst=i(F.emStrong.rDelimAst,"g").replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimUnd=i(F.emStrong.rDelimUnd,"g").replace(/punct/g,F._punctuation).getRegex(),F._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,F._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,F._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,F.autolink=i(F.autolink).replace("scheme",F._scheme).replace("email",F._email).getRegex(),F._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,F.tag=i(F.tag).replace("comment",F._comment).replace("attribute",F._attribute).getRegex(),F._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,F._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,F._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,F.link=i(F.link).replace("label",F._label).replace("href",F._href).replace("title",F._title).getRegex(),F.reflink=i(F.reflink).replace("label",F._label).replace("ref",O._label).getRegex(),F.nolink=i(F.nolink).replace("ref",O._label).getRegex(),F.reflinkSearch=i(F.reflinkSearch,"g").replace("reflink",F.reflink).replace("nolink",F.nolink).getRegex(),F.normal=E({},F),F.pedantic=E({},F.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",F._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",F._label).getRegex()}),F.gfm=E({},F.normal,{escape:i(F.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),F.gfm.url=i(F.gfm.url,"i").replace("email",F.gfm._extended_email).getRegex(),F.breaks=E({},F.gfm,{br:i(F.br).replace("{2,}","*").getRegex(),text:i(F.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function N(x){return x.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function W(x){var Y="",$e,ie,fe=x.length;for($e=0;$e<fe;$e++)ie=x.charCodeAt($e),Math.random()>.5&&(ie="x"+ie.toString(16)),Y+="&#"+ie+";";return Y}var X=function(){function x($e){this.tokens=[],this.tokens.links=Object.create(null),this.options=$e||me.defaults,this.options.tokenizer=this.options.tokenizer||new M,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ie={block:O.normal,inline:F.normal};this.options.pedantic?(ie.block=O.pedantic,ie.inline=F.pedantic):this.options.gfm&&(ie.block=O.gfm,this.options.breaks?ie.inline=F.breaks:ie.inline=F.gfm),this.tokenizer.rules=ie}x.lex=function(ie,fe){var te=new x(fe);return te.lex(ie)},x.lexInline=function(ie,fe){var te=new x(fe);return te.inlineTokens(ie)};var Y=x.prototype;return Y.lex=function(ie){ie=ie.replace(/\r\n|\r/g,`
`),this.blockTokens(ie,this.tokens);for(var fe;fe=this.inlineQueue.shift();)this.inlineTokens(fe.src,fe.tokens);return this.tokens},Y.blockTokens=function(ie,fe){var te=this;fe===void 0&&(fe=[]),this.options.pedantic?ie=ie.replace(/\t/g,"    ").replace(/^ +$/gm,""):ie=ie.replace(/^( *)(\t+)/gm,function(re,ae,ee){return ae+"    ".repeat(ee.length)});for(var de,pe,Pe,B;ie;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(re){return(de=re.call({lexer:te},ie,fe))?(ie=ie.substring(de.raw.length),fe.push(de),!0):!1}))){if(de=this.tokenizer.space(ie)){ie=ie.substring(de.raw.length),de.raw.length===1&&fe.length>0?fe[fe.length-1].raw+=`
`:fe.push(de);continue}if(de=this.tokenizer.code(ie)){ie=ie.substring(de.raw.length),pe=fe[fe.length-1],pe&&(pe.type==="paragraph"||pe.type==="text")?(pe.raw+=`
`+de.raw,pe.text+=`
`+de.text,this.inlineQueue[this.inlineQueue.length-1].src=pe.text):fe.push(de);continue}if(de=this.tokenizer.fences(ie)){ie=ie.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.heading(ie)){ie=ie.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.hr(ie)){ie=ie.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.blockquote(ie)){ie=ie.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.list(ie)){ie=ie.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.html(ie)){ie=ie.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.def(ie)){ie=ie.substring(de.raw.length),pe=fe[fe.length-1],pe&&(pe.type==="paragraph"||pe.type==="text")?(pe.raw+=`
`+de.raw,pe.text+=`
`+de.raw,this.inlineQueue[this.inlineQueue.length-1].src=pe.text):this.tokens.links[de.tag]||(this.tokens.links[de.tag]={href:de.href,title:de.title});continue}if(de=this.tokenizer.table(ie)){ie=ie.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.lheading(ie)){ie=ie.substring(de.raw.length),fe.push(de);continue}if(Pe=ie,this.options.extensions&&this.options.extensions.startBlock&&function(){var re=1/0,ae=ie.slice(1),ee=void 0;te.options.extensions.startBlock.forEach(function(ge){ee=ge.call({lexer:this},ae),typeof ee=="number"&&ee>=0&&(re=Math.min(re,ee))}),re<1/0&&re>=0&&(Pe=ie.substring(0,re+1))}(),this.state.top&&(de=this.tokenizer.paragraph(Pe))){pe=fe[fe.length-1],B&&pe.type==="paragraph"?(pe.raw+=`
`+de.raw,pe.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=pe.text):fe.push(de),B=Pe.length!==ie.length,ie=ie.substring(de.raw.length);continue}if(de=this.tokenizer.text(ie)){ie=ie.substring(de.raw.length),pe=fe[fe.length-1],pe&&pe.type==="text"?(pe.raw+=`
`+de.raw,pe.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=pe.text):fe.push(de);continue}if(ie){var Z="Infinite loop on byte: "+ie.charCodeAt(0);if(this.options.silent){console.error(Z);break}else throw new Error(Z)}}return this.state.top=!0,fe},Y.inline=function(ie,fe){return fe===void 0&&(fe=[]),this.inlineQueue.push({src:ie,tokens:fe}),fe},Y.inlineTokens=function(ie,fe){var te=this;fe===void 0&&(fe=[]);var de,pe,Pe,B=ie,Z,re,ae;if(this.tokens.links){var ee=Object.keys(this.tokens.links);if(ee.length>0)for(;(Z=this.tokenizer.rules.inline.reflinkSearch.exec(B))!=null;)ee.includes(Z[0].slice(Z[0].lastIndexOf("[")+1,-1))&&(B=B.slice(0,Z.index)+"["+P("a",Z[0].length-2)+"]"+B.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Z=this.tokenizer.rules.inline.blockSkip.exec(B))!=null;)B=B.slice(0,Z.index)+"["+P("a",Z[0].length-2)+"]"+B.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Z=this.tokenizer.rules.inline.escapedEmSt.exec(B))!=null;)B=B.slice(0,Z.index)+"++"+B.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ie;)if(re||(ae=""),re=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ye){return(de=ye.call({lexer:te},ie,fe))?(ie=ie.substring(de.raw.length),fe.push(de),!0):!1}))){if(de=this.tokenizer.escape(ie)){ie=ie.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.tag(ie)){ie=ie.substring(de.raw.length),pe=fe[fe.length-1],pe&&de.type==="text"&&pe.type==="text"?(pe.raw+=de.raw,pe.text+=de.text):fe.push(de);continue}if(de=this.tokenizer.link(ie)){ie=ie.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.reflink(ie,this.tokens.links)){ie=ie.substring(de.raw.length),pe=fe[fe.length-1],pe&&de.type==="text"&&pe.type==="text"?(pe.raw+=de.raw,pe.text+=de.text):fe.push(de);continue}if(de=this.tokenizer.emStrong(ie,B,ae)){ie=ie.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.codespan(ie)){ie=ie.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.br(ie)){ie=ie.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.del(ie)){ie=ie.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.autolink(ie,W)){ie=ie.substring(de.raw.length),fe.push(de);continue}if(!this.state.inLink&&(de=this.tokenizer.url(ie,W))){ie=ie.substring(de.raw.length),fe.push(de);continue}if(Pe=ie,this.options.extensions&&this.options.extensions.startInline&&function(){var ye=1/0,ze=ie.slice(1),We=void 0;te.options.extensions.startInline.forEach(function(et){We=et.call({lexer:this},ze),typeof We=="number"&&We>=0&&(ye=Math.min(ye,We))}),ye<1/0&&ye>=0&&(Pe=ie.substring(0,ye+1))}(),de=this.tokenizer.inlineText(Pe,N)){ie=ie.substring(de.raw.length),de.raw.slice(-1)!=="_"&&(ae=de.raw.slice(-1)),re=!0,pe=fe[fe.length-1],pe&&pe.type==="text"?(pe.raw+=de.raw,pe.text+=de.text):fe.push(de);continue}if(ie){var ge="Infinite loop on byte: "+ie.charCodeAt(0);if(this.options.silent){console.error(ge);break}else throw new Error(ge)}}return fe},C(x,null,[{key:"rules",get:function(){return{block:O,inline:F}}}]),x}(),ce=function(){function x($e){this.options=$e||me.defaults}var Y=x.prototype;return Y.code=function(ie,fe,te){var de=(fe||"").match(/\S*/)[0];if(this.options.highlight){var pe=this.options.highlight(ie,de);pe!=null&&pe!==ie&&(te=!0,ie=pe)}return ie=ie.replace(/\n$/,"")+`
`,de?'<pre><code class="'+this.options.langPrefix+S(de,!0)+'">'+(te?ie:S(ie,!0))+`</code></pre>
`:"<pre><code>"+(te?ie:S(ie,!0))+`</code></pre>
`},Y.blockquote=function(ie){return`<blockquote>
`+ie+`</blockquote>
`},Y.html=function(ie){return ie},Y.heading=function(ie,fe,te,de){if(this.options.headerIds){var pe=this.options.headerPrefix+de.slug(te);return"<h"+fe+' id="'+pe+'">'+ie+"</h"+fe+`>
`}return"<h"+fe+">"+ie+"</h"+fe+`>
`},Y.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Y.list=function(ie,fe,te){var de=fe?"ol":"ul",pe=fe&&te!==1?' start="'+te+'"':"";return"<"+de+pe+`>
`+ie+"</"+de+`>
`},Y.listitem=function(ie){return"<li>"+ie+`</li>
`},Y.checkbox=function(ie){return"<input "+(ie?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Y.paragraph=function(ie){return"<p>"+ie+`</p>
`},Y.table=function(ie,fe){return fe&&(fe="<tbody>"+fe+"</tbody>"),`<table>
<thead>
`+ie+`</thead>
`+fe+`</table>
`},Y.tablerow=function(ie){return`<tr>
`+ie+`</tr>
`},Y.tablecell=function(ie,fe){var te=fe.header?"th":"td",de=fe.align?"<"+te+' align="'+fe.align+'">':"<"+te+">";return de+ie+("</"+te+`>
`)},Y.strong=function(ie){return"<strong>"+ie+"</strong>"},Y.em=function(ie){return"<em>"+ie+"</em>"},Y.codespan=function(ie){return"<code>"+ie+"</code>"},Y.br=function(){return this.options.xhtml?"<br/>":"<br>"},Y.del=function(ie){return"<del>"+ie+"</del>"},Y.link=function(ie,fe,te){if(ie=a(this.options.sanitize,this.options.baseUrl,ie),ie===null)return te;var de='<a href="'+S(ie)+'"';return fe&&(de+=' title="'+fe+'"'),de+=">"+te+"</a>",de},Y.image=function(ie,fe,te){if(ie=a(this.options.sanitize,this.options.baseUrl,ie),ie===null)return te;var de='<img src="'+ie+'" alt="'+te+'"';return fe&&(de+=' title="'+fe+'"'),de+=this.options.xhtml?"/>":">",de},Y.text=function(ie){return ie},x}(),J=function(){function x(){}var Y=x.prototype;return Y.strong=function(ie){return ie},Y.em=function(ie){return ie},Y.codespan=function(ie){return ie},Y.del=function(ie){return ie},Y.html=function(ie){return ie},Y.text=function(ie){return ie},Y.link=function(ie,fe,te){return""+te},Y.image=function(ie,fe,te){return""+te},Y.br=function(){return""},x}(),Q=function(){function x(){this.seen={}}var Y=x.prototype;return Y.serialize=function(ie){return ie.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Y.getNextSafeSlug=function(ie,fe){var te=ie,de=0;if(this.seen.hasOwnProperty(te)){de=this.seen[ie];do de++,te=ie+"-"+de;while(this.seen.hasOwnProperty(te))}return fe||(this.seen[ie]=de,this.seen[te]=0),te},Y.slug=function(ie,fe){fe===void 0&&(fe={});var te=this.serialize(ie);return this.getNextSafeSlug(te,fe.dryrun)},x}(),G=function(){function x($e){this.options=$e||me.defaults,this.options.renderer=this.options.renderer||new ce,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new J,this.slugger=new Q}x.parse=function(ie,fe){var te=new x(fe);return te.parse(ie)},x.parseInline=function(ie,fe){var te=new x(fe);return te.parseInline(ie)};var Y=x.prototype;return Y.parse=function(ie,fe){fe===void 0&&(fe=!0);var te="",de,pe,Pe,B,Z,re,ae,ee,ge,ye,ze,We,et,Ye,rt,nt,Ae,Ne,Ve,Le=ie.length;for(de=0;de<Le;de++){if(ye=ie[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ye.type]&&(Ve=this.options.extensions.renderers[ye.type].call({parser:this},ye),Ve!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ye.type))){te+=Ve||"";continue}switch(ye.type){case"space":continue;case"hr":{te+=this.renderer.hr();continue}case"heading":{te+=this.renderer.heading(this.parseInline(ye.tokens),ye.depth,l(this.parseInline(ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{te+=this.renderer.code(ye.text,ye.lang,ye.escaped);continue}case"table":{for(ee="",ae="",B=ye.header.length,pe=0;pe<B;pe++)ae+=this.renderer.tablecell(this.parseInline(ye.header[pe].tokens),{header:!0,align:ye.align[pe]});for(ee+=this.renderer.tablerow(ae),ge="",B=ye.rows.length,pe=0;pe<B;pe++){for(re=ye.rows[pe],ae="",Z=re.length,Pe=0;Pe<Z;Pe++)ae+=this.renderer.tablecell(this.parseInline(re[Pe].tokens),{header:!1,align:ye.align[Pe]});ge+=this.renderer.tablerow(ae)}te+=this.renderer.table(ee,ge);continue}case"blockquote":{ge=this.parse(ye.tokens),te+=this.renderer.blockquote(ge);continue}case"list":{for(ze=ye.ordered,We=ye.start,et=ye.loose,B=ye.items.length,ge="",pe=0;pe<B;pe++)rt=ye.items[pe],nt=rt.checked,Ae=rt.task,Ye="",rt.task&&(Ne=this.renderer.checkbox(nt),et?rt.tokens.length>0&&rt.tokens[0].type==="paragraph"?(rt.tokens[0].text=Ne+" "+rt.tokens[0].text,rt.tokens[0].tokens&&rt.tokens[0].tokens.length>0&&rt.tokens[0].tokens[0].type==="text"&&(rt.tokens[0].tokens[0].text=Ne+" "+rt.tokens[0].tokens[0].text)):rt.tokens.unshift({type:"text",text:Ne}):Ye+=Ne),Ye+=this.parse(rt.tokens,et),ge+=this.renderer.listitem(Ye,Ae,nt);te+=this.renderer.list(ge,ze,We);continue}case"html":{te+=this.renderer.html(ye.text);continue}case"paragraph":{te+=this.renderer.paragraph(this.parseInline(ye.tokens));continue}case"text":{for(ge=ye.tokens?this.parseInline(ye.tokens):ye.text;de+1<Le&&ie[de+1].type==="text";)ye=ie[++de],ge+=`
`+(ye.tokens?this.parseInline(ye.tokens):ye.text);te+=fe?this.renderer.paragraph(ge):ge;continue}default:{var Xe='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(Xe);return}else throw new Error(Xe)}}}return te},Y.parseInline=function(ie,fe){fe=fe||this.renderer;var te="",de,pe,Pe,B=ie.length;for(de=0;de<B;de++){if(pe=ie[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[pe.type]&&(Pe=this.options.extensions.renderers[pe.type].call({parser:this},pe),Pe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(pe.type))){te+=Pe||"";continue}switch(pe.type){case"escape":{te+=fe.text(pe.text);break}case"html":{te+=fe.html(pe.text);break}case"link":{te+=fe.link(pe.href,pe.title,this.parseInline(pe.tokens,fe));break}case"image":{te+=fe.image(pe.href,pe.title,pe.text);break}case"strong":{te+=fe.strong(this.parseInline(pe.tokens,fe));break}case"em":{te+=fe.em(this.parseInline(pe.tokens,fe));break}case"codespan":{te+=fe.codespan(pe.text);break}case"br":{te+=fe.br();break}case"del":{te+=fe.del(this.parseInline(pe.tokens,fe));break}case"text":{te+=fe.text(pe.text);break}default:{var Z='Token with "'+pe.type+'" type was not found.';if(this.options.silent){console.error(Z);return}else throw new Error(Z)}}}return te},x}();function oe(x,Y,$e){if(typeof x>"u"||x===null)throw new Error("marked(): input parameter is undefined or null");if(typeof x!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(x)+", string expected");if(typeof Y=="function"&&($e=Y,Y=null),Y=E({},oe.defaults,Y||{}),k(Y),$e){var ie=Y.highlight,fe;try{fe=X.lex(x,Y)}catch(B){return $e(B)}var te=function(Z){var re;if(!Z)try{Y.walkTokens&&oe.walkTokens(fe,Y.walkTokens),re=G.parse(fe,Y)}catch(ae){Z=ae}return Y.highlight=ie,Z?$e(Z):$e(null,re)};if(!ie||ie.length<3||(delete Y.highlight,!fe.length))return te();var de=0;oe.walkTokens(fe,function(B){B.type==="code"&&(de++,setTimeout(function(){ie(B.text,B.lang,function(Z,re){if(Z)return te(Z);re!=null&&re!==B.text&&(B.text=re,B.escaped=!0),de--,de===0&&te()})},0))}),de===0&&te();return}function pe(B){if(B.message+=`
Please report this to https://github.com/markedjs/marked.`,Y.silent)return"<p>An error occurred:</p><pre>"+S(B.message+"",!0)+"</pre>";throw B}try{var Pe=X.lex(x,Y);if(Y.walkTokens){if(Y.async)return Promise.all(oe.walkTokens(Pe,Y.walkTokens)).then(function(){return G.parse(Pe,Y)}).catch(pe);oe.walkTokens(Pe,Y.walkTokens)}return G.parse(Pe,Y)}catch(B){pe(B)}}oe.options=oe.setOptions=function(x){return E(oe.defaults,x),b(oe.defaults),oe},oe.getDefaults=L,oe.defaults=me.defaults,oe.use=function(){for(var x=arguments.length,Y=new Array(x),$e=0;$e<x;$e++)Y[$e]=arguments[$e];var ie=E.apply(void 0,[{}].concat(Y)),fe=oe.defaults.extensions||{renderers:{},childTokens:{}},te;Y.forEach(function(de){if(de.extensions&&(te=!0,de.extensions.forEach(function(Pe){if(!Pe.name)throw new Error("extension name required");if(Pe.renderer){var B=fe.renderers?fe.renderers[Pe.name]:null;B?fe.renderers[Pe.name]=function(){for(var Z=arguments.length,re=new Array(Z),ae=0;ae<Z;ae++)re[ae]=arguments[ae];var ee=Pe.renderer.apply(this,re);return ee===!1&&(ee=B.apply(this,re)),ee}:fe.renderers[Pe.name]=Pe.renderer}if(Pe.tokenizer){if(!Pe.level||Pe.level!=="block"&&Pe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");fe[Pe.level]?fe[Pe.level].unshift(Pe.tokenizer):fe[Pe.level]=[Pe.tokenizer],Pe.start&&(Pe.level==="block"?fe.startBlock?fe.startBlock.push(Pe.start):fe.startBlock=[Pe.start]:Pe.level==="inline"&&(fe.startInline?fe.startInline.push(Pe.start):fe.startInline=[Pe.start]))}Pe.childTokens&&(fe.childTokens[Pe.name]=Pe.childTokens)})),de.renderer&&function(){var Pe=oe.defaults.renderer||new ce,B=function(ae){var ee=Pe[ae];Pe[ae]=function(){for(var ge=arguments.length,ye=new Array(ge),ze=0;ze<ge;ze++)ye[ze]=arguments[ze];var We=de.renderer[ae].apply(Pe,ye);return We===!1&&(We=ee.apply(Pe,ye)),We}};for(var Z in de.renderer)B(Z);ie.renderer=Pe}(),de.tokenizer&&function(){var Pe=oe.defaults.tokenizer||new M,B=function(ae){var ee=Pe[ae];Pe[ae]=function(){for(var ge=arguments.length,ye=new Array(ge),ze=0;ze<ge;ze++)ye[ze]=arguments[ze];var We=de.tokenizer[ae].apply(Pe,ye);return We===!1&&(We=ee.apply(Pe,ye)),We}};for(var Z in de.tokenizer)B(Z);ie.tokenizer=Pe}(),de.walkTokens){var pe=oe.defaults.walkTokens;ie.walkTokens=function(Pe){var B=[];return B.push(de.walkTokens.call(this,Pe)),pe&&(B=B.concat(pe.call(this,Pe))),B}}te&&(ie.extensions=fe),oe.setOptions(ie)})},oe.walkTokens=function(x,Y){for(var $e=[],ie=function(){var pe=te.value;switch($e=$e.concat(Y.call(oe,pe)),pe.type){case"table":{for(var Pe=R(pe.header),B;!(B=Pe()).done;){var Z=B.value;$e=$e.concat(oe.walkTokens(Z.tokens,Y))}for(var re=R(pe.rows),ae;!(ae=re()).done;)for(var ee=ae.value,ge=R(ee),ye;!(ye=ge()).done;){var ze=ye.value;$e=$e.concat(oe.walkTokens(ze.tokens,Y))}break}case"list":{$e=$e.concat(oe.walkTokens(pe.items,Y));break}default:oe.defaults.extensions&&oe.defaults.extensions.childTokens&&oe.defaults.extensions.childTokens[pe.type]?oe.defaults.extensions.childTokens[pe.type].forEach(function(We){$e=$e.concat(oe.walkTokens(pe[We],Y))}):pe.tokens&&($e=$e.concat(oe.walkTokens(pe.tokens,Y)))}},fe=R(x),te;!(te=fe()).done;)ie();return $e},oe.parseInline=function(x,Y){if(typeof x>"u"||x===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof x!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(x)+", string expected");Y=E({},oe.defaults,Y||{}),k(Y);try{var $e=X.lexInline(x,Y);return Y.walkTokens&&oe.walkTokens($e,Y.walkTokens),G.parseInline($e,Y)}catch(ie){if(ie.message+=`
Please report this to https://github.com/markedjs/marked.`,Y.silent)return"<p>An error occurred:</p><pre>"+S(ie.message+"",!0)+"</pre>";throw ie}},oe.Parser=G,oe.parser=G.parse,oe.Renderer=ce,oe.TextRenderer=J,oe.Lexer=X,oe.lexer=X.lex,oe.Tokenizer=M,oe.Slugger=Q,oe.parse=oe;var _=oe.options,Ee=oe.setOptions,he=oe.use,q=oe.walkTokens,U=oe.parseInline,ne=oe,be=G.parse,H=X.lex;me.Lexer=X,me.Parser=G,me.Renderer=ce,me.Slugger=Q,me.TextRenderer=J,me.Tokenizer=M,me.getDefaults=L,me.lexer=H,me.marked=oe,me.options=_,me.parse=ne,me.parseInline=U,me.parser=be,me.setOptions=Ee,me.use=he,me.walkTokens=q,Object.defineProperty(me,"__esModule",{value:!0})}),define(ke[76],Se([1,0,28]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wl=e.$vl=e.$ul=void 0;const T=new C.$Cc(1e4);function f(g){return y(g,"NFC",T)}e.$ul=f;const R=new C.$Cc(1e4);function L(g){return y(g,"NFD",R)}e.$vl=L;const b=/[^\u0000-\u0080]/;function y(g,A,I){if(!g)return g;const $=I.get(g);if($)return $;let v;return b.test(g)?v=g.normalize(A):v=g,I.set(g,v),v}e.$wl=function(){const g=/[\u0300-\u036f]/g;return function(A){return L(A).replace(g,"")}}()}),define(ke[123],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yl=e.$Xl=e.$Wl=e.rot=e.$Ul=void 0;function C(b,y,g){return Math.min(Math.max(b,y),g)}e.$Ul=C;function T(b,y){return(y+b%y)%y}e.rot=T;class f{constructor(){this.a=0}getNext(){return this.a++}}e.$Wl=f;class R{constructor(){this.a=1,this.b=0}update(y){return this.b=this.b+(y-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Xl=R;class L{constructor(y){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(y),this.c.fill(0,0,y)}update(y){const g=this.c[this.d];return this.c[this.d]=y,this.d=(this.d+1)%this.c.length,this.e-=g,this.e+=y,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Yl=L}),function(){function me(f){const R=[];typeof f=="number"&&R.push("code/timeOrigin",f);function L(y){R.push(y,Date.now())}function b(){const y=[];for(let g=0;g<R.length;g+=2)y.push({name:R[g],startTime:R[g+1]});return y}return{mark:L,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?me():{mark(f){performance.mark(f)},getMarks(){let f=performance.timeOrigin;typeof f!="number"&&(f=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(f)}];for(const L of performance.getEntriesByType("mark"))R.push({name:L.name,startTime:Math.round(f+L.startTime)});return R}};if(typeof process=="object"){const f=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return me(f)}else return console.trace("perf-util loaded in UNKNOWN environment"),me()}function C(f){return f.MonacoPerformanceMarks||(f.MonacoPerformanceMarks=e()),f.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return C(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=C(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=C(T))}(),function(me,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var C=e();for(var T in C)(typeof exports=="object"?exports:me)[T]=C[T]}}(typeof self<"u"?self:this,function(){return function(me){var e={};function C(T){if(e[T])return e[T].exports;var f=e[T]={i:T,l:!1,exports:{}};return me[T].call(f.exports,f,f.exports,C),f.l=!0,f.exports}return C.m=me,C.c=e,C.d=function(T,f,R){C.o(T,f)||Object.defineProperty(T,f,{enumerable:!0,get:R})},C.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},C.t=function(T,f){if(1&f&&(T=C(T)),8&f||4&f&&typeof T=="object"&&T&&T.__esModule)return T;var R=Object.create(null);if(C.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:T}),2&f&&typeof T!="string")for(var L in T)C.d(R,L,function(b){return T[b]}.bind(null,L));return R},C.n=function(T){var f=T&&T.__esModule?function(){return T.default}:function(){return T};return C.d(f,"a",f),f},C.o=function(T,f){return Object.prototype.hasOwnProperty.call(T,f)},C.p="",C(C.s=0)}([function(me,e,C){(function(T){var f;e=me.exports=he,f=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var ee=Array.prototype.slice.call(arguments,0);ee.unshift("SEMVER"),console.log.apply(console,ee)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],y=e.src=[],g=0,A=g++;y[A]="0|[1-9]\\d*";var I=g++;y[I]="[0-9]+";var $=g++;y[$]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=g++;y[v]="("+y[A]+")\\.("+y[A]+")\\.("+y[A]+")";var S=g++;y[S]="("+y[I]+")\\.("+y[I]+")\\.("+y[I]+")";var w=g++;y[w]="(?:"+y[A]+"|"+y[$]+")";var l=g++;y[l]="(?:"+y[I]+"|"+y[$]+")";var o=g++;y[o]="(?:-("+y[w]+"(?:\\."+y[w]+")*))";var i=g++;y[i]="(?:-?("+y[l]+"(?:\\."+y[l]+")*))";var n=g++;y[n]="[0-9A-Za-z-]+";var r=g++;y[r]="(?:\\+("+y[n]+"(?:\\."+y[n]+")*))";var a=g++,t="v?"+y[v]+y[o]+"?"+y[r]+"?";y[a]="^"+t+"$";var s="[v=\\s]*"+y[S]+y[i]+"?"+y[r]+"?",d=g++;y[d]="^"+s+"$";var c=g++;y[c]="((?:<|>)?=?)";var u=g++;y[u]=y[I]+"|x|X|\\*";var h=g++;y[h]=y[A]+"|x|X|\\*";var E=g++;y[E]="[v=\\s]*("+y[h]+")(?:\\.("+y[h]+")(?:\\.("+y[h]+")(?:"+y[o]+")?"+y[r]+"?)?)?";var D=g++;y[D]="[v=\\s]*("+y[u]+")(?:\\.("+y[u]+")(?:\\.("+y[u]+")(?:"+y[i]+")?"+y[r]+"?)?)?";var m=g++;y[m]="^"+y[c]+"\\s*"+y[E]+"$";var p=g++;y[p]="^"+y[c]+"\\s*"+y[D]+"$";var k=g++;y[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=g++;y[P]="(?:~>?)";var z=g++;y[z]="(\\s*)"+y[P]+"\\s+",b[z]=new RegExp(y[z],"g");var j=g++;y[j]="^"+y[P]+y[E]+"$";var M=g++;y[M]="^"+y[P]+y[D]+"$";var O=g++;y[O]="(?:\\^)";var F=g++;y[F]="(\\s*)"+y[O]+"\\s+",b[F]=new RegExp(y[F],"g");var N=g++;y[N]="^"+y[O]+y[E]+"$";var W=g++;y[W]="^"+y[O]+y[D]+"$";var X=g++;y[X]="^"+y[c]+"\\s*("+s+")$|^$";var ce=g++;y[ce]="^"+y[c]+"\\s*("+t+")$|^$";var J=g++;y[J]="(\\s*)"+y[c]+"\\s*("+s+"|"+y[E]+")",b[J]=new RegExp(y[J],"g");var Q=g++;y[Q]="^\\s*("+y[E]+")\\s+-\\s+("+y[E]+")\\s*$";var G=g++;y[G]="^\\s*("+y[D]+")\\s+-\\s+("+y[D]+")\\s*$";var oe=g++;y[oe]="(<|>)?=?\\s*\\*";for(var _=0;_<35;_++)f(_,y[_]),b[_]||(b[_]=new RegExp(y[_]));function Ee(ee,ge){if(ee instanceof he)return ee;if(typeof ee!="string"||ee.length>R||!(ge?b[d]:b[a]).test(ee))return null;try{return new he(ee,ge)}catch{return null}}function he(ee,ge){if(ee instanceof he){if(ee.loose===ge)return ee;ee=ee.version}else if(typeof ee!="string")throw new TypeError("Invalid Version: "+ee);if(ee.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof he))return new he(ee,ge);f("SemVer",ee,ge),this.loose=ge;var ye=ee.trim().match(ge?b[d]:b[a]);if(!ye)throw new TypeError("Invalid Version: "+ee);if(this.raw=ee,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function(ze){if(/^[0-9]+$/.test(ze)){var We=+ze;if(We>=0&&We<L)return We}return ze}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=Ee,e.valid=function(ee,ge){var ye=Ee(ee,ge);return ye?ye.version:null},e.clean=function(ee,ge){var ye=Ee(ee.trim().replace(/^[=v]+/,""),ge);return ye?ye.version:null},e.SemVer=he,he.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},he.prototype.toString=function(){return this.version},he.prototype.compare=function(ee){return f("SemVer.compare",this.version,this.loose,ee),ee instanceof he||(ee=new he(ee,this.loose)),this.compareMain(ee)||this.comparePre(ee)},he.prototype.compareMain=function(ee){return ee instanceof he||(ee=new he(ee,this.loose)),U(this.major,ee.major)||U(this.minor,ee.minor)||U(this.patch,ee.patch)},he.prototype.comparePre=function(ee){if(ee instanceof he||(ee=new he(ee,this.loose)),this.prerelease.length&&!ee.prerelease.length)return-1;if(!this.prerelease.length&&ee.prerelease.length)return 1;if(!this.prerelease.length&&!ee.prerelease.length)return 0;var ge=0;do{var ye=this.prerelease[ge],ze=ee.prerelease[ge];if(f("prerelease compare",ge,ye,ze),ye===void 0&&ze===void 0)return 0;if(ze===void 0)return 1;if(ye===void 0)return-1;if(ye!==ze)return U(ye,ze)}while(++ge)},he.prototype.inc=function(ee,ge){switch(ee){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ge);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ge);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ge),this.inc("pre",ge);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ge),this.inc("pre",ge);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}ge&&(this.prerelease[0]===ge?isNaN(this.prerelease[1])&&(this.prerelease=[ge,0]):this.prerelease=[ge,0]);break;default:throw new Error("invalid increment argument: "+ee)}return this.format(),this.raw=this.version,this},e.inc=function(ee,ge,ye,ze){typeof ye=="string"&&(ze=ye,ye=void 0);try{return new he(ee,ye).inc(ge,ze).version}catch{return null}},e.diff=function(ee,ge){if(x(ee,ge))return null;var ye=Ee(ee),ze=Ee(ge);if(ye.prerelease.length||ze.prerelease.length){for(var We in ye)if((We==="major"||We==="minor"||We==="patch")&&ye[We]!==ze[We])return"pre"+We;return"prerelease"}for(var We in ye)if((We==="major"||We==="minor"||We==="patch")&&ye[We]!==ze[We])return We},e.compareIdentifiers=U;var q=/^[0-9]+$/;function U(ee,ge){var ye=q.test(ee),ze=q.test(ge);return ye&&ze&&(ee=+ee,ge=+ge),ye&&!ze?-1:ze&&!ye?1:ee<ge?-1:ee>ge?1:0}function ne(ee,ge,ye){return new he(ee,ye).compare(new he(ge,ye))}function be(ee,ge,ye){return ne(ee,ge,ye)>0}function H(ee,ge,ye){return ne(ee,ge,ye)<0}function x(ee,ge,ye){return ne(ee,ge,ye)===0}function Y(ee,ge,ye){return ne(ee,ge,ye)!==0}function $e(ee,ge,ye){return ne(ee,ge,ye)>=0}function ie(ee,ge,ye){return ne(ee,ge,ye)<=0}function fe(ee,ge,ye,ze){var We;switch(ge){case"===":typeof ee=="object"&&(ee=ee.version),typeof ye=="object"&&(ye=ye.version),We=ee===ye;break;case"!==":typeof ee=="object"&&(ee=ee.version),typeof ye=="object"&&(ye=ye.version),We=ee!==ye;break;case"":case"=":case"==":We=x(ee,ye,ze);break;case"!=":We=Y(ee,ye,ze);break;case">":We=be(ee,ye,ze);break;case">=":We=$e(ee,ye,ze);break;case"<":We=H(ee,ye,ze);break;case"<=":We=ie(ee,ye,ze);break;default:throw new TypeError("Invalid operator: "+ge)}return We}function te(ee,ge){if(ee instanceof te){if(ee.loose===ge)return ee;ee=ee.value}if(!(this instanceof te))return new te(ee,ge);f("comparator",ee,ge),this.loose=ge,this.parse(ee),this.semver===de?this.value="":this.value=this.operator+this.semver.version,f("comp",this)}e.rcompareIdentifiers=function(ee,ge){return U(ge,ee)},e.major=function(ee,ge){return new he(ee,ge).major},e.minor=function(ee,ge){return new he(ee,ge).minor},e.patch=function(ee,ge){return new he(ee,ge).patch},e.compare=ne,e.compareLoose=function(ee,ge){return ne(ee,ge,!0)},e.rcompare=function(ee,ge,ye){return ne(ge,ee,ye)},e.sort=function(ee,ge){return ee.sort(function(ye,ze){return e.compare(ye,ze,ge)})},e.rsort=function(ee,ge){return ee.sort(function(ye,ze){return e.rcompare(ye,ze,ge)})},e.gt=be,e.lt=H,e.eq=x,e.neq=Y,e.gte=$e,e.lte=ie,e.cmp=fe,e.Comparator=te;var de={};function pe(ee,ge){if(ee instanceof pe)return ee.loose===ge?ee:new pe(ee.raw,ge);if(ee instanceof te)return new pe(ee.value,ge);if(!(this instanceof pe))return new pe(ee,ge);if(this.loose=ge,this.raw=ee,this.set=ee.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ee);this.format()}function Pe(ee){return!ee||ee.toLowerCase()==="x"||ee==="*"}function B(ee,ge,ye,ze,We,et,Ye,rt,nt,Ae,Ne,Ve,Le){return((ge=Pe(ye)?"":Pe(ze)?">="+ye+".0.0":Pe(We)?">="+ye+"."+ze+".0":">="+ge)+" "+(rt=Pe(nt)?"":Pe(Ae)?"<"+(+nt+1)+".0.0":Pe(Ne)?"<"+nt+"."+(+Ae+1)+".0":Ve?"<="+nt+"."+Ae+"."+Ne+"-"+Ve:"<="+rt)).trim()}function Z(ee,ge){for(var ye=0;ye<ee.length;ye++)if(!ee[ye].test(ge))return!1;if(ge.prerelease.length){for(ye=0;ye<ee.length;ye++)if(f(ee[ye].semver),ee[ye].semver!==de&&ee[ye].semver.prerelease.length>0){var ze=ee[ye].semver;if(ze.major===ge.major&&ze.minor===ge.minor&&ze.patch===ge.patch)return!0}return!1}return!0}function re(ee,ge,ye){try{ge=new pe(ge,ye)}catch{return!1}return ge.test(ee)}function ae(ee,ge,ye,ze){var We,et,Ye,rt,nt;switch(ee=new he(ee,ze),ge=new pe(ge,ze),ye){case">":We=be,et=ie,Ye=H,rt=">",nt=">=";break;case"<":We=H,et=$e,Ye=be,rt="<",nt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(re(ee,ge,ze))return!1;for(var Ae=0;Ae<ge.set.length;++Ae){var Ne=ge.set[Ae],Ve=null,Le=null;if(Ne.forEach(function(Xe){Xe.semver===de&&(Xe=new te(">=0.0.0")),Ve=Ve||Xe,Le=Le||Xe,We(Xe.semver,Ve.semver,ze)?Ve=Xe:Ye(Xe.semver,Le.semver,ze)&&(Le=Xe)}),Ve.operator===rt||Ve.operator===nt||(!Le.operator||Le.operator===rt)&&et(ee,Le.semver)||Le.operator===nt&&Ye(ee,Le.semver))return!1}return!0}te.prototype.parse=function(ee){var ge=this.loose?b[X]:b[ce],ye=ee.match(ge);if(!ye)throw new TypeError("Invalid comparator: "+ee);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new he(ye[2],this.loose):this.semver=de},te.prototype.toString=function(){return this.value},te.prototype.test=function(ee){return f("Comparator.test",ee,this.loose),this.semver===de||(typeof ee=="string"&&(ee=new he(ee,this.loose)),fe(ee,this.operator,this.semver,this.loose))},te.prototype.intersects=function(ee,ge){if(!(ee instanceof te))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new pe(ee.value,ge),re(this.value,ye,ge);if(ee.operator==="")return ye=new pe(this.value,ge),re(ee.semver,ye,ge);var ze=!(this.operator!==">="&&this.operator!==">"||ee.operator!==">="&&ee.operator!==">"),We=!(this.operator!=="<="&&this.operator!=="<"||ee.operator!=="<="&&ee.operator!=="<"),et=this.semver.version===ee.semver.version,Ye=!(this.operator!==">="&&this.operator!=="<="||ee.operator!==">="&&ee.operator!=="<="),rt=fe(this.semver,"<",ee.semver,ge)&&(this.operator===">="||this.operator===">")&&(ee.operator==="<="||ee.operator==="<"),nt=fe(this.semver,">",ee.semver,ge)&&(this.operator==="<="||this.operator==="<")&&(ee.operator===">="||ee.operator===">");return ze||We||et&&Ye||rt||nt},e.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(ee){return ee.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(ee){var ge=this.loose;ee=ee.trim(),f("range",ee,ge);var ye=ge?b[G]:b[Q];ee=ee.replace(ye,B),f("hyphen replace",ee),ee=ee.replace(b[J],"$1$2$3"),f("comparator trim",ee,b[J]),ee=(ee=(ee=ee.replace(b[z],"$1~")).replace(b[F],"$1^")).split(/\s+/).join(" ");var ze=ge?b[X]:b[ce],We=ee.split(" ").map(function(et){return function(Ye,rt){return f("comp",Ye),Ye=function(nt,Ae){return nt.trim().split(/\s+/).map(function(Ne){return function(Ve,Le){f("caret",Ve,Le);var Xe=Le?b[W]:b[N];return Ve.replace(Xe,function(le,ue,Ie,Ke,Ge){var _e;return f("caret",Ve,le,ue,Ie,Ke,Ge),Pe(ue)?_e="":Pe(Ie)?_e=">="+ue+".0.0 <"+(+ue+1)+".0.0":Pe(Ke)?_e=ue==="0"?">="+ue+"."+Ie+".0 <"+ue+"."+(+Ie+1)+".0":">="+ue+"."+Ie+".0 <"+(+ue+1)+".0.0":Ge?(f("replaceCaret pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),_e=ue==="0"?Ie==="0"?">="+ue+"."+Ie+"."+Ke+Ge+" <"+ue+"."+Ie+"."+(+Ke+1):">="+ue+"."+Ie+"."+Ke+Ge+" <"+ue+"."+(+Ie+1)+".0":">="+ue+"."+Ie+"."+Ke+Ge+" <"+(+ue+1)+".0.0"):(f("no pr"),_e=ue==="0"?Ie==="0"?">="+ue+"."+Ie+"."+Ke+" <"+ue+"."+Ie+"."+(+Ke+1):">="+ue+"."+Ie+"."+Ke+" <"+ue+"."+(+Ie+1)+".0":">="+ue+"."+Ie+"."+Ke+" <"+(+ue+1)+".0.0"),f("caret return",_e),_e})}(Ne,Ae)}).join(" ")}(Ye,rt),f("caret",Ye),Ye=function(nt,Ae){return nt.trim().split(/\s+/).map(function(Ne){return function(Ve,Le){var Xe=Le?b[M]:b[j];return Ve.replace(Xe,function(le,ue,Ie,Ke,Ge){var _e;return f("tilde",Ve,le,ue,Ie,Ke,Ge),Pe(ue)?_e="":Pe(Ie)?_e=">="+ue+".0.0 <"+(+ue+1)+".0.0":Pe(Ke)?_e=">="+ue+"."+Ie+".0 <"+ue+"."+(+Ie+1)+".0":Ge?(f("replaceTilde pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),_e=">="+ue+"."+Ie+"."+Ke+Ge+" <"+ue+"."+(+Ie+1)+".0"):_e=">="+ue+"."+Ie+"."+Ke+" <"+ue+"."+(+Ie+1)+".0",f("tilde return",_e),_e})}(Ne,Ae)}).join(" ")}(Ye,rt),f("tildes",Ye),Ye=function(nt,Ae){return f("replaceXRanges",nt,Ae),nt.split(/\s+/).map(function(Ne){return function(Ve,Le){Ve=Ve.trim();var Xe=Le?b[p]:b[m];return Ve.replace(Xe,function(le,ue,Ie,Ke,Ge,_e){f("xRange",Ve,le,ue,Ie,Ke,Ge,_e);var st=Pe(Ie),lt=st||Pe(Ke),wt=lt||Pe(Ge);return ue==="="&&wt&&(ue=""),st?le=ue===">"||ue==="<"?"<0.0.0":"*":ue&&wt?(lt&&(Ke=0),wt&&(Ge=0),ue===">"?(ue=">=",lt?(Ie=+Ie+1,Ke=0,Ge=0):wt&&(Ke=+Ke+1,Ge=0)):ue==="<="&&(ue="<",lt?Ie=+Ie+1:Ke=+Ke+1),le=ue+Ie+"."+Ke+"."+Ge):lt?le=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":wt&&(le=">="+Ie+"."+Ke+".0 <"+Ie+"."+(+Ke+1)+".0"),f("xRange return",le),le})}(Ne,Ae)}).join(" ")}(Ye,rt),f("xrange",Ye),Ye=function(nt,Ae){return f("replaceStars",nt,Ae),nt.trim().replace(b[oe],"")}(Ye,rt),f("stars",Ye),Ye}(et,ge)}).join(" ").split(/\s+/);return this.loose&&(We=We.filter(function(et){return!!et.match(ze)})),We=We.map(function(et){return new te(et,ge)})},pe.prototype.intersects=function(ee,ge){if(!(ee instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function(ze){return ee.set.some(function(We){return We.every(function(et){return ze.intersects(et,ge)})})})})},e.toComparators=function(ee,ge){return new pe(ee,ge).set.map(function(ye){return ye.map(function(ze){return ze.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(ee){if(!ee)return!1;typeof ee=="string"&&(ee=new he(ee,this.loose));for(var ge=0;ge<this.set.length;ge++)if(Z(this.set[ge],ee))return!0;return!1},e.satisfies=re,e.maxSatisfying=function(ee,ge,ye){var ze=null,We=null;try{var et=new pe(ge,ye)}catch{return null}return ee.forEach(function(Ye){et.test(Ye)&&(ze&&We.compare(Ye)!==-1||(We=new he(ze=Ye,ye)))}),ze},e.minSatisfying=function(ee,ge,ye){var ze=null,We=null;try{var et=new pe(ge,ye)}catch{return null}return ee.forEach(function(Ye){et.test(Ye)&&(ze&&We.compare(Ye)!==1||(We=new he(ze=Ye,ye)))}),ze},e.validRange=function(ee,ge){try{return new pe(ee,ge).range||"*"}catch{return null}},e.ltr=function(ee,ge,ye){return ae(ee,ge,"<",ye)},e.gtr=function(ee,ge,ye){return ae(ee,ge,">",ye)},e.outside=ae,e.prerelease=function(ee,ge){var ye=Ee(ee,ge);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function(ee,ge,ye){return ee=new pe(ee,ye),ge=new pe(ge,ye),ee.intersects(ge)},e.coerce=function(ee){if(ee instanceof he)return ee;if(typeof ee!="string")return null;var ge=ee.match(b[k]);return ge==null?null:Ee((ge[1]||"0")+"."+(ge[2]||"0")+"."+(ge[3]||"0"))}}).call(this,C(1))},function(me,e){var C,T,f=me.exports={};function R(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function b(l){if(C===setTimeout)return setTimeout(l,0);if((C===R||!C)&&setTimeout)return C=setTimeout,setTimeout(l,0);try{return C(l,0)}catch{try{return C.call(null,l,0)}catch{return C.call(this,l,0)}}}(function(){try{C=typeof setTimeout=="function"?setTimeout:R}catch{C=R}try{T=typeof clearTimeout=="function"?clearTimeout:L}catch{T=L}})();var y,g=[],A=!1,I=-1;function $(){A&&y&&(A=!1,y.length?g=y.concat(g):I=-1,g.length&&v())}function v(){if(!A){var l=b($);A=!0;for(var o=g.length;o;){for(y=g,g=[];++I<o;)y&&y[I].run();I=-1,o=g.length}y=null,A=!1,function(i){if(T===clearTimeout)return clearTimeout(i);if((T===L||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(i);try{T(i)}catch{try{return T.call(null,i)}catch{return T.call(this,i)}}}(l)}}function S(l,o){this.fun=l,this.array=o}function w(){}f.nextTick=function(l){var o=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)o[i-1]=arguments[i];g.push(new S(l,o)),g.length!==1||A||b(v)},S.prototype.run=function(){this.fun.apply(null,this.array)},f.title="browser",f.browser=!0,f.env={},f.argv=[],f.version="",f.versions={},f.on=w,f.addListener=w,f.once=w,f.off=w,f.removeListener=w,f.removeAllListeners=w,f.emit=w,f.prependListener=w,f.prependOnceListener=w,f.listeners=function(l){return[]},f.binding=function(l){throw new Error("process.binding is not supported")},f.cwd=function(){return"/"},f.chdir=function(l){throw new Error("process.chdir is not supported")},f.umask=function(){return 0}}])}),define(ke[38],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nd=void 0;const C=globalThis.performance&&typeof globalThis.performance.now=="function";class T{static create(R){return new T(R)}constructor(R){this.c=C&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Nd=T}),define(ke[4],Se([1,0,8,74,3,75,38]),function(me,e,C,T,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.Event=void 0;const b=!1,y=!1;var g;(function(m){m.None=()=>f.$Rc.None;function p(fe){if(y){const{onDidAddListener:te}=fe,de=S.create();let pe=0;fe.onDidAddListener=()=>{++pe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),de.print()),te?.()}}}function k(fe,te){return ce(fe,()=>{},0,void 0,!0,void 0,te)}m.defer=k;function P(fe){return(te,de=null,pe)=>{let Pe=!1,B;return B=fe(Z=>{if(!Pe)return B?B.dispose():Pe=!0,te.call(de,Z)},null,pe),Pe&&B.dispose(),B}}m.once=P;function z(fe,te,de){return W((pe,Pe=null,B)=>fe(Z=>pe.call(Pe,te(Z)),null,B),de)}m.map=z;function j(fe,te,de){return W((pe,Pe=null,B)=>fe(Z=>{te(Z),pe.call(Pe,Z)},null,B),de)}m.forEach=j;function M(fe,te,de){return W((pe,Pe=null,B)=>fe(Z=>te(Z)&&pe.call(Pe,Z),null,B),de)}m.filter=M;function O(fe){return fe}m.signal=O;function F(...fe){return(te,de=null,pe)=>{const Pe=(0,f.$Oc)(...fe.map(B=>B(Z=>te.call(de,Z))));return X(Pe,pe)}}m.any=F;function N(fe,te,de,pe){let Pe=de;return z(fe,B=>(Pe=te(Pe,B),Pe),pe)}m.reduce=N;function W(fe,te){let de;const pe={onWillAddFirstListener(){de=fe(Pe.fire,Pe)},onDidRemoveLastListener(){de?.dispose()}};te||p(pe);const Pe=new n(pe);return te?.add(Pe),Pe.event}function X(fe,te){return te instanceof Array?te.push(fe):te&&te.add(fe),fe}function ce(fe,te,de=100,pe=!1,Pe=!1,B,Z){let re,ae,ee,ge=0,ye;const ze={leakWarningThreshold:B,onWillAddFirstListener(){re=fe(et=>{ge++,ae=te(ae,et),pe&&!ee&&(We.fire(ae),ae=void 0),ye=()=>{const Ye=ae;ae=void 0,ee=void 0,(!pe||ge>1)&&We.fire(Ye),ge=0},typeof de=="number"?(clearTimeout(ee),ee=setTimeout(ye,de)):ee===void 0&&(ee=0,queueMicrotask(ye))})},onWillRemoveListener(){Pe&&ge>0&&ye?.()},onDidRemoveLastListener(){ye=void 0,re.dispose()}};Z||p(ze);const We=new n(ze);return Z?.add(We),We.event}m.debounce=ce;function J(fe,te=0,de){return m.debounce(fe,(pe,Pe)=>pe?(pe.push(Pe),pe):[Pe],te,void 0,!0,void 0,de)}m.accumulate=J;function Q(fe,te=(pe,Pe)=>pe===Pe,de){let pe=!0,Pe;return M(fe,B=>{const Z=pe||!te(B,Pe);return pe=!1,Pe=B,Z},de)}m.latch=Q;function G(fe,te,de){return[m.filter(fe,te,de),m.filter(fe,pe=>!te(pe),de)]}m.split=G;function oe(fe,te=!1,de=[],pe){let Pe=de.slice(),B=fe(ae=>{Pe?Pe.push(ae):re.fire(ae)});pe&&pe.add(B);const Z=()=>{Pe?.forEach(ae=>re.fire(ae)),Pe=null},re=new n({onWillAddFirstListener(){B||(B=fe(ae=>re.fire(ae)),pe&&pe.add(B))},onDidAddFirstListener(){Pe&&(te?setTimeout(Z):Z())},onDidRemoveLastListener(){B&&B.dispose(),B=null}});return pe&&pe.add(re),re.event}m.buffer=oe;function _(fe,te){return(pe,Pe,B)=>{const Z=te(new he);return fe(function(re){const ae=Z.evaluate(re);ae!==Ee&&pe.call(Pe,ae)},void 0,B)}}m.chain=_;const Ee=Symbol("HaltChainable");class he{constructor(){this.f=[]}map(te){return this.f.push(te),this}forEach(te){return this.f.push(de=>(te(de),de)),this}filter(te){return this.f.push(de=>te(de)?de:Ee),this}reduce(te,de){let pe=de;return this.f.push(Pe=>(pe=te(pe,Pe),pe)),this}latch(te=(de,pe)=>de===pe){let de=!0,pe;return this.f.push(Pe=>{const B=de||!te(Pe,pe);return de=!1,pe=Pe,B?Pe:Ee}),this}evaluate(te){for(const de of this.f)if(te=de(te),te===Ee)break;return te}}function q(fe,te,de=pe=>pe){const pe=(...re)=>Z.fire(de(...re)),Pe=()=>fe.on(te,pe),B=()=>fe.removeListener(te,pe),Z=new n({onWillAddFirstListener:Pe,onDidRemoveLastListener:B});return Z.event}m.fromNodeEventEmitter=q;function U(fe,te,de=pe=>pe){const pe=(...re)=>Z.fire(de(...re)),Pe=()=>fe.addEventListener(te,pe),B=()=>fe.removeEventListener(te,pe),Z=new n({onWillAddFirstListener:Pe,onDidRemoveLastListener:B});return Z.event}m.fromDOMEventEmitter=U;function ne(fe){return new Promise(te=>P(fe)(te))}m.toPromise=ne;function be(fe){const te=new n;return fe.then(de=>{te.fire(de)},()=>{te.fire(void 0)}).finally(()=>{te.dispose()}),te.event}m.fromPromise=be;function H(fe,te,de){return te(de),fe(pe=>te(pe))}m.runAndSubscribe=H;function x(fe,te){let de=null;function pe(B){de?.dispose(),de=new f.$Qc,te(B,de)}pe(void 0);const Pe=fe(B=>pe(B));return(0,f.$Pc)(()=>{Pe.dispose(),de?.dispose()})}m.runAndSubscribeWithStore=x;class Y{constructor(te,de){this._observable=te,this.f=0,this.g=!1;const pe={onWillAddFirstListener:()=>{te.addObserver(this)},onDidRemoveLastListener:()=>{te.removeObserver(this)}};de||p(pe),this.emitter=new n(pe),de&&de.add(this.emitter)}beginUpdate(te){this.f++}handlePossibleChange(te){}handleChange(te,de){this.g=!0}endUpdate(te){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function $e(fe,te){return new Y(fe,te).emitter.event}m.fromObservable=$e;function ie(fe){return te=>{let de=0,pe=!1;const Pe={beginUpdate(){de++},endUpdate(){de--,de===0&&(fe.reportChanges(),pe&&(pe=!1,te()))},handlePossibleChange(){},handleChange(){pe=!0}};return fe.addObserver(Pe),fe.reportChanges(),{dispose(){fe.removeObserver(Pe)}}}}m.fromObservableLight=ie})(g||(e.Event=g={}));class A{static{this.all=new Set}static{this.f=0}constructor(p){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${p}_${A.f++}`,A.all.add(this)}start(p){this.g=new L.$Nd,this.listenerCount=p}stop(){if(this.g){const p=this.g.elapsed();this.durations.push(p),this.elapsedOverall+=p,this.invocationCount+=1,this.g=void 0}}}e.$Pd=A;let I=-1;function $(m){const p=I;return I=m,{dispose(){I=p}}}e.$Qd=$;class v{constructor(p,k=Math.random().toString(18).slice(2,5)){this.threshold=p,this.name=k,this.g=0}dispose(){this.f?.clear()}check(p,k){const P=this.threshold;if(P<=0||k<P)return;this.f||(this.f=new Map);const z=this.f.get(p.value)||0;if(this.f.set(p.value,z+1),this.g-=1,this.g<=0){this.g=P*.5;let j,M=0;for(const[O,F]of this.f)(!j||M<F)&&(j=O,M=F);console.warn(`[${this.name}] potential listener LEAK detected, having ${k} listeners already. MOST frequent listener (${M}):`),console.warn(j)}return()=>{const j=this.f.get(p.value)||0;this.f.set(p.value,j-1)}}}class S{static create(){return new S(new Error().stack??"")}constructor(p){this.value=p}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let w=0;class l{constructor(p){this.value=p,this.id=w++}}const o=2,i=(m,p)=>{if(m instanceof l)p(m);else for(let k=0;k<m.length;k++){const P=m[k];P&&p(P)}};class n{constructor(p){this.w=0,this.f=p,this.g=I>0||this.f?.leakWarningThreshold?new v(this.f?.leakWarningThreshold??I):void 0,this.j=this.f?._profName?new A(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(b){const p=this.t;queueMicrotask(()=>{i(p,k=>k.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(p,k,P)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),f.$Rc.None;if(this.m)return f.$Rc.None;k&&(p=p.bind(k));const z=new l(p);let j,M;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(z.stack=S.create(),j=this.g.check(z.stack,this.w+1)),b&&(z.stack=M??S.create()),this.t?this.t instanceof l?(this.u??=new a,this.t=[this.t,z]):this.t.push(z):(this.f?.onWillAddFirstListener?.(this),this.t=z,this.f?.onDidAddFirstListener?.(this)),this.w++;const O=(0,f.$Pc)(()=>{j?.(),this.x(z)});return P instanceof f.$Qc?P.add(O):Array.isArray(P)&&P.push(O),O},this.q}x(p){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const k=this.t,P=k.indexOf(p);if(P===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,k[P]=void 0;const z=this.u.current===this;if(this.w*o<=k.length){let j=0;for(let M=0;M<k.length;M++)k[M]?k[j++]=k[M]:z&&(this.u.end--,j<this.u.i&&this.u.i--);k.length=j}}y(p,k){if(!p)return;const P=this.f?.onListenerError||C.$Z;if(!P){p.value(k);return}try{p.value(k)}catch(z){P(z)}}z(p){const k=p.current.t;for(;p.i<p.end;)this.y(k[p.i++],p.value);p.reset()}fire(p){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof l)this.y(this.t,p);else{const k=this.u;k.enqueue(this,p,this.t.length),this.z(k)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Rd=n;const r=()=>new a;e.$Sd=r;class a{constructor(){this.i=-1,this.end=0}enqueue(p,k,P){this.i=0,this.end=P,this.current=p,this.value=k}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends n{async fireAsync(p,k,P){if(this.t)for(this.h||(this.h=new R.$2c),i(this.t,z=>this.h.push([z.value,p]));this.h.size>0&&!k.isCancellationRequested;){const[z,j]=this.h.shift(),M=[],O={...j,token:k,waitUntil:F=>{if(Object.isFrozen(M))throw new Error("waitUntil can NOT be called asynchronous");P&&(F=P(F,z)),M.push(F)}};try{z(O)}catch(F){(0,C.$Z)(F);continue}Object.freeze(M),await Promise.allSettled(M).then(F=>{for(const N of F)N.status==="rejected"&&(0,C.$Z)(N.reason)})}}}e.$Td=t;class s extends n{get isPaused(){return this.h!==0}constructor(p){super(p),this.h=0,this.s=new R.$2c,this.A=p?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const p=Array.from(this.s);this.s.clear(),super.fire(this.A(p))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(p){this.w&&(this.h!==0?this.s.push(p):super.fire(p))}}e.$Ud=s;class d extends s{constructor(p){super(p),this.k=p.delay??100}fire(p){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(p)}}e.$Vd=d;class c extends n{constructor(p){super(p),this.h=[],this.k=p?.merge}fire(p){this.hasListeners()&&(this.h.push(p),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(k=>super.fire(k)),this.h=[]}))}}e.$Wd=c;class u{constructor(){this.g=!1,this.h=[],this.f=new n({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(p){const k={event:p,listener:null};this.h.push(k),this.g&&this.m(k);const P=()=>{this.g&&this.o(k);const z=this.h.indexOf(k);this.h.splice(z,1)};return(0,f.$Pc)((0,T.$cb)(P))}j(){this.g=!0,this.h.forEach(p=>this.m(p))}k(){this.g=!1,this.h.forEach(p=>this.o(p))}m(p){p.listener=p.event(k=>this.f.fire(k))}o(p){p.listener&&p.listener.dispose(),p.listener=null}dispose(){this.f.dispose()}}e.$Xd=u;class h{constructor(p,k,P,z){this.f=new f.$Qc;const j=this.f.add(new u),M=this.f.add(new f.$1c);function O(F){M.set(F,j.add(z(F)))}for(const F of p)O(F);this.f.add(k(F=>{O(F)})),this.f.add(P(F=>{M.deleteAndDispose(F)})),this.event=j.event}dispose(){this.f.dispose()}}e.$Yd=h;class E{constructor(){this.f=[]}wrapEvent(p){return(k,P,z)=>p(j=>{const M=this.f[this.f.length-1];M?M.push(()=>k.call(P,j)):k.call(P,j)},void 0,z)}bufferEvents(p){const k=[];this.f.push(k);const P=p();return this.f.pop(),k.forEach(z=>z()),P}}e.$Zd=E;class D{constructor(){this.f=!1,this.g=g.None,this.h=f.$Rc.None,this.j=new n({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(p){this.g=p,this.f&&(this.h.dispose(),this.h=p(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$1d=D}),define(ke[21],Se([1,0,4]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2d=e.CancellationToken=void 0;const T=Object.freeze(function(b,y){const g=setTimeout(b.bind(y),0);return{dispose(){clearTimeout(g)}}});var f;(function(b){function y(g){return g===b.None||g===b.Cancelled||g instanceof R?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}b.isCancellationToken=y,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:C.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(f||(e.CancellationToken=f={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?T:(this.b||(this.b=new C.$Rd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class L{constructor(y){this.f=void 0,this.g=void 0,this.g=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=f.Cancelled}dispose(y=!1){y&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=f.None}}e.$2d=L}),define(ke[162],Se([1,0,21]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ce=e.$Be=e.$Ae=void 0;class T{constructor(b){this.b=b,this.a=null}get(){if(this.a)return this.a;const b=new C.$2d,y=this.b(b.token);return this.a={promise:y,dispose:()=>{this.a=null,b.cancel(),b.dispose()}},this.a}}e.$Ae=T;class f{constructor(b){this.c=b,this.a=void 0,this.b=void 0}get(b){const y=JSON.stringify(b);return this.b!==y&&(this.b=y,this.a=this.c(b)),this.a}}e.$Be=f;class R{get cachedValues(){return this.a}constructor(b){this.b=b,this.a=new Map}get(b){if(this.a.has(b))return this.a.get(b);const y=this.b(b);return this.a.set(b,y),y}}e.$Ce=R}),define(ke[98],Se([1,0,8,3]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=void 0;function f(r){const a=r;return a?typeof a.read=="function":!1}e.$3d=f;function R(r){const a=r;return a?[a.on,a.pause,a.resume,a.destroy].every(t=>typeof t=="function"):!1}e.$4d=R;function L(r){const a=r;return a?R(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.$5d=L;function b(r,a){return new y(r,a)}e.$6d=b;class y{constructor(a,t){this.e=a,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(a){if(!this.a.destroyed){if(this.a.flowing)this.g(a);else if(this.b.data.push(a),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(a){this.a.destroyed||(this.a.flowing?this.h(a):this.b.error.push(a))}end(a){this.a.destroyed||(typeof a<"u"&&this.write(a),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(a){this.c.data.slice(0).forEach(t=>t(a))}h(a){this.c.error.length===0?(0,C.$Z)(a):this.c.error.slice(0).forEach(t=>t(a))}i(){this.c.end.slice(0).forEach(a=>a())}on(a,t){if(!this.a.destroyed)switch(a){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(a,t){if(this.a.destroyed)return;let s;switch(a){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const d=s.indexOf(t);d>=0&&s.splice(d,1)}}j(){if(this.b.data.length>0){const a=this.e(this.b.data);this.g(a),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const a of this.b.error)this.h(a);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(r,a){const t=[];let s;for(;(s=r.read())!==null;)t.push(s);return a(t)}e.$7d=g;function A(r,a,t){const s=[];let d;for(;(d=r.read())!==null&&s.length<t;)s.push(d);return d===null&&s.length>0?a(s):{read:()=>{if(s.length>0)return s.shift();if(typeof d<"u"){const c=d;return d=void 0,c}return r.read()}}}e.$8d=A;function I(r,a){return new Promise((t,s)=>{const d=[];$(r,{onData:c=>{a&&d.push(c)},onError:c=>{a?s(c):t(void 0)},onEnd:()=>{t(a?a(d):void 0)}})})}e.$9d=I;function $(r,a,t){r.on("error",s=>{t?.isCancellationRequested||a.onError(s)}),r.on("end",()=>{t?.isCancellationRequested||a.onEnd()}),r.on("data",s=>{t?.isCancellationRequested||a.onData(s)})}e.$0d=$;function v(r,a){return new Promise((t,s)=>{const d=new T.$Qc,c=[],u=D=>{if(c.push(D),c.length>a)return d.dispose(),r.pause(),t({stream:r,buffer:c,ended:!1})},h=D=>(d.dispose(),s(D)),E=()=>(d.dispose(),t({stream:r,buffer:c,ended:!0}));d.add((0,T.$Pc)(()=>r.removeListener("error",h))),r.on("error",h),d.add((0,T.$Pc)(()=>r.removeListener("end",E))),r.on("end",E),d.add((0,T.$Pc)(()=>r.removeListener("data",u))),r.on("data",u)})}e.$$d=v;function S(r,a){const t=b(a);return t.end(r),t}e.$_d=S;function w(){const r=b(()=>{throw new Error("not supported")});return r.end(),r}e.$ae=w;function l(r){let a=!1;return{read:()=>a?null:(a=!0,r)}}e.$be=l;function o(r,a,t){const s=b(t);return $(r,{onData:d=>s.write(a.data(d)),onError:d=>s.error(a.error?a.error(d):d),onEnd:()=>s.end()}),s}e.$ce=o;function i(r,a,t){let s=!1;return{read:()=>{const d=a.read();return s?d:(s=!0,d!==null?t([r,d]):r)}}}e.$de=i;function n(r,a,t){let s=!1;const d=b(t);return $(a,{onData:c=>s?d.write(c):(s=!0,d.write(t([r,c]))),onError:c=>d.error(c),onEnd:()=>{s||(s=!0,d.write(r)),d.end()}}),d}e.$ee=n}),define(ke[22],Se([1,0,48,98]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=void 0;const f=typeof Buffer<"u",R=new C.$U(()=>new Uint8Array(256));let L,b;class y{static alloc(k){return f?new y(Buffer.allocUnsafe(k)):new y(new Uint8Array(k))}static wrap(k){return f&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new y(k)}static fromString(k,P){return!(P?.dontUseNodeBuffer||!1)&&f?new y(Buffer.from(k)):(L||(L=new TextEncoder),new y(L.encode(k)))}static fromByteArray(k){const P=y.alloc(k.length);for(let z=0,j=k.length;z<j;z++)P.buffer[z]=k[z];return P}static concat(k,P){if(typeof P>"u"){P=0;for(let M=0,O=k.length;M<O;M++)P+=k[M].byteLength}const z=y.alloc(P);let j=0;for(let M=0,O=k.length;M<O;M++){const F=k[M];z.set(F,j),j+=F.byteLength}return z}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=y.alloc(this.byteLength);return k.set(this),k}toString(){return f?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(k,P){return new y(this.buffer.subarray(k,P))}set(k,P){if(k instanceof y)this.buffer.set(k.buffer,P);else if(k instanceof Uint8Array)this.buffer.set(k,P);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),P);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return $(this.buffer,k)}writeUInt32BE(k,P){v(this.buffer,k,P)}readUInt32LE(k){return S(this.buffer,k)}writeUInt32LE(k,P){w(this.buffer,k,P)}readUInt8(k){return l(this.buffer,k)}writeUInt8(k,P){o(this.buffer,k,P)}indexOf(k,P=0){return g(this.buffer,k instanceof y?k.buffer:k,P)}}e.$fe=y;function g(p,k,P=0){const z=k.byteLength,j=p.byteLength;if(z===0)return 0;if(z===1)return p.indexOf(k[0]);if(z>j-P)return-1;const M=R.value;M.fill(k.length);for(let W=0;W<k.length;W++)M[k[W]]=k.length-W-1;let O=P+k.length-1,F=O,N=-1;for(;O<j;)if(p[O]===k[F]){if(F===0){N=O;break}O--,F--}else O+=Math.max(k.length-F,M[p[O]]),F=k.length-1;return N}e.$ge=g;function A(p,k){return p[k+0]<<0>>>0|p[k+1]<<8>>>0}e.$he=A;function I(p,k,P){p[P+0]=k&255,k=k>>>8,p[P+1]=k&255}e.$ie=I;function $(p,k){return p[k]*2**24+p[k+1]*2**16+p[k+2]*2**8+p[k+3]}e.$je=$;function v(p,k,P){p[P+3]=k,k=k>>>8,p[P+2]=k,k=k>>>8,p[P+1]=k,k=k>>>8,p[P]=k}e.$ke=v;function S(p,k){return p[k+0]<<0>>>0|p[k+1]<<8>>>0|p[k+2]<<16>>>0|p[k+3]<<24>>>0}e.$le=S;function w(p,k,P){p[P+0]=k&255,k=k>>>8,p[P+1]=k&255,k=k>>>8,p[P+2]=k&255,k=k>>>8,p[P+3]=k&255}e.$me=w;function l(p,k){return p[k]}e.$ne=l;function o(p,k,P){p[P]=k}e.$oe=o;function i(p){return T.$7d(p,k=>y.concat(k))}e.$pe=i;function n(p){return T.$be(p)}e.$qe=n;function r(p){return T.$9d(p,k=>y.concat(k))}e.$re=r;async function a(p){return p.ended?y.concat(p.buffer):y.concat([...p.buffer,await r(p.stream)])}e.$se=a;function t(p){return T.$_d(p,k=>y.concat(k))}e.$te=t;function s(p){return T.$ce(p,{data:k=>typeof k=="string"?y.fromString(k):y.wrap(k)},k=>y.concat(k))}e.$ue=s;function d(p){return T.$6d(k=>y.concat(k),p)}e.$ve=d;function c(p,k){return T.$de(p,k,P=>y.concat(P))}e.$we=c;function u(p,k){return T.$ee(p,k,P=>y.concat(P))}e.$xe=u;function h(p){let k=0,P=0,z=0;const j=new Uint8Array(Math.floor(p.length/4*3)),M=F=>{switch(P){case 3:j[z++]=k|F,P=0;break;case 2:j[z++]=k|F>>>2,k=F<<6,P=3;break;case 1:j[z++]=k|F>>>4,k=F<<4,P=2;break;default:k=F<<2,P=1}};for(let F=0;F<p.length;F++){const N=p.charCodeAt(F);if(N>=65&&N<=90)M(N-65);else if(N>=97&&N<=122)M(N-97+26);else if(N>=48&&N<=57)M(N-48+52);else if(N===43||N===45)M(62);else if(N===47||N===95)M(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${p[F]}`)}}const O=z;for(;P>0;)M(0);return y.wrap(j).slice(0,O)}e.$ye=h;const E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function m({buffer:p},k=!0,P=!1){const z=P?D:E;let j="";const M=p.byteLength%3;let O=0;for(;O<p.byteLength-M;O+=3){const F=p[O+0],N=p[O+1],W=p[O+2];j+=z[F>>>2],j+=z[(F<<4|N>>>4)&63],j+=z[(N<<2|W>>>6)&63],j+=z[W&63]}if(M===1){const F=p[O+0];j+=z[F>>>2],j+=z[F<<4&63],k&&(j+="==")}else if(M===2){const F=p[O+0],N=p[O+1];j+=z[F>>>2],j+=z[(F<<4|N>>>4)&63],j+=z[N<<2&63],k&&(j+="=")}return j}e.$ze=m}),define(ke[13],Se([1,0,162,48]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bf=e.$Af=e.$zf=e.$yf=e.GraphemeBreakType=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=void 0;function f(Ae){return!Ae||typeof Ae!="string"?!0:Ae.trim().length===0}e.$Fe=f;const R=/{(\d+)}/g;function L(Ae,...Ne){return Ne.length===0?Ae:Ae.replace(R,function(Ve,Le){const Xe=parseInt(Le,10);return isNaN(Xe)||Xe<0||Xe>=Ne.length?Ve:Ne[Xe]})}e.$Ge=L;const b=/{([^}]+)}/g;function y(Ae,Ne){return Object.keys(Ne).length===0?Ae:Ae.replace(b,(Ve,Le)=>Ne[Le]??Ve)}e.$He=y;function g(Ae){return Ae.replace(/[<>&]/g,function(Ne){switch(Ne){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ne}})}e.$Ie=g;function A(Ae){return Ae.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Je=A;function I(Ae,Ne){let Ve=0;const Le=Ne.charCodeAt(0);for(let Xe=Ae.length-1;Xe>=0;Xe--)Ae.charCodeAt(Xe)===Le&&Ve++;return Ve}e.$Ke=I;function $(Ae,Ne,Ve="\u2026"){return Ae.length<=Ne?Ae:`${Ae.substr(0,Ne)}${Ve}`}e.$Le=$;function v(Ae,Ne=" "){const Ve=S(Ae,Ne);return w(Ve,Ne)}e.$Me=v;function S(Ae,Ne){if(!Ae||!Ne)return Ae;const Ve=Ne.length;if(Ve===0||Ae.length===0)return Ae;let Le=0;for(;Ae.indexOf(Ne,Le)===Le;)Le=Le+Ve;return Ae.substring(Le)}e.$Ne=S;function w(Ae,Ne){if(!Ae||!Ne)return Ae;const Ve=Ne.length,Le=Ae.length;if(Ve===0||Le===0)return Ae;let Xe=Le,le=-1;for(;le=Ae.lastIndexOf(Ne,Xe-1),!(le===-1||le+Ve!==Xe);){if(le===0)return"";Xe=le}return Ae.substring(0,Xe)}e.$Oe=w;function l(Ae){return Ae.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Pe=l;function o(Ae){return Ae.replace(/\*/g,"")}e.$Qe=o;function i(Ae,Ne,Ve={}){if(!Ae)throw new Error("Cannot create regex from empty string");Ne||(Ae=A(Ae)),Ve.wholeWord&&(/\B/.test(Ae.charAt(0))||(Ae="\\b"+Ae),/\B/.test(Ae.charAt(Ae.length-1))||(Ae=Ae+"\\b"));let Le="";return Ve.global&&(Le+="g"),Ve.matchCase||(Le+="i"),Ve.multiline&&(Le+="m"),Ve.unicode&&(Le+="u"),new RegExp(Ae,Le)}e.$Re=i;function n(Ae){return Ae.source==="^"||Ae.source==="^$"||Ae.source==="$"||Ae.source==="^\\s*$"?!1:!!(Ae.exec("")&&Ae.lastIndex===0)}e.$Se=n;function r(Ae){return Ae.split(/\r\n|\r|\n/)}e.$Te=r;function a(Ae){for(let Ne=0,Ve=Ae.length;Ne<Ve;Ne++){const Le=Ae.charCodeAt(Ne);if(Le!==32&&Le!==9)return Ne}return-1}e.$Ue=a;function t(Ae,Ne=0,Ve=Ae.length){for(let Le=Ne;Le<Ve;Le++){const Xe=Ae.charCodeAt(Le);if(Xe!==32&&Xe!==9)return Ae.substring(Ne,Le)}return Ae.substring(Ne,Ve)}e.$Ve=t;function s(Ae,Ne=Ae.length-1){for(let Ve=Ne;Ve>=0;Ve--){const Le=Ae.charCodeAt(Ve);if(Le!==32&&Le!==9)return Ve}return-1}e.$We=s;function d(Ae,Ne,Ve){const Le=[];let Xe=0;for(const le of Ae.matchAll(Ne)){if(Le.push(Ae.slice(Xe,le.index)),le.index===void 0)throw new Error("match.index should be defined");Xe=le.index+le[0].length,Le.push(Ve(le[0],...le.slice(1),le.index,Ae,le.groups))}return Le.push(Ae.slice(Xe)),Promise.all(Le).then(le=>le.join(""))}e.$Xe=d;function c(Ae,Ne){return Ae<Ne?-1:Ae>Ne?1:0}e.$Ye=c;function u(Ae,Ne,Ve=0,Le=Ae.length,Xe=0,le=Ne.length){for(;Ve<Le&&Xe<le;Ve++,Xe++){const Ke=Ae.charCodeAt(Ve),Ge=Ne.charCodeAt(Xe);if(Ke<Ge)return-1;if(Ke>Ge)return 1}const ue=Le-Ve,Ie=le-Xe;return ue<Ie?-1:ue>Ie?1:0}e.$Ze=u;function h(Ae,Ne){return E(Ae,Ne,0,Ae.length,0,Ne.length)}e.$1e=h;function E(Ae,Ne,Ve=0,Le=Ae.length,Xe=0,le=Ne.length){for(;Ve<Le&&Xe<le;Ve++,Xe++){let Ke=Ae.charCodeAt(Ve),Ge=Ne.charCodeAt(Xe);if(Ke===Ge)continue;if(Ke>=128||Ge>=128)return u(Ae.toLowerCase(),Ne.toLowerCase(),Ve,Le,Xe,le);m(Ke)&&(Ke-=32),m(Ge)&&(Ge-=32);const _e=Ke-Ge;if(_e!==0)return _e}const ue=Le-Ve,Ie=le-Xe;return ue<Ie?-1:ue>Ie?1:0}e.$2e=E;function D(Ae){return Ae>=48&&Ae<=57}e.$3e=D;function m(Ae){return Ae>=97&&Ae<=122}e.$4e=m;function p(Ae){return Ae>=65&&Ae<=90}e.$5e=p;function k(Ae,Ne){return Ae.length===Ne.length&&E(Ae,Ne)===0}e.$6e=k;function P(Ae,Ne){const Ve=Ne.length;return Ne.length>Ae.length?!1:E(Ae,Ne,0,Ve)===0}e.$7e=P;function z(Ae,Ne){const Ve=Math.min(Ae.length,Ne.length);let Le;for(Le=0;Le<Ve;Le++)if(Ae.charCodeAt(Le)!==Ne.charCodeAt(Le))return Le;return Ve}e.$8e=z;function j(Ae,Ne){const Ve=Math.min(Ae.length,Ne.length);let Le;const Xe=Ae.length-1,le=Ne.length-1;for(Le=0;Le<Ve;Le++)if(Ae.charCodeAt(Xe-Le)!==Ne.charCodeAt(le-Le))return Le;return Ve}e.$9e=j;function M(Ae){return 55296<=Ae&&Ae<=56319}e.$0e=M;function O(Ae){return 56320<=Ae&&Ae<=57343}e.$$e=O;function F(Ae,Ne){return(Ae-55296<<10)+(Ne-56320)+65536}e.$_e=F;function N(Ae,Ne,Ve){const Le=Ae.charCodeAt(Ve);if(M(Le)&&Ve+1<Ne){const Xe=Ae.charCodeAt(Ve+1);if(O(Xe))return F(Le,Xe)}return Le}e.$af=N;function W(Ae,Ne){const Ve=Ae.charCodeAt(Ne-1);if(O(Ve)&&Ne>1){const Le=Ae.charCodeAt(Ne-2);if(M(Le))return F(Le,Ve)}return Ve}class X{get offset(){return this.e}constructor(Ne,Ve=0){this.c=Ne,this.d=Ne.length,this.e=Ve}setOffset(Ne){this.e=Ne}prevCodePoint(){const Ne=W(this.c,this.e);return this.e-=Ne>=65536?2:1,Ne}nextCodePoint(){const Ne=N(this.c,this.d,this.e);return this.e+=Ne>=65536?2:1,Ne}eol(){return this.e>=this.d}}e.$bf=X;class ce{get offset(){return this.c.offset}constructor(Ne,Ve=0){this.c=new X(Ne,Ve)}nextGraphemeLength(){const Ne=ge.getInstance(),Ve=this.c,Le=Ve.offset;let Xe=Ne.getGraphemeBreakType(Ve.nextCodePoint());for(;!Ve.eol();){const le=Ve.offset,ue=Ne.getGraphemeBreakType(Ve.nextCodePoint());if(ae(Xe,ue)){Ve.setOffset(le);break}Xe=ue}return Ve.offset-Le}prevGraphemeLength(){const Ne=ge.getInstance(),Ve=this.c,Le=Ve.offset;let Xe=Ne.getGraphemeBreakType(Ve.prevCodePoint());for(;Ve.offset>0;){const le=Ve.offset,ue=Ne.getGraphemeBreakType(Ve.prevCodePoint());if(ae(ue,Xe)){Ve.setOffset(le);break}Xe=ue}return Le-Ve.offset}eol(){return this.c.eol()}}e.$cf=ce;function J(Ae,Ne){return new ce(Ae,Ne).nextGraphemeLength()}e.$df=J;function Q(Ae,Ne){return new ce(Ae,Ne).prevGraphemeLength()}e.$ef=Q;function G(Ae,Ne){Ne>0&&O(Ae.charCodeAt(Ne))&&Ne--;const Ve=Ne+J(Ae,Ne);return[Ve-Q(Ae,Ve),Ve]}e.$ff=G;function oe(Ae){const Ne=new ce(Ae);let Ve=0;for(;!Ne.eol();)Ve++,Ne.nextGraphemeLength();return Ve}e.$gf=oe;let _;function Ee(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function he(Ae){return _||(_=Ee()),_.test(Ae)}e.$hf=he;const q=/^[\t\n\r\x20-\x7E]*$/;function U(Ae){return q.test(Ae)}e.$if=U,e.$jf=/[\u2028\u2029]/;function ne(Ae){return e.$jf.test(Ae)}e.$kf=ne;function be(Ae){return Ae>=11904&&Ae<=55215||Ae>=63744&&Ae<=64255||Ae>=65281&&Ae<=65374}e.$lf=be;function H(Ae){return Ae>=127462&&Ae<=127487||Ae===8986||Ae===8987||Ae===9200||Ae===9203||Ae>=9728&&Ae<=10175||Ae===11088||Ae===11093||Ae>=127744&&Ae<=128591||Ae>=128640&&Ae<=128764||Ae>=128992&&Ae<=129008||Ae>=129280&&Ae<=129535||Ae>=129648&&Ae<=129782}e.$mf=H;function x(Ae,Ne){if(Ae.length<Ne)return Ae;const Ve=/\b/g;let Le=0;for(;Ve.test(Ae)&&!(Ae.length-Ve.lastIndex<Ne);)Le=Ve.lastIndex,Ve.lastIndex+=1;return Ae.substring(Le).replace(/^\s/,"")}e.$nf=x;const Y=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,$e=/\x1b\].*?\x07/g;function ie(Ae){return Ae&&(Ae=Ae.replace(Y,"").replace($e,"")),Ae}e.$of=ie,e.$pf=String.fromCharCode(65279);function fe(Ae){return!!(Ae&&Ae.length>0&&Ae.charCodeAt(0)===65279)}e.$qf=fe;function te(Ae){return fe(Ae)?Ae.substr(1):Ae}e.$rf=te;function de(Ae,Ne){if(!Ae||!Ne||Ae.length<Ne.length)return!1;const Ve=Ne.length,Le=Ae.toLowerCase();let Xe=0,le=-1;for(;Xe<Ve;){const ue=Le.indexOf(Ne[Xe],le+1);if(ue<0)return!1;le=ue,Xe++}return!0}e.$sf=de;function pe(Ae,Ne=!1){return Ae?(Ne&&(Ae=Ae.replace(/\\./g,"")),Ae.toLowerCase()!==Ae):!1}e.$tf=pe;function Pe(Ae){return Ae.charAt(0).toUpperCase()+Ae.slice(1)}e.$uf=Pe;function B(Ae,Ne=1){if(Ne===0)return"";let Ve=-1;do Ve=Ae.indexOf(`
`,Ve+1),Ne--;while(Ne>0&&Ve>=0);return Ve===-1?Ae:(Ae[Ve-1]==="\r"&&Ve--,Ae.substr(0,Ve))}e.$vf=B;function Z(Ae){return Ae=Ae%(2*26),Ae<26?String.fromCharCode(97+Ae):String.fromCharCode(65+Ae-26)}e.$wf=Z;function re(Ae){return ge.getInstance().getGraphemeBreakType(Ae)}e.$xf=re;function ae(Ae,Ne){return Ae===0?Ne!==5&&Ne!==7:Ae===2&&Ne===3?!1:Ae===4||Ae===2||Ae===3||Ne===4||Ne===2||Ne===3?!0:!(Ae===8&&(Ne===8||Ne===9||Ne===11||Ne===12)||(Ae===11||Ae===9)&&(Ne===9||Ne===10)||(Ae===12||Ae===10)&&Ne===10||Ne===5||Ne===13||Ne===7||Ae===1||Ae===13&&Ne===14||Ae===6&&Ne===6)}var ee;(function(Ae){Ae[Ae.Other=0]="Other",Ae[Ae.Prepend=1]="Prepend",Ae[Ae.CR=2]="CR",Ae[Ae.LF=3]="LF",Ae[Ae.Control=4]="Control",Ae[Ae.Extend=5]="Extend",Ae[Ae.Regional_Indicator=6]="Regional_Indicator",Ae[Ae.SpacingMark=7]="SpacingMark",Ae[Ae.L=8]="L",Ae[Ae.V=9]="V",Ae[Ae.T=10]="T",Ae[Ae.LV=11]="LV",Ae[Ae.LVT=12]="LVT",Ae[Ae.ZWJ=13]="ZWJ",Ae[Ae.Extended_Pictographic=14]="Extended_Pictographic"})(ee||(e.GraphemeBreakType=ee={}));class ge{static{this.c=null}static getInstance(){return ge.c||(ge.c=new ge),ge.c}constructor(){this.d=ye()}getGraphemeBreakType(Ne){if(Ne<32)return Ne===10?3:Ne===13?2:4;if(Ne<127)return 0;const Ve=this.d,Le=Ve.length/3;let Xe=1;for(;Xe<=Le;)if(Ne<Ve[3*Xe])Xe=2*Xe;else if(Ne>Ve[3*Xe+1])Xe=2*Xe+1;else return Ve[3*Xe+2];return 0}}function ye(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ze(Ae,Ne){if(Ae===0)return 0;const Ve=We(Ae,Ne);if(Ve!==void 0)return Ve;const Le=new X(Ne,Ae);return Le.prevCodePoint(),Le.offset}e.$yf=ze;function We(Ae,Ne){const Ve=new X(Ne,Ae);let Le=Ve.prevCodePoint();for(;et(Le)||Le===65039||Le===8419;){if(Ve.offset===0)return;Le=Ve.prevCodePoint()}if(!H(Le))return;let Xe=Ve.offset;return Xe>0&&Ve.prevCodePoint()===8205&&(Xe=Ve.offset),Xe}function et(Ae){return 127995<=Ae&&Ae<=127999}var Ye;(function(Ae){Ae[Ae.zwj=8205]="zwj",Ae[Ae.emojiVariantSelector=65039]="emojiVariantSelector",Ae[Ae.enclosingKeyCap=8419]="enclosingKeyCap"})(Ye||(Ye={})),e.$zf="\xA0";class rt{static{this.c=new T.$U(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new C.$Be(Ne=>{function Ve(_e){const st=new Map;for(let lt=0;lt<_e.length;lt+=2)st.set(_e[lt],_e[lt+1]);return st}function Le(_e,st){const lt=new Map(_e);for(const[wt,Ue]of st)lt.set(wt,Ue);return lt}function Xe(_e,st){if(!_e)return st;const lt=new Map;for(const[wt,Ue]of _e)st.has(wt)&&lt.set(wt,Ue);return lt}const le=this.c.value;let ue=Ne.filter(_e=>!_e.startsWith("_")&&_e in le);ue.length===0&&(ue=["_default"]);let Ie;for(const _e of ue){const st=Ve(le[_e]);Ie=Xe(Ie,st)}const Ke=Ve(le._common),Ge=Le(Ke,Ie);return new rt(Ge)})}static getInstance(Ne){return rt.d.get(Array.from(Ne))}static{this.e=new T.$U(()=>Object.keys(rt.c.value).filter(Ne=>!Ne.startsWith("_")))}static getLocales(){return rt.e.value}constructor(Ne){this.f=Ne}isAmbiguous(Ne){return this.f.has(Ne)}getPrimaryConfusable(Ne){return this.f.get(Ne)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Af=rt;class nt{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(nt.c())),this.d}static isInvisibleCharacter(Ne){return nt.e().has(Ne)}static get codePoints(){return nt.e()}}e.$Bf=nt}),define(ke[124],Se([1,0,28,13]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.FuzzyScore=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.or=void 0;function f(...te){return function(de,pe){for(let Pe=0,B=te.length;Pe<B;Pe++){const Z=te[Pe](de,pe);if(Z)return Z}return null}}e.or=f,e.$Ij=R.bind(void 0,!1),e.$Jj=R.bind(void 0,!0);function R(te,de,pe){if(!pe||pe.length<de.length)return null;let Pe;return te?Pe=T.$7e(pe,de):Pe=pe.indexOf(de)===0,Pe?de.length>0?[{start:0,end:de.length}]:[]:null}function L(te,de){const pe=de.toLowerCase().indexOf(te.toLowerCase());return pe===-1?null:[{start:pe,end:pe+te.length}]}e.$Kj=L;function b(te,de){return y(te.toLowerCase(),de.toLowerCase(),0,0)}e.$Lj=b;function y(te,de,pe,Pe){if(pe===te.length)return[];if(Pe===de.length)return null;if(te[pe]===de[Pe]){let B=null;return(B=y(te,de,pe+1,Pe+1))?o({start:Pe,end:Pe+1},B):null}return y(te,de,pe,Pe+1)}function g(te){return 97<=te&&te<=122}function A(te){return 65<=te&&te<=90}e.$Mj=A;function I(te){return 48<=te&&te<=57}function $(te){return te===32||te===9||te===10||te===13}const v=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(te=>v.add(te.charCodeAt(0)));function S(te){return $(te)||v.has(te)}function w(te,de){return te===de||S(te)&&S(de)}function l(te){return g(te)||A(te)||I(te)}function o(te,de){return de.length===0?de=[te]:te.end===de[0].start?de[0].start=te.start:de.unshift(te),de}function i(te,de){for(let pe=de;pe<te.length;pe++){const Pe=te.charCodeAt(pe);if(A(Pe)||I(Pe)||pe>0&&!l(te.charCodeAt(pe-1)))return pe}return te.length}function n(te,de,pe,Pe){if(pe===te.length)return[];if(Pe===de.length)return null;if(te[pe]!==de[Pe].toLowerCase())return null;{let B=null,Z=Pe+1;for(B=n(te,de,pe+1,Pe+1);!B&&(Z=i(de,Z))<de.length;)B=n(te,de,pe+1,Z),Z++;return B===null?null:o({start:Pe,end:Pe+1},B)}}function r(te){let de=0,pe=0,Pe=0,B=0,Z=0;for(let ye=0;ye<te.length;ye++)Z=te.charCodeAt(ye),A(Z)&&de++,g(Z)&&pe++,l(Z)&&Pe++,I(Z)&&B++;const re=de/te.length,ae=pe/te.length,ee=Pe/te.length,ge=B/te.length;return{upperPercent:re,lowerPercent:ae,alphaPercent:ee,numericPercent:ge}}function a(te){const{upperPercent:de,lowerPercent:pe}=te;return pe===0&&de>.6}function t(te){const{upperPercent:de,lowerPercent:pe,alphaPercent:Pe,numericPercent:B}=te;return pe>.2&&de<.8&&Pe>.6&&B<.2}function s(te){let de=0,pe=0,Pe=0,B=0;for(let Z=0;Z<te.length;Z++)Pe=te.charCodeAt(Z),A(Pe)&&de++,g(Pe)&&pe++,$(Pe)&&B++;return(de===0||pe===0)&&B===0?te.length<=30:de<=5}function d(te,de){if(!de||(de=de.trim(),de.length===0)||!s(te)||de.length>60)return null;const pe=r(de);if(!t(pe)){if(!a(pe))return null;de=de.toLowerCase()}let Pe=null,B=0;for(te=te.toLowerCase();B<de.length&&(Pe=n(te,de,0,B))===null;)B=i(de,B+1);return Pe}e.$Nj=d;function c(te,de,pe=!1){if(!de||de.length===0)return null;let Pe=null,B=0;for(te=te.toLowerCase(),de=de.toLowerCase();B<de.length&&(Pe=u(te,de,0,B,pe))===null;)B=h(de,B+1);return Pe}e.$Oj=c;function u(te,de,pe,Pe,B){if(pe===te.length)return[];if(Pe===de.length)return null;if(w(te.charCodeAt(pe),de.charCodeAt(Pe))){let Z=null,re=Pe+1;if(Z=u(te,de,pe+1,Pe+1,B),!B)for(;!Z&&(re=h(de,re))<de.length;)Z=u(te,de,pe+1,re,B),re++;return Z?te.charCodeAt(pe)!==de.charCodeAt(Pe)?Z:o({start:Pe,end:Pe+1},Z):null}else return null}function h(te,de){for(let pe=de;pe<te.length;pe++)if(S(te.charCodeAt(pe))||pe>0&&S(te.charCodeAt(pe-1)))return pe;return te.length}const E=f(e.$Jj,d,L),D=f(e.$Jj,d,b),m=new C.$Cc(1e4);function p(te,de,pe=!1){if(typeof te!="string"||typeof de!="string")return null;let Pe=m.get(te);Pe||(Pe=new RegExp(T.$Pe(te),"i"),m.set(te,Pe));const B=Pe.exec(de);return B?[{start:B.index,end:B.index+B[0].length}]:pe?D(te,de):E(te,de)}e.$Pj=p;function k(te,de){const pe=be(te,te.toLowerCase(),0,de,de.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return pe?z(pe):null}e.$Qj=k;function P(te,de,pe,Pe,B,Z){const re=Math.min(13,te.length);for(;pe<re;pe++){const ae=be(te,de,pe,Pe,B,Z,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ae)return ae}return[0,Z]}e.$Rj=P;function z(te){if(typeof te>"u")return[];const de=[],pe=te[1];for(let Pe=te.length-1;Pe>1;Pe--){const B=te[Pe]+pe,Z=de[de.length-1];Z&&Z.end===B?Z.end=B+1:de.push({start:B,end:B+1})}return de}e.$Sj=z;const j=128;function M(){const te=[],de=[];for(let pe=0;pe<=j;pe++)de[pe]=0;for(let pe=0;pe<=j;pe++)te.push(de.slice(0));return te}function O(te){const de=[];for(let pe=0;pe<=te;pe++)de[pe]=0;return de}const F=O(2*j),N=O(2*j),W=M(),X=M(),ce=M(),J=!1;function Q(te,de,pe,Pe,B){function Z(ae,ee,ge=" "){for(;ae.length<ee;)ae=ge+ae;return ae}let re=` |   |${Pe.split("").map(ae=>Z(ae,3)).join("|")}
`;for(let ae=0;ae<=pe;ae++)ae===0?re+=" |":re+=`${de[ae-1]}|`,re+=te[ae].slice(0,B+1).map(ee=>Z(ee.toString(),3)).join("|")+`
`;return re}function G(te,de,pe,Pe){te=te.substr(de),pe=pe.substr(Pe),console.log(Q(X,te,te.length,pe,pe.length)),console.log(Q(ce,te,te.length,pe,pe.length)),console.log(Q(W,te,te.length,pe,pe.length))}function oe(te,de){if(de<0||de>=te.length)return!1;const pe=te.codePointAt(de);switch(pe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!T.$mf(pe)}}function _(te,de){if(de<0||de>=te.length)return!1;switch(te.charCodeAt(de)){case 32:case 9:return!0;default:return!1}}function Ee(te,de,pe){return de[te]!==pe[te]}function he(te,de,pe,Pe,B,Z,re=!1){for(;de<pe&&B<Z;)te[de]===Pe[B]&&(re&&(F[de]=B),de+=1),B+=1;return de===pe}e.$Tj=he;var q;(function(te){te[te.Diag=1]="Diag",te[te.Left=2]="Left",te[te.LeftLeft=3]="LeftLeft"})(q||(q={}));var U;(function(te){te.Default=[-100,0];function de(pe){return!pe||pe.length===2&&pe[0]===-100&&pe[1]===0}te.isDefault=de})(U||(e.FuzzyScore=U={}));class ne{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(de,pe){this.firstMatchCanBeWeak=de,this.boostFullMatch=pe}}e.$Uj=ne;function be(te,de,pe,Pe,B,Z,re=ne.default){const ae=te.length>j?j:te.length,ee=Pe.length>j?j:Pe.length;if(pe>=ae||Z>=ee||ae-pe>ee-Z||!he(de,pe,ae,B,Z,ee,!0))return;H(ae,ee,pe,Z,de,B);let ge=1,ye=1,ze=pe,We=Z;const et=[!1];for(ge=1,ze=pe;ze<ae;ge++,ze++){const Ne=F[ze],Ve=N[ze],Le=ze+1<ae?N[ze+1]:ee;for(ye=Ne-Z+1,We=Ne;We<Le;ye++,We++){let Xe=Number.MIN_SAFE_INTEGER,le=!1;We<=Ve&&(Xe=x(te,de,ze,pe,Pe,B,We,ee,Z,W[ge-1][ye-1]===0,et));let ue=0;Xe!==Number.MAX_SAFE_INTEGER&&(le=!0,ue=Xe+X[ge-1][ye-1]);const Ie=We>Ne,Ke=Ie?X[ge][ye-1]+(W[ge][ye-1]>0?-5:0):0,Ge=We>Ne+1&&W[ge][ye-1]>0,_e=Ge?X[ge][ye-2]+(W[ge][ye-2]>0?-5:0):0;if(Ge&&(!Ie||_e>=Ke)&&(!le||_e>=ue))X[ge][ye]=_e,ce[ge][ye]=3,W[ge][ye]=0;else if(Ie&&(!le||Ke>=ue))X[ge][ye]=Ke,ce[ge][ye]=2,W[ge][ye]=0;else if(le)X[ge][ye]=ue,ce[ge][ye]=1,W[ge][ye]=W[ge-1][ye-1]+1;else throw new Error("not possible")}}if(J&&G(te,pe,Pe,Z),!et[0]&&!re.firstMatchCanBeWeak)return;ge--,ye--;const Ye=[X[ge][ye],Z];let rt=0,nt=0;for(;ge>=1;){let Ne=ye;do{const Ve=ce[ge][Ne];if(Ve===3)Ne=Ne-2;else if(Ve===2)Ne=Ne-1;else break}while(Ne>=1);rt>1&&de[pe+ge-1]===B[Z+ye-1]&&!Ee(Ne+Z-1,Pe,B)&&rt+1>W[ge][Ne]&&(Ne=ye),Ne===ye?rt++:rt=1,nt||(nt=Ne),ge--,ye=Ne-1,Ye.push(ye)}ee===ae&&re.boostFullMatch&&(Ye[0]+=2);const Ae=nt-ae;return Ye[0]-=Ae,Ye}e.$Vj=be;function H(te,de,pe,Pe,B,Z){let re=te-1,ae=de-1;for(;re>=pe&&ae>=Pe;)B[re]===Z[ae]&&(N[re]=ae,re--),ae--}function x(te,de,pe,Pe,B,Z,re,ae,ee,ge,ye){if(de[pe]!==Z[re])return Number.MIN_SAFE_INTEGER;let ze=1,We=!1;return re===pe-Pe?ze=te[pe]===B[re]?7:5:Ee(re,B,Z)&&(re===0||!Ee(re-1,B,Z))?(ze=te[pe]===B[re]?7:5,We=!0):oe(Z,re)&&(re===0||!oe(Z,re-1))?ze=5:(oe(Z,re-1)||_(Z,re-1))&&(ze=5,We=!0),ze>1&&pe===Pe&&(ye[0]=!0),We||(We=Ee(re,B,Z)||oe(Z,re-1)||_(Z,re-1)),pe===Pe?re>ee&&(ze-=We?3:5):ge?ze+=We?2:0:ze+=We?0:1,re+1===ae&&(ze-=We?3:5),ze}function Y(te,de,pe,Pe,B,Z,re){return ie(te,de,pe,Pe,B,Z,!0,re)}e.$Wj=Y;function $e(te,de,pe,Pe,B,Z,re){return ie(te,de,pe,Pe,B,Z,!1,re)}e.$Xj=$e;function ie(te,de,pe,Pe,B,Z,re,ae){let ee=be(te,de,pe,Pe,B,Z,ae);if(ee&&!re)return ee;if(te.length>=3){const ge=Math.min(7,te.length-1);for(let ye=pe+1;ye<ge;ye++){const ze=fe(te,ye);if(ze){const We=be(ze,ze.toLowerCase(),pe,Pe,B,Z,ae);We&&(We[0]-=3,(!ee||We[0]>ee[0])&&(ee=We))}}}return ee}function fe(te,de){if(de+1>=te.length)return;const pe=te[de],Pe=te[de+1];if(pe!==Pe)return te.slice(0,de)+Pe+pe+te.slice(de+2)}}),define(ke[52],Se([1,0,13]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=void 0;function T(o){return f(o,0)}e.$Ji=T;function f(o,i){switch(typeof o){case"object":return o===null?R(349,i):Array.isArray(o)?y(o,i):g(o,i);case"string":return b(o,i);case"boolean":return L(o,i);case"number":return R(o,i);case"undefined":return R(937,i);default:return R(617,i)}}e.$Ki=f;function R(o,i){return(i<<5)-i+o|0}e.$Li=R;function L(o,i){return R(o?433:863,i)}function b(o,i){i=R(149417,i);for(let n=0,r=o.length;n<r;n++)i=R(o.charCodeAt(n),i);return i}e.$Mi=b;function y(o,i){return i=R(104579,i),o.reduce((n,r)=>f(r,n),i)}function g(o,i){return i=R(181387,i),Object.keys(o).sort().reduce((n,r)=>(n=b(r,n),f(o[r],n)),i)}class A{constructor(){this.g=0}get value(){return this.g}hash(i){return this.g=f(i,this.g),this.g}}e.$Ni=A;var I;(function(o){o[o.BLOCK_SIZE=64]="BLOCK_SIZE",o[o.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function $(o,i,n=32){const r=n-i,a=~((1<<r)-1);return(o<<i|(a&o)>>>r)>>>0}function v(o,i=0,n=o.byteLength,r=0){for(let a=0;a<n;a++)o[i+a]=r}function S(o,i,n="0"){for(;o.length<i;)o=n+o;return o}function w(o,i=32){return o instanceof ArrayBuffer?Array.from(new Uint8Array(o)).map(n=>n.toString(16).padStart(2,"0")).join(""):S((o>>>0).toString(16),i/4)}e.$Oi=w;class l{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(i){const n=i.length;if(n===0)return;const r=this.p;let a=this.r,t=this.u,s,d;for(t!==0?(s=t,d=-1,t=0):(s=i.charCodeAt(0),d=0);;){let c=s;if(C.$0e(s))if(d+1<n){const u=i.charCodeAt(d+1);C.$$e(u)?(d++,c=C.$_e(s,u)):c=65533}else{t=s;break}else C.$$e(s)&&(c=65533);if(a=this.w(r,a,c),d++,d<n)s=i.charCodeAt(d);else break}this.r=a,this.u=t}w(i,n,r){return r<128?i[n++]=r:r<2048?(i[n++]=192|(r&1984)>>>6,i[n++]=128|(r&63)>>>0):r<65536?(i[n++]=224|(r&61440)>>>12,i[n++]=128|(r&4032)>>>6,i[n++]=128|(r&63)>>>0):(i[n++]=240|(r&1835008)>>>18,i[n++]=128|(r&258048)>>>12,i[n++]=128|(r&4032)>>>6,i[n++]=128|(r&63)>>>0),n>=64&&(this.y(),n-=64,this.t+=64,i[0]=i[64+0],i[1]=i[64+1],i[2]=i[64+2]),n}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),w(this.h)+w(this.l)+w(this.m)+w(this.n)+w(this.o)}x(){this.p[this.r++]=128,v(this.p,this.r),this.r>56&&(this.y(),v(this.p));const i=8*this.t;this.q.setUint32(56,Math.floor(i/4294967296),!1),this.q.setUint32(60,i%4294967296,!1),this.y()}y(){const i=l.g,n=this.q;for(let E=0;E<64;E+=4)i.setUint32(E,n.getUint32(E,!1),!1);for(let E=64;E<320;E+=4)i.setUint32(E,$(i.getUint32(E-12,!1)^i.getUint32(E-32,!1)^i.getUint32(E-56,!1)^i.getUint32(E-64,!1),1),!1);let r=this.h,a=this.l,t=this.m,s=this.n,d=this.o,c,u,h;for(let E=0;E<80;E++)E<20?(c=a&t|~a&s,u=1518500249):E<40?(c=a^t^s,u=1859775393):E<60?(c=a&t|a&s|t&s,u=2400959708):(c=a^t^s,u=3395469782),h=$(r,5)+c+d+u+i.getUint32(E*4,!1)&4294967295,d=s,s=t,t=$(a,30),a=r,r=h;this.h=this.h+r&4294967295,this.l=this.l+a&4294967295,this.m=this.m+t&4294967295,this.n=this.n+s&4294967295,this.o=this.o+d&4294967295}}e.$Pi=l}),define(ke[39],Se([1,0,13]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(f){f[f.Ignore=0]="Ignore",f[f.Info=1]="Info",f[f.Warning=2]="Warning",f[f.Error=3]="Error"})(T||(T={})),function(f){const R="error",L="warning",b="warn",y="info",g="ignore";function A($){return $?C.$6e(R,$)?f.Error:C.$6e(L,$)||C.$6e(b,$)?f.Warning:C.$6e(y,$)?f.Info:f.Ignore:f.Ignore}f.fromValue=A;function I($){switch($){case f.Error:return R;case f.Warning:return L;case f.Info:return y;default:return g}}f.toString=I}(T||(T={})),e.default=T}),define(ke[163],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Od=void 0,e.$Od=Symbol("MicrotaskDelay")}),define(ke[77],Se([1,0,19,13]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=void 0;class f{constructor(){this.b="",this.c=0}reset(v){return this.b=v,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(v){const S=v.charCodeAt(0),w=this.b.charCodeAt(this.c);return S-w}value(){return this.b[this.c]}}e.$Xh=f;class R{constructor(v=!0){this.e=v}reset(v){return this.b=v,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let v=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(v)this.c++;else break;else v=!1;return this}cmp(v){return this.e?(0,T.$Ze)(v,this.b,0,v.length,this.c,this.d):(0,T.$2e)(v,this.b,0,v.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Yh=R;class L{constructor(v=!0,S=!0){this.f=v,this.g=S}reset(v){this.d=0,this.e=0,this.b=v,this.c=v.length;for(let S=v.length-1;S>=0;S--,this.c--){const w=this.b.charCodeAt(S);if(!(w===47||this.f&&w===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let v=!0;for(;this.e<this.c;this.e++){const S=this.b.charCodeAt(this.e);if(S===47||this.f&&S===92)if(v)this.d++;else break;else v=!1}return this}cmp(v){return this.g?(0,T.$Ze)(v,this.b,0,v.length,this.d,this.e):(0,T.$2e)(v,this.b,0,v.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Zh=L;var b;(function($){$[$.Scheme=1]="Scheme",$[$.Authority=2]="Authority",$[$.Path=3]="Path",$[$.Query=4]="Query",$[$.Fragment=5]="Fragment"})(b||(b={}));class y{constructor(v,S){this.f=v,this.g=S,this.d=[],this.e=0}reset(v){return this.c=v,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new L(!1,!this.f(v)),this.b.reset(v.path),this.b.value()&&this.d.push(3)),this.g(v)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(v){if(this.d[this.e]===1)return(0,T.$1e)(v,this.c.scheme);if(this.d[this.e]===2)return(0,T.$1e)(v,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(v);if(this.d[this.e]===4)return(0,T.$Ye)(v,this.c.query);if(this.d[this.e]===5)return(0,T.$Ye)(v,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$1h=y;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const v=this.right;return this.right=v.left,v.left=this,this.updateHeight(),v.updateHeight(),v}rotateRight(){const v=this.left;return this.left=v.right,v.right=this,this.updateHeight(),v.updateHeight(),v}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function($){$[$.Left=-1]="Left",$[$.Mid=0]="Mid",$[$.Right=1]="Right"})(A||(A={}));class I{static forUris(v=()=>!1,S=()=>!1){return new I(new y(v,S))}static forPaths(v=!1){return new I(new L(void 0,!v))}static forStrings(){return new I(new f)}static forConfigKeys(){return new I(new R)}constructor(v){this.b=v}clear(){this.c=void 0}fill(v,S){if(S){const w=S.slice(0);(0,C.$Wb)(w);for(const l of w)this.set(l,v)}else{const w=v.slice(0);(0,C.$Wb)(w);for(const l of w)this.set(l[0],l[1])}}set(v,S){const w=this.b.reset(v);let l;this.c||(this.c=new g,this.c.segment=w.value());const o=[];for(l=this.c;;){const n=w.cmp(l.segment);if(n>0)l.left||(l.left=new g,l.left.segment=w.value()),o.push([-1,l]),l=l.left;else if(n<0)l.right||(l.right=new g,l.right.segment=w.value()),o.push([1,l]),l=l.right;else if(w.hasNext())w.next(),l.mid||(l.mid=new g,l.mid.segment=w.value()),o.push([0,l]),l=l.mid;else break}const i=l.value;l.value=S,l.key=v;for(let n=o.length-1;n>=0;n--){const r=o[n][1];r.updateHeight();const a=r.balanceFactor();if(a<-1||a>1){const t=o[n][0],s=o[n+1][0];if(t===1&&s===1)o[n][1]=r.rotateLeft();else if(t===-1&&s===-1)o[n][1]=r.rotateRight();else if(t===1&&s===-1)r.right=o[n+1][1]=o[n+1][1].rotateRight(),o[n][1]=r.rotateLeft();else if(t===-1&&s===1)r.left=o[n+1][1]=o[n+1][1].rotateLeft(),o[n][1]=r.rotateRight();else throw new Error;if(n>0)switch(o[n-1][0]){case-1:o[n-1][1].left=o[n][1];break;case 1:o[n-1][1].right=o[n][1];break;case 0:o[n-1][1].mid=o[n][1];break}else this.c=o[0][1]}}return i}get(v){return this.d(v)?.value}d(v){const S=this.b.reset(v);let w=this.c;for(;w;){const l=S.cmp(w.segment);if(l>0)w=w.left;else if(l<0)w=w.right;else if(S.hasNext())S.next(),w=w.mid;else break}return w}has(v){const S=this.d(v);return!(S?.value===void 0&&S?.mid===void 0)}delete(v){return this.e(v,!1)}deleteSuperstr(v){return this.e(v,!0)}e(v,S){const w=this.b.reset(v),l=[];let o=this.c;for(;o;){const i=w.cmp(o.segment);if(i>0)l.push([-1,o]),o=o.left;else if(i<0)l.push([1,o]),o=o.right;else if(w.hasNext())w.next(),l.push([0,o]),o=o.mid;else break}if(o){if(S?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const i=this.f(o.right);if(i.key){const{key:n,value:r,segment:a}=i;this.e(i.key,!1),o.key=n,o.value=r,o.segment=a}}else{const i=o.left??o.right;if(l.length>0){const[n,r]=l[l.length-1];switch(n){case-1:r.left=i;break;case 0:r.mid=i;break;case 1:r.right=i;break}}else this.c=i}for(let i=l.length-1;i>=0;i--){const n=l[i][1];n.updateHeight();const r=n.balanceFactor();if(r>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),l[i][1]=n.rotateLeft()):r<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),l[i][1]=n.rotateRight()),i>0)switch(l[i-1][0]){case-1:l[i-1][1].left=l[i][1];break;case 1:l[i-1][1].right=l[i][1];break;case 0:l[i-1][1].mid=l[i][1];break}else this.c=l[0][1]}}}f(v){for(;v.left;)v=v.left;return v}findSubstr(v){const S=this.b.reset(v);let w=this.c,l;for(;w;){const o=S.cmp(w.segment);if(o>0)w=w.left;else if(o<0)w=w.right;else if(S.hasNext())S.next(),l=w.value||l,w=w.mid;else break}return w&&w.value||l}findSuperstr(v){return this.g(v,!1)}g(v,S){const w=this.b.reset(v);let l=this.c;for(;l;){const o=w.cmp(l.segment);if(o>0)l=l.left;else if(o<0)l=l.right;else if(w.hasNext())w.next(),l=l.mid;else return l.mid?this.h(l.mid):S?l.value:void 0}}hasElementOrSubtree(v){return this.g(v,!0)!==void 0}forEach(v){for(const[S,w]of this)v(w,S)}*[Symbol.iterator](){yield*this.h(this.c)}h(v){const S=[];return this.j(v,S),S[Symbol.iterator]()}j(v,S){v&&(v.left&&this.j(v.left,S),v.value&&S.push([v.key,v.value]),v.mid&&this.j(v.mid,S),v.right&&this.j(v.right,S))}_isBalanced(){const v=S=>{if(!S)return!0;const w=S.balanceFactor();return w<-1||w>1?!1:v(S.left)&&v(S.right)};return v(this.c)}}e.$2h=I}),define(ke[18],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=void 0;function C(a){return typeof a=="string"}e.$Cf=C;function T(a){return Array.isArray(a)&&a.every(t=>C(t))}e.$Df=T;function f(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.$Ef=f;function R(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}e.$Ff=R;function L(a){return typeof a=="number"&&!isNaN(a)}e.$Gf=L;function b(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.$Hf=b;function y(a){return a===!0||a===!1}e.$If=y;function g(a){return typeof a>"u"}e.$Jf=g;function A(a){return!I(a)}e.$Kf=A;function I(a){return g(a)||a===null}e.$Lf=I;function $(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Mf=$;function v(a){if(I(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.$Nf=v;function S(...a){const t=[];for(let s=0;s<a.length;s++){const d=a[s];if(I(d))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);t.push(d)}return t}e.$Of=S;const w=Object.prototype.hasOwnProperty;function l(a){if(!f(a))return!1;for(const t in a)if(w.call(a,t))return!1;return!0}e.$Pf=l;function o(a){return typeof a=="function"}e.$Qf=o;function i(...a){return a.length>0&&a.every(o)}e.$Rf=i;function n(a,t){const s=Math.min(a.length,t.length);for(let d=0;d<s;d++)r(a[d],t[d])}e.$Sf=n;function r(a,t){if(C(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(o(t)){try{if(a instanceof t)return}catch{}if(!I(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Tf=r}),define(ke[78],Se([1,0,18]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1j=e.$Zj=e.$Yj=void 0;const T=Object.create(null);function f(b,y){if((0,C.$Cf)(y)){const g=T[y];if(g===void 0)throw new Error(`${b} references an unknown codicon: ${y}`);y=g}return T[b]=y,{id:b}}function R(){return T}e.$Yj=R;function L(){return Object.values(e.$1j)}e.$Zj=L,e.$1j={add:f("add",6e4),plus:f("plus",6e4),gistNew:f("gist-new",6e4),repoCreate:f("repo-create",6e4),lightbulb:f("lightbulb",60001),lightBulb:f("light-bulb",60001),repo:f("repo",60002),repoDelete:f("repo-delete",60002),gistFork:f("gist-fork",60003),repoForked:f("repo-forked",60003),gitPullRequest:f("git-pull-request",60004),gitPullRequestAbandoned:f("git-pull-request-abandoned",60004),recordKeys:f("record-keys",60005),keyboard:f("keyboard",60005),tag:f("tag",60006),tagAdd:f("tag-add",60006),tagRemove:f("tag-remove",60006),gitPullRequestLabel:f("git-pull-request-label",60006),person:f("person",60007),personFollow:f("person-follow",60007),personOutline:f("person-outline",60007),personFilled:f("person-filled",60007),gitBranch:f("git-branch",60008),gitBranchCreate:f("git-branch-create",60008),gitBranchDelete:f("git-branch-delete",60008),sourceControl:f("source-control",60008),mirror:f("mirror",60009),mirrorPublic:f("mirror-public",60009),star:f("star",60010),starAdd:f("star-add",60010),starDelete:f("star-delete",60010),starEmpty:f("star-empty",60010),comment:f("comment",60011),commentAdd:f("comment-add",60011),alert:f("alert",60012),warning:f("warning",60012),search:f("search",60013),searchSave:f("search-save",60013),logOut:f("log-out",60014),signOut:f("sign-out",60014),logIn:f("log-in",60015),signIn:f("sign-in",60015),eye:f("eye",60016),eyeUnwatch:f("eye-unwatch",60016),eyeWatch:f("eye-watch",60016),circleFilled:f("circle-filled",60017),primitiveDot:f("primitive-dot",60017),closeDirty:f("close-dirty",60017),debugBreakpoint:f("debug-breakpoint",60017),debugBreakpointDisabled:f("debug-breakpoint-disabled",60017),debugHint:f("debug-hint",60017),primitiveSquare:f("primitive-square",60018),edit:f("edit",60019),pencil:f("pencil",60019),info:f("info",60020),issueOpened:f("issue-opened",60020),gistPrivate:f("gist-private",60021),gitForkPrivate:f("git-fork-private",60021),lock:f("lock",60021),mirrorPrivate:f("mirror-private",60021),close:f("close",60022),removeClose:f("remove-close",60022),x:f("x",60022),repoSync:f("repo-sync",60023),sync:f("sync",60023),clone:f("clone",60024),desktopDownload:f("desktop-download",60024),beaker:f("beaker",60025),microscope:f("microscope",60025),vm:f("vm",60026),deviceDesktop:f("device-desktop",60026),file:f("file",60027),fileText:f("file-text",60027),more:f("more",60028),ellipsis:f("ellipsis",60028),kebabHorizontal:f("kebab-horizontal",60028),mailReply:f("mail-reply",60029),reply:f("reply",60029),organization:f("organization",60030),organizationFilled:f("organization-filled",60030),organizationOutline:f("organization-outline",60030),newFile:f("new-file",60031),fileAdd:f("file-add",60031),newFolder:f("new-folder",60032),fileDirectoryCreate:f("file-directory-create",60032),trash:f("trash",60033),trashcan:f("trashcan",60033),history:f("history",60034),clock:f("clock",60034),folder:f("folder",60035),fileDirectory:f("file-directory",60035),symbolFolder:f("symbol-folder",60035),logoGithub:f("logo-github",60036),markGithub:f("mark-github",60036),github:f("github",60036),terminal:f("terminal",60037),console:f("console",60037),repl:f("repl",60037),zap:f("zap",60038),symbolEvent:f("symbol-event",60038),error:f("error",60039),stop:f("stop",60039),variable:f("variable",60040),symbolVariable:f("symbol-variable",60040),array:f("array",60042),symbolArray:f("symbol-array",60042),symbolModule:f("symbol-module",60043),symbolPackage:f("symbol-package",60043),symbolNamespace:f("symbol-namespace",60043),symbolObject:f("symbol-object",60043),symbolMethod:f("symbol-method",60044),symbolFunction:f("symbol-function",60044),symbolConstructor:f("symbol-constructor",60044),symbolBoolean:f("symbol-boolean",60047),symbolNull:f("symbol-null",60047),symbolNumeric:f("symbol-numeric",60048),symbolNumber:f("symbol-number",60048),symbolStructure:f("symbol-structure",60049),symbolStruct:f("symbol-struct",60049),symbolParameter:f("symbol-parameter",60050),symbolTypeParameter:f("symbol-type-parameter",60050),symbolKey:f("symbol-key",60051),symbolText:f("symbol-text",60051),symbolReference:f("symbol-reference",60052),goToFile:f("go-to-file",60052),symbolEnum:f("symbol-enum",60053),symbolValue:f("symbol-value",60053),symbolRuler:f("symbol-ruler",60054),symbolUnit:f("symbol-unit",60054),activateBreakpoints:f("activate-breakpoints",60055),archive:f("archive",60056),arrowBoth:f("arrow-both",60057),arrowDown:f("arrow-down",60058),arrowLeft:f("arrow-left",60059),arrowRight:f("arrow-right",60060),arrowSmallDown:f("arrow-small-down",60061),arrowSmallLeft:f("arrow-small-left",60062),arrowSmallRight:f("arrow-small-right",60063),arrowSmallUp:f("arrow-small-up",60064),arrowUp:f("arrow-up",60065),bell:f("bell",60066),bold:f("bold",60067),book:f("book",60068),bookmark:f("bookmark",60069),debugBreakpointConditionalUnverified:f("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:f("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:f("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:f("debug-breakpoint-data-unverified",60072),debugBreakpointData:f("debug-breakpoint-data",60073),debugBreakpointDataDisabled:f("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:f("debug-breakpoint-log-unverified",60074),debugBreakpointLog:f("debug-breakpoint-log",60075),debugBreakpointLogDisabled:f("debug-breakpoint-log-disabled",60075),briefcase:f("briefcase",60076),broadcast:f("broadcast",60077),browser:f("browser",60078),bug:f("bug",60079),calendar:f("calendar",60080),caseSensitive:f("case-sensitive",60081),check:f("check",60082),checklist:f("checklist",60083),chevronDown:f("chevron-down",60084),dropDownButton:f("drop-down-button",60084),chevronLeft:f("chevron-left",60085),chevronRight:f("chevron-right",60086),chevronUp:f("chevron-up",60087),chromeClose:f("chrome-close",60088),chromeMaximize:f("chrome-maximize",60089),chromeMinimize:f("chrome-minimize",60090),chromeRestore:f("chrome-restore",60091),circle:f("circle",60092),circleOutline:f("circle-outline",60092),debugBreakpointUnverified:f("debug-breakpoint-unverified",60092),circleSlash:f("circle-slash",60093),circuitBoard:f("circuit-board",60094),clearAll:f("clear-all",60095),clippy:f("clippy",60096),closeAll:f("close-all",60097),cloudDownload:f("cloud-download",60098),cloudUpload:f("cloud-upload",60099),code:f("code",60100),collapseAll:f("collapse-all",60101),colorMode:f("color-mode",60102),commentDiscussion:f("comment-discussion",60103),compareChanges:f("compare-changes",60157),creditCard:f("credit-card",60105),dash:f("dash",60108),dashboard:f("dashboard",60109),database:f("database",60110),debugContinue:f("debug-continue",60111),debugDisconnect:f("debug-disconnect",60112),debugPause:f("debug-pause",60113),debugRestart:f("debug-restart",60114),debugStart:f("debug-start",60115),debugStepInto:f("debug-step-into",60116),debugStepOut:f("debug-step-out",60117),debugStepOver:f("debug-step-over",60118),debugStop:f("debug-stop",60119),debug:f("debug",60120),deviceCameraVideo:f("device-camera-video",60121),deviceCamera:f("device-camera",60122),deviceMobile:f("device-mobile",60123),diffAdded:f("diff-added",60124),diffIgnored:f("diff-ignored",60125),diffModified:f("diff-modified",60126),diffRemoved:f("diff-removed",60127),diffRenamed:f("diff-renamed",60128),diff:f("diff",60129),discard:f("discard",60130),editorLayout:f("editor-layout",60131),emptyWindow:f("empty-window",60132),exclude:f("exclude",60133),extensions:f("extensions",60134),eyeClosed:f("eye-closed",60135),fileBinary:f("file-binary",60136),fileCode:f("file-code",60137),fileMedia:f("file-media",60138),filePdf:f("file-pdf",60139),fileSubmodule:f("file-submodule",60140),fileSymlinkDirectory:f("file-symlink-directory",60141),fileSymlinkFile:f("file-symlink-file",60142),fileZip:f("file-zip",60143),files:f("files",60144),filter:f("filter",60145),flame:f("flame",60146),foldDown:f("fold-down",60147),foldUp:f("fold-up",60148),fold:f("fold",60149),folderActive:f("folder-active",60150),folderOpened:f("folder-opened",60151),gear:f("gear",60152),gift:f("gift",60153),gistSecret:f("gist-secret",60154),gist:f("gist",60155),gitCommit:f("git-commit",60156),gitCompare:f("git-compare",60157),gitMerge:f("git-merge",60158),githubAction:f("github-action",60159),githubAlt:f("github-alt",60160),globe:f("globe",60161),grabber:f("grabber",60162),graph:f("graph",60163),gripper:f("gripper",60164),heart:f("heart",60165),home:f("home",60166),horizontalRule:f("horizontal-rule",60167),hubot:f("hubot",60168),inbox:f("inbox",60169),issueClosed:f("issue-closed",60324),issueReopened:f("issue-reopened",60171),issues:f("issues",60172),italic:f("italic",60173),jersey:f("jersey",60174),json:f("json",60175),bracket:f("bracket",60175),kebabVertical:f("kebab-vertical",60176),key:f("key",60177),law:f("law",60178),lightbulbAutofix:f("lightbulb-autofix",60179),linkExternal:f("link-external",60180),link:f("link",60181),listOrdered:f("list-ordered",60182),listUnordered:f("list-unordered",60183),liveShare:f("live-share",60184),loading:f("loading",60185),location:f("location",60186),mailRead:f("mail-read",60187),mail:f("mail",60188),markdown:f("markdown",60189),megaphone:f("megaphone",60190),mention:f("mention",60191),milestone:f("milestone",60192),gitPullRequestMilestone:f("git-pull-request-milestone",60192),mortarBoard:f("mortar-board",60193),move:f("move",60194),multipleWindows:f("multiple-windows",60195),mute:f("mute",60196),noNewline:f("no-newline",60197),note:f("note",60198),octoface:f("octoface",60199),openPreview:f("open-preview",60200),package:f("package",60201),paintcan:f("paintcan",60202),pin:f("pin",60203),play:f("play",60204),run:f("run",60204),plug:f("plug",60205),preserveCase:f("preserve-case",60206),preview:f("preview",60207),project:f("project",60208),pulse:f("pulse",60209),question:f("question",60210),quote:f("quote",60211),radioTower:f("radio-tower",60212),reactions:f("reactions",60213),references:f("references",60214),refresh:f("refresh",60215),regex:f("regex",60216),remoteExplorer:f("remote-explorer",60217),remote:f("remote",60218),remove:f("remove",60219),replaceAll:f("replace-all",60220),replace:f("replace",60221),repoClone:f("repo-clone",60222),repoForcePush:f("repo-force-push",60223),repoPull:f("repo-pull",60224),repoPush:f("repo-push",60225),report:f("report",60226),requestChanges:f("request-changes",60227),rocket:f("rocket",60228),rootFolderOpened:f("root-folder-opened",60229),rootFolder:f("root-folder",60230),rss:f("rss",60231),ruby:f("ruby",60232),saveAll:f("save-all",60233),saveAs:f("save-as",60234),save:f("save",60235),screenFull:f("screen-full",60236),screenNormal:f("screen-normal",60237),searchStop:f("search-stop",60238),server:f("server",60240),settingsGear:f("settings-gear",60241),settings:f("settings",60242),shield:f("shield",60243),smiley:f("smiley",60244),sortPrecedence:f("sort-precedence",60245),splitHorizontal:f("split-horizontal",60246),splitVertical:f("split-vertical",60247),squirrel:f("squirrel",60248),starFull:f("star-full",60249),starHalf:f("star-half",60250),symbolClass:f("symbol-class",60251),symbolColor:f("symbol-color",60252),symbolCustomColor:f("symbol-customcolor",60252),symbolConstant:f("symbol-constant",60253),symbolEnumMember:f("symbol-enum-member",60254),symbolField:f("symbol-field",60255),symbolFile:f("symbol-file",60256),symbolInterface:f("symbol-interface",60257),symbolKeyword:f("symbol-keyword",60258),symbolMisc:f("symbol-misc",60259),symbolOperator:f("symbol-operator",60260),symbolProperty:f("symbol-property",60261),wrench:f("wrench",60261),wrenchSubaction:f("wrench-subaction",60261),symbolSnippet:f("symbol-snippet",60262),tasklist:f("tasklist",60263),telescope:f("telescope",60264),textSize:f("text-size",60265),threeBars:f("three-bars",60266),thumbsdown:f("thumbsdown",60267),thumbsup:f("thumbsup",60268),tools:f("tools",60269),triangleDown:f("triangle-down",60270),triangleLeft:f("triangle-left",60271),triangleRight:f("triangle-right",60272),triangleUp:f("triangle-up",60273),twitter:f("twitter",60274),unfold:f("unfold",60275),unlock:f("unlock",60276),unmute:f("unmute",60277),unverified:f("unverified",60278),verified:f("verified",60279),versions:f("versions",60280),vmActive:f("vm-active",60281),vmOutline:f("vm-outline",60282),vmRunning:f("vm-running",60283),watch:f("watch",60284),whitespace:f("whitespace",60285),wholeWord:f("whole-word",60286),window:f("window",60287),wordWrap:f("word-wrap",60288),zoomIn:f("zoom-in",60289),zoomOut:f("zoom-out",60290),listFilter:f("list-filter",60291),listFlat:f("list-flat",60292),listSelection:f("list-selection",60293),selection:f("selection",60293),listTree:f("list-tree",60294),debugBreakpointFunctionUnverified:f("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:f("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:f("debug-breakpoint-function-disabled",60296),debugStackframeActive:f("debug-stackframe-active",60297),circleSmallFilled:f("circle-small-filled",60298),debugStackframeDot:f("debug-stackframe-dot",60298),debugStackframe:f("debug-stackframe",60299),debugStackframeFocused:f("debug-stackframe-focused",60299),debugBreakpointUnsupported:f("debug-breakpoint-unsupported",60300),symbolString:f("symbol-string",60301),debugReverseContinue:f("debug-reverse-continue",60302),debugStepBack:f("debug-step-back",60303),debugRestartFrame:f("debug-restart-frame",60304),callIncoming:f("call-incoming",60306),callOutgoing:f("call-outgoing",60307),menu:f("menu",60308),expandAll:f("expand-all",60309),feedback:f("feedback",60310),gitPullRequestReviewer:f("git-pull-request-reviewer",60310),groupByRefType:f("group-by-ref-type",60311),ungroupByRefType:f("ungroup-by-ref-type",60312),account:f("account",60313),gitPullRequestAssignee:f("git-pull-request-assignee",60313),bellDot:f("bell-dot",60314),debugConsole:f("debug-console",60315),library:f("library",60316),output:f("output",60317),runAll:f("run-all",60318),syncIgnored:f("sync-ignored",60319),pinned:f("pinned",60320),githubInverted:f("github-inverted",60321),debugAlt:f("debug-alt",60305),serverProcess:f("server-process",60322),serverEnvironment:f("server-environment",60323),pass:f("pass",60324),stopCircle:f("stop-circle",60325),playCircle:f("play-circle",60326),record:f("record",60327),debugAltSmall:f("debug-alt-small",60328),vmConnect:f("vm-connect",60329),cloud:f("cloud",60330),merge:f("merge",60331),exportIcon:f("export",60332),graphLeft:f("graph-left",60333),magnet:f("magnet",60334),notebook:f("notebook",60335),redo:f("redo",60336),checkAll:f("check-all",60337),pinnedDirty:f("pinned-dirty",60338),passFilled:f("pass-filled",60339),circleLargeFilled:f("circle-large-filled",60340),circleLarge:f("circle-large",60341),circleLargeOutline:f("circle-large-outline",60341),combine:f("combine",60342),gather:f("gather",60342),table:f("table",60343),variableGroup:f("variable-group",60344),typeHierarchy:f("type-hierarchy",60345),typeHierarchySub:f("type-hierarchy-sub",60346),typeHierarchySuper:f("type-hierarchy-super",60347),gitPullRequestCreate:f("git-pull-request-create",60348),runAbove:f("run-above",60349),runBelow:f("run-below",60350),notebookTemplate:f("notebook-template",60351),debugRerun:f("debug-rerun",60352),workspaceTrusted:f("workspace-trusted",60353),workspaceUntrusted:f("workspace-untrusted",60354),workspaceUnspecified:f("workspace-unspecified",60355),terminalCmd:f("terminal-cmd",60356),terminalDebian:f("terminal-debian",60357),terminalLinux:f("terminal-linux",60358),terminalPowershell:f("terminal-powershell",60359),terminalTmux:f("terminal-tmux",60360),terminalUbuntu:f("terminal-ubuntu",60361),terminalBash:f("terminal-bash",60362),arrowSwap:f("arrow-swap",60363),copy:f("copy",60364),personAdd:f("person-add",60365),filterFilled:f("filter-filled",60366),wand:f("wand",60367),debugLineByLine:f("debug-line-by-line",60368),inspect:f("inspect",60369),layers:f("layers",60370),layersDot:f("layers-dot",60371),layersActive:f("layers-active",60372),compass:f("compass",60373),compassDot:f("compass-dot",60374),compassActive:f("compass-active",60375),azure:f("azure",60376),issueDraft:f("issue-draft",60377),gitPullRequestClosed:f("git-pull-request-closed",60378),gitPullRequestDraft:f("git-pull-request-draft",60379),debugAll:f("debug-all",60380),debugCoverage:f("debug-coverage",60381),runErrors:f("run-errors",60382),folderLibrary:f("folder-library",60383),debugContinueSmall:f("debug-continue-small",60384),beakerStop:f("beaker-stop",60385),graphLine:f("graph-line",60386),graphScatter:f("graph-scatter",60387),pieChart:f("pie-chart",60388),bracketDot:f("bracket-dot",60389),bracketError:f("bracket-error",60390),lockSmall:f("lock-small",60391),azureDevops:f("azure-devops",60392),verifiedFilled:f("verified-filled",60393),newLine:f("newline",60394),layout:f("layout",60395),layoutActivitybarLeft:f("layout-activitybar-left",60396),layoutActivitybarRight:f("layout-activitybar-right",60397),layoutPanelLeft:f("layout-panel-left",60398),layoutPanelCenter:f("layout-panel-center",60399),layoutPanelJustify:f("layout-panel-justify",60400),layoutPanelRight:f("layout-panel-right",60401),layoutPanel:f("layout-panel",60402),layoutSidebarLeft:f("layout-sidebar-left",60403),layoutSidebarRight:f("layout-sidebar-right",60404),layoutStatusbar:f("layout-statusbar",60405),layoutMenubar:f("layout-menubar",60406),layoutCentered:f("layout-centered",60407),layoutSidebarRightOff:f("layout-sidebar-right-off",60416),layoutPanelOff:f("layout-panel-off",60417),layoutSidebarLeftOff:f("layout-sidebar-left-off",60418),target:f("target",60408),indent:f("indent",60409),recordSmall:f("record-small",60410),errorSmall:f("error-small",60411),arrowCircleDown:f("arrow-circle-down",60412),arrowCircleLeft:f("arrow-circle-left",60413),arrowCircleRight:f("arrow-circle-right",60414),arrowCircleUp:f("arrow-circle-up",60415),heartFilled:f("heart-filled",60420),map:f("map",60421),mapFilled:f("map-filled",60422),circleSmall:f("circle-small",60423),bellSlash:f("bell-slash",60424),bellSlashDot:f("bell-slash-dot",60425),commentUnresolved:f("comment-unresolved",60426),gitPullRequestGoToChanges:f("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:f("git-pull-request-new-changes",60428),searchFuzzy:f("search-fuzzy",60429),commentDraft:f("comment-draft",60430),send:f("send",60431),sparkle:f("sparkle",60432),insert:f("insert",60433),mic:f("mic",60434),thumbsDownFilled:f("thumbsdown-filled",60435),thumbsUpFilled:f("thumbsup-filled",60436),coffee:f("coffee",60437),snake:f("snake",60438),game:f("game",60439),vr:f("vr",60440),chip:f("chip",60441),piano:f("piano",60442),music:f("music",60443),micFilled:f("mic-filled",60444),gitFetch:f("git-fetch",60445),copilot:f("copilot",60446),dialogError:f("dialog-error","error"),dialogWarning:f("dialog-warning","warning"),dialogInfo:f("dialog-info","info"),dialogClose:f("dialog-close","close"),treeItemExpanded:f("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:f("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:f("tree-filter-on-type-off","list-selection"),treeFilterClear:f("tree-filter-clear","close"),treeItemLoading:f("tree-item-loading","loading"),menuSelection:f("menu-selection","check"),menuSubmenu:f("menu-submenu","chevron-right"),menuBarMore:f("menubar-more","more"),scrollbarButtonLeft:f("scrollbar-button-left","triangle-left"),scrollbarButtonRight:f("scrollbar-button-right","triangle-right"),scrollbarButtonUp:f("scrollbar-button-up","triangle-up"),scrollbarButtonDown:f("scrollbar-button-down","triangle-down"),toolBarMore:f("toolbar-more","more"),quickInputBack:f("quick-input-back","arrow-left")}}),define(ke[24],Se([1,0,18]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=void 0;function T(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const i=Array.isArray(o)?[]:{};return Object.entries(o).forEach(([n,r])=>{i[n]=r&&typeof r=="object"?T(r):r}),i}e.$an=T;function f(o){if(!o||typeof o!="object")return o;const i=[o];for(;i.length>0;){const n=i.shift();Object.freeze(n);for(const r in n)if(R.call(n,r)){const a=n[r];typeof a=="object"&&!Object.isFrozen(a)&&!(0,C.$Ff)(a)&&i.push(a)}}return o}e.$bn=f;const R=Object.prototype.hasOwnProperty;function L(o,i){return b(o,i,new Set)}e.$cn=L;function b(o,i,n){if((0,C.$Lf)(o))return o;const r=i(o);if(typeof r<"u")return r;if(Array.isArray(o)){const a=[];for(const t of o)a.push(b(t,i,n));return a}if((0,C.$Ef)(o)){if(n.has(o))throw new Error("Cannot clone recursive data-structure");n.add(o);const a={};for(const t in o)R.call(o,t)&&(a[t]=b(o[t],i,n));return n.delete(o),a}return o}function y(o,i,n=!0){return(0,C.$Ef)(o)?((0,C.$Ef)(i)&&Object.keys(i).forEach(r=>{r in o?n&&((0,C.$Ef)(o[r])&&(0,C.$Ef)(i[r])?y(o[r],i[r],n):o[r]=i[r]):o[r]=i[r]}),o):i}e.$dn=y;function g(o,i){if(o===i)return!0;if(o==null||i===null||i===void 0||typeof o!=typeof i||typeof o!="object"||Array.isArray(o)!==Array.isArray(i))return!1;let n,r;if(Array.isArray(o)){if(o.length!==i.length)return!1;for(n=0;n<o.length;n++)if(!g(o[n],i[n]))return!1}else{const a=[];for(r in o)a.push(r);a.sort();const t=[];for(r in i)t.push(r);if(t.sort(),!g(a,t))return!1;for(n=0;n<a.length;n++)if(!g(o[a[n]],i[a[n]]))return!1}return!0}e.$en=g;function A(o){const i=new Set;return JSON.stringify(o,(n,r)=>{if((0,C.$Ef)(r)||Array.isArray(r)){if(i.has(r))return"[Circular]";i.add(r)}return r})}e.$fn=A;function I(o,i){const n=Object.create(null);return!o||!i||Object.keys(i).forEach(a=>{const t=o[a],s=i[a];g(t,s)||(n[a]=s)}),n}e.$gn=I;function $(o,i){const n=i.toLowerCase(),r=Object.keys(o).find(a=>a.toLowerCase()===n);return r?o[r]:o[i]}e.$hn=$;function v(o,i){const n=Object.create(null);for(const[r,a]of Object.entries(o))i(r,a)&&(n[r]=a);return n}e.$in=v;function S(o){let i=[];for(;Object.prototype!==o;)i=i.concat(Object.getOwnPropertyNames(o)),o=Object.getPrototypeOf(o);return i}e.$jn=S;function w(o){const i=[];for(const n of S(o))typeof o[n]=="function"&&i.push(n);return i}e.$kn=w;function l(o,i){const n=a=>function(){const t=Array.prototype.slice.call(arguments,0);return i(a,t)},r={};for(const a of o)r[a]=n(a);return r}e.$ln=l}),define(ke[61],Se([1,0,78]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$2j=e.ThemeColor=void 0;var T;(function(L){function b(y){return y&&typeof y=="object"&&typeof y.id=="string"}L.isThemeColor=b})(T||(e.ThemeColor=T={}));function f(L){return{id:L}}e.$2j=f;var R;(function(L){L.iconNameSegment="[A-Za-z0-9]+",L.iconNameExpression="[A-Za-z0-9-]+",L.iconModifierExpression="~[A-Za-z]+",L.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${L.iconNameExpression})(${L.iconModifierExpression})?$`);function y(i){const n=b.exec(i.id);if(!n)return y(C.$1j.error);const[,r,a]=n,t=["codicon","codicon-"+r];return a&&t.push("codicon-modifier-"+a.substring(1)),t}L.asClassNameArray=y;function g(i){return y(i).join(" ")}L.asClassName=g;function A(i){return"."+y(i).join(".")}L.asCSSSelector=A;function I(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||T.isThemeColor(i.color))}L.isThemeIcon=I;const $=new RegExp(`^\\$\\((${L.iconNameExpression}(?:${L.iconModifierExpression})?)\\)$`);function v(i){const n=$.exec(i);if(!n)return;const[,r]=n;return{id:r}}L.fromString=v;function S(i){return{id:i}}L.fromId=S;function w(i,n){let r=i.id;const a=r.lastIndexOf("~");return a!==-1&&(r=r.substring(0,a)),n&&(r=`${r}~${n}`),{id:r}}L.modify=w;function l(i){const n=i.id.lastIndexOf("~");if(n!==-1)return i.id.substring(n+1)}L.getModifier=l;function o(i,n){return i.id===n.id&&i.color?.id===n.color?.id}L.isEqual=o})(R||(e.ThemeIcon=R={}))}),define(ke[164],Se([1,0,124,13,61]),function(me,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=void 0;const R="$(",L=new RegExp(`\\$\\(${f.ThemeIcon.iconNameExpression}(?:${f.ThemeIcon.iconModifierExpression})?\\)`,"g"),b=new RegExp(`(\\\\)?${L.source}`,"g");function y(o){return o.replace(b,(i,n)=>n?i:`\\${i}`)}e.$3j=y;const g=new RegExp(`\\\\${L.source}`,"g");function A(o){return o.replace(g,i=>`\\${i}`)}e.$4j=A;const I=new RegExp(`(\\s)?(\\\\)?${L.source}(\\s)?`,"g");function $(o){return o.indexOf(R)===-1?o:o.replace(I,(i,n,r,a)=>r?i:n||a||"")}e.$5j=$;function v(o){return o?o.replace(/\$\((.*?)\)/g,(i,n)=>` ${n} `).trim():""}e.$6j=v;const S=new RegExp(`\\$\\(${f.ThemeIcon.iconNameCharacter}+\\)`,"g");function w(o){S.lastIndex=0;let i="";const n=[];let r=0;for(;;){const a=S.lastIndex,t=S.exec(o),s=o.substring(a,t?.index);if(s.length>0){i+=s;for(let d=0;d<s.length;d++)n.push(r)}if(!t)break;r+=t[0].length}return{text:i,iconOffsets:n}}e.$7j=w;function l(o,i,n=!1){const{text:r,iconOffsets:a}=i;if(!a||a.length===0)return(0,C.$Pj)(o,r,n);const t=(0,T.$Ne)(r," "),s=r.length-t.length,d=(0,C.$Pj)(o,t,n);if(d)for(const c of d){const u=a[c.start+s]+s;c.start+=u,c.end+=u}return d}e.$8j=l}),define(ke[125],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ee=e.$De=e.Constants=void 0;var C;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(C||(e.Constants=C={}));function T(R){return R<0?0:R>255?255:R|0}e.$De=T;function f(R){return R<0?0:R>4294967295?4294967295:R|0}e.$Ee=f}),define(ke[32],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ig=e.$hg=void 0;const C=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(f){return C.test(f)}e.$hg=T,e.$ig=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let f;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?f=crypto.getRandomValues.bind(crypto):f=function(b){for(let y=0;y<b.length;y++)b[y]=Math.floor(Math.random()*256);return b};const R=new Uint8Array(16),L=[];for(let b=0;b<256;b++)L.push(b.toString(16).padStart(2,"0"));return function(){f(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let y=0,g="";return g+=L[R[y++]],g+=L[R[y++]],g+=L[R[y++]],g+=L[R[y++]],g+="-",g+=L[R[y++]],g+=L[R[y++]],g+="-",g+=L[R[y++]],g+=L[R[y++]],g+="-",g+=L[R[y++]],g+=L[R[y++]],g+="-",g+=L[R[y++]],g+=L[R[y++]],g+=L[R[y++]],g+=L[R[y++]],g+=L[R[y++]],g+=L[R[y++]],g}}()}),define(ke[165],Se([1,0,19,51,32]),function(me,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9s=e.$8s=e.$7s=e.$6s=e.$5s=void 0;function R(I){return{asString:async()=>I,asFile:()=>{},value:typeof I=="string"?I:void 0}}e.$5s=R;function L(I,$,v){const S={id:(0,f.$ig)(),name:I,uri:$,data:v};return{asString:async()=>"",asFile:()=>S,value:void 0}}e.$6s=L;class b{constructor(){this.a=new Map}get size(){let $=0;for(const v of this.a)$++;return $}has($){return this.a.has(this.b($))}matches($){const v=[...this.a.keys()];return T.Iterable.some(this,([S,w])=>w.asFile())&&v.push("files"),A(y($),v)}get($){return this.a.get(this.b($))?.[0]}append($,v){const S=this.a.get($);S?S.push(v):this.a.set(this.b($),[v])}replace($,v){this.a.set(this.b($),[v])}delete($){this.a.delete(this.b($))}*[Symbol.iterator](){for(const[$,v]of this.a)for(const S of v)yield[$,S]}b($){return y($)}}e.$7s=b;function y(I){return I.toLowerCase()}function g(I,$){return A(y(I),$.map(y))}e.$8s=g;function A(I,$){if(I==="*/*")return $.length>0;if($.includes(I))return!0;const v=I.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!v)return!1;const[S,w,l]=v;return l==="*"?$.some(o=>o.startsWith(w+"/")):!1}e.$9s=Object.freeze({create:I=>(0,C.$Lb)(I.map($=>$.toString())).join(`\r
`),split:I=>I.split(`\r
`),parse:I=>e.$9s.split(I).filter($=>!$.startsWith("#"))})}),define(ke[166],Se([1,0,62]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mg=e.$lg=e.$kg=void 0;function T(b,y,g,A=1){let I=!1;return new Promise($=>{const v=setTimeout(()=>{if(!I)return I=!0,$(0)},g);f(b,y,A,S=>{if(!I)return I=!0,clearTimeout(v),$(S)})})}e.$kg=T;function f(b,y,g,A){if(y===0)return A(0);const I=new C.Socket;I.once("connect",()=>(L(I),f(b+g,y-1,g,A))),I.once("data",()=>{}),I.once("error",$=>(L(I),$.code!=="ECONNREFUSED"?f(b+g,y-1,g,A):A(b))),I.connect(b,"127.0.0.1")}e.$lg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(b,y,g,A="127.0.0.1"){let I=!1,$,v=1;const S=C.createServer({pauseOnConnect:!0});function w(l,o){I||(I=!0,S.removeAllListeners(),S.close(),$&&clearTimeout($),o(l))}return new Promise(l=>{$=setTimeout(()=>{w(0,l)},g),S.on("listening",()=>{w(b,l)}),S.on("error",o=>{o&&(o.code==="EADDRINUSE"||o.code==="EACCES")&&v<y?(b++,v++,S.listen(b,A)):w(0,l)}),S.on("close",()=>{w(0,l)}),S.listen(b,A)})}e.$mg=R;function L(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch(y){console.error(y)}}}),define(ke[126],Se([1,0,125]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xs=e.$Ws=void 0;class T{constructor(b){const y=(0,C.$De)(b);this.c=y,this.a=T.d(y),this.b=new Map}static d(b){const y=new Uint8Array(256);return y.fill(b),y}set(b,y){const g=(0,C.$De)(y);b>=0&&b<256?this.a[b]=g:this.b.set(b,g)}get(b){return b>=0&&b<256?this.a[b]:this.b.get(b)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$Ws=T;var f;(function(L){L[L.False=0]="False",L[L.True=1]="True"})(f||(f={}));class R{constructor(){this.a=new T(0)}add(b){this.a.set(b,1)}has(b){return this.a.get(b)===1}clear(){return this.a.clear()}}e.$Xs=R}),define(ke[167],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_s=e.StringEOL=void 0;var C;(function(f){f[f.Unknown=0]="Unknown",f[f.Invalid=3]="Invalid",f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(C||(e.StringEOL=C={}));function T(f){let R=0,L=0,b=0,y=0;for(let g=0,A=f.length;g<A;g++){const I=f.charCodeAt(g);I===13?(R===0&&(L=g),R++,g+1<A&&f.charCodeAt(g+1)===10?(y|=2,g++):y|=3,b=g+1):I===10&&(y|=1,R===0&&(L=g),R++,b=g+1)}return R===0&&(L=f.length),[R,L,f.length-b,y]}e.$_s=T}),define(ke[53],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ys=void 0;class C{constructor(f,R){this.lineNumber=f,this.column=R}with(f=this.lineNumber,R=this.column){return f===this.lineNumber&&R===this.column?this:new C(f,R)}delta(f=0,R=0){return this.with(this.lineNumber+f,this.column+R)}equals(f){return C.equals(this,f)}static equals(f,R){return!f&&!R?!0:!!f&&!!R&&f.lineNumber===R.lineNumber&&f.column===R.column}isBefore(f){return C.isBefore(this,f)}static isBefore(f,R){return f.lineNumber<R.lineNumber?!0:R.lineNumber<f.lineNumber?!1:f.column<R.column}isBeforeOrEqual(f){return C.isBeforeOrEqual(this,f)}static isBeforeOrEqual(f,R){return f.lineNumber<R.lineNumber?!0:R.lineNumber<f.lineNumber?!1:f.column<=R.column}static compare(f,R){const L=f.lineNumber|0,b=R.lineNumber|0;if(L===b){const y=f.column|0,g=R.column|0;return y-g}return L-b}clone(){return new C(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(f){return new C(f.lineNumber,f.column)}static isIPosition(f){return f&&typeof f.lineNumber=="number"&&typeof f.column=="number"}}e.$ys=C}),define(ke[29],Se([1,0,53]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zs=void 0;class T{constructor(R,L,b,y){R>b||R===b&&L>y?(this.startLineNumber=b,this.startColumn=y,this.endLineNumber=R,this.endColumn=L):(this.startLineNumber=R,this.startColumn=L,this.endLineNumber=b,this.endColumn=y)}isEmpty(){return T.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return T.containsPosition(this,R)}static containsPosition(R,L){return!(L.lineNumber<R.startLineNumber||L.lineNumber>R.endLineNumber||L.lineNumber===R.startLineNumber&&L.column<R.startColumn||L.lineNumber===R.endLineNumber&&L.column>R.endColumn)}static strictContainsPosition(R,L){return!(L.lineNumber<R.startLineNumber||L.lineNumber>R.endLineNumber||L.lineNumber===R.startLineNumber&&L.column<=R.startColumn||L.lineNumber===R.endLineNumber&&L.column>=R.endColumn)}containsRange(R){return T.containsRange(this,R)}static containsRange(R,L){return!(L.startLineNumber<R.startLineNumber||L.endLineNumber<R.startLineNumber||L.startLineNumber>R.endLineNumber||L.endLineNumber>R.endLineNumber||L.startLineNumber===R.startLineNumber&&L.startColumn<R.startColumn||L.endLineNumber===R.endLineNumber&&L.endColumn>R.endColumn)}strictContainsRange(R){return T.strictContainsRange(this,R)}static strictContainsRange(R,L){return!(L.startLineNumber<R.startLineNumber||L.endLineNumber<R.startLineNumber||L.startLineNumber>R.endLineNumber||L.endLineNumber>R.endLineNumber||L.startLineNumber===R.startLineNumber&&L.startColumn<=R.startColumn||L.endLineNumber===R.endLineNumber&&L.endColumn>=R.endColumn)}plusRange(R){return T.plusRange(this,R)}static plusRange(R,L){let b,y,g,A;return L.startLineNumber<R.startLineNumber?(b=L.startLineNumber,y=L.startColumn):L.startLineNumber===R.startLineNumber?(b=L.startLineNumber,y=Math.min(L.startColumn,R.startColumn)):(b=R.startLineNumber,y=R.startColumn),L.endLineNumber>R.endLineNumber?(g=L.endLineNumber,A=L.endColumn):L.endLineNumber===R.endLineNumber?(g=L.endLineNumber,A=Math.max(L.endColumn,R.endColumn)):(g=R.endLineNumber,A=R.endColumn),new T(b,y,g,A)}intersectRanges(R){return T.intersectRanges(this,R)}static intersectRanges(R,L){let b=R.startLineNumber,y=R.startColumn,g=R.endLineNumber,A=R.endColumn;const I=L.startLineNumber,$=L.startColumn,v=L.endLineNumber,S=L.endColumn;return b<I?(b=I,y=$):b===I&&(y=Math.max(y,$)),g>v?(g=v,A=S):g===v&&(A=Math.min(A,S)),b>g||b===g&&y>A?null:new T(b,y,g,A)}equalsRange(R){return T.equalsRange(this,R)}static equalsRange(R,L){return!R&&!L?!0:!!R&&!!L&&R.startLineNumber===L.startLineNumber&&R.startColumn===L.startColumn&&R.endLineNumber===L.endLineNumber&&R.endColumn===L.endColumn}getEndPosition(){return T.getEndPosition(this)}static getEndPosition(R){return new C.$ys(R.endLineNumber,R.endColumn)}getStartPosition(){return T.getStartPosition(this)}static getStartPosition(R){return new C.$ys(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,L){return new T(this.startLineNumber,this.startColumn,R,L)}setStartPosition(R,L){return new T(R,L,this.endLineNumber,this.endColumn)}collapseToStart(){return T.collapseToStart(this)}static collapseToStart(R){return new T(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return T.collapseToEnd(this)}static collapseToEnd(R){return new T(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new T(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,L=R){return new T(R.lineNumber,R.column,L.lineNumber,L.column)}static lift(R){return R?new T(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,L){return!(R.endLineNumber<L.startLineNumber||R.endLineNumber===L.startLineNumber&&R.endColumn<L.startColumn||L.endLineNumber<R.startLineNumber||L.endLineNumber===R.startLineNumber&&L.endColumn<R.startColumn)}static areIntersecting(R,L){return!(R.endLineNumber<L.startLineNumber||R.endLineNumber===L.startLineNumber&&R.endColumn<=L.startColumn||L.endLineNumber<R.startLineNumber||L.endLineNumber===R.startLineNumber&&L.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,L){if(R&&L){const g=R.startLineNumber|0,A=L.startLineNumber|0;if(g===A){const I=R.startColumn|0,$=L.startColumn|0;if(I===$){const v=R.endLineNumber|0,S=L.endLineNumber|0;if(v===S){const w=R.endColumn|0,l=L.endColumn|0;return w-l}return v-S}return I-$}return g-A}return(R?1:0)-(L?1:0)}static compareRangesUsingEnds(R,L){return R.endLineNumber===L.endLineNumber?R.endColumn===L.endColumn?R.startLineNumber===L.startLineNumber?R.startColumn-L.startColumn:R.startLineNumber-L.startLineNumber:R.endColumn-L.endColumn:R.endLineNumber-L.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.$zs=T}),define(ke[168],Se([1,0,29]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$As=void 0;class T{static insert(R,L){return{range:new C.$zs(R.lineNumber,R.column,R.lineNumber,R.column),text:L,forceMoveMarkers:!0}}static delete(R){return{range:R,text:null}}static replace(R,L){return{range:R,text:L}}static replaceMove(R,L){return{range:R,text:L,forceMoveMarkers:!0}}}e.$As=T}),define(ke[169],Se([1,0,53,29]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bs=e.SelectionDirection=void 0;var f;(function(L){L[L.LTR=0]="LTR",L[L.RTL=1]="RTL"})(f||(e.SelectionDirection=f={}));class R extends T.$zs{constructor(b,y,g,A){super(b,y,g,A),this.selectionStartLineNumber=b,this.selectionStartColumn=y,this.positionLineNumber=g,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(b){return R.selectionsEqual(this,b)}static selectionsEqual(b,y){return b.selectionStartLineNumber===y.selectionStartLineNumber&&b.selectionStartColumn===y.selectionStartColumn&&b.positionLineNumber===y.positionLineNumber&&b.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(b,y){return this.getDirection()===0?new R(this.startLineNumber,this.startColumn,b,y):new R(b,y,this.startLineNumber,this.startColumn)}getPosition(){return new C.$ys(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new C.$ys(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(b,y){return this.getDirection()===0?new R(b,y,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,b,y)}static fromPositions(b,y=b){return new R(b.lineNumber,b.column,y.lineNumber,y.column)}static fromRange(b,y){return y===0?new R(b.startLineNumber,b.startColumn,b.endLineNumber,b.endColumn):new R(b.endLineNumber,b.endColumn,b.startLineNumber,b.startColumn)}static liftSelection(b){return new R(b.selectionStartLineNumber,b.selectionStartColumn,b.positionLineNumber,b.positionColumn)}static selectionsArrEqual(b,y){if(b&&!y||!b&&y)return!1;if(!b&&!y)return!0;if(b.length!==y.length)return!1;for(let g=0,A=b.length;g<A;g++)if(!this.selectionsEqual(b[g],y[g]))return!1;return!0}static isISelection(b){return b&&typeof b.selectionStartLineNumber=="number"&&typeof b.selectionStartColumn=="number"&&typeof b.positionLineNumber=="number"&&typeof b.positionColumn=="number"}static createWithDirection(b,y,g,A,I){return I===0?new R(b,y,g,A):new R(g,A,b,y)}}e.$Bs=R}),define(ke[170],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9r=void 0,e.$9r={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[171],Se([1,0,126]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zs=e.$Ys=e.WordCharacterClass=void 0;var T;(function(L){L[L.Regular=0]="Regular",L[L.Whitespace=1]="Whitespace",L[L.WordSeparator=2]="WordSeparator"})(T||(e.WordCharacterClass=T={}));class f extends C.$Ws{constructor(b){super(0);for(let y=0,g=b.length;y<g;y++)this.set(b.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.$Ys=f;function R(L){const b={};return y=>(b.hasOwnProperty(y)||(b[y]=L(y)),b[y])}e.$Zs=R(L=>new f(L))}),define(ke[127],Se([1,0,51,3,75]),function(me,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=e.$as=e.$_r=e.$$r=e.$0r=void 0,e.$0r="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(I=""){let $="(-?\\d*\\.\\d\\w*)|([^";for(const v of e.$0r)I.indexOf(v)>=0||($+="\\"+v);return $+="\\s]+)",new RegExp($,"g")}e.$$r=R();function L(I){let $=e.$$r;if(I&&I instanceof RegExp)if(I.global)$=I;else{let v="g";I.ignoreCase&&(v+="i"),I.multiline&&(v+="m"),I.unicode&&(v+="u"),$=new RegExp(I.source,v)}return $.lastIndex=0,$}e.$_r=L;const b=new f.$2c;b.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function y(I){const $=b.unshift(I);return(0,T.$Pc)($)}e.$as=y;function g(I,$,v,S,w){if(w||(w=C.Iterable.first(b)),v.length>w.maxLen){let r=I-w.maxLen/2;return r<0?r=0:S+=r,v=v.substring(r,I+w.maxLen/2),g(I,$,v,S,w)}const l=Date.now(),o=I-1-S;let i=-1,n=null;for(let r=1;!(Date.now()-l>=w.timeBudget);r++){const a=o-w.windowSize*r;$.lastIndex=Math.max(0,a);const t=A($,v,o,i);if(!t&&n||(n=t,a<=0))break;i=a}if(n){const r={word:n[0],startColumn:S+1+n.index,endColumn:S+1+n.index+n[0].length};return $.lastIndex=0,r}return null}e.$bs=g;function A(I,$,v,S){let w;for(;w=I.exec($);){const l=w.index||0;if(l<=v&&I.lastIndex>=v)return w;if(S>0&&l>S)return null}return null}}),define(ke[172],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=e.$vt=e.IndentAction=void 0;var C;(function(L){L[L.None=0]="None",L[L.Indent=1]="Indent",L[L.IndentOutdent=2]="IndentOutdent",L[L.Outdent=3]="Outdent"})(C||(e.IndentAction=C={}));class T{constructor(b){if(this.e=null,this.f=!1,this.open=b.open,this.close=b.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(b.notIn))for(let y=0,g=b.notIn.length;y<g;y++)switch(b.notIn[y]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(b){switch(b){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(b,y){if(b.getTokenCount()===0)return!0;const g=b.findTokenIndexAtOffset(y-2),A=b.getStandardTokenType(g);return this.isOK(A)}g(b,y){for(let g=b;g<=y;g++){const A=String.fromCharCode(g);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$vt=T;class f{constructor(b){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of b)R(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),R(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),R(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),R(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&R(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.$wt=f;function R(L,b,y){L.has(b)?L.get(b).push(y):L.set(b,[y])}}),define(ke[173],Se([1,0,126]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5Y=e.$4Y=e.$3Y=e.State=void 0;var T;(function(v){v[v.Invalid=0]="Invalid",v[v.Start=1]="Start",v[v.H=2]="H",v[v.HT=3]="HT",v[v.HTT=4]="HTT",v[v.HTTP=5]="HTTP",v[v.F=6]="F",v[v.FI=7]="FI",v[v.FIL=8]="FIL",v[v.BeforeColon=9]="BeforeColon",v[v.AfterColon=10]="AfterColon",v[v.AlmostThere=11]="AlmostThere",v[v.End=12]="End",v[v.Accept=13]="Accept",v[v.LastKnownState=14]="LastKnownState"})(T||(e.State=T={}));class f{constructor(S,w,l){const o=new Uint8Array(S*w);for(let i=0,n=S*w;i<n;i++)o[i]=l;this.a=o,this.rows=S,this.cols=w}get(S,w){return this.a[S*this.cols+w]}set(S,w,l){this.a[S*this.cols+w]=l}}class R{constructor(S){let w=0,l=0;for(let i=0,n=S.length;i<n;i++){const[r,a,t]=S[i];a>w&&(w=a),r>l&&(l=r),t>l&&(l=t)}w++,l++;const o=new f(l,w,0);for(let i=0,n=S.length;i<n;i++){const[r,a,t]=S[i];o.set(r,a,t)}this.a=o,this.b=w}nextState(S,w){return w<0||w>=this.b?0:this.a.get(S,w)}}e.$3Y=R;let L=null;function b(){return L===null&&(L=new R([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),L}var y;(function(v){v[v.None=0]="None",v[v.ForceTermination=1]="ForceTermination",v[v.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let g=null;function A(){if(g===null){g=new C.$Ws(0);const v=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let w=0;w<v.length;w++)g.set(v.charCodeAt(w),1);const S=".,;:";for(let w=0;w<S.length;w++)g.set(S.charCodeAt(w),2)}return g}class I{static a(S,w,l,o,i){let n=i-1;do{const r=w.charCodeAt(n);if(S.get(r)!==2)break;n--}while(n>o);if(o>0){const r=w.charCodeAt(o-1),a=w.charCodeAt(n);(r===40&&a===41||r===91&&a===93||r===123&&a===125)&&n--}return{range:{startLineNumber:l,startColumn:o+1,endLineNumber:l,endColumn:n+2},url:w.substring(o,n+1)}}static computeLinks(S,w=b()){const l=A(),o=[];for(let i=1,n=S.getLineCount();i<=n;i++){const r=S.getLineContent(i),a=r.length;let t=0,s=0,d=0,c=1,u=!1,h=!1,E=!1,D=!1;for(;t<a;){let m=!1;const p=r.charCodeAt(t);if(c===13){let k;switch(p){case 40:u=!0,k=0;break;case 41:k=u?0:1;break;case 91:E=!0,h=!0,k=0;break;case 93:E=!1,k=h?0:1;break;case 123:D=!0,k=0;break;case 125:k=D?0:1;break;case 39:case 34:case 96:d===p?k=1:d===39||d===34||d===96?k=0:k=1;break;case 42:k=d===42?1:0;break;case 124:k=d===124?1:0;break;case 32:k=E?0:1;break;default:k=l.get(p)}k===1&&(o.push(I.a(l,r,i,s,t)),m=!0)}else if(c===12){let k;p===91?(h=!0,k=0):k=l.get(p),k===1?m=!0:c=13}else c=w.nextState(c,p),c===0&&(m=!0);m&&(c=1,u=!1,h=!1,D=!1,s=t+1,d=p),t++}c===13&&o.push(I.a(l,r,i,s,a))}return o}}e.$4Y=I;function $(v){return!v||typeof v.getLineCount!="function"||typeof v.getLineContent!="function"?[]:I.computeLinks(v)}e.$5Y=$}),define(ke[79],Se([1,0,24]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vu=e.$Uu=e.$Tu=e.$Su=e.ModelConstants=e.PositionAffinity=e.$Ru=e.TrackedRangeStickiness=e.$Qu=e.$Pu=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var T;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(T||(e.OverviewRulerLane=T={}));var f;(function(r){r[r.Left=1]="Left",r[r.Right=2]="Right"})(f||(e.GlyphMarginLane=f={}));var R;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(R||(e.MinimapPosition=R={}));var L;(function(r){r[r.Both=0]="Both",r[r.Right=1]="Right",r[r.Left=2]="Left",r[r.None=3]="None"})(L||(e.InjectedTextCursorStops=L={}));var b;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(b||(e.EndOfLinePreference=b={}));var y;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(y||(e.DefaultEndOfLine=y={}));var g;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(g||(e.EndOfLineSequence=g={}));class A{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(a){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,a.tabSize|0),a.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,a.indentSize|0),this.a=!1),this.insertSpaces=!!a.insertSpaces,this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=!!a.trimAutoWhitespace,this.bracketPairColorizationOptions=a.bracketPairColorizationOptions}equals(a){return this.tabSize===a.tabSize&&this.a===a.a&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace&&(0,C.$en)(this.bracketPairColorizationOptions,a.bracketPairColorizationOptions)}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.$Pu=A;class I{constructor(a,t){this._findMatchBrand=void 0,this.range=a,this.matches=t}}e.$Qu=I;var $;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})($||(e.TrackedRangeStickiness=$={}));function v(r){return r&&typeof r.read=="function"}e.$Ru=v;var S;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right",r[r.None=2]="None",r[r.LeftOfInjectedText=3]="LeftOfInjectedText",r[r.RightOfInjectedText=4]="RightOfInjectedText"})(S||(e.PositionAffinity=S={}));var w;(function(r){r[r.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(w||(e.ModelConstants=w={}));class l{constructor(a,t,s,d,c,u){this.identifier=a,this.range=t,this.text=s,this.forceMoveMarkers=d,this.isAutoWhitespaceEdit=c,this._isTracked=u}}e.$Su=l;class o{constructor(a,t,s){this.regex=a,this.wordSeparators=t,this.simpleSearch=s}}e.$Tu=o;class i{constructor(a,t,s){this.reverseEdits=a,this.changes=t,this.trimAutoWhitespaceLineNumbers=s}}e.$Uu=i;function n(r){return!r.isTooLargeForSyncing()&&!r.isForSimpleWidget}e.$Vu=n}),define(ke[174],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AB=e.$zB=e.$yB=e.$xB=e.$wB=e.$vB=e.$uB=e.$tB=e.$sB=e.NodeColor=e.$rB=void 0;class C{constructor(l,o){this.piece=l,this.color=o,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$sB)return f(this.right);let l=this;for(;l.parent!==e.$sB&&l.parent.left!==l;)l=l.parent;return l.parent===e.$sB?e.$sB:l.parent}prev(){if(this.left!==e.$sB)return R(this.left);let l=this;for(;l.parent!==e.$sB&&l.parent.right!==l;)l=l.parent;return l.parent===e.$sB?e.$sB:l.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$rB=C;var T;(function(w){w[w.Black=0]="Black",w[w.Red=1]="Red"})(T||(e.NodeColor=T={})),e.$sB=new C(null,0),e.$sB.parent=e.$sB,e.$sB.left=e.$sB,e.$sB.right=e.$sB,e.$sB.color=0;function f(w){for(;w.left!==e.$sB;)w=w.left;return w}e.$tB=f;function R(w){for(;w.right!==e.$sB;)w=w.right;return w}e.$uB=R;function L(w){return w===e.$sB?0:w.size_left+w.piece.length+L(w.right)}function b(w){return w===e.$sB?0:w.lf_left+w.piece.lineFeedCnt+b(w.right)}function y(){e.$sB.parent=e.$sB}function g(w,l){const o=l.right;o.size_left+=l.size_left+(l.piece?l.piece.length:0),o.lf_left+=l.lf_left+(l.piece?l.piece.lineFeedCnt:0),l.right=o.left,o.left!==e.$sB&&(o.left.parent=l),o.parent=l.parent,l.parent===e.$sB?w.root=o:l.parent.left===l?l.parent.left=o:l.parent.right=o,o.left=l,l.parent=o}e.$vB=g;function A(w,l){const o=l.left;l.left=o.right,o.right!==e.$sB&&(o.right.parent=l),o.parent=l.parent,l.size_left-=o.size_left+(o.piece?o.piece.length:0),l.lf_left-=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),l.parent===e.$sB?w.root=o:l===l.parent.right?l.parent.right=o:l.parent.left=o,o.right=l,l.parent=o}e.$wB=A;function I(w,l){let o,i;if(l.left===e.$sB?(i=l,o=i.right):l.right===e.$sB?(i=l,o=i.left):(i=f(l.right),o=i.right),i===w.root){w.root=o,o.color=0,l.detach(),y(),w.root.parent=e.$sB;return}const n=i.color===1;if(i===i.parent.left?i.parent.left=o:i.parent.right=o,i===l?(o.parent=i.parent,S(w,o)):(i.parent===l?o.parent=i:o.parent=i.parent,S(w,o),i.left=l.left,i.right=l.right,i.parent=l.parent,i.color=l.color,l===w.root?w.root=i:l===l.parent.left?l.parent.left=i:l.parent.right=i,i.left!==e.$sB&&(i.left.parent=i),i.right!==e.$sB&&(i.right.parent=i),i.size_left=l.size_left,i.lf_left=l.lf_left,S(w,i)),l.detach(),o.parent.left===o){const a=L(o),t=b(o);if(a!==o.parent.size_left||t!==o.parent.lf_left){const s=a-o.parent.size_left,d=t-o.parent.lf_left;o.parent.size_left=a,o.parent.lf_left=t,v(w,o.parent,s,d)}}if(S(w,o.parent),n){y();return}let r;for(;o!==w.root&&o.color===0;)o===o.parent.left?(r=o.parent.right,r.color===1&&(r.color=0,o.parent.color=1,g(w,o.parent),r=o.parent.right),r.left.color===0&&r.right.color===0?(r.color=1,o=o.parent):(r.right.color===0&&(r.left.color=0,r.color=1,A(w,r),r=o.parent.right),r.color=o.parent.color,o.parent.color=0,r.right.color=0,g(w,o.parent),o=w.root)):(r=o.parent.left,r.color===1&&(r.color=0,o.parent.color=1,A(w,o.parent),r=o.parent.left),r.left.color===0&&r.right.color===0?(r.color=1,o=o.parent):(r.left.color===0&&(r.right.color=0,r.color=1,g(w,r),r=o.parent.left),r.color=o.parent.color,o.parent.color=0,r.left.color=0,A(w,o.parent),o=w.root));o.color=0,y()}e.$xB=I;function $(w,l){for(S(w,l);l!==w.root&&l.parent.color===1;)if(l.parent===l.parent.parent.left){const o=l.parent.parent.right;o.color===1?(l.parent.color=0,o.color=0,l.parent.parent.color=1,l=l.parent.parent):(l===l.parent.right&&(l=l.parent,g(w,l)),l.parent.color=0,l.parent.parent.color=1,A(w,l.parent.parent))}else{const o=l.parent.parent.left;o.color===1?(l.parent.color=0,o.color=0,l.parent.parent.color=1,l=l.parent.parent):(l===l.parent.left&&(l=l.parent,A(w,l)),l.parent.color=0,l.parent.parent.color=1,g(w,l.parent.parent))}w.root.color=0}e.$yB=$;function v(w,l,o,i){for(;l!==w.root&&l!==e.$sB;)l.parent.left===l&&(l.parent.size_left+=o,l.parent.lf_left+=i),l=l.parent}e.$zB=v;function S(w,l){let o=0,i=0;if(l!==w.root){for(;l!==w.root&&l===l.parent.right;)l=l.parent;if(l!==w.root)for(l=l.parent,o=L(l.left)-l.size_left,i=b(l.left)-l.lf_left,l.size_left+=o,l.lf_left+=i;l!==w.root&&(o!==0||i!==0);)l.parent.left===l&&(l.parent.size_left+=o,l.parent.lf_left+=i),l=l.parent}}e.$AB=S}),define(ke[175],Se([1,0,19,125]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1u=e.$Zu=e.$Yu=void 0;class f{constructor(y){this.a=y,this.b=new Uint32Array(y.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(y,g){y=(0,T.$Ee)(y);const A=this.a,I=this.b,$=g.length;return $===0?!1:(this.a=new Uint32Array(A.length+$),this.a.set(A.subarray(0,y),0),this.a.set(A.subarray(y),y+$),this.a.set(g,y),y-1<this.c[0]&&(this.c[0]=y-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}setValue(y,g){return y=(0,T.$Ee)(y),g=(0,T.$Ee)(g),this.a[y]===g?!1:(this.a[y]=g,y-1<this.c[0]&&(this.c[0]=y-1),!0)}removeValues(y,g){y=(0,T.$Ee)(y),g=(0,T.$Ee)(g);const A=this.a,I=this.b;if(y>=A.length)return!1;const $=A.length-y;return g>=$&&(g=$),g===0?!1:(this.a=new Uint32Array(A.length-g),this.a.set(A.subarray(0,y),0),this.a.set(A.subarray(y+g),y),this.b=new Uint32Array(this.a.length),y-1<this.c[0]&&(this.c[0]=y-1),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(y){return y<0?0:(y=(0,T.$Ee)(y),this.d(y))}d(y){if(y<=this.c[0])return this.b[y];let g=this.c[0]+1;g===0&&(this.b[0]=this.a[0],g++),y>=this.a.length&&(y=this.a.length-1);for(let A=g;A<=y;A++)this.b[A]=this.b[A-1]+this.a[A];return this.c[0]=Math.max(this.c[0],y),this.b[y]}getIndexOf(y){y=Math.floor(y),this.getTotalSum();let g=0,A=this.a.length-1,I=0,$=0,v=0;for(;g<=A;)if(I=g+(A-g)/2|0,$=this.b[I],v=$-this.a[I],y<v)A=I-1;else if(y>=$)g=I+1;else break;return new L(I,y-v)}}e.$Yu=f;class R{constructor(y){this.a=y,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(y){return this.g(),y===0?0:this.d[y-1]}getIndexOf(y){this.g();const g=this.e[y],A=g>0?this.d[g-1]:0;return new L(g,y-A)}removeValues(y,g){this.a.splice(y,g),this.f(y)}insertValues(y,g){this.a=(0,C.$Vb)(this.a,y,g),this.f(y)}f(y){this.b=!1,this.c=Math.min(this.c,y-1)}g(){if(!this.b){for(let y=this.c+1,g=this.a.length;y<g;y++){const A=this.a[y],I=y>0?this.d[y-1]:0;this.d[y]=I+A;for(let $=0;$<A;$++)this.e[I+$]=y}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(y,g){this.a[y]!==g&&(this.a[y]=g,this.f(y))}}e.$Zu=R;class L{constructor(y,g){this.index=y,this.remainder=g,this._prefixSumIndexOfResultBrand=void 0,this.index=y,this.remainder=g}}e.$1u=L}),define(ke[176],Se([1,0,13,53,175]),function(me,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2u=void 0;class R{constructor(b,y,g,A){this.d=b,this.f=y,this.g=g,this.h=A,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(b){b.eol&&b.eol!==this.g&&(this.g=b.eol,this.j=null);const y=b.changes;for(const g of y)this.o(g.range),this.p(new T.$ys(g.range.startLineNumber,g.range.startColumn),g.text);this.h=b.versionId,this.k=null}l(){if(!this.j){const b=this.g.length,y=this.f.length,g=new Uint32Array(y);for(let A=0;A<y;A++)g[A]=this.f[A].length+b;this.j=new f.$Yu(g)}}n(b,y){this.f[b]=y,this.j&&this.j.setValue(b,this.f[b].length+this.g.length)}o(b){if(b.startLineNumber===b.endLineNumber){if(b.startColumn===b.endColumn)return;this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.startLineNumber-1].substring(b.endColumn-1));return}this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.endLineNumber-1].substring(b.endColumn-1)),this.f.splice(b.startLineNumber,b.endLineNumber-b.startLineNumber),this.j&&this.j.removeValues(b.startLineNumber,b.endLineNumber-b.startLineNumber)}p(b,y){if(y.length===0)return;const g=(0,C.$Te)(y);if(g.length===1){this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+g[0]+this.f[b.lineNumber-1].substring(b.column-1));return}g[g.length-1]+=this.f[b.lineNumber-1].substring(b.column-1),this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+g[0]);const A=new Uint32Array(g.length-1);for(let I=1;I<g.length;I++)this.f.splice(b.lineNumber+I-1,0,g[I]),A[I-1]=g[I].length+this.g.length;this.j&&this.j.insertValues(b.lineNumber,A)}}e.$2u=R}),define(ke[99],Se([1,0,13,171,53,29,79]),function(me,e,C,T,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GB=e.$FB=e.$EB=e.$DB=e.$CB=e.$BB=void 0;const b=999;class y{constructor(i,n,r,a){this.searchString=i,this.isRegex=n,this.matchCase=r,this.wordSeparators=a}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=g(this.searchString):i=this.searchString.indexOf(`
`)>=0;let n=null;try{n=C.$Re(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!n)return null;let r=!this.isRegex&&!i;return r&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(r=this.matchCase),new L.$Tu(n,this.wordSeparators?(0,T.$Zs)(this.wordSeparators):null,r?this.searchString:null)}}e.$BB=y;function g(o){if(!o||o.length===0)return!1;for(let i=0,n=o.length;i<n;i++){const r=o.charCodeAt(i);if(r===10)return!0;if(r===92){if(i++,i>=n)break;const a=o.charCodeAt(i);if(a===110||a===114||a===87)return!0}}return!1}e.$CB=g;function A(o,i,n){if(!n)return new L.$Qu(o,null);const r=[];for(let a=0,t=i.length;a<t;a++)r[a]=i[a];return new L.$Qu(o,r)}e.$DB=A;class I{constructor(i){const n=[];let r=0;for(let a=0,t=i.length;a<t;a++)i.charCodeAt(a)===10&&(n[r++]=a);this.a=n}findLineFeedCountBeforeOffset(i){const n=this.a;let r=0,a=n.length-1;if(a===-1||i<=n[0])return 0;for(;r<a;){const t=r+((a-r)/2>>0);n[t]>=i?a=t-1:n[t+1]>=i?(r=t,a=t):r=t+1}return r+1}}class ${static findMatches(i,n,r,a,t){const s=n.parseSearchRequest();return s?s.regex.multiline?this.b(i,r,new l(s.wordSeparators,s.regex),a,t):this.c(i,r,s,a,t):[]}static a(i,n,r,a,t,s){let d,c=0;a?(c=a.findLineFeedCountBeforeOffset(t),d=n+t+c):d=n+t;let u;if(a){const m=a.findLineFeedCountBeforeOffset(t+s.length)-c;u=d+s.length+m}else u=d+s.length;const h=i.getPositionAt(d),E=i.getPositionAt(u);return new R.$zs(h.lineNumber,h.column,E.lineNumber,E.column)}static b(i,n,r,a,t){const s=i.getOffsetAt(n.getStartPosition()),d=i.getValueInRange(n,1),c=i.getEOL()===`\r
`?new I(d):null,u=[];let h=0,E;for(r.reset(0);E=r.next(d);)if(u[h++]=A(this.a(i,s,d,c,E.index,E[0]),E,a),h>=t)return u;return u}static c(i,n,r,a,t){const s=[];let d=0;if(n.startLineNumber===n.endLineNumber){const u=i.getLineContent(n.startLineNumber).substring(n.startColumn-1,n.endColumn-1);return d=this.d(r,u,n.startLineNumber,n.startColumn-1,d,s,a,t),s}const c=i.getLineContent(n.startLineNumber).substring(n.startColumn-1);d=this.d(r,c,n.startLineNumber,n.startColumn-1,d,s,a,t);for(let u=n.startLineNumber+1;u<n.endLineNumber&&d<t;u++)d=this.d(r,i.getLineContent(u),u,0,d,s,a,t);if(d<t){const u=i.getLineContent(n.endLineNumber).substring(0,n.endColumn-1);d=this.d(r,u,n.endLineNumber,0,d,s,a,t)}return s}static d(i,n,r,a,t,s,d,c){const u=i.wordSeparators;if(!d&&i.simpleSearch){const D=i.simpleSearch,m=D.length,p=n.length;let k=-m;for(;(k=n.indexOf(D,k+m))!==-1;)if((!u||w(u,n,p,k,m))&&(s[t++]=new L.$Qu(new R.$zs(r,k+1+a,r,k+1+m+a),null),t>=c))return t;return t}const h=new l(i.wordSeparators,i.regex);let E;h.reset(0);do if(E=h.next(n),E&&(s[t++]=A(new R.$zs(r,E.index+1+a,r,E.index+1+E[0].length+a),E,d),t>=c))return t;while(E);return t}static findNextMatch(i,n,r,a){const t=n.parseSearchRequest();if(!t)return null;const s=new l(t.wordSeparators,t.regex);return t.regex.multiline?this.e(i,r,s,a):this.f(i,r,s,a)}static e(i,n,r,a){const t=new f.$ys(n.lineNumber,1),s=i.getOffsetAt(t),d=i.getLineCount(),c=i.getValueInRange(new R.$zs(t.lineNumber,t.column,d,i.getLineMaxColumn(d)),1),u=i.getEOL()===`\r
`?new I(c):null;r.reset(n.column-1);const h=r.next(c);return h?A(this.a(i,s,c,u,h.index,h[0]),h,a):n.lineNumber!==1||n.column!==1?this.e(i,new f.$ys(1,1),r,a):null}static f(i,n,r,a){const t=i.getLineCount(),s=n.lineNumber,d=i.getLineContent(s),c=this.g(r,d,s,n.column,a);if(c)return c;for(let u=1;u<=t;u++){const h=(s+u-1)%t,E=i.getLineContent(h+1),D=this.g(r,E,h+1,1,a);if(D)return D}return null}static g(i,n,r,a,t){i.reset(a-1);const s=i.next(n);return s?A(new R.$zs(r,s.index+1,r,s.index+1+s[0].length),s,t):null}static findPreviousMatch(i,n,r,a){const t=n.parseSearchRequest();if(!t)return null;const s=new l(t.wordSeparators,t.regex);return t.regex.multiline?this.h(i,r,s,a):this.j(i,r,s,a)}static h(i,n,r,a){const t=this.b(i,new R.$zs(1,1,n.lineNumber,n.column),r,a,10*b);if(t.length>0)return t[t.length-1];const s=i.getLineCount();return n.lineNumber!==s||n.column!==i.getLineMaxColumn(s)?this.h(i,new f.$ys(s,i.getLineMaxColumn(s)),r,a):null}static j(i,n,r,a){const t=i.getLineCount(),s=n.lineNumber,d=i.getLineContent(s).substring(0,n.column-1),c=this.k(r,d,s,a);if(c)return c;for(let u=1;u<=t;u++){const h=(t+s-u-1)%t,E=i.getLineContent(h+1),D=this.k(r,E,h+1,a);if(D)return D}return null}static k(i,n,r,a){let t=null,s;for(i.reset(0);s=i.next(n);)t=A(new R.$zs(r,s.index+1,r,s.index+1+s[0].length),s,a);return t}}e.$EB=$;function v(o,i,n,r,a){if(r===0)return!0;const t=i.charCodeAt(r-1);if(o.get(t)!==0||t===13||t===10)return!0;if(a>0){const s=i.charCodeAt(r);if(o.get(s)!==0)return!0}return!1}function S(o,i,n,r,a){if(r+a===n)return!0;const t=i.charCodeAt(r+a);if(o.get(t)!==0||t===13||t===10)return!0;if(a>0){const s=i.charCodeAt(r+a-1);if(o.get(s)!==0)return!0}return!1}function w(o,i,n,r,a){return v(o,i,n,r,a)&&S(o,i,n,r,a)}e.$FB=w;class l{constructor(i,n){this._wordSeparators=i,this.a=n,this.b=-1,this.c=0}reset(i){this.a.lastIndex=i,this.b=-1,this.c=0}next(i){const n=i.length;let r;do{if(this.b+this.c===n||(r=this.a.exec(i),!r))return null;const a=r.index,t=r[0].length;if(a===this.b&&t===this.c){if(t===0){C.$af(i,n,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=a,this.c=t,!this._wordSeparators||w(this._wordSeparators,i,n,a,t))return r}while(r);return null}}e.$GB=l}),define(ke[128],Se([1,0,53,29,79,174,99]),function(me,e,C,T,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LB=e.$KB=e.$JB=e.$IB=e.$HB=void 0;const b=65535;function y(o){let i;return o[o.length-1]<65536?i=new Uint16Array(o.length):i=new Uint32Array(o.length),i.set(o,0),i}class g{constructor(i,n,r,a,t){this.lineStarts=i,this.cr=n,this.lf=r,this.crlf=a,this.isBasicASCII=t}}function A(o,i=!0){const n=[0];let r=1;for(let a=0,t=o.length;a<t;a++){const s=o.charCodeAt(a);s===13?a+1<t&&o.charCodeAt(a+1)===10?(n[r++]=a+2,a++):n[r++]=a+1:s===10&&(n[r++]=a+1)}return i?y(n):n}e.$HB=A;function I(o,i){o.length=0,o[0]=0;let n=1,r=0,a=0,t=0,s=!0;for(let c=0,u=i.length;c<u;c++){const h=i.charCodeAt(c);h===13?c+1<u&&i.charCodeAt(c+1)===10?(t++,o[n++]=c+2,c++):(r++,o[n++]=c+1):h===10?(a++,o[n++]=c+1):s&&h!==9&&(h<32||h>126)&&(s=!1)}const d=new g(y(o),r,a,t,s);return o.length=0,d}e.$IB=I;class ${constructor(i,n,r,a,t){this.bufferIndex=i,this.start=n,this.end=r,this.lineFeedCnt=a,this.length=t}}e.$JB=$;class v{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.$KB=v;class S{constructor(i,n){this.a=[],this.c=i,this.d=n,this.b=0,i.root!==R.$sB&&i.iterate(i.root,r=>(r!==R.$sB&&this.a.push(r.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class w{constructor(i){this.a=i,this.b=[]}get(i){for(let n=this.b.length-1;n>=0;n--){const r=this.b[n];if(r.nodeStartOffset<=i&&r.nodeStartOffset+r.node.piece.length>=i)return r}return null}get2(i){for(let n=this.b.length-1;n>=0;n--){const r=this.b[n];if(r.nodeStartLineNumber&&r.nodeStartLineNumber<i&&r.nodeStartLineNumber+r.node.piece.lineFeedCnt>=i)return r}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let n=!1;const r=this.b;for(let a=0;a<r.length;a++){const t=r[a];if(t.node.parent===null||t.nodeStartOffset>=i){r[a]=null,n=!0;continue}}if(n){const a=[];for(const t of r)t!==null&&a.push(t);this.b=a}}}class l{constructor(i,n,r){this.create(i,n,r)}create(i,n,r){this.a=[new v("",[0])],this.g={line:0,column:0},this.root=R.$sB,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=r;let a=null;for(let t=0,s=i.length;t<s;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=A(i[t].buffer));const d=new $(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),a=this.S(a,d)}this.h=new w(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const n=b,r=n-Math.floor(n/3),a=r*2;let t="",s=0;const d=[];if(this.iterate(this.root,c=>{const u=this.R(c),h=u.length;if(s<=r||s+h<a)return t+=u,s+=h,!0;const E=t.replace(/\r\n|\r|\n/g,i);return d.push(new v(E,A(E))),t=u,s=h,!0}),s>0){const c=t.replace(/\r\n|\r|\n/g,i);d.push(new v(c,A(c)))}this.create(d,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new S(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,a=>{if(a===R.$sB)return!0;const t=this.R(a),s=t.length,d=i.G(n),c=i.G(n+s),u=i.getValueInRange2(d,c);return n+=s,t===u})}getOffsetAt(i,n){let r=0,a=this.root;for(;a!==R.$sB;)if(a.left!==R.$sB&&a.lf_left+1>=i)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt+1>=i){r+=a.size_left;const t=this.B(a,i-a.lf_left-2);return r+=t+n-1}else i-=a.lf_left+a.piece.lineFeedCnt,r+=a.size_left+a.piece.length,a=a.right;return r}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,r=0;const a=i;for(;n!==R.$sB;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const t=this.A(n,i-n.size_left);if(r+=n.lf_left+t.index,t.index===0){const s=this.getOffsetAt(r+1,1),d=a-s;return new C.$ys(r+1,d+1)}return new C.$ys(r+1,t.remainder+1)}else if(i-=n.size_left+n.piece.length,r+=n.lf_left+n.piece.lineFeedCnt,n.right===R.$sB){const t=this.getOffsetAt(r+1,1),s=a-i-t;return new C.$ys(r+1,s+1)}else n=n.right;return new C.$ys(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const r=this.H(i.startLineNumber,i.startColumn),a=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(r,a);return n?n!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,n):t}getValueInRange2(i,n){if(i.node===n.node){const d=i.node,c=this.a[d.piece.bufferIndex].buffer,u=this.u(d.piece.bufferIndex,d.piece.start);return c.substring(u+i.remainder,u+n.remainder)}let r=i.node;const a=this.a[r.piece.bufferIndex].buffer,t=this.u(r.piece.bufferIndex,r.piece.start);let s=a.substring(t+i.remainder,t+r.piece.length);for(r=r.next();r!==R.$sB;){const d=this.a[r.piece.bufferIndex].buffer,c=this.u(r.piece.bufferIndex,r.piece.start);if(r===n.node){s+=d.substring(c,c+n.remainder);break}else s+=d.substr(c,r.piece.length);r=r.next()}return s}getLinesContent(){const i=[];let n=0,r="",a=!1;return this.iterate(this.root,t=>{if(t===R.$sB)return!0;const s=t.piece;let d=s.length;if(d===0)return!0;const c=this.a[s.bufferIndex].buffer,u=this.a[s.bufferIndex].lineStarts,h=s.start.line,E=s.end.line;let D=u[h]+s.start.column;if(a&&(c.charCodeAt(D)===10&&(D++,d--),i[n++]=r,r="",a=!1,d===0))return!0;if(h===E)return!this.f&&c.charCodeAt(D+d-1)===13?(a=!0,r+=c.substr(D,d-1)):r+=c.substr(D,d),!0;r+=this.f?c.substring(D,Math.max(D,u[h+1]-this.e)):c.substring(D,u[h+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=r;for(let m=h+1;m<E;m++)r=this.f?c.substring(u[m],u[m+1]-this.e):c.substring(u[m],u[m+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=r;return!this.f&&c.charCodeAt(u[E]+s.end.column-1)===13?(a=!0,s.end.column===0?n--:r=c.substr(u[E],s.end.column-1)):r=c.substr(u[E],s.end.column),!0}),a&&(i[n++]=r,r=""),i[n++]=r,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const r=this.a[n.piece.bufferIndex],a=this.u(n.piece.bufferIndex,n.piece.start);return r.buffer.charCodeAt(a)}else{const n=this.a[i.node.piece.bufferIndex],a=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(a)}}getLineCharCode(i,n){const r=this.H(i,n+1);return this.l(r)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const n=this.G(i);return this.l(n)}findMatchesInNode(i,n,r,a,t,s,d,c,u,h,E){const D=this.a[i.piece.bufferIndex],m=this.u(i.piece.bufferIndex,i.piece.start),p=this.u(i.piece.bufferIndex,t),k=this.u(i.piece.bufferIndex,s);let P;const z={line:0,column:0};let j,M;n._wordSeparators?(j=D.buffer.substring(p,k),M=O=>O+p,n.reset(0)):(j=D.buffer,M=O=>O,n.reset(p));do if(P=n.next(j),P){if(M(P.index)>=k)return h;this.s(i,M(P.index)-m,z);const O=this.t(i.piece.bufferIndex,t,z),F=z.line===t.line?z.column-t.column+a:z.column+1,N=F+P[0].length;if(E[h++]=(0,L.$DB)(new T.$zs(r+O,F,r+O,N),P,c),M(P.index)+P[0].length>=k||h>=u)return h}while(P);return h}findMatchesLineByLine(i,n,r,a){const t=[];let s=0;const d=new L.$GB(n.wordSeparators,n.regex);let c=this.H(i.startLineNumber,i.startColumn);if(c===null)return[];const u=this.H(i.endLineNumber,i.endColumn);if(u===null)return[];let h=this.s(c.node,c.remainder);const E=this.s(u.node,u.remainder);if(c.node===u.node)return this.findMatchesInNode(c.node,d,i.startLineNumber,i.startColumn,h,E,n,r,a,s,t),t;let D=i.startLineNumber,m=c.node;for(;m!==u.node;){const k=this.t(m.piece.bufferIndex,h,m.piece.end);if(k>=1){const z=this.a[m.piece.bufferIndex].lineStarts,j=this.u(m.piece.bufferIndex,m.piece.start),M=z[h.line+k],O=D===i.startLineNumber?i.startColumn:1;if(s=this.findMatchesInNode(m,d,D,O,h,this.s(m,M-j),n,r,a,s,t),s>=a)return t;D+=k}const P=D===i.startLineNumber?i.startColumn-1:0;if(D===i.endLineNumber){const z=this.getLineContent(D).substring(P,i.endColumn-1);return s=this.n(n,d,z,i.endLineNumber,P,s,t,r,a),t}if(s=this.n(n,d,this.getLineContent(D).substr(P),D,P,s,t,r,a),s>=a)return t;D++,c=this.H(D,1),m=c.node,h=this.s(c.node,c.remainder)}if(D===i.endLineNumber){const k=D===i.startLineNumber?i.startColumn-1:0,P=this.getLineContent(D).substring(k,i.endColumn-1);return s=this.n(n,d,P,i.endLineNumber,k,s,t,r,a),t}const p=D===i.startLineNumber?i.startColumn:1;return s=this.findMatchesInNode(u.node,d,D,p,h,E,n,r,a,s,t),t}n(i,n,r,a,t,s,d,c,u){const h=i.wordSeparators;if(!c&&i.simpleSearch){const D=i.simpleSearch,m=D.length,p=r.length;let k=-m;for(;(k=r.indexOf(D,k+m))!==-1;)if((!h||(0,L.$FB)(h,r,p,k,m))&&(d[s++]=new f.$Qu(new T.$zs(a,k+1+t,a,k+1+m+t),null),s>=u))return s;return s}let E;n.reset(0);do if(E=n.next(r),E&&(d[s++]=(0,L.$DB)(new T.$zs(a,E.index+1+t,a,E.index+1+E[0].length+t),E,c),s>=u))return s;while(E);return s}insert(i,n,r=!1){if(this.f=this.f&&r,this.j.lineNumber=0,this.j.value="",this.root!==R.$sB){const{node:a,remainder:t,nodeStartOffset:s}=this.G(i),d=a.piece,c=d.bufferIndex,u=this.s(a,t);if(a.piece.bufferIndex===0&&d.end.line===this.g.line&&d.end.column===this.g.column&&s+d.length===i&&n.length<b){this.F(a,n),this.y();return}if(s===i)this.o(n,a),this.h.validate(i);else if(s+a.piece.length>i){const h=[];let E=new $(d.bufferIndex,u,d.end,this.t(d.bufferIndex,u,d.end),this.u(c,d.end)-this.u(c,u));if(this.K()&&this.M(n)&&this.I(a,t)===10){const k={line:E.start.line+1,column:0};E=new $(E.bufferIndex,k,E.end,this.t(E.bufferIndex,k,E.end),E.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(a,t-1)===13){const k=this.s(a,t-1);this.C(a,k),n="\r"+n,a.piece.length===0&&h.push(a)}else this.C(a,u);else this.C(a,u);const D=this.w(n);E.length>0&&this.S(a,E);let m=a;for(let p=0;p<D.length;p++)m=this.S(m,D[p]);this.v(h)}else this.q(n,a)}else{const a=this.w(n);let t=this.T(null,a[0]);for(let s=1;s<a.length;s++)t=this.S(t,a[s])}this.y()}delete(i,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===R.$sB)return;const r=this.G(i),a=this.G(i+n),t=r.node,s=a.node;if(t===s){const D=this.s(t,r.remainder),m=this.s(t,a.remainder);if(r.nodeStartOffset===i){if(n===t.piece.length){const p=t.next();(0,R.$xB)(this,t),this.N(p),this.y();return}this.D(t,m),this.h.validate(i),this.N(t),this.y();return}if(r.nodeStartOffset+t.piece.length===i+n){this.C(t,D),this.O(t),this.y();return}this.E(t,D,m),this.y();return}const d=[],c=this.s(t,r.remainder);this.C(t,c),this.h.validate(i),t.piece.length===0&&d.push(t);const u=this.s(s,a.remainder);this.D(s,u),s.piece.length===0&&d.push(s);const h=t.next();for(let D=h;D!==R.$sB&&D!==s;D=D.next())d.push(D);const E=t.piece.length===0?t.prev():t;this.v(d),this.O(E),this.y()}o(i,n){const r=[];if(this.K()&&this.M(i)&&this.L(n)){const s=n.piece,d={line:s.start.line+1,column:0},c=new $(s.bufferIndex,d,s.end,this.t(s.bufferIndex,d,s.end),s.length-1);n.piece=c,i+=`
`,(0,R.$zB)(this,n,-1,-1),n.piece.length===0&&r.push(n)}const a=this.w(i);let t=this.T(n,a[a.length-1]);for(let s=a.length-2;s>=0;s--)t=this.T(t,a[s]);this.N(t),this.v(r)}q(i,n){this.Q(i,n)&&(i+=`
`);const r=this.w(i),a=this.S(n,r[0]);let t=a;for(let s=1;s<r.length;s++)t=this.S(t,r[s]);this.N(a)}s(i,n,r){const a=i.piece,t=i.piece.bufferIndex,s=this.a[t].lineStarts,c=s[a.start.line]+a.start.column+n;let u=a.start.line,h=a.end.line,E=0,D=0,m=0;for(;u<=h&&(E=u+(h-u)/2|0,m=s[E],E!==h);)if(D=s[E+1],c<m)h=E-1;else if(c>=D)u=E+1;else break;return r?(r.line=E,r.column=c-m,null):{line:E,column:c-m}}t(i,n,r){if(r.column===0)return r.line-n.line;const a=this.a[i].lineStarts;if(r.line===a.length-1)return r.line-n.line;const t=a[r.line+1],s=a[r.line]+r.column;if(t>s+1)return r.line-n.line;const d=s-1;return this.a[i].buffer.charCodeAt(d)===13?r.line-n.line+1:r.line-n.line}u(i,n){return this.a[i].lineStarts[n.line]+n.column}v(i){for(let n=0;n<i.length;n++)(0,R.$xB)(this,i[n])}w(i){if(i.length>b){const h=[];for(;i.length>b;){const D=i.charCodeAt(b-1);let m;D===13||D>=55296&&D<=56319?(m=i.substring(0,b-1),i=i.substring(b-1)):(m=i.substring(0,b),i=i.substring(b));const p=A(m);h.push(new $(this.a.length,{line:0,column:0},{line:p.length-1,column:m.length-p[p.length-1]},p.length-1,m.length)),this.a.push(new v(m,p))}const E=A(i);return h.push(new $(this.a.length,{line:0,column:0},{line:E.length-1,column:i.length-E[E.length-1]},E.length-1,i.length)),this.a.push(new v(i,E)),h}let n=this.a[0].buffer.length;const r=A(i,!1);let a=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},a=this.g;for(let h=0;h<r.length;h++)r[h]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1)),this.a[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let h=0;h<r.length;h++)r[h]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,s=this.a[0].lineStarts.length-1,d=t-this.a[0].lineStarts[s],c={line:s,column:d},u=new $(0,a,c,this.t(0,a,c),t-n);return this.g=c,[u]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,n=0){let r=this.root,a="";const t=this.h.get2(i);if(t){r=t.node;const s=this.B(r,i-t.nodeStartLineNumber-1),d=this.a[r.piece.bufferIndex].buffer,c=this.u(r.piece.bufferIndex,r.piece.start);if(t.nodeStartLineNumber+r.piece.lineFeedCnt===i)a=d.substring(c+s,c+r.piece.length);else{const u=this.B(r,i-t.nodeStartLineNumber);return d.substring(c+s,c+u-n)}}else{let s=0;const d=i;for(;r!==R.$sB;)if(r.left!==R.$sB&&r.lf_left>=i-1)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt>i-1){const c=this.B(r,i-r.lf_left-2),u=this.B(r,i-r.lf_left-1),h=this.a[r.piece.bufferIndex].buffer,E=this.u(r.piece.bufferIndex,r.piece.start);return s+=r.size_left,this.h.set({node:r,nodeStartOffset:s,nodeStartLineNumber:d-(i-1-r.lf_left)}),h.substring(E+c,E+u-n)}else if(r.lf_left+r.piece.lineFeedCnt===i-1){const c=this.B(r,i-r.lf_left-2),u=this.a[r.piece.bufferIndex].buffer,h=this.u(r.piece.bufferIndex,r.piece.start);a=u.substring(h+c,h+r.piece.length);break}else i-=r.lf_left+r.piece.lineFeedCnt,s+=r.size_left+r.piece.length,r=r.right}for(r=r.next();r!==R.$sB;){const s=this.a[r.piece.bufferIndex].buffer;if(r.piece.lineFeedCnt>0){const d=this.B(r,0),c=this.u(r.piece.bufferIndex,r.piece.start);return a+=s.substring(c,c+d-n),a}else{const d=this.u(r.piece.bufferIndex,r.piece.start);a+=s.substr(d,r.piece.length)}r=r.next()}return a}y(){let i=this.root,n=1,r=0;for(;i!==R.$sB;)n+=i.lf_left+i.piece.lineFeedCnt,r+=i.size_left+i.piece.length,i=i.right;this.b=n,this.c=r,this.h.validate(this.c)}A(i,n){const r=i.piece,a=this.s(i,n),t=a.line-r.start.line;if(this.u(r.bufferIndex,r.end)-this.u(r.bufferIndex,r.start)===n){const s=this.t(i.piece.bufferIndex,r.start,a);if(s!==t)return{index:s,remainder:0}}return{index:t,remainder:a.column}}B(i,n){if(n<0)return 0;const r=i.piece,a=this.a[r.bufferIndex].lineStarts,t=r.start.line+n+1;return t>r.end.line?a[r.end.line]+r.end.column-a[r.start.line]-r.start.column:a[t]-a[r.start.line]-r.start.column}C(i,n){const r=i.piece,a=r.lineFeedCnt,t=this.u(r.bufferIndex,r.end),s=n,d=this.u(r.bufferIndex,s),c=this.t(r.bufferIndex,r.start,s),u=c-a,h=d-t,E=r.length+h;i.piece=new $(r.bufferIndex,r.start,s,c,E),(0,R.$zB)(this,i,h,u)}D(i,n){const r=i.piece,a=r.lineFeedCnt,t=this.u(r.bufferIndex,r.start),s=n,d=this.t(r.bufferIndex,s,r.end),c=this.u(r.bufferIndex,s),u=d-a,h=t-c,E=r.length+h;i.piece=new $(r.bufferIndex,s,r.end,d,E),(0,R.$zB)(this,i,h,u)}E(i,n,r){const a=i.piece,t=a.start,s=a.end,d=a.length,c=a.lineFeedCnt,u=n,h=this.t(a.bufferIndex,a.start,u),E=this.u(a.bufferIndex,n)-this.u(a.bufferIndex,t);i.piece=new $(a.bufferIndex,a.start,u,h,E),(0,R.$zB)(this,i,E-d,h-c);const D=new $(a.bufferIndex,r,s,this.t(a.bufferIndex,r,s),this.u(a.bufferIndex,s)-this.u(a.bufferIndex,r)),m=this.S(i,D);this.N(m)}F(i,n){this.Q(n,i)&&(n+=`
`);const r=this.K()&&this.L(n)&&this.M(i),a=this.a[0].buffer.length;this.a[0].buffer+=n;const t=A(n,!1);for(let m=0;m<t.length;m++)t[m]+=a;if(r){const m=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:a-m}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const s=this.a[0].lineStarts.length-1,d=this.a[0].buffer.length-this.a[0].lineStarts[s],c={line:s,column:d},u=i.piece.length+n.length,h=i.piece.lineFeedCnt,E=this.t(0,i.piece.start,c),D=E-h;i.piece=new $(i.piece.bufferIndex,i.piece.start,c,E,u),this.g=c,(0,R.$zB)(this,i,n.length,D)}G(i){let n=this.root;const r=this.h.get(i);if(r)return{node:r.node,nodeStartOffset:r.nodeStartOffset,remainder:i-r.nodeStartOffset};let a=0;for(;n!==R.$sB;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){a+=n.size_left;const t={node:n,remainder:i-n.size_left,nodeStartOffset:a};return this.h.set(t),t}else i-=n.size_left+n.piece.length,a+=n.size_left+n.piece.length,n=n.right;return null}H(i,n){let r=this.root,a=0;for(;r!==R.$sB;)if(r.left!==R.$sB&&r.lf_left>=i-1)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt>i-1){const t=this.B(r,i-r.lf_left-2),s=this.B(r,i-r.lf_left-1);return a+=r.size_left,{node:r,remainder:Math.min(t+n-1,s),nodeStartOffset:a}}else if(r.lf_left+r.piece.lineFeedCnt===i-1){const t=this.B(r,i-r.lf_left-2);if(t+n-1<=r.piece.length)return{node:r,remainder:t+n-1,nodeStartOffset:a};n-=r.piece.length-t;break}else i-=r.lf_left+r.piece.lineFeedCnt,a+=r.size_left+r.piece.length,r=r.right;for(r=r.next();r!==R.$sB;){if(r.piece.lineFeedCnt>0){const t=this.B(r,0),s=this.J(r);return{node:r,remainder:Math.min(n-1,t),nodeStartOffset:s}}else if(r.piece.length>=n-1){const t=this.J(r);return{node:r,remainder:n-1,nodeStartOffset:t}}else n-=r.piece.length;r=r.next()}return null}I(i,n){if(i.piece.lineFeedCnt<1)return-1;const r=this.a[i.piece.bufferIndex],a=this.u(i.piece.bufferIndex,i.piece.start)+n;return r.buffer.charCodeAt(a)}J(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===R.$sB||i.piece.lineFeedCnt===0)return!1;const n=i.piece,r=this.a[n.bufferIndex].lineStarts,a=n.start.line,t=r[a]+n.start.column;return a===r.length-1||r[a+1]>t+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===R.$sB||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const n=i.prev();this.M(n)&&this.P(n,i)}}O(i){if(this.K()&&this.M(i)){const n=i.next();this.L(n)&&this.P(i,n)}}P(i,n){const r=[],a=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:a[i.piece.end.line]-a[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const s=i.piece.length-1,d=i.piece.lineFeedCnt-1;i.piece=new $(i.piece.bufferIndex,i.piece.start,t,d,s),(0,R.$zB)(this,i,-1,-1),i.piece.length===0&&r.push(i);const c={line:n.piece.start.line+1,column:0},u=n.piece.length-1,h=this.t(n.piece.bufferIndex,c,n.piece.end);n.piece=new $(n.piece.bufferIndex,c,n.piece.end,h,u),(0,R.$zB)(this,n,-1,-1),n.piece.length===0&&r.push(n);const E=this.w(`\r
`);this.S(i,E[0]);for(let D=0;D<r.length;D++)(0,R.$xB)(this,r[D])}Q(i,n){if(this.K()&&this.M(i)){const r=n.next();if(this.L(r)){if(i+=`
`,r.piece.length===1)(0,R.$xB)(this,r);else{const a=r.piece,t={line:a.start.line+1,column:0},s=a.length-1,d=this.t(a.bufferIndex,t,a.end);r.piece=new $(a.bufferIndex,t,a.end,d,s),(0,R.$zB)(this,r,-1,-1)}return!0}}return!1}iterate(i,n){if(i===R.$sB)return n(R.$sB);const r=this.iterate(i.left,n);return r&&n(i)&&this.iterate(i.right,n)}R(i){if(i===R.$sB)return"";const n=this.a[i.piece.bufferIndex],r=i.piece,a=this.u(r.bufferIndex,r.start),t=this.u(r.bufferIndex,r.end);return n.buffer.substring(a,t)}getPieceContent(i){const n=this.a[i.bufferIndex],r=this.u(i.bufferIndex,i.start),a=this.u(i.bufferIndex,i.end);return n.buffer.substring(r,a)}S(i,n){const r=new R.$rB(n,1);if(r.left=R.$sB,r.right=R.$sB,r.parent=R.$sB,r.size_left=0,r.lf_left=0,this.root===R.$sB)this.root=r,r.color=0;else if(i.right===R.$sB)i.right=r,r.parent=i;else{const t=(0,R.$tB)(i.right);t.left=r,r.parent=t}return(0,R.$yB)(this,r),r}T(i,n){const r=new R.$rB(n,1);if(r.left=R.$sB,r.right=R.$sB,r.parent=R.$sB,r.size_left=0,r.lf_left=0,this.root===R.$sB)this.root=r,r.color=0;else if(i.left===R.$sB)i.left=r,r.parent=i;else{const a=(0,R.$uB)(i.left);a.right=r,r.parent=a}return(0,R.$yB)(this,r),r}U(i){let n="";return this.iterate(i,r=>(n+=this.R(r),!0)),n}}e.$LB=l}),define(ke[177],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S7=e.$R7=void 0;class C{constructor(){this.a=new Map}removeDragOperationTransfer(R){if(R&&this.a.has(R)){const L=this.a.get(R);return this.a.delete(R),L}}addDragOperationTransfer(R,L){this.a.set(R,L)}}e.$R7=C;class T{constructor(R){this.identifier=R}}e.$S7=T}),define(ke[178],Se([1,0,4,3]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$s=void 0;class f{constructor(){this.a=new Map,this.b=new Map,this.c=new C.$Rd,this.onDidChange=this.c.event,this.d=null}handleChange(b){this.c.fire({changedLanguages:b,changedColorMap:!1})}register(b,y){return this.a.set(b,y),this.handleChange([b]),(0,T.$Pc)(()=>{this.a.get(b)===y&&(this.a.delete(b),this.handleChange([b]))})}get(b){return this.a.get(b)||null}registerFactory(b,y){this.b.get(b)?.dispose();const g=new R(this,b,y);return this.b.set(b,g),(0,T.$Pc)(()=>{const A=this.b.get(b);!A||A!==g||(this.b.delete(b),A.dispose())})}async getOrCreate(b){const y=this.get(b);if(y)return y;const g=this.b.get(b);return!g||g.isResolved?null:(await g.resolve(),this.get(b))}isResolved(b){if(this.get(b))return!0;const g=this.b.get(b);return!!(!g||g.isResolved)}setColorMap(b){this.d=b,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$$s=f;class R extends T.$Rc{get isResolved(){return this.c}constructor(b,y,g){super(),this.f=b,this.g=y,this.h=g,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const b=await this.h.tokenizationSupport;this.c=!0,b&&!this.a&&this.B(this.f.register(this.g,b))}}}),define(ke[179],Se([9,10]),function(me,e){return me.create("vs/base/common/actions",e)}),define(ke[180],Se([1,0,4,3,179]),function(me,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=void 0;class R extends T.$Rc{constructor($,v="",S="",w=!0,l){super(),this.h=this.B(new C.$Rd),this.onDidChange=this.h.event,this.w=!0,this.j=$,this.m=v,this.u=S,this.w=w,this.C=l}get id(){return this.j}get label(){return this.m}set label($){this.D($)}D($){this.m!==$&&(this.m=$,this.h.fire({label:$}))}get tooltip(){return this.n||""}set tooltip($){this.F($)}F($){this.n!==$&&(this.n=$,this.h.fire({tooltip:$}))}get class(){return this.u}set class($){this.G($)}G($){this.u!==$&&(this.u=$,this.h.fire({class:$}))}get enabled(){return this.w}set enabled($){this.H($)}H($){this.w!==$&&(this.w=$,this.h.fire({enabled:$}))}get checked(){return this.z}set checked($){this.I($)}I($){this.z!==$&&(this.z=$,this.h.fire({checked:$}))}async run($,v){this.C&&await this.C($)}}e.$Ai=R;class L extends T.$Rc{constructor(){super(...arguments),this.f=this.B(new C.$Rd),this.onWillRun=this.f.event,this.m=this.B(new C.$Rd),this.onDidRun=this.m.event}async run($,v){if(!$.enabled)return;this.f.fire({action:$});let S;try{await this.u($,v)}catch(w){S=w}this.m.fire({action:$,error:S})}async u($,v){await $.run(v)}}e.$Bi=L;class b{constructor(){this.id=b.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...$){let v=[];for(const S of $)S.length&&(v.length?v=[...v,new b,...S]:v=S);return v}static{this.ID="vs.actions.separator"}async run(){}}e.$Ci=b;class y{get actions(){return this.a}constructor($,v,S,w){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=$,this.label=v,this.class=w,this.a=S}async run(){}}e.$Di=y;class g extends R{static{this.ID="vs.actions.empty"}constructor(){super(g.ID,f.localize(0,null),void 0,!1)}}e.$Ei=g;function A(I){return{id:I.id,label:I.label,class:void 0,enabled:I.enabled??!0,checked:I.checked??!1,run:async(...$)=>I.run(...$),tooltip:I.label}}e.$Fi=A}),define(ke[181],Se([9,10]),function(me,e){return me.create("vs/base/common/date",e)}),define(ke[182],Se([1,0,181]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$km=e.$jm=void 0;const T=60,f=T*60,R=f*24,L=R*7,b=R*30,y=R*365;function g(I,$,v,S){typeof I!="number"&&(I=I.getTime());const w=Math.round((new Date().getTime()-I)/1e3);if(w<-30)return(0,C.localize)(0,null,g(new Date().getTime()+w*1e3,!1));if(!S&&w<30)return(0,C.localize)(1,null);let l;return w<T?(l=w,$?l===1?v?(0,C.localize)(2,null,l):(0,C.localize)(3,null,l):v?(0,C.localize)(4,null,l):(0,C.localize)(5,null,l):l===1?v?(0,C.localize)(6,null,l):(0,C.localize)(7,null,l):v?(0,C.localize)(8,null,l):(0,C.localize)(9,null,l)):w<f?(l=Math.floor(w/T),$?l===1?v?(0,C.localize)(10,null,l):(0,C.localize)(11,null,l):v?(0,C.localize)(12,null,l):(0,C.localize)(13,null,l):l===1?v?(0,C.localize)(14,null,l):(0,C.localize)(15,null,l):v?(0,C.localize)(16,null,l):(0,C.localize)(17,null,l)):w<R?(l=Math.floor(w/f),$?l===1?v?(0,C.localize)(18,null,l):(0,C.localize)(19,null,l):v?(0,C.localize)(20,null,l):(0,C.localize)(21,null,l):l===1?v?(0,C.localize)(22,null,l):(0,C.localize)(23,null,l):v?(0,C.localize)(24,null,l):(0,C.localize)(25,null,l)):w<L?(l=Math.floor(w/R),$?l===1?(0,C.localize)(26,null,l):(0,C.localize)(27,null,l):l===1?(0,C.localize)(28,null,l):(0,C.localize)(29,null,l)):w<b?(l=Math.floor(w/L),$?l===1?v?(0,C.localize)(30,null,l):(0,C.localize)(31,null,l):v?(0,C.localize)(32,null,l):(0,C.localize)(33,null,l):l===1?v?(0,C.localize)(34,null,l):(0,C.localize)(35,null,l):v?(0,C.localize)(36,null,l):(0,C.localize)(37,null,l)):w<y?(l=Math.floor(w/b),$?l===1?v?(0,C.localize)(38,null,l):(0,C.localize)(39,null,l):v?(0,C.localize)(40,null,l):(0,C.localize)(41,null,l):l===1?v?(0,C.localize)(42,null,l):(0,C.localize)(43,null,l):v?(0,C.localize)(44,null,l):(0,C.localize)(45,null,l)):(l=Math.floor(w/y),$?l===1?v?(0,C.localize)(46,null,l):(0,C.localize)(47,null,l):v?(0,C.localize)(48,null,l):(0,C.localize)(49,null,l):l===1?v?(0,C.localize)(50,null,l):(0,C.localize)(51,null,l):v?(0,C.localize)(52,null,l):(0,C.localize)(53,null,l))}e.$jm=g;function A(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$km=A}),define(ke[183],Se([9,10]),function(me,e){return me.create("vs/base/common/errorMessage",e)}),define(ke[43],Se([1,0,19,18,183]),function(me,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=e.$Gi=void 0;function R(I,$){return $&&(I.stack||I.stacktrace)?f.localize(0,null,b(I),L(I.stack)||L(I.stacktrace)):b(I)}function L(I){return Array.isArray(I)?I.join(`
`):I}function b(I){return I.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${I.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?f.localize(1,null,I.message):I.message||f.localize(2,null)}function y(I=null,$=!1){if(!I)return f.localize(3,null);if(Array.isArray(I)){const v=C.$Gb(I),S=y(v[0],$);return v.length>1?f.localize(4,null,S,v.length):S}if(T.$Cf(I))return I;if(I.detail){const v=I.detail;if(v.error)return R(v.error,$);if(v.exception)return R(v.exception,$)}return I.stack?R(I,$):I.message?I.message:f.localize(5,null)}e.$Gi=y;function g(I){const $=I;return $ instanceof Error&&Array.isArray($.actions)}e.$Hi=g;function A(I,$){let v;return typeof I=="string"?v=new Error(I):v=I,v.actions=$,v}e.$Ii=A}),define(ke[184],Se([9,10]),function(me,e){return me.create("vs/base/common/platform",e)}),define(ke[11],Se([1,0,184]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let T=!1,f=!1,R=!1,L=!1,b=!1,y=!1,g=!1,A=!1,I=!1,$=!1,v,S=e.$g,w=e.$g,l,o;const i=globalThis;let n;typeof i.vscode<"u"&&typeof i.vscode.process<"u"?n=i.vscode.process:typeof process<"u"&&(n=process);const r=typeof n?.versions?.electron=="string",a=r&&n?.type==="renderer";if(typeof navigator=="object"&&!a)o=navigator.userAgent,T=o.indexOf("Windows")>=0,f=o.indexOf("Macintosh")>=0,A=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=o.indexOf("Linux")>=0,$=o?.indexOf("Mobi")>=0,y=!0,v=C.getConfiguredDefaultLocale(C.localize(0,null))||e.$g,S=v,w=navigator.language;else if(typeof n=="object"){T=n.platform==="win32",f=n.platform==="darwin",R=n.platform==="linux",L=R&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,g=r,I=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,v=e.$g,S=e.$g;const m=n.env.VSCODE_NLS_CONFIG;if(m)try{const p=JSON.parse(m),k=p.availableLanguages["*"];v=p.locale,w=p.osLocale,S=k||e.$g,l=p._translationsConfigFile}catch{}b=!0}else console.error("Unable to resolve platform.");var t;(function(m){m[m.Web=0]="Web",m[m.Mac=1]="Mac",m[m.Linux=2]="Linux",m[m.Windows=3]="Windows"})(t||(e.Platform=t={}));function s(m){switch(m){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=s;let d=0;f?d=1:T?d=3:R&&(d=2),e.$i=T,e.$j=f,e.$k=R,e.$l=L,e.$m=b,e.$n=g,e.$o=y,e.$p=y&&typeof i.importScripts=="function",e.$q=e.$p?i.origin:void 0,e.$r=A,e.$s=$,e.$t=I,e.$u=d,e.$v=o,e.$w=S;var c;(function(m){function p(){return e.$w}m.value=p;function k(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}m.isDefaultVariant=k;function P(){return e.$w==="en"}m.isDefault=P})(c||(e.Language=c={})),e.$x=v,e.$y=w,e.$z=l,e.$A=typeof i.postMessage=="function"&&!i.importScripts,e.$B=(()=>{if(e.$A){const m=[];i.addEventListener("message",k=>{if(k.data&&k.data.vscodeScheduleAsyncWork)for(let P=0,z=m.length;P<z;P++){const j=m[P];if(j.id===k.data.vscodeScheduleAsyncWork){m.splice(P,1),j.callback();return}}});let p=0;return k=>{const P=++p;m.push({id:P,callback:k}),i.postMessage({vscodeScheduleAsyncWork:P},"*")}}return m=>setTimeout(m)})();var u;(function(m){m[m.Windows=1]="Windows",m[m.Macintosh=2]="Macintosh",m[m.Linux=3]="Linux"})(u||(e.OperatingSystem=u={})),e.OS=f||A?2:T?1:3;let h=!0,E=!1;function D(){if(!E){E=!0;const m=new Uint8Array(2);m[0]=1,m[1]=2,h=new Uint16Array(m.buffer)[0]===(2<<8)+1}return h}e.$D=D,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0)}),define(ke[49],Se([1,0,11]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.env=e.cwd=void 0;let T;const f=globalThis.vscode;if(typeof f<"u"&&typeof f.process<"u"){const R=f.process;T={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?T={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:T={get platform(){return C.$i?"win32":C.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=T.cwd,e.env=T.env,e.$cc=T.platform,e.$dc=T.arch}),define(ke[16],Se([1,0,49]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=e.sep=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=void 0;const T=65,f=97,R=90,L=122,b=46,y=47,g=92,A=58,I=63;class $ extends Error{constructor(s,d,c){let u;typeof d=="string"&&d.indexOf("not ")===0?(u="must not be",d=d.replace(/^not /,"")):u="must be";const h=s.indexOf(".")!==-1?"property":"argument";let E=`The "${s}" ${h} ${u} of type ${d}`;E+=`. Received type ${typeof c}`,super(E),this.code="ERR_INVALID_ARG_TYPE"}}function v(t,s){if(t===null||typeof t!="object")throw new $(s,"Object",t)}function S(t,s){if(typeof t!="string")throw new $(s,"string",t)}const w=C.$cc==="win32";function l(t){return t===y||t===g}function o(t){return t===y}function i(t){return t>=T&&t<=R||t>=f&&t<=L}function n(t,s,d,c){let u="",h=0,E=-1,D=0,m=0;for(let p=0;p<=t.length;++p){if(p<t.length)m=t.charCodeAt(p);else{if(c(m))break;m=y}if(c(m)){if(!(E===p-1||D===1))if(D===2){if(u.length<2||h!==2||u.charCodeAt(u.length-1)!==b||u.charCodeAt(u.length-2)!==b){if(u.length>2){const k=u.lastIndexOf(d);k===-1?(u="",h=0):(u=u.slice(0,k),h=u.length-1-u.lastIndexOf(d)),E=p,D=0;continue}else if(u.length!==0){u="",h=0,E=p,D=0;continue}}s&&(u+=u.length>0?`${d}..`:"..",h=2)}else u.length>0?u+=`${d}${t.slice(E+1,p)}`:u=t.slice(E+1,p),h=p-E-1;E=p,D=0}else m===b&&D!==-1?++D:D=-1}return u}function r(t,s){v(s,"pathObject");const d=s.dir||s.root,c=s.base||`${s.name||""}${s.ext||""}`;return d?d===s.root?`${d}${c}`:`${d}${t}${c}`:c}e.$ec={resolve(...t){let s="",d="",c=!1;for(let u=t.length-1;u>=-1;u--){let h;if(u>=0){if(h=t[u],S(h,"path"),h.length===0)continue}else s.length===0?h=C.cwd():(h=C.env[`=${s}`]||C.cwd(),(h===void 0||h.slice(0,2).toLowerCase()!==s.toLowerCase()&&h.charCodeAt(2)===g)&&(h=`${s}\\`));const E=h.length;let D=0,m="",p=!1;const k=h.charCodeAt(0);if(E===1)l(k)&&(D=1,p=!0);else if(l(k))if(p=!0,l(h.charCodeAt(1))){let P=2,z=P;for(;P<E&&!l(h.charCodeAt(P));)P++;if(P<E&&P!==z){const j=h.slice(z,P);for(z=P;P<E&&l(h.charCodeAt(P));)P++;if(P<E&&P!==z){for(z=P;P<E&&!l(h.charCodeAt(P));)P++;(P===E||P!==z)&&(m=`\\\\${j}\\${h.slice(z,P)}`,D=P)}}}else D=1;else i(k)&&h.charCodeAt(1)===A&&(m=h.slice(0,2),D=2,E>2&&l(h.charCodeAt(2))&&(p=!0,D=3));if(m.length>0)if(s.length>0){if(m.toLowerCase()!==s.toLowerCase())continue}else s=m;if(c){if(s.length>0)break}else if(d=`${h.slice(D)}\\${d}`,c=p,p&&s.length>0)break}return d=n(d,!c,"\\",l),c?`${s}\\${d}`:`${s}${d}`||"."},normalize(t){S(t,"path");const s=t.length;if(s===0)return".";let d=0,c,u=!1;const h=t.charCodeAt(0);if(s===1)return o(h)?"\\":t;if(l(h))if(u=!0,l(t.charCodeAt(1))){let D=2,m=D;for(;D<s&&!l(t.charCodeAt(D));)D++;if(D<s&&D!==m){const p=t.slice(m,D);for(m=D;D<s&&l(t.charCodeAt(D));)D++;if(D<s&&D!==m){for(m=D;D<s&&!l(t.charCodeAt(D));)D++;if(D===s)return`\\\\${p}\\${t.slice(m)}\\`;D!==m&&(c=`\\\\${p}\\${t.slice(m,D)}`,d=D)}}}else d=1;else i(h)&&t.charCodeAt(1)===A&&(c=t.slice(0,2),d=2,s>2&&l(t.charCodeAt(2))&&(u=!0,d=3));let E=d<s?n(t.slice(d),!u,"\\",l):"";return E.length===0&&!u&&(E="."),E.length>0&&l(t.charCodeAt(s-1))&&(E+="\\"),c===void 0?u?`\\${E}`:E:u?`${c}\\${E}`:`${c}${E}`},isAbsolute(t){S(t,"path");const s=t.length;if(s===0)return!1;const d=t.charCodeAt(0);return l(d)||s>2&&i(d)&&t.charCodeAt(1)===A&&l(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let s,d;for(let h=0;h<t.length;++h){const E=t[h];S(E,"path"),E.length>0&&(s===void 0?s=d=E:s+=`\\${E}`)}if(s===void 0)return".";let c=!0,u=0;if(typeof d=="string"&&l(d.charCodeAt(0))){++u;const h=d.length;h>1&&l(d.charCodeAt(1))&&(++u,h>2&&(l(d.charCodeAt(2))?++u:c=!1))}if(c){for(;u<s.length&&l(s.charCodeAt(u));)u++;u>=2&&(s=`\\${s.slice(u)}`)}return e.$ec.normalize(s)},relative(t,s){if(S(t,"from"),S(s,"to"),t===s)return"";const d=e.$ec.resolve(t),c=e.$ec.resolve(s);if(d===c||(t=d.toLowerCase(),s=c.toLowerCase(),t===s))return"";let u=0;for(;u<t.length&&t.charCodeAt(u)===g;)u++;let h=t.length;for(;h-1>u&&t.charCodeAt(h-1)===g;)h--;const E=h-u;let D=0;for(;D<s.length&&s.charCodeAt(D)===g;)D++;let m=s.length;for(;m-1>D&&s.charCodeAt(m-1)===g;)m--;const p=m-D,k=E<p?E:p;let P=-1,z=0;for(;z<k;z++){const M=t.charCodeAt(u+z);if(M!==s.charCodeAt(D+z))break;M===g&&(P=z)}if(z!==k){if(P===-1)return c}else{if(p>k){if(s.charCodeAt(D+z)===g)return c.slice(D+z+1);if(z===2)return c.slice(D+z)}E>k&&(t.charCodeAt(u+z)===g?P=z:z===2&&(P=3)),P===-1&&(P=0)}let j="";for(z=u+P+1;z<=h;++z)(z===h||t.charCodeAt(z)===g)&&(j+=j.length===0?"..":"\\..");return D+=P,j.length>0?`${j}${c.slice(D,m)}`:(c.charCodeAt(D)===g&&++D,c.slice(D,m))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const s=e.$ec.resolve(t);if(s.length<=2)return t;if(s.charCodeAt(0)===g){if(s.charCodeAt(1)===g){const d=s.charCodeAt(2);if(d!==I&&d!==b)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(i(s.charCodeAt(0))&&s.charCodeAt(1)===A&&s.charCodeAt(2)===g)return`\\\\?\\${s}`;return t},dirname(t){S(t,"path");const s=t.length;if(s===0)return".";let d=-1,c=0;const u=t.charCodeAt(0);if(s===1)return l(u)?t:".";if(l(u)){if(d=c=1,l(t.charCodeAt(1))){let D=2,m=D;for(;D<s&&!l(t.charCodeAt(D));)D++;if(D<s&&D!==m){for(m=D;D<s&&l(t.charCodeAt(D));)D++;if(D<s&&D!==m){for(m=D;D<s&&!l(t.charCodeAt(D));)D++;if(D===s)return t;D!==m&&(d=c=D+1)}}}}else i(u)&&t.charCodeAt(1)===A&&(d=s>2&&l(t.charCodeAt(2))?3:2,c=d);let h=-1,E=!0;for(let D=s-1;D>=c;--D)if(l(t.charCodeAt(D))){if(!E){h=D;break}}else E=!1;if(h===-1){if(d===-1)return".";h=d}return t.slice(0,h)},basename(t,s){s!==void 0&&S(s,"ext"),S(t,"path");let d=0,c=-1,u=!0,h;if(t.length>=2&&i(t.charCodeAt(0))&&t.charCodeAt(1)===A&&(d=2),s!==void 0&&s.length>0&&s.length<=t.length){if(s===t)return"";let E=s.length-1,D=-1;for(h=t.length-1;h>=d;--h){const m=t.charCodeAt(h);if(l(m)){if(!u){d=h+1;break}}else D===-1&&(u=!1,D=h+1),E>=0&&(m===s.charCodeAt(E)?--E===-1&&(c=h):(E=-1,c=D))}return d===c?c=D:c===-1&&(c=t.length),t.slice(d,c)}for(h=t.length-1;h>=d;--h)if(l(t.charCodeAt(h))){if(!u){d=h+1;break}}else c===-1&&(u=!1,c=h+1);return c===-1?"":t.slice(d,c)},extname(t){S(t,"path");let s=0,d=-1,c=0,u=-1,h=!0,E=0;t.length>=2&&t.charCodeAt(1)===A&&i(t.charCodeAt(0))&&(s=c=2);for(let D=t.length-1;D>=s;--D){const m=t.charCodeAt(D);if(l(m)){if(!h){c=D+1;break}continue}u===-1&&(h=!1,u=D+1),m===b?d===-1?d=D:E!==1&&(E=1):d!==-1&&(E=-1)}return d===-1||u===-1||E===0||E===1&&d===u-1&&d===c+1?"":t.slice(d,u)},format:r.bind(null,"\\"),parse(t){S(t,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return s;const d=t.length;let c=0,u=t.charCodeAt(0);if(d===1)return l(u)?(s.root=s.dir=t,s):(s.base=s.name=t,s);if(l(u)){if(c=1,l(t.charCodeAt(1))){let P=2,z=P;for(;P<d&&!l(t.charCodeAt(P));)P++;if(P<d&&P!==z){for(z=P;P<d&&l(t.charCodeAt(P));)P++;if(P<d&&P!==z){for(z=P;P<d&&!l(t.charCodeAt(P));)P++;P===d?c=P:P!==z&&(c=P+1)}}}}else if(i(u)&&t.charCodeAt(1)===A){if(d<=2)return s.root=s.dir=t,s;if(c=2,l(t.charCodeAt(2))){if(d===3)return s.root=s.dir=t,s;c=3}}c>0&&(s.root=t.slice(0,c));let h=-1,E=c,D=-1,m=!0,p=t.length-1,k=0;for(;p>=c;--p){if(u=t.charCodeAt(p),l(u)){if(!m){E=p+1;break}continue}D===-1&&(m=!1,D=p+1),u===b?h===-1?h=p:k!==1&&(k=1):h!==-1&&(k=-1)}return D!==-1&&(h===-1||k===0||k===1&&h===D-1&&h===E+1?s.base=s.name=t.slice(E,D):(s.name=t.slice(E,h),s.base=t.slice(E,D),s.ext=t.slice(h,D))),E>0&&E!==c?s.dir=t.slice(0,E-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(w){const t=/\\/g;return()=>{const s=C.cwd().replace(t,"/");return s.slice(s.indexOf("/"))}}return()=>C.cwd()})();e.$fc={resolve(...t){let s="",d=!1;for(let c=t.length-1;c>=-1&&!d;c--){const u=c>=0?t[c]:a();S(u,"path"),u.length!==0&&(s=`${u}/${s}`,d=u.charCodeAt(0)===y)}return s=n(s,!d,"/",o),d?`/${s}`:s.length>0?s:"."},normalize(t){if(S(t,"path"),t.length===0)return".";const s=t.charCodeAt(0)===y,d=t.charCodeAt(t.length-1)===y;return t=n(t,!s,"/",o),t.length===0?s?"/":d?"./":".":(d&&(t+="/"),s?`/${t}`:t)},isAbsolute(t){return S(t,"path"),t.length>0&&t.charCodeAt(0)===y},join(...t){if(t.length===0)return".";let s;for(let d=0;d<t.length;++d){const c=t[d];S(c,"path"),c.length>0&&(s===void 0?s=c:s+=`/${c}`)}return s===void 0?".":e.$fc.normalize(s)},relative(t,s){if(S(t,"from"),S(s,"to"),t===s||(t=e.$fc.resolve(t),s=e.$fc.resolve(s),t===s))return"";const d=1,c=t.length,u=c-d,h=1,E=s.length-h,D=u<E?u:E;let m=-1,p=0;for(;p<D;p++){const P=t.charCodeAt(d+p);if(P!==s.charCodeAt(h+p))break;P===y&&(m=p)}if(p===D)if(E>D){if(s.charCodeAt(h+p)===y)return s.slice(h+p+1);if(p===0)return s.slice(h+p)}else u>D&&(t.charCodeAt(d+p)===y?m=p:p===0&&(m=0));let k="";for(p=d+m+1;p<=c;++p)(p===c||t.charCodeAt(p)===y)&&(k+=k.length===0?"..":"/..");return`${k}${s.slice(h+m)}`},toNamespacedPath(t){return t},dirname(t){if(S(t,"path"),t.length===0)return".";const s=t.charCodeAt(0)===y;let d=-1,c=!0;for(let u=t.length-1;u>=1;--u)if(t.charCodeAt(u)===y){if(!c){d=u;break}}else c=!1;return d===-1?s?"/":".":s&&d===1?"//":t.slice(0,d)},basename(t,s){s!==void 0&&S(s,"ext"),S(t,"path");let d=0,c=-1,u=!0,h;if(s!==void 0&&s.length>0&&s.length<=t.length){if(s===t)return"";let E=s.length-1,D=-1;for(h=t.length-1;h>=0;--h){const m=t.charCodeAt(h);if(m===y){if(!u){d=h+1;break}}else D===-1&&(u=!1,D=h+1),E>=0&&(m===s.charCodeAt(E)?--E===-1&&(c=h):(E=-1,c=D))}return d===c?c=D:c===-1&&(c=t.length),t.slice(d,c)}for(h=t.length-1;h>=0;--h)if(t.charCodeAt(h)===y){if(!u){d=h+1;break}}else c===-1&&(u=!1,c=h+1);return c===-1?"":t.slice(d,c)},extname(t){S(t,"path");let s=-1,d=0,c=-1,u=!0,h=0;for(let E=t.length-1;E>=0;--E){const D=t.charCodeAt(E);if(D===y){if(!u){d=E+1;break}continue}c===-1&&(u=!1,c=E+1),D===b?s===-1?s=E:h!==1&&(h=1):s!==-1&&(h=-1)}return s===-1||c===-1||h===0||h===1&&s===c-1&&s===d+1?"":t.slice(s,c)},format:r.bind(null,"/"),parse(t){S(t,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return s;const d=t.charCodeAt(0)===y;let c;d?(s.root="/",c=1):c=0;let u=-1,h=0,E=-1,D=!0,m=t.length-1,p=0;for(;m>=c;--m){const k=t.charCodeAt(m);if(k===y){if(!D){h=m+1;break}continue}E===-1&&(D=!1,E=m+1),k===b?u===-1?u=m:p!==1&&(p=1):u!==-1&&(p=-1)}if(E!==-1){const k=h===0&&d?1:h;u===-1||p===0||p===1&&u===E-1&&u===h+1?s.base=s.name=t.slice(k,E):(s.name=t.slice(k,u),s.base=t.slice(k,E),s.ext=t.slice(u,E))}return h>0?s.dir=t.slice(0,h-1):d&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.$fc.win32=e.$ec.win32=e.$ec,e.$fc.posix=e.$ec.posix=e.$fc,e.$gc=w?e.$ec.normalize:e.$fc.normalize,e.$hc=w?e.$ec.isAbsolute:e.$fc.isAbsolute,e.$ic=w?e.$ec.join:e.$fc.join,e.$jc=w?e.$ec.resolve:e.$fc.resolve,e.$kc=w?e.$ec.relative:e.$fc.relative,e.$lc=w?e.$ec.dirname:e.$fc.dirname,e.$mc=w?e.$ec.basename:e.$fc.basename,e.$nc=w?e.$ec.extname:e.$fc.extname,e.$oc=w?e.$ec.format:e.$fc.format,e.$pc=w?e.$ec.parse:e.$fc.parse,e.$qc=w?e.$ec.toNamespacedPath:e.$fc.toNamespacedPath,e.sep=w?e.$ec.sep:e.$fc.sep,e.$sc=w?e.$ec.delimiter:e.$fc.delimiter}),define(ke[129],Se([1,0,48,16]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=e.$yq=e.$xq=e.$wq=e.$vq=e.$uq=e.$tq=e.$sq=e.$rq=e.$qq=e.$pq=e.$oq=e.$nq=void 0;const f=new C.$U(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),R=new C.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),L=new C.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function b(D,m,p=!1){const k=D||"",P=m||"",z=f.value.collator.compare(k,P);return f.value.collatorIsNumeric&&z===0&&k!==P?k<P?-1:1:z}e.$nq=b;function y(D,m){const p=R.value.collator;return D=D||"",m=m||"",r(p,D,m)}e.$oq=y;function g(D,m){const p=R.value.collator;return D=D||"",m=m||"",d(D,m)||r(p,D,m)}e.$pq=g;function A(D,m){const p=R.value.collator;return D=D||"",m=m||"",s(D,m)||r(p,D,m)}e.$qq=A;function I(D,m){return D=D||"",m=m||"",D===m?0:D<m?-1:1}e.$rq=I;function $(D,m){const[p,k]=i(D),[P,z]=i(m);let j=f.value.collator.compare(k,z);if(j===0){if(f.value.collatorIsNumeric&&k!==z)return k<z?-1:1;if(j=f.value.collator.compare(p,P),f.value.collatorIsNumeric&&j===0&&p!==P)return p<P?-1:1}return j}e.$sq=$;function v(D,m){D=D||"",m=m||"";const p=n(D),k=n(m),P=R.value.collator,z=L.value.collator;return r(z,p,k)||r(P,D,m)}e.$tq=v;function S(D,m){D=D||"",m=m||"";const p=n(D),k=n(m),P=R.value.collator,z=L.value.collator;return r(z,p,k)||d(D,m)||r(P,D,m)}e.$uq=S;function w(D,m){D=D||"",m=m||"";const p=n(D),k=n(m),P=R.value.collator,z=L.value.collator;return r(z,p,k)||s(D,m)||r(P,D,m)}e.$vq=w;function l(D,m){D=D||"",m=m||"";const p=n(D).toLowerCase(),k=n(m).toLowerCase();return p!==k?p<k?-1:1:D!==m?D<m?-1:1:0}e.$wq=l;const o=/^(.*?)(\.([^.]*))?$/;function i(D,m=!1){const p=D?o.exec(D):[];let k=[p&&p[1]||"",p&&p[3]||""];return m&&(!k[0]&&k[1]||k[0]&&k[0].charAt(0)===".")&&(k=[k[0]+"."+k[1],""]),k}function n(D){const m=D?o.exec(D):[];return m&&m[1]&&m[1].charAt(0)!=="."&&m[3]||""}function r(D,m,p){const k=D.compare(m,p);return k!==0?k:m.length!==p.length?m.length<p.length?-1:1:0}function a(D){const m=D.charAt(0);return m.toLocaleUpperCase()!==m}function t(D){const m=D.charAt(0);return m.toLocaleLowerCase()!==m}function s(D,m){return a(D)&&t(m)?-1:t(D)&&a(m)?1:0}function d(D,m){return t(D)&&a(m)?-1:a(D)&&t(m)?1:0}function c(D,m,p=!1){return p||(D=D&&D.toLowerCase(),m=m&&m.toLowerCase()),D===m?0:D<m?-1:1}function u(D,m,p=!1){const k=D.split(T.sep),P=m.split(T.sep),z=k.length-1,j=P.length-1;let M,O;for(let F=0;;F++){if(M=z===F,O=j===F,M&&O)return b(k[F],P[F],p);if(M)return-1;if(O)return 1;const N=c(k[F],P[F],p);if(N!==0)return N}}e.$xq=u;function h(D,m,p){const k=D.toLowerCase(),P=m.toLowerCase(),z=E(D,m,p);if(z)return z;const j=k.endsWith(p),M=P.endsWith(p);if(j!==M)return j?-1:1;const O=b(k,P);return O!==0?O:k.localeCompare(P)}e.$yq=h;function E(D,m,p){const k=D.toLowerCase(),P=m.toLowerCase(),z=k.startsWith(p),j=P.startsWith(p);if(z!==j)return z?-1:1;if(z&&j){if(k.length<P.length)return-1;if(k.length>P.length)return 1}return 0}e.$zq=E}),define(ke[33],Se([1,0,16,11,13,18]),function(me,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=void 0;function L(h){return h===47||h===92}e.$Uf=L;function b(h){return h.replace(/[\\/]/g,C.$fc.sep)}e.$Vf=b;function y(h){return h.indexOf("/")===-1&&(h=b(h)),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h),h}e.$Wf=y;function g(h,E=C.$fc.sep){if(!h)return"";const D=h.length,m=h.charCodeAt(0);if(L(m)){if(L(h.charCodeAt(1))&&!L(h.charCodeAt(2))){let k=3;const P=k;for(;k<D&&!L(h.charCodeAt(k));k++);if(P!==k&&!L(h.charCodeAt(k+1))){for(k+=1;k<D;k++)if(L(h.charCodeAt(k)))return h.slice(0,k+1).replace(/[\\/]/g,E)}}return E}else if(o(m)&&h.charCodeAt(1)===58)return L(h.charCodeAt(2))?h.slice(0,2)+E:h.slice(0,2);let p=h.indexOf("://");if(p!==-1){for(p+=3;p<D;p++)if(L(h.charCodeAt(p)))return h.slice(0,p+1)}return""}e.$Xf=g;function A(h){if(!T.$i||!h||h.length<5)return!1;let E=h.charCodeAt(0);if(E!==92||(E=h.charCodeAt(1),E!==92))return!1;let D=2;const m=D;for(;D<h.length&&(E=h.charCodeAt(D),E!==92);D++);return!(m===D||(E=h.charCodeAt(D+1),isNaN(E)||E===92))}e.$Yf=A;const I=/[\\/:\*\?"<>\|]/g,$=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function S(h,E=T.$i){const D=E?I:$;return!(!h||h.length===0||/^\s+$/.test(h)||(D.lastIndex=0,D.test(h))||E&&v.test(h)||h==="."||h===".."||E&&h[h.length-1]==="."||E&&h.length!==h.trim().length||h.length>255)}e.$Zf=S;function w(h,E,D){const m=h===E;return!D||m?m:!h||!E?!1:(0,f.$6e)(h,E)}e.$1f=w;function l(h,E,D,m=C.sep){if(h===E)return!0;if(!h||!E||E.length>h.length)return!1;if(D){if(!(0,f.$7e)(h,E))return!1;if(E.length===h.length)return!0;let k=E.length;return E.charAt(E.length-1)===m&&k--,h.charAt(k)===m}return E.charAt(E.length-1)!==m&&(E+=m),h.indexOf(E)===0}e.$2f=l;function o(h){return h>=65&&h<=90||h>=97&&h<=122}e.$3f=o;function i(h,E){return T.$i&&h.endsWith(":")&&(h+=C.sep),(0,C.$hc)(h)||(h=(0,C.$ic)(E,h)),h=(0,C.$gc)(h),T.$i?(h=(0,f.$Oe)(h,C.sep),h.endsWith(":")&&(h+=C.sep)):(h=(0,f.$Oe)(h,C.sep),h||(h=C.sep)),h}e.$4f=i;function n(h){const E=(0,C.$gc)(h);return T.$i?h.length>3?!1:r(E)&&(h.length===2||E.charCodeAt(2)===92):E===C.$fc.sep}e.$5f=n;function r(h,E=T.$i){return E?o(h.charCodeAt(0))&&h.charCodeAt(1)===58:!1}e.$6f=r;function a(h,E=T.$i){return r(h,E)?h[0]:void 0}e.$7f=a;function t(h,E,D){return E.length>h.length?-1:h===E?0:(D&&(h=h.toLowerCase(),E=E.toLowerCase()),h.indexOf(E))}e.$8f=t;function s(h){const E=h.split(":");let D,m,p;for(const k of E){const P=Number(k);(0,R.$Gf)(P)?m===void 0?m=P:p===void 0&&(p=P):D=D?[D,k].join(":"):k}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:m!==void 0?m:void 0,column:p!==void 0?p:m!==void 0?1:void 0}}e.$9f=s;const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",c="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function u(h,E,D=8){let m="";for(let k=0;k<D;k++){let P;k===0&&T.$i&&!E&&(D===3||D===4)?P=c:P=d,m+=P.charAt(Math.floor(Math.random()*P.length))}let p;return E?p=`${E}-${m}`:p=m,h?(0,C.$ic)(h,p):p}e.$0f=u}),define(ke[130],Se([1,0,129,124,52,16,11,13]),function(me,e,C,T,f,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Eq=e.$Dq=e.$Cq=e.$Bq=e.$Aq=void 0;const y=0,g=[y,[]];function A(W,X,ce,J){if(!W||!X)return g;const Q=W.length,G=X.length;if(Q<G)return g;const oe=W.toLowerCase();return I(X,ce,G,W,oe,Q,J)}e.$Aq=A;function I(W,X,ce,J,Q,G,oe){const _=[],Ee=[];for(let ne=0;ne<ce;ne++){const be=ne*G,H=be-G,x=ne>0,Y=W[ne],$e=X[ne];for(let ie=0;ie<G;ie++){const fe=ie>0,te=be+ie,de=te-1,pe=H+ie-1,Pe=fe?_[de]:0,B=x&&fe?_[pe]:0,Z=x&&fe?Ee[pe]:0;let re;!B&&x?re=0:re=$(Y,$e,J,Q,ie,Z),re&&B+re>=Pe&&(oe||x||Q.startsWith(X,ie))?(Ee[te]=Z+1,_[te]=B+re):(Ee[te]=y,_[te]=Pe)}}const he=[];let q=ce-1,U=G-1;for(;q>=0&&U>=0;){const ne=q*G+U;Ee[ne]===y||(he.push(U),q--),U--}return[_[ce*G-1],he.reverse()]}function $(W,X,ce,J,Q,G){let oe=0;if(!v(X,J[Q]))return oe;if(oe+=1,G>0&&(oe+=G*5),W===ce[Q]&&(oe+=1),Q===0)oe+=8;else{const _=S(ce.charCodeAt(Q-1));_?oe+=_:(0,T.$Mj)(ce.charCodeAt(Q))&&G===0&&(oe+=2)}return oe}function v(W,X){return W===X?!0:W==="/"||W==="\\"?X==="/"||X==="\\":!1}function S(W){switch(W){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const w=[void 0,[]];function l(W,X,ce=0,J=0){const Q=X;return Q.values&&Q.values.length>1?o(W,Q.values,ce,J):i(W,X,ce,J)}e.$Bq=l;function o(W,X,ce,J){let Q=0;const G=[];for(const oe of X){const[_,Ee]=i(W,oe,ce,J);if(typeof _!="number")return w;Q+=_,G.push(...Ee)}return[Q,D(G)]}function i(W,X,ce,J){const Q=(0,T.$Vj)(X.original,X.originalLowercase,ce,W,W.toLowerCase(),J,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Q?[Q[0],(0,T.$Sj)(Q)]:w}const n=Object.freeze({score:0}),r=1<<18,a=1<<17,t=1<<16;function s(W,X,ce,J){const Q=J.values?J.values:[J];return(0,f.$Ji)({[J.normalized]:{values:Q.map(oe=>({value:oe.normalized,expectContiguousMatch:oe.expectContiguousMatch})),label:W,description:X,allowNonContiguousMatches:ce}})}function d(W,X,ce,J,Q){if(!W||!X.normalized)return n;const G=J.getItemLabel(W);if(!G)return n;const oe=J.getItemDescription(W),_=s(G,oe,ce,X),Ee=Q[_];if(Ee)return Ee;const he=c(G,oe,J.getItemPath(W),X,ce);return Q[_]=he,he}e.$Cq=d;function c(W,X,ce,J,Q){const G=!ce||!J.containsPathSeparator;return ce&&(L.$k?J.pathNormalized===ce:(0,b.$6e)(J.pathNormalized,ce))?{score:r,labelMatch:[{start:0,end:W.length}],descriptionMatch:X?[{start:0,end:X.length}]:void 0}:J.values&&J.values.length>1?u(W,X,ce,J.values,G,Q):h(W,X,ce,J,G,Q)}function u(W,X,ce,J,Q,G){let oe=0;const _=[],Ee=[];for(const he of J){const{score:q,labelMatch:U,descriptionMatch:ne}=h(W,X,ce,he,Q,G);if(q===y)return n;oe+=q,U&&_.push(...U),ne&&Ee.push(...ne)}return{score:oe,labelMatch:D(_),descriptionMatch:D(Ee)}}function h(W,X,ce,J,Q,G){if(Q||!X){const[oe,_]=A(W,J.normalized,J.normalizedLowercase,G&&!J.expectContiguousMatch);if(oe){const Ee=(0,T.$Jj)(J.normalized,W);let he;if(Ee){he=a;const q=Math.round(J.normalized.length/W.length*100);he+=q}else he=t;return{score:he+oe,labelMatch:Ee||E(_)}}}if(X){let oe=X;ce&&(oe=`${X}${R.sep}`);const _=oe.length,Ee=`${oe}${W}`,[he,q]=A(Ee,J.normalized,J.normalizedLowercase,G&&!J.expectContiguousMatch);if(he){const U=E(q),ne=[],be=[];return U.forEach(H=>{H.start<_&&H.end>_?(ne.push({start:0,end:H.end-_}),be.push({start:H.start,end:_})):H.start>=_?ne.push({start:H.start-_,end:H.end-_}):be.push(H)}),{score:he,labelMatch:ne,descriptionMatch:be}}}return n}function E(W){const X=[];if(!W)return X;let ce;for(const J of W)ce&&ce.end===J?ce.end+=1:(ce={start:J,end:J+1},X.push(ce));return X}function D(W){const X=W.sort((Q,G)=>Q.start-G.start),ce=[];let J;for(const Q of X)!J||!m(J,Q)?(J=Q,ce.push(Q)):(J.start=Math.min(J.start,Q.start),J.end=Math.max(J.end,Q.end));return ce}function m(W,X){return!(W.end<X.start||X.end<W.start)}function p(W,X,ce,J,Q,G){const oe=d(W,ce,J,Q,G),_=d(X,ce,J,Q,G),Ee=oe.score,he=_.score;if((Ee===r||he===r)&&Ee!==he)return Ee===r?-1:1;if(Ee>t||he>t){if(Ee!==he)return Ee>he?-1:1;if(Ee<a&&he<a){const Y=P(oe.labelMatch,_.labelMatch);if(Y!==0)return Y}const H=Q.getItemLabel(W)||"",x=Q.getItemLabel(X)||"";if(H.length!==x.length)return H.length-x.length}if(Ee!==he)return Ee>he?-1:1;const q=Array.isArray(oe.labelMatch)&&oe.labelMatch.length>0,U=Array.isArray(_.labelMatch)&&_.labelMatch.length>0;if(q&&!U)return-1;if(U&&!q)return 1;const ne=k(W,oe,Q),be=k(X,_,Q);return ne&&be&&ne!==be?be>ne?-1:1:z(W,X,ce,Q)}e.$Dq=p;function k(W,X,ce){let J=-1,Q=-1;if(X.descriptionMatch&&X.descriptionMatch.length?J=X.descriptionMatch[0].start:X.labelMatch&&X.labelMatch.length&&(J=X.labelMatch[0].start),X.labelMatch&&X.labelMatch.length){if(Q=X.labelMatch[X.labelMatch.length-1].end,X.descriptionMatch&&X.descriptionMatch.length){const G=ce.getItemDescription(W);G&&(Q+=G.length)}}else X.descriptionMatch&&X.descriptionMatch.length&&(Q=X.descriptionMatch[X.descriptionMatch.length-1].end);return Q-J}function P(W,X){if(!W&&!X||(!W||!W.length)&&(!X||!X.length))return 0;if(!X||!X.length)return-1;if(!W||!W.length)return 1;const ce=W[0].start,Q=W[W.length-1].end-ce,G=X[0].start,_=X[X.length-1].end-G;return Q===_?0:_<Q?1:-1}function z(W,X,ce,J){const Q=J.getItemLabel(W)||"",G=J.getItemLabel(X)||"",oe=J.getItemDescription(W),_=J.getItemDescription(X),Ee=Q.length+(oe?oe.length:0),he=G.length+(_?_.length:0);if(Ee!==he)return Ee-he;const q=J.getItemPath(W),U=J.getItemPath(X);return q&&U&&q.length!==U.length?q.length-U.length:Q!==G?(0,C.$yq)(Q,G,ce.normalized):oe&&_&&oe!==_?(0,C.$yq)(oe,_,ce.normalized):q&&U&&q!==U?(0,C.$yq)(q,U,ce.normalized):0}function j(W){return W.startsWith('"')&&W.endsWith('"')}const M=" ";function O(W){typeof W!="string"&&(W="");const X=W.toLowerCase(),{pathNormalized:ce,normalized:J,normalizedLowercase:Q}=F(W),G=ce.indexOf(R.sep)>=0,oe=j(W);let _;const Ee=W.split(M);if(Ee.length>1)for(const he of Ee){const q=j(he),{pathNormalized:U,normalized:ne,normalizedLowercase:be}=F(he);ne&&(_||(_=[]),_.push({original:he,originalLowercase:he.toLowerCase(),pathNormalized:U,normalized:ne,normalizedLowercase:be,expectContiguousMatch:q}))}return{original:W,originalLowercase:X,pathNormalized:ce,normalized:J,normalizedLowercase:Q,values:_,containsPathSeparator:G,expectContiguousMatch:oe}}e.$Eq=O;function F(W){let X;L.$i?X=W.replace(/\//g,R.sep):X=W.replace(/\\/g,R.sep);const ce=(0,b.$Qe)(X).replace(/\s|"/g,"");return{pathNormalized:X,normalized:ce,normalizedLowercase:ce.toLowerCase()}}function N(W){return Array.isArray(W)?O(W.map(X=>X.original).join(M)):O(W.original)}e.$Fq=N}),define(ke[100],Se([1,0,16]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=e.$Yr=e.$Xr=e.$Wr=e.$Vr=void 0,e.$Vr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},f={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(A){const I=(0,C.$nc)(A),$=T[I.toLowerCase()];return $!==void 0?$:L(A)}e.$Wr=R;function L(A){const I=(0,C.$nc)(A);return f[I.toLowerCase()]}e.$Xr=L;function b(A){for(const I in f)if(f[I]===A)return I}e.$Yr=b;const y=/^(.+)\/(.+?)(;.+)?$/;function g(A,I){const $=y.exec(A);return $?`${$[1].toLowerCase()}/${$[2].toLowerCase()}${$[3]??""}`:I?void 0:A}e.$Zr=g}),define(ke[101],Se([1,0,11]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=e.$Fl=e.TerminateResponseCode=e.Source=void 0;var T;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(T||(e.Source=T={}));var f;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(f||(e.TerminateResponseCode=f={}));function R(b,...y){const g=y.reduce(($,v)=>($[v]=!0,$),{}),A=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter($=>!g[$]).forEach($=>{for(let v=0;v<A.length;v++)if($.search(A[v])!==-1){delete b[$];break}})}e.$Fl=R;function L(b){b&&(delete b.DEBUG,C.$j&&delete b.DYLD_LIBRARY_PATH,C.$k&&delete b.LD_PRELOAD)}e.$Gl=L}),define(ke[2],Se([1,0,16,11]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vc=e.$uc=e.URI=void 0;const f=/^\w[\w\d+.-]*$/,R=/^\//,L=/^\/\//;function b(c,u){if(!c.scheme&&u)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${c.authority}", path: "${c.path}", query: "${c.query}", fragment: "${c.fragment}"}`);if(c.scheme&&!f.test(c.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(c.path){if(c.authority){if(!R.test(c.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(c.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(c,u){return!c&&!u?"file":c}function g(c,u){switch(c){case"https":case"http":case"file":u?u[0]!==I&&(u=I+u):u=I;break}return u}const A="",I="/",$=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class v{static isUri(u){return u instanceof v?!0:u?typeof u.authority=="string"&&typeof u.fragment=="string"&&typeof u.path=="string"&&typeof u.query=="string"&&typeof u.scheme=="string"&&typeof u.fsPath=="string"&&typeof u.with=="function"&&typeof u.toString=="function":!1}constructor(u,h,E,D,m,p=!1){typeof u=="object"?(this.scheme=u.scheme||A,this.authority=u.authority||A,this.path=u.path||A,this.query=u.query||A,this.fragment=u.fragment||A):(this.scheme=y(u,p),this.authority=h||A,this.path=g(this.scheme,E||A),this.query=D||A,this.fragment=m||A,b(this,p))}get fsPath(){return r(this,!1)}with(u){if(!u)return this;let{scheme:h,authority:E,path:D,query:m,fragment:p}=u;return h===void 0?h=this.scheme:h===null&&(h=A),E===void 0?E=this.authority:E===null&&(E=A),D===void 0?D=this.path:D===null&&(D=A),m===void 0?m=this.query:m===null&&(m=A),p===void 0?p=this.fragment:p===null&&(p=A),h===this.scheme&&E===this.authority&&D===this.path&&m===this.query&&p===this.fragment?this:new l(h,E,D,m,p)}static parse(u,h=!1){const E=$.exec(u);return E?new l(E[2]||A,d(E[4]||A),d(E[5]||A),d(E[7]||A),d(E[9]||A),h):new l(A,A,A,A,A)}static file(u){let h=A;if(T.$i&&(u=u.replace(/\\/g,I)),u[0]===I&&u[1]===I){const E=u.indexOf(I,2);E===-1?(h=u.substring(2),u=I):(h=u.substring(2,E),u=u.substring(E)||I)}return new l("file",h,u,A,A)}static from(u,h){return new l(u.scheme,u.authority,u.path,u.query,u.fragment,h)}static joinPath(u,...h){if(!u.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let E;return T.$i&&u.scheme==="file"?E=v.file(C.$ec.join(r(u,!0),...h)).path:E=C.$fc.join(u.path,...h),u.with({path:E})}toString(u=!1){return a(this,u)}toJSON(){return this}static revive(u){if(u){if(u instanceof v)return u;{const h=new l(u);return h._formatted=u.external??null,h._fsPath=u._sep===w?u.fsPath??null:null,h}}else return u}}e.URI=v;function S(c){return!c||typeof c!="object"?!1:typeof c.scheme=="string"&&(typeof c.authority=="string"||typeof c.authority>"u")&&(typeof c.path=="string"||typeof c.path>"u")&&(typeof c.query=="string"||typeof c.query>"u")&&(typeof c.fragment=="string"||typeof c.fragment>"u")}e.$uc=S;const w=T.$i?1:void 0;class l extends v{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=r(this,!1)),this._fsPath}toString(u=!1){return u?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const u={$mid:1};return this._fsPath&&(u.fsPath=this._fsPath,u._sep=w),this._formatted&&(u.external=this._formatted),this.path&&(u.path=this.path),this.scheme&&(u.scheme=this.scheme),this.authority&&(u.authority=this.authority),this.query&&(u.query=this.query),this.fragment&&(u.fragment=this.fragment),u}}const o={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function i(c,u,h){let E,D=-1;for(let m=0;m<c.length;m++){const p=c.charCodeAt(m);if(p>=97&&p<=122||p>=65&&p<=90||p>=48&&p<=57||p===45||p===46||p===95||p===126||u&&p===47||h&&p===91||h&&p===93||h&&p===58)D!==-1&&(E+=encodeURIComponent(c.substring(D,m)),D=-1),E!==void 0&&(E+=c.charAt(m));else{E===void 0&&(E=c.substr(0,m));const k=o[p];k!==void 0?(D!==-1&&(E+=encodeURIComponent(c.substring(D,m)),D=-1),E+=k):D===-1&&(D=m)}}return D!==-1&&(E+=encodeURIComponent(c.substring(D))),E!==void 0?E:c}function n(c){let u;for(let h=0;h<c.length;h++){const E=c.charCodeAt(h);E===35||E===63?(u===void 0&&(u=c.substr(0,h)),u+=o[E]):u!==void 0&&(u+=c[h])}return u!==void 0?u:c}function r(c,u){let h;return c.authority&&c.path.length>1&&c.scheme==="file"?h=`//${c.authority}${c.path}`:c.path.charCodeAt(0)===47&&(c.path.charCodeAt(1)>=65&&c.path.charCodeAt(1)<=90||c.path.charCodeAt(1)>=97&&c.path.charCodeAt(1)<=122)&&c.path.charCodeAt(2)===58?u?h=c.path.substr(1):h=c.path[1].toLowerCase()+c.path.substr(2):h=c.path,T.$i&&(h=h.replace(/\//g,"\\")),h}e.$vc=r;function a(c,u){const h=u?n:i;let E="",{scheme:D,authority:m,path:p,query:k,fragment:P}=c;if(D&&(E+=D,E+=":"),(m||D==="file")&&(E+=I,E+=I),m){let z=m.indexOf("@");if(z!==-1){const j=m.substr(0,z);m=m.substr(z+1),z=j.lastIndexOf(":"),z===-1?E+=h(j,!1,!1):(E+=h(j.substr(0,z),!1,!1),E+=":",E+=h(j.substr(z+1),!1,!0)),E+="@"}m=m.toLowerCase(),z=m.lastIndexOf(":"),z===-1?E+=h(m,!1,!0):(E+=h(m.substr(0,z),!1,!0),E+=m.substr(z))}if(p){if(p.length>=3&&p.charCodeAt(0)===47&&p.charCodeAt(2)===58){const z=p.charCodeAt(1);z>=65&&z<=90&&(p=`/${String.fromCharCode(z+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===58){const z=p.charCodeAt(0);z>=65&&z<=90&&(p=`${String.fromCharCode(z+32)}:${p.substr(2)}`)}E+=h(p,!0,!1)}return k&&(E+="?",E+=h(k,!1,!1)),P&&(E+="#",E+=u?P:i(P,!1,!1)),E}function t(c){try{return decodeURIComponent(c)}catch{return c.length>3?c.substr(0,3)+t(c.substr(3)):c}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function d(c){return c.match(s)?c.replace(s,u=>t(u)):c}}),define(ke[185],Se([1,0,2]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$6p=e.$5p=e.$4p=void 0;function T(g){const A=g;return A&&typeof A.type=="string"&&typeof A.severity=="string"}e.$4p=T;function f(g){const A=[];let I;try{const $=JSON.parse(g.arguments),v=$[$.length-1];v&&v.__$stack&&($.pop(),I=v.__$stack),A.push(...$)}catch{A.push("Unable to log remote console arguments",g.arguments)}return{args:A,stack:I}}e.$5p=f;function R(g){if(typeof g!="string")return R(f(g).stack);const A=g;if(A){const I=L(A),$=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if($&&$.length===4)return{uri:C.URI.file($[1]),line:Number($[2]),column:Number($[3])}}}e.$6p=R;function L(g){if(!g)return g;const A=g.indexOf(`
`);return A===-1?g:g.substring(0,A)}function b(g,A){const{args:I,stack:$}=f(g),v=typeof I[0]=="string"&&I.length===1;let S=L($);S&&(S=`(${S.trim()})`);let w=[];if(typeof I[0]=="string"?S&&v?w=[`%c[${A}] %c${I[0]} %c${S}`,y("blue"),y(""),y("grey")]:w=[`%c[${A}] %c${I[0]}`,y("blue"),y(""),...I.slice(1)]:w=[`%c[${A}]%`,y("blue"),...I],S&&!v&&w.push(S),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,w)}e.log=b;function y(g){return`color: ${g}`}}),define(ke[54],Se([1,0,22,2]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sh=e.$rh=e.$qh=void 0;function f(y){return JSON.stringify(y,L)}e.$qh=f;function R(y){let g=JSON.parse(y);return g=b(g),g}e.$rh=R;function L(y,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function b(y,g=0){if(!y||g>200)return y;if(typeof y=="object"){switch(y.$mid){case 1:return T.URI.revive(y);case 2:return new RegExp(y.source,y.flags);case 17:return new Date(y.source)}if(y instanceof C.$fe||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let A=0;A<y.length;++A)y[A]=b(y[A],g+1);else for(const A in y)Object.hasOwnProperty.call(y,A)&&(y[A]=b(y[A],g+1))}return y}e.$sh=b}),define(ke[17],Se([1,0,8,11,2]),function(me,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.Schemas=void 0;var R;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeManagedRemoteResource="vscode-managed-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm"})(R||(e.Schemas=R={})),e.$$f="vscode-tkn",e.$_f="tkn";class L{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(A){this.d=A}setDelegate(A){this.e=A}setServerRootPath(A){this.f=`${A}/${R.vscodeRemoteResource}`}set(A,I,$){this.a[A]=I,this.b[A]=$}setConnectionToken(A,I){this.c[A]=I}getPreferredWebSchema(){return this.d}rewrite(A){if(this.e)try{return this.e(A)}catch(l){return C.$Z(l),A}const I=A.authority;let $=this.a[I];$&&$.indexOf(":")!==-1&&$.indexOf("[")===-1&&($=`[${$}]`);const v=this.b[I],S=this.c[I];let w=`path=${encodeURIComponent(A.path)}`;return typeof S=="string"&&(w+=`&${e.$_f}=${encodeURIComponent(S)}`),f.URI.from({scheme:T.$o?this.d:R.vscodeRemoteResource,authority:`${$}:${v}`,path:this.f,query:w})}}e.$ag=new L,e.$bg="vs/../../extensions",e.$cg="vs/../../node_modules",e.$dg="vs/../../node_modules.asar",e.$eg="vs/../../node_modules.asar.unpacked",e.$fg="vscode-app";class b{static{this.a=e.$fg}asBrowserUri(A){const I=this.b(A,me);return this.uriToBrowserUri(I)}uriToBrowserUri(A){return A.scheme===R.vscodeRemote?e.$ag.rewrite(A):A.scheme===R.file&&(T.$m||T.$q===`${R.vscodeFileResource}://${b.a}`)?A.with({scheme:R.vscodeFileResource,authority:A.authority||b.a,query:null,fragment:null}):A}asFileUri(A){const I=this.b(A,me);return this.uriToFileUri(I)}uriToFileUri(A){return A.scheme===R.vscodeFileResource?A.with({scheme:R.file,authority:A.authority!==b.a?A.authority:null,query:null,fragment:null}):A}b(A,I){return f.URI.isUri(A)?A:f.URI.parse(I.toUrl(A))}}e.$gg=new b;var y;(function(g){const A=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(A.get("3"));const I="vscode-coi";function $(S){let w;typeof S=="string"?w=new URL(S).searchParams:S instanceof URL?w=S.searchParams:f.URI.isUri(S)&&(w=new URL(S.toString(!0)).searchParams);const l=w?.get(I);if(l)return A.get(l)}g.getHeadersFromQuery=$;function v(S,w,l){if(!globalThis.crossOriginIsolated)return;const o=w&&l?"3":l?"2":"1";S instanceof URLSearchParams?S.set(I,o):S[I]=o}g.addSearchParam=v})(y||(e.COI=y={}))}),define(ke[186],Se([1,0,159,17,11,2]),function(me,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OC=void 0;class L{constructor($,v,S){this.id=$,this.dependencies=v,this.callback=S}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=($,v,S)=>{typeof $!="string"&&(S=v,v=$,$=null),(typeof v!="object"||!Array.isArray(v))&&(S=v,v=null),this.c.push(new L($,v,S))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){if($.startsWith(window.location.origin)||$.startsWith("vscode-file://vscode-app"))return $;throw new Error(`[trusted_script_src] Invalid script url: ${$}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){return $}})))}async load($){this.g();const v=await(this.a?this.i($):this.b?this.h($):this.j($));if(!v)throw new Error(`Did not receive a define call from script ${$}`);if(Array.isArray(v.dependencies)&&v.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${$}. The dependencies are: ${v.dependencies.join(", ")}`);return typeof v.callback=="function"?v.callback([]):v.callback}h($){return new Promise((v,S)=>{const w=document.createElement("script");w.setAttribute("async","async"),w.setAttribute("type","text/javascript");const l=()=>{w.removeEventListener("load",o),w.removeEventListener("error",i)},o=n=>{l(),v(this.c.pop())},i=n=>{l(),S(n)};w.addEventListener("load",o),w.addEventListener("error",i),this.f&&($=this.f.createScriptURL($)),w.setAttribute("src",$),window.document.getElementsByTagName("head")[0].appendChild(w)})}i($){return new Promise((v,S)=>{try{this.f&&($=this.f.createScriptURL($)),importScripts($),v(this.c.pop())}catch(w){S(w)}})}async j($){try{const v=globalThis._VSCODE_NODE_MODULES.fs,S=globalThis._VSCODE_NODE_MODULES.vm,w=globalThis._VSCODE_NODE_MODULES.module,l=R.URI.parse($).fsPath,o=v.readFileSync(l).toString(),i=w.wrap(o.replace(/^#!.*/,""));return new S.Script(i).runInThisContext().apply(),this.c.pop()}catch(v){throw v}}}const y=new Map;let g={};typeof globalThis.require=="object"&&(g=globalThis.require.paths??{});async function A(I,$,v){if(C.$S){v===void 0&&(v=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),g[I]&&(I=g[I]);const S=`${I}/${$}`;if(y.has(S))return y.get(S);let w;if(/^\w[\w\d+.-]*:\/\//.test(S))w=S;else{const n=`${v&&!f.$o?T.$dg:T.$cg}/${S}`;w=T.$gg.asBrowserUri(n).toString(!0)}const l=b.INSTANCE.load(w);return y.set(S,l),l}else return await new Promise((S,w)=>{me([I],S,w)})}e.$OC=A}),define(ke[23],Se([1,0,33,17,16,11,13,2]),function(me,e,C,T,f,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jg=e.DataUri=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=void 0;function y(v){return(0,b.$vc)(v,!0)}e.$ng=y;class g{constructor(S){this.a=S}compare(S,w,l=!1){return S===w?0:(0,L.$Ye)(this.getComparisonKey(S,l),this.getComparisonKey(w,l))}isEqual(S,w,l=!1){return S===w?!0:!S||!w?!1:this.getComparisonKey(S,l)===this.getComparisonKey(w,l)}getComparisonKey(S,w=!1){return S.with({path:this.a(S)?S.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(S){return this.a(S)}isEqualOrParent(S,w,l=!1){if(S.scheme===w.scheme){if(S.scheme===T.Schemas.file)return C.$2f(y(S),y(w),this.a(S))&&S.query===w.query&&(l||S.fragment===w.fragment);if((0,e.$Eg)(S.authority,w.authority))return C.$2f(S.path,w.path,this.a(S),"/")&&S.query===w.query&&(l||S.fragment===w.fragment)}return!1}joinPath(S,...w){return b.URI.joinPath(S,...w)}basenameOrAuthority(S){return(0,e.$wg)(S)||S.authority}basename(S){return f.$fc.basename(S.path)}extname(S){return f.$fc.extname(S.path)}dirname(S){if(S.path.length===0)return S;let w;return S.scheme===T.Schemas.file?w=b.URI.file(f.$lc(y(S))).path:(w=f.$fc.dirname(S.path),S.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${S.toString})) resulted in a relative path`),w="/")),S.with({path:w})}normalizePath(S){if(!S.path.length)return S;let w;return S.scheme===T.Schemas.file?w=b.URI.file(f.$gc(y(S))).path:w=f.$fc.normalize(S.path),S.with({path:w})}relativePath(S,w){if(S.scheme!==w.scheme||!(0,e.$Eg)(S.authority,w.authority))return;if(S.scheme===T.Schemas.file){const i=f.$kc(y(S),y(w));return R.$i?C.$Vf(i):i}let l=S.path||"/";const o=w.path||"/";if(this.a(S)){let i=0;for(const n=Math.min(l.length,o.length);i<n&&!(l.charCodeAt(i)!==o.charCodeAt(i)&&l.charAt(i).toLowerCase()!==o.charAt(i).toLowerCase());i++);l=o.substr(0,i)+l.substr(i)}return f.$fc.relative(l,o)}resolvePath(S,w){if(S.scheme===T.Schemas.file){const l=b.URI.file(f.$jc(y(S),w));return S.with({authority:l.authority,path:l.path})}return w=C.$Wf(w),S.with({path:f.$fc.resolve(S.path,w)})}isAbsolutePath(S){return!!S.path&&S.path[0]==="/"}isEqualAuthority(S,w){return S===w||S!==void 0&&w!==void 0&&(0,L.$6e)(S,w)}hasTrailingPathSeparator(S,w=f.sep){if(S.scheme===T.Schemas.file){const l=y(S);return l.length>C.$Xf(l).length&&l[l.length-1]===w}else{const l=S.path;return l.length>1&&l.charCodeAt(l.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(S.fsPath)}}removeTrailingPathSeparator(S,w=f.sep){return(0,e.$Fg)(S,w)?S.with({path:S.path.substr(0,S.path.length-1)}):S}addTrailingPathSeparator(S,w=f.sep){let l=!1;if(S.scheme===T.Schemas.file){const o=y(S);l=o!==void 0&&o.length===C.$Xf(o).length&&o[o.length-1]===w}else{w="/";const o=S.path;l=o.length===1&&o.charCodeAt(o.length-1)===47}return!l&&!(0,e.$Fg)(S,w)?S.with({path:S.path+"/"}):S}}e.$og=g,e.$pg=new g(()=>!1),e.$qg=new g(v=>v.scheme===T.Schemas.file?!R.$k:!0),e.$rg=new g(v=>!0),e.$sg=e.$pg.isEqual.bind(e.$pg),e.$tg=e.$pg.isEqualOrParent.bind(e.$pg),e.$ug=e.$pg.getComparisonKey.bind(e.$pg),e.$vg=e.$pg.basenameOrAuthority.bind(e.$pg),e.$wg=e.$pg.basename.bind(e.$pg),e.$xg=e.$pg.extname.bind(e.$pg),e.$yg=e.$pg.dirname.bind(e.$pg),e.$zg=e.$pg.joinPath.bind(e.$pg),e.$Ag=e.$pg.normalizePath.bind(e.$pg),e.$Bg=e.$pg.relativePath.bind(e.$pg),e.$Cg=e.$pg.resolvePath.bind(e.$pg),e.$Dg=e.$pg.isAbsolutePath.bind(e.$pg),e.$Eg=e.$pg.isEqualAuthority.bind(e.$pg),e.$Fg=e.$pg.hasTrailingPathSeparator.bind(e.$pg),e.$Gg=e.$pg.removeTrailingPathSeparator.bind(e.$pg),e.$Hg=e.$pg.addTrailingPathSeparator.bind(e.$pg);function A(v,S){const w=[];for(let l=0;l<v.length;l++){const o=S(v[l]);v.some((i,n)=>n===l?!1:(0,e.$tg)(o,S(i)))||w.push(v[l])}return w}e.$Ig=A;var I;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function S(w){const l=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(n=>{const[r,a]=n.split(":");r&&a&&l.set(r,a)});const i=w.path.substring(0,w.path.indexOf(";"));return i&&l.set(v.META_DATA_MIME,i),l}v.parseMetaData=S})(I||(e.DataUri=I={}));function $(v,S,w){if(S){let l=v.path;return l&&l[0]!==f.$fc.sep&&(l=f.$fc.sep+l),v.with({scheme:w,authority:S,path:l})}return v.with({scheme:w})}e.$Jg=$}),define(ke[12],Se([1,0,21,8,4,3,23,11,163]),function(me,e,C,T,f,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=e.$lh=e.$kh=e.$jh=e.Promises=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=void 0;function g(be){return!!be&&typeof be.then=="function"}e.$Kg=g;function A(be){const H=new C.$2d,x=be(H.token),Y=new Promise(($e,ie)=>{const fe=H.token.onCancellationRequested(()=>{fe.dispose(),H.dispose(),ie(new T.$4)});Promise.resolve(x).then(te=>{fe.dispose(),H.dispose(),$e(te)},te=>{fe.dispose(),H.dispose(),ie(te)})});return new class{cancel(){H.cancel()}then($e,ie){return Y.then($e,ie)}catch($e){return this.then(void 0,$e)}finally($e){return Y.finally($e)}}}e.$Lg=A;function I(be,H,x){return new Promise((Y,$e)=>{const ie=H.onCancellationRequested(()=>{ie.dispose(),Y(x)});be.then(Y,$e).finally(()=>ie.dispose())})}e.$Mg=I;function $(be,H){return new Promise((x,Y)=>{const $e=H.onCancellationRequested(()=>{$e.dispose(),Y(new T.$4)});be.then(x,Y).finally(()=>$e.dispose())})}e.$Ng=$;async function v(be){let H=-1;const x=be.map((Y,$e)=>Y.then(ie=>(H=$e,ie)));try{return await Promise.race(x)}finally{be.forEach((Y,$e)=>{$e!==H&&Y.cancel()})}}e.$Og=v;function S(be,H,x){let Y;const $e=setTimeout(()=>{Y?.(void 0),x?.()},H);return Promise.race([be.finally(()=>clearTimeout($e)),new Promise(ie=>Y=ie)])}e.$Pg=S;function w(be){return new Promise((H,x)=>{const Y=be();g(Y)?Y.then(H,x):H(Y)})}e.$Qg=w;class l{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(H){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=H,!this.b){const x=()=>{if(this.b=null,this.f)return;const Y=this.queue(this.d);return this.d=null,Y};this.b=new Promise(Y=>{this.a.then(x,x).then(Y)})}return new Promise((x,Y)=>{this.b.then(x,Y)})}return this.a=H(),new Promise((x,Y)=>{this.a.then($e=>{this.a=null,x($e)},$e=>{this.a=null,Y($e)})})}dispose(){this.f=!0}}e.$Rg=l;class o{constructor(){this.a=Promise.resolve(null)}queue(H){return this.a=this.a.then(()=>H(),()=>H())}}e.$Sg=o;class i{constructor(){this.a=new Map}queue(H,x){const $e=(this.a.get(H)??Promise.resolve()).catch(()=>{}).then(x).finally(()=>{this.a.get(H)===$e&&this.a.delete(H)});return this.a.set(H,$e),$e}}e.$Tg=i;const n=(be,H)=>{let x=!0;const Y=setTimeout(()=>{x=!1,H()},be);return{isTriggered:()=>x,dispose:()=>{clearTimeout(Y),x=!1}}},r=be=>{let H=!0;return queueMicrotask(()=>{H&&(H=!1,be())}),{isTriggered:()=>H,dispose:()=>{H=!1}}};class a{constructor(H){this.defaultDelay=H,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(H,x=this.defaultDelay){this.g=H,this.h(),this.b||(this.b=new Promise(($e,ie)=>{this.d=$e,this.f=ie}).then(()=>{if(this.b=null,this.d=null,this.g){const $e=this.g;return this.g=null,$e()}}));const Y=()=>{this.a=null,this.d?.(null)};return this.a=x===y.$Od?r(Y):n(x,Y),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Ug=a;class t{constructor(H){this.a=new a(H),this.b=new l}trigger(H,x){return this.a.trigger(()=>this.b.queue(H),x)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Vg=t;class s{constructor(){this.a=!1,this.b=new Promise((H,x)=>{this.d=H})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Wg=s;class d extends s{constructor(H){super(),this.f=setTimeout(()=>this.open(),H)}open(){clearTimeout(this.f),super.open()}}e.$Xg=d;function c(be,H){return H?new Promise((x,Y)=>{const $e=setTimeout(()=>{ie.dispose(),x()},be),ie=H.onCancellationRequested(()=>{clearTimeout($e),ie.dispose(),Y(new T.$4)})}):A(x=>c(be,x))}e.$Yg=c;function u(be,H=0,x){const Y=setTimeout(()=>{be(),x&&$e.dispose()},H),$e=(0,R.$Pc)(()=>{clearTimeout(Y),x?.deleteAndLeak($e)});return x?.add($e),$e}e.$Zg=u;function h(be){const H=[];let x=0;const Y=be.length;function $e(){return x<Y?be[x++]():null}function ie(fe){fe!=null&&H.push(fe);const te=$e();return te?te.then(ie):Promise.resolve(H)}return Promise.resolve(null).then(ie)}e.$1g=h;function E(be,H=Y=>!!Y,x=null){let Y=0;const $e=be.length,ie=()=>{if(Y>=$e)return Promise.resolve(x);const fe=be[Y++];return Promise.resolve(fe()).then(de=>H(de)?Promise.resolve(de):ie())};return ie()}e.$2g=E;function D(be,H=Y=>!!Y,x=null){if(be.length===0)return Promise.resolve(x);let Y=be.length;const $e=()=>{Y=-1;for(const ie of be)ie.cancel?.()};return new Promise((ie,fe)=>{for(const te of be)te.then(de=>{--Y>=0&&H(de)?($e(),ie(de)):Y===0&&ie(x)}).catch(de=>{--Y>=0&&($e(),fe(de))})})}e.$3g=D;class m{constructor(H){this.a=0,this.d=H,this.f=[],this.b=0,this.g=new f.$Rd}get onDrained(){return this.g.event}get size(){return this.a}queue(H){return this.a++,new Promise((x,Y)=>{this.f.push({factory:H,c:x,e:Y}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const H=this.f.shift();this.b++;const x=H.factory();x.then(H.c,H.e),x.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$4g=m;class p extends m{constructor(){super(1)}}e.$5g=p;class k{constructor(){this.a=new J,this.b=0}queue(H){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,H())):this.a.run(this.b++,H())}}e.$6g=k;class P{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const H=new oe;return this.b.add(H),H.p}g(){for(const[,H]of this.a)if(H.size>0)return!1;return!0}queueFor(H,x=L.$pg){const Y=x.getComparisonKey(H);let $e=this.a.get(Y);if(!$e){$e=new p;const ie=this.f++,fe=f.Event.once($e.onDrained)(()=>{$e?.dispose(),this.a.delete(Y),this.h(),this.d?.deleteAndDispose(ie),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$1c),this.d.set(ie,fe),this.a.set(Y,$e)}return $e}h(){this.g()&&this.j()}j(){for(const H of this.b)H.complete();this.b.clear()}dispose(){for(const[,H]of this.a)H.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$7g=P;class z{constructor(H,x){this.a=-1,typeof H=="function"&&typeof x=="number"&&this.setIfNotSet(H,x)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(H,x){this.cancel(),this.a=setTimeout(()=>{this.a=-1,H()},x)}setIfNotSet(H,x){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,H()},x))}}e.$8g=z;class j{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(H,x,Y=globalThis){this.cancel();const $e=Y.setInterval(()=>{H()},x);this.d=(0,R.$Pc)(()=>{Y.clearInterval($e),this.d=void 0})}dispose(){this.cancel()}}e.$9g=j;class M{constructor(H,x){this.b=-1,this.a=H,this.d=x,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(H=this.d){this.cancel(),this.b=setTimeout(this.f,H)}get delay(){return this.d}set delay(H){this.d=H}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$0g=M;class O{constructor(H,x){x%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.a=H,this.b=x,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(H=this.b){H%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(H/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$$g=O;class F extends M{constructor(H,x){super(H,x),this.j=[]}work(H){this.j.push(H),this.isScheduled()||this.schedule()}h(){const H=this.j;this.j=[],this.a?.(H)}dispose(){this.j=[],super.dispose()}}e.$_g=F;class N extends R.$Rc{constructor(H,x){super(),this.g=H,this.h=x,this.a=[],this.b=this.B(new R.$Sc),this.f=!1}get pending(){return this.a.length}work(H){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+H.length>this.g.maxBufferedWork)return!1}else if(this.pending+H.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const x of H)this.a.push(x);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new M(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$ah=N,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$ch=(be,H)=>{(0,b.$B)(()=>{if(x)return;const Y=Date.now()+15;H(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,Y-Date.now())}}))});let x=!1;return{dispose(){x||(x=!0)}}}:e.$ch=(be,H,x)=>{const Y=be.requestIdleCallback(H,typeof x=="number"?{timeout:x}:void 0);let $e=!1;return{dispose(){$e||($e=!0,be.cancelIdleCallback(Y))}}},e.$bh=be=>(0,e.$ch)(globalThis,be)}();class W{constructor(H,x){this.g=!1,this.d=()=>{try{this.j=x()}catch(Y){this.l=Y}finally{this.g=!0}},this.f=(0,e.$ch)(H,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$dh=W;class X extends W{constructor(H){super(globalThis,H)}}e.$eh=X;async function ce(be,H,x){let Y;for(let $e=0;$e<x;$e++)try{return await be()}catch(ie){Y=ie,await c(H)}throw Y}e.$fh=ce;class J{isRunning(H){return typeof H=="number"?this.a?.taskId===H:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(H,x,Y){return this.a={taskId:H,cancel:()=>Y?.(),promise:x},x.then(()=>this.d(H),()=>this.d(H)),x}d(H){this.a&&H===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const H=this.b;this.b=void 0,H.run().then(H.promiseResolve,H.promiseReject)}}queue(H){if(this.b)this.b.run=H;else{let x,Y;const $e=new Promise((ie,fe)=>{x=ie,Y=fe});this.b={run:H,promise:$e,promiseResolve:x,promiseReject:Y}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$gh=J;class Q{constructor(H,x=()=>Date.now()){this.d=H,this.f=x,this.a=0,this.b=0}increment(){const H=this.f();return H-this.a>this.d&&(this.a=H,this.b=0),this.b++,this.b}}e.$hh=Q;var G;(function(be){be[be.Resolved=0]="Resolved",be[be.Rejected=1]="Rejected"})(G||(G={}));class oe{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((H,x)=>{this.a=H,this.b=x})}complete(H){return new Promise(x=>{this.a(H),this.d={outcome:0,value:H},x()})}error(H){return new Promise(x=>{this.b(H),this.d={outcome:1,value:H},x()})}cancel(){return this.error(new T.$4)}}e.$ih=oe;var _;(function(be){async function H(Y){let $e;const ie=await Promise.all(Y.map(fe=>fe.then(te=>te,te=>{$e||($e=te)})));if(typeof $e<"u")throw $e;return ie}be.settled=H;function x(Y){return new Promise(async($e,ie)=>{try{await Y($e,ie)}catch(fe){ie(fe)}})}be.withAsyncBody=x})(_||(e.Promises=_={}));var Ee;(function(be){be[be.Initial=0]="Initial",be[be.DoneOK=1]="DoneOK",be[be.DoneError=2]="DoneError"})(Ee||(Ee={}));class he{static fromArray(H){return new he(x=>{x.emitMany(H)})}static fromPromise(H){return new he(async x=>{x.emitMany(await H)})}static fromPromises(H){return new he(async x=>{await Promise.all(H.map(async Y=>x.emitOne(await Y)))})}static merge(H){return new he(async x=>{await Promise.all(H.map(async Y=>{for await(const $e of Y)x.emitOne($e)}))})}static{this.EMPTY=he.fromArray([])}constructor(H){this.a=0,this.b=[],this.d=null,this.f=new f.$Rd,queueMicrotask(async()=>{const x={emitOne:Y=>this.g(Y),emitMany:Y=>this.h(Y),reject:Y=>this.k(Y)};try{await Promise.resolve(H(x)),this.j()}catch(Y){this.k(Y)}finally{x.emitOne=void 0,x.emitMany=void 0,x.reject=void 0}})}[Symbol.asyncIterator](){let H=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(H<this.b.length)return{done:!1,value:this.b[H++]};if(this.a===1)return{done:!0,value:void 0};await f.Event.toPromise(this.f.event)}while(!0)}}}static map(H,x){return new he(async Y=>{for await(const $e of H)Y.emitOne(x($e))})}map(H){return he.map(this,H)}static filter(H,x){return new he(async Y=>{for await(const $e of H)x($e)&&Y.emitOne($e)})}filter(H){return he.filter(this,H)}static coalesce(H){return he.filter(H,x=>!!x)}coalesce(){return he.coalesce(this)}static async toPromise(H){const x=[];for await(const Y of H)x.push(Y);return x}toPromise(){return he.toPromise(this)}g(H){this.a===0&&(this.b.push(H),this.f.fire())}h(H){this.a===0&&(this.b=this.b.concat(H),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(H){this.a===0&&(this.a=2,this.d=H,this.f.fire())}}e.$jh=he;class q extends he{constructor(H,x){super(x),this.l=H}cancel(){this.l.cancel()}}e.$kh=q;function U(be){const H=new C.$2d,x=be(H.token);return new q(H,async Y=>{const $e=H.token.onCancellationRequested(()=>{$e.dispose(),H.dispose(),Y.reject(new T.$4)});try{for await(const ie of x){if(H.token.isCancellationRequested)return;Y.emitOne(ie)}$e.dispose(),H.dispose()}catch(ie){$e.dispose(),H.dispose(),Y.reject(ie)}})}e.$lh=U;class ne{constructor(){this.a=new oe,this.b=new he(Y=>{if(H){Y.reject(H);return}return x&&Y.emitMany(x),this.d=$e=>Y.reject($e),this.f=$e=>Y.emitOne($e),this.a.p});let H,x;this.f=Y=>{x||(x=[]),x.push(Y)},this.d=Y=>{H||(H=Y)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(H){this.d(H),this.a.complete()}emitOne(H){this.f(H)}}e.$mh=ne}),define(ke[34],Se([1,0,19,12,33,28,16,11,13]),function(me,e,C,T,f,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=void 0;function g(){return Object.create(null)}e.$xj=g,e.$yj="**",e.$zj="/";const A="[/\\\\]",I="[^/\\\\]",$=/\//g;function v(ce,J){switch(ce){case 0:return"";case 1:return`${I}*?`;default:return`(?:${A}|${I}+${A}${J?`|${A}${I}+`:""})*?`}}function S(ce,J){if(!ce)return[];const Q=[];let G=!1,oe=!1,_="";for(const Ee of ce){switch(Ee){case J:if(!G&&!oe){Q.push(_),_="";continue}break;case"{":G=!0;break;case"}":G=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}_+=Ee}return _&&Q.push(_),Q}e.$Aj=S;function w(ce){if(!ce)return"";let J="";const Q=S(ce,e.$zj);if(Q.every(G=>G===e.$yj))J=".*";else{let G=!1;Q.forEach((oe,_)=>{if(oe===e.$yj){if(G)return;J+=v(2,_===Q.length-1)}else{let Ee=!1,he="",q=!1,U="";for(const ne of oe){if(ne!=="}"&&Ee){he+=ne;continue}if(q&&(ne!=="]"||!U)){let be;ne==="-"?be=ne:(ne==="^"||ne==="!")&&!U?be="^":ne===e.$zj?be="":be=(0,y.$Je)(ne),U+=be;continue}switch(ne){case"{":Ee=!0;continue;case"[":q=!0;continue;case"}":{const H=`(?:${S(he,",").map(x=>w(x)).join("|")})`;J+=H,Ee=!1,he="";break}case"]":{J+="["+U+"]",q=!1,U="";break}case"?":J+=I;continue;case"*":J+=v(1);continue;default:J+=(0,y.$Je)(ne)}}_<Q.length-1&&(Q[_+1]!==e.$yj||_+2<Q.length)&&(J+=A)}G=oe===e.$yj})}return J}const l=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.$Cc(1e4),s=function(){return!1},d=function(){return null};function c(ce,J){if(!ce)return d;let Q;typeof ce!="string"?Q=ce.pattern:Q=ce,Q=Q.trim();const G=`${Q}_${!!J.trimForExclusions}`;let oe=t.get(G);if(oe)return u(oe,ce);let _;return l.test(Q)?oe=E(Q.substr(4),Q):(_=o.exec(h(Q,J)))?oe=D(_[1],Q):(J.trimForExclusions?n:i).test(Q)?oe=m(Q,J):(_=r.exec(h(Q,J)))?oe=p(_[1].substr(1),Q,!0):(_=a.exec(h(Q,J)))?oe=p(_[1],Q,!1):oe=k(Q),t.set(G,oe),u(oe,ce)}function u(ce,J){if(typeof J=="string")return ce;const Q=function(G,oe){return(0,f.$2f)(G,J.base,!b.$k)?ce((0,y.$Ne)(G.substr(J.base.length),L.sep),oe):null};return Q.allBasenames=ce.allBasenames,Q.allPaths=ce.allPaths,Q.basenames=ce.basenames,Q.patterns=ce.patterns,Q}function h(ce,J){return J.trimForExclusions&&ce.endsWith("/**")?ce.substr(0,ce.length-2):ce}function E(ce,J){return function(Q,G){return typeof Q=="string"&&Q.endsWith(ce)?J:null}}function D(ce,J){const Q=`/${ce}`,G=`\\${ce}`,oe=function(Ee,he){return typeof Ee!="string"?null:he?he===ce?J:null:Ee===ce||Ee.endsWith(Q)||Ee.endsWith(G)?J:null},_=[ce];return oe.basenames=_,oe.patterns=[J],oe.allBasenames=_,oe}function m(ce,J){const Q=W(ce.slice(1,-1).split(",").map(he=>c(he,J)).filter(he=>he!==d),ce),G=Q.length;if(!G)return d;if(G===1)return Q[0];const oe=function(he,q){for(let U=0,ne=Q.length;U<ne;U++)if(Q[U](he,q))return ce;return null},_=Q.find(he=>!!he.allBasenames);_&&(oe.allBasenames=_.allBasenames);const Ee=Q.reduce((he,q)=>q.allPaths?he.concat(q.allPaths):he,[]);return Ee.length&&(oe.allPaths=Ee),oe}function p(ce,J,Q){const G=L.sep===L.$fc.sep,oe=G?ce:ce.replace($,L.sep),_=L.sep+oe,Ee=L.$fc.sep+ce;let he;return Q?he=function(q,U){return typeof q=="string"&&(q===oe||q.endsWith(_)||!G&&(q===ce||q.endsWith(Ee)))?J:null}:he=function(q,U){return typeof q=="string"&&(q===oe||!G&&q===ce)?J:null},he.allPaths=[(Q?"*/":"./")+ce],he}function k(ce){try{const J=new RegExp(`^${w(ce)}$`);return function(Q){return J.lastIndex=0,typeof Q=="string"&&J.test(Q)?ce:null}}catch{return d}}function P(ce,J,Q){return!ce||typeof J!="string"?!1:z(ce)(J,void 0,Q)}e.$Bj=P;function z(ce,J={}){if(!ce)return s;if(typeof ce=="string"||j(ce)){const Q=c(ce,J);if(Q===d)return s;const G=function(oe,_){return!!Q(oe,_)};return Q.allBasenames&&(G.allBasenames=Q.allBasenames),Q.allPaths&&(G.allPaths=Q.allPaths),G}return F(ce,J)}e.$Cj=z;function j(ce){const J=ce;return J?typeof J.base=="string"&&typeof J.pattern=="string":!1}e.$Dj=j;function M(ce){return ce.allBasenames||[]}e.$Ej=M;function O(ce){return ce.allPaths||[]}e.$Fj=O;function F(ce,J){const Q=W(Object.getOwnPropertyNames(ce).map(he=>N(he,ce[he],J)).filter(he=>he!==d)),G=Q.length;if(!G)return d;if(!Q.some(he=>!!he.requiresSiblings)){if(G===1)return Q[0];const he=function(ne,be){let H;for(let x=0,Y=Q.length;x<Y;x++){const $e=Q[x](ne,be);if(typeof $e=="string")return $e;(0,T.$Kg)($e)&&(H||(H=[]),H.push($e))}return H?(async()=>{for(const x of H){const Y=await x;if(typeof Y=="string")return Y}return null})():null},q=Q.find(ne=>!!ne.allBasenames);q&&(he.allBasenames=q.allBasenames);const U=Q.reduce((ne,be)=>be.allPaths?ne.concat(be.allPaths):ne,[]);return U.length&&(he.allPaths=U),he}const oe=function(he,q,U){let ne,be;for(let H=0,x=Q.length;H<x;H++){const Y=Q[H];Y.requiresSiblings&&U&&(q||(q=(0,L.$mc)(he)),ne||(ne=q.substr(0,q.length-(0,L.$nc)(he).length)));const $e=Y(he,q,ne,U);if(typeof $e=="string")return $e;(0,T.$Kg)($e)&&(be||(be=[]),be.push($e))}return be?(async()=>{for(const H of be){const x=await H;if(typeof x=="string")return x}return null})():null},_=Q.find(he=>!!he.allBasenames);_&&(oe.allBasenames=_.allBasenames);const Ee=Q.reduce((he,q)=>q.allPaths?he.concat(q.allPaths):he,[]);return Ee.length&&(oe.allPaths=Ee),oe}function N(ce,J,Q){if(J===!1)return d;const G=c(ce,Q);if(G===d)return d;if(typeof J=="boolean")return G;if(J){const oe=J.when;if(typeof oe=="string"){const _=(Ee,he,q,U)=>{if(!U||!G(Ee,he))return null;const ne=oe.replace("$(basename)",()=>q),be=U(ne);return(0,T.$Kg)(be)?be.then(H=>H?ce:null):be?ce:null};return _.requiresSiblings=!0,_}}return G}function W(ce,J){const Q=ce.filter(he=>!!he.basenames);if(Q.length<2)return ce;const G=Q.reduce((he,q)=>{const U=q.basenames;return U?he.concat(U):he},[]);let oe;if(J){oe=[];for(let he=0,q=G.length;he<q;he++)oe.push(J)}else oe=Q.reduce((he,q)=>{const U=q.patterns;return U?he.concat(U):he},[]);const _=function(he,q){if(typeof he!="string")return null;if(!q){let ne;for(ne=he.length;ne>0;ne--){const be=he.charCodeAt(ne-1);if(be===47||be===92)break}q=he.substr(ne)}const U=G.indexOf(q);return U!==-1?oe[U]:null};_.basenames=G,_.patterns=oe,_.allBasenames=G;const Ee=ce.filter(he=>!he.basenames);return Ee.push(_),Ee}function X(ce,J){return(0,C.$tb)(ce,J,(Q,G)=>typeof Q=="string"&&typeof G=="string"?Q===G:typeof Q!="string"&&typeof G!="string"?Q.base===G.base&&Q.pattern===G.pattern:!1)}e.$Gj=X}),define(ke[80],Se([1,0,8,164,23,13,2]),function(me,e,C,T,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.MarkdownStringTextNewlineStyle=void 0;var b;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(b||(e.MarkdownStringTextNewlineStyle=b={}));class y{constructor(o="",i=!1){if(this.value=o,typeof this.value!="string")throw(0,C.$6)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(o,i=0){return this.value+=$(this.supportThemeIcons?(0,T.$3j)(o):o).replace(/([ \t]+)/g,(n,r)=>"&nbsp;".repeat(r.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(o){return this.value+=o,this}appendCodeblock(o,i){return this.value+="\n```",this.value+=o,this.value+=`
`,this.value+=i,this.value+="\n```\n",this}appendLink(o,i,n){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(o),")"),n&&(this.value+=` "${this.c(this.c(n,'"'),")")}"`),this.value+=")",this}c(o,i){const n=new RegExp((0,R.$Je)(i),"g");return o.replace(n,(r,a)=>o.charAt(a-1)!=="\\"?`\\${r}`:r)}}e.$9j=y;function g(l){return A(l)?!l.value:Array.isArray(l)?l.every(g):!0}e.$0j=g;function A(l){return l instanceof y?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||typeof l.isTrusted=="object"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}e.$$j=A;function I(l,o){return l===o?!0:!l||!o?!1:l.value===o.value&&l.isTrusted===o.isTrusted&&l.supportThemeIcons===o.supportThemeIcons&&l.supportHtml===o.supportHtml&&(l.baseUri===o.baseUri||!!l.baseUri&&!!o.baseUri&&(0,f.$sg)(L.URI.from(l.baseUri),L.URI.from(o.baseUri)))}e.$_j=I;function $(l){return l.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$ak=$;function v(l){return l.replace(/"/g,"&quot;")}e.$bk=v;function S(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$ck=S;function w(l){const o=[],i=l.split("|").map(r=>r.trim());l=i[0];const n=i[1];if(n){const r=/height=(\d+)/.exec(n),a=/width=(\d+)/.exec(n),t=r?r[1]:"",s=a?a[1]:"",d=isFinite(parseInt(s)),c=isFinite(parseInt(t));d&&o.push(`width="${s}"`),c&&o.push(`height="${t}"`)}return{href:l,dimensions:o}}e.$dk=w}),define(ke[102],Se([1,0,19,33,16,11,23,13]),function(me,e,C,T,f,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hv=e.$Gv=e.$Fv=e.$Ev=e.$Dv=e.$Cv=e.$Bv=e.$Av=e.$zv=e.$yv=void 0;function y(c,u){const{os:h,tildify:E,relative:D}=u;if(D){const k=g(c,D,h);if(typeof k=="string")return k}let m=c.fsPath;if(h===1&&!R.$i?m=m.replace(/\//g,"\\"):h!==1&&R.$i&&(m=m.replace(/\\/g,"/")),h!==1&&E?.userHome){const k=E.userHome.fsPath;let P;c.scheme!==E.userHome.scheme&&c.path[0]===f.$fc.sep&&c.path[1]!==f.$fc.sep?P=E.userHome.with({path:c.path}).fsPath:P=m,m=$(P,k,h)}return(h===1?f.$ec:f.$fc).normalize(A(m,h===1))}e.$yv=y;function g(c,u,h){const E=h===1?f.$ec:f.$fc,D=h===3?L.$pg:L.$rg,m=u.getWorkspace(),p=(0,C.$Nb)(m.folders);if(!p)return;c.scheme!==p.uri.scheme&&c.path[0]===f.$fc.sep&&c.path[1]!==f.$fc.sep&&(c=p.uri.with({path:c.path}));const k=u.getWorkspaceFolder(c);if(!k)return;let P;if(D.isEqual(k.uri,c)?P="":P=D.relativePath(k.uri,c)??"",P&&(P=E.normalize(P)),m.folders.length>1&&!u.noPrefix){const z=k.name?k.name:D.basenameOrAuthority(k.uri);P=P?`${z} \u2022 ${P}`:z}return P}function A(c,u=R.$i){return(0,T.$6f)(c,u)?c.charAt(0).toUpperCase()+c.slice(1):c}e.$zv=A;let I=Object.create(null);function $(c,u,h=R.OS){if(h===1||!c||!u)return c;let E=I.original===u?I.normalized:void 0;E||(E=u,R.$i&&(E=(0,T.$Vf)(E)),E=`${(0,b.$Oe)(E,f.$fc.sep)}${f.$fc.sep}`,I={original:u,normalized:E});let D=c;return R.$i&&(D=(0,T.$Vf)(D)),(h===3?D.startsWith(E):(0,b.$7e)(D,E))?`~/${D.substr(E.length)}`:c}e.$Av=$;function v(c,u){return c.replace(/^~($|\/|\\)/,`${u}$1`)}e.$Bv=v;const S="\u2026",w="\\\\",l="~";function o(c,u=f.sep){const h=new Array(c.length);let E=!1;for(let D=0;D<c.length;D++){const m=c[D];if(m===""){h[D]=`.${u}`;continue}if(!m){h[D]=m;continue}E=!0;let p="",k=m;k.indexOf(w)===0?(p=k.substr(0,k.indexOf(w)+w.length),k=k.substr(k.indexOf(w)+w.length)):k.indexOf(u)===0?(p=k.substr(0,k.indexOf(u)+u.length),k=k.substr(k.indexOf(u)+u.length)):k.indexOf(l)===0&&(p=k.substr(0,k.indexOf(l)+l.length),k=k.substr(k.indexOf(l)+l.length));const P=k.split(u);for(let z=1;E&&z<=P.length;z++)for(let j=P.length-z;E&&j>=0;j--){E=!1;let M=P.slice(j,j+z).join(u);for(let O=0;!E&&O<c.length;O++)if(O!==D&&c[O]&&c[O].indexOf(M)>-1){const F=j+z===P.length,N=j>0&&c[O].indexOf(u)>-1?u+M:M,W=c[O].endsWith(N);E=!F||W}if(!E){let O="";(P[0].endsWith(":")||p!=="")&&(j===1&&(j=0,z++,M=P[0]+u+M),j>0&&(O=P[0]+u),O=p+O),j>0&&(O=O+S+u),O=O+M,j+z<P.length&&(O=O+u+S),h[D]=O}}E&&(h[D]=m)}return h}e.$Cv=o;var i;(function(c){c[c.TEXT=0]="TEXT",c[c.VARIABLE=1]="VARIABLE",c[c.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function n(c,u=Object.create(null)){const h=[];let E=!1,D="";for(const m of c)if(m==="$"||E&&m==="{")D&&h.push({value:D,type:i.TEXT}),D="",E=!0;else if(m==="}"&&E){const p=u[D];if(typeof p=="string")p.length&&h.push({value:p,type:i.VARIABLE});else if(p){const k=h[h.length-1];(!k||k.type!==i.SEPARATOR)&&h.push({value:p.label,type:i.SEPARATOR})}D="",E=!1}else D+=m;return D&&!E&&h.push({value:D,type:i.TEXT}),h.filter((m,p)=>{if(m.type===i.SEPARATOR){const k=h[p-1],P=h[p+1];return[k,P].every(z=>z&&(z.type===i.VARIABLE||z.type===i.TEXT)&&z.value.length>0)}return!0}).map(m=>m.value).join("")}e.$Dv=n;function r(c,u){return R.$j||u?c.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$j?"&":"&&"):c.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.$Ev=r;function a(c,u){return R.$j||u?c.replace(/\(&&\w\)|&&/g,""):R.$i?c.replace(/&&|&/g,h=>h==="&"?"&&":"&"):c.replace(/&&/g,"_")}e.$Fv=a;function t(c){return c.replace(/&/g,"&&")}e.$Gv=t;function s(c){if(c.endsWith("]")){const u=c.lastIndexOf(" [",c.length-2);if(u!==-1){const h=d(c.substring(0,u));return{name:h.name,parentPath:h.parentPath+c.substring(u)}}}return d(c)}e.$Hv=s;function d(c){const u=c.indexOf("/")!==-1?f.$fc:f.$ec,h=u.basename(c),E=u.dirname(c);return h.length?{name:h,parentPath:E}:{name:E,parentPath:""}}}),define(ke[131],Se([1,0,22,2]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=e.$Um=e.$Tm=e.$Sm=e.$Rm=void 0;function f(I){return I.toJSON()}class R{constructor($){this.a=$}transformIncoming($){const v=this.a.transformIncoming($);return v===$?$:f(T.URI.from(v))}transformOutgoing($){const v=this.a.transformOutgoing($);return v===$?$:f(T.URI.from(v))}transformOutgoingURI($){const v=this.a.transformOutgoing($);return v===$?$:T.URI.from(v)}transformOutgoingScheme($){return this.a.transformOutgoingScheme($)}}e.$Rm=R,e.$Sm=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function L(I,$,v){if(!I||v>200)return null;if(typeof I=="object"){if(I instanceof T.URI)return $.transformOutgoing(I);for(const S in I)if(Object.hasOwnProperty.call(I,S)){const w=L(I[S],$,v+1);w!==null&&(I[S]=w)}}return null}function b(I,$){const v=L(I,$,0);return v===null?I:v}e.$Tm=b;function y(I,$,v,S){if(!I||S>200)return null;if(typeof I=="object"){if(I.$mid===1)return v?T.URI.revive($.transformIncoming(I)):$.transformIncoming(I);if(I instanceof C.$fe)return null;for(const w in I)if(Object.hasOwnProperty.call(I,w)){const l=y(I[w],$,v,S+1);l!==null&&(I[w]=l)}}return null}function g(I,$){const v=y(I,$,!1,0);return v===null?I:v}e.$Um=g;function A(I,$){const v=y(I,$,!0,0);return v===null?I:v}e.$Vm=A}),define(ke[30],Se([1,0,55,63,385,12,33,76,16,11,23,2]),function(me,e,C,T,f,R,L,b,y,g,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var $;(function(N){N[N.UNLINK=0]="UNLINK",N[N.MOVE=1]="MOVE"})($||(e.RimRafMode=$={}));async function v(N,W=$.UNLINK,X){if((0,L.$5f)(N))throw new Error("rimraf - will refuse to recursively delete root");return W===$.UNLINK?w(N):S(N,X)}async function S(N,W=(0,L.$0f)((0,T.tmpdir)())){try{try{await C.promises.rename(N,W)}catch(X){return X.code==="ENOENT"?void 0:w(N)}w(W).catch(X=>{})}catch(X){if(X.code!=="ENOENT")throw X}}async function w(N){return(0,f.promisify)(C.rm)(N,{recursive:!0,force:!0,maxRetries:3})}function l(N){if((0,L.$5f)(N))throw new Error("rimraf - will refuse to recursively delete root");C.rmSync(N,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=l;async function o(N,W){return r(await(W?i(N):(0,f.promisify)(C.readdir)(N)))}async function i(N){try{return await(0,f.promisify)(C.readdir)(N,{withFileTypes:!0})}catch(ce){console.warn("[node.js fs] readdir with filetypes failed with error: ",ce)}const W=[],X=await o(N);for(const ce of X){let J=!1,Q=!1,G=!1;try{const oe=await e.Promises.lstat((0,y.$ic)(N,ce));J=oe.isFile(),Q=oe.isDirectory(),G=oe.isSymbolicLink()}catch(oe){console.warn("[node.js fs] unexpected error from lstat after readdir: ",oe)}W.push({name:ce,isFile:()=>J,isDirectory:()=>Q,isSymbolicLink:()=>G})}return W}function n(N){return r(C.readdirSync(N))}e.readdirSync=n;function r(N){return N.map(W=>typeof W=="string"?g.$j?(0,b.$ul)(W):W:(W.name=g.$j?(0,b.$ul)(W.name):W.name,W))}async function a(N){const W=await o(N),X=[];for(const ce of W)await s.existsDirectory((0,y.$ic)(N,ce))&&X.push(ce);return X}function t(N,W=1e3){return new Promise(X=>{let ce=!1;const J=setInterval(()=>{ce||(ce=!0,C.access(N,Q=>{ce=!1,Q&&(clearInterval(J),X(void 0))}))},W)})}e.whenDeleted=t;var s;(function(N){async function W(J){let Q;try{if(Q=await e.Promises.lstat(J),!Q.isSymbolicLink())return{stat:Q}}catch{}try{return{stat:await e.Promises.stat(J),symbolicLink:Q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(G){if(G.code==="ENOENT"&&Q)return{stat:Q,symbolicLink:{dangling:!0}};if(g.$i&&G.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(J)),symbolicLink:{dangling:!1}}}catch(oe){if(oe.code==="ENOENT"&&Q)return{stat:Q,symbolicLink:{dangling:!0}};throw oe}throw G}}N.stat=W;async function X(J){try{const{stat:Q,symbolicLink:G}=await N.stat(J);return Q.isFile()&&G?.dangling!==!0}catch{}return!1}N.existsFile=X;async function ce(J){try{const{stat:Q,symbolicLink:G}=await N.stat(J);return Q.isDirectory()&&G?.dangling!==!0}catch{}return!1}N.existsDirectory=ce})(s||(e.SymlinkSupport=s={}));const d=new R.$7g;function c(N,W,X){return d.queueFor(I.URI.file(N),A.$qg).queue(()=>{const ce=m(X);return new Promise((J,Q)=>E(N,W,ce,G=>G?Q(G):J()))})}let u=!0;function h(N){u=N}e.configureFlushOnWrite=h;function E(N,W,X,ce){if(!u)return C.writeFile(N,W,{mode:X.mode,flag:X.flag},ce);C.open(N,X.flag,X.mode,(J,Q)=>{if(J)return ce(J);C.writeFile(Q,W,G=>{if(G)return C.close(Q,()=>ce(G));C.fdatasync(Q,oe=>(oe&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",oe),h(!1)),C.close(Q,_=>ce(_))))})})}function D(N,W,X){const ce=m(X);if(!u)return C.writeFileSync(N,W,{mode:ce.mode,flag:ce.flag});const J=C.openSync(N,ce.flag,ce.mode);try{C.writeFileSync(J,W);try{C.fdatasyncSync(J)}catch(Q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Q),h(!1)}}finally{C.closeSync(J)}}e.writeFileSync=D;function m(N){return N?{mode:typeof N.mode=="number"?N.mode:438,flag:typeof N.flag=="string"?N.flag:"w"}:{mode:438,flag:"w"}}async function p(N,W,X=6e4){if(N!==W)try{g.$i&&typeof X=="number"?await k(N,W,Date.now(),X):await(0,f.promisify)(C.rename)(N,W)}catch(ce){if(N.toLowerCase()!==W.toLowerCase()&&ce.code==="EXDEV"||N.endsWith("."))await P(N,W,{preserveSymlinks:!1}),await v(N,$.MOVE);else throw ce}}async function k(N,W,X,ce,J=0){try{return await(0,f.promisify)(C.rename)(N,W)}catch(Q){if(Q.code!=="EACCES"&&Q.code!=="EPERM"&&Q.code!=="EBUSY")throw Q;if(Date.now()-X>=ce)throw console.error(`[node.js fs] rename failed after ${J} retries with error: ${Q}`),Q;if(J===0){let G=!1;try{const{stat:oe}=await s.stat(W);oe.isFile()||(G=!0)}catch{}if(G)throw Q}return await(0,R.$Yg)(Math.min(100,J*10)),k(N,W,X,ce,J+1)}}async function P(N,W,X){return j(N,W,{root:{source:N,target:W},options:X,handledSourcePaths:new Set})}const z=511;async function j(N,W,X){if(X.handledSourcePaths.has(N))return;X.handledSourcePaths.add(N);const{stat:ce,symbolicLink:J}=await s.stat(N);if(J){if(X.options.preserveSymlinks)try{return await F(N,W,X)}catch(Q){console.warn("[node.js fs] copy of symlink failed: ",Q)}if(J.dangling)return}return ce.isDirectory()?M(N,W,ce.mode&z,X):O(N,W,ce.mode&z)}async function M(N,W,X,ce){await e.Promises.mkdir(W,{recursive:!0,mode:X});const J=await o(N);for(const Q of J)await j((0,y.$ic)(N,Q),(0,y.$ic)(W,Q),ce)}async function O(N,W,X){await e.Promises.copyFile(N,W),await e.Promises.chmod(W,X)}async function F(N,W,X){let ce=await e.Promises.readlink(N);(0,L.$2f)(ce,X.root.source,!g.$k)&&(ce=(0,y.$ic)(X.root.target,ce.substr(X.root.source.length+1))),await e.Promises.symlink(ce,W)}e.Promises=new class{get access(){return(0,f.promisify)(C.access)}get stat(){return(0,f.promisify)(C.stat)}get lstat(){return(0,f.promisify)(C.lstat)}get utimes(){return(0,f.promisify)(C.utimes)}get read(){return(N,W,X,ce,J)=>new Promise((Q,G)=>{C.read(N,W,X,ce,J,(oe,_,Ee)=>oe?G(oe):Q({bytesRead:_,buffer:Ee}))})}get readFile(){return(0,f.promisify)(C.readFile)}get write(){return(N,W,X,ce,J)=>new Promise((Q,G)=>{C.write(N,W,X,ce,J,(oe,_,Ee)=>oe?G(oe):Q({bytesWritten:_,buffer:Ee}))})}get appendFile(){return(0,f.promisify)(C.appendFile)}get fdatasync(){return(0,f.promisify)(C.fdatasync)}get truncate(){return(0,f.promisify)(C.truncate)}get copyFile(){return(0,f.promisify)(C.copyFile)}get open(){return(0,f.promisify)(C.open)}get close(){return(0,f.promisify)(C.close)}get symlink(){return(0,f.promisify)(C.symlink)}get readlink(){return(0,f.promisify)(C.readlink)}get chmod(){return(0,f.promisify)(C.chmod)}get mkdir(){return(0,f.promisify)(C.mkdir)}get unlink(){return(0,f.promisify)(C.unlink)}get rmdir(){return(0,f.promisify)(C.rmdir)}get realpath(){return(0,f.promisify)(C.realpath)}async exists(N){try{return await e.Promises.access(N),!0}catch{return!1}}get readdir(){return o}get readDirsInDir(){return a}get writeFile(){return c}get rm(){return v}get rename(){return p}get copy(){return P}}}),define(ke[103],Se([1,0,55,16,11,13,30]),function(me,e,C,T,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=e.$aq=e.$_p=e.$$p=void 0;function b($){if(f.$k)return $;const v=(0,T.$lc)($);if($===v)return $;const S=((0,T.$mc)($)||$).toLowerCase();try{const l=(0,L.readdirSync)(v).filter(o=>o.toLowerCase()===S);if(l.length===1){const o=b(v);if(o)return(0,T.$ic)(o,l[0])}else if(l.length>1){const o=l.indexOf(S);if(o>=0){const i=b(v);if(i)return(0,T.$ic)(i,l[o])}}}catch{}return null}e.$$p=b;async function y($){if(f.$k)return $;const v=(0,T.$lc)($);if($===v)return $;const S=((0,T.$mc)($)||$).toLowerCase();try{const l=(await L.Promises.readdir(v)).filter(o=>o.toLowerCase()===S);if(l.length===1){const o=await y(v);if(o)return(0,T.$ic)(o,l[0])}else if(l.length>1){const o=l.indexOf(S);if(o>=0){const i=await y(v);if(i)return(0,T.$ic)(i,l[o])}}}catch{}return null}e.$_p=y;async function g($){try{return await L.Promises.realpath($)}catch{const S=I($);return await L.Promises.access(S,C.constants.R_OK),S}}e.$aq=g;function A($){try{return C.realpathSync($)}catch{const S=I($);return C.accessSync(S,C.constants.R_OK),S}}e.$bq=A;function I($){return(0,R.$Oe)((0,T.$gc)($),T.sep)}}),define(ke[104],Se([1,0,16,11,49,101,18,30]),function(me,e,C,T,f,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Il=e.$Hl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function y(I=f.env){return I.comspec||"cmd.exe"}e.$Hl=y;function g(I){let $=[],v=!1;const S=function(w){if(v){$.push(w);return}(!I.send(w,o=>{if(o&&console.error(o),v=!1,$.length>0){const i=$.slice(0);$=[],i.forEach(n=>S(n))}})||T.$i)&&(v=!0)};return{send:S}}e.$Il=g;var A;(function(I){async function $(v,S,w){if(C.$hc(v))return v;if(S===void 0&&(S=f.cwd()),C.$lc(v)!=="."||(w===void 0&&L.$Cf(f.env.PATH)&&(w=f.env.PATH.split(C.$sc)),w===void 0||w.length===0))return C.$ic(S,v);async function o(i){if(await b.Promises.exists(i)){let n;try{n=await b.Promises.stat(i)}catch(r){r.message.startsWith("EACCES")&&(n=await b.Promises.lstat(i))}return n?!n.isDirectory():!1}return!1}for(const i of w){let n;if(C.$hc(i)?n=C.$ic(i,v):n=C.$ic(S,i,v),await o(n))return n;let r=n+".com";if(await o(r)||(r=n+".exe",await o(r)))return r}return C.$ic(S,v)}I.findExecutable=$})(A||(e.win32=A={}))});var He=this&&this.__decorate||function(me,e,C,T){var f=arguments.length,R=f<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,C):T,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(me,e,C,T);else for(var b=me.length-1;b>=0;b--)(L=me[b])&&(R=(f<3?L(R):f>3?L(e,C,R):L(e,C))||R);return f>3&&R&&Object.defineProperty(e,C,R),R};define(ke[81],Se([1,0,19,12,22,21,59,8,4,3,54,13,18]),function(me,e,C,T,f,R,L,b,y,g,A,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eh=e.ProxyChannel=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.RequestInitiator=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=void 0;var v;(function(J){J[J.Promise=100]="Promise",J[J.PromiseCancel=101]="PromiseCancel",J[J.EventListen=102]="EventListen",J[J.EventDispose=103]="EventDispose"})(v||(v={}));function S(J){switch(J){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(J){J[J.Initialize=200]="Initialize",J[J.PromiseSuccess=201]="PromiseSuccess",J[J.PromiseError=202]="PromiseError",J[J.PromiseErrorObj=203]="PromiseErrorObj",J[J.EventFire=204]="EventFire"})(w||(w={}));function l(J){switch(J){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var o;(function(J){J[J.Uninitialized=0]="Uninitialized",J[J.Idle=1]="Idle"})(o||(o={}));function i(J){let Q=0;for(let G=0;;G+=7){const oe=J.read(1);if(Q|=(oe.buffer[0]&127)<<G,!(oe.buffer[0]&128))return Q}}const n=d(0);function r(J,Q){if(Q===0){J.write(n);return}let G=0;for(let _=Q;_!==0;_=_>>>7)G++;const oe=f.$fe.alloc(G);for(let _=0;Q!==0;_++)oe.buffer[_]=Q&127,Q=Q>>>7,Q>0&&(oe.buffer[_]|=128);J.write(oe)}class a{constructor(Q){this.b=Q,this.a=0}read(Q){const G=this.b.slice(this.a,this.a+Q);return this.a+=G.byteLength,G}}e.$th=a;class t{constructor(){this.a=[]}get buffer(){return f.$fe.concat(this.a)}write(Q){this.a.push(Q)}}e.$uh=t;var s;(function(J){J[J.Undefined=0]="Undefined",J[J.String=1]="String",J[J.Buffer=2]="Buffer",J[J.VSBuffer=3]="VSBuffer",J[J.Array=4]="Array",J[J.Object=5]="Object",J[J.Int=6]="Int"})(s||(s={}));function d(J){const Q=f.$fe.alloc(1);return Q.writeUInt8(J,0),Q}const c={Undefined:d(s.Undefined),String:d(s.String),Buffer:d(s.Buffer),VSBuffer:d(s.VSBuffer),Array:d(s.Array),Object:d(s.Object),Uint:d(s.Int)},u=typeof Buffer<"u";function h(J,Q){if(typeof Q>"u")J.write(c.Undefined);else if(typeof Q=="string"){const G=f.$fe.fromString(Q);J.write(c.String),r(J,G.byteLength),J.write(G)}else if(u&&Buffer.isBuffer(Q)){const G=f.$fe.wrap(Q);J.write(c.Buffer),r(J,G.byteLength),J.write(G)}else if(Q instanceof f.$fe)J.write(c.VSBuffer),r(J,Q.byteLength),J.write(Q);else if(Array.isArray(Q)){J.write(c.Array),r(J,Q.length);for(const G of Q)h(J,G)}else if(typeof Q=="number"&&(Q|0)===Q)J.write(c.Uint),r(J,Q);else{const G=f.$fe.fromString(JSON.stringify(Q));J.write(c.Object),r(J,G.byteLength),J.write(G)}}e.$vh=h;function E(J){switch(J.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return J.read(i(J)).toString();case s.Buffer:return J.read(i(J)).buffer;case s.VSBuffer:return J.read(i(J));case s.Array:{const G=i(J),oe=[];for(let _=0;_<G;_++)oe.push(E(J));return oe}case s.Object:return JSON.parse(J.read(i(J)).toString());case s.Int:return i(J)}}e.$wh=E;class D{constructor(Q,G,oe=null,_=1e3){this.h=Q,this.j=G,this.k=oe,this.l=_,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(Ee=>this.q(Ee)),this.m({type:200})}registerChannel(Q,G){this.b.set(Q,G),setTimeout(()=>this.w(Q),0)}m(Q){switch(Q.type){case 200:{const G=this.o([Q.type]);this.k?.logOutgoing(G,0,1,l(Q.type));return}case 201:case 202:case 204:case 203:{const G=this.o([Q.type,Q.id],Q.data);this.k?.logOutgoing(G,Q.id,1,l(Q.type),Q.data);return}}}o(Q,G=void 0){const oe=new t;return h(oe,Q),h(oe,G),this.p(oe.buffer)}p(Q){try{return this.h.send(Q),Q.byteLength}catch{return 0}}q(Q){const G=new a(Q),oe=E(G),_=E(G),Ee=oe[0];switch(Ee){case 100:return this.k?.logIncoming(Q.byteLength,oe[1],1,`${S(Ee)}: ${oe[2]}.${oe[3]}`,_),this.s({type:Ee,id:oe[1],channelName:oe[2],name:oe[3],arg:_});case 102:return this.k?.logIncoming(Q.byteLength,oe[1],1,`${S(Ee)}: ${oe[2]}.${oe[3]}`,_),this.t({type:Ee,id:oe[1],channelName:oe[2],name:oe[3],arg:_});case 101:return this.k?.logIncoming(Q.byteLength,oe[1],1,`${S(Ee)}`),this.u({type:Ee,id:oe[1]});case 103:return this.k?.logIncoming(Q.byteLength,oe[1],1,`${S(Ee)}`),this.u({type:Ee,id:oe[1]})}}s(Q){const G=this.b.get(Q.channelName);if(!G){this.v(Q);return}const oe=new R.$2d;let _;try{_=G.call(this.j,Q.name,Q.arg,oe.token)}catch(q){_=Promise.reject(q)}const Ee=Q.id;_.then(q=>{this.m({id:Ee,data:q,type:201})},q=>{q instanceof Error?this.m({id:Ee,data:{message:q.message,name:q.name,stack:q.stack?q.stack.split?q.stack.split(`
`):q.stack:void 0},type:202}):this.m({id:Ee,data:q,type:203})}).finally(()=>{he.dispose(),this.d.delete(Q.id)});const he=(0,g.$Pc)(()=>oe.cancel());this.d.set(Q.id,he)}t(Q){const G=this.b.get(Q.channelName);if(!G){this.v(Q);return}const oe=Q.id,Ee=G.listen(this.j,Q.name,Q.arg)(he=>this.m({id:oe,data:he,type:204}));this.d.set(Q.id,Ee)}u(Q){const G=this.d.get(Q.id);G&&(G.dispose(),this.d.delete(Q.id))}v(Q){let G=this.g.get(Q.channelName);G||(G=[],this.g.set(Q.channelName,G));const oe=setTimeout(()=>{console.error(`Unknown channel: ${Q.channelName}`),Q.type===100&&this.m({id:Q.id,data:{name:"Unknown channel",message:`Channel name '${Q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);G.push({request:Q,timeoutTimer:oe})}w(Q){const G=this.g.get(Q);if(G){for(const oe of G)switch(clearTimeout(oe.timeoutTimer),oe.request.type){case 100:this.s(oe.request);break;case 102:this.t(oe.request);break}this.g.delete(Q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,g.$Mc)(this.d.values()),this.d.clear()}}e.$xh=D;var m;(function(J){J[J.LocalSide=0]="LocalSide",J[J.OtherSide=1]="OtherSide"})(m||(e.RequestInitiator=m={}));class p{constructor(Q,G=null){this.l=Q,this.a=!1,this.b=o.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new y.$Rd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(oe=>this.s(oe)),this.j=G}getChannel(Q){const G=this;return{call(oe,_,Ee){return G.a?Promise.reject(new b.$4):G.m(Q,oe,_,Ee)},listen(oe,_){return G.a?y.Event.None:G.o(Q,oe,_)}}}m(Q,G,oe,_=R.CancellationToken.None){const Ee=this.g++,q={id:Ee,type:100,channelName:Q,name:G,arg:oe};if(_.isCancellationRequested)return Promise.reject(new b.$4);let U;return new Promise((be,H)=>{if(_.isCancellationRequested)return H(new b.$4);const x=()=>{const fe=te=>{switch(te.type){case 201:this.f.delete(Ee),be(te.data);break;case 202:{this.f.delete(Ee);const de=new Error(te.data.message);de.stack=Array.isArray(te.data.stack)?te.data.stack.join(`
`):te.data.stack,de.name=te.data.name,H(de);break}case 203:this.f.delete(Ee),H(te.data);break}};this.f.set(Ee,fe),this.p(q)};let Y=null;this.b===o.Idle?x():(Y=(0,T.$Lg)(fe=>this.u()),Y.then(()=>{Y=null,x()}));const $e=()=>{Y?(Y.cancel(),Y=null):this.p({id:Ee,type:101}),H(new b.$4)},ie=_.onCancellationRequested($e);U=(0,g.$Oc)((0,g.$Pc)($e),ie),this.d.add(U)}).finally(()=>{U.dispose(),this.d.delete(U)})}o(Q,G,oe){const _=this.g++,he={id:_,type:102,channelName:Q,name:G,arg:oe};let q=null;const U=new y.$Rd({onWillAddFirstListener:()=>{q=(0,T.$Lg)(be=>this.u()),q.then(()=>{q=null,this.d.add(U),this.p(he)})},onDidRemoveLastListener:()=>{q?(q.cancel(),q=null):(this.d.delete(U),this.p({id:_,type:103}))}}),ne=be=>U.fire(be.data);return this.f.set(_,ne),U.event}p(Q){switch(Q.type){case 100:case 102:{const G=this.q([Q.type,Q.id,Q.channelName,Q.name],Q.arg);this.j?.logOutgoing(G,Q.id,0,`${S(Q.type)}: ${Q.channelName}.${Q.name}`,Q.arg);return}case 101:case 103:{const G=this.q([Q.type,Q.id]);this.j?.logOutgoing(G,Q.id,0,S(Q.type));return}}}q(Q,G=void 0){const oe=new t;return h(oe,Q),h(oe,G),this.r(oe.buffer)}r(Q){try{return this.l.send(Q),Q.byteLength}catch{return 0}}s(Q){const G=new a(Q),oe=E(G),_=E(G),Ee=oe[0];switch(Ee){case 200:return this.j?.logIncoming(Q.byteLength,0,0,l(Ee)),this.t({type:oe[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Q.byteLength,oe[1],0,l(Ee),_),this.t({type:oe[0],id:oe[1],data:_})}}t(Q){if(Q.type===200){this.b=o.Idle,this.k.fire();return}this.f.get(Q.id)?.(Q)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}u(){return this.b===o.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,g.$Mc)(this.d.values()),this.d.clear()}}e.$yh=p,He([L.$nh],p.prototype,"onDidInitializePromise",null);class k{get connections(){const Q=[];return this.f.forEach(G=>Q.push(G)),Q}constructor(Q){this.a=new Map,this.f=new Set,this.g=new y.$Rd,this.onDidAddConnection=this.g.event,this.h=new y.$Rd,this.onDidRemoveConnection=this.h.event,this.j=new g.$Qc,this.j.add(Q(({protocol:G,onDidClientDisconnect:oe})=>{const _=y.Event.once(G.onMessage);this.j.add(_(Ee=>{const he=new a(Ee),q=E(he),U=new D(G,q),ne=new p(G);this.a.forEach((H,x)=>U.registerChannel(x,H));const be={channelServer:U,channelClient:ne,ctx:q};this.f.add(be),this.g.fire(be),this.j.add(oe(()=>{U.dispose(),ne.dispose(),this.f.delete(be),this.h.fire(be)}))}))}))}getChannel(Q,G){const oe=this;return{call(_,Ee,he){let q;if((0,$.$Qf)(G)){const ne=(0,C.$3b)(oe.connections.filter(G));q=ne?Promise.resolve(ne):y.Event.toPromise(y.Event.filter(oe.onDidAddConnection,G))}else q=G.routeCall(oe,_,Ee);const U=q.then(ne=>ne.channelClient.getChannel(Q));return z(U).call(_,Ee,he)},listen(_,Ee){if((0,$.$Qf)(G))return oe.k(Q,G,_,Ee);const he=G.routeEvent(oe,_,Ee).then(q=>q.channelClient.getChannel(Q));return z(he).listen(_,Ee)}}}k(Q,G,oe,_){const Ee=this;let he;const q=new y.$Rd({onWillAddFirstListener:()=>{he=new g.$Qc;const U=new y.$Xd,ne=new Map,be=x=>{const $e=x.channelClient.getChannel(Q).listen(oe,_),ie=U.add($e);ne.set(x,ie)},H=x=>{const Y=ne.get(x);Y&&(Y.dispose(),ne.delete(x))};Ee.connections.filter(G).forEach(be),y.Event.filter(Ee.onDidAddConnection,G)(be,void 0,he),Ee.onDidRemoveConnection(H,void 0,he),U.event(q.fire,q,he),he.add(U)},onDidRemoveLastListener:()=>{he?.dispose(),he=void 0}});return q.event}registerChannel(Q,G){this.a.set(Q,G);for(const oe of this.f)oe.channelServer.registerChannel(Q,G)}dispose(){this.j.dispose();for(const Q of this.f)Q.channelClient.dispose(),Q.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$zh=k;class P{constructor(Q,G,oe=null){const _=new t;h(_,G),Q.send(_.buffer),this.a=new p(Q,oe),this.d=new D(Q,G,oe)}getChannel(Q){return this.a.getChannel(Q)}registerChannel(Q,G){this.d.registerChannel(Q,G)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Ah=P;function z(J){return{call(Q,G,oe){return J.then(_=>_.call(Q,G,oe))},listen(Q,G){const oe=new y.$1d;return J.then(_=>oe.input=_.listen(Q,G)),oe.event}}}e.$Bh=z;function j(J){let Q=!1;return{call(G,oe,_){return Q?J.call(G,oe,_):(0,T.$Yg)(0).then(()=>Q=!0).then(()=>J.call(G,oe,_))},listen(G,oe){if(Q)return J.listen(G,oe);const _=new y.$1d;return(0,T.$Yg)(0).then(()=>Q=!0).then(()=>_.input=J.listen(G,oe)),_.event}}}e.$Ch=j;class M{constructor(Q){this.a=Q}routeCall(Q){return this.b(Q)}routeEvent(Q){return this.b(Q)}async b(Q){for(const G of Q.connections)if(await Promise.resolve(this.a(G.ctx)))return Promise.resolve(G);return await y.Event.toPromise(Q.onDidAddConnection),await this.b(Q)}}e.$Dh=M;var O;(function(J){function Q(Ee,he,q){const U=Ee,ne=q&&q.disableMarshalling,be=new Map;for(const H in U)oe(H)&&be.set(H,y.Event.buffer(U[H],!0,void 0,he));return new class{listen(H,x,Y){const $e=be.get(x);if($e)return $e;if(_(x)){const ie=U[x];if(typeof ie=="function")return ie.call(U,Y)}throw new b.$ab(`Event not found: ${x}`)}call(H,x,Y){const $e=U[x];if(typeof $e=="function"){if(!ne&&Array.isArray(Y))for(let fe=0;fe<Y.length;fe++)Y[fe]=(0,A.$sh)(Y[fe]);let ie=$e.apply(U,Y);return ie instanceof Promise||(ie=Promise.resolve(ie)),ie}throw new b.$ab(`Method not found: ${x}`)}}}J.fromService=Q;function G(Ee,he){const q=he&&he.disableMarshalling;return new Proxy({},{get(U,ne){if(typeof ne=="string")return he?.properties?.has(ne)?he.properties.get(ne):_(ne)?function(be){return Ee.listen(ne,be)}:oe(ne)?Ee.listen(ne):async function(...be){let H;he&&!(0,$.$Lf)(he.context)?H=[he.context,...be]:H=be;const x=await Ee.call(ne,H);return q?x:(0,A.$sh)(x)};throw new b.$ab(`Property not found: ${String(ne)}`)}})}J.toService=G;function oe(Ee){return Ee[0]==="o"&&Ee[1]==="n"&&I.$5e(Ee.charCodeAt(2))}function _(Ee){return/^onDynamic/.test(Ee)&&I.$5e(Ee.charCodeAt(9))}})(O||(e.ProxyChannel=O={}));const F=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function N(J){if(Array.isArray(J))return J;if(J&&typeof J=="object"&&typeof J.toString=="function"){const Q=J.toString();if(Q!=="[object Object]")return Q}return J}function W(J){return Array.isArray(J)?J.map(N):N(J)}function X(J,Q,G,oe,_,Ee,he){he=W(he);const q=F[_],U=q[oe%q.length];let ne=[`%c[${J}]%c[${String(Q).padStart(7," ")}]%c[len: ${String(G).padStart(5," ")}]%c${String(oe).padStart(5," ")} - ${Ee}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(Ee)?(ne=ne.concat(he),ne.push(")")):ne.push(he),console.log.apply(console,ne)}class ce{constructor(Q,G){this.d=Q,this.f=G,this.a=0,this.b=0}logOutgoing(Q,G,oe,_,Ee){this.b+=Q,X(this.d,this.b,Q,G,oe,_,Ee)}logIncoming(Q,G,oe,_,Ee){this.a+=Q,X(this.f,this.a,Q,G,oe,_,Ee)}}e.$Eh=ce}),define(ke[82],Se([1,0,22,4,3,81]),function(me,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.ProtocolConstants=e.$Fh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var L;(function(c){c.Created="created",c.Read="read",c.Write="write",c.Open="open",c.Error="error",c.Close="close",c.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",c.NodeEndReceived="nodeEndReceived",c.NodeEndSent="nodeEndSent",c.NodeDrainBegin="nodeDrainBegin",c.NodeDrainEnd="nodeDrainEnd",c.zlibInflateError="zlibInflateError",c.zlibInflateData="zlibInflateData",c.zlibInflateInitialWrite="zlibInflateInitialWrite",c.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",c.zlibInflateWrite="zlibInflateWrite",c.zlibInflateFlushFired="zlibInflateFlushFired",c.zlibDeflateError="zlibDeflateError",c.zlibDeflateData="zlibDeflateData",c.zlibDeflateWrite="zlibDeflateWrite",c.zlibDeflateFlushFired="zlibDeflateFlushFired",c.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",c.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",c.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",c.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",c.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",c.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",c.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",c.ProtocolHeaderRead="protocolHeaderRead",c.ProtocolMessageRead="protocolMessageRead",c.ProtocolHeaderWrite="protocolHeaderWrite",c.ProtocolMessageWrite="protocolMessageWrite",c.ProtocolWrite="protocolWrite"})(L||(e.SocketDiagnosticsEventType=L={}));var b;(function(c){c.enableDiagnostics=!1,c.records=[];const u=new WeakMap;let h=0;function E(m,p){if(!u.has(m)){const k=String(++h);u.set(m,k)}return u.get(m)}function D(m,p,k,P){if(!c.enableDiagnostics)return;const z=E(m,p);if(P instanceof C.$fe||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const j=C.$fe.alloc(P.byteLength);j.set(P),c.records.push({timestamp:Date.now(),id:z,label:p,type:k,buff:j})}else c.records.push({timestamp:Date.now(),id:z,label:p,type:k,data:P})}c.traceSocketEvent=D})(b||(e.SocketDiagnostics=b={}));var y;(function(c){c[c.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",c[c.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(y||(e.SocketCloseEventType=y={}));let g=null;function A(){return g||(g=C.$fe.alloc(0)),g}class I{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(u){this.a.push(u),this.b+=u.byteLength}read(u){return this.c(u,!0)}peek(u){return this.c(u,!1)}c(u,h){if(u===0)return A();if(u>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===u){const p=this.a[0];return h&&(this.a.shift(),this.b-=u),p}if(this.a[0].byteLength>u){const p=this.a[0].slice(0,u);return h&&(this.a[0]=this.a[0].slice(u),this.b-=u),p}const E=C.$fe.alloc(u);let D=0,m=0;for(;u>0;){const p=this.a[m];if(p.byteLength>u){const k=p.slice(0,u);E.set(k,D),D+=u,h&&(this.a[m]=p.slice(u),this.b-=u),u-=u}else E.set(p,D),D+=p.byteLength,h?(this.a.shift(),this.b-=p.byteLength):m++,u-=p.byteLength}return E}}e.$Fh=I;var $;(function(c){c[c.None=0]="None",c[c.Regular=1]="Regular",c[c.Control=2]="Control",c[c.Ack=3]="Ack",c[c.Disconnect=5]="Disconnect",c[c.ReplayRequest=6]="ReplayRequest",c[c.Pause=7]="Pause",c[c.Resume=8]="Resume",c[c.KeepAlive=9]="KeepAlive"})($||($={}));function v(c){switch(c){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var S;(function(c){c[c.HeaderLength=13]="HeaderLength",c[c.AcknowledgeTime=2e3]="AcknowledgeTime",c[c.TimeoutTime=2e4]="TimeoutTime",c[c.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",c[c.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",c[c.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(S||(e.ProtocolConstants=S={}));class w{constructor(u,h,E,D){this.type=u,this.id=h,this.ack=E,this.data=D,this.writtenTime=0}get size(){return this.data.byteLength}}class l extends f.$Rc{constructor(u){super(),this.f=this.B(new T.$Rd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=u,this.b=!1,this.c=new I,this.B(this.a.onData(h=>this.acceptChunk(h))),this.lastReadTime=Date.now()}acceptChunk(u){if(!(!u||u.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(u);this.c.byteLength>=this.g.readLen;){const h=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=h.readUInt32BE(9),this.g.messageType=h.readUInt8(0),this.g.id=h.readUInt32BE(1),this.g.ack=h.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:v(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const E=this.g.messageType,D=this.g.id,m=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",h),this.f.fire(new w(E,D,m,h)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class o{constructor(u){this.k=null,this.a=!1,this.b=!1,this.c=u,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(u){if(this.a)return;u.writtenTime=Date.now(),this.lastWriteTime=Date.now();const h=C.$fe.alloc(13);h.writeUInt8(u.type,0),h.writeUInt32BE(u.id,1),h.writeUInt32BE(u.ack,5),h.writeUInt32BE(u.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:v(u.type),id:u.id,ack:u.ack,messageSize:u.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",u.data),this.j(h,u.data)}g(u,h){const E=this.f===0;return this.d.push(u,h),this.f+=u.byteLength+h.byteLength,E}h(){const u=C.$fe.concat(this.d,this.f);return this.d.length=0,this.f=0,u}j(u,h){this.g(u,h)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const u=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:u.byteLength}),this.c.write(u)}}class i extends f.$Rc{constructor(u){super(),this.f=new T.$Rd,this.onMessage=this.f.event,this.g=new T.$Rd,this.onDidDispose=this.g.event,this.a=u,this.b=this.B(new o(this.a)),this.c=this.B(new l(this.a)),this.B(this.c.onMessage(h=>{h.type===1&&this.f.fire(h.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(u){this.b.write(new w(1,0,0,u))}}e.$Gh=i;class n extends R.$Ah{static fromSocket(u,h){return new n(new i(u),h)}get onDidDispose(){return this.b.onDidDispose}constructor(u,h,E=null){super(u,h,E),this.b=u}dispose(){super.dispose();const u=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),u.end()}}e.$Hh=n;class r{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new T.$Rd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(u){this.b?this.d.length>0?this.d.push(u):this.a.fire(u):this.d.push(u)}flushBuffer(){this.d=[]}}e.$Ih=r;class a{constructor(u){this.data=u,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let u=0,h=this.a;for(;h;)h=h.next,u++;return u}peek(){return this.a?this.a.data:null}toArray(){const u=[];let h=0,E=this.a;for(;E;)u[h++]=E.data,E=E.next;return u}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(u){const h=new a(u);if(!this.a){this.a=h,this.b=h;return}this.b.next=h,this.b=h}}class s{static{this.a=10}static{this.b=null}static getInstance(){return s.b||(s.b=new s),s.b}constructor(){this.c=[];const u=Date.now();for(let h=0;h<s.a;h++)this.c[h]=u-1e3*h;setInterval(()=>{for(let h=s.a;h>=1;h--)this.c[h]=this.c[h-1];this.c[0]=Date.now()},1e3)}d(){const u=Date.now(),h=(1+s.a)*1e3;let E=0;for(let D=0;D<s.a;D++)u-this.c[D]<=h&&E++;return 1-E/s.a}hasHighLoad(){return this.d()>=.5}}class d{get unacknowledgedCount(){return this.c-this.d}constructor(u){this.u=new r,this.onControlMessage=this.u.event,this.v=new r,this.onMessage=this.v.event,this.w=new r,this.onDidDispose=this.w.event,this.x=new r,this.onSocketClose=this.x.event,this.y=new r,this.onSocketTimeout=this.y.event,this.s=u.loadEstimator??s.getInstance(),this.t=u.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new f.$Qc,this.o=u.socket,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new l(this.o)),this.r.add(this.q.onMessage(h=>this.z(h))),this.r.add(this.o.onClose(h=>this.x.fire(h))),u.initialChunk&&this.q.acceptChunk(u.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const u=new w(5,0,0,A());this.p.write(u),this.p.flush()}sendPause(){const u=new w(7,0,0,A());this.p.write(u)}sendResume(){const u=new w(8,0,0,A());this.p.write(u)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(u,h){this.a=!0,this.r.dispose(),this.r=new f.$Qc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=u,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new l(this.o)),this.r.add(this.q.onMessage(E=>this.z(E))),this.r.add(this.o.onClose(E=>this.x.fire(E))),this.q.acceptChunk(h)}endAcceptReconnection(){this.a=!1,this.h=this.g;const u=new w(3,0,this.h,A());this.p.write(u);const h=this.b.toArray();for(let E=0,D=h.length;E<D;E++)this.p.write(h[E]);this.B()}acceptDisconnect(){this.w.fire()}z(u){if(u.ack>this.d){this.d=u.ack;do{const h=this.b.peek();if(h&&h.id<=u.ack)this.b.pop();else break}while(!0)}switch(u.type){case 0:break;case 1:{if(u.id>this.g)if(u.id!==this.g+1){const h=Date.now();h-this.m>1e4&&(this.m=h,this.p.write(new w(6,0,0,A())))}else this.g=u.id,this.j=Date.now(),this.A(),this.v.fire(u.data);break}case 2:{this.u.fire(u.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const h=this.b.toArray();for(let E=0,D=h.length;E<D;E++)this.p.write(h[E]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(u){const h=++this.c;this.h=this.g;const E=new w(1,h,this.h,u);this.b.push(E),this.a||(this.p.write(E),this.B())}sendControl(u){const h=new w(2,0,0,u);this.p.write(h)}A(){if(this.g<=this.h||this.k)return;const u=Date.now()-this.j;if(u>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-u+5)}B(){if(this.c<=this.d||this.f||this.a)return;const u=this.b.peek(),h=Date.now()-u.writtenTime,E=Date.now()-this.q.lastReadTime,D=Date.now()-this.n;if(h>=2e4&&E>=2e4&&D>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:h,timeSinceLastReceivedSomeData:E});return}const m=Math.max(2e4-h,2e4-E,2e4-D,500);this.f=setTimeout(()=>{this.f=null,this.B()},m)}C(){if(this.g<=this.h)return;this.h=this.g;const u=new w(3,0,this.h,A());this.p.write(u)}D(){this.h=this.g;const u=new w(9,0,this.h,A());this.p.write(u)}}e.$Jh=d}),define(ke[187],Se([1,0,50,12,22,21,185,8,4,3,24,104,101,81]),function(me,e,C,T,f,R,L,b,y,g,A,I,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=e.$8p=void 0;class S extends v.$xh{constructor(o){super({send:i=>{try{process.send?.(i.buffer.toString("base64"))}catch{}},onMessage:y.Event.fromNodeEventEmitter(process,"message",i=>f.$fe.wrap(Buffer.from(i,"base64")))},o),process.once("disconnect",()=>this.dispose())}}e.$8p=S;class w{constructor(o,i){this.i=o,this.j=i,this.c=new Set,this.g=new Map,this.h=new y.$Rd,this.onDidProcessExit=this.h.event;const n=i&&i.timeout?i.timeout:6e4;this.b=new T.$Ug(n),this.d=null,this.f=null}getChannel(o){const i=this;return{call(n,r,a){return i.k(o,n,r,a)},listen(n,r){return i.l(o,n,r)}}}k(o,i,n,r=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(r.isCancellationRequested)return Promise.reject(b.$5());this.b.cancel();const a=this.n(o),t=(0,T.$Lg)(c=>a.call(i,n,c)),s=r.onCancellationRequested(()=>t.cancel()),d=(0,g.$Pc)(()=>t.cancel());return this.c.add(d),t.finally(()=>{s.dispose(),this.c.delete(d),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(o,i,n){if(!this.b)return y.Event.None;this.b.cancel();let r;const a=new y.$Rd({onWillAddFirstListener:()=>{r=this.n(o).listen(i,n)(a.fire,a),this.c.add(r)},onDidRemoveLastListener:()=>{this.c.delete(r),r.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return a.event}get m(){if(!this.f){const o=this.j&&this.j.args?this.j.args:[],i=Object.create(null);i.env={...(0,A.$an)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(i.env={...i.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(i.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(i.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(i.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),i.execArgv===void 0&&(i.execArgv=process.execArgv.filter(u=>!/^--inspect(-brk)?=/.test(u)).filter(u=>!u.startsWith("--vscode-"))),(0,$.$Gl)(i.env),this.d=(0,C.fork)(this.i,o,i);const n=new y.$Rd;y.Event.fromNodeEventEmitter(this.d,"message",u=>u)(u=>{if((0,L.$4p)(u)){(0,L.log)(u,`IPC Library: ${this.j.serverName}`);return}n.fire(f.$fe.wrap(Buffer.from(u,"base64")))});const a=this.j.useQueue?(0,I.$Il)(this.d):this.d,t=u=>this.d&&this.d.connected&&a.send(u.buffer.toString("base64")),s=n.event,d={send:t,onMessage:s};this.f=new v.$yh(d);const c=()=>this.o();process.once("exit",c),this.d.on("error",u=>console.warn('IPC "'+this.j.serverName+'" errored with '+u)),this.d.on("exit",(u,h)=>{process.removeListener("exit",c),this.c.forEach(E=>(0,g.$Mc)(E)),this.c.clear(),u!==0&&h!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+u+" and signal "+h),this.b?.cancel(),this.o(),this.h.fire({code:u,signal:h})})}return this.f}n(o){let i=this.g.get(o);return i||(i=this.m.getChannel(o),this.g.set(o,i)),i}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$9p=w}),define(ke[188],Se([1,0,12,4,3,54,18]),function(me,e,C,T,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=e.$8o=e.StorageState=e.$7o=e.StorageHint=void 0;var b;(function($){$[$.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",$[$.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function y($){const v=$;return v?.changed instanceof Map||v?.deleted instanceof Set}e.$7o=y;var g;(function($){$[$.None=0]="None",$[$.Initialized=1]="Initialized",$[$.Closed=2]="Closed"})(g||(e.StorageState=g={}));class A extends f.$Rc{static{this.a=100}constructor(v,S=Object.create(null)){super(),this.r=v,this.s=S,this.b=this.B(new T.$Ud),this.onDidChangeStorage=this.b.event,this.c=g.None,this.f=new Map,this.g=this.B(new C.$Vg(A.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(v=>this.u(v)))}u(v){this.b.pause();try{v.changed?.forEach((S,w)=>this.w(w,S)),v.deleted?.forEach(S=>this.w(S,void 0))}finally{this.b.resume()}}w(v,S){if(this.c===g.Closed)return;let w=!1;(0,L.$Lf)(S)?w=this.f.delete(v):this.f.get(v)!==S&&(this.f.set(v,S),w=!0),w&&this.b.fire({key:v,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===g.None&&(this.c=g.Initialized,this.s.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(v,S){const w=this.f.get(v);return(0,L.$Lf)(w)?S:w}getBoolean(v,S){const w=this.get(v);return(0,L.$Lf)(w)?S:w==="true"}getNumber(v,S){const w=this.get(v);return(0,L.$Lf)(w)?S:parseInt(w,10)}getObject(v,S){const w=this.get(v);return(0,L.$Lf)(w)?S:(0,R.$rh)(w)}async set(v,S,w=!1){if(this.c===g.Closed)return;if((0,L.$Lf)(S))return this.delete(v,w);const l=(0,L.$Ef)(S)||Array.isArray(S)?(0,R.$qh)(S):String(S);if(this.f.get(v)!==l)return this.f.set(v,l),this.j.set(v,l),this.h.delete(v),this.b.fire({key:v,external:w}),this.D()}async delete(v,S=!1){if(!(this.c===g.Closed||!this.f.delete(v)))return this.h.has(v)||this.h.add(v),this.j.delete(v),this.b.fire({key:v,external:S}),this.D()}async optimize(){if(this.c!==g.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=g.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const v={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(v).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(v){if(this.z)return this.D(v)}async D(v){return this.s.hint===b.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),v)}async whenFlushed(){if(this.z)return new Promise(v=>this.n.push(v))}isInMemory(){return this.s.hint===b.STORAGE_IN_MEMORY}}e.$8o=A;class I{constructor(){this.onDidChangeItemsExternal=T.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(v){v.insert?.forEach((S,w)=>this.a.set(w,S)),v.delete?.forEach(S=>this.a.delete(S))}async optimize(){}async close(){}}e.$9o=I}),define(ke[189],Se([1,0,13,11,22]),function(me,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=e.$Ss=e.$Rs=void 0;let R;function L(){return R||(R=new TextDecoder("UTF-16LE")),R}let b;function y(){return b||(b=new TextDecoder("UTF-16BE")),b}let g;function A(){return g||(g=T.$D()?L():y()),g}e.$Rs=A;function I(S,w,l){const o=new Uint16Array(S.buffer,w,l);return l>0&&(o[0]===65279||o[0]===65534)?$(S,w,l):L().decode(o)}e.$Ss=I;function $(S,w,l){const o=[];let i=0;for(let n=0;n<l;n++){const r=f.$he(S,w);w+=2,o[i++]=String.fromCharCode(r)}return o.join("")}class v{constructor(w){this.a=w|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const w=new Uint16Array(this.b.buffer,0,this.d);return A().decode(w)}f(){const w=this.e();this.d=0,this.c===null?this.c=[w]:this.c[this.c.length]=w}appendCharCode(w){const l=this.a-this.d;l<=1&&(l===0||C.$0e(w))&&this.f(),this.b[this.d++]=w}appendASCIICharCode(w){this.d===this.a&&this.f(),this.b[this.d++]=w}appendString(w){const l=w.length;if(this.d+l>=this.a){this.f(),this.c[this.c.length]=w;return}for(let o=0;o<l;o++)this.b[this.d++]=w.charCodeAt(o)}}e.$Ts=v}),define(ke[190],Se([1,0,22,189]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vs=e.$Us=void 0;function f(y){return y.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class R{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(g,A,I,$){this.oldPosition=g,this.oldText=A,this.newPosition=I,this.newText=$}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${f(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${f(this.oldText)}")`:`(replace@${this.oldPosition} "${f(this.oldText)}" with "${f(this.newText)}")`}static a(g){return 4+2*g.length}static c(g,A,I){const $=A.length;C.$ke(g,$,I),I+=4;for(let v=0;v<$;v++)C.$ie(g,A.charCodeAt(v),I),I+=2;return I}static d(g,A){const I=C.$je(g,A);return A+=4,(0,T.$Ss)(g,A,I)}writeSize(){return 4+4+R.a(this.oldText)+R.a(this.newText)}write(g,A){return C.$ke(g,this.oldPosition,A),A+=4,C.$ke(g,this.newPosition,A),A+=4,A=R.c(g,this.oldText,A),A=R.c(g,this.newText,A),A}static read(g,A,I){const $=C.$je(g,A);A+=4;const v=C.$je(g,A);A+=4;const S=R.d(g,A);A+=R.a(S);const w=R.d(g,A);return A+=R.a(w),I.push(new R($,S,v,w)),A}}e.$Us=R;function L(y,g){return y===null||y.length===0?g:new b(y,g).compress()}e.$Vs=L;class b{constructor(g,A){this.a=g,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let g=0,A=0,I=this.n(g),$=this.l(A);for(;g<this.f||A<this.h;){if(I===null){this.k($),$=this.l(++A);continue}if($===null){this.m(I),I=this.n(++g);continue}if($.oldEnd<=I.newPosition){this.k($),$=this.l(++A);continue}if(I.newEnd<=$.oldPosition){this.m(I),I=this.n(++g);continue}if($.oldPosition<I.newPosition){const[o,i]=b.r($,I.newPosition-$.oldPosition);this.k(o),$=i;continue}if(I.newPosition<$.oldPosition){const[o,i]=b.q(I,$.oldPosition-I.newPosition);this.m(o),I=i;continue}let w,l;if($.oldEnd===I.newEnd)w=I,l=$,I=this.n(++g),$=this.l(++A);else if($.oldEnd<I.newEnd){const[o,i]=b.q(I,$.oldLength);w=o,l=$,I=i,$=this.l(++A)}else{const[o,i]=b.r($,I.newLength);w=I,l=o,I=this.n(++g),$=i}this.d[this.e++]=new R(w.oldPosition,w.oldText,l.newPosition,l.newText),this.g+=w.newLength-w.oldLength,this.j+=l.newLength-l.oldLength}const v=b.s(this.d);return b.t(v)}k(g){this.d[this.e++]=b.o(this.g,g),this.j+=g.newLength-g.oldLength}l(g){return g<this.h?this.c[g]:null}m(g){this.d[this.e++]=b.p(this.j,g),this.g+=g.newLength-g.oldLength}n(g){return g<this.f?this.a[g]:null}static o(g,A){return new R(A.oldPosition-g,A.oldText,A.newPosition,A.newText)}static p(g,A){return new R(A.oldPosition,A.oldText,A.newPosition+g,A.newText)}static q(g,A){const I=g.newText.substr(0,A),$=g.newText.substr(A);return[new R(g.oldPosition,g.oldText,g.newPosition,I),new R(g.oldEnd,"",g.newPosition+A,$)]}static r(g,A){const I=g.oldText.substr(0,A),$=g.oldText.substr(A);return[new R(g.oldPosition,I,g.newPosition,g.newText),new R(g.oldPosition+A,$,g.newEnd,"")]}static s(g){if(g.length===0)return g;const A=[];let I=0,$=g[0];for(let v=1;v<g.length;v++){const S=g[v];$.oldEnd===S.oldPosition?$=new R($.oldPosition,$.oldText+S.oldText,$.newPosition,$.newText+S.newText):(A[I++]=$,$=S)}return A[I++]=$,A}static t(g){if(g.length===0)return g;const A=[];let I=0;for(let $=0;$<g.length;$++){const v=g[$];v.oldText!==v.newText&&(A[I++]=v)}return A}}}),define(ke[191],Se([1,0,34,16]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LE=void 0;function f(R,L,b,y,g,A){if(Array.isArray(R)){let I=0;for(const $ of R){const v=f($,L,b,y,g,A);if(v===10)return v;v>I&&(I=v)}return I}else{if(typeof R=="string")return y?R==="*"?5:R===b?10:0:0;if(R){const{language:I,pattern:$,scheme:v,hasAccessToAllModels:S,notebookType:w}=R;if(!y&&!S)return 0;w&&g&&(L=g);let l=0;if(v)if(v===L.scheme)l=10;else if(v==="*")l=5;else return 0;if(I)if(I===b)l=10;else if(I==="*")l=Math.max(l,5);else return 0;if(w)if(w===A)l=10;else if(w==="*"&&A!==void 0)l=Math.max(l,5);else return 0;if($){let o;if(typeof $=="string"?o=$:o={...$,base:(0,T.$gc)($.base)},o===L.fsPath||(0,C.$Bj)(o,L.fsPath))l=10;else return 0}return l}else return 0}}e.$LE=f}),define(ke[192],Se([1,0,4,13,29,79,128,167,190,3]),function(me,e,C,T,f,R,L,b,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MB=void 0;class A extends g.$Rc{constructor($,v,S,w,l,o,i){super(),this.m=this.B(new C.$Rd),this.onDidChangeContent=this.m.event,this.f=v,this.j=!o,this.g=w,this.h=l,this.c=new L.$LB($,S,i)}equals($){return!($ instanceof A)||this.f!==$.f||this.getEOL()!==$.getEOL()?!1:this.c.equal($.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot($){return this.c.createSnapshot($?this.f:"")}getOffsetAt($,v){return this.c.getOffsetAt($,v)}getPositionAt($){return this.c.getPositionAt($)}getRangeAt($,v){const S=$+v,w=this.getPositionAt($),l=this.getPositionAt(S);return new f.$zs(w.lineNumber,w.column,l.lineNumber,l.column)}getValueInRange($,v=0){if($.isEmpty())return"";const S=this.n(v);return this.c.getValueInRange($,S)}getValueLengthInRange($,v=0){if($.isEmpty())return 0;if($.startLineNumber===$.endLineNumber)return $.endColumn-$.startColumn;const S=this.getOffsetAt($.startLineNumber,$.startColumn),w=this.getOffsetAt($.endLineNumber,$.endColumn);let l=0;const o=this.n(v),i=this.getEOL();if(o.length!==i.length){const n=o.length-i.length,r=$.endLineNumber-$.startLineNumber;l=n*r}return w-S+l}getCharacterCountInRange($,v=0){if(this.j){let S=0;const w=$.startLineNumber,l=$.endLineNumber;for(let o=w;o<=l;o++){const i=this.getLineContent(o),n=o===w?$.startColumn-1:0,r=o===l?$.endColumn-1:i.length;for(let a=n;a<r;a++)T.$0e(i.charCodeAt(a))?(S=S+1,a=a+1):S=S+1}return S+=this.n(v).length*(l-w),S}return this.getValueLengthInRange($,v)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent($){return this.c.getLineContent($)}getLineCharCode($,v){return this.c.getLineCharCode($,v)}getCharCode($){return this.c.getCharCode($)}getLineLength($){return this.c.getLineLength($)}getLineMinColumn($){return 1}getLineMaxColumn($){return this.getLineLength($)+1}getLineFirstNonWhitespaceColumn($){const v=T.$Ue(this.getLineContent($));return v===-1?0:v+1}getLineLastNonWhitespaceColumn($){const v=T.$We(this.getLineContent($));return v===-1?0:v+2}n($){switch($){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL($){this.c.setEOL($)}applyEdits($,v,S){let w=this.g,l=this.h,o=this.j,i=!0,n=[];for(let u=0;u<$.length;u++){const h=$[u];i&&h._isTracked&&(i=!1);const E=h.range;if(h.text){let P=!0;o||(P=!T.$if(h.text),o=P),!w&&P&&(w=T.$hf(h.text)),!l&&P&&(l=T.$kf(h.text))}let D="",m=0,p=0,k=0;if(h.text){let P;[m,p,k,P]=(0,b.$_s)(h.text);const z=this.getEOL();P===0||P===(z===`\r
`?2:1)?D=h.text:D=h.text.replace(/\r\n|\r|\n/g,z)}n[u]={sortIndex:u,identifier:h.identifier||null,range:E,rangeOffset:this.getOffsetAt(E.startLineNumber,E.startColumn),rangeLength:this.getValueLengthInRange(E),text:D,eolCount:m,firstLineLength:p,lastLineLength:k,forceMoveMarkers:!!h.forceMoveMarkers,isAutoWhitespaceEdit:h.isAutoWhitespaceEdit||!1}}n.sort(A.u);let r=!1;for(let u=0,h=n.length-1;u<h;u++){const E=n[u].range.getEndPosition(),D=n[u+1].range.getStartPosition();if(D.isBeforeOrEqual(E)){if(D.isBefore(E))throw new Error("Overlapping ranges are not allowed!");r=!0}}i&&(n=this.s(n));const a=S||v?A._getInverseEditRanges(n):[],t=[];if(v)for(let u=0;u<n.length;u++){const h=n[u],E=a[u];if(h.isAutoWhitespaceEdit&&h.range.isEmpty())for(let D=E.startLineNumber;D<=E.endLineNumber;D++){let m="";D===E.startLineNumber&&(m=this.getLineContent(h.range.startLineNumber),T.$Ue(m)!==-1)||t.push({lineNumber:D,oldContent:m})}}let s=null;if(S){let u=0;s=[];for(let h=0;h<n.length;h++){const E=n[h],D=a[h],m=this.getValueInRange(E.range),p=E.rangeOffset+u;u+=E.text.length-m.length,s[h]={sortIndex:E.sortIndex,identifier:E.identifier,range:D,text:m,textChange:new y.$Us(E.rangeOffset,m,p,E.text)}}r||s.sort((h,E)=>h.sortIndex-E.sortIndex)}this.g=w,this.h=l,this.j=o;const d=this.t(n);let c=null;if(v&&t.length>0){t.sort((u,h)=>h.lineNumber-u.lineNumber),c=[];for(let u=0,h=t.length;u<h;u++){const E=t[u].lineNumber;if(u>0&&t[u-1].lineNumber===E)continue;const D=t[u].oldContent,m=this.getLineContent(E);m.length===0||m===D||T.$Ue(m)!==-1||c.push(E)}}return this.m.fire(),new R.$Uu(s,d,c)}s($){return $.length<1e3?$:[this._toSingleEditOperation($)]}_toSingleEditOperation($){let v=!1;const S=$[0].range,w=$[$.length-1].range,l=new f.$zs(S.startLineNumber,S.startColumn,w.endLineNumber,w.endColumn);let o=S.startLineNumber,i=S.startColumn;const n=[];for(let d=0,c=$.length;d<c;d++){const u=$[d],h=u.range;v=v||u.forceMoveMarkers,n.push(this.getValueInRange(new f.$zs(o,i,h.startLineNumber,h.startColumn))),u.text.length>0&&n.push(u.text),o=h.endLineNumber,i=h.endColumn}const r=n.join(""),[a,t,s]=(0,b.$_s)(r);return{sortIndex:0,identifier:$[0].identifier,range:l,rangeOffset:this.getOffsetAt(l.startLineNumber,l.startColumn),rangeLength:this.getValueLengthInRange(l,0),text:r,eolCount:a,firstLineLength:t,lastLineLength:s,forceMoveMarkers:v,isAutoWhitespaceEdit:!1}}t($){$.sort(A.w);const v=[];for(let S=0;S<$.length;S++){const w=$[S],l=w.range.startLineNumber,o=w.range.startColumn,i=w.range.endLineNumber,n=w.range.endColumn;if(l===i&&o===n&&w.text.length===0)continue;w.text?(this.c.delete(w.rangeOffset,w.rangeLength),this.c.insert(w.rangeOffset,w.text,!0)):this.c.delete(w.rangeOffset,w.rangeLength);const r=new f.$zs(l,o,i,n);v.push({range:r,rangeLength:w.rangeLength,text:w.text,rangeOffset:w.rangeOffset,forceMoveMarkers:w.forceMoveMarkers})}return v}findMatchesLineByLine($,v,S,w){return this.c.findMatchesLineByLine($,v,S,w)}getPieceTree(){return this.c}static _getInverseEditRange($,v){const S=$.startLineNumber,w=$.startColumn,[l,o,i]=(0,b.$_s)(v);let n;if(v.length>0){const r=l+1;r===1?n=new f.$zs(S,w,S,w+o):n=new f.$zs(S,w,S+r-1,i+1)}else n=new f.$zs(S,w,S,w);return n}static _getInverseEditRanges($){const v=[];let S=0,w=0,l=null;for(let o=0,i=$.length;o<i;o++){const n=$[o];let r,a;l?l.range.endLineNumber===n.range.startLineNumber?(r=S,a=w+(n.range.startColumn-l.range.endColumn)):(r=S+(n.range.startLineNumber-l.range.endLineNumber),a=n.range.startColumn):(r=n.range.startLineNumber,a=n.range.startColumn);let t;if(n.text.length>0){const s=n.eolCount+1;s===1?t=new f.$zs(r,a,r,a+n.firstLineLength):t=new f.$zs(r,a,r+s-1,n.lastLineLength+1)}else t=new f.$zs(r,a,r,a);S=t.endLineNumber,w=t.endColumn,v.push(t),l=n}return v}static u($,v){const S=f.$zs.compareRangesUsingEnds($.range,v.range);return S===0?$.sortIndex-v.sortIndex:S}static w($,v){const S=f.$zs.compareRangesUsingEnds($.range,v.range);return S===0?v.sortIndex-$.sortIndex:-S}}e.$MB=A}),define(ke[193],Se([1,0,13,128,192]),function(me,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NB=void 0;class R{constructor(y,g,A,I,$,v,S,w,l){this.a=y,this.b=g,this.c=A,this.d=I,this.e=$,this.f=v,this.g=S,this.h=w,this.j=l}k(y){const g=this.c+this.d+this.e,A=this.c+this.e;return g===0?y===1?`
`:`\r
`:A>g/2?`\r
`:`
`}create(y){const g=this.k(y),A=this.a;if(this.j&&(g===`\r
`&&(this.c>0||this.d>0)||g===`
`&&(this.c>0||this.e>0)))for(let $=0,v=A.length;$<v;$++){const S=A[$].buffer.replace(/\r\n|\r|\n/g,g),w=(0,T.$HB)(S);A[$]=new T.$KB(S,w)}const I=new f.$MB(A,this.b,g,this.f,this.g,this.h,this.j);return{textBuffer:I,disposable:I}}getFirstLineText(y){return this.a[0].buffer.substr(0,y).split(/\r\n|\r|\n/)[0]}}class L{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(y){if(y.length===0)return;this.a.length===0&&C.$qf(y)&&(this.b=C.$pf,y=y.substr(1));const g=y.charCodeAt(y.length-1);g===13||g>=55296&&g<=56319?(this.m(y.substr(0,y.length-1),!1),this.c=!0,this.d=g):(this.m(y,!1),this.c=!1,this.d=g)}m(y,g){!g&&y.length===0||(this.c?this.n(String.fromCharCode(this.d)+y):this.n(y))}n(y){const g=(0,T.$IB)(this.e,y);this.a.push(new T.$KB(y,g.lineStarts)),this.f+=g.cr,this.g+=g.lf,this.h+=g.crlf,g.isBasicASCII||(this.l=!1,this.j||(this.j=C.$hf(y)),this.k||(this.k=C.$kf(y)))}finish(y=!0){return this.o(),new R(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,y)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const y=this.a[this.a.length-1];y.buffer+=String.fromCharCode(this.d);const g=(0,T.$HB)(y.buffer);y.lineStarts=g,this.d===13&&this.f++}}}e.$NB=L}),define(ke[132],Se([1,0,22,11]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$20=e.$10=void 0;var f;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(f||(f={}));function R(I){for(let $=0,v=I.length;$<v;$+=4){const S=I[$+0],w=I[$+1],l=I[$+2],o=I[$+3];I[$+0]=o,I[$+1]=l,I[$+2]=w,I[$+3]=S}}function L(I){const $=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return T.$D()||R($),C.$fe.wrap($)}function b(I){const $=I.buffer;if(T.$D()||R($),$.byteOffset%4===0)return new Uint32Array($.buffer,$.byteOffset,$.length/4);{const v=new Uint8Array($.byteLength);return v.set($),new Uint32Array(v.buffer,v.byteOffset,v.length/4)}}function y(I){const $=new Uint32Array(g(I));let v=0;if($[v++]=I.id,I.type==="full")$[v++]=1,$[v++]=I.data.length,$.set(I.data,v),v+=I.data.length;else{$[v++]=2,$[v++]=I.deltas.length;for(const S of I.deltas)$[v++]=S.start,$[v++]=S.deleteCount,S.data?($[v++]=S.data.length,$.set(S.data,v),v+=S.data.length):$[v++]=0}return L($)}e.$10=y;function g(I){let $=0;if($+=1+1,I.type==="full")$+=1+I.data.length;else{$+=1,$+=(1+1+1)*I.deltas.length;for(const v of I.deltas)v.data&&($+=v.data.length)}return $}function A(I){const $=b(I);let v=0;const S=$[v++];if($[v++]===1){const i=$[v++],n=$.subarray(v,v+i);return v+=i,{id:S,type:"full",data:n}}const l=$[v++],o=[];for(let i=0;i<l;i++){const n=$[v++],r=$[v++],a=$[v++];let t;a>0&&(t=$.subarray(v,v+a),v+=a),o[i]={start:n,deleteCount:r,data:t}}return{id:S,type:"delta",deltas:o}}e.$20=A}),define(ke[194],Se([9,10]),function(me,e){return me.create("vs/editor/common/config/editorOptions",e)}),define(ke[133],Se([1,0,19,24,11,170,127,194]),function(me,e,C,T,f,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(le){le[le.None=0]="None",le[le.Keep=1]="Keep",le[le.Brackets=2]="Brackets",le[le.Advanced=3]="Advanced",le[le.Full=4]="Full"})(y||(e.EditorAutoIndentStrategy=y={})),e.MINIMAP_GUTTER_WIDTH=8;class g{constructor(ue){this.c=ue}hasChanged(ue){return this.c[ue]}}e.ConfigurationChangedEvent=g;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class I{constructor(ue,Ie,Ke,Ge){this.id=ue,this.name=Ie,this.defaultValue=Ke,this.schema=Ge}applyUpdate(ue,Ie){return v(ue,Ie)}compute(ue,Ie,Ke){return Ke}}class ${constructor(ue,Ie){this.newValue=ue,this.didChange=Ie}}e.ApplyUpdateResult=$;function v(le,ue){if(typeof le!="object"||typeof ue!="object"||!le||!ue)return new $(ue,le!==ue);if(Array.isArray(le)||Array.isArray(ue)){const Ke=Array.isArray(le)&&Array.isArray(ue)&&C.$tb(le,ue);return new $(ue,!Ke)}let Ie=!1;for(const Ke in ue)if(ue.hasOwnProperty(Ke)){const Ge=v(le[Ke],ue[Ke]);Ge.didChange&&(le[Ke]=Ge.newValue,Ie=!0)}return new $(le,Ie)}class S{constructor(ue){this.schema=void 0,this.id=ue,this.name="_never_",this.defaultValue=void 0}applyUpdate(ue,Ie){return v(ue,Ie)}validate(ue){return this.defaultValue}}class w{constructor(ue,Ie,Ke,Ge){this.id=ue,this.name=Ie,this.defaultValue=Ke,this.schema=Ge}applyUpdate(ue,Ie){return v(ue,Ie)}validate(ue){return typeof ue>"u"?this.defaultValue:ue}compute(ue,Ie,Ke){return Ke}}function l(le,ue){return typeof le>"u"?ue:le==="false"?!1:!!le}e.boolean=l;class o extends w{constructor(ue,Ie,Ke,Ge=void 0){typeof Ge<"u"&&(Ge.type="boolean",Ge.default=Ke),super(ue,Ie,Ke,Ge)}validate(ue){return l(ue,this.defaultValue)}}function i(le,ue,Ie,Ke){if(typeof le>"u")return ue;let Ge=parseInt(le,10);return isNaN(Ge)?ue:(Ge=Math.max(Ie,Ge),Ge=Math.min(Ke,Ge),Ge|0)}e.clampedInt=i;class n extends w{static clampedInt(ue,Ie,Ke,Ge){return i(ue,Ie,Ke,Ge)}constructor(ue,Ie,Ke,Ge,_e,st=void 0){typeof st<"u"&&(st.type="integer",st.default=Ke,st.minimum=Ge,st.maximum=_e),super(ue,Ie,Ke,st),this.minimum=Ge,this.maximum=_e}validate(ue){return n.clampedInt(ue,this.defaultValue,this.minimum,this.maximum)}}function r(le,ue,Ie,Ke){if(typeof le>"u")return ue;const Ge=a.float(le,ue);return a.clamp(Ge,Ie,Ke)}e.clampedFloat=r;class a extends w{static clamp(ue,Ie,Ke){return ue<Ie?Ie:ue>Ke?Ke:ue}static float(ue,Ie){if(typeof ue=="number")return ue;if(typeof ue>"u")return Ie;const Ke=parseFloat(ue);return isNaN(Ke)?Ie:Ke}constructor(ue,Ie,Ke,Ge,_e){typeof _e<"u"&&(_e.type="number",_e.default=Ke),super(ue,Ie,Ke,_e),this.validationFn=Ge}validate(ue){return this.validationFn(a.float(ue,this.defaultValue))}}class t extends w{static string(ue,Ie){return typeof ue!="string"?Ie:ue}constructor(ue,Ie,Ke,Ge=void 0){typeof Ge<"u"&&(Ge.type="string",Ge.default=Ke),super(ue,Ie,Ke,Ge)}validate(ue){return t.string(ue,this.defaultValue)}}function s(le,ue,Ie,Ke){return typeof le!="string"?ue:Ke&&le in Ke?Ke[le]:Ie.indexOf(le)===-1?ue:le}e.stringSet=s;class d extends w{constructor(ue,Ie,Ke,Ge,_e=void 0){typeof _e<"u"&&(_e.type="string",_e.enum=Ge,_e.default=Ke),super(ue,Ie,Ke,_e),this.c=Ge}validate(ue){return s(ue,this.defaultValue,this.c)}}class c extends I{constructor(ue,Ie,Ke,Ge,_e,st,lt=void 0){typeof lt<"u"&&(lt.type="string",lt.enum=_e,lt.default=Ge),super(ue,Ie,Ke,lt),this.c=_e,this.d=st}validate(ue){return typeof ue!="string"?this.defaultValue:this.c.indexOf(ue)===-1?this.defaultValue:this.d(ue)}}function u(le){switch(le){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class h extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",tags:["accessibility"],description:b.localize(3,null)})}validate(ue){switch(ue){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ue,Ie,Ke){return Ke===0?ue.accessibilitySupport:Ke}}class E extends I{constructor(){const ue={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ue,{"editor.comments.insertSpace":{type:"boolean",default:ue.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ue.ignoreEmptyLines,description:b.localize(5,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{insertSpace:l(Ie.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:l(Ie.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var D;(function(le){le[le.Hidden=0]="Hidden",le[le.Blink=1]="Blink",le[le.Smooth=2]="Smooth",le[le.Phase=3]="Phase",le[le.Expand=4]="Expand",le[le.Solid=5]="Solid"})(D||(e.TextEditorCursorBlinkingStyle=D={}));function m(le){switch(le){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var p;(function(le){le[le.Line=1]="Line",le[le.Block=2]="Block",le[le.Underline=3]="Underline",le[le.LineThin=4]="LineThin",le[le.BlockOutline=5]="BlockOutline",le[le.UnderlineThin=6]="UnderlineThin"})(p||(e.TextEditorCursorStyle=p={}));function k(le){switch(le){case p.Line:return"line";case p.Block:return"block";case p.Underline:return"underline";case p.LineThin:return"line-thin";case p.BlockOutline:return"block-outline";case p.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=k;function P(le){switch(le){case"line":return p.Line;case"block":return p.Block;case"underline":return p.Underline;case"line-thin":return p.LineThin;case"block-outline":return p.BlockOutline;case"underline-thin":return p.UnderlineThin}}class z extends S{constructor(){super(140)}compute(ue,Ie,Ke){const Ge=["monaco-editor"];return Ie.get(39)&&Ge.push(Ie.get(39)),ue.extraEditorClassName&&Ge.push(ue.extraEditorClassName),Ie.get(73)==="default"?Ge.push("mouse-default"):Ie.get(73)==="copy"&&Ge.push("mouse-copy"),Ie.get(110)&&Ge.push("showUnused"),Ie.get(138)&&Ge.push("showDeprecated"),Ge.join(" ")}}class j extends o{constructor(){super(37,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(ue,Ie,Ke){return Ke&&ue.emptySelectionClipboard}}class M extends I{constructor(){const ue={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ue,{"editor.find.cursorMoveOnType":{type:"boolean",default:ue.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ue.seedSearchStringFromSelection,enumDescriptions:[b.localize(8,null),b.localize(9,null),b.localize(10,null)],description:b.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ue.autoFindInSelection,enumDescriptions:[b.localize(12,null),b.localize(13,null),b.localize(14,null)],description:b.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ue.globalFindClipboard,description:b.localize(16,null),included:f.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ue.addExtraSpaceOnTop,description:b.localize(17,null)},"editor.find.loop":{type:"boolean",default:ue.loop,description:b.localize(18,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{cursorMoveOnType:l(Ie.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ue.seedSearchStringFromSelection=="boolean"?ue.seedSearchStringFromSelection?"always":"never":s(Ie.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ue.autoFindInSelection=="boolean"?ue.autoFindInSelection?"always":"never":s(Ie.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:l(Ie.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:l(Ie.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:l(Ie.loop,this.defaultValue.loop)}}}class O extends I{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",O.OFF,{anyOf:[{type:"boolean",description:b.localize(19,null)},{type:"string",description:b.localize(20,null)}],description:b.localize(21,null),default:!1})}validate(ue){return typeof ue>"u"?this.defaultValue:typeof ue=="string"?ue==="false"?O.OFF:ue==="true"?O.ON:ue:ue?O.ON:O.OFF}}e.EditorFontLigatures=O;class F extends I{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",F.OFF,{anyOf:[{type:"boolean",description:b.localize(22,null)},{type:"string",description:b.localize(23,null)}],description:b.localize(24,null),default:!1})}validate(ue){return typeof ue>"u"?this.defaultValue:typeof ue=="string"?ue==="false"?F.OFF:ue==="true"?F.TRANSLATE:ue:ue?F.TRANSLATE:F.OFF}compute(ue,Ie,Ke){return ue.fontInfo.fontVariationSettings}}e.EditorFontVariations=F;class N extends S{constructor(){super(50)}compute(ue,Ie,Ke){return ue.fontInfo}}class W extends w{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(25,null)})}validate(ue){const Ie=a.float(ue,this.defaultValue);return Ie===0?e.EDITOR_FONT_DEFAULTS.fontSize:a.clamp(Ie,6,100)}compute(ue,Ie,Ke){return ue.fontInfo.fontSize}}class X extends I{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:X.d,maximum:X.e,errorMessage:b.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:X.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(27,null)})}validate(ue){return ue==="normal"||ue==="bold"?ue:String(n.clampedInt(ue,e.EDITOR_FONT_DEFAULTS.fontWeight,X.d,X.e))}}class ce extends I{constructor(){const ue={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ie={type:"string",enum:["peek","gotoAndPeek","goto"],default:ue.multiple,enumDescriptions:[b.localize(28,null),b.localize(29,null),b.localize(30,null)]},Ke=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ue,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:b.localize(32,null),...Ie},"editor.gotoLocation.multipleTypeDefinitions":{description:b.localize(33,null),...Ie},"editor.gotoLocation.multipleDeclarations":{description:b.localize(34,null),...Ie},"editor.gotoLocation.multipleImplementations":{description:b.localize(35,null),...Ie},"editor.gotoLocation.multipleReferences":{description:b.localize(36,null),...Ie},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ue.alternativeDefinitionCommand,enum:Ke,description:b.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ue.alternativeTypeDefinitionCommand,enum:Ke,description:b.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ue.alternativeDeclarationCommand,enum:Ke,description:b.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ue.alternativeImplementationCommand,enum:Ke,description:b.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ue.alternativeReferenceCommand,enum:Ke,description:b.localize(41,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{multiple:s(Ie.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ie.multipleDefinitions??s(Ie.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ie.multipleTypeDefinitions??s(Ie.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ie.multipleDeclarations??s(Ie.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ie.multipleImplementations??s(Ie.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ie.multipleReferences??s(Ie.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ie.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ie.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ie.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ie.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ie.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class J extends I{constructor(){const ue={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ue,{"editor.hover.enabled":{type:"boolean",default:ue.enabled,description:b.localize(42,null)},"editor.hover.delay":{type:"number",default:ue.delay,minimum:0,maximum:1e4,description:b.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ue.sticky,description:b.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ue.hidingDelay,description:b.localize(45,null)},"editor.hover.above":{type:"boolean",default:ue.above,description:b.localize(46,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:l(Ie.enabled,this.defaultValue.enabled),delay:n.clampedInt(Ie.delay,this.defaultValue.delay,0,1e4),sticky:l(Ie.sticky,this.defaultValue.sticky),hidingDelay:n.clampedInt(Ie.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:l(Ie.above,this.defaultValue.above)}}}var Q;(function(le){le[le.None=0]="None",le[le.Text=1]="Text",le[le.Blocks=2]="Blocks"})(Q||(e.RenderMinimap=Q={}));class G extends S{constructor(){super(143)}compute(ue,Ie,Ke){return G.computeLayout(Ie,{memory:ue.memory,outerWidth:ue.outerWidth,outerHeight:ue.outerHeight,isDominatedByLongLines:ue.isDominatedByLongLines,lineHeight:ue.fontInfo.lineHeight,viewLineCount:ue.viewLineCount,lineNumbersDigitCount:ue.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ue.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ue.fontInfo.maxDigitWidth,pixelRatio:ue.pixelRatio,glyphMarginDecorationLaneCount:ue.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ue){const Ie=ue.height/ue.lineHeight,Ke=Math.floor(ue.paddingTop/ue.lineHeight);let Ge=Math.floor(ue.paddingBottom/ue.lineHeight);ue.scrollBeyondLastLine&&(Ge=Math.max(Ge,Ie-1));const _e=(Ke+ue.viewLineCount+Ge)/(ue.pixelRatio*ue.height),st=Math.floor(ue.viewLineCount/_e);return{typicalViewportLineCount:Ie,extraLinesBeforeFirstLine:Ke,extraLinesBeyondLastLine:Ge,desiredRatio:_e,minimapLineCount:st}}static c(ue,Ie){const Ke=ue.outerWidth,Ge=ue.outerHeight,_e=ue.pixelRatio;if(!ue.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(_e*Ge),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ge};const st=Ie.stableMinimapLayoutInput,lt=st&&ue.outerHeight===st.outerHeight&&ue.lineHeight===st.lineHeight&&ue.typicalHalfwidthCharacterWidth===st.typicalHalfwidthCharacterWidth&&ue.pixelRatio===st.pixelRatio&&ue.scrollBeyondLastLine===st.scrollBeyondLastLine&&ue.paddingTop===st.paddingTop&&ue.paddingBottom===st.paddingBottom&&ue.minimap.enabled===st.minimap.enabled&&ue.minimap.side===st.minimap.side&&ue.minimap.size===st.minimap.size&&ue.minimap.showSlider===st.minimap.showSlider&&ue.minimap.renderCharacters===st.minimap.renderCharacters&&ue.minimap.maxColumn===st.minimap.maxColumn&&ue.minimap.scale===st.minimap.scale&&ue.verticalScrollbarWidth===st.verticalScrollbarWidth&&ue.isViewportWrapping===st.isViewportWrapping,wt=ue.lineHeight,Ue=ue.typicalHalfwidthCharacterWidth,Kt=ue.scrollBeyondLastLine,Ht=ue.minimap.renderCharacters;let Et=_e>=2?Math.round(ue.minimap.scale*2):ue.minimap.scale;const Ut=ue.minimap.maxColumn,Ot=ue.minimap.size,Gt=ue.minimap.side,Bt=ue.verticalScrollbarWidth,Dt=ue.viewLineCount,Mt=ue.remainingWidth,Wt=ue.isViewportWrapping,tt=Ht?2:3;let Vt=Math.floor(_e*Ge);const qt=Vt/_e;let ut=!1,mt=!1,Nt=tt*Et,Pt=Et/_e,At=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:Jt,extraLinesBeforeFirstLine:Me,extraLinesBeyondLastLine:Fe,desiredRatio:Ce,minimapLineCount:se}=G.computeContainedMinimapLineCount({viewLineCount:Dt,scrollBeyondLastLine:Kt,paddingTop:ue.paddingTop,paddingBottom:ue.paddingBottom,height:Ge,lineHeight:wt,pixelRatio:_e});if(Dt/se>1)ut=!0,mt=!0,Et=1,Nt=1,Pt=Et/_e;else{let qe=!1,xe=Et+1;if(Ot==="fit"){const Qe=Math.ceil((Me+Dt+Fe)*Nt);Wt&&lt&&Mt<=Ie.stableFitRemainingWidth?(qe=!0,xe=Ie.stableFitMaxMinimapScale):qe=Qe>Vt}if(Ot==="fill"||qe){ut=!0;const Qe=Et;Nt=Math.min(wt*_e,Math.max(1,Math.floor(1/Ce))),Wt&&lt&&Mt<=Ie.stableFitRemainingWidth&&(xe=Ie.stableFitMaxMinimapScale),Et=Math.min(xe,Math.max(1,Math.floor(Nt/tt))),Et>Qe&&(At=Math.min(2,Et/Qe)),Pt=Et/_e/At,Vt=Math.ceil(Math.max(Jt,Me+Dt+Fe)*Nt),Wt?(Ie.stableMinimapLayoutInput=ue,Ie.stableFitRemainingWidth=Mt,Ie.stableFitMaxMinimapScale=Et):(Ie.stableMinimapLayoutInput=null,Ie.stableFitRemainingWidth=0)}}}const gt=Math.floor(Ut*Pt),St=Math.min(gt,Math.max(0,Math.floor((Mt-Bt-2)*Pt/(Ue+Pt)))+e.MINIMAP_GUTTER_WIDTH);let Rt=Math.floor(_e*St);const It=Rt/_e;Rt=Math.floor(Rt*At);const Je=Ht?1:2,zt=Gt==="left"?0:Ke-St-Bt;return{renderMinimap:Je,minimapLeft:zt,minimapWidth:St,minimapHeightIsEditorHeight:ut,minimapIsSampling:mt,minimapScale:Et,minimapLineHeight:Nt,minimapCanvasInnerWidth:Rt,minimapCanvasInnerHeight:Vt,minimapCanvasOuterWidth:It,minimapCanvasOuterHeight:qt}}static computeLayout(ue,Ie){const Ke=Ie.outerWidth|0,Ge=Ie.outerHeight|0,_e=Ie.lineHeight|0,st=Ie.lineNumbersDigitCount|0,lt=Ie.typicalHalfwidthCharacterWidth,wt=Ie.maxDigitWidth,Ue=Ie.pixelRatio,Kt=Ie.viewLineCount,Ht=ue.get(135),Et=Ht==="inherit"?ue.get(134):Ht,Ut=Et==="inherit"?ue.get(130):Et,Ot=ue.get(133),Gt=Ie.isDominatedByLongLines,Bt=ue.get(57),Dt=ue.get(67).renderType!==0,Mt=ue.get(68),Wt=ue.get(104),tt=ue.get(83),Vt=ue.get(72),qt=ue.get(102),ut=qt.verticalScrollbarSize,mt=qt.verticalHasArrows,Nt=qt.arrowSize,Pt=qt.horizontalScrollbarSize,At=ue.get(43),gt=ue.get(109)!=="never";let St=ue.get(65);At&&gt&&(St+=16);let Rt=0;if(Dt){const pt=Math.max(st,Mt);Rt=Math.round(pt*wt)}let It=0;Bt&&(It=_e*Ie.glyphMarginDecorationLaneCount);let Je=0,zt=Je+It,Jt=zt+Rt,Me=Jt+St;const Fe=Ke-It-Rt-St;let Ce=!1,se=!1,Te=-1;Et==="inherit"&&Gt?(Ce=!0,se=!0):Ut==="on"||Ut==="bounded"?se=!0:Ut==="wordWrapColumn"&&(Te=Ot);const qe=G.c({outerWidth:Ke,outerHeight:Ge,lineHeight:_e,typicalHalfwidthCharacterWidth:lt,pixelRatio:Ue,scrollBeyondLastLine:Wt,paddingTop:tt.top,paddingBottom:tt.bottom,minimap:Vt,verticalScrollbarWidth:ut,viewLineCount:Kt,remainingWidth:Fe,isViewportWrapping:se},Ie.memory||new A);qe.renderMinimap!==0&&qe.minimapLeft===0&&(Je+=qe.minimapWidth,zt+=qe.minimapWidth,Jt+=qe.minimapWidth,Me+=qe.minimapWidth);const xe=Fe-qe.minimapWidth,Qe=Math.max(1,Math.floor((xe-ut-2)/lt)),ot=mt?Nt:0;return se&&(Te=Math.max(1,Qe),Ut==="bounded"&&(Te=Math.min(Te,Ot))),{width:Ke,height:Ge,glyphMarginLeft:Je,glyphMarginWidth:It,glyphMarginDecorationLaneCount:Ie.glyphMarginDecorationLaneCount,lineNumbersLeft:zt,lineNumbersWidth:Rt,decorationsLeft:Jt,decorationsWidth:St,contentLeft:Me,contentWidth:xe,minimap:qe,viewportColumn:Qe,isWordWrapMinified:Ce,isViewportWrapping:se,wrappingColumn:Te,verticalScrollbarWidth:ut,horizontalScrollbarHeight:Pt,overviewRuler:{top:ot,width:ut,height:Ge-2*ot,right:0}}}}e.EditorLayoutInfoComputer=G;class oe extends I{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[b.localize(47,null),b.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:b.localize(49,null)}})}validate(ue){return s(ue,"simple",["simple","advanced"])}compute(ue,Ie,Ke){return Ie.get(2)===2?"advanced":Ke}}class _ extends I{constructor(){const ue={enabled:!0};super(64,"lightbulb",ue,{"editor.lightbulb.enabled":{type:"boolean",default:ue.enabled,description:b.localize(50,null)}})}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:{enabled:l(ue.enabled,this.defaultValue.enabled)}}}class Ee extends I{constructor(){const ue={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",ue,{"editor.stickyScroll.enabled":{type:"boolean",default:ue.enabled,description:b.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:ue.maxLineCount,minimum:1,maximum:10,description:b.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ue.defaultModel,description:b.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ue.scrollWithEditor,description:b.localize(54,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:l(Ie.enabled,this.defaultValue.enabled),maxLineCount:n.clampedInt(Ie.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:s(Ie.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:l(Ie.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class he extends I{constructor(){const ue={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",ue,{"editor.inlayHints.enabled":{type:"string",default:ue.enabled,description:b.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[b.localize(56,null),b.localize(57,null,f.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(58,null,f.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:ue.fontSize,markdownDescription:b.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ue.fontFamily,markdownDescription:b.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ue.padding,description:b.localize(62,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return typeof Ie.enabled=="boolean"&&(Ie.enabled=Ie.enabled?"on":"off"),{enabled:s(Ie.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:n.clampedInt(Ie.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ie.fontFamily,this.defaultValue.fontFamily),padding:l(Ie.padding,this.defaultValue.padding)}}}class q extends I{constructor(){super(65,"lineDecorationsWidth",10)}validate(ue){return typeof ue=="string"&&/^\d+(\.\d+)?ch$/.test(ue)?-parseFloat(ue.substring(0,ue.length-2)):n.clampedInt(ue,this.defaultValue,0,1e3)}compute(ue,Ie,Ke){return Ke<0?n.clampedInt(-Ke*ue.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ke}}class U extends a{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ue=>a.clamp(ue,0,150),{markdownDescription:b.localize(63,null)})}compute(ue,Ie,Ke){return ue.fontInfo.lineHeight}}class ne extends I{constructor(){const ue={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",ue,{"editor.minimap.enabled":{type:"boolean",default:ue.enabled,description:b.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:ue.autohide,description:b.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(66,null),b.localize(67,null),b.localize(68,null)],default:ue.size,description:b.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ue.side,description:b.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ue.showSlider,description:b.localize(71,null)},"editor.minimap.scale":{type:"number",default:ue.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ue.renderCharacters,description:b.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:ue.maxColumn,description:b.localize(74,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:l(Ie.enabled,this.defaultValue.enabled),autohide:l(Ie.autohide,this.defaultValue.autohide),size:s(Ie.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(Ie.side,this.defaultValue.side,["right","left"]),showSlider:s(Ie.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:l(Ie.renderCharacters,this.defaultValue.renderCharacters),scale:n.clampedInt(Ie.scale,1,1,3),maxColumn:n.clampedInt(Ie.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function be(le){return le==="ctrlCmd"?f.$j?"metaKey":"ctrlKey":"altKey"}class H extends I{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(76,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{top:n.clampedInt(Ie.top,0,0,1e3),bottom:n.clampedInt(Ie.bottom,0,0,1e3)}}}class x extends I{constructor(){const ue={enabled:!0,cycle:!0};super(85,"parameterHints",ue,{"editor.parameterHints.enabled":{type:"boolean",default:ue.enabled,description:b.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:ue.cycle,description:b.localize(78,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:l(Ie.enabled,this.defaultValue.enabled),cycle:l(Ie.cycle,this.defaultValue.cycle)}}}class Y extends S{constructor(){super(141)}compute(ue,Ie,Ke){return ue.pixelRatio}}class $e extends I{constructor(){const ue={other:"on",comments:"off",strings:"off"},Ie=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[b.localize(79,null),b.localize(80,null),b.localize(81,null)]}];super(88,"quickSuggestions",ue,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ie,default:ue.strings,description:b.localize(82,null)},comments:{anyOf:Ie,default:ue.comments,description:b.localize(83,null)},other:{anyOf:Ie,default:ue.other,description:b.localize(84,null)}},default:ue,markdownDescription:b.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ue}validate(ue){if(typeof ue=="boolean"){const Ue=ue?"on":"off";return{comments:Ue,strings:Ue,other:Ue}}if(!ue||typeof ue!="object")return this.defaultValue;const{other:Ie,comments:Ke,strings:Ge}=ue,_e=["on","inline","off"];let st,lt,wt;return typeof Ie=="boolean"?st=Ie?"on":"off":st=s(Ie,this.defaultValue.other,_e),typeof Ke=="boolean"?lt=Ke?"on":"off":lt=s(Ke,this.defaultValue.comments,_e),typeof Ge=="boolean"?wt=Ge?"on":"off":wt=s(Ge,this.defaultValue.strings,_e),{other:st,comments:lt,strings:wt}}}var ie;(function(le){le[le.Off=0]="Off",le[le.On=1]="On",le[le.Relative=2]="Relative",le[le.Interval=3]="Interval",le[le.Custom=4]="Custom"})(ie||(e.RenderLineNumbersType=ie={}));class fe extends I{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(86,null),b.localize(87,null),b.localize(88,null),b.localize(89,null)],default:"on",description:b.localize(90,null)})}validate(ue){let Ie=this.defaultValue.renderType,Ke=this.defaultValue.renderFn;return typeof ue<"u"&&(typeof ue=="function"?(Ie=4,Ke=ue):ue==="interval"?Ie=3:ue==="relative"?Ie=2:ue==="on"?Ie=1:Ie=0),{renderType:Ie,renderFn:Ke}}}function te(le){const ue=le.get(97);return ue==="editable"?le.get(90):ue!=="on"}e.filterValidationDecorations=te;class de extends I{constructor(){const ue=[],Ie={type:"number",description:b.localize(91,null)};super(101,"rulers",ue,{type:"array",items:{anyOf:[Ie,{type:["object"],properties:{column:Ie,color:{type:"string",description:b.localize(92,null),format:"color-hex"}}}]},default:ue,description:b.localize(93,null)})}validate(ue){if(Array.isArray(ue)){const Ie=[];for(const Ke of ue)if(typeof Ke=="number")Ie.push({column:n.clampedInt(Ke,0,0,1e4),color:null});else if(Ke&&typeof Ke=="object"){const Ge=Ke;Ie.push({column:n.clampedInt(Ge.column,0,0,1e4),color:Ge.color})}return Ie.sort((Ke,Ge)=>Ke.column-Ge.column),Ie}return this.defaultValue}}class pe extends I{constructor(){super(91,"readOnlyMessage",void 0)}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:ue}}function Pe(le,ue){if(typeof le!="string")return ue;switch(le){case"hidden":return 2;case"visible":return 3;default:return 1}}class B extends I{constructor(){const ue={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",ue,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(94,null),b.localize(95,null),b.localize(96,null)],default:"auto",description:b.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(98,null),b.localize(99,null),b.localize(100,null)],default:"auto",description:b.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ue.verticalScrollbarSize,description:b.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ue.horizontalScrollbarSize,description:b.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ue.scrollByPage,description:b.localize(104,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:ue.ignoreHorizontalScrollbarInContentHeight,description:b.localize(105,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue,Ke=n.clampedInt(Ie.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ge=n.clampedInt(Ie.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:n.clampedInt(Ie.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Pe(Ie.vertical,this.defaultValue.vertical),horizontal:Pe(Ie.horizontal,this.defaultValue.horizontal),useShadows:l(Ie.useShadows,this.defaultValue.useShadows),verticalHasArrows:l(Ie.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:l(Ie.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:l(Ie.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:l(Ie.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ke,horizontalSliderSize:n.clampedInt(Ie.horizontalSliderSize,Ke,0,1e3),verticalScrollbarSize:Ge,verticalSliderSize:n.clampedInt(Ie.verticalSliderSize,Ge,0,1e3),scrollByPage:l(Ie.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:l(Ie.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Z extends I{constructor(){const ue={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",ue,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.nonBasicASCII,description:b.localize(106,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ue.invisibleCharacters,description:b.localize(107,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ue.ambiguousCharacters,description:b.localize(108,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.includeComments,description:b.localize(109,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.includeStrings,description:b.localize(110,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ue.allowedCharacters,description:b.localize(111,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ue.allowedLocales,description:b.localize(112,null)}})}applyUpdate(ue,Ie){let Ke=!1;Ie.allowedCharacters&&ue&&(T.$en(ue.allowedCharacters,Ie.allowedCharacters)||(ue={...ue,allowedCharacters:Ie.allowedCharacters},Ke=!0)),Ie.allowedLocales&&ue&&(T.$en(ue.allowedLocales,Ie.allowedLocales)||(ue={...ue,allowedLocales:Ie.allowedLocales},Ke=!0));const Ge=super.applyUpdate(ue,Ie);return Ke?new $(Ge.newValue,!0):Ge}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{nonBasicASCII:ge(Ie.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:l(Ie.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:l(Ie.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ge(Ie.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ge(Ie.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ue.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ue.allowedLocales,this.defaultValue.allowedLocales)}}c(ue,Ie){if(typeof ue!="object"||!ue)return Ie;const Ke={};for(const[Ge,_e]of Object.entries(ue))_e===!0&&(Ke[Ge]=!0);return Ke}}class re extends I{constructor(){const ue={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",ue,{"editor.inlineSuggest.enabled":{type:"boolean",default:ue.enabled,description:b.localize(113,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ue.showToolbar,enum:["always","onHover"],enumDescriptions:[b.localize(114,null),b.localize(115,null)],description:b.localize(116,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ue.suppressSuggestions,description:b.localize(117,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:l(Ie.enabled,this.defaultValue.enabled),mode:s(Ie.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:s(Ie.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:l(Ie.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:l(Ie.keepOnBlur,this.defaultValue.keepOnBlur)}}}class ae extends I{constructor(){const ue={enabled:R.$9r.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.$9r.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ue,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ue.enabled,markdownDescription:b.localize(118,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ue.independentColorPoolPerBracketType,description:b.localize(119,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:l(Ie.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:l(Ie.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class ee extends I{constructor(){const ue={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ue,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(120,null),b.localize(121,null),b.localize(122,null)],default:ue.bracketPairs,description:b.localize(123,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(124,null),b.localize(125,null),b.localize(126,null)],default:ue.bracketPairsHorizontal,description:b.localize(127,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ue.highlightActiveBracketPair,description:b.localize(128,null)},"editor.guides.indentation":{type:"boolean",default:ue.indentation,description:b.localize(129,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[b.localize(130,null),b.localize(131,null),b.localize(132,null)],default:ue.highlightActiveIndentation,description:b.localize(133,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{bracketPairs:ge(Ie.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ge(Ie.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:l(Ie.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:l(Ie.indentation,this.defaultValue.indentation),highlightActiveIndentation:ge(Ie.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ge(le,ue,Ie){const Ke=Ie.indexOf(le);return Ke===-1?ue:Ie[Ke]}class ye extends I{constructor(){const ue={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",ue,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(134,null),b.localize(135,null)],default:ue.insertMode,description:b.localize(136,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ue.filterGraceful,description:b.localize(137,null)},"editor.suggest.localityBonus":{type:"boolean",default:ue.localityBonus,description:b.localize(138,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ue.shareSuggestSelections,markdownDescription:b.localize(139,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[b.localize(140,null),b.localize(141,null),b.localize(142,null),b.localize(143,null)],default:ue.selectionMode,markdownDescription:b.localize(144,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ue.snippetsPreventQuickSuggestions,description:b.localize(145,null)},"editor.suggest.showIcons":{type:"boolean",default:ue.showIcons,description:b.localize(146,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ue.showStatusBar,description:b.localize(147,null)},"editor.suggest.preview":{type:"boolean",default:ue.preview,description:b.localize(148,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ue.showInlineDetails,description:b.localize(149,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(150,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(151,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(152,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(153,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(154,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:b.localize(155,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:b.localize(156,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(157,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(158,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(159,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(160,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(161,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(162,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(163,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(164,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(165,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(166,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(167,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(168,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(169,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(170,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(171,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(172,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(173,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(174,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(175,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(176,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(177,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(178,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(179,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(180,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(181,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{insertMode:s(Ie.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:l(Ie.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:l(Ie.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:l(Ie.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:l(Ie.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:s(Ie.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:l(Ie.showIcons,this.defaultValue.showIcons),showStatusBar:l(Ie.showStatusBar,this.defaultValue.showStatusBar),preview:l(Ie.preview,this.defaultValue.preview),previewMode:s(Ie.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:l(Ie.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:l(Ie.showMethods,this.defaultValue.showMethods),showFunctions:l(Ie.showFunctions,this.defaultValue.showFunctions),showConstructors:l(Ie.showConstructors,this.defaultValue.showConstructors),showDeprecated:l(Ie.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:l(Ie.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:l(Ie.showFields,this.defaultValue.showFields),showVariables:l(Ie.showVariables,this.defaultValue.showVariables),showClasses:l(Ie.showClasses,this.defaultValue.showClasses),showStructs:l(Ie.showStructs,this.defaultValue.showStructs),showInterfaces:l(Ie.showInterfaces,this.defaultValue.showInterfaces),showModules:l(Ie.showModules,this.defaultValue.showModules),showProperties:l(Ie.showProperties,this.defaultValue.showProperties),showEvents:l(Ie.showEvents,this.defaultValue.showEvents),showOperators:l(Ie.showOperators,this.defaultValue.showOperators),showUnits:l(Ie.showUnits,this.defaultValue.showUnits),showValues:l(Ie.showValues,this.defaultValue.showValues),showConstants:l(Ie.showConstants,this.defaultValue.showConstants),showEnums:l(Ie.showEnums,this.defaultValue.showEnums),showEnumMembers:l(Ie.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:l(Ie.showKeywords,this.defaultValue.showKeywords),showWords:l(Ie.showWords,this.defaultValue.showWords),showColors:l(Ie.showColors,this.defaultValue.showColors),showFiles:l(Ie.showFiles,this.defaultValue.showFiles),showReferences:l(Ie.showReferences,this.defaultValue.showReferences),showFolders:l(Ie.showFolders,this.defaultValue.showFolders),showTypeParameters:l(Ie.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:l(Ie.showSnippets,this.defaultValue.showSnippets),showUsers:l(Ie.showUsers,this.defaultValue.showUsers),showIssues:l(Ie.showIssues,this.defaultValue.showIssues)}}}class ze extends I{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(182,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:b.localize(183,null),default:!0,type:"boolean"}})}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:l(ue.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:l(ue.selectSubwords,this.defaultValue.selectSubwords)}}}var We;(function(le){le[le.None=0]="None",le[le.Same=1]="Same",le[le.Indent=2]="Indent",le[le.DeepIndent=3]="DeepIndent"})(We||(e.WrappingIndent=We={}));class et extends I{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[b.localize(184,null),b.localize(185,null),b.localize(186,null),b.localize(187,null)],description:b.localize(188,null),default:"same"}})}validate(ue){switch(ue){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ue,Ie,Ke){return Ie.get(2)===2?0:Ke}}class Ye extends S{constructor(){super(144)}compute(ue,Ie,Ke){const Ge=Ie.get(143);return{isDominatedByLongLines:ue.isDominatedByLongLines,isWordWrapMinified:Ge.isWordWrapMinified,isViewportWrapping:Ge.isViewportWrapping,wrappingColumn:Ge.wrappingColumn}}}class rt extends I{constructor(){const ue={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ue,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ue.enabled,markdownDescription:b.localize(189,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:b.localize(190,null),enum:["afterDrop","never"],enumDescriptions:[b.localize(191,null),b.localize(192,null)],default:"afterDrop"}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:l(Ie.enabled,this.defaultValue.enabled),showDropSelector:s(Ie.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class nt extends I{constructor(){const ue={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",ue,{"editor.pasteAs.enabled":{type:"boolean",default:ue.enabled,markdownDescription:b.localize(193,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:b.localize(194,null),enum:["afterPaste","never"],enumDescriptions:[b.localize(195,null),b.localize(196,null)],default:"afterPaste"}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Ie=ue;return{enabled:l(Ie.enabled,this.defaultValue.enabled),showPasteSelector:s(Ie.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Ae="Consolas, 'Courier New', monospace",Ne="Menlo, Monaco, 'Courier New', monospace",Ve="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:f.$j?Ne:f.$k?Ve:Ae,fontWeight:"normal",fontSize:f.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Le(le){return e.editorOptionsRegistry[le.id]=le,le}var Xe;(function(le){le[le.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",le[le.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",le[le.accessibilitySupport=2]="accessibilitySupport",le[le.accessibilityPageSize=3]="accessibilityPageSize",le[le.ariaLabel=4]="ariaLabel",le[le.ariaRequired=5]="ariaRequired",le[le.autoClosingBrackets=6]="autoClosingBrackets",le[le.autoClosingComments=7]="autoClosingComments",le[le.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",le[le.autoClosingDelete=9]="autoClosingDelete",le[le.autoClosingOvertype=10]="autoClosingOvertype",le[le.autoClosingQuotes=11]="autoClosingQuotes",le[le.autoIndent=12]="autoIndent",le[le.automaticLayout=13]="automaticLayout",le[le.autoSurround=14]="autoSurround",le[le.bracketPairColorization=15]="bracketPairColorization",le[le.guides=16]="guides",le[le.codeLens=17]="codeLens",le[le.codeLensFontFamily=18]="codeLensFontFamily",le[le.codeLensFontSize=19]="codeLensFontSize",le[le.colorDecorators=20]="colorDecorators",le[le.colorDecoratorsLimit=21]="colorDecoratorsLimit",le[le.columnSelection=22]="columnSelection",le[le.comments=23]="comments",le[le.contextmenu=24]="contextmenu",le[le.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",le[le.cursorBlinking=26]="cursorBlinking",le[le.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",le[le.cursorStyle=28]="cursorStyle",le[le.cursorSurroundingLines=29]="cursorSurroundingLines",le[le.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",le[le.cursorWidth=31]="cursorWidth",le[le.disableLayerHinting=32]="disableLayerHinting",le[le.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",le[le.domReadOnly=34]="domReadOnly",le[le.dragAndDrop=35]="dragAndDrop",le[le.dropIntoEditor=36]="dropIntoEditor",le[le.emptySelectionClipboard=37]="emptySelectionClipboard",le[le.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",le[le.extraEditorClassName=39]="extraEditorClassName",le[le.fastScrollSensitivity=40]="fastScrollSensitivity",le[le.find=41]="find",le[le.fixedOverflowWidgets=42]="fixedOverflowWidgets",le[le.folding=43]="folding",le[le.foldingStrategy=44]="foldingStrategy",le[le.foldingHighlight=45]="foldingHighlight",le[le.foldingImportsByDefault=46]="foldingImportsByDefault",le[le.foldingMaximumRegions=47]="foldingMaximumRegions",le[le.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",le[le.fontFamily=49]="fontFamily",le[le.fontInfo=50]="fontInfo",le[le.fontLigatures=51]="fontLigatures",le[le.fontSize=52]="fontSize",le[le.fontWeight=53]="fontWeight",le[le.fontVariations=54]="fontVariations",le[le.formatOnPaste=55]="formatOnPaste",le[le.formatOnType=56]="formatOnType",le[le.glyphMargin=57]="glyphMargin",le[le.gotoLocation=58]="gotoLocation",le[le.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",le[le.hover=60]="hover",le[le.inDiffEditor=61]="inDiffEditor",le[le.inlineSuggest=62]="inlineSuggest",le[le.letterSpacing=63]="letterSpacing",le[le.lightbulb=64]="lightbulb",le[le.lineDecorationsWidth=65]="lineDecorationsWidth",le[le.lineHeight=66]="lineHeight",le[le.lineNumbers=67]="lineNumbers",le[le.lineNumbersMinChars=68]="lineNumbersMinChars",le[le.linkedEditing=69]="linkedEditing",le[le.links=70]="links",le[le.matchBrackets=71]="matchBrackets",le[le.minimap=72]="minimap",le[le.mouseStyle=73]="mouseStyle",le[le.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",le[le.mouseWheelZoom=75]="mouseWheelZoom",le[le.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",le[le.multiCursorModifier=77]="multiCursorModifier",le[le.multiCursorPaste=78]="multiCursorPaste",le[le.multiCursorLimit=79]="multiCursorLimit",le[le.occurrencesHighlight=80]="occurrencesHighlight",le[le.overviewRulerBorder=81]="overviewRulerBorder",le[le.overviewRulerLanes=82]="overviewRulerLanes",le[le.padding=83]="padding",le[le.pasteAs=84]="pasteAs",le[le.parameterHints=85]="parameterHints",le[le.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",le[le.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",le[le.quickSuggestions=88]="quickSuggestions",le[le.quickSuggestionsDelay=89]="quickSuggestionsDelay",le[le.readOnly=90]="readOnly",le[le.readOnlyMessage=91]="readOnlyMessage",le[le.renameOnType=92]="renameOnType",le[le.renderControlCharacters=93]="renderControlCharacters",le[le.renderFinalNewline=94]="renderFinalNewline",le[le.renderLineHighlight=95]="renderLineHighlight",le[le.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",le[le.renderValidationDecorations=97]="renderValidationDecorations",le[le.renderWhitespace=98]="renderWhitespace",le[le.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",le[le.roundedSelection=100]="roundedSelection",le[le.rulers=101]="rulers",le[le.scrollbar=102]="scrollbar",le[le.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",le[le.scrollBeyondLastLine=104]="scrollBeyondLastLine",le[le.scrollPredominantAxis=105]="scrollPredominantAxis",le[le.selectionClipboard=106]="selectionClipboard",le[le.selectionHighlight=107]="selectionHighlight",le[le.selectOnLineNumbers=108]="selectOnLineNumbers",le[le.showFoldingControls=109]="showFoldingControls",le[le.showUnused=110]="showUnused",le[le.snippetSuggestions=111]="snippetSuggestions",le[le.smartSelect=112]="smartSelect",le[le.smoothScrolling=113]="smoothScrolling",le[le.stickyScroll=114]="stickyScroll",le[le.stickyTabStops=115]="stickyTabStops",le[le.stopRenderingLineAfter=116]="stopRenderingLineAfter",le[le.suggest=117]="suggest",le[le.suggestFontSize=118]="suggestFontSize",le[le.suggestLineHeight=119]="suggestLineHeight",le[le.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",le[le.suggestSelection=121]="suggestSelection",le[le.tabCompletion=122]="tabCompletion",le[le.tabIndex=123]="tabIndex",le[le.unicodeHighlighting=124]="unicodeHighlighting",le[le.unusualLineTerminators=125]="unusualLineTerminators",le[le.useShadowDOM=126]="useShadowDOM",le[le.useTabStops=127]="useTabStops",le[le.wordBreak=128]="wordBreak",le[le.wordSeparators=129]="wordSeparators",le[le.wordWrap=130]="wordWrap",le[le.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",le[le.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",le[le.wordWrapColumn=133]="wordWrapColumn",le[le.wordWrapOverride1=134]="wordWrapOverride1",le[le.wordWrapOverride2=135]="wordWrapOverride2",le[le.wrappingIndent=136]="wrappingIndent",le[le.wrappingStrategy=137]="wrappingStrategy",le[le.showDeprecated=138]="showDeprecated",le[le.inlayHints=139]="inlayHints",le[le.editorClassName=140]="editorClassName",le[le.pixelRatio=141]="pixelRatio",le[le.tabFocusMode=142]="tabFocusMode",le[le.layoutInfo=143]="layoutInfo",le[le.wrappingInfo=144]="wrappingInfo",le[le.defaultColorDecorators=145]="defaultColorDecorators",le[le.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",le[le.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(Xe||(e.EditorOption=Xe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Le(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(197,null)})),acceptSuggestionOnEnter:Le(new d(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(198,null),""],markdownDescription:b.localize(199,null)})),accessibilitySupport:Le(new h),accessibilityPageSize:Le(new n(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(200,null),tags:["accessibility"]})),ariaLabel:Le(new t(4,"ariaLabel",b.localize(201,null))),ariaRequired:Le(new o(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Le(new o(8,"screenReaderAnnounceInlineSuggestion",!0,{description:b.localize(202,null),tags:["accessibility"]})),autoClosingBrackets:Le(new d(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(203,null),b.localize(204,null),""],description:b.localize(205,null)})),autoClosingComments:Le(new d(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(206,null),b.localize(207,null),""],description:b.localize(208,null)})),autoClosingDelete:Le(new d(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(209,null),""],description:b.localize(210,null)})),autoClosingOvertype:Le(new d(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(211,null),""],description:b.localize(212,null)})),autoClosingQuotes:Le(new d(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(213,null),b.localize(214,null),""],description:b.localize(215,null)})),autoIndent:Le(new c(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],u,{enumDescriptions:[b.localize(216,null),b.localize(217,null),b.localize(218,null),b.localize(219,null),b.localize(220,null)],description:b.localize(221,null)})),automaticLayout:Le(new o(13,"automaticLayout",!1)),autoSurround:Le(new d(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(222,null),b.localize(223,null),b.localize(224,null),""],description:b.localize(225,null)})),bracketPairColorization:Le(new ae),bracketPairGuides:Le(new ee),stickyTabStops:Le(new o(115,"stickyTabStops",!1,{description:b.localize(226,null)})),codeLens:Le(new o(17,"codeLens",!0,{description:b.localize(227,null)})),codeLensFontFamily:Le(new t(18,"codeLensFontFamily","",{description:b.localize(228,null)})),codeLensFontSize:Le(new n(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:b.localize(229,null)})),colorDecorators:Le(new o(20,"colorDecorators",!0,{description:b.localize(230,null)})),colorDecoratorActivatedOn:Le(new d(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[b.localize(231,null),b.localize(232,null),b.localize(233,null)],description:b.localize(234,null)})),colorDecoratorsLimit:Le(new n(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:b.localize(235,null)})),columnSelection:Le(new o(22,"columnSelection",!1,{description:b.localize(236,null)})),comments:Le(new E),contextmenu:Le(new o(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Le(new o(25,"copyWithSyntaxHighlighting",!0,{description:b.localize(237,null)})),cursorBlinking:Le(new c(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],m,{description:b.localize(238,null)})),cursorSmoothCaretAnimation:Le(new d(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[b.localize(239,null),b.localize(240,null),b.localize(241,null)],description:b.localize(242,null)})),cursorStyle:Le(new c(28,"cursorStyle",p.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:b.localize(243,null)})),cursorSurroundingLines:Le(new n(29,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(244,null)})),cursorSurroundingLinesStyle:Le(new d(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(245,null),b.localize(246,null)],markdownDescription:b.localize(247,null)})),cursorWidth:Le(new n(31,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(248,null)})),disableLayerHinting:Le(new o(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Le(new o(33,"disableMonospaceOptimizations",!1)),domReadOnly:Le(new o(34,"domReadOnly",!1)),dragAndDrop:Le(new o(35,"dragAndDrop",!0,{description:b.localize(249,null)})),emptySelectionClipboard:Le(new j),dropIntoEditor:Le(new rt),stickyScroll:Le(new Ee),experimentalWhitespaceRendering:Le(new d(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[b.localize(250,null),b.localize(251,null),b.localize(252,null)],description:b.localize(253,null)})),extraEditorClassName:Le(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Le(new a(40,"fastScrollSensitivity",5,le=>le<=0?5:le,{markdownDescription:b.localize(254,null)})),find:Le(new M),fixedOverflowWidgets:Le(new o(42,"fixedOverflowWidgets",!1)),folding:Le(new o(43,"folding",!0,{description:b.localize(255,null)})),foldingStrategy:Le(new d(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(256,null),b.localize(257,null)],description:b.localize(258,null)})),foldingHighlight:Le(new o(45,"foldingHighlight",!0,{description:b.localize(259,null)})),foldingImportsByDefault:Le(new o(46,"foldingImportsByDefault",!1,{description:b.localize(260,null)})),foldingMaximumRegions:Le(new n(47,"foldingMaximumRegions",5e3,10,65e3,{description:b.localize(261,null)})),unfoldOnClickAfterEndOfLine:Le(new o(48,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(262,null)})),fontFamily:Le(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(263,null)})),fontInfo:Le(new N),fontLigatures2:Le(new O),fontSize:Le(new W),fontWeight:Le(new X),fontVariations:Le(new F),formatOnPaste:Le(new o(55,"formatOnPaste",!1,{description:b.localize(264,null)})),formatOnType:Le(new o(56,"formatOnType",!1,{description:b.localize(265,null)})),glyphMargin:Le(new o(57,"glyphMargin",!0,{description:b.localize(266,null)})),gotoLocation:Le(new ce),hideCursorInOverviewRuler:Le(new o(59,"hideCursorInOverviewRuler",!1,{description:b.localize(267,null)})),hover:Le(new J),inDiffEditor:Le(new o(61,"inDiffEditor",!1)),letterSpacing:Le(new a(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,le=>a.clamp(le,-5,20),{description:b.localize(268,null)})),lightbulb:Le(new _),lineDecorationsWidth:Le(new q),lineHeight:Le(new U),lineNumbers:Le(new fe),lineNumbersMinChars:Le(new n(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Le(new o(69,"linkedEditing",!1,{description:b.localize(269,null)})),links:Le(new o(70,"links",!0,{description:b.localize(270,null)})),matchBrackets:Le(new d(71,"matchBrackets","always",["always","near","never"],{description:b.localize(271,null)})),minimap:Le(new ne),mouseStyle:Le(new d(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Le(new a(74,"mouseWheelScrollSensitivity",1,le=>le===0?1:le,{markdownDescription:b.localize(272,null)})),mouseWheelZoom:Le(new o(75,"mouseWheelZoom",!1,{markdownDescription:b.localize(273,null)})),multiCursorMergeOverlapping:Le(new o(76,"multiCursorMergeOverlapping",!0,{description:b.localize(274,null)})),multiCursorModifier:Le(new c(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],be,{markdownEnumDescriptions:[b.localize(275,null),b.localize(276,null)],markdownDescription:b.localize(277,null)})),multiCursorPaste:Le(new d(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(278,null),b.localize(279,null)],markdownDescription:b.localize(280,null)})),multiCursorLimit:Le(new n(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:b.localize(281,null)})),occurrencesHighlight:Le(new d(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[b.localize(282,null),b.localize(283,null),b.localize(284,null)],markdownDescription:b.localize(285,null)})),overviewRulerBorder:Le(new o(81,"overviewRulerBorder",!0,{description:b.localize(286,null)})),overviewRulerLanes:Le(new n(82,"overviewRulerLanes",3,0,3)),padding:Le(new H),pasteAs:Le(new nt),parameterHints:Le(new x),peekWidgetDefaultFocus:Le(new d(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(287,null),b.localize(288,null)],description:b.localize(289,null)})),definitionLinkOpensInPeek:Le(new o(87,"definitionLinkOpensInPeek",!1,{description:b.localize(290,null)})),quickSuggestions:Le(new $e),quickSuggestionsDelay:Le(new n(89,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(291,null)})),readOnly:Le(new o(90,"readOnly",!1)),readOnlyMessage:Le(new pe),renameOnType:Le(new o(92,"renameOnType",!1,{description:b.localize(292,null),markdownDeprecationMessage:b.localize(293,null)})),renderControlCharacters:Le(new o(93,"renderControlCharacters",!0,{description:b.localize(294,null),restricted:!0})),renderFinalNewline:Le(new d(94,"renderFinalNewline",f.$k?"dimmed":"on",["off","on","dimmed"],{description:b.localize(295,null)})),renderLineHighlight:Le(new d(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(296,null)],description:b.localize(297,null)})),renderLineHighlightOnlyWhenFocus:Le(new o(96,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(298,null)})),renderValidationDecorations:Le(new d(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Le(new d(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(299,null),b.localize(300,null),b.localize(301,null),""],description:b.localize(302,null)})),revealHorizontalRightPadding:Le(new n(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Le(new o(100,"roundedSelection",!0,{description:b.localize(303,null)})),rulers:Le(new de),scrollbar:Le(new B),scrollBeyondLastColumn:Le(new n(103,"scrollBeyondLastColumn",4,0,1073741824,{description:b.localize(304,null)})),scrollBeyondLastLine:Le(new o(104,"scrollBeyondLastLine",!0,{description:b.localize(305,null)})),scrollPredominantAxis:Le(new o(105,"scrollPredominantAxis",!0,{description:b.localize(306,null)})),selectionClipboard:Le(new o(106,"selectionClipboard",!0,{description:b.localize(307,null),included:f.$k})),selectionHighlight:Le(new o(107,"selectionHighlight",!0,{description:b.localize(308,null)})),selectOnLineNumbers:Le(new o(108,"selectOnLineNumbers",!0)),showFoldingControls:Le(new d(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[b.localize(309,null),b.localize(310,null),b.localize(311,null)],description:b.localize(312,null)})),showUnused:Le(new o(110,"showUnused",!0,{description:b.localize(313,null)})),showDeprecated:Le(new o(138,"showDeprecated",!0,{description:b.localize(314,null)})),inlayHints:Le(new he),snippetSuggestions:Le(new d(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(315,null),b.localize(316,null),b.localize(317,null),b.localize(318,null)],description:b.localize(319,null)})),smartSelect:Le(new ze),smoothScrolling:Le(new o(113,"smoothScrolling",!1,{description:b.localize(320,null)})),stopRenderingLineAfter:Le(new n(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Le(new ye),inlineSuggest:Le(new re),inlineCompletionsAccessibilityVerbose:Le(new o(147,"inlineCompletionsAccessibilityVerbose",!1,{description:b.localize(321,null)})),suggestFontSize:Le(new n(118,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(322,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Le(new n(119,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(323,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Le(new o(120,"suggestOnTriggerCharacters",!0,{description:b.localize(324,null)})),suggestSelection:Le(new d(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(325,null),b.localize(326,null),b.localize(327,null)],description:b.localize(328,null)})),tabCompletion:Le(new d(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(329,null),b.localize(330,null),b.localize(331,null)],description:b.localize(332,null)})),tabIndex:Le(new n(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Le(new Z),unusualLineTerminators:Le(new d(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(333,null),b.localize(334,null),b.localize(335,null)],description:b.localize(336,null)})),useShadowDOM:Le(new o(126,"useShadowDOM",!0)),useTabStops:Le(new o(127,"useTabStops",!0,{description:b.localize(337,null)})),wordBreak:Le(new d(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[b.localize(338,null),b.localize(339,null)],description:b.localize(340,null)})),wordSeparators:Le(new t(129,"wordSeparators",L.$0r,{description:b.localize(341,null)})),wordWrap:Le(new d(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(342,null),b.localize(343,null),b.localize(344,null),b.localize(345,null)],description:b.localize(346,null)})),wordWrapBreakAfterCharacters:Le(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Le(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Le(new n(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(347,null)})),wordWrapOverride1:Le(new d(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Le(new d(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Le(new z),defaultColorDecorators:Le(new o(145,"defaultColorDecorators",!1,{markdownDescription:b.localize(348,null)})),pixelRatio:Le(new Y),tabFocusMode:Le(new o(142,"tabFocusMode",!1,{markdownDescription:b.localize(349,null)})),layoutInfo:Le(new G),wrappingInfo:Le(new Ye),wrappingIndent:Le(new et),wrappingStrategy:Le(new oe)}}),define(ke[195],Se([9,10]),function(me,e){return me.create("vs/editor/common/languages",e)}),define(ke[83],Se([1,0,78,2,168,29,178,195]),function(me,e,C,T,f,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$qt=e.$pt=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$ot=e.$nt=e.SymbolKinds=e.SymbolTag=e.$mt=e.$lt=e.SymbolKind=e.$kt=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$jt=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$it=e.$ht=e.$gt=void 0;class y{constructor(O,F,N){this.offset=O,this.type=F,this.language=N,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$gt=y;class g{constructor(O,F){this.tokens=O,this.endState=F,this._tokenizationResultBrand=void 0}}e.$ht=g;class A{constructor(O,F){this.tokens=O,this.endState=F,this._encodedTokenizationResultBrand=void 0}}e.$it=A;var I;(function(M){M[M.Method=0]="Method",M[M.Function=1]="Function",M[M.Constructor=2]="Constructor",M[M.Field=3]="Field",M[M.Variable=4]="Variable",M[M.Class=5]="Class",M[M.Struct=6]="Struct",M[M.Interface=7]="Interface",M[M.Module=8]="Module",M[M.Property=9]="Property",M[M.Event=10]="Event",M[M.Operator=11]="Operator",M[M.Unit=12]="Unit",M[M.Value=13]="Value",M[M.Constant=14]="Constant",M[M.Enum=15]="Enum",M[M.EnumMember=16]="EnumMember",M[M.Keyword=17]="Keyword",M[M.Text=18]="Text",M[M.Color=19]="Color",M[M.File=20]="File",M[M.Reference=21]="Reference",M[M.Customcolor=22]="Customcolor",M[M.Folder=23]="Folder",M[M.TypeParameter=24]="TypeParameter",M[M.User=25]="User",M[M.Issue=26]="Issue",M[M.Snippet=27]="Snippet"})(I||(e.CompletionItemKind=I={}));var $;(function(M){const O=new Map;O.set(0,C.$1j.symbolMethod),O.set(1,C.$1j.symbolFunction),O.set(2,C.$1j.symbolConstructor),O.set(3,C.$1j.symbolField),O.set(4,C.$1j.symbolVariable),O.set(5,C.$1j.symbolClass),O.set(6,C.$1j.symbolStruct),O.set(7,C.$1j.symbolInterface),O.set(8,C.$1j.symbolModule),O.set(9,C.$1j.symbolProperty),O.set(10,C.$1j.symbolEvent),O.set(11,C.$1j.symbolOperator),O.set(12,C.$1j.symbolUnit),O.set(13,C.$1j.symbolValue),O.set(15,C.$1j.symbolEnum),O.set(14,C.$1j.symbolConstant),O.set(15,C.$1j.symbolEnum),O.set(16,C.$1j.symbolEnumMember),O.set(17,C.$1j.symbolKeyword),O.set(27,C.$1j.symbolSnippet),O.set(18,C.$1j.symbolText),O.set(19,C.$1j.symbolColor),O.set(20,C.$1j.symbolFile),O.set(21,C.$1j.symbolReference),O.set(22,C.$1j.symbolCustomColor),O.set(23,C.$1j.symbolFolder),O.set(24,C.$1j.symbolTypeParameter),O.set(25,C.$1j.account),O.set(26,C.$1j.issues);function F(X){let ce=O.get(X);return ce||(console.info("No codicon found for CompletionItemKind "+X),ce=C.$1j.symbolProperty),ce}M.toIcon=F;const N=new Map;N.set("method",0),N.set("function",1),N.set("constructor",2),N.set("field",3),N.set("variable",4),N.set("class",5),N.set("struct",6),N.set("interface",7),N.set("module",8),N.set("property",9),N.set("event",10),N.set("operator",11),N.set("unit",12),N.set("value",13),N.set("constant",14),N.set("enum",15),N.set("enum-member",16),N.set("enumMember",16),N.set("keyword",17),N.set("snippet",27),N.set("text",18),N.set("color",19),N.set("file",20),N.set("reference",21),N.set("customcolor",22),N.set("folder",23),N.set("type-parameter",24),N.set("typeParameter",24),N.set("account",25),N.set("issue",26);function W(X,ce){let J=N.get(X);return typeof J>"u"&&!ce&&(J=9),J}M.fromString=W})($||(e.CompletionItemKinds=$={}));var v;(function(M){M[M.Deprecated=1]="Deprecated"})(v||(e.CompletionItemTag=v={}));var S;(function(M){M[M.None=0]="None",M[M.KeepWhitespace=1]="KeepWhitespace",M[M.InsertAsSnippet=4]="InsertAsSnippet"})(S||(e.CompletionItemInsertTextRule=S={}));var w;(function(M){M[M.Invoke=0]="Invoke",M[M.TriggerCharacter=1]="TriggerCharacter",M[M.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w||(e.CompletionTriggerKind=w={}));var l;(function(M){M[M.Automatic=0]="Automatic",M[M.Explicit=1]="Explicit"})(l||(e.InlineCompletionTriggerKind=l={}));class o{constructor(O,F,N,W){this.range=O,this.text=F,this.completionKind=N,this.isSnippetText=W}equals(O){return R.$zs.lift(this.range).equalsRange(O.range)&&this.text===O.text&&this.completionKind===O.completionKind&&this.isSnippetText===O.isSnippetText}}e.$jt=o;var i;(function(M){M[M.Invoke=1]="Invoke",M[M.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var n;(function(M){M[M.Invoke=1]="Invoke",M[M.TriggerCharacter=2]="TriggerCharacter",M[M.ContentChange=3]="ContentChange"})(n||(e.SignatureHelpTriggerKind=n={}));var r;(function(M){M[M.Text=0]="Text",M[M.Read=1]="Read",M[M.Write=2]="Write"})(r||(e.DocumentHighlightKind=r={}));function a(M){return M&&T.URI.isUri(M.uri)&&R.$zs.isIRange(M.range)&&(R.$zs.isIRange(M.originSelectionRange)||R.$zs.isIRange(M.targetSelectionRange))}e.$kt=a;var t;(function(M){M[M.File=0]="File",M[M.Module=1]="Module",M[M.Namespace=2]="Namespace",M[M.Package=3]="Package",M[M.Class=4]="Class",M[M.Method=5]="Method",M[M.Property=6]="Property",M[M.Field=7]="Field",M[M.Constructor=8]="Constructor",M[M.Enum=9]="Enum",M[M.Interface=10]="Interface",M[M.Function=11]="Function",M[M.Variable=12]="Variable",M[M.Constant=13]="Constant",M[M.String=14]="String",M[M.Number=15]="Number",M[M.Boolean=16]="Boolean",M[M.Array=17]="Array",M[M.Object=18]="Object",M[M.Key=19]="Key",M[M.Null=20]="Null",M[M.EnumMember=21]="EnumMember",M[M.Struct=22]="Struct",M[M.Event=23]="Event",M[M.Operator=24]="Operator",M[M.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$lt={[17]:(0,b.localize)(0,null),[16]:(0,b.localize)(1,null),[4]:(0,b.localize)(2,null),[13]:(0,b.localize)(3,null),[8]:(0,b.localize)(4,null),[9]:(0,b.localize)(5,null),[21]:(0,b.localize)(6,null),[23]:(0,b.localize)(7,null),[7]:(0,b.localize)(8,null),[0]:(0,b.localize)(9,null),[11]:(0,b.localize)(10,null),[10]:(0,b.localize)(11,null),[19]:(0,b.localize)(12,null),[5]:(0,b.localize)(13,null),[1]:(0,b.localize)(14,null),[2]:(0,b.localize)(15,null),[20]:(0,b.localize)(16,null),[15]:(0,b.localize)(17,null),[18]:(0,b.localize)(18,null),[24]:(0,b.localize)(19,null),[3]:(0,b.localize)(20,null),[6]:(0,b.localize)(21,null),[14]:(0,b.localize)(22,null),[22]:(0,b.localize)(23,null),[25]:(0,b.localize)(24,null),[12]:(0,b.localize)(25,null)};function s(M,O){return(0,b.localize)(26,null,M,e.$lt[O])}e.$mt=s;var d;(function(M){M[M.Deprecated=1]="Deprecated"})(d||(e.SymbolTag=d={}));var c;(function(M){const O=new Map;O.set(0,C.$1j.symbolFile),O.set(1,C.$1j.symbolModule),O.set(2,C.$1j.symbolNamespace),O.set(3,C.$1j.symbolPackage),O.set(4,C.$1j.symbolClass),O.set(5,C.$1j.symbolMethod),O.set(6,C.$1j.symbolProperty),O.set(7,C.$1j.symbolField),O.set(8,C.$1j.symbolConstructor),O.set(9,C.$1j.symbolEnum),O.set(10,C.$1j.symbolInterface),O.set(11,C.$1j.symbolFunction),O.set(12,C.$1j.symbolVariable),O.set(13,C.$1j.symbolConstant),O.set(14,C.$1j.symbolString),O.set(15,C.$1j.symbolNumber),O.set(16,C.$1j.symbolBoolean),O.set(17,C.$1j.symbolArray),O.set(18,C.$1j.symbolObject),O.set(19,C.$1j.symbolKey),O.set(20,C.$1j.symbolNull),O.set(21,C.$1j.symbolEnumMember),O.set(22,C.$1j.symbolStruct),O.set(23,C.$1j.symbolEvent),O.set(24,C.$1j.symbolOperator),O.set(25,C.$1j.symbolTypeParameter);function F(N){let W=O.get(N);return W||(console.info("No codicon found for SymbolKind "+N),W=C.$1j.symbolProperty),W}M.toIcon=F})(c||(e.SymbolKinds=c={}));class u{static asEditOperation(O){return f.$As.replace(R.$zs.lift(O.range),O.text)}}e.$nt=u;class h{static{this.Comment=new h("comment")}static{this.Imports=new h("imports")}static{this.Region=new h("region")}static fromValue(O){switch(O){case"comment":return h.Comment;case"imports":return h.Imports;case"region":return h.Region}return new h(O)}constructor(O){this.value=O}}e.$ot=h;var E;(function(M){function O(F){return!F||typeof F!="object"?!1:typeof F.id=="string"&&typeof F.title=="string"}M.is=O})(E||(e.Command=E={}));var D;(function(M){M[M.Collapsed=0]="Collapsed",M[M.Expanded=1]="Expanded"})(D||(e.CommentThreadCollapsibleState=D={}));var m;(function(M){M[M.Unresolved=0]="Unresolved",M[M.Resolved=1]="Resolved"})(m||(e.CommentThreadState=m={}));var p;(function(M){M[M.Editing=0]="Editing",M[M.Preview=1]="Preview"})(p||(e.CommentMode=p={}));var k;(function(M){M[M.Published=0]="Published",M[M.Draft=1]="Draft"})(k||(e.CommentState=k={}));var P;(function(M){M[M.Type=1]="Type",M[M.Parameter=2]="Parameter"})(P||(e.InlayHintKind=P={}));class z{constructor(O){this.b=O,this.a=null}dispose(){this.a&&this.a.then(O=>{O&&O.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$pt=z,e.$qt=new L.$$s;var j;(function(M){M[M.None=0]="None",M[M.Option=1]="Option",M[M.Default=2]="Default",M[M.Preferred=3]="Preferred"})(j||(e.ExternalUriOpenerPriority=j={}))}),define(ke[196],Se([9,10]),function(me,e){return me.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ke[197],Se([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/contextkey",e)}),define(ke[198],Se([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/scanner",e)}),define(ke[199],Se([9,10]),function(me,e){return me.create("vs/platform/dialogs/common/dialogs",e)}),define(ke[200],Se([9,10]),function(me,e){return me.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ke[201],Se([9,10]),function(me,e){return me.create("vs/platform/extensions/common/extensionValidator",e)}),define(ke[202],Se([9,10]),function(me,e){return me.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ke[203],Se([9,10]),function(me,e){return me.create("vs/platform/files/common/files",e)}),define(ke[204],Se([9,10]),function(me,e){return me.create("vs/platform/files/common/io",e)}),define(ke[205],Se([9,10]),function(me,e){return me.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ke[206],Se([9,10]),function(me,e){return me.create("vs/platform/markers/common/markers",e)}),define(ke[207],Se([9,10]),function(me,e){return me.create("vs/platform/theme/common/iconRegistry",e)}),define(ke[208],Se([9,10]),function(me,e){return me.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ke[209],Se([9,10]),function(me,e){return me.create("vs/platform/workspace/common/workspace",e)}),define(ke[210],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(ke[211],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ke[212],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ke[213],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(ke[214],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLogService",e)}),define(ke[215],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostNotebook",e)}),define(ke[216],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostProgress",e)}),define(ke[217],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ke[218],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ke[219],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ke[220],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ke[221],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTunnelService",e)}),define(ke[222],Se([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ke[223],Se([9,10]),function(me,e){return me.create("vs/workbench/api/node/extHostDebugService",e)}),define(ke[224],Se([9,10]),function(me,e){return me.create("vs/workbench/common/configuration",e)}),define(ke[225],Se([9,10]),function(me,e){return me.create("vs/workbench/common/editor",e)}),define(ke[226],Se([9,10]),function(me,e){return me.create("vs/workbench/common/views",e)}),define(ke[227],Se([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ke[228],Se([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/debug",e)}),define(ke[229],Se([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ke[230],Se([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ke[231],Se([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ke[232],Se([9,10]),function(me,e){return me.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ke[233],Se([9,10]),function(me,e){return me.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(ke[234],Se([9,10]),function(me,e){return me.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ke[235],Se([9,10]),function(me,e){return me.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(ke[236],Se([9,10]),function(me,e){return me.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ke[237],Se([1,0,8,198]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.TokenType=void 0;var f;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(f||(e.TokenType=f={}));function R(...g){switch(g.length){case 1:return(0,T.localize)(0,null,g[0]);case 2:return(0,T.localize)(1,null,g[0],g[1]);case 3:return(0,T.localize)(2,null,g[0],g[1],g[2]);default:return}}const L=(0,T.localize)(3,null),b=(0,T.localize)(4,null);class y{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,C.$7)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const I=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:I})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const I=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:I})}else this.h(126)?this.k(9):this.l(R("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(R("&&"));break;case 124:this.h(124)?this.k(16):this.l(R("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const I=this.d,$=this.c.substring(this.d,this.e),v={type:19,offset:this.d,lexeme:$};this.g.push({offset:I,lexeme:$,additionalInfo:A}),this.f.push(v)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const I=this.c.substring(this.d,this.e),$=y.b.get(I);$?this.k($):this.f.push({type:17,lexeme:I,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(L);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,I=!1,$=!1;for(;;){if(A>=this.c.length){this.e=A,this.l(b);return}const S=this.c.charCodeAt(A);if(I)I=!1;else if(S===47&&!$){A++;break}else S===91?$=!0:S===92?I=!0:S===93&&($=!1);A++}for(;A<this.c.length&&y.a.has(this.c.charCodeAt(A));)A++;this.e=A;const v=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:v,offset:this.d})}r(){return this.e>=this.c.length}}e.$Qi=y}),define(ke[238],Se([1,0,23,39,201,386]),function(me,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function y(o){return o=o.trim(),o==="*"||L.test(o)}e.$Ro=y;function g(o){if(!y(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=o.match(L);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}e.$So=g;function A(o){if(!o)return null;const i=o.majorBase,n=o.majorMustEqual,r=o.minorBase;let a=o.minorMustEqual;const t=o.patchBase;let s=o.patchMustEqual;o.hasCaret&&(i===0||(a=!1),s=!1);let d=0;if(o.preRelease){const c=b.exec(o.preRelease);if(c){const[,u,h,E]=c;d=Date.UTC(Number(u),Number(h)-1,Number(E))}}return{majorBase:i,majorMustEqual:n,minorBase:r,minorMustEqual:a,patchBase:t,patchMustEqual:s,isMinimum:o.hasGreaterEquals,notBefore:d}}e.$To=A;function I(o,i,n){let r;typeof o=="string"?r=A(g(o)):r=o;let a;i instanceof Date?a=i.getTime():typeof i=="string"&&(a=new Date(i).getTime());let t;if(typeof n=="string"?t=A(g(n)):t=n,!r||!t)return!1;const s=r.majorBase,d=r.minorBase,c=r.patchBase;let u=t.majorBase,h=t.minorBase,E=t.patchBase;const D=t.notBefore;let m=t.majorMustEqual,p=t.minorMustEqual,k=t.patchMustEqual;return t.isMinimum?s>u?!0:s<u?!1:d>h?!0:d<h||a&&a<D?!1:c>=E:(s===1&&u===0&&(!m||!p||!k)&&(u=1,h=0,E=0,m=!0,p=!1,k=!1),s<u?!1:s>u?!m:d<h?!1:d>h?!p:c<E?!1:c>E?!k:!(a&&a<D))}e.$Uo=I;function $(o,i,n,r,a){const t=[];if(typeof r.publisher<"u"&&typeof r.publisher!="string")return t.push([T.default.Error,f.localize(0,null)]),t;if(typeof r.name!="string")return t.push([T.default.Error,f.localize(1,null,"name")]),t;if(typeof r.version!="string")return t.push([T.default.Error,f.localize(2,null,"version")]),t;if(!r.engines)return t.push([T.default.Error,f.localize(3,null,"engines")]),t;if(typeof r.engines.vscode!="string")return t.push([T.default.Error,f.localize(4,null,"engines.vscode")]),t;if(typeof r.extensionDependencies<"u"&&!l(r.extensionDependencies))return t.push([T.default.Error,f.localize(5,null,"extensionDependencies")]),t;if(typeof r.activationEvents<"u"){if(!l(r.activationEvents))return t.push([T.default.Error,f.localize(6,null,"activationEvents")]),t;if(typeof r.main>"u"&&typeof r.browser>"u")return t.push([T.default.Error,f.localize(7,null,"activationEvents","main","browser")]),t}if(typeof r.extensionKind<"u"&&typeof r.main>"u"&&t.push([T.default.Warning,f.localize(8,null,"extensionKind")]),typeof r.main<"u"){if(typeof r.main!="string")return t.push([T.default.Error,f.localize(9,null,"main")]),t;{const c=(0,C.$zg)(n,r.main);(0,C.$tg)(c,n)||t.push([T.default.Warning,f.localize(10,null,c.path,n.path)])}}if(typeof r.browser<"u"){if(typeof r.browser!="string")return t.push([T.default.Error,f.localize(11,null,"browser")]),t;{const c=(0,C.$zg)(n,r.browser);(0,C.$tg)(c,n)||t.push([T.default.Warning,f.localize(12,null,c.path,n.path)])}}if(!R.valid(r.version))return t.push([T.default.Error,f.localize(13,null)]),t;const s=[];if(!v(o,i,r,a,s))for(const c of s)t.push([T.default.Error,c]);return t}e.$Vo=$;function v(o,i,n,r,a){return r||typeof n.main>"u"&&typeof n.browser>"u"?!0:w(o,i,n.engines.vscode,a)}e.$Wo=v;function S(o,i,n){return o==="*"||w(i,n,o)}e.$Xo=S;function w(o,i,n,r=[]){const a=A(g(n));if(!a)return r.push(f.localize(14,null,n)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return r.push(f.localize(15,null,n)),!1}else if(!a.majorMustEqual)return r.push(f.localize(16,null,n)),!1;return I(o,i,a)?!0:(r.push(f.localize(17,null,o,n)),!1)}function l(o){if(!Array.isArray(o))return!1;for(let i=0,n=o.length;i<n;i++)if(typeof o[i]!="string")return!1;return!0}}),define(ke[105],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sh=void 0;class C{constructor(f,R=[],L=!1){this.ctor=f,this.staticArguments=R,this.supportsDelayedInstantiation=L}}e.$Sh=C}),define(ke[106],Se([1,0,105]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=e.$Cr=e.InstantiationType=void 0;const T=[];var f;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(f||(e.InstantiationType=f={}));function R(b,y,g){y instanceof C.$Sh||(y=new C.$Sh(y,[],!!g)),T.push([b,y])}e.$Cr=R;function L(){return T}e.$Dr=L}),define(ke[239],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=e.$hq=void 0;class C{constructor(R,L){this.key=R,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.$hq=C;class T{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const L of this.a.values())L.outgoing.size===0&&R.push(L);return R}insertEdge(R,L){const b=this.lookupOrInsertNode(R),y=this.lookupOrInsertNode(L);b.outgoing.set(y.key,y),y.incoming.set(b.key,b)}removeNode(R){const L=this.b(R);this.a.delete(L);for(const b of this.a.values())b.outgoing.delete(L),b.incoming.delete(L)}lookupOrInsertNode(R){const L=this.b(R);let b=this.a.get(L);return b||(b=new C(L,R),this.a.set(L,b)),b}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[L,b]of this.a)R.push(`${L}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,L]of this.a){const b=new Set([R]),y=this.c(L,b);if(y)return y}}c(R,L){for(const[b,y]of R.outgoing){if(L.has(b))return[...L,b].join(" -> ");L.add(b);const g=this.c(y,L);if(g)return g;L.delete(b)}}}e.$iq=T}),define(ke[5],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wh=e.$Vh=e.$Uh=e._util=void 0;var C;(function(L){L.serviceIds=new Map,L.DI_TARGET="$di$target",L.DI_DEPENDENCIES="$di$dependencies";function b(y){return y[L.DI_DEPENDENCIES]||[]}L.getServiceDependencies=b})(C||(e._util=C={})),e.$Uh=f("instantiationService");function T(L,b,y){b[C.DI_TARGET]===b?b[C.DI_DEPENDENCIES].push({id:L,index:y}):(b[C.DI_DEPENDENCIES]=[{id:L,index:y}],b[C.DI_TARGET]=b)}function f(L){if(C.serviceIds.has(L))return C.serviceIds.get(L);const b=function(y,g,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(b,y,A)};return b.toString=()=>L,C.serviceIds.set(L,b),b}e.$Vh=f;function R(L){return L}e.$Wh=R}),define(ke[44],Se([1,0,18,2,5]),function(me,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.ConfigurationTarget=e.$ri=e.$qi=e.$pi=void 0,e.$pi=(0,f.$Vh)("configurationService");function R(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof T.URI)}e.$qi=R;function L(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof T.URI)}e.$ri=L;var b;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function y(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$si=y;function g(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}e.$ti=g;function A(o,i){const n=Object.create(null);for(const r in o)I(n,r,o[r],i);return n}e.$ui=A;function I(o,i,n,r){const a=i.split("."),t=a.pop();let s=o;for(let d=0;d<a.length;d++){const c=a[d];let u=s[c];switch(typeof u){case"undefined":u=s[c]=Object.create(null);break;case"object":break;default:r(`Ignoring ${i} as ${a.slice(0,d+1).join(".")} is ${JSON.stringify(u)}`);return}s=u}if(typeof s=="object"&&s!==null)try{s[t]=n}catch{r(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(s)}`)}else r(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(s)}`)}e.$vi=I;function $(o,i){const n=i.split(".");v(o,n)}e.$wi=$;function v(o,i){const n=i.shift();if(i.length===0){delete o[n];return}if(Object.keys(o).indexOf(n)!==-1){const r=o[n];typeof r=="object"&&!Array.isArray(r)&&(v(r,i),Object.keys(r).length===0&&delete o[n])}}function S(o,i,n){function r(s,d){let c=s;for(const u of d){if(typeof c!="object"||c===null)return;c=c[u]}return c}const a=i.split("."),t=r(o,a);return typeof t>"u"?n:t}e.$xi=S;function w(o,i,n){Object.keys(i).forEach(r=>{r!=="__proto__"&&(r in o?C.$Ef(o[r])&&C.$Ef(i[r])?w(o[r],i[r],n):n&&(o[r]=i[r]):o[r]=i[r])})}e.$yi=w;function l(o){return o.replace(/[\[\]]/g,"")}e.$zi=l}),define(ke[45],Se([1,0,11,13,237,5,197,8]),function(me,e,C,T,f,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.ContextKeyExprType=e.$Ri=void 0;const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",C.$j),y.set("isLinux",C.$k),y.set("isWindows",C.$i),y.set("isWeb",C.$o),y.set("isMacNative",C.$j&&!C.$o),y.set("isEdge",C.$H),y.set("isFirefox",C.$F),y.set("isChrome",C.$E),y.set("isSafari",C.$G);function g(q,U){if(y.get(q)!==void 0)throw(0,b.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");y.set(q,U)}e.$Ri=g;const A=Object.prototype.hasOwnProperty;var I;(function(q){q[q.False=0]="False",q[q.True=1]="True",q[q.Defined=2]="Defined",q[q.Not=3]="Not",q[q.Equals=4]="Equals",q[q.NotEquals=5]="NotEquals",q[q.And=6]="And",q[q.Regex=7]="Regex",q[q.NotRegex=8]="NotRegex",q[q.Or=9]="Or",q[q.In=10]="In",q[q.NotIn=11]="NotIn",q[q.Greater=12]="Greater",q[q.GreaterEquals=13]="GreaterEquals",q[q.Smaller=14]="Smaller",q[q.SmallerEquals=15]="SmallerEquals"})(I||(e.ContextKeyExprType=I={}));const $={regexParsingWithErrorRecovery:!0},v=(0,L.localize)(0,null),S=(0,L.localize)(1,null),w=(0,L.localize)(2,null),l=(0,L.localize)(3,null),o=(0,L.localize)(4,null),i=(0,L.localize)(5,null),n=(0,L.localize)(6,null),r=(0,L.localize)(7,null);class a{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=$){this.k=U,this.d=new f.$Qi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:v,offset:0,lexeme:"",additionalInfo:S});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const ne=this.l();if(!this.E()){const be=this.D(),H=be.type===17?i:void 0;throw this.h.push({message:o,offset:be.offset,lexeme:f.$Qi.getLexeme(be),additionalInfo:H}),a.c}return ne}catch(ne){if(ne!==a.c)throw ne;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(16);){const ne=this.o();U.push(ne)}return U.length===1?U[0]:t.or(...U)}o(){const U=[this.s()];for(;this.y(15);){const ne=this.s();U.push(ne)}return U.length===1?U[0]:t.and(...U)}s(){if(this.y(2)){const U=this.D();switch(U.type){case 11:return this.z(),u.INSTANCE;case 12:return this.z(),h.INSTANCE;case 0:{this.z();const ne=this.l();return this.A(1,l),ne?.negate()}case 17:return this.z(),P.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ne=this.l();return this.A(1,l),ne}case 17:{const ne=U.lexeme;if(this.z(),this.y(9)){const H=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),H.type!==10)throw this.B("REGEX",H);const x=H.lexeme,Y=x.lastIndexOf("/"),$e=Y===x.length-1?void 0:this.w(x.substring(Y+1));let ie;try{ie=new RegExp(x.substring(1,Y),$e)}catch{throw this.B("REGEX",H)}return N.create(ne,ie)}switch(H.type){case 10:case 19:{const x=[H.lexeme];this.z();let Y=this.D(),$e=0;for(let pe=0;pe<H.lexeme.length;pe++)H.lexeme.charCodeAt(pe)===40?$e++:H.lexeme.charCodeAt(pe)===41&&$e--;for(;!this.E()&&Y.type!==15&&Y.type!==16;){switch(Y.type){case 0:$e++;break;case 1:$e--;break;case 10:case 18:for(let pe=0;pe<Y.lexeme.length;pe++)Y.lexeme.charCodeAt(pe)===40?$e++:H.lexeme.charCodeAt(pe)===41&&$e--}if($e<0)break;x.push(f.$Qi.getLexeme(Y)),this.z(),Y=this.D()}const ie=x.join(""),fe=ie.lastIndexOf("/"),te=fe===ie.length-1?void 0:this.w(ie.substring(fe+1));let de;try{de=new RegExp(ie.substring(1,fe),te)}catch{throw this.B("REGEX",H)}return t.regex(ne,de)}case 18:{const x=H.lexeme;this.z();let Y=null;if(!(0,T.$Fe)(x)){const $e=x.indexOf("/"),ie=x.lastIndexOf("/");if($e!==ie&&$e>=0){const fe=x.slice($e+1,ie),te=x[ie+1]==="i"?"i":"";try{Y=new RegExp(fe,te)}catch{throw this.B("REGEX",H)}}}if(Y===null)throw this.B("REGEX",H);return N.create(ne,Y)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,w);const H=this.u();return t.notIn(ne,H)}switch(this.D().type){case 3:{this.z();const H=this.u();if(this.x().type===18)return t.equals(ne,H);switch(H){case"true":return t.has(ne);case"false":return t.not(ne);default:return t.equals(ne,H)}}case 4:{this.z();const H=this.u();if(this.x().type===18)return t.notEquals(ne,H);switch(H){case"true":return t.not(ne);case"false":return t.has(ne);default:return t.notEquals(ne,H)}}case 5:return this.z(),O.create(ne,this.u());case 6:return this.z(),F.create(ne,this.u());case 7:return this.z(),j.create(ne,this.u());case 8:return this.z(),M.create(ne,this.u());case 13:return this.z(),t.in(ne,this.u());default:return t.has(ne)}}case 20:throw this.h.push({message:n,offset:U.offset,lexeme:"",additionalInfo:r}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case 17:case 18:return this.z(),U.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,ne){if(this.C(U))return this.z();throw this.B(ne,this.D())}B(U,ne,be){const H=(0,L.localize)(8,null,U,f.$Qi.getLexeme(ne)),x=ne.offset,Y=f.$Qi.getLexeme(ne);return this.h.push({message:H,offset:x,lexeme:Y,additionalInfo:be}),a.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Si=a;class t{static false(){return u.INSTANCE}static true(){return h.INSTANCE}static has(U){return E.create(U)}static equals(U,ne){return D.create(U,ne)}static notEquals(U,ne){return k.create(U,ne)}static regex(U,ne){return N.create(U,ne)}static in(U,ne){return m.create(U,ne)}static notIn(U,ne){return p.create(U,ne)}static not(U){return P.create(U)}static and(...U){return ce.create(U,null,!0)}static or(...U){return J.create(U,null,!0)}static greater(U,ne){return j.create(U,ne)}static greaterEquals(U,ne){return M.create(U,ne)}static smaller(U,ne){return O.create(U,ne)}static smallerEquals(U,ne){return F.create(U,ne)}static{this.c=new a({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$Ti=t;function s(q){const U=new a({regexParsingWithErrorRecovery:!1});return q.map(ne=>(U.parse(ne),U.lexingErrors.length>0?U.lexingErrors.map(be=>({errorMessage:be.additionalInfo?(0,L.localize)(9,null,be.additionalInfo):(0,L.localize)(10,null),offset:be.offset,length:be.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(be=>({errorMessage:be.additionalInfo?`${be.message}. ${be.additionalInfo}`:be.message,offset:be.offset,length:be.lexeme.length})):[]))}e.$Ui=s;function d(q,U){const ne=q?q.substituteConstants():void 0,be=U?U.substituteConstants():void 0;return!ne&&!be?!0:!ne||!be?!1:ne.equals(be)}e.$Vi=d;function c(q,U){return q.cmp(U)}class u{static{this.INSTANCE=new u}constructor(){this.type=0}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return h.INSTANCE}}e.$Wi=u;class h{static{this.INSTANCE=new h}constructor(){this.type=1}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return u.INSTANCE}}e.$Xi=h;class E{static create(U,ne=null){const be=y.get(U);return typeof be=="boolean"?be?h.INSTANCE:u.INSTANCE:new E(U,ne)}constructor(U,ne){this.key=U,this.c=ne,this.type=2}cmp(U){return U.type!==this.type?this.type-U.type:G(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=y.get(this.key);return typeof U=="boolean"?U?h.INSTANCE:u.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$Yi=E;class D{static create(U,ne,be=null){if(typeof ne=="boolean")return ne?E.create(U,be):P.create(U,be);const H=y.get(U);return typeof H=="boolean"?ne===(H?"true":"false")?h.INSTANCE:u.INSTANCE:new D(U,ne,be)}constructor(U,ne,be){this.c=U,this.d=ne,this.f=be,this.type=4}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=y.get(this.c);if(typeof U=="boolean"){const ne=U?"true":"false";return this.d===ne?h.INSTANCE:u.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Zi=D;class m{static create(U,ne){return new m(U,ne)}constructor(U,ne){this.d=U,this.f=ne,this.type=10,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const ne=U.getValue(this.f),be=U.getValue(this.d);return Array.isArray(ne)?ne.includes(be):typeof be=="string"&&typeof ne=="object"&&ne!==null?A.call(ne,be):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=p.create(this.d,this.f)),this.c}}e.$1i=m;class p{static create(U,ne){return new p(U,ne)}constructor(U,ne){this.d=U,this.f=ne,this.type=11,this.c=m.create(U,ne)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$2i=p;class k{static create(U,ne,be=null){if(typeof ne=="boolean")return ne?P.create(U,be):E.create(U,be);const H=y.get(U);return typeof H=="boolean"?ne===(H?"true":"false")?u.INSTANCE:h.INSTANCE:new k(U,ne,be)}constructor(U,ne,be){this.c=U,this.d=ne,this.f=be,this.type=5}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=y.get(this.c);if(typeof U=="boolean"){const ne=U?"true":"false";return this.d===ne?u.INSTANCE:h.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$3i=k;class P{static create(U,ne=null){const be=y.get(U);return typeof be=="boolean"?be?u.INSTANCE:h.INSTANCE:new P(U,ne)}constructor(U,ne){this.c=U,this.d=ne,this.type=3}cmp(U){return U.type!==this.type?this.type-U.type:G(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=y.get(this.c);return typeof U=="boolean"?U?u.INSTANCE:h.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=E.create(this.c,this)),this.d}}e.$4i=P;function z(q,U){if(typeof q=="string"){const ne=parseFloat(q);isNaN(ne)||(q=ne)}return typeof q=="string"||typeof q=="number"?U(q):u.INSTANCE}class j{static create(U,ne,be=null){return z(ne,H=>new j(U,H,be))}constructor(U,ne,be){this.c=U,this.d=ne,this.f=be,this.type=12}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$5i=j;class M{static create(U,ne,be=null){return z(ne,H=>new M(U,H,be))}constructor(U,ne,be){this.c=U,this.d=ne,this.f=be,this.type=13}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$6i=M;class O{static create(U,ne,be=null){return z(ne,H=>new O(U,H,be))}constructor(U,ne,be){this.c=U,this.d=ne,this.f=be,this.type=14}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$7i=O;class F{static create(U,ne,be=null){return z(ne,H=>new F(U,H,be))}constructor(U,ne,be){this.c=U,this.d=ne,this.f=be,this.type=15}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$8i=F;class N{static create(U,ne){return new N(U,ne)}constructor(U,ne){this.d=U,this.f=ne,this.type=7,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const ne=this.f?this.f.source:"",be=U.f?U.f.source:"";return ne<be?-1:ne>be?1:0}equals(U){if(U.type===this.type){const ne=this.f?this.f.source:"",be=U.f?U.f.source:"";return this.d===U.d&&ne===be}return!1}substituteConstants(){return this}evaluate(U){const ne=U.getValue(this.d);return this.f?this.f.test(ne):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=W.create(this)),this.c}}e.$9i=N;class W{static create(U){return new W(U)}constructor(U){this.c=U,this.type=8}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new W(this.c.map(U))}negate(){return this.c}}e.$0i=W;function X(q){let U=null;for(let ne=0,be=q.length;ne<be;ne++){const H=q[ne].substituteConstants();if(q[ne]!==H&&U===null){U=[];for(let x=0;x<ne;x++)U[x]=q[x]}U!==null&&(U[ne]=H)}return U===null?q:U}class ce{static create(U,ne,be){return ce.d(U,ne,be)}constructor(U,ne){this.expr=U,this.c=ne,this.type=6}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ne=0,be=this.expr.length;ne<be;ne++){const H=c(this.expr[ne],U.expr[ne]);if(H!==0)return H}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ne=0,be=this.expr.length;ne<be;ne++)if(!this.expr[ne].equals(U.expr[ne]))return!1;return!0}return!1}substituteConstants(){const U=X(this.expr);return U===this.expr?this:ce.create(U,this.c,!1)}evaluate(U){for(let ne=0,be=this.expr.length;ne<be;ne++)if(!this.expr[ne].evaluate(U))return!1;return!0}static d(U,ne,be){const H=[];let x=!1;for(const Y of U)if(Y){if(Y.type===1){x=!0;continue}if(Y.type===0)return u.INSTANCE;if(Y.type===6){H.push(...Y.expr);continue}H.push(Y)}if(H.length===0&&x)return h.INSTANCE;if(H.length!==0){if(H.length===1)return H[0];H.sort(c);for(let Y=1;Y<H.length;Y++)H[Y-1].equals(H[Y])&&(H.splice(Y,1),Y--);if(H.length===1)return H[0];for(;H.length>1;){const Y=H[H.length-1];if(Y.type!==9)break;H.pop();const $e=H.pop(),ie=H.length===0,fe=J.create(Y.expr.map(te=>ce.create([te,$e],null,be)),null,ie);fe&&(H.push(fe),H.sort(c))}if(H.length===1)return H[0];if(be){for(let Y=0;Y<H.length;Y++)for(let $e=Y+1;$e<H.length;$e++)if(H[Y].negate().equals(H[$e]))return u.INSTANCE;if(H.length===1)return H[0]}return new ce(H,ne)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const ne of this.expr)U.push(...ne.keys());return U}map(U){return new ce(this.expr.map(ne=>ne.map(U)),null)}negate(){if(!this.c){const U=[];for(const ne of this.expr)U.push(ne.negate());this.c=J.create(U,this,!0)}return this.c}}e.$$i=ce;class J{static create(U,ne,be){return J.d(U,ne,be)}constructor(U,ne){this.expr=U,this.c=ne,this.type=9}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ne=0,be=this.expr.length;ne<be;ne++){const H=c(this.expr[ne],U.expr[ne]);if(H!==0)return H}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ne=0,be=this.expr.length;ne<be;ne++)if(!this.expr[ne].equals(U.expr[ne]))return!1;return!0}return!1}substituteConstants(){const U=X(this.expr);return U===this.expr?this:J.create(U,this.c,!1)}evaluate(U){for(let ne=0,be=this.expr.length;ne<be;ne++)if(this.expr[ne].evaluate(U))return!0;return!1}static d(U,ne,be){let H=[],x=!1;if(U){for(let Y=0,$e=U.length;Y<$e;Y++){const ie=U[Y];if(ie){if(ie.type===0){x=!0;continue}if(ie.type===1)return h.INSTANCE;if(ie.type===9){H=H.concat(ie.expr);continue}H.push(ie)}}if(H.length===0&&x)return u.INSTANCE;H.sort(c)}if(H.length!==0){if(H.length===1)return H[0];for(let Y=1;Y<H.length;Y++)H[Y-1].equals(H[Y])&&(H.splice(Y,1),Y--);if(H.length===1)return H[0];if(be){for(let Y=0;Y<H.length;Y++)for(let $e=Y+1;$e<H.length;$e++)if(H[Y].negate().equals(H[$e]))return h.INSTANCE;if(H.length===1)return H[0]}return new J(H,ne)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const ne of this.expr)U.push(...ne.keys());return U}map(U){return new J(this.expr.map(ne=>ne.map(U)),null)}negate(){if(!this.c){const U=[];for(const ne of this.expr)U.push(ne.negate());for(;U.length>1;){const ne=U.shift(),be=U.shift(),H=[];for(const x of he(ne))for(const Y of he(be))H.push(ce.create([x,Y],null,!1));U.unshift(J.create(H,null,!1))}this.c=J.create(U,this,!0)}return this.c}}e.$_i=J;class Q extends E{static{this.d=[]}static all(){return Q.d.values()}constructor(U,ne,be){super(U,null),this.f=ne,typeof be=="object"?Q.d.push({...be,key:U}):be!==!0&&Q.d.push({key:U,description:be,type:ne!=null?typeof ne:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return D.create(this.key,U)}notEqualsTo(U){return k.create(this.key,U)}}e.$aj=Q,e.$bj=(0,R.$Vh)("contextKeyService");function G(q,U){return q<U?-1:q>U?1:0}function oe(q,U,ne,be){return q<ne?-1:q>ne?1:U<be?-1:U>be?1:0}function _(q,U){if(q.type===0||U.type===1)return!0;if(q.type===9)return U.type===9?Ee(q.expr,U.expr):!1;if(U.type===9){for(const ne of U.expr)if(_(q,ne))return!0;return!1}if(q.type===6){if(U.type===6)return Ee(U.expr,q.expr);for(const ne of q.expr)if(_(ne,U))return!0;return!1}return q.equals(U)}e.$cj=_;function Ee(q,U){let ne=0,be=0;for(;ne<q.length&&be<U.length;){const H=q[ne].cmp(U[be]);if(H<0)return!1;H===0&&ne++,be++}return ne===q.length}function he(q){return q.type===9?q.expr:[q]}}),define(ke[240],Se([1,0,23,39,199,5,102,11,24]),function(me,e,C,T,f,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mv=e.$Lv=e.ConfirmResult=e.$Kv=e.$Jv=e.$Iv=void 0,e.$Iv=(0,R.$Vh)("dialogService");var g;(function(w){w[w.Confirmation=1]="Confirmation",w[w.Prompt=2]="Prompt",w[w.Input=3]="Input"})(g||(g={}));class A{a(l){return this.d(l,g.Confirmation)}b(l){return this.d(l,g.Prompt)}c(l){return this.d(l,g.Input)}d(l,o){const i=[];switch(o){case g.Confirmation:{const n=l;n.primaryButton?i.push(n.primaryButton):i.push((0,f.localize)(0,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,f.localize)(1,null));break}case g.Prompt:{const n=l;Array.isArray(n.buttons)&&n.buttons.length>0&&i.push(...n.buttons.map(r=>r.label)),n.cancelButton&&(n.cancelButton===!0?i.push((0,f.localize)(2,null)):typeof n.cancelButton=="string"?i.push(n.cancelButton):n.cancelButton.label?i.push(n.cancelButton.label):i.push((0,f.localize)(3,null))),i.length===0&&i.push((0,f.localize)(4,null));break}case g.Input:{const n=l;n.primaryButton?i.push(n.primaryButton):i.push((0,f.localize)(5,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,f.localize)(6,null));break}}return i}e(l){if(typeof l=="string")return l;if(typeof l=="number")return l===T.default.Info?"info":l===T.default.Error?"error":l===T.default.Warning?"warning":"none"}f(l,o,i){const n=[...l.buttons??[]];l.cancelButton&&typeof l.cancelButton!="string"&&typeof l.cancelButton!="boolean"&&n.push(l.cancelButton);let r=n[o]?.run({checkboxChecked:i});return r instanceof Promise||(r=Promise.resolve(r)),{result:r,checkboxChecked:i}}}e.$Jv=A,e.$Kv=(0,R.$Vh)("fileDialogService");var I;(function(w){w[w.SAVE=0]="SAVE",w[w.DONT_SAVE=1]="DONT_SAVE",w[w.CANCEL=2]="CANCEL"})(I||(e.ConfirmResult=I={}));const $=10;function v(w){const l=[];return l.push(...w.slice(0,$).map(o=>typeof o=="string"?o:(0,C.$wg)(o))),w.length>$&&(w.length-$===1?l.push((0,f.localize)(7,null)):l.push((0,f.localize)(8,null,w.length-$))),l.push(""),l.join(`
`)}e.$Lv=v;function S(w,l){const o=(0,y.$an)(w);let i=(o.buttons??[]).map(t=>(0,L.$Fv)(t)),n=(w.buttons||[]).map((t,s)=>s),r=0,a=o.cancelId??i.length-1;if(i.length>1){const t=typeof a=="number"?i[a]:void 0;if(b.$k||b.$j){if(typeof t=="string"&&i.length>1&&a!==1){i.splice(a,1),i.splice(1,0,t);const s=n[a];n.splice(a,1),n.splice(1,0,s),a=1}b.$k&&i.length>1&&(i=i.reverse(),n=n.reverse(),r=i.length-1,typeof t=="string"&&(a=r-1))}else if(b.$i&&typeof t=="string"&&i.length>1&&a!==i.length-1){i.splice(a,1),i.push(t);const s=n[a];n.splice(a,1),n.push(s),a=i.length-1}}return o.buttons=i,o.defaultId=r,o.cancelId=a,o.noLink=!0,o.title=o.title||l.nameLong,{options:o,buttonIndeces:n}}e.$Mv=S}),define(ke[134],Se([1,0,5]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$3h=void 0,e.$3h=(0,C.$Vh)("environmentService"),e.$4h=(0,C.$Wh)(e.$3h)}),define(ke[135],Se([1,0,200,5]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$do=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=void 0,e.$4n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$5n=new RegExp(e.$4n),e.$6n="__web_extension",e.$7n="skipWalkthrough",e.$8n="extensionsSync",e.$9n="dependecyOrPackExtensionInstall";function f(o){switch(o){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$0n=f;function R(o){switch(o){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$$n=R;function L(o,i){switch(o){case 3:return i==="x64"?"win32-x64":i==="arm64"?"win32-arm64":"unknown";case 2:return i==="x64"?"linux-x64":i==="arm64"?"linux-arm64":i==="arm"?"linux-armhf":"unknown";case"alpine":return i==="x64"?"alpine-x64":i==="arm64"?"alpine-arm64":"unknown";case 1:return i==="x64"?"darwin-x64":i==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$_n=L;function b(o,i){return i==="web"&&!o.includes("web")}e.$ao=b;function y(o,i,n){return b(i,n)?!1:o==="undefined"||o==="universal"?!0:o==="unknown"?!1:o===n}e.$bo=y;function g(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}e.$co=g;var A;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=10]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var I;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(I||(e.SortOrder=I={}));var $;(function(o){o.Install="install",o.Uninstall="uninstall"})($||(e.StatisticType=$={}));var v;(function(o){o[o.None=1]="None",o[o.Install=2]="Install",o[o.Update=3]="Update",o[o.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.$do=(0,T.$Vh)("extensionGalleryService");var S;(function(o){o.Unsupported="Unsupported",o.Deprecated="Deprecated",o.Malicious="Malicious",o.Incompatible="Incompatible",o.IncompatibleTargetPlatform="IncompatibleTargetPlatform",o.ReleaseVersionNotFound="ReleaseVersionNotFound",o.Invalid="Invalid",o.Download="Download",o.Extract="Extract",o.Delete="Delete",o.Rename="Rename",o.CorruptZip="CorruptZip",o.IncompleteZip="IncompleteZip",o.Signature="Signature",o.Internal="Internal"})(S||(e.ExtensionManagementErrorCode=S={}));var w;(function(o){o.UnknownError="UnknownError",o.PackageIsInvalidZip="PackageIsInvalidZip",o.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(w||(e.ExtensionSignaturetErrorCode=w={}));class l extends Error{constructor(i,n){super(i),this.code=n,this.name=n}}e.$eo=l,e.$fo=(0,T.$Vh)("extensionManagementService"),e.$go="extensionsIdentifiers/disabled",e.$ho="extensionsIdentifiers/enabled",e.$io=(0,T.$Vh)("IGlobalExtensionEnablementService"),e.$jo=(0,T.$Vh)("IExtensionTipsService"),e.$ko=(0,C.localize)(0,null),e.$lo={value:e.$ko,original:"Extensions"},e.$mo={value:(0,C.localize)(1,null),original:"Preferences"}}),define(ke[241],Se([1,0,5]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KZb=e.$JZb=void 0,e.$JZb=(0,C.$Vh)("externalTerminal"),e.$KZb="Terminal.app"}),define(ke[242],Se([1,0,50,17,16,11,101,30,104,202,241]),function(me,e,C,T,f,R,L,b,y,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H8b=e.$G8b=e.$F8b=void 0;const I=g.localize(0,null);class ${async getDefaultTerminalForPlatforms(){return{windows:v.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class v extends ${static{this.b="cmd.exe"}openTerminal(r,a){return this.spawnTerminal(C,r,y.$Hl(),a)}spawnTerminal(r,a,t,s){const d=a.windowsExec||v.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const c=f.$mc(d,".exe").toLowerCase();if(c==="cmder")return r.spawn(d,s?[s]:void 0),Promise.resolve(void 0);const u=["/c","start","/wait"];return d.indexOf(" ")>=0&&u.push('""'),u.push(d),c==="wt"&&u.push("-d ."),new Promise((h,E)=>{const D=l(process),m=r.spawn(t,u,{cwd:s,env:D});m.on("error",E),m.on("exit",()=>h())})}runInTerminal(r,a,t,s,d){const c="windowsExec"in d&&d.windowsExec?d.windowsExec:v.getDefaultTerminalWindows();return new Promise((u,h)=>{const E=`"${a} - ${I}"`,D=`""${t.join('" "')}" & pause"`,m=Object.assign({},l(process),s);Object.keys(m).filter(j=>m[j]===null).forEach(j=>delete m[j]);const p={cwd:a,env:m,windowsVerbatimArguments:!0};let k,P;f.$mc(c,".exe")==="wt"?(k=c,P=["-d",".",v.b,"/c",D]):(k=v.b,P=["/c","start",E,"/wait",c,"/c",D]),C.spawn(k,P,p).on("error",j=>{h(o(j))}),u(void 0)})}static getDefaultTerminalWindows(){if(!v.d){const r=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");v.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${r?"Sysnative":"System32"}\\cmd.exe`}return v.d}}e.$F8b=v;class S extends ${static{this.b="/usr/bin/osascript"}openTerminal(r,a){return this.spawnTerminal(C,r,a)}runInTerminal(r,a,t,s,d){const c=d.osxExec||A.$KZb;return new Promise((u,h)=>{if(c===A.$KZb||c==="iTerm.app"){const E=c===A.$KZb?"TerminalHelper":"iTermHelper",m=[T.$gg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${E}.scpt`).fsPath,"-t",r||I,"-w",a];for(const P of t)m.push("-a"),m.push(P);if(s){const P=Object.assign({},l(process),s);for(const z in P){const j=P[z];j===null?(m.push("-u"),m.push(z)):(m.push("-e"),m.push(`${z}=${j}`))}}let p="";const k=C.spawn(S.b,m);k.on("error",P=>{h(o(P))}),k.stderr.on("data",P=>{p+=P.toString()}),k.on("exit",P=>{if(P===0)u(void 0);else if(p){const z=p.split(`
`,1);h(new Error(z[0]))}else h(new Error(g.localize(1,null,E,P)))})}else h(new Error(g.localize(2,null,c)))})}spawnTerminal(r,a,t){const s=a.osxExec||A.$KZb;return new Promise((d,c)=>{const u=["-a",s];t&&u.push(t);const h=l(process),E=r.spawn("/usr/bin/open",u,{cwd:t,env:h});E.on("error",c),E.on("exit",()=>d())})}}e.$G8b=S;class w extends ${static{this.b=g.localize(3,null)}openTerminal(r,a){return this.spawnTerminal(C,r,a)}runInTerminal(r,a,t,s,d){const c=d.linuxExec?Promise.resolve(d.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((u,h)=>{const E=[];c.then(D=>{D.indexOf("gnome-terminal")>=0?E.push("-x"):E.push("-e"),E.push("bash"),E.push("-c");const m=`${i(t)}; echo; read -p "${w.b}" -n1;`;E.push(`''${m}''`);const p=Object.assign({},l(process),s);Object.keys(p).filter(j=>p[j]===null).forEach(j=>delete p[j]);const k={cwd:a,env:p};let P="";const z=C.spawn(D,E,k);z.on("error",j=>{h(o(j))}),z.stderr.on("data",j=>{P+=j.toString()}),z.on("exit",j=>{if(j===0)u(void 0);else if(P){const M=P.split(`
`,1);h(new Error(M[0]))}else h(new Error(g.localize(4,null,D,j)))})})})}static async getDefaultTerminalLinuxReady(){if(!w.d)if(!R.$k)w.d=Promise.resolve("xterm");else{const r=await b.Promises.exists("/etc/debian_version");w.d=new Promise(a=>{r?a("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?a("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?a("konsole"):process.env.COLORTERM?a(process.env.COLORTERM):process.env.TERM?a(process.env.TERM):a("xterm")})}return w.d}spawnTerminal(r,a,t){const s=a.linuxExec?Promise.resolve(a.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((d,c)=>{s.then(u=>{const h=l(process),E=r.spawn(u,[],{cwd:t,env:h});E.on("error",c),E.on("exit",()=>d())})})}}e.$H8b=w;function l(n){const r={...n.env};return(0,L.$Fl)(r),r}function o(n){return"errno"in n&&n.errno==="ENOENT"&&"path"in n&&typeof n.path=="string"?new Error(g.localize(5,null,n.path)):n}function i(n){let r="";for(const a of n)a.indexOf(" ")>=0?r+='"'+a+'"':r+=a,r+=" ";return r}}),define(ke[31],Se([1,0,77,16,13,18,2,203,5,11,17,48]),function(me,e,C,T,f,R,L,b,y,g,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.FileKind=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.FileOperationResult=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.FileChangeType=e.$wk=e.FileOperation=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.FileSystemProviderErrorCode=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.FileSystemProviderCapabilities=e.$gk=e.FilePermission=e.FileType=e.$fk=e.$ek=void 0,e.$ek=(0,y.$Vh)("fileService");function $(_){return _.create===!0}e.$fk=$;var v;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(v||(e.FileType=v={}));var S;(function(_){_[_.Readonly=1]="Readonly",_[_.Locked=2]="Locked"})(S||(e.FilePermission=S={}));function w(_){const Ee=_;return!!Ee&&typeof Ee.onDidChange=="function"}e.$gk=w;var l;(function(_){_[_.None=0]="None",_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock",_[_.FileAtomicRead=16384]="FileAtomicRead",_[_.FileAtomicWrite=32768]="FileAtomicWrite",_[_.FileAtomicDelete=65536]="FileAtomicDelete",_[_.FileClone=131072]="FileClone"})(l||(e.FileSystemProviderCapabilities=l={}));function o(_){return!!(_.capabilities&2)}e.$hk=o;function i(_){return!!(_.capabilities&8)}e.$ik=i;function n(_){return!!(_.capabilities&131072)}e.$jk=n;function r(_){return!!(_.capabilities&4)}e.$kk=r;function a(_){return!!(_.capabilities&16)}e.$lk=a;function t(_){return o(_)?!!(_.capabilities&16384):!1}e.$mk=t;function s(_){return o(_)?!!(_.capabilities&32768):!1}e.$nk=s;function d(_){return!!(_.capabilities&65536)}e.$ok=d;function c(_){return!!(_.capabilities&2048)}e.$pk=c;var u;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsStorageQuota="EntryExceedsStorageQuota",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(u||(e.FileSystemProviderErrorCode=u={}));class h extends Error{static create(Ee,he){const q=new h(Ee.toString(),he);return m(q,he),q}constructor(Ee,he){super(Ee),this.code=he}}e.$qk=h;function E(_,Ee){return h.create(_,Ee)}e.$rk=E;function D(_){return _||E((0,b.localize)(0,null),u.Unknown)}e.$sk=D;function m(_,Ee){return _.name=Ee?`${Ee} (FileSystemError)`:"FileSystemError",_}e.$tk=m;function p(_){if(!_)return u.Unknown;if(_ instanceof h)return _.code;const Ee=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!Ee)return u.Unknown;switch(Ee[1]){case u.FileExists:return u.FileExists;case u.FileIsADirectory:return u.FileIsADirectory;case u.FileNotADirectory:return u.FileNotADirectory;case u.FileNotFound:return u.FileNotFound;case u.FileTooLarge:return u.FileTooLarge;case u.FileWriteLocked:return u.FileWriteLocked;case u.NoPermissions:return u.NoPermissions;case u.Unavailable:return u.Unavailable}return u.Unknown}e.$uk=p;function k(_){if(_ instanceof F)return _.fileOperationResult;switch(p(_)){case u.FileNotFound:return 1;case u.FileIsADirectory:return 0;case u.FileNotADirectory:return 9;case u.FileWriteLocked:return 5;case u.NoPermissions:return 6;case u.FileExists:return 4;case u.FileTooLarge:return 7;default:return 10}}e.$vk=k;var P;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY",_[_.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class z{constructor(Ee,he,q){this.resource=Ee,this.operation=he,this.target=q}isOperation(Ee){return this.operation===Ee}}e.$wk=z;var j;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(j||(e.FileChangeType=j={}));class M{static{this.a=null}constructor(Ee,he){this.c=he,this.b=void 0,this.d=new I.$U(()=>{const q=C.$2h.forUris(()=>this.c);return q.fill(this.rawAdded.map(U=>[U,!0])),q}),this.f=new I.$U(()=>{const q=C.$2h.forUris(()=>this.c);return q.fill(this.rawUpdated.map(U=>[U,!0])),q}),this.g=new I.$U(()=>{const q=C.$2h.forUris(()=>this.c);return q.fill(this.rawDeleted.map(U=>[U,!0])),q}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const q of Ee){switch(q.type){case 1:this.rawAdded.push(q.resource);break;case 0:this.rawUpdated.push(q.resource);break;case 2:this.rawDeleted.push(q.resource);break}this.b!==M.a&&(typeof q.cId=="number"?this.b===void 0?this.b=q.cId:this.b!==q.cId&&(this.b=M.a):this.b!==void 0&&(this.b=M.a))}}contains(Ee,...he){return this.h(Ee,{includeChildren:!1},...he)}affects(Ee,...he){return this.h(Ee,{includeChildren:!0},...he)}h(Ee,he,...q){if(!Ee)return!1;const U=q.length>0;return!!((!U||q.includes(1))&&(this.d.value.get(Ee)||he.includeChildren&&this.d.value.findSuperstr(Ee))||(!U||q.includes(0))&&(this.f.value.get(Ee)||he.includeChildren&&this.f.value.findSuperstr(Ee))||(!U||q.includes(2))&&(this.g.value.findSubstr(Ee)||he.includeChildren&&this.g.value.findSuperstr(Ee)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Ee){return this.b===Ee}hasCorrelation(){return typeof this.b=="number"}}e.$xk=M;function O(_,Ee,he){return!_||!Ee||_===Ee||Ee.length>_.length?!1:(Ee.charAt(Ee.length-1)!==T.sep&&(Ee+=T.sep),he?(0,f.$7e)(_,Ee):_.indexOf(Ee)===0)}e.$yk=O;class F extends Error{constructor(Ee,he,q){super(Ee),this.fileOperationResult=he,this.options=q}}e.$zk=F;class N extends F{constructor(Ee,he,q,U){super(Ee,he,U),this.fileOperationResult=he,this.size=q}}e.$Ak=N;class W extends F{constructor(Ee,he,q){super(Ee,2,q),this.stat=he}}e.$Bk=W;var X;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(X||(e.FileOperationResult=X={})),e.$Ck={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Dk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Ek="files.associations",e.$Fk="files.exclude",e.$Gk="files.readonlyInclude",e.$Hk="files.readonlyExclude",e.$Ik="files.readonlyFromPermissions";var ce;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(ce||(e.FileKind=ce={})),e.$Jk="";function J(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.$Kk=J;async function Q(_,Ee){if(!Ee.hasProvider(L.URI.from({scheme:_.scheme})))return new Promise(he=>{const q=Ee.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===_.scheme&&U.added&&(q.dispose(),he())})})}e.$Lk=Q;class G{static{this.KB=1024}static{this.MB=G.KB*G.KB}static{this.GB=G.MB*G.KB}static{this.TB=G.GB*G.KB}static formatSize(Ee){return(0,R.$Gf)(Ee)||(Ee=0),Ee<G.KB?(0,b.localize)(1,null,Ee.toFixed(0)):Ee<G.MB?(0,b.localize)(2,null,(Ee/G.KB).toFixed(2)):Ee<G.GB?(0,b.localize)(3,null,(Ee/G.MB).toFixed(2)):Ee<G.TB?(0,b.localize)(4,null,(Ee/G.GB).toFixed(2)):(0,b.localize)(5,null,(Ee/G.TB).toFixed(2))}}e.$Mk=G;function oe(_){const Ee=typeof _=="string"||_?.scheme===A.Schemas.vscodeRemote;return typeof _!="string"&&_?.scheme===A.Schemas.file?1024*G.MB:Ee?10*G.MB:g.$o?50*G.MB:1024*G.MB}e.$Nk=oe}),define(ke[243],Se([1,0,22,8,204,31]),function(me,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=void 0;async function L(A,I,$,v,S,w){let l;try{await b(A,I,$,v,S,w)}catch(o){l=o}finally{l&&S.errorTransformer&&(l=S.errorTransformer(l)),typeof l<"u"&&$.error(l),$.end()}}e.$Sp=L;async function b(A,I,$,v,S,w){y(w);const l=await A.open(I,{create:!1});try{y(w);let o=0,i=0,n=S&&typeof S.length=="number"?S.length:void 0,r=C.$fe.alloc(Math.min(S.bufferSize,typeof n=="number"?n:S.bufferSize)),a=S&&typeof S.position=="number"?S.position:0,t=0;do i=await A.read(l,a,r.buffer,t,r.byteLength-t),a+=i,t+=i,o+=i,typeof n=="number"&&(n-=i),t===r.byteLength&&(await $.write(v(r)),r=C.$fe.alloc(Math.min(S.bufferSize,typeof n=="number"?n:S.bufferSize)),t=0);while(i>0&&(typeof n!="number"||n>0)&&y(w)&&g(o,S));if(t>0){let s=t;typeof n=="number"&&(s=Math.min(t,n)),$.write(v(r.slice(0,s)))}}catch(o){throw(0,R.$sk)(o)}finally{await A.close(l)}}function y(A){if(A.isCancellationRequested)throw(0,T.$5)();return!0}function g(A,I){if(typeof I?.limits?.size=="number"&&A>I.limits.size)throw(0,R.$rk)((0,f.localize)(0,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ke[84],Se([1,0,34,3,16,11,2,31]),function(me,e,C,T,f,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$1p=e.$Zp=e.$Yp=e.$Xp=e.$Wp=e.$Vp=e.$Up=void 0;function y(o){return o.recursive===!0}e.$Up=y;class g extends T.$Rc{static{this.a=5}constructor(i,n,r,a){super(),this.h=i,this.j=n,this.m=r,this.n=a,this.c=this.B(new T.$Sc),this.f=void 0,this.g=0}s(){const i=new T.$Qc;this.c.value=i,this.b=this.r(i),this.b.setVerboseLogging(this.m),i.add(this.b.onDidChangeFile(n=>this.h(n))),i.add(this.b.onDidLogMessage(n=>this.j(n))),i.add(this.b.onDidError(n=>this.t(n)))}t(i){this.n.restartOnError?this.g<g.a&&this.f?(this.w(`restarting watcher after error: ${i}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${i}`):this.w(i)}u(i){this.g++,this.s(),this.watch(i)}async watch(i){this.f=i,await this.b?.watch(i)}async setVerboseLogging(i){this.m=i,await this.b?.setVerboseLogging(i)}w(i){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${i}`})}y(i){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${i}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Vp=g;class A extends g{constructor(i,n,r){super(i,n,r,{type:"node.js",restartOnError:!1})}}e.$Wp=A;class I extends g{constructor(i,n,r){super(i,n,r,{type:"universal",restartOnError:!0})}}e.$Xp=I;function $(o){return o.map(i=>({type:i.type,resource:L.URI.revive(i.resource),cId:i.cId}))}e.$Yp=$;function v(o){const i=new l;for(const n of o)i.processEvent(n);return i.coalesce()}e.$Zp=v;function S(o,i){return typeof i=="string"&&!i.startsWith(C.$yj)&&!(0,f.$hc)(i)?{base:o,pattern:i}:i}e.$1p=S;function w(o,i){const n=[];for(const r of i)n.push((0,C.$Cj)(S(o,r)));return n}e.$2p=w;class l{constructor(){this.a=new Set,this.b=new Map}c(i){return R.$k?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const n=this.b.get(this.c(i));let r=!1;if(n){const a=n.type,t=i.type;n.resource.fsPath!==i.resource.fsPath&&(i.type===2||i.type===1)?r=!0:a===1&&t===2?(this.b.delete(this.c(i)),this.a.delete(n)):a===2&&t===1?n.type=0:a===1&&t===0||(n.type=t)}else r=!0;r&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],n=[];return Array.from(this.a).filter(r=>r.type!==2?(i.push(r),!1):!0).sort((r,a)=>r.resource.fsPath.length-a.resource.fsPath.length).filter(r=>n.some(a=>(0,b.$yk)(r.resource.fsPath,a,!R.$k))?!1:(n.push(r.resource.fsPath),!0)).concat(i)}}}),define(ke[244],Se([1,0,55,12,21,33,3,76,16,11,23,2,103,30,84]),function(me,e,C,T,f,R,L,b,y,g,A,I,$,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=e.$cq=void 0;class w extends L.$Rc{static{this.a=100}static{this.b=75}constructor(i,n,r,a){super(),this.m=i,this.n=n,this.r=r,this.s=a,this.c=this.B(new T.$ah({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new T.$_g(t=>this.z(t),w.b)),this.g=(0,S.$2p)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,S.$2p)(this.m.path,this.m.includes):void 0,this.j=new f.$2d,this.ready=this.t()}async t(){try{const i=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const n=await v.Promises.stat(i);this.B(await this.w(i,n.isDirectory()))}catch(i){i.code!=="ENOENT"?this.D(i):this.G(i)}}async u(i){let n=i.path;try{n=await v.Promises.realpath(i.path),i.path===n&&(n=await(0,$.$_p)(i.path)??i.path),i.path!==n&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${n})`)}catch{}return n}async w(i,n){if(g.$j&&(0,R.$2f)(i,"/Volumes/",!0))return this.D(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),L.$Rc.None;const r=new f.$2d(this.j.token),a=new L.$Qc;try{const t=I.URI.file(this.m.path),s=(0,y.$mc)(i),d=(0,C.watch)(i);a.add((0,L.$Pc)(()=>{d.removeAllListeners(),d.close()})),this.G(`Started watching: '${i}'`);const c=new Set;if(n)try{for(const h of await v.Promises.readdir(i))c.add(h)}catch(h){this.D(h)}const u=new Map;a.add((0,L.$Pc)(()=>{for(const[,h]of u)h.dispose();u.clear()})),d.on("error",(h,E)=>{this.D(`Failed to watch ${i} for changes using fs.watch() (${h}, ${E})`),this.dispose()}),d.on("change",(h,E)=>{if(r.token.isCancellationRequested)return;this.G(`[raw] ["${h}"] ${E}`);let D="";if(E&&(D=E.toString(),g.$j&&(D=(0,b.$ul)(D))),!(!D||h!=="change"&&h!=="rename"))if(n)if(h==="rename"){u.get(D)?.dispose();const m=setTimeout(async()=>{if(u.delete(D),D===s&&!await v.Promises.exists(i)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const p=await this.C((0,y.$ic)(i,D));if(r.token.isCancellationRequested)return;let k;p?c.has(D)?k=0:(k=1,c.add(D)):(c.delete(D),k=2),this.y({resource:(0,A.$zg)(t,D),type:k,cId:this.m.correlationId})},w.a);u.set(D,(0,L.$Pc)(()=>clearTimeout(m)))}else{let m;c.has(D)?m=0:(m=1,c.add(D)),this.y({resource:(0,A.$zg)(t,D),type:m,cId:this.m.correlationId})}else if(h==="rename"||D!==s){const m=setTimeout(async()=>{const p=await v.Promises.exists(i);r.token.isCancellationRequested||(p?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),a.add(await this.w(i,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},w.a);a.clear(),a.add((0,L.$Pc)(()=>clearTimeout(m)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await v.Promises.exists(i)&&!r.token.isCancellationRequested&&this.D(`Failed to watch ${i} for changes using fs.watch() (${t.toString()})`)}return(0,L.$Pc)(()=>{r.dispose(!0),a.dispose()})}y(i,n=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${i.type===1?"[ADDED]":i.type===2?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!n&&this.g.some(r=>r(i.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${i.resource.fsPath}`):!n&&this.h&&this.h.length>0&&!this.h.some(r=>r(i.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${i.resource.fsPath}`):this.f.work(i))}z(i){const n=(0,S.$Zp)(i);if(n.length>0){if(this.s)for(const a of n)this.G(` >> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.resource.fsPath}`);this.c.work(n)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${n.length}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(i){if(g.$k)return v.Promises.exists(i);try{const n=(0,y.$mc)(i);return(await v.Promises.readdir((0,y.$lc)(i))).some(a=>a===n)}catch(n){return this.G(n),!1}}setVerboseLogging(i){this.s=i}D(i){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}F(i){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}G(i){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$cq=w;async function l(o,i,n,r,a=512){const t=await v.Promises.open(o,"r"),s=Buffer.allocUnsafe(a),d=new f.$2d(r);let c,u=!1;const h={path:o,excludes:[],recursive:!1},E=new w(h,D=>{(async()=>{for(const{type:m}of D)if(m===0){if(u)return;u=!0;try{for(;!d.token.isCancellationRequested;){const{bytesRead:p}=await v.Promises.read(t,s,0,a,null);if(!p||d.token.isCancellationRequested)break;i(s.slice(0,p))}}catch(p){c=new Error(p),d.dispose(!0)}finally{u=!1}}})()});return await E.ready,n(),new Promise((D,m)=>{d.token.onCancellationRequested(async()=>{E.dispose();try{await v.Promises.close(t)}catch(p){c=new Error(p)}c?m(c):D()})})}e.$dq=l}),define(ke[245],Se([1,0,4,34,3,11,244]),function(me,e,C,T,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=void 0;class b extends f.$Rc{constructor(){super(...arguments),this.a=this.B(new C.$Rd),this.onDidChangeFile=this.a.event,this.b=this.B(new C.$Rd),this.onDidLogMessage=this.b.event,this.onDidError=C.Event.None,this.c=new Map,this.f=!1}async watch(g){const A=this.j(g),I=A.filter(v=>{const S=this.c.get(v.path);return S?!(0,T.$Gj)(S.request.excludes,v.excludes)||!(0,T.$Gj)(S.request.includes,v.includes):!0}),$=Array.from(this.c.values()).filter(({request:v})=>!A.find(S=>S.path===v.path&&(0,T.$Gj)(S.excludes,v.excludes)&&(0,T.$Gj)(S.includes,v.includes))).map(({request:v})=>v.path);I.length&&this.m(`Request to start watching: ${I.map(v=>`${v.path} (excludes: ${v.excludes.length>0?v.excludes:"<none>"}, includes: ${v.includes&&v.includes.length>0?JSON.stringify(v.includes):"<all>"}, correlationId: ${typeof v.correlationId=="number"?v.correlationId:"<none>"})`).join(",")}`),$.length&&this.m(`Request to stop watching: ${$.join(",")}`);for(const v of $)this.h(v);for(const v of I)this.g(v)}g(g){const A=new L.$cq(g,$=>this.a.fire($),$=>this.b.fire($),this.f),I={request:g,instance:A};this.c.set(g.path,I)}async stop(){for(const[g]of this.c)this.h(g);this.c.clear()}h(g){const A=this.c.get(g);A&&(this.c.delete(g),A.instance.dispose())}j(g){const A=new Map;for(const I of g){const $=R.$k?I.path:I.path.toLowerCase();let v=A.get(I.correlationId);v||(v=new Map,A.set(I.correlationId,v)),v.set($,I)}return Array.from(A.values()).map(I=>Array.from(I.values())).flat()}async setVerboseLogging(g){this.f=g;for(const[,A]of this.c)A.instance.setVerboseLogging(g)}m(g){this.f&&this.b.fire({type:"trace",message:this.n(g)})}n(g,A){return A?`[File Watcher (node.js)] ${g} (path: ${A.request.path})`:`[File Watcher (node.js)] ${g}`}}e.$eq=b}),define(ke[246],Se([1,0,84,245]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=void 0;class f extends C.$Wp{constructor(L,b,y){super(L,b,y),this.s()}r(L){return L.add(new T.$eq)}}e.$fq=f}),define(ke[247],Se([1,0,17,81,187,84]),function(me,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0p=void 0;class L extends R.$Xp{constructor(y,g,A){super(y,g,A),this.s()}r(y){const g=y.add(new f.$9p(C.$gg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return y.add(g.onDidProcessExit(({code:A,signal:I})=>this.t(`terminated by itself with code ${A}, signal: ${I}`))),T.ProxyChannel.toService((0,T.$Ch)(g.getChannel("watcher")))}}e.$0p=L}),define(ke[107],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=void 0;class C{constructor(...f){this.a=new Map;for(const[R,L]of f)this.set(R,L)}set(f,R){const L=this.a.get(f);return this.a.set(f,R),L}has(f){return this.a.has(f)}get(f){return this.a.get(f)}}e.$Th=C}),define(ke[248],Se([1,0,12,8,3,105,239,5,107,75]),function(me,e,C,T,f,R,L,b,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=e.$jq=void 0;const A=!1;class I extends Error{constructor(l){super("cyclic dependency between services"),this.message=l.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${l.toString()}`}}class ${constructor(l=new y.$Th,o=!1,i,n=A){this.f=l,this.g=o,this.h=i,this.i=n,this.o=new Set,this.f.set(b.$Uh,this),this._globalGraph=n?i?._globalGraph??new L.$iq(r=>r):void 0}createChild(l){return new $(l,this.g,this,this.i)}invokeFunction(l,...o){const i=S.traceInvocation(this.i,l);let n=!1;try{return l({get:a=>{if(n)throw(0,T.$7)("service accessor is only valid during the invocation of its target method");const t=this.m(a,i);if(!t)throw new Error(`[invokeFunction] unknown service '${a}'`);return t}},...o)}finally{n=!0,i.stop()}}createInstance(l,...o){let i,n;return l instanceof R.$Sh?(i=S.traceCreation(this.i,l.ctor),n=this.j(l.ctor,l.staticArguments.concat(o),i)):(i=S.traceCreation(this.i,l),n=this.j(l,o,i)),i.stop(),n}j(l,o=[],i){const n=b._util.getServiceDependencies(l).sort((t,s)=>t.index-s.index),r=[];for(const t of n){const s=this.m(t.id,i);s||this.u(`[createInstance] ${l.name} depends on UNKNOWN service ${t.id}.`,!1),r.push(s)}const a=n.length>0?n[0].index:o.length;if(o.length!==a){console.trace(`[createInstance] First service dependency of ${l.name} at position ${a+1} conflicts with ${o.length} static arguments`);const t=a-o.length;t>0?o=o.concat(new Array(t)):o=o.slice(0,a)}return Reflect.construct(l,o.concat(r))}k(l,o){if(this.f.get(l)instanceof R.$Sh)this.f.set(l,o);else if(this.h)this.h.k(l,o);else throw new Error("illegalState - setting UNKNOWN service instance")}l(l){const o=this.f.get(l);return!o&&this.h?this.h.l(l):o}m(l,o){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(l));const i=this.l(l);return i instanceof R.$Sh?this.q(l,i,o.branch(l,!0)):(o.branch(l,!1),i)}q(l,o,i){if(this.o.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this.o.add(l);try{return this.r(l,o,i)}finally{this.o.delete(l)}}r(l,o,i){const n=new L.$iq(t=>t.id.toString());let r=0;const a=[{id:l,desc:o,_trace:i}];for(;a.length;){const t=a.pop();if(n.lookupOrInsertNode(t),r++>1e3)throw new I(n);for(const s of b._util.getServiceDependencies(t.desc.ctor)){const d=this.l(s.id);if(d||this.u(`[createInstance] ${l} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(s.id)),d instanceof R.$Sh){const c={id:s.id,desc:d,_trace:t._trace.branch(s.id,!0)};n.insertEdge(t,c),a.push(c)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new I(n);break}for(const{data:s}of t){if(this.l(s.id)instanceof R.$Sh){const c=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,c)}n.removeNode(s)}}return this.l(l)}s(l,o,i=[],n,r){if(this.f.get(l)instanceof R.$Sh)return this.t(l,o,i,n,r);if(this.h)return this.h.s(l,o,i,n,r);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}t(l,o,i=[],n,r){if(n){const a=new $(void 0,this.g,this,this.i);a.c=String(l);const t=new Map,s=new C.$eh(()=>{const d=a.j(o,i,r);for(const[c,u]of t){const h=d[c];if(typeof h=="function")for(const E of u)h.apply(d,E)}return t.clear(),d});return new Proxy(Object.create(null),{get(d,c){if(!s.isInitialized&&typeof c=="string"&&(c.startsWith("onDid")||c.startsWith("onWill"))){let E=t.get(c);return E||(E=new g.$2c,t.set(c,E)),(m,p,k)=>{const P=E.push([m,p,k]);return(0,f.$Pc)(P)}}if(c in d)return d[c];const u=s.value;let h=u[c];return typeof h!="function"||(h=h.bind(u),d[c]=h),h},set(d,c,u){return s.value[c]=u,!0},getPrototypeOf(d){return o.prototype}})}else return this.j(o,i,r)}u(l,o){if(o&&console.warn(l),this.g)throw new Error(l)}}e.$jq=$;var v;(function(w){w[w.None=0]="None",w[w.Creation=1]="Creation",w[w.Invocation=2]="Invocation",w[w.Branch=3]="Branch"})(v||(v={}));class S{static{this.all=new Set}static{this.c=new class extends S{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(l,o){return l?new S(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S.c}static traceCreation(l,o){return l?new S(1,o.name):S.c}static{this.f=0}constructor(l,o){this.type=l,this.name=o,this.g=Date.now(),this.h=[]}branch(l,o){const i=new S(3,l.toString());return this.h.push([l,o,i]),i}stop(){const l=Date.now()-this.g;S.f+=l;let o=!1;function i(r,a){const t=[],s=new Array(r+1).join("	");for(const[d,c,u]of a.h)if(c&&u){o=!0,t.push(`${s}CREATES -> ${d}`);const h=i(r+1,u);h&&t.push(h)}else t.push(`${s}uses -> ${d}`);return t.join(`
`)}const n=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${S.f.toFixed(2)}ms)`];(l>2||o)&&S.all.add(n.join(`
`))}}e.$kq=S}),define(ke[14],Se([1,0,43,4,52,3,28,11,23,18,2,45,5]),function(me,e,C,T,f,R,L,b,y,g,A,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.log=e.$gj=e.LogLevel=e.$fj=e.$ej=e.$dj=void 0,e.$dj=(0,$.$Vh)("logService"),e.$ej=(0,$.$Vh)("loggerService");function v(){return new Date().toISOString()}function S(m){return(0,g.$Gf)(m)}e.$fj=S;var w;(function(m){m[m.Off=0]="Off",m[m.Trace=1]="Trace",m[m.Debug=2]="Debug",m[m.Info=3]="Info",m[m.Warning=4]="Warning",m[m.Error=5]="Error"})(w||(e.LogLevel=w={})),e.$gj=w.Info;function l(m,p,k){switch(p){case w.Trace:m.trace(k);break;case w.Debug:m.debug(k);break;case w.Info:m.info(k);break;case w.Warning:m.warn(k);break;case w.Error:m.error(k);break;case w.Off:break;default:throw new Error(`Invalid log level ${p}`)}}e.log=l;function o(m,p=!1){let k="";for(let P=0;P<m.length;P++){let z=m[P];if(z instanceof Error&&(z=(0,C.$Gi)(z,p)),typeof z=="object")try{z=JSON.stringify(z)}catch{}k+=(P>0?" ":"")+z}return k}class i extends R.$Rc{constructor(){super(...arguments),this.b=e.$gj,this.c=this.B(new T.$Rd),this.onDidChangeLogLevel=this.c.event}setLevel(p){this.b!==p&&(this.b=p,this.c.fire(this.b))}getLevel(){return this.b}f(p){return this.b!==w.Off&&this.b<=p}}e.$ij=i;class n extends i{constructor(p){super(),this.h=p}f(p){return this.h||super.f(p)}trace(p,...k){this.f(w.Trace)&&this.g(w.Trace,o([p,...k],!0))}debug(p,...k){this.f(w.Debug)&&this.g(w.Debug,o([p,...k]))}info(p,...k){this.f(w.Info)&&this.g(w.Info,o([p,...k]))}warn(p,...k){this.f(w.Warning)&&this.g(w.Warning,o([p,...k]))}error(p,...k){if(this.f(w.Error))if(p instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=p.stack,this.g(w.Error,o(P))}else this.g(w.Error,o([p,...k]))}flush(){}}e.$jj=n;class r extends i{constructor(p=e.$gj){super(),this.setLevel(p),this.g=!b.$i}trace(p,...k){this.f(w.Trace)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,p,...k):console.log(`[main ${v()}]`,p,...k))}debug(p,...k){this.f(w.Debug)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,p,...k):console.log(`[main ${v()}]`,p,...k))}info(p,...k){this.f(w.Info)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,p,...k):console.log(`[main ${v()}]`,p,...k))}warn(p,...k){this.f(w.Warning)&&(this.g?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,p,...k):console.warn(`[main ${v()}]`,p,...k))}error(p,...k){this.f(w.Error)&&(this.g?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,p,...k):console.error(`[main ${v()}]`,p,...k))}dispose(){}flush(){}}e.$kj=r;class a extends i{constructor(p=e.$gj,k=!0){super(),this.g=k,this.setLevel(p)}trace(p,...k){this.f(w.Trace)&&(this.g?console.log("%cTRACE","color: #888",p,...k):console.log(p,...k))}debug(p,...k){this.f(w.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",p,...k):console.log(p,...k))}info(p,...k){this.f(w.Info)&&(this.g?console.log("%c INFO","color: #33f",p,...k):console.log(p,...k))}warn(p,...k){this.f(w.Warning)&&(this.g?console.log("%c WARN","color: #993",p,...k):console.log(p,...k))}error(p,...k){this.f(w.Error)&&(this.g?console.log("%c  ERR","color: #f33",p,...k):console.error(p,...k))}dispose(){}flush(){}}e.$lj=a;class t extends i{constructor(p,k=e.$gj){super(),this.g=p,this.setLevel(k)}trace(p,...k){this.f(w.Trace)&&this.g.log(w.Trace,[this.h(p),...k])}debug(p,...k){this.f(w.Debug)&&this.g.log(w.Debug,[this.h(p),...k])}info(p,...k){this.f(w.Info)&&this.g.log(w.Info,[this.h(p),...k])}warn(p,...k){this.f(w.Warning)&&this.g.log(w.Warning,[this.h(p),...k])}error(p,...k){this.f(w.Error)&&this.g.log(w.Error,[this.h(p),...k])}h(p){return typeof p=="string"?p:(0,C.$Gi)(p,this.f(w.Trace))}dispose(){}flush(){}}e.$mj=t;class s extends i{constructor(p){super(),this.g=p,p.length&&this.setLevel(p[0].getLevel())}setLevel(p){for(const k of this.g)k.setLevel(p);super.setLevel(p)}trace(p,...k){for(const P of this.g)P.trace(p,...k)}debug(p,...k){for(const P of this.g)P.debug(p,...k)}info(p,...k){for(const P of this.g)P.info(p,...k)}warn(p,...k){for(const P of this.g)P.warn(p,...k)}error(p,...k){for(const P of this.g)P.error(p,...k)}flush(){for(const p of this.g)p.flush()}dispose(){for(const p of this.g)p.dispose()}}e.$nj=s;class d extends R.$Rc{constructor(p,k,P){if(super(),this.h=p,this.j=k,this.b=new L.$zc,this.c=this.B(new T.$Rd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new T.$Rd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new T.$Rd),this.onDidChangeVisibility=this.g.event,P)for(const z of P)this.b.set(z.resource,{logger:void 0,info:z})}m(p){return(0,g.$Cf)(p)?[...this.b.values()].find(k=>k.info.id===p):this.b.get(p)}getLogger(p){return this.m(p)?.logger}createLogger(p,k){const P=this.n(p),z=(0,g.$Cf)(p)?p:k?.id??(0,f.$Ji)(P.toString()).toString(16);let j=this.b.get(P)?.logger;const M=k?.logLevel==="always"?w.Trace:k?.logLevel;j||(j=this.s(P,M??this.getLogLevel(P)??this.h,{...k,id:z}));const O={logger:j,info:{resource:P,id:z,logLevel:M,name:k?.name,hidden:k?.hidden,extensionId:k?.extensionId,when:k?.when}};return this.registerLogger(O.info),this.b.set(P,O),j}n(p){return(0,g.$Cf)(p)?(0,y.$zg)(this.j,`${p}.log`):p}setLogLevel(p,k){if(A.URI.isUri(p)){const P=p,z=k,j=this.b.get(P);j&&z!==j.info.logLevel&&(j.info.logLevel=z===this.h?void 0:z,j.logger?.setLevel(z),this.b.set(j.info.resource,j),this.f.fire([P,z]))}else{this.h=p;for(const[P,z]of this.b.entries())this.b.get(P)?.info.logLevel===void 0&&z.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(p,k){const P=this.m(p);P&&k!==!P.info.hidden&&(P.info.hidden=!k,this.b.set(P.info.resource,P),this.g.fire([P.info.resource,k]))}getLogLevel(p){let k;return p&&(k=this.b.get(p)?.info.logLevel),k??this.h}registerLogger(p){const k=this.b.get(p.resource);k?k.info.hidden!==p.hidden&&this.setVisibility(p.resource,!p.hidden):(this.b.set(p.resource,{info:p,logger:void 0}),this.c.fire({added:[p],removed:[]}))}deregisterLogger(p){const k=this.b.get(p);k&&(k.logger&&k.logger.dispose(),this.b.delete(p),this.c.fire({added:[],removed:[k.info]}))}*getRegisteredLoggers(){for(const p of this.b.values())yield p.info}getRegisteredLogger(p){return this.b.get(p)?.info}dispose(){this.b.forEach(p=>p.logger?.dispose()),this.b.clear(),super.dispose()}}e.$oj=d;class c{constructor(){this.onDidChangeLogLevel=new T.$Rd().event}setLevel(p){}getLevel(){return w.Info}trace(p,...k){}debug(p,...k){}info(p,...k){}warn(p,...k){}error(p,...k){}critical(p,...k){}dispose(){}flush(){}}e.$pj=c;class u extends c{}e.$qj=u;function h(m){if(m.verbose)return w.Trace;if(typeof m.logLevel=="string"){const p=D(m.logLevel.toLowerCase());if(p!==void 0)return p}return e.$gj}e.$rj=h;function E(m){switch(m){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}e.$sj=E;function D(m){switch(m){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.$tj=D,e.$uj=new I.$aj("logLevel",E(w.Info))}),define(ke[249],Se([1,0,19,12,8,4,3,16,84,14]),function(me,e,C,T,f,R,L,b,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=void 0;class A extends L.$Rc{constructor($,v){super(),this.a=$,this.b=v,this.c=this.B(new R.$Rd),this.onDidChangeFile=this.c.event,this.g=this.B(new R.$Rd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new T.$Vg(0)),this.w=[],this.y=this.B(new T.$Vg(0))}watch($,v){return v.recursive||this.b?.watcher?.forceUniversal?this.n($,v):this.z($,v)}n($,v){const S={path:this.H($),excludes:v.excludes,includes:v.includes,recursive:v.recursive,correlationId:v.correlationId},w=(0,C.$Tb)(this.j,S);return this.r(),(0,L.$Pc)(()=>{w(),this.r()})}r(){this.m.trigger(()=>this.s()).catch($=>(0,f.$Z)($))}s(){this.h||(this.h=this.B(this.t(v=>this.c.fire((0,y.$Yp)(v)),v=>this.G(v),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)})));const $=this.b?.watcher?.recursive?.usePolling;if($===!0)for(const v of this.j)(0,y.$Up)(v)&&(v.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray($))for(const v of this.j)(0,y.$Up)(v)&&$.includes(v.path)&&(v.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z($,v){const S={path:this.H($),excludes:v.excludes,includes:v.includes,recursive:!1,correlationId:v.correlationId},w=(0,C.$Tb)(this.w,S);return this.C(),(0,L.$Pc)(()=>{w(),this.C()})}C(){this.y.trigger(()=>this.D()).catch($=>(0,f.$Z)($))}D(){return this.u||(this.u=this.B(this.F($=>this.c.fire((0,y.$Yp)($)),$=>this.G($),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)}))),this.u.watch(this.w)}G($){$.type==="error"&&this.g.fire($.message),this.a[$.type]($.message)}H($){return(0,b.$gc)($.fsPath)}}e.$3p=A}),define(ke[250],Se([1,0,55,387,12,28,22,4,33,3,16,11,23,98,30,205,31,243,249,43,247,246]),function(me,e,C,T,f,R,L,b,y,g,A,I,$,v,S,w,l,o,i,n,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=void 0,(()=>{try{(0,T.gracefulify)(C)}catch(s){console.error(`Error enabling graceful-fs: ${(0,n.$Gi)(s)}`)}})();class t extends i.$3p{static{this.I=!1}constructor(d,c){super(d,c),this.onDidChangeCapabilities=b.Event.None,this.N=new R.$zc(u=>$.$qg.getComparisonKey(u)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,I.$k&&(this.J|=1024)),this.J}async stat(d){try{const{stat:c,symbolicLink:u}=await S.SymlinkSupport.stat(this.H(d));return{type:this.M(c,u),ctime:c.birthtime.getTime(),mtime:c.mtime.getTime(),size:c.size,permissions:c.mode&128?void 0:l.FilePermission.Locked}}catch(c){throw this.fb(c)}}async L(d){try{return await this.stat(d)}catch{return}}async readdir(d){try{const c=await S.Promises.readdir(this.H(d),{withFileTypes:!0}),u=[];return await Promise.all(c.map(async h=>{try{let E;h.isSymbolicLink()?E=(await this.stat((0,$.$zg)(d,h.name))).type:E=this.M(h),u.push([h.name,E])}catch(E){this.a.trace(E)}})),u}catch(c){throw this.fb(c)}}M(d,c){let u;return c?.dangling?u=l.FileType.Unknown:d.isFile()?u=l.FileType.File:d.isDirectory()?u=l.FileType.Directory:u=l.FileType.Unknown,c&&(u|=l.FileType.SymbolicLink),u}async O(d){const c=this.H(d);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${c})`);let u;for(;u=this.N.get(d);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${c})`),await u.wait();const h=new f.$Wg;return this.N.set(d,h),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${c})`),(0,g.$Pc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${c})`),this.N.get(d)===h&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${c})`),this.N.delete(d)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${c})`),h.open()})}async readFile(d,c){let u;try{c?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(d)})`),u=await this.O(d));const h=this.H(d);return await S.Promises.readFile(h)}catch(h){throw this.fb(h)}finally{u?.dispose()}}P(d){t.I&&this.a.trace(d)}readFileStream(d,c,u){const h=(0,v.$6d)(E=>L.$fe.concat(E.map(D=>L.$fe.wrap(D))).buffer);return(0,o.$Sp)(this,d,h,E=>E.buffer,{...c,bufferSize:256*1024},u),h}async writeFile(d,c,u){return u?.atomic!==!1&&u?.atomic?.postfix&&await this.Q(d)?this.R(d,(0,$.$zg)((0,$.$yg)(d),`${(0,$.$wg)(d)}${u.atomic.postfix}`),c,u):this.S(d,c,u)}async Q(d){try{const c=this.H(d),{symbolicLink:u}=await S.SymlinkSupport.stat(c);if(u)return!1}catch{}return!0}async R(d,c,u,h){const E=new g.$Qc;try{E.add(await this.O(d)),E.add(await this.O(c)),await this.S(c,u,h,!0);try{await this.rename(c,d,{overwrite:!0})}catch(D){try{await this.delete(c,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw D}}finally{E.dispose()}}async S(d,c,u,h){let E;try{const D=this.H(d);if(!u.create||!u.overwrite){if(await S.Promises.exists(D)){if(!u.overwrite)throw(0,l.$rk)((0,w.localize)(0,null),l.FileSystemProviderErrorCode.FileExists)}else if(!u.create)throw(0,l.$rk)((0,w.localize)(1,null),l.FileSystemProviderErrorCode.FileNotFound)}E=await this.open(d,{create:!0,unlock:u.unlock},h),await this.write(E,0,c,0,c.byteLength)}catch(D){throw await this.gb(d,D)}finally{typeof E=="number"&&await this.close(E)}}static{this.Y=!0}static configureFlushOnWrite(d){t.Y=d}async open(d,c,u){const h=this.H(d);let E;(0,l.$fk)(c)&&!u&&(E=await this.O(d));let D;try{if((0,l.$fk)(c)&&c.unlock)try{const{stat:p}=await S.SymlinkSupport.stat(h);p.mode&128||await S.Promises.chmod(h,p.mode|128)}catch(p){p.code!=="ENOENT"&&this.a.trace(p)}let m;if((0,l.$fk)(c)){if(I.$i)try{await S.Promises.truncate(h,0),m="r+"}catch(p){p.code!=="ENOENT"&&this.a.trace(p)}m||(m="w")}else m="r";D=await S.Promises.open(h,m)}catch(m){throw E?.dispose(),(0,l.$fk)(c)?await this.gb(d,m):this.fb(m)}if(this.U.set(D,0),(0,l.$fk)(c)&&this.X.set(D,d),E){const m=this.W.get(D);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${D} (${h})`),this.W.set(D,E),m&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${D} (${h})`),m.dispose())}return D}async close(d){const c=this.W.get(d);try{if(this.U.delete(d),this.X.delete(d)&&t.Y)try{await S.Promises.fdatasync(d)}catch(u){t.configureFlushOnWrite(!1),this.a.error(u)}return await S.Promises.close(d)}catch(u){throw this.fb(u)}finally{c&&(this.W.get(d)===c&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${d}`),this.W.delete(d)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${d}`),c.dispose())}}async read(d,c,u,h,E){const D=this.Z(d,c);let m=null;try{m=(await S.Promises.read(d,u,h,E,D)).bytesRead}catch(p){throw this.fb(p)}finally{this.$(d,D,m)}return m}Z(d,c){return c===this.U.get(d)?null:c}$(d,c,u){const h=this.U.get(d);typeof h=="number"&&(typeof c=="number"||(typeof u=="number"?this.U.set(d,h+u):this.U.delete(d)))}async write(d,c,u,h,E){return(0,f.$fh)(()=>this.ab(d,c,u,h,E),100,3)}async ab(d,c,u,h,E){const D=this.Z(d,c);let m=null;try{m=(await S.Promises.write(d,u,h,E,D)).bytesWritten}catch(p){throw await this.gb(this.X.get(d),p)}finally{this.$(d,D,m)}return m}async mkdir(d){try{await S.Promises.mkdir(this.H(d))}catch(c){throw this.fb(c)}}async delete(d,c){try{const u=this.H(d);if(c.recursive){let h;c?.atomic!==!1&&c.atomic.postfix&&(h=(0,A.$ic)((0,A.$lc)(u),`${(0,A.$mc)(u)}${c.atomic.postfix}`)),await S.Promises.rm(u,S.RimRafMode.MOVE,h)}else try{await S.Promises.unlink(u)}catch(h){if(h.code==="EPERM"||h.code==="EISDIR"){let E=!1;try{const{stat:D,symbolicLink:m}=await S.SymlinkSupport.stat(u);E=D.isDirectory()&&!m}catch{}if(E)await S.Promises.rmdir(u);else throw h}else throw h}}catch(u){throw this.fb(u)}}async rename(d,c,u){const h=this.H(d),E=this.H(c);if(h!==E)try{await this.bb(d,c,"move",u.overwrite),await S.Promises.rename(h,E)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,w.localize)(2,null,(0,A.$mc)(h),(0,A.$mc)((0,A.$lc)(E)),D.toString()))),this.fb(D)}}async copy(d,c,u){const h=this.H(d),E=this.H(c);if(h!==E)try{await this.bb(d,c,"copy",u.overwrite),await S.Promises.copy(h,E,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,w.localize)(3,null,(0,A.$mc)(h),(0,A.$mc)((0,A.$lc)(E)),D.toString()))),this.fb(D)}}async bb(d,c,u,h){const E=this.H(d),D=this.H(c);let m=!1;if(!!(this.capabilities&1024)||(m=(0,y.$1f)(E,D,!0)),m){if(u==="copy")throw(0,l.$rk)((0,w.localize)(4,null),l.FileSystemProviderErrorCode.FileExists);if(u==="move")return}const k=await this.L(d);if(!k)throw(0,l.$rk)((0,w.localize)(5,null),l.FileSystemProviderErrorCode.FileNotFound);const P=await this.L(c);if(P){if(!h)throw(0,l.$rk)((0,w.localize)(6,null),l.FileSystemProviderErrorCode.FileExists);k.type&l.FileType.File&&P.type&l.FileType.File||await this.delete(c,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(d,c){return this.cb(d,c,!1)}async cb(d,c,u){const h=this.H(d),E=this.H(c),D=!!(this.capabilities&1024);if((0,y.$1f)(h,E,!D))return;const m=new g.$Qc;try{m.add(await this.O(d)),m.add(await this.O(c)),u&&await S.Promises.mkdir((0,A.$lc)(E),{recursive:!0}),await S.Promises.copyFile(h,E)}catch(p){if(p.code==="ENOENT"&&!u)return this.cb(d,c,!0);throw this.fb(p)}finally{m.dispose()}}t(d,c,u){return new r.$0p(h=>d(h),h=>c(h),u)}F(d,c,u){return new a.$fq(h=>d(h),h=>c(h),u)}fb(d){if(d instanceof l.$qk)return d;let c=d,u;switch(d.code){case"ENOENT":u=l.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":u=l.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":u=l.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":u=l.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":u=l.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":c=`${d.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,u=l.FileSystemProviderErrorCode.Unknown;break;default:u=l.FileSystemProviderErrorCode.Unknown}return(0,l.$rk)(c,u)}async gb(d,c){let u=this.fb(c);if(d&&u.code===l.FileSystemProviderErrorCode.NoPermissions)try{const{stat:h}=await S.SymlinkSupport.stat(this.H(d));h.mode&128||(u=(0,l.$rk)(c,l.FileSystemProviderErrorCode.FileWriteLocked))}catch(h){this.a.trace(h)}return u}}e.$gq=t}),define(ke[251],Se([1,0,3,14]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YN=void 0;class f extends C.$Rc{constructor(L,b=[]){super(),this.a=new T.$nj([L,...b]),this.B(L.onDidChangeLogLevel(y=>this.setLevel(y)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(L){this.a.setLevel(L)}getLevel(){return this.a.getLevel()}trace(L,...b){this.a.trace(L,...b)}debug(L,...b){this.a.debug(L,...b)}info(L,...b){this.a.info(L,...b)}warn(L,...b){this.a.warn(L,...b)}error(L,...b){this.a.error(L,...b)}flush(){this.a.flush()}}e.$YN=f}),define(ke[252],Se([1,0,31,14]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NN=void 0;var f;(function(g){g[g.Trace=0]="Trace",g[g.Debug=1]="Debug",g[g.Info=2]="Info",g[g.Warning=3]="Warning",g[g.Error=4]="Error",g[g.Critical=5]="Critical",g[g.Off=6]="Off"})(f||(f={}));async function R(g,A,I,$,v){try{const S=await new Promise((l,o)=>{me(["@vscode/spdlog"],l,o)});S.setFlushOn(f.Trace);const w=await S.createAsyncRotatingLogger(g,A,I,$);return v?w.clearFormatters():w.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),w}catch(S){console.error(S)}return null}function L(g,A,I){switch(A){case T.LogLevel.Trace:g.trace(I);break;case T.LogLevel.Debug:g.debug(I);break;case T.LogLevel.Info:g.info(I);break;case T.LogLevel.Warning:g.warn(I);break;case T.LogLevel.Error:g.error(I);break;case T.LogLevel.Off:break;default:throw new Error(`Invalid log level ${A}`)}}function b(g,A){switch(A){case T.LogLevel.Trace:g.setLevel(f.Trace);break;case T.LogLevel.Debug:g.setLevel(f.Debug);break;case T.LogLevel.Info:g.setLevel(f.Info);break;case T.LogLevel.Warning:g.setLevel(f.Warning);break;case T.LogLevel.Error:g.setLevel(f.Error);break;case T.LogLevel.Off:g.setLevel(f.Off);break;default:throw new Error(`Invalid log level ${A}`)}}class y extends T.$jj{constructor(A,I,$,v,S){super(),this.m=[],this.setLevel(S),this.n=this.s(A,I,$,v),this.B(this.onDidChangeLogLevel(w=>{this.r&&b(this.r,w)}))}async s(A,I,$,v){const S=$?6:1,w=30/S*C.$Mk.MB,l=await R(A,I,w,S,v);if(l){this.r=l,b(this.r,this.getLevel());for(const{level:o,message:i}of this.m)L(this.r,o,i);this.m=[]}}g(A,I){this.r?L(this.r,A,I):this.getLevel()<=A&&this.m.push({level:A,message:I})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$NN=y}),define(ke[136],Se([1,0,39,206,5]),function(me,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ft=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(R||(e.MarkerTag=R={}));var L;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(L||(e.MarkerSeverity=L={})),function(y){function g(S,w){return w-S}y.compare=g;const A=Object.create(null);A[y.Error]=(0,T.localize)(0,null),A[y.Warning]=(0,T.localize)(1,null),A[y.Info]=(0,T.localize)(2,null);function I(S){return A[S]||""}y.toString=I;function $(S){switch(S){case C.default.Error:return y.Error;case C.default.Warning:return y.Warning;case C.default.Info:return y.Info;case C.default.Ignore:return y.Hint}}y.fromSeverity=$;function v(S){switch(S){case y.Error:return C.default.Error;case y.Warning:return C.default.Warning;case y.Info:return C.default.Info;case y.Hint:return C.default.Ignore}}y.toSeverity=v}(L||(e.MarkerSeverity=L={}));var b;(function(y){const g="";function A($){return I($,!0)}y.makeKey=A;function I($,v){const S=[g];return $.source?S.push($.source.replace("\xA6","\\\xA6")):S.push(g),$.code?typeof $.code=="string"?S.push($.code.replace("\xA6","\\\xA6")):S.push($.code.value.replace("\xA6","\\\xA6")):S.push(g),$.severity!==void 0&&$.severity!==null?S.push(L.toString($.severity)):S.push(g),$.message&&v?S.push($.message.replace("\xA6","\\\xA6")):S.push(g),$.startLineNumber!==void 0&&$.startLineNumber!==null?S.push($.startLineNumber.toString()):S.push(g),$.startColumn!==void 0&&$.startColumn!==null?S.push($.startColumn.toString()):S.push(g),$.endLineNumber!==void 0&&$.endLineNumber!==null?S.push($.endLineNumber.toString()):S.push(g),$.endColumn!==void 0&&$.endColumn!==null?S.push($.endColumn.toString()):S.push(g),S.push(g),S.join("\xA6")}y.makeKeyOptionalMessage=I})(b||(e.IMarkerData=b={})),e.$ft=(0,f.$Vh)("markerService")}),define(ke[253],Se([1,0,4,39,5]),function(me,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8u=e.$7u=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$6u=e.Severity=void 0,e.Severity=T.default,e.$6u=(0,f.$Vh)("notificationService");var R;(function(A){A[A.DEFAULT=0]="DEFAULT",A[A.SILENT=1]="SILENT",A[A.URGENT=2]="URGENT"})(R||(e.NotificationPriority=R={}));var L;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.PROFILE=1]="PROFILE",A[A.APPLICATION=2]="APPLICATION"})(L||(e.NeverShowAgainScope=L={}));var b;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})(b||(e.NotificationsFilter=b={}));class y{constructor(){this.progress=new g,this.onDidClose=C.Event.None,this.onDidChangeVisibility=C.Event.None}updateSeverity(I){}updateMessage(I){}updateActions(I){}close(){}}e.$7u=y;class g{infinite(){}done(){}total(I){}worked(I){}}e.$8u=g}),define(ke[137],Se([1,0,13,2,5]),function(me,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TU=e.$SU=e.$RU=e.$QU=e.$PU=void 0,e.$PU=(0,f.$Vh)("openerService");function R(g,A){return T.URI.isUri(g)?(0,C.$6e)(g.scheme,A):(0,C.$7e)(g,A+":")}e.$QU=R;function L(g,...A){return A.some(I=>R(g,I))}e.$RU=L;function b(g,A){return g.with({fragment:`${A.startLineNumber},${A.startColumn}${A.endLineNumber?`-${A.endLineNumber}${A.endColumn?`,${A.endColumn}`:""}`:""}`})}e.$SU=b;function y(g){let A;const I=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(g.fragment);return I&&(A={startLineNumber:parseInt(I[1]),startColumn:I[2]?parseInt(I[2]):1,endLineNumber:I[4]?parseInt(I[4]):void 0,endColumn:I[4]?I[5]?parseInt(I[5]):1:void 0},g=g.with({fragment:""})),{selection:A,uri:g}}e.$TU=y}),define(ke[254],Se([1,0,49]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;const f=globalThis.vscode;if(typeof f<"u"&&typeof f.context<"u"){const R=f.context.configuration();if(R)T=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(T=globalThis._VSCODE_PRODUCT_JSON,C.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`,serverDataFolderName:T.serverDataFolderName?`${T.serverDataFolderName}-dev`:void 0}),!T.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(T,{version:R.version})}}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=T}),define(ke[138],Se([1,0,5]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wj=e.$vj=void 0,e.$vj=(0,C.$Vh)("productService"),e.$wj="vscode://schemas/vscode-product"});var Be=this&&this.__param||function(me,e){return function(C,T){e(C,T,me)}};define(ke[85],Se([1,0,12,21,3,5]),function(me,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cv=e.$bv=e.$av=e.$_u=e.$$u=e.$0u=e.ProgressLocation=e.$9u=void 0,e.$9u=(0,R.$Vh)("progressService");var L;(function(I){I[I.Explorer=1]="Explorer",I[I.Scm=3]="Scm",I[I.Extensions=5]="Extensions",I[I.Window=10]="Window",I[I.Notification=15]="Notification",I[I.Dialog=20]="Dialog"})(L||(e.ProgressLocation=L={})),e.$0u=Object.freeze({total(){},worked(){},done(){}});class b{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor($){this.b=$}report($){this.a=$,this.b(this.a)}}e.$$u=b;class y{get value(){return this.a}constructor($){this.e=$}report($){this.b?this.b.push($):this.b=[$],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const $=this.b.shift();this.a=$,await this.e(this.a)}}finally{this.c=!1;const $=this.d;this.d=void 0,$?.()}}drain(){return this.c?new Promise($=>{const v=this.d;this.d=()=>{v?.(),$()}}):Promise.resolve()}}e.$_u=y;let g=class extends f.$Rc{constructor($,v){super(),this.a=new C.$ih,v.withProgress($,S=>(this.b=S,this.c&&S.report(this.c),this.a.p)),this.B((0,f.$Pc)(()=>this.a.complete()))}report($){this.b?this.b.report($):this.c=$}};e.$av=g,e.$av=g=He([Be(1,e.$9u)],g);class A extends f.$Rc{constructor($){super(),this.g=$,this.a=0,this.b=this.B(new f.$Qc)}start($){this.stop();const v=++this.a,S=new T.$2d;return this.f=setTimeout(()=>{v===this.a&&(this.c=this.g.show(!0))},$),this.b.add((0,f.$Pc)(()=>clearTimeout(this.f))),this.b.add((0,f.$Pc)(()=>S.cancel())),this.b.add((0,f.$Pc)(()=>this.c?this.c.done():void 0)),{id:v,token:S.token,stop:()=>this.h(v),isCurrent:()=>this.a===v}}stop(){this.h(this.a)}h($){this.a===$&&this.b.clear()}}e.$bv=A,e.$cv=(0,R.$Vh)("editorProgressService")}),define(ke[37],Se([1,0,60,18]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mn=void 0;class f{constructor(){this.a=new Map}add(L,b){C.ok(T.$Cf(L)),C.ok(T.$Ef(b)),C.ok(!this.a.has(L),"There is already an extension with this id"),this.a.set(L,b)}knows(L){return this.a.has(L)}as(L){return this.a.get(L)||null}}e.$mn=new f}),define(ke[108],Se([1,0,4,37]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=void 0,e.$nn={JSONContribution:"base.contributions.json"};function f(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class R{constructor(){this.b=new C.$Rd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(y,g){this.a[f(y)]=g,this.b.fire(y)}notifySchemaChanged(y){this.b.fire(y)}getSchemaContributions(){return{schemas:this.a}}}const L=new R;T.$mn.add(e.$nn.JSONContribution,L)}),define(ke[86],Se([1,0,19,4,18,196,44,108,37]),function(me,e,C,T,f,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.ConfigurationScope=e.$rn=e.EditPresentationTypes=void 0;var g;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(g||(e.EditPresentationTypes=g={})),e.$rn={Configuration:"base.contributions.configuration"};var A;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$sn={properties:{},patternProperties:{}},e.$tn={properties:{},patternProperties:{}},e.$un={properties:{},patternProperties:{}},e.$vn={properties:{},patternProperties:{}},e.$wn={properties:{},patternProperties:{}},e.$xn={properties:{},patternProperties:{}},e.$yn="vscode://schemas/settings/resourceLanguage",e.$zn="vscode://schemas/settings/configurationDefaults";const I=y.$mn.as(b.$nn.JSONContribution);class ${constructor(){this.h=new Set,this.i=new T.$Rd,this.onDidSchemaChange=this.i.event,this.j=new T.$Rd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},I.registerSchema(e.$yn,this.g),this.v()}registerConfiguration(t,s=!0){this.registerConfigurations([t],s)}registerConfigurations(t,s=!0){const d=new Set;this.n(t,s,d),I.registerSchema(e.$yn,this.g),this.i.fire(),this.j.fire({properties:d})}deregisterConfigurations(t){const s=new Set;this.o(t,s),I.registerSchema(e.$yn,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:t,remove:s}){const d=new Set;this.o(s,d),this.n(t,!1,d),I.registerSchema(e.$yn,this.g),this.i.fire(),this.j.fire({properties:d})}registerDefaultConfigurations(t){const s=new Set;this.k(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(t,s){const d=[];for(const{overrides:c,source:u}of t)for(const h in c)if(s.add(h),e.$Bn.test(h)){const E=this.a.get(h),D=E?.valuesSources??new Map;if(u)for(const P of Object.keys(c[h]))D.set(P,u);const m={...E?.value||{},...c[h]};this.a.set(h,{source:u,value:m,valuesSources:D});const p=(0,L.$zi)(h),k={type:"object",default:m,description:R.localize(1,null,p),$ref:e.$yn,defaultDefaultValue:m,source:f.$Cf(u)?void 0:u,defaultValueSource:u};d.push(...w(h)),this.d[h]=k,this.b.properties[h]=k}else{this.a.set(h,{value:c[h],source:u});const E=this.d[h];E&&(this.w(h,E),this.r(h,E))}this.m(d)}deregisterDefaultConfigurations(t){const s=new Set;this.l(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(t,s){for(const{overrides:d,source:c}of t)for(const u in d){const h=this.a.get(u),E=f.$Cf(c)?c:c?.id,D=f.$Cf(h?.source)?h?.source:h?.source?.id;if(E===D)if(s.add(u),this.a.delete(u),e.$Bn.test(u))delete this.d[u],delete this.b.properties[u];else{const m=this.d[u];m&&(this.w(u,m),this.r(u,m))}}this.u()}deltaConfiguration(t){let s=!1;const d=new Set;t.removedDefaults&&(this.l(t.removedDefaults,d),s=!0),t.addedDefaults&&(this.k(t.addedDefaults,d),s=!0),t.removedConfigurations&&this.o(t.removedConfigurations,d),t.addedConfigurations&&this.n(t.addedConfigurations,!1,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const s of t)this.h.add(s);this.u()}n(t,s,d){t.forEach(c=>{this.p(c,s,c.extensionInfo,c.restrictedProperties,void 0,d),this.c.push(c),this.q(c)})}o(t,s){const d=c=>{if(c.properties)for(const u in c.properties){s.add(u);const h=this.d[u];h?.policy?.name&&this.e.delete(h.policy.name),delete this.d[u],this.s(u,c.properties[u])}c.allOf?.forEach(u=>d(u))};for(const c of t){d(c);const u=this.c.indexOf(c);u!==-1&&this.c.splice(u,1)}}p(t,s=!0,d,c,u=3,h){u=f.$Lf(t.scope)?u:t.scope;const E=t.properties;if(E)for(const m in E){const p=E[m];if(s&&n(m,p)){delete E[m];continue}if(p.source=d,p.defaultDefaultValue=E[m].default,this.w(m,p),e.$Bn.test(m)?p.scope=void 0:(p.scope=f.$Lf(p.scope)?u:p.scope,p.restricted=f.$Lf(p.restricted)?!!c?.includes(m):p.restricted),E[m].hasOwnProperty("included")&&!E[m].included){this.f[m]=E[m],delete E[m];continue}else this.d[m]=E[m],E[m].policy?.name&&this.e.set(E[m].policy.name,m);!E[m].deprecationMessage&&E[m].markdownDeprecationMessage&&(E[m].deprecationMessage=E[m].markdownDeprecationMessage),h.add(m)}const D=t.allOf;if(D)for(const m of D)this.p(m,s,d,c,u,h)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const s=d=>{const c=d.properties;if(c)for(const h in c)this.r(h,c[h]);d.allOf?.forEach(s)};s(t)}r(t,s){switch(e.$sn.properties[t]=s,s.scope){case 1:e.$tn.properties[t]=s;break;case 2:e.$un.properties[t]=s;break;case 6:e.$vn.properties[t]=s;break;case 3:e.$wn.properties[t]=s;break;case 4:e.$xn.properties[t]=s;break;case 5:e.$xn.properties[t]=s,this.g.properties[t]=s;break}}s(t,s){switch(delete e.$sn.properties[t],s.scope){case 1:delete e.$tn.properties[t];break;case 2:delete e.$un.properties[t];break;case 6:delete e.$vn.properties[t];break;case 3:delete e.$wn.properties[t];break;case 4:case 5:delete e.$xn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const s=`[${t}]`,d={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.$yn};this.w(s,d),e.$sn.properties[s]=d,e.$tn.properties[s]=d,e.$un.properties[s]=d,e.$vn.properties[s]=d,e.$wn.properties[s]=d,e.$xn.properties[s]=d}}v(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.$yn};e.$sn.patternProperties[e.$An]=t,e.$tn.patternProperties[e.$An]=t,e.$un.patternProperties[e.$An]=t,e.$vn.patternProperties[e.$An]=t,e.$wn.patternProperties[e.$An]=t,e.$xn.patternProperties[e.$An]=t,this.i.fire()}w(t,s){const d=this.a.get(t);let c=d?.value,u=d?.source;f.$Jf(c)&&(c=s.defaultDefaultValue,u=void 0),f.$Jf(c)&&(c=o(s.type)),s.default=c,s.defaultValueSource=u}}const v="\\[([^\\]]+)\\]",S=new RegExp(v,"g");e.$An=`^(${v})+$`,e.$Bn=new RegExp(e.$An);function w(a){const t=[];if(e.$Bn.test(a)){let s=S.exec(a);for(;s?.length;){const d=s[1].trim();d&&t.push(d),s=S.exec(a)}}return(0,C.$Lb)(t)}e.$Cn=w;function l(a){return a.reduce((t,s)=>`${t}[${s}]`,"")}e.$Dn=l;function o(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$En=o;const i=new $;y.$mn.add(e.$rn.Configuration,i);function n(a,t){return a.trim()?e.$Bn.test(a)?R.localize(7,null,a):i.getConfigurationProperties()[a]!==void 0?R.localize(8,null,a):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,a,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}e.$Fn=n;function r(){const a=[],t=i.getConfigurationProperties();for(const s of Object.keys(t))a.push([s,t[s].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.$Gn=r}),define(ke[255],Se([1,0,19,4,160,3,28,24,18,2,44,86,37]),function(me,e,C,T,f,R,L,b,y,g,A,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=void 0;function v(s){return Object.isFrozen(s)?s:b.$bn(s)}class S{constructor(d={},c=[],u=[],h){this.b=d,this.c=c,this.d=u,this.raw=h,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const d=this.raw.map(c=>{if(c instanceof S)return c;const u=new w("");return u.parseRaw(c),u.configurationModel});this.f=d.reduce((c,u)=>u===c?u:c.merge(u),d[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(d){return d?(0,A.$xi)(this.contents,d):this.contents}inspect(d,c){const u=this.rawConfiguration.getValue(d),h=c?this.rawConfiguration.getOverrideValue(d,c):void 0,E=c?this.rawConfiguration.override(c).getValue(d):u;return{value:u,override:h,merged:E}}getOverrideValue(d,c){const u=this.i(c);return u?d?(0,A.$xi)(u,d):u:void 0}getKeysForOverrideIdentifier(d){const c=[];for(const u of this.overrides)u.identifiers.includes(d)&&c.push(...u.keys);return C.$Lb(c)}getAllOverrideIdentifiers(){const d=[];for(const c of this.overrides)d.push(...c.identifiers);return C.$Lb(d)}override(d){let c=this.a.get(d);return c||(c=this.g(d),this.a.set(d,c)),c}merge(...d){const c=b.$an(this.contents),u=b.$an(this.overrides),h=[...this.keys],E=this.raw?.length?[...this.raw]:[this];for(const D of d)if(E.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.h(c,D.contents);for(const m of D.overrides){const[p]=u.filter(k=>C.$tb(k.identifiers,m.identifiers));p?(this.h(p.contents,m.contents),p.keys.push(...m.keys),p.keys=C.$Lb(p.keys)):u.push(b.$an(m))}for(const m of D.keys)h.indexOf(m)===-1&&h.push(m)}return new S(c,h,u,E.every(D=>D instanceof S)?void 0:E)}g(d){const c=this.i(d);if(!c||typeof c!="object"||!Object.keys(c).length)return this;const u={};for(const h of C.$Lb([...Object.keys(this.contents),...Object.keys(c)])){let E=this.contents[h];const D=c[h];D&&(typeof E=="object"&&typeof D=="object"?(E=b.$an(E),this.h(E,D)):E=D),u[h]=E}return new S(u,this.keys,this.overrides)}h(d,c){for(const u of Object.keys(c)){if(u in d&&y.$Ef(d[u])&&y.$Ef(c[u])){this.h(d[u],c[u]);continue}d[u]=b.$an(c[u])}}i(d){let c=null,u=null;const h=E=>{E&&(u?this.h(u,E):u=b.$an(E))};for(const E of this.overrides)E.identifiers.length===1&&E.identifiers[0]===d?c=E.contents:E.identifiers.includes(d)&&h(E.contents);return h(c),u}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(d,c){this.j(d,c,!0)}setValue(d,c){this.j(d,c,!1)}removeValue(d){const c=this.keys.indexOf(d);c!==-1&&(this.keys.splice(c,1),(0,A.$wi)(this.contents,d),I.$Bn.test(d)&&this.overrides.splice(this.overrides.findIndex(u=>C.$tb(u.identifiers,(0,I.$Cn)(d))),1))}j(d,c,u){(0,A.$vi)(this.contents,d,c,h=>console.error(h)),u=u||this.keys.indexOf(d)===-1,u&&this.keys.push(d),I.$Bn.test(d)&&this.overrides.push({identifiers:(0,I.$Cn)(d),keys:Object.keys(this.contents[d]),contents:(0,A.$ui)(this.contents[d],h=>console.error(h))})}}e.$Hn=S;class w{constructor(d){this.f=d,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new S}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(d,c){if(!y.$Lf(d)){const u=this.g(d);this.parseRaw(u,c)}}reparse(d){this.a&&this.parseRaw(this.a,d)}parseRaw(d,c){this.a=d;const{contents:u,keys:h,overrides:E,restricted:D,hasExcludedProperties:m}=this.h(d,c);this.b=new S(u,h,E,m?[d]:void 0),this.c=D||[]}g(d){let c={},u=null,h=[];const E=[],D=[];function m(k){Array.isArray(h)?h.push(k):u!==null&&(h[u]=k)}const p={onObjectBegin:()=>{const k={};m(k),E.push(h),h=k,u=null},onObjectProperty:k=>{u=k},onObjectEnd:()=>{h=E.pop()},onArrayBegin:()=>{const k=[];m(k),E.push(h),h=k,u=null},onArrayEnd:()=>{h=E.pop()},onLiteralValue:m,onError:(k,P,z)=>{D.push({error:k,offset:P,length:z})}};if(d)try{f.$0m(d,p),c=h[0]||{}}catch(k){console.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return c}h(d,c){const u=$.$mn.as(I.$rn.Configuration).getConfigurationProperties(),h=this.i(d,u,!0,c);d=h.raw;const E=(0,A.$ui)(d,p=>console.error(`Conflict in settings file ${this.f}: ${p}`)),D=Object.keys(d),m=this.j(d,p=>console.error(`Conflict in settings file ${this.f}: ${p}`));return{contents:E,keys:D,overrides:m,restricted:h.restricted,hasExcludedProperties:h.hasExcludedProperties}}i(d,c,u,h){let E=!1;if(!h?.scopes&&!h?.skipRestricted&&!h?.exclude?.length)return{raw:d,restricted:[],hasExcludedProperties:E};const D={},m=[];for(const p in d)if(I.$Bn.test(p)&&u){const k=this.i(d[p],c,!1,h);D[p]=k.raw,E=E||k.hasExcludedProperties,m.push(...k.restricted)}else{const k=c[p],P=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&m.push(p),!h.exclude?.includes(p)&&(h.include?.includes(p)||(P===void 0||h.scopes===void 0||h.scopes.includes(P))&&!(h.skipRestricted&&k?.restricted))?D[p]=d[p]:E=!0}return{raw:D,restricted:m,hasExcludedProperties:E}}j(d,c){const u=[];for(const h of Object.keys(d))if(I.$Bn.test(h)){const E={};for(const D in d[h])E[D]=d[h][D];u.push({identifiers:(0,I.$Cn)(h),keys:Object.keys(E),contents:(0,A.$ui)(E,c)})}return u}}e.$In=w;class l extends R.$Rc{constructor(d,c,u,h){super(),this.c=d,this.f=c,this.g=h,this.b=this.B(new T.$Rd),this.onDidChange=this.b.event,this.a=new w(this.c.toString()),this.B(this.g.watch(u.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(T.Event.any(T.Event.filter(this.g.onDidFilesChange,E=>E.contains(this.c)),T.Event.filter(this.g.onDidRunOperation,E=>(E.isOperation(0)||E.isOperation(3)||E.isOperation(1)||E.isOperation(4))&&u.isEqual(E.resource,d)))(()=>this.b.fire()))}async loadConfiguration(){try{const d=await this.g.readFile(this.c);return this.a.parse(d.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new S}}reparse(d){return d&&(this.f=d),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Jn=l;class o{constructor(d,c,u,h,E,D,m,p,k,P,z,j,M){this.a=d,this.b=c,this.c=u,this.overrideIdentifiers=h,this.d=E,this.f=D,this.g=m,this.h=p,this.i=k,this.j=P,this.k=z,this.l=j,this.m=M}get value(){return v(this.c)}n(d,c,u){const h=d.inspect(c,u);return{get value(){return v(h.value)},get override(){return v(h.override)},get merged(){return v(h.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class i{constructor(d,c,u,h,E=new S,D=new S,m=new L.$zc,p=new S,k=new L.$zc){this.c=d,this.d=c,this.f=u,this.g=h,this.h=E,this.i=D,this.j=m,this.l=p,this.m=k,this.a=null,this.b=new L.$zc,this.n=null}getValue(d,c,u){return this.p(d,c,u).getValue(d)}updateValue(d,c,u={}){let h;u.resource?(h=this.m.get(u.resource),h||(h=new S,this.m.set(u.resource,h))):h=this.l,c===void 0?h.removeValue(d):h.setValue(d,c),u.resource||(this.a=null)}inspect(d,c,u){const h=this.p(d,c,u),E=this.t(c.resource,u),D=c.resource?this.m.get(c.resource)||this.l:this.l,m=new Set;for(const p of h.overrides)for(const k of p.identifiers)h.getOverrideValue(d,k)!==void 0&&m.add(k);return new o(d,c,h.getValue(d),m.size?[...m]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,u?this.i:void 0,E||void 0,D)}keys(d){const c=this.t(void 0,d);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:c?c.keys.slice(0):[]}}updateDefaultConfiguration(d){this.c=d,this.a=null,this.b.clear()}updatePolicyConfiguration(d){this.d=d}updateApplicationConfiguration(d){this.f=d,this.a=null,this.b.clear()}updateLocalUserConfiguration(d){this.g=d,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(d){this.h=d,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(d){this.i=d,this.a=null,this.b.clear()}updateFolderConfiguration(d,c){this.j.set(d,c),this.b.delete(d)}deleteFolderConfiguration(d){this.folderConfigurations.delete(d),this.b.delete(d)}compareAndUpdateDefaultConfiguration(d,c){const u=[];if(!c){const{added:h,updated:E,removed:D}=a(this.c,d);c=[...h,...E,...D]}for(const h of c)for(const E of(0,I.$Cn)(h)){const D=this.c.getKeysForOverrideIdentifier(E),m=d.getKeysForOverrideIdentifier(E),p=[...m.filter(k=>D.indexOf(k)===-1),...D.filter(k=>m.indexOf(k)===-1),...D.filter(k=>!b.$en(this.c.override(E).getValue(k),d.override(E).getValue(k)))];u.push([E,p])}return this.updateDefaultConfiguration(d),{keys:c,overrides:u}}compareAndUpdatePolicyConfiguration(d){const{added:c,updated:u,removed:h}=a(this.d,d),E=[...c,...u,...h];return E.length&&this.updatePolicyConfiguration(d),{keys:E,overrides:[]}}compareAndUpdateApplicationConfiguration(d){const{added:c,updated:u,removed:h,overrides:E}=a(this.applicationConfiguration,d),D=[...c,...u,...h];return D.length&&this.updateApplicationConfiguration(d),{keys:D,overrides:E}}compareAndUpdateLocalUserConfiguration(d){const{added:c,updated:u,removed:h,overrides:E}=a(this.localUserConfiguration,d),D=[...c,...u,...h];return D.length&&this.updateLocalUserConfiguration(d),{keys:D,overrides:E}}compareAndUpdateRemoteUserConfiguration(d){const{added:c,updated:u,removed:h,overrides:E}=a(this.remoteUserConfiguration,d),D=[...c,...u,...h];return D.length&&this.updateRemoteUserConfiguration(d),{keys:D,overrides:E}}compareAndUpdateWorkspaceConfiguration(d){const{added:c,updated:u,removed:h,overrides:E}=a(this.workspaceConfiguration,d),D=[...c,...u,...h];return D.length&&this.updateWorkspaceConfiguration(d),{keys:D,overrides:E}}compareAndUpdateFolderConfiguration(d,c){const u=this.folderConfigurations.get(d),{added:h,updated:E,removed:D,overrides:m}=a(u,c),p=[...h,...E,...D];return(p.length||!u)&&this.updateFolderConfiguration(d,c),{keys:p,overrides:m}}compareAndDeleteFolderConfiguration(d){const c=this.folderConfigurations.get(d);if(!c)throw new Error("Unknown folder");this.deleteFolderConfiguration(d);const{added:u,updated:h,removed:E,overrides:D}=a(c,void 0);return{keys:[...u,...h,...E],overrides:D}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(d,c,u){let h=this.q(c,u);return c.overrideIdentifier&&(h=h.override(c.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(d)!==void 0&&(h=h.merge(this.d)),h}q({resource:d},c){let u=this.r();if(c&&d){const h=c.getFolder(d);h&&(u=this.s(h.uri)||u);const E=this.m.get(d);E&&(u=u.merge(E))}return u}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(d){let c=this.b.get(d);if(!c){const u=this.r(),h=this.j.get(d);h?(c=u.merge(h),this.b.set(d,c)):c=u}return c}t(d,c){if(c&&d){const u=c.getFolder(d);if(u)return this.j.get(u.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((d,c)=>{const{contents:u,overrides:h,keys:E}=this.j.get(c);return d.push([c,{contents:u,overrides:h,keys:E}]),d},[])}}allKeys(){const d=new Set;return this.c.keys.forEach(c=>d.add(c)),this.userConfiguration.keys.forEach(c=>d.add(c)),this.i.keys.forEach(c=>d.add(c)),this.j.forEach(c=>c.keys.forEach(u=>d.add(u))),[...d.values()]}u(){const d=new Set;return this.c.getAllOverrideIdentifiers().forEach(c=>d.add(c)),this.userConfiguration.getAllOverrideIdentifiers().forEach(c=>d.add(c)),this.i.getAllOverrideIdentifiers().forEach(c=>d.add(c)),this.j.forEach(c=>c.getAllOverrideIdentifiers().forEach(u=>d.add(u))),[...d.values()]}v(d){const c=new Set;return this.c.getKeysForOverrideIdentifier(d).forEach(u=>c.add(u)),this.userConfiguration.getKeysForOverrideIdentifier(d).forEach(u=>c.add(u)),this.i.getKeysForOverrideIdentifier(d).forEach(u=>c.add(u)),this.j.forEach(u=>u.getKeysForOverrideIdentifier(d).forEach(h=>c.add(h))),[...c.values()]}static parse(d){const c=this.w(d.defaults),u=this.w(d.policy),h=this.w(d.application),E=this.w(d.user),D=this.w(d.workspace),m=d.folders.reduce((p,k)=>(p.set(g.URI.revive(k[0]),this.w(k[1])),p),new L.$zc);return new i(c,u,h,E,new S,D,m,new S,new L.$zc)}static w(d){return new S(d.contents,d.keys,d.overrides)}}e.$Kn=i;function n(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const d=new Set,c=new Map;for(const h of s)h.keys.forEach(E=>d.add(E)),h.overrides.forEach(([E,D])=>{const m=(0,L.$wc)(c,E,new Set);D.forEach(p=>m.add(p))});const u=[];return c.forEach((h,E)=>u.push([E,[...h.values()]])),{keys:[...d.values()],overrides:u}}e.$Ln=n;class r{constructor(d,c,u,h){this.change=d,this.f=c,this.g=u,this.h=h,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const E of d.keys)this.affectedKeys.add(E);for(const[,E]of d.overrides)for(const D of E)this.affectedKeys.add(D);this.d=this.a;for(const E of this.affectedKeys)this.d+=E+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=i.parse(this.f.data)),this.i}affectsConfiguration(d,c){const u=this.a+d,h=this.d.indexOf(u);if(h<0)return!1;const E=h+u.length;if(E>=this.d.length)return!1;const D=this.d.charCodeAt(E);if(D!==this.b&&D!==this.c)return!1;if(c){const m=this.previousConfiguration?this.previousConfiguration.getValue(d,c,this.f?.workspace):void 0,p=this.g.getValue(d,c,this.h);return!b.$en(m,p)}return!0}}e.$Mn=r;function a(s,d){const{added:c,removed:u,updated:h}=t(d?.rawConfiguration,s?.rawConfiguration),E=[],D=s?.getAllOverrideIdentifiers()||[],m=d?.getAllOverrideIdentifiers()||[];if(d){const p=m.filter(k=>!D.includes(k));for(const k of p)E.push([k,d.getKeysForOverrideIdentifier(k)])}if(s){const p=D.filter(k=>!m.includes(k));for(const k of p)E.push([k,s.getKeysForOverrideIdentifier(k)])}if(d&&s){for(const p of D)if(m.includes(p)){const k=t({contents:s.getOverrideValue(void 0,p)||{},keys:s.getKeysForOverrideIdentifier(p)},{contents:d.getOverrideValue(void 0,p)||{},keys:d.getKeysForOverrideIdentifier(p)});E.push([p,[...k.added,...k.removed,...k.updated]])}}return{added:c,removed:u,updated:h,overrides:E}}function t(s,d){const c=s?d?s.keys.filter(E=>d.keys.indexOf(E)===-1):[...s.keys]:[],u=d?s?d.keys.filter(E=>s.keys.indexOf(E)===-1):[...d.keys]:[],h=[];if(s&&d){for(const E of d.keys)if(s.keys.indexOf(E)!==-1){const D=(0,A.$xi)(d.contents,E),m=(0,A.$xi)(s.contents,E);b.$en(D,m)||h.push(E)}}return{added:c,removed:u,updated:h}}}),define(ke[256],Se([1,0,22,4,3,82]),function(me,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7pb=e.$6pb=e.$5pb=e.$4pb=void 0;const L=(g,A,I)=>{const $=new Uint8Array(16);for(let w=0;w<16;w++)$[w]=Math.round(Math.random()*256);const v=(0,C.$ze)(C.$fe.wrap($));return[`GET ws://localhost${g}?${A}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${v}`].join(`\r
`)+`\r
\r
`};e.$4pb=L,e.$5pb=C.$fe.fromString(`\r
\r
`);async function b(g,A,I,$,v){g.write(C.$fe.fromString((0,e.$4pb)(A,I,$)));const S=new f.$Qc;try{return await new Promise((w,l)=>{let o;S.add(g.onData(i=>{o?o=C.$fe.concat([o,i],o.byteLength+i.byteLength):o=i;const n=o.indexOf(e.$5pb);if(n===-1)return;w(g),g.pauseData();const r=o.slice(n+e.$5pb.byteLength);r.byteLength&&v.onData.fire(r)})),S.add(g.onClose(i=>l(i??new Error("socket closed")))),S.add(g.onEnd(()=>l(new Error("socket ended"))))})}catch(w){throw g.dispose(),w}finally{S.dispose()}}e.$6pb=b;class y extends f.$Rc{constructor(A,I){super(),this.g=A,this.a=this.B(new T.$Ud),this.onData=(...$)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...$)),this.b=this.B(new T.$Rd),this.onDidDispose=this.b.event,this.f=!1,this.B(I.onData),this.B(I.onData.event($=>this.a.fire($))),this.onClose=this.B(I.onClose).event,this.onEnd=this.B(I.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(A,I){R.SocketDiagnostics.traceSocketEvent(this,this.g,A,I)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$7pb=y}),define(ke[64],Se([1,0,8,5]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.$Yk=e.RemoteAuthorityResolverErrorCode=e.$Xk=e.$Wk=e.RemoteConnectionType=e.$Vk=void 0,e.$Vk=(0,T.$Vh)("remoteAuthorityResolverService");var f;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(f||(e.RemoteConnectionType=f={}));class R{constructor(I){this.id=I,this.type=1}toString(){return`Managed(${this.id})`}}e.$Wk=R;class L{constructor(I,$){this.host=I,this.port=$,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Xk=L;var b;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(b||(e.RemoteAuthorityResolverErrorCode=b={}));class y extends C.$ab{static isNotAvailable(I){return I instanceof y&&I._code===b.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof y&&I._code===b.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof y&&I._code===b.NoResolverFound}static isInvalidAuthority(I){return I instanceof y&&I._code===b.InvalidAuthority}static isHandled(I){return I instanceof y&&I.isHandled}constructor(I,$=b.Unknown,v){super(I),this._message=I,this._code=$,this._detail=v,this.isHandled=$===b.NotAvailable&&v===!0,Object.setPrototypeOf(this,y.prototype)}}e.$Yk=y;function g(A){const I=A.indexOf("+");return I===-1?A:A.substring(0,I)}e.$Zk=g}),define(ke[65],Se([1,0,17]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=void 0;function T(g){return g.scheme===C.Schemas.vscodeRemote?g.authority:void 0}e.$1k=T;function f(g){if(!g)return;const A=g.indexOf("+");return A<0?g:g.substr(0,A)}e.$2k=f;function R(g){return`/${g.quality??"oss"}-${g.commit??"dev"}`}e.$3k=R;function L(g){const{host:A,port:I}=y(g);if(typeof I>"u")throw new Error("Remote authority doesn't contain a port!");return{host:A,port:I}}e.$4k=L;function b(g,A){let{host:I,port:$}=y(g);return typeof $>"u"&&($=A),{host:I,port:$}}e.$5k=b;function y(g){const A=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const I=g.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const $=g.match(/(.*):(\d+)$/);return $?{host:$[1],port:parseInt($[2],10)}:{host:g,port:void 0}}}),define(ke[26],Se([1,0,13,5,65]),function(me,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.TargetPlatform=e.ExtensionType=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=void 0,e.$6l="extensions.user.cache",e.$7l="extensions.builtin.cache",e.$8l="undefined_publisher",e.$9l=["ui","workspace","web"];function R(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.$0l=R,e.$$l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(L||(e.ExtensionType=L={}));var b;(function(w){w.WIN32_X64="win32-x64",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class y{constructor(l){this.value=l,this._lower=l.toLowerCase()}static equals(l,o){if(typeof l>"u"||l===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof l=="string"||typeof o=="string"){const i=typeof l=="string"?l:l.value,n=typeof o=="string"?o:o.value;return C.$6e(i,n)}return l._lower===o._lower}static toKey(l){return typeof l=="string"?l.toLowerCase():l._lower}}e.$_l=y;class g{get size(){return this.c.size}constructor(l){if(this.c=new Set,l)for(const o of l)this.add(o)}add(l){this.c.add(y.toKey(l))}delete(l){return this.c.delete(y.toKey(l))}has(l){return this.c.has(y.toKey(l))}}e.$am=g;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(l){this.c.delete(y.toKey(l))}get(l){return this.c.get(y.toKey(l))}has(l){return this.c.has(y.toKey(l))}set(l,o){this.c.set(y.toKey(l),o)}values(){return this.c.values()}forEach(l){this.c.forEach(l)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$bm=A;function I(w){return $(w)}e.$cm=I;function $(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.$dm=$;function v(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.$em=v;function S(w,l){if(l){const o=`onResolveRemoteAuthority:${(0,f.$2k)(l)}`;return!!w.activationEvents?.includes(o)}return!1}e.$fm=S,e.$gm=(0,T.$Vh)("IBuiltinExtensionsScannerService")}),define(ke[139],Se([1,0,8,26]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yF=e.$xF=void 0;class f{constructor(){this.a=new Map,this.b=new WeakMap}register(L,b){this.a.set(L,b)}readActivationEvents(L){return this.b.has(L)||this.b.set(L,this.c(L)),this.b.get(L)}createActivationEventsMap(L){const b=Object.create(null);for(const y of L){const g=this.readActivationEvents(y);g.length>0&&(b[T.$_l.toKey(y.identifier)]=g)}return b}c(L){if(typeof L.main>"u"&&typeof L.browser>"u")return[];const b=Array.isArray(L.activationEvents)?L.activationEvents.slice(0):[];for(let y=0;y<b.length;y++)b[y]==="onUri"&&(b[y]=`onUri:${T.$_l.toKey(L.identifier)}`);if(!L.contributes)return b;for(const y in L.contributes){const g=this.a.get(y);if(!g)continue;const A=L.contributes[y],I=Array.isArray(A)?A:[A];try{g(I,b)}catch($){(0,C.$Z)($)}}return b}}e.$xF=f,e.$yF=new f}),define(ke[257],Se([1,0,12,22,21,8,4,3,56,38,32,82,64,65]),function(me,e,C,T,f,R,L,b,y,g,A,I,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.PersistentConnectionEventType=e.$_k=e.$$k=e.$0k=e.ConnectionType=void 0;const S=30*1e3;var w;(function(q){q[q.Management=1]="Management",q[q.ExtensionHost=2]="ExtensionHost",q[q.Tunnel=3]="Tunnel"})(w||(e.ConnectionType=w={}));function l(q){switch(q){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function o(q){const U=new f.$2d;return setTimeout(()=>U.cancel(),q),U.token}function i(q,U){if(q.isCancellationRequested||U.isCancellationRequested)return f.CancellationToken.Cancelled;const ne=new f.$2d;return q.onCancellationRequested(()=>ne.cancel()),U.onCancellationRequested(()=>ne.cancel()),ne.token}class n{get didTimeout(){return this.c==="timedout"}constructor(U){this.c="pending",this.d=new b.$Qc,this.promise=new Promise((ne,be)=>{this.f=ne,this.g=be}),U.isCancellationRequested?this.h():this.d.add(U.onCancellationRequested(()=>this.h()))}registerDisposable(U){this.c==="pending"?this.d.add(U):U.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(U))}reject(U){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(U))}}function r(q,U){const ne=new n(U);return ne.registerDisposable(q.onControlMessage(be=>{const H=JSON.parse(be.toString()),x=Q(H);x?ne.reject(x):ne.resolve(H)})),ne.promise}function a(q,U,ne,be,H,x,Y,$e){const ie=new n($e),fe=g.$Nd.create(!1);return q.info(`Creating a socket (${Y})...`),y.mark(`code/willCreateSocket/${x}`),U.connect(ne,be,H,Y).then(te=>{ie.didTimeout?(y.mark(`code/didCreateSocketError/${x}`),q.info(`Creating a socket (${Y}) finished after ${fe.elapsed()} ms, but this is too late and has timed out already.`),te?.dispose()):(y.mark(`code/didCreateSocketOK/${x}`),q.info(`Creating a socket (${Y}) was successful after ${fe.elapsed()} ms.`),ie.resolve(te))},te=>{y.mark(`code/didCreateSocketError/${x}`),q.info(`Creating a socket (${Y}) returned an error after ${fe.elapsed()} ms.`),q.error(te),ie.reject(te)}),ie.promise}function t(q,U){const ne=new n(U);return q.then(be=>{ne.didTimeout||ne.resolve(be)},be=>{ne.didTimeout||ne.reject(be)}),ne.promise}async function s(q,U,ne,be){const H=Ee(q,U);q.logService.trace(`${H} 1/6. invoking socketFactory.connect().`);let x;try{x=await a(q.logService,q.remoteSocketFactoryService,q.connectTo,(0,v.$3k)(q),`reconnectionToken=${q.reconnectionToken}&reconnection=${q.reconnectionProtocol?"true":"false"}`,l(U),`renderer-${l(U)}-${q.reconnectionToken}`,be)}catch(te){throw q.logService.error(`${H} socketFactory.connect() failed or timed out. Error:`),q.logService.error(te),te}q.logService.trace(`${H} 2/6. socketFactory.connect() was successful.`);let Y,$e;q.reconnectionProtocol?(q.reconnectionProtocol.beginAcceptReconnection(x,null),Y=q.reconnectionProtocol,$e=!1):(Y=new I.$Jh({socket:x}),$e=!0),q.logService.trace(`${H} 3/6. sending AuthRequest control message.`);const ie=await t(q.signService.createNewMessage((0,A.$ig)()),be),fe={type:"auth",auth:q.connectionToken||"00000000000000000000",data:ie.data};Y.sendControl(T.$fe.fromString(JSON.stringify(fe)));try{const te=await r(Y,i(be,o(1e4)));if(te.type!=="sign"||typeof te.data!="string"){const B=new Error("Unexpected handshake message");throw B.code="VSCODE_CONNECTION_ERROR",B}if(q.logService.trace(`${H} 4/6. received SignRequest control message.`),!await t(q.signService.validate(ie,te.signedData),be)){const B=new Error("Refused to connect to unsupported server");throw B.code="VSCODE_CONNECTION_ERROR",B}const pe=await t(q.signService.sign(te.data),be),Pe={type:"connectionType",commit:q.commit,signedData:pe,desiredConnectionType:U};return ne&&(Pe.args=ne),q.logService.trace(`${H} 5/6. sending ConnectionTypeRequest control message.`),Y.sendControl(T.$fe.fromString(JSON.stringify(Pe))),{protocol:Y,ownsProtocol:$e}}catch(te){throw te&&te.code==="ETIMEDOUT"&&(q.logService.error(`${H} the handshake timed out. Error:`),q.logService.error(te)),te&&te.code==="VSCODE_CONNECTION_ERROR"&&(q.logService.error(`${H} received error control message when negotiating connection. Error:`),q.logService.error(te)),$e&&J(Y),te}}async function d(q,U,ne,be){const H=Date.now(),x=Ee(q,U),{protocol:Y,ownsProtocol:$e}=await s(q,U,ne,be),ie=new n(be);return ie.registerDisposable(Y.onControlMessage(fe=>{const te=JSON.parse(fe.toString()),de=Q(te);de?(q.logService.error(`${x} received error control message when negotiating connection. Error:`),q.logService.error(de),$e&&J(Y),ie.reject(de)):(q.reconnectionProtocol?.endAcceptReconnection(),q.logService.trace(`${x} 6/6. handshake finished, connection is up and running after ${he(H)}!`),ie.resolve({protocol:Y,firstMessage:te}))})),ie.promise}async function c(q,U){const{protocol:ne}=await d(q,1,void 0,U);return{protocol:ne}}async function u(q,U,ne){const{protocol:be,firstMessage:H}=await d(q,2,U,ne),x=H&&H.debugPort;return{protocol:be,debugPort:x}}async function h(q,U,ne){const be=Date.now(),H=Ee(q,3),{protocol:x}=await s(q,3,U,ne);return q.logService.trace(`${H} 6/6. handshake finished, connection is up and running after ${he(be)}!`),x}async function E(q,U,ne){const{connectTo:be,connectionToken:H}=await q.addressProvider.getAddress();return{commit:q.commit,quality:q.quality,connectTo:be,connectionToken:H,reconnectionToken:U,reconnectionProtocol:ne,remoteSocketFactoryService:q.remoteSocketFactoryService,signService:q.signService,logService:q.logService}}async function D(q,U,ne){return p(q,async be=>{const{protocol:H}=await c(be,f.CancellationToken.None);return new X(q,U,ne,be.reconnectionToken,H)})}e.$0k=D;async function m(q,U){return p(q,async ne=>{const{protocol:be,debugPort:H}=await u(ne,U,f.CancellationToken.None);return new ce(q,U,ne.reconnectionToken,be,H)})}e.$$k=m;async function p(q,U){for(let be=1;;be++)try{const H=(0,A.$ig)(),x=await E(q,H,null);return await U(x)}catch(H){if(be<5)q.logService.error(`[remote-connection][attempt ${be}] An error occurred in initial connection! Will retry... Error:`),q.logService.error(H);else throw q.logService.error(`[remote-connection][attempt ${be}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),q.logService.error(H),W.triggerPermanentFailure(0,0,$.$Yk.isHandled(H)),H}}async function k(q,U,ne){const be=await E(q,(0,A.$ig)(),null);return await h(be,{host:U,port:ne},f.CancellationToken.None)}e.$_k=k;function P(q){return(0,C.$Lg)(U=>new Promise((ne,be)=>{const H=setTimeout(ne,q*1e3);U.onCancellationRequested(()=>{clearTimeout(H),ne()})}))}var z;(function(q){q[q.ConnectionLost=0]="ConnectionLost",q[q.ReconnectionWait=1]="ReconnectionWait",q[q.ReconnectionRunning=2]="ReconnectionRunning",q[q.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",q[q.ConnectionGain=4]="ConnectionGain"})(z||(e.PersistentConnectionEventType=z={}));class j{constructor(U,ne){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.type=0}}e.$al=j;class M{constructor(U,ne,be,H){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.durationSeconds=be,this.c=H,this.type=1}skipWait(){this.c.cancel()}}e.$bl=M;class O{constructor(U,ne,be){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.attempt=be,this.type=2}}e.$cl=O;class F{constructor(U,ne,be){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.attempt=be,this.type=4}}e.$dl=F;class N{constructor(U,ne,be,H){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.attempt=be,this.handled=H,this.type=3}}e.$el=N;class W extends b.$Rc{static triggerPermanentFailure(U,ne,be){this._permanentFailure=!0,this.f=U,this.g=ne,this.h=be,this.j.forEach(H=>H.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(U=>U.y())}static debugPauseSocketWriting(){this.j.forEach(U=>U.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||W._permanentFailure}constructor(U,ne,be,H,x){super(),this.t=U,this.u=ne,this.reconnectionToken=be,this.protocol=H,this.w=x,this.m=this.B(new L.$Rd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new F(this.reconnectionToken,0,0)),this.B(H.onSocketClose(Y=>{const $e=_(this.t,this.reconnectionToken,!0);Y?Y.type===0?(this.u.logService.info(`${$e} received socket close event (hadError: ${Y.hadError}).`),Y.error&&this.u.logService.error(Y.error)):(this.u.logService.info(`${$e} received socket close event (wasClean: ${Y.wasClean}, code: ${Y.code}, reason: ${Y.reason}).`),Y.event&&this.u.logService.error(Y.event)):this.u.logService.info(`${$e} received socket close event.`),this.y()})),this.B(H.onSocketTimeout(Y=>{const $e=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${$e} received socket timeout event (unacknowledgedMsgCount: ${Y.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Y.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Y.timeSinceLastReceivedSomeData}).`),this.y()})),W.j.push(this),this.B((0,b.$Pc)(()=>{const Y=W.j.indexOf(this);Y>=0&&W.j.splice(Y,1)})),this.n&&this.D(W.f,W.g,W.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const U=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const ne=[0,5,5,10,10,10,10,10,30];let be=-1;do{be++;const H=be<ne.length?ne[be]:ne[ne.length-1];try{if(H>0){const Y=P(H);this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),H,Y)),this.u.logService.info(`${U} waiting for ${H} seconds before reconnecting...`);try{await Y}catch{}}if(this.n){this.u.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),be+1)),this.u.logService.info(`${U} resolving connection...`);const x=await E(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${U} connecting to ${x.connectTo}...`),await this.G(x,o(S)),this.u.logService.info(`${U} reconnected!`),this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),be+1));break}catch(x){if(x.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(x),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,!1);break}if(be>360){this.u.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(x),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,!1);break}if($.$Yk.isTemporarilyNotAvailable(x)){this.u.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(x);continue}if((x.code==="ETIMEDOUT"||x.code==="ENETUNREACH"||x.code==="ECONNREFUSED"||x.code==="ECONNRESET")&&x.syscall==="connect"){this.u.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(x);continue}if((0,R.$3)(x)){this.u.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(x);continue}if(x instanceof $.$Yk){this.u.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(x),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,$.$Yk.isHandled(x));break}this.u.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(x),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,!1);break}}while(!this.n&&!this.s)}C(U,ne,be){this.w?W.triggerPermanentFailure(U,ne,be):this.D(U,ne,be)}D(U,ne,be){this.m.fire(new N(this.reconnectionToken,U,ne,be)),J(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$fl=W;class X extends W{constructor(U,ne,be,H,x){super(1,U,H,x,!0),this.client=this.B(new I.$Hh(x,{remoteAuthority:ne,clientId:be},U.ipcLogger))}async G(U,ne){await c(U,ne)}}e.$gl=X;class ce extends W{constructor(U,ne,be,H,x){super(2,U,be,H,!1),this.H=ne,this.debugPort=x}async G(U,ne){await u(U,this.H,ne)}}e.$hl=ce;function J(q){try{q.acceptDisconnect();const U=q.getSocket();q.dispose(),U.dispose()}catch(U){(0,R.$Z)(U)}}function Q(q){if(q&&q.type==="error"){const U=new Error(`Connection error: ${q.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function G(q,U){for(;q.length<U;)q+=" ";return q}function oe(q,U){return`[remote-connection][${G(l(q),13)}][${U.substr(0,5)}\u2026]`}function _(q,U,ne){return`${oe(q,U)}[${ne?"reconnect":"initial"}]`}function Ee(q,U){return`${_(U,q.reconnectionToken,!!q.reconnectionProtocol)}[${q.connectTo}]`}function he(q){return`${Date.now()-q} ms`}}),define(ke[258],Se([1,0,3,5]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7k=e.$6k=void 0,e.$6k=(0,T.$Vh)("remoteSocketFactoryService");class f{constructor(){this.a={}}register(L,b){return this.a[L]??=[],this.a[L].push(b),(0,C.$Pc)(()=>{const y=this.a[L]?.indexOf(b);typeof y=="number"&&y>=0&&this.a[L]?.splice(y,1)})}b(L){return(this.a[L.type]||[]).find(y=>y.supports(L))}connect(L,b,y,g){const A=this.b(L);if(!A)throw new Error(`No socket factory found for ${L}`);return A.connect(L,b,y,g)}}e.$7k=f}),define(ke[259],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W4b=void 0;class C{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(f){try{const R=await this.c();if(R){const L=String(C.a++);return this.b.set(L,R),{id:L,data:R.createNewMessage(f)}}}catch{}return{id:"",data:f}}async validate(f,R){if(!f.id)return!0;const L=this.b.get(f.id);if(!L)return!1;this.b.delete(f.id);try{return L.validate(R)==="ok"}catch{return!1}finally{L.dispose?.()}}async sign(f){try{return await this.d(f)}catch{}return f}}e.$W4b=C}),define(ke[109],Se([1,0,5]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9k=e.$8k=void 0,e.$8k="signService",e.$9k=(0,C.$Vh)(e.$8k)}),define(ke[140],Se([1,0,259]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T9b=void 0;class T extends C.$W4b{c(){return this.h().then(R=>new R.validator)}d(R){return this.h().then(L=>new L.signer().sign(R))}h(){return new Promise((R,L)=>me(["vsda"],R,L))}}e.$T9b=T}),define(ke[260],Se([1,0,11,49,32]),function(me,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$no=void 0;function R(y){if(C.$u===2&&/^penguin(\.|$)/i.test(y))return"chromebook"}function L(y,g,A,I,$,v,S,w,l){const o=Object.create(null);o["common.machineId"]=v,o["common.sqmId"]=S,o.sessionID=(0,f.$ig)()+Date.now(),o.commitHash=I,o.version=$,o["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,C.$h)(C.$u),o["common.nodePlatform"]=T.$cc,o["common.nodeArch"]=A,o["common.product"]=l||"desktop",w&&(o["common.msftInternal"]=w);let i=0;const n=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),C.$l&&(o["common.snap"]="true");const r=R(g);return r&&(o["common.platformDetail"]=r),o}e.$no=L;function b(y){const g=T.env.USERDNSDOMAIN;if(!g)return!1;const A=g.toLowerCase();return y.some(I=>A===I)}e.$oo=b}),define(ke[261],Se([1,0,5]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=void 0,e.$il=(0,C.$Vh)("telemetryService"),e.$jl=(0,C.$Vh)("customEndpointTelemetryService"),e.$kl="telemetry.currentSessionDate",e.$ll="telemetry.firstSessionDate",e.$ml="telemetry.lastSessionDate",e.$nl="telemetry.machineId",e.$ol="telemetry.sqmId",e.$pl="telemetry",e.$ql="telemetry.telemetryLevel",e.$rl="telemetry.enableCrashReporter",e.$sl="telemetry.enableTelemetry";var T;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(T||(e.TelemetryLevel=T={}));var f;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(f||(e.TelemetryConfiguration=f={}))}),define(ke[87],Se([1,0,24,18,4,44,65,260,261]),function(me,e,C,T,f,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=void 0;class g{constructor(u){this.value=u,this.isTrustedTelemetryValue=!0}}e.$po=g;class A{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$qo=A,e.$ro=new A;class I{async publicLog(u,h,E){}async publicLogError(u,h,E){}}e.$so=I,e.$to="telemetry",e.$uo="extensionTelemetryLog",e.$vo={log:()=>null,flush:()=>Promise.resolve(null)};function $(c,u){return f.Event.debounce(u.onDidChangeConfiguration,(E,D)=>{const m=E?new Set([...E.affectedKeys,...D.affectedKeys]):D.affectedKeys;return{...D,affectedKeys:m}},1e3,!0)(E=>{E.source!==7&&c.publicLog2("updateConfiguration",{configurationSource:(0,R.$si)(E.source),configurationKeys:Array.from(E.affectedKeys)})})}e.$wo=$;function v(c,u){return!u.isBuilt&&!u.disableTelemetry?!0:!(u.disableTelemetry||!c.enableTelemetry)}e.$xo=v;function S(c,u){return u.extensionTestsLocationURI?!0:!(u.isBuilt||u.disableTelemetry||c.enableTelemetry&&c.aiConfig?.ariaKey)}e.$yo=S;function w(c){const u=c.getValue(y.$ql),h=c.getValue(y.$rl);if(c.getValue(y.$sl)===!1||h===!1)return 0;switch(u??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$zo=w;function l(c){const u={},h={},E={};n(c,E);for(let D in E){D=D.length>150?D.substr(D.length-149):D;const m=E[D];typeof m=="number"?h[D]=m:typeof m=="boolean"?h[D]=m?1:0:typeof m=="string"?(m.length>8192&&console.warn(`Telemetry property: ${D} has been trimmed to 8192, the original length is ${m.length}`),u[D]=m.substring(0,8191)):typeof m<"u"&&m!==null&&(u[D]=m)}return{properties:u,measurements:h}}e.$Ao=l;const o=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function i(c){if(!c)return"none";const u=(0,L.$2k)(c);return o.has(u)?u:"other"}e.$Bo=i;function n(c,u,h=0,E){if(c)for(const D of Object.getOwnPropertyNames(c)){const m=c[D],p=E?E+D:D;Array.isArray(m)?u[p]=(0,C.$fn)(m):m instanceof Date?u[p]=m.toISOString():(0,T.$Ef)(m)?h<2?n(m,u,h+1,p+"."):u[p]=(0,C.$fn)(m):u[p]=m}}function r(c,u){const h=c.msftInternalDomains||[],E=u.getValue("telemetry.internalTesting");return(0,b.$oo)(h)||E}e.$Co=r;function a(c){return[c.appRoot,c.extensionsPath,c.userHome.fsPath,c.tmpDir.fsPath,c.userDataPath]}e.$Do=a;function t(c,u){if(!c||!c.includes("/")&&!c.includes("\\"))return c;let h=c;const E=[];for(const k of u)for(;;){const P=k.exec(c);if(!P)break;E.push([P.index,k.lastIndex])}const D=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,m=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let p=0;for(h="";;){const k=m.exec(c);if(!k)break;const P=E.some(([z,j])=>k.index<j&&z<m.lastIndex);!D.test(k[0])&&!P&&(h+=c.substring(p,k.index)+"<REDACTED: user-file-path>",p=m.lastIndex)}return p<c.length&&(h+=c.substr(p)),h}function s(c){if(!c)return c;const u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of u)if(h.regex.test(c))return`<REDACTED: ${h.label}>`;return c}function d(c,u){return(0,C.$cn)(c,h=>{if(h instanceof g||Object.hasOwnProperty.call(h,"isTrustedTelemetryValue"))return h.value;if(typeof h=="string"){let E=h.replaceAll("%20"," ");E=t(E,u);for(const D of u)E=E.replace(D,"");return E=s(E),E}})}e.$Eo=d}),define(ke[262],Se([1,0,13,135,26,11,2,8,49,87]),function(me,e,C,T,f,R,L,b,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=void 0;function A(d,c){return d.uuid&&c.uuid?d.uuid===c.uuid:d.id===c.id?!0:(0,C.$1e)(d.id,c.id)===0}e.$Fo=A;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class ${static create(c){const u=c.manifest?c.manifest.version:c.version,h=c.manifest?c.targetPlatform:c.properties.targetPlatform;return new $(c.identifier,u,h)}static parse(c){const u=I.exec(c);return u&&u[1]&&u[2]?new $({id:u[1]},u[2],u[4]||void 0):null}constructor(c,u,h="undefined"){this.version=u,this.targetPlatform=h,this.id=c.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(c){return c instanceof $?A(this,c)&&this.version===c.version&&this.targetPlatform===c.targetPlatform:!1}}e.$Go=$;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(d){const c=v.exec(d);return c&&c[1]?[l(c[1]),c[2]]:[l(d),void 0]}e.$Ho=S;function w(d,c){return`${d}.${c}`}e.$Io=w;function l(d){return d.toLowerCase()}e.$Jo=l;function o(d,c){return l(w(d??f.$8l,c))}e.$Ko=o;function i(d,c){const u=[],h=E=>{for(const D of u)if(D.some(m=>A(c(m),c(E))))return D;return null};for(const E of d){const D=h(E);D?D.push(E):u.push([E])}return u}e.$Lo=i;function n(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.$Mo=n;function r(d){return{id:new g.$po(d.identifier.id),name:new g.$po(d.name),galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),isSigned:d.isSigned,...d.telemetryData}}e.$No=r,e.$Oo=new f.$_l("pprice.better-merge");function a(d,c){const u=[],h=c.manifest.extensionDependencies?.slice(0)??[];for(;h.length;){const E=h.shift();if(E&&u.every(D=>!A(D.identifier,{id:E}))){const D=d.filter(m=>A(m.identifier,{id:E}));D.length===1&&(u.push(D[0]),h.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return u}e.$Po=a;async function t(d,c){if(!R.$k)return!1;let u;try{u=(await d.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{u=(await d.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(E){c.debug("Error while getting the os-release file.",(0,b.$9)(E))}}return!!u&&(u.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(d,c){const u=await t(d,c),h=(0,T.$_n)(u?"alpine":R.$u,y.$dc);return c.debug("ComputeTargetPlatform:",h),h}e.$Qo=s}),define(ke[263],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=e.$ur=e.$tr=e.$sr=e.$rr=e.$qr=void 0;function C(y){return[...y.entries()]}e.$qr=C;function T(y){return y?[...y.entries()]:[]}e.$rr=T;function f(y){return new Map(y)}e.$sr=f;function R(y){return new Map(y??[])}e.$tr=R;function L(y){return Array.from(y.entries()).map(g=>[g[0],C(g[1].map),T(g[1].descriptionMap)])}e.$ur=L;function b(y){return new Map(y.map(g=>[g[0],{map:f(g[1]),descriptionMap:R(g[2])}]))}e.$vr=b}),define(ke[264],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lqb=void 0;class C{constructor(f){this.b=f,this.a=new Map}dispose(){for(const f of this.a.values())f.dispose()}startBuffering(f,R,L=5){const b=R(y=>{const g=typeof y=="string"?y:y.data;let A=this.a.get(f);if(A){A.data.push(g);return}const I=setTimeout(()=>this.flushBuffer(f),L);A={data:[g],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(f),b.dispose()}},this.a.set(f,A)});return b}stopBuffering(f){this.a.get(f)?.dispose()}flushBuffer(f){const R=this.a.get(f);R&&(this.a.delete(f),this.b(f,R.data.join("")))}}e.$lqb=C}),define(ke[265],Se([1,0,12,78,61,4,18,2,207,108,37]),function(me,e,C,T,f,R,L,b,y,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hw=e.$gw=e.$fw=e.$ew=e.$dw=e.$cw=e.$bw=e.$aw=e.IconFontDefinition=e.IconContribution=e.$_v=void 0,e.$_v={IconContribution:"base.contributions.icons"};var I;(function(r){function a(t,s){let d=t.defaults;for(;f.ThemeIcon.isThemeIcon(d);){const c=S.getIcon(d.id);if(!c)return;d=c.defaults}return d}r.getDefinition=a})(I||(e.IconContribution=I={}));var $;(function(r){function a(s){return{weight:s.weight,style:s.style,src:s.src.map(d=>({format:d.format,location:d.location.toString()}))}}r.toJSONObject=a;function t(s){const d=c=>(0,L.$Cf)(c)?c:void 0;if(s&&Array.isArray(s.src)&&s.src.every(c=>(0,L.$Cf)(c.format)&&(0,L.$Cf)(c.location)))return{weight:d(s.weight),style:d(s.style),src:s.src.map(c=>({format:c.format,location:b.URI.parse(c.location)}))}}r.fromJSONObject=t})($||(e.IconFontDefinition=$={}));class v{constructor(){this.a=new R.$Rd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,y.localize)(0,null)},fontCharacter:{type:"string",description:(0,y.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${f.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(a,t,s,d){const c=this.b[a];if(c){if(s&&!c.description){c.description=s,this.d.properties[a].markdownDescription=`${s} $(${a})`;const E=this.e.enum.indexOf(a);E!==-1&&(this.e.enumDescriptions[E]=s),this.a.fire()}return c}const u={id:a,description:s,defaults:t,deprecationMessage:d};this.b[a]=u;const h={$ref:"#/definitions/icons"};return d&&(h.deprecationMessage=d),s&&(h.markdownDescription=`${s}: $(${a})`),this.d.properties[a]=h,this.e.enum.push(a),this.e.enumDescriptions.push(s||""),this.a.fire(),{id:a}}deregisterIcon(a){delete this.b[a],delete this.d.properties[a];const t=this.e.enum.indexOf(a);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(a=>this.b[a])}getIcon(a){return this.b[a]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(a,t){const s=this.f[a];return s||(this.f[a]=t,this.a.fire(),t)}deregisterIconFont(a){delete this.f[a]}getIconFont(a){return this.f[a]}toString(){const a=(c,u)=>c.id.localeCompare(u.id),t=c=>{for(;f.ThemeIcon.isThemeIcon(c.defaults);)c=this.b[c.defaults.id];return`codicon codicon-${c?c.id:""}`},s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const d=Object.keys(this.b).map(c=>this.b[c]);for(const c of d.filter(u=>!!u.description).sort(a))s.push(`|<i class="${t(c)}"></i>|${c.id}|${f.ThemeIcon.isThemeIcon(c.defaults)?c.defaults.id:c.id}|${c.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const c of d.filter(u=>!f.ThemeIcon.isThemeIcon(u.defaults)).sort(a))s.push(`|<i class="${t(c)}"></i>|${c.id}|`);return s.join(`
`)}}const S=new v;A.$mn.add(e.$_v.IconContribution,S);function w(r,a,t,s){return S.registerIcon(r,a,t,s)}e.$aw=w;function l(){return S}e.$bw=l;function o(){const r=(0,T.$Yj)();for(const a in r){const t="\\"+r[a].toString(16);S.registerIcon(a,{fontCharacter:t})}}o(),e.$cw="vscode://schemas/icons";const i=A.$mn.as(g.$nn.JSONContribution);i.registerSchema(e.$cw,S.getIconSchema());const n=new C.$0g(()=>i.notifySchemaChanged(e.$cw),200);S.onDidChange(()=>{n.isScheduled()||n.schedule()}),e.$dw=w("widget-close",T.$1j.close,(0,y.localize)(2,null)),e.$ew=w("goto-previous-location",T.$1j.arrowUp,(0,y.localize)(3,null)),e.$fw=w("goto-next-location",T.$1j.arrowDown,(0,y.localize)(4,null)),e.$gw=f.ThemeIcon.modify(T.$1j.sync,"spin"),e.$hw=f.ThemeIcon.modify(T.$1j.loading,"spin")}),define(ke[88],Se([1,0,4,44,5,14]),function(me,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nv=e.$mv=e.$lv=e.$kv=e.$jv=e.$iv=e.$hv=e.$gv=e.ProvidedOnAutoForward=e.$fv=e.TunnelPrivacyId=e.TunnelProtocol=e.$ev=e.$dv=void 0,e.$dv=(0,f.$Vh)("tunnelService"),e.$ev=(0,f.$Vh)("sharedTunnelsService");var L;(function(l){l.Http="http",l.Https="https"})(L||(e.TunnelProtocol=L={}));var b;(function(l){l.ConstantPrivate="constantPrivate",l.Private="private",l.Public="public"})(b||(e.TunnelPrivacyId=b={}));function y(l){return!!l.forwardPort}e.$fv=y;var g;(function(l){l[l.Notify=1]="Notify",l[l.OpenBrowser=2]="OpenBrowser",l[l.OpenPreview=3]="OpenPreview",l[l.Silent=4]="Silent",l[l.Ignore=5]="Ignore",l[l.OpenBrowserOnce=6]="OpenBrowserOnce"})(g||(e.ProvidedOnAutoForward=g={}));function A(l){if(l.scheme!=="http"&&l.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(l.authority);if(o)return{address:o[1],port:+o[2]}}e.$gv=A,e.$hv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(l){return e.$hv.indexOf(l)>=0}e.$iv=I,e.$jv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function $(l){return e.$jv.indexOf(l)>=0}e.$kv=$;function v(l,o,i,n){if(i===1)return!1;if(i===2&&$(o)){const r=/(\d+)\.(\d+)\.(\d+)/g.exec(n);if(r?.length===4&&parseInt(r[1])>=18)return!1}return l<1024}e.$lv=v;class S{constructor(o,i,n){this.remoteAddress=o,this.localAddress=i,this.b=n,this.a=new C.$Rd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$mv=S;let w=class{constructor(o,i){this.j=o,this.k=i,this.a=new C.$Rd,this.onTunnelOpened=this.a.event,this.b=new C.$Rd,this.onTunnelClosed=this.b.event,this.c=new C.$Rd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const o=this.k.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this.f=o,o?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this.g=o.elevation,this.h=o.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const o=[],i=Array.from(this.e.values());for(const n of i){const r=Array.from(n.values());for(const a of r){const t=await a.value;t&&typeof t!="string"&&o.push(t)}}return o}async dispose(){for(const o of this.e.values()){for(const{value:i}of o.values())await i.then(n=>typeof n!="string"?n?.dispose():void 0);o.clear()}this.e.clear()}setEnvironmentTunnel(o,i,n,r,a){this.p(o,i,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:i,localAddress:n,privacy:r,protocol:a,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,i){($(o)||I(o))&&(o=e.$hv[0]);const n=this.r(o,i);if(n)return++n.refcount,n.value}openTunnel(o,i,n,r,a,t=!1,s,d){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${i}:${n} on local port ${a}.`);const c=this.f??o;if(!c)return;if(i||(i="localhost"),r||(r=this.l),this.f&&this.i.has(n)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const u=this.s(c,i,n,r,a,t,s,d);return u?u.then(h=>{if(h){if(typeof h=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(i,n),h}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(i,n);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const E=this.n(h);return(h.tunnelRemoteHost!==i||h.tunnelRemotePort!==n)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&h.privacy!==s&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(E),E}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),u)}n(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const i=this.e.get(o.tunnelRemoteHost);if(i){const n=i.get(o.tunnelRemotePort);n&&(n.refcount--,await this.o(o.tunnelRemoteHost,o.tunnelRemotePort,n))}}}}async o(o,i,n){if(n.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${i}.`);const r=n.value.then(async a=>{a&&typeof a!="string"&&(await a.dispose(!0),this.b.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this.e.has(o)&&this.e.get(o).delete(i),r}}async closeTunnel(o,i){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${i} `);const n=this.e.get(o);if(n&&n.has(i)){const r=n.get(i);r.refcount=0,await this.o(o,i,r)}}p(o,i,n){this.e.has(o)||this.e.set(o,new Map),this.e.get(o).set(i,{refcount:1,value:n})}async q(o,i){const n=this.e.get(o);if(n){const r=n.get(i),a=r?await r.value:void 0;(!a||typeof a=="string")&&n.delete(i),n.size===0&&this.e.delete(o)}}r(o,i){const n=[o];I(o)?(n.push(...e.$hv),n.push(...e.$jv)):$(o)&&n.push(...e.$jv);const r=n.map(a=>this.e.get(a));for(const a of r){const t=a?.get(i);if(t)return t}}canTunnel(o){return!!A(o)}t(o,i,n,r,a,t,s){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${i}:${n} on local port ${r}.`);const d=n;this.i.add(d);const c=r===void 0?n:r,u={elevationRequired:a?this.isPortPrivileged(c):!1},h={remoteAddress:{host:i,port:n},localAddressPort:r,privacy:t,public:t?t!==b.Private:void 0,protocol:s},E=o.forwardPort(h,u);return E?(this.p(i,n,E),E.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(d)})):this.i.delete(d),E}};e.$nv=w,e.$nv=w=He([Be(0,R.$dj),Be(1,T.$pi)],w)}),define(ke[266],Se([1,0,5]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ok=void 0,e.$Ok=(0,C.$Vh)("IUriIdentityService")}),define(ke[267],Se([1,0,5]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$ov=void 0,e.$ov=(0,C.$Vh)("editSessionIdentityService");var T;(function(f){f[f.Complete=100]="Complete",f[f.Partial=50]="Partial",f[f.None=0]="None"})(T||(e.EditSessionIdentityMatch=T={}))}),define(ke[268],Se([1,0,17]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=void 0;function T(y){return y.scheme!==C.Schemas.file&&y.scheme!==C.Schemas.vscodeRemote}e.$9J=T;function f(y){if(y.folders.length)return y.folders.every(g=>T(g.uri))?y.folders[0].uri:void 0;if(y.configuration&&T(y.configuration))return y.configuration}e.$0J=f;function R(y){return f(y)?.scheme}e.$$J=R;function L(y){return f(y)?.authority}e.$_J=L;function b(y){return f(y)!==void 0}e.$aK=b}),define(ke[40],Se([1,0,209,16,77,23,2,5,17]),function(me,e,C,T,f,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.WorkbenchState=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=void 0,e.$5h=(0,b.$Vh)("contextService");function g(c){const u=c;return typeof u?.id=="string"&&L.URI.isUri(u.uri)}e.$6h=g;function A(c){return typeof c?.id=="string"&&!g(c)&&!$(c)}e.$7h=A,e.$8h={id:"ext-dev"},e.$9h={id:"empty-window"};function I(c,u){if(typeof c=="string"||typeof c>"u")return typeof c=="string"?{id:(0,T.$mc)(c)}:u?e.$8h:e.$9h;const h=c;return h.configuration?{id:h.id,configPath:h.configuration}:h.folders.length===1?{id:h.id,uri:h.folders[0].uri}:{id:h.id}}e.$0h=I;function $(c){const u=c;return typeof u?.id=="string"&&L.URI.isUri(u.configPath)}e.$$h=$;function v(c){const u=c;if(u?.uri)return{id:u.id,uri:L.URI.revive(u.uri)};const h=c;if(h?.configPath)return{id:h.id,configPath:L.URI.revive(h.configPath)};if(c?.id)return{id:c.id}}e.$_h=v;var S;(function(c){c[c.EMPTY=1]="EMPTY",c[c.FOLDER=2]="FOLDER",c[c.WORKSPACE=3]="WORKSPACE"})(S||(e.WorkbenchState=S={}));function w(c){const u=c;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&Array.isArray(u.folders))}e.$ai=w;function l(c){const u=c;return!!(u&&typeof u=="object"&&L.URI.isUri(u.uri)&&typeof u.name=="string"&&typeof u.toResource=="function")}e.$bi=l;class o{constructor(u,h,E,D,m){this.h=u,this.j=E,this.k=D,this.l=m,this.c=f.$2h.forUris(this.l,()=>!0),this.folders=h}update(u){this.h=u.id,this.k=u.configuration,this.j=u.transient,this.l=u.l,this.folders=u.folders}get folders(){return this.g}set folders(u){this.g=u,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(u){this.k=u}getFolder(u){return u&&this.c.findSubstr(u)||null}n(){this.c=f.$2h.forUris(this.l,()=>!0);for(const u of this.folders)this.c.set(u.uri,u)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$ci=o;class i{constructor(u,h){this.raw=h,this.uri=u.uri,this.index=u.index,this.name=u.name}toResource(u){return(0,R.$zg)(this.uri,u)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$di=i;function n(c){return new i({uri:c,index:0,name:(0,R.$vg)(c)},{uri:c.toString()})}e.$ei=n,e.$fi="code-workspace",e.$gi=`.${e.$fi}`,e.$hi=[{name:(0,C.localize)(0,null),extensions:[e.$fi]}],e.$ii="workspace.json";function r(c,u){return R.$qg.isEqualOrParent(c,u.untitledWorkspacesHome)}e.$ji=r;function a(c){let u;return L.URI.isUri(c)?u=c:u=c.configuration,u?.scheme===y.Schemas.tmp}e.$ki=a,e.$li="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(c){return c.id===e.$li}e.$mi=t;function s(c,u){return!r(c,u)&&!a(c)}e.$ni=s;function d(c){return(typeof c=="string"?(0,T.$nc)(c):(0,R.$xg)(c))===e.$gi}e.$oi=d}),define(ke[269],Se([1,0,52,4,3,23,2,208,134,31,5,14,40,28,266,12,32,13,18]),function(me,e,C,T,f,R,L,b,y,g,A,I,$,v,S,w,l,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.ProfileResourceType=void 0;var n;(function(c){c.Settings="settings",c.Keybindings="keybindings",c.Snippets="snippets",c.Tasks="tasks",c.Extensions="extensions",c.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function r(c){const u=c;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&typeof u.isDefault=="boolean"&&typeof u.name=="string"&&L.URI.isUri(u.location)&&L.URI.isUri(u.globalStorageHome)&&L.URI.isUri(u.settingsResource)&&L.URI.isUri(u.keybindingsResource)&&L.URI.isUri(u.tasksResource)&&L.URI.isUri(u.snippetsHome)&&L.URI.isUri(u.extensionsResource))}e.$Pk=r,e.$Qk=(0,A.$Vh)("IUserDataProfilesService");function a(c,u){return{id:c.id,isDefault:c.isDefault,name:c.name,shortName:c.shortName,icon:c.icon,location:L.URI.revive(c.location).with({scheme:u}),globalStorageHome:L.URI.revive(c.globalStorageHome).with({scheme:u}),settingsResource:L.URI.revive(c.settingsResource).with({scheme:u}),keybindingsResource:L.URI.revive(c.keybindingsResource).with({scheme:u}),tasksResource:L.URI.revive(c.tasksResource).with({scheme:u}),snippetsHome:L.URI.revive(c.snippetsHome).with({scheme:u}),extensionsResource:L.URI.revive(c.extensionsResource).with({scheme:u}),cacheHome:L.URI.revive(c.cacheHome).with({scheme:u}),useDefaultFlags:c.useDefaultFlags,isTransient:c.isTransient}}e.$Rk=a;function t(c,u,h,E,D,m){return{id:c,name:u,location:h,isDefault:!1,shortName:D?.shortName,icon:D?.icon,globalStorageHome:m&&D?.useDefaultFlags?.globalState?m.globalStorageHome:(0,R.$zg)(h,"globalStorage"),settingsResource:m&&D?.useDefaultFlags?.settings?m.settingsResource:(0,R.$zg)(h,"settings.json"),keybindingsResource:m&&D?.useDefaultFlags?.keybindings?m.keybindingsResource:(0,R.$zg)(h,"keybindings.json"),tasksResource:m&&D?.useDefaultFlags?.tasks?m.tasksResource:(0,R.$zg)(h,"tasks.json"),snippetsHome:m&&D?.useDefaultFlags?.snippets?m.snippetsHome:(0,R.$zg)(h,"snippets"),extensionsResource:m&&D?.useDefaultFlags?.extensions?m.extensionsResource:(0,R.$zg)(h,"extensions.json"),cacheHome:(0,R.$zg)(E,c),useDefaultFlags:D?.useDefaultFlags,isTransient:D?.transient}}e.$Sk=t;let s=class extends f.$Rc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(u,h,E,D){super(),this.t=u,this.u=h,this.w=E,this.y=D,this.f=!0,this.h=this.B(new T.$Rd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new T.$Rd),this.onWillCreateProfile=this.j.event,this.m=this.B(new T.$Rd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new T.$Rd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new v.$zc,emptyWindows:new Map},this.profilesHome=(0,R.$zg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,R.$zg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(u){this.f!==u&&(this.z=void 0,this.f=u)}isEnabled(){return this.f}get C(){if(!this.z){const u=this.D(),h=[u];if(this.f)try{for(const m of this.O()){if(!m.name||!(0,i.$Cf)(m.name)||!m.location){this.y.warn("Skipping the invalid stored profile",m.location||m.name);continue}h.push(t((0,R.$wg)(m.location),m.name,m.location,this.g,{shortName:m.shortName,icon:m.icon,useDefaultFlags:m.useDefaultFlags},u))}}catch(m){this.y.error(m)}const E=new v.$zc,D=new Map;if(h.length)try{const m=this.Q();if(m.workspaces)for(const[p,k]of Object.entries(m.workspaces)){const P=L.URI.parse(p),z=h.find(j=>j.id===k);z&&E.set(P,z)}if(m.emptyWindows)for(const[p,k]of Object.entries(m.emptyWindows)){const P=h.find(z=>z.id===k);P&&D.set(p,P)}}catch(m){this.y.error(m)}this.z={profiles:h,workspaces:E,emptyWindows:D}}return this.z}D(){const u=t("__default__profile__",(0,b.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...u,extensionsResource:this.S()??u.extensionsResource,isDefault:!0}}async createTransientProfile(u){const h="Temp",E=new RegExp(`${(0,o.$Je)(h)}\\s(\\d+)`);let D=0;for(const p of this.profiles){const k=E.exec(p.name),P=k?parseInt(k[1]):0;D=P>D?P:D}const m=`${h} ${D+1}`;return this.createProfile((0,C.$Ji)((0,l.$ig)()).toString(16),m,{transient:!0},u)}async createNamedProfile(u,h,E){return this.createProfile((0,C.$Ji)((0,l.$ig)()).toString(16),u,h,E)}async createProfile(u,h,E,D){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const m=await this.F(u,h,E);return D&&await this.setProfileForWorkspace(D,m),m}async F(u,h,E){if(!(0,i.$Cf)(h)||!h)throw new Error("Name of the profile is mandatory and must be of type `string`");let D=this.r.get(h);return D||(D=(async()=>{try{const m=this.profiles.find(P=>P.name===h||P.id===u);if(m)return m;const p=t(u,h,(0,R.$zg)(this.profilesHome,u),this.g,E,this.defaultProfile);await this.u.createFolder(p.location);const k=[];return this.j.fire({profile:p,join(P){k.push(P)}}),await w.Promises.settled(k),this.I([p],[],[]),p}finally{this.r.delete(h)}})(),this.r.set(h,D)),D}async updateProfile(u,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let E=this.profiles.find(D=>D.id===u.id);if(!E)throw new Error(`Profile '${u.name}' does not exist`);return E=t(E.id,h.name??E.name,E.location,this.g,{shortName:h.shortName??E.shortName,icon:h.icon===null?void 0:h.icon??E.icon,transient:h.transient??E.isTransient,useDefaultFlags:h.useDefaultFlags??E.useDefaultFlags},this.defaultProfile),this.I([],[],[E]),E}async removeProfile(u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(u.isDefault)throw new Error("Cannot remove default profile");const h=this.profiles.find(D=>D.id===u.id);if(!h)throw new Error(`Profile '${u.name}' does not exist`);const E=[];this.m.fire({profile:h,join(D){E.push(D)}});try{await Promise.allSettled(E)}catch(D){this.y.error(D)}for(const D of[...this.C.emptyWindows.keys()])h.id===this.C.emptyWindows.get(D)?.id&&this.C.emptyWindows.delete(D);for(const D of[...this.C.workspaces.keys()])h.id===this.C.workspaces.get(D)?.id&&this.C.workspaces.delete(D);this.M(),this.I([],[h],[]);try{await this.u.del(h.cacheHome,{recursive:!0})}catch(D){(0,g.$vk)(D)!==1&&this.y.error(D)}}async setProfileForWorkspace(u,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const E=this.profiles.find(D=>D.id===h.id);if(!E)throw new Error(`Profile '${h.name}' does not exist`);this.L(u,E)}unsetWorkspace(u,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(u,void 0,h)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const u=await this.u.resolve(this.profilesHome);await Promise.all((u.children||[]).filter(h=>h.isDirectory&&this.profiles.every(E=>!this.w.extUri.isEqual(E.location,h.resource))).map(h=>this.u.del(h.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const u=this.s.profiles.filter(h=>!this.H(h));await Promise.allSettled(u.map(h=>this.removeProfile(h)))}getProfileForWorkspace(u){const h=this.G(u);return L.URI.isUri(h)?this.s.workspaces.get(h)??this.C.workspaces.get(h):this.s.emptyWindows.get(h)??this.C.emptyWindows.get(h)}G(u){return(0,$.$6h)(u)?u.uri:(0,$.$$h)(u)?u.configPath:u.id}H(u){return!!([...this.s.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,u.location))||[...this.s.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,u.location))||[...this.C.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,u.location))||[...this.C.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,u.location)))}I(u,h,E){const D=[...this.profiles,...u],m=[];this.s.profiles=[];for(let p of D)p.isDefault||h.some(k=>p.id===k.id)||(p=E.find(k=>p.id===k.id)??p,p.isTransient?this.s.profiles.push(p):m.push({location:p.location,name:p.name,shortName:p.shortName,icon:p.icon,useDefaultFlags:p.useDefaultFlags}));this.P(m),this.z=void 0,this.J(u,h,E)}J(u,h,E){this.h.fire({added:u,removed:h,updated:E,all:this.profiles})}L(u,h,E){E=h?.isTransient?!0:E,E||this.L(u,void 0,!0);const D=this.G(u),m=E?this.s:this.C;L.URI.isUri(D)?(m.workspaces.delete(D),h&&m.workspaces.set(D,h)):(m.emptyWindows.delete(D),h&&m.emptyWindows.set(D,h)),E||this.M()}M(){const u={};for(const[E,D]of this.C.workspaces.entries())u[E.toString()]=D.id;const h={};for(const[E,D]of this.C.emptyWindows.entries())h[E.toString()]=D.id;this.R({workspaces:u,emptyWindows:h}),this.z=void 0}N(u){const h={},E=this.D();if(u.workspaces)for(const[m,p]of Object.entries(u.workspaces)){const k=L.URI.parse(p);h[m]=this.w.extUri.isEqual(k,E.location)?E.id:this.w.extUri.basename(k)}const D={};if(u.emptyWindows)for(const[m,p]of Object.entries(u.emptyWindows)){const k=L.URI.parse(p);D[m]=this.w.extUri.isEqual(k,E.location)?E.id:this.w.extUri.basename(k)}return{workspaces:h,emptyWindows:D}}O(){return[]}P(u){throw new Error("not implemented")}Q(){return{}}R(u){throw new Error("not implemented")}S(){}};e.$Tk=s,e.$Tk=s=He([Be(0,y.$3h),Be(1,g.$ek),Be(2,S.$Ok),Be(3,I.$dj)],s);class d extends s{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(u){this.a=u}Q(){return this.X}R(u){this.X=u}}e.$Uk=d}),define(ke[270],Se([1,0,12,4,3,56,18,188,5,269]),function(me,e,C,T,f,R,L,b,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$_o=e.$$o=e.$0o=void 0,e.$0o="__$__isNewStorageMarker",e.$$o="__$__targetStorageMarker",e.$_o=(0,y.$Vh)("storageService");var A;(function(i){i[i.NONE=0]="NONE",i[i.SHUTDOWN=1]="SHUTDOWN"})(A||(e.WillSaveStateReason=A={}));var I;(function(i){i[i.APPLICATION=-1]="APPLICATION",i[i.PROFILE=0]="PROFILE",i[i.WORKSPACE=1]="WORKSPACE"})(I||(e.StorageScope=I={}));var $;(function(i){i[i.USER=0]="USER",i[i.MACHINE=1]="MACHINE"})($||(e.StorageTarget=$={}));function v(i){const n=i.get(e.$$o);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}e.$ap=v;class S extends f.$Rc{static{this.a=60*1e3}constructor(n={flushInterval:S.a}){super(),this.m=n,this.b=this.B(new T.$Ud),this.c=this.B(new T.$Ud),this.onDidChangeTarget=this.c.event,this.f=this.B(new T.$Rd),this.onWillSaveState=this.f.event,this.h=this.B(new C.$0g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new f.$Sc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(n,r,a){return T.Event.filter(this.b.event,t=>t.scope===n&&(r===void 0||t.key===r),a)}n(){this.j.value=(0,C.$bh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,f.$Mc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.O()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(n,r){const{key:a,external:t}=r;if(a===e.$$o){switch(n){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:n})}else this.b.fire({scope:n,key:a,target:this.J(n)[a],external:t})}w(n){this.f.fire({reason:n})}get(n,r,a){return this.P(r)?.get(n,a)}getBoolean(n,r,a){return this.P(r)?.getBoolean(n,a)}getNumber(n,r,a){return this.P(r)?.getNumber(n,a)}getObject(n,r,a){return this.P(r)?.getObject(n,a)}storeAll(n,r){this.y(()=>{for(const a of n)this.store(a.key,a.value,a.scope,a.target,r)})}store(n,r,a,t,s=!1){if((0,L.$Lf)(r)){this.remove(n,a,s);return}this.y(()=>{this.z(n,a,t),this.P(a)?.set(n,r,s)})}remove(n,r,a=!1){this.y(()=>{this.z(n,r,void 0),this.P(r)?.delete(n,a)})}y(n){this.b.pause(),this.c.pause();try{n()}finally{this.b.resume(),this.c.resume()}}keys(n,r){const a=[],t=this.J(n);for(const s of Object.keys(t))t[s]===r&&a.push(s);return a}z(n,r,a,t=!1){const s=this.J(r);typeof a=="number"?s[n]!==a&&(s[n]=a,this.P(r)?.set(e.$$o,JSON.stringify(s),t)):typeof s[n]=="number"&&(delete s[n],this.P(r)?.set(e.$$o,JSON.stringify(s),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(n){switch(n){case-1:return this.I;case 0:return this.G;default:return this.D}}L(n){const r=this.P(n);return r?v(r):Object.create(null)}isNew(n){return this.getBoolean(e.$0o,n)===!0}async flush(n=A.NONE){this.f.fire({reason:n});const r=this.P(-1),a=this.P(0),t=this.P(1);switch(n){case A.NONE:await C.Promises.settled([r?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case A.SHUTDOWN:await C.Promises.settled([r?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.P(-1)?.items??new Map,r=this.P(0)?.items??new Map,a=this.P(1)?.items??new Map;return o(n,r,a,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(n){return await this.flush(),this.P(n)?.optimize()}async switch(n,r){return this.w(A.NONE),(0,g.$Pk)(n)?this.R(n,r):this.S(n,r)}M(n,r){return!(n.id===r.id||w(r)&&w(n))}N(n,r,a){this.y(()=>{const t=new Set;for(const[s,d]of n)t.add(s),r.get(s)!==d&&this.u(a,{key:s,external:!0});for(const[s]of r.items)t.has(s)||this.u(a,{key:s,external:!0})})}}e.$bp=S;function w(i){return i.isDefault||!!i.useDefaultFlags?.globalState}e.$cp=w;class l extends S{constructor(){super(),this.U=this.B(new b.$8o(new b.$9o,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new b.$8o(new b.$9o,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new b.$8o(new b.$9o,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(n=>this.u(1,n))),this.B(this.W.onDidChangeStorage(n=>this.u(0,n))),this.B(this.U.onDidChangeStorage(n=>this.u(-1,n)))}P(n){switch(n){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(n){switch(n){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(n){return!1}}e.$dp=l;async function o(i,n,r,a,t,s){const d=P=>{try{return JSON.parse(P)}catch{return P}},c=new Map,u=new Map;i.forEach((P,z)=>{c.set(z,P),u.set(z,d(P))});const h=new Map,E=new Map;n.forEach((P,z)=>{h.set(z,P),E.set(z,d(P))});const D=new Map,m=new Map;r.forEach((P,z)=>{D.set(z,P),m.set(z,d(P))}),console.group(a!==t?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const p=[];if(c.forEach((P,z)=>{p.push({key:z,value:P})}),console.table(p),console.groupEnd(),console.log(u),a!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const P=[];h.forEach((z,j)=>{P.push({key:j,value:z})}),console.table(P),console.groupEnd(),console.log(E)}console.group(`Storage: Workspace (path: ${s})`);const k=[];D.forEach((P,z)=>{k.push({key:z,value:P})}),console.table(k),console.groupEnd(),console.log(m)}e.$ep=o}),define(ke[110],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hdc=void 0;class C{static{this.a=!1}constructor(f){this.d=f,this.b=new Map,this.c=1}add(f){const R=this.c++;return this.b.set(R,f),this.e(),R}get(f,R){return this.b.has(f)?this.b.get(f)[R]:void 0}delete(f){this.b.delete(f),this.e()}e(){C.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Hdc=C}),define(ke[57],Se([1,0,17,23,5]),function(me,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ldc=e.$Kdc=void 0;class R{constructor(){this.a=new Set(Object.keys(C.Schemas)),this.b=new Map,this.extUri=new T.$og(b=>{const y=this.b.get(b.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(b,y){y===null?this.b.delete(b.scheme):this.b.set(b.scheme,y)}isFreeScheme(b){return!this.b.has(b)&&!this.a.has(b)}getCapabilities(b){return this.b.get(b)}}e.$Kdc=R,e.$Ldc=(0,f.$Vh)("IExtHostFileSystemInfo")}),define(ke[27],Se([1,0,5]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RM=void 0,e.$RM=(0,C.$Vh)("IExtHostInitDataService")}),define(ke[271],Se([1,0,214,14,251,27]),function(me,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rfc=void 0;let L=class extends f.$YN{constructor(y,g,A){const I=A.remote.isRemote?"remoteexthost":y?"workerexthost":"exthost",$=A.remote.isRemote?(0,C.localize)(0,null):y?(0,C.localize)(1,null):(0,C.localize)(2,null);super(g.createLogger(I,{name:$}))}};e.$Rfc=L,e.$Rfc=L=He([Be(1,T.$ej),Be(2,R.$RM)],L)}),define(ke[272],Se([1,0,12]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uec=e.$tec=void 0;class T{constructor(L,b,y){this.h=new Map,this.a=L,this.b=b,this.c=y,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(g=>(this.f=g,this)),this.g=this.c.onDidChangeStorage(g=>{g.shared===this.b&&g.key===this.a&&(this.f=g.value)}),this.i=new C.$0g(()=>{const g=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of g.values())A.complete()}catch(A){for(const I of g.values())I.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,L])=>L!==void 0).map(([L])=>L)}get whenReady(){return this.d}get(L,b){let y=this.f[L];return typeof y>"u"&&(y=b),y}update(L,b){this.f[L]=b;const y=this.h.get(L);if(y!==void 0)return y.p;const g=new C.$ih;return this.h.set(L,g),this.i.isScheduled()||this.i.schedule(),g.p}dispose(){this.g.dispose()}}e.$tec=T;class f extends T{setKeysForSync(L){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},L)}constructor(L,b){super(L.identifier.value,!0,b),this.j=L}}e.$uec=f}),define(ke[273],Se([1,0,4,2]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hfc=void 0;class f{constructor(L){this.c=L,this.a=new C.$Rd,this.onDidSaveNotebookDocument=this.a.event,this.b=new C.$Rd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(L,b,y,g){const I=this.c.getNotebookDocument(T.URI.revive(L)).acceptModelChanged(b.value,y,g);this.b.fire(I)}$acceptDirtyStateChanged(L,b){this.c.getNotebookDocument(T.URI.revive(L)).acceptDirty(b)}$acceptModelSaved(L){const b=this.c.getNotebookDocument(T.URI.revive(L));this.a.fire(b.apiNotebook)}}e.$hfc=f}),define(ke[20],Se([1,0,5]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CM=e.$BM=void 0,e.$BM=(0,C.$Vh)("IExtHostRpcService");class T{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.$CM=T}),define(ke[274],Se([1,0,26,4]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bec=void 0;class f{#e;constructor(L,b){this.b=new T.$Rd,this.onDidChange=this.b.event,this.a=C.$_l.toKey(L.identifier),this.#e=b,this.#e.onDidChangePassword(y=>{y.extensionId===this.a&&this.b.fire({key:y.key})})}get(L){return this.#e.get(this.a,L)}store(L,b){return this.#e.store(this.a,L,b)}delete(L){return this.#e.delete(this.a,L)}}e.$Bec=f}),define(ke[66],Se([1,0,5]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5dc=e.$4dc=void 0,e.$4dc=(0,C.$Vh)("IURITransformerService");class T{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=L=>L,this.transformOutgoing=L=>L,this.transformOutgoingURI=L=>L,this.transformOutgoingScheme=L=>L)}}e.$5dc=T}),define(ke[275],Se([1,0,22]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fcb=e.$Ecb=void 0;class T{constructor(){this.buffers=[]}add(y){let g=this.buffers.indexOf(y);return g<0&&(g=this.buffers.length,this.buffers.push(y)),g}}function f(b,y){if(y.serializeBuffersForPostMessage){const g=new T,I=JSON.stringify(b,(v,S)=>{if(S instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:g.add(S)};if(ArrayBuffer.isView(S)){const w=R(S);if(w)return{$$vscode_array_buffer_reference$$:!0,index:g.add(S.buffer),view:{type:w,byteLength:S.byteLength,byteOffset:S.byteOffset}}}return S}),$=g.buffers.map(v=>{const S=new Uint8Array(v);return C.$fe.wrap(S)});return{message:I,buffers:$}}else return{message:JSON.stringify(b),buffers:[]}}e.$Ecb=f;function R(b){switch(b.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function L(b,y){const g=y.map($=>{const v=new ArrayBuffer($.byteLength);return new Uint8Array(v).set($.buffer),v}),A=y.length?($,v)=>{if(v&&typeof v=="object"&&v.$$vscode_array_buffer_reference$$){const S=v,{index:w}=S,l=g[w];if(S.view)switch(S.view.type){case 1:return new Int8Array(l,S.view.byteOffset,S.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(l,S.view.byteOffset,S.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(l,S.view.byteOffset,S.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(l,S.view.byteOffset,S.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(l,S.view.byteOffset,S.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(l,S.view.byteOffset,S.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(l,S.view.byteOffset,S.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(l,S.view.byteOffset,S.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(l,S.view.byteOffset,S.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(l,S.view.byteOffset,S.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(l,S.view.byteOffset,S.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return l}return v}:void 0;return{message:JSON.parse(b,A),arrayBuffers:g}}e.$Fcb=L}),define(ke[276],Se([1,0,277,388,389,62,2,14,390]),function(me,e,C,T,f,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ngc=void 0;const g=!1;function A(n,r,a,t,s,d){const c=d.environment.useHostProxy,u=typeof c=="boolean"?c:!d.remote.isRemote,h={resolveProxy:m=>n.resolveProxy(m),lookupProxyAuthorization:l.bind(void 0,t,s,r,{},d.remote.isRemote),getProxyURL:()=>r.getConfiguration("http").get("proxy"),getProxySupport:()=>r.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>$(r),addCertificatesV2:()=>v(r),log:t,getLogLevel:()=>{const m=t.getLevel();switch(m){case b.LogLevel.Trace:return y.LogLevel.Trace;case b.LogLevel.Debug:return y.LogLevel.Debug;case b.LogLevel.Info:return y.LogLevel.Info;case b.LogLevel.Warning:return y.LogLevel.Warning;case b.LogLevel.Error:return y.LogLevel.Error;case b.LogLevel.Off:return y.LogLevel.Off;default:return p(m)}function p(k){return t.error("Unknown log level",k),y.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:u,loadAdditionalCertificates:async()=>{const m=[];if(d.remote.isRemote&&m.push((0,y.loadSystemCertificates)({log:t})),u){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const p=n.loadCertificates();p.then(k=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",k.length)),m.push(p)}return(await Promise.all(m)).flat()},env:process.env},E=(0,y.createProxyResolver)(h),D=I(h,E);return w(a,D)}e.$ngc=A;function I(n,r){return{http:Object.assign(C,(0,y.createHttpPatch)(n,C,r)),https:Object.assign(T,(0,y.createHttpPatch)(n,T,r)),net:Object.assign(R,(0,y.createNetPatch)(n,R)),tls:Object.assign(f,(0,y.createTlsPatch)(n,f))}}function $(n){const r=n.getConfiguration("http");return!r.get("experimental.systemCertificatesV2",g)&&!!r.get("systemCertificates")}function v(n){const r=n.getConfiguration("http");return!!r.get("experimental.systemCertificatesV2",g)&&!!r.get("systemCertificates")}const S=new Map;function w(n,r){return n.getExtensionPathIndex().then(a=>{const t=globalThis._VSCODE_NODE_MODULES.module,s=t._load;t._load=function(c,u,h){if(c==="net")return r.net;if(c==="tls")return r.tls;if(c!=="http"&&c!=="https")return s.apply(this,arguments);const E=a.findSubstr(L.URI.file(u.filename));let D=S.get(E);if(D||S.set(E,D={}),!D[c]){const m=r[c];D[c]={...m}}return D[c]}})}async function l(n,r,a,t,s,d,c,u){const h=t[d];c&&(t[d]=c),n.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${d}`,`proxyAuthenticate:${c}`,`proxyAuthenticateCache:${h}`);const E=c||h,D=Array.isArray(E)?E:typeof E=="string"?[E]:[];if(i(r,D,s),D.some(m=>/^(Negotiate|Kerberos)( |$)/i.test(m))&&!u.kerberosRequested)try{u.kerberosRequested=!0;const m=await new Promise((j,M)=>{me(["kerberos"],j,M)}),p=new URL(d),k=a.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${p.hostname}`:`HTTP@${p.hostname}`);return n.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${d}`,`spn:${k}`),"Negotiate "+await(await m.initializeClient(k)).step("")}catch(m){n.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",m)}}let o=!1;function i(n,r,a){o||!r.length||(o=!0,n.$publicLog2("proxyAuthenticationRequest",{authenticationType:r.map(t=>t.split(" ")[0]).join(","),extensionHostType:a?"remote":"local"}))}}),define(ke[278],Se([1,0,131]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gr=void 0;function T(R){return{transformIncoming:L=>L.scheme==="vscode-remote"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="file"?{scheme:"vscode-local",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoing:L=>L.scheme==="file"?{scheme:"vscode-remote",authority:R,path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="vscode-local"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoingScheme:L=>L==="file"?"vscode-remote":L==="vscode-local"?"file":L}}function f(R){return new C.$Rm(T(R))}e.$Gr=f}),define(ke[141],Se([1,0,225,18,2,3,5,37,31,17,43,180,39]),function(me,e,C,T,f,R,L,b,y,g,A,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BE=e.$AE=e.$zE=e.EditorsOrder=e.$yE=e.CloseDirection=e.$xE=e.$wE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$vE=e.$uE=e.$tE=e.$sE=e.$rE=e.$qE=e.$pE=e.$oE=e.EditorInputCapabilities=e.$nE=e.SaveReason=e.Verbosity=e.$mE=e.$lE=e.$kE=e.$jE=e.$iE=e.$hE=e.$gE=e.$fE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$eE=e.$dE=e.$cE=e.$bE=e.$aE=void 0,e.$aE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$bE={id:"default",displayName:(0,C.localize)(0,null),providerDisplayName:(0,C.localize)(1,null)},e.$cE="workbench.editor.sidebysideEditor",e.$dE="workbench.editors.textDiffEditor",e.$eE="workbench.editors.binaryResourceDiffEditor";var v;(function(he){he[he.PROGRAMMATIC=1]="PROGRAMMATIC",he[he.USER=2]="USER",he[he.EDIT=3]="EDIT",he[he.NAVIGATION=4]="NAVIGATION",he[he.JUMP=5]="JUMP"})(v||(e.EditorPaneSelectionChangeReason=v={}));var S;(function(he){he[he.IDENTICAL=1]="IDENTICAL",he[he.SIMILAR=2]="SIMILAR",he[he.DIFFERENT=3]="DIFFERENT"})(S||(e.EditorPaneSelectionCompareResult=S={}));function w(he){const q=he;return!!q&&typeof q.getSelection=="function"&&!!q.onDidChangeSelection}e.$fE=w;function l(he,q,U){for(const ne of U.visibleEditorPanes)if(ne.group.id===q&&he.matches(ne.input))return ne.getViewState()}e.$gE=l;function o(he){if(E(he))return!1;const q=he;return f.URI.isUri(q?.resource)}e.$hE=o;function i(he){if(E(he))return!1;const q=he;return q?.original!==void 0&&q.modified!==void 0}e.$iE=i;function n(he){if(E(he))return!1;const q=he;return Array.isArray(q?.resources)}e.$jE=n;function r(he){if(E(he)||i(he))return!1;const q=he;return q?.primary!==void 0&&q.secondary!==void 0}e.$kE=r;function a(he){if(E(he))return!1;const q=he;return q?q.resource===void 0||q.resource.scheme===g.Schemas.untitled||q.forceUntitled===!0:!1}e.$lE=a;function t(he){if(E(he))return!1;const q=he;return f.URI.isUri(q?.base?.resource)&&f.URI.isUri(q?.input1?.resource)&&f.URI.isUri(q?.input2?.resource)&&f.URI.isUri(q?.result?.resource)}e.$mE=t;var s;(function(he){he[he.SHORT=0]="SHORT",he[he.MEDIUM=1]="MEDIUM",he[he.LONG=2]="LONG"})(s||(e.Verbosity=s={}));var d;(function(he){he[he.EXPLICIT=1]="EXPLICIT",he[he.AUTO=2]="AUTO",he[he.FOCUS_CHANGE=3]="FOCUS_CHANGE",he[he.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(d||(e.SaveReason=d={}));class c{constructor(){this.a=new Map}registerSource(q,U){let ne=this.a.get(q);return ne||(ne={source:q,label:U},this.a.set(q,ne)),ne.source}getSourceLabel(q){return this.a.get(q)?.label??q}}e.$nE=new c;var u;(function(he){he[he.None=0]="None",he[he.Readonly=2]="Readonly",he[he.Untitled=4]="Untitled",he[he.Singleton=8]="Singleton",he[he.RequiresTrust=16]="RequiresTrust",he[he.CanSplitInGroup=32]="CanSplitInGroup",he[he.ForceDescription=64]="ForceDescription",he[he.CanDropIntoEditor=128]="CanDropIntoEditor",he[he.MultipleEditors=256]="MultipleEditors",he[he.Scratchpad=512]="Scratchpad",he[he.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(u||(e.EditorInputCapabilities=u={}));class h extends R.$Rc{}e.$oE=h;function E(he){return he instanceof h}e.$pE=E;function D(he){const q=he;return f.URI.isUri(q?.preferredResource)}function m(he){const q=he;return E(q?.primary)&&E(q?.secondary)}e.$qE=m;function p(he){const q=he;return E(q?.modified)&&E(q?.original)}e.$rE=p;function k(he,q,U,ne,be){return Ee(ne,[(0,I.$Fi)({id:"workbench.action.openLargeFile",label:(0,C.localize)(2,null),run:()=>{const H={...U,limits:{size:Number.MAX_VALUE}};he.openEditor(q,H)}}),(0,I.$Fi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,C.localize)(3,null),run:()=>be.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:$.default.Warning})}e.$sE=k;function P(he){return E(he?.editor)}e.$tE=P;function z(he){const q=he;return P(he)&&q?.group!==void 0}e.$uE=z;function j(he){const q=he;return typeof q?.groupId=="number"&&E(q.editor)}e.$vE=j;var M;(function(he){he[he.UNKNOWN=0]="UNKNOWN",he[he.REPLACE=1]="REPLACE",he[he.MOVE=2]="MOVE",he[he.UNPIN=3]="UNPIN"})(M||(e.EditorCloseContext=M={}));var O;(function(he){he[he.GROUP_ACTIVE=0]="GROUP_ACTIVE",he[he.GROUP_INDEX=1]="GROUP_INDEX",he[he.GROUP_LABEL=2]="GROUP_LABEL",he[he.GROUP_LOCKED=3]="GROUP_LOCKED",he[he.EDITOR_OPEN=4]="EDITOR_OPEN",he[he.EDITOR_CLOSE=5]="EDITOR_CLOSE",he[he.EDITOR_MOVE=6]="EDITOR_MOVE",he[he.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",he[he.EDITOR_LABEL=8]="EDITOR_LABEL",he[he.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",he[he.EDITOR_PIN=10]="EDITOR_PIN",he[he.EDITOR_STICKY=11]="EDITOR_STICKY",he[he.EDITOR_DIRTY=12]="EDITOR_DIRTY",he[he.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(O||(e.GroupModelChangeKind=O={}));var F;(function(he){he[he.PRIMARY=1]="PRIMARY",he[he.SECONDARY=2]="SECONDARY",he[he.BOTH=3]="BOTH",he[he.ANY=4]="ANY"})(F||(e.SideBySideEditor=F={}));class N{getOriginalUri(q,U){if(!q)return;if(t(q))return e.$xE.getOriginalUri(q.result,U);if(U?.supportSideBySide){const{primary:be,secondary:H}=this.a(q);if(be&&H){if(U?.supportSideBySide===F.BOTH)return{primary:this.getOriginalUri(be,{filterByScheme:U.filterByScheme}),secondary:this.getOriginalUri(H,{filterByScheme:U.filterByScheme})};if(U?.supportSideBySide===F.ANY)return this.getOriginalUri(be,{filterByScheme:U.filterByScheme})??this.getOriginalUri(H,{filterByScheme:U.filterByScheme});q=U.supportSideBySide===F.PRIMARY?be:H}}if(i(q)||n(q)||r(q)||t(q))return;const ne=D(q)?q.preferredResource:q.resource;return!ne||!U||!U.filterByScheme?ne:this.b(ne,U.filterByScheme)}a(q){return m(q)||r(q)?{primary:q.primary,secondary:q.secondary}:p(q)||i(q)?{primary:q.modified,secondary:q.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(q,U){if(!q)return;if(t(q))return e.$xE.getCanonicalUri(q.result,U);if(U?.supportSideBySide){const{primary:be,secondary:H}=this.a(q);if(be&&H){if(U?.supportSideBySide===F.BOTH)return{primary:this.getCanonicalUri(be,{filterByScheme:U.filterByScheme}),secondary:this.getCanonicalUri(H,{filterByScheme:U.filterByScheme})};if(U?.supportSideBySide===F.ANY)return this.getCanonicalUri(be,{filterByScheme:U.filterByScheme})??this.getCanonicalUri(H,{filterByScheme:U.filterByScheme});q=U.supportSideBySide===F.PRIMARY?be:H}}if(i(q)||n(q)||r(q)||t(q))return;const ne=q.resource;return!ne||!U||!U.filterByScheme?ne:this.b(ne,U.filterByScheme)}b(q,U){if(Array.isArray(U)){if(U.some(ne=>q.scheme===ne))return q}else if(U===q.scheme)return q}}var W;(function(he){he[he.UNKNOWN=0]="UNKNOWN",he[he.KEYBOARD=1]="KEYBOARD",he[he.MOUSE=2]="MOUSE"})(W||(e.EditorCloseMethod=W={}));function X(he,q,U,ne){if(!he.isSticky(q))return!1;switch(ne.preventPinnedEditorClose){case"keyboardAndMouse":return U===W.MOUSE||U===W.KEYBOARD;case"mouse":return U===W.MOUSE;case"keyboard":return U===W.KEYBOARD}return!1}e.$wE=X,e.$xE=new N;var ce;(function(he){he[he.LEFT=0]="LEFT",he[he.RIGHT=1]="RIGHT"})(ce||(e.CloseDirection=ce={}));class J{constructor(){this.c=new Map,this.d=new Map}start(q){const U=this.a=q.get(L.$Uh);for(const[ne,be]of this.c)this.e(ne,be,U);this.c.clear()}e(q,U,ne){const be=ne.createInstance(U);this.d.set(q,be)}registerFileEditorFactory(q){if(this.b)throw new Error("Can only register one file editor factory.");this.b=q}getFileEditorFactory(){return(0,T.$Nf)(this.b)}registerEditorSerializer(q,U){if(this.c.has(q)||this.d.has(q))throw new Error(`A editor serializer with type ID '${q}' was already registered.`);return this.a?this.e(q,U,this.a):this.c.set(q,U),(0,R.$Pc)(()=>{this.c.delete(q),this.d.delete(q)})}getEditorSerializer(q){return this.d.get(typeof q=="string"?q:q.typeId)}}b.$mn.add(e.$aE.EditorFactory,new J);async function Q(he,q,U){return!he||!he.length?[]:await Promise.all(he.map(async ne=>{const be=f.URI.revive(ne.fileUri);if(!be){U.info("Cannot resolve the path because it is not valid.",ne);return}if(!await q.canHandleResource(be)){U.info("Cannot resolve the path because it cannot be handled",ne);return}let x=ne.exists,Y=ne.type;if(typeof x!="boolean"||typeof Y!="number")try{Y=(await q.stat(be)).isDirectory?y.FileType.Directory:y.FileType.Unknown,x=!0}catch(ie){U.error(ie),x=!1}if(!x&&ne.openOnlyIfExists){U.info("Cannot resolve the path because it does not exist",ne);return}if(Y===y.FileType.Directory){U.info("Cannot resolve the path because it is a directory",ne);return}const $e={...ne.options,pinned:!0};return x?{resource:be,options:$e}:{resource:be,options:$e,forceUntitled:!0}}))}e.$yE=Q;var G;(function(he){he[he.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",he[he.SEQUENTIAL=1]="SEQUENTIAL"})(G||(e.EditorsOrder=G={}));function oe(he){const q=he;if(!q)return!1;const U=q;if(U.modified)return oe(U.modified);const ne=q;return!!(ne.contributionsState&&ne.viewState&&Array.isArray(ne.cursorState))}e.$zE=oe;function _(he){return(0,A.$Hi)(he)}e.$AE=_;function Ee(he,q,U){const ne=(0,A.$Ii)(he,q);return ne.forceMessage=U?.forceMessage,ne.forceSeverity=U?.forceSeverity,ne.allowDialog=U?.allowDialog,ne}e.$BE=Ee}),define(ke[279],Se([1,0,4,226,5,3,28,37,19,24,78,265]),function(me,e,C,T,f,R,L,b,y,g,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KE=e.$JE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$IE=e.$HE=e.ViewContentGroups=e.$GE=e.$FE=e.ViewContainerLocation=e.Extensions=e.$EE=e.$DE=e.$CE=void 0,e.$CE="views",e.$DE=(0,T.localize)(0,null),e.$EE=(0,I.$aw)("default-view-icon",A.$1j.window,(0,T.localize)(1,null));var $;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})($||(e.Extensions=$={}));var v;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(v||(e.ViewContainerLocation=v={})),e.$FE=[0,1,2];function S(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$GE=S;class w extends R.$Rc{constructor(){super(...arguments),this.c=this.B(new C.$Rd),this.onDidRegister=this.c.event,this.f=this.B(new C.$Rd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,y.$Qb)([...this.g.values()])}registerViewContainer(d,c,u){const h=this.get(d.id);if(h)return h;const E=d;return E.openCommandActionDescriptor=u?.doNotRegisterOpenCommand?void 0:E.openCommandActionDescriptor??{id:E.id},(0,L.$wc)(this.g,c,[]).push(E),u?.isDefault&&this.h.push(E),this.c.fire({viewContainer:E,viewContainerLocation:c}),E}deregisterViewContainer(d){for(const c of this.g.keys()){const u=this.g.get(c),h=u?.indexOf(d);if(h!==-1){u?.splice(h,1),u.length===0&&this.g.delete(c),this.f.fire({viewContainer:d,viewContainerLocation:c});return}}}get(d){return this.all.filter(c=>c.id===d)[0]}getViewContainers(d){return[...this.g.get(d)||[]]}getViewContainerLocation(d){return[...this.g.keys()].filter(c=>this.getViewContainers(c).filter(u=>u?.id===d.id).length>0)[0]}getDefaultViewContainer(d){return this.h.find(c=>this.getViewContainerLocation(c)===d)}}b.$mn.add($.ViewContainersRegistry,new w);var l;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(l||(e.ViewContentGroups=l={}));function o(s,d){const c=s.group??l.More,u=d.group??l.More;return c!==u?c.localeCompare(u):(s.order??5)-(d.order??5)}class i extends R.$Rc{constructor(){super(...arguments),this.c=this.B(new C.$Rd),this.onViewsRegistered=this.c.event,this.f=this.B(new C.$Rd),this.onViewsDeregistered=this.f.event,this.g=this.B(new C.$Rd),this.onDidChangeContainer=this.g.event,this.h=this.B(new C.$Rd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new L.$Fc}registerViews(d,c){this.registerViews2([{views:d,viewContainer:c}])}registerViews2(d){d.forEach(({views:c,viewContainer:u})=>this.r(c,u)),this.c.fire(d)}deregisterViews(d,c){const u=this.s(d,c);u.length&&this.f.fire({views:u,viewContainer:c})}moveViews(d,c){for(const u of this.m.keys())if(u!==c){const h=this.s(d,u);h.length&&(this.r(h,c),this.g.fire({views:h,from:u,to:c}))}}getViews(d){return this.m.get(d)||[]}getView(d){for(const c of this.j){const u=(this.m.get(c)||[]).filter(h=>h.id===d)[0];if(u)return u}return null}getViewContainer(d){for(const c of this.j)if((this.m.get(c)||[]).filter(h=>h.id===d)[0])return c;return null}registerViewWelcomeContent(d,c){return this.n.add(d,c),this.h.fire(d),(0,R.$Pc)(()=>{this.n.delete(d,c),this.h.fire(d)})}registerViewWelcomeContent2(d,c){const u=new Map;for(const[h,E]of c)this.n.add(d,E),u.set(h,(0,R.$Pc)(()=>{this.n.delete(d,E),this.h.fire(d)}));return this.h.fire(d),u}getViewWelcomeContent(d){const c=[];return this.n.forEach(d,u=>c.push(u)),c.sort(o)}r(d,c){let u=this.m.get(c);u||(u=[],this.m.set(c,u),this.j.push(c));for(const h of d){if(this.getView(h.id)!==null)throw new Error((0,T.localize)(2,null,h.id));u.push(h)}}s(d,c){const u=this.m.get(c);if(!u)return[];const h=[],E=[];for(const D of u)d.includes(D)?h.push(D):E.push(D);return h.length&&(E.length?this.m.set(c,E):(this.m.delete(c),this.j.splice(this.j.indexOf(c),1))),h}}b.$mn.add($.ViewsRegistry,new i),e.$HE=(0,f.$Vh)("viewsService"),e.$IE=(0,f.$Vh)("viewDescriptorService");var n;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var r;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(r||(e.TreeItemCollapsibleState=r={}));class a{constructor(d,c){this.c=!1,this.d=!1,(0,g.$dn)(this,d),this.d=!!c,this.resolve=async u=>{if(c&&!this.c){const h=await c(u);h&&(this.tooltip=this.tooltip??h.tooltip,this.command=this.command??h.command)}u.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$JE=a;class t extends Error{constructor(d){super((0,T.localize)(3,null,d)),this.name="NoTreeViewError"}static is(d){return d.name==="NoTreeViewError"}}e.$KE=t}),define(ke[280],Se([1,0,2,29,5]),function(me,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aF=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$_E=e.$$E=void 0;function R(g){return!!g&&typeof g=="object"&&"uri"in g&&g.uri instanceof C.URI&&"version"in g&&typeof g.version=="number"&&"ranges"in g&&Array.isArray(g.ranges)&&g.ranges.every(T.$zs.isIRange)}e.$$E=R;function L(g){return!!g&&typeof g=="object"&&"documents"in g&&Array.isArray(g.documents)&&g.documents.every(R)}e.$_E=L;var b;(function(g){g[g.Down=0]="Down",g[g.Up=1]="Up"})(b||(e.InteractiveSessionVoteDirection=b={}));var y;(function(g){g[g.Action=1]="Action",g[g.Toolbar=2]="Toolbar"})(y||(e.InteractiveSessionCopyKind=y={})),e.$aF=(0,f.$Vh)("IChatService")}),define(ke[142],Se([1,0,4,12,227]),function(me,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$cb=void 0;class R{constructor(){this.f=new Map,this.k=[],this.m=new C.$Rd,this.n=new C.$Rd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(b){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=b}onEvent(b){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=b}onRequest(b){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=b}sendResponse(b){b.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${b.command}`)):this.s("response",b)}sendRequest(b,y,g,A){const I={command:b};if(y&&Object.keys(y).length>0&&(I.arguments=y),this.s("request",I),typeof A=="number"){const $=setTimeout(()=>{clearTimeout($);const v=this.f.get(I.seq);if(v){this.f.delete(I.seq);const S={type:"response",seq:0,request_seq:I.seq,success:!1,command:b,message:(0,f.localize)(0,null,A,b)};v(S)}},A)}return g&&this.f.set(I.seq,g),I.seq}acceptMessage(b){this.j?this.j(b):(this.k.push(b),this.k.length===1&&this.q())}o(b,y){return b.type!=="event"||y.type!=="event"}async q(){let b;for(;this.k.length;){if((!b||this.o(this.k[0],b))&&await(0,T.$Yg)(0),b=this.k.shift(),!b)return;switch(b.type){case"event":this.i?.(b);break;case"request":this.g?.(b);break;case"response":{const y=b,g=this.f.get(y.request_seq);g&&(this.f.delete(y.request_seq),g(y));break}}}}s(b,y){y.type=b,y.seq=this.d++,this.sendMessage(y)}async u(){if(this.f.size===0)return Promise.resolve();const b=new Map;this.f.forEach((y,g)=>b.set(g,y)),await(0,T.$Yg)(500),b.forEach((y,g)=>{y({type:"response",seq:0,request_seq:g,success:!1,command:"canceled",message:"canceled"}),this.f.delete(g)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$$cb=R}),define(ke[281],Se([1,0,228,45,5]),function(me,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$lH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$kH=e.MemoryRangeType=e.$jH=e.State=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=void 0,e.$gG="workbench.view.debug",e.$hG="workbench.debug.variablesView",e.$iG="workbench.debug.watchExpressionsView",e.$jG="workbench.debug.callStackView",e.$kG="workbench.debug.loadedScriptsView",e.$lG="workbench.debug.breakPointsView",e.$mG="workbench.debug.disassemblyView",e.$nG="workbench.panel.repl",e.$oG="workbench.panel.repl.view",e.$pG=new T.$aj("debugType",void 0,{type:"string",description:C.localize(0,null)}),e.$qG=new T.$aj("debugConfigurationType",void 0,{type:"string",description:C.localize(1,null)}),e.$rG=new T.$aj("debugState","inactive",{type:"string",description:C.localize(2,null)}),e.$sG="debugUx",e.$tG=new T.$aj(e.$sG,"default",{type:"string",description:C.localize(3,null)}),e.$uG=new T.$aj("hasDebugged",!1,{type:"boolean",description:C.localize(4,null)}),e.$vG=new T.$aj("inDebugMode",!1,{type:"boolean",description:C.localize(5,null)}),e.$wG=new T.$aj("inDebugRepl",!1,{type:"boolean",description:C.localize(6,null)}),e.$xG=new T.$aj("breakpointWidgetVisible",!1,{type:"boolean",description:C.localize(7,null)}),e.$yG=new T.$aj("inBreakpointWidget",!1,{type:"boolean",description:C.localize(8,null)}),e.$zG=new T.$aj("breakpointsFocused",!0,{type:"boolean",description:C.localize(9,null)}),e.$AG=new T.$aj("watchExpressionsFocused",!0,{type:"boolean",description:C.localize(10,null)}),e.$BG=new T.$aj("watchExpressionsExist",!1,{type:"boolean",description:C.localize(11,null)}),e.$CG=new T.$aj("variablesFocused",!0,{type:"boolean",description:C.localize(12,null)}),e.$DG=new T.$aj("expressionSelected",!1,{type:"boolean",description:C.localize(13,null)}),e.$EG=new T.$aj("breakpointInputFocused",!1,{type:"boolean",description:C.localize(14,null)}),e.$FG=new T.$aj("callStackItemType",void 0,{type:"string",description:C.localize(15,null)}),e.$GG=new T.$aj("callStackSessionIsAttach",!1,{type:"boolean",description:C.localize(16,null)}),e.$HG=new T.$aj("callStackItemStopped",!1,{type:"boolean",description:C.localize(17,null)}),e.$IG=new T.$aj("callStackSessionHasOneThread",!1,{type:"boolean",description:C.localize(18,null)}),e.$JG=new T.$aj("watchItemType",void 0,{type:"string",description:C.localize(19,null)}),e.$KG=new T.$aj("canViewMemory",void 0,{type:"boolean",description:C.localize(20,null)}),e.$LG=new T.$aj("breakpointItemType",void 0,{type:"string",description:C.localize(21,null)}),e.$MG=new T.$aj("breakpointSupportsCondition",!1,{type:"boolean",description:C.localize(22,null)}),e.$NG=new T.$aj("loadedScriptsSupported",!1,{type:"boolean",description:C.localize(23,null)}),e.$OG=new T.$aj("loadedScriptsItemType",void 0,{type:"string",description:C.localize(24,null)}),e.$PG=new T.$aj("focusedSessionIsAttach",!1,{type:"boolean",description:C.localize(25,null)}),e.$QG=new T.$aj("focusedSessionIsNoDebug",!1,{type:"boolean",description:C.localize(26,null)}),e.$RG=new T.$aj("stepBackSupported",!1,{type:"boolean",description:C.localize(27,null)}),e.$SG=new T.$aj("restartFrameSupported",!1,{type:"boolean",description:C.localize(28,null)}),e.$TG=new T.$aj("stackFrameSupportsRestart",!1,{type:"boolean",description:C.localize(29,null)}),e.$UG=new T.$aj("jumpToCursorSupported",!1,{type:"boolean",description:C.localize(30,null)}),e.$VG=new T.$aj("stepIntoTargetsSupported",!1,{type:"boolean",description:C.localize(31,null)}),e.$WG=new T.$aj("breakpointsExist",!1,{type:"boolean",description:C.localize(32,null)}),e.$XG=new T.$aj("debuggersAvailable",!1,{type:"boolean",description:C.localize(33,null)}),e.$YG=new T.$aj("debugExtensionAvailable",!0,{type:"boolean",description:C.localize(34,null)}),e.$ZG=new T.$aj("debugProtocolVariableMenuContext",void 0,{type:"string",description:C.localize(35,null)}),e.$1G=new T.$aj("debugSetVariableSupported",!1,{type:"boolean",description:C.localize(36,null)}),e.$2G=new T.$aj("debugSetExpressionSupported",!1,{type:"boolean",description:C.localize(37,null)}),e.$3G=new T.$aj("breakWhenValueChangesSupported",!1,{type:"boolean",description:C.localize(38,null)}),e.$4G=new T.$aj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:C.localize(39,null)}),e.$5G=new T.$aj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:C.localize(40,null)}),e.$6G=new T.$aj("terminateDebuggeeSupported",!1,{type:"boolean",description:C.localize(41,null)}),e.$7G=new T.$aj("suspendDebuggeeSupported",!1,{type:"boolean",description:C.localize(42,null)}),e.$8G=new T.$aj("variableEvaluateNamePresent",!1,{type:"boolean",description:C.localize(43,null)}),e.$9G=new T.$aj("variableIsReadonly",!1,{type:"boolean",description:C.localize(44,null)}),e.$0G=new T.$aj("exceptionWidgetVisible",!1,{type:"boolean",description:C.localize(45,null)}),e.$$G=new T.$aj("multiSessionRepl",!1,{type:"boolean",description:C.localize(46,null)}),e.$_G=new T.$aj("multiSessionDebug",!1,{type:"boolean",description:C.localize(47,null)}),e.$aH=new T.$aj("disassembleRequestSupported",!1,{type:"boolean",description:C.localize(48,null)}),e.$bH=new T.$aj("disassemblyViewFocus",!1,{type:"boolean",description:C.localize(49,null)}),e.$cH=new T.$aj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:C.localize(50,null)}),e.$dH=new T.$aj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:C.localize(51,null)});const R=$=>C.localize(52,null,$);e.$eH=R,e.$fH="editor.contrib.debug",e.$gH="editor.contrib.breakpoint",e.$hH="debug",e.$iH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:C.localize(53,null)};var L;(function($){$[$.Inactive=0]="Inactive",$[$.Initializing=1]="Initializing",$[$.Stopped=2]="Stopped",$[$.Running=3]="Running"})(L||(e.State=L={}));function b($){switch($){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$jH=b;var y;(function($){$[$.Valid=0]="Valid",$[$.Unreadable=1]="Unreadable",$[$.Error=2]="Error"})(y||(e.MemoryRangeType=y={})),e.$kH="vscode-debug-memory";var g;(function($){$[$.Initial=1]="Initial",$[$.Dynamic=2]="Dynamic"})(g||(e.DebugConfigurationProviderTriggerKind=g={}));var A;(function($){$.UnverifiedBreakpoints="unverifiedBreakpoints"})(A||(e.DebuggerString=A={})),e.$lH=(0,f.$Vh)("debugService");var I;(function($){$[$.CONDITION=0]="CONDITION",$[$.HIT_COUNT=1]="HIT_COUNT",$[$.LOG_MESSAGE=2]="LOG_MESSAGE"})(I||(e.BreakpointWidgetContext=I={}))}),define(ke[282],Se([1,0,13,2,16,24,17,29,21,19]),function(me,e,C,T,f,R,L,b,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rF=e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=e.$iF=e.$hF=e.$gF=e.$fF=void 0;const A=/{([^}]+)}/g;function I(D,m,p){return D.replace(A,function(k,P){return m&&P.length>0&&P[0]!=="_"?k:p&&p.hasOwnProperty(P)?p[P]:k})}e.$fF=I;function $(D){const m={};for(const p of Object.keys(D))p.startsWith("!")||(m[p]=D[p]);return m}e.$gF=$;function v(D){return D.configuration.request==="attach"&&!S(D)&&(!D.parentSession||v(D.parentSession))}e.$hF=v;function S(D){let m=D.configuration.type;if(m)return m==="vslsShare"&&(m=D.configuration.adapterProxy.configuration.type),(0,C.$6e)(m,"extensionhost")||(0,C.$6e)(m,"pwa-extensionhost")?D:D.parentSession?S(D.parentSession):void 0}e.$iF=S;function w(D){return D.type&&(D.label||D.program||D.runtime)}e.$jF=w;function l(D,m,p){let k,P=0;const z=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let j=null;for(;j=z.exec(D);){const M=j.index+1,O=M+j[0].length;if(M<=m&&O>=p){k=j[0],P=M;break}}if(k){const M=/\w+/g;let O=null;for(;(O=M.exec(k))&&!(O.index+1+P+O[0].length>=p););O&&(k=k.substring(0,M.lastIndex))}return k?{start:P,end:P+k.length-1}:{start:0,end:0}}e.$kF=l;async function o(D,m,p,k){if(D.evaluatableExpressionProvider.has(m)){const P=D.evaluatableExpressionProvider.ordered(m),z=(0,g.$Gb)(await Promise.all(P.map(async j=>{try{return await j.provideEvaluatableExpression(m,p,k??y.CancellationToken.None)}catch{return}})));if(z.length>0){let j=z[0].expression;const M=z[0].range;return j||(j=m.getLineContent(p.lineNumber).substring(M.startColumn-1,M.endColumn-1)),{range:M,matchingExpression:j}}}else{const P=m.getLineContent(p.lineNumber),{start:z,end:j}=l(P,p.column,p.column),M=P.substring(z-1,j);return{matchingExpression:M,range:new b.$zs(p.lineNumber,z,p.lineNumber,z+M.length)}}return null}e.$lF=o;const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(D){return!!(D&&D.match(i))}e.$mF=n;function r(D){if(typeof D.path=="string"&&!(typeof D.sourceReference=="number"&&D.sourceReference>0)){if(n(D.path))return T.URI.parse(D.path);if((0,f.$hc)(D.path))return T.URI.file(D.path)}return D.path}function a(D){if(typeof D.path=="object"){const m=T.URI.revive(D.path);if(m)return m.scheme===L.Schemas.file?m.fsPath:m.toString()}return D.path}function t(D,m){const p=m?r:a,k=(0,R.$an)(D);return d(k,(P,z)=>{P&&z&&(z.path=p(z))}),k}e.$nF=t;function s(D,m){const p=m?r:a,k=(0,R.$an)(D);return d(k,(P,z)=>{!P&&z&&(z.path=p(z))}),k}e.$oF=s;function d(D,m){switch(D.type){case"event":{const p=D;switch(p.event){case"output":m(!1,p.body.source);break;case"loadedSource":m(!1,p.body.source);break;case"breakpoint":m(!1,p.body.breakpoint.source);break;default:break}break}case"request":{const p=D;switch(p.command){case"setBreakpoints":m(!0,p.arguments.source);break;case"breakpointLocations":m(!0,p.arguments.source);break;case"source":m(!0,p.arguments.source);break;case"gotoTargets":m(!0,p.arguments.source);break;case"launchVSCode":p.arguments.args.forEach(k=>m(!1,k));break;default:break}break}case"response":{const p=D;if(p.success&&p.body)switch(p.command){case"stackTrace":p.body.stackFrames.forEach(k=>m(!1,k.source));break;case"loadedSources":p.body.sources.forEach(k=>m(!1,k));break;case"scopes":p.body.scopes.forEach(k=>m(!1,k.source));break;case"setFunctionBreakpoints":p.body.breakpoints.forEach(k=>m(!1,k.source));break;case"setBreakpoints":p.body.breakpoints.forEach(k=>m(!1,k.source));break;case"disassemble":p.body?.instructions.forEach(P=>m(!1,P.location));break;default:break}break}}}function c(D){return D.filter(m=>!m.presentation?.hidden).sort((m,p)=>m.presentation?p.presentation?m.presentation.group?p.presentation.group?m.presentation.group!==p.presentation.group?m.presentation.group.localeCompare(p.presentation.group):u(m.presentation.order,p.presentation.order):-1:p.presentation.group?1:u(m.presentation.order,p.presentation.order):-1:p.presentation?1:0)}e.$pF=c;function u(D,m){return typeof D!="number"?typeof m!="number"?0:1:typeof m!="number"?-1:D-m}async function h(D,m){const p=D.getValue("debug.saveBeforeStart",{overrideIdentifier:m.activeTextEditorLanguageId});if(p!=="none"&&(await m.saveAll(),p==="allEditorsInActiveGroup")){const k=m.activeEditorPane;k&&k.input.resource?.scheme===L.Schemas.untitled&&await m.save({editor:k.input,groupId:k.group.id})}await D.reloadConfiguration()}e.$qF=h;const E=(D,m)=>!D||!m?D===m:D.name===m.name&&D.path===m.path&&D.sourceReference===m.sourceReference;e.$rF=E}),define(ke[283],Se([1,0,50,62,24,16,11,13,30,229,142]),function(me,e,C,T,f,R,L,b,y,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2fc=e.$1fc=e.$Zfc=e.$Yfc=e.$Xfc=void 0;class I extends A.$$cb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.l=/: */}constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(o,i){this.p=i,this.r=Buffer.allocUnsafe(0),this.t=-1,o.on("data",n=>this.w(n))}sendMessage(o){if(this.p){const i=JSON.stringify(o);this.p.write(`Content-Length: ${Buffer.byteLength(i,"utf8")}${I.a}${i}`,"utf8")}}w(o){for(this.r=Buffer.concat([this.r,o]);;){if(this.t>=0){if(this.r.length>=this.t){const i=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,i.length>0)try{this.acceptMessage(JSON.parse(i))}catch(n){this.m.fire(new Error((n.message||n)+`
`+i))}continue}}else{const i=this.r.indexOf(I.a);if(i!==-1){const r=this.r.toString("utf8",0,i).split(I.b);for(const a of r){const t=a.split(I.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(i+I.a.length);continue}}break}}}e.$Xfc=I;class $ extends I{startSession(){return new Promise((o,i)=>{let n=!1;this.x=this.y(()=>{this.v(this.x,this.x),o(),n=!0}),this.x.on("close",()=>{n?this.m.fire(new Error("connection closed")):i(new Error("connection closed"))}),this.x.on("error",r=>{n?this.m.fire(r):i(r)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$Yfc=$;class v extends ${constructor(o){super(),this.z=o}y(o){return T.createConnection(this.z.port,this.z.host||"127.0.0.1",o)}}e.$Zfc=v;class S extends ${constructor(o){super(),this.z=o}y(o){return T.createConnection(this.z.path,o)}}e.$1fc=S;class w extends I{constructor(o,i){super(),this.y=o,this.z=i}async startSession(){const o=this.y.command,i=this.y.args,n=this.y.options||{};try{if(o)if(R.$hc(o)){if(!await y.Promises.exists(o))throw new Error(g.localize(0,null,o))}else o.indexOf("/")<0&&o.indexOf("\\")<0;else throw new Error(g.localize(1,null,this.z));let r=process.env;if(n.env&&Object.keys(n.env).length>0&&(r=f.$dn(f.$an(process.env),n.env)),o==="node")if(Array.isArray(i)&&i.length>0){const a=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:r,execArgv:a?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};n.cwd&&(t.cwd=n.cwd);const s=C.fork(i[0],i.slice(1),t);if(!s.pid)throw new Error(g.localize(2,null,i[0]));this.x=s}else throw new Error(g.localize(3,null));else{const a={env:r};n.cwd&&(a.cwd=n.cwd),this.x=C.spawn(o,i,a)}this.x.on("error",a=>{this.m.fire(a)}),this.x.on("exit",(a,t)=>{this.n.fire(a)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",a=>{this.m.fire(a)}),this.x.stdin.on("error",a=>{this.m.fire(a)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(r){this.m.fire(r)}}async stopSession(){return this.x?(await this.u(),L.$i?new Promise((o,i)=>{const n=C.exec(`taskkill /F /T /PID ${this.x.pid}`,function(r,a,t){if(r)return i(r)});n.on("exit",o),n.on("error",i)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(o,i){if(!o)return;const n=Object.create(null);o.runtime&&(o.runtime.indexOf("./")===0?n.runtime=R.$ic(i,o.runtime):n.runtime=o.runtime),o.runtimeArgs&&(n.runtimeArgs=o.runtimeArgs),o.program&&(R.$hc(o.program)?n.program=o.program:n.program=R.$ic(i,o.program)),o.args&&(n.args=o.args);const r=o;return r.win&&(n.win=w.A(r.win,i)),r.winx86&&(n.winx86=w.A(r.winx86,i)),r.windows&&(n.windows=w.A(r.windows,i)),r.osx&&(n.osx=w.A(r.osx,i)),r.linux&&(n.linux=w.A(r.linux,i)),n}static platformAdapterExecutable(o,i){let n=Object.create(null);i=i.toLowerCase();for(const c of o)if(c.contributes){const u=c.contributes.debuggers;u&&u.length>0&&u.filter(h=>typeof h.type=="string"&&b.$6e(h.type,i)).forEach(h=>{const E=w.A(h,c.extensionLocation.fsPath);n=f.$dn(n,E,c.isBuiltin)})}let r;L.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?r=n.winx86||n.win||n.windows:L.$i?r=n.win||n.windows:L.$j?r=n.osx:L.$k&&(r=n.linux),r=r||n;const a=r.program||n.program,t=r.args||n.args,s=r.runtime||n.runtime,d=r.runtimeArgs||n.runtimeArgs;if(s)return{type:"executable",command:s,args:(d||[]).concat(typeof a=="string"?[a]:[]).concat(t||[])};if(a)return{type:"executable",command:a,args:t||[]}}}e.$2fc=w}),define(ke[284],Se([1,0,50,33,11]),function(me,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4fc=e.$3fc=void 0;function R(g,A){return new Promise((I,$)=>{let v="";const S=C.spawn(g,A);S.pid&&S.stdout.on("data",w=>{v+=w.toString()}),S.on("error",w=>{$(w)}),S.on("close",w=>{I(v)})})}async function L(g){if(g)if(f.$i){const A=await new Promise((I,$)=>{me(["@vscode/windows-process-tree"],I,$)});return new Promise(I=>{A.getProcessTree(g,$=>{I(!!$&&$.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(g)]).then(A=>{const I=A.trim();return!(I.length===0||I.indexOf(" tmux")>=0)},A=>!0);return Promise.resolve(!0)}e.$3fc=L;var b;(function(g){g[g.cmd=0]="cmd",g[g.powershell=1]="powershell",g[g.bash=2]="bash"})(b||(b={}));function y(g,A,I,$,v){g=g.trim().toLowerCase();let S;g.indexOf("powershell")>=0||g.indexOf("pwsh")>=0?S=1:g.indexOf("cmd.exe")>=0?S=0:g.indexOf("bash")>=0?S=2:f.$i?S=0:S=2;let w,l=" ";switch(S){case 1:if(w=o=>(o=o.replace(/\'/g,"''"),o.length>0&&o.charAt(o.length-1)==="\\"?`'${o}\\'`:`'${o}'`),$){const o=(0,T.$7f)($);o&&(l+=`${o}:; `),l+=`cd ${w($)}; `}if(v)for(const o in v){const i=v[o];i===null?l+=`Remove-Item env:${o}; `:l+=`\${env:${o}}='${i}'; `}if(A.length>0){const o=A.shift(),i=I?o:w(o);l+=i[0]==="'"?`& ${i} `:`${i} `;for(const n of A)l+=n==="<"||n===">"||I?n:w(n),l+=" "}break;case 0:if(w=o=>(o=o.replace(/\"/g,'""'),o=o.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(i=>o.includes(i))||o.length===0?`"${o}"`:o),$){const o=(0,T.$7f)($);o&&(l+=`${o}: && `),l+=`cd ${w($)} && `}if(v){l+='cmd /C "';for(const o in v){let i=v[o];i===null?l+=`set "${o}=" && `:(i=i.replace(/[&^|<>]/g,n=>`^${n}`),l+=`set "${o}=${i}" && `)}}for(const o of A)l+=o==="<"||o===">"||I?o:w(o),l+=" ";v&&(l+='"');break;case 2:{w=i=>(i=i.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),i.length===0?'""':i);const o=i=>/[^\w@%\/+=,.:^-]/.test(i)?`'${i.replace(/'/g,"'\\''")}'`:i;if($&&(l+=`cd ${w($)} ; `),v){l+="/usr/bin/env";for(const i in v){const n=v[i];n===null?l+=` -u ${o(i)}`:l+=` ${o(`${i}=${n}`)}`}l+=" "}for(const i of A)l+=i==="<"||i===">"||I?i:w(i),l+=" ";break}}return l}e.$4fc=y}),define(ke[111],Se([1,0,22,34,51,100,17,16,11,45]),function(me,e,C,T,f,R,L,b,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FI=e.$EI=e.$DI=e.$CI=e.CellStatusbarAlignment=e.$BI=e.$AI=e.$zI=e.NotebookEditorPriority=e.$yI=e.$xI=e.$wI=e.$vI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$uI=e.$tI=e.$sI=e.$rI=e.CellKind=e.$qI=e.$pI=e.$oI=void 0,e.$oI="workbench.editor.notebook",e.$pI="workbench.editor.notebookTextDiffEditor",e.$qI="workbench.editor.interactive";var A;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(A||(e.CellKind=A={})),e.$rI=["application/json","application/javascript","text/html","image/svg+xml",R.$Vr.latex,R.$Vr.markdown,"image/png","image/jpeg",R.$Vr.text],e.$sI=[R.$Vr.latex,R.$Vr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",R.$Vr.text],e.$tI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$uI="_notAvailable";var I;(function(N){N[N.Running=1]="Running",N[N.Idle=2]="Idle"})(I||(e.NotebookRunState=I={}));var $;(function(N){N[N.Unconfirmed=1]="Unconfirmed",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})($||(e.NotebookCellExecutionState=$={}));var v;(function(N){N[N.Unconfirmed=1]="Unconfirmed",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(v||(e.NotebookExecutionState=v={}));var S;(function(N){N[N.WithHardKernelDependency=0]="WithHardKernelDependency",N[N.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",N[N.Pure=2]="Pure",N[N.Never=3]="Never"})(S||(e.NotebookRendererMatch=S={}));var w;(function(N){N.Always="always",N.Never="never",N.Optional="optional"})(w||(e.RendererMessagingSpec=w={}));var l;(function(N){N[N.ModelChange=1]="ModelChange",N[N.Move=2]="Move",N[N.ChangeCellLanguage=5]="ChangeCellLanguage",N[N.Initialize=6]="Initialize",N[N.ChangeCellMetadata=7]="ChangeCellMetadata",N[N.Output=8]="Output",N[N.OutputItem=9]="OutputItem",N[N.ChangeCellContent=10]="ChangeCellContent",N[N.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",N[N.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",N[N.ChangeCellMime=13]="ChangeCellMime",N[N.Unknown=100]="Unknown"})(l||(e.NotebookCellsChangeType=l={}));var o;(function(N){N[N.Handle=0]="Handle",N[N.Index=1]="Index"})(o||(e.SelectionStateType=o={}));var i;(function(N){N[N.Replace=1]="Replace",N[N.Output=2]="Output",N[N.Metadata=3]="Metadata",N[N.CellLanguage=4]="CellLanguage",N[N.DocumentMetadata=5]="DocumentMetadata",N[N.Move=6]="Move",N[N.OutputItems=7]="OutputItems",N[N.PartialMetadata=8]="PartialMetadata",N[N.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var n;(function(N){N.scheme=L.Schemas.vscodeNotebookCell;const W=["W","X","Y","Z","a","b","c","d","e","f"],X=new RegExp(`^[${W.join("")}]+`),ce=7;function J(he,q){const U=q.toString(ce),be=`${U.length<W.length?W[U.length-1]:"z"}${U}s${(0,C.$ze)(C.$fe.fromString(he.scheme),!0,!0)}`;return he.with({scheme:N.scheme,fragment:be})}N.generate=J;function Q(he){if(he.scheme!==N.scheme)return;const q=he.fragment.indexOf("s");if(q<0)return;const U=parseInt(he.fragment.substring(0,q).replace(X,""),ce),ne=(0,C.$ye)(he.fragment.substring(q+1)).toString();if(!isNaN(U))return{handle:U,notebook:he.with({scheme:ne,fragment:null})}}N.parse=Q;function G(he,q){return he.with({scheme:L.Schemas.vscodeNotebookCellOutput,fragment:`op${q??""},${he.scheme!==L.Schemas.file?he.scheme:""}`})}N.generateCellOutputUri=G;function oe(he){if(he.scheme!==L.Schemas.vscodeNotebookCellOutput)return;const q=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(he.fragment);if(!q)return;const U=q[1]&&q[1]!==""?q[1]:void 0,ne=q[2];return{outputId:U,notebook:he.with({scheme:ne||L.Schemas.file,fragment:null})}}N.parseCellOutputUri=oe;function _(he,q,U){return N.generate(he,q).with({scheme:U})}N.generateCellPropertyUri=_;function Ee(he,q){if(he.scheme===q)return N.parse(he.with({scheme:N.scheme}))}N.parseCellPropertyUri=Ee})(n||(e.CellUri=n={}));const r=N=>y.$i?N.replace(/\//g,"\\"):N;class a{constructor(W=[],X=e.$rI){this.e=X,this.d=[...new Set(W)].map(ce=>({pattern:ce,matches:T.$Cj(r(ce))}))}sort(W){const X=new Map(f.Iterable.map(W,J=>[J,r(J)]));let ce=[];for(const{matches:J}of this.d)for(const[Q,G]of X)if(J(G)){ce.push(Q),X.delete(Q);break}return X.size&&(ce=ce.concat([...X.keys()].sort((J,Q)=>this.e.indexOf(J)-this.e.indexOf(Q)))),ce}prioritize(W,X){const ce=this.f(W);if(ce===-1){this.d.unshift({pattern:W,matches:T.$Cj(r(W))});return}const J=new Set(X.map(G=>this.f(G,ce)));J.delete(-1);const Q=Array.from(J).sort();this.d.splice(ce+1,0,...Q.map(G=>this.d[G]));for(let G=Q.length-1;G>=0;G--)this.d.splice(Q[G],1)}toArray(){return this.d.map(W=>W.pattern)}f(W,X=this.d.length){const ce=r(W);for(let J=0;J<X;J++)if(this.d[J].matches(ce))return J;return-1}}e.$vI=a;function t(N,W,X,ce=(J,Q)=>J===Q){const J=[];function Q(_,Ee,he){if(Ee===0&&he.length===0)return;const q=J[J.length-1];q&&q.start+q.deleteCount===_?(q.deleteCount+=Ee,q.toInsert.push(...he)):J.push({start:_,deleteCount:Ee,toInsert:he})}let G=0,oe=0;for(;;){if(G===N.length){Q(G,0,W.slice(oe));break}if(oe===W.length){Q(G,N.length-G,[]);break}const _=N[G],Ee=W[oe];if(ce(_,Ee)){G+=1,oe+=1;continue}X(Ee)?(Q(G,1,[]),G+=1):(Q(G,0,[Ee]),oe+=1)}return J}e.$wI=t,e.$xI=new g.$aj("notebookEditorCursorAtBoundary","none"),e.$yI=new g.$aj("notebookEditorCursorAtLineBoundary","none");var s;(function(N){N.default="default",N.option="option"})(s||(e.NotebookEditorPriority=s={}));function d(N){const W=N;return!!((typeof W.include=="string"||T.$Dj(W.include))&&(typeof W.exclude=="string"||T.$Dj(W.exclude)))}e.$zI=d;function c(N,W,X){if(Array.isArray(N.viewType)&&N.viewType.indexOf(W)>=0||N.viewType===W)return!0;if(N.filenamePattern){const ce=d(N.filenamePattern)?N.filenamePattern.include:N.filenamePattern,J=d(N.filenamePattern)?N.filenamePattern.exclude:void 0;if(T.$Bj(ce,(0,b.$mc)(X.fsPath).toLowerCase()))return!(J&&T.$Bj(J,(0,b.$mc)(X.fsPath).toLowerCase()))}return!1}e.$AI=c,e.$BI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var u;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(u||(e.CellStatusbarAlignment=u={}));class h{static{this.d="notebook/"}static create(W){return`${h.d}${W}`}static parse(W){if(W.startsWith(h.d))return W.substring(h.d.length)}}e.$CI=h;function E(N){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(N)}e.$DI=E;const D=new TextDecoder;function m(N){const W=[];let X=!1;for(const G of N)(W.length===0||X)&&(W.push(G),X=!0);let ce=P(W);const J=C.$fe.concat(W.map(G=>C.$fe.wrap(G))),Q=F(J);return ce=ce||Q.byteLength!==J.byteLength,{data:Q,didCompression:ce}}e.$EI=m,e.$FI=`${String.fromCharCode(27)}[A`;const p=e.$FI.split("").map(N=>N.charCodeAt(0)),k=10;function P(N){let W=!1;return N.forEach((X,ce)=>{if(ce===0||X.length<e.$FI.length)return;const J=N[ce-1],Q=X.subarray(0,e.$FI.length);if(Q[0]===p[0]&&Q[1]===p[1]&&Q[2]===p[2]){const G=J.lastIndexOf(k);if(G===-1)return;W=!0,N[ce-1]=J.subarray(0,G),N[ce]=X.subarray(e.$FI.length)}}),W}function z(N){let W=N;do N=W,W=N.replace(/[^\n]\x08/gm,"");while(W.length<N.length);return N}function j(N){for(N=N.replace(/\r+\n/gm,`
`);N.search(/\r[^$]/g)>-1;){const W=N.match(/^(.*)\r+/m)[1];let X=N.match(/\r+(.*)$/m)[1];X=X+W.slice(X.length,W.length),N=N.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,X)}return N}const M="\b".charCodeAt(0),O="\r".charCodeAt(0);function F(N){return!N.buffer.includes(M)&&!N.buffer.includes(O)?N:C.$fe.fromString(j(z(D.decode(N.buffer))))}}),define(ke[7],Se([1,0,19,8,80,28,100,13,18,2,32,26,31,64,111]),function(me,e,C,T,f,R,L,b,y,g,A,I,$,v,S){"use strict";var w,l,o,i,n,r,a,t,s,d,c,u,h,E,D,m,p,k;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$qM=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=e.$fM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.TestRunProfileKind=e.TestResultState=e.$9L=e.$8L=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$7L=e.$6L=e.$5L=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$4L=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$3L=e.$2L=e.$1L=e.$ZL=e.$YL=e.ColorThemeKind=e.$XL=e.$WL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$VL=e.DebugConsoleMode=e.$UL=e.$TL=e.$SL=e.$RL=e.$QL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$PL=e.$OL=e.FileChangeType=e.$NL=e.$ML=e.$LL=e.$KL=e.InlineCompletionTriggerKind=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.ConfigurationTarget=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.$qL=e.$pL=e.$oL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$nL=e.ViewBadge=e.ProgressLocation=e.$mL=e.$lL=e.TaskScope=e.ShellQuoting=e.$kL=e.$jL=e.$iL=e.TaskPanelKind=e.TaskRevealKind=e.$hL=e.TerminalLocation=e.$gL=e.$fL=e.$eL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$dL=e.$cL=e.$bL=e.$aL=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$_K=e.StatusBarAlignment=e.ViewColumn=e.$$K=e.$0K=e.$9K=e.$8K=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$7K=e.$6K=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$5K=e.$4K=e.$3K=e.$2K=e.$1K=e.LanguageStatusSeverity=e.$ZK=e.$YK=e.$XK=e.$WK=e.$VK=e.$UK=e.CodeActionTriggerKind=e.$TK=e.$SK=e.SymbolTag=e.SymbolKind=e.$RK=e.DocumentHighlightKind=e.$QK=e.$PK=e.$OK=e.$NK=e.DiagnosticSeverity=e.DiagnosticTag=e.$MK=e.$LK=e.FileEditType=e.$KK=e.$JK=e.$IK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function P(K){return Object.assign(K,{apply:function(...ve){if(ve.length===0)return Reflect.construct(K,[]);{const Re=ve.length===1?[]:ve[1];return Reflect.construct(K,Re,ve[0].constructor)}},call:function(...ve){if(ve.length===0)return Reflect.construct(K,[]);{const[Re,...Ze]=ve;return Reflect.construct(K,Ze,Re.constructor)}}})}var z;(function(K){K[K.Top=0]="Top",K[K.Bottom=1]="Bottom"})(z||(e.TerminalOutputAnchor=z={}));var j;(function(K){K[K.TerminalCommand=0]="TerminalCommand",K[K.Opener=1]="Opener",K[K.Command=3]="Command"})(j||(e.TerminalQuickFixType=j={}));let M=w=class{static from(...V){let ve=V;return new w(function(){if(ve){for(const Re of ve)Re&&typeof Re.dispose=="function"&&Re.dispose();ve=void 0}})}#e;constructor(V){this.#e=V}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$BK=M,e.$BK=M=w=He([P],M);let O=l=class{static Min(...V){if(V.length===0)throw new TypeError;let ve=V[0];for(let Re=1;Re<V.length;Re++){const Ze=V[Re];Ze.isBefore(ve)&&(ve=Ze)}return ve}static Max(...V){if(V.length===0)throw new TypeError;let ve=V[0];for(let Re=1;Re<V.length;Re++){const Ze=V[Re];Ze.isAfter(ve)&&(ve=Ze)}return ve}static isPosition(V){if(!V)return!1;if(V instanceof l)return!0;const{line:ve,character:Re}=V;return typeof ve=="number"&&typeof Re=="number"}static of(V){if(V instanceof l)return V;if(this.isPosition(V))return new l(V.line,V.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(V,ve){if(V<0)throw(0,T.$6)("line must be non-negative");if(ve<0)throw(0,T.$6)("character must be non-negative");this.c=V,this.e=ve}isBefore(V){return this.c<V.c?!0:V.c<this.c?!1:this.e<V.e}isBeforeOrEqual(V){return this.c<V.c?!0:V.c<this.c?!1:this.e<=V.e}isAfter(V){return!this.isBeforeOrEqual(V)}isAfterOrEqual(V){return!this.isBefore(V)}isEqual(V){return this.c===V.c&&this.e===V.e}compareTo(V){return this.c<V.c?-1:this.c>V.line?1:this.e<V.e?-1:this.e>V.e?1:0}translate(V,ve=0){if(V===null||ve===null)throw(0,T.$6)();let Re;return typeof V>"u"?Re=0:typeof V=="number"?Re=V:(Re=typeof V.lineDelta=="number"?V.lineDelta:0,ve=typeof V.characterDelta=="number"?V.characterDelta:0),Re===0&&ve===0?this:new l(this.line+Re,this.character+ve)}with(V,ve=this.character){if(V===null||ve===null)throw(0,T.$6)();let Re;return typeof V>"u"?Re=this.line:typeof V=="number"?Re=V:(Re=typeof V.line=="number"?V.line:this.line,ve=typeof V.character=="number"?V.character:this.character),Re===this.line&&ve===this.character?this:new l(Re,ve)}toJSON(){return{line:this.line,character:this.character}}};e.$CK=O,e.$CK=O=l=He([P],O);let F=o=class{static isRange(V){return V instanceof o?!0:V?O.isPosition(V.start)&&O.isPosition(V.end):!1}static of(V){if(V instanceof o)return V;if(this.isRange(V))return new o(V.start,V.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(V,ve,Re,Ze){let it,ct;if(typeof V=="number"&&typeof ve=="number"&&typeof Re=="number"&&typeof Ze=="number"?(it=new O(V,ve),ct=new O(Re,Ze)):O.isPosition(V)&&O.isPosition(ve)&&(it=O.of(V),ct=O.of(ve)),!it||!ct)throw new Error("Invalid arguments");it.isBefore(ct)?(this.c=it,this.e=ct):(this.c=ct,this.e=it)}contains(V){return o.isRange(V)?this.contains(V.start)&&this.contains(V.end):O.isPosition(V)?!(O.of(V).isBefore(this.c)||this.e.isBefore(V)):!1}isEqual(V){return this.c.isEqual(V.c)&&this.e.isEqual(V.e)}intersection(V){const ve=O.Max(V.start,this.c),Re=O.Min(V.end,this.e);if(!ve.isAfter(Re))return new o(ve,Re)}union(V){if(this.contains(V))return this;if(V.contains(this))return V;const ve=O.Min(V.start,this.c),Re=O.Max(V.end,this.end);return new o(ve,Re)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(V,ve=this.end){if(V===null||ve===null)throw(0,T.$6)();let Re;return V?O.isPosition(V)?Re=V:(Re=V.start||this.start,ve=V.end||this.end):Re=this.start,Re.isEqual(this.c)&&ve.isEqual(this.end)?this:new o(Re,ve)}toJSON(){return[this.start,this.end]}};e.$DK=F,e.$DK=F=o=He([P],F);let N=i=class extends F{static isSelection(V){return V instanceof i?!0:V?F.isRange(V)&&O.isPosition(V.anchor)&&O.isPosition(V.active)&&typeof V.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(V,ve,Re,Ze){let it,ct;if(typeof V=="number"&&typeof ve=="number"&&typeof Re=="number"&&typeof Ze=="number"?(it=new O(V,ve),ct=new O(Re,Ze)):O.isPosition(V)&&O.isPosition(ve)&&(it=O.of(V),ct=O.of(ve)),!it||!ct)throw new Error("Invalid arguments");super(it,ct),this.f=it,this.g=ct}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$EK=N,e.$EK=N=i=He([P],N);const W=K=>{if(typeof K!="string"||K.length===0||!/^[0-9A-Za-z_\-]+$/.test(K))throw(0,T.$6)("connectionToken")};class X{static isResolvedAuthority(V){return V&&typeof V=="object"&&typeof V.host=="string"&&typeof V.port=="number"&&(V.connectionToken===void 0||typeof V.connectionToken=="string")}constructor(V,ve,Re){if(typeof V!="string"||V.length===0)throw(0,T.$6)("host");if(typeof ve!="number"||ve===0||Math.round(ve)!==ve)throw(0,T.$6)("port");typeof Re<"u"&&W(Re),this.host=V,this.port=Math.round(ve),this.connectionToken=Re}}e.$FK=X;class ce{static isManagedResolvedAuthority(V){return V&&typeof V=="object"&&typeof V.makeConnection=="function"&&(V.connectionToken===void 0||typeof V.connectionToken=="string")}constructor(V,ve){this.makeConnection=V,this.connectionToken=ve,typeof ve<"u"&&W(ve)}}e.$GK=ce;class J extends Error{static NotAvailable(V,ve){return new J(V,v.RemoteAuthorityResolverErrorCode.NotAvailable,ve)}static TemporarilyNotAvailable(V){return new J(V,v.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(V,ve=v.RemoteAuthorityResolverErrorCode.Unknown,Re){super(V),this._message=V,this._code=ve,this._detail=Re,Object.setPrototypeOf(this,J.prototype)}}e.$HK=J;var Q;(function(K){K[K.LF=1]="LF",K[K.CRLF=2]="CRLF"})(Q||(e.EndOfLine=Q={}));var G;(function(K){K[K.Replace=1]="Replace",K[K.Append=2]="Append",K[K.Prepend=3]="Prepend"})(G||(e.EnvironmentVariableMutatorType=G={}));let oe=n=class{static isTextEdit(V){return V instanceof n?!0:V?F.isRange(V)&&typeof V.newText=="string":!1}static replace(V,ve){return new n(V,ve)}static insert(V,ve){return n.replace(new F(V,V),ve)}static delete(V){return n.replace(V,"")}static setEndOfLine(V){const ve=new n(new F(new O(0,0),new O(0,0)),"");return ve.newEol=V,ve}get range(){return this.c}set range(V){if(V&&!F.isRange(V))throw(0,T.$6)("range");this.c=V}get newText(){return this.e||""}set newText(V){if(V&&typeof V!="string")throw(0,T.$6)("newText");this.e=V}get newEol(){return this.f}set newEol(V){if(V&&typeof V!="number")throw(0,T.$6)("newEol");this.f=V}constructor(V,ve){this.c=V,this.e=ve}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$IK=oe,e.$IK=oe=n=He([P],oe);let _=r=class{static isNotebookCellEdit(V){return V instanceof r?!0:V?_t.isNotebookRange(V)&&Array.isArray(V.newCells):!1}static replaceCells(V,ve){return new r(V,ve)}static insertCells(V,ve){return new r(new _t(V,V),ve)}static deleteCells(V){return new r(V,[])}static updateCellMetadata(V,ve){const Re=new r(new _t(V,V),[]);return Re.newCellMetadata=ve,Re}static updateNotebookMetadata(V){const ve=new r(new _t(0,0),[]);return ve.newNotebookMetadata=V,ve}constructor(V,ve){this.range=V,this.newCells=ve}};e.$JK=_,e.$JK=_=r=He([P],_);class Ee{static isSnippetTextEdit(V){return V instanceof Ee?!0:V?F.isRange(V.range)&&U.isSnippetString(V.snippet):!1}static replace(V,ve){return new Ee(V,ve)}static insert(V,ve){return Ee.replace(new F(V,V),ve)}constructor(V,ve){this.range=V,this.snippet=ve}}e.$KK=Ee;var he;(function(K){K[K.File=1]="File",K[K.Text=2]="Text",K[K.Cell=3]="Cell",K[K.CellReplace=5]="CellReplace",K[K.Snippet=6]="Snippet"})(he||(e.FileEditType=he={}));let q=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(V,ve,Re,Ze){this.c.push({_type:1,from:V,to:ve,options:Re,metadata:Ze})}createFile(V,ve,Re){this.c.push({_type:1,from:void 0,to:V,options:ve,metadata:Re})}deleteFile(V,ve,Re){this.c.push({_type:1,from:V,to:void 0,options:ve,metadata:Re})}e(V,ve,Re){this.c.push({_type:3,metadata:Re,uri:V,edit:{editType:5,metadata:ve},notebookMetadata:ve})}f(V,ve,Re,Ze){const it=ve.start,ct=ve.end;(it!==ct||Re.length>0)&&this.c.push({_type:5,uri:V,index:it,count:ct-it,cells:Re,metadata:Ze})}g(V,ve,Re,Ze){this.c.push({_type:3,metadata:Ze,uri:V,edit:{editType:3,index:ve,metadata:Re}})}replace(V,ve,Re,Ze){this.c.push({_type:2,uri:V,edit:new oe(ve,Re),metadata:Ze})}insert(V,ve,Re,Ze){this.replace(V,new F(ve,ve),Re,Ze)}delete(V,ve,Re){this.replace(V,ve,"",Re)}has(V){return this.c.some(ve=>ve._type===2&&ve.uri.toString()===V.toString())}set(V,ve){if(ve)for(const Re of ve){if(!Re)continue;let Ze,it;Array.isArray(Re)?(Ze=Re[0],it=Re[1]):Ze=Re,_.isNotebookCellEdit(Ze)?Ze.newCellMetadata?this.g(V,Ze.range.start,Ze.newCellMetadata,it):Ze.newNotebookMetadata?this.e(V,Ze.newNotebookMetadata,it):this.f(V,Ze.range,Ze.newCells,it):Ee.isSnippetTextEdit(Ze)?this.c.push({_type:6,uri:V,range:Ze.range,edit:Ze.snippet,metadata:it}):this.c.push({_type:2,uri:V,edit:Ze,metadata:it})}else{for(let Re=0;Re<this.c.length;Re++){const Ze=this.c[Re];switch(Ze._type){case 2:case 6:case 3:case 5:Ze.uri.toString()===V.toString()&&(this.c[Re]=void 0);break}}(0,C.$Hb)(this.c)}}get(V){const ve=[];for(const Re of this.c)Re._type===2&&Re.uri.toString()===V.toString()&&ve.push(Re.edit);return ve}entries(){const V=new R.$zc;for(const ve of this.c)if(ve._type===2){let Re=V.get(ve.uri);Re||(Re=[ve.uri,[]],V.set(ve.uri,Re)),Re[1].push(ve.edit)}return[...V.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$LK=q,e.$LK=q=He([P],q);let U=a=class{static isSnippetString(V){return V instanceof a?!0:V?typeof V.value=="string":!1}static c(V){return V.replace(/\$|}|\\/g,"\\$&")}constructor(V){this.e=1,this.value=V||""}appendText(V){return this.value+=a.c(V),this}appendTabstop(V=this.e++){return this.value+="$",this.value+=V,this}appendPlaceholder(V,ve=this.e++){if(typeof V=="function"){const Re=new a;Re.e=this.e,V(Re),this.e=Re.e,V=Re.value}else V=a.c(V);return this.value+="${",this.value+=ve,this.value+=":",this.value+=V,this.value+="}",this}appendChoice(V,ve=this.e++){const Re=V.map(Ze=>Ze.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ve,this.value+="|",this.value+=Re,this.value+="|}",this}appendVariable(V,ve){if(typeof ve=="function"){const Re=new a;Re.e=this.e,ve(Re),this.e=Re.e,ve=Re.value}else typeof ve=="string"&&(ve=ve.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=V,ve&&(this.value+=":",this.value+=ve),this.value+="}",this}};e.$MK=U,e.$MK=U=a=He([P],U);var ne;(function(K){K[K.Unnecessary=1]="Unnecessary",K[K.Deprecated=2]="Deprecated"})(ne||(e.DiagnosticTag=ne={}));var be;(function(K){K[K.Hint=3]="Hint",K[K.Information=2]="Information",K[K.Warning=1]="Warning",K[K.Error=0]="Error"})(be||(e.DiagnosticSeverity=be={}));let H=t=class{static isLocation(V){return V instanceof t?!0:V?F.isRange(V.range)&&g.URI.isUri(V.uri):!1}constructor(V,ve){if(this.uri=V,ve)if(F.isRange(ve))this.range=F.of(ve);else if(O.isPosition(ve))this.range=new F(ve,ve);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$NK=H,e.$NK=H=t=He([P],H);let x=class{static is(V){return V?typeof V.message=="string"&&V.location&&F.isRange(V.location.range)&&g.URI.isUri(V.location.uri):!1}constructor(V,ve){this.location=V,this.message=ve}static isEqual(V,ve){return V===ve?!0:!V||!ve?!1:V.message===ve.message&&V.location.range.isEqual(ve.location.range)&&V.location.uri.toString()===ve.location.uri.toString()}};e.$OK=x,e.$OK=x=He([P],x);let Y=class{constructor(V,ve,Re=be.Error){if(!F.isRange(V))throw new TypeError("range must be set");if(!ve)throw new TypeError("message must be set");this.range=V,this.message=ve,this.severity=Re}toJSON(){return{severity:be[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(V,ve){return V===ve?!0:!V||!ve?!1:V.message===ve.message&&V.severity===ve.severity&&V.code===ve.code&&V.severity===ve.severity&&V.source===ve.source&&V.range.isEqual(ve.range)&&(0,C.$tb)(V.tags,ve.tags)&&(0,C.$tb)(V.relatedInformation,ve.relatedInformation,x.isEqual)}};e.$PK=Y,e.$PK=Y=He([P],Y);let $e=class{constructor(V,ve){if(!V)throw new Error("Illegal argument, contents must be defined");Array.isArray(V)?this.contents=V:this.contents=[V],this.range=ve}};e.$QK=$e,e.$QK=$e=He([P],$e);var ie;(function(K){K[K.Text=0]="Text",K[K.Read=1]="Read",K[K.Write=2]="Write"})(ie||(e.DocumentHighlightKind=ie={}));let fe=class{constructor(V,ve=ie.Text){this.range=V,this.kind=ve}toJSON(){return{range:this.range,kind:ie[this.kind]}}};e.$RK=fe,e.$RK=fe=He([P],fe);var te;(function(K){K[K.File=0]="File",K[K.Module=1]="Module",K[K.Namespace=2]="Namespace",K[K.Package=3]="Package",K[K.Class=4]="Class",K[K.Method=5]="Method",K[K.Property=6]="Property",K[K.Field=7]="Field",K[K.Constructor=8]="Constructor",K[K.Enum=9]="Enum",K[K.Interface=10]="Interface",K[K.Function=11]="Function",K[K.Variable=12]="Variable",K[K.Constant=13]="Constant",K[K.String=14]="String",K[K.Number=15]="Number",K[K.Boolean=16]="Boolean",K[K.Array=17]="Array",K[K.Object=18]="Object",K[K.Key=19]="Key",K[K.Null=20]="Null",K[K.EnumMember=21]="EnumMember",K[K.Struct=22]="Struct",K[K.Event=23]="Event",K[K.Operator=24]="Operator",K[K.TypeParameter=25]="TypeParameter"})(te||(e.SymbolKind=te={}));var de;(function(K){K[K.Deprecated=1]="Deprecated"})(de||(e.SymbolTag=de={}));let pe=s=class{static validate(V){if(!V.name)throw new Error("name must not be falsy")}constructor(V,ve,Re,Ze,it){this.name=V,this.kind=ve,this.containerName=it,typeof Re=="string"&&(this.containerName=Re),Ze instanceof H?this.location=Ze:Re instanceof F&&(this.location=new H(Ze,Re)),s.validate(this)}toJSON(){return{name:this.name,kind:te[this.kind],location:this.location,containerName:this.containerName}}};e.$SK=pe,e.$SK=pe=s=He([P],pe);let Pe=d=class{static validate(V){if(!V.name)throw new Error("name must not be falsy");if(!V.range.contains(V.selectionRange))throw new Error("selectionRange must be contained in fullRange");V.children?.forEach(d.validate)}constructor(V,ve,Re,Ze,it){this.name=V,this.detail=ve,this.kind=Re,this.range=Ze,this.selectionRange=it,this.children=[],d.validate(this)}};e.$TK=Pe,e.$TK=Pe=d=He([P],Pe);var B;(function(K){K[K.Invoke=1]="Invoke",K[K.Automatic=2]="Automatic"})(B||(e.CodeActionTriggerKind=B={}));let Z=class{constructor(V,ve){this.title=V,this.kind=ve}};e.$UK=Z,e.$UK=Z=He([P],Z);let re=class{static{c=this}static{this.c="."}constructor(V){this.value=V}append(V){return new c(this.value?this.value+c.c+V:V)}intersects(V){return this.contains(V)||V.contains(this)}contains(V){return this.value===V.value||V.value.startsWith(this.value+c.c)}};e.$VK=re,e.$VK=re=c=He([P],re),re.Empty=new re(""),re.QuickFix=re.Empty.append("quickfix"),re.Refactor=re.Empty.append("refactor"),re.RefactorExtract=re.Refactor.append("extract"),re.RefactorInline=re.Refactor.append("inline"),re.RefactorMove=re.Refactor.append("move"),re.RefactorRewrite=re.Refactor.append("rewrite"),re.Source=re.Empty.append("source"),re.SourceOrganizeImports=re.Source.append("organizeImports"),re.SourceFixAll=re.Source.append("fixAll"),re.Notebook=re.Empty.append("notebook");let ae=class{constructor(V,ve){if(this.range=V,this.parent=ve,ve&&!ve.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$WK=ae,e.$WK=ae=He([P],ae);class ee{constructor(V,ve,Re,Ze,it,ct){this.kind=V,this.name=ve,this.detail=Re,this.uri=Ze,this.range=it,this.selectionRange=ct}}e.$XK=ee;class ge{constructor(V,ve){this.fromRanges=ve,this.from=V}}e.$YK=ge;class ye{constructor(V,ve){this.fromRanges=ve,this.to=V}}e.$ZK=ye;var ze;(function(K){K[K.Information=0]="Information",K[K.Warning=1]="Warning",K[K.Error=2]="Error"})(ze||(e.LanguageStatusSeverity=ze={}));let We=class{constructor(V,ve){this.range=V,this.command=ve}get isResolved(){return!!this.command}};e.$1K=We,e.$1K=We=He([P],We);let et=u=class{#e;static isMarkdownString(V){return V instanceof u?!0:V&&V.appendCodeblock&&V.appendMarkdown&&V.appendText&&V.value!==void 0}constructor(V,ve=!1){this.#e=new f.$9j(V,{supportThemeIcons:ve})}get value(){return this.#e.value}set value(V){this.#e.value=V}get isTrusted(){return this.#e.isTrusted}set isTrusted(V){this.#e.isTrusted=V}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(V){this.#e.supportThemeIcons=V}get supportHtml(){return this.#e.supportHtml}set supportHtml(V){this.#e.supportHtml=V}get baseUri(){return this.#e.baseUri}set baseUri(V){this.#e.baseUri=V}appendText(V){return this.#e.appendText(V),this}appendMarkdown(V){return this.#e.appendMarkdown(V),this}appendCodeblock(V,ve){return this.#e.appendCodeblock(ve??"",V),this}};e.$2K=et,e.$2K=et=u=He([P],et);let Ye=class{constructor(V,ve){this.label=V,this.documentation=ve}};e.$3K=Ye,e.$3K=Ye=He([P],Ye);let rt=class{constructor(V,ve){this.label=V,this.documentation=ve,this.parameters=[]}};e.$4K=rt,e.$4K=rt=He([P],rt);let nt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$5K=nt,e.$5K=nt=He([P],nt);var Ae;(function(K){K[K.Invoke=1]="Invoke",K[K.TriggerCharacter=2]="TriggerCharacter",K[K.ContentChange=3]="ContentChange"})(Ae||(e.SignatureHelpTriggerKind=Ae={}));var Ne;(function(K){K[K.Type=1]="Type",K[K.Parameter=2]="Parameter"})(Ne||(e.InlayHintKind=Ne={}));let Ve=class{constructor(V){this.value=V}};e.$6K=Ve,e.$6K=Ve=He([P],Ve);let Le=class{constructor(V,ve,Re){this.position=V,this.label=ve,this.kind=Re}};e.$7K=Le,e.$7K=Le=He([P],Le);var Xe;(function(K){K[K.Invoke=0]="Invoke",K[K.TriggerCharacter=1]="TriggerCharacter",K[K.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Xe||(e.CompletionTriggerKind=Xe={}));var le;(function(K){K[K.Text=0]="Text",K[K.Method=1]="Method",K[K.Function=2]="Function",K[K.Constructor=3]="Constructor",K[K.Field=4]="Field",K[K.Variable=5]="Variable",K[K.Class=6]="Class",K[K.Interface=7]="Interface",K[K.Module=8]="Module",K[K.Property=9]="Property",K[K.Unit=10]="Unit",K[K.Value=11]="Value",K[K.Enum=12]="Enum",K[K.Keyword=13]="Keyword",K[K.Snippet=14]="Snippet",K[K.Color=15]="Color",K[K.File=16]="File",K[K.Reference=17]="Reference",K[K.Folder=18]="Folder",K[K.EnumMember=19]="EnumMember",K[K.Constant=20]="Constant",K[K.Struct=21]="Struct",K[K.Event=22]="Event",K[K.Operator=23]="Operator",K[K.TypeParameter=24]="TypeParameter",K[K.User=25]="User",K[K.Issue=26]="Issue"})(le||(e.CompletionItemKind=le={}));var ue;(function(K){K[K.Deprecated=1]="Deprecated"})(ue||(e.CompletionItemTag=ue={}));let Ie=class{constructor(V,ve){this.label=V,this.kind=ve}toJSON(){return{label:this.label,kind:this.kind&&le[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$8K=Ie,e.$8K=Ie=He([P],Ie);let Ke=class{constructor(V=[],ve=!1){this.items=V,this.isIncomplete=ve}};e.$9K=Ke,e.$9K=Ke=He([P],Ke);let Ge=class{constructor(V,ve,Re){this.insertText=V,this.range=ve,this.command=Re}};e.$0K=Ge,e.$0K=Ge=He([P],Ge);let _e=class{constructor(V){this.commands=void 0,this.suppressSuggestions=void 0,this.items=V}};e.$$K=_e,e.$$K=_e=He([P],_e);var st;(function(K){K[K.Active=-1]="Active",K[K.Beside=-2]="Beside",K[K.One=1]="One",K[K.Two=2]="Two",K[K.Three=3]="Three",K[K.Four=4]="Four",K[K.Five=5]="Five",K[K.Six=6]="Six",K[K.Seven=7]="Seven",K[K.Eight=8]="Eight",K[K.Nine=9]="Nine"})(st||(e.ViewColumn=st={}));var lt;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(lt||(e.StatusBarAlignment=lt={}));function wt(K,V){return`${I.$_l.toKey(K)}.${V}`}e.$_K=wt;var Ue;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative"})(Ue||(e.TextEditorLineNumbersStyle=Ue={}));var Kt;(function(K){K[K.Manual=1]="Manual",K[K.AfterDelay=2]="AfterDelay",K[K.FocusOut=3]="FocusOut"})(Kt||(e.TextDocumentSaveReason=Kt={}));var Ht;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(Ht||(e.TextEditorRevealType=Ht={}));var Et;(function(K){K[K.Keyboard=1]="Keyboard",K[K.Mouse=2]="Mouse",K[K.Command=3]="Command"})(Et||(e.TextEditorSelectionChangeKind=Et={}));var Ut;(function(K){K[K.Undo=1]="Undo",K[K.Redo=2]="Redo"})(Ut||(e.TextDocumentChangeReason=Ut={}));var Ot;(function(K){K[K.OpenOpen=0]="OpenOpen",K[K.ClosedClosed=1]="ClosedClosed",K[K.OpenClosed=2]="OpenClosed",K[K.ClosedOpen=3]="ClosedOpen"})(Ot||(e.DecorationRangeBehavior=Ot={})),function(K){function V(ve){switch(ve){case"keyboard":return K.Keyboard;case"mouse":return K.Mouse;case"api":return K.Command}}K.fromValue=V}(Et||(e.TextEditorSelectionChangeKind=Et={}));var Gt;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(Gt||(e.SyntaxTokenType=Gt={})),function(K){function V(ve){switch(ve){case K.Other:return"other";case K.Comment:return"comment";case K.String:return"string";case K.RegEx:return"regex"}return"other"}K.toString=V}(Gt||(e.SyntaxTokenType=Gt={}));let Bt=class{constructor(V,ve){if(ve&&!g.URI.isUri(ve))throw(0,T.$6)("target");if(!F.isRange(V)||V.isEmpty)throw(0,T.$6)("range");this.range=V,this.target=ve}};e.$aL=Bt,e.$aL=Bt=He([P],Bt);let Dt=class{constructor(V,ve,Re,Ze){this.red=V,this.green=ve,this.blue=Re,this.alpha=Ze}};e.$bL=Dt,e.$bL=Dt=He([P],Dt);let Mt=class{constructor(V,ve){if(ve&&!(ve instanceof Dt))throw(0,T.$6)("color");if(!F.isRange(V)||V.isEmpty)throw(0,T.$6)("range");this.range=V,this.color=ve}};e.$cL=Mt,e.$cL=Mt=He([P],Mt);let Wt=class{constructor(V){if(!V||typeof V!="string")throw(0,T.$6)("label");this.label=V}};e.$dL=Wt,e.$dL=Wt=He([P],Wt);var tt;(function(K){K[K.RGB=0]="RGB",K[K.HEX=1]="HEX",K[K.HSL=2]="HSL"})(tt||(e.ColorFormat=tt={}));var Vt;(function(K){K[K.Error=0]="Error",K[K.Warning=1]="Warning",K[K.Information=2]="Information"})(Vt||(e.SourceControlInputBoxValidationType=Vt={}));var qt;(function(K){K[K.Unknown=0]="Unknown",K[K.Shutdown=1]="Shutdown",K[K.Process=2]="Process",K[K.User=3]="User",K[K.Extension=4]="Extension"})(qt||(e.TerminalExitReason=qt={}));class ut{constructor(V,ve,Re){if(this.startIndex=V,this.length=ve,this.tooltip=Re,typeof V!="number"||V<0)throw(0,T.$6)("startIndex");if(typeof ve!="number"||ve<1)throw(0,T.$6)("length");if(Re!==void 0&&typeof Re!="string")throw(0,T.$6)("tooltip")}}e.$eL=ut;class mt{constructor(V){this.uri=V}}e.$fL=mt;class Nt{constructor(V){this.terminalCommand=V}}e.$gL=Nt;var Pt;(function(K){K[K.Panel=1]="Panel",K[K.Editor=2]="Editor"})(Pt||(e.TerminalLocation=Pt={}));class At{constructor(V){if(this.options=V,typeof V!="object")throw(0,T.$6)("options")}}e.$hL=At;var gt;(function(K){K[K.Always=1]="Always",K[K.Silent=2]="Silent",K[K.Never=3]="Never"})(gt||(e.TaskRevealKind=gt={}));var St;(function(K){K[K.Shared=1]="Shared",K[K.Dedicated=2]="Dedicated",K[K.New=3]="New"})(St||(e.TaskPanelKind=St={}));let Rt=class{static{h=this}static{this.Clean=new h("clean","Clean")}static{this.Build=new h("build","Build")}static{this.Rebuild=new h("rebuild","Rebuild")}static{this.Test=new h("test","Test")}static from(V){switch(V){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}constructor(V,ve){if(this.label=ve,typeof V!="string"||typeof ve!="string")throw(0,T.$6)("name");this.c=V}get id(){return this.c}};e.$iL=Rt,e.$iL=Rt=h=He([P],Rt);function It(K){let V="";for(let ve=0;ve<K.length;ve++)V+=K[ve].replace(/,/g,",,")+",";return V}let Je=class{constructor(V,ve,Re){if(typeof V!="string")throw(0,T.$6)("process");this.e=[],this.c=V,ve!==void 0&&(Array.isArray(ve)?(this.e=ve,this.f=Re):this.f=ve)}get process(){return this.c}set process(V){if(typeof V!="string")throw(0,T.$6)("process");this.c=V}get args(){return this.e}set args(V){Array.isArray(V)||(V=[]),this.e=V}get options(){return this.f}set options(V){this.f=V}computeId(){const V=[];if(V.push("process"),this.c!==void 0&&V.push(this.c),this.e&&this.e.length>0)for(const ve of this.e)V.push(ve);return It(V)}};e.$jL=Je,e.$jL=Je=He([P],Je);let zt=class{constructor(V,ve,Re){if(this.f=[],Array.isArray(ve)){if(!V)throw(0,T.$6)("command can't be undefined or null");if(typeof V!="string"&&typeof V.value!="string")throw(0,T.$6)("command");this.e=V,this.f=ve,this.g=Re}else{if(typeof V!="string")throw(0,T.$6)("commandLine");this.c=V,this.g=ve}}get commandLine(){return this.c}set commandLine(V){if(typeof V!="string")throw(0,T.$6)("commandLine");this.c=V}get command(){return this.e?this.e:""}set command(V){if(typeof V!="string"&&typeof V.value!="string")throw(0,T.$6)("command");this.e=V}get args(){return this.f}set args(V){this.f=V||[]}get options(){return this.g}set options(V){this.g=V}computeId(){const V=[];if(V.push("shell"),this.c!==void 0&&V.push(this.c),this.e!==void 0&&V.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ve of this.f)V.push(typeof ve=="string"?ve:ve.value);return It(V)}};e.$kL=zt,e.$kL=zt=He([P],zt);var Jt;(function(K){K[K.Escape=1]="Escape",K[K.Strong=2]="Strong",K[K.Weak=3]="Weak"})(Jt||(e.ShellQuoting=Jt={}));var Me;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace"})(Me||(e.TaskScope=Me={}));class Fe{constructor(V){this.c=V}computeId(){return"customExecution"+(0,A.$ig)()}set callback(V){this.c=V}get callback(){return this.c}}e.$lL=Fe;let Ce=class{static{E=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(V,ve,Re,Ze,it,ct){this.j=!1,this.k=this.definition=V;let ft;typeof ve=="string"?(this.m=this.name=ve,this.t=this.source=Re,this.execution=Ze,ft=it,this.j=!0):ve===Me.Global||ve===Me.Workspace?(this.target=ve,this.m=this.name=Re,this.t=this.source=Ze,this.execution=it,ft=ct):(this.target=ve,this.m=this.name=Re,this.t=this.source=Ze,this.execution=it,ft=ct),typeof ft=="string"?(this.o=[ft],this.q=!0):Array.isArray(ft)?(this.o=ft,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(V){this.h=V}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Je?this.k={type:E.e,id:this.n.computeId()}:this.n instanceof zt?this.k={type:E.f,id:this.n.computeId()}:this.n instanceof Fe?this.k={type:E.c,id:this.n.computeId()}:this.k={type:E.g,id:(0,A.$ig)()}}get definition(){return this.k}set definition(V){if(V==null)throw(0,T.$6)("Kind can't be undefined or null");this.z(),this.k=V}get scope(){return this.l}set target(V){this.z(),this.l=V}get name(){return this.m}set name(V){if(typeof V!="string")throw(0,T.$6)("name");this.z(),this.m=V}get execution(){return this.n}set execution(V){V===null&&(V=void 0),this.z(),this.n=V;const ve=this.k.type;(E.g===ve||E.e===ve||E.f===ve||E.c===ve)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(V){if(Array.isArray(V))this.z(),this.o=V,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(V){V!==!0&&V!==!1&&(V=!1),this.z(),this.r=V}get source(){return this.t}set source(V){if(typeof V!="string"||V.length===0)throw(0,T.$6)("source must be a string of length > 0");this.z(),this.t=V}get group(){return this.u}set group(V){V===null&&(V=void 0),this.z(),this.u=V}get detail(){return this.y}set detail(V){V===null&&(V=void 0),this.y=V}get presentationOptions(){return this.w}set presentationOptions(V){V==null&&(V=Object.create(null)),this.z(),this.w=V}get runOptions(){return this.x}set runOptions(V){V==null&&(V=Object.create(null)),this.z(),this.x=V}};e.$mL=Ce,e.$mL=Ce=E=He([P],Ce);var se;(function(K){K[K.SourceControl=1]="SourceControl",K[K.Window=10]="Window",K[K.Notification=15]="Notification"})(se||(e.ProgressLocation=se={}));var Te;(function(K){function V(ve){const Re=ve;return(0,y.$Gf)(Re.value)?Re.tooltip&&!(0,y.$Cf)(Re.tooltip)?(console.log("INVALID view badge, invalid tooltip",Re.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Re.value),!1)}K.isViewBadge=V})(Te||(e.ViewBadge=Te={}));let qe=D=class{static isTreeItem(V,ve){const Re=V;if(Re.checkboxState!==void 0){const Ze=(0,y.$Gf)(Re.checkboxState)?Re.checkboxState:(0,y.$Ef)(Re.checkboxState)&&(0,y.$Gf)(Re.checkboxState.state)?Re.checkboxState.state:void 0,it=!(0,y.$Gf)(Re.checkboxState)&&(0,y.$Ef)(Re.checkboxState)?Re.checkboxState.tooltip:void 0;if(Ze===void 0||Ze!==Qe.Checked&&Ze!==Qe.Unchecked||it!==void 0&&!(0,y.$Cf)(it))return console.log("INVALID tree item, invalid checkboxState",Re.checkboxState),!1}if(V instanceof D)return!0;if(Re.label!==void 0&&!(0,y.$Cf)(Re.label)&&!Re.label?.label)return console.log("INVALID tree item, invalid label",Re.label),!1;if(Re.id!==void 0&&!(0,y.$Cf)(Re.id))return console.log("INVALID tree item, invalid id",Re.id),!1;if(Re.iconPath!==void 0&&!(0,y.$Cf)(Re.iconPath)&&!g.URI.isUri(Re.iconPath)&&(!Re.iconPath||!(0,y.$Cf)(Re.iconPath.id))){const Ze=Re.iconPath;if(!Ze||!(0,y.$Cf)(Ze.light)&&!g.URI.isUri(Ze.light)&&!(0,y.$Cf)(Ze.dark)&&!g.URI.isUri(Ze.dark))return console.log("INVALID tree item, invalid iconPath",Re.iconPath),!1}return Re.description!==void 0&&!(0,y.$Cf)(Re.description)&&typeof Re.description!="boolean"?(console.log("INVALID tree item, invalid description",Re.description),!1):Re.resourceUri!==void 0&&!g.URI.isUri(Re.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Re.resourceUri),!1):Re.tooltip!==void 0&&!(0,y.$Cf)(Re.tooltip)&&!(Re.tooltip instanceof et)?(console.log("INVALID tree item, invalid tooltip",Re.tooltip),!1):Re.command!==void 0&&!Re.command.command?(console.log("INVALID tree item, invalid command",Re.command),!1):Re.collapsibleState!==void 0&&Re.collapsibleState<xe.None&&Re.collapsibleState>xe.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Re.collapsibleState),!1):Re.contextValue!==void 0&&!(0,y.$Cf)(Re.contextValue)?(console.log("INVALID tree item, invalid contextValue",Re.contextValue),!1):Re.accessibilityInformation!==void 0&&!Re.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Re.accessibilityInformation),!1):!0}constructor(V,ve=xe.None){this.collapsibleState=ve,g.URI.isUri(V)?this.resourceUri=V:this.label=V}};e.$nL=qe,e.$nL=qe=D=He([P],qe);var xe;(function(K){K[K.None=0]="None",K[K.Collapsed=1]="Collapsed",K[K.Expanded=2]="Expanded"})(xe||(e.TreeItemCollapsibleState=xe={}));var Qe;(function(K){K[K.Unchecked=0]="Unchecked",K[K.Checked=1]="Checked"})(Qe||(e.TreeItemCheckboxState=Qe={}));let ot=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(V){this.value=V}};e.$oL=ot,e.$oL=ot=He([P],ot);class pt extends ot{}e.$pL=pt;class bt extends pt{#e;constructor(V){super(""),this.#e=V}asFile(){return this.#e}}e.$qL=bt;class vt{constructor(V,ve,Re,Ze){this.name=V,this.uri=ve,this._itemId=Re,this.c=Ze}data(){return this.c()}}e.$rL=vt;let ht=class{#e=new Map;constructor(V){for(const[ve,Re]of V??[]){const Ze=this.#e.get(this.#t(ve));Ze?Ze.push(Re):this.#e.set(this.#t(ve),[Re])}}get(V){return this.#e.get(this.#t(V))?.[0]}set(V,ve){this.#e.set(this.#t(V),[ve])}forEach(V,ve){for(const[Re,Ze]of this.#e)for(const it of Ze)V.call(ve,it,Re,this)}*[Symbol.iterator](){for(const[V,ve]of this.#e)for(const Re of ve)yield[V,Re]}#t(V){return V.toLowerCase()}};e.$sL=ht,e.$sL=ht=He([P],ht);let Lt=class{constructor(V){this.insertText=V}};e.$tL=Lt,e.$tL=Lt=He([P],Lt);let Qt=class{constructor(V,ve){this.label=ve,this.insertText=V}};e.$uL=Qt,e.$uL=Qt=He([P],Qt);let Xt=class{constructor(V,ve){this.id=V,this.color=ve}static isThemeIcon(V){return typeof V.id!="string"?(console.log("INVALID ThemeIcon, invalid id",V.id),!1):!0}};e.$vL=Xt,e.$vL=Xt=He([P],Xt),Xt.File=new Xt("file"),Xt.Folder=new Xt("folder");let si=class{constructor(V){this.id=V}};e.$wL=si,e.$wL=si=He([P],si);var Si;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace",K[K.WorkspaceFolder=3]="WorkspaceFolder"})(Si||(e.ConfigurationTarget=Si={}));let Ct=class{get base(){return this.c}set base(V){this.c=V,this.e=g.URI.file(V)}get baseUri(){return this.e}set baseUri(V){this.e=V,this.c=V.fsPath}constructor(V,ve){if(typeof V!="string"&&(!V||!g.URI.isUri(V)&&!g.URI.isUri(V.uri)))throw(0,T.$6)("base");if(typeof ve!="string")throw(0,T.$6)("pattern");typeof V=="string"?this.baseUri=g.URI.file(V):g.URI.isUri(V)?this.baseUri=V:this.baseUri=V.uri,this.pattern=ve}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$xL=Ct,e.$xL=Ct=He([P],Ct);const Yi=new WeakMap;function ln(K,V){Yi.set(K,V)}e.$yL=ln;let kt=class{constructor(V,ve,Re,Ze){this.enabled=typeof V=="boolean"?V:!0,typeof ve=="string"&&(this.condition=ve),typeof Re=="string"&&(this.hitCondition=Re),typeof Ze=="string"&&(this.logMessage=Ze)}get id(){return this.c||(this.c=Yi.get(this)??(0,A.$ig)()),this.c}};e.$zL=kt,e.$zL=kt=He([P],kt);let mi=class extends kt{constructor(V,ve,Re,Ze,it){if(super(ve,Re,Ze,it),V===null)throw(0,T.$6)("location");this.location=V}};e.$AL=mi,e.$AL=mi=He([P],mi);let $i=class extends kt{constructor(V,ve,Re,Ze,it){super(ve,Re,Ze,it),this.functionName=V}};e.$BL=$i,e.$BL=$i=He([P],$i);let oi=class extends kt{constructor(V,ve,Re,Ze,it,ct,ft){if(super(Ze,it,ct,ft),!ve)throw(0,T.$6)("dataId");this.label=V,this.dataId=ve,this.canPersist=Re}};e.$CL=oi,e.$CL=oi=He([P],oi);let Di=class{constructor(V,ve,Re){this.command=V,this.args=ve||[],this.options=Re}};e.$DL=Di,e.$DL=Di=He([P],Di);let Ci=class{constructor(V,ve){this.port=V,this.host=ve}};e.$EL=Ci,e.$EL=Ci=He([P],Ci);let Ft=class{constructor(V){this.path=V}};e.$FL=Ft,e.$FL=Ft=He([P],Ft);let bi=class{constructor(V){this.implementation=V}};e.$GL=bi,e.$GL=bi=He([P],bi);let Ii=class{constructor(V,ve,Re){this.session=V,this.threadId=ve,this.frameId=Re}};e.$HL=Ii,e.$HL=Ii=He([P],Ii);let ai=class{constructor(V,ve){this.session=V,this.threadId=ve}};e.$IL=ai,e.$IL=ai=He([P],ai);let ci=class{constructor(V,ve){this.range=V,this.expression=ve}};e.$JL=ci,e.$JL=ci=He([P],ci);var dt;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(dt||(e.InlineCompletionTriggerKind=dt={}));let Pi=class{constructor(V,ve){this.range=V,this.text=ve}};e.$KL=Pi,e.$KL=Pi=He([P],Pi);let xt=class{constructor(V,ve,Re=!0){this.range=V,this.variableName=ve,this.caseSensitiveLookup=Re}};e.$LL=xt,e.$LL=xt=He([P],xt);let ni=class{constructor(V,ve){this.range=V,this.expression=ve}};e.$ML=ni,e.$ML=ni=He([P],ni);let hi=class{constructor(V,ve){this.frameId=V,this.stoppedLocation=ve}};e.$NL=hi,e.$NL=hi=He([P],hi);var Xi;(function(K){K[K.Changed=1]="Changed",K[K.Created=2]="Created",K[K.Deleted=3]="Deleted"})(Xi||(e.FileChangeType=Xi={}));let Ai=m=class extends Error{static FileExists(V){return new m(V,$.FileSystemProviderErrorCode.FileExists,m.FileExists)}static FileNotFound(V){return new m(V,$.FileSystemProviderErrorCode.FileNotFound,m.FileNotFound)}static FileNotADirectory(V){return new m(V,$.FileSystemProviderErrorCode.FileNotADirectory,m.FileNotADirectory)}static FileIsADirectory(V){return new m(V,$.FileSystemProviderErrorCode.FileIsADirectory,m.FileIsADirectory)}static NoPermissions(V){return new m(V,$.FileSystemProviderErrorCode.NoPermissions,m.NoPermissions)}static Unavailable(V){return new m(V,$.FileSystemProviderErrorCode.Unavailable,m.Unavailable)}constructor(V,ve=$.FileSystemProviderErrorCode.Unknown,Re){super(g.URI.isUri(V)?V.toString(!0):V),this.code=Re?.name??"Unknown",(0,$.$tk)(this,ve),Object.setPrototypeOf(this,m.prototype),typeof Error.captureStackTrace=="function"&&typeof Re=="function"&&Error.captureStackTrace(this,Re)}};e.$OL=Ai,e.$OL=Ai=m=He([P],Ai);let Ri=class{constructor(V,ve,Re){this.start=V,this.end=ve,this.kind=Re}};e.$PL=Ri,e.$PL=Ri=He([P],Ri);var Li;(function(K){K[K.Comment=1]="Comment",K[K.Imports=2]="Imports",K[K.Region=3]="Region"})(Li||(e.FoldingRangeKind=Li={}));var xi;(function(K){K[K.Collapsed=0]="Collapsed",K[K.Expanded=1]="Expanded"})(xi||(e.CommentThreadCollapsibleState=xi={}));var Mi;(function(K){K[K.Editing=0]="Editing",K[K.Preview=1]="Preview"})(Mi||(e.CommentMode=Mi={}));var ui;(function(K){K[K.Published=0]="Published",K[K.Draft=1]="Draft"})(ui||(e.CommentState=ui={}));var _i;(function(K){K[K.Unresolved=0]="Unresolved",K[K.Resolved=1]="Resolved"})(_i||(e.CommentThreadState=_i={}));class Fi{constructor(V,ve=[]){this.tokenTypes=V,this.tokenModifiers=ve}}e.$QL=Fi;function Ti(K){return typeof K>"u"||(0,y.$Df)(K)}class Ni{constructor(V){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,V){this.l=!0;for(let ve=0,Re=V.tokenTypes.length;ve<Re;ve++)this.j.set(V.tokenTypes[ve],ve);for(let ve=0,Re=V.tokenModifiers.length;ve<Re;ve++)this.k.set(V.tokenModifiers[ve],ve)}}push(V,ve,Re,Ze,it){if(typeof V=="number"&&typeof ve=="number"&&typeof Re=="number"&&typeof Ze=="number"&&(typeof it=="number"||typeof it>"u"))return typeof it>"u"&&(it=0),this.n(V,ve,Re,Ze,it);if(F.isRange(V)&&typeof ve=="string"&&Ti(Re))return this.m(V,ve,Re);throw(0,T.$6)()}m(V,ve,Re){if(!this.l)throw new Error("Legend must be provided in constructor");if(V.start.line!==V.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ve))throw new Error("`tokenType` is not in the provided legend");const Ze=V.start.line,it=V.start.character,ct=V.end.character-V.start.character,ft=this.j.get(ve);let jt=0;if(Re)for(const Yt of Re){if(!this.k.has(Yt))throw new Error("`tokenModifier` is not in the provided legend");const ei=this.k.get(Yt);jt|=1<<ei>>>0}this.n(Ze,it,ct,ft,jt)}n(V,ve,Re,Ze,it){if(this.f&&(V<this.c||V===this.c&&ve<this.e)){this.f=!1;const jt=this.g.length/5|0;let Yt=0,ei=0;for(let ii=0;ii<jt;ii++){let ri=this.g[5*ii],Qi=this.g[5*ii+1];ri===0?(ri=Yt,Qi+=ei):ri+=Yt,this.g[5*ii]=ri,this.g[5*ii+1]=Qi,Yt=ri,ei=Qi}}let ct=V,ft=ve;this.f&&this.h>0&&(ct-=this.c,ct===0&&(ft-=this.e)),this.g[this.h++]=ct,this.g[this.h++]=ft,this.g[this.h++]=Re,this.g[this.h++]=Ze,this.g[this.h++]=it,this.c=V,this.e=ve}static o(V){const ve=[],Re=V.length/5|0;for(let ft=0;ft<Re;ft++)ve[ft]=ft;ve.sort((ft,jt)=>{const Yt=V[5*ft],ei=V[5*jt];if(Yt===ei){const ii=V[5*ft+1],ri=V[5*jt+1];return ii-ri}return Yt-ei});const Ze=new Uint32Array(V.length);let it=0,ct=0;for(let ft=0;ft<Re;ft++){const jt=5*ve[ft],Yt=V[jt+0],ei=V[jt+1],ii=V[jt+2],ri=V[jt+3],Qi=V[jt+4],Dn=Yt-it,Tn=Dn===0?ei-ct:ei,Zi=5*ft;Ze[Zi+0]=Dn,Ze[Zi+1]=Tn,Ze[Zi+2]=ii,Ze[Zi+3]=ri,Ze[Zi+4]=Qi,it=Yt,ct=ei}return Ze}build(V){return this.f?new Oi(new Uint32Array(this.g),V):new Oi(Ni.o(this.g),V)}}e.$RL=Ni;class Oi{constructor(V,ve){this.resultId=ve,this.data=V}}e.$SL=Oi;class di{constructor(V,ve,Re){this.start=V,this.deleteCount=ve,this.data=Re}}e.$TL=di;class hn{constructor(V,ve){this.resultId=ve,this.edits=V}}e.$UL=hn;var en;(function(K){K[K.Separate=0]="Separate",K[K.MergeWithParent=1]="MergeWithParent"})(en||(e.DebugConsoleMode=en={}));let zi=class{static{this.Back={iconPath:new Xt("arrow-left")}}constructor(){}};e.$VL=zi,e.$VL=zi=He([P],zi);var pi;(function(K){K[K.Separator=-1]="Separator",K[K.Default=0]="Default"})(pi||(e.QuickPickItemKind=pi={}));var tn;(function(K){K[K.Info=1]="Info",K[K.Warning=2]="Warning",K[K.Error=3]="Error"})(tn||(e.InputBoxValidationSeverity=tn={}));var nn;(function(K){K[K.UI=1]="UI",K[K.Workspace=2]="Workspace"})(nn||(e.ExtensionKind=nn={}));class wi{static validate(V){if(typeof V.badge=="string"){let ve=(0,b.$df)(V.badge,0);if(ve<V.badge.length&&(ve+=(0,b.$df)(V.badge,ve)),V.badge.length>ve)throw new Error("The 'badge'-property must be undefined or a short character")}else if(V.badge&&!Xt.isThemeIcon(V.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!V.color&&!V.badge&&!V.tooltip)throw new Error("The decoration is empty");return!0}constructor(V,ve,Re){this.badge=V,this.tooltip=ve,this.color=Re}}e.$WL=wi;let vi=class{constructor(V){this.kind=V}};e.$XL=vi,e.$XL=vi=He([P],vi);var rn;(function(K){K[K.Light=1]="Light",K[K.Dark=2]="Dark",K[K.HighContrast=3]="HighContrast",K[K.HighContrastLight=4]="HighContrastLight"})(rn||(e.ColorThemeKind=rn={}));class _t{static isNotebookRange(V){return V instanceof _t?!0:V?typeof V.start=="number"&&typeof V.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(V,ve){if(V<0)throw(0,T.$6)("start must be positive");if(ve<0)throw(0,T.$6)("end must be positive");V<=ve?(this.c=V,this.e=ve):(this.c=ve,this.e=V)}with(V){let ve=this.c,Re=this.e;return V.start!==void 0&&(ve=V.start),V.end!==void 0&&(Re=V.end),ve===this.c&&Re===this.e?this:new _t(ve,Re)}}e.$YL=_t;class fi{static validate(V){if(typeof V.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof V.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof V.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(V){return Array.isArray(V)&&V.every(ve=>fi.isNotebookCellData(ve))}static isNotebookCellData(V){return!0}constructor(V,ve,Re,Ze,it,ct,ft){this.kind=V,this.value=ve,this.languageId=Re,this.mime=Ze,this.outputs=it??[],this.metadata=ct,this.executionSummary=ft,fi.validate(this)}}e.$ZL=fi;class dn{constructor(V){this.cells=V}}e.$1L=dn;class Zt{static isNotebookCellOutputItem(V){return V instanceof Zt?!0:V?typeof V.mime=="string"&&V.data instanceof Uint8Array:!1}static error(V){const ve={name:V.name,message:V.message,stack:V.stack};return Zt.json(ve,"application/vnd.code.notebook.error")}static stdout(V){return Zt.text(V,"application/vnd.code.notebook.stdout")}static stderr(V){return Zt.text(V,"application/vnd.code.notebook.stderr")}static bytes(V,ve="application/octet-stream"){return new Zt(V,ve)}static#e=new TextEncoder;static text(V,ve=L.$Vr.text){const Re=Zt.#e.encode(String(V));return new Zt(Re,ve)}static json(V,ve="text/x-json"){const Re=JSON.stringify(V,void 0,"	");return Zt.text(Re,ve)}constructor(V,ve){this.data=V,this.mime=ve;const Re=(0,L.$Zr)(ve,!0);if(!Re)throw new Error(`INVALID mime type: ${ve}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Re}}e.$2L=Zt;class yi{static isNotebookCellOutput(V){return V instanceof yi?!0:!V||typeof V!="object"?!1:typeof V.id=="string"&&Array.isArray(V.items)}static ensureUniqueMimeTypes(V,ve=!1){const Re=new Set,Ze=new Set;for(let it=0;it<V.length;it++){const ct=V[it],ft=(0,L.$Zr)(ct.mime);if(!Re.has(ft)||(0,S.$DI)(ft)){Re.add(ft);continue}Ze.add(it),ve&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Ze.size===0?V:V.filter((it,ct)=>!Ze.has(ct))}constructor(V,ve,Re){this.items=yi.ensureUniqueMimeTypes(V,!0),typeof ve=="string"?(this.id=ve,this.metadata=Re):(this.id=(0,A.$ig)(),this.metadata=ve??Re)}}e.$3L=yi;var sn;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(sn||(e.NotebookCellKind=sn={}));var Ei;(function(K){K[K.Idle=1]="Idle",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(Ei||(e.NotebookCellExecutionState=Ei={}));var ji;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(ji||(e.NotebookCellStatusBarAlignment=ji={}));var je;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(je||(e.NotebookEditorRevealType=je={}));class ti{constructor(V,ve){this.text=V,this.alignment=ve}}e.$4L=ti;var Ui;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred"})(Ui||(e.NotebookControllerAffinity=Ui={}));var $t;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred",K[K.Hidden=-1]="Hidden"})($t||(e.NotebookControllerAffinity2=$t={}));class fn{constructor(V,ve=[]){this.uri=V,this.provides=(0,C.$2b)(ve)}}e.$5L=fn;class gn{constructor(V){this.label=V}}e.$6L=gn;let ki=class{constructor(V,ve){this.label=V,this.timestamp=ve}};e.$7L=ki,e.$7L=ki=He([P],ki);var on;(function(K){K[K.Production=1]="Production",K[K.Development=2]="Development",K[K.Test=3]="Test"})(on||(e.ExtensionMode=on={}));var gi;(function(K){K[K.Node=1]="Node",K[K.Webworker=2]="Webworker"})(gi||(e.ExtensionRuntime=gi={}));var an;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(an||(e.StandardTokenType=an={}));class mn{constructor(V,ve){this.ranges=V,this.wordPattern=ve}}e.$8L=mn;class $n{constructor(V){this.c=V}get autoForwardAction(){return this.c}}e.$9L=$n;var Bi;(function(K){K[K.Queued=1]="Queued",K[K.Running=2]="Running",K[K.Passed=3]="Passed",K[K.Failed=4]="Failed",K[K.Skipped=5]="Skipped",K[K.Errored=6]="Errored"})(Bi||(e.TestResultState=Bi={}));var cn;(function(K){K[K.Run=1]="Run",K[K.Debug=2]="Debug",K[K.Coverage=3]="Coverage"})(cn||(e.TestRunProfileKind=cn={}));let Wi=class{constructor(V=void 0,ve=void 0,Re=void 0,Ze=!1){this.include=V,this.exclude=ve,this.profile=Re,this.continuous=Ze}};e.$0L=Wi,e.$0L=Wi=He([P],Wi);let Vi=p=class{static diff(V,ve,Re){const Ze=new p(V);return Ze.expectedOutput=ve,Ze.actualOutput=Re,Ze}constructor(V){this.message=V}};e.$$L=Vi,e.$$L=Vi=p=He([P],Vi);let qi=class{constructor(V){this.id=V}};e.$_L=qi,e.$_L=qi=He([P],qi);let li=class{constructor(V,ve){this.covered=V,this.total=ve}};e.$aM=li,e.$aM=li=He([P],li);let Ki=k=class{static fromDetails(V,ve){const Re=new li(0,0),Ze=new li(0,0),it=new li(0,0);for(const ft of ve)if("branches"in ft){Re.total+=1,Re.covered+=ft.executionCount>0?1:0;for(const jt of ft.branches)Ze.total+=1,Ze.covered+=jt.executionCount>0?1:0}else it.total+=1,it.covered+=ft.executionCount>0?1:0;const ct=new k(V,Re,Ze.total>0?Ze:void 0,it.total>0?it:void 0);return ct.detailedCoverage=ve,ct}constructor(V,ve,Re,Ze){this.uri=V,this.statementCoverage=ve,this.branchCoverage=Re,this.functionCoverage=Ze}};e.$bM=Ki,e.$bM=Ki=k=He([P],Ki);let Hi=class{constructor(V,ve,Re=[]){this.executionCount=V,this.location=ve,this.branches=Re}};e.$cM=Hi,e.$cM=Hi=He([P],Hi);let Gi=class{constructor(V,ve){this.executionCount=V,this.location=ve}};e.$dM=Gi,e.$dM=Gi=He([P],Gi);let Ji=class{constructor(V,ve){this.executionCount=V,this.location=ve}};e.$eM=Ji,e.$eM=Ji=He([P],Ji);var un;(function(K){K[K.None=0]="None",K[K.Option=1]="Option",K[K.Default=2]="Default",K[K.Preferred=3]="Preferred"})(un||(e.ExternalUriOpenerPriority=un={}));var we;(function(K){K[K.Untrusted=0]="Untrusted",K[K.Trusted=1]="Trusted",K[K.Unspecified=2]="Unspecified"})(we||(e.WorkspaceTrustState=we={}));var De;(function(K){K[K.Notify=1]="Notify",K[K.OpenBrowser=2]="OpenBrowser",K[K.OpenPreview=3]="OpenPreview",K[K.Silent=4]="Silent",K[K.Ignore=5]="Ignore",K[K.OpenBrowserOnce=6]="OpenBrowserOnce"})(De||(e.PortAutoForwardAction=De={}));class Oe{constructor(V,ve,Re,Ze,it,ct){this.kind=V,this.name=ve,this.detail=Re,this.uri=Ze,this.range=it,this.selectionRange=ct}}e.$fM=Oe;class at{constructor(V){this.uri=V}}e.$gM=at;class yt{constructor(V,ve){this.original=V,this.modified=ve}}e.$hM=yt;class Tt{constructor(V,ve,Re,Ze){this.base=V,this.input1=ve,this.input2=Re,this.result=Ze}}e.$iM=Tt;class Cn{constructor(V,ve){this.uri=V,this.viewType=ve}}e.$jM=Cn;class In{constructor(V){this.viewType=V}}e.$kM=In;class Pn{constructor(V,ve){this.uri=V,this.notebookType=ve}}e.$lM=Pn;class An{constructor(V,ve,Re){this.original=V,this.modified=ve,this.notebookType=Re}}e.$mM=An;class Rn{constructor(){}}e.$nM=Rn;class Ln{constructor(V,ve){this.uri=V,this.inputBoxUri=ve}}e.$oM=Ln;class Mn{constructor(V){this.providerId=V}}e.$pM=Mn;var bn;(function(K){K[K.Down=0]="Down",K[K.Up=1]="Up"})(bn||(e.InteractiveSessionVoteDirection=bn={}));var pn;(function(K){K[K.Action=1]="Action",K[K.Toolbar=2]="Toolbar"})(pn||(e.InteractiveSessionCopyKind=pn={}));var wn;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful",K[K.Undone=2]="Undone",K[K.Accepted=3]="Accepted",K[K.Bug=4]="Bug"})(wn||(e.InteractiveEditorResponseFeedbackKind=wn={}));var vn;(function(K){K[K.System=0]="System",K[K.User=1]="User",K[K.Assistant=2]="Assistant",K[K.Function=3]="Function"})(vn||(e.ChatMessageRole=vn={}));var yn;(function(K){K[K.Short=1]="Short",K[K.Medium=2]="Medium",K[K.Full=3]="Full"})(yn||(e.ChatVariableLevel=yn={}));class Fn{constructor(V,ve){this.role=V,this.content=ve}}e.$qM=Fn;var En;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful"})(En||(e.ChatAgentResultFeedbackKind=En={}));var kn;(function(K){K[K.SymbolInformation=1]="SymbolInformation",K[K.CommandInformation=2]="CommandInformation",K[K.SearchInformation=3]="SearchInformation",K[K.SettingInformation=4]="SettingInformation"})(kn||(e.RelatedInformationType=kn={}));var Sn;(function(K){K[K.Started=1]="Started",K[K.Recognizing=2]="Recognizing",K[K.Recognized=3]="Recognized",K[K.Stopped=4]="Stopped"})(Sn||(e.SpeechToTextStatus=Sn={}))}),define(ke[143],Se([1,0,60,17,13,176,127,7,19]),function(me,e,C,T,f,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FM=e.$EM=e.$DM=void 0;const g=new Map;function A(S,w){w?g.set(S,w):g.delete(S)}e.$DM=A;function I(S){return g.get(S)}class $ extends R.$2u{constructor(w,l,o,i,n,r,a,t){super(l,o,i,n),this.c=w,this.m=r,this.q=a,this.notebook=t,this.b=!1}dispose(){(0,C.ok)(!this.b),this.b=!0,this.q=!1}equalLines(w){return(0,y.$tb)(this.f,w)}get document(){if(!this.a){const w=this;this.a={get uri(){return w.d},get fileName(){return w.d.fsPath},get isUntitled(){return w.d.scheme===T.Schemas.untitled},get languageId(){return w.m},get version(){return w.h},get isClosed(){return w.b},get isDirty(){return w.q},save(){return w.r()},getText(l){return l?w.s(l):w.getText()},get eol(){return w.g===`
`?b.EndOfLine.LF:b.EndOfLine.CRLF},get lineCount(){return w.f.length},lineAt(l){return w.t(l)},offsetAt(l){return w.u(l)},positionAt(l){return w.v(l)},validateRange(l){return w.w(l)},validatePosition(l){return w.x(l)},getWordRangeAtPosition(l,o){return w.y(l,o)}}}return Object.freeze(this.a)}_acceptLanguageId(w){(0,C.ok)(!this.b),this.m=w}_acceptIsDirty(w){(0,C.ok)(!this.b),this.q=w}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(w){const l=this.w(w);if(l.isEmpty)return"";if(l.isSingleLine)return this.f[l.start.line].substring(l.start.character,l.end.character);const o=this.g,i=l.start.line,n=l.end.line,r=[];r.push(this.f[i].substring(l.start.character));for(let a=i+1;a<n;a++)r.push(this.f[a]);return r.push(this.f[n].substring(0,l.end.character)),r.join(o)}t(w){let l;if(w instanceof b.$CK?l=w.line:typeof w=="number"&&(l=w),typeof l!="number"||l<0||l>=this.f.length||Math.floor(l)!==l)throw new Error("Illegal value for `line`");return new v(l,this.f[l],l===this.f.length-1)}u(w){return w=this.x(w),this.l(),this.j.getPrefixSum(w.line-1)+w.character}v(w){w=Math.floor(w),w=Math.max(0,w),this.l();const l=this.j.getIndexOf(w),o=this.f[l.index].length;return new b.$CK(l.index,Math.min(l.remainder,o))}w(w){if(!(w instanceof b.$DK))throw new Error("Invalid argument");const l=this.x(w.start),o=this.x(w.end);return l===w.start&&o===w.end?w:new b.$DK(l.line,l.character,o.line,o.character)}x(w){if(!(w instanceof b.$CK))throw new Error("Invalid argument");if(this.f.length===0)return w.with(0,0);let{line:l,character:o}=w,i=!1;if(l<0)l=0,o=0,i=!0;else if(l>=this.f.length)l=this.f.length-1,o=this.f[l].length,i=!0;else{const n=this.f[l].length;o<0?(o=0,i=!0):o>n&&(o=n,i=!0)}return i?new b.$CK(l,o):w}y(w,l){const o=this.x(w);if(!l)l=I(this.m);else if((0,f.$Se)(l))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${l.source}' because it matches the empty string.`);const i=(0,L.$bs)(o.character+1,(0,L.$_r)(l),this.f[o.line],0);if(i)return new b.$DK(o.line,i.startColumn-1,o.line,i.endColumn-1)}}e.$EM=$;class v{constructor(w,l,o){this.a=w,this.b=l,this.c=o}get lineNumber(){return this.a}get text(){return this.b}get range(){return new b.$DK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new b.$DK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$FM=v}),define(ke[285],Se([1,0,7,20,4]),function(me,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ffc=void 0;let R=class{constructor(b){this.a=new C.$XL(C.ColorThemeKind.Dark),this.b=new f.$Rd}get activeColorTheme(){return this.a}$onColorThemeChange(b){let y;switch(b){case"light":y=C.ColorThemeKind.Light;break;case"hcDark":y=C.ColorThemeKind.HighContrast;break;case"hcLight":y=C.ColorThemeKind.HighContrastLight;break;default:y=C.ColorThemeKind.Dark}this.a=new C.$XL(y),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Ffc=R,e.$Ffc=R=He([Be(0,T.$BM)],R)}),define(ke[286],Se([1,0,5]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HI=e.CellExecutionUpdateType=void 0;var T;(function(f){f[f.Output=1]="Output",f[f.OutputItems=2]="OutputItems",f[f.ExecutionState=3]="ExecutionState"})(T||(e.CellExecutionUpdateType=T={})),e.$HI=(0,C.$Vh)("INotebookExecutionService")}),define(ke[287],Se([1,0,3,29,193,99]),function(me,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VOb=void 0;class L extends C.$Rc{constructor(y,g,A){super(),this._source=y,this.b=g,this.c=A,this.a=void 0}f(y){const g=y.getLineCount();return new T.$zs(1,1,g,this.g(y,g))}g(y,g){if(g<1||g>y.getLineCount())throw new Error("Illegal value for lineNumber");return y.getLineLength(g)+1}get inputTextBuffer(){if(!this.b){const y=new f.$NB;y.acceptChunk(this._source);const g=y.finish(!0),{textBuffer:A,disposable:I}=g.create(1);this.b=A,this.B(I)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(y=>{const g=new f.$NB;g.acceptChunk(y);const A=g.finish(!0),{textBuffer:I,disposable:$}=A.create(1);return this.B($),I})),this.a}findInInputs(y){const A=new R.$BB(y,!1,!1,null).parseSearchRequest();if(!A)return[];const I=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(I,A,!0,5e3)}findInOutputs(y){const A=new R.$BB(y,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(I=>{const $=I.findMatchesLineByLine(this.f(I),A,!0,5e3);if($.length!==0)return{textBuffer:I,matches:$}}).filter(I=>!!I):[]}}e.$VOb=L}),define(ke[67],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sJ=e.TestPosition=e.TestIdPathParts=void 0;var C;(function(R){R.Delimiter="\0"})(C||(e.TestIdPathParts=C={}));var T;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(T||(e.TestPosition=T={}));class f{static fromExtHostTestItem(L,b,y=L.parent){if(L._isRoot)return new f([b]);const g=[L.id];for(let A=y;A&&A.id!==b;A=A.parent)g.push(A.id);return g.push(b),new f(g.reverse())}static isRoot(L){return!L.includes("\0")}static root(L){const b=L.indexOf("\0");return b===-1?L:L.slice(0,b)}static fromString(L){return new f(L.split("\0"))}static join(L,b){return new f([...L.path,b])}static joinToString(L,b){return L.toString()+"\0"+b}static parentId(L){const b=L.lastIndexOf("\0");return b===-1?void 0:L.slice(0,b)}static localId(L){const b=L.lastIndexOf("\0");return b===-1?L:L.slice(b+1)}static isChild(L,b){return b.startsWith(L)&&b[L.length]==="\0"}static compare(L,b){return L===b?0:f.isChild(L,b)?2:f.isChild(b,L)?3:1}constructor(L,b=L.length){if(this.path=L,this.d=b,L.length===0||b<1)throw new Error("cannot create test with empty path")}get rootId(){return new f(this.path,1)}get parentId(){return this.d>1?new f(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let L=1;L<=this.d;L++)yield new f(this.path,L)}*idsToRoot(){for(let L=this.d;L>0;L--)yield new f(this.path,L)}compare(L){if(typeof L=="string")return f.compare(this.toString(),L);for(let b=0;b<L.d&&b<this.d;b++)if(L.path[b]!==this.path[b])return 1;return L.d>this.d?2:L.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let L=1;L<this.d;L++)this.c+="\0",this.c+=this.path[L]}return this.c}}e.$sJ=f}),define(ke[89],Se([1,0,2,29,67]),function(me,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zJ=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$yJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$xJ=e.$wJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$vJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$uJ=e.$tJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var R;(function(D){D[D.Unset=0]="Unset",D[D.Queued=1]="Queued",D[D.Running=2]="Running",D[D.Passed=3]="Passed",D[D.Failed=4]="Failed",D[D.Skipped=5]="Skipped",D[D.Errored=6]="Errored"})(R||(e.TestResultState=R={}));var L;(function(D){D[D.Run=1]="Run",D[D.Debug=2]="Debug",D[D.Coverage=3]="Coverage"})(L||(e.ExtTestRunProfileKind=L={}));var b;(function(D){D[D.Run=2]="Run",D[D.Debug=4]="Debug",D[D.Coverage=8]="Coverage",D[D.HasNonDefaultProfile=16]="HasNonDefaultProfile",D[D.HasConfigurable=32]="HasConfigurable",D[D.SupportsContinuousRun=64]="SupportsContinuousRun"})(b||(e.TestRunProfileBitset=b={})),e.$tJ=[2,4,8,16,32,64];const y=D=>"runId"in D;e.$uJ=y;var g;(function(D){D.serialize=m=>({range:m.range.toJSON(),uri:m.uri.toJSON()}),D.deserialize=m=>({range:T.$zs.lift(m.range),uri:C.URI.revive(m.uri)})})(g||(e.IRichLocation=g={}));var A;(function(D){D[D.Error=0]="Error",D[D.Output=1]="Output"})(A||(e.TestMessageType=A={}));var I;(function(D){D.serialize=m=>({message:m.message,type:0,expected:m.expected,actual:m.actual,contextValue:m.contextValue,location:m.location&&g.serialize(m.location)}),D.deserialize=m=>({message:m.message,type:0,expected:m.expected,actual:m.actual,contextValue:m.contextValue,location:m.location&&g.deserialize(m.location)})})(I||(e.ITestErrorMessage=I={}));const $=(D,m)=>`${m?"s":"e"}${D}`;e.$vJ=$;var v;(function(D){D.serialize=m=>({message:m.message,type:1,offset:m.offset,length:m.length,location:m.location&&g.serialize(m.location)}),D.deserialize=m=>({message:m.message,type:1,offset:m.offset,length:m.length,location:m.location&&g.deserialize(m.location)})})(v||(e.ITestOutputMessage=v={}));var S;(function(D){D.serialize=m=>m.type===0?I.serialize(m):v.serialize(m),D.deserialize=m=>m.type===0?I.deserialize(m):v.deserialize(m)})(S||(e.ITestMessage=S={}));var w;(function(D){D.serializeWithoutMessages=m=>({state:m.state,duration:m.duration,messages:[]}),D.serialize=m=>({state:m.state,duration:m.duration,messages:m.messages.map(S.serialize)}),D.deserialize=m=>({state:m.state,duration:m.duration,messages:m.messages.map(S.deserialize)})})(w||(e.ITestTaskState=w={}));const l="\0",o=(D,m)=>D+l+m;e.$wJ=o;const i=D=>{const m=D.indexOf(l);return{ctrlId:D.slice(0,m),tagId:D.slice(m+1)}};e.$xJ=i;var n;(function(D){D.serialize=m=>({extId:m.extId,label:m.label,tags:m.tags,busy:m.busy,children:void 0,uri:m.uri?.toJSON(),range:m.range?.toJSON()||null,description:m.description,error:m.error,sortText:m.sortText}),D.deserialize=m=>({extId:m.extId,label:m.label,tags:m.tags,busy:m.busy,children:void 0,uri:m.uri?C.URI.revive(m.uri):void 0,range:m.range?T.$zs.lift(m.range):null,description:m.description,error:m.error,sortText:m.sortText})})(n||(e.ITestItem=n={}));var r;(function(D){D[D.NotExpandable=0]="NotExpandable",D[D.Expandable=1]="Expandable",D[D.BusyExpanding=2]="BusyExpanding",D[D.Expanded=3]="Expanded"})(r||(e.TestItemExpandState=r={}));var a;(function(D){D.serialize=m=>({expand:m.expand,item:n.serialize(m.item)}),D.deserialize=m=>({controllerId:f.$sJ.root(m.item.extId),expand:m.expand,item:n.deserialize(m.item)})})(a||(e.InternalTestItem=a={}));var t;(function(D){D.serialize=m=>{let p;return m.item&&(p={},m.item.label!==void 0&&(p.label=m.item.label),m.item.tags!==void 0&&(p.tags=m.item.tags),m.item.busy!==void 0&&(p.busy=m.item.busy),m.item.uri!==void 0&&(p.uri=m.item.uri?.toJSON()),m.item.range!==void 0&&(p.range=m.item.range?.toJSON()),m.item.description!==void 0&&(p.description=m.item.description),m.item.error!==void 0&&(p.error=m.item.error),m.item.sortText!==void 0&&(p.sortText=m.item.sortText)),{extId:m.extId,expand:m.expand,item:p}},D.deserialize=m=>{let p;return m.item&&(p={},m.item.label!==void 0&&(p.label=m.item.label),m.item.tags!==void 0&&(p.tags=m.item.tags),m.item.busy!==void 0&&(p.busy=m.item.busy),m.item.range!==void 0&&(p.range=m.item.range?T.$zs.lift(m.item.range):null),m.item.description!==void 0&&(p.description=m.item.description),m.item.error!==void 0&&(p.error=m.item.error),m.item.sortText!==void 0&&(p.sortText=m.item.sortText)),{extId:m.extId,expand:m.expand,item:p}}})(t||(e.ITestItemUpdate=t={}));const s=(D,m)=>{m.expand!==void 0&&(D.expand=m.expand),m.item!==void 0&&(D.item=D.item?Object.assign(D.item,m.item):m.item)};e.$yJ=s;var d;(function(D){D.serializeWithoutMessages=m=>({...a.serialize(m),ownComputedState:m.ownComputedState,computedState:m.computedState,tasks:m.tasks.map(w.serializeWithoutMessages)}),D.serialize=m=>({...a.serialize(m),ownComputedState:m.ownComputedState,computedState:m.computedState,tasks:m.tasks.map(w.serialize)}),D.deserialize=m=>({...a.deserialize(m),ownComputedState:m.ownComputedState,computedState:m.computedState,tasks:m.tasks.map(w.deserialize),retired:!0})})(d||(e.TestResultItem=d={}));var c;(function(D){D[D.Function=0]="Function",D[D.Statement=1]="Statement"})(c||(e.DetailType=c={}));var u;(function(D){D[D.Add=0]="Add",D[D.Update=1]="Update",D[D.DocumentSynced=2]="DocumentSynced",D[D.Remove=3]="Remove",D[D.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",D[D.Retire=5]="Retire",D[D.AddTag=6]="AddTag",D[D.RemoveTag=7]="RemoveTag"})(u||(e.TestDiffOpType=u={}));var h;(function(D){D.deserialize=m=>m.op===0?{op:m.op,item:a.deserialize(m.item)}:m.op===1?{op:m.op,item:t.deserialize(m.item)}:m.op===2?{op:m.op,uri:C.URI.revive(m.uri),docv:m.docv}:m,D.serialize=m=>m.op===0?{op:m.op,item:a.serialize(m.item)}:m.op===1?{op:m.op,item:t.serialize(m.item)}:m})(h||(e.TestsDiffOp=h={}));class E{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(m){const p=this.o();for(const k of m)switch(k.op){case 0:this.j(a.deserialize(k.item),p);break;case 1:this.k(t.deserialize(k.item),p);break;case 3:this.l(k.itemId,p);break;case 5:this.m(k.itemId);break;case 4:this.updatePendingRoots(k.amount);break;case 6:this.c.set(k.tag.id,k.tag);break;case 7:this.c.delete(k.id);break}p.complete?.()}j(m,p){const k=f.$sJ.parentId(m.item.extId)?.toString();let P;if(!k)P=this.p(m),this.f.add(P),this.d.set(m.item.extId,P);else if(this.d.has(k)){const z=this.d.get(k);z.children.add(m.item.extId),P=this.p(m,z),this.d.set(m.item.extId,P)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(m)}`);return}return p.add?.(P),m.expand===2&&this.g++,P}k(m,p){const k=this.d.get(m.extId);if(k)return m.expand!==void 0&&(k.expand===2&&this.g--,m.expand===2&&this.g++),(0,e.$yJ)(k,m),p.update?.(k),k}l(m,p){const k=this.d.get(m);if(!k)return;const P=f.$sJ.parentId(k.item.extId)?.toString();P?this.d.get(P).children.delete(k.item.extId):this.f.delete(k);const z=[[m]];for(;z.length;)for(const j of z.pop()){const M=this.d.get(j);M&&(z.push(M.children),this.d.delete(j),p.remove?.(M,M!==k),M.expand===2&&this.g--)}}m(m){}updatePendingRoots(m){this.h+=m}o(){return{}}}e.$zJ=E}),define(ke[112],Se([1,0,12,4,3,60,89,67]),function(me,e,C,T,f,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vM=e.$uM=e.$tM=e.$sM=e.$rM=e.TestItemEventOp=void 0;var y;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})(y||(e.TestItemEventOp=y={}));const g=(i,n)=>i===n,I=Object.entries({range:(i,n)=>i===n?!0:!i||!n?!1:i.equalsRange(n),busy:g,label:g,description:g,error:g,sortText:g,tags:(i,n)=>!(i.length!==n.length||i.some(r=>!n.includes(r)))}),$=(i,n)=>{let r;for(const[a,t]of I)t(i[a],n[a])||(r?r[a]=n[a]:r={[a]:n[a]});return r};class v extends f.$Rc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new C.$0g(()=>this.flushDiff(),200)),this.g=this.B(new T.$Rd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(n){this.h=n;for(const r of this.tree.values())this.I(r)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case 2:{for(const r of this.m)if(r.op===2&&r.uri===n.uri){r.docv=n.docv;return}break}case 1:{const r=this.m[this.m.length-1];if(r){if(r.op===1&&r.item.extId===n.item.extId){(0,L.$yJ)(r.item,n.item);return}if(r.op===0&&r.item.item.extId===n.item.extId){(0,L.$yJ)(r.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,r){const a=this.tree.get(n);if(a){if((a.expandLevels===void 0||r>a.expandLevels)&&(a.expandLevels=r),a.expand===1){const t=this.L(a);return t.isOpen()?this.J(a,r-1):t.wait().then(()=>this.J(a,r-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.J(a,r-1)):this.J(a,r-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(n,r){switch(r.op){case 3:this.N(b.$sJ.joinToString(n.fullId,r.id));break;case 0:this.y(r.item,n);break;case 5:for(const a of r.ops)this.u(n,a);break;case 1:this.z(r.new,r.old,n.fullId.toString());break;case 2:this.I(n);break;case 4:this.pushDiff({op:1,item:{extId:n.fullId.toString(),item:r.update}});break;case 6:this.w(n.actual.uri);break;default:(0,R.$4c)(r)}}w(n){n&&this.pushDiff({op:2,uri:n,docv:this.s.getDocumentVersion(n)})}y(n,r){const a=b.$sJ.fromExtHostTestItem(n,this.root.id,r?.actual),t=this.s.getApiFor(n);t.parent&&t.parent!==r?.actual&&this.s.getChildren(t.parent).delete(n.id);let s=this.tree.get(a.toString());if(!s){s={fullId:a,actual:n,expandLevels:r?.expandLevels?r.expandLevels-1:void 0,expand:0},n.tags.forEach(this.C,this),this.tree.set(s.fullId.toString(),s),this.F(n,r),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:s.expand,item:this.s.toITestItem(n)}}),this.H(n,s,r);return}if(s.actual===n){this.G(n,s,r);return}if(s.actual.uri?.toString()!==n.uri?.toString())return this.N(a.toString()),this.y(n,r);const d=this.s.getChildren(s.actual),c=s.actual,u=$(this.s.toITestItem(c),this.s.toITestItem(n));this.s.getApiFor(c).listener=void 0,s.actual=n,s.expand=0,u&&(u.hasOwnProperty("tags")&&(this.z(n.tags,c.tags,a.toString()),delete u.tags),this.u(s,{op:4,update:u})),this.H(n,s,r);for(const[h,E]of d)this.s.getChildren(n).get(E.id)||this.N(b.$sJ.joinToString(a,E.id));this.w(s.actual.uri)}z(n,r,a){const t=new Set(r.map(s=>s.id));for(const s of n)t.delete(s.id)||this.C(s);this.pushDiff({op:1,item:{extId:a,item:{tags:n.map(s=>(0,L.$wJ)(this.s.controllerId,s.id))}}}),t.forEach(this.D,this)}C(n){const r=this.j.get(n.id);r?r.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,L.$wJ)(this.s.controllerId,n.id)}}))}D(n){const r=this.j.get(n);r&&!--r.refCount&&(this.j.delete(n),this.pushDiff({op:7,id:(0,L.$wJ)(this.s.controllerId,n)}))}F(n,r){this.s.getApiFor(n).parent=r&&r.actual!==this.root?r.actual:void 0}G(n,r,a){this.F(n,a);const t=this.s.getApiFor(n);t.parent=a?.actual,t.listener=s=>this.u(r,s),this.I(r)}H(n,r,a){this.G(n,r,a);for(const[t,s]of this.s.getChildren(n))this.y(s,r)}I(n){let r;this.h?n.resolveBarrier?r=n.resolveBarrier.isOpen()?3:2:r=n.actual.canResolveChildren?1:0:r=0,r!==n.expand&&(n.expand=r,this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:r}}),r===1&&n.expandLevels!==void 0&&this.L(n))}J(n,r){if(r<0)return;const a=[];for(const[t,s]of this.s.getChildren(n.actual)){const d=this.expand(b.$sJ.joinToString(n.fullId,s.id),r);(0,C.$Kg)(d)&&a.push(d)}if(a.length)return Promise.all(a).then(()=>{})}L(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const s=new C.$Wg;return s.open(),s}n.expand=2,this.M(n);const r=n.resolveBarrier=new C.$Wg,a=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,s)};let t;try{t=this.h(n.actual===this.root?void 0:n.actual)}catch(s){a(s)}return(0,C.$Kg)(t)?t.catch(a).then(()=>{r.open(),this.I(n)}):(r.open(),this.I(n)),n.resolveBarrier}M(n){this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:n.expand}})}N(n){const r=this.tree.get(n);if(!r)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:n});const a=[r];for(;a.length;){const t=a.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const s of t.actual.tags)this.D(s.id);this.tree.delete(t.fullId.toString());for(const[s,d]of this.s.getChildren(t.actual))a.push(this.tree.get(b.$sJ.joinToString(t.fullId,d.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$rM=v;class S extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$sM=S;class w extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$tM=w;class l extends Error{constructor(n,r,a){super(`TestItem with ID "${n}" is from controller "${r}" and cannot be added as a child of an item from controller "${a}".`)}}e.$uM=l;const o=(i,n,r)=>{let a=new Map;return{get size(){return a.size},forEach(t,s){for(const d of a.values())t.call(s,d,this)},[Symbol.iterator](){return a.entries()},replace(t){const s=new Map,d=new Set(a.keys()),c={op:5,ops:[]};for(const u of t){if(!(u instanceof r))throw new w(u.id);const h=n(u).controllerId;if(h!==i.controllerId)throw new l(u.id,h,i.controllerId);if(s.has(u.id))throw new S(u.id);s.set(u.id,u),d.delete(u.id),c.ops.push({op:0,item:u})}for(const u of d.keys())c.ops.push({op:3,id:u});i.listener?.(c),a=s},add(t){if(!(t instanceof r))throw new w(t.id);a.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){a.delete(t)&&i.listener?.({op:3,id:t})},get(t){return a.get(t)},toJSON(){return Array.from(a.values())}}};e.$vM=o}),define(ke[144],Se([1,0,112]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xM=e.$wM=void 0;const T=new WeakMap,f=(L,b)=>{const y={controllerId:b};return T.set(L,y),y};e.$wM=f;const R=L=>{const b=T.get(L);if(!b)throw new C.$tM(L?.id||"<unknown>");return b};e.$xM=R}),define(ke[113],Se([1,0,17,2]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0tb=e.$9tb=e.$8tb=e.$7tb=e.$6tb=void 0,e.$6tb="vscode-cdn.net",e.$7tb=`vscode-resource.${e.$6tb}`,e.$8tb=`'self' https://*.${e.$6tb}`;function f(b,y){return b.scheme===C.Schemas.http||b.scheme===C.Schemas.https?b:(y&&y.authority&&y.isRemote&&b.scheme===C.Schemas.file&&(b=T.URI.from({scheme:C.Schemas.vscodeRemote,authority:y.authority,path:b.path})),T.URI.from({scheme:C.Schemas.https,authority:`${b.scheme}+${R(b.authority)}.${e.$7tb}`,path:b.path,fragment:b.fragment,query:b.query}))}e.$9tb=f;function R(b){return b.replace(/./g,y=>{const g=y.charCodeAt(0);return g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57?y:"-"+g.toString(16).padStart(4,"0")})}function L(b){return b.replace(/-([0-9a-f]{4})/g,(y,g)=>String.fromCharCode(parseInt(g,16)))}e.$0tb=L}),define(ke[288],Se([1,0,4,3,113]),function(me,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2dc=void 0;class R{constructor(b,y,g){this.d=b,this.e=y,this.f=g,this.a=0,this.b=new T.$Qc,this.c=new Map,this.b.add(y.onDidChangeVisibleTextEditors(()=>{const A=y.getVisibleTextEditors();for(const I of this.c.values())A.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this.c.forEach(b=>b.inset.dispose()),this.b.dispose()}createWebviewEditorInset(b,y,g,A,I){let $;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===b){$=n;break}if(!$)throw new Error("not a visible editor");const v=this,S=this.a++,w=new C.$Rd,l=new C.$Rd,o=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,f.$9tb)(n,v.f)}get cspSource(){return f.$8tb}set options(n){this.b=n,v.d.$setOptions(S,n)}get options(){return this.b}set html(n){this.a=n,v.d.$setHtml(S,n)}get html(){return this.a}get onDidReceiveMessage(){return w.event}postMessage(n){return v.d.$postMessage(S,n)}},i=new class{constructor(){this.editor=b,this.line=y,this.height=g,this.webview=o,this.onDidDispose=l.event}dispose(){v.c.has(S)&&(v.c.delete(S),v.d.$disposeEditorInset(S),l.fire(),l.dispose(),w.dispose())}};return this.d.$createEditorInset(S,$.id,$.value.document.uri,y+1,g,A||{},I.identifier,I.extensionLocation),this.c.set(S,{editor:b,inset:i,onDidReceiveMessage:w}),i}$onDidDispose(b){const y=this.c.get(b);y&&y.inset.dispose()}$onDidReceiveMessage(b,y){this.c.get(b)?.onDidReceiveMessage.fire(y)}}e.$2dc=R}),define(ke[289],Se([1,0,5]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oN=e.VariableKind=e.$nN=void 0,e.$nN=(0,C.$Vh)("configurationResolverService");var T;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator"})(T||(e.VariableKind=T={}));class f extends Error{constructor(L,b){super(b),this.variable=L}}e.$oN=f}),define(ke[290],Se([1,0,16,49,18,24,11,102,232,289,13]),function(me,e,C,T,f,R,L,b,y,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CN=void 0;class I{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(v,S,w,l){this.h=new Map,this.a=v,this.b=S,this.g=w,l&&(this.c=l.then(o=>this.i(o)))}i(v){if(L.$i){const S=Object.create(null);return Object.keys(v).forEach(w=>{S[w.toLowerCase()]=v[w]}),S}return v}resolveWithEnvironment(v,S,w){return this.l({env:this.i(v),userHome:void 0},S?S.uri:void 0,w)}async resolveAsync(v,S){const w={env:await this.c,userHome:await this.g};return this.l(w,v?v.uri:void 0,S)}async j(v,S,w,l){const o=R.$an(S);L.$i&&o.windows?Object.keys(o.windows).forEach(n=>o[n]=o.windows[n]):L.$j&&o.osx?Object.keys(o.osx).forEach(n=>o[n]=o.osx[n]):L.$k&&o.linux&&Object.keys(o.linux).forEach(n=>o[n]=o.linux[n]),delete o.windows,delete o.osx,delete o.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,v?v.uri:void 0,o,w,l)}async resolveAnyAsync(v,S,w){return this.j(v,S,w)}async resolveAnyMap(v,S,w){const l=new Map;return{newConfig:await this.j(v,S,w,l),resolvedVariables:l}}resolveWithInteractionReplace(v,S,w,l){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(v,S,w,l){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(v,S){if(this.h.has(v))throw new Error("Variable "+v+" is contributed twice.");this.h.set(v,S)}async l(v,S,w,l,o){if(f.$Cf(w))return this.m(v,S,w,l,o);if(Array.isArray(w))return Promise.all(w.map(i=>this.l(v,S,i,l,o)));if(f.$Ef(w)){const i=Object.create(null),n=await Promise.all(Object.keys(w).map(async r=>[await this.m(v,S,r,l,o),await this.l(v,S,w[r],l,o)]));for(const[r,a]of n)i[r]=a;return i}return w}m(v,S,w,l,o){return(0,A.$Xe)(w,I.VARIABLE_REGEXP,async(i,n)=>{if(n.includes(I.VARIABLE_LHS))return i;let r=await this.o(v,i,n,S,l);return o?.set(n,r),r!==i&&f.$Cf(r)&&r.match(I.VARIABLE_REGEXP)&&(r=await this.m(v,S,r,l,o)),r})}n(v){return this.b?this.b.getUriLabel(v,{noPrefix:!0}):v.fsPath}async o(v,S,w,l,o){let i;const n=w.split(":");n.length>1&&(w=n[0],i=n[1]);const r=s=>{const d=this.a.getFilePath();if(d)return(0,b.$zv)(d);throw new g.$oN(s,(0,y.localize)(0,null,S))},a=s=>{const d=r(s);if(this.a.getWorkspaceFolderPathForFile){const c=this.a.getWorkspaceFolderPathForFile();if(c)return(0,b.$zv)(c)}throw new g.$oN(s,(0,y.localize)(1,null,S,C.$mc(d)))},t=s=>{if(i){const d=this.a.getFolderUri(i);if(d)return d;throw new g.$oN(s,(0,y.localize)(2,null,S,i))}if(l)return l;throw this.a.getWorkspaceFolderCount()>1?new g.$oN(s,(0,y.localize)(3,null,S)):new g.$oN(s,(0,y.localize)(4,null,S))};switch(w){case"env":if(i){if(v.env){const s=v.env[L.$i?i.toLowerCase():i];if(f.$Cf(s))return s}return""}throw new g.$oN(g.VariableKind.Env,(0,y.localize)(5,null,S));case"config":if(i){const s=this.a.getConfigurationValue(l,i);if(f.$Lf(s))throw new g.$oN(g.VariableKind.Config,(0,y.localize)(6,null,S,i));if(f.$Ef(s))throw new g.$oN(g.VariableKind.Config,(0,y.localize)(7,null,S,i));return s}throw new g.$oN(g.VariableKind.Config,(0,y.localize)(8,null,S));case"command":return this.p(g.VariableKind.Command,S,i,o,"command");case"input":return this.p(g.VariableKind.Input,S,i,o,"input");case"extensionInstallFolder":if(i){const s=await this.a.getExtension(i);if(!s)throw new g.$oN(g.VariableKind.ExtensionInstallFolder,(0,y.localize)(9,null,S,i));return this.n(s.extensionLocation)}throw new g.$oN(g.VariableKind.ExtensionInstallFolder,(0,y.localize)(10,null,S));default:switch(w){case"workspaceRoot":case"workspaceFolder":return(0,b.$zv)(this.n(t(g.VariableKind.WorkspaceFolder)));case"cwd":return l||i?(0,b.$zv)(this.n(t(g.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,b.$zv)(C.$mc(this.n(t(g.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(v.userHome)return v.userHome;throw new g.$oN(g.VariableKind.UserHome,(0,y.localize)(11,null,S))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new g.$oN(g.VariableKind.LineNumber,(0,y.localize)(12,null,S))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new g.$oN(g.VariableKind.SelectedText,(0,y.localize)(13,null,S))}case"file":return r(g.VariableKind.File);case"fileWorkspaceFolder":return a(g.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return C.$mc(a(g.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return l||i?C.$kc(this.n(t(g.VariableKind.RelativeFile)),r(g.VariableKind.RelativeFile)):r(g.VariableKind.RelativeFile);case"relativeFileDirname":{const s=C.$lc(r(g.VariableKind.RelativeFileDirname));if(l||i){const d=C.$kc(this.n(t(g.VariableKind.RelativeFileDirname)),s);return d.length===0?".":d}return s}case"fileDirname":return C.$lc(r(g.VariableKind.FileDirname));case"fileExtname":return C.$nc(r(g.VariableKind.FileExtname));case"fileBasename":return C.$mc(r(g.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=C.$mc(r(g.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-C.$nc(s).length)}case"fileDirnameBasename":return C.$mc(C.$lc(r(g.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||S}case"execInstallFolder":{const s=this.a.getAppRoot();return s||S}case"pathSeparator":return C.sep;default:try{const s=i?`${w}:${i}`:w;return this.p(g.VariableKind.Unknown,S,s,o,void 0)}catch{return S}}}}p(v,S,w,l,o){if(w&&l){const i=o===void 0?l[w]:l[o+":"+w];if(typeof i=="string")return i;throw new g.$oN(v,(0,y.localize)(14,null,S))}return S}}e.$CN=I}),define(ke[145],Se([1,0,5,141]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JC=e.$IC=e.OpenEditorContext=e.GroupsOrder=e.$HC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$GC=void 0,e.$GC=(0,C.$Vh)("editorGroupsService");var f;(function(S){S[S.UP=0]="UP",S[S.DOWN=1]="DOWN",S[S.LEFT=2]="LEFT",S[S.RIGHT=3]="RIGHT"})(f||(e.GroupDirection=f={}));var R;(function(S){S[S.HORIZONTAL=0]="HORIZONTAL",S[S.VERTICAL=1]="VERTICAL"})(R||(e.GroupOrientation=R={}));var L;(function(S){S[S.FIRST=0]="FIRST",S[S.LAST=1]="LAST",S[S.NEXT=2]="NEXT",S[S.PREVIOUS=3]="PREVIOUS"})(L||(e.GroupLocation=L={}));var b;(function(S){S[S.MAXIMIZE=0]="MAXIMIZE",S[S.EXPAND=1]="EXPAND",S[S.EVEN=2]="EVEN"})(b||(e.GroupsArrangement=b={}));var y;(function(S){S[S.COPY_EDITORS=0]="COPY_EDITORS",S[S.MOVE_EDITORS=1]="MOVE_EDITORS"})(y||(e.MergeGroupMode=y={}));function g(S){const w=S;return(0,T.$pE)(w?.editor)&&(0,T.$pE)(w?.replacement)}e.$HC=g;var A;(function(S){S[S.CREATION_TIME=0]="CREATION_TIME",S[S.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",S[S.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var I;(function(S){S[S.NEW_EDITOR=1]="NEW_EDITOR",S[S.MOVE_EDITOR=2]="MOVE_EDITOR",S[S.COPY_EDITOR=3]="COPY_EDITOR"})(I||(e.OpenEditorContext=I={}));function $(S){const w=S;return!!w&&typeof w.id=="number"&&Array.isArray(w.editors)}e.$IC=$;function v(S){return S.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$JC=v}),define(ke[291],Se([1,0,5,145]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NC=e.$MC=e.$LC=e.$KC=void 0,e.$KC=(0,C.$Vh)("editorService"),e.$LC=-1,e.$MC=-2;function f(R){const L=R;return typeof R=="number"||(0,T.$IC)(L)}e.$NC=f}),define(ke[146],Se([1,0,5,134]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WJ=void 0,e.$WJ=(0,C.$Wh)(T.$3h)}),define(ke[147],Se([1,0,26,4,16,3]),function(me,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z5b=e.$Y5b=e.$X5b=e.$W5b=e.$V5b=void 0;class L{constructor(o,i){this.versionId=o,this.removedDueToLooping=i}}e.$V5b=L;class b{static isHostExtension(o,i,n){if(i.getExtensionDescription(o))return!1;const r=n.getExtensionDescription(o);return r?!!((r.main||r.browser)&&r.api==="none"):!1}constructor(o,i){this.j=o,this.c=new T.$Rd,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(S),this.f=new C.$bm,this.g=[],this.h=new Map;for(const o of this.e){if(this.f.has(o.identifier)){console.error("Extension `"+o.identifier.value+"` is already registered");continue}this.f.set(o.identifier,o),this.g.push(o);const i=this.j.readActivationEvents(o);for(const n of i)this.h.has(n)||this.h.set(n,[]),this.h.get(n).push(o)}}set(o){return this.e=o,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(o,i){this.e=w(this.e,i),this.e=this.e.concat(o);const n=b.l(this.e);return this.e=w(this.e,n.map(r=>r.identifier)),this.k(),this.d++,this.c.fire(void 0),new L(this.d,n)}static l(o){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(s){this.d.has(s)||(this.d.add(s),this.e.push(s))}addArc(s,d){this.addNode(s),this.addNode(d),this.c.has(s)?this.c.get(s).push(d):this.c.set(s,[d])}getArcs(s){return this.c.has(s)?this.c.get(s):[]}hasOnlyGoodArcs(s,d){const c=i.getArcs(s);for(let u=0;u<c.length;u++)if(!d.has(c[u]))return!1;return!0}getNodes(){return this.e}},n=new C.$bm;for(const s of o)if(n.set(s.identifier,s),s.extensionDependencies)for(const d of s.extensionDependencies)i.addArc(C.$_l.toKey(s.identifier),C.$_l.toKey(d));const r=new Set;i.getNodes().filter(s=>i.getArcs(s).length===0).forEach(s=>r.add(s));const a=i.getNodes().filter(s=>!r.has(s));let t;do{t=!1;for(let s=0;s<a.length;s++){const d=a[s];i.hasOnlyGoodArcs(d,r)&&(a.splice(s,1),s--,r.add(d),t=!0)}}while(t);return a.map(s=>n.get(s))}containsActivationEvent(o){return this.h.has(o)}containsExtension(o){return this.f.has(o)}getExtensionDescriptionsForActivationEvent(o){const i=this.h.get(o);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new y(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(o){const i=this.f.get(o);return i||void 0}getExtensionDescriptionByUUID(o){for(const i of this.g)if(i.uuid===o)return i}getExtensionDescriptionByIdOrUUID(o,i){return this.getExtensionDescription(o)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$W5b=b;class y{constructor(o,i){this.versionId=o,this.extensions=i}}e.$X5b=y;class g{constructor(o){this.d=new $,this.c=new b(o,[])}async acquireLock(o){const i=await this.d.acquire(o);return new A(this,i)}deltaExtensions(o,i,n){if(!o.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,n)}containsActivationEvent(o){return this.c.containsActivationEvent(o)}containsExtension(o){return this.c.containsExtension(o)}getExtensionDescriptionsForActivationEvent(o){return this.c.getExtensionDescriptionsForActivationEvent(o)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(o){return this.c.getExtensionDescription(o)}getExtensionDescriptionByUUID(o){return this.c.getExtensionDescriptionByUUID(o)}getExtensionDescriptionByIdOrUUID(o,i){return this.c.getExtensionDescriptionByIdOrUUID(o,i)}}e.$Y5b=g;class A extends R.$Rc{constructor(o,i){super(),this.f=o,this.c=!1,this.B(i)}isAcquiredFor(o){return!this.c&&this.f===o}}e.$Z5b=A;class I{constructor(o){this.name=o,this.promise=new Promise((i,n)=>{this.c=i})}resolve(o){this.c(o)}}class ${constructor(){this.c=[],this.d=!1}async acquire(o){const i=new I(o);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const o=this.c.shift();this.d=!0;let i=!0;const n=setTimeout(()=>{i&&console.warn(`The customer named ${o.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),r=()=>{i&&(clearTimeout(n),i=!1,this.d=!1,this.e())};o.resolve((0,R.$Pc)(r))}}var v;(function(l){l[l.Builtin=0]="Builtin",l[l.User=1]="User",l[l.Dev=2]="Dev"})(v||(v={}));function S(l,o){const i=l.isBuiltin?0:l.isUnderDevelopment?2:1,n=o.isBuiltin?0:o.isUnderDevelopment?2:1;if(i!==n)return i-n;const r=f.$fc.basename(l.extensionLocation.path),a=f.$fc.basename(o.extensionLocation.path);return r<a?-1:r>a?1:0}function w(l,o){const i=new C.$am(o);return l.filter(n=>!i.has(n.identifier))}}),define(ke[292],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=e.$Fm=e.$Em=e.$Dm=e.ExtHostConnectionType=void 0;var C;(function(A){A[A.IPC=1]="IPC",A[A.Socket=2]="Socket",A[A.MessagePort=3]="MessagePort"})(C||(e.ExtHostConnectionType=C={}));class T{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(I){this.pipeName=I,this.type=1}serialize(I){I[T.ENV_KEY]=this.pipeName}}e.$Dm=T;class f{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(I){I[f.ENV_KEY]="1"}}e.$Em=f;class R{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(I){I[R.ENV_KEY]="1"}}e.$Fm=R;function L(A){delete A[T.ENV_KEY],delete A[f.ENV_KEY],delete A[R.ENV_KEY]}function b(A,I){L(I),A.serialize(I)}e.$Gm=b;function y(A){if(A[T.ENV_KEY])return g(A,new T(A[T.ENV_KEY]));if(A[f.ENV_KEY])return g(A,new f);if(A[R.ENV_KEY])return g(A,new R);throw new Error("No connection information defined in environment!")}e.$Hm=y;function g(A,I){return L(A),I}}),define(ke[114],Se([1,0,22]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$im=e.$hm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var T;(function(g){g[g.Desktop=1]="Desktop",g[g.Web=2]="Web"})(T||(e.UIKind=T={}));var f;(function(g){g[g.VersionMismatch=55]="VersionMismatch",g[g.UnexpectedError=81]="UnexpectedError"})(f||(e.ExtensionHostExitCode=f={}));var R;(function(g){g[g.Initialized=0]="Initialized",g[g.Ready=1]="Ready",g[g.Terminate=2]="Terminate"})(R||(e.MessageType=R={}));function L(g){const A=C.$fe.alloc(1);switch(g){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.$hm=L;function b(g,A){if(g.byteLength!==1)return!1;switch(g.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.$im=b;var y;(function(g){g.Start="START_NATIVE_LOG",g.End="END_NATIVE_LOG"})(y||(e.NativeLogMarkers=y={}))}),define(ke[90],Se([1,0,5,4,14,27,114,65,87,24,2,3,218]),function(me,e,C,T,f,R,L,b,y,g,A,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VM=e.$UM=e.$TM=e.$SM=void 0;let v=class extends I.$Rc{constructor(o,i){super(),this.s=o,this.t=i,this.a=this.B(new T.$Rd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new T.$Rd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:y.$uo,name:(0,$.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(i.onDidChangeLogLevel(n=>{(0,f.$fj)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===f.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(o,i,n){const r=this.getTelemetryDetails(),a=new S(i,n,o,this.n,this.j,this.getBuiltInCommonProperties(o),{isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}),t=this.r.get(o.identifier.value)??[];return this.r.set(o.identifier.value,[...t,a]),a.apiTelemetryLogger}$initializeTelemetryLevel(o,i,n){this.f=o,this.g=i,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(o){const i=Object.create(null);switch(i["common.extname"]=`${o.publisher}.${o.name}`,i["common.extversion"]=o.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=w(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case L.UIKind.Web:i["common.uikind"]="web";break;case L.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,b.$2k)((0,y.$Bo)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(o){this.h=this.getTelemetryConfiguration(),this.f=o;const i=this.getTelemetryDetails();this.r.forEach((n,r)=>{const a=n.filter(t=>!t.isDisposed);a.length===0?this.r.delete(r):this.r.set(r,a)}),this.r.forEach(n=>{for(const r of n)r.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(o,i){const r=this.r.get(o.value)?.filter(t=>!t.isDisposed);if(!r)return this.r.delete(o.value),!1;let a=!1;for(const t of r)t.ignoreUnhandledExtHostErrors||(t.logError(i),a=!0);return a}};e.$SM=v,e.$SM=v=He([Be(0,R.$RM),Be(1,f.$ej)],v);class S{static validateSender(o){if(typeof o!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof o.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof o.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof o.flush<"u"&&typeof o.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(o,i,n,r,a,t,s){this.g=n,this.h=r,this.i=a,this.j=t,this.a=new T.$Rd,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=o,this.d={isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}}updateTelemetryEnablements(o,i){this.e&&(this.d={isUsageEnabled:o,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(o){let i="properties"in o?o.properties??{}:o;return i=(0,y.$Eo)(i,[]),this.c&&(i=(0,g.$dn)(i,this.c)),this.b||(i=(0,g.$dn)(i,this.j)),"properties"in o?o.properties=i:o=i,o}k(o,i){this.f&&(this.g.publisher==="vscode"?o=this.g.name+"/"+o:o=this.g.identifier.value+"/"+o,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(o,i),this.h.trace(o,i))}logUsage(o,i){this.d.isUsageEnabled&&this.k(o,i)}logError(o,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof o=="string")this.k(o,i);else{const n={name:o.name,message:o.message,stack:o.stack,cause:o.cause},r=(0,y.$Eo)(n,[]),a=new Error(r.message,{cause:r.cause});a.stack=r.stack,a.name=r.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(a,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const o=this,i={logUsage:o.logUsage.bind(o),get isUsageEnabled(){return o.d.isUsageEnabled},get isErrorsEnabled(){return o.d.isErrorsEnabled},logError:o.logError.bind(o),dispose:o.dispose.bind(o),onDidChangeEnableStates:o.a.event.bind(o)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let o=this.f;this.f=void 0,Promise.resolve(o.flush()).then(o=void 0),this.e=void 0}else this.f=void 0}}e.$TM=S;function w(l){const o=Date.now()-new Date(l).getTime();return isNaN(o)?!1:o<1e3*60*60*24}e.$UM=w,e.$VM=(0,C.$Vh)("IExtHostTelemetry")}),define(ke[25],Se([1,0,4,2,262,139,26,5]),function(me,e,C,T,f,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SF=e.$RF=e.$QF=e.ActivationKind=e.$PF=e.$OF=e.$NF=e.$MF=e.$LF=e.ExtensionHostStartup=e.$KF=e.$JF=e.$IF=e.$HF=void 0,e.$HF=Object.freeze({identifier:new L.$_l("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$IF="extensions.webWorker",e.$JF=(0,b.$Vh)("extensionService");class y{constructor(a){this.dependency=a}}e.$KF=y;var g;(function(r){r[r.EagerAutoStart=1]="EagerAutoStart",r[r.EagerManualStart=2]="EagerManualStart",r[r.Lazy=3]="Lazy"})(g||(e.ExtensionHostStartup=g={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(a,t,s){this.c=a,this.d=t.slice(0),this.e=s.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:R.$yF.createActivationEventsMap(this.d)}}set(a,t,s){if(this.c>a)throw new Error(`ExtensionHostExtensions: invalid versionId ${a} (current: ${this.c})`);const d=[],c=[],u=[],h=[],E=I(this.d),D=I(t),m=(j,M)=>j.extensionLocation.toString()===M.extensionLocation.toString()||j.isBuiltin===M.isBuiltin||j.isUserBuiltin===M.isUserBuiltin||j.isUnderDevelopment===M.isUnderDevelopment;for(const j of this.d){const M=D.get(j.identifier);if(!M){d.push(j.identifier),E.delete(j.identifier);continue}if(!m(j,M)){d.push(j.identifier),E.delete(j.identifier);continue}}for(const j of t){const M=E.get(j.identifier);if(!M){c.push(j);continue}if(!m(M,j)){d.push(M.identifier),E.delete(M.identifier);continue}}const p=new L.$am(this.e),k=new L.$am(s);for(const j of this.e)k.has(j)||u.push(j);for(const j of s)p.has(j)||h.push(j);const P=R.$yF.createActivationEventsMap(c),z={versionId:a,toRemove:d,toAdd:c,addActivationEvents:P,myToRemove:u,myToAdd:h};return this.delta(z),z}delta(a){if(this.c>=a.versionId)return null;const{toRemove:t,toAdd:s,myToRemove:d,myToAdd:c}=a,u=new L.$am(t),h=new L.$am(d);for(let E=0;E<this.d.length;E++)u.has(this.d[E].identifier)&&(this.d.splice(E,1),E--);for(let E=0;E<this.e.length;E++)h.has(this.e[E])&&(this.e.splice(E,1),E--);for(const E of s)this.d.push(E);for(const E of c)this.e.push(E);return this.f=null,a}containsExtension(a){for(const t of this.e)if(L.$_l.equals(t,a))return!0;return!1}containsActivationEvent(a){return this.f||(this.f=this.g()),this.f.has(a)}g(){const a=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const s=R.$yF.readActivationEvents(t);for(const d of s)a.add(d)}return a}}e.$LF=A;function I(r){const a=new L.$bm;for(const t of r)a.set(t.identifier,t);return a}function $(r,a){return r.enabledApiProposals?r.enabledApiProposals.includes(a):!1}e.$MF=$;function v(r,a){if(!$(r,a))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${a}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${a}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}e.$NF=v;class S{constructor(a,t,s,d){this.codeLoadingTime=a,this.activateCallTime=t,this.activateResolvedTime=s,this.activationReason=d}}e.$OF=S;class w{constructor(a,t){this.description=a,this.value=t}}e.$PF=w;var l;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(l||(e.ActivationKind=l={}));function o(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,f.$Ko)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}e.$QF=o;function i(r,a){return{identifier:new L.$_l((0,f.$Io)(r.manifest.publisher,r.manifest.name)),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!a,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform}}e.$RF=i;class n{constructor(){this.onDidRegisterExtensions=C.Event.None,this.onDidChangeExtensionsStatus=C.Event.None,this.onDidChangeExtensions=C.Event.None,this.onWillActivateByEvent=C.Event.None,this.onDidChangeResponsiveChange=C.Event.None,this.onWillStop=C.Event.None,this.extensions=[]}activateByEvent(a){return Promise.resolve(void 0)}activateById(a,t){return Promise.resolve(void 0)}activationEventIsDone(a){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(a){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(a,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(a){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$SF=n}),define(ke[293],Se([1,0,8,147,26,25,14,12]),function(me,e,C,T,f,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qec=e.$pec=e.$oec=e.$nec=e.$mec=e.$lec=void 0;class y{static{this.NONE=new y(!1,-1,-1,-1)}constructor(o,i,n,r){this.startup=o,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=r}}e.$lec=y;class g{constructor(o){this.a=o,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(o,i){return o===-1||i===-1?-1:i-o}build(){return new y(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$mec=g;class A{constructor(o,i,n,r,a,t){this.activationFailed=o,this.activationFailedError=i,this.activationTimes=n,this.module=r,this.exports=a,this.subscriptions=t}}e.$nec=A;class I extends A{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.$oec=I;class $ extends A{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$pec=$;class v extends A{constructor(o){super(!0,o,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let S=class{constructor(o,i,n,r){this.g=r,this.a=o,this.b=i,this.c=n,this.d=new f.$bm,this.f=Object.create(null)}dispose(){for(const[o,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const o=[];for(const[i,n]of this.d)o.push(n.wait());await Promise.all(o)}isActivated(o){const i=this.d.get(o);return!!(i&&i.value)}getActivatedExtension(o){const i=this.d.get(o);if(!i||!i.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return i.value}async activateByEvent(o,i){if(this.f[o])return;const n=this.a.getExtensionDescriptionsForActivationEvent(o);await this.h(n.map(r=>({id:r.identifier,reason:{startup:i,extensionId:r.identifier,activationEvent:o}}))),this.f[o]=!0}activateById(o,i){const n=this.a.getExtensionDescription(o);if(!n)throw new Error(`Extension '${o}' is not known`);return this.h([{id:n.identifier,reason:i}])}async h(o){const i=o.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(i.map(n=>n.wait()))}j(o){if(this.d.has(o.id))return this.d.get(o.id);if(this.l(o.id))return this.k(o,null,[],null);const i=this.a.getExtensionDescription(o.id);if(!i){const a=new Error(`Cannot activate unknown extension '${o.id.value}'`),t=this.k(o,null,[],new v(a));return this.c.onExtensionActivationError(o.id,a,new R.$KF(o.id.value)),t}const n=[],r=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const a of r){if(this.m(a))continue;const t=this.d.get(a);if(t){n.push(t);continue}if(this.l(a)){n.push(this.j({id:this.b.getExtensionDescription(a).identifier,reason:o.reason}));continue}const s=this.a.getExtensionDescription(a);if(s){if(!s.main&&!s.browser)continue;n.push(this.j({id:s.identifier,reason:o.reason}));continue}const d=i.displayName||i.identifier.value,c=new Error(`Cannot activate the '${d}' extension because it depends on unknown extension '${a}'`),u=this.k(o,i.displayName,[],new v(c));return this.c.onExtensionActivationError(i.identifier,c,new R.$KF(a)),u}return this.k(o,i.displayName,n,null)}k(o,i,n,r){const a=new w(o.id,i,o.reason,n,r,this.c,this.g);return this.d.set(o.id,a),a}l(o){return T.$W5b.isHostExtension(o,this.a,this.b)}m(o){const i=this.b.getExtensionDescription(o);return i?!i.main&&!i.browser:!1}};e.$qec=S,e.$qec=S=He([Be(3,L.$dj)],S);let w=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(o,i,n,r,a,t,s){this.c=o,this.d=i,this.f=n,this.g=r,this.h=a,this.j=t,this.k=s,this.a=new b.$Wg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let o=0;o<this.g.length;o++){const i=this.g[o];if(i.value&&!i.value.activationFailed){this.g.splice(o,1),o--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this.h=new v(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(o=>o.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(o){const i=new Error;if(o&&o.name&&(i.name=o.name),o&&o.message?i.message=`Activating extension '${this.c.value}' failed: ${o.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${o}.`,o&&o.stack&&(i.stack=o.stack),this.h=new v(i),this.b&&C.$3(o))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(o)}}};w=He([Be(6,L.$dj)],w)}),define(ke[15],Se([1,0,19,22,165,74,80,28,161,54,100,24,18,2,29,83,136,144,141,111,67,89,291,7,25]),function(me,e,C,T,f,R,L,b,y,g,A,I,$,v,S,w,l,o,i,n,r,a,t,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$AM=e.$zM=e.MarkdownString=e.$yM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var c;(function(Me){function Fe(se){const{selectionStartLineNumber:Te,selectionStartColumn:qe,positionLineNumber:xe,positionColumn:Qe}=se,ot=new s.$CK(Te-1,qe-1),pt=new s.$CK(xe-1,Qe-1);return new s.$EK(ot,pt)}Me.to=Fe;function Ce(se){const{anchor:Te,active:qe}=se;return{selectionStartLineNumber:Te.line+1,selectionStartColumn:Te.character+1,positionLineNumber:qe.line+1,positionColumn:qe.character+1}}Me.from=Ce})(c||(e.Selection=c={}));var u;(function(Me){function Fe(se){if(!se)return;const{start:Te,end:qe}=se;return{startLineNumber:Te.line+1,startColumn:Te.character+1,endLineNumber:qe.line+1,endColumn:qe.character+1}}Me.from=Fe;function Ce(se){if(!se)return;const{startLineNumber:Te,startColumn:qe,endLineNumber:xe,endColumn:Qe}=se;return new s.$DK(Te-1,qe-1,xe-1,Qe-1)}Me.to=Ce})(u||(e.Range=u={}));var h;(function(Me){function Fe(Ce){switch(Ce){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Me.to=Fe})(h||(e.TokenType=h={}));var E;(function(Me){function Fe(se){return new s.$CK(se.lineNumber-1,se.column-1)}Me.to=Fe;function Ce(se){return{lineNumber:se.line+1,column:se.character+1}}Me.from=Ce})(E||(e.Position=E={}));var D;(function(Me){function Fe(Te,qe,xe){return(0,C.$Gb)((0,C.$2b)(Te).map(Qe=>Ce(Qe,qe,xe)))}Me.from=Fe;function Ce(Te,qe,xe){if(typeof Te=="string")return{$serialized:!0,language:Te,isBuiltin:xe?.isBuiltin};if(Te)return{$serialized:!0,language:Te.language,scheme:se(Te.scheme,qe),pattern:le.from(Te.pattern)??void 0,exclusive:Te.exclusive,notebookType:Te.notebookType,isBuiltin:xe?.isBuiltin}}function se(Te,qe){return qe&&typeof Te=="string"?qe.transformOutgoingScheme(Te):Te}})(D||(e.DocumentSelector=D={}));var m;(function(Me){function Fe(se){switch(se){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Me.from=Fe;function Ce(se){switch(se){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Me.to=Ce})(m||(e.DiagnosticTag=m={}));var p;(function(Me){function Fe(se){let Te;return se.code&&((0,$.$Cf)(se.code)||(0,$.$Gf)(se.code)?Te=String(se.code):Te={value:String(se.code.value),target:se.code.target}),{...u.from(se.range),message:se.message,source:se.source,code:Te,severity:P.from(se.severity),relatedInformation:se.relatedInformation&&se.relatedInformation.map(k.from),tags:Array.isArray(se.tags)?(0,C.$Gb)(se.tags.map(m.from)):void 0}}Me.from=Fe;function Ce(se){const Te=new s.$PK(u.to(se),se.message,P.to(se.severity));return Te.source=se.source,Te.code=(0,$.$Cf)(se.code)?se.code:se.code?.value,Te.relatedInformation=se.relatedInformation&&se.relatedInformation.map(k.to),Te.tags=se.tags&&(0,C.$Gb)(se.tags.map(m.to)),Te}Me.to=Ce})(p||(e.Diagnostic=p={}));var k;(function(Me){function Fe(se){return{...u.from(se.location.range),message:se.message,resource:se.location.uri}}Me.from=Fe;function Ce(se){return new s.$OK(new s.$NK(se.resource,u.to(se)),se.message)}Me.to=Ce})(k||(e.DiagnosticRelatedInformation=k={}));var P;(function(Me){function Fe(se){switch(se){case s.DiagnosticSeverity.Error:return l.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return l.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return l.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return l.MarkerSeverity.Hint}return l.MarkerSeverity.Error}Me.from=Fe;function Ce(se){switch(se){case l.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case l.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case l.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case l.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Me.to=Ce})(P||(e.DiagnosticSeverity=P={}));var z;(function(Me){function Fe(se){return typeof se=="number"&&se>=s.ViewColumn.One?se-1:se===s.ViewColumn.Beside?t.$MC:t.$LC}Me.from=Fe;function Ce(se){if(typeof se=="number"&&se>=0)return se+1;throw new Error("invalid 'EditorGroupColumn'")}Me.to=Ce})(z||(e.ViewColumn=z={}));function j(Me){return typeof Me.range<"u"}function M(Me){return Me.length===0?!0:!!j(Me[0])}e.$yM=M;var O;(function(Me){function Fe(Qe){return Qe.map(Me.from)}Me.fromMany=Fe;function Ce(Qe){return Qe&&typeof Qe=="object"&&typeof Qe.language=="string"&&typeof Qe.value=="string"}function se(Qe){let ot;if(Ce(Qe)){const{language:ht,value:Lt}=Qe;ot={value:"```"+ht+`
`+Lt+"\n```\n"}}else s.$2K.isMarkdownString(Qe)?ot={value:Qe.value,isTrusted:Qe.isTrusted,supportThemeIcons:Qe.supportThemeIcons,supportHtml:Qe.supportHtml,baseUri:Qe.baseUri}:typeof Qe=="string"?ot={value:Qe}:ot={value:""};const pt=Object.create(null);ot.uris=pt;const bt=ht=>{try{let Lt=v.URI.parse(ht,!0);Lt=Lt.with({query:Te(Lt.query,pt)}),pt[ht]=Lt}catch{}return""},vt=new y.marked.Renderer;return vt.link=bt,vt.image=ht=>typeof ht=="string"?bt(L.$dk(ht).href):"",(0,y.marked)(ot.value,{renderer:vt}),ot}Me.from=se;function Te(Qe,ot){if(!Qe)return Qe;let pt;try{pt=(0,g.$rh)(Qe)}catch{}if(!pt)return Qe;let bt=!1;return pt=(0,I.$cn)(pt,vt=>{if(v.URI.isUri(vt)){const ht=`__uri_${Math.random().toString(16).slice(2,8)}`;return ot[ht]=vt,bt=!0,ht}else return}),bt?JSON.stringify(pt):Qe}function qe(Qe){const ot=new s.$2K(Qe.value,Qe.supportThemeIcons);return ot.isTrusted=Qe.isTrusted,ot.supportHtml=Qe.supportHtml,ot.baseUri=Qe.baseUri?v.URI.from(Qe.baseUri):void 0,ot}Me.to=qe;function xe(Qe){if(Qe)return typeof Qe=="string"?Qe:Me.from(Qe)}Me.fromStrict=xe})(O||(e.MarkdownString=O={}));function F(Me){return M(Me)?Me.map(Fe=>({range:u.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?O.fromMany(Fe.hoverMessage):Fe.hoverMessage?O.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Me.map(Fe=>({range:u.from(Fe)}))}e.$zM=F;function N(Me){return typeof Me>"u"?Me:typeof Me=="string"?v.URI.file(Me):Me}e.$AM=N;var W;(function(Me){function Fe(Ce){return typeof Ce>"u"?Ce:{contentText:Ce.contentText,contentIconPath:Ce.contentIconPath?N(Ce.contentIconPath):void 0,border:Ce.border,borderColor:Ce.borderColor,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,color:Ce.color,backgroundColor:Ce.backgroundColor,margin:Ce.margin,width:Ce.width,height:Ce.height}}Me.from=Fe})(W||(e.ThemableDecorationAttachmentRenderOptions=W={}));var X;(function(Me){function Fe(Ce){return typeof Ce>"u"?Ce:{backgroundColor:Ce.backgroundColor,outline:Ce.outline,outlineColor:Ce.outlineColor,outlineStyle:Ce.outlineStyle,outlineWidth:Ce.outlineWidth,border:Ce.border,borderColor:Ce.borderColor,borderRadius:Ce.borderRadius,borderSpacing:Ce.borderSpacing,borderStyle:Ce.borderStyle,borderWidth:Ce.borderWidth,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,cursor:Ce.cursor,color:Ce.color,opacity:Ce.opacity,letterSpacing:Ce.letterSpacing,gutterIconPath:Ce.gutterIconPath?N(Ce.gutterIconPath):void 0,gutterIconSize:Ce.gutterIconSize,overviewRulerColor:Ce.overviewRulerColor,before:Ce.before?W.from(Ce.before):void 0,after:Ce.after?W.from(Ce.after):void 0}}Me.from=Fe})(X||(e.ThemableDecorationRenderOptions=X={}));var ce;(function(Me){function Fe(Ce){if(typeof Ce>"u")return Ce;switch(Ce){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Me.from=Fe})(ce||(e.DecorationRangeBehavior=ce={}));var J;(function(Me){function Fe(Ce){return{isWholeLine:Ce.isWholeLine,rangeBehavior:Ce.rangeBehavior?ce.from(Ce.rangeBehavior):void 0,overviewRulerLane:Ce.overviewRulerLane,light:Ce.light?X.from(Ce.light):void 0,dark:Ce.dark?X.from(Ce.dark):void 0,backgroundColor:Ce.backgroundColor,outline:Ce.outline,outlineColor:Ce.outlineColor,outlineStyle:Ce.outlineStyle,outlineWidth:Ce.outlineWidth,border:Ce.border,borderColor:Ce.borderColor,borderRadius:Ce.borderRadius,borderSpacing:Ce.borderSpacing,borderStyle:Ce.borderStyle,borderWidth:Ce.borderWidth,fontStyle:Ce.fontStyle,fontWeight:Ce.fontWeight,textDecoration:Ce.textDecoration,cursor:Ce.cursor,color:Ce.color,opacity:Ce.opacity,letterSpacing:Ce.letterSpacing,gutterIconPath:Ce.gutterIconPath?N(Ce.gutterIconPath):void 0,gutterIconSize:Ce.gutterIconSize,overviewRulerColor:Ce.overviewRulerColor,before:Ce.before?W.from(Ce.before):void 0,after:Ce.after?W.from(Ce.after):void 0}}Me.from=Fe})(J||(e.DecorationRenderOptions=J={}));var Q;(function(Me){function Fe(se){return{text:se.newText,eol:se.newEol&&Ae.from(se.newEol),range:u.from(se.range)}}Me.from=Fe;function Ce(se){const Te=new s.$IK(u.to(se.range),se.text);return Te.newEol=typeof se.eol>"u"?void 0:Ae.to(se.eol),Te}Me.to=Ce})(Q||(e.TextEdit=Q={}));var G;(function(Me){function Fe(se,Te){const qe={edits:[]};if(se instanceof s.$LK){const xe=new b.$Ac;for(const Qe of se._allEntries())Qe._type===1&&v.URI.isUri(Qe.to)&&Qe.from===void 0&&xe.add(Qe.to);for(const Qe of se._allEntries())if(Qe._type===1){let ot;Qe.options?.contents&&(ArrayBuffer.isView(Qe.options.contents)?ot={type:"base64",value:(0,T.$ze)(T.$fe.wrap(Qe.options.contents))}:ot={type:"dataTransferItem",id:Qe.options.contents._itemId}),qe.edits.push({oldResource:Qe.from,newResource:Qe.to,options:{...Qe.options,contents:ot},metadata:Qe.metadata})}else Qe._type===2?qe.edits.push({resource:Qe.uri,textEdit:Q.from(Qe.edit),versionId:xe.has(Qe.uri)?void 0:Te?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===6?qe.edits.push({resource:Qe.uri,textEdit:{range:u.from(Qe.range),text:Qe.edit.value,insertAsSnippet:!0},versionId:xe.has(Qe.uri)?void 0:Te?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===3?qe.edits.push({metadata:Qe.metadata,resource:Qe.uri,cellEdit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:Te?.getNotebookDocumentVersion(Qe.uri)}):Qe._type===5&&qe.edits.push({metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:Te?.getNotebookDocumentVersion(Qe.uri),cellEdit:{editType:1,index:Qe.index,count:Qe.count,cells:Qe.cells.map(wt.from)}})}return qe}Me.from=Fe;function Ce(se){const Te=new s.$LK,qe=new b.$zc;for(const xe of se.edits)if(xe.textEdit){const Qe=xe,ot=v.URI.revive(Qe.resource),pt=u.to(Qe.textEdit.range),bt=Qe.textEdit.text,vt=Qe.textEdit.insertAsSnippet;let ht;vt?ht=s.$KK.replace(pt,new s.$MK(bt)):ht=s.$IK.replace(pt,bt);const Lt=qe.get(ot);Lt?Lt.push(ht):qe.set(ot,[ht])}else Te.renameFile(v.URI.revive(xe.oldResource),v.URI.revive(xe.newResource),xe.options);for(const[xe,Qe]of qe)Te.set(xe,Qe);return Te}Me.to=Ce})(G||(e.WorkspaceEdit=G={}));var oe;(function(Me){const Fe=Object.create(null);Fe[s.SymbolKind.File]=0,Fe[s.SymbolKind.Module]=1,Fe[s.SymbolKind.Namespace]=2,Fe[s.SymbolKind.Package]=3,Fe[s.SymbolKind.Class]=4,Fe[s.SymbolKind.Method]=5,Fe[s.SymbolKind.Property]=6,Fe[s.SymbolKind.Field]=7,Fe[s.SymbolKind.Constructor]=8,Fe[s.SymbolKind.Enum]=9,Fe[s.SymbolKind.Interface]=10,Fe[s.SymbolKind.Function]=11,Fe[s.SymbolKind.Variable]=12,Fe[s.SymbolKind.Constant]=13,Fe[s.SymbolKind.String]=14,Fe[s.SymbolKind.Number]=15,Fe[s.SymbolKind.Boolean]=16,Fe[s.SymbolKind.Array]=17,Fe[s.SymbolKind.Object]=18,Fe[s.SymbolKind.Key]=19,Fe[s.SymbolKind.Null]=20,Fe[s.SymbolKind.EnumMember]=21,Fe[s.SymbolKind.Struct]=22,Fe[s.SymbolKind.Event]=23,Fe[s.SymbolKind.Operator]=24,Fe[s.SymbolKind.TypeParameter]=25;function Ce(Te){return typeof Fe[Te]=="number"?Fe[Te]:6}Me.from=Ce;function se(Te){for(const qe in Fe)if(Fe[qe]===Te)return Number(qe);return s.SymbolKind.Property}Me.to=se})(oe||(e.SymbolKind=oe={}));var _;(function(Me){function Fe(se){switch(se){case s.SymbolTag.Deprecated:return 1}}Me.from=Fe;function Ce(se){switch(se){case 1:return s.SymbolTag.Deprecated}}Me.to=Ce})(_||(e.SymbolTag=_={}));var Ee;(function(Me){function Fe(se){return{name:se.name,kind:oe.from(se.kind),tags:se.tags&&se.tags.map(_.from),containerName:se.containerName,location:be.from(se.location)}}Me.from=Fe;function Ce(se){const Te=new s.$SK(se.name,oe.to(se.kind),se.containerName,be.to(se.location));return Te.tags=se.tags&&se.tags.map(_.to),Te}Me.to=Ce})(Ee||(e.WorkspaceSymbol=Ee={}));var he;(function(Me){function Fe(se){const Te={name:se.name||"!!MISSING: name!!",detail:se.detail,range:u.from(se.range),selectionRange:u.from(se.selectionRange),kind:oe.from(se.kind),tags:se.tags?.map(_.from)??[]};return se.children&&(Te.children=se.children.map(Fe)),Te}Me.from=Fe;function Ce(se){const Te=new s.$TK(se.name,se.detail,oe.to(se.kind),u.to(se.range),u.to(se.selectionRange));return(0,C.$Kb)(se.tags)&&(Te.tags=se.tags.map(_.to)),se.children&&(Te.children=se.children.map(Ce)),Te}Me.to=Ce})(he||(e.DocumentSymbol=he={}));var q;(function(Me){function Fe(se){const Te=new s.$XK(oe.to(se.kind),se.name,se.detail||"",v.URI.revive(se.uri),u.to(se.range),u.to(se.selectionRange));return Te._sessionId=se._sessionId,Te._itemId=se._itemId,Te}Me.to=Fe;function Ce(se,Te,qe){if(Te=Te??se._sessionId,qe=qe??se._itemId,Te===void 0||qe===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:qe,name:se.name,detail:se.detail,kind:oe.from(se.kind),uri:se.uri,range:u.from(se.range),selectionRange:u.from(se.selectionRange),tags:se.tags?.map(_.from)}}Me.from=Ce})(q||(e.CallHierarchyItem=q={}));var U;(function(Me){function Fe(Ce){return new s.$YK(q.to(Ce.from),Ce.fromRanges.map(se=>u.to(se)))}Me.to=Fe})(U||(e.CallHierarchyIncomingCall=U={}));var ne;(function(Me){function Fe(Ce){return new s.$ZK(q.to(Ce.to),Ce.fromRanges.map(se=>u.to(se)))}Me.to=Fe})(ne||(e.CallHierarchyOutgoingCall=ne={}));var be;(function(Me){function Fe(se){return{range:se.range&&u.from(se.range),uri:se.uri}}Me.from=Fe;function Ce(se){return new s.$NK(v.URI.revive(se.uri),u.to(se.range))}Me.to=Ce})(be||(e.location=be={}));var H;(function(Me){function Fe(se){const Te=se,qe=se;return{originSelectionRange:Te.originSelectionRange?u.from(Te.originSelectionRange):void 0,uri:Te.targetUri?Te.targetUri:qe.uri,range:u.from(Te.targetRange?Te.targetRange:qe.range),targetSelectionRange:Te.targetSelectionRange?u.from(Te.targetSelectionRange):void 0}}Me.from=Fe;function Ce(se){return{targetUri:v.URI.revive(se.uri),targetRange:u.to(se.range),targetSelectionRange:se.targetSelectionRange?u.to(se.targetSelectionRange):void 0,originSelectionRange:se.originSelectionRange?u.to(se.originSelectionRange):void 0}}Me.to=Ce})(H||(e.DefinitionLink=H={}));var x;(function(Me){function Fe(se){return{range:u.from(se.range),contents:O.fromMany(se.contents)}}Me.from=Fe;function Ce(se){return new s.$QK(se.contents.map(O.to),u.to(se.range))}Me.to=Ce})(x||(e.Hover=x={}));var Y;(function(Me){function Fe(se){return{range:u.from(se.range),expression:se.expression}}Me.from=Fe;function Ce(se){return new s.$JL(u.to(se.range),se.expression)}Me.to=Ce})(Y||(e.EvaluatableExpression=Y={}));var $e;(function(Me){function Fe(se){if(se instanceof s.$KL)return{type:"text",range:u.from(se.range),text:se.text};if(se instanceof s.$LL)return{type:"variable",range:u.from(se.range),variableName:se.variableName,caseSensitiveLookup:se.caseSensitiveLookup};if(se instanceof s.$ML)return{type:"expression",range:u.from(se.range),expression:se.expression};throw new Error("Unknown 'InlineValue' type")}Me.from=Fe;function Ce(se){switch(se.type){case"text":return{range:u.to(se.range),text:se.text};case"variable":return{range:u.to(se.range),variableName:se.variableName,caseSensitiveLookup:se.caseSensitiveLookup};case"expression":return{range:u.to(se.range),expression:se.expression}}}Me.to=Ce})($e||(e.InlineValue=$e={}));var ie;(function(Me){function Fe(se){return{frameId:se.frameId,stoppedLocation:u.from(se.stoppedLocation)}}Me.from=Fe;function Ce(se){return new s.$NL(se.frameId,u.to(se.stoppedLocation))}Me.to=Ce})(ie||(e.InlineValueContext=ie={}));var fe;(function(Me){function Fe(se){return{range:u.from(se.range),kind:se.kind}}Me.from=Fe;function Ce(se){return new s.$RK(u.to(se.range),se.kind)}Me.to=Ce})(fe||(e.DocumentHighlight=fe={}));var te;(function(Me){function Fe(Ce){switch(Ce){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Me.to=Fe})(te||(e.CompletionTriggerKind=te={}));var de;(function(Me){function Fe(Ce){return{triggerKind:te.to(Ce.triggerKind),triggerCharacter:Ce.triggerCharacter}}Me.to=Fe})(de||(e.CompletionContext=de={}));var pe;(function(Me){function Fe(se){switch(se){case s.CompletionItemTag.Deprecated:return 1}}Me.from=Fe;function Ce(se){switch(se){case 1:return s.CompletionItemTag.Deprecated}}Me.to=Ce})(pe||(e.CompletionItemTag=pe={}));var Pe;(function(Me){const Fe=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function Ce(qe){return Fe.get(qe)??9}Me.from=Ce;const se=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Te(qe){return se.get(qe)??s.CompletionItemKind.Property}Me.to=Te})(Pe||(e.CompletionItemKind=Pe={}));var B;(function(Me){function Fe(Ce,se){const Te=new s.$8K(Ce.label);return Te.insertText=Ce.insertText,Te.kind=Pe.to(Ce.kind),Te.tags=Ce.tags?.map(pe.to),Te.detail=Ce.detail,Te.documentation=L.$$j(Ce.documentation)?O.to(Ce.documentation):Ce.documentation,Te.sortText=Ce.sortText,Te.filterText=Ce.filterText,Te.preselect=Ce.preselect,Te.commitCharacters=Ce.commitCharacters,S.$zs.isIRange(Ce.range)?Te.range=u.to(Ce.range):typeof Ce.range=="object"&&(Te.range={inserting:u.to(Ce.range.insert),replacing:u.to(Ce.range.replace)}),Te.keepWhitespace=typeof Ce.insertTextRules>"u"?!1:!!(Ce.insertTextRules&1),typeof Ce.insertTextRules<"u"&&Ce.insertTextRules&4?Te.insertText=new s.$MK(Ce.insertText):(Te.insertText=Ce.insertText,Te.textEdit=Te.range instanceof s.$DK?new s.$IK(Te.range,Te.insertText):void 0),Ce.additionalTextEdits&&Ce.additionalTextEdits.length>0&&(Te.additionalTextEdits=Ce.additionalTextEdits.map(qe=>Q.to(qe))),Te.command=se&&Ce.command?se.fromInternal(Ce.command):void 0,Te}Me.to=Fe})(B||(e.CompletionItem=B={}));var Z;(function(Me){function Fe(se){if(typeof se.label!="string"&&!Array.isArray(se.label))throw new TypeError("Invalid label");return{label:se.label,documentation:O.fromStrict(se.documentation)}}Me.from=Fe;function Ce(se){return{label:se.label,documentation:L.$$j(se.documentation)?O.to(se.documentation):se.documentation}}Me.to=Ce})(Z||(e.ParameterInformation=Z={}));var re;(function(Me){function Fe(se){return{label:se.label,documentation:O.fromStrict(se.documentation),parameters:Array.isArray(se.parameters)?se.parameters.map(Z.from):[],activeParameter:se.activeParameter}}Me.from=Fe;function Ce(se){return{label:se.label,documentation:L.$$j(se.documentation)?O.to(se.documentation):se.documentation,parameters:Array.isArray(se.parameters)?se.parameters.map(Z.to):[],activeParameter:se.activeParameter}}Me.to=Ce})(re||(e.SignatureInformation=re={}));var ae;(function(Me){function Fe(se){return{activeSignature:se.activeSignature,activeParameter:se.activeParameter,signatures:Array.isArray(se.signatures)?se.signatures.map(re.from):[]}}Me.from=Fe;function Ce(se){return{activeSignature:se.activeSignature,activeParameter:se.activeParameter,signatures:Array.isArray(se.signatures)?se.signatures.map(re.to):[]}}Me.to=Ce})(ae||(e.SignatureHelp=ae={}));var ee;(function(Me){function Fe(Ce,se){const Te=new s.$7K(E.to(se.position),typeof se.label=="string"?se.label:se.label.map(ge.to.bind(void 0,Ce)),se.kind&&ye.to(se.kind));return Te.textEdits=se.textEdits&&se.textEdits.map(Q.to),Te.tooltip=L.$$j(se.tooltip)?O.to(se.tooltip):se.tooltip,Te.paddingLeft=se.paddingLeft,Te.paddingRight=se.paddingRight,Te}Me.to=Fe})(ee||(e.InlayHint=ee={}));var ge;(function(Me){function Fe(Ce,se){const Te=new s.$6K(se.label);return Te.tooltip=L.$$j(se.tooltip)?O.to(se.tooltip):se.tooltip,w.Command.is(se.command)&&(Te.command=Ce.fromInternal(se.command)),se.location&&(Te.location=be.to(se.location)),Te}Me.to=Fe})(ge||(e.InlayHintLabelPart=ge={}));var ye;(function(Me){function Fe(se){return se}Me.from=Fe;function Ce(se){return se}Me.to=Ce})(ye||(e.InlayHintKind=ye={}));var ze;(function(Me){function Fe(se){return{range:u.from(se.range),url:se.target,tooltip:se.tooltip}}Me.from=Fe;function Ce(se){let Te;if(se.url)try{Te=typeof se.url=="string"?v.URI.parse(se.url,!0):v.URI.revive(se.url)}catch{}return new s.$aL(u.to(se.range),Te)}Me.to=Ce})(ze||(e.DocumentLink=ze={}));var We;(function(Me){function Fe(se){const Te=new s.$dL(se.label);return se.textEdit&&(Te.textEdit=Q.to(se.textEdit)),se.additionalTextEdits&&(Te.additionalTextEdits=se.additionalTextEdits.map(qe=>Q.to(qe))),Te}Me.to=Fe;function Ce(se){return{label:se.label,textEdit:se.textEdit?Q.from(se.textEdit):void 0,additionalTextEdits:se.additionalTextEdits?se.additionalTextEdits.map(Te=>Q.from(Te)):void 0}}Me.from=Ce})(We||(e.ColorPresentation=We={}));var et;(function(Me){function Fe(se){return new s.$bL(se[0],se[1],se[2],se[3])}Me.to=Fe;function Ce(se){return[se.red,se.green,se.blue,se.alpha]}Me.from=Ce})(et||(e.Color=et={}));var Ye;(function(Me){function Fe(se){return{range:u.from(se.range)}}Me.from=Fe;function Ce(se){return new s.$WK(u.to(se.range))}Me.to=Ce})(Ye||(e.SelectionRange=Ye={}));var rt;(function(Me){function Fe(Ce){switch(Ce){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Me.to=Fe})(rt||(e.TextDocumentSaveReason=rt={}));var nt;(function(Me){function Fe(se){switch(se){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Me.from=Fe;function Ce(se){switch(se){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Me.to=Ce})(nt||(e.TextEditorLineNumbersStyle=nt={}));var Ae;(function(Me){function Fe(se){if(se===s.EndOfLine.CRLF)return 1;if(se===s.EndOfLine.LF)return 0}Me.from=Fe;function Ce(se){if(se===1)return s.EndOfLine.CRLF;if(se===0)return s.EndOfLine.LF}Me.to=Ce})(Ae||(e.EndOfLine=Ae={}));var Ne;(function(Me){function Fe(Ce){if(typeof Ce=="object")return Ce.viewId;switch(Ce){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Me.from=Fe})(Ne||(e.ProgressLocation=Ne={}));var Ve;(function(Me){function Fe(se){const Te={start:se.start+1,end:se.end+1};return se.kind&&(Te.kind=Le.from(se.kind)),Te}Me.from=Fe;function Ce(se){const Te={start:se.start-1,end:se.end-1};return se.kind&&(Te.kind=Le.to(se.kind)),Te}Me.to=Ce})(Ve||(e.FoldingRange=Ve={}));var Le;(function(Me){function Fe(se){if(se)switch(se){case s.FoldingRangeKind.Comment:return w.$ot.Comment;case s.FoldingRangeKind.Imports:return w.$ot.Imports;case s.FoldingRangeKind.Region:return w.$ot.Region}}Me.from=Fe;function Ce(se){if(se)switch(se.value){case w.$ot.Comment.value:return s.FoldingRangeKind.Comment;case w.$ot.Imports.value:return s.FoldingRangeKind.Imports;case w.$ot.Region.value:return s.FoldingRangeKind.Region}}Me.to=Ce})(Le||(e.FoldingRangeKind=Le={}));var Xe;(function(Me){function Fe(Ce){if(Ce)return{pinned:typeof Ce.preview=="boolean"?!Ce.preview:void 0,inactive:Ce.background,preserveFocus:Ce.preserveFocus,selection:typeof Ce.selection=="object"?u.from(Ce.selection):void 0,override:typeof Ce.override=="boolean"?i.$bE.id:void 0}}Me.from=Fe})(Xe||(e.TextEditorOpenOptions=Xe={}));var le;(function(Me){function Fe(qe){return qe instanceof s.$xL?qe.toJSON():typeof qe=="string"?qe:Ce(qe)||se(qe)?new s.$xL(qe.baseUri??qe.base,qe.pattern).toJSON():qe}Me.from=Fe;function Ce(qe){const xe=qe;return xe?v.URI.isUri(xe.baseUri)&&typeof xe.pattern=="string":!1}function se(qe){const xe=qe;return xe?typeof xe.base=="string"&&typeof xe.pattern=="string":!1}function Te(qe){return typeof qe=="string"?qe:new s.$xL(v.URI.revive(qe.baseUri),qe.pattern)}Me.to=Te})(le||(e.GlobPattern=le={}));var ue;(function(Me){function Fe(Ce){if(Ce){if(Array.isArray(Ce))return Ce.map(Fe);if(typeof Ce=="string")return Ce;{const se=Ce;return{language:se.language,scheme:se.scheme,pattern:le.from(se.pattern),exclusive:se.exclusive,notebookType:se.notebookType}}}else return}Me.from=Fe})(ue||(e.LanguageSelector=ue={}));var Ie;(function(Me){function Fe(se){return!!se&&typeof se=="object"&&"documents"in se&&Array.isArray(se.documents)&&se.documents.every(Te=>Array.isArray(Te)&&Te.every(qe=>qe&&typeof qe=="object"&&"uri"in qe&&v.URI.isUri(qe.uri)&&"version"in qe&&typeof qe.version=="number"&&"ranges"in qe&&Array.isArray(qe.ranges)&&qe.ranges.every(xe=>xe instanceof s.$DK)))}Me.is=Fe;function Ce(se){return{documents:se.documents.map(Te=>Te.map(qe=>({uri:v.URI.from(qe.uri),version:qe.version,ranges:qe.ranges.map(xe=>u.from(xe))})))}}Me.from=Ce})(Ie||(e.MappedEditsContext=Ie={}));var Ke;(function(Me){function Fe(se){return{start:se.start,end:se.end}}Me.from=Fe;function Ce(se){return new s.$YL(se.start,se.end)}Me.to=Ce})(Ke||(e.NotebookRange=Ke={}));var Ge;(function(Me){function Fe(se){return{timing:typeof se.runStartTime=="number"&&typeof se.runEndTime=="number"?{startTime:se.runStartTime,endTime:se.runEndTime}:void 0,executionOrder:se.executionOrder,success:se.lastRunSuccess}}Me.to=Fe;function Ce(se){return{lastRunSuccess:se.success,runStartTime:se.timing?.startTime,runEndTime:se.timing?.endTime,executionOrder:se.executionOrder}}Me.from=Ce})(Ge||(e.NotebookCellExecutionSummary=Ge={}));var _e;(function(Me){function Fe(Ce){if(Ce===n.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(Ce===n.NotebookCellExecutionState.Pending)return;if(Ce===n.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ce}`)}Me.to=Fe})(_e||(e.NotebookCellExecutionState=_e={}));var st;(function(Me){function Fe(se){switch(se){case s.NotebookCellKind.Markup:return n.CellKind.Markup;case s.NotebookCellKind.Code:default:return n.CellKind.Code}}Me.from=Fe;function Ce(se){switch(se){case n.CellKind.Markup:return s.NotebookCellKind.Markup;case n.CellKind.Code:default:return s.NotebookCellKind.Code}}Me.to=Ce})(st||(e.NotebookCellKind=st={}));var lt;(function(Me){function Fe(se){const Te={metadata:se.metadata??Object.create(null),cells:[]};for(const qe of se.cells)s.$ZL.validate(qe),Te.cells.push(wt.from(qe));return Te}Me.from=Fe;function Ce(se){const Te=new s.$1L(se.cells.map(wt.to));return(0,$.$Pf)(se.metadata)||(Te.metadata=se.metadata),Te}Me.to=Ce})(lt||(e.NotebookData=lt={}));var wt;(function(Me){function Fe(se){return{cellKind:st.from(se.kind),language:se.languageId,mime:se.mime,source:se.value,metadata:se.metadata,internalMetadata:Ge.from(se.executionSummary??{}),outputs:se.outputs?se.outputs.map(Kt.from):[]}}Me.from=Fe;function Ce(se){return new s.$ZL(st.to(se.cellKind),se.source,se.language,se.mime,se.outputs?se.outputs.map(Kt.to):void 0,se.metadata,se.internalMetadata?Ge.to(se.internalMetadata):void 0)}Me.to=Ce})(wt||(e.NotebookCellData=wt={}));var Ue;(function(Me){function Fe(se){return{mime:se.mime,valueBytes:T.$fe.wrap(se.data)}}Me.from=Fe;function Ce(se){return new s.$2L(se.valueBytes.buffer,se.mime)}Me.to=Ce})(Ue||(e.NotebookCellOutputItem=Ue={}));var Kt;(function(Me){function Fe(se){return{outputId:se.id,items:se.items.map(Ue.from),metadata:se.metadata}}Me.from=Fe;function Ce(se){const Te=se.items.map(Ue.to);return new s.$3L(Te,se.outputId,se.metadata)}Me.to=Ce})(Kt||(e.NotebookCellOutput=Kt={}));var Ht;(function(Me){function Fe(Te){return se(Te)?{include:le.from(Te.include)??void 0,exclude:le.from(Te.exclude)??void 0}:le.from(Te)??void 0}Me.from=Fe;function Ce(Te){return se(Te)?{include:le.to(Te.include),exclude:le.to(Te.exclude)}:le.to(Te)}Me.to=Ce;function se(Te){const qe=Te;return qe?!(0,$.$Lf)(qe.include)&&!(0,$.$Lf)(qe.exclude):!1}})(Ht||(e.NotebookExclusiveDocumentPattern=Ht={}));var Et;(function(Me){function Fe(Ce,se,Te){const qe=typeof Ce.command=="string"?{title:"",command:Ce.command}:Ce.command;return{alignment:Ce.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:se.toInternal(qe,Te),text:Ce.text,tooltip:Ce.tooltip,accessibilityInformation:Ce.accessibilityInformation,priority:Ce.priority}}Me.from=Fe})(Et||(e.NotebookStatusBarItem=Et={}));var Ut;(function(Me){function Fe(Ce,se,Te){const qe=typeof Ce.command=="string"?{title:"",command:Ce.command}:Ce.command;return{command:se.toInternal(qe,Te),label:Ce.label,description:Ce.description,detail:Ce.detail,documentation:Ce.documentation}}Me.from=Fe})(Ut||(e.NotebookKernelSourceAction=Ut={}));var Ot;(function(Me){function Fe(Ce){return{transientOutputs:Ce?.transientOutputs??!1,transientCellMetadata:Ce?.transientCellMetadata??{},transientDocumentMetadata:Ce?.transientDocumentMetadata??{},cellContentMetadata:Ce?.cellContentMetadata??{}}}Me.from=Fe})(Ot||(e.NotebookDocumentContentOptions=Ot={}));var Gt;(function(Me){function Fe(se){return{uri:se.uri,provides:se.provides}}Me.from=Fe;function Ce(se){return new s.$5L(v.URI.revive(se.uri),se.provides)}Me.to=Ce})(Gt||(e.NotebookRendererScript=Gt={}));var Bt;(function(Me){function Fe(se){return{message:O.fromStrict(se.message)||"",type:0,expected:se.expectedOutput,actual:se.actualOutput,contextValue:se.contextValue,location:se.location&&{range:u.from(se.location.range),uri:se.location.uri}}}Me.from=Fe;function Ce(se){const Te=new s.$$L(typeof se.message=="string"?se.message:O.to(se.message));return Te.actualOutput=se.actual,Te.expectedOutput=se.expected,Te.contextValue=se.contextValue,Te.location=se.location?be.to(se.location):void 0,Te}Me.to=Ce})(Bt||(e.TestMessage=Bt={}));var Dt;(function(Me){Me.namespace=a.$wJ,Me.denamespace=a.$xJ})(Dt||(e.TestTag=Dt={}));var Mt;(function(Me){function Fe(se){const Te=(0,o.$xM)(se).controllerId;return{extId:r.$sJ.fromExtHostTestItem(se,Te).toString(),label:se.label,uri:v.URI.revive(se.uri),busy:se.busy,tags:se.tags.map(qe=>Dt.namespace(Te,qe.id)),range:S.$zs.lift(u.from(se.range)),description:se.description||null,sortText:se.sortText||null,error:se.error&&O.fromStrict(se.error)||null}}Me.from=Fe;function Ce(se){return{parent:void 0,error:void 0,id:r.$sJ.fromString(se.extId).localId,label:se.label,uri:v.URI.revive(se.uri),tags:(se.tags||[]).map(Te=>{const{tagId:qe}=Dt.denamespace(Te);return new s.$_L(qe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:u.to(se.range||void 0),canResolveChildren:!1,busy:se.busy,description:se.description||void 0,sortText:se.sortText||void 0}}Me.toPlain=Ce})(Mt||(e.TestItem=Mt={})),function(Me){function Fe(se){return{id:se.id}}Me.from=Fe;function Ce(se){return new s.$_L(se.id)}Me.to=Ce}(Dt||(e.TestTag=Dt={}));var Wt;(function(Me){const Fe=(se,Te)=>{const qe=[];for(const[Qe,ot]of Te)r.$sJ.compare(ot.item.extId,Qe)===2&&(Te.delete(Qe),qe.push(ot));const xe={...Mt.toPlain(se.item),parent:void 0,taskStates:se.tasks.map(Qe=>({state:Qe.state,duration:Qe.duration,messages:Qe.messages.filter(ot=>ot.type===0).map(Bt.to)})),children:qe.map(Qe=>Fe(Qe,Te))};for(const Qe of xe.children)Qe.parent=xe;return xe};function Ce(se){const Te=[],qe=new Map;for(const xe of se.items){qe.set(xe.item.extId,xe);const Qe=r.$sJ.root(xe.item.extId);se.request.targets.some(ot=>ot.controllerId===Qe&&ot.testIds.includes(xe.item.extId))&&Te.push(xe)}return{completedAt:se.completedAt,results:Te.map(xe=>Fe(xe,qe))}}Me.to=Ce})(Wt||(e.TestResults=Wt={}));var tt;(function(Me){function Fe(qe){return{covered:qe.covered,total:qe.covered}}function Ce(qe){return"line"in qe?E.from(qe):u.from(qe)}function se(qe){return"branches"in qe?{count:qe.executionCount,location:Ce(qe.location),type:1,branches:qe.branches.length?qe.branches.map(xe=>({count:xe.executionCount,location:xe.location&&Ce(xe.location)})):void 0}:{type:0,count:qe.executionCount,location:Ce(qe.location)}}Me.fromDetailed=se;function Te(qe){return{uri:qe.uri,statement:Fe(qe.statementCoverage),branch:qe.branchCoverage&&Fe(qe.branchCoverage),function:qe.functionCoverage&&Fe(qe.functionCoverage),details:qe.detailedCoverage?.map(se)}}Me.fromFile=Te})(tt||(e.TestCoverage=tt={}));var Vt;(function(Me){function Fe(Ce){switch(Ce){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Me.to=Fe})(Vt||(e.CodeActionTriggerKind=Vt={}));var qt;(function(Me){function Fe(se){const Te=new s.$fM(oe.to(se.kind),se.name,se.detail||"",v.URI.revive(se.uri),u.to(se.range),u.to(se.selectionRange));return Te._sessionId=se._sessionId,Te._itemId=se._itemId,Te}Me.to=Fe;function Ce(se,Te,qe){if(Te=Te??se._sessionId,qe=qe??se._itemId,Te===void 0||qe===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:qe,kind:oe.from(se.kind),name:se.name,detail:se.detail??"",uri:se.uri,range:u.from(se.range),selectionRange:u.from(se.selectionRange),tags:se.tags?.map(_.from)}}Me.from=Ce})(qt||(e.TypeHierarchyItem=qt={}));var ut;(function(Me){function Fe(Ce){if(Ce)return{value:Ce.value,tooltip:Ce.tooltip}}Me.from=Fe})(ut||(e.ViewBadge=ut={}));var mt;(function(Me){function Fe(qe,xe,Qe){const ot=xe.fileData;return ot?new s.$qL(new s.$rL(ot.name,v.URI.revive(ot.uri),ot.id,(0,R.$cb)(()=>Qe(ot.id)))):qe===A.$Vr.uriList&&xe.uriListData?new s.$pL(Te(xe.uriListData)):new s.$pL(xe.asString)}Me.to=Fe;async function Ce(qe,xe){const Qe=await xe.asString();if(qe===A.$Vr.uriList)return{asString:Qe,fileData:void 0,uriListData:se(Qe)};const ot=xe.asFile();return{asString:Qe,fileData:ot?{name:ot.name,uri:ot.uri,id:ot._itemId??ot.id}:void 0}}Me.from=Ce;function se(qe){return f.$9s.split(qe).map(xe=>{if(xe.startsWith("#"))return xe;try{return v.URI.parse(xe)}catch{}return xe})}function Te(qe){return f.$9s.create(qe.map(xe=>typeof xe=="string"?xe:v.URI.revive(xe)))}})(mt||(e.DataTransferItem=mt={}));var Nt;(function(Me){function Fe(se,Te){const qe=se.items.map(([xe,Qe])=>[xe,mt.to(xe,Qe,Te)]);return new s.$sL(qe)}Me.toDataTransfer=Fe;async function Ce(se){const Te={items:[]},qe=[];for(const[xe,Qe]of se)qe.push((async()=>{Te.items.push([xe,await mt.from(xe,Qe)])})());return await Promise.all(qe),Te}Me.from=Ce})(Nt||(e.DataTransfer=Nt={}));var Pt;(function(Me){function Fe(Ce){return{kind:"reply",message:Ce.message,title:Ce.title,tooltip:Ce.tooltip}}Me.from=Fe})(Pt||(e.ChatReplyFollowup=Pt={}));var At;(function(Me){function Fe(Ce){return typeof Ce=="string"?{title:Ce,message:Ce,kind:"reply"}:"commandId"in Ce?{kind:"command",title:Ce.title??"",commandId:Ce.commandId??"",when:Ce.when??"",args:Ce.args}:Pt.from(Ce)}Me.from=Fe})(At||(e.ChatFollowup=At={}));var gt;(function(Me){function Fe(se){const Te=new s.$qM(St.to(se.role),se.content);return Te.name=se.name,Te}Me.to=Fe;function Ce(se){return{role:St.from(se.role),content:se.content,name:se.name}}Me.from=Ce})(gt||(e.ChatMessage=gt={}));var St;(function(Me){function Fe(se){switch(se){case 0:return s.ChatMessageRole.System;case 1:return s.ChatMessageRole.User;case 2:return s.ChatMessageRole.Assistant;case 3:return s.ChatMessageRole.Function}}Me.to=Fe;function Ce(se){switch(se){case s.ChatMessageRole.System:return 0;case s.ChatMessageRole.Assistant:return 2;case s.ChatMessageRole.Function:return 3;case s.ChatMessageRole.User:default:return 1}}Me.from=Ce})(St||(e.ChatMessageRole=St={}));var Rt;(function(Me){function Fe(Te){const qe={};for(const xe of Object.keys(Te))qe[xe]=Te[xe].map(Me.to);return qe}Me.objectTo=Fe;function Ce(Te){return{level:It.to(Te.level),value:Te.value,description:Te.description}}Me.to=Ce;function se(Te){return{level:It.from(Te.level),value:Te.value,description:Te.description}}Me.from=se})(Rt||(e.ChatVariable=Rt={}));var It;(function(Me){function Fe(se){switch(se){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Me.to=Fe;function Ce(se){switch(se){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Me.from=Ce})(It||(e.ChatVariableLevel=It={}));var Je;(function(Me){function Fe(Ce){switch(Ce){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return s.InteractiveEditorResponseFeedbackKind.Bug}}Me.to=Fe})(Je||(e.InteractiveEditorResponseFeedbackKind=Je={}));var zt;(function(Me){function Fe(Ce,se){return"placeholder"in se&&"resolvedContent"in se?{placeholder:se.placeholder,kind:"asyncContent"}:"markdownContent"in se?((0,d.$NF)(Ce,"chatAgents2Additions"),{content:O.from(se.markdownContent),kind:"content"}):"content"in se?typeof se.content=="string"?{content:se.content,kind:"content"}:((0,d.$NF)(Ce,"chatAgents2Additions"),{content:O.from(se.content),kind:"content"}):"documents"in se?{documents:se.documents.map(Te=>({uri:Te.uri,version:Te.version,ranges:Te.ranges.map(qe=>u.from(qe))})),kind:"usedContext"}:"reference"in se?{reference:"uri"in se.reference?{uri:se.reference.uri,range:u.from(se.reference.range)}:se.reference,kind:"reference"}:"inlineReference"in se?{inlineReference:"uri"in se.inlineReference?{uri:se.inlineReference.uri,range:u.from(se.inlineReference.range)}:se.inlineReference,name:se.title,kind:"inlineReference"}:"agentName"in se?((0,d.$NF)(Ce,"chatAgents2Additions"),{agentName:se.agentName,command:se.command,kind:"agentDetection"}):{treeData:se.treeData,kind:"treeData"}}Me.from=Fe})(zt||(e.ChatResponseProgress=zt={}));var Jt;(function(Me){function Fe(Ce,se,Te){return"terminalCommand"in Ce?{terminalCommand:Ce.terminalCommand}:"uri"in Ce?{uri:Ce.uri}:se.toInternal(Ce,Te)}Me.from=Fe})(Jt||(e.TerminalQuickFix=Jt={}))}),define(ke[294],Se([1,0,2,8,7,15,75]),function(me,e,C,T,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wec=void 0;class b{constructor(g,A,I,$={timeout:1500,errors:3}){this.c=g,this.d=A,this.f=I,this.g=$,this.a=new L.$2c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(g){return(A,I,$)=>{const S={dispose:this.a.push([A,I,g])};return Array.isArray($)&&$.push(S),S}}async $participateInSave(g,A){const I=C.URI.revive(g);let $=!1;const v=setTimeout(()=>$=!0,this.g.timeout),S=[];try{for(const w of[...this.a]){if($)break;const l=this.d.getDocument(I),o=await this.h(w,{document:l,reason:R.TextDocumentSaveReason.to(A)});S.push(o)}}finally{clearTimeout(v)}return S}h([g,A,I],$){const v=this.b.get(g);return typeof v=="number"&&v>this.g.errors?Promise.resolve(!1):this.i(I,g,A,$).then(()=>!0,S=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this.c.error(S),!(S instanceof Error)||S.message!=="concurrent_edits"){const w=this.b.get(g);this.b.set(g,w?w+1:1),typeof w=="number"&&w>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(g,A,I,$){const v=[],S=Date.now(),{document:w,reason:l}=$,{version:o}=w,i=Object.freeze({document:w,reason:l,waitUntil(n){if(Object.isFrozen(v))throw(0,T.$7)("waitUntil can not be called async");v.push(Promise.resolve(n))}});try{A.apply(I,[i])}catch(n){return Promise.reject(n)}return Object.freeze(v),new Promise((n,r)=>{const a=setTimeout(()=>r(new Error("timeout")),this.g.timeout);return Promise.all(v).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${g.identifier.value}' finished after ${Date.now()-S}ms`),clearTimeout(a),n(t)}).catch(t=>{clearTimeout(a),r(t)})}).then(n=>{const r={edits:[]};for(const a of n)if(Array.isArray(a)&&a.every(t=>t instanceof f.$IK))for(const{newText:t,newEol:s,range:d}of a)r.edits.push({resource:w.uri,versionId:void 0,textEdit:{range:d&&R.Range.from(d),text:t,eol:s&&R.EndOfLine.from(s)}});if(r.edits.length!==0)return o===w.version?this.f.$tryApplyWorkspaceEdit(r):Promise.reject(new Error("concurrent_edits"))})}}e.$Wec=b}),define(ke[295],Se([1,0,17,2,15,7,111]),function(me,e,C,T,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ec=e.$2ec=void 0;class b{constructor(I,$,v,S){this.start=I,this.deletedCount=$,this.deletedItems=v,this.items=S}asApiEvent(){return{range:new R.$YL(this.start,this.start+this.deletedCount),addedCells:this.items.map(I=>I.apiCell),removedCells:this.deletedItems}}}class y{static asModelAddData(I,$){return{EOL:$.eol,lines:$.source,languageId:$.language,uri:$.uri,isDirty:!1,versionId:1,notebook:I}}constructor(I,$,v){this.notebook=I,this.h=$,this.j=v,this.handle=v.handle,this.uri=T.URI.revive(v.uri),this.cellKind=v.cellKind,this.a=v.outputs.map(f.NotebookCellOutput.to),this.e=v.internalMetadata??{},this.b=Object.freeze(v.metadata??{}),this.d=Object.freeze(f.NotebookCellExecutionSummary.to(v.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const I=this,$=this.h.getDocument(this.uri);if(!$)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const v={get index(){return I.notebook.getCellIndex(I)},notebook:I.notebook.apiNotebook,kind:f.NotebookCellKind.to(this.j.cellKind),document:$.document,get mime(){return I.g},set mime(S){I.g=S},get outputs(){return I.a.slice(0)},get metadata(){return I.b},get executionSummary(){return I.d}};this.f=Object.freeze(v)}return this.f}setOutputs(I){this.a=I.map(f.NotebookCellOutput.to)}setOutputItems(I,$,v){const S=v.map(f.NotebookCellOutputItem.to),w=this.a.find(l=>l.id===I);if(w&&($||(w.items.length=0),w.items.push(...S),w.items.length>1&&w.items.every(l=>L.$DI(l.mime)))){const l=new Map,o=[];w.items.forEach(i=>{let n;l.has(i.mime)?n=l.get(i.mime):(n=[],l.set(i.mime,n),o.push(i.mime)),n.push(i.data)}),w.items.length=0,o.forEach(i=>{const n=L.$EI(l.get(i));w.items.push({mime:i,data:n.data.buffer})})}}setMetadata(I){this.b=Object.freeze(I)}setInternalMetadata(I){this.e=I,this.d=Object.freeze(f.NotebookCellExecutionSummary.to(I))}setMime(I){}}e.$2ec=y;class g{static{this.a=0}constructor(I,$,v,S,w){this.k=I,this.l=$,this.m=v,this.uri=S,this.handle=g.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=w.viewType,this.f=Object.freeze(w.metadata??Object.create(null)),this.r([[0,0,w.cells]],!0,void 0),this.g=w.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const I=this,$={get uri(){return I.uri},get version(){return I.g},get notebookType(){return I.d},get isDirty(){return I.h},get isUntitled(){return I.uri.scheme===C.Schemas.untitled},get isClosed(){return I.j},get metadata(){return I.f},get cellCount(){return I.b.length},cellAt(v){return v=I.n(v),I.b[v].apiCell},getCells(v){return(v?I.p(v):I.b).map(w=>w.apiCell)},save(){return I.q()}};this.e=Object.freeze($)}return this.e}acceptDocumentPropertiesChanged(I){I.metadata&&(this.f=Object.freeze({...this.f,...I.metadata}))}acceptDirty(I){this.h=I}acceptModelChanged(I,$,v){this.g=I.versionId,this.h=$,this.acceptDocumentPropertiesChanged({metadata:v});const S={notebook:this.apiNotebook,metadata:v,cellChanges:[],contentChanges:[]},w=[];for(const o of I.rawEvents)o.kind===L.NotebookCellsChangeType.ModelChange?this.r(o.changes,!1,S.contentChanges):o.kind===L.NotebookCellsChangeType.Move?this.s(o.index,o.length,o.newIdx,S.contentChanges):o.kind===L.NotebookCellsChangeType.Output?(this.t(o.index,o.outputs),w.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===L.NotebookCellsChangeType.OutputItem?(this.u(o.index,o.outputId,o.append,o.outputItems),w.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===L.NotebookCellsChangeType.ChangeCellLanguage?(this.v(o.index,o.language),w.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document})):o.kind===L.NotebookCellsChangeType.ChangeCellContent?w.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document}):o.kind===L.NotebookCellsChangeType.ChangeCellMime?this.w(o.index,o.mime):o.kind===L.NotebookCellsChangeType.ChangeCellMetadata?(this.x(o.index,o.metadata),w.push({cell:this.b[o.index].apiCell,metadata:this.b[o.index].apiCell.metadata})):o.kind===L.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(o.index,o.internalMetadata),w.push({cell:this.b[o.index].apiCell,executionSummary:this.b[o.index].apiCell.executionSummary}));const l=new Map;for(let o=0;o<w.length;o++){const i=w[o],n=l.get(i.cell);if(n===void 0){const r=S.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});l.set(i.cell,r-1)}else S.cellChanges[n]={...S.cellChanges[n],...i}}return Object.freeze(S),Object.freeze(S.cellChanges),Object.freeze(S.contentChanges),S}n(I){return I=I|0,I<0?0:I>=this.b.length?this.b.length-1:I}o(I){let $=I.start|0,v=I.end|0;return $<0&&($=0),v>this.b.length&&(v=this.b.length),I.with({start:$,end:v})}p(I){I=this.o(I);const $=[];for(let v=I.start;v<I.end;v++)$.push(this.b[v]);return $}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(I,$,v){if(this.j)return;const S=[],w=[],l=[];if(I.reverse().forEach(o=>{const n=o[2].map(t=>{const s=new y(this,this.l,t);return $||w.push(y.asModelAddData(this.apiNotebook,t)),s}),r=new b(o[0],o[1],[],n),a=this.b.splice(o[0],o[1],...n);for(const t of a)l.push(t.uri),r.deletedItems.push(t.apiCell);S.push(r)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:w,removedDocuments:l}),v)for(const o of S)v.push(o.asApiEvent())}s(I,$,v,S){const w=this.b.splice(I,$);this.b.splice(v,0,...w);const l=[new b(I,$,w.map(o=>o.apiCell),[]),new b(v,0,[],w)];for(const o of l)S.push(o.asApiEvent())}t(I,$){this.b[I].setOutputs($)}u(I,$,v,S){this.b[I].setOutputItems($,v,S)}v(I,$){const v=this.b[I];v.apiCell.document.languageId!==$&&this.m.$acceptModelLanguageChanged(v.uri,$)}w(I,$){const v=this.b[I];v.apiCell.mime=$}x(I,$){this.b[I].setMetadata($)}y(I,$){this.b[I].setInternalMetadata($)}getCellFromApiCell(I){return this.b.find($=>$.apiCell===I)}getCellFromIndex(I){return this.b[I]}getCell(I){return this.b.find($=>$.handle===I)}getCellIndex(I){return this.b.indexOf(I)}}e.$3ec=g}),define(ke[296],Se([1,0,4,2,15,7]),function(me,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gfc=void 0;class L{constructor(y,g,A,I={timeout:1500,errors:3}){this.b=y,this.c=g,this.d=A,this.f=I,this.a=new C.$Td}dispose(){}getOnWillSaveNotebookDocumentEvent(y){return(g,A,I)=>{const $=function(S){g.call(A,S)};return $.extension=y,this.a.event($,void 0,I)}}async $participateInSave(y,g,A){const I=T.URI.revive(y),$=this.c.getNotebookDocument(I);if(!$)throw new Error("Unable to resolve notebook document");const v=[];if(await this.a.fireAsync({notebook:$.apiNotebook,reason:f.TextDocumentSaveReason.to(g)},A,async(w,l)=>{const o=Date.now(),i=await await Promise.resolve(w);Date.now()-o>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",l.extension.identifier),!A.isCancellationRequested&&i&&(i instanceof R.$LK?v.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",l.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if(v.length===0)return!0;const S={edits:[]};for(const w of v){const{edits:l}=f.WorkspaceEdit.from(w);S.edits=S.edits.concat(l)}return this.d.$tryApplyWorkspaceEdit(S)}}e.$gfc=L}),define(ke[148],Se([1,0,8,15,7]),function(me,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ec=void 0;class R{static{this.apiEditorsToExtHost=new WeakMap}constructor(b,y,g,A,I,$){this.id=b,this.f=y,this.notebookData=g,this.a=[],this.b=[],this.d=!1,this.a=I,this.b=A,this.c=$}get apiEditor(){if(!this.e){const b=this;this.e={get notebook(){return b.notebookData.apiNotebook},get selection(){return b.a[0]},set selection(y){this.selections=[y]},get selections(){return b.a},set selections(y){if(!Array.isArray(y)||!y.every(f.$YL.isNotebookRange))throw(0,C.$6)("selections");b.a=y,b.g(y)},get visibleRanges(){return b.b},revealRange(y,g){b.f.$tryRevealRange(b.id,T.NotebookRange.from(y),g??f.NotebookEditorRevealType.Default)},get viewColumn(){return b.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(b){this.d=b}_acceptVisibleRanges(b){this.b=b}_acceptSelections(b){this.a=b}g(b){this.f.$trySetSelections(this.id,b.map(T.NotebookRange.from))}_acceptViewColumn(b){this.c=b}}e.$4ec=R}),define(ke[297],Se([1,0,8,4,14,15]),function(me,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ifc=void 0;let L=class{constructor(y,g){this.c=y,this.d=g,this.a=new T.$Rd({onListenerError:C.$1}),this.b=new T.$Rd({onListenerError:C.$1}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(y,g){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",y,g);const A=this.d.getEditorById(y);g.visibleRanges&&A._acceptVisibleRanges(g.visibleRanges.ranges.map(R.NotebookRange.to)),g.selections&&A._acceptSelections(g.selections.selections.map(R.NotebookRange.to)),g.visibleRanges&&this.b.fire({notebookEditor:A.apiEditor,visibleRanges:A.apiEditor.visibleRanges}),g.selections&&this.a.fire(Object.freeze({notebookEditor:A.apiEditor,selections:A.apiEditor.selections}))}$acceptEditorViewColumns(y){for(const g in y)this.d.getEditorById(g)._acceptViewColumn(R.ViewColumn.to(y[g]))}};e.$ifc=L,e.$ifc=L=He([Be(0,f.$dj)],L)}),define(ke[298],Se([1,0,15,85,216,21,59,8]),function(me,e,C,T,f,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pfc=void 0;class y{constructor($){this.b=0,this.c=new Map,this.a=$}async withProgress($,v,S){const w=this.b++,{title:l,location:o,cancellable:i}=v,n={label:(0,f.localize)(0,null,$.displayName||$.name),id:$.identifier.value};return this.a.$startProgress(w,{location:C.ProgressLocation.from(o),title:l,source:n,cancellable:i},$.isUnderDevelopment?void 0:$.identifier.value).catch(b.$1),this.d(w,S,!!i)}d($,v,S){let w;S&&(w=new R.$2d,this.c.set($,w));const l=i=>{this.a.$progressEnd(i),this.c.delete(i),w?.dispose()};let o;try{o=v(new A(this.a,$),S&&w?w.token:R.CancellationToken.None)}catch(i){throw l($),i}return o.then(i=>l($),i=>l($)),o}$acceptProgressCanceled($){const v=this.c.get($);v&&(v.cancel(),this.c.delete($))}}e.$pfc=y;function g(I,$){return I.message=$.message,typeof $.increment=="number"&&(typeof I.increment=="number"?I.increment+=$.increment:I.increment=$.increment),I}class A extends T.$$u{constructor($,v){super(S=>this.throttledReport(S)),this.c=$,this.d=v}throttledReport($){this.c.$progressReport(this.d,$)}}He([(0,L.$ph)(100,(I,$)=>g(I,$),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(ke[149],Se([1,0,29,144,67,112,89,15,2]),function(me,e,C,T,f,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QM=e.$PM=e.$OM=e.$NM=void 0;const g=(n,r,a,t)=>{let s=r;return{enumerable:!0,configurable:!1,get(){return s},set(d){if(!a(s,d)){const c=s;s=d,n.listener?.(t(d,c))}}}},A=(n,r)=>n===r,I={range:(n,r)=>n===r?!0:!n||!r?!1:n.isEqual(r),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(n,r)=>!(n.length!==r.length||n.some(a=>!r.find(t=>a.id===t.id)))},$=n=>r=>({op:4,update:n(r)}),v=(n,r)=>({range:(()=>{let a;const t=$(s=>({range:C.$zs.lift(b.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return a},set(s){n.listener?.({op:6}),I.range(a,s)||(a=s,n.listener?.(t(s)))}}})(),label:g(n,r,I.label,$(a=>({label:a}))),description:g(n,void 0,I.description,$(a=>({description:a}))),sortText:g(n,void 0,I.sortText,$(a=>({sortText:a}))),canResolveChildren:g(n,!1,I.canResolveChildren,a=>({op:2,state:a})),busy:g(n,!1,I.busy,$(a=>({busy:a}))),error:g(n,void 0,I.error,$(a=>({error:b.MarkdownString.fromStrict(a)||null}))),tags:g(n,[],I.tags,(a,t)=>({op:1,new:a.map(b.TestTag.from),old:t.map(b.TestTag.from)}))}),S=n=>{const r=f.$sJ.fromString(n.extId),a=new l(r.controllerId,r.localId,n.label,y.URI.revive(n.uri)||void 0);return a.range=b.Range.to(n.range||void 0),a.description=n.description||void 0,a.sortText=n.sortText||void 0,a.tags=n.tags.map(t=>b.TestTag.to({id:(0,L.$xJ)(t).tagId})),a},w=n=>{let r;for(const a of n.tests){const t=S(a.item);(0,T.$xM)(t).parent=r,r=t}return r};e.$NM=w;class l{constructor(r,a,t,s){if(a.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(a)} symbol`);const d=(0,T.$wM)(this,r);Object.defineProperties(this,{id:{value:a,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return d.parent instanceof o?void 0:d.parent}},children:{value:(0,R.$vM)(d,T.$xM,l),enumerable:!0,writable:!1},...v(d,t)})}}e.$OM=l;class o extends l{constructor(r,a){super(r,r,a,void 0),this._isRoot=!0}}e.$PM=o;class i extends R.$rM{constructor(r,a,t){super({controllerId:r,getDocumentVersion:s=>s&&t.getDocument(s)?.version,getApiFor:T.$xM,getChildren:s=>s.children,root:new o(r,a),toITestItem:b.TestItem.from})}}e.$QM=i}),define(ke[150],Se([1,0,60,8,122,15,7]),function(me,e,C,T,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KM=e.$JM=e.$IM=void 0;class b{static{this.c=new f.$GM("TextEditorDecorationType")}constructor($,v,S){const w=b.c.nextId();$.$registerTextEditorDecorationType(v.identifier,w,R.DecorationRenderOptions.from(S)),this.value=Object.freeze({key:w,dispose(){$.$removeTextEditorDecorationType(w)}})}}e.$IM=b;class y{constructor($,v){this.g=[],this.h=void 0,this.j=!1,this.c=$,this.d=$.version,this.e=v.undoStopBefore,this.f=v.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace($,v){this.k();let S=null;if($ instanceof L.$CK)S=new L.$DK($,$);else if($ instanceof L.$DK)S=$;else throw new Error("Unrecognized location");this.l(S,v,!1)}insert($,v){this.k(),this.l(new L.$DK($,$),v,!0)}delete($){this.k();let v=null;if($ instanceof L.$DK)v=$;else throw new Error("Unrecognized location");this.l(v,null,!0)}l($,v,S){const w=this.c.validateRange($);this.g.push({range:w,text:v,forceMoveMarkers:S})}setEndOfLine($){if(this.k(),$!==L.EndOfLine.LF&&$!==L.EndOfLine.CRLF)throw(0,T.$6)("endOfLine");this.h=$}}class g{constructor($,v,S,w){this.c=$,this.d=v,this._accept(S),this.e=w;const l=this;this.value={get tabSize(){return l.f},set tabSize(o){l.m(o)},get indentSize(){return l.g},set indentSize(o){l.o(o)},get insertSpaces(){return l.h},set insertSpaces(o){l.q(o)},get cursorStyle(){return l.j},set cursorStyle(o){l.s(o)},get lineNumbers(){return l.k},set lineNumbers(o){l.t(o)}}}_accept($){this.f=$.tabSize,this.g=$.indentSize,this.h=$.insertSpaces,this.j=$.cursorStyle,this.k=R.TextEditorLineNumbersStyle.to($.lineNumbers)}l($){if($==="auto")return"auto";if(typeof $=="number"){const v=Math.floor($);return v>0?v:null}if(typeof $=="string"){const v=parseInt($,10);return isNaN(v)?null:v>0?v:null}return null}m($){const v=this.l($);if(v!==null){if(typeof v=="number"){if(this.f===v)return;this.f=v}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:v}))}}n($){if($==="tabSize")return"tabSize";if(typeof $=="number"){const v=Math.floor($);return v>0?v:null}if(typeof $=="string"){const v=parseInt($,10);return isNaN(v)?null:v>0?v:null}return null}o($){const v=this.n($);if(v!==null){if(typeof v=="number"){if(this.g===v)return;this.g=v}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:v}))}}p($){return $==="auto"?"auto":$==="false"?!1:!!$}q($){const v=this.p($);if(typeof v=="boolean"){if(this.h===v)return;this.h=v}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:v}))}s($){this.j!==$&&(this.j=$,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:$})))}t($){this.k!==$&&(this.k=$,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from($)})))}assign($){const v={};let S=!1;if(typeof $.tabSize<"u"){const w=this.l($.tabSize);w==="auto"?(S=!0,v.tabSize=w):typeof w=="number"&&this.f!==w&&(this.f=w,S=!0,v.tabSize=w)}if(typeof $.indentSize<"u"){const w=this.n($.indentSize);w==="tabSize"?(S=!0,v.indentSize=w):typeof w=="number"&&this.g!==w&&(this.g=w,S=!0,v.indentSize=w)}if(typeof $.insertSpaces<"u"){const w=this.p($.insertSpaces);w==="auto"?(S=!0,v.insertSpaces=w):this.h!==w&&(this.h=w,S=!0,v.insertSpaces=w)}typeof $.cursorStyle<"u"&&this.j!==$.cursorStyle&&(this.j=$.cursorStyle,S=!0,v.cursorStyle=$.cursorStyle),typeof $.lineNumbers<"u"&&this.k!==$.lineNumbers&&(this.k=$.lineNumbers,S=!0,v.lineNumbers=R.TextEditorLineNumbersStyle.from($.lineNumbers)),S&&this.u("setOptions",this.c.$trySetOptions(this.d,v))}u($,v){v.catch(S=>{this.e.warn(`ExtHostTextEditorOptions '${$}' failed:'`),this.e.warn(S)})}}e.$JM=g;class A{constructor($,v,S,w,l,o,i,n){this.id=$,this.j=v,this.k=S,this.g=!1,this.h=new Set,this.c=l,this.d=new g(this.j,this.id,o,S),this.e=i,this.f=n;const r=this;this.value=Object.freeze({get document(){return w.value},set document(a){throw new T.$8("document")},get selection(){return r.c&&r.c[0]},set selection(a){if(!(a instanceof L.$EK))throw(0,T.$6)("selection");r.c=[a],r.l()},get selections(){return r.c},set selections(a){if(!Array.isArray(a)||a.some(t=>!(t instanceof L.$EK)))throw(0,T.$6)("selections");r.c=a,r.l()},get visibleRanges(){return r.e},set visibleRanges(a){throw new T.$8("visibleRanges")},get options(){return r.d.value},set options(a){r.g||r.d.assign(a)},get viewColumn(){return r.f},set viewColumn(a){throw new T.$8("viewColumn")},edit(a,t={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new y(w.value,t);return a(s),r.m(s)},insertSnippet(a,t,s={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let d;if(!t||Array.isArray(t)&&t.length===0)d=r.c.map(c=>R.Range.from(c));else if(t instanceof L.$CK){const{lineNumber:c,column:u}=R.Position.from(t);d=[{startLineNumber:c,startColumn:u,endLineNumber:c,endColumn:u}]}else if(t instanceof L.$DK)d=[R.Range.from(t)];else{d=[];for(const c of t)if(c instanceof L.$DK)d.push(R.Range.from(c));else{const{lineNumber:u,column:h}=R.Position.from(c);d.push({startLineNumber:u,startColumn:h,endLineNumber:u,endColumn:h})}}return v.$tryInsertSnippet($,w.value.version,a.value,d,s)},setDecorations(a,t){const s=t.length===0;s&&!r.h.has(a.key)||(s?r.h.delete(a.key):r.h.add(a.key),r.n(()=>{if(R.$yM(t))return v.$trySetDecorations($,a.key,R.$zM(t));{const d=new Array(4*t.length);for(let c=0,u=t.length;c<u;c++){const h=t[c];d[4*c]=h.start.line+1,d[4*c+1]=h.start.character+1,d[4*c+2]=h.end.line+1,d[4*c+3]=h.end.character+1}return v.$trySetDecorationsFast($,a.key,d)}}))},revealRange(a,t){r.n(()=>v.$tryRevealRange($,R.Range.from(a),t||L.TextEditorRevealType.Default))},show(a){v.$tryShowEditor($,R.ViewColumn.from(a))},hide(){v.$tryHideEditor($)}})}dispose(){(0,C.ok)(!this.g),this.g=!0}_acceptOptions($){(0,C.ok)(!this.g),this.d._accept($)}_acceptVisibleRanges($){(0,C.ok)(!this.g),this.e=$}_acceptViewColumn($){(0,C.ok)(!this.g),this.f=$}_acceptSelections($){(0,C.ok)(!this.g),this.c=$}async l(){const $=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,$)),this.value}m($){const v=$.finalize();if(v.edits.length===0&&!v.setEndOfLine)return Promise.resolve(!0);const S=v.edits.map(l=>l.range);S.sort((l,o)=>l.end.line===o.end.line?l.end.character===o.end.character?l.start.line===o.start.line?l.start.character-o.start.character:l.start.line-o.start.line:l.end.character-o.end.character:l.end.line-o.end.line);for(let l=0,o=S.length-1;l<o;l++){const i=S[l].end;if(S[l+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const w=v.edits.map(l=>({range:R.Range.from(l.range),text:l.text,forceMoveMarkers:l.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,v.documentVersionId,w,{setEndOfLine:typeof v.setEndOfLine=="number"?R.EndOfLine.from(v.setEndOfLine):void 0,undoStopBefore:v.undoStopBefore,undoStopAfter:v.undoStopAfter})}n($){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):$().then(()=>this,v=>(v instanceof Error&&v.name==="DISPOSED"||this.k.warn(v),null))}}e.$KM=A}),define(ke[299],Se([1,0,220,23,2,4,3,279,12,7,18,19,15,80,21,177,25]),function(me,e,C,T,f,R,L,b,y,g,A,I,$,v,S,w,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ifc=void 0;function o(r,a){if((0,A.$Cf)(r))return{label:r};if(r&&typeof r=="object"&&typeof r.label=="string"){let t;return Array.isArray(r.highlights)&&(t=r.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),t=t.length?t:void 0),{label:r.label,highlights:t}}}class i extends L.$Rc{constructor(a,t,s){super(),this.f=a,this.g=t,this.h=s,this.a=new Map,this.b=new w.$R7;function d(c){return c&&c.$treeViewId&&(c.$treeItemHandle||c.$selectedTreeItems||c.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:c=>d(c)?this.r(c):Array.isArray(c)&&c.length>0?c.map(u=>d(u)?this.r(u):u):c})}registerTreeDataProvider(a,t,s){const d=this.createTreeView(a,{treeDataProvider:t},s);return{dispose:()=>d.dispose()}}createTreeView(a,t,s){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=t.dragAndDropController?.dropMimeTypes??[],c=t.dragAndDropController?.dragMimeTypes??[],u=!!t.dragAndDropController?.handleDrag,h=!!t.dragAndDropController?.handleDrop,E=this.m(a,t,s),D={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:d,dragMimeTypes:c,hasHandleDrag:u,hasHandleDrop:h,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},m=this.f.$registerTreeViewDataProvider(a,D),p={get onDidCollapseElement(){return E.onDidCollapseElement},get onDidExpandElement(){return E.onDidExpandElement},get selection(){return E.selectedElements},get onDidChangeSelection(){return E.onDidChangeSelection},get activeItem(){return(0,l.$NF)(s,"treeViewActiveItem"),E.focusedElement},get onDidChangeActiveItem(){return(0,l.$NF)(s,"treeViewActiveItem"),E.onDidChangeActiveItem},get visible(){return E.visible},get onDidChangeVisibility(){return E.onDidChangeVisibility},get onDidChangeCheckboxState(){return E.onDidChangeCheckboxState},get message(){return E.message},set message(k){(0,v.$$j)(k)&&(0,l.$NF)(s,"treeViewMarkdownMessage"),E.message=k},get title(){return E.title},set title(k){E.title=k},get description(){return E.description},set description(k){E.description=k},get badge(){return E.badge},set badge(k){k!==void 0&&g.ViewBadge.isViewBadge(k)?E.badge={value:Math.floor(Math.abs(k.value)),tooltip:k.tooltip}:k===void 0&&(E.badge=void 0)},reveal:(k,P)=>E.reveal(k,P),dispose:async()=>{await m,this.a.delete(a),E.dispose()}};return this.B(p),p}$getChildren(a,t){const s=this.a.get(a);return s?s.getChildren(t):Promise.reject(new b.$KE(a))}async $handleDrop(a,t,s,d,c,u,h,E){const D=this.a.get(a);if(!D)return Promise.reject(new b.$KE(a));const m=$.DataTransfer.toDataTransfer(s,async p=>(await this.f.$resolveDropFileData(a,t,p)).buffer);return h===a&&E&&await this.j(m,D,E,c,u),D.onDrop(m,d,c)}async j(a,t,s,d,c){const u=this.b.removeDragOperationTransfer(c);if(u)(await u)?.forEach((h,E)=>{h&&a.set(E,h)});else if(c&&t.handleDrag){const h=t.handleDrag(s,a,d);this.b.addDragOperationTransfer(c,h),await h}return a}async $handleDrag(a,t,s,d){const c=this.a.get(a);if(!c)return Promise.reject(new b.$KE(a));const u=await this.j(new g.$sL,c,t,d,s);if(!(!u||d.isCancellationRequested))return $.DataTransfer.from(u)}async $hasResolve(a){const t=this.a.get(a);if(!t)throw new b.$KE(a);return t.hasResolve}$resolve(a,t,s){const d=this.a.get(a);if(!d)throw new b.$KE(a);return d.resolveTreeItem(t,s)}$setExpanded(a,t,s){const d=this.a.get(a);if(!d)throw new b.$KE(a);d.setExpanded(t,s)}$setSelectionAndFocus(a,t,s){const d=this.a.get(a);if(!d)throw new b.$KE(a);d.setSelectionAndFocus(t,s)}$setVisible(a,t){const s=this.a.get(a);if(!s){if(!t)return;throw new b.$KE(a)}s.setVisible(t)}$changeCheckboxState(a,t){const s=this.a.get(a);if(!s)throw new b.$KE(a);s.setCheckboxState(t)}m(a,t,s){const d=this.B(new n(a,t,this.f,this.g.converter,this.h,s));return this.a.set(a,d),d}r(a){const t=this.a.get(a.$treeViewId);return t&&"$treeItemHandle"in a?t.getExtensionElement(a.$treeItemHandle):t&&"$focusedTreeItem"in a&&a.$focusedTreeItem?t.focusedElement:null}}e.$Ifc=i;class n extends L.$Rc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(a=>this.getExtensionElement(a)).filter(a=>!(0,A.$Lf)(a))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(a,t,s,d,c,u){if(super(),this.I=a,this.J=s,this.L=d,this.M=c,this.N=u,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new R.$Rd),this.onDidExpandElement=this.u.event,this.w=this.B(new R.$Rd),this.onDidCollapseElement=this.w.event,this.y=this.B(new R.$Rd),this.onDidChangeSelection=this.y.event,this.z=this.B(new R.$Rd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new R.$Rd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new R.$Rd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new R.$Rd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new S.$2d,u.contributes&&u.contributes.views)for(const m in u.contributes.views)for(const p of u.contributes.views[m])p.id===a&&(this.P=p.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(m=>this.F.fire({message:!1,element:m})));let h,E;const D=R.Event.debounce(this.F.event,(m,p)=>(m||(m={message:!1,elements:[]}),p.element!==!1&&(h||(h=new Promise(k=>E=k),this.G=this.G.then(()=>h)),Array.isArray(p.element)?m.elements.push(...p.element):m.elements.push(p.element)),p.message&&(m.message=!0),m),200,!0);this.B(D(({message:m,elements:p})=>{p.length&&(this.H=this.H.then(()=>{const k=E;return h=null,this.$(p).then(()=>k())})),m&&this.J.$setMessage(this.I,$.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(a){const t=a?this.getExtensionElement(a):void 0;if(a&&!t)return this.M.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let s=this.X(a);return s||(s=await this.Y(t)),s?s.map(d=>d.item):void 0}getExtensionElement(a){return this.j.get(a)}reveal(a,t){t=t||{select:!0,focus:!1};const s=(0,A.$Lf)(t.select)?!0:t.select,d=(0,A.$Lf)(t.focus)?!1:t.focus,c=(0,A.$Lf)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.G.then(()=>this.S(a)).then(u=>this.W(a,u[u.length-1]).then(h=>this.J.$reveal(this.I,{item:h.item,parentChain:u.map(E=>E.item)},{select:s,focus:d,expand:c})),u=>this.M.error(u)):this.J.$reveal(this.I,void 0,{select:s,focus:d,expand:c})}get message(){return this.O}set message(a){this.O=a,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(a){this.P=a,this.J.$setTitle(this.I,a,this.Q)}get description(){return this.Q}set description(a){this.Q=a,this.J.$setTitle(this.I,this.P,a)}get badge(){return this.R}set badge(a){this.R?.value===a?.value&&this.R?.tooltip===a?.tooltip||(this.R=$.ViewBadge.from(a),this.J.$setBadge(this.I,a))}setExpanded(a,t){const s=this.getExtensionElement(a);s&&(t?this.u.fire(Object.freeze({element:s})):this.w.fire(Object.freeze({element:s})))}setSelectionAndFocus(a,t){const s=!(0,I.$tb)(this.s,a);this.s=a;const d=this.t!==t;this.t=t,s&&this.y.fire(Object.freeze({selection:this.selectedElements})),d&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(a){a!==this.r&&(this.r=a,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(a){const t=(await Promise.all(a.map(async s=>{const d=this.getExtensionElement(s.treeItemHandle);return d?{extensionItem:d,treeItem:await this.f.getTreeItem(d),newState:s.newState?g.TreeItemCheckboxState.Checked:g.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);t.forEach(s=>{s.treeItem.checkboxState=s.newState?g.TreeItemCheckboxState.Checked:g.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(s=>[s.extensionItem,s.newState])})}async handleDrag(a,t,s){const d=[];for(const c of a){const u=this.getExtensionElement(c);u&&d.push(u)}if(!(!this.g?.handleDrag||d.length===0))return await this.g.handleDrag(d,t,s),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(a,t,s){const d=t?this.getExtensionElement(t):void 0;if(!(!d&&t||!this.g?.handleDrop))return(0,y.$Qg)(()=>this.g?.handleDrop?this.g.handleDrop(d,a,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(a,t){if(!this.f.resolveTreeItem)return;const s=this.j.get(a);if(s){const d=this.m.get(s);if(d){const c=await this.f.resolveTreeItem(d.extensionItem,s,t)??d.extensionItem;return this.hb(c),d.item.tooltip=this.eb(c.tooltip),d.item.command=this.fb(d.disposableStore,c.command),d.item}}}S(a){return this.U(a).then(t=>t?this.S(t).then(s=>this.W(t,s[s.length-1]).then(d=>(s.push(d),s))):Promise.resolve([]))}U(a){const t=this.m.get(a);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,y.$Qg)(()=>this.f.getParent(a))}W(a,t){const s=this.m.get(a);return s?Promise.resolve(s):(0,y.$Qg)(()=>this.f.getTreeItem(a)).then(d=>this.kb(a,d,t,!0)).then(d=>this.getChildren(t?t.item.handle:void 0).then(()=>{const c=this.getExtensionElement(d);if(c){const u=this.m.get(c);if(u)return Promise.resolve(u)}throw new Error(`Cannot resolve tree item for element ${d} from extension ${this.N.identifier.value}`)}))}X(a){if(a){let t;if(typeof a=="string"){const s=this.getExtensionElement(a);t=s?this.m.get(s):void 0}else t=a;return t&&t.children||void 0}return this.h}async Y(a){this.rb(a);const t=new S.$2d(this.Z.token);try{const s=a?this.m.get(a):void 0,d=await this.f.getChildren(a);if(t.token.isCancellationRequested)return;const c=await Promise.all((0,I.$Gb)(d||[]).map(async u=>{const h=await this.f.getTreeItem(u);return h&&!t.token.isCancellationRequested?this.db(u,h,s):null}));return t.token.isCancellationRequested?void 0:(0,I.$Gb)(c)}finally{t.dispose()}}$(a){if(a.some(s=>!s))return this.Z.dispose(!0),this.Z=new S.$2d,this.tb(),this.J.$refresh(this.I);{const s=this.ab(a);if(s.length)return this.bb(s)}return Promise.resolve(void 0)}ab(a){const t=new Set,s=a.map(c=>this.m.get(c));for(const c of s)if(c&&!t.has(c.item.handle)){let u=c;for(;u&&u.parent&&s.findIndex(h=>u&&u.parent&&h&&h.item.handle===u.parent.item.handle)===-1;){const h=this.j.get(u.parent.item.handle);u=h?this.m.get(h):void 0}u&&!u.parent&&t.add(c.item.handle)}const d=[];return t.forEach(c=>{const u=this.j.get(c);if(u){const h=this.m.get(u);h&&(!h.parent||!t.has(h.parent.item.handle))&&d.push(c)}}),d}bb(a){const t={};return Promise.all(a.map(s=>this.cb(s).then(d=>{d&&(t[s]=d.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(a){const t=this.getExtensionElement(a);if(t){const s=this.m.get(t);if(s)return this.rb(t),(0,y.$Qg)(()=>this.f.getTreeItem(t)).then(d=>{if(d){const c=this.ib(t,d,s.parent);return this.pb(t,c,s,s.parent),s.dispose(),c}return null})}return Promise.resolve(null)}db(a,t,s){const d=this.ib(a,t,s);if(t.id&&this.j.has(d.item.handle))throw new Error((0,C.localize)(0,null,t.id));return this.ob(a,d),this.qb(d,s),d}eb(a){return g.$2K.isMarkdownString(a)?$.MarkdownString.from(a):a}fb(a,t){return t?{...this.L.toInternal(t,a),originalId:t.command}:void 0}gb(a){if(a.checkboxState===void 0)return;let t,s,d;return typeof a.checkboxState=="number"?t=a.checkboxState:(t=a.checkboxState.state,s=a.checkboxState.tooltip,d=a.checkboxState.accessibilityInformation),{isChecked:t===g.TreeItemCheckboxState.Checked,tooltip:s,accessibilityInformation:d}}hb(a){if(!g.$nL.isTreeItem(a,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(a,t,s){this.hb(t);const d=this.B(new L.$Qc),c=this.kb(a,t,s),u=this.lb(t);return{item:{handle:c,parentHandle:s?s.item.handle:void 0,label:o(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(d,t.command),contextValue:t.contextValue,icon:u,iconDark:this.mb(t)||u,themeIcon:this.jb(t),collapsibleState:(0,A.$Lf)(t.collapsibleState)?g.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:s,children:void 0,disposableStore:d,dispose(){d.dispose()}}}jb(a){return a.iconPath instanceof g.$vL?a.iconPath:void 0}kb(a,{id:t,label:s,resourceUri:d},c,u){if(t)return`${n.b}/${t}`;const h=o(s,this.N),E=c?c.item.handle:n.a;let D=h?h.label:d?(0,T.$wg)(d):"";D=D.indexOf("/")!==-1?D.replace("/","//"):D;const m=this.m.has(a)?this.m.get(a).item.handle:void 0,p=this.X(c)||[];let k,P=0;do{if(k=`${E}/${P}:${D}`,u||!this.j.has(k)||m===k)break;P++}while(P<=p.length);return k}lb(a){if(a.iconPath&&!(a.iconPath instanceof g.$vL))return typeof a.iconPath=="string"||f.URI.isUri(a.iconPath)?this.nb(a.iconPath):this.nb(a.iconPath.light)}mb(a){if(a.iconPath&&!(a.iconPath instanceof g.$vL)&&a.iconPath.dark)return this.nb(a.iconPath.dark)}nb(a){return f.URI.isUri(a)?a:f.URI.file(a)}ob(a,t){this.j.set(t.item.handle,a),this.m.set(a,t)}pb(a,t,s,d){this.j.delete(t.item.handle),this.m.delete(a),t.item.handle!==s.item.handle&&this.j.delete(s.item.handle),this.ob(a,t);const c=this.X(d)||[],u=c.filter(h=>h.item.handle===s.item.handle)[0];u&&c.splice(c.indexOf(u),1,t)}qb(a,t){t?(t.children||(t.children=[]),t.children.push(a)):(this.h||(this.h=[]),this.h.push(a))}rb(a){if(a){const t=this.m.get(a);if(t){if(t.children)for(const s of t.children){const d=this.j.get(s.item.handle);d&&this.sb(d)}t.children=void 0}}else this.tb()}sb(a){const t=this.m.get(a);if(t){if(t.children)for(const s of t.children){const d=this.j.get(s.item.handle);d&&this.sb(d)}this.m.delete(a),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(a=>a.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(ke[300],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmInputBoxActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxActionButton.d.ts",scmInputBoxValueProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxValueProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ke[301],Se([1,0,234,8,39,135,108,37,26,300,138,139]),function(me,e,C,T,f,R,L,b,y,g,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=void 0;const $=b.$mn.as(L.$nn.JSONContribution);class v{constructor(a,t,s){this.a=a,this.b=t,this.c=s}d(a,t){this.a({type:a,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(a){this.d(f.default.Error,a)}warn(a){this.d(f.default.Warning,a)}info(a){this.d(f.default.Info,a)}}e.$TF=v;class S{static a(a){const t=new y.$am;for(let s=0,d=a.length;s<d;s++)t.add(a[s].description.identifier);return t}static compute(a,t){if(!a||!a.length)return new S(t,[]);if(!t||!t.length)return new S([],a);const s=this.a(a),d=this.a(t),c=t.filter(h=>!s.has(h.description.identifier)),u=a.filter(h=>!d.has(h.description.identifier));return new S(c,u)}constructor(a,t){this.added=a,this.removed=t}}e.$UF=S;class w{constructor(a,t){this.name=a,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(a){if(this.a!==null)throw new Error("Handler already set!");this.a=a,this.d()}acceptUsers(a){this.c=S.compute(this.b,a),this.b=a,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(a){(0,T.$Z)(a)}}}e.$VF=w;const l={type:"string",enum:["ui","workspace"],enumDescriptions:[C.localize(0,null),C.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.$WF={properties:{engines:{type:"object",description:C.localize(2,null),properties:{vscode:{type:"string",description:C.localize(3,null),default:"^1.22.0"}}},publisher:{description:C.localize(4,null),type:"string"},displayName:{description:C.localize(5,null),type:"string"},categories:{description:C.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:y.$$l},{type:"string",const:"Languages",deprecationMessage:C.localize(7,null)}]}},galleryBanner:{type:"object",description:C.localize(8,null),properties:{color:{description:C.localize(9,null),type:"string"},theme:{description:C.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:C.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:C.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:C.localize(13,null)},enabledApiProposals:{markdownDescription:C.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}},api:{markdownDescription:C.localize(15,null),type:"string",enum:["none"],enumDescriptions:[C.localize(16,null)]},activationEvents:{description:C.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:C.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:C.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:C.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:C.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:C.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:C.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:C.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:C.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:C.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:C.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:C.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:C.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:C.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:C.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:C.localize(32,null)},{label:"onUri",body:"onUri",description:C.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:C.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:C.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:C.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:C.localize(37,null)},{label:"onRenderer",description:C.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:C.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:C.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:C.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:C.localize(42,null)},{label:"*",description:C.localize(43,null),body:"*"}]}},badges:{type:"array",description:C.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:C.localize(45,null)},href:{type:"string",description:C.localize(46,null)},description:{type:"string",description:C.localize(47,null)}}}},markdown:{type:"string",description:C.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:C.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:C.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$4n}},extensionPack:{description:C.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$4n}},extensionKind:{description:C.localize(52,null),type:"array",items:l,default:["workspace"],defaultSnippets:[{body:["ui"],description:C.localize(53,null)},{body:["workspace"],description:C.localize(54,null)},{body:["ui","workspace"],description:C.localize(55,null)},{body:["workspace","ui"],description:C.localize(56,null)},{body:[],description:C.localize(57,null)}]},capabilities:{description:C.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:C.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:C.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[C.localize(61,null),C.localize(62,null),C.localize(63,null)]},description:{type:"string",markdownDescription:C.localize(64,null)}}},untrustedWorkspaces:{description:C.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:C.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[C.localize(67,null),C.localize(68,null),C.localize(69,null)]},restrictedConfigurations:{description:C.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:C.localize(71,null)}}}}},sponsor:{description:C.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:C.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:C.localize(74,null),type:"string"},"vscode:uninstall":{description:C.localize(75,null),type:"string"}}},icon:{type:"string",description:C.localize(76,null)},l10n:{type:"string",description:C.localize(77,null)},pricing:{type:"string",markdownDescription:C.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(a){if(this.a.has(a.extensionPoint))throw new Error("Duplicate extension point: "+a.extensionPoint);const t=new w(a.extensionPoint,a.defaultExtensionKind);return this.a.set(a.extensionPoint,t),a.activationEventsGenerator&&I.$yF.register(a.extensionPoint,a.activationEventsGenerator),e.$WF.properties.contributes.properties[a.extensionPoint]=a.jsonSchema,$.registerSchema(o,e.$WF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$XF=i;const n={ExtensionsRegistry:"ExtensionsRegistry"};b.$mn.add(n.ExtensionsRegistry,new i),e.$YF=b.$mn.as(n.ExtensionsRegistry),$.registerSchema(o,e.$WF),$.registerSchema(A.$wj,{properties:{extensionEnabledApiProposals:{description:C.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(g.allApiProposals),markdownEnumDescriptions:Object.values(g.allApiProposals)}}]}}}})}),define(ke[302],Se([1,0,230,18,24,301,45,4]),function(me,e,C,T,f,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8F=void 0;const y={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:C.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:C.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:C.localize(2,null),default:""}}};var g;(function($){function v(S,w,l){if(!S)return;const o=T.$Cf(S.type)?S.type:void 0;if(!o||o.length===0){l.error(C.localize(3,null));return}const i=[];if(Array.isArray(S.required))for(const n of S.required)T.$Cf(n)&&i.push(n);return{extensionId:w.value,taskType:o,required:i,properties:S.properties?f.$an(S.properties):{},when:S.when?L.$Ti.deserialize(S.when):void 0}}$.from=v})(g||(g={}));const A=R.$YF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:($,v)=>{for(const S of $)S.type&&v.push(`onTaskType:${S.type}`)},jsonSchema:{description:C.localize(4,null),type:"array",items:y}});class I{constructor(){this.d=new b.$Rd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((v,S)=>{A.setHandler((w,l)=>{this.c=void 0;try{for(const o of l.removed){const i=o.value;for(const n of i)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const o of l.added){const i=o.value;for(const n of i){const r=g.from(n,o.description.identifier,o.collector);r&&(this.a[r.taskType]=r)}}(l.removed.length>0||l.added.length>0)&&this.d.fire()}catch{}v(void 0)})})}onReady(){return this.b}get(v){return this.a[v]}all(){return Object.keys(this.a).map(v=>this.a[v])}getJsonSchema(){if(this.c===void 0){const v=[];for(const S of this.all()){const w={type:"object",additionalProperties:!1};S.required.length>0&&(w.required=S.required.slice(0)),S.properties!==void 0?w.properties=f.$an(S.properties):w.properties=Object.create(null),w.properties.type={type:"string",enum:[S.taskType]},v.push(w)}this.c={oneOf:v}}return this.c}}e.$8F=new I}),define(ke[303],Se([1,0,231,18,23,24,45,302]),function(me,e,C,T,f,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$fG=e.JsonSchemaVersion=e.ExecutionEngine=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$_F=e.ShellQuoting=e.$$F=e.$0F=e.$9F=void 0,e.$9F="settings",e.$0F=new L.$aj("taskRunning",!1,C.localize(0,null)),e.$$F={value:C.localize(1,null),original:"Tasks"};var y;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(y||(e.ShellQuoting=y={})),e.$_F="$customized",function(F){function N(W){if(!W)return F.Strong;switch(W.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=N}(y||(e.ShellQuoting=y={}));var g;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(g||(e.CommandOptions=g={}));var A;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(A||(e.RevealKind=A={})),function(F){function N(W){switch(W.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=N}(A||(e.RevealKind=A={}));var I;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(I||(e.RevealProblemKind=I={})),function(F){function N(W){switch(W.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=N}(I||(e.RevealProblemKind=I={}));var $;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})($||(e.PanelKind=$={})),function(F){function N(W){switch(W.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=N}($||(e.PanelKind=$={}));var v;(function(F){F.defaults={echo:!0,reveal:A.Always,revealProblems:I.Never,focus:!1,panel:$.Shared,showReuseMessage:!0,clear:!1}})(v||(e.PresentationOptions=v={}));var S;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(S||(e.RuntimeType=S={})),function(F){function N(X){switch(X.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=N;function W(X){switch(X){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=W}(S||(e.RuntimeType=S={}));var w;(function(F){function N(W){return T.$Cf(W)?W:W.value}F.value=N})(w||(e.CommandString=w={}));var l;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function N(X){return X===F.Clean._id||X===F.Build._id||X===F.Rebuild._id||X===F.Test._id}F.is=N;function W(X){if(X!==void 0)return T.$Cf(X)?N(X)?{_id:X,isDefault:!1}:void 0:X}F.from=W})(l||(e.TaskGroup=l={}));var o;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(o||(e.TaskScope=o={}));var i;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function N(W){switch(W){case F.User:return 2;case F.WorkspaceFile:return 5;default:return 6}}F.toConfigurationTarget=N})(i||(e.TaskSourceKind=i={}));var n;(function(F){F.parallel="parallel",F.sequence="sequence"})(n||(e.DependsOrder=n={}));var r;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(r||(e.RunOnOptions=r={}));var a;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:r.default,instanceLimit:1}})(a||(e.RunOptions=a={}));class t{constructor(N,W,X,ce,J,Q){this._label="",this._id=N,W&&(this._label=W),X&&(this.type=X),this.runOptions=ce,this.configurationProperties=J,this._source=Q}getDefinition(N){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const N={folder:this.d(),id:this._id};return JSON.stringify(N)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(N,W=!1){if(N===void 0)return!1;if(T.$Cf(N))return N===this._label||N===this.configurationProperties.identifier||W&&N===this._id;const X=this.getDefinition(!0);return X!==void 0&&X._key===N._key}getQualifiedLabel(){const N=this.getWorkspaceFolder();return N?`${this._label} (${N.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(N){this.c===void 0&&(this.c=[]),N&&(this.c=this.c.concat(N))}get taskLoadMessages(){return this.c}}e.$aG=t;class s extends t{constructor(N,W,X,ce,J,Q,G,oe){super(N,X,void 0,G,oe,W),this.command={},this._source=W,this.hasDefinedMatchers=Q,J&&(this.command=J)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(N=!1){if(N&&this._source.customizes!==void 0)return this._source.customizes;{let W;switch(this.command?this.command.runtime:void 0){case S.Shell:W="shell";break;case S.Process:W="process";break;case S.CustomExecution:W="customExecution";break;case void 0:W="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:W,_key:this._id,id:this._id}}}static is(N){return N instanceof s}getMapKey(){const N=this._source.config.workspaceFolder;return N?`${N.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$9F:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const N=this.d();if(!N)return;let W=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(W+=this._source.kind);const X={type:e.$_F,folder:N,id:W};return JSON.stringify(X)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?f.$wg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(N){return new s(N._id,N._source,N._label,N.type,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$bG=s;class d extends t{constructor(N,W,X,ce,J,Q,G){super(N,X,ce,Q,G,W),this._source=W,this.configures=J}static is(N){return N instanceof d}f(N){return N}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?f.$wg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$9F:this._source.config.workspaceFolder?.uri.toString()}getKey(){const N=this.d();if(!N)return;let W=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(W+=this._source.kind);const X={type:e.$_F,folder:N,id:W};return JSON.stringify(X)}}e.$cG=d;class c extends t{constructor(N,W,X,ce,J,Q,G,oe,_){super(N,X,ce,oe,_,W),this.defines=J,this.hasDefinedMatchers=G,this.command=Q,this.icon=_.icon,this.hide=_.hide}clone(){return new c(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(N){return N instanceof c}getMapKey(){const N=this._source.workspaceFolder;return N?`${this._source.scope.toString()}|${N.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const N={type:"contributed",scope:this._source.scope,id:this._id};return N.folder=this.d(),JSON.stringify(N)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(N){return new c(N._id,N._source,N._label,N.type,N.defines,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$dG=c;class u extends t{constructor(N,W,X,ce,J,Q){super(N,X,ce,J,Q,W),this._source=W}clone(){return new u(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(N){return N instanceof u}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(N){return new u(N._id,N._source,N._label,N.type,N.runOptions,N.configurationProperties)}}e.$eG=u;var h;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(h||(e.ExecutionEngine=h={})),function(F){F._default=F.Terminal}(h||(e.ExecutionEngine=h={}));var E;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(E||(e.JsonSchemaVersion=E={}));class D{constructor(N){this.c=new Map;for(let W=0;W<N.length;W++)this.c.set(N[W].uri.toString(),W)}compare(N,W){const X=N.getWorkspaceFolder(),ce=W.getWorkspaceFolder();if(X&&ce){let J=this.c.get(X.uri.toString());J=J===void 0?0:J+1;let Q=this.c.get(ce.uri.toString());return Q=Q===void 0?0:Q+1,J===Q?N._label.localeCompare(W._label):J-Q}else return!X&&ce?-1:X&&!ce?1:0}}e.$fG=D;var m;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(m||(e.TaskEventKind=m={}));var p;(function(F){F.SingleRun="singleRun",F.Background="background"})(p||(e.TaskRunType=p={}));var k;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange",F[F.Reconnect=4]="Reconnect"})(k||(e.TaskRunSource=k={}));var P;(function(F){function N(oe){return{taskId:oe._id,taskName:oe.configurationProperties.name,runType:oe.configurationProperties.isBackground?"background":"singleRun",group:oe.configurationProperties.group,__task:oe}}function W(oe,_,Ee){return{...N(oe),kind:"start",terminalId:_,resolvedVariables:Ee}}F.start=W;function X(oe,_,Ee){return{...N(oe),kind:"processStarted",terminalId:_,processId:Ee}}F.processStarted=X;function ce(oe,_,Ee){return{...N(oe),kind:"processEnded",terminalId:_,exitCode:Ee}}F.processEnded=ce;function J(oe,_,Ee){return{...N(oe),kind:"terminated",exitReason:Ee,terminalId:_}}F.terminated=J;function Q(oe,_,Ee){return{...N(_),kind:oe,terminalId:Ee}}F.general=Q;function G(){return{kind:"changed"}}F.changed=G})(P||(e.TaskEvent=P={}));var z;(function(F){function N(X){const ce=Object.keys(X).sort();let J="";for(const Q of ce){let G=X[Q];G instanceof Object?G=N(G):typeof G=="string"&&(G=G.replace(/,/g,",,")),J+=Q+","+G+","}return J}function W(X){const J={_key:N(X),type:X.taskType};return Object.assign(J,X),J}F.create=W})(z||(e.KeyedTaskIdentifier=z={}));var j;(function(F){F.AutoDetect="task.autoDetect",F.SaveBeforeRun="task.saveBeforeRun",F.ShowDecorations="task.showDecorations",F.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",F.SlowProviderWarning="task.slowProviderWarning",F.QuickOpenHistory="task.quickOpen.history",F.QuickOpenDetail="task.quickOpen.detail",F.QuickOpenSkip="task.quickOpen.skip",F.QuickOpenShowAll="task.quickOpen.showAll",F.AllowAutomaticTasks="task.allowAutomaticTasks",F.Reconnection="task.reconnection",F.VerboseLogging="task.verboseLogging"})(j||(e.TaskSettingId=j={}));var M;(function(F){F.Tasks="tasks",F.SuppressTaskName="tasks.suppressTaskName",F.Windows="tasks.windows",F.Osx="tasks.osx",F.Linux="tasks.linux",F.ShowOutput="tasks.showOutput",F.IsShellCommand="tasks.isShellCommand",F.ServiceTestSetting="tasks.service.testSetting"})(M||(e.TasksSchemaProperties=M={}));var O;(function(F){function N(W,X){const ce=b.$8F.get(W.type);if(ce===void 0){const oe=R.$an(W);return delete oe._key,z.create(oe)}const J=Object.create(null);J.type=ce.taskType;const Q=new Set;ce.required.forEach(oe=>Q.add(oe));const G=ce.properties;for(const oe of Object.keys(G)){const _=W[oe];if(_!=null)J[oe]=_;else if(Q.has(oe)){const Ee=G[oe];if(Ee.default!==void 0)J[oe]=R.$an(Ee.default);else switch(Ee.type){case"boolean":J[oe]=!1;break;case"number":case"integer":J[oe]=0;break;case"string":J[oe]="";break;default:X.error(C.localize(2,null,JSON.stringify(W,void 0,0),oe));return}}}return z.create(J)}F.createTaskIdentifier=N})(O||(e.TaskDefinition=O={}))}),define(ke[304],Se([1,0,8]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$25b=e.$15b=void 0;class T{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((L,b)=>{this.b=L,this.d=b,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(L){this.f||this.h||(this.f=!0,this.g=L,this.a&&this.b(L))}resolveErr(L){this.f||this.h||(this.h=!0,this.i=L,this.a?this.d(L):(0,C.$Z)(L))}then(L,b){return this.j().then(L,b)}catch(L){return this.j().then(void 0,L)}finally(L){return this.j().finally(L)}}e.$15b=T;class f extends T{constructor(){super(),this.h=!0,this.i=new C.$4}}e.$25b=f}),define(ke[68],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wv=e.$vv=e.$uv=e.$tv=void 0;class C{static{this.count=0}constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++C.count}}e.$tv=C;const T=[];function f(b){const y=new C(b);return T[y.nid]=y,y}e.$uv=f;function R(b){return T[b].sid}e.$vv=R;class L{constructor(y){this.value=y}}e.$wv=L}),define(ke[6],Se([1,0,68]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AK=e.$zK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$yK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(w){w[w.Default=0]="Default",w[w.InCenter=1]="InCenter",w[w.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",w[w.AtTop=3]="AtTop"})(T||(e.TextEditorRevealType=T={}));var f;(function(w){w[w.UnknownInput=0]="UnknownInput",w[w.TextInput=1]="TextInput",w[w.TextDiffInput=2]="TextDiffInput",w[w.TextMergeInput=3]="TextMergeInput",w[w.NotebookInput=4]="NotebookInput",w[w.NotebookDiffInput=5]="NotebookDiffInput",w[w.CustomEditorInput=6]="CustomEditorInput",w[w.WebviewEditorInput=7]="WebviewEditorInput",w[w.TerminalEditorInput=8]="TerminalEditorInput",w[w.InteractiveEditorInput=9]="InteractiveEditorInput",w[w.ChatEditorInput=10]="ChatEditorInput"})(f||(e.TabInputKind=f={}));var R;(function(w){w[w.TAB_OPEN=0]="TAB_OPEN",w[w.TAB_CLOSE=1]="TAB_CLOSE",w[w.TAB_UPDATE=2]="TAB_UPDATE",w[w.TAB_MOVE=3]="TAB_MOVE"})(R||(e.TabModelOperationKind=R={}));var L;(function(w){w[w.Editable=0]="Editable",w[w.SupportsHotExit=1]="SupportsHotExit"})(L||(e.WebviewEditorCapabilities=L={}));var b;(function(w){w[w.Int8Array=1]="Int8Array",w[w.Uint8Array=2]="Uint8Array",w[w.Uint8ClampedArray=3]="Uint8ClampedArray",w[w.Int16Array=4]="Int16Array",w[w.Uint16Array=5]="Uint16Array",w[w.Int32Array=6]="Int32Array",w[w.Uint32Array=7]="Uint32Array",w[w.Float32Array=8]="Float32Array",w[w.Float64Array=9]="Float64Array",w[w.BigInt64Array=10]="BigInt64Array",w[w.BigUint64Array=11]="BigUint64Array"})(b||(e.WebviewMessageArrayBufferViewType=b={}));var y;(function(w){w[w.Text=1]="Text",w[w.Error=2]="Error",w[w.Rich=3]="Rich"})(y||(e.CellOutputKind=y={}));var g;(function(w){w[w.Default=0]="Default",w[w.InCenter=1]="InCenter",w[w.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",w[w.AtTop=3]="AtTop"})(g||(e.NotebookEditorRevealType=g={}));var A;(function(w){w[w.None=0]="None",w[w.Process=1]="Process",w[w.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class I{static{this.a=0}static mixin(l){return l._id=I.a++,l}}e.$yK=I;var $;(function(w){w.label="a",w.kind="b",w.detail="c",w.documentation="d",w.sortText="e",w.filterText="f",w.preselect="g",w.insertText="h",w.insertTextRules="i",w.range="j",w.commitCharacters="k",w.additionalTextEdits="l",w.kindModifier="m",w.commandIdent="n",w.commandId="o",w.commandArguments="p"})($||(e.ISuggestDataDtoField=$={}));var v;(function(w){w.defaultRanges="a",w.completions="b",w.isIncomplete="c",w.duration="d"})(v||(e.ISuggestResultDtoField=v={}));var S;(function(w){w[w.Workspace=0]="Workspace",w[w.TextDocument=1]="TextDocument"})(S||(e.ExtHostTestingResource=S={})),e.$zK={MainThreadAuthentication:(0,C.$uv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,C.$uv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,C.$uv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,C.$uv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,C.$uv)("MainThreadChatVariables"),MainThreadClipboard:(0,C.$uv)("MainThreadClipboard"),MainThreadCommands:(0,C.$uv)("MainThreadCommands"),MainThreadComments:(0,C.$uv)("MainThreadComments"),MainThreadConfiguration:(0,C.$uv)("MainThreadConfiguration"),MainThreadConsole:(0,C.$uv)("MainThreadConsole"),MainThreadDebugService:(0,C.$uv)("MainThreadDebugService"),MainThreadDecorations:(0,C.$uv)("MainThreadDecorations"),MainThreadDiagnostics:(0,C.$uv)("MainThreadDiagnostics"),MainThreadDialogs:(0,C.$uv)("MainThreadDiaglogs"),MainThreadDocuments:(0,C.$uv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,C.$uv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,C.$uv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,C.$uv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,C.$uv)("MainThreadEditorTabs"),MainThreadErrors:(0,C.$uv)("MainThreadErrors"),MainThreadTreeViews:(0,C.$uv)("MainThreadTreeViews"),MainThreadDownloadService:(0,C.$uv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,C.$uv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,C.$uv)("MainThreadLanguages"),MainThreadLogger:(0,C.$uv)("MainThreadLogger"),MainThreadMessageService:(0,C.$uv)("MainThreadMessageService"),MainThreadOutputService:(0,C.$uv)("MainThreadOutputService"),MainThreadProgress:(0,C.$uv)("MainThreadProgress"),MainThreadQuickDiff:(0,C.$uv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,C.$uv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,C.$uv)("MainThreadStatusBar"),MainThreadSecretState:(0,C.$uv)("MainThreadSecretState"),MainThreadStorage:(0,C.$uv)("MainThreadStorage"),MainThreadSpeech:(0,C.$uv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,C.$uv)("MainThreadTelemetry"),MainThreadTerminalService:(0,C.$uv)("MainThreadTerminalService"),MainThreadWebviews:(0,C.$uv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,C.$uv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,C.$uv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,C.$uv)("MainThreadCustomEditors"),MainThreadUrls:(0,C.$uv)("MainThreadUrls"),MainThreadUriOpeners:(0,C.$uv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,C.$uv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,C.$uv)("MainThreadWorkspace"),MainThreadFileSystem:(0,C.$uv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,C.$uv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,C.$uv)("MainThreadExtensionService"),MainThreadSCM:(0,C.$uv)("MainThreadSCM"),MainThreadSearch:(0,C.$uv)("MainThreadSearch"),MainThreadShare:(0,C.$uv)("MainThreadShare"),MainThreadTask:(0,C.$uv)("MainThreadTask"),MainThreadWindow:(0,C.$uv)("MainThreadWindow"),MainThreadLabelService:(0,C.$uv)("MainThreadLabelService"),MainThreadNotebook:(0,C.$uv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,C.$uv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,C.$uv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,C.$uv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,C.$uv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,C.$uv)("MainThreadInteractive"),MainThreadChat:(0,C.$uv)("MainThreadChat"),MainThreadInlineChat:(0,C.$uv)("MainThreadInlineChatShape"),MainThreadTheming:(0,C.$uv)("MainThreadTheming"),MainThreadTunnelService:(0,C.$uv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,C.$uv)("MainThreadManagedSockets"),MainThreadTimeline:(0,C.$uv)("MainThreadTimeline"),MainThreadTesting:(0,C.$uv)("MainThreadTesting"),MainThreadLocalization:(0,C.$uv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,C.$uv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,C.$uv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,C.$uv)("MainThreadIssueReporter")},e.$AK={ExtHostCommands:(0,C.$uv)("ExtHostCommands"),ExtHostConfiguration:(0,C.$uv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,C.$uv)("ExtHostDiagnostics"),ExtHostDebugService:(0,C.$uv)("ExtHostDebugService"),ExtHostDecorations:(0,C.$uv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,C.$uv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,C.$uv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,C.$uv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,C.$uv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,C.$uv)("ExtHostEditors"),ExtHostTreeViews:(0,C.$uv)("ExtHostTreeViews"),ExtHostFileSystem:(0,C.$uv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,C.$uv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,C.$uv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,C.$uv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,C.$uv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,C.$uv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,C.$uv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,C.$uv)("ExtHostStatusBar"),ExtHostShare:(0,C.$uv)("ExtHostShare"),ExtHostExtensionService:(0,C.$uv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,C.$uv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,C.$uv)("ExtHostTerminalService"),ExtHostSCM:(0,C.$uv)("ExtHostSCM"),ExtHostSearch:(0,C.$uv)("ExtHostSearch"),ExtHostTask:(0,C.$uv)("ExtHostTask"),ExtHostWorkspace:(0,C.$uv)("ExtHostWorkspace"),ExtHostWindow:(0,C.$uv)("ExtHostWindow"),ExtHostWebviews:(0,C.$uv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,C.$uv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,C.$uv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,C.$uv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,C.$uv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,C.$uv)("ExtHostEditorTabs"),ExtHostProgress:(0,C.$uv)("ExtHostProgress"),ExtHostComments:(0,C.$uv)("ExtHostComments"),ExtHostSecretState:(0,C.$uv)("ExtHostSecretState"),ExtHostStorage:(0,C.$uv)("ExtHostStorage"),ExtHostUrls:(0,C.$uv)("ExtHostUrls"),ExtHostUriOpeners:(0,C.$uv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,C.$uv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,C.$uv)("ExtHostOutputService"),ExtHosLabelService:(0,C.$uv)("ExtHostLabelService"),ExtHostNotebook:(0,C.$uv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,C.$uv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,C.$uv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,C.$uv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,C.$uv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,C.$uv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,C.$uv)("ExtHostInteractive"),ExtHostInlineChat:(0,C.$uv)("ExtHostInlineChatShape"),ExtHostChat:(0,C.$uv)("ExtHostChat"),ExtHostChatAgents2:(0,C.$uv)("ExtHostChatAgents"),ExtHostChatVariables:(0,C.$uv)("ExtHostChatVariables"),ExtHostChatProvider:(0,C.$uv)("ExtHostChatProvider"),ExtHostSpeech:(0,C.$uv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,C.$uv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,C.$uv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,C.$uv)("ExtHostTheming"),ExtHostTunnelService:(0,C.$uv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,C.$uv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,C.$uv)("ExtHostAuthentication"),ExtHostTimeline:(0,C.$uv)("ExtHostTimeline"),ExtHostTesting:(0,C.$uv)("ExtHostTesting"),ExtHostTelemetry:(0,C.$uv)("ExtHostTelemetry"),ExtHostLocalization:(0,C.$uv)("ExtHostLocalization"),ExtHostIssueReporter:(0,C.$uv)("ExtHostIssueReporter")}}),define(ke[305],Se([1,0,6,7]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Idc=void 0;class f{constructor(L){this.a=new Map,this.b=0,this.c=L.getProxy(C.$zK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(L,b,y){if(this.a.size===0)throw new Error("No related information providers registered");const g=this.a.get(L);if(!g)throw new Error("related information provider not found");return await g.provideRelatedInformation(b,y)??[]}getRelatedInformation(L,b,y){return this.c.$getAiRelatedInformation(b,y)}registerRelatedInformationProvider(L,b,y){const g=this.b;return this.b++,this.a.set(g,y),this.c.$registerAiRelatedInformationProvider(g,b),new T.$BK(()=>{this.c.$unregisterAiRelatedInformationProvider(g),this.a.delete(g)})}}e.$Idc=f}),define(ke[91],Se([1,0,5,14,6,20]),function(me,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qdc=e.$Pdc=e.$Odc=void 0,e.$Odc=(0,C.$Vh)("IExtHostApiDeprecationService");let L=class{constructor(y,g){this.c=g,this.a=new Set,this.b=y.getProxy(f.$zK.MainThreadTelemetry)}report(y,g,A){const I=this.d(y,g);this.a.has(I)||(this.a.add(I),g.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${y}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:g.identifier.value,apiId:y}))}d(y,g){return`${y}-${g.identifier.value}`}};e.$Pdc=L,e.$Pdc=L=He([Be(0,R.$BM),Be(1,T.$dj)],L),e.$Qdc=Object.freeze(new class{report(b,y,g){}})}),define(ke[306],Se([1,0,4,6,7,26]),function(me,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tdc=void 0;class L{constructor(g){this.b=new Map,this.c=[],this.d=new C.$Rd,this.onDidChangeSessions=this.d.event,this.f=new b,this.g=new b,this.a=g.getProxy(T.$zK.MainThreadAuthentication)}$setProviders(g){return this.c=g,Promise.resolve()}async getSession(g,A,I,$={}){const v=R.$_l.toKey(g.identifier),S=[...I].sort().join(" ");return await this.f.getOrCreate(`${v} ${A} ${S}`,async()=>{await this.a.$ensureProvider(A);const w=g.displayName||g.name;return this.a.$getSession(A,I,v,w,$)})}async getSessions(g,A,I){const $=R.$_l.toKey(g.identifier),v=[...I].sort().join(" ");return await this.g.getOrCreate(`${$} ${v}`,async()=>{await this.a.$ensureProvider(A);const S=g.displayName||g.name;return this.a.$getSessions(A,I,$,S)})}async removeSession(g,A){const I=this.b.get(g);return I?I.provider.removeSession(A):this.a.$removeSession(g,A)}registerAuthenticationProvider(g,A,I,$){if(this.b.get(g))throw new Error(`An authentication provider with id '${g}' is already registered.`);this.b.set(g,{label:A,provider:I,options:$??{supportsMultipleAccounts:!1}}),this.c.find(S=>S.id===g)||this.c.push({id:g,label:A});const v=I.onDidChangeSessions(S=>{this.a.$sendDidChangeSessions(g,{added:S.added??[],changed:S.changed??[],removed:S.removed??[]})});return this.a.$registerAuthenticationProvider(g,A,$?.supportsMultipleAccounts??!1),new f.$BK(()=>{v.dispose(),this.b.delete(g);const S=this.c.findIndex(w=>w.id===g);S>-1&&this.c.splice(S),this.a.$unregisterAuthenticationProvider(g)})}$createSession(g,A,I){const $=this.b.get(g);if($)return Promise.resolve($.provider.createSession(A,I));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$removeSession(g,A){const I=this.b.get(g);if(I)return Promise.resolve(I.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$getSessions(g,A){const I=this.b.get(g);if(I)return Promise.resolve(I.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${g}`)}$onDidChangeAuthenticationSessions(g,A){return this.d.fire({provider:{id:g,label:A}}),Promise.resolve()}}e.$Tdc=L;class b{constructor(){this.a=new Map}getOrCreate(g,A){const I=this.a.get(g);if(I)return I;const $=A().finally(()=>this.a.delete(g));return this.a.set(g,$),$}}}),define(ke[307],Se([1,0,6,20,15]),function(me,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Udc=void 0;let R=class{constructor(b,y){this.a=b.getProxy(C.$zK.MainThreadBulkEdits),this.b={getTextDocumentVersion:g=>y.getDocument(g)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(b,y,g){const A=f.WorkspaceEdit.from(b,this.b);return this.a.$tryApplyWorkspaceEdit(A,void 0,g?.isRefactoring??!1)}};e.$Udc=R,e.$Udc=R=He([Be(0,T.$BM)],R)}),define(ke[308],Se([1,0,4,51,3,6,15]),function(me,e,C,T,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vdc=void 0;class b{static{this.a=0}constructor(A,I){this.extension=A,this.provider=I,this.handle=b.a++}}class y{static{this.a=0}constructor(A){this.b=new Map,this.c=new Map,this.d=new C.$Rd,this.onDidPerformUserAction=this.d.event,this.e=A.getProxy(R.$zK.MainThreadChat)}registerChatProvider(A,I,$){const v=new b(A,$);return this.b.set(v.handle,v),this.e.$registerChatProvider(v.handle,I),(0,f.$Pc)(()=>{this.e.$unregisterChatProvider(v.handle),this.b.delete(v.handle)})}transferChatSession(A,I){const $=T.Iterable.find(this.c.keys(),v=>this.c.get(v)===A)??0;typeof $=="number"&&this.e.$transferChatSession($,I)}sendInteractiveRequestToProvider(A,I){this.e.$sendRequestToProvider(A,I)}async $prepareChat(A,I){const $=this.b.get(A);if(!$)return;const v=await $.provider.prepareSession(I);if(!v)return;const S=y.a++;return this.c.set(S,v),{id:S,requesterUsername:v.requester?.name,requesterAvatarIconUri:v.requester?.icon,responderUsername:v.responder?.name,responderAvatarIconUri:v.responder?.icon,inputPlaceholder:v.inputPlaceholder}}async $provideWelcomeMessage(A,I){const $=this.b.get(A);if(!$||!$.provider.provideWelcomeMessage)return;const v=await $.provider.provideWelcomeMessage(I);if(v)return v.map(S=>typeof S=="string"?S:Array.isArray(S)?S.map(w=>L.ChatReplyFollowup.from(w)):L.MarkdownString.from(S))}async $provideSampleQuestions(A,I){const $=this.b.get(A);if(!$||!$.provider.provideSampleQuestions)return;const v=await $.provider.provideSampleQuestions(I);if(v)return v?.map(S=>L.ChatReplyFollowup.from(S))}$releaseSession(A){this.c.delete(A)}async $onDidPerformUserAction(A){this.d.fire(A)}}e.$Vdc=y}),define(ke[309],Se([1,0,12,21,43,4,38,18,2,210,85,6,15,7,280,25]),function(me,e,C,T,f,R,L,b,y,g,A,I,$,v,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xdc=void 0;class l{static{this.a=0}constructor(n,r,a){this.i=r,this.j=a,this.b=new Map,this.g=new Map,this.h=new Map,this.d=n.getProxy(I.$zK.MainThreadChatAgents2)}createChatAgent(n,r,a){const t=l.a++,s=new o(n,r,this.d,t,a);return this.b.set(t,s),this.d.$registerAgent(t,r,{}),s.apiAgent}async $invokeAgent(n,r,a,t,s,d){this.g.delete(r);const c=this.b.get(n);if(!c)throw new Error(`[CHAT](${n}) CANNOT invoke agent because the agent is not registered`);let u=!1;function h(){if(u)throw new Error("Only valid while executing the command")}const E=new C.$ih;d.onCancellationRequested(()=>E.complete()),setTimeout(()=>E.complete(),10*1e3),this.i.allowListExtensionWhile(c.extension.identifier,E.p);const D=t.command?await c.validateSlashCommand(t.command):void 0,m=L.$Nd.create(!1);let p;try{const k=c.invoke({prompt:t.message,variables:$.ChatVariable.objectTo(t.variables),slashCommand:D},{history:s.history.map($.ChatMessage.to)},new A.$$u(P=>{h(),typeof p>"u"&&"content"in P&&(p=m.elapsed());const z=$.ChatResponseProgress.from(c.extension,P);if("placeholder"in P&&"resolvedContent"in P){const j=Promise.all([this.d.$handleProgressChunk(a,z),P.resolvedContent]);(0,C.$Mg)(j,d).then(M=>{if(!M)return;const[O,F]=M,N=$.ChatResponseProgress.from(c.extension,F);this.d.$handleProgressChunk(a,N,O??void 0)})}else this.d.$handleProgressChunk(a,z)}),d);return await(0,C.$Mg)(Promise.resolve(k).then(P=>{if(P){this.g.set(r,P);let z=this.h.get(r);z||(z=new Map,this.h.set(r,z)),z.set(a,P);const j={firstProgress:p,totalElapsed:m.elapsed()};return{errorDetails:P.errorDetails,timings:j}}else this.g.delete(r)}),d)}catch(k){return this.j.error(k,c.extension),{errorDetails:{message:(0,g.localize)(0,null,(0,f.$Gi)(k)),responseIsIncomplete:!0}}}finally{u=!0,E.complete()}}$releaseSession(n){this.g.delete(n),this.h.delete(n)}async $provideSlashCommands(n,r){const a=this.b.get(n);return a?a.provideSlashCommand(r):[]}$provideFollowups(n,r,a){const t=this.b.get(n);if(!t)return Promise.resolve([]);const s=this.g.get(r);return s?t.provideFollowups(s,a):Promise.resolve([])}$acceptFeedback(n,r,a,t,s){const d=this.b.get(n);if(!d)return;const c=this.h.get(r)?.get(a);if(!c)return;let u;switch(t){case S.InteractiveSessionVoteDirection.Down:u=v.ChatAgentResultFeedbackKind.Unhelpful;break;case S.InteractiveSessionVoteDirection.Up:u=v.ChatAgentResultFeedbackKind.Helpful;break}d.acceptFeedback(Object.freeze(s?{result:c,kind:u,reportIssue:s}:{result:c,kind:u}))}$acceptAction(n,r,a,t){const s=this.b.get(n);if(!s)return;const d=this.h.get(r)?.get(a);d&&t.action.kind!=="vote"&&s.acceptAction(Object.freeze({action:t.action,result:d}))}}e.$Xdc=l;class o{constructor(n,r,a,t,s){this.extension=n,this.s=r,this.t=a,this.u=t,this.w=s,this.o=new R.$Rd,this.q=new R.$Rd}acceptFeedback(n){this.o.fire(n)}acceptAction(n){this.q.fire(n)}async validateSlashCommand(n){this.b||(await this.provideSlashCommand(T.CancellationToken.None),(0,b.$Mf)(this.b));const r=this.b.find(a=>a.name===n);if(!r)throw new Error(`Unknown slashCommand: ${n}`);return r}async provideSlashCommand(n){if(!this.a)return[];const r=await this.a.provideSlashCommands(n);return r?(this.b=r,r.map(a=>({name:a.name,description:a.description,followupPlaceholder:a.followupPlaceholder,shouldRepopulate:a.shouldRepopulate,sampleRequest:a.sampleRequest}))):[]}async provideFollowups(n,r){if(!this.d)return[];const a=await this.d.provideFollowups(n,r);return a?a.map(t=>$.ChatFollowup.from(t)):[]}get apiAgent(){let n=!1,r=!1;const a=()=>{n||r||(r=!0,queueMicrotask(()=>{this.t.$updateAgent(this.u,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof y.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof v.$vL?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.d!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:$.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:$.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.r}),r=!1}))},t=this;return{get name(){return t.s},get description(){return t.g??""},set description(s){t.g=s,a()},get fullName(){return t.h??t.extension.displayName??t.extension.name},set fullName(s){t.h=s,a()},get iconPath(){return t.i},set iconPath(s){t.i=s,a()},get slashCommandProvider(){return t.a},set slashCommandProvider(s){t.a=s,a()},get followupProvider(){return t.d},set followupProvider(s){t.d=s,a()},get isDefault(){return(0,w.$NF)(t.extension,"defaultChatAgent"),t.j},set isDefault(s){(0,w.$NF)(t.extension,"defaultChatAgent"),t.j=s,a()},get helpTextPrefix(){return(0,w.$NF)(t.extension,"defaultChatAgent"),t.k},set helpTextPrefix(s){if((0,w.$NF)(t.extension,"defaultChatAgent"),!t.j)throw new Error("helpTextPrefix is only available on the default chat agent");t.k=s,a()},get helpTextPostfix(){return(0,w.$NF)(t.extension,"defaultChatAgent"),t.l},set helpTextPostfix(s){if((0,w.$NF)(t.extension,"defaultChatAgent"),!t.j)throw new Error("helpTextPostfix is only available on the default chat agent");t.l=s,a()},get isSecondary(){return(0,w.$NF)(t.extension,"defaultChatAgent"),t.n},set isSecondary(s){(0,w.$NF)(t.extension,"defaultChatAgent"),t.n=s,a()},get sampleRequest(){return t.m},set sampleRequest(s){t.m=s,a()},get supportIssueReporting(){return(0,w.$NF)(t.extension,"chatAgents2Additions"),t.r},set supportIssueReporting(s){(0,w.$NF)(t.extension,"chatAgents2Additions"),t.r=s,a()},get onDidReceiveFeedback(){return t.o.event},onDidPerformAction:(0,w.$MF)(this.extension,"chatAgents2Additions")?this.q.event:void 0,dispose(){n=!0,t.a=void 0,t.d=void 0,t.o.dispose(),t.t.$unregisterAgent(t.u)}}}invoke(n,r,a,t){return this.w(n,r,a,t)}}}),define(ke[310],Se([1,0,21,3,6,15,85,26,12,4]),function(me,e,C,T,f,R,L,b,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wdc=void 0;class A{constructor(S,w){this.stream=new y.$mh,this.stream=w??new y.$mh;const l=this;this.apiObj={option:S,response:l.stream.asyncIterable}}}class I{constructor(S,w){this.a=new g.$Rd,this.b=new Map,this.c=new y.$mh,this.d=!1;const l=this;this.apiObject={result:S,response:l.c.asyncIterable,onDidStartResponseStream:l.a.event,cancel(){w.cancel()}},S.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,o]of this.b)o.stream.resolve();else this.c.resolve()})}handleFragment(S){if(this.d)return;let w=this.b.get(S.index);w||(this.b.size===0?w=new A(S.index,this.c):w=new A(S.index),this.b.set(S.index,w),this.a.fire(w.apiObj)),w.stream.emitOne(S.part)}}class ${static{this.a=1}constructor(S,w){this.d=w,this.c=new Map,this.e=new Map,this.f=new b.$bm,this.b=S.getProxy(f.$zK.MainThreadChatProvider)}registerProvider(S,w,l,o){const i=$.a++;return this.c.set(i,{extension:S,provider:l}),this.b.$registerProvider(i,w,{extension:S,displayName:o.name??S.value}),(0,T.$Pc)(()=>{this.b.$unregisterProvider(i),this.c.delete(i)})}async $provideChatResponse(S,w,l,o,i){const n=this.c.get(S);if(!n)return;const r=new L.$$u(async a=>{if(i.isCancellationRequested){this.d.warn(`[CHAT](${n.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(w,{index:a.index,part:a.part})});return n.provider.provideChatResponse(l.map(R.ChatMessage.to),o,r,i)}allowListExtensionWhile(S,w){this.f.set(S,w),w.finally(()=>this.f.delete(S))}async requestChatResponseProvider(S,w){if(!this.f.has(S))throw new Error("Extension is NOT allowed to make chat requests");const l=this;return{get isRevoked(){return!l.f.has(S)},makeRequest(o,i,n){if(!l.f.has(S))throw new Error("Access to chat has been revoked");const r=new C.$2d(n),a=Math.random()*1e6|0,t=l.b.$fetchResponse(S,w,a,o.map(R.ChatMessage.from),i??{},r.token),s=new I(t,r);return l.e.set(a,{res:s}),t.finally(()=>{l.e.delete(a)}),s.apiObject}}}async $handleResponseFragment(S,w){const l=this.e.get(S);l&&l.res.handleFragment(w)}}e.$Wdc=$}),define(ke[311],Se([1,0,3,6,8,15]),function(me,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ydc=void 0;class L{static{this.a=0}constructor(y){this.b=new Map,this.c=y.getProxy(T.$zK.MainThreadChatVariables)}async $resolveVariable(y,g,A){const I=this.b.get(y);if(I)try{const $=await I.resolver.resolve(I.data.name,{message:g},A);if($)return $.map(R.ChatVariable.from)}catch($){(0,f.$1)($)}}registerVariableResolver(y,g,A,I){const $=L.a++;return this.b.set($,{extension:y.identifier,data:{name:g,description:A},resolver:I}),this.c.$registerVariable($,{name:g,description:A}),(0,C.$Pc)(()=>{this.b.delete($),this.c.$unregisterVariable($)})}}e.$Ydc=L}),define(ke[312],Se([1,0,6]),function(me,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zdc=void 0;class T{constructor(R){const L=R.getProxy(C.$zK.MainThreadClipboard);this.value=Object.freeze({readText(){return L.$readText()},writeText(b){return L.$writeText(b)}})}}e.$Zdc=T}),define(ke[35],Se([1,0,18,7,15,24,6,19,14,54,29,53,2,3,5,20,149,22,68,43,38,87,90]),function(me,e,C,T,f,R,L,b,y,g,A,I,$,v,S,w,l,o,i,n,r,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2M=e.$1M=e.$ZM=e.$YM=e.$XM=e.$WM=void 0;let s=class{#e;#t;#i;constructor(D,m,p){this.b=new Map,this.c=new Map,this.#e=D.getProxy(L.$zK.MainThreadCommands),this.d=m,this.#i=p,this.#t=D.getProxy(L.$zK.MainThreadTelemetry),this.converter=new d(this,k=>{const P=this.c.get(k);return P?.result===u.Void?P:void 0},m),this.f=[{processArgument(k){return(0,g.$sh)(k)}},{processArgument(k){return(0,R.$cn)(k,function(P){if(A.$zs.isIRange(P))return f.Range.to(P);if(I.$ys.isIPosition(P))return f.Position.to(P);if(A.$zs.isIRange(P.range)&&$.URI.isUri(P.uri))return f.location.to(P);if(P instanceof o.$fe)return P.buffer.buffer;if(!Array.isArray(P))return P})}}]}registerArgumentProcessor(D){this.f.push(D)}registerApiCommand(D){const m=this.registerCommand(!1,D.id,async(...p)=>{const k=D.args.map((z,j)=>{if(!z.validate(p[j]))throw new Error(`Invalid argument '${z.name}' when running '${D.id}', received: ${typeof p[j]=="object"?JSON.stringify(p[j],null,"	"):p[j]} `);return z.convert(p[j])}),P=await this.executeCommand(D.internalId,...k);return D.result.convert(P,p,this.converter)},void 0,{description:D.description,args:D.args,returns:D.result.description});return this.c.set(D.id,D),new T.$BK(()=>{m.dispose(),this.c.delete(D.id)})}registerCommand(D,m,p,k,P,z){if(this.d.trace("ExtHostCommands#registerCommand",m),!m.trim().length)throw new Error("invalid id");if(this.b.has(m))throw new Error(`command '${m}' already exists`);return this.b.set(m,{callback:p,thisArg:k,metadata:P,extension:z}),D&&this.#e.$registerCommand(m),new T.$BK(()=>{this.b.delete(m)&&D&&this.#e.$unregisterCommand(m)})}executeCommand(D,...m){return this.d.trace("ExtHostCommands#executeCommand",D),this.g(D,m,!0)}async g(D,m,p){if(this.b.has(D))return this.#e.$fireCommandActivationEvent(D),this.h(D,m,!1);{let k=!1;const P=(0,R.$cn)(m,function(z){if(z instanceof T.$CK)return f.Position.from(z);if(z instanceof T.$DK)return f.Range.from(z);if(z instanceof T.$NK)return f.location.from(z);if(T.$YL.isNotebookRange(z))return f.NotebookRange.from(z);if(z instanceof ArrayBuffer)return k=!0,o.$fe.wrap(new Uint8Array(z));if(z instanceof Uint8Array)return k=!0,o.$fe.wrap(z);if(z instanceof o.$fe)return k=!0,z;if(!Array.isArray(z))return z});try{const z=await this.#e.$executeCommand(D,k?new i.$wv(P):P,p);return(0,g.$sh)(z)}catch(z){if(z instanceof Error&&z.message==="$executeCommand:retry")return this.g(D,m,!1);throw z}}}async h(D,m,p){const k=this.b.get(D);if(!k)throw new Error("Unknown command");const{callback:P,thisArg:z,metadata:j}=k;if(j?.args)for(let O=0;O<j.args.length;O++)try{(0,C.$Tf)(m[O],j.args[O].constraint)}catch{throw new Error(`Running the contributed command: '${D}' failed. Illegal argument '${j.args[O].name}' - ${j.args[O].description}`)}const M=r.$Nd.create();try{return await P.apply(z,m)}catch(O){if(D===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...m);F&&(D=F.command)}if(this.d.error(O,D,k.extension?.identifier),!p)throw O;if(k.extension?.identifier){const F=this.#i.onExtensionError(k.extension.identifier,O);this.d.trace("forwarded error to extension?",F,k.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$Gi)(O)),this.id=D,this.source=k.extension?.displayName??k.extension?.name}}}finally{this.j(k,D,M.elapsed())}}j(D,m,p){D.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:D.extension.identifier.value,id:new a.$po(m),duration:p})}$executeContributedCommand(D,...m){this.d.trace("ExtHostCommands#$executeContributedCommand",D);const p=this.b.get(D);return p?(m=m.map(k=>this.f.reduce((P,z)=>z.processArgument(P,p.extension?.identifier),k)),this.h(D,m,!0)):Promise.reject(new Error(`Contributed command '${D}' does not exist.`))}getCommands(D=!1){return this.d.trace("ExtHostCommands#getCommands",D),this.#e.$getCommands().then(m=>(D&&(m=m.filter(p=>p[0]!=="_")),m))}$getContributedCommandMetadata(){const D=Object.create(null);for(const[m,p]of this.b){const{metadata:k}=p;k&&(D[m]=k)}return Promise.resolve(D)}};e.$WM=s,e.$WM=s=He([Be(0,w.$BM),Be(1,y.$dj),Be(2,t.$VM)],s),e.$XM=(0,S.$Vh)("IExtHostCommands");class d{constructor(D,m,p){this.d=D,this.f=m,this.g=p,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(D,m){if(!D)return;const p={$ident:void 0,id:D.command,title:D.title,tooltip:D.tooltip};if(!D.command)return p;const k=this.f(D.command);if(k)p.id=k.internalId,p.arguments=k.args.map((P,z)=>P.convert(D.arguments&&D.arguments[z]));else if((0,b.$Kb)(D.arguments)){const P=`${D.command} /${++this.c}`;this.b.set(P,D),m.add((0,v.$Pc)(()=>{this.b.delete(P),this.g.trace("CommandsConverter#DISPOSE",P)})),p.$ident=P,p.id=this.delegatingCommandId,p.arguments=[P],this.g.trace("CommandsConverter#CREATE",D.command,P)}return p}fromInternal(D){return typeof D.$ident=="string"?this.b.get(D.$ident):{command:D.id,title:D.title,arguments:D.arguments}}getActualCommand(...D){return this.b.get(D[0])}h(...D){const m=this.getActualCommand(...D);return this.g.trace("CommandsConverter#EXECUTE",D[0],m?m.command:"MISSING"),m?this.d.executeCommand(m.command,...m.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${D[0]}`)}}e.$YM=d;class c{static{this.Uri=new c("uri","Uri of a text document",D=>$.URI.isUri(D),D=>D)}static{this.Position=new c("position","A position in a text document",D=>T.$CK.isPosition(D),f.Position.from)}static{this.Range=new c("range","A range in a text document",D=>T.$DK.isRange(D),f.Range.from)}static{this.Selection=new c("selection","A selection in a text document",D=>T.$EK.isSelection(D),f.Selection.from)}static{this.Number=new c("number","",D=>typeof D=="number",D=>D)}static{this.String=new c("string","",D=>typeof D=="string",D=>D)}static{this.StringArray=c.Arr(c.String)}static Arr(D){return new c(`${D.name}_array`,`Array of ${D.name}, ${D.description}`,m=>Array.isArray(m)&&m.every(p=>D.validate(p)),m=>m.map(p=>D.convert(p)))}static{this.CallHierarchyItem=new c("item","A call hierarchy item",D=>D instanceof T.$XK,f.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new c("item","A type hierarchy item",D=>D instanceof T.$fM,f.TypeHierarchyItem.from)}static{this.TestItem=new c("testItem","A VS Code TestItem",D=>D instanceof l.$OM,f.TestItem.from)}constructor(D,m,p,k){this.name=D,this.description=m,this.validate=p,this.convert=k}optional(){return new c(this.name,`(optional) ${this.description}`,D=>D==null||this.validate(D),D=>D===void 0?void 0:D===null?null:this.convert(D))}with(D,m){return new c(D??this.name,m??this.description,this.validate,this.convert)}}e.$ZM=c;class u{static{this.Void=new u("no result",D=>D)}constructor(D,m){this.description=D,this.convert=m}}e.$1M=u;class h{constructor(D,m,p,k,P){this.id=D,this.internalId=m,this.description=p,this.args=k,this.result=P}}e.$2M=h}),define(ke[313],Se([1,0,19,17,2,83,132,45,137,35,15,7]),function(me,e,C,T,f,R,L,b,y,g,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sdc=void 0;const $=[new g.$2M("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[g.$ZM.Uri,g.$ZM.Position],new g.$1M("A promise that resolves to an array of DocumentHighlight-instances.",S(A.DocumentHighlight.to))),new g.$2M("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[g.$ZM.Uri],new g.$1M("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,o)=>{if((0,C.$Jb)(l))return;class i extends I.$SK{static to(r){const a=new i(r.name,A.SymbolKind.to(r.kind),r.containerName||"",new I.$NK(o[0],A.Range.to(r.range)));return a.detail=r.detail,a.range=a.location.range,a.selectionRange=A.Range.to(r.selectionRange),a.children=r.children?r.children.map(i.to):[],a}}return l.map(i.to)})),new g.$2M("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[g.$ZM.Uri,new g.$ZM("options","Formatting options",l=>!0,l=>l)],new g.$1M("A promise that resolves to an array of TextEdits.",S(A.TextEdit.to))),new g.$2M("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[g.$ZM.Uri,g.$ZM.Range,new g.$ZM("options","Formatting options",l=>!0,l=>l)],new g.$1M("A promise that resolves to an array of TextEdits.",S(A.TextEdit.to))),new g.$2M("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[g.$ZM.Uri,g.$ZM.Position,new g.$ZM("ch","Trigger character",l=>typeof l=="string",l=>l),new g.$ZM("options","Formatting options",l=>!0,l=>l)],new g.$1M("A promise that resolves to an array of TextEdits.",S(A.TextEdit.to))),new g.$2M("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[g.$ZM.Uri,g.$ZM.Position],new g.$1M("A promise that resolves to an array of Location or LocationLink instances.",w)),new g.$2M("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[g.$ZM.Uri,g.$ZM.Position],new g.$1M("A promise that resolves to an array of Location or LocationLink instances.",w)),new g.$2M("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[g.$ZM.Uri,g.$ZM.Position],new g.$1M("A promise that resolves to an array of Location or LocationLink instances.",w)),new g.$2M("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[g.$ZM.Uri,g.$ZM.Position],new g.$1M("A promise that resolves to an array of Location or LocationLink instances.",w)),new g.$2M("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[g.$ZM.Uri,g.$ZM.Position],new g.$1M("A promise that resolves to an array of Location-instances.",S(A.location.to))),new g.$2M("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[g.$ZM.Uri,g.$ZM.Position],new g.$1M("A promise that resolves to an array of Hover-instances.",S(A.Hover.to))),new g.$2M("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[g.$ZM.Uri,new g.$ZM("position","A position in a text document",l=>Array.isArray(l)&&l.every(o=>I.$CK.isPosition(o)),l=>l.map(A.Position.from))],new g.$1M("A promise that resolves to an array of ranges.",l=>l.map(o=>{let i;for(const n of o.reverse())i=new I.$WK(A.Range.to(n),i);return i}))),new g.$2M("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[g.$ZM.String.with("query","Search string")],new g.$1M("A promise that resolves to an array of SymbolInformation-instances.",l=>l.map(A.WorkspaceSymbol.to))),new g.$2M("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[g.$ZM.Uri,g.$ZM.Position],new g.$1M("A promise that resolves to an array of CallHierarchyItem-instances",l=>l.map(A.CallHierarchyItem.to))),new g.$2M("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[g.$ZM.CallHierarchyItem],new g.$1M("A promise that resolves to an array of CallHierarchyIncomingCall-instances",l=>l.map(A.CallHierarchyIncomingCall.to))),new g.$2M("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[g.$ZM.CallHierarchyItem],new g.$1M("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",l=>l.map(A.CallHierarchyOutgoingCall.to))),new g.$2M("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[g.$ZM.Uri,g.$ZM.Position],new g.$1M("A promise that resolves to a range and placeholder text.",l=>{if(l)return{range:A.Range.to(l.range),placeholder:l.text}})),new g.$2M("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[g.$ZM.Uri,g.$ZM.Position,g.$ZM.String.with("newName","The new symbol name")],new g.$1M("A promise that resolves to a WorkspaceEdit.",l=>{if(l){if(l.rejectReason)throw new Error(l.rejectReason);return A.WorkspaceEdit.to(l)}})),new g.$2M("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[g.$ZM.Uri,g.$ZM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new g.$1M("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(A.DocumentLink.to))),new g.$2M("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[g.$ZM.Uri],new g.$1M("A promise that resolves to SemanticTokensLegend.",l=>{if(l)return new I.$QL(l.tokenTypes,l.tokenModifiers)})),new g.$2M("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[g.$ZM.Uri],new g.$1M("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const o=(0,L.$20)(l);if(o.type==="full")return new I.$SL(o.data,void 0)})),new g.$2M("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[g.$ZM.Uri,g.$ZM.Range.optional()],new g.$1M("A promise that resolves to SemanticTokensLegend.",l=>{if(l)return new I.$QL(l.tokenTypes,l.tokenModifiers)})),new g.$2M("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[g.$ZM.Uri,g.$ZM.Range],new g.$1M("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const o=(0,L.$20)(l);if(o.type==="full")return new I.$SL(o.data,void 0)})),new g.$2M("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[g.$ZM.Uri,g.$ZM.Position,g.$ZM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),g.$ZM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new g.$1M("A promise that resolves to a CompletionList-instance.",(l,o,i)=>{if(!l)return new I.$9K([]);const n=l.suggestions.map(r=>A.CompletionItem.to(r,i));return new I.$9K(n,l.incomplete)})),new g.$2M("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[g.$ZM.Uri,g.$ZM.Position,g.$ZM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new g.$1M("A promise that resolves to SignatureHelp.",l=>{if(l)return A.SignatureHelp.to(l)})),new g.$2M("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[g.$ZM.Uri,g.$ZM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new g.$1M("A promise that resolves to an array of CodeLens-instances.",(l,o,i)=>S(n=>new I.$1K(A.Range.to(n.range),n.command&&i.fromInternal(n.command)))(l))),new g.$2M("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[g.$ZM.Uri,new g.$ZM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>I.$DK.isRange(l),l=>I.$EK.isSelection(l)?A.Selection.from(l):A.Range.from(l)),g.$ZM.String.with("kind","Code action kind to return code actions for").optional(),g.$ZM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new g.$1M("A promise that resolves to an array of Command-instances.",(l,o,i)=>S(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return i.fromInternal(n.command)}else{const r=new I.$UK(n.title,n.kind?new I.$VK(n.kind):void 0);return n.edit&&(r.edit=A.WorkspaceEdit.to(n.edit)),n.command&&(r.command=i.fromInternal(n.command)),r.isPreferred=n.isPreferred,r}})(l))),new g.$2M("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[g.$ZM.Uri],new g.$1M("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(o=>new I.$cL(A.Range.to(o.range),A.Color.to(o.color))):[])),new g.$2M("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new g.$ZM("color","The color to show and insert",l=>l instanceof I.$bL,A.Color.from),new g.$ZM("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:A.Range.from(l.range)}))],new g.$1M("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(A.ColorPresentation.to):[])),new g.$2M("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[g.$ZM.Uri,g.$ZM.Range],new g.$1M("A promise that resolves to an array of Inlay objects",(l,o,i)=>l.map(A.InlayHint.to.bind(void 0,i)))),new g.$2M("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[g.$ZM.Uri],new g.$1M("A promise that resolves to an array of FoldingRange objects",(l,o)=>{if(l)return l.map(A.FoldingRange.to)})),new g.$2M("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new g.$1M("A promise that resolves to an array of NotebookContentProvider static info objects.",S(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(o=>A.NotebookExclusiveDocumentPattern.to(o))})))),new g.$2M("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[g.$ZM.Uri,g.$ZM.Range,new g.$ZM("context","An InlineValueContext",l=>l&&typeof l.frameId=="number"&&l.stoppedLocation instanceof I.$DK,l=>A.InlineValueContext.from(l))],new g.$1M("A promise that resolves to an array of InlineValue objects",l=>l.map(A.InlineValue.to))),new g.$2M("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new g.$ZM("uriOrString","Uri-instance or string (only http/https)",l=>f.URI.isUri(l)||typeof l=="string"&&(0,y.$RU)(l,T.Schemas.http,T.Schemas.https),l=>l),new g.$ZM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[A.ViewColumn.from(l),void 0]:[A.ViewColumn.from(l.viewColumn),A.TextEditorOpenOptions.from(l)])).optional(),g.$ZM.String.with("label","").optional()],g.$1M.Void),new g.$2M("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[g.$ZM.Uri.with("resource","Resource to open"),g.$ZM.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new g.$ZM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[A.ViewColumn.from(l),void 0]:[A.ViewColumn.from(l.viewColumn),A.TextEditorOpenOptions.from(l)])).optional()],g.$1M.Void),new g.$2M("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[g.$ZM.Uri.with("left","Left-hand side resource of the diff editor"),g.$ZM.Uri.with("right","Right-hand side resource of the diff editor"),g.$ZM.String.with("title","Human readable title for the diff editor").optional(),new g.$ZM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[A.ViewColumn.from(l.viewColumn),A.TextEditorOpenOptions.from(l)]).optional()],g.$1M.Void),new g.$2M("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[g.$ZM.String.with("title","Human readable title for the changes editor"),new g.$ZM("resourceList","List of resources to compare",l=>{for(const o of l){if(o.length!==3)return!1;const[i,n,r]=o;if(!f.URI.isUri(i)||!f.URI.isUri(n)&&n!==void 0&&n!==null||!f.URI.isUri(r)&&r!==void 0&&r!==null)return!1}return!0},l=>l)],g.$1M.Void),new g.$2M("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[g.$ZM.Uri,g.$ZM.Position],new g.$1M("A promise that resolves to an array of TypeHierarchyItem-instances",l=>l.map(A.TypeHierarchyItem.to))),new g.$2M("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[g.$ZM.TypeHierarchyItem],new g.$1M("A promise that resolves to an array of TypeHierarchyItem-instances",l=>l.map(A.TypeHierarchyItem.to))),new g.$2M("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[g.$ZM.TypeHierarchyItem],new g.$1M("A promise that resolves to an array of TypeHierarchyItem-instances",l=>l.map(A.TypeHierarchyItem.to))),new g.$2M("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[g.$ZM.TestItem],g.$1M.Void),new g.$2M("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[g.$ZM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],g.$1M.Void),new g.$2M("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[g.$ZM.String.with("name","The context key name"),new g.$ZM("value","The context key value",()=>!0,l=>l)],g.$1M.Void),new g.$2M("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[g.$ZM.Uri,g.$ZM.StringArray,new g.$ZM("MappedEditsContext","Mapped Edits Context",l=>A.MappedEditsContext.is(l),l=>A.MappedEditsContext.from(l))],new g.$1M("A promise that resolves to a workspace edit or null",l=>l?A.WorkspaceEdit.to(l):null))];class v{static register(o){$.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",b.$Ui)}}e.$Sdc=v;function S(l){return o=>{if(Array.isArray(o))return o.map(l)}}function w(l){if(!Array.isArray(l))return;const o=[];for(const i of l)R.$kt(i)?o.push(A.DefinitionLink.to(i)):o.push(A.location.to(i));return o}}),define(ke[314],Se([1,0,12,59,4,3,2,83,26,15,7,6,25]),function(me,e,C,T,f,R,L,b,y,g,A,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3dc=void 0;function v(S,w,l){const o=S.getProxy(I.$zK.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new y.$bm,w.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===6){const E=this.b.get(h.handle);return E?E.value:h}else if(h&&h.$mid===7){const E=this.b.get(h.commentControlHandle);if(!E)return h;const D=E.getCommentThread(h.commentThreadHandle);return D?D.value:h}else if(h&&(h.$mid===9||h.$mid===8)){const E=this.b.get(h.thread.commentControlHandle);if(!E)return h;const D=E.getCommentThread(h.thread.commentThreadHandle);return D?h.$mid===8?D.value:{thread:D.value,text:h.text}:h}else if(h&&h.$mid===10){const E=this.b.get(h.thread.commentControlHandle);if(!E)return h;const D=E.getCommentThread(h.thread.commentThreadHandle);if(!D)return h;const m=h.commentUniqueId,p=D.getCommentByUniqueId(m);return p||h}else if(h&&h.$mid===11){const E=this.b.get(h.thread.commentControlHandle);if(!E)return h;const D=E.getCommentThread(h.thread.commentThreadHandle);if(!D)return h;const m=h.text,p=h.commentUniqueId,k=D.getCommentByUniqueId(p);return k?(typeof k.body=="string"?k.body=m:k.body=new A.$2K(m),k):h}return h}})}createCommentController(h,E,D){const m=i.a++,p=new r(h,m,E,D);this.b.set(p.handle,p);const k=this.c.get(h.identifier)||[];return k.push(p),this.c.set(h.identifier,k),p.value}async $createCommentThreadTemplate(h,E,D){const m=this.b.get(h);m&&m.$createCommentThreadTemplate(E,D)}async $updateCommentThreadTemplate(h,E,D){const m=this.b.get(h);m&&m.$updateCommentThreadTemplate(E,D)}$deleteCommentThread(h,E){this.b.get(h)?.$deleteCommentThread(E)}$provideCommentingRanges(h,E,D){const m=this.b.get(h);if(!m||!m.commentingRangeProvider)return Promise.resolve(void 0);const p=l.getDocument(L.URI.revive(E));return(0,C.$Qg)(async()=>{const k=await m.commentingRangeProvider.provideCommentingRanges(p,D);let P;return Array.isArray(k)?P={ranges:k,fileComments:!1}:k?P={ranges:k.ranges||[],fileComments:k.fileComments||!1}:P=k??void 0,P}).then(k=>{let P;return k&&(P={ranges:k.ranges.map(z=>g.Range.from(z)),fileComments:k.fileComments}),P})}$toggleReaction(h,E,D,m,p){const k=this.b.get(h);return!k||!k.reactionHandler?Promise.resolve(void 0):(0,C.$Qg)(()=>{const P=k.getCommentThread(E);if(P){const z=P.getCommentByUniqueId(m.uniqueIdInThread);if(k!==void 0&&z&&k.reactionHandler)return k.reactionHandler(z,s(p))}return Promise.resolve(void 0)})}}class n{static{this.a=0}set threadId(h){this.n=h}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(h){(h===void 0!=(this.p===void 0)||!h||!this.p||!h.isEqual(this.p))&&(this.p=h,this.b.range=h,this.c.fire())}get range(){return this.p}set canReply(h){this.d!==h&&(this.d=h,this.b.canReply=h,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(h){this.e=h,this.b.label=h,this.c.fire()}get contextValue(){return this.f}set contextValue(h){this.f=h,this.b.contextValue=h,this.c.fire()}get comments(){return this.q}set comments(h){this.q=h,this.b.comments=h,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(h){this.g=h,this.b.collapsibleState=h,this.c.fire()}get state(){return this.h}set state(h){this.h=h,this.b.state=h,this.c.fire()}get isDisposed(){return this.j}constructor(h,E,D,m,p,k,P,z){this.m=E,this.n=D,this.o=m,this.p=p,this.q=k,this.extensionDescription=P,this.r=z,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new f.$Rd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.$Sc,this.l.value=new R.$Qc,this.n===void 0&&(this.n=`${h}.${this.handle}`),o.$createCommentThread(E,this.handle,this.n,this.o,g.Range.from(this.p),P.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=k,this.i.push({dispose:()=>{o.$deleteCommentThread(E,this.handle)}});const j=this;this.value={get uri(){return j.uri},get range(){return j.range},set range(M){j.range=M},get comments(){return j.comments},set comments(M){j.comments=M},get collapsibleState(){return j.collapsibleState},set collapsibleState(M){j.collapsibleState=M},get canReply(){return j.canReply},set canReply(M){j.canReply=M},get contextValue(){return j.contextValue},set contextValue(M){j.contextValue=M},get label(){return j.label},set label(M){j.label=M},get state(){return j.state},set state(M){j.state=M},dispose:()=>{j.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.$Qc);const h=D=>Object.prototype.hasOwnProperty.call(this.b,D),E={};h("range")&&(E.range=g.Range.from(this.p)),h("label")&&(E.label=this.label),h("contextValue")&&(E.contextValue=this.contextValue??null),h("comments")&&(E.comments=this.q.map(D=>a(this,D,this.k,this.extensionDescription))),h("collapsibleState")&&(E.collapseState=d(this.g)),h("canReply")&&(E.canReply=this.canReply),h("state")&&(E.state=c(this.h)),h("isTemplate")&&(E.isTemplate=this.r),this.b={},o.$updateCommentThread(this.m,this.handle,this.n,this.o,E)}getCommentByUniqueId(h){for(const E of this.k){const D=E[0],m=E[1];if(h===m)return D}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(h=>h.dispose())}}He([(0,T.$oh)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class r{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(h){this.b=h,o.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(h){this.c=h,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!h})}get options(){return this.d}set options(h){this.d=h,o.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(h,E,D,m){this.f=h,this.g=E,this.h=D,this.i=m,this.a=new Map,o.$registerCommentController(this.handle,D,m,this.f.identifier.value);const p=this;this.value=Object.freeze({id:p.id,label:p.label,get options(){return p.options},set options(k){p.options=k},get commentingRangeProvider(){return p.commentingRangeProvider},set commentingRangeProvider(k){p.commentingRangeProvider=k},get reactionHandler(){return p.reactionHandler},set reactionHandler(k){p.reactionHandler=k},createCommentThread(k,P,z){return p.createCommentThread(k,P,z).value},dispose:()=>{p.dispose()}}),this.e=[],this.e.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(h,E,D){E===void 0&&(0,$.$NF)(this.f,"fileComments");const m=new n(this.id,this.handle,void 0,h,E,D,this.f,!1);return this.a.set(m.handle,m),m}$createCommentThreadTemplate(h,E){const D=new n(this.id,this.handle,void 0,L.URI.revive(h),g.Range.to(E),[],this.f,!0);return D.collapsibleState=b.CommentThreadCollapsibleState.Expanded,this.a.set(D.handle,D),D}$updateCommentThreadTemplate(h,E){const D=this.a.get(h);D&&(D.range=g.Range.to(E))}$deleteCommentThread(h){this.a.get(h)?.dispose(),this.a.delete(h)}getCommentThread(h){return this.a.get(h)}dispose(){this.a.forEach(h=>{h.dispose()}),this.e.forEach(h=>h.dispose())}}function a(u,h,E,D){let m=E.get(h);return m||(m=++u.commentHandle,E.set(h,m)),h.state!==void 0&&(0,$.$NF)(D,"commentsDraftState"),{mode:h.mode,contextValue:h.contextValue,uniqueIdInThread:m,body:typeof h.body=="string"?h.body:g.MarkdownString.from(h.body),userName:h.author.name,userIconPath:h.author.iconPath,label:h.label,commentReactions:h.reactions?h.reactions.map(p=>t(p)):void 0,state:h.state,timestamp:h.timestamp?.toJSON()}}function t(u){return{label:u.label,iconPath:u.iconPath?g.$AM(u.iconPath):void 0,count:u.count,hasReacted:u.authorHasReacted}}function s(u){return{label:u.label||"",count:u.count||0,iconPath:u.iconPath?L.URI.revive(u.iconPath):"",authorHasReacted:u.hasReacted||!1}}function d(u){if(u!==void 0)switch(u){case A.CommentThreadCollapsibleState.Expanded:return b.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return b.CommentThreadCollapsibleState.Collapsed}return b.CommentThreadCollapsibleState.Collapsed}function c(u){if(u!==void 0)switch(u){case A.CommentThreadState.Unresolved:return b.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return b.CommentThreadState.Resolved}return b.CommentThreadState.Unresolved}return new i}e.$3dc=v}),define(ke[315],Se([1,0,24,6,27,20]),function(me,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qfc=void 0;let L=class{constructor(A,I){this.a=A.getProxy(T.$zK.MainThreadConsole),this.b=I.consoleForward.includeStack,this.c=I.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(A,I){const $=this,v=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){$.e(A,I,v,arguments)}})}e(A,I,$,v){this.a.$logExtensionHostMessage({type:"__$console",severity:I,arguments:y(v,this.b)}),this.c&&this.f(A,$,v)}};e.$Qfc=L,e.$Qfc=L=He([Be(0,R.$BM),Be(1,f.$RM)],L);const b=1e5;function y(g,A){const I=[];if(g.length)for(let $=0;$<g.length;$++){let v=g[$];if(typeof v>"u")v="undefined";else if(v instanceof Error){const S=v;S.stack?v=S.stack:v=S.toString()}I.push(v)}if(A){const $=new Error().stack;$&&I.push({__$stack:$.split(`
`).slice(3).join(`
`)})}try{const $=(0,C.$fn)(I);return $.length>b?"Output omitted for a large object that exceeds the limits":$}catch($){return`Output omitted for an object that cannot be inspected ('${$.toString()}')`}}}),define(ke[151],Se([1,0,2,6,7,5,20,14,19,13,16,25]),function(me,e,C,T,f,R,L,b,y,g,A,I){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$Tec=e.$Sec=void 0;let v=class{static{$=this}static{this.c=0}static{this.d=250}constructor(w,l){this.h=l,this.f=new Map,this.g=w.getProxy(T.$zK.MainThreadDecorations)}registerFileDecorationProvider(w,l){const o=$.c++;this.f.set(o,{provider:w,extensionDescription:l}),this.g.$registerDecorationProvider(o,l.identifier.value);const i=w.onDidChangeFileDecorations&&w.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(o,null);return}const r=(0,y.$2b)(n);if(r.length<=$.d){this.g.$onDidChange(o,r);return}this.h.warn("[Decorations] CAPPING events from decorations provider",l.identifier.value,r.length);const a=r.map(d=>({uri:d,rank:(0,g.$Ke)(d.path,"/")})),t=(0,y.$yb)(a,(d,c)=>d.rank-c.rank||(0,g.$Ye)(d.uri.path,c.uri.path)),s=[];e:for(const d of t){let c;for(const u of d){const h=(0,A.$lc)(u.uri.path);if(c!==h&&(c=h,s.push(u.uri)>=$.d))break e}}this.g.$onDidChange(o,s)});return new f.$BK(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(w,l,o){if(!this.f.has(w))return Object.create(null);const i=Object.create(null),{provider:n,extensionDescription:r}=this.f.get(w);return await Promise.all(l.map(async a=>{try{const{uri:t,id:s}=a,d=await Promise.resolve(n.provideFileDecoration(C.URI.revive(t),o));if(!d)return;try{f.$WL.validate(d),d.badge&&typeof d.badge!="string"&&(0,I.$NF)(r,"codiconDecoration"),i[s]=[d.propagate,d.tooltip,d.badge,d.color]}catch(c){this.h.warn(`INVALID decoration from extension '${r.identifier.value}': ${c}`)}}catch(t){this.h.error(t)}})),i}};e.$Sec=v,e.$Sec=v=$=He([Be(0,L.$BM),Be(1,b.$dj)],v),e.$Tec=(0,R.$Vh)("IExtHostDecorations")}),define(ke[316],Se([1,0,211,136,2,6,7,15,4,14,28,57]),function(me,e,C,T,f,R,L,b,y,g,A,I){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ndc=e.$Mdc=void 0;class v{#e;#t;#i;constructor(l,o,i,n,r,a,t,s){this.d=l,this.e=o,this.f=i,this.g=n,this.h=r,this.c=!1,this.f=Math.max(n,i),this.#i=new A.$zc(d=>a.getComparisonKey(d)),this.#e=t,this.#t=s}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(l,o){if(!l){this.clear();return}this.j();let i=[];if(f.URI.isUri(l)){if(!o){this.delete(l);return}this.#i.set(l,o.slice()),i=[l]}else if(Array.isArray(l)){i=[];let a;l=[...l].sort(v.k);for(const t of l){const[s,d]=t;if((!a||s.toString()!==a.toString())&&(a&&this.#i.get(a).length===0&&this.#i.delete(a),a=s,i.push(s),this.#i.set(s,[])),d)this.#i.get(s)?.push(...d);else{const c=this.#i.get(s);c&&(c.length=0)}}}if(this.#t.fire(i),!this.#e)return;const n=[];let r=0;for(const a of i){let t=[];const s=this.#i.get(a);if(s)if(s.length>this.g){t=[];const d=[L.DiagnosticSeverity.Error,L.DiagnosticSeverity.Warning,L.DiagnosticSeverity.Information,L.DiagnosticSeverity.Hint];e:for(let c=0;c<4;c++)for(const u of s)if(u.severity===d[c]&&t.push({...b.Diagnostic.from(u),modelVersionId:this.h(a)})===this.g)break e;t.push({severity:T.MarkerSeverity.Info,message:(0,C.localize)(0,null,s.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=s.map(d=>({...b.Diagnostic.from(d),modelVersionId:this.h(a)}));if(n.push([a,t]),r+=t.length,r>this.f)break}this.#e.$changeMany(this.e,n)}delete(l){this.j(),this.#t.fire([l]),this.#i.delete(l),this.#e?.$changeMany(this.e,[[l,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(l,o){this.j();for(const[i,n]of this)l.call(o,i,n,this)}*[Symbol.iterator](){this.j();for(const l of this.#i.keys())yield[l,this.get(l)]}get(l){this.j();const o=this.#i.get(l);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(l){return this.j(),Array.isArray(this.#i.get(l))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(l,o){return l[0].toString()<o[0].toString()?-1:l[0].toString()>o[0].toString()?1:0}}e.$Mdc=v;let S=class{static{$=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*$.d}static _mapper(l){const o=new A.$zc;for(const i of l)o.set(i,i);return{uris:Object.freeze(Array.from(o.values()))}}constructor(l,o,i,n){this.j=o,this.k=i,this.l=n,this.g=new Map,this.h=new y.$Vd({merge:r=>r.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this.h.event,$._mapper),this.f=l.getProxy(R.$zK.MainThreadDiagnostics)}createDiagnosticCollection(l,o){const{g:i,f:n,h:r,j:a,k:t,l:s}=this,d=new class{$changeMany(h,E){n.$changeMany(h,E),a.trace("[DiagnosticCollection] change many (extension, owner, uris)",l.value,h,E.length===0?"CLEARING":E)}$clear(h){n.$clear(h),a.trace("[DiagnosticCollection] remove all (extension, owner)",l.value,h)}dispose(){n.dispose()}};let c;if(!o)o="_generated_diagnostic_collection_name_#"+$.c++,c=o;else if(!i.has(o))c=o;else{this.j.warn(`DiagnosticCollection with name '${o}' does already exist.`);do c=o+$.c++;while(i.has(c))}return new class extends v{constructor(){super(o,c,$.e,$.d,h=>s.getDocument(h)?.version,t.extUri,d,r),i.set(c,this)}dispose(){super.dispose(),i.delete(c)}}}getDiagnostics(l){if(l)return this.m(l);{const o=new Map,i=[];for(const n of this.g.values())n.forEach((r,a)=>{let t=o.get(r.toString());typeof t>"u"&&(t=i.length,o.set(r.toString(),t),i.push([r,[]])),i[t][1]=i[t][1].concat(...a)});return i}}m(l){let o=[];for(const i of this.g.values())i.has(l)&&(o=o.concat(i.get(l)));return o}$acceptMarkersChange(l){if(!this.n){const o="_generated_mirror",i=new v(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this.k.extUri,void 0,this.h);this.g.set(o,i),this.n=i}for(const[o,i]of l)this.n.set(f.URI.revive(o),i.map(b.Diagnostic.to))}};e.$Ndc=S,e.$Ndc=S=$=He([Be(1,g.$dj),Be(2,I.$Ldc)],S)}),define(ke[317],Se([1,0,2,6,25]),function(me,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uec=void 0;class R{constructor(b){this.a=b.getProxy(T.$zK.MainThreadDialogs)}showOpenDialog(b,y){return y?.allowUIResources&&(0,f.$NF)(b,"showLocal"),this.a.$showOpenDialog(y).then(g=>g?g.map(A=>C.URI.revive(A)):void 0)}showSaveDialog(b){return this.a.$showSaveDialog(b).then(y=>y?C.URI.revive(y):void 0)}}e.$Uec=R}),define(ke[318],Se([1,0,8,2,7,6,17,21,13]),function(me,e,C,T,f,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vec=void 0;class g{static{this.a=0}constructor(I,$,v){this.d=$,this.e=v,this.b=new Map,this.c=I.getProxy(R.$zK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,$){if(Object.keys(L.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const v=g.a++;this.b.set(v,$),this.c.$registerTextContentProvider(v,I);let S;return typeof $.onDidChange=="function"&&(S=$.onDidChange(w=>{if(w.scheme!==I){this.e.warn(`Provider for scheme '${I}' is firing event for schema '${w.scheme}' which will be IGNORED`);return}this.d.getDocument(w)&&this.$provideTextDocumentContent(v,w).then(l=>{if(!l&&typeof l!="string")return;const o=this.d.getDocument(w);if(!o)return;const i=(0,y.$Te)(l);if(!o.equalLines(i))return this.c.$onVirtualDocumentChange(w,l)},C.$Z)})),new f.$BK(()=>{this.b.delete(v)&&this.c.$unregisterTextContentProvider(v),S&&(S.dispose(),S=void 0)})}$provideTextDocumentContent(I,$){const v=this.b.get(I);return v?Promise.resolve(v.provideTextDocumentContent(T.URI.revive($),b.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${$.scheme}`))}}e.$Vec=g}),define(ke[319],Se([1,0,4,3,2,6,143,15,18,24,7,8]),function(me,e,C,T,f,R,L,b,y,g,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jdc=void 0;class ${constructor(S,w){this.a=new C.$Rd({onListenerError:I.$1}),this.b=new C.$Rd({onListenerError:I.$1}),this.c=new C.$Rd({onListenerError:I.$1}),this.d=new C.$Rd({onListenerError:I.$1}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new T.$Qc,this.h=new Map,this.f=S.getProxy(R.$zK.MainThreadDocuments),this.g=w,this.g.onDidRemoveDocuments(l=>{for(const o of l)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(l=>{for(const o of l)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(S){if(!S)return;const w=this.g.getDocument(S);if(w)return w}getDocument(S){const w=this.getDocumentData(S);if(!w?.document)throw new Error(`Unable to retrieve document from URI '${S}'`);return w.document}ensureDocumentData(S){const w=this.g.getDocument(S);if(w)return Promise.resolve(w);let l=this.h.get(S.toString());return l||(l=this.f.$tryOpenDocument(S).then(o=>{this.h.delete(S.toString());const i=f.URI.revive(o);return(0,y.$Nf)(this.g.getDocument(i))},o=>(this.h.delete(S.toString()),Promise.reject(o))),this.h.set(S.toString(),l)),l}createDocumentData(S){return this.f.$tryCreateDocument(S).then(w=>f.URI.revive(w))}$acceptModelLanguageChanged(S,w){const l=f.URI.revive(S),o=this.g.getDocument(l);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(w),this.a.fire(o.document)}$acceptModelSaved(S){const w=f.URI.revive(S),l=this.g.getDocument(w);if(!l)throw new Error("unknown document");this.$acceptDirtyStateChanged(S,!1),this.d.fire(l.document)}$acceptDirtyStateChanged(S,w){const l=f.URI.revive(S),o=this.g.getDocument(l);if(!o)throw new Error("unknown document");o._acceptIsDirty(w),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(S,w,l){const o=f.URI.revive(S),i=this.g.getDocument(o);if(!i)throw new Error("unknown document");i._acceptIsDirty(l),i.onEvents(w);let n;w.isUndoing?n=A.TextDocumentChangeReason.Undo:w.isRedoing&&(n=A.TextDocumentChangeReason.Redo),this.c.fire((0,g.$bn)({document:i.document,contentChanges:w.changes.map(r=>({range:b.Range.to(r.range),rangeOffset:r.rangeOffset,rangeLength:r.rangeLength,text:r.text})),reason:n}))}setWordDefinitionFor(S,w){(0,L.$DM)(S,w)}}e.$Jdc=$}),define(ke[69],Se([1,0,60,4,3,2,5,6,143,20,150,15,14,28,17,51,48]),function(me,e,C,T,f,R,L,b,y,g,A,I,$,v,S,w,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MM=e.$LM=void 0;class o{constructor(r){this.value=r,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(r,a){this.h=r,this.i=a,this.a=null,this.b=new Map,this.c=new v.$zc,this.d=new T.$Rd,this.e=new T.$Rd,this.f=new T.$Rd,this.g=new T.$Rd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const a=[],t=[],s=[];if(r.removedDocuments)for(const d of r.removedDocuments){const c=R.URI.revive(d),u=this.c.get(c);u?.unref()&&(this.c.delete(c),a.push(u.value))}if(r.addedDocuments)for(const d of r.addedDocuments){const c=R.URI.revive(d.uri);let u=this.c.get(c);if(u&&c.scheme!==S.Schemas.vscodeNotebookCell&&c.scheme!==S.Schemas.vscodeInteractiveInput)throw new Error(`document '${c} already exists!'`);u||(u=new o(new y.$EM(this.h.getProxy(b.$zK.MainThreadDocuments),c,d.lines,d.EOL,d.versionId,d.languageId,d.isDirty,d.notebook)),this.c.set(c,u),t.push(u.value)),u.ref()}if(r.removedEditors)for(const d of r.removedEditors){const c=this.b.get(d);this.b.delete(d),c&&s.push(c)}if(r.addedEditors)for(const d of r.addedEditors){const c=R.URI.revive(d.documentUri);C.ok(this.c.has(c),`document '${c}' does not exist`),C.ok(!this.b.has(d.id),`editor '${d.id}' already exists!`);const u=this.c.get(c).value,h=new A.$KM(d.id,this.h.getProxy(b.$zK.MainThreadTextEditors),this.i,new l.$U(()=>u.document),d.selections.map(I.Selection.to),d.options,d.visibleRanges.map(E=>I.Range.to(E)),typeof d.editorPosition=="number"?I.ViewColumn.to(d.editorPosition):void 0);this.b.set(d.id,h)}r.newActiveEditor!==void 0&&(C.ok(r.newActiveEditor===null||this.b.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this.a=r.newActiveEditor),(0,f.$Mc)(a),(0,f.$Mc)(s),r.removedDocuments&&this.e.fire(a),r.addedDocuments&&this.d.fire(t),(r.removedEditors||r.addedEditors)&&this.f.fire(this.allEditors().map(d=>d.value)),r.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(r){return this.c.get(r)?.value}allDocuments(){return w.Iterable.map(this.c.values(),r=>r.value)}getEditor(r){return this.b.get(r)}activeEditor(r){if(!this.a)return;const a=this.b.get(this.a);return r?a:a?.value}allEditors(){return[...this.b.values()]}};e.$LM=i,e.$LM=i=He([Be(0,g.$BM),Be(1,$.$dj)],i),e.$MM=(0,L.$Vh)("IExtHostDocumentsAndEditors")}),define(ke[70],Se([1,0,73,4,18,2,5,6,20,15,7]),function(me,e,C,T,f,R,L,b,y,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kec=e.$jec=void 0,e.$jec=(0,L.$Vh)("IExtHostEditorTabs");class I{constructor(l,o,i){this.e=i,this.d=o,this.acceptDtoUpdate(l)}get apiObject(){if(!this.a){const l=this,o={get isActive(){return l.b.id===l.e()},get label(){return l.b.label},get input(){return l.c},get isDirty(){return l.b.isDirty},get isPinned(){return l.b.isPinned},get isPreview(){return l.b.isPreview},get group(){return l.d.apiObject}};this.a=Object.freeze(o)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(l){this.b=l,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.$gM(R.URI.revive(this.b.input.uri));case 2:return new A.$hM(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified));case 3:return new A.$iM(R.URI.revive(this.b.input.base),R.URI.revive(this.b.input.input1),R.URI.revive(this.b.input.input2),R.URI.revive(this.b.input.result));case 6:return new A.$jM(R.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.$kM(this.b.input.viewType);case 4:return new A.$lM(R.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.$mM(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.$nM;case 9:return new A.$oM(R.URI.revive(this.b.input.uri),R.URI.revive(this.b.input.inputBoxUri));case 10:return new A.$pM(this.b.input.providerId);default:return}}}class ${constructor(l,o){this.c=[],this.d="",this.b=l,this.e=o;for(const i of l.tabs)i.isActive&&(this.d=i.id),this.c.push(new I(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const l=this,o={get isActive(){return l.b.groupId===l.e()},get viewColumn(){return g.ViewColumn.to(l.b.viewColumn)},get activeTab(){return l.c.find(i=>i.tabId===l.d)?.apiObject},get tabs(){return Object.freeze(l.c.map(i=>i.apiObject))}};this.a=Object.freeze(o)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(l){this.b=l}acceptTabOperation(l){if(l.kind===0){const i=new I(l.tabDto,this,()=>this.activeTabId());return this.c.splice(l.index,0,i),l.tabDto.isActive&&(this.d=i.tabId),i}else if(l.kind===1){const i=this.c.splice(l.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${l.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(l.kind===3){if(l.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(l.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${l.oldIndex} which does not exist`);return this.c.splice(l.index,0,i),i}const o=this.c.find(i=>i.tabId===l.tabDto.id);if(!o)throw new Error("INVALID tab");return l.tabDto.isActive?this.d=l.tabDto.id:this.d===l.tabDto.id&&!l.tabDto.isActive&&(this.d=""),o.acceptDtoUpdate(l.tabDto),o}activeTabId(){return this.d}}let v=class{constructor(l){this.b=new T.$Rd,this.c=new T.$Rd,this.e=[],this.a=l.getProxy(b.$zK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const l=this,o={onDidChangeTabGroups:l.c.event,onDidChangeTabs:l.b.event,get all(){return Object.freeze(l.e.map(i=>i.apiObject))},get activeTabGroup(){const i=l.d;return(0,f.$Nf)(l.e.find(r=>r.groupId===i)?.apiObject)},close:async(i,n)=>{const r=Array.isArray(i)?i:[i];return r.length?S(r[0])?this.j(r,n):this.i(r,n):!0}};this.f=Object.freeze(o)}return this.f}$acceptEditorTabModel(l){const o=new Set(this.e.map(d=>d.groupId)),i=new Set(l.map(d=>d.groupId)),n=(0,C.$K)(o,i),r=this.e.filter(d=>n.removed.includes(d.groupId)).map(d=>d.apiObject),a=[],t=[];this.e=l.map(d=>{const c=new $(d,()=>this.d);return n.added.includes(c.groupId)?a.push(c.apiObject):t.push(c.apiObject),c});const s=(0,f.$Nf)(l.find(d=>d.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:a,closed:r,changed:t}))}$acceptTabGroupUpdate(l){const o=this.e.find(i=>i.groupId===l.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(l),l.isActive&&(this.d=l.groupId),this.c.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(l){const o=this.e.find(n=>n.groupId===l.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const i=o.acceptTabOperation(l);switch(l.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(l){for(const o of this.e)for(const i of o.tabs)if(i.apiObject===l)return i}h(l){return this.e.find(o=>o.apiObject===l)}async i(l,o){const i=[];for(const n of l){const r=this.g(n);if(!r)throw new Error("Tab close: Invalid tab not found!");i.push(r.tabId)}return this.a.$closeTab(i,o)}async j(l,o){const i=[];for(const n of l){const r=this.h(n);if(!r)throw new Error("Group close: Invalid group not found!");i.push(r.groupId)}return this.a.$closeGroup(i,o)}};e.$kec=v,e.$kec=v=He([Be(0,y.$BM)],v);function S(w){return w.tabs!==void 0}}),define(ke[320],Se([1,0,6,7]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xec=void 0;class f{constructor(L){this.a=new Map,this.b=0,this.c=L.getProxy(C.$zK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(L,b,y){if(this.a.size===0)throw new Error("No embedding vector providers registered");const g=this.a.get(L);if(!g)throw new Error("Embedding vector provider not found");const A=await g.provideEmbeddingVector(b,y);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(L,b,y){const g=this.b;return this.b++,this.a.set(g,y),this.c.$registerAiEmbeddingVectorProvider(b,g),new T.$BK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(g),this.a.delete(g)})}}e.$Xec=f}),define(ke[321],Se([1,0,2,6,3,7,15,173,13,22,25,80]),function(me,e,C,T,f,R,L,b,y,g,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yec=void 0;class ${constructor(){this.a=[]}add(w){this.b=void 0,this.a.push(w)}delete(w){const l=this.a.indexOf(w);l>=0&&(this.a.splice(l,1),this.b=void 0)}c(){if(!this.b){const w=this.a.sort(),l=[];let o,i,n=14,r=14;for(const a of w){let t=o?(0,y.$8e)(o,a):0;for(t===0?i=1:i=r;t<a.length;t++)t+1===a.length?(n=r,r=9):r+=1,l.push([i,a.toUpperCase().charCodeAt(t),r]),l.push([i,a.toLowerCase().charCodeAt(t),r]),i=r;o=a,r=n}l.push([9,58,10]),l.push([10,47,12]),this.b=new b.$3Y(l)}}provideDocumentLinks(w){this.c();const l=[],o=b.$4Y.computeLinks({getLineContent(i){return w.lineAt(i-1).text},getLineCount(){return w.lineCount}},this.b);for(const i of o){const n=L.DocumentLink.to(i);n.target&&l.push(n)}return l}}class v{constructor(w,l){this.i=l,this.b=new $,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=w.getProxy(T.$zK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(w,l,o,i={}){if(v.j(o),this.d.has(l))throw new Error(`a provider for the scheme '${l}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(w,"*",this.b));const n=this.h++;this.b.add(l),this.d.add(l),this.c.set(n,o);let r=2;i.isCaseSensitive&&(r+=1024),i.isReadonly&&(r+=2048),typeof o.copy=="function"&&(r+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,A.$NF)(w,"fsChunks"),r+=4);let a;i.isReadonly&&(0,I.$$j)(i.isReadonly)&&((0,A.$NF)(w,"readonlyMessage"),a={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(n,l,r,a).catch(s=>{console.error(`FAILED to register filesystem provider of ${w.identifier.value}-extension for the scheme ${l}`),console.error(s)});const t=o.onDidChangeFile(s=>{const d=[];for(const c of s){const{uri:u,type:h}=c;if(u.scheme!==l)continue;let E;switch(h){case R.FileChangeType.Changed:E=0;break;case R.FileChangeType.Created:E=1;break;case R.FileChangeType.Deleted:E=2;break;default:throw new Error("Unknown FileChangeType")}d.push({resource:u,type:E})}this.a.$onFileSystemChange(n,d)});return(0,f.$Pc)(()=>{t.dispose(),this.b.delete(l),this.d.delete(l),this.c.delete(n),this.a.$unregisterProvider(n)})}static j(w){if(!w)throw new Error("MISSING provider");if(typeof w.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof w.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof w.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof w.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof w.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof w.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof w.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof w.rename!="function")throw new Error("Provider does NOT implement rename")}static k(w){const{type:l,ctime:o,mtime:i,size:n,permissions:r}=w;return{type:l,ctime:o,mtime:i,size:n,permissions:r}}$stat(w,l){return Promise.resolve(this.l(w).stat(C.URI.revive(l))).then(o=>v.k(o))}$readdir(w,l){return Promise.resolve(this.l(w).readDirectory(C.URI.revive(l)))}$readFile(w,l){return Promise.resolve(this.l(w).readFile(C.URI.revive(l))).then(o=>g.$fe.wrap(o))}$writeFile(w,l,o,i){return Promise.resolve(this.l(w).writeFile(C.URI.revive(l),o.buffer,i))}$delete(w,l,o){return Promise.resolve(this.l(w).delete(C.URI.revive(l),o))}$rename(w,l,o,i){return Promise.resolve(this.l(w).rename(C.URI.revive(l),C.URI.revive(o),i))}$copy(w,l,o,i){const n=this.l(w);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(C.URI.revive(l),C.URI.revive(o),i))}$mkdir(w,l){return Promise.resolve(this.l(w).createDirectory(C.URI.revive(l)))}$watch(w,l,o,i){const n=this.l(w).watch(C.URI.revive(o),i);this.f.set(l,n)}$unwatch(w,l){const o=this.f.get(l);o&&(o.dispose(),this.f.delete(l))}$open(w,l,o){const i=this.l(w);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(C.URI.revive(l),o))}$close(w,l){const o=this.l(w);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(l))}$read(w,l,o,i){const n=this.l(w);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const r=g.$fe.alloc(i);return Promise.resolve(n.read(l,o,r.buffer,0,i)).then(a=>r.slice(0,a))}$write(w,l,o,i){const n=this.l(w);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(l,o,i.buffer,0,i.byteLength))}l(w){const l=this.c.get(w);if(!l){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return l}}e.$Yec=v}),define(ke[71],Se([1,0,6,31,7,22,5,20,57,3,12,23,17]),function(me,e,C,T,f,R,L,b,y,g,A,I,$){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$_dc=e.$$dc=void 0;let S=v=class{constructor(l,o){this.b=new Map,this.c=new A.$7g,this.a=l.getProxy(C.$zK.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(n){try{let r;const a=i.b.get(n.scheme);return a?(await i.a.$ensureActivation(n.scheme),r=await a.impl.stat(n)):r=await i.a.$stat(n),{type:r.type,ctime:r.ctime,mtime:r.mtime,size:r.size,permissions:r.permissions===T.FilePermission.Readonly?1:void 0}}catch(r){v.e(r)}},async readDirectory(n){try{const r=i.b.get(n.scheme);return r?(await i.a.$ensureActivation(n.scheme),(await r.impl.readDirectory(n)).slice()):await i.a.$readdir(n)}catch(r){return v.e(r)}},async createDirectory(n){try{const r=i.b.get(n.scheme);return r&&!r.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(r.impl,r.extUri,n)):await i.a.$mkdir(n)}catch(r){return v.e(r)}},async readFile(n){try{const r=i.b.get(n.scheme);return r?(await i.a.$ensureActivation(n.scheme),(await r.impl.readFile(n)).slice()):(await i.a.$readFile(n)).buffer}catch(r){return v.e(r)}},async writeFile(n,r){try{const a=i.b.get(n.scheme);return a&&!a.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(a.impl,a.extUri,a.extUri.dirname(n)),await i.c.queueFor(n).queue(()=>Promise.resolve(a.impl.writeFile(n,r,{create:!0,overwrite:!0})))):await i.a.$writeFile(n,R.$fe.wrap(r))}catch(a){return v.e(a)}},async delete(n,r){try{const a=i.b.get(n.scheme);return a&&!a.isReadonly?(await i.a.$ensureActivation(n.scheme),await a.impl.delete(n,{recursive:!1,...r})):await i.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...r})}catch(a){return v.e(a)}},async rename(n,r,a){try{return await i.a.$rename(n,r,{overwrite:!1,...a})}catch(t){return v.e(t)}},async copy(n,r,a){try{return await i.a.$copy(n,r,{overwrite:!1,...a})}catch(t){return v.e(t)}},isWritableFileSystem(n){const r=o.getCapabilities(n);if(typeof r=="number")return!(r&2048)}})}async d(l,o,i){const n=[];for(;!o.isEqual(i,o.dirname(i));)try{if(!((await l.stat(i)).type&T.FileType.Directory))throw f.$OL.FileExists(`Unable to create folder '${i.scheme===$.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(r){if(T.$uk(r)!==T.FileSystemProviderErrorCode.FileNotFound)throw r;n.push(o.basename(i)),i=o.dirname(i)}for(let r=n.length-1;r>=0;r--){i=o.joinPath(i,n[r]);try{await l.createDirectory(i)}catch(a){if(T.$uk(a)!==T.FileSystemProviderErrorCode.FileExists)throw a}}}static e(l){if(l instanceof f.$OL)throw l;if(l instanceof T.$qk)switch(l.code){case T.FileSystemProviderErrorCode.FileExists:throw f.$OL.FileExists(l.message);case T.FileSystemProviderErrorCode.FileNotFound:throw f.$OL.FileNotFound(l.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw f.$OL.FileNotADirectory(l.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw f.$OL.FileIsADirectory(l.message);case T.FileSystemProviderErrorCode.NoPermissions:throw f.$OL.NoPermissions(l.message);case T.FileSystemProviderErrorCode.Unavailable:throw f.$OL.Unavailable(l.message);default:throw new f.$OL(l.message,l.name)}if(!(l instanceof Error))throw new f.$OL(String(l));if(l.name==="ENOPRO"||l.message.includes("ENOPRO"))throw f.$OL.Unavailable(l.message);switch(l.name){case T.FileSystemProviderErrorCode.FileExists:throw f.$OL.FileExists(l.message);case T.FileSystemProviderErrorCode.FileNotFound:throw f.$OL.FileNotFound(l.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw f.$OL.FileNotADirectory(l.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw f.$OL.FileIsADirectory(l.message);case T.FileSystemProviderErrorCode.NoPermissions:throw f.$OL.NoPermissions(l.message);case T.FileSystemProviderErrorCode.Unavailable:throw f.$OL.Unavailable(l.message);default:throw new f.$OL(l.message,l.name)}}addFileSystemProvider(l,o,i){return this.b.set(l,{impl:o,extUri:i?.isCaseSensitive?I.$pg:I.$rg,isReadonly:!!i?.isReadonly}),(0,g.$Pc)(()=>this.b.delete(l))}getFileSystemProviderExtUri(l){return this.b.get(l)?.extUri??I.$pg}};e.$$dc=S,e.$$dc=S=v=He([Be(0,b.$BM),Be(1,y.$Ldc)],S),e.$_dc=(0,L.$Vh)("IExtHostConsumerFileSystem")}),define(ke[322],Se([1,0,4,34,2,6,15,7,48]),function(me,e,C,T,f,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zec=void 0;class g{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(v,S,w,l,o,i){this.a=Math.random(),this.b=new C.$Rd,this.c=new C.$Rd,this.d=new C.$Rd,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const n=(0,T.$Cj)(o),r=typeof o=="string",a=i?.correlate,t=l(s=>{if(!(typeof s.session=="number"&&s.session!==this.a)&&!(a&&typeof s.session>"u")){if(!i?.ignoreCreateEvents)for(const d of s.created){const c=f.URI.revive(d);n(c.fsPath)&&(!r||S.getWorkspaceFolder(c))&&this.b.fire(c)}if(!i?.ignoreChangeEvents)for(const d of s.changed){const c=f.URI.revive(d);n(c.fsPath)&&(!r||S.getWorkspaceFolder(c))&&this.c.fire(c)}if(!i?.ignoreDeleteEvents)for(const d of s.deleted){const c=f.URI.revive(d);n(c.fsPath)&&(!r||S.getWorkspaceFolder(c))&&this.d.fire(c)}}});this.g=b.$BK.from(this.i(v,w,o,i,i?.correlate),this.b,this.c,this.d,t)}i(v,S,w,l,o){const i=b.$BK.from();if(typeof w=="string")return i;const n=v.getProxy(R.$zK.MainThreadFileSystemEventService);let r=!1;return(w.pattern.includes(T.$yj)||w.pattern.includes(T.$zj))&&(r=!0),n.$watch(S.identifier.value,this.a,w.baseUri,{recursive:r,excludes:l?.excludes??[]},!!o),b.$BK.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor(v){this.a=v,this.session=this.a.session,this.b=new y.$U(()=>this.a.created.map(f.URI.revive)),this.c=new y.$U(()=>this.a.changed.map(f.URI.revive)),this.d=new y.$U(()=>this.a.deleted.map(f.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class I{constructor(v,S,w){this.j=v,this.k=S,this.l=w,this.a=new C.$Rd,this.b=new C.$Rd,this.c=new C.$Rd,this.d=new C.$Rd,this.g=new C.$Td,this.h=new C.$Td,this.i=new C.$Td,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(v,S,w,l){return new g(this.j,v,S,this.a.event,L.GlobPattern.from(w),l)}$onFileEvent(v){this.a.fire(new A(v))}$onDidRunFileOperation(v,S){switch(v){case 2:this.b.fire(Object.freeze({files:S.map(w=>({oldUri:f.URI.revive(w.source),newUri:f.URI.revive(w.target)}))}));break;case 1:this.d.fire(Object.freeze({files:S.map(w=>f.URI.revive(w.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:S.map(w=>f.URI.revive(w.target))}));break;default:}}getOnWillRenameFileEvent(v){return this.m(v,this.g)}getOnWillCreateFileEvent(v){return this.m(v,this.h)}getOnWillDeleteFileEvent(v){return this.m(v,this.i)}m(v,S){return(w,l,o)=>{const i=function(r){w.call(l,r)};return i.extension=v,S.event(i,void 0,o)}}async $onWillRunFileOperation(v,S,w,l){switch(v){case 2:return await this.n(this.g,{files:S.map(o=>({oldUri:f.URI.revive(o.source),newUri:f.URI.revive(o.target)}))},w,l);case 1:return await this.n(this.i,{files:S.map(o=>f.URI.revive(o.target))},w,l);case 0:case 3:return await this.n(this.h,{files:S.map(o=>f.URI.revive(o.target))},w,l)}}async n(v,S,w,l){const o=new Set,i=[];if(await v.fireAsync(S,l,async(r,a)=>{const t=Date.now(),s=await Promise.resolve(r);s instanceof b.$LK&&(i.push([a.extension,s]),o.add(a.extension.displayName??a.extension.identifier.value)),Date.now()-t>w&&this.k.warn("SLOW file-participant",a.extension.identifier)}),l.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,r]of i){const{edits:a}=L.WorkspaceEdit.from(r,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(a)}return{edit:n,extensionNames:Array.from(o)}}}e.$Zec=I}),define(ke[323],Se([1,0,3,2,6,15,7,35,12]),function(me,e,C,T,f,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ec=void 0;class g{static{this.a=0}constructor(v,S){this.extension=v,this.provider=S,this.handle=g.a++}}class A{constructor(v){this.session=v,this.responses=[]}}class I{static{this.a=0}constructor(v,S,w,l){this.f=w,this.g=l,this.b=new Map,this.d=new Map,this.e=v.getProxy(f.$zK.MainThreadInlineChat),S.registerApiCommand(new b.$2M("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new b.$ZM("Run arguments","",o=>!0,o=>{if(o)return{initialRange:o.initialRange?R.Range.from(o.initialRange):void 0,initialSelection:o.initialSelection?R.Selection.from(o.initialSelection):void 0,message:o.message,autoSend:o.autoSend,position:o.position?R.Position.from(o.position):void 0}})],b.$1M.Void))}registerProvider(v,S,w){const l=new g(v,S);return this.b.set(l.handle,l),this.e.$registerInteractiveEditorProvider(l.handle,w?.label??v.displayName??v.name,v.identifier.value,typeof S.handleInteractiveEditorResponseFeedback=="function",w?.supportReportIssue??!1),(0,C.$Pc)(()=>{this.e.$unregisterInteractiveEditorProvider(l.handle),this.b.delete(l.handle)})}async $prepareSession(v,S,w,l){const o=this.b.get(v);if(!o){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(T.URI.revive(S)),n=R.Selection.to(w),r=await o.provider.prepareInteractiveEditorSession({document:i,selection:n},l);if(!r)return;if(r.wholeRange&&!r.wholeRange.contains(n))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const a=I.a++;return this.d.set(a,new A(r)),{id:a,placeholder:r.placeholder,input:r.input,slashCommands:r.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:R.Range.from(r.wholeRange),message:r.message}}async $provideResponse(v,S,w,l){const o=this.b.get(v);if(!o)return;const i=this.d.get(S.id);if(!i)return;const n={prompt:w.prompt,selection:R.Selection.to(w.selection),wholeRange:R.Range.to(w.wholeRange),attempt:w.attempt,live:w.live};let r=!1;const a={report:async u=>{if(!w.live&&u.edits?.length)throw new Error("Progress reporting is only supported for live sessions");r||l.isCancellationRequested||await this.e.$handleProgressChunk(w.requestId,{message:u.message,edits:u.edits?.map(R.TextEdit.from),editsShouldBeInstant:u.editsShouldBeInstant,slashCommand:u.slashCommand?.command,markdownFragment:L.$2K.isMarkdownString(u.content)?u.content.value:u.content})}},t=Promise.resolve(o.provider.provideInteractiveEditorResponse(i.session,n,a,l));let s;try{s=await(0,y.$Mg)(t,l)}finally{r=!0}if(!s)return;const d=i.responses.push(s)-1,c={wholeRange:R.Range.from(s.wholeRange),placeholder:s.placeholder};if(I.h(s)){const{edits:u,contents:h}=s,E=h!==void 0?R.MarkdownString.from(h):void 0;return u instanceof L.$LK?{...c,id:d,type:"bulkEdit",edits:R.WorkspaceEdit.from(u),message:E}:{...c,id:d,type:"editorEdit",edits:u.map(R.TextEdit.from),message:E}}return{...c,id:d,type:"message",message:R.MarkdownString.from(s.contents)}}$handleFeedback(v,S,w,l){const o=this.b.get(v),i=this.d.get(S),n=i?.responses[w];if(o&&n){const r=R.InteractiveEditorResponseFeedbackKind.to(l);o.provider.handleInteractiveEditorResponseFeedback?.(i.session,n,r)}}$releaseSession(v,S){}static h(v){return typeof v=="object"&&typeof v.edits=="object"}}e.$1ec=I}),define(ke[324],Se([1,0,2,35]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bfc=void 0;class f{constructor(L,b,y,g,A){this.a=b,this.b=y,this.c=g;const I=new T.$2M("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.$ZM("showOptions","Show Options",$=>!0,$=>$),new T.$ZM("resource","Interactive resource Uri",$=>!0,$=>$),new T.$ZM("controllerId","Notebook controller Id",$=>!0,$=>$),new T.$ZM("title","Interactive editor title",$=>!0,$=>$)],new T.$1M("Notebook and input URI",$=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",$.notebookEditorId),$.notebookEditorId!==void 0){const v=this.a.getEditorById($.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",v.id),{notebookUri:C.URI.revive($.notebookUri),inputUri:C.URI.revive($.inputUri),notebookEditor:v.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",$.notebookUri,$.inputUri),{notebookUri:C.URI.revive($.notebookUri),inputUri:C.URI.revive($.inputUri)}}));this.c.registerApiCommand(I)}$willAddInteractiveDocument(L,b,y,g){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:b,lines:[""],languageId:y,uri:L,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(C.URI.revive(g))?.apiNotebook}]})}$willRemoveInteractiveDocument(L,b){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[L]})}}e.$bfc=f}),define(ke[325],Se([1,0,6,7]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cfc=void 0;class f{constructor(L){this.a=new Map,this.b=new Map,this.c=L.getProxy(C.$zK.MainThreadIssueReporter)}async $getIssueReporterUri(L,b){if(this.a.size===0)throw new Error("No issue request handlers registered");const y=this.a.get(L);if(!y)throw new Error("Issue request handler not found");const g=await y.handleIssueUrlRequest();if(!g)throw new Error("Issue request handler returned no result");return g}async $getIssueReporterData(L,b){if(this.b.size===0)throw new Error("No issue request handlers registered");const y=this.b.get(L);if(!y)throw new Error("Issue data provider not found");const g=await y.provideIssueData(b);if(!g)throw new Error("Issue data provider returned no result");return g}async $getIssueReporterTemplate(L,b){if(this.b.size===0)throw new Error("No issue request handlers registered");const y=this.b.get(L);if(!y)throw new Error("Issue data provider not found");const g=await y.provideIssueTemplate(b);if(!g)throw new Error("Issue template provider returned no result");return g}registerIssueUriRequestHandler(L,b){const y=L.identifier.value;return this.a.set(y,b),this.c.$registerIssueUriRequestHandler(y),new T.$BK(()=>{this.c.$unregisterIssueUriRequestHandler(y),this.a.delete(y)})}registerIssueDataProvider(L,b){const y=L.identifier.value;return this.b.set(y,b),this.c.$registerIssueDataProvider(y),new T.$BK(()=>{this.c.$unregisterIssueDataProvider(y),this.b.delete(y)})}}e.$cfc=f}),define(ke[326],Se([1,0,3,6]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dfc=void 0;class f{constructor(L){this.b=0,this.a=L.getProxy(T.$zK.MainThreadLabelService)}$registerResourceLabelFormatter(L){const b=this.b++;return this.a.$registerResourceLabelFormatter(b,L),(0,C.$Pc)(()=>{this.a.$unregisterResourceLabelFormatter(b)})}}e.$dfc=f}),define(ke[327],Se([1,0,2,24,15,7,83,6,13,29,19,18,169,21,26,3,132,122,110,38,8,12,25,213]),function(me,e,C,T,f,R,L,b,y,g,A,I,$,v,S,w,l,o,i,n,r,a,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rdc=void 0;class d{constructor(B,Z){this.d=B,this.e=Z}async provideDocumentSymbols(B,Z){const re=this.d.getDocument(B),ae=await this.e.provideDocumentSymbols(re,Z);if(!(0,A.$Jb)(ae))return ae[0]instanceof R.$TK?ae.map(f.DocumentSymbol.from):d.f(ae)}static f(B){B=B.slice(0).sort((ae,ee)=>{let ge=ae.location.range.start.compareTo(ee.location.range.start);return ge===0&&(ge=ee.location.range.end.compareTo(ae.location.range.end)),ge});const Z=[],re=[];for(const ae of B){const ee={name:ae.name||"!!MISSING: name!!",kind:f.SymbolKind.from(ae.kind),tags:ae.tags?.map(f.SymbolTag.from)||[],detail:"",containerName:ae.containerName,range:f.Range.from(ae.location.range),selectionRange:f.Range.from(ae.location.range),children:[]};for(;;){if(re.length===0){re.push(ee),Z.push(ee);break}const ge=re[re.length-1];if(g.$zs.containsRange(ge.range,ee.range)&&!g.$zs.equalsRange(ge.range,ee.range)){ge.children?.push(ee),re.push(ee);break}re.pop()}}return Z}}class c{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(B,Z,re){this.g=B,this.h=Z,this.j=re,this.e=new i.$Hdc("CodeLens"),this.f=new Map}async provideCodeLenses(B,Z){const re=this.g.getDocument(B),ae=await this.j.provideCodeLenses(re,Z);if(!ae||Z.isCancellationRequested)return;const ee=this.e.add(ae),ge=new w.$Qc;this.f.set(ee,ge);const ye={cacheId:ee,lenses:[]};for(let ze=0;ze<ae.length;ze++)ye.lenses.push({cacheId:[ee,ze],range:f.Range.from(ae[ze].range),command:this.h.toInternal(ae[ze].command,ge)});return ye}async resolveCodeLens(B,Z){const re=B.cacheId&&this.e.get(...B.cacheId);if(!re)return;let ae;if(typeof this.j.resolveCodeLens!="function"||re.isResolved?ae=re:ae=await this.j.resolveCodeLens(re,Z),ae||(ae=re),Z.isCancellationRequested)return;const ee=B.cacheId&&this.f.get(B.cacheId[0]);if(ee)return B.command=this.h.toInternal(ae.command??c.d,ee),B}releaseCodeLenses(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}}function u(Pe){return Array.isArray(Pe)?Pe.map(f.DefinitionLink.from):Pe?[f.DefinitionLink.from(Pe)]:[]}class h{constructor(B,Z){this.d=B,this.e=Z}async provideDefinition(B,Z,re){const ae=this.d.getDocument(B),ee=f.Position.to(Z),ge=await this.e.provideDefinition(ae,ee,re);return u(ge)}}class E{constructor(B,Z){this.d=B,this.e=Z}async provideDeclaration(B,Z,re){const ae=this.d.getDocument(B),ee=f.Position.to(Z),ge=await this.e.provideDeclaration(ae,ee,re);return u(ge)}}class D{constructor(B,Z){this.d=B,this.e=Z}async provideImplementation(B,Z,re){const ae=this.d.getDocument(B),ee=f.Position.to(Z),ge=await this.e.provideImplementation(ae,ee,re);return u(ge)}}class m{constructor(B,Z){this.d=B,this.e=Z}async provideTypeDefinition(B,Z,re){const ae=this.d.getDocument(B),ee=f.Position.to(Z),ge=await this.e.provideTypeDefinition(ae,ee,re);return u(ge)}}class p{constructor(B,Z){this.d=B,this.e=Z}async provideHover(B,Z,re){const ae=this.d.getDocument(B),ee=f.Position.to(Z),ge=await this.e.provideHover(ae,ee,re);if(!(!ge||(0,A.$Jb)(ge.contents)))return ge.range||(ge.range=ae.getWordRangeAtPosition(ee)),ge.range||(ge.range=new R.$DK(ee,ee)),f.Hover.from(ge)}}class k{constructor(B,Z){this.d=B,this.e=Z}async provideEvaluatableExpression(B,Z,re){const ae=this.d.getDocument(B),ee=f.Position.to(Z),ge=await this.e.provideEvaluatableExpression(ae,ee,re);if(ge)return f.EvaluatableExpression.from(ge)}}class P{constructor(B,Z){this.d=B,this.e=Z}async provideInlineValues(B,Z,re,ae){const ee=this.d.getDocument(B),ge=await this.e.provideInlineValues(ee,f.Range.to(Z),f.InlineValueContext.to(re),ae);if(Array.isArray(ge))return ge.map(ye=>f.InlineValue.from(ye))}}class z{constructor(B,Z){this.d=B,this.e=Z}async provideDocumentHighlights(B,Z,re){const ae=this.d.getDocument(B),ee=f.Position.to(Z),ge=await this.e.provideDocumentHighlights(ae,ee,re);if(Array.isArray(ge))return ge.map(f.DocumentHighlight.from)}}class j{constructor(B,Z){this.d=B,this.e=Z}async provideLinkedEditingRanges(B,Z,re){const ae=this.d.getDocument(B),ee=f.Position.to(Z),ge=await this.e.provideLinkedEditingRanges(ae,ee,re);if(ge&&Array.isArray(ge.ranges))return{ranges:(0,A.$Gb)(ge.ranges.map(f.Range.from)),wordPattern:ge.wordPattern}}}class M{constructor(B,Z){this.d=B,this.e=Z}async provideReferences(B,Z,re,ae){const ee=this.d.getDocument(B),ge=f.Position.to(Z),ye=await this.e.provideReferences(ee,ge,re,ae);if(Array.isArray(ye))return ye.map(f.location.from)}}class O{static{this.d=1e3}constructor(B,Z,re,ae,ee,ge,ye){this.g=B,this.h=Z,this.j=re,this.k=ae,this.l=ee,this.m=ge,this.n=ye,this.e=new i.$Hdc("CodeAction"),this.f=new Map}async provideCodeActions(B,Z,re,ae){const ee=this.g.getDocument(B),ge=$.$Bs.isISelection(Z)?f.Selection.to(Z):f.Range.to(Z),ye=[];for(const nt of this.j.getDiagnostics(B))if(ge.intersection(nt.range)&&ye.push(nt)>O.d)break;const ze={diagnostics:ye,only:re.only?new R.$VK(re.only):void 0,triggerKind:f.CodeActionTriggerKind.to(re.trigger)},We=await this.k.provideCodeActions(ee,ge,ze,ae);if(!(0,A.$Kb)(We)||ae.isCancellationRequested)return;const et=this.e.add(We),Ye=new w.$Qc;this.f.set(et,Ye);const rt=[];for(let nt=0;nt<We.length;nt++){const Ae=We[nt];Ae&&(O.o(Ae)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),rt.push({_isSynthetic:!0,title:Ae.title,command:this.h.toInternal(Ae,Ye)})):(ze.only&&(Ae.kind?ze.only.contains(Ae.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ze.only.value} 'requested but returned code action is of kind '${Ae.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ze.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),rt.push({cacheId:[et,nt],title:Ae.title,command:Ae.command&&this.h.toInternal(Ae.command,Ye),diagnostics:Ae.diagnostics&&Ae.diagnostics.map(f.Diagnostic.from),edit:Ae.edit&&f.WorkspaceEdit.from(Ae.edit,void 0),kind:Ae.kind&&Ae.kind.value,isPreferred:Ae.isPreferred,isAI:(0,t.$MF)(this.m,"codeActionAI")?Ae.isAI:!1,disabled:Ae.disabled?.reason})))}return{cacheId:et,actions:rt}}async resolveCodeAction(B,Z){const[re,ae]=B,ee=this.e.get(re,ae);if(!ee||O.o(ee))return{};if(!this.k.resolveCodeAction)return{};const ge=await this.k.resolveCodeAction(ee,Z)??ee;let ye;ge.edit&&(ye=f.WorkspaceEdit.from(ge.edit,void 0));let ze;if(ge.command){const We=this.f.get(re);We&&(ze=this.h.toInternal(ge.command,We))}return{edit:ye,command:ze}}releaseCodeActions(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}static o(B){return typeof B.command=="string"&&typeof B.title=="string"}}class F{static toInternalProviderId(B,Z){return B+"."+Z}constructor(B,Z,re,ae,ee){this.d=B,this.e=Z,this.f=re,this.g=ae,this.h=ee}async prepareDocumentPaste(B,Z,re,ae){if(!this.f.prepareDocumentPaste)return;const ee=this.e.getDocument(B),ge=Z.map(We=>f.Range.to(We)),ye=f.DataTransfer.toDataTransfer(re,()=>{throw new r.$0});if(await this.f.prepareDocumentPaste(ee,ge,ye,ae),ae.isCancellationRequested)return;const ze=Array.from(ye).filter(([,We])=>!(We instanceof R.$pL));return f.DataTransfer.from(ze)}async providePasteEdits(B,Z,re,ae,ee){if(!this.f.provideDocumentPasteEdits)return;const ge=this.e.getDocument(Z),ye=re.map(et=>f.Range.to(et)),ze=f.DataTransfer.toDataTransfer(ae,async et=>(await this.d.$resolvePasteFileData(this.g,B,et)).buffer),We=await this.f.provideDocumentPasteEdits(ge,ye,ze,ee);if(We)return{label:We.label??(0,s.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:We.yieldTo?.map(et=>"mimeType"in et?et:{providerId:F.toInternalProviderId(et.extensionId,et.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?f.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class N{constructor(B,Z){this.d=B,this.e=Z}async provideDocumentFormattingEdits(B,Z,re){const ae=this.d.getDocument(B),ee=await this.e.provideDocumentFormattingEdits(ae,Z,re);if(Array.isArray(ee))return ee.map(f.TextEdit.from)}}class W{constructor(B,Z){this.d=B,this.e=Z}async provideDocumentRangeFormattingEdits(B,Z,re,ae){const ee=this.d.getDocument(B),ge=f.Range.to(Z),ye=await this.e.provideDocumentRangeFormattingEdits(ee,ge,re,ae);if(Array.isArray(ye))return ye.map(f.TextEdit.from)}async provideDocumentRangesFormattingEdits(B,Z,re,ae){(0,I.$Mf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ee=this.d.getDocument(B),ge=Z.map(f.Range.to),ye=await this.e.provideDocumentRangesFormattingEdits(ee,ge,re,ae);if(Array.isArray(ye))return ye.map(f.TextEdit.from)}}class X{constructor(B,Z){this.d=B,this.e=Z,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,Z,re,ae,ee){const ge=this.d.getDocument(B),ye=f.Position.to(Z),ze=await this.e.provideOnTypeFormattingEdits(ge,ye,re,ae,ee);if(Array.isArray(ze))return ze.map(f.TextEdit.from)}}class ce{constructor(B,Z){this.e=B,this.f=Z,this.d=new i.$Hdc("WorkspaceSymbols")}async provideWorkspaceSymbols(B,Z){const re=await this.e.provideWorkspaceSymbols(B,Z);if(!(0,A.$Kb)(re))return{symbols:[]};const ae=this.d.add(re),ee={cacheId:ae,symbols:[]};for(let ge=0;ge<re.length;ge++){const ye=re[ge];if(!ye||!ye.name){this.f.warn("INVALID SymbolInformation",ye);continue}ee.symbols.push({...f.WorkspaceSymbol.from(ye),cacheId:[ae,ge]})}return ee}async resolveWorkspaceSymbol(B,Z){if(typeof this.e.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const re=this.d.get(...B.cacheId);if(re){const ae=await this.e.resolveWorkspaceSymbol(re,Z);return ae&&(0,T.$dn)(B,f.WorkspaceSymbol.from(ae),!0)}}releaseWorkspaceSymbols(B){this.d.delete(B)}}class J{static supportsResolving(B){return typeof B.prepareRename=="function"}constructor(B,Z,re){this.d=B,this.e=Z,this.f=re}async provideRenameEdits(B,Z,re,ae){const ee=this.d.getDocument(B),ge=f.Position.to(Z);try{const ye=await this.e.provideRenameEdits(ee,ge,re,ae);return ye?f.WorkspaceEdit.from(ye):void 0}catch(ye){const ze=J.g(ye);return ze?{rejectReason:ze,edits:void 0}:Promise.reject(ye)}}async resolveRenameLocation(B,Z,re){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const ae=this.d.getDocument(B),ee=f.Position.to(Z);try{const ge=await this.e.prepareRename(ae,ee,re);let ye,ze;if(R.$DK.isRange(ge)?(ye=ge,ze=ae.getText(ge)):(0,I.$Ef)(ge)&&(ye=ge.range,ze=ge.placeholder),!ye||!ze)return;if(ye.start.line>ee.line||ye.end.line<ee.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:f.Range.from(ye),text:ze}}catch(ge){const ye=J.g(ge);return ye?{rejectReason:ye,range:void 0,text:void 0}:Promise.reject(ge)}}static g(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class Q{constructor(B,Z){this.resultId=B,this.tokens=Z}}class G{constructor(B,Z){this.f=B,this.g=Z,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(B,Z,re){const ae=this.f.getDocument(B),ee=Z!==0?this.d.get(Z):null;let ge=typeof ee?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(ae,ee.resultId,re):await this.g.provideDocumentSemanticTokens(ae,re);return ee&&this.d.delete(Z),ge?(ge=G.h(ge),this.o(G.n(ee,ge),ge)):null}async releaseDocumentSemanticColoring(B){this.d.delete(B)}static h(B){return G.j(B)?G.k(B)?B:new R.$SL(new Uint32Array(B.data),B.resultId):G.l(B)?G.m(B)?B:new R.$UL(B.edits.map(Z=>new R.$TL(Z.start,Z.deleteCount,Z.data?new Uint32Array(Z.data):Z.data)),B.resultId):B}static j(B){return B&&!!B.data}static k(B){return B.data instanceof Uint32Array}static l(B){return B&&Array.isArray(B.edits)}static m(B){for(const Z of B.edits)if(!(Z.data instanceof Uint32Array))return!1;return!0}static n(B,Z){if(!G.j(Z)||!B||!B.tokens)return Z;const re=B.tokens,ae=re.length,ee=Z.data,ge=ee.length;let ye=0;const ze=Math.min(ae,ge);for(;ye<ze&&re[ye]===ee[ye];)ye++;if(ye===ae&&ye===ge)return new R.$UL([],Z.resultId);let We=0;const et=ze-ye;for(;We<et&&re[ae-We-1]===ee[ge-We-1];)We++;return new R.$UL([{start:ye,deleteCount:ae-ye-We,data:ee.subarray(ye,ge-We)}],Z.resultId)}o(B,Z){if(G.j(B)){const re=this.e++;return this.d.set(re,new Q(B.resultId,B.data)),(0,l.$10)({id:re,type:"full",data:B.data})}if(G.l(B)){const re=this.e++;return G.j(Z)?this.d.set(re,new Q(Z.resultId,Z.data)):this.d.set(re,new Q(B.resultId)),(0,l.$10)({id:re,type:"delta",deltas:(B.edits||[]).map(ae=>({start:ae.start,deleteCount:ae.deleteCount,data:ae.data}))})}return null}}class oe{constructor(B,Z){this.d=B,this.e=Z}async provideDocumentRangeSemanticTokens(B,Z,re){const ae=this.d.getDocument(B),ee=await this.e.provideDocumentRangeSemanticTokens(ae,f.Range.to(Z),re);return ee?this.f(ee):null}f(B){return(0,l.$10)({id:0,type:"full",data:B.data})}}class _{static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}constructor(B,Z,re,ae,ee){this.f=B,this.g=Z,this.h=re,this.j=ae,this.k=ee,this.d=new i.$Hdc("CompletionItem"),this.e=new Map}async provideCompletionItems(B,Z,re,ae){const ee=this.f.getDocument(B),ge=f.Position.to(Z),ye=ee.getWordRangeAtPosition(ge)||new R.$DK(ge,ge),ze=ye.with({end:ge}),We=new n.$Nd,et=await this.h.provideCompletionItems(ee,ge,ae,f.CompletionContext.to(re));if(!et||ae.isCancellationRequested)return;const Ye=Array.isArray(et)?new R.$9K(et):et,rt=_.supportsResolving(this.h)?this.d.add(Ye.items):this.d.add([]),nt=new w.$Qc;this.e.set(rt,nt);const Ae=[],Ne={x:rt,b:Ae,a:{replace:f.Range.from(ye),insert:f.Range.from(ze)},c:Ye.isIncomplete||void 0,d:We.elapsed()};for(let Ve=0;Ve<Ye.items.length;Ve++){const Le=Ye.items[Ve],Xe=this.l(Le,[rt,Ve],ze,ye);Ae.push(Xe)}return Ne}async resolveCompletionItem(B,Z){if(typeof this.h.resolveCompletionItem!="function")return;const re=this.d.get(...B);if(!re)return;const ae=this.l(re,B),ee=await this.h.resolveCompletionItem(re,Z);if(!ee)return;const ge=this.l(ee,B);return(ae.h!==ge.h||ae.i!==ge.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(ae.n!==ge.n||ae.o!==ge.o||!(0,T.$en)(ae.p,ge.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...ae,d:ge.d,c:ge.c,l:ge.l,h:ge.h,i:ge.i,n:ge.n,o:ge.o,p:ge.p}}releaseCompletionItems(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,Z,re,ae){const ee=this.e.get(Z[0]);if(!ee)throw Error("DisposableStore is missing...");const ge=this.g.toInternal(B.command,ee),ye={x:Z,a:B.label,b:B.kind!==void 0?f.CompletionItemKind.from(B.kind):void 0,m:B.tags&&B.tags.map(f.CompletionItemTag.from),c:B.detail,d:typeof B.documentation>"u"?void 0:f.MarkdownString.fromStrict(B.documentation),e:B.sortText!==B.label?B.sortText:void 0,f:B.filterText!==B.label?B.filterText:void 0,g:B.preselect||void 0,i:B.keepWhitespace?1:0,k:B.commitCharacters?.join(""),l:B.additionalTextEdits&&B.additionalTextEdits.map(f.TextEdit.from),n:ge?.$ident,o:ge?.id,p:ge?.$ident?void 0:ge?.arguments};B.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ye.h=B.textEdit.newText):typeof B.insertText=="string"?ye.h=B.insertText:B.insertText instanceof R.$MK&&(ye.h=B.insertText.value,ye.i|=4);let ze;return B.textEdit?ze=B.textEdit.range:B.range&&(ze=B.range),R.$DK.isRange(ze)?ye.j=f.Range.from(ze):ze&&(!re?.isEqual(ze.inserting)||!ae?.isEqual(ze.replacing))&&(ye.j={insert:f.Range.from(ze.inserting),replace:f.Range.from(ze.replacing)}),ye}}class Ee{async provideInlineCompletions(B,Z,re,ae){}disposeCompletions(B){}handleDidShowCompletionItem(B,Z,re){}handlePartialAccept(B,Z,re){}}class he extends Ee{constructor(B,Z,re,ae){super(),this.f=B,this.g=Z,this.h=re,this.j=ae,this.d=new q,this.e=(0,t.$MF)(this.f,"inlineCompletionsAdditions"),this.k={[L.InlineCompletionTriggerKind.Automatic]:R.InlineCompletionTriggerKind.Automatic,[L.InlineCompletionTriggerKind.Explicit]:R.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$MF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(B,Z,re,ae){const ee=this.g.getDocument(B),ge=f.Position.to(Z),ye=await this.h.provideInlineCompletionItems(ee,ge,{selectedCompletionInfo:re.selectedSuggestionInfo?{range:f.Range.to(re.selectedSuggestionInfo.range),text:re.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[re.triggerKind]},ae);if(!ye||ae.isCancellationRequested)return;const ze=Array.isArray(ye)?ye:ye.items,We=this.e?Array.isArray(ye)?[]:ye.commands||[]:[],et=this.e&&!Array.isArray(ye)?ye.enableForwardStability:void 0;let Ye;return{pid:this.d.createReferenceId({dispose(){Ye?.dispose()},items:ze}),items:ze.map((nt,Ae)=>{let Ne;nt.command&&(Ye||(Ye=new w.$Qc),Ne=this.j.toInternal(nt.command,Ye));const Ve=nt.insertText;return{insertText:typeof Ve=="string"?Ve:{snippet:Ve.value},filterText:nt.filterText,range:nt.range?f.Range.from(nt.range):void 0,command:Ne,idx:Ae,completeBracketPairs:this.e?nt.completeBracketPairs:!1}}),commands:We.map(nt=>(Ye||(Ye=new w.$Qc),this.j.toInternal(nt,Ye))),suppressSuggestions:!1,enableForwardStability:et}}disposeCompletions(B){this.d.disposeReferenceId(B)?.dispose()}handleDidShowCompletionItem(B,Z,re){const ae=this.d.get(B)?.items[Z];ae&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(ae,re)}handlePartialAccept(B,Z,re){const ae=this.d.get(B)?.items[Z];ae&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(ae,re)}}class q{constructor(){this.d=new Map,this.e=1}createReferenceId(B){const Z=this.e++;return this.d.set(Z,B),Z}disposeReferenceId(B){const Z=this.d.get(B);return this.d.delete(B),Z}get(B){return this.d.get(B)}}class U{constructor(B,Z){this.e=B,this.f=Z,this.d=new i.$Hdc("SignatureHelp")}async provideSignatureHelp(B,Z,re,ae){const ee=this.e.getDocument(B),ge=f.Position.to(Z),ye=this.g(re),ze=await this.f.provideSignatureHelp(ee,ge,ae,ye);if(ze){const We=this.d.add([ze]);return{...f.SignatureHelp.from(ze),id:We}}}g(B){let Z;if(B.activeSignatureHelp){const re=f.SignatureHelp.to(B.activeSignatureHelp),ae=this.d.get(B.activeSignatureHelp.id,0);ae?(Z=ae,Z.activeSignature=re.activeSignature,Z.activeParameter=re.activeParameter):Z=re}return{...B,activeSignatureHelp:Z}}releaseSignatureHelp(B){this.d.delete(B)}}class ne{constructor(B,Z,re,ae,ee){this.f=B,this.g=Z,this.h=re,this.j=ae,this.k=ee,this.d=new i.$Hdc("InlayHints"),this.e=new Map}async provideInlayHints(B,Z,re){const ae=this.f.getDocument(B),ee=f.Range.to(Z),ge=await this.h.provideInlayHints(ae,ee,re);if(!Array.isArray(ge)||ge.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${Z}`);return}if(re.isCancellationRequested)return;const ye=this.d.add(ge);this.e.set(ye,new w.$Qc);const ze={hints:[],cacheId:ye};for(let We=0;We<ge.length;We++)this.l(ge[We],ee)&&ze.hints.push(this.m(ge[We],[ye,We]));return this.j.trace(`[InlayHints] ${ze.hints.length} inlay hints from '${this.k.identifier.value}' for ${Z}`),ze}async resolveInlayHint(B,Z){if(typeof this.h.resolveInlayHint!="function")return;const re=this.d.get(...B);if(!re)return;const ae=await this.h.resolveInlayHint(re,Z);if(ae&&this.l(ae))return this.m(ae,B)}releaseHints(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,Z){return B.label.length===0||Array.isArray(B.label)&&B.label.every(re=>re.value.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(Z&&!Z.contains(B.position))}m(B,Z){const re=this.e.get(Z[0]);if(!re)throw Error("DisposableStore is missing...");const ae={label:"",cacheId:Z,tooltip:f.MarkdownString.fromStrict(B.tooltip),position:f.Position.from(B.position),textEdits:B.textEdits&&B.textEdits.map(f.TextEdit.from),kind:B.kind&&f.InlayHintKind.from(B.kind),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};return typeof B.label=="string"?ae.label=B.label:ae.label=B.label.map(ee=>{const ge={label:ee.value};return ge.tooltip=f.MarkdownString.fromStrict(ee.tooltip),R.$NK.isLocation(ee.location)&&(ge.location=f.location.from(ee.location)),ee.command&&(ge.command=this.g.toInternal(ee.command,re)),ge}),ae}}class be{constructor(B,Z){this.e=B,this.f=Z,this.d=new i.$Hdc("DocumentLink")}async provideLinks(B,Z){const re=this.e.getDocument(B),ae=await this.f.provideDocumentLinks(re,Z);if(!(!Array.isArray(ae)||ae.length===0)&&!Z.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:ae.filter(be.g).map(f.DocumentLink.from)};{const ee=this.d.add(ae),ge={links:[],cacheId:ee};for(let ye=0;ye<ae.length;ye++){if(!be.g(ae[ye]))continue;const ze=f.DocumentLink.from(ae[ye]);ze.cacheId=[ee,ye],ge.links.push(ze)}return ge}}}static g(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,Z){if(typeof this.f.resolveDocumentLink!="function")return;const re=this.d.get(...B);if(!re)return;const ae=await this.f.resolveDocumentLink(re,Z);if(!(!ae||!be.g(ae)))return f.DocumentLink.from(ae)}releaseLinks(B){this.d.delete(B)}}class H{constructor(B,Z){this.d=B,this.e=Z}async provideColors(B,Z){const re=this.d.getDocument(B),ae=await this.e.provideDocumentColors(re,Z);return Array.isArray(ae)?ae.map(ge=>({color:f.Color.from(ge.color),range:f.Range.from(ge.range)})):[]}async provideColorPresentations(B,Z,re){const ae=this.d.getDocument(B),ee=f.Range.to(Z.range),ge=f.Color.to(Z.color),ye=await this.e.provideColorPresentations(ge,{document:ae,range:ee},re);if(Array.isArray(ye))return ye.map(f.ColorPresentation.from)}}class x{constructor(B,Z){this.d=B,this.e=Z}async provideFoldingRanges(B,Z,re){const ae=this.d.getDocument(B),ee=await this.e.provideFoldingRanges(ae,Z,re);if(Array.isArray(ee))return ee.map(f.FoldingRange.from)}}class Y{constructor(B,Z,re){this.d=B,this.e=Z,this.f=re}async provideSelectionRanges(B,Z,re){const ae=this.d.getDocument(B),ee=Z.map(f.Position.to),ge=await this.e.provideSelectionRanges(ae,ee,re);if(!(0,A.$Kb)(ge))return[];if(ge.length!==ee.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ye=[];for(let ze=0;ze<ee.length;ze++){const We=[];ye.push(We);let et=ee[ze],Ye=ge[ze];for(;;){if(!Ye.range.contains(et))throw new Error("INVALID selection range, must contain the previous range");if(We.push(f.SelectionRange.from(Ye)),!Ye.parent)break;et=Ye.range,Ye=Ye.parent}}return ye}}class $e{constructor(B,Z){this.f=B,this.g=Z,this.d=new o.$GM(""),this.e=new Map}async prepareSession(B,Z,re){const ae=this.f.getDocument(B),ee=f.Position.to(Z),ge=await this.g.prepareCallHierarchy(ae,ee,re);if(!ge)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(ge)?ge.map(ze=>this.h(ye,ze)):[this.h(ye,ge)]}async provideCallsTo(B,Z,re){const ae=this.j(B,Z);if(!ae)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyIncomingCalls(ae,re);if(ee)return ee.map(ge=>({from:this.h(B,ge.from),fromRanges:ge.fromRanges.map(ye=>f.Range.from(ye))}))}async provideCallsFrom(B,Z,re){const ae=this.j(B,Z);if(!ae)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyOutgoingCalls(ae,re);if(ee)return ee.map(ge=>({to:this.h(B,ge.to),fromRanges:ge.fromRanges.map(ye=>f.Range.from(ye))}))}releaseSession(B){this.e.delete(B)}h(B,Z){const re=this.e.get(B),ae=f.CallHierarchyItem.from(Z,B,re.size.toString(36));return re.set(ae._itemId,Z),ae}j(B,Z){return this.e.get(B)?.get(Z)}}class ie{constructor(B,Z){this.f=B,this.g=Z,this.d=new o.$GM(""),this.e=new Map}async prepareSession(B,Z,re){const ae=this.f.getDocument(B),ee=f.Position.to(Z),ge=await this.g.prepareTypeHierarchy(ae,ee,re);if(!ge)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(ge)?ge.map(ze=>this.h(ye,ze)):[this.h(ye,ge)]}async provideSupertypes(B,Z,re){const ae=this.j(B,Z);if(!ae)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySupertypes(ae,re);if(ee)return ee.map(ge=>this.h(B,ge))}async provideSubtypes(B,Z,re){const ae=this.j(B,Z);if(!ae)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySubtypes(ae,re);if(ee)return ee.map(ge=>this.h(B,ge))}releaseSession(B){this.e.delete(B)}h(B,Z){const re=this.e.get(B),ae=f.TypeHierarchyItem.from(Z,B,re.size.toString(36));return re.set(ae._itemId,Z),ae}j(B,Z){return this.e.get(B)?.get(Z)}}class fe{static toInternalProviderId(B,Z){return B+"."+Z}constructor(B,Z,re,ae,ee){this.d=B,this.e=Z,this.f=re,this.g=ae,this.h=ee}async provideDocumentOnDropEdits(B,Z,re,ae,ee){const ge=this.e.getDocument(Z),ye=f.Position.to(re),ze=f.DataTransfer.toDataTransfer(ae,async et=>(await this.d.$resolveDocumentOnDropFileData(this.g,B,et)).buffer),We=await this.f.provideDocumentDropEdits(ge,ye,ze,ee);if(We)return{label:We.label??(0,s.localize)(1,null,this.h.displayName||this.h.name),yieldTo:We.yieldTo?.map(et=>"mimeType"in et?et:{providerId:fe.toInternalProviderId(et.extensionId,et.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?f.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class te{constructor(B,Z){this.d=B,this.e=Z}async provideMappedEdits(B,Z,re,ae){const ee=C.URI.revive(B),ge=this.d.getDocument(ee),ye=re.documents.map(et=>et.map(Ye=>({uri:C.URI.revive(Ye.uri),version:Ye.version,ranges:Ye.ranges.map(rt=>f.Range.to(rt))}))),ze={documents:ye,selections:ye[0]?.[0]?.ranges??[]},We=await this.e.provideMappedEdits(ge,Z,ze,ae);return We?f.WorkspaceEdit.from(We):null}}class de{constructor(B,Z){this.adapter=B,this.extension=Z}}class pe{static{this.d=0}constructor(B,Z,re,ae,ee,ge,ye,ze){this.g=Z,this.h=re,this.j=ae,this.k=ee,this.l=ge,this.m=ye,this.n=ze,this.f=new Map,this.e=B.getProxy(b.$zK.MainThreadLanguageFeatures)}o(B,Z){return f.DocumentSelector.from(B,this.g,Z)}p(B){return new R.$BK(()=>{this.f.delete(B),this.e.$unregister(B)})}q(){return pe.d++}async s(B,Z,re,ae,ee,ge=!1){const ye=this.f.get(B);if(!ye||!(ye.adapter instanceof Z))return ae;const ze=Date.now();ge||this.l.trace(`[${ye.extension.identifier.value}] INVOKE provider '${re.toString().replace(/[\r\n]/g,"")}'`);const We=re(ye.adapter,ye.extension);return Promise.resolve(We).catch(et=>{(0,r.$3)(et)||(this.l.error(`[${ye.extension.identifier.value}] provider FAILED`),this.l.error(et),this.n.onExtensionError(ye.extension.identifier,et))}).finally(()=>{ge||this.l.trace(`[${ye.extension.identifier.value}] provider DONE after ${Date.now()-ze}ms`)}),v.CancellationToken.isCancellationToken(ee)?(0,a.$Ng)(We,ee):We}t(B,Z){const re=this.q();return this.f.set(re,new de(B,Z)),re}static u(B){return B.displayName||B.name}registerDocumentSymbolProvider(B,Z,re,ae){const ee=this.t(new d(this.h,re),B),ge=ae&&ae.label||pe.u(B);return this.e.$registerDocumentSymbolProvider(ee,this.o(Z,B),ge),this.p(ee)}$provideDocumentSymbols(B,Z,re){return this.s(B,d,ae=>ae.provideDocumentSymbols(C.URI.revive(Z),re),void 0,re)}registerCodeLensProvider(B,Z,re){const ae=this.q(),ee=typeof re.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(ae,new de(new c(this.h,this.j.converter,re),B)),this.e.$registerCodeLensSupport(ae,this.o(Z,B),ee);let ge=this.p(ae);if(ee!==void 0){const ye=re.onDidChangeCodeLenses(ze=>this.e.$emitCodeLensEvent(ee));ge=R.$BK.from(ge,ye)}return ge}$provideCodeLenses(B,Z,re){return this.s(B,c,ae=>ae.provideCodeLenses(C.URI.revive(Z),re),void 0,re)}$resolveCodeLens(B,Z,re){return this.s(B,c,ae=>ae.resolveCodeLens(Z,re),void 0,void 0)}$releaseCodeLenses(B,Z){this.s(B,c,re=>Promise.resolve(re.releaseCodeLenses(Z)),void 0,void 0)}registerDefinitionProvider(B,Z,re){const ae=this.t(new h(this.h,re),B);return this.e.$registerDefinitionSupport(ae,this.o(Z,B)),this.p(ae)}$provideDefinition(B,Z,re,ae){return this.s(B,h,ee=>ee.provideDefinition(C.URI.revive(Z),re,ae),[],ae)}registerDeclarationProvider(B,Z,re){const ae=this.t(new E(this.h,re),B);return this.e.$registerDeclarationSupport(ae,this.o(Z,B)),this.p(ae)}$provideDeclaration(B,Z,re,ae){return this.s(B,E,ee=>ee.provideDeclaration(C.URI.revive(Z),re,ae),[],ae)}registerImplementationProvider(B,Z,re){const ae=this.t(new D(this.h,re),B);return this.e.$registerImplementationSupport(ae,this.o(Z,B)),this.p(ae)}$provideImplementation(B,Z,re,ae){return this.s(B,D,ee=>ee.provideImplementation(C.URI.revive(Z),re,ae),[],ae)}registerTypeDefinitionProvider(B,Z,re){const ae=this.t(new m(this.h,re),B);return this.e.$registerTypeDefinitionSupport(ae,this.o(Z,B)),this.p(ae)}$provideTypeDefinition(B,Z,re,ae){return this.s(B,m,ee=>ee.provideTypeDefinition(C.URI.revive(Z),re,ae),[],ae)}registerHoverProvider(B,Z,re,ae){const ee=this.t(new p(this.h,re),B);return this.e.$registerHoverProvider(ee,this.o(Z,B)),this.p(ee)}$provideHover(B,Z,re,ae){return this.s(B,p,ee=>ee.provideHover(C.URI.revive(Z),re,ae),void 0,ae)}registerEvaluatableExpressionProvider(B,Z,re,ae){const ee=this.t(new k(this.h,re),B);return this.e.$registerEvaluatableExpressionProvider(ee,this.o(Z,B)),this.p(ee)}$provideEvaluatableExpression(B,Z,re,ae){return this.s(B,k,ee=>ee.provideEvaluatableExpression(C.URI.revive(Z),re,ae),void 0,ae)}registerInlineValuesProvider(B,Z,re,ae){const ee=typeof re.onDidChangeInlineValues=="function"?this.q():void 0,ge=this.t(new P(this.h,re),B);this.e.$registerInlineValuesProvider(ge,this.o(Z,B),ee);let ye=this.p(ge);if(ee!==void 0){const ze=re.onDidChangeInlineValues(We=>this.e.$emitInlineValuesEvent(ee));ye=R.$BK.from(ye,ze)}return ye}$provideInlineValues(B,Z,re,ae,ee){return this.s(B,P,ge=>ge.provideInlineValues(C.URI.revive(Z),re,ae,ee),void 0,ee)}registerDocumentHighlightProvider(B,Z,re){const ae=this.t(new z(this.h,re),B);return this.e.$registerDocumentHighlightProvider(ae,this.o(Z,B)),this.p(ae)}$provideDocumentHighlights(B,Z,re,ae){return this.s(B,z,ee=>ee.provideDocumentHighlights(C.URI.revive(Z),re,ae),void 0,ae)}registerLinkedEditingRangeProvider(B,Z,re){const ae=this.t(new j(this.h,re),B);return this.e.$registerLinkedEditingRangeProvider(ae,this.o(Z,B)),this.p(ae)}$provideLinkedEditingRanges(B,Z,re,ae){return this.s(B,j,async ee=>{const ge=await ee.provideLinkedEditingRanges(C.URI.revive(Z),re,ae);if(ge)return{ranges:ge.ranges,wordPattern:ge.wordPattern?pe.w(ge.wordPattern):void 0}},void 0,ae)}registerReferenceProvider(B,Z,re){const ae=this.t(new M(this.h,re),B);return this.e.$registerReferenceSupport(ae,this.o(Z,B)),this.p(ae)}$provideReferences(B,Z,re,ae,ee){return this.s(B,M,ge=>ge.provideReferences(C.URI.revive(Z),re,ae,ee),void 0,ee)}registerCodeActionProvider(B,Z,re,ae){const ee=new w.$Qc,ge=this.t(new O(this.h,this.j.converter,this.k,re,this.l,B,this.m),B);return this.e.$registerQuickFixSupport(ge,this.o(Z,B),{providedKinds:ae?.providedCodeActionKinds?.map(ye=>ye.value),documentation:ae?.documentation?.map(ye=>({kind:ye.kind.value,command:this.j.converter.toInternal(ye.command,ee)}))},pe.u(B),!!re.resolveCodeAction),ee.add(this.p(ge)),ee}$provideCodeActions(B,Z,re,ae,ee){return this.s(B,O,ge=>ge.provideCodeActions(C.URI.revive(Z),re,ae,ee),void 0,ee)}$resolveCodeAction(B,Z,re){return this.s(B,O,ae=>ae.resolveCodeAction(Z,re),{},void 0)}$releaseCodeActions(B,Z){this.s(B,O,re=>Promise.resolve(re.releaseCodeActions(Z)),void 0,void 0)}registerDocumentFormattingEditProvider(B,Z,re){const ae=this.t(new N(this.h,re),B);return this.e.$registerDocumentFormattingSupport(ae,this.o(Z,B),B.identifier,B.displayName||B.name),this.p(ae)}$provideDocumentFormattingEdits(B,Z,re,ae){return this.s(B,N,ee=>ee.provideDocumentFormattingEdits(C.URI.revive(Z),re,ae),void 0,ae)}registerDocumentRangeFormattingEditProvider(B,Z,re){const ae=typeof re.provideDocumentRangesFormattingEdits=="function",ee=this.t(new W(this.h,re),B);return this.e.$registerRangeFormattingSupport(ee,this.o(Z,B),B.identifier,B.displayName||B.name,ae),this.p(ee)}$provideDocumentRangeFormattingEdits(B,Z,re,ae,ee){return this.s(B,W,ge=>ge.provideDocumentRangeFormattingEdits(C.URI.revive(Z),re,ae,ee),void 0,ee)}$provideDocumentRangesFormattingEdits(B,Z,re,ae,ee){return this.s(B,W,ge=>ge.provideDocumentRangesFormattingEdits(C.URI.revive(Z),re,ae,ee),void 0,ee)}registerOnTypeFormattingEditProvider(B,Z,re,ae){const ee=this.t(new X(this.h,re),B);return this.e.$registerOnTypeFormattingSupport(ee,this.o(Z,B),ae,B.identifier),this.p(ee)}$provideOnTypeFormattingEdits(B,Z,re,ae,ee,ge){return this.s(B,X,ye=>ye.provideOnTypeFormattingEdits(C.URI.revive(Z),re,ae,ee,ge),void 0,ge)}registerWorkspaceSymbolProvider(B,Z){const re=this.t(new ce(Z,this.l),B);return this.e.$registerNavigateTypeSupport(re,typeof Z.resolveWorkspaceSymbol=="function"),this.p(re)}$provideWorkspaceSymbols(B,Z,re){return this.s(B,ce,ae=>ae.provideWorkspaceSymbols(Z,re),{symbols:[]},re)}$resolveWorkspaceSymbol(B,Z,re){return this.s(B,ce,ae=>ae.resolveWorkspaceSymbol(Z,re),void 0,void 0)}$releaseWorkspaceSymbols(B,Z){this.s(B,ce,re=>re.releaseWorkspaceSymbols(Z),void 0,void 0)}registerRenameProvider(B,Z,re){const ae=this.t(new J(this.h,re,this.l),B);return this.e.$registerRenameSupport(ae,this.o(Z,B),J.supportsResolving(re)),this.p(ae)}$provideRenameEdits(B,Z,re,ae,ee){return this.s(B,J,ge=>ge.provideRenameEdits(C.URI.revive(Z),re,ae,ee),void 0,ee)}$resolveRenameLocation(B,Z,re,ae){return this.s(B,J,ee=>ee.resolveRenameLocation(C.URI.revive(Z),re,ae),void 0,ae)}registerDocumentSemanticTokensProvider(B,Z,re,ae){const ee=this.t(new G(this.h,re),B),ge=typeof re.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ee,this.o(Z,B),ae,ge);let ye=this.p(ee);if(ge){const ze=re.onDidChangeSemanticTokens(We=>this.e.$emitDocumentSemanticTokensEvent(ge));ye=R.$BK.from(ye,ze)}return ye}$provideDocumentSemanticTokens(B,Z,re,ae){return this.s(B,G,ee=>ee.provideDocumentSemanticTokens(C.URI.revive(Z),re,ae),null,ae)}$releaseDocumentSemanticTokens(B,Z){this.s(B,G,re=>re.releaseDocumentSemanticColoring(Z),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,Z,re,ae){const ee=this.t(new oe(this.h,re),B);return this.e.$registerDocumentRangeSemanticTokensProvider(ee,this.o(Z,B),ae),this.p(ee)}$provideDocumentRangeSemanticTokens(B,Z,re,ae){return this.s(B,oe,ee=>ee.provideDocumentRangeSemanticTokens(C.URI.revive(Z),re,ae),null,ae)}registerCompletionItemProvider(B,Z,re,ae){const ee=this.t(new _(this.h,this.j.converter,re,this.m,B),B);return this.e.$registerCompletionsProvider(ee,this.o(Z,B),ae,_.supportsResolving(re),B.identifier),this.p(ee)}$provideCompletionItems(B,Z,re,ae,ee){return this.s(B,_,ge=>ge.provideCompletionItems(C.URI.revive(Z),re,ae,ee),void 0,ee)}$resolveCompletionItem(B,Z,re){return this.s(B,_,ae=>ae.resolveCompletionItem(Z,re),void 0,re)}$releaseCompletionItems(B,Z){this.s(B,_,re=>re.releaseCompletionItems(Z),void 0,void 0)}registerInlineCompletionsProvider(B,Z,re,ae){const ee=new he(B,this.h,re,this.j.converter),ge=this.t(ee,B);return this.e.$registerInlineCompletionsSupport(ge,this.o(Z,B),ee.supportsHandleEvents,S.$_l.toKey(B.identifier.value),ae?.yieldTo?.map(ye=>S.$_l.toKey(ye))||[]),this.p(ge)}$provideInlineCompletions(B,Z,re,ae,ee){return this.s(B,Ee,ge=>ge.provideInlineCompletions(C.URI.revive(Z),re,ae,ee),void 0,ee)}$handleInlineCompletionDidShow(B,Z,re,ae){this.s(B,Ee,async ee=>{ee.handleDidShowCompletionItem(Z,re,ae)},void 0,void 0)}$handleInlineCompletionPartialAccept(B,Z,re,ae){this.s(B,Ee,async ee=>{ee.handlePartialAccept(Z,re,ae)},void 0,void 0)}$freeInlineCompletionsList(B,Z){this.s(B,Ee,async re=>{re.disposeCompletions(Z)},void 0,void 0)}registerSignatureHelpProvider(B,Z,re,ae){const ee=Array.isArray(ae)?{triggerCharacters:ae,retriggerCharacters:[]}:ae,ge=this.t(new U(this.h,re),B);return this.e.$registerSignatureHelpProvider(ge,this.o(Z,B),ee),this.p(ge)}$provideSignatureHelp(B,Z,re,ae,ee){return this.s(B,U,ge=>ge.provideSignatureHelp(C.URI.revive(Z),re,ae,ee),void 0,ee)}$releaseSignatureHelp(B,Z){this.s(B,U,re=>re.releaseSignatureHelp(Z),void 0,void 0)}registerInlayHintsProvider(B,Z,re){const ae=typeof re.onDidChangeInlayHints=="function"?this.q():void 0,ee=this.t(new ne(this.h,this.j.converter,re,this.l,B),B);this.e.$registerInlayHintsProvider(ee,this.o(Z,B),typeof re.resolveInlayHint=="function",ae,pe.u(B));let ge=this.p(ee);if(ae!==void 0){const ye=re.onDidChangeInlayHints(ze=>this.e.$emitInlayHintsEvent(ae));ge=R.$BK.from(ge,ye)}return ge}$provideInlayHints(B,Z,re,ae){return this.s(B,ne,ee=>ee.provideInlayHints(C.URI.revive(Z),re,ae),void 0,ae)}$resolveInlayHint(B,Z,re){return this.s(B,ne,ae=>ae.resolveInlayHint(Z,re),void 0,re)}$releaseInlayHints(B,Z){this.s(B,ne,re=>re.releaseHints(Z),void 0,void 0)}registerDocumentLinkProvider(B,Z,re){const ae=this.t(new be(this.h,re),B);return this.e.$registerDocumentLinkProvider(ae,this.o(Z,B),typeof re.resolveDocumentLink=="function"),this.p(ae)}$provideDocumentLinks(B,Z,re){return this.s(B,be,ae=>ae.provideLinks(C.URI.revive(Z),re),void 0,re,Z.scheme==="output")}$resolveDocumentLink(B,Z,re){return this.s(B,be,ae=>ae.resolveLink(Z,re),void 0,void 0,!0)}$releaseDocumentLinks(B,Z){this.s(B,be,re=>re.releaseLinks(Z),void 0,void 0,!0)}registerColorProvider(B,Z,re){const ae=this.t(new H(this.h,re),B);return this.e.$registerDocumentColorProvider(ae,this.o(Z,B)),this.p(ae)}$provideDocumentColors(B,Z,re){return this.s(B,H,ae=>ae.provideColors(C.URI.revive(Z),re),[],re)}$provideColorPresentations(B,Z,re,ae){return this.s(B,H,ee=>ee.provideColorPresentations(C.URI.revive(Z),re,ae),void 0,ae)}registerFoldingRangeProvider(B,Z,re){const ae=this.q(),ee=typeof re.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(ae,new de(new x(this.h,re),B)),this.e.$registerFoldingRangeProvider(ae,this.o(Z,B),B.identifier,ee);let ge=this.p(ae);if(ee!==void 0){const ye=re.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ee));ge=R.$BK.from(ge,ye)}return ge}$provideFoldingRanges(B,Z,re,ae){return this.s(B,x,ee=>ee.provideFoldingRanges(C.URI.revive(Z),re,ae),void 0,ae)}registerSelectionRangeProvider(B,Z,re){const ae=this.t(new Y(this.h,re,this.l),B);return this.e.$registerSelectionRangeProvider(ae,this.o(Z,B)),this.p(ae)}$provideSelectionRanges(B,Z,re,ae){return this.s(B,Y,ee=>ee.provideSelectionRanges(C.URI.revive(Z),re,ae),[],ae)}registerCallHierarchyProvider(B,Z,re){const ae=this.t(new $e(this.h,re),B);return this.e.$registerCallHierarchyProvider(ae,this.o(Z,B)),this.p(ae)}$prepareCallHierarchy(B,Z,re,ae){return this.s(B,$e,ee=>Promise.resolve(ee.prepareSession(C.URI.revive(Z),re,ae)),void 0,ae)}$provideCallHierarchyIncomingCalls(B,Z,re,ae){return this.s(B,$e,ee=>ee.provideCallsTo(Z,re,ae),void 0,ae)}$provideCallHierarchyOutgoingCalls(B,Z,re,ae){return this.s(B,$e,ee=>ee.provideCallsFrom(Z,re,ae),void 0,ae)}$releaseCallHierarchy(B,Z){this.s(B,$e,re=>Promise.resolve(re.releaseSession(Z)),void 0,void 0)}registerTypeHierarchyProvider(B,Z,re){const ae=this.t(new ie(this.h,re),B);return this.e.$registerTypeHierarchyProvider(ae,this.o(Z,B)),this.p(ae)}$prepareTypeHierarchy(B,Z,re,ae){return this.s(B,ie,ee=>Promise.resolve(ee.prepareSession(C.URI.revive(Z),re,ae)),void 0,ae)}$provideTypeHierarchySupertypes(B,Z,re,ae){return this.s(B,ie,ee=>ee.provideSupertypes(Z,re,ae),void 0,ae)}$provideTypeHierarchySubtypes(B,Z,re,ae){return this.s(B,ie,ee=>ee.provideSubtypes(Z,re,ae),void 0,ae)}$releaseTypeHierarchy(B,Z){this.s(B,ie,re=>Promise.resolve(re.releaseSession(Z)),void 0,void 0)}registerDocumentOnDropEditProvider(B,Z,re,ae){const ee=this.q();this.f.set(ee,new de(new fe(this.e,this.h,re,ee,B),B));const ge=(0,t.$MF)(B,"dropMetadata")&&ae?fe.toInternalProviderId(B.identifier.value,ae.id):void 0;return this.e.$registerDocumentOnDropEditProvider(ee,this.o(Z,B),ge,(0,t.$MF)(B,"dropMetadata")?ae:void 0),this.p(ee)}$provideDocumentOnDropEdits(B,Z,re,ae,ee,ge){return this.s(B,fe,ye=>Promise.resolve(ye.provideDocumentOnDropEdits(Z,C.URI.revive(re),ae,ee,ge)),void 0,void 0)}registerMappedEditsProvider(B,Z,re){const ae=this.t(new te(this.h,re),B);return this.e.$registerMappedEditsProvider(ae,this.o(Z,B)),this.p(ae)}$provideMappedEdits(B,Z,re,ae,ee){return this.s(B,te,ge=>Promise.resolve(ge.provideMappedEdits(Z,re,ae,ee)),null,ee)}registerDocumentPasteEditProvider(B,Z,re,ae){const ee=this.q();this.f.set(ee,new de(new F(this.e,this.h,re,ee,B),B));const ge=F.toInternalProviderId(B.identifier.value,ae.id);return this.e.$registerPasteEditProvider(ee,this.o(Z,B),ge,{supportsCopy:!!re.prepareDocumentPaste,supportsPaste:!!re.provideDocumentPasteEdits,copyMimeTypes:ae.copyMimeTypes,pasteMimeTypes:ae.pasteMimeTypes}),this.p(ee)}$prepareDocumentPaste(B,Z,re,ae,ee){return this.s(B,F,ge=>ge.prepareDocumentPaste(C.URI.revive(Z),re,ae,ee),void 0,ee)}$providePasteEdits(B,Z,re,ae,ee,ge){return this.s(B,F,ye=>ye.providePasteEdits(Z,C.URI.revive(re),ae,ee,ge),void 0,ge)}static w(B){return{pattern:B.source,flags:B.flags}}static y(B){return{decreaseIndentPattern:pe.w(B.decreaseIndentPattern),increaseIndentPattern:pe.w(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?pe.w(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?pe.w(B.unIndentedLinePattern):void 0}}static z(B){return{beforeText:pe.w(B.beforeText),afterText:B.afterText?pe.w(B.afterText):void 0,previousLineText:B.previousLineText?pe.w(B.previousLineText):void 0,action:B.action}}static B(B){return B.map(pe.z)}static C(B){return{open:B.open,close:B.close,notIn:B.notIn?B.notIn.map(Z=>R.SyntaxTokenType.toString(Z)):void 0}}static D(B){return B.map(pe.C)}setLanguageConfiguration(B,Z,re){const{wordPattern:ae}=re;if(ae&&(0,y.$Se)(ae))throw new Error(`Invalid language configuration: wordPattern '${ae}' is not allowed to match the empty string.`);ae?this.h.setWordDefinitionFor(Z,ae):this.h.setWordDefinitionFor(Z,void 0),re.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),re.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const ee=this.q(),ge={comments:re.comments,brackets:re.brackets,wordPattern:re.wordPattern?pe.w(re.wordPattern):void 0,indentationRules:re.indentationRules?pe.y(re.indentationRules):void 0,onEnterRules:re.onEnterRules?pe.B(re.onEnterRules):void 0,__electricCharacterSupport:re.__electricCharacterSupport,__characterPairSupport:re.__characterPairSupport,autoClosingPairs:re.autoClosingPairs?pe.D(re.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ee,Z,ge),this.p(ee)}$setWordDefinitions(B){for(const Z of B)this.h.setWordDefinitionFor(Z.languageId,new RegExp(Z.regexSource,Z.regexFlags))}}e.$Rdc=pe}),define(ke[328],Se([1,0,6,15,7,39,12,3,25]),function(me,e,C,T,f,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$efc=void 0;class g{constructor(I,$,v,S){this.c=$,this.d=v,this.e=S,this.b=[],this.f=0,this.g=new Set,this.a=I.getProxy(C.$zK.MainThreadLanguages)}$acceptLanguageIds(I){this.b=I}async getLanguages(){return this.b.slice(0)}async changeLanguage(I,$){await this.a.$changeLanguage(I,$);const v=this.c.getDocumentData(I);if(!v)throw new Error(`document '${I.toString()}' NOT found`);return v.document}async tokenAtPosition(I,$){const v=I.version,S=T.Position.from($),w=await this.a.$tokensAtPosition(I.uri,S),l={type:f.StandardTokenType.Other,range:I.getWordRangeAtPosition($)??new f.$DK($.line,$.character,$.line,$.character)};if(!w)return l;const o={range:T.Range.to(w.range),type:T.TokenType.to(w.type)};return!o.range.contains($)||v!==I.version?l:o}createLanguageStatusItem(I,$,v){const S=this.f++,w=this.a,l=this.g,o=`${I.identifier.value}/${$}`;if(l.has(o))throw new Error(`LanguageStatusItem with id '${$}' ALREADY exists`);l.add(o);const i={selector:v,id:$,name:I.displayName??I.name,severity:f.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const r=new b.$Qc,a=()=>{if(n?.dispose(),!l.has(o)){console.warn(`LanguageStatusItem (${$}) from ${I.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,L.$Zg)(()=>{r.clear(),this.a.$setLanguageStatus(S,{id:o,name:i.name??I.displayName??I.name,source:I.displayName??I.name,selector:T.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===f.LanguageStatusSeverity.Error?R.default.Error:i.severity===f.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:i.command&&this.d.toInternal(i.command,r),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){r.dispose(),n?.dispose(),w.$removeLanguageStatus(S),l.delete(o)},get id(){return i.id},get name(){return i.name},set name(s){i.name=s,a()},get selector(){return i.selector},set selector(s){i.selector=s,a()},get text(){return i.text},set text(s){i.text=s,a()},set text2(s){(0,y.$NF)(I,"languageStatusText"),i.text=s,a()},get text2(){return(0,y.$NF)(I,"languageStatusText"),i.text},get detail(){return i.detail},set detail(s){i.detail=s,a()},get severity(){return i.severity},set severity(s){i.severity=s,a()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(s){i.accessibilityInformation=s,a()},get command(){return i.command},set command(s){i.command=s,a()},get busy(){return i.busy},set busy(s){i.busy=s,a()}};return a(),t}}e.$efc=g}),define(ke[115],Se([1,0,11,13,2,5,14,6,27,20]),function(me,e,C,T,f,R,L,b,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dec=e.$Cec=void 0;let A=class{constructor($,v,S){this.f=S,this.d=new Map,this.a=v.getProxy(b.$zK.MainThreadLocalization),this.b=$.environment.appLanguage,this.c=this.b===C.$g}getMessage($,v){const{message:S,args:w,comment:l}=v;if(this.c)return(0,T.$He)(S,w??{});let o=S;l&&l.length>0&&(o+=`/${Array.isArray(l)?l.join(""):l}`);const i=this.d.get($)?.contents[o];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,T.$He)(i??S,w??{})}getBundle($){return this.d.get($)?.contents}getBundleUri($){return this.d.get($)?.uri}async initializeLocalizedMessages($){if(this.c||!$.l10n&&!$.isBuiltin||this.d.has($.identifier.value))return;let v;const S=await this.g($);if(!S){this.f.error(`No bundle location found for extension ${$.identifier.value}`);return}try{const w=await this.a.$fetchBundleContents(S),l=JSON.parse(w);v=$.isBuiltin?l.contents?.bundle:l}catch(w){this.f.error(`Failed to load translations for ${$.identifier.value} from ${S}: ${w.message}`);return}v&&this.d.set($.identifier.value,{contents:v,uri:S})}async g($){if($.isBuiltin){const v=await this.a.$fetchBuiltInBundleUri($.identifier.value,this.b);return f.URI.revive(v)}return $.l10n?f.URI.joinPath($.extensionLocation,$.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Cec=A,e.$Cec=A=He([Be(0,y.$RM),Be(1,g.$BM),Be(2,L.$dj)],A),e.$Dec=(0,R.$Vh)("IExtHostLocalizationService")}),define(ke[152],Se([1,0,14,6,27,20,2,54]),function(me,e,C,T,f,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pfc=void 0;let y=class extends C.$oj{constructor(I,$){super($.logLevel,$.logsLocation,$.loggers.map(v=>(0,b.$sh)(v))),this.r=I.getProxy(T.$zK.MainThreadLogger)}$setLogLevel(I,$){$?this.setLogLevel(L.URI.revive($),I):this.setLogLevel(I)}setVisibility(I,$){super.setVisibility(I,$),this.r.$setVisibility(I,$)}s(I,$,v){return new g(this.r,I,$,v)}};e.$Pfc=y,e.$Pfc=y=He([Be(0,R.$BM),Be(1,f.$RM)],y);class g extends C.$jj{constructor(I,$,v,S){super(S?.logLevel==="always"),this.r=I,this.s=$,this.m=!1,this.n=[],this.setLevel(v),this.r.$createLogger($,S).then(()=>{this.u(this.n),this.m=!0})}g(I,$){const v=[[I,$]];this.m?this.u(v):this.n.push(...v)}u(I){this.r.$log(this.s,I)}flush(){this.r.$flush(this.s)}}}),define(ke[116],Se([1,0,6,5,3,20,22]),function(me,e,C,T,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fec=e.$Eec=void 0,e.$Eec=(0,T.$Vh)("IExtHostManagedSockets");let b=class{constructor(I){this.b=0,this.c=null,this.d=new Map,this.a=I.getProxy(C.$zK.MainThreadManagedSockets)}setFactory(I,$){for(const v of this.d.values())v.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new y(I,$),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(I){if(!this.c||this.c.socketFactoryId!==I)throw new Error(`No socket factory with id ${I}`);const $=++this.b,v=await this.c.makeConnection(),S=new f.$Qc;return this.d.set($,new g($,v,S)),S.add((0,f.$Pc)(()=>this.d.delete($))),S.add(v.onDidEnd(()=>{this.a.$onDidManagedSocketEnd($),S.dispose()})),S.add(v.onDidClose(w=>{this.a.$onDidManagedSocketClose($,w?.stack??w?.message),S.dispose()})),S.add(v.onDidReceiveMessage(w=>this.a.$onDidManagedSocketHaveData($,L.$fe.wrap(w)))),$}$remoteSocketWrite(I,$){this.d.get(I)?.actual.send($.buffer)}$remoteSocketEnd(I){const $=this.d.get(I);$&&($.actual.end(),$.dispose())}async $remoteSocketDrain(I){await this.d.get(I)?.actual.drain?.()}};e.$Fec=b,e.$Fec=b=He([Be(0,R.$BM)],b);class y{constructor(I,$){this.socketFactoryId=I,this.makeConnection=$}}class g extends f.$Rc{constructor(I,$,v){super(),this.socketId=I,this.actual=$,this.B(v)}}}),define(ke[329],Se([1,0,6,14,25]),function(me,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ffc=void 0;function R(b){return b&&b.title}let L=class{constructor(y,g){this.b=g,this.a=y.getProxy(C.$zK.MainThreadMessageService)}showMessage(y,g,A,I,$){const v={source:{identifier:y.identifier,label:y.displayName||y.name}};let S;typeof I=="string"||R(I)?S=[I,...$]:(v.modal=I?.modal,v.useCustom=I?.useCustom,v.detail=I?.detail,S=$),v.useCustom&&(0,f.$NF)(y,"resolvers");const w=[];for(let l=0;l<S.length;l++){const o=S[l];if(typeof o=="string")w.push({title:o,handle:l,isCloseAffordance:!1});else if(typeof o=="object"){const{title:i,isCloseAffordance:n}=o;w.push({title:i,isCloseAffordance:!!n,handle:l})}else this.b.warn("Invalid message item:",o)}return this.a.$showMessage(g,A,v,w).then(l=>{if(typeof l=="number")return S[l]})}};e.$ffc=L,e.$ffc=L=He([Be(1,T.$dj)],L)}),define(ke[330],Se([1,0,19,12,21,4,3,28,2,26,14,6,35,15,7,113,286,25,68]),function(me,e,C,T,f,R,L,b,y,g,A,I,$,v,S,w,l,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kfc=e.$jfc=void 0;let n=class{constructor(h,E,D,m,p){this.l=E,this.m=D,this.n=m,this.o=p,this.b=new b.$zc,this.c=new b.$zc,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new Map,this.j=0,this.k=new R.$Rd,this.onDidChangeNotebookCellExecutionState=this.k.event,this.a=h.getProxy(I.$zK.MainThreadNotebookKernels);const k=new $.$2M("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new $.$ZM("options","Select kernel options",P=>!0,P=>{if(P&&"notebookEditor"in P&&"id"in P){const z=this.m.getIdByEditor(P.notebookEditor);return{id:P.id,extension:P.extension,notebookEditorId:z}}else if(P&&"notebookEditor"in P){const z=this.m.getIdByEditor(P.notebookEditor);if(z===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${P.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:z}}return P})],$.$1M.Void);this.n.registerApiCommand(k)}createNotebookController(h,E,D,m,p,k){for(const oe of this.i.values())if(oe.controller.id===E&&g.$_l.equals(h.identifier,oe.extensionId))throw new Error(`notebook controller with id '${E}' ALREADY exist`);const P=this.j++,z=this;this.o.trace(`NotebookController[${P}], CREATED by ${h.identifier.value}, ${E}`);const j=()=>console.warn(`NO execute handler from notebook controller '${N.id}' of extension: '${h.identifier}'`);let M=!1;const O=new R.$Rd,F=new R.$Rd,N={id:c(h.identifier,E),notebookType:D,extensionId:h.identifier,extensionLocation:h.extensionLocation,label:m||h.identifier.value,preloads:k?k.map(v.NotebookRendererScript.from):[]};let W=p??j,X;this.a.$addKernel(P,N).catch(oe=>{console.log(oe),M=!0});let ce=0;const J=()=>{if(M)return;const oe=++ce;Promise.resolve().then(()=>{oe===ce&&this.a.$updateKernel(P,N)})},Q=new b.$zc,G={get id(){return E},get notebookType(){return N.notebookType},onDidChangeSelectedNotebooks:O.event,get label(){return N.label},set label(oe){N.label=oe??h.displayName??h.name,J()},get detail(){return N.detail??""},set detail(oe){N.detail=oe,J()},get description(){return N.description??""},set description(oe){N.description=oe,J()},get supportedLanguages(){return N.supportedLanguages},set supportedLanguages(oe){N.supportedLanguages=oe,J()},get supportsExecutionOrder(){return N.supportsExecutionOrder??!1},set supportsExecutionOrder(oe){N.supportsExecutionOrder=oe,J()},get rendererScripts(){return N.preloads?N.preloads.map(v.NotebookRendererScript.to):[]},get executeHandler(){return W},set executeHandler(oe){W=oe??j},get interruptHandler(){return X},set interruptHandler(oe){X=oe,N.supportsInterrupt=!!oe,J()},createNotebookCellExecution(oe){if(M)throw new Error("notebook controller is DISPOSED");if(!Q.has(oe.notebook.uri))throw z.o.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Q.keys()).map(_=>_.toString())),new Error(`notebook controller is NOT associated to notebook: ${oe.notebook.uri.toString()}`);return z._createNotebookCellExecution(oe,c(h.identifier,this.id))},createNotebookExecution(oe){if((0,o.$NF)(h,"notebookExecution"),M)throw new Error("notebook controller is DISPOSED");if(!Q.has(oe.uri))throw z.o.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Q.keys()).map(_=>_.toString())),new Error(`notebook controller is NOT associated to notebook: ${oe.uri.toString()}`);return z._createNotebookExecution(oe,c(h.identifier,this.id))},dispose:()=>{M||(this.o.trace(`NotebookController[${P}], DISPOSED`),M=!0,this.i.delete(P),O.dispose(),F.dispose(),this.a.$removeKernel(P))},updateNotebookAffinity(oe,_){_===S.NotebookControllerAffinity2.Hidden&&(0,o.$NF)(h,"notebookControllerAffinityHidden"),z.a.$updateNotebookPriority(P,oe.uri,_)},onDidReceiveMessage:F.event,postMessage(oe,_){return(0,o.$NF)(h,"notebookMessaging"),z.a.$postMessage(P,_&&z.m.getIdByEditor(_),oe)},asWebviewUri(oe){return(0,o.$NF)(h,"notebookMessaging"),(0,w.$9tb)(oe,z.l.remote)}};return this.i.set(P,{extensionId:h.identifier,controller:G,onDidReceiveMessage:F,onDidChangeSelection:O,associatedNotebooks:Q}),G}getIdByController(h){for(const[E,D]of this.i)if(D.controller===h)return c(D.extensionId,h.id);return null}createNotebookControllerDetectionTask(h,E){const D=this.f++,m=this;this.o.trace(`NotebookControllerDetectionTask[${D}], CREATED by ${h.identifier.value}`),this.a.$addKernelDetectionTask(D,E);const p={dispose:()=>{this.e.delete(D),m.a.$removeKernelDetectionTask(D)}};return this.e.set(D,p),p}registerKernelSourceActionProvider(h,E,D){const m=this.h++,p=typeof D.onDidChangeNotebookKernelSourceActions=="function"?m:void 0,k=this;this.g.set(m,D),this.o.trace(`NotebookKernelSourceActionProvider[${m}], CREATED by ${h.identifier.value}`),this.a.$addKernelSourceActionProvider(m,m,E);let P;return p!==void 0&&(P=D.onDidChangeNotebookKernelSourceActions(z=>this.a.$emitNotebookKernelSourceActionsChangeEvent(p))),{dispose:()=>{this.g.delete(m),k.a.$removeKernelSourceActionProvider(m,m),P?.dispose()}}}async $provideKernelSourceActions(h,E){const D=this.g.get(h);if(D){const m=new L.$Qc;return(await D.provideNotebookKernelSourceActions(E)??[]).map(k=>v.NotebookKernelSourceAction.from(k,this.n.converter,m))}return[]}$acceptNotebookAssociation(h,E,D){const m=this.i.get(h);if(m){const p=this.m.getNotebookDocument(y.URI.revive(E));D?m.associatedNotebooks.set(p.uri,!0):m.associatedNotebooks.delete(p.uri),this.o.trace(`NotebookController[${h}] ASSOCIATE notebook`,p.uri.toString(),D),m.onDidChangeSelection.fire({selected:D,notebook:p.apiNotebook})}}async $executeCells(h,E,D){const m=this.i.get(h);if(!m)return;const p=this.m.getNotebookDocument(y.URI.revive(E)),k=[];for(const P of D){const z=p.getCell(P);z&&k.push(z.apiCell)}try{this.o.trace(`NotebookController[${h}] EXECUTE cells`,p.uri.toString(),k.length),await m.controller.executeHandler.call(m.controller,k,p.apiNotebook,m.controller)}catch(P){this.o.error(`NotebookController[${h}] execute cells FAILED`,P),console.error(P)}}async $cancelCells(h,E,D){const m=this.i.get(h);if(!m)return;const p=this.m.getNotebookDocument(y.URI.revive(E));if(m.controller.interruptHandler)await m.controller.interruptHandler.call(m.controller,p.apiNotebook);else for(const k of D){const P=p.getCell(k);P&&this.b.get(P.uri)?.cancel()}if(m.controller.interruptHandler){const k=this.c.get(p.uri);D.length&&Array.isArray(k)&&k.length&&k.forEach(P=>P.dispose())}}$acceptKernelMessageFromRenderer(h,E,D){const m=this.i.get(h);if(!m)return;const p=this.m.getEditorById(E);m.onDidReceiveMessage.fire(Object.freeze({editor:p.apiEditor,message:D}))}$cellExecutionChanged(h,E,D){const p=this.m.getNotebookDocument(y.URI.revive(h)).getCell(E);if(p){const k=D?v.NotebookCellExecutionState.to(D):S.NotebookCellExecutionState.Idle;k!==void 0&&this.k.fire({cell:p.apiCell,state:k})}}_createNotebookCellExecution(h,E){if(h.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const m=this.m.getNotebookDocument(h.notebook.uri).getCellFromApiCell(h);if(!m)throw new Error("invalid cell");if(this.b.has(m.uri))throw new Error(`duplicate execution for ${m.uri}`);const p=new a(E,m,this.a);this.b.set(m.uri,p);const k=p.onDidChangeState(()=>{p.state===r.Resolved&&(p.dispose(),k.dispose(),this.b.delete(m.uri))});return p.asApiObject()}_createNotebookExecution(h,E){const D=this.m.getNotebookDocument(h.uri),m=h.getCells().find(P=>{const z=D.getCellFromApiCell(P);return z&&this.b.has(z.uri)});if(m)throw new Error(`duplicate cell execution for ${m.document.uri}`);if(this.c.has(D.uri))throw new Error(`duplicate notebook execution for ${D.uri}`);const p=new s(E,D,this.a),k=p.onDidChangeState(()=>{p.state===t.Resolved&&(p.dispose(),k.dispose(),this.c.delete(D.uri))});return this.c.set(D.uri,[p,k]),p.asApiObject()}};e.$jfc=n,e.$jfc=n=He([Be(4,A.$dj)],n);var r;(function(u){u[u.Init=0]="Init",u[u.Started=1]="Started",u[u.Resolved=2]="Resolved"})(r||(r={}));class a extends L.$Rc{static{this.a=0}get state(){return this.f}constructor(h,E,D){super(),this.m=E,this.n=D,this.b=a.a++,this.c=new R.$Rd,this.onDidChangeState=this.c.event,this.f=r.Init,this.g=this.B(new f.$2d),this.h=new d(10,m=>this.s(m)),this.j=E.internalMetadata.executionOrder,this.n.$createExecution(this.b,h,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(h){await this.h.addItem(h)}async s(h){const E=Array.isArray(h)?h:[h];return this.n.$updateExecution(this.b,new i.$wv(E))}t(){if(this.f===r.Init)throw new Error("Must call start before modifying cell output");if(this.f===r.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(h){let E=this.m;if(h&&(E=this.m.notebook.getCellFromApiCell(h)),!E)throw new Error("INVALID cell");return E.handle}y(h){return h.map(E=>{const D=S.$3L.ensureUniqueMimeTypes(E.items,!0);return D===E.items?v.NotebookCellOutput.from(E):v.NotebookCellOutput.from({items:D,id:E.id,metadata:E.metadata})})}async z(h,E,D){const m=this.w(E),p=this.y((0,C.$2b)(h));return this.r({editType:l.CellExecutionUpdateType.Output,cellHandle:m,append:D,outputs:p})}async C(h,E,D){return h=S.$3L.ensureUniqueMimeTypes((0,C.$2b)(h),!0),this.r({editType:l.CellExecutionUpdateType.OutputItems,items:h.map(v.NotebookCellOutputItem.from),outputId:E.id,append:D})}asApiObject(){const h=this;return Object.freeze({get token(){return h.g.token},get cell(){return h.m.apiCell},get executionOrder(){return h.j},set executionOrder(D){h.j=D,h.s([{editType:l.CellExecutionUpdateType.ExecutionState,executionOrder:h.j}])},start(D){if(h.f===r.Resolved||h.f===r.Started)throw new Error("Cannot call start again");h.f=r.Started,h.c.fire(),h.s({editType:l.CellExecutionUpdateType.ExecutionState,runStartTime:D})},end(D,m){if(h.f===r.Resolved)throw new Error("Cannot call resolve twice");h.f=r.Resolved,h.c.fire(),h.h.flush(),h.n.$completeExecution(h.b,new i.$wv({runEndTime:m,lastRunSuccess:D}))},clearOutput(D){return h.t(),h.z([],D,!1)},appendOutput(D,m){return h.t(),h.z(D,m,!0)},replaceOutput(D,m){return h.t(),h.z(D,m,!1)},appendOutputItems(D,m){return h.t(),h.C(D,m,!0)},replaceOutputItems(D,m){return h.t(),h.C(D,m,!1)}})}}var t;(function(u){u[u.Init=0]="Init",u[u.Started=1]="Started",u[u.Resolved=2]="Resolved"})(t||(t={}));class s extends L.$Rc{static{this.a=0}get state(){return this.f}constructor(h,E,D){super(),this.h=E,this.j=D,this.b=s.a++,this.c=new R.$Rd,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new f.$2d),this.j.$createNotebookExecution(this.b,h,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===t.Resolved||this.f===t.Started)throw new Error("Cannot call start again");this.f=t.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===t.Resolved)throw new Error("Cannot call resolve twice");this.f=t.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class d{constructor(h,E){this.e=h,this.f=E,this.a=[],this.b=Date.now()}addItem(h){return this.a.push(h),this.c||(this.c=new T.$ih,this.b=Date.now(),(0,T.$Yg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const h=this.c;this.c=void 0;const E=this.a;return this.a=[],this.f(E).finally(()=>h.complete())}}function c(u,h){return`${u.value}/${h}`}e.$kfc=c}),define(ke[331],Se([1,0,4,6,148]),function(me,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lfc=void 0;class R{constructor(b,y){this.c=y,this.a=new Map,this.b=b.getProxy(T.$zK.MainThreadNotebookRenderers)}$postRendererMessage(b,y,g){const A=this.c.getEditorById(b);this.a.get(y)?.fire({editor:A.apiEditor,message:g})}createRendererMessaging(b,y){if(!b.contributes?.notebookRenderer?.some(A=>A.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);return{onDidReceiveMessage:(A,I,$)=>this.d(y).event(A,I,$),postMessage:(A,I)=>{f.$4ec.apiEditorsToExtHost.has(A)&&([A,I]=[I,A]);const $=I&&f.$4ec.apiEditorsToExtHost.get(I);return this.b.$postMessage($?.id,y,A)}}}d(b){let y=this.a.get(b);return y||(y=new C.$Rd({onDidRemoveLastListener:()=>{y?.dispose(),this.a.delete(b)}}),this.a.set(b,y),y)}}e.$lfc=R}),define(ke[332],Se([1,0,3,18,2,25,6]),function(me,e,C,T,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ofc=void 0;class b{constructor(g){this.b=new Map,this.a=g.getProxy(L.$zK.MainThreadProfileContentHandlers)}registrProfileContentHandler(g,A,I){if((0,R.$NF)(g,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,I),this.a.$registerProfileContentHandler(A,I.name,I.description,g.identifier.value),(0,C.$Pc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(g,A,I,$){const v=this.b.get(g);if(!v)throw new Error(`Unknown handler with id: ${g}`);return v.saveProfile(A,I,$)}async $readProfile(g,A,I){const $=this.b.get(g);if(!$)throw new Error(`Unknown handler with id: ${g}`);return $.readProfile((0,T.$Cf)(A)?A:f.URI.revive(A),I)}}e.$ofc=b}),define(ke[333],Se([1,0,2,6,12,15]),function(me,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qfc=void 0;class L{static{this.a=0}constructor(y,g){this.d=g,this.c=new Map,this.b=y.getProxy(T.$zK.MainThreadQuickDiff)}$provideOriginalResource(y,g,A){const I=C.URI.revive(g),$=this.c.get(y);return $?(0,f.$Qg)(()=>$.provideOriginalResource(I,A)).then(v=>v||null):Promise.resolve(null)}registerQuickDiffProvider(y,g,A,I){const $=L.a++;return this.c.set($,g),this.b.$registerQuickDiffProvider($,R.DocumentSelector.from(y,this.d),A,I),{dispose:()=>{this.b.$unregisterQuickDiffProvider($),this.c.delete($)}}}}e.$qfc=L}),define(ke[334],Se([1,0,21,4,3,6,2,7,8,19,39,61,25,15]),function(me,e,C,T,f,R,L,b,y,g,A,I,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rfc=void 0;function S(w,l,o){const i=w.getProxy(R.$zK.MainThreadQuickOpen);class n{constructor(E,D){this.e=new Map,this.f=0,this.a=E,this.b=D}showQuickPick(E,D,m,p=C.CancellationToken.None){this.c=void 0;const k=Promise.resolve(D),P=++this.f,z=i.$show(P,{title:m?.title,placeHolder:m?.placeHolder,matchOnDescription:m?.matchOnDescription,matchOnDetail:m?.matchOnDetail,ignoreFocusLost:m?.ignoreFocusOut,canPickMany:m?.canPickMany},p),j={},M=z.then(()=>j);return Promise.race([M,k]).then(O=>{if(O===j)return;const F=(0,$.$MF)(E,"quickPickItemTooltip");return k.then(N=>{const W=[];for(let X=0;X<N.length;X++){const ce=N[X];if(typeof ce=="string")W.push({label:ce,handle:X});else if(ce.kind===b.QuickPickItemKind.Separator)W.push({type:"separator",label:ce.label});else{ce.tooltip&&!F&&console.warn(`Extension '${E.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${E.identifier.value}`);const J=ce.iconPath?d(ce.iconPath):void 0;W.push({label:ce.label,iconPath:J?.iconPath,iconClass:J?.iconClass,description:ce.description,detail:ce.detail,picked:ce.picked,alwaysShow:ce.alwaysShow,tooltip:F?v.MarkdownString.fromStrict(ce.tooltip):void 0,handle:X})}}return m&&typeof m.onDidSelectItem=="function"&&(this.c=X=>{m.onDidSelectItem(N[X])}),i.$setItems(P,W),z.then(X=>{if(typeof X=="number")return N[X];if(Array.isArray(X))return X.map(ce=>N[ce])})})}).then(void 0,O=>{if(!(0,y.$3)(O))return i.$setError(P,O),Promise.reject(O)})}$onItemSelected(E){this.c?.(E)}showInput(E,D=C.CancellationToken.None){return this.d=E?.validateInput,i.$input(E,typeof this.d=="function",D).then(void 0,m=>{if(!(0,y.$3)(m))return Promise.reject(m)})}async $validateInput(E){if(!this.d)return;const D=await this.d(E);if(!D||typeof D=="string")return D;let m;switch(D.severity){case b.InputBoxValidationSeverity.Info:m=A.default.Info;break;case b.InputBoxValidationSeverity.Warning:m=A.default.Warning;break;case b.InputBoxValidationSeverity.Error:m=A.default.Error;break;default:m=D.message?A.default.Error:A.default.Ignore;break}return{content:D.message,severity:m}}async showWorkspaceFolderPick(E,D=C.CancellationToken.None){const m=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[E]);if(!m)return;const p=await this.a.getWorkspaceFolders2();if(p)return p.find(k=>k.uri.toString()===m.uri.toString())}createQuickPick(E){const D=new c(E,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}createInputBox(E){const D=new u(E,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}$onDidChangeValue(E,D){this.e.get(E)?._fireDidChangeValue(D)}$onDidAccept(E){this.e.get(E)?._fireDidAccept()}$onDidChangeActive(E,D){const m=this.e.get(E);m instanceof c&&m._fireDidChangeActive(D)}$onDidChangeSelection(E,D){const m=this.e.get(E);m instanceof c&&m._fireDidChangeSelection(D)}$onDidTriggerButton(E,D){this.e.get(E)?._fireDidTriggerButton(D)}$onDidTriggerItemButton(E,D,m){const p=this.e.get(E);p instanceof c&&p._fireDidTriggerItemButton(D,m)}$onDidHide(E){this.e.get(E)?._fireDidHide()}}class r{static{this.a=1}constructor(E,D){this.x=E,this.y=D,this._id=c.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new T.$Rd,this.q=new T.$Rd,this.r=new T.$Rd,this.s=new T.$Rd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(E){this.b=E,this.z({title:E})}get step(){return this.c}set step(E){this.c=E,this.z({step:E})}get totalSteps(){return this.d}set totalSteps(E){this.d=E,this.z({totalSteps:E})}get enabled(){return this.g}set enabled(E){this.g=E,this.z({enabled:E})}get busy(){return this.j}set busy(E){this.j=E,this.z({busy:E})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(E){this.k=E,this.z({ignoreFocusOut:E})}get value(){return this.l}set value(E){this.l=E,this.z({value:E})}get placeholder(){return this.m}set placeholder(E){this.m=E,this.z({placeholder:E})}get buttons(){return this.n}set buttons(E){this.n=E.slice(),this.o.clear(),E.forEach((D,m)=>{const p=D===b.$VL.Back?-1:m;this.o.set(p,D)}),this.z({buttons:E.map((D,m)=>({...d(D.iconPath),tooltip:D.tooltip,handle:D===b.$VL.Back?-1:m}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(E){this.l=E,this.q.fire(E)}_fireDidTriggerButton(E){const D=this.o.get(E);D&&this.r.fire(D)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,f.$Mc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z(E){if(!this.v){for(const D of Object.keys(E)){const m=E[D];this.u[D]=m===void 0?null:m}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}function a(h){if(h instanceof b.$vL)return{id:h.id};const E=s(h),D=t(h);return{dark:typeof E=="string"?L.URI.file(E):E,light:typeof D=="string"?L.URI.file(D):D}}function t(h){return typeof h=="object"&&"light"in h?h.light:h}function s(h){return typeof h=="object"&&"dark"in h?h.dark:h}function d(h){const E=a(h);let D,m;return"id"in E?m=I.ThemeIcon.asClassName(E):D=E,{iconPath:D,iconClass:m}}class c extends r{constructor(E,D){super(E.identifier,D),this.O=E,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new T.$Rd,this.L=[],this.M=new T.$Rd,this.N=new T.$Rd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(E){this.B=E.slice(),this.C.clear(),this.D.clear(),E.forEach((p,k)=>{this.C.set(k,p),this.D.set(p,k)});const D=(0,$.$MF)(this.O,"quickPickItemTooltip"),m=[];for(let p=0;p<E.length;p++){const k=E[p];if(k.kind===b.QuickPickItemKind.Separator)m.push({type:"separator",label:k.label});else{k.tooltip&&!D&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const P=k.iconPath?d(k.iconPath):void 0;m.push({handle:p,label:k.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:k.description,detail:k.detail,picked:k.picked,alwaysShow:k.alwaysShow,tooltip:D?v.MarkdownString.fromStrict(k.tooltip):void 0,buttons:k.buttons?.map((z,j)=>({...d(z.iconPath),tooltip:z.tooltip,handle:j}))})}}this.z({items:m})}get canSelectMany(){return this.E}set canSelectMany(E){this.E=E,this.z({canSelectMany:E})}get matchOnDescription(){return this.F}set matchOnDescription(E){this.F=E,this.z({matchOnDescription:E})}get matchOnDetail(){return this.G}set matchOnDetail(E){this.G=E,this.z({matchOnDetail:E})}get sortByLabel(){return this.H}set sortByLabel(E){this.H=E,this.z({sortByLabel:E})}get keepScrollPosition(){return this.I}set keepScrollPosition(E){this.I=E,this.z({keepScrollPosition:E})}get activeItems(){return this.J}set activeItems(E){this.J=E.filter(D=>this.D.has(D)),this.z({activeItems:this.J.map(D=>this.D.get(D))})}get selectedItems(){return this.L}set selectedItems(E){this.L=E.filter(D=>this.D.has(D)),this.z({selectedItems:this.L.map(D=>this.D.get(D))})}_fireDidChangeActive(E){const D=(0,g.$Gb)(E.map(m=>this.C.get(m)));this.J=D,this.K.fire(D)}_fireDidChangeSelection(E){const D=(0,g.$Gb)(E.map(m=>this.C.get(m)));this.L=D,this.M.fire(D)}_fireDidTriggerItemButton(E,D){const m=this.C.get(E);if(!m||!m.buttons||!m.buttons.length)return;const p=m.buttons[D];p&&this.N.fire({button:p,item:m})}}class u extends r{constructor(E,D){super(E.identifier,D),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(E){this.B=E,this.z({password:E})}get prompt(){return this.C}set prompt(E){this.C=E,this.z({prompt:E})}get valueSelection(){return this.D}set valueSelection(E){this.D=E,this.z({valueSelection:E})}get validationMessage(){return this.E}set validationMessage(E){this.E=E,E?typeof E=="string"?this.z({validationMessage:E,severity:A.default.Error}):this.z({validationMessage:E.message,severity:E.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new n(l,o)}e.$rfc=S}),define(ke[335],Se([1,0,2,4,59,3,12,6,19,129,14,21,26,61,15,25,17,11]),function(me,e,C,T,f,R,L,b,y,g,A,I,$,v,S,w,l,o){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$tfc=e.$sfc=void 0;function n(O){return O instanceof C.URI}function r(O,F){return O.scheme===l.Schemas.file&&F.scheme===l.Schemas.file&&o.$k?O.toString()===F.toString():O.toString().toLowerCase()===F.toString().toLowerCase()}function a(O){if(O)return typeof O.iconPath=="string"?C.URI.file(O.iconPath):C.URI.isUri(O.iconPath)||v.ThemeIcon.isThemeIcon(O.iconPath)?O.iconPath:void 0}function t(O){if(O?.icon){if(C.URI.isUri(O.icon))return O.icon;if(v.ThemeIcon.isThemeIcon(O.icon))return O.icon;{const F=O.icon;return{light:F.light,dark:F.dark}}}else return}function s(O){if(O.icon){if(C.URI.isUri(O.icon))return O.icon;if(v.ThemeIcon.isThemeIcon(O.icon))return O.icon;{const F=O.icon;return{light:F.light,dark:F.dark}}}else return}function d(O){if(O.icon){if(C.URI.isUri(O.icon))return O.icon;if(v.ThemeIcon.isThemeIcon(O.icon))return O.icon;{const F=O.icon;return{light:F.light,dark:F.dark}}}else return}function c(O,F){if(!O.iconPath&&!F.iconPath)return 0;if(O.iconPath){if(!F.iconPath)return 1}else return-1;const N=typeof O.iconPath=="string"?O.iconPath:C.URI.isUri(O.iconPath)?O.iconPath.fsPath:O.iconPath.id,W=typeof F.iconPath=="string"?F.iconPath:C.URI.isUri(F.iconPath)?F.iconPath.fsPath:F.iconPath.id;return(0,g.$xq)(N,W)}function u(O,F){let N=0;if(O.strikeThrough!==F.strikeThrough)return O.strikeThrough?1:-1;if(O.faded!==F.faded)return O.faded?1:-1;if(O.tooltip!==F.tooltip)return(O.tooltip||"").localeCompare(F.tooltip||"");if(N=c(O,F),N!==0)return N;if(O.light&&F.light)N=c(O.light,F.light);else{if(O.light)return 1;if(F.light)return-1}if(N!==0)return N;if(O.dark&&F.dark)N=c(O.dark,F.dark);else{if(O.dark)return 1;if(F.dark)return-1}return N}function h(O,F){if(O.command!==F.command)return O.command<F.command?-1:1;if(O.title!==F.title)return O.title<F.title?-1:1;if(O.tooltip!==F.tooltip){if(O.tooltip!==void 0&&F.tooltip!==void 0)return O.tooltip<F.tooltip?-1:1;if(O.tooltip!==void 0)return 1;if(F.tooltip!==void 0)return-1}if(O.arguments===F.arguments)return 0;if(O.arguments)if(F.arguments){if(O.arguments.length!==F.arguments.length)return O.arguments.length-F.arguments.length}else return 1;else return-1;for(let N=0;N<O.arguments.length;N++){const W=O.arguments[N],X=F.arguments[N];if(W!==X&&!(n(W)&&n(X)&&r(W,X)))return W<X?-1:1}return 0}function E(O,F){let N=(0,g.$xq)(O.resourceUri.fsPath,F.resourceUri.fsPath,!0);if(N!==0)return N;if(O.command&&F.command)N=h(O.command,F.command);else{if(O.command)return 1;if(F.command)return-1}if(N!==0)return N;if(O.decorations&&F.decorations)N=u(O.decorations,F.decorations);else{if(O.decorations)return 1;if(F.decorations)return-1}return N}function D(O,F){for(let N=0;N<O.length;N++)if(O[N]!==F[N])return!1;return!0}function m(O,F){return O.command===F.command&&O.title===F.title&&O.tooltip===F.tooltip&&(O.arguments&&F.arguments?D(O.arguments,F.arguments):O.arguments===F.arguments)}function p(O,F){return(0,y.$tb)(O,F,m)}function k(O,F){return O===F?!0:!O||!F?!1:O.id===F.id&&O.label===F.label&&O.upstream?.id===F.upstream?.id&&O.upstream?.label===F.upstream?.label}class P{#e;#t;get value(){return this.d}set value(F){F=F??"",this.#e.$setInputBoxValue(this.o,F),this.q(F)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(F){this.#e.$setInputBoxPlaceholder(this.o,F),this.f=F}get validateInput(){return(0,w.$NF)(this.m,"scmValidation"),this.g}set validateInput(F){if((0,w.$NF)(this.m,"scmValidation"),F&&typeof F!="function")throw new Error(`[${this.m.identifier.value}]: Invalid SCM input box validation function`);this.g=F,this.#e.$setValidationProviderIsEnabled(this.o,!!F)}get enabled(){return this.h}set enabled(F){F=!!F,this.h!==F&&(this.h=F,this.#e.$setInputBoxEnablement(this.o,F))}get visible(){return this.j}set visible(F){F=!!F,this.j!==F&&(this.j=F,this.#e.$setInputBoxVisibility(this.o,F))}get actionButton(){return(0,w.$NF)(this.m,"scmInputBoxActionButton"),this.k}set actionButton(F){(0,w.$NF)(this.m,"scmInputBoxActionButton"),this.l.value=new R.$Qc,this.k=F;const N=F!==void 0?{command:this.n.converter.toInternal(F.command,this.l.value),icon:t(F),enabled:F.enabled}:void 0;this.#e.$setInputBoxActionButton(this.o,N??null)}get document(){return(0,w.$NF)(this.m,"scmTextDocument"),this.#t.getDocument(this.p)}constructor(F,N,W,X,ce,J){this.m=F,this.n=N,this.o=ce,this.p=J,this.d="",this.e=new T.$Rd,this.f="",this.h=!0,this.j=!0,this.l=new R.$Sc,this.#t=W,this.#e=X}showValidationMessage(F,N){(0,w.$NF)(this.m,"scmValidation"),this.#e.$showValidationMessage(this.o,F,N)}$onInputBoxValueChange(F){this.q(F)}q(F){this.d=F,this.e.fire(F)}}e.$sfc=P;class z{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(F){this.v=F,this.q.$updateGroupLabel(this.t,this.handle,F)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(F){this.p=F,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(F){this.f=[...F],this.k.fire()}constructor(F,N,W,X,ce){this.q=F,this.s=N,this.t=W,this.u=X,this.v=ce,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new T.$Rd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new T.$Rd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=z.d++}getResourceState(F){return this.g.get(F)}$executeResourceCommand(F,N){const W=this.h.get(F);return W?(0,L.$Qg)(()=>this.s.executeCommand(W.command,...W.arguments||[],N)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const F=[...this.f].sort(E),W=(0,y.$Cb)(this.o,F,E).map(J=>{const Q=J.toInsert.map(G=>{const oe=this.e++;this.g.set(oe,G);const _=G.resourceUri;let Ee;if(G.command)if(G.command.command==="vscode.open"||G.command.command==="vscode.diff"||G.command.command==="vscode.changes"){const ie=new R.$Qc;Ee=this.s.converter.toInternal(G.command,ie),this.j.set(oe,ie)}else this.h.set(oe,G.command);const he=a(G.decorations),q=G.decorations&&a(G.decorations.light)||he,U=G.decorations&&a(G.decorations.dark)||he,ne=[q,U],be=G.decorations&&G.decorations.tooltip||"",H=G.decorations&&!!G.decorations.strikeThrough,x=G.decorations&&!!G.decorations.faded,Y=G.contextValue||"";return{rawResource:[oe,_,ne,be,H,x,Y,Ee],handle:oe}});return{start:J.start,deleteCount:J.deleteCount,toInsert:Q}}),X=W.map(({start:J,deleteCount:Q,toInsert:G})=>[J,Q,G.map(oe=>oe.rawResource)]),ce=W.reverse();for(const{start:J,deleteCount:Q,toInsert:G}of ce){const oe=G.map(Ee=>Ee.handle),_=this.n.splice(J,Q,...oe);for(const Ee of _)this.g.delete(Ee),this.h.delete(Ee),this.j.get(Ee)?.dispose(),this.j.delete(Ee)}return this.o=F,X}dispose(){this.l=!0,this.m.fire()}}class j{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(F){this.g!==F&&(this.g=F,this.#e.$updateSourceControl(this.x,{count:F}))}get quickDiffProvider(){return this.h}set quickDiffProvider(F){this.h=F;let N;(0,w.$MF)(this.y,"quickDiffProvider")&&(N=F?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!F,quickDiffLabel:N})}get historyProvider(){return(0,w.$NF)(this.y,"scmHistoryProvider"),this.j}set historyProvider(F){(0,w.$NF)(this.y,"scmHistoryProvider"),this.j=F,this.k.value=new R.$Qc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!F}),F&&(this.k.value.add(F.onDidChangeCurrentHistoryItemGroup(()=>{k(this.l,F?.currentHistoryItemGroup)||(this.l=F?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l))})),this.k.value.add(F.onDidChangeActionButton(()=>{(0,w.$NF)(this.y,"scmActionButton"),this.m.value=new R.$Qc;const N=F.actionButton!==void 0?{command:this.z.converter.toInternal(F.actionButton.command,this.m.value),description:F.actionButton.description,enabled:F.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,N??null)})))}get commitTemplate(){return this.n}set commitTemplate(F){F!==this.n&&(this.n=F,this.#e.$updateSourceControl(this.x,{commitTemplate:F}))}get acceptInputCommand(){return this.p}set acceptInputCommand(F){this.o.value=new R.$Qc,this.p=F;const N=this.z.converter.toInternal(F,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:N})}get actionButton(){return(0,w.$NF)(this.y,"scmActionButton"),this.s}set actionButton(F){(0,w.$NF)(this.y,"scmActionButton"),this.q.value=new R.$Qc,this.s=F;const N=F!==void 0?{command:this.z.converter.toInternal(F.command,this.q.value),secondaryCommands:F.secondaryCommands?.map(W=>W.map(X=>this.z.converter.toInternal(X,this.q.value))),description:F.description,enabled:F.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:N??null})}get statusBarCommands(){return this.u}set statusBarCommands(F){if(this.u&&F&&p(this.u,F))return;this.t.value=new R.$Qc,this.u=F;const N=(F||[]).map(W=>this.z.converter.toInternal(W,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:N})}get selected(){return this.v}constructor(F,N,W,X,ce,J,Q){this.y=F,this.z=X,this.A=ce,this.B=J,this.C=Q,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new R.$Sc,this.m=new R.$Sc,this.n=void 0,this.o=new R.$Sc,this.p=void 0,this.q=new R.$Sc,this.t=new R.$Sc,this.u=void 0,this.v=!1,this.w=new T.$Rd,this.onDidChangeSelection=this.w.event,this.x=j.d++,this.D=new Map,this.E=new Set,this.#e=W;const G=C.URI.from({scheme:l.Schemas.vscodeSourceControl,path:`${ce}/scm${this.x}/input`,query:Q?`rootUri=${encodeURIComponent(Q.toString())}`:void 0});this.f=new P(F,X,N,this.#e,this.x,G),this.#e.$registerSourceControl(this.x,ce,J,Q,G)}createResourceGroup(F,N){const W=new z(this.#e,this.z,this.x,F,N),X=T.Event.once(W.onDidDispose)(()=>this.D.delete(W));return this.D.set(W,X),this.eventuallyAddResourceGroups(),W}eventuallyAddResourceGroups(){const F=[],N=[];for(const[W,X]of this.D){X.dispose();const ce=W.onDidUpdateResourceStates(()=>{this.E.add(W),this.eventuallyUpdateResourceStates()});T.Event.once(W.onDidDispose)(()=>{this.E.delete(W),ce.dispose(),this.e.delete(W.handle),this.#e.$unregisterGroup(this.x,W.handle)}),F.push([W.handle,W.id,W.label,W.features]);const J=W._takeResourceStateSnapshot();J.length>0&&N.push([W.handle,J]),this.e.set(W.handle,W)}this.#e.$registerGroups(this.x,F,N),this.D.clear()}eventuallyUpdateResourceStates(){const F=[];this.E.forEach(N=>{const W=N._takeResourceStateSnapshot();W.length!==0&&F.push([N.handle,W])}),F.length>0&&this.#e.$spliceResourceStates(this.x,F),this.E.clear()}getResourceGroup(F){return this.e.get(F)}setSelectionState(F){this.v=F,this.w.fire(F)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(F=>F.dispose()),this.#e.$unregisterSourceControl(this.x)}}He([(0,f.$oh)(100)],j.prototype,"eventuallyAddResourceGroups",null),He([(0,f.$oh)(100)],j.prototype,"eventuallyUpdateResourceStates",null);let M=class{static{i=this}static{this.d=0}static{this.e=0}get onDidChangeActiveProvider(){return this.k.event}constructor(F,N,W,X){this.n=N,this.o=W,this.p=X,this.h=new Map,this.j=new $.$bm,this.k=new T.$Rd,this.l=new Map,this.f=F.getProxy(b.$zK.MainThreadSCM),this.g=F.getProxy(b.$zK.MainThreadTelemetry),N.registerArgumentProcessor({processArgument:ce=>{if(ce&&ce.$mid===3){const J=this.h.get(ce.sourceControlHandle);if(!J)return ce;const Q=J.getResourceGroup(ce.groupHandle);return Q?Q.getResourceState(ce.handle):ce}else if(ce&&ce.$mid===4){const J=this.h.get(ce.sourceControlHandle);return J?J.getResourceGroup(ce.groupHandle):ce}else if(ce&&ce.$mid===5){const J=this.h.get(ce.handle);return J||ce}return ce}})}createSourceControl(F,N,W,X){this.p.trace("ExtHostSCM#createSourceControl",F.identifier.value,N,W,X),this.g.$publicLog2("api/scm/createSourceControl",{extensionId:F.identifier.value});const ce=i.d++,J=new j(F,this.o,this.f,this.n,N,W,X);this.h.set(ce,J);const Q=this.j.get(F.identifier)||[];return Q.push(J),this.j.set(F.identifier,Q),J}registerSourceControlInputBoxValueProvider(F,N){this.p.trace("ExtHostSCM#registerSourceControlInputBoxValueProvider",F.identifier.value,N.label);const W=i.e++;return this.l.set(W,N),this.f.$registerSourceControlInputBoxValueProvider(W,N.label,d(N)),(0,R.$Pc)(()=>{this.f.$unregisterSourceControlInputBoxValueProvider(W),this.l.delete(W)})}async $provideInputBoxValue(F,N,W){const X=this.l.get(F);if(X)return await X.provideValue(N,W,I.CancellationToken.None)??void 0}getLastInputBox(F){this.p.trace("ExtHostSCM#getLastInputBox",F.identifier.value);const N=this.j.get(F.identifier),W=N&&N[N.length-1];return W&&W.inputBox}$provideOriginalResource(F,N,W){const X=C.URI.revive(N);this.p.trace("ExtHostSCM#$provideOriginalResource",F,X.toString());const ce=this.h.get(F);return!ce||!ce.quickDiffProvider||!ce.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,L.$Qg)(()=>ce.quickDiffProvider.provideOriginalResource(X,W)).then(J=>J||null)}$onInputBoxValueChange(F,N){this.p.trace("ExtHostSCM#$onInputBoxValueChange",F);const W=this.h.get(F);return W&&W.inputBox.$onInputBoxValueChange(N),Promise.resolve(void 0)}$executeResourceCommand(F,N,W,X){this.p.trace("ExtHostSCM#$executeResourceCommand",F,N,W);const ce=this.h.get(F);if(!ce)return Promise.resolve(void 0);const J=ce.getResourceGroup(N);return J?J.$executeResourceCommand(W,X):Promise.resolve(void 0)}$validateInput(F,N,W){this.p.trace("ExtHostSCM#$validateInput",F);const X=this.h.get(F);return!X||!X.inputBox.validateInput?Promise.resolve(void 0):(0,L.$Qg)(()=>X.inputBox.validateInput(N,W)).then(ce=>{if(!ce)return Promise.resolve(void 0);const J=S.MarkdownString.fromStrict(ce.message);return J?Promise.resolve([J,ce.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(F){return this.p.trace("ExtHostSCM#$setSelectedSourceControl",F),F!==void 0&&this.h.get(F)?.setSelectionState(!0),this.m!==void 0&&this.h.get(this.m)?.setSelectionState(!1),this.m=F,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(F,N,W){return await this.h.get(F)?.historyProvider?.resolveHistoryItemGroupBase(N,W)??void 0}async $resolveHistoryItemGroupCommonAncestor(F,N,W,X){return await this.h.get(F)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(N,W,X)??void 0}async $provideHistoryItems(F,N,W,X){return(await this.h.get(F)?.historyProvider?.provideHistoryItems(N,W,X))?.map(Q=>({...Q,icon:s(Q)}))??void 0}async $provideHistoryItemChanges(F,N,W){return await this.h.get(F)?.historyProvider?.provideHistoryItemChanges(N,W)??void 0}};e.$tfc=M,e.$tfc=M=i=He([Be(3,A.$dj)],M)}),define(ke[117],Se([1,0,6,4,5]),function(me,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aec=e.$zec=void 0;class R{constructor(b){this.b=new T.$Rd,this.onDidChangePassword=this.b.event,this.a=b.getProxy(C.$zK.MainThreadSecretState)}async $onDidChangePassword(b){this.b.fire(b)}get(b,y){return this.a.$getPassword(b,y)}store(b,y,g){return this.a.$setPassword(b,y,g)}delete(b,y){return this.a.$deletePassword(b,y)}}e.$zec=R,e.$Aec=(0,f.$Vh)("IExtHostSecretState")}),define(ke[336],Se([1,0,6,15,2]),function(me,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ufc=void 0;class R{static{this.a=0}constructor(b,y){this.d=y,this.c=new Map,this.b=b.getProxy(C.$zK.MainThreadShare)}async $provideShare(b,y,g){return await this.c.get(b)?.provideShare({selection:T.Range.to(y.selection),resourceUri:f.URI.revive(y.resourceUri)},g)??void 0}registerShareProvider(b,y){const g=R.a++;return this.c.set(g,y),this.b.$registerShareProvider(g,T.DocumentSelector.from(b,this.d),y.id,y.label,y.priority),{dispose:()=>{this.b.$unregisterShareProvider(g),this.c.delete(g)}}}}e.$ufc=R}),define(ke[337],Se([1,0,21,3,6]),function(me,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vfc=void 0;class R{static{this.a=1}constructor(b){this.c=new Map,this.d=new Map,this.b=b.getProxy(f.$zK.MainThreadSpeech)}async $createSpeechToTextSession(b,y){const g=this.c.get(b);if(!g)return;const A=new T.$Qc,I=new C.$2d;this.d.set(y,I);const $=A.add(g.provideSpeechToTextSession(I.token));A.add($.onDidChange(v=>{I.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(y,v)})),A.add(I.token.onCancellationRequested(()=>A.dispose()))}async $cancelSpeechToTextSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}registerProvider(b,y,g){const A=R.a++;return this.c.set(A,g),this.b.$registerProvider(A,y,{extension:b,displayName:b.value}),(0,T.$Pc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$vfc=R}),define(ke[338],Se([1,0,7,6,217,3,15,18]),function(me,e,C,T,f,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xfc=e.$wfc=void 0;class y{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new C.$wL("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new C.$wL("statusBarItem.warningForeground")]])}#e;#t;constructor($,v,S,w,l,o=C.StatusBarAlignment.Left,i){if(this.i=!1,this.k="",this.q=new R.$Qc,this.#e=$,this.#t=v,l&&w){this.c=(0,C.$_K)(w.identifier,l);const n=S.get(this.c);n&&(o=n.alignLeft?C.StatusBarAlignment.Left:C.StatusBarAlignment.Right,i=n.priority,this.j=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this.c=String(y.a++);this.e=w,this.f=l,this.g=o,this.h=this.u(i)}u($){if((0,b.$Gf)($))return $===Number.POSITIVE_INFINITY?Number.MAX_VALUE:$===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:$}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text($){this.k=$,this.v()}set name($){this.m=$,this.v()}set tooltip($){this.l=$,this.v()}set color($){this.n=$,this.v()}set backgroundColor($){$&&!y.b.has($.id)&&($=void 0),this.o=$,this.v()}set command($){this.r?.fromApi!==$&&(this.p&&this.q.add(this.p),this.p=new R.$Qc,typeof $=="string"?this.r={fromApi:$,internal:this.#t.toInternal({title:"",command:$},this.p)}:$?this.r={fromApi:$,internal:this.#t.toInternal($,this.p)}:this.r=void 0,this.v())}set accessibilityInformation($){this.t=$,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let $;this.e?this.f?$=`${this.e.identifier.value}.${this.f}`:$=this.e.identifier.value:$=this.f;let v;this.m?v=this.m:v=(0,f.localize)(0,null,this.e.displayName||this.e.name);let S=this.n;this.o&&(S=y.b.get(this.o.id));const w=L.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,$,this.e?.identifier.value,v,this.k,w,this.r?.internal,S,this.o,this.g===C.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$wfc=y;class g{constructor($){this.b=[],this.a=$.createStatusBarEntry(void 0,"status.extensionMessage",C.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,f.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage($){const v={message:$};return this.b.unshift(v),this.c(),new C.$BK(()=>{const S=this.b.indexOf(v);S>=0&&(this.b.splice(S,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor($,v){this.e=new Map,this.a=$.getProxy(T.$zK.MainThreadStatusBar),this.b=v,this.c=new g(this)}$acceptStaticEntries($){for(const v of $)this.e.set(v.entryId,v)}createStatusBarEntry($,v,S,w){return new y(this.a,this.b,this.e,$,v,S,w)}setStatusBarMessage($,v){const S=this.c.setMessage($);let w;return typeof v=="number"?w=setTimeout(()=>S.dispose(),v):typeof v<"u"&&v.then(()=>S.dispose(),()=>S.dispose()),new C.$BK(()=>{S.dispose(),clearTimeout(w)})}}e.$xfc=A}),define(ke[118],Se([1,0,6,4,5]),function(me,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sec=e.$rec=void 0;class R{constructor(b,y){this.c=y,this.b=new T.$Rd,this.onDidChangeStorage=this.b.event,this.a=b.getProxy(C.$zK.MainThreadStorage)}registerExtensionStorageKeysToSync(b,y){this.a.$registerExtensionStorageKeysToSync(b,y)}async initializeExtensionStorage(b,y,g){const A=await this.a.$initializeExtensionStorage(b,y);let I;return A&&(I=this.d(b,y,A)),I||g}setValue(b,y,g){return this.a.$setValue(b,y,g)}$acceptValue(b,y,g){const A=this.d(b,y,g);A&&this.b.fire({shared:b,key:y,value:A})}d(b,y,g){try{return JSON.parse(g)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${y}, global: ${b}): ${A}`)}}}e.$rec=R,e.$sec=(0,f.$Vh)("IExtHostStorage")}),define(ke[92],Se([1,0,5,27,14,71,2]),function(me,e,C,T,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bec=e.$aec=void 0,e.$aec=(0,C.$Vh)("IExtensionStoragePaths");let b=class{constructor(g,A,I){this.d=A,this.f=I,this.a=g.workspace??void 0,this.b=g.environment,this.whenReady=this.h().then($=>this.c=$)}async g(g){return L.URI.joinPath(this.b.workspaceStorageHome,g)}async h(){if(!this.a)return Promise.resolve(void 0);const g=this.a.id,A=await this.g(g);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(L.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:L.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(I){this.d.error("[ExtHostStorage]",I);return}}workspaceValue(g){if(this.c)return L.URI.joinPath(this.c,g.identifier.value)}globalValue(g){return L.URI.joinPath(this.b.globalStorageHome,g.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$bec=b,e.$bec=b=He([Be(0,T.$RM),Be(1,f.$dj),Be(2,R.$_dc)],b)}),define(ke[46],Se([1,0,4,6,5,2,20,3,7,219,8,263,21,32,264,61,12,15,35]),function(me,e,C,T,f,R,L,b,y,g,A,I,$,v,S,w,l,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yec=e.$xec=e.$wec=e.$vec=void 0,e.$vec=(0,f.$Vh)("IExtHostTerminalService");class n{constructor(m,p,k,P){this.l=m,this._id=p,this.m=k,this.n=P,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(j=>this.f=j);const z=this;this.value={get name(){return z.n||""},get processId(){return z.b},get creationOptions(){return z.m},get exitStatus(){return z.h},get state(){return z.j},get selection(){return z.k},sendText(j,M=!0){z.q(),z.l.$sendText(z._id,j,M)},show(j){z.q(),z.l.$show(z._id,j)},hide(){z.q(),z.l.$hide(z._id)},dispose(){z.a||(z.a=!0,z.l.$dispose(z._id))},get dimensions(){if(!(z.d===void 0||z.g===void 0))return{columns:z.d,rows:z.g}}}}async create(m,p){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:m.name,shellPath:m.shellPath??void 0,shellArgs:m.shellArgs??void 0,cwd:m.cwd??p?.cwd??void 0,env:m.env??void 0,icon:u(m.iconPath)??void 0,color:w.ThemeColor.isThemeColor(m.color)?m.color.id:void 0,initialText:m.message??void 0,strictEnv:m.strictEnv??void 0,hideFromUser:m.hideFromUser??void 0,isFeatureTerminal:p?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:p?.useShellEnvironment??void 0,location:p?.location||this.o(m.location,p?.resolvedExtHostIdentifier),isTransient:m.isTransient??void 0})}async createExtensionTerminal(m,p,k,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:k,color:w.ThemeColor.isThemeColor(P)?P.id:void 0,location:this.o(m,p),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(m,p){return typeof m=="object"?"parentTerminal"in m&&m.parentTerminal&&p?{parentTerminal:p}:"viewColumn"in m?{viewColumn:o.ViewColumn.from(m.viewColumn),preserveFocus:m.preserveFocus}:void 0:m}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(m){this.n=m}setExitStatus(m,p){this.h=Object.freeze({code:m,reason:p})}setDimensions(m,p){return m===this.d&&p===this.g||m===0||p===0?!1:(this.d=m,this.g=p,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(m){this.k=m}_setProcessId(m){this.f?(this.f(m),this.f=void 0):this.b.then(p=>{p!==m&&(this.b=Promise.resolve(m))})}}e.$wec=n;class r{get onProcessReady(){return this.b.event}constructor(m){this.g=m,this.id=0,this.shouldPersist=!1,this.a=new C.$Rd,this.onProcessData=this.a.event,this.b=new C.$Rd,this.d=new C.$Rd,this.onDidChangeProperty=this.d.event,this.f=new C.$Rd,this.onProcessExit=this.f.event}refreshProperty(m){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${m}`)}updateProperty(m,p){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${m}, value: ${p}`)}async start(){}shutdown(){this.g.close()}input(m){this.g.handleInput?.(m)}resize(m,p){this.g.setDimensions?.({columns:m,rows:p})}clearBuffer(){}async processBinary(m){}acknowledgeDataEvent(m){}async setUnicodeVersion(m){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(m){this.g.onDidWrite(p=>this.a.fire(p)),this.g.onDidClose?.((p=void 0)=>{this.f.fire(p===void 0?void 0:p)}),this.g.onDidOverrideDimensions?.(p=>{p&&this.d.fire({type:"overrideDimensions",value:{cols:p.columns,rows:p.rows}})}),this.g.onDidChangeName?.(p=>{this.d.fire({type:"title",value:p})}),this.g.open(m||void 0),m&&this.g.setDimensions?.(m),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let a=1,t=class extends b.$Rc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(m=>m.value)}constructor(m,p,k){super(),this.Q=p,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new b.$Sc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new C.$Rd,this.onDidCloseTerminal=this.H.event,this.I=new C.$Rd,this.onDidOpenTerminal=this.I.event,this.J=new C.$Rd,this.onDidChangeActiveTerminal=this.J.event,this.L=new C.$Rd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new C.$Rd,this.onDidChangeTerminalState=this.M.event,this.N=new C.$Rd,this.onDidChangeShell=this.N.event,this.O=new C.$Rd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new C.$Rd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=k.getProxy(T.$zK.MainThreadTerminalService),this.y=new S.$lqb(this.a.$sendProcessData),this.a.$registerProcessSupport(m),this.Q.registerArgumentProcessor({processArgument:P=>{const z=j=>{const M=j;return this.W(M.instanceId)?.value};switch(P?.$mid){case 15:return z(P);default:{if(Array.isArray(P))for(let j=0;j<P.length&&P[j].$mid===15;j++)P[j]=z(P[j]);return P}}}}),this.B({dispose:()=>{for(const[P,z]of this.g)z.shutdown(!0)}})}getDefaultShell(m){return(m?this.u:this.s)?.path||""}getDefaultShellArgs(m){return(m?this.u:this.s)?.args||[]}createExtensionTerminal(m,p){const k=new n(this.a,(0,v.$ig)(),m,m.name),P=new r(m.pty);return k.createExtensionTerminal(m.location,this.R(m,p).resolvedExtHostIdentifier,u(m.iconPath),h(m.color)).then(z=>{const j=this.S(z,P);this.h[z]=j}),this.f.push(k),k.value}R(m,p){if(p=p||{},m.location&&typeof m.location=="object"&&"parentTerminal"in m.location){const k=m.location.parentTerminal;if(k){const P=this.f.find(z=>z.value===k);P&&(p.resolvedExtHostIdentifier=P._id)}}else m.location&&typeof m.location!="object"?p.location=m.location:p.location&&typeof p.location=="object"&&"splitActiveTerminal"in p.location&&(p.location={splitActiveTerminal:!0});return p}attachPtyToTerminal(m,p){if(!this.W(m))throw new Error(`Cannot resolve terminal with id ${m} for virtual process`);const P=new r(p),z=this.S(m,P);this.h[m]=z}async $acceptActiveTerminalChanged(m){const p=this.b;if(m===null){this.b=void 0,p!==this.b&&this.J.fire(this.b);return}const k=this.W(m);k&&(this.b=k,p!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(m,p){const k=this.W(m);k&&this.O.fire({terminal:k.value,data:p})}async $acceptTerminalDimensions(m,p,k){const P=this.W(m);P&&P.setDimensions(p,k)&&this.L.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand(m,p){const k=this.W(m);k&&this.P.fire({terminal:k.value,...p})}async $acceptTerminalMaximumDimensions(m,p,k){this.g.get(m)?.resize(p,k)}async $acceptTerminalTitleChange(m,p){const k=this.W(m);k&&(k.name=p)}async $acceptTerminalClosed(m,p,k){const P=this.Y(this.f,m);if(P!==null){const z=this.f.splice(P,1)[0];z.setExitStatus(p,k),this.H.fire(z.value)}}$acceptTerminalOpened(m,p,k,P){if(p){const M=this.Y(this.f,p);if(M!==null){this.f[M]._id=m,this.I.fire(this.terminals[M]),this.f[M].isOpen=!0;return}}const z={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:R.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},j=new n(this.a,m,z,k);this.f.push(j),this.I.fire(j.value),j.isOpen=!0}async $acceptTerminalProcessId(m,p){this.W(m)?._setProcessId(p)}async $startExtensionTerminal(m,p){const k=this.W(m);if(!k)return{message:(0,g.localize)(0,null,m)};k.isOpen||await new Promise(z=>{const j=this.onDidOpenTerminal(async M=>{M===k.value&&(j.dispose(),z())})});const P=this.g.get(m);P?P.startSendingEvents(p):this.j[m]={initialDimensions:p}}S(m,p){const k=new b.$Qc;k.add(p.onProcessReady(z=>this.a.$sendProcessReady(m,z.pid,z.cwd,z.windowsPty))),k.add(p.onDidChangeProperty(z=>this.a.$sendProcessProperty(m,z))),this.y.startBuffering(m,p.onProcessData),k.add(p.onProcessExit(z=>this.U(m,z))),this.g.set(m,p);const P=this.j[m];return P&&p instanceof r&&(p.startSendingEvents(P.initialDimensions),delete this.j[m]),k}$acceptProcessAckDataEvent(m,p){this.g.get(m)?.acknowledgeDataEvent(p)}$acceptProcessInput(m,p){this.g.get(m)?.input(p)}$acceptTerminalInteraction(m){const p=this.W(m);p?.setInteractedWith()&&this.M.fire(p.value)}$acceptTerminalSelection(m,p){this.W(m)?.setSelection(p)}$acceptProcessResize(m,p,k){try{this.g.get(m)?.resize(p,k)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(m,p){this.g.get(m)?.shutdown(p)}$acceptProcessRequestInitialCwd(m){this.g.get(m)?.getInitialCwd().then(p=>this.a.$sendProcessProperty(m,{type:"initialCwd",value:p}))}$acceptProcessRequestCwd(m){this.g.get(m)?.getCwd().then(p=>this.a.$sendProcessProperty(m,{type:"cwd",value:p}))}$acceptProcessRequestLatency(m){return Promise.resolve(m)}registerLinkProvider(m){return this.z.add(m),this.z.size===1&&this.a.$startLinkProvider(),new y.$BK(()=>{this.z.delete(m),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(m,p,k){if(this.C.has(p))throw new Error(`Terminal profile provider "${p}" already registered`);return this.C.set(p,k),this.a.$registerProfileProvider(p,m.identifier.value),new y.$BK(()=>{this.C.delete(p),this.a.$unregisterProfileProvider(p)})}registerTerminalQuickFixProvider(m,p,k){if(this.D.has(m))throw new Error(`Terminal quick fix provider "${m}" is already registered`);return this.D.set(m,k),this.a.$registerQuickFixProvider(m,p),new y.$BK(()=>{this.D.delete(m),this.a.$unregisterQuickFixProvider(m)})}async $provideTerminalQuickFixes(m,p){const k=new $.$2d().token;if(k.isCancellationRequested)return;const P=this.D.get(m);if(!P)return;const z=await P.provideTerminalQuickFixes(p,k);if(z===null||Array.isArray(z)&&z.length===0)return;const j=new b.$Qc;if(this.w.value=j,!Array.isArray(z))return z?o.TerminalQuickFix.from(z,this.Q.converter,j):void 0;const M=[];for(const O of z){const F=o.TerminalQuickFix.from(O,this.Q.converter,j);F&&M.push(F)}return M}async $createContributedProfileTerminal(m,p){const k=new $.$2d().token;let P=await this.C.get(m)?.provideTerminalProfile(k);if(!k.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${m}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,p);return}this.createTerminalFromOptions(P.options,p)}}async $provideLinks(m,p){const k=this.W(m);if(!k)return[];this.F.delete(m),this.G.get(m)?.dispose(!0);const z=new $.$2d;this.G.set(m,z);const j=[],M={terminal:k.value,line:p},O=[];for(const W of this.z)O.push(l.Promises.withAsyncBody(async X=>{z.token.onCancellationRequested(()=>X({provider:W,links:[]}));const ce=await W.provideTerminalLinks(M,z.token)||[];z.token.isCancellationRequested||X({provider:W,links:ce})}));const F=await Promise.all(O);if(z.token.isCancellationRequested)return[];const N=new Map;for(const W of F)W&&W.links.length>0&&j.push(...W.links.map(X=>{const ce={id:a++,startIndex:X.startIndex,length:X.length,label:X.tooltip};return N.set(ce.id,{provider:W.provider,link:X}),ce}));return this.F.set(m,N),j}$activateLink(m,p){const k=this.F.get(m)?.get(p);k&&k.provider.handleTerminalLink(k.link)}U(m,p){this.y.stopBuffering(m),this.g.delete(m),delete this.j[m];const k=this.h[m];k&&(k.dispose(),delete this.h[m]),this.a.$sendProcessExit(m,p)}W(m){return this.X(this.f,m)}X(m,p){const k=this.Y(m,p);return k!==null?m[k]:null}Y(m,p){const k=m.findIndex(P=>P._id===p);return k===-1?null:k}getEnvironmentVariableCollection(m){let p=this.n.get(m.identifier.value);return p||(p=new s,this.$(m.identifier.value,p)),p.getScopedEnvironmentVariableCollection(void 0)}Z(m,p){const k=(0,I.$qr)(p.map),P=(0,I.$rr)(p.descriptionMap);this.a.$setEnvironmentVariableCollection(m,p.persistent,k.length===0?void 0:k,P)}$initEnvironmentVariableCollections(m){m.forEach(p=>{const k=p[0],P=new s(p[1]);this.$(k,P)})}$acceptDefaultProfile(m,p){const k=this.s;this.s=m,this.u=p,k?.path!==m.path&&this.N.fire(m.path)}$(m,p){this.n.set(m,p),p.onDidChangeCollection(()=>{this.Z(m,p)})}};e.$xec=t,e.$xec=t=He([Be(1,i.$XM),Be(2,L.$BM)],t);class s{get persistent(){return this.b}set persistent(m){this.b=m,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(m){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new C.$Rd,this.map=new Map(m)}getScopedEnvironmentVariableCollection(m){const p=this.h(m);let k=this.a.get(p);return k||(k=new d(this,m),this.a.set(p,k),k.onDidChangeCollection(()=>this.d.fire())),k}replace(m,p,k,P){this.f(m,{value:p,type:y.EnvironmentVariableMutatorType.Replace,options:k??{applyAtProcessCreation:!0},scope:P})}append(m,p,k,P){this.f(m,{value:p,type:y.EnvironmentVariableMutatorType.Append,options:k??{applyAtProcessCreation:!0},scope:P})}prepend(m,p,k,P){this.f(m,{value:p,type:y.EnvironmentVariableMutatorType.Prepend,options:k??{applyAtProcessCreation:!0},scope:P})}f(m,p){if(p.options&&p.options.applyAtProcessCreation===!1&&!p.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const k=this.g(m,p.scope),P=this.map.get(k),z=p.options?{applyAtProcessCreation:p.options.applyAtProcessCreation??!1,applyAtShellIntegration:p.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==p.value||P.type!==p.type||P.options?.applyAtProcessCreation!==z.applyAtProcessCreation||P.options?.applyAtShellIntegration!==z.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==p.scope?.workspaceFolder?.index){const j=this.g(m,p.scope),M={variable:m,...p,options:z};this.map.set(j,M),this.d.fire()}}get(m,p){const k=this.g(m,p),P=this.map.get(k);return P?E(P):void 0}g(m,p){const k=this.h(p);return k.length?`${m}:::${k}`:m}h(m){return this.j(m?.workspaceFolder)??""}j(m){return m?m.uri.toString():void 0}getVariableMap(m){const p=new Map;for(const[k,P]of this.map)this.h(P.scope)===this.h(m)&&p.set(P.variable,E(P));return p}delete(m,p){const k=this.g(m,p);this.map.delete(k),this.d.fire()}clear(m){if(m?.workspaceFolder){for(const[p,k]of this.map)k.scope?.workspaceFolder?.index===m.workspaceFolder.index&&this.map.delete(p);this.k(m)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(m,p){const k=this.h(p),P=this.descriptionMap.get(k);if(!P||P.description!==m){let z;typeof m=="string"?z=m:z=m?.value.split(`

`)[0];const j={description:z,scope:p};this.descriptionMap.set(k,j),this.d.fire()}}getDescription(m){const p=this.h(m);return this.descriptionMap.get(p)?.description}k(m){const p=this.h(m);this.descriptionMap.delete(p)}}class d{get persistent(){return this.b.persistent}set persistent(m){this.b.persistent=m}get onDidChangeCollection(){return this.a&&this.a.event}constructor(m,p){this.b=m,this.d=p,this.a=new C.$Rd}getScoped(m){return this.b.getScopedEnvironmentVariableCollection(m)}replace(m,p,k){this.b.replace(m,p,k,this.d)}append(m,p,k){this.b.append(m,p,k,this.d)}prepend(m,p,k){this.b.prepend(m,p,k,this.d)}get(m){return this.b.get(m,this.d)}forEach(m,p){this.b.getVariableMap(this.d).forEach((k,P)=>m.call(p,P,k,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(m){this.b.delete(m,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(m){this.b.setDescription(m,this.d)}get description(){return this.b.getDescription(this.d)}}let c=class extends t{constructor(m,p){super(!1,m,p)}createTerminal(m,p,k){throw new A.$$}createTerminalFromOptions(m,p){throw new A.$$}};e.$yec=c,e.$yec=c=He([Be(0,i.$XM),Be(1,L.$BM)],c);function u(D){if(!(!D||typeof D=="string"))return"id"in D?{id:D.id,color:D.color}:D}function h(D){return w.ThemeColor.isThemeColor(D)?D:void 0}function E(D){const m={...D};return delete m.scope,m.options=m.options??void 0,delete m.variable,m}}),define(ke[339],Se([1,0,121,12,22,21,4,74,52,3,24,18,32,6,20,149,15,7,67,112,89,25]),function(me,e,C,T,f,R,L,b,y,g,A,I,$,v,S,w,l,o,i,n,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Efc=e.$Dfc=e.$Cfc=e.$Bfc=void 0;let t=class extends g.$Rc{constructor(M,O,F){super(),this.u=F,this.f=this.B(new L.$Rd),this.g=new Map,this.s=this.B(new L.$Rd),this.onResultsChanged=this.f.event,this.results=[],this.h=M.getProxy(v.$zK.MainThreadTesting),this.m=new k(this.h),this.j=new u(this.h),O.registerArgumentProcessor({processArgument:N=>{switch(N?.$mid){case 16:{const W=N,X=W.tests[W.tests.length-1].item.extId;return this.g.get(i.$sJ.root(X))?.collection.tree.get(X)?.actual??(0,w.$NM)(N)}case 18:{const{extId:W,message:X}=N;return{test:this.g.get(i.$sJ.root(W))?.collection.tree.get(W)?.actual,message:l.TestMessage.to(X)}}default:return N}}}),O.registerCommand(!1,"testing.getExplorerSelection",async()=>{const N=await O.executeCommand("_testing.getExplorerSelection"),W=X=>{const ce=this.g.get(i.$sJ.root(X));if(ce)return i.$sJ.isRoot(X)?ce.controller:ce.collection.tree.get(X)?.actual};return{include:N?.include.map(W).filter(I.$Kf)||[],exclude:N?.exclude.map(W).filter(I.$Kf)||[]}})}createTestController(M,O,F,N){if(this.g.has(O))throw new Error(`Attempt to insert a duplicate controller with ID "${O}"`);const W=new g.$Qc,X=W.add(new w.$QM(O,F,this.u));X.root.label=F;const ce=new Map,J=new Set,Q=this.h,G={items:X.root.children,get label(){return F},set label(_){F=_,X.root.label=_,Q.$updateController(O,{label:F})},get refreshHandler(){return N},set refreshHandler(_){N=_,Q.$updateController(O,{canRefresh:!!_})},get id(){return O},createRunProfile:(_,Ee,he,q,U,ne)=>{let be=(0,y.$Ji)(_);for(;ce.has(be);)be++;return new P(this.h,ce,M,J,this.s.event,O,be,_,Ee,he,q,U,ne)},createTestItem(_,Ee,he){return new w.$OM(O,_,Ee,he)},createTestRun:(_,Ee,he=!0)=>this.j.createTestRun(M,O,X,_,Ee,he),invalidateTestResults:_=>{if(_===void 0)this.h.$markTestRetired(void 0);else{const Ee=_ instanceof Array?_:[_];this.h.$markTestRetired(Ee.map(he=>i.$sJ.fromExtHostTestItem(he,O).toString()))}},set resolveHandler(_){X.resolveHandler=_},get resolveHandler(){return X.resolveHandler},dispose:()=>{W.dispose()}};Q.$registerTestController(O,F,!!N),W.add((0,g.$Pc)(()=>Q.$unregisterTestController(O)));const oe={controller:G,collection:X,profiles:ce,extension:M,activeProfiles:J};return this.g.set(O,oe),W.add((0,g.$Pc)(()=>this.g.delete(O))),W.add(X.onDidGenerateDiff(_=>Q.$publishDiff(O,_.map(r.TestsDiffOp.serialize)))),G}createTestObserver(){return this.m.checkout()}async runTests(M,O=R.CancellationToken.None){const F=h(M);if(!F)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const N=this.g.get(F.controllerId);if(!N)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:M.include?.map(W=>i.$sJ.fromExtHostTestItem(W,N.collection.root.id).toString())??[N.collection.root.id],profileGroup:z[F.kind],profileId:F.profileId,controllerId:F.controllerId}],exclude:M.exclude?.map(W=>W.id)},O)}$syncTests(){for(const{collection:M}of this.g.values())M.flushDiff();return Promise.resolve()}$provideFileCoverage(M,O,F){return(0,C.$qb)(this.j.trackers,W=>W.id===M?W.getCoverage(O):void 0)?.provideFileCoverage(F)??Promise.resolve([])}$resolveFileCoverage(M,O,F,N){return(0,C.$qb)(this.j.trackers,X=>X.id===M?X.getCoverage(O):void 0)?.resolveFileCoverage(F,N)??Promise.resolve([])}$configureRunProfile(M,O){this.g.get(M)?.profiles.get(O)?.configureHandler?.()}$setActiveRunProfiles(M){const O=new Map;for(const[F,N]of Object.entries(M)){const W=this.g.get(F);if(!W)continue;const X=new Map,ce=N.filter(Q=>!W.activeProfiles.has(Q)),J=[...W.activeProfiles].filter(Q=>!N.includes(Q));for(const Q of ce)X.set(Q,!0),W.activeProfiles.add(Q);for(const Q of J)X.set(Q,!1),W.activeProfiles.delete(Q);X.size&&O.set(F,X)}this.s.fire(O)}async $refreshTests(M,O){await this.g.get(M)?.controller.refreshHandler?.(O)}$publishTestResults(M){this.results=Object.freeze(M.map(O=>(0,A.$bn)(l.TestResults.to(O))).concat(this.results).sort((O,F)=>F.completedAt-O.completedAt).slice(0,32)),this.f.fire()}async $expandTest(M,O){const F=this.g.get(i.$sJ.fromString(M).controllerId)?.collection;F&&(await F.expand(M,O<0?1/0:O),F.flushDiff())}$acceptDiff(M){this.m.applyDiff(M.map(r.TestsDiffOp.deserialize))}async $runControllerTests(M,O){return Promise.all(M.map(F=>this.w(F,!1,O)))}async $startContinuousRun(M,O){const F=new R.$2d(O),N=await Promise.all(M.map(W=>this.w(W,!0,F.token)));return!O.isCancellationRequested&&!N.some(W=>W.error)&&await new Promise(W=>O.onCancellationRequested(W)),F.dispose(!0),N}async w(M,O,F){const N=this.g.get(M.controllerId);if(!N)return{};const{collection:W,profiles:X,extension:ce}=N,J=X.get(M.profileId);if(!J)return{};const Q=M.testIds.map(Ee=>W.tree.get(Ee)).filter(I.$Kf),G=M.excludeExtIds.map(Ee=>N.collection.tree.get(Ee)).filter(I.$Kf).filter(Ee=>Q.some(he=>he.fullId.compare(Ee.fullId)===2));if(!Q.length)return{};const oe=new o.$0L(Q.some(Ee=>Ee.actual instanceof w.$PM)?void 0:Q.map(Ee=>Ee.actual),G.map(Ee=>Ee.actual),J,O),_=(0,r.$uJ)(M)&&this.j.prepareForMainThreadTestRun(oe,E.fromInternal(M,N.collection),ce,F);try{return await J.runHandler(oe,F),{}}catch(Ee){return{error:String(Ee)}}finally{_&&(_.hasRunningTasks&&!F.isCancellationRequested&&await L.Event.toPromise(_.onEnd),_.dispose())}}$cancelExtensionTestRun(M){M===void 0?this.j.cancelAllRuns():this.j.cancelRunById(M)}};e.$Bfc=t,e.$Bfc=t=He([Be(0,S.$BM)],t);const s=1e4;var d;(function(j){j[j.Running=0]="Running",j[j.Cancelling=1]="Cancelling",j[j.Ended=2]="Ended"})(d||(d={}));class c extends g.$Rc{get hasRunningTasks(){return this.f.size>0}get id(){return this.m.id}constructor(M,O,F){super(),this.m=M,this.s=O,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new L.$Rd),this.onEnd=this.j.event,this.h=this.B(new R.$2d(F));const N=this.B(new T.$0g(()=>this.u(),s));this.B(this.h.token.onCancellationRequested(()=>N.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.u()}getCoverage(M){return this.f.get(M)?.coverage}createRun(M){const O=this.m.id,F=this.m.controllerId,N=(0,$.$ig)(),W=new D(this.s,O,N),X=G=>(oe,..._)=>{if(J){console.warn(`Setting the state of test "${oe.id}" is a no-op after the run ends.`);return}this.m.isIncluded(oe)&&(this.y(oe),G(oe,..._))},ce=(G,oe)=>{const _=oe instanceof Array?oe.map(l.TestMessage.from):[l.TestMessage.from(oe)];if(G.uri&&G.range){const Ee={range:l.Range.from(G.range),uri:G.uri};for(const he of _)he.location=he.location||Ee}this.s.$appendTestMessagesInRun(O,N,i.$sJ.fromExtHostTestItem(G,F).toString(),_)};let J=!1;const Q={isPersisted:this.m.isPersisted,token:this.h.token,name:M,get coverageProvider(){return W.coverageProvider},set coverageProvider(G){W.coverageProvider=G},enqueued:X(G=>{this.s.$updateTestStateInRun(O,N,i.$sJ.fromExtHostTestItem(G,F).toString(),1)}),skipped:X(G=>{this.s.$updateTestStateInRun(O,N,i.$sJ.fromExtHostTestItem(G,F).toString(),5)}),started:X(G=>{this.s.$updateTestStateInRun(O,N,i.$sJ.fromExtHostTestItem(G,F).toString(),2)}),errored:X((G,oe,_)=>{ce(G,oe),this.s.$updateTestStateInRun(O,N,i.$sJ.fromExtHostTestItem(G,F).toString(),6,_)}),failed:X((G,oe,_)=>{ce(G,oe),this.s.$updateTestStateInRun(O,N,i.$sJ.fromExtHostTestItem(G,F).toString(),4,_)}),passed:X((G,oe)=>{this.s.$updateTestStateInRun(O,N,i.$sJ.fromExtHostTestItem(G,this.m.controllerId).toString(),3,oe)}),appendOutput:(G,oe,_)=>{J||(_&&(this.m.isIncluded(_)?this.y(_):_=void 0),this.s.$appendOutputToRun(O,N,f.$fe.fromString(G),oe&&l.location.from(oe),_&&i.$sJ.fromExtHostTestItem(_,F).toString()))},end:()=>{J||(J=!0,this.s.$finishedTestRunTask(O,N),this.f.delete(N),this.f.size||this.w())}};return this.f.set(N,{run:Q,coverage:W}),this.s.$startedTestRunTask(O,{id:N,name:M,running:!0}),Q}u(){for(const{run:M}of this.f.values())M.end()}w(){this.c!==2&&(this.c=2,this.j.fire())}y(M){if(!(M instanceof w.$OM))throw new n.$tM(M.id);if(this.g.has(i.$sJ.fromExtHostTestItem(M,this.m.controllerId).toString()))return;const O=[],F=this.m.colllection.root;for(;;){const N=l.TestItem.from(M);if(O.unshift(N),this.g.has(N.extId)||(this.g.add(N.extId),M===F))break;M=M.parent||F}this.s.$addTestsToRun(this.m.controllerId,this.m.id,O)}dispose(){this.w(),super.dispose()}}class u{get trackers(){return this.c.values()}constructor(M){this.d=M,this.c=new Map}prepareForMainThreadTestRun(M,O,F,N){return this.f(M,O,F,N)}cancelRunById(M){for(const O of this.c.values())if(O.id===M){O.cancel();return}}cancelAllRuns(){for(const M of this.c.values())M.cancel()}createTestRun(M,O,F,N,W,X){const ce=this.c.get(N);if(ce)return ce.createRun(W);const J=E.fromPublic(O,F,N,X),Q=h(N);this.d.$startedExtensionTestRun({controllerId:O,continuous:!!N.continuous,profile:Q&&{group:z[Q.kind],id:Q.profileId},exclude:N.exclude?.map(oe=>i.$sJ.fromExtHostTestItem(oe,F.root.id).toString())??[],id:J.id,include:N.include?.map(oe=>i.$sJ.fromExtHostTestItem(oe,F.root.id).toString())??[F.root.id],persist:X});const G=this.f(N,J,M);return L.Event.once(G.onEnd)(()=>{this.d.$finishedExtensionTestRun(J.id),G.dispose()}),G.createRun(W)}f(M,O,F,N){const W=new c(O,this.d,N);return this.c.set(M,W),L.Event.once(W.onEnd)(()=>this.c.delete(M)),W}}e.$Cfc=u;const h=j=>{if(j.profile){if(!(j.profile instanceof P))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return j.profile}};class E{static fromPublic(M,O,F,N){return new E(M,(0,$.$ig)(),F.include?.map(W=>i.$sJ.fromExtHostTestItem(W,M).toString())??[M],F.exclude?.map(W=>i.$sJ.fromExtHostTestItem(W,M).toString())??[],N,O)}static fromInternal(M,O){return new E(M.controllerId,M.runId,M.testIds,M.excludeExtIds,!0,O)}constructor(M,O,F,N,W,X){this.controllerId=M,this.id=O,this.isPersisted=W,this.colllection=X,this.c=F.map(ce=>ce+"\0"),this.d=N.map(ce=>ce+"\0")}isIncluded(M){const O=i.$sJ.fromExtHostTestItem(M,this.controllerId).toString()+"\0";for(const F of this.d)if(O===F||O.startsWith(F))return!1;for(const F of this.c)if(O===F||O.startsWith(F))return!0;return!1}}e.$Dfc=E;class D{set coverageProvider(M){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");M&&(this.c=M,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(M,O,F){this.f=M,this.g=O,this.h=F}async provideFileCoverage(M){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(M))());try{return(await this.d)?.map(l.TestCoverage.fromFile)??[]}catch(O){throw this.d=void 0,O}}async resolveFileCoverage(M,O){const F=await this.d;let N=F?.[M];return!this.c||!F||!N?[]:(N.detailedCoverage||(N=F[M]=await this.c.resolveFileCoverage?.(N,O)??N),N.detailedCoverage?.map(l.TestCoverage.fromDetailed)??[])}}class m{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(M){this.h=M,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(M){this.c.add(M)}update(M){Object.assign(M.revived,l.TestItem.toPlain(M.item)),this.c.has(M)||this.d.add(M)}remove(M){if(this.c.has(M)){this.c.delete(M);return}this.d.delete(M);const O=i.$sJ.parentId(M.item.extId);if(O&&this.g.has(O.toString())){this.g.add(M.item.extId);return}this.f.add(M)}getChangeEvent(){const{c:M,d:O,f:F}=this;return{get added(){return[...M].map(N=>N.revived)},get updated(){return[...O].map(N=>N.revived)},get removed(){return[...F].map(N=>N.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class p extends r.$zJ{constructor(){super(...arguments),this.q=new L.$Rd,this.onDidChangeTests=this.q.event}get rootTests(){return this.f}getMirroredTestDataById(M){return this.d.get(M)}getMirroredTestDataByReference(M){return this.d.get(M.id)}p(M,O){return{...M,revived:l.TestItem.toPlain(M.item),depth:O?O.depth+1:0,children:new Set}}o(){return new m(this.q)}}class k{constructor(M){this.d=M}checkout(){this.c||(this.c=this.f());const M=this.c;return M.observers++,{onDidChangeTest:M.tests.onDidChangeTests,get tests(){return[...M.tests.rootTests].map(O=>O.revived)},dispose:(0,b.$cb)(()=>{--M.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(M){return this.c?.tests.getMirroredTestDataByReference(M)}applyDiff(M){this.c?.tests.apply(M)}f(){const M=new p;return this.d.$subscribeToDiffs(),{observers:0,tests:M}}}class P{#e;#t;#i;#o;#r;get label(){return this.d}set label(M){M!==this.d&&(this.d=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:M}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(M){M!==this.g&&(this.g=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:M}))}get isDefault(){return this.f}set isDefault(M){M!==this.f&&(this.f=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:M}))}get tag(){return this._tag}set tag(M){M?.id!==this._tag?.id&&(this._tag=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:M?l.TestTag.namespace(this.controllerId,M.id):null}))}get configureHandler(){return this.c}set configureHandler(M){M!==this.c&&(this.c=M,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!M}))}get isSelected(){return(0,a.$NF)(this.#t,"testingActiveProfile"),this.#i.has(this.profileId)}get onDidChangeSelected(){return(0,a.$NF)(this.#t,"testingActiveProfile"),L.Event.chain(this.#o,M=>M.map(O=>O.get(this.controllerId)?.get(this.profileId)).filter(I.$Kf))}constructor(M,O,F,N,W,X,ce,J,Q,G,oe=!1,_=void 0,Ee=!1){this.controllerId=X,this.profileId=ce,this.d=J,this.kind=Q,this.runHandler=G,this.f=oe,this._tag=_,this.g=Ee,this.#e=M,this.#r=O,this.#t=F,this.#i=N,this.#o=W,O.set(ce,this);const he=z[Q];if(typeof he!="number")throw new Error(`Unknown TestRunProfile.group ${Q}`);this.#e.$publishTestRunProfile({profileId:ce,controllerId:X,tag:_?l.TestTag.namespace(this.controllerId,_.id):null,label:J,group:he,isDefault:oe,hasConfigurationHandler:!1,supportsContinuousRun:Ee})}dispose(){this.#r?.delete(this.profileId)&&(this.#r=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$Efc=P;const z={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(ke[340],Se([1,0,19,8,4,6,150,15,7]),function(me,e,C,T,f,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1dc=void 0;class g{constructor(I,$){this.i=$,this.a=new f.$Rd({onListenerError:T.$1}),this.b=new f.$Rd({onListenerError:T.$1}),this.c=new f.$Rd({onListenerError:T.$1}),this.d=new f.$Rd({onListenerError:T.$1}),this.f=new f.$Rd({onListenerError:T.$1}),this.g=new f.$Rd({onListenerError:T.$1}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=I.getProxy(R.$zK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(v=>this.g.fire(v)),this.i.onDidChangeActiveTextEditor(v=>this.f.fire(v))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(I){const $=this.i.allEditors();return I?$:$.map(v=>v.value)}async showTextDocument(I,$,v){let S;typeof $=="number"?S={position:b.ViewColumn.from($),preserveFocus:v}:typeof $=="object"?S={position:b.ViewColumn.from($.viewColumn),preserveFocus:$.preserveFocus,selection:typeof $.selection=="object"?b.Range.from($.selection):void 0,pinned:typeof $.preview=="boolean"?!$.preview:void 0}:S={preserveFocus:!1};const w=await this.h.$tryShowTextDocument(I.uri,S),l=w&&this.i.getEditor(w);if(l)return l.value;throw w?new Error(`Could NOT open editor for "${I.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${I.uri.toString()}".`)}createTextEditorDecorationType(I,$){return new L.$IM(this.h,I,$).value}$acceptEditorPropertiesChanged(I,$){const v=this.i.getEditor(I);if(!v)throw new Error("unknown text editor");if($.options&&v._acceptOptions($.options),$.selections){const S=$.selections.selections.map(b.Selection.to);v._acceptSelections(S)}if($.visibleRanges){const S=C.$Gb($.visibleRanges.map(b.Range.to));v._acceptVisibleRanges(S)}if($.options&&this.b.fire({textEditor:v.value,options:{...$.options,lineNumbers:b.TextEditorLineNumbersStyle.to($.options.lineNumbers)}}),$.selections){const S=y.TextEditorSelectionChangeKind.fromValue($.selections.source),w=$.selections.selections.map(b.Selection.to);this.a.fire({textEditor:v.value,selections:w,kind:S})}if($.visibleRanges){const S=C.$Gb($.visibleRanges.map(b.Range.to));this.c.fire({textEditor:v.value,visibleRanges:S})}}$acceptEditorPositionData(I){for(const $ in I){const v=this.i.getEditor($);if(!v)throw new Error("Unknown text editor");const S=b.ViewColumn.to(I[$]);v.value.viewColumn!==S&&(v._acceptViewColumn(S),this.d.fire({textEditor:v.value,viewColumn:S}))}}getDiffInformation(I){return Promise.resolve(this.h.$getDiffInformation(I))}}e.$1dc=g}),define(ke[341],Se([1,0,2,5,6,3,7,15,26,18]),function(me,e,C,T,f,R,L,b,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hfc=e.$Gfc=void 0,e.$Gfc=(0,T.$Vh)("IExtHostTimeline");class A{constructor(v,S){this.b=new Map,this.c=new Map,this.a=v.getProxy(f.$zK.MainThreadTimeline),S.registerArgumentProcessor({processArgument:(w,l)=>{if(w&&w.$mid===12)if(this.b.get(w.source)&&y.$_l.equals(l,this.b.get(w.source)?.extension)){const o=w.uri===void 0?void 0:C.URI.revive(w.uri);return this.c.get(w.source)?.get(I(o))?.get(w.handle)}else return;return w}})}async $getTimeline(v,S,w,l){return this.b.get(v)?.provider.provideTimeline(C.URI.revive(S),w,l)}registerTimelineProvider(v,S,w,l){const o=new R.$Qc,i=this.d(S.id,l,o).bind(this);let n;S.onDidChange&&(n=S.onDidChange(a=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...a,id:S.id}),this));const r=this.c;return this.f({...S,scheme:v,onDidChange:void 0,async provideTimeline(a,t,s){t?.resetCache&&(o.clear(),r.get(S.id)?.clear());const d=await S.provideTimeline(a,t,s);if(d==null)return;const c=i(a,t);return{...d,source:S.id,items:d.items.map(c)}},dispose(){for(const a of r.values())a.get(S.id)?.clear();n?.dispose(),o.dispose()}},w)}d(v,S,w){return(l,o)=>{let i;if(o?.cacheResults){let n=this.c.get(v);n===void 0&&(n=new Map,this.c.set(v,n));const r=I(l);i=n.get(r),i===void 0&&(i=new Map,n.set(r,i))}return n=>{const{iconPath:r,...a}=n,t=`${v}|${n.id??n.timestamp}`;i?.set(t,n);let s,d,c;n.iconPath&&(r instanceof L.$vL?c={id:r.id,color:r.color}:C.URI.isUri(r)?(s=r,d=r):{light:s,dark:d}=r);let u;return L.$2K.isMarkdownString(a.tooltip)?u=b.MarkdownString.from(a.tooltip):(0,g.$Cf)(a.tooltip)?u=a.tooltip:L.$2K.isMarkdownString(a.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),u=b.MarkdownString.from(a.detail)):(0,g.$Cf)(a.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),u=a.detail),{...a,id:a.id??void 0,handle:t,source:v,command:n.command?S.toInternal(n.command,w):void 0,icon:s,iconDark:d,themeIcon:c,tooltip:u,accessibilityInformation:n.accessibilityInformation}}}}f(v,S){if(this.b.get(v.id))throw new Error(`Timeline Provider ${v.id} already exists.`);return this.a.$registerTimelineProvider({id:v.id,label:v.label,scheme:v.scheme}),this.b.set(v.id,{provider:v,extension:S}),(0,R.$Pc)(()=>{for(const l of this.c.values())l.get(v.id)?.clear();this.b.delete(v.id),this.a.$unregisterTimelineProvider(v.id),v.dispose()})}}e.$Hfc=A;function I($){return $?.toString()}}),define(ke[72],Se([1,0,21,4,3,221,5,14,88,6,27,20,7]),function(me,e,C,T,f,R,L,b,y,g,A,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qwb=e.$Pwb=e.TunnelDtoConverter=void 0;class v extends y.$mv{}var S;(function(l){function o(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?y.TunnelPrivacyId.Public:y.TunnelPrivacyId.Private),protocol:n.protocol}}l.fromApiTunnel=o;function i(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==y.TunnelPrivacyId.ConstantPrivate&&n.privacy!==y.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}l.fromServiceTunnel=i})(S||(e.TunnelDtoConverter=S={})),e.$Pwb=(0,L.$Vh)("IExtHostTunnelService");let w=class extends f.$Rc{constructor(o,i,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new T.$Rd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=o.getProxy(g.$zK.MainThreadTunnelService)}async openTunnel(o,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const n=await this.a.$openTunnel(i,o.displayName);if(n){const r=new v(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(r),r}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(o,i){const n=this.u();return this.r.set(n,{selector:o,provider:i}),this.a.$registerPortsAttributesProvider(o,n),new $.$BK(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(o,i,n,r,a){const t=[];for(const d of o){const c=this.r.get(d);if(!c)return[];t.push(...await Promise.all(i.map(async u=>{let h;try{h=await c.provider.providePortAttributes({port:u,pid:n,commandLine:r},a)}catch{h=await c.provider.providePortAttributes(u,n,r,a)}return{providedAttributes:h,port:u}})))}const s=t.filter(d=>!!d.providedAttributes);return s.length>0?s.map(d=>({autoForwardAction:d.providedAttributes.autoForwardAction,port:d.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(r,a)=>await o.provideTunnel(r,a,new C.$2d().token)??void 0;const n=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,f.$Pc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,i){if(o){o.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this.f=o.showCandidatePort,this.a.$setCandidateFilter());const n=o.tunnelFactory??(i?this.w(i):void 0);if(n){this.b=n;let r=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&r.length===0&&(r=[{id:"private",label:R.localize(0,null),themeIcon:"lock"},{id:"public",label:R.localize(1,null),themeIcon:"eye"}]);const a=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:r}:void 0;this.a.$setTunnelProvider(a)}}else this.b=void 0;return(0,f.$Pc)(()=>{this.b=void 0})}w(o){}async $closeTunnel(o,i){if(this.g.has(o.host)){const n=this.g.get(o.host);n.has(o.port)&&(i&&n.get(o.port).disposeListener.dispose(),await n.get(o.port).tunnel.dispose(),n.delete(o.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(o,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(o,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const r=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),r===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(o.remoteAddress.host)||this.g.set(o.remoteAddress.host,new Map);const a=this.B(r.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(r.remoteAddress))));return this.g.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:r,disposeListener:a}),S.fromApiTunnel(r)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(o){const i=await Promise.all(o.map(r=>this.f(r.host,r.port,r.detail??""))),n=o.filter((r,a)=>i[a]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(r=>r.port).join(", ")} to ${n.map(r=>r.port).join(", ")}`),n}};e.$Qwb=w,e.$Qwb=w=He([Be(0,I.$BM),Be(1,A.$RM),Be(2,b.$dj)],w)}),define(ke[342],Se([1,0,3,17,2,6]),function(me,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jfc=void 0;class L{static{this.a=new Set([T.Schemas.http,T.Schemas.https])}constructor(y){this.c=new Map,this.b=y.getProxy(R.$zK.MainThreadUriOpeners)}registerExternalUriOpener(y,g,A,I){if(this.c.has(g))throw new Error(`Opener with id '${g}' already registered`);const $=I.schemes.find(v=>!L.a.has(v));if($)throw new Error(`Scheme '${$}' is not supported. Only http and https are currently supported.`);return this.c.set(g,A),this.b.$registerUriOpener(g,I.schemes,y,I.label),(0,C.$Pc)(()=>{this.c.delete(g),this.b.$unregisterUriOpener(g)})}async $canOpenUri(y,g,A){const I=this.c.get(y);if(!I)throw new Error(`Unknown opener with id: ${y}`);const $=f.URI.revive(g);return I.canOpenExternalUri($,A)}async $openUri(y,g,A){const I=this.c.get(y);if(!I)throw new Error(`Unknown opener id: '${y}'`);return I.openExternalUri(f.URI.revive(g.resolvedUri),{sourceUri:f.URI.revive(g.sourceUri)},A)}}e.$Jfc=L}),define(ke[343],Se([1,0,6,2,3,8,26]),function(me,e,C,T,f,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kfc=void 0;class b{static{this.a=0}constructor(g){this.c=new L.$am,this.d=new Map,this.b=g.getProxy(C.$zK.MainThreadUrls)}registerUriHandler(g,A){const I=g.identifier;if(this.c.has(I))throw new Error(`Protocol handler already registered for extension ${I}`);const $=b.a++;return this.c.add(I),this.d.set($,A),this.b.$registerUriHandler($,I,g.displayName||g.name),(0,f.$Pc)(()=>{this.c.delete(I),this.d.delete($),this.b.$unregisterUriHandler($)})}$handleExternalUri(g,A){const I=this.d.get(g);if(!I)return Promise.resolve(void 0);try{I.handleUri(T.URI.revive(A))}catch($){(0,R.$Z)($)}return Promise.resolve(void 0)}async createAppUri(g){return T.URI.revive(await this.b.$createAppUri(g))}}e.$Kfc=b}),define(ke[93],Se([1,0,4,3,17,24,2,238,275,113,6]),function(me,e,C,T,f,R,L,b,y,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gec=e.$fec=e.$eec=e.$dec=e.$cec=void 0;class I{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;constructor(r,a,t,s,d,c,u){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new C.$Rd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new C.$Rd,this._onDidDispose=this.#h.event,this.#e=r,this.#t=a,this.#s=t,this.#o=s,this.#r=d,this.#n=c,this.#l=$(c),this.#d=v(c),this.#i=u}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(r){return this.#u=!0,(0,g.$9tb)(r,this.#o)}get cspSource(){const r=this.#n.extensionLocation;if(r.scheme===f.Schemas.https||r.scheme===f.Schemas.http){let a=r.toString();return a.endsWith("/")||(a+="/"),a+" "+g.$8tb}return g.$8tb}get html(){return this.a(),this.#a}set html(r){this.a(),this.#a!==r&&(this.#a=r,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(r)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(r)))}get options(){return this.a(),this.#s}set options(r){this.a(),R.$en(this.#s,r)||this.#t.$setOptions(this.#e,l(this.#n,this.#r,r)),this.#s=r}async postMessage(r){if(this.#c)return!1;const a=(0,y.$Ecb)(r,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,a.message,...a.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(r){if(!this.#d)return r;const a=this.#n.extensionLocation?.scheme===f.Schemas.vscodeRemote,t=this.#n.extensionLocation.scheme===f.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return r.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,d,c,u,h,E)=>{const D=L.URI.from({scheme:u||"file",path:decodeURIComponent(h)}),m=(0,g.$9tb)(D,{isRemote:a,authority:t}).toString();return`${d}${m}${E}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,d,c,u,h,E)=>{const D=L.URI.from({scheme:u||"file",path:decodeURIComponent(h)}),m=(0,g.$9tb)(D,{isRemote:a,authority:t}).toString();return`${d}${m}${E}`})}}e.$cec=I;function $(n){try{const r=(0,b.$To)((0,b.$So)(n.engines.vscode));return!!r&&r.majorBase>=1&&r.minorBase>=57}catch{return!1}}e.$dec=$;function v(n){try{const r=(0,b.$To)((0,b.$So)(n.engines.vscode));return r?r.majorBase<1||r.majorBase===1&&r.minorBase<60:!1}catch{return!1}}class S extends T.$Rc{constructor(r,a,t,s,d){super(),this.c=a,this.f=t,this.g=s,this.h=d,this.b=new Map,this.a=r.getProxy(A.$zK.MainThreadWebviews)}dispose(){super.dispose();for(const r of this.b.values())r.dispose();this.b.clear()}$onMessage(r,a,t){const s=this.j(r);if(s){const{message:d}=(0,y.$Fcb)(a,t.value);s._onMessageEmitter.fire(d)}}$onMissingCsp(r,a){this.g.warn(`${a} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(r,a,t){const s=new I(r,this.a,o(a),this.c,this.f,t,this.h);this.b.set(r,s);const d=s._onDidDispose(()=>{d.dispose(),this.deleteWebview(r)});return s}deleteWebview(r){this.b.delete(r)}j(r){return this.b.get(r)}}e.$eec=S;function w(n){return{id:n.identifier,location:n.extensionLocation}}e.$fec=w;function l(n,r,a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots||i(n,r)}}e.$gec=l;function o(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(r=>L.URI.from(r))}}function i(n,r){return[...(r?.getWorkspaceFolders()||[]).map(a=>a.uri),n.extensionLocation]}}),define(ke[344],Se([1,0,21,52,3,17,23,2,15,93,110,6,7]),function(me,e,C,T,f,R,L,b,y,g,A,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iec=void 0;class v{constructor(s,d){this.document=s,this.b=d,this.a=1,this.c=new A.$Hdc("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,d){await this.f(s).undo(),d||this.disposeBackup()}async redo(s,d){await this.f(s).redo(),d||this.disposeBackup()}disposeEdits(s){for(const d of s)this.c.delete(d)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=a(this.document.uri)+this.a++;return(0,L.$zg)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const d=this.c.get(s,0);if(!d)throw new Error("No edit found");return d}}class S{constructor(){this.a=new Map}get(s,d){return this.a.get(this.b(s,d))}add(s,d,c){const u=this.b(s,d.uri);if(this.a.has(u))throw new Error(`Document already exists for viewType:${s} resource:${d.uri}`);const h=new v(d,c);return this.a.set(u,h),h}delete(s,d){const c=this.b(s,d.uri);this.a.delete(c)}b(s,d){return`${s}@@@${d}`}}var w;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(w||(w={}));class l{constructor(){this.a=new Map}addTextProvider(s,d,c){return this.b(0,s,d,c)}addCustomProvider(s,d,c){return this.b(1,s,d,c)}get(s){return this.a.get(s)}b(s,d,c,u){if(this.a.has(d))throw new Error(`Provider for viewType:${d} already registered`);return this.a.set(d,{type:s,extension:c,provider:u}),new $.$BK(()=>this.a.delete(d))}}class o{constructor(s,d,c,u,h){this.d=d,this.f=c,this.g=u,this.h=h,this.b=new l,this.c=new S,this.a=s.getProxy(I.$zK.MainThreadCustomEditors)}registerCustomEditorProvider(s,d,c,u){const h=new f.$Qc;return n(c)?(h.add(this.b.addTextProvider(d,s,c)),this.a.$registerTextEditorProvider((0,g.$fec)(s),d,u.webviewOptions||{},{supportsMove:!!c.moveCustomTextEditor},(0,g.$dec)(s))):(h.add(this.b.addCustomProvider(d,s,c)),i(c)&&h.add(c.onDidChangeCustomDocument(E=>{const D=this.i(d,E.document.uri);if(r(E)){const m=D.addEdit(E);this.a.$onDidEdit(E.document.uri,d,m,E.label)}else this.a.$onContentChange(E.document.uri,d)})),this.a.$registerCustomEditorProvider((0,g.$fec)(s),d,u.webviewOptions||{},!!u.supportsMultipleEditorsPerDocument,(0,g.$dec)(s))),$.$BK.from(h,new $.$BK(()=>{this.a.$unregisterEditorProvider(d)}))}async $createCustomDocument(s,d,c,u,h){const E=this.b.get(d);if(!E)throw new Error(`No provider found for '${d}'`);if(E.type!==1)throw new Error(`Invalid provide type for '${d}'`);const D=b.URI.revive(s),m=await E.provider.openCustomDocument(D,{backupId:c,untitledDocumentData:u?.buffer},h);let p;return i(E.provider)&&this.f&&(p=this.f.workspaceValue(E.extension)??this.f.globalValue(E.extension)),this.c.add(d,m,p),{editable:i(E.provider)}}async $disposeCustomDocument(s,d){const c=this.b.get(d);if(!c)throw new Error(`No provider found for '${d}'`);if(c.type!==1)throw new Error(`Invalid provider type for '${d}'`);const u=b.URI.revive(s),{document:h}=this.i(d,u);this.c.delete(d,h),h.dispose()}async $resolveCustomEditor(s,d,c,u,h,E){const D=this.b.get(c);if(!D)throw new Error(`No provider found for '${c}'`);const m=y.ViewColumn.to(h),p=this.g.createNewWebview(d,u.contentOptions,D.extension),k=this.h.createNewWebviewPanel(d,c,u.title,m,u.options,p,u.active),P=b.URI.revive(s);switch(D.type){case 1:{const{document:z}=this.i(c,P);return D.provider.resolveCustomEditor(z,k,E)}case 0:{const z=this.d.getDocument(P);return D.provider.resolveCustomTextEditor(z,k,E)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,d,c){this.i(d,s).disposeEdits(c)}async $onMoveCustomEditor(s,d,c){const u=this.b.get(c);if(!u)throw new Error(`No provider found for '${c}'`);if(!u.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${c}'`);const h=this.h.getWebviewPanel(s);if(!h)throw new Error("No webview found");const E=b.URI.revive(d),D=this.d.getDocument(E);await u.provider.moveCustomTextEditor(D,h,C.CancellationToken.None)}async $undo(s,d,c,u){return this.i(d,s).undo(c,u)}async $redo(s,d,c,u){return this.i(d,s).redo(c,u)}async $revert(s,d,c){const u=this.i(d,s);await this.j(d).revertCustomDocument(u.document,c),u.disposeBackup()}async $onSave(s,d,c){const u=this.i(d,s);await this.j(d).saveCustomDocument(u.document,c),u.disposeBackup()}async $onSaveAs(s,d,c,u){const h=this.i(d,s);return this.j(d).saveCustomDocumentAs(h.document,b.URI.revive(c),u)}async $backup(s,d,c){const u=this.i(d,s),E=await this.j(d).backupCustomDocument(u.document,{destination:u.getNewBackupUri()},c);return u.updateBackup(E),E.id}i(s,d){const c=this.c.get(s,b.URI.revive(d));if(!c)throw new Error("No custom document found");return c}j(s){const c=this.b.get(s)?.provider;if(!c||!i(c))throw new Error("Custom document is not editable");return c}}e.$iec=o;function i(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function r(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function a(t){const s=t.scheme===R.Schemas.file||t.scheme===R.Schemas.untitled?t.fsPath:t.toString();return(0,T.$Ji)(s)+""}}),define(ke[345],Se([1,0,4,3,2,32,15,93,6,7]),function(me,e,C,T,f,R,L,b,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hec=void 0;class A extends T.$Rc{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;#h;constructor(S,w,l,o){super(),this.#s=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new C.$Rd),this.onDidDispose=this.#d.event,this.#h=this.B(new C.$Rd),this.onDidChangeViewState=this.#h.event,this.#e=S,this.#t=w,this.#o=l,this.#i=o.viewType,this.#r=o.panelOptions,this.#s=o.viewColumn,this.#n=o.title,this.#u=o.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#o.dispose(),super.dispose())}get webview(){return this.c(),this.#o}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(S){this.c(),this.#n!==S&&(this.#n=S,this.#t.$setTitle(this.#e,S))}get iconPath(){return this.c(),this.#a}set iconPath(S){this.c(),this.#a!==S&&(this.#a=S,this.#t.$setIconPath(this.#e,f.URI.isUri(S)?{light:S,dark:S}:S))}get options(){return this.#r}get viewColumn(){if(this.c(),!(typeof this.#s=="number"&&this.#s<0))return this.#s}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(S){this.#l||(this.active!==S.active||this.visible!==S.visible||this.viewColumn!==S.viewColumn)&&(this.#u=S.active,this.#c=S.visible,this.#s=S.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(S,w){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof S>"u"?void 0:L.ViewColumn.from(S),preserveFocus:!!w})}c(){if(this.#l)throw new Error("Webview is disposed")}}class I extends T.$Rc{static c(){return(0,R.$ig)()}constructor(S,w,l){super(),this.j=w,this.m=l,this.g=new Map,this.h=new Map,this.f=S.getProxy(y.$zK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(S=>S.dispose()),this.g.clear()}createWebviewPanel(S,w,l,o,i={}){const n=typeof o=="object"?o.viewColumn:o,r={viewColumn:L.ViewColumn.from(n),preserveFocus:typeof o=="object"&&!!o.preserveFocus},a=(0,b.$dec)(S),t=I.c();this.f.$createWebviewPanel((0,b.$fec)(S),t,w,{title:l,panelOptions:$(i),webviewOptions:(0,b.$gec)(S,this.m,i),serializeBuffersForPostMessage:a},r);const s=this.j.createNewWebview(t,i,S);return this.createNewWebviewPanel(t,w,l,n,i,s,!0)}$onDidChangeWebviewPanelViewStates(S){const w=Object.keys(S);w.sort((l,o)=>{const i=S[l],n=S[o];return i.active?1:n.active?-1:+i.visible-+n.visible});for(const l of w){const o=this.getWebviewPanel(l);if(!o)continue;const i=S[l];o._updateViewState({active:i.active,visible:i.visible,viewColumn:L.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(S){this.getWebviewPanel(S)?.dispose(),this.g.delete(S),this.j.deleteWebview(S)}registerWebviewPanelSerializer(S,w,l){if(this.h.has(w))throw new Error(`Serializer for '${w}' already registered`);return this.h.set(w,{serializer:l,extension:S}),this.f.$registerSerializer(w,{serializeBuffersForPostMessage:(0,b.$dec)(S)}),new g.$BK(()=>{this.h.delete(w),this.f.$unregisterSerializer(w)})}async $deserializeWebviewPanel(S,w,l,o){const i=this.h.get(w);if(!i)throw new Error(`No serializer found for '${w}'`);const{serializer:n,extension:r}=i,a=this.j.createNewWebview(S,l.webviewOptions,r),t=this.createNewWebviewPanel(S,w,l.title,o,l.panelOptions,a,l.active);await n.deserializeWebviewPanel(t,l.state)}createNewWebviewPanel(S,w,l,o,i,n,r){const a=new A(S,this.f,n,{viewType:w,title:l,viewColumn:o,panelOptions:i,active:r});return this.g.set(S,a),a}getWebviewPanel(S){return this.g.get(S)}}e.$hec=I;function $(v){return{enableFindWidget:v.enableFindWidget,retainContextWhenHidden:v.retainContextWhenHidden}}}),define(ke[346],Se([1,0,4,3,93,15,6,7]),function(me,e,C,T,f,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lfc=void 0;class y extends T.$Rc{#e;#t;#i;#o;#r;#n;#a;#s;#c;constructor(I,$,v,S,w,l){super(),this.#r=!1,this.#u=this.B(new C.$Rd),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new C.$Rd),this.onDidDispose=this.#l.event,this.#i=v,this.#a=S,this.#e=I,this.#t=$,this.#o=w,this.#n=l}dispose(){this.#r||(this.#r=!0,this.#l.fire(),this.#o.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(I){this.a(),this.#a!==I&&(this.#a=I,this.#t.$setWebviewViewTitle(this.#e,I))}get description(){return this.a(),this.#s}set description(I){this.a(),this.#s!==I&&(this.#s=I,this.#t.$setWebviewViewDescription(this.#e,I))}get visible(){return this.#n}get webview(){return this.#o}get viewType(){return this.#i}_setVisible(I){I===this.#n||this.#r||(this.#n=I,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(I){this.a(),!(I?.value===this.#c?.value&&I?.tooltip===this.#c?.tooltip)&&(this.#c=R.ViewBadge.from(I),this.#t.$setWebviewViewBadge(this.#e,I))}show(I){this.a(),this.#t.$show(this.#e,!!I)}a(){if(this.#r)throw new Error("Webview is disposed")}}class g{constructor(I,$){this.d=$,this.b=new Map,this.c=new Map,this.a=I.getProxy(L.$zK.MainThreadWebviewViews)}registerWebviewViewProvider(I,$,v,S){if(this.b.has($))throw new Error(`View provider for '${$}' already registered`);return this.b.set($,{provider:v,extension:I}),this.a.$registerWebviewViewProvider((0,f.$fec)(I),$,{retainContextWhenHidden:S?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,f.$dec)(I)}),new b.$BK(()=>{this.b.delete($),this.a.$unregisterWebviewViewProvider($)})}async $resolveWebviewView(I,$,v,S,w){const l=this.b.get($);if(!l)throw new Error(`No view provider found for '${$}'`);const{provider:o,extension:i}=l,n=this.d.createNewWebview(I,{},i),r=new y(I,this.a,$,v,n,!0);this.c.set(I,r),await o.resolveWebviewView(r,{state:S},w)}async $onDidChangeWebviewViewVisibility(I,$){this.e(I)._setVisible($)}async $disposeWebviewView(I){const $=this.e(I);this.c.delete(I),$.dispose(),this.d.deleteWebview(I)}e(I){const $=this.c.get(I);if(!$)throw new Error("No webview found");return $}}e.$Lfc=g}),define(ke[153],Se([1,0,4,6,2,17,13,5,20,25]),function(me,e,C,T,f,R,L,b,y,g){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$Nfc=e.$Mfc=void 0;let I=class{static{A=this}static{this.a={focused:!0,active:!0}}getState(v){const S=this.d;return{get focused(){return S.focused},get active(){return(0,g.$NF)(v,"windowActivity"),S.active}}}constructor(v){this.c=new C.$Rd,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=v.getProxy(T.$zK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:S,isActive:w})=>{this.onDidChangeWindowProperty("focused",S),this.onDidChangeWindowProperty("active",w)})}$onDidChangeWindowFocus(v){this.onDidChangeWindowProperty("focused",v)}$onDidChangeWindowActive(v){this.onDidChangeWindowProperty("active",v)}onDidChangeWindowProperty(v,S){S!==this.d[v]&&(this.d={...this.d,[v]:S},this.c.fire(this.d))}openUri(v,S){let w;if(typeof v=="string"){w=v;try{v=f.URI.parse(v)}catch{return Promise.reject(`Invalid uri - '${v}'`)}}return(0,L.$Fe)(v.scheme)?Promise.reject("Invalid scheme - cannot be empty"):v.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${v.scheme}'`):this.b.$openUri(v,w,S)}async asExternalUri(v,S){if((0,L.$Fe)(v.scheme))return Promise.reject("Invalid scheme - cannot be empty");const w=await this.b.$asExternalUri(v,S);return f.URI.from(w)}};e.$Mfc=I,e.$Mfc=I=A=He([Be(0,y.$BM)],I),e.$Nfc=(0,b.$Vh)("IExtHostWindow")}),define(ke[347],Se([1,0,315,27,20]),function(me,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pgc=void 0;const R=1024*1024;let L=class extends C.$Qfc{constructor(y,g){super(y,g),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(y,g,A){const I=y==="error"||y==="warn"?process.stderr:process.stdout;this.g=!0,I.write(`
START_NATIVE_LOG
`),g.apply(console,A),I.write(`
END_NATIVE_LOG
`),this.g=!1}j(y,g){const A=process[y],I=A.write;let $="";Object.defineProperty(A,"write",{set:()=>{},get:()=>(v,S,w)=>{if(!this.g){$+=v.toString(S);const l=$.length>R?$.length:$.lastIndexOf(`
`);l!==-1&&(console[g]($.slice(0,l)),$=$.slice(l+1))}I.call(A,v,S,w)}})}};e.$pgc=L,e.$pgc=L=He([Be(0,f.$BM),Be(1,T.$RM)],L)}),define(ke[348],Se([1,0,71,17,14,250,31,11]),function(me,e,C,T,f,R,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qgc=void 0;let y=class{constructor(I,$){I.addFileSystemProvider(T.Schemas.file,new g($),{isCaseSensitive:b.$k})}};e.$qgc=y,e.$qgc=y=He([Be(0,C.$_dc),Be(1,f.$dj)],y);class g{constructor(I){this.b=I,this.a=new R.$gq(this.b)}async stat(I){const $=await this.a.stat(I);return{type:$.type,ctime:$.ctime,mtime:$.mtime,size:$.size,permissions:$.permissions===L.FilePermission.Readonly?1:void 0}}readDirectory(I){return this.a.readdir(I)}createDirectory(I){return this.a.mkdir(I)}readFile(I){return this.a.readFile(I)}writeFile(I,$,v){return this.a.writeFile(I,$,{...v,unlock:!1,atomic:!1})}delete(I,$){return this.a.delete(I,{...$,useTrash:!1,atomic:!1})}rename(I,$,v){return this.a.rename(I,$,v)}copy(I,$,v){return this.a.copy(I,$,v)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(I,$){throw new Error("Method not implemented.")}}}),define(ke[349],Se([1,0,16,63,32,35,3,6,2,20]),function(me,e,C,T,f,R,L,b,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ogc=void 0;let A=class extends L.$Rc{constructor($,v){super();const S=$.getProxy(b.$zK.MainThreadDownloadService);v.registerCommand(!1,"_workbench.downloadResource",async w=>{const l=y.URI.file((0,C.$ic)((0,T.tmpdir)(),(0,f.$ig)()));return await S.$download(w,l),l})}};e.$ogc=A,e.$ogc=A=He([Be(0,g.$BM),Be(1,R.$XM)],A)}),define(ke[350],Se([1,0,152,17,252,32]),function(me,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bgc=void 0;class L extends C.$Pfc{s(y,g,A){return y.scheme===T.Schemas.file?new f.$NN(A?.name||(0,R.$ig)(),y.fsPath,!A?.donotRotate,!!A?.donotUseFormatters,g):super.s(y,g,A)}registerLogger(y){super.registerLogger(y),this.r.$registerLogger(y)}deregisterLogger(y){super.deregisterLogger(y),this.r.$deregisterLogger(y)}}e.$Bgc=L}),define(ke[351],Se([1,0,55,16,2,92,3,17,12,30]),function(me,e,C,T,f,R,L,b,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Agc=void 0;class A extends R.$bec{constructor(){super(...arguments),this.i=null}async g(t){const s=await super.g(t);if(s.scheme!==b.Schemas.file)return s;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${s.fsPath}.`),s;const d=s.fsPath;let c=0;do{let u;c===0?u=d:u=/[/\\]$/.test(d)?`${d.substr(0,d.length-1)}-${c}`:`${d}-${c}`,await I(u);const h=T.$ic(u,"vscode.lock"),E=await w(this.d,h,!1);if(E)return this.i=E,process.on("exit",()=>{E.dispose()}),f.URI.file(u);c++}while(c<10);return s}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$Agc=A;async function I(a){try{await g.Promises.stat(a);return}catch{}try{await g.Promises.mkdir(a,{recursive:!0})}catch{}}const $=1e3,v=10*60*1e3;class S extends L.$Rc{constructor(t,s){super(),this.b=t,this.c=s,this.a=this.B(new y.$9g),this.a.cancelAndSet(async()=>{const d=await l(t,s);(!d||d.pid!==process.pid)&&(t.info(`Lock '${s}': The lock was lost unexpectedly.`),this.a.cancel());try{await g.Promises.utimes(s,new Date,new Date)}catch(c){t.error(c),t.info(`Lock '${s}': Could not update mtime.`)}},$)}dispose(){super.dispose();try{C.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const s={pid:process.pid,willReleaseAt:Date.now()+t};await g.Promises.writeFile(this.c,JSON.stringify(s),{flag:"w"})}catch(s){this.b.error(s)}}}async function w(a,t,s){try{const c={pid:process.pid,willReleaseAt:0};await g.Promises.writeFile(t,JSON.stringify(c),{flag:"wx"})}catch(c){a.error(c)}const d=await l(a,t);return!d||d.pid!==process.pid?s?(a.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(a.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),n(a,t)):(a.info(`Lock '${t}': Lock acquired.`),new S(a,t))}async function l(a,t){let s;try{s=await g.Promises.readFile(t)}catch(d){return a.error(d),null}try{return JSON.parse(String(s))}catch(d){return a.error(d),null}}async function o(a,t){let s;try{s=await g.Promises.stat(t)}catch(d){return a.error(d),0}return s.mtime.getTime()}function i(a){try{return process.kill(a,0),!0}catch{return!1}}async function n(a,t){const s=await l(a,t);if(!s)return a.info(`Lock '${t}': Could not read pid of lock holder.`),r(a,t);if(s.willReleaseAt){let E=s.willReleaseAt-Date.now();if(E<5e3){for(E>0?a.info(`Lock '${t}': The lockfile is scheduled to be released in ${E} ms.`):a.info(`Lock '${t}': The lockfile is scheduled to have been released.`);E>0;){if(await(0,y.$Yg)(Math.min(100,E)),await o(a,t)===0)return r(a,t);E=s.willReleaseAt-Date.now()}return r(a,t)}}if(!i(s.pid))return a.info(`Lock '${t}': The pid ${s.pid} appears to be gone.`),r(a,t);const d=await o(a,t),c=Date.now()-d;if(c<=v)return a.info(`Lock '${t}': The lock does not look stale, elapsed: ${c} ms, giving up.`),null;a.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,y.$Yg)(2e3);const u=await o(a,t),h=Date.now()-u;return h<=v?(a.info(`Lock '${t}': The lock does not look stale, elapsed: ${h} ms, giving up.`),null):(a.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),r(a,t))}async function r(a,t){a.info(`Lock '${t}': Deleting a stale lock.`);try{await g.Promises.unlink(t)}catch{}return w(a,t,!0)}}),define(ke[352],Se([1,0,32,20,46,35]),function(me,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vfc=void 0;let L=class extends f.$xec{constructor(y,g){super(!0,y,g)}createTerminal(y,g,A){return this.createTerminalFromOptions({name:y,shellPath:g,shellArgs:A})}createTerminalFromOptions(y,g){const A=new f.$wec(this.a,(0,C.$ig)(),y,y.name);return this.f.push(A),A.create(y,this.R(y,g)),A.value}};e.$Vfc=L,e.$Vfc=L=He([Be(0,R.$XM),Be(1,T.$BM)],L)}),define(ke[353],Se([1,0,12,22,21,8,4,3,131,304,68]),function(me,e,C,T,f,R,L,b,y,g,A){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$55b=e.ResponsiveState=e.RequestInitiator=e.$45b=e.$35b=void 0;function $(k,P){try{return JSON.stringify(k,P)}catch{return"null"}}const v="$$ref$$",S={[v]:-1};class w{constructor(P,z){this.jsonString=P,this.referencedBuffers=z}}function l(k,P=null,z=!1){const j=[];return{jsonString:(z?$:JSON.stringify)(k,(O,F)=>{if(typeof F>"u")return S;if(typeof F=="object"){if(F instanceof T.$fe){const N=j.push(F)-1;return{[v]:N}}if(P)return P(O,F)}return F}),referencedBuffers:j}}e.$35b=l;function o(k,P,z){return JSON.parse(k,(j,M)=>{if(M){const O=M[v];if(typeof O=="number")return P[O];if(z&&M.$mid===1)return z.transformIncoming(M)}return M})}e.$45b=o;function i(k,P){return JSON.stringify(k,P)}function n(k){return k?(P,z)=>z&&z.$mid===1?k.transformOutgoing(z):z:null}var r;(function(k){k[k.LocalSide=0]="LocalSide",k[k.OtherSide=1]="OtherSide"})(r||(e.RequestInitiator=r={}));var a;(function(k){k[k.Responsive=0]="Responsive",k[k.Unresponsive=1]="Unresponsive"})(a||(e.ResponsiveState=a={}));const t=()=>{},s=Symbol.for("rpcProtocol"),d=Symbol.for("rpcProxy");class c extends b.$Rc{static{I=s}static{this.a=3*1e3}constructor(P,z=null,j=null){super(),this[I]=!0,this.b=this.B(new L.$Rd),this.onDidChangeResponsiveState=this.b.event,this.c=P,this.f=z,this.g=j,this.h=n(this.g),this.j=!1,this.m=[],this.s=[];for(let M=0,O=A.$tv.count;M<O;M++)this.m[M]=null,this.s[M]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new C.$0g(()=>this.H(),1e3)),this.c.onMessage(M=>this.L(M))}dispose(){this.j=!0,Object.keys(this.w).forEach(P=>{const z=this.w[P];delete this.w[P],z.resolveErr(R.$5())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(P){this.z===0&&(this.C=Date.now()+c.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(P){this.C=Date.now()+c.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(P){this.y!==P&&(this.y=P,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(P){return this.g?(0,y.$Um)(P,this.g):P}getProxy(P){const{nid:z,sid:j}=P;return this.s[z]||(this.s[z]=this.J(z,j)),this.s[z]}J(P,z){const j={get:(M,O)=>(typeof O=="string"&&!M[O]&&O.charCodeAt(0)===36&&(M[O]=(...F)=>this.U(P,O,F)),O===d?z:M[O])};return new Proxy(Object.create(null),j)}set(P,z){return this.m[P.nid]=z,z}assertRegistered(P){for(let z=0,j=P.length;z<j;z++){const M=P[z];if(!this.m[M.nid])throw new Error(`Missing proxy instance ${M.sid}`)}}L(P){if(this.j)return;const z=P.byteLength,j=h.read(P,0),M=j.readUInt8(),O=j.readUInt32();switch(M){case 1:case 2:{let{rpcId:F,method:N,args:W}=D.deserializeRequestJSONArgs(j);this.g&&(W=(0,y.$Um)(W,this.g)),this.M(z,O,F,N,W,M===2);break}case 3:case 4:{let{rpcId:F,method:N,args:W}=D.deserializeRequestMixedArgs(j);this.g&&(W=(0,y.$Um)(W,this.g)),this.M(z,O,F,N,W,M===4);break}case 5:{this.f?.logIncoming(z,O,0,"ack"),this.G(O);break}case 6:{this.N(z,O);break}case 7:{this.O(z,O,void 0);break}case 9:{let F=D.deserializeReplyOKJSON(j);this.g&&(F=(0,y.$Um)(F,this.g)),this.O(z,O,F);break}case 10:{const F=D.deserializeReplyOKJSONWithBuffers(j,this.g);this.O(z,O,F);break}case 8:{const F=D.deserializeReplyOKVSBuffer(j);this.O(z,O,F);break}case 11:{let F=D.deserializeReplyErrError(j);this.g&&(F=(0,y.$Um)(F,this.g)),this.P(z,O,F);break}case 12:{this.P(z,O,void 0);break}default:console.error("received unexpected message"),console.error(P)}}M(P,z,j,M,O,F){this.f?.logIncoming(P,z,1,`receiveRequest ${(0,A.$vv)(j)}.${M}(`,O);const N=String(z);let W,X;if(F){const J=new f.$2d;O.push(J.token),W=this.Q(j,M,O),X=()=>J.cancel()}else W=this.Q(j,M,O),X=t;this.u[N]=X;const ce=D.serializeAcknowledged(z);this.f?.logOutgoing(ce.byteLength,z,1,"ack"),this.c.send(ce),W.then(J=>{delete this.u[N];const Q=D.serializeReplyOK(z,J,this.h);this.f?.logOutgoing(Q.byteLength,z,1,"reply:",J),this.c.send(Q)},J=>{delete this.u[N];const Q=D.serializeReplyErr(z,J);this.f?.logOutgoing(Q.byteLength,z,1,"replyErr:",J),this.c.send(Q)})}N(P,z){this.f?.logIncoming(P,z,1,"receiveCancel");const j=String(z);this.u[j]?.()}O(P,z,j){this.f?.logIncoming(P,z,0,"receiveReply:",j);const M=String(z);if(!this.w.hasOwnProperty(M))return;const O=this.w[M];delete this.w[M],O.resolveOk(j)}P(P,z,j){this.f?.logIncoming(P,z,0,"receiveReplyErr:",j);const M=String(z);if(!this.w.hasOwnProperty(M))return;const O=this.w[M];delete this.w[M];let F;j&&(j.$isError?(F=new Error,F.name=j.name,F.message=j.message,F.stack=j.stack):F=j),O.resolveErr(F)}Q(P,z,j){try{return Promise.resolve(this.S(P,z,j))}catch(M){return Promise.reject(M)}}S(P,z,j){const M=this.m[P];if(!M)throw new Error("Unknown actor "+(0,A.$vv)(P));const O=M[z];if(typeof O!="function")throw new Error("Unknown method "+z+" on actor "+(0,A.$vv)(P));return O.apply(M,j)}U(P,z,j){if(this.j)return new g.$25b;let M=null;if(j.length>0&&f.CancellationToken.isCancellationToken(j[j.length-1])&&(M=j.pop()),M&&M.isCancellationRequested)return Promise.reject(R.$5());const O=D.serializeRequestArguments(j,this.h),F=++this.t,N=String(F),W=new g.$15b,X=new b.$Qc;M&&X.add(M.onCancellationRequested(()=>{const J=D.serializeCancel(F);this.f?.logOutgoing(J.byteLength,F,0,"cancel"),this.c.send(D.serializeCancel(F))})),this.w[N]=new u(W,X),this.F(F);const ce=D.serializeRequest(F,P,z,O,!!M);return this.f?.logOutgoing(ce.byteLength,F,0,`request: ${(0,A.$vv)(P)}.${z}(`,j),this.c.send(ce),W}}e.$55b=c;class u{constructor(P,z){this.a=P,this.b=z}resolveOk(P){this.a.resolveOk(P),this.b.dispose()}resolveErr(P){this.a.resolveErr(P),this.b.dispose()}}class h{static alloc(P,z,j){const M=new h(T.$fe.alloc(j+1+4),0);return M.writeUInt8(P),M.writeUInt32(z),M}static read(P,z){return new h(P,z)}get buffer(){return this.a}constructor(P,z){this.a=P,this.b=z}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(P){this.a.writeUInt8(P,this.b),this.b+=1}readUInt8(){const P=this.a.readUInt8(this.b);return this.b+=1,P}writeUInt32(P){this.a.writeUInt32BE(P,this.b),this.b+=4}readUInt32(){const P=this.a.readUInt32BE(this.b);return this.b+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this.a.writeUInt8(P.byteLength,this.b),this.b+=1,this.a.set(P,this.b),this.b+=P.byteLength}readShortString(){const P=this.a.readUInt8(this.b);this.b+=1;const j=this.a.slice(this.b,this.b+P).toString();return this.b+=P,j}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readLongString(){const P=this.a.readUInt32BE(this.b);this.b+=4;const j=this.a.slice(this.b,this.b+P).toString();return this.b+=P,j}writeBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readVSBuffer(){const P=this.a.readUInt32BE(this.b);this.b+=4;const z=this.a.slice(this.b,this.b+P);return this.b+=P,z}static sizeMixedArray(P){let z=0;z+=1;for(let j=0,M=P.length;j<M;j++){const O=P[j];switch(z+=1,O.type){case 1:z+=this.sizeLongString(O.value);break;case 2:z+=this.sizeVSBuffer(O.value);break;case 3:z+=this.sizeUInt32,z+=this.sizeLongString(O.value);for(let F=0;F<O.buffers.length;++F)z+=this.sizeVSBuffer(O.buffers[F]);break;case 4:break}}return z}writeMixedArray(P){this.a.writeUInt8(P.length,this.b),this.b+=1;for(let z=0,j=P.length;z<j;z++){const M=P[z];switch(M.type){case 1:this.writeUInt8(1),this.writeLongString(M.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(M.value);break;case 3:this.writeUInt8(3),this.writeUInt32(M.buffers.length),this.writeLongString(M.value);for(let O=0;O<M.buffers.length;++O)this.writeBuffer(M.buffers[O]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this.a.readUInt8(this.b);this.b+=1;const z=new Array(P);for(let j=0;j<P;j++)switch(this.readUInt8()){case 1:z[j]=this.readLongString();break;case 2:z[j]=this.readVSBuffer();break;case 3:{const O=this.readUInt32(),F=this.readLongString(),N=[];for(let W=0;W<O;++W)N.push(this.readVSBuffer());z[j]=new A.$wv(o(F,N,null));break}case 4:z[j]=void 0;break}return z}}var E;(function(k){k[k.Simple=0]="Simple",k[k.Mixed=1]="Mixed"})(E||(E={}));class D{static a(P){for(let z=0,j=P.length;z<j;z++)if(P[z]instanceof T.$fe||P[z]instanceof A.$wv||typeof P[z]>"u")return!0;return!1}static serializeRequestArguments(P,z){if(this.a(P)){const j=[];for(let M=0,O=P.length;M<O;M++){const F=P[M];if(F instanceof T.$fe)j[M]={type:2,value:F};else if(typeof F>"u")j[M]={type:4};else if(F instanceof A.$wv){const{jsonString:N,referencedBuffers:W}=l(F.value,z);j[M]={type:3,value:T.$fe.fromString(N),buffers:W}}else j[M]={type:1,value:T.$fe.fromString(i(F,z))}}return{type:1,args:j}}return{type:0,args:i(P,z)}}static serializeRequest(P,z,j,M,O){switch(M.type){case 0:return this.b(P,z,j,M.args,O);case 1:return this.c(P,z,j,M.args,O)}}static b(P,z,j,M,O){const F=T.$fe.fromString(j),N=T.$fe.fromString(M);let W=0;W+=h.sizeUInt8(),W+=h.sizeShortString(F),W+=h.sizeLongString(N);const X=h.alloc(O?2:1,P,W);return X.writeUInt8(z),X.writeShortString(F),X.writeLongString(N),X.buffer}static deserializeRequestJSONArgs(P){const z=P.readUInt8(),j=P.readShortString(),M=P.readLongString();return{rpcId:z,method:j,args:JSON.parse(M)}}static c(P,z,j,M,O){const F=T.$fe.fromString(j);let N=0;N+=h.sizeUInt8(),N+=h.sizeShortString(F),N+=h.sizeMixedArray(M);const W=h.alloc(O?4:3,P,N);return W.writeUInt8(z),W.writeShortString(F),W.writeMixedArray(M),W.buffer}static deserializeRequestMixedArgs(P){const z=P.readUInt8(),j=P.readShortString(),M=P.readMixedArray(),O=new Array(M.length);for(let F=0,N=M.length;F<N;F++){const W=M[F];typeof W=="string"?O[F]=JSON.parse(W):O[F]=W}return{rpcId:z,method:j,args:O}}static serializeAcknowledged(P){return h.alloc(5,P,0).buffer}static serializeCancel(P){return h.alloc(6,P,0).buffer}static serializeReplyOK(P,z,j){if(typeof z>"u")return this.d(P);if(z instanceof T.$fe)return this.e(P,z);if(z instanceof A.$wv){const{jsonString:M,referencedBuffers:O}=l(z.value,j,!0);return this.g(P,M,O)}else return this.f(P,$(z,j))}static d(P){return h.alloc(7,P,0).buffer}static e(P,z){let j=0;j+=h.sizeVSBuffer(z);const M=h.alloc(8,P,j);return M.writeVSBuffer(z),M.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static f(P,z){const j=T.$fe.fromString(z);let M=0;M+=h.sizeLongString(j);const O=h.alloc(9,P,M);return O.writeLongString(j),O.buffer}static g(P,z,j){const M=T.$fe.fromString(z);let O=0;O+=h.sizeUInt32,O+=h.sizeLongString(M);for(const N of j)O+=h.sizeVSBuffer(N);const F=h.alloc(10,P,O);F.writeUInt32(j.length),F.writeLongString(M);for(const N of j)F.writeBuffer(N);return F.buffer}static deserializeReplyOKJSON(P){const z=P.readLongString();return JSON.parse(z)}static deserializeReplyOKJSONWithBuffers(P,z){const j=P.readUInt32(),M=P.readLongString(),O=[];for(let F=0;F<j;++F)O.push(P.readVSBuffer());return new A.$wv(o(M,O,z))}static serializeReplyErr(P,z){const j=z?$(R.$2(z),null):void 0;if(typeof j!="string")return this.h(P);const M=T.$fe.fromString(j);let O=0;O+=h.sizeLongString(M);const F=h.alloc(11,P,O);return F.writeLongString(M),F.buffer}static deserializeReplyErrError(P){const z=P.readLongString();return JSON.parse(z)}static h(P){return h.alloc(12,P,0).buffer}}var m;(function(k){k[k.RequestJSONArgs=1]="RequestJSONArgs",k[k.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",k[k.RequestMixedArgs=3]="RequestMixedArgs",k[k.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",k[k.Acknowledged=5]="Acknowledged",k[k.Cancel=6]="Cancel",k[k.ReplyOKEmpty=7]="ReplyOKEmpty",k[k.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",k[k.ReplyOKJSON=9]="ReplyOKJSON",k[k.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",k[k.ReplyErrError=11]="ReplyErrError",k[k.ReplyErrEmpty=12]="ReplyErrEmpty"})(m||(m={}));var p;(function(k){k[k.String=1]="String",k[k.VSBuffer=2]="VSBuffer",k[k.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",k[k.Undefined=4]="Undefined"})(p||(p={}))}),define(ke[354],Se([1,0,4,37,45,5]),function(me,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VJ=e.$UJ=e.OutputChannelUpdateMode=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=void 0,e.$KJ="text/x-code-output",e.$LJ="output",e.$MJ="Log",e.$NJ="text/x-code-log-output",e.$OJ="log",e.$PJ="workbench.panel.output",e.$QJ=new f.$aj("inOutput",!1),e.$RJ=new f.$aj("activeLogOutput",!1),e.$SJ=new f.$aj("outputView.scrollLock",!1),e.$TJ=(0,R.$Vh)("outputService");var L;(function(y){y[y.Append=1]="Append",y[y.Replace=2]="Replace",y[y.Clear=3]="Clear"})(L||(e.OutputChannelUpdateMode=L={})),e.$UJ={OutputChannels:"workbench.contributions.outputChannels"};class b{constructor(){this.a=new Map,this.b=new C.$Rd,this.onDidRegisterChannel=this.b.event,this.c=new C.$Rd,this.onDidRemoveChannel=this.c.event}registerChannel(g){this.a.has(g.id)||(this.a.set(g.id,g),this.b.fire(g.id))}getChannels(){const g=[];return this.a.forEach(A=>g.push(A)),g}getChannel(g){return this.a.get(g)}removeChannel(g){this.a.delete(g),this.c.fire(g)}}T.$mn.add(e.$UJ.OutputChannels,new b),e.$VJ=new f.$aj("activeOutputChannel","")}),define(ke[154],Se([1,0,6,5,20,26,14,354,71,27,57,182,22,18,31,4,3]),function(me,e,C,T,f,R,L,b,y,g,A,I,$,v,S,w,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nfc=e.$mfc=void 0;class o extends L.$jj{get disposed(){return this.n}constructor(a,t,s,d,c){super(),this.id=a,this.name=t,this.r=s,this.s=d,this.extension=c,this.m=0,this.n=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(u=>this.setLevel(u)))}get logLevel(){return this.getLevel()}appendLine(a){this.append(a+`
`)}append(a){this.info(a)}clear(){const a=this.m;this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Clear,a)}replace(a){const t=this.m;this.info(a),this.s.$update(this.id,b.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(a,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof a=="boolean"?a:t))}hide(){this.s.$close(this.id)}g(a,t){this.m+=$.$fe.fromString(t).byteLength,(0,L.log)(this.r,a,t),this.visible&&(this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends o{appendLine(a){this.append(a)}}let n=class{constructor(a,t,s,d,c,u){this.i=t,this.j=s,this.k=d,this.l=c,this.m=u,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=a.getProxy(C.$zK.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,I.$km)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(a){this.h=a;for(const[t,s]of this.g)s.visible=t===this.h}createOutputChannel(a,t,s){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");const d=typeof t=="object"&&t.log,c=(0,v.$Cf)(t)?t:void 0;if((0,v.$Cf)(c)&&!c.trim())throw new Error("illegal argument `languageId`. must not be empty");let u;const h=this.i.environment.extensionLogLevel?.find(([D])=>R.$_l.equals(s.identifier,D))?.[1];h&&(u=(0,L.$tj)(h));const E=d?this.o(a,u,s):this.n(a,c,s);return E.then(D=>{this.g.set(D.id,D),D.visible=D.id===this.h}),d?this.r(a,u??this.m.getLevel(),E):this.q(a,E)}async n(a,t,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const d=await this.c,c=this.k.extUri.joinPath(d,`${this.f++}-${a.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),u=this.l.createLogger(c,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),h=await this.a.$register(a,c,t,s.identifier.value);return new o(h,a,u,this.a,s)}async o(a,t,s){const d=await this.p(s),c=a.replace(/[\\/:\*\?"<>\|]/g,""),u=this.k.extUri.joinPath(d,`${c}.log`),h=`${s.identifier.value}.${c}`,E=this.l.createLogger(u,{id:h,name:a,logLevel:t,extensionId:s.identifier.value});return new i(h,a,E,this.a,s)}p(a){let t=this.d.get(a.identifier.value);if(!t){const s=this.k.extUri.joinPath(this.i.logsLocation,a.identifier.value);this.d.set(a.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(s)}catch(d){if((0,S.$uk)(d)!==S.FileSystemProviderErrorCode.FileExists)throw d}return s})())}return t}q(a,t){let s=!1;const d=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return a},append(c){d(),t.then(u=>u.append(c))},appendLine(c){d(),t.then(u=>u.appendLine(c))},clear(){d(),t.then(c=>c.clear())},replace(c){d(),t.then(u=>u.replace(c))},show(c,u){d(),t.then(h=>h.show(c,u))},hide(){d(),t.then(c=>c.hide())},dispose(){s=!0,t.then(c=>c.dispose())}}}r(a,t,s){const d=new l.$Qc,c=()=>{if(d.isDisposed)throw new Error("Channel has been closed")},u=d.add(new w.$Rd);function h(E){t=E,u.fire(E)}return s.then(E=>{d.add(E),E.logLevel!==t&&h(E.logLevel),d.add(E.onDidChangeLogLevel(D=>h(D)))}),{...this.q(a,s),get logLevel(){return t},onDidChangeLogLevel:u.event,trace(E,...D){c(),s.then(m=>m.trace(E,...D))},debug(E,...D){c(),s.then(m=>m.debug(E,...D))},info(E,...D){c(),s.then(m=>m.info(E,...D))},warn(E,...D){c(),s.then(m=>m.warn(E,...D))},error(E,...D){c(),s.then(m=>m.error(E,...D))},dispose(){d.dispose()}}}};e.$mfc=n,e.$mfc=n=He([Be(0,f.$BM),Be(1,g.$RM),Be(2,y.$_dc),Be(3,A.$Ldc),Be(4,L.$ej),Be(5,L.$dj)],n),e.$nfc=(0,T.$Vh)("IExtHostOutputService")}),define(ke[155],Se([1,0,5,12]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Am=e.$zm=void 0,e.$zm=(0,C.$Vh)("remoteAgentService"),e.$Am=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(f){let R=1/0;for(let b=0;b<this.maxSampleCount;b++){const y=await f.getRoundTripTime();if(y===void 0)return;R=Math.min(R,y/2),await(0,T.$Yg)(this.sampleDelay)}this.average.push(R),this.average.length>this.maxAverageCount&&this.average.shift();let L;return this.initial.length<this.maxInitialCount?this.initial.push(R):L=this.initial.reduce((b,y)=>b+y,0)/this.initial.length,this.lastMeasurement={initial:L,current:R,average:this.average.reduce((b,y)=>b+y,0)/this.average.length,high:(()=>typeof L>"u"?!1:R>this.highLatencyMaxThreshold||R>this.highLatencyMinThreshold&&R>L*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(ke[355],Se([1,0,224,86,37,40,44,3,4,155,11,24]),function(me,e,C,T,f,R,L,b,y,g,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=void 0,e.$pH=Object.freeze({id:"application",order:100,title:(0,C.localize)(0,null),type:"object"}),e.$qH=Object.freeze({id:"workbench",order:7,title:(0,C.localize)(1,null),type:"object"}),e.$rH=Object.freeze({id:"security",scope:1,title:(0,C.localize)(2,null),type:"object",order:7}),e.$sH={ConfigurationMigration:"base.contributions.configuration.migration"};class ${constructor(){this.migrations=[],this.a=new y.$Rd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(o){this.migrations.push(...o)}}const v=new $;f.$mn.add(e.$sH.ConfigurationMigration,v);let S=class extends b.$Rc{constructor(o,i){super(),this.a=o,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async n=>{for(const r of n.added)await this.f(r,v.migrations)})),this.c(v.migrations),this.B(v.onDidRegisterConfigurationMigration(n=>this.c(n)))}async c(o){await this.f(void 0,o);for(const i of this.b.getWorkspace().folders)await this.f(i,o)}async f(o,i){await Promise.all([i.map(n=>this.g(n,o?.uri))])}async g(o,i){const n=this.a.inspect(o.key,{resource:i}),r=[["userValue",2],["userLocalValue",3],["userRemoteValue",4],["workspaceValue",5],["workspaceFolderValue",6]];for(const[a,t]of r){const s=[];for(const c of n.overrideIdentifiers??[]){const u=await this.h(o,{resource:i,overrideIdentifier:c},a);for(const h of u??[]){let E=s.find(([[D,m]])=>D===h[0]&&(0,I.$en)(m.value,h[1].value));E||s.push(E=[h,[]]),E[1].push(c)}}const d=await this.h(o,{resource:i},a,n);for(const c of d??[])s.push([c,[]]);s.length&&await Promise.allSettled(s.map(async([[c,u],h])=>this.a.updateValue(c,u.value,{resource:i,overrideIdentifiers:h},t)))}}async h(o,i,n,r){const a=(r??this.a.inspect(o.key,i))[n];if(a===void 0)return;const t=d=>this.a.inspect(d,i)[n],s=await o.migrateFn(a,t);return Array.isArray(s)?s:[[o.key,s]]}};e.$tH=S,e.$tH=S=He([Be(0,L.$pi),Be(1,R.$5h)],S);let w=class extends b.$Rc{constructor(o){super(),(async()=>{if(!A.$i&&(await o.getEnvironment())?.os!==1)return;f.$mn.as(T.$rn.Configuration).registerConfiguration({...e.$rH,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,C.localize)(3,null)},default:[],markdownDescription:(0,C.localize)(4,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,C.localize)(5,null),scope:2}}})})()}};e.$uH=w,e.$uH=w=He([Be(0,g.$zm)],w)}),define(ke[356],Se([1,0,34,17,16,23,233,355,86,5,37]),function(me,e,C,T,f,R,L,b,y,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ybb=e.$Xbb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$Wbb=e.$Vbb=void 0,e.$Vbb=(0,g.$Vh)("editorResolverService"),e.$Wbb="workbench.editorAssociations";const I=A.$mn.as(y.$rn.Configuration),$={...b.$qH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,L.localize)(0,null),additionalProperties:{type:"string"}}}};I.registerConfiguration($);var v;(function(o){o.builtin="builtin",o.option="option",o.exclusive="exclusive",o.default="default"})(v||(e.RegisteredEditorPriority=v={}));var S;(function(o){o[o.ABORT=1]="ABORT",o[o.NONE=2]="NONE"})(S||(e.ResolvedStatus=S={}));function w(o){switch(o){case v.exclusive:return 5;case v.default:return 4;case v.builtin:return 3;case v.option:default:return 1}}e.$Xbb=w;function l(o,i){if(new Set([T.Schemas.extension,T.Schemas.webviewPanel,T.Schemas.vscodeWorkspaceTrust,T.Schemas.vscodeSettings]).has(i.scheme))return!1;const a=typeof o=="string"&&o.indexOf(f.$fc.sep)>=0?`${i.scheme}:${i.path}`:(0,R.$wg)(i);return C.$Bj(typeof o=="string"?o.toLowerCase():o,a.toLowerCase())}e.$Ybb=l}),define(ke[357],Se([1,0,33,17,16,11,23,2,5,268,40,146,155]),function(me,e,C,T,f,R,L,b,y,g,A,I,$){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$cK=e.$bK=void 0,e.$bK=(0,y.$Vh)("pathService");let S=v=class{constructor(l,o,i,n){this.d=l,this.e=o,this.f=i,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const r=await this.e.getEnvironment();return this.c=r?.userHome??l})()}hasValidBasename(l,o,i){return typeof o=="string"||typeof o>"u"?this.a.then(n=>this.h(l,n,o)):this.h(l,o,i)}h(l,o,i){return l.scheme===T.Schemas.file||l.scheme===T.Schemas.vscodeRemote?(0,C.$Zf)(i??(0,L.$wg)(l),o===1):!0}get defaultUriScheme(){return v.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(l,o){if(l.remoteAuthority)return T.Schemas.vscodeRemote;const i=(0,g.$$J)(o.getWorkspace());if(i)return i;const n=o.getWorkspace().folders[0];if(n)return n.uri.scheme;const r=o.getWorkspace().configuration;return r?r.scheme:T.Schemas.file}userHome(l){return l?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(l=>l===1?f.$ec:f.$fc)}async fileURI(l){let o="";if(await this.a===1&&(l=l.replace(/\\/g,"/")),l[0]==="/"&&l[1]==="/"){const n=l.indexOf("/",2);n===-1?(o=l.substring(2),l="/"):(o=l.substring(2,n),l=l.substring(n)||"/")}return b.URI.from({scheme:T.Schemas.file,authority:o,path:l,query:"",fragment:""})}};e.$cK=S,e.$cK=S=v=He([Be(1,$.$zm),Be(2,I.$WJ),Be(3,A.$5h)],S)}),define(ke[358],Se([1,0,235,19,59,4,52,3,2,44,240,14,64,270,88,40,146,25,21,18,24,45]),function(me,e,C,T,f,R,L,b,y,g,A,I,$,v,S,w,l,o,i,n,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8J=e.$7J=e.$6J=e.OnPortForward=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.TunnelSource=e.TunnelCloseReason=e.$ZJ=e.$YJ=e.$XJ=void 0;const t=10*1e3,s="remote.tunnels.toRestore";e.$XJ="onTunnel",e.$YJ=new a.$aj("forwardedPortsViewEnabled",!1,C.localize(0,null));function d(z){const j=z.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(j)return{host:j[1]?.substring(0,j[1].length-1)||"localhost",port:Number(j[2])}}e.$ZJ=d;var c;(function(z){z.Other="Other",z.User="User",z.AutoForwardEnd="AutoForwardEnd"})(c||(e.TunnelCloseReason=c={}));var u;(function(z){z[z.User=0]="User",z[z.Auto=1]="Auto",z[z.Extension=2]="Extension"})(u||(e.TunnelSource=u={})),e.$1J={source:u.User,description:C.localize(1,null)},e.$2J={source:u.Auto,description:C.localize(2,null)};function h(z,j,M){const O=z.get(D(j,M));if(O)return O;if((0,S.$iv)(j))for(const F of S.$hv){const N=D(F,M);if(z.has(N))return z.get(N)}else if((0,S.$kv)(j))for(const F of S.$jv){const N=D(F,M);if(z.has(N))return z.get(N)}}e.$3J=h;function E(z,j,M){const O=h(z,j,M);if(O)return O;const F=(0,S.$kv)(j)?"localhost":(0,S.$iv)(j)?"0.0.0.0":void 0;if(F)return h(z,F,M)}e.$4J=E;function D(z,j){return z+":"+j}e.$5J=D;var m;(function(z){z.Notify="notify",z.OpenBrowser="openBrowser",z.OpenBrowserOnce="openBrowserOnce",z.OpenPreview="openPreview",z.Silent="silent",z.Ignore="ignore"})(m||(e.OnPortForward=m={}));function p(z){return z&&"host"in z&&typeof z.host=="string"&&"port"in z&&typeof z.port=="number"&&(!("detail"in z)||typeof z.detail=="string")&&(!("pid"in z)||typeof z.pid=="string")}e.$6J=p;class k extends b.$Rc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(j){super(),this.r=j,this.j=[],this.n=new R.$Rd,this.onDidChangeAttributes=this.n.event,this.B(j.onDidChangeConfiguration(M=>{(M.affectsConfiguration(k.c)||M.affectsConfiguration(k.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(j,M,O){let F=this.w(j,M,O,this.j,0);const N={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;F>=0;){const W=this.j[F];W.key===j?(N.onAutoForward=W.onAutoForward??N.onAutoForward,N.elevateIfNeeded=W.elevateIfNeeded!==void 0?W.elevateIfNeeded:N.elevateIfNeeded,N.label=W.label??N.label,N.requireLocalPort=W.requireLocalPort,N.protocol=W.protocol):(N.onAutoForward=N.onAutoForward??W.onAutoForward,N.elevateIfNeeded=N.elevateIfNeeded!==void 0?N.elevateIfNeeded:W.elevateIfNeeded,N.label=N.label??W.label,N.requireLocalPort=N.requireLocalPort!==void 0?N.requireLocalPort:void 0,N.protocol=N.protocol??W.protocol),F=this.w(j,M,O,this.j,F+1)}return N.onAutoForward!==void 0||N.elevateIfNeeded!==void 0||N.label!==void 0||N.requireLocalPort!==void 0||N.protocol!==void 0?N:this.C()}t(j){return j.start!==void 0&&j.end!==void 0}u(j){return j.host!==void 0&&j.port!==void 0&&(0,n.$Cf)(j.host)&&(0,n.$Gf)(j.port)}w(j,M,O,F,N){if(N>=F.length)return-1;const W=!(0,S.$iv)(M)&&!(0,S.$kv)(M),ce=F.slice(N).findIndex(J=>(0,n.$Gf)(J.key)?W?!1:J.key===j:this.t(J.key)?W?!1:j>=J.key.start&&j<=J.key.end:this.u(J.key)?j===J.key.port&&M===J.key.host:O?J.key.test(O):!1);return ce>=0?ce+N:-1}y(){const j=this.r.getValue(k.c);if(!j||!(0,n.$Ef)(j))return[];const M=[];for(const F in j){if(F===void 0)continue;const N=j[F];let W;if(Number(F))W=Number(F);else if((0,n.$Cf)(F))if(k.g.test(F)){const X=F.match(k.g);W={start:Number(X[1]),end:Number(X[2])}}else if(k.h.test(F)){const X=F.match(k.h);W={host:X[1],port:Number(X[2])}}else{let X;try{X=RegExp(F)}catch{}X&&(W=X)}W&&M.push({key:W,elevateIfNeeded:N.elevateIfNeeded,onAutoForward:N.onAutoForward,label:N.label,requireLocalPort:N.requireLocalPort,protocol:N.protocol})}const O=this.r.getValue(k.f);return O&&(this.m={elevateIfNeeded:O.elevateIfNeeded,label:O.label,onAutoForward:O.onAutoForward,requireLocalPort:O.requireLocalPort,protocol:O.protocol}),this.z(M)}z(j){function M(O,F){return(0,n.$Gf)(O.key)?O.key:F.t(O.key)?O.key.start:F.u(O.key)?O.key.port:Number.MAX_VALUE}return j.sort((O,F)=>M(O,this)-M(F,this))}C(){return this.m}static providedActionToAction(j){switch(j){case S.ProvidedOnAutoForward.Notify:return m.Notify;case S.ProvidedOnAutoForward.OpenBrowser:return m.OpenBrowser;case S.ProvidedOnAutoForward.OpenBrowserOnce:return m.OpenBrowserOnce;case S.ProvidedOnAutoForward.OpenPreview:return m.OpenPreview;case S.ProvidedOnAutoForward.Silent:return m.Silent;case S.ProvidedOnAutoForward.Ignore:return m.Ignore;default:return}}async addAttributes(j,M,O){const N=this.r.inspect(k.c).userRemoteValue;let W;!N||!(0,n.$Ef)(N)?W={}:W=(0,r.$an)(N),W[`${j}`]||(W[`${j}`]={});for(const X in M)W[`${j}`][X]=M[X];return this.r.updateValue(k.c,W,O)}}e.$7J=k;let P=class extends b.$Rc{constructor(j,M,O,F,N,W,X,ce,J,Q){super(),this.H=j,this.I=M,this.J=O,this.L=F,this.M=N,this.N=W,this.O=X,this.P=ce,this.Q=J,this.R=Q,this.c=new Map,this.g=new R.$Rd,this.onForwardPort=this.g.event,this.h=new R.$Rd,this.onClosePort=this.h.event,this.j=new R.$Rd,this.onPortName=this.j.event,this.n=new R.$Rd,this.onCandidatesChanged=this.n.event,this.t=new R.$Rd,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new R.$Rd,this.D=new Map,this.F=new Map,this.G=[],this.ab=new Date,this.configPortsAttributes=new k(O),this.s=this.Z(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.gb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async G=>{const oe=await this.getAttributes(G.map(_=>({port:_.tunnelRemotePort,host:_.tunnelRemoteHost})));for(const _ of G)if(_.localAddress){const Ee=D(_.tunnelRemoteHost,_.tunnelRemotePort),he=E(this.m??new Map,_.tunnelRemoteHost,_.tunnelRemotePort);this.forwarded.set(Ee,{remotePort:_.tunnelRemotePort,remoteHost:_.tunnelRemoteHost,localAddress:_.localAddress,protocol:oe?.get(_.tunnelRemotePort)?.protocol??S.TunnelProtocol.Http,localUri:await this.X(_.localAddress,oe?.get(_.tunnelRemotePort)),localPort:_.tunnelLocalPort,runningProcess:he?.detail,hasRunningProcess:!!he,pid:he?.pid,privacy:_.privacy,source:e.$1J}),this.f.set(Ee,_)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async G=>{const oe=D(G.tunnelRemoteHost,G.tunnelRemotePort);if(!E(this.forwarded,G.tunnelRemoteHost,G.tunnelRemotePort)&&!E(this.detected,G.tunnelRemoteHost,G.tunnelRemotePort)&&!E(this.c,G.tunnelRemoteHost,G.tunnelRemotePort)&&G.localAddress){const _=E(this.m??new Map,G.tunnelRemoteHost,G.tunnelRemotePort),Ee=(await this.getAttributes([{port:G.tunnelRemotePort,host:G.tunnelRemoteHost}]))?.get(G.tunnelRemotePort);this.forwarded.set(oe,{remoteHost:G.tunnelRemoteHost,remotePort:G.tunnelRemotePort,localAddress:G.localAddress,protocol:Ee?.protocol??S.TunnelProtocol.Http,localUri:await this.X(G.localAddress,Ee),localPort:G.tunnelLocalPort,closeable:!0,runningProcess:_?.detail,hasRunningProcess:!!_,pid:_?.pid,privacy:G.privacy,source:e.$1J})}await this.$(),this.f.set(oe,G),this.g.fire(this.forwarded.get(oe))})),this.B(this.H.onTunnelClosed(G=>this.W(G,c.Other))),this.U()}S(){return this.Q.extensions.find(j=>j.activationEvents?.includes(e.$XJ))?(this.R.createKey(e.$YJ.key,!0),!0):!1}U(){if(this.S())return;const j=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&j.dispose()}))}async W(j,M){const O=D(j.host,j.port);this.forwarded.has(O)&&(this.forwarded.delete(O),await this.$(),this.h.fire(j))}X(j,M){if(j.startsWith("http"))return y.URI.parse(j);const O=M?.protocol??"http";return y.URI.parse(`${O}://${j}`)}async Y(){const j=this.N.getWorkspace(),M=j.configuration?(0,L.$Ji)(j.configuration.path):j.folders.length>0?(0,L.$Ji)(j.folders[0].uri.path):void 0;if(M===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${s}.${this.L.remoteAuthority}.${M}`}async Z(){const j=this.I.get(s,1);if(j)return this.I.remove(s,1),await this.$(),j;const M=await this.Y();if(M)return this.I.get(M,0)}async restoreForwarded(){if(this.J.getValue("remote.restoreForwardedPorts")){const j=await this.s;if(j&&j!==this.y){const M=JSON.parse(j)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${M.map(O=>O.remotePort).join(", ")}`);for(const O of M){const F=E(this.detected,O.remoteHost,O.remotePort);O.source.source!==u.Extension&&!F||O.source.source===u.Extension&&F?await this.cb({remote:{host:O.remoteHost,port:O.remotePort},local:O.localPort,name:O.name,privacy:O.privacy,elevateIfNeeded:!0,source:O.source}):O.source.source===u.Extension&&!F&&this.D.set(D(O.remoteHost,O.remotePort),O)}}}if(this.z=!0,this.C.fire(),!this.w){const j=await this.Y();this.w=this.B(new b.$Qc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async M=>{M.key===j&&(this.s=Promise.resolve(this.I.get(j,0)),await this.restoreForwarded())}))}}async $(){if(this.J.getValue("remote.restoreForwardedPorts")){const j=JSON.stringify(Array.from(this.forwarded.values()));if(j!==this.y){this.y=j;const M=await this.Y();M&&this.I.store(M,this.y,0,0)}}}async bb(j,M,O){if(!j.tunnelLocalPort||!O?.requireLocalPort||j.tunnelLocalPort===M)return;const F=new Date;if(this.ab.getTime()+t>F.getTime())return;this.ab=F;const N=C.localize(3,null,M,j.tunnelRemotePort,j.tunnelLocalPort);return this.P.info(N)}async forward(j,M){return!this.z&&this.L.remoteAuthority&&await R.Event.toPromise(this.C.event),this.cb(j,M)}async cb(j,M){await this.Q.activateByEvent(e.$XJ);const O=E(this.forwarded,j.remote.host,j.remote.port);M=M??(M!==null?(await this.getAttributes([j.remote]))?.get(j.remote.port):void 0);const F=j.local!==void 0?j.local:j.remote.port;let N;if(O)return this.eb(O,j,M);{const W=this.L.remoteAuthority,X=W?{getAddress:async()=>(await this.M.resolveAuthority(W)).authority}:void 0,ce=D(j.remote.host,j.remote.port);this.c.set(ce,!0),j=this.db(ce,j);const J=await this.H.openTunnel(X,j.remote.host,j.remote.port,void 0,F,j.elevateIfNeeded?j.elevateIfNeeded:M?.elevateIfNeeded,j.privacy,M?.protocol);if(typeof J=="string")N=J;else if(J&&J.localAddress){const Q=E(this.m??new Map,j.remote.host,j.remote.port),G=J.protocol?J.protocol===S.TunnelProtocol.Https?S.TunnelProtocol.Https:S.TunnelProtocol.Http:M?.protocol??S.TunnelProtocol.Http,oe={remoteHost:J.tunnelRemoteHost,remotePort:J.tunnelRemotePort,localPort:J.tunnelLocalPort,name:M?.label??j.name,closeable:!0,localAddress:J.localAddress,protocol:G,localUri:await this.X(J.localAddress,M),runningProcess:Q?.detail,hasRunningProcess:!!Q,pid:Q?.pid,source:j.source??e.$1J,privacy:J.privacy};return this.forwarded.set(ce,oe),this.f.set(ce,J),this.c.delete(ce),await this.$(),await this.bb(J,F,M),this.g.fire(oe),J}this.c.delete(ce)}return N}db(j,M){const O=this.D.has(j)?this.D:this.F.has(j)?this.F:void 0;if(O){const F=O.get(j);O.delete(j),F&&(M.name=F.name??M.name,M.local=("local"in F?F.local:"localPort"in F?F.localPort:void 0)??M.local,M.privacy=F.privacy??M.privacy)}return M}async eb(j,M,O){const F=O?.label??M.name;let N;(function(X){X[X.None=0]="None",X[X.Fire=1]="Fire",X[X.Reopen=2]="Reopen"})(N||(N={}));let W=N.None;switch(F!==j.name&&(j.name=F,W=N.Fire),(O?.protocol||j.protocol!==S.TunnelProtocol.Http)&&O?.protocol!==j.protocol&&(M.source=j.source,W=N.Reopen),M.privacy&&j.privacy!==M.privacy&&(W=N.Reopen),W){case N.Fire:{this.g.fire();break}case N.Reopen:await this.close(j.remoteHost,j.remotePort,c.User),await this.cb(M,O)}return E(this.f,M.remote.host,M.remote.port)}async name(j,M,O){const F=E(this.forwarded,j,M),N=D(j,M);if(F){F.name=O,await this.$(),this.j.fire({host:j,port:M});return}else this.detected.has(N)&&(this.detected.get(N).name=O,this.j.fire({host:j,port:M}))}async close(j,M,O){const F=D(j,M),N=this.forwarded.get(F);return O===c.AutoForwardEnd&&N&&N.source.source===u.Auto&&this.F.set(F,{local:N.localPort,name:N.name,privacy:N.privacy}),await this.H.closeTunnel(j,M),this.W({host:j,port:M},O)}address(j,M){const O=D(j,M);return(this.forwarded.get(O)||this.detected.get(O))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(j){if(j)for(const M of j){const O=E(this.m??new Map,M.remoteAddress.host,M.remoteAddress.port),F=typeof M.localAddress=="string"?M.localAddress:D(M.localAddress.host,M.localAddress.port);this.detected.set(D(M.remoteAddress.host,M.remoteAddress.port),{remoteHost:M.remoteAddress.host,remotePort:M.remoteAddress.port,localAddress:F,protocol:S.TunnelProtocol.Http,localUri:this.X(F),closeable:!1,runningProcess:O?.detail,hasRunningProcess:!!O,pid:O?.pid,privacy:S.TunnelPrivacyId.ConstantPrivate,source:{source:u.Extension,description:C.localize(4,null)}}),this.H.setEnvironmentTunnel(M.remoteAddress.host,M.remoteAddress.port,F,S.TunnelPrivacyId.ConstantPrivate,S.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(j){this.r=j}async setCandidates(j){let M=j;this.r&&(M=await this.r(j));const O=this.fb(M);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(O.values()).map(F=>F.port).join(", ")}`),this.n.fire(O)}fb(j){const M=this.m??new Map,O=new Map;return this.m=O,j.forEach(F=>{const N=D(F.host,F.port);O.set(N,{host:F.host,port:F.port,detail:F.detail,pid:F.pid}),M.has(N)&&M.delete(N);const W=E(this.forwarded,F.host,F.port);W&&(W.runningProcess=F.detail,W.hasRunningProcess=!0,W.pid=F.pid)}),M.forEach((F,N)=>{const W=d(N);if(!W)return;const X=E(this.forwarded,W.host,W.port);X&&(X.runningProcess=void 0,X.hasRunningProcess=!1,X.pid=void 0);const ce=E(this.detected,W.host,W.port);ce&&(ce.runningProcess=void 0,ce.hasRunningProcess=!1,ce.pid=void 0)}),M}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async gb(){const j=Array.from(this.forwarded.values()),M=await this.getAttributes(j.map(O=>({port:O.remotePort,host:O.remoteHost})),!1);if(M)for(const O of j){const F=M.get(O.remotePort);(F?.protocol||O.protocol!==S.TunnelProtocol.Http)&&F?.protocol!==O.protocol&&await this.cb({remote:{host:O.remoteHost,port:O.remotePort},local:O.localPort,name:O.name,source:O.source},F),F&&F.label&&F.label!==O.name&&await this.name(O.remoteHost,O.remotePort,F.label)}}async getAttributes(j,M=!0){const O=new Map,F=new Map;j.forEach(J=>{const Q=E(this.m??new Map,S.$hv[0],J.port)??J;if(Q){O.set(J.port,Q);const G=p(Q)?Q.pid:void 0;F.has(G)||F.set(G,[]),F.get(G)?.push(J.port)}});const N=new Map;if(j.forEach(J=>{const Q=this.configPortsAttributes.getAttributes(J.port,J.host,O.get(J.port)?.detail);Q&&N.set(J.port,Q)}),this.G.length===0||!M)return N.size>0?N:void 0;const W=await Promise.all((0,T.$Qb)(this.G.map(J=>Array.from(F.entries()).map(Q=>{const G=Q[1],oe=O.get(G[0]);return J.providePortAttributes(G,oe?.pid,oe?.detail,new i.$2d().token)})))),X=new Map;if(W.forEach(J=>J.forEach(Q=>{Q&&X.set(Q.port,Q)})),!N&&!X)return;const ce=new Map;return j.forEach(J=>{const Q=N.get(J.port),G=X.get(J.port);ce.set(J.port,{elevateIfNeeded:Q?.elevateIfNeeded,label:Q?.label,onAutoForward:Q?.onAutoForward??k.providedActionToAction(G?.autoForwardAction),requireLocalPort:Q?.requireLocalPort,protocol:Q?.protocol})}),ce}addAttributesProvider(j){this.G.push(j)}};e.$8J=P,He([(0,f.$oh)(1e3)],P.prototype,"$",null),e.$8J=P=He([Be(0,S.$dv),Be(1,v.$_o),Be(2,g.$pi),Be(3,l.$WJ),Be(4,$.$Vk),Be(5,w.$5h),Be(6,I.$dj),Be(7,A.$Iv),Be(8,o.$JF),Be(9,a.$bj)],P)}),define(ke[94],Se([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$RI=e.$QI=void 0;class C{constructor(L,b){this.line=L,this.character=b}isBefore(L){return!1}isBeforeOrEqual(L){return!1}isAfter(L){return!1}isAfterOrEqual(L){return!1}isEqual(L){return!1}compareTo(L){return 0}translate(L,b){return new C(0,0)}with(L){return new C(0,0)}}e.$QI=C;class T{constructor(L,b,y,g){this.isEmpty=!1,this.isSingleLine=!1,this.start=new C(L,b),this.end=new C(y,g)}contains(L){return!1}isEqual(L){return!1}intersection(L){}union(L){return new T(0,0,0,0)}with(L){return new T(0,0,0,0)}}e.$RI=T;var f;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(f||(e.TextSearchCompleteMessageType=f={}))}),define(ke[36],Se([1,0,19,34,24,33,13,5,16,8,94,12]),function(me,e,C,T,f,R,L,b,y,g,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.SearchErrorCode=e.$7I=e.$6I=e.SearchSortOrder=e.ViewMode=e.$5I=e.$4I=e.$3I=e.$2I=e.SearchCompletionExitCode=e.$1I=e.$ZI=e.$YI=e.QueryType=e.SearchProviderType=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$SI="workbench.view.search",e.$TI="workbench.panel.search",e.$UI="workbench.view.search",e.$VI="search-result",e.$WI="search.exclude";const $="\u27EA ",v=" characters skipped \u27EB",S=($.length+v.length+5)*2;e.$XI=(0,b.$Vh)("searchService");var w;(function(G){G[G.file=0]="file",G[G.text=1]="text"})(w||(e.SearchProviderType=w={}));var l;(function(G){G[G.File=1]="File",G[G.Text=2]="Text"})(l||(e.QueryType=l={}));function o(G){return!!G.preview}e.$YI=o;function i(G){return!!G.resource}e.$ZI=i;function n(G){return!!G.message}e.$1I=n;var r;(function(G){G[G.Normal=0]="Normal",G[G.NewSearchStarted=1]="NewSearchStarted"})(r||(e.SearchCompletionExitCode=r={}));class a{constructor(oe){this.resource=oe,this.results=[]}}e.$2I=a;class t{constructor(oe,_,Ee,he){this.ranges=_,this.webviewIndex=he;const q=Array.isArray(_)?_:[_];if(Ee&&Ee.matchLines===1&&s(q)){oe=(0,L.$vf)(oe,Ee.matchLines);let U="",ne=0,be=0;const H=Math.floor(Ee.charsPerLine/5),x=[];for(const Y of q){const $e=Math.max(Y.startColumn-H,0),ie=Y.startColumn+Ee.charsPerLine;if($e>be+H+S){const fe=$+($e-be)+v;U+=fe+oe.slice($e,ie),ne+=$e-(be+fe.length)}else U+=oe.slice(be,ie);x.push(new c(0,Y.startColumn-ne,Y.endColumn-ne)),be=ie}this.preview={text:U,matches:Array.isArray(this.ranges)?x:x[0]}}else{const U=Array.isArray(_)?_[0].startLineNumber:_.startLineNumber;this.preview={text:oe,matches:(0,C.$1b)(_,ne=>new d(ne.startLineNumber-U,ne.startColumn,ne.endLineNumber-U,ne.endColumn))}}}}e.$3I=t;function s(G){const oe=G[0].startLineNumber;for(const _ of G)if(_.startLineNumber!==oe||_.endLineNumber!==oe)return!1;return!0}class d{constructor(oe,_,Ee,he){this.startLineNumber=oe,this.startColumn=_,this.endLineNumber=Ee,this.endColumn=he}}e.$4I=d;class c extends d{constructor(oe,_,Ee){super(oe,_,oe,Ee)}}e.$5I=c;var u;(function(G){G.List="list",G.Tree="tree"})(u||(e.ViewMode=u={}));var h;(function(G){G.Default="default",G.FileNames="fileNames",G.Type="type",G.Modified="modified",G.CountDescending="countDescending",G.CountAscending="countAscending"})(h||(e.SearchSortOrder=h={}));function E(G,oe=!0){const _=G&&G.files&&G.files.exclude,Ee=oe&&G&&G.search&&G.search.exclude;if(!_&&!Ee)return;if(!_||!Ee)return _||Ee;let he=Object.create(null);return he=f.$dn(he,f.$an(_)),he=f.$dn(he,f.$an(Ee),!0),he}e.$6I=E;function D(G,oe){return G.excludePattern&&T.$Bj(G.excludePattern,oe)?!1:G.includePattern||G.usingSearchPaths?G.includePattern&&T.$Bj(G.includePattern,oe)?!0:G.usingSearchPaths?!!G.folderQueries&&G.folderQueries.some(_=>{const Ee=_.folder.fsPath;if(R.$2f(oe,Ee)){const he=y.$kc(Ee,oe);return!_.includePattern||!!T.$Bj(_.includePattern,he)}else return!1}):!1:!0}e.$7I=D;var m;(function(G){G[G.unknownEncoding=1]="unknownEncoding",G[G.regexParseError=2]="regexParseError",G[G.globParseError=3]="globParseError",G[G.invalidLiteral=4]="invalidLiteral",G[G.rgProcessError=5]="rgProcessError",G[G.other=6]="other",G[G.canceled=7]="canceled"})(m||(e.SearchErrorCode=m={}));class p extends Error{constructor(oe,_){super(oe),this.code=_}}e.$8I=p;function k(G){const oe=G.message;if((0,g.$3)(G))return new p(oe,m.canceled);try{const _=JSON.parse(oe);return new p(_.message,_.code)}catch{return new p(oe,m.other)}}e.$9I=k;function P(G){const oe={message:G.message,code:G.code};return new Error(JSON.stringify(oe))}e.$0I=P;function z(G){return G.type==="error"?!0:G.type==="success"}e.$$I=z;function j(G){return G.type==="success"}e.$_I=j;function M(G){return!!G.path}e.$aJ=M;function O(G,oe){const _=G.searchPath?G.searchPath:G.relativePath;return(0,L.$sf)(_,oe)}e.$bJ=O;class F{constructor(oe){this.path=oe,this.results=[]}addMatch(oe){this.results.push(oe)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$cJ=F;function N(G,oe){const _={...G||{},...oe||{}};return Object.keys(_).filter(Ee=>{const he=_[Ee];return typeof he=="boolean"&&he})}e.$dJ=N;class W{constructor(oe,_){this.c=null,this.a={...oe.excludePattern||{},..._.excludePattern||{}},this.b=T.$Cj(this.a);let Ee=oe.includePattern;_.includePattern&&(Ee?Ee={...Ee,..._.includePattern}:Ee=_.includePattern),Ee&&(this.c=T.$Cj(Ee))}matchesExcludesSync(oe,_,Ee){return!!(this.b&&this.b(oe,_,Ee))}includedInQuerySync(oe,_,Ee){return!(this.b&&this.b(oe,_,Ee)||this.c&&!this.c(oe,_,Ee))}includedInQuery(oe,_,Ee){const he=this.b(oe,_,Ee),q=()=>this.c?!!this.c(oe,_,Ee):!0;return(0,I.$Kg)(he)?he.then(U=>U?!1:q()):q()}hasSiblingExcludeClauses(){return X(this.a)}}e.$eJ=W;function X(G){for(const oe in G)if(typeof G[oe]!="boolean")return!0;return!1}function ce(G){if(!G)return;let oe;return _=>(oe||(oe=(G()||Promise.resolve([])).then(Ee=>Ee?Q(Ee):{})),oe.then(Ee=>!!Ee[_]))}e.$fJ=ce;function J(G){if(!G)return;let oe;return _=>{if(!oe){const Ee=G();oe=Ee?Q(Ee):{}}return!!oe[_]}}e.$gJ=J;function Q(G){const oe={};for(const _ of G)oe[_]=!0;return oe}}),define(ke[41],Se([1,0,19,12,21,4,3,77,17,123,23,13,2,222,5,14,253,40,57,27,20,15,7,66,36,6,54]),function(me,e,C,T,f,R,L,b,y,g,A,I,$,v,S,w,l,o,i,n,r,a,t,s,d,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7dc=e.$6dc=void 0;function h(j,M,O){return new A.$og(F=>p(F,O)).isEqual(j,M)}function E(j,M,O){return h(j.uri,M.uri,O)?0:(0,I.$Ye)(j.uri.toString(),M.uri.toString())}function D(j,M,O){return j.index!==M.index?j.index<M.index?-1:1:h(j.uri,M.uri,O)?(0,I.$Ye)(j.name,M.name):(0,I.$Ye)(j.uri.toString(),M.uri.toString())}function m(j,M,O,F){const N=j.slice(0).sort((X,ce)=>O(X,ce,F)),W=M.slice(0).sort((X,ce)=>O(X,ce,F));return(0,C.$Db)(N,W,(X,ce)=>O(X,ce,F))}function p(j,M){const O=M.getCapabilities(j.scheme);return!(O&&O&1024)}class k extends o.$ci{static toExtHostWorkspace(M,O,F,N){if(!M)return{workspace:null,added:[],removed:[]};const{id:W,name:X,folders:ce,configuration:J,transient:Q,isUntitled:G}=M,oe=[],_=O;O?ce.forEach((U,ne)=>{const be=$.URI.revive(U.uri),H=k.o(F||O,be,N);H?(H.name=U.name,H.index=U.index,oe.push(H)):oe.push({uri:be,name:U.name,index:ne})}):oe.push(...ce.map(({uri:U,name:ne,index:be})=>({uri:$.URI.revive(U),name:ne,index:be}))),oe.sort((U,ne)=>U.index<ne.index?-1:1);const Ee=new k(W,X,oe,!!Q,J?$.URI.revive(J):null,!!G,U=>p(U,N)),{added:he,removed:q}=m(_?_.workspaceFolders:[],Ee.workspaceFolders,E,N);return{workspace:Ee,added:he,removed:q}}static o(M,O,F){for(let N=0;N<M.folders.length;N++){const W=M.workspaceFolders[N];if(h(W.uri,O,F))return W}}constructor(M,O,F,N,W,X,ce){super(M,F.map(J=>new o.$di(J)),N,W,ce),this.t=O,this.u=X,this.q=[],this.s=b.$2h.forUris(ce),F.forEach(J=>{this.q.push(J),this.s.set(J.uri,J)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(M,O){return O&&this.s.get(M)&&(M=(0,A.$yg)(M)),this.s.findSubstr(M)}resolveWorkspaceFolder(M){return this.s.get(M)}}let P=class{constructor(M,O,F,N,W){this.c=new R.$Rd,this.onDidChangeWorkspace=this.c.event,this.g=new R.$Rd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new R.$Td,this.B=new Map,this.h=N,this.s=F,this.t=W,this.j=new g.$Wl,this.k=new T.$Wg,this.o=M.getProxy(c.$zK.MainThreadWorkspace),this.q=M.getProxy(c.$zK.MainThreadMessageService);const X=O.workspace;this.l=X?new k(X.id,X.name,[],!!X.transient,X.configuration?$.URI.revive(X.configuration):null,!!X.isUntitled,ce=>p(ce,F)):void 0}$initializeWorkspace(M,O){this.v=O,this.$acceptWorkspaceData(M),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?$.URI.from({scheme:y.Schemas.untitled,path:(0,A.$wg)((0,A.$yg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(M,O,F,...N){const W=[];if(Array.isArray(N)&&N.forEach(G=>{$.URI.isUri(G.uri)&&!W.some(oe=>h(oe.uri,G.uri,this.s))&&W.push({uri:G.uri,name:G.name||(0,A.$vg)(G.uri)})}),this.n||[O,F].some(G=>typeof G!="number"||G<0)||F===0&&W.length===0)return!1;const X=this.x?this.x.workspaceFolders:[];if(O+F>X.length)return!1;const ce=X.slice(0);ce.splice(O,F,...W.map(G=>({uri:G.uri,name:G.name||(0,A.$vg)(G.uri),index:void 0})));for(let G=0;G<ce.length;G++){const oe=ce[G];if(ce.some((_,Ee)=>Ee!==G&&h(oe.uri,_.uri,this.s)))return!1}ce.forEach((G,oe)=>G.index=oe);const{added:J,removed:Q}=m(X,ce,D,this.s);if(J.length===0&&Q.length===0)return!1;if(this.o){const G=M.displayName||M.name;this.o.$updateWorkspaceFolders(G,O,F,W).then(void 0,oe=>{this.n=void 0;const _={source:{identifier:M.identifier,label:M.displayName||M.name}};this.q.$showMessage(l.Severity.Error,(0,v.localize)(0,null,G,oe.toString()),_,[])})}return this.y(ce),!0}getWorkspaceFolder(M,O){if(this.x)return this.x.getWorkspaceFolder(M,O)}async getWorkspaceFolder2(M,O){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(M,O)}async resolveWorkspaceFolder(M){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(M)}getPath(){if(!this.x)return;const{folders:M}=this.x;if(M.length!==0)return M[0].uri.fsPath}getRelativePath(M,O){let F,N="";if(typeof M=="string"?(F=$.URI.file(M),N=M):typeof M<"u"&&(F=M,N=M.fsPath),!F)return N;const W=this.getWorkspaceFolder(F,!0);if(!W)return N;typeof O>"u"&&this.x&&(O=this.x.folders.length>1);let X=(0,A.$Bg)(W.uri,F);return O&&W.name&&(X=`${W.name}/${X}`),X}y(M){this.x&&(this.n=k.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:M,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(M){const{workspace:O,added:F,removed:N}=k.toExtHostWorkspace(M,this.l,this.n,this.s);this.l=O||void 0,this.n=void 0,this.c.fire(Object.freeze({added:F,removed:N}))}findFiles(M,O,F,N,W=f.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${N.value}, entryPoint: findFiles`);let X;if(O===null?X=!1:O&&(typeof O=="string"?X=O:X=O.pattern),W&&W.isCancellationRequested)return Promise.resolve([]);const{includePattern:ce,folder:J}=z(a.GlobPattern.from(M));return this.o.$startFileSearch(ce??null,J??null,X??null,F??null,W).then(Q=>Array.isArray(Q)?Q.map(G=>$.URI.revive(G)):[])}async findTextInFiles(M,O,F,N,W=f.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${N.value}, entryPoint: findTextInFiles`);const X=this.j.getNext(),ce=typeof O.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:O.previewOptions,{includePattern:J,folder:Q}=z(a.GlobPattern.from(O.include)),G=typeof O.exclude=="string"?O.exclude:O.exclude?O.exclude.pattern:void 0,oe={ignoreSymlinks:typeof O.followSymlinks=="boolean"?!O.followSymlinks:void 0,disregardIgnoreFiles:typeof O.useIgnoreFiles=="boolean"?!O.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof O.useGlobalIgnoreFiles=="boolean"?!O.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof O.useParentIgnoreFiles=="boolean"?!O.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof O.useDefaultExcludes=="boolean"?!O.useDefaultExcludes:!0,fileEncoding:O.encoding,maxResults:O.maxResults,previewOptions:ce,afterContext:O.afterContext,beforeContext:O.beforeContext,includePattern:J,excludePattern:G},_=!1;if(this.u[X]=Ee=>{if(_)return;const he=$.URI.revive(Ee.resource);Ee.results.forEach(q=>{const U=(0,u.$sh)(q);(0,d.$YI)(U)?F({uri:he,preview:{text:U.preview.text,matches:(0,C.$1b)(U.preview.matches,ne=>new t.$DK(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,C.$1b)(U.ranges,ne=>new t.$DK(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):F({uri:he,text:U.text,lineNumber:U.lineNumber})})},W.isCancellationRequested)return{};try{const Ee=await this.o.$startTextSearch(M,Q??null,oe,X,W);return delete this.u[X],Ee||{}}catch(Ee){throw delete this.u[X],Ee}}$handleTextSearchResult(M,O){this.u[O]?.(M)}async save(M){const O=await this.o.$save(M,{saveAs:!1});return $.URI.revive(O)}async saveAs(M){const O=await this.o.$save(M,{saveAs:!0});return $.URI.revive(O)}saveAll(M){return this.o.$saveAll(M)}resolveProxy(M){return this.o.$resolveProxy(M)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(M){return this.o.$requestWorkspaceTrust(M)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(M,O){if(this.w.has(M))throw new Error(`A provider has already been registered for scheme ${M}`);this.w.set(M,O);const F=this.t.transformOutgoingScheme(M),N=this.z++;return this.o.$registerEditSessionIdentityProvider(N,F),(0,L.$Pc)(()=>{this.w.delete(M),this.o.$unregisterEditSessionIdentityProvider(N)})}async $getEditSessionIdentifier(M,O){this.h.info("Getting edit session identifier for workspaceFolder",M);const F=await this.resolveWorkspaceFolder($.URI.revive(M));if(!F){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const N=this.w.get(F.uri.scheme);if(this.h.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!N),!N)return;const W=await N.provideEditSessionIdentity(F,O);if(this.h.info("Provider returned edit session identifier: ",W),!!W)return W}async $provideEditSessionIdentityMatch(M,O,F,N){this.h.info("Getting edit session identifier for workspaceFolder",M);const W=await this.resolveWorkspaceFolder($.URI.revive(M));if(!W){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",W);const X=this.w.get(W.uri.scheme);if(this.h.info(`Provider for scheme ${W.uri.scheme} is defined: `,!!X),!X)return;const ce=await X.provideEditSessionIdentityMatch?.(O,F,N);if(this.h.info("Provider returned edit session identifier match result: ",ce),!!ce)return ce}getOnWillCreateEditSessionIdentityEvent(M){return(O,F,N)=>{const W=function(ce){O.call(F,ce)};return W.extension=M,this.A.event(W,void 0,N)}}async $onWillCreateEditSessionIdentity(M,O,F){const N=await this.resolveWorkspaceFolder($.URI.revive(M));if(N===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:N},O,async(W,X)=>{const ce=Date.now();await Promise.resolve(W),Date.now()-ce>F&&this.h.warn("SLOW edit session create-participant",X.extension.identifier)}),O.isCancellationRequested}registerCanonicalUriProvider(M,O){if(this.B.has(M))throw new Error(`A provider has already been registered for scheme ${M}`);this.B.set(M,O);const F=this.t.transformOutgoingScheme(M),N=this.z++;return this.o.$registerCanonicalUriProvider(N,F),(0,L.$Pc)(()=>{this.B.delete(M),this.o.$unregisterCanonicalUriProvider(N)})}async provideCanonicalUri(M,O,F){const N=this.B.get(M.scheme);if(!N)return;const W=await N.provideCanonicalUri?.($.URI.revive(M),O,F);if(W)return W}async $provideCanonicalUri(M,O,F){return this.provideCanonicalUri($.URI.revive(M),{targetScheme:O},F)}};e.$6dc=P,e.$6dc=P=He([Be(0,r.$BM),Be(1,n.$RM),Be(2,i.$Ldc),Be(3,w.$dj),Be(4,s.$4dc)],P),e.$7dc=(0,S.$Vh)("IExtHostWorkspace");function z(j){let M,O;return j&&(typeof j=="string"?M=j:(M=j.pattern,O=$.URI.revive(j.baseUri))),{includePattern:M,folder:O}}}),define(ke[42],Se([1,0,24,4,41,6,7,255,86,18,12,5,20,14,2]),function(me,e,C,T,f,R,L,b,y,g,A,I,$,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0dc=e.$9dc=e.$8dc=void 0;function w(s,d){if(d){const c=d.split(".");let u=s;for(let h=0;u&&h<c.length;h++)u=u[c[h]];return u}}function l(s){return s instanceof S.URI}function o(s){return s&&s.uri instanceof S.URI&&s.languageId&&typeof s.languageId=="string"}function i(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function n(s){return s&&s.uri instanceof S.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function r(s){if(l(s))return{resource:s};if(o(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(i(s))return{overrideIdentifier:s.languageId};if(n(s))return{resource:s.uri};if(s===null)return{resource:null}}let a=class{constructor(d,c,u){this.a=d.getProxy(R.$zK.MainThreadConfiguration),this.c=c,this.b=u,this.d=new A.$Wg,this.e=null}getConfigProvider(){return this.d.wait().then(d=>this.e)}$initializeConfiguration(d){this.e=new t(this.a,this.c,d,this.b),this.d.open()}$acceptConfigurationChanged(d,c){this.getConfigProvider().then(u=>u.$acceptConfigurationChanged(d,c))}};e.$8dc=a,e.$8dc=a=He([Be(0,$.$BM),Be(1,f.$7dc),Be(2,v.$dj)],a);class t{constructor(d,c,u,h){this.a=new T.$Rd,this.b=d,this.f=h,this.c=c,this.e=b.$Kn.parse(u),this.d=this.k(u.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(d,c){const u={data:this.e.toData(),workspace:this.c.workspace};this.e=b.$Kn.parse(d),this.d=this.k(d.configurationScopes),this.a.fire(this.j(c,u))}getConfiguration(d,c,u){const h=r(c)||{},E=this.g(d?w(this.e.getValue(void 0,h,this.c.workspace),d):this.e.getValue(void 0,h,this.c.workspace));d&&this.h(d,h,u?.identifier);function D(p){if(p==null)return null;if(typeof p=="boolean")return p?2:5;switch(p){case L.ConfigurationTarget.Global:return 2;case L.ConfigurationTarget.Workspace:return 5;case L.ConfigurationTarget.WorkspaceFolder:return 6}}const m={has(p){return typeof w(E,p)<"u"},get:(p,k)=>{this.h(d?`${d}.${p}`:p,h,u?.identifier);let P=w(E,p);if(typeof P>"u")P=k;else{let z;const j=(M,O)=>{if((0,g.$Ef)(M)){let F;const N=()=>{z=z||(0,C.$an)(E),F=F||w(z,O)};return new Proxy(M,{get:(W,X)=>{if(typeof X=="string"&&X.toLowerCase()==="tojson")return N(),()=>F;if(z)return F=F||w(z,O),F[X];const ce=W[X];return typeof X=="string"?j(ce,`${O}.${X}`):ce},set:(W,X,ce)=>(N(),F&&(F[X]=ce),!0),deleteProperty:(W,X)=>(N(),F&&delete F[X],!0),defineProperty:(W,X,ce)=>(N(),F&&Object.defineProperty(F,X,ce),!0)})}return Array.isArray(M)?(0,C.$an)(M):M};P=j(P,p)}return P},update:(p,k,P,z)=>{p=d?`${d}.${p}`:p;const j=D(P);return k!==void 0?this.b.$updateConfigurationOption(j,p,k,h,z):this.b.$removeConfigurationOption(j,p,h,z)},inspect:p=>{p=d?`${d}.${p}`:p;const k=this.e.inspect(p,h,this.c.workspace);if(k)return{key:p,defaultValue:(0,C.$an)(k.policy?.value??k.default?.value),globalValue:(0,C.$an)(k.user?.value??k.application?.value),workspaceValue:(0,C.$an)(k.workspace?.value),workspaceFolderValue:(0,C.$an)(k.workspaceFolder?.value),defaultLanguageValue:(0,C.$an)(k.default?.override),globalLanguageValue:(0,C.$an)(k.user?.override??k.application?.override),workspaceLanguageValue:(0,C.$an)(k.workspace?.override),workspaceFolderLanguageValue:(0,C.$an)(k.workspaceFolder?.override),languageIds:(0,C.$an)(k.overrideIdentifiers)}}};return typeof E=="object"&&(0,C.$dn)(m,E,!1),Object.freeze(m)}g(d){const c=u=>(0,g.$Ef)(u)?new Proxy(u,{get:(h,E)=>c(h[E]),set:(h,E,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(E)}' of object`)},deleteProperty:(h,E)=>{throw new Error(`TypeError: Cannot delete read only property '${String(E)}' of object`)},defineProperty:(h,E)=>{throw new Error(`TypeError: Cannot define property '${String(E)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):u;return c(d)}h(d,c,u){const h=y.$Bn.test(d)?4:this.d.get(d),E=u?`[${u.value}] `:"";if(h===4){typeof c?.resource>"u"&&this.f.warn(`${E}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${d}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){c?.resource&&this.f.warn(`${E}Accessing a window scoped configuration for a resource is not expected. To associate '${d}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(d,c){const u=new b.$Mn(d,c,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(h,E)=>u.affectsConfiguration(h,r(E))})}k(d){return d.reduce((c,u)=>(c.set(u[0],u[1]),c),new Map)}}e.$9dc=t,e.$0dc=(0,I.$Vh)("IExtHostConfiguration")}),define(ke[95],Se([1,0,2,12,4,6,7,41,69,42,21,46,20,27,5,17,11,14,91,303,8]),function(me,e,C,T,f,R,L,b,y,g,A,I,$,v,S,w,l,o,i,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Afc=e.$zfc=e.$yfc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var a;(function(j){function M(F){if(F!=null)return F}j.from=M;function O(F){if(F!=null)return F}j.to=O})(a||(a={}));var t;(function(j){function M(F){if(F!=null)return F}j.from=M;function O(F){if(F!=null)return F}j.to=O})(t||(t={}));var s;(function(j){function M(F){if(F!=null)return F}j.from=M;function O(F){if(F!=null)return F}j.to=O})(s||(s={}));var d;(function(j){function M(N){if(N){const W=N;return W&&!!W.process}else return!1}j.is=M;function O(N){if(N==null)return;const W={process:N.process,args:N.args};return N.options&&(W.options=s.from(N.options)),W}j.from=O;function F(N){if(N!=null)return new L.$jL(N.process,N.args,N.options)}j.to=F})(d||(d={}));var c;(function(j){function M(F){if(F!=null)return F}j.from=M;function O(F){if(F!=null)return F}j.to=O})(c||(c={}));var u;(function(j){function M(N){if(N){const W=N;return W&&(!!W.commandLine||!!W.command)}else return!1}j.is=M;function O(N){if(N==null)return;const W={};return N.commandLine!==void 0?W.commandLine=N.commandLine:(W.command=N.command,W.args=N.args),N.options&&(W.options=c.from(N.options)),W}j.from=O;function F(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new L.$kL(N.commandLine,N.options):new L.$kL(N.command,N.args?N.args:[],N.options)}j.to=F})(u||(u={}));var h;(function(j){function M(N){if(N){const W=N;return W&&W.customExecution==="customExecution"}else return!1}j.is=M;function O(N){return{customExecution:"customExecution"}}j.from=O;function F(N,W){return W.get(N)}j.to=F})(h||(e.CustomExecutionDTO=h={}));var E;(function(j){function M(O,F){let N;return O.scope!==void 0&&typeof O.scope!="number"?N=O.scope.uri:O.scope!==void 0&&typeof O.scope=="number"&&(O.scope===L.TaskScope.Workspace&&F&&F.workspaceFile?N=F.workspaceFile:N=n.$9F),{id:O._id,workspaceFolder:N}}j.from=M})(E||(e.TaskHandleDTO=E={}));var D;(function(j){function M(O){if(O!=null)return{_id:O.id,isDefault:O.isDefault}}j.from=M})(D||(D={}));var m;(function(j){function M(N,W){if(N==null)return[];const X=[];for(const ce of N){const J=O(ce,W);J&&X.push(J)}return X}j.fromMany=M;function O(N,W){if(N==null)return;let X;N.execution instanceof L.$jL?X=d.from(N.execution):N.execution instanceof L.$kL?X=u.from(N.execution):N.execution&&N.execution instanceof L.$lL&&(X=h.from(N.execution));const ce=a.from(N.definition);let J;return N.scope?typeof N.scope=="number"?J=N.scope:J=N.scope.uri:J=L.TaskScope.Workspace,!ce||!J?void 0:{_id:N._id,definition:ce,name:N.name,source:{extensionId:W.identifier.value,label:N.source,scope:J},execution:X,isBackground:N.isBackground,group:D.from(N.group),presentationOptions:t.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}j.from=O;async function F(N,W,X){if(N==null)return;let ce;d.is(N.execution)?ce=d.to(N.execution):u.is(N.execution)?ce=u.to(N.execution):h.is(N.execution)&&(ce=h.to(N._id,X));const J=a.to(N.definition);let Q;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?Q=N.source.scope:Q=await W.resolveWorkspaceFolder(C.URI.revive(N.source.scope)):Q=L.TaskScope.Workspace),!J||!Q)return;const G=new L.$mL(J,Q,N.name,N.source.label,ce,N.problemMatchers);return N.isBackground!==void 0&&(G.isBackground=N.isBackground),N.group!==void 0&&(G.group=L.$iL.from(N.group._id),G.group&&N.group.isDefault&&(G.group=new L.$iL(G.group.id,G.group.label),N.group.isDefault===!0&&(G.group.isDefault=N.group.isDefault))),N.presentationOptions&&(G.presentationOptions=t.to(N.presentationOptions)),N._id&&(G._id=N._id),N.detail&&(G.detail=N.detail),G}j.to=F})(m||(e.TaskDTO=m={}));var p;(function(j){function M(F){return F}j.from=M;function O(F){if(F)return Object.assign(Object.create(null),F)}j.to=O})(p||(p={}));class k{#e;constructor(M,O,F){this._id=O,this.a=F,this.#e=M}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(M){}fireDidEndProcess(M){}}let P=class{constructor(M,O,F,N,W,X,ce,J){this.q=new f.$Rd,this.r=new f.$Rd,this.s=new f.$Rd,this.t=new f.$Rd,this.a=M.getProxy(R.$zK.MainThreadTask),this.b=F,this.c=N,this.d=W,this.e=X,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ce,this.g=J,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(M,O,F){if(!F)return new L.$BK(()=>{});const N=this.w();return this.j.set(N,{type:O,provider:F,extension:M}),this.a.$registerTaskProvider(N,O),new L.$BK(()=>{this.j.delete(N),this.a.$unregisterTaskProvider(N)})}registerTaskSystem(M,O){this.a.$registerTaskSystem(M,O)}fetchTasks(M){return this.a.$fetchTasks(p.from(M)).then(async O=>{const F=[];for(const N of O){const W=await m.to(N,this.b,this.m);W&&F.push(W)}return F})}get taskExecutions(){const M=[];return this.k.forEach(O=>M.push(O)),M}terminateTask(M){if(!(M instanceof k))throw new Error("No valid task execution provided");return this.a.$terminateTask(M._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(M,O,F){const N=this.m.get(M.id);N&&(this.o.set(M.id,N),this.e.attachPtyToTerminal(O,await N.callback(F))),this.p=M.id,this.q.fire({execution:await this.y(M)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(M){const O=await this.y(M);this.l.delete(M.id),this.k.delete(M.id),this.A(M),this.r.fire({execution:O})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(M){const O=await this.y(M.id);this.s.fire({execution:O,processId:M.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(M){const O=await this.y(M.id);this.t.fire({execution:O,exitCode:M.exitCode})}$provideTasks(M,O){const F=this.j.get(M);if(!F)return Promise.reject(new Error("no handler found"));const N=[],W=(0,T.$Qg)(()=>F.provider.provideTasks(A.CancellationToken.None)).then(X=>this.u(O,N,F,X));return new Promise(X=>{W.then(ce=>{Promise.all(N).then(()=>{X(ce)})})})}async $resolveTask(M,O){const F=this.j.get(M);if(!F)return Promise.reject(new Error("no handler found"));if(O.definition.type!==F.type)throw new Error(`Unexpected: Task of type [${O.definition.type}] cannot be resolved by provider of type [${F.type}].`);const N=await m.to(O,this.b,this.m);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const W=await F.provider.resolveTask(N,A.CancellationToken.None);if(!W)return;this.z(W,F);const X=m.from(W,F.extension);if(!X)throw new Error("Unexpected: Task cannot be resolved.");if(W.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return h.is(X.execution)&&await this.x(X,W,!0),await this.v(X)}w(){return this.h++}async x(M,O,F){const N=await this.a.$createTaskId(M);!F&&!this.m.has(N)&&(this.n.add(N),this.o.set(N,O.execution)),this.m.set(N,O.execution)}async y(M,O){if(typeof M=="string"){const W=this.l.get(M);if(!W)throw new r.$ab("Unexpected: The specified task is missing an execution");return W}const F=this.l.get(M.id);if(F)return F;const N=new Promise((W,X)=>{function ce(J,Q,G){G?W(new k(J,Q.id,G)):X("Unexpected: Task does not exist.")}O?ce(this,M,O):m.to(M.task,this.b,this.m).then(J=>ce(this,M,J))});return this.l.set(M.id,N),N.then(W=>(this.k.set(M.id,W),W),W=>Promise.reject(W))}z(M,O){M._deprecated&&this.g.report("Task.constructor",O.extension,"Use the Task constructor that takes a `scope` instead.")}A(M){this.o.get(M.id)&&this.o.delete(M.id),this.n.has(M.id)&&this.p!==M.id&&(this.m.delete(M.id),this.n.delete(M.id));const F=this.n.values();let N=F.next();for(;!N.done;)!this.o.has(N.value)&&this.p!==N.value&&(this.m.delete(N.value),this.n.delete(N.value)),N=F.next()}};e.$yfc=P,e.$yfc=P=He([Be(0,$.$BM),Be(1,v.$RM),Be(2,b.$7dc),Be(3,y.$MM),Be(4,g.$0dc),Be(5,I.$vec),Be(6,o.$dj),Be(7,i.$Odc)],P);let z=class extends P{constructor(M,O,F,N,W,X,ce,J){super(M,O,F,N,W,X,ce,J),this.registerTaskSystem(w.Schemas.vscodeRemote,{scheme:w.Schemas.vscodeRemote,authority:"",platform:l.$h(0)})}async executeTask(M,O){if(!O.execution)throw new Error("Tasks to execute must include an execution");const F=m.from(O,M);if(F===void 0)throw new Error("Task is not valid");if(h.is(F.execution))await this.x(F,O,!1);else throw new r.$$;const N=await this.y(await this.a.$getTaskExecution(F),O);return this.a.$executeTask(F).catch(W=>{throw new Error(W)}),N}u(M,O,F,N){const W=[];if(N)for(const X of N){if(this.z(X,F),!X.definition||!M[X.definition.type]){const J=X.source?X.source:"No task source";this.f.warn(`The task [${J}, ${X.name}] uses an undefined task type. The task will be ignored in the future.`)}const ce=m.from(X,F.extension);ce&&h.is(ce.execution)?(W.push(ce),O.push(this.x(ce,X,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:W,extension:F.extension}}async v(M){if(h.is(M.execution))return M;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(M,O){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(M,O,F){}};e.$zfc=z,e.$zfc=z=He([Be(0,$.$BM),Be(1,v.$RM),Be(2,b.$7dc),Be(3,y.$MM),Be(4,g.$0dc),Be(5,I.$vec),Be(6,o.$dj),Be(7,i.$Odc)],z),e.$Afc=(0,S.$Vh)("IExtHostTask")}),define(ke[359],Se([1,0,36,29]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oJ=e.$nJ=e.$mJ=void 0;function f(L){return"cellResults"in L}e.$mJ=f,e.$nJ="rawCell#";function R(L,b){let y=-1;const g=[];let A=[];return L.forEach($=>{$.range.startLineNumber!==y&&A.length>0&&(g.push([...A]),A=[]),A.push($),y=$.range.endLineNumber}),A.length>0&&g.push([...A]),g.map($=>{const v=[],S=$[0].range.startLineNumber,w=$[$.length-1].range.endLineNumber;for(let l=S;l<=w;l++)v.push(b.getLineContent(l));return new C.$3I(v.join(`
`)+`
`,$.map(l=>new T.$zs(l.range.startLineNumber-1,l.range.startColumn-1,l.range.endLineNumber-1,l.range.endColumn-1)))})}e.$oJ=R}),define(ke[360],Se([1,0,215,22,4,3,28,13,18,2,31,110,6,35,15,7,68,295,148,8,24,17,287,359,356]),function(me,e,C,T,f,R,L,b,y,g,A,I,$,v,S,w,l,o,i,n,r,a,t,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$afc=void 0;class c{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(h=>h.apiEditor)}constructor(h,E,D,m,p,k){this.q=D,this.r=m,this.s=p,this.t=k,this.f=new Map,this.g=new L.$zc,this.h=new Map,this.j=new f.$Rd({onListenerError:n.$1}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new f.$Rd({onListenerError:n.$1}),this.onDidOpenNotebookDocument=this.m.event,this.n=new f.$Rd({onListenerError:n.$1}),this.onDidCloseNotebookDocument=this.n.event,this.o=new f.$Rd({onListenerError:n.$1}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new I.$Hdc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=h.getProxy($.$zK.MainThreadNotebook),this.c=h.getProxy($.$zK.MainThreadNotebookDocuments),this.d=h.getProxy($.$zK.MainThreadNotebookEditors),this.i=E.converter,E.registerArgumentProcessor({processArgument:P=>{if(P&&P.$mid===13){const z=P.notebookEditor?.notebookUri,j=P.cell.handle,O=this.g.get(z)?.getCell(j);if(O)return O.apiCell}if(P&&P.$mid===14){const z=P.uri,j=this.g.get(z);if(j)return j.apiNotebook}return P}}),c.B(E)}getEditorById(h){const E=this.h.get(h);if(!E)throw new Error(`unknown text editor: ${h}. known editors: ${[...this.h.keys()]} `);return E}getIdByEditor(h){for(const[E,D]of this.h)if(D.apiEditor===h)return E}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(h,E){const D=this.g.get(h);if(!D&&!E)throw new Error(`NO notebook document for '${h}'`);return D}static u(h,E){if(!E)return;const D=E.filenamePattern.map(m=>S.NotebookExclusiveDocumentPattern.from(m)).filter(m=>m!==void 0);if(E.filenamePattern&&!D){console.warn(`Notebook content provider view options file name pattern is invalid ${E.filenamePattern}`);return}return{extension:h.identifier,providerDisplayName:h.displayName||h.name,displayName:E.displayName,filenamePattern:D,exclusive:E.exclusive||!1}}registerNotebookCellStatusBarItemProvider(h,E,D){const m=c.a++,p=typeof D.onDidChangeCellStatusBarItems=="function"?c.a++:void 0;this.f.set(m,D),this.b.$registerNotebookCellStatusBarItemProvider(m,p,E);let k;return p!==void 0&&(k=D.onDidChangeCellStatusBarItems(P=>this.b.$emitCellStatusBarEvent(p))),new w.$BK(()=>{this.f.delete(m),this.b.$unregisterNotebookCellStatusBarItemProvider(m,p),k?.dispose()})}async createNotebookDocument(h){const E=await this.c.$tryCreateNotebook({viewType:h.viewType,content:h.content&&S.NotebookData.from(h.content)});return g.URI.revive(E)}async openNotebookDocument(h){const E=this.g.get(h);if(E)return E.apiNotebook;const D=await this.c.$tryOpenNotebook(h),m=this.g.get(g.URI.revive(D));return(0,y.$Nf)(m?.apiNotebook)}async showNotebookDocument(h,E){g.URI.isUri(h)&&(h=await this.openNotebookDocument(h));let D;typeof E=="object"?D={position:S.ViewColumn.from(E.viewColumn),preserveFocus:E.preserveFocus,selections:E.selections&&E.selections.map(S.NotebookRange.from),pinned:typeof E.preview=="boolean"?!E.preview:void 0}:D={preserveFocus:!1};const m=await this.d.$tryShowNotebookDocument(h.uri,h.notebookType,D),p=m&&this.h.get(m)?.apiEditor;if(p)return p;throw m?new Error(`Could NOT open editor for "${h.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${h.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(h,E,D,m){const p=this.f.get(h),k=g.URI.revive(E),P=this.g.get(k);if(!P||!p)return;const z=P.getCellFromIndex(D);if(!z)return;const j=await p.provideCellStatusBarItems(z.apiCell,m);if(!j)return;const M=new R.$Qc,O=this.p.add([M]),N=(Array.isArray(j)?j:[j]).map(W=>S.NotebookStatusBarItem.from(W,this.i,M));return{cacheId:O,items:N}}$releaseNotebookCellStatusBarItems(h){this.p.delete(h)}registerNotebookSerializer(h,E,D,m,p){if((0,b.$Fe)(E))throw new Error("viewType cannot be empty or just whitespace");const k=this.w++;return this.x.set(k,{viewType:E,serializer:D,options:m}),this.b.$registerNotebookSerializer(k,{id:h.identifier,location:h.extensionLocation},E,S.NotebookDocumentContentOptions.from(m),c.u(h,p)),(0,R.$Pc)(()=>{this.b.$unregisterNotebookSerializer(k)})}async $dataToNotebook(h,E,D){const m=this.x.get(h);if(!m)throw new Error("NO serializer found");const p=await m.serializer.deserializeNotebook(E.buffer,D);return new l.$wv(S.NotebookData.from(p))}async $notebookToData(h,E,D){const m=this.x.get(h);if(!m)throw new Error("NO serializer found");const p=await m.serializer.serializeNotebook(S.NotebookData.to(E.value),D);return T.$fe.wrap(p)}async $saveNotebook(h,E,D,m,p){const k=g.URI.revive(E),P=this.x.get(h);if(!P)throw new Error("NO serializer found");const z=this.g.get(k);if(!z)throw new Error("Document NOT found");if(z.versionId!==D)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(k.scheme))throw new A.$zk((0,C.localize)(0,null,this.z(k)),6);await this.y(k,m);const j={metadata:(0,r.$in)(z.apiNotebook.metadata,W=>!(P.options?.transientDocumentMetadata??{})[W]),cells:[]};for(const W of z.apiNotebook.getCells()){const X=new w.$ZL(W.kind,W.document.getText(),W.document.languageId,W.mime,P.options?.transientOutputs?[]:[...W.outputs],W.metadata,W.executionSummary);X.metadata=(0,r.$in)(W.metadata,ce=>!(P.options?.transientCellMetadata??{})[ce]),j.cells.push(X)}const M=await P.serializer.serializeNotebook(j,p);await this.s.value.writeFile(k,M);const O=this.s.getFileSystemProviderExtUri(k.scheme),F=await this.s.value.stat(k);return{name:O.basename(k),isFile:(F.type&A.FileType.File)!==0,isDirectory:(F.type&A.FileType.Directory)!==0,isSymbolicLink:(F.type&A.FileType.SymbolicLink)!==0,mtime:F.mtime,ctime:F.ctime,size:F.size,readonly:!!((F.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(k.scheme),locked:!!((F.permissions??0)&A.FilePermission.Locked),etag:A.$Kk({mtime:F.mtime,size:F.size}),children:void 0}}async $searchInNotebooks(h,E,D,m,p){const k=this.x.get(h)?.serializer;if(!k)return{limitHit:!1,results:[]};const P=new L.$Ac;await(async(F,N,W)=>{await Promise.all(F.map(async X=>await Promise.all(X.filenamePatterns.map(ce=>{const J={...W,type:1,filePattern:ce};return this.t.doInternalFileSearchWithCustomCallback(J,N,Q=>{Q.forEach(G=>{P.has(G)||m.some(_=>X.isFromSettings&&!_.isFromSettings?!1:_.filenamePatterns.some(Ee=>(0,d.$Ybb)(Ee,G)))||P.add(G)})})}))))})(D,p,E);const j=new L.$zc;let M=!1;const O=Array.from(P).map(async F=>{const N=[];try{if(p.isCancellationRequested)return;if(E.maxResults&&[...j.values()].reduce((J,Q)=>J+Q.cellResults.length,0)>E.maxResults){M=!0;return}const W=[],X=this.g.get(F);if(X)X.apiNotebook.getCells().forEach(Q=>W.push({input:Q.document.getText(),outputs:Q.outputs.flatMap(G=>G.items.map(oe=>oe.data.toString()))}));else{const J=await this.s.value.readFile(F),Q=T.$fe.fromString(J.toString()),G=await k.deserializeNotebook(Q.buffer,p);if(p.isCancellationRequested)return;S.NotebookData.from(G).cells.forEach(_=>W.push({input:_.source,outputs:_.outputs.flatMap(Ee=>Ee.items.map(he=>he.valueBytes.toString()))}))}if(p.isCancellationRequested)return;W.forEach((J,Q)=>{const G=E.contentPattern.pattern,oe=new t.$VOb(J.input,void 0,J.outputs),_=oe.findInInputs(G),Ee=oe.findInOutputs(G),he=Ee.flatMap(q=>(0,s.$oJ)(q.matches,q.textBuffer)).map((q,U)=>(q.webviewIndex=U,q));if(_.length>0||Ee.length>0){const q={index:Q,contentResults:(0,s.$oJ)(_,oe.inputTextBuffer),webviewResults:he};N.push(q)}});const ce={resource:F,cellResults:N};j.set(F,ce);return}catch{return}});return await Promise.all(O),{limitHit:M,results:[...j.values()]}}async y(h,E){const D=await this.s.value.stat(h);if(typeof E?.mtime=="number"&&typeof E.etag=="string"&&E.etag!==A.$Jk&&typeof D.mtime=="number"&&typeof D.size=="number"&&E.mtime<D.mtime&&E.etag!==A.$Kk({mtime:E.mtime,size:D.size}))throw new A.$zk((0,C.localize)(1,null),3,E)}z(h){return h.scheme===a.Schemas.file?h.fsPath:h.toString()}A(h,E,D){if(this.h.has(E))throw new Error(`editor with id ALREADY EXSIST: ${E}`);const m=new i.$4ec(E,this.d,h,D.visibleRanges.map(S.NotebookRange.to),D.selections.map(S.NotebookRange.to),typeof D.viewColumn=="number"?S.ViewColumn.to(D.viewColumn):void 0);this.h.set(E,m)}$acceptDocumentAndEditorsDelta(h){if(h.value.removedDocuments)for(const D of h.value.removedDocuments){const m=g.URI.revive(D),p=this.g.get(m);p&&(p.dispose(),this.g.delete(m),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:p.apiNotebook.getCells().map(k=>k.document.uri)}),this.n.fire(p.apiNotebook));for(const k of this.h.values())k.notebookData.uri.toString()===m.toString()&&this.h.delete(k.id)}if(h.value.addedDocuments){const D=[];for(const m of h.value.addedDocuments){const p=g.URI.revive(m.uri);if(this.g.has(p))throw new Error(`adding EXISTING notebook ${p} `);const k=new o.$3ec(this.c,this.q,this.r,p,m);D.push(...m.cells.map(P=>o.$2ec.asModelAddData(k.apiNotebook,P))),this.g.get(p)?.dispose(),this.g.set(p,k),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:D}),this.m.fire(k.apiNotebook)}}if(h.value.addedEditors)for(const D of h.value.addedEditors){if(this.h.has(D.id))return;const m=g.URI.revive(D.documentUri),p=this.g.get(m);p&&this.A(p,D.id,D)}const E=[];if(h.value.removedEditors)for(const D of h.value.removedEditors){const m=this.h.get(D);m&&(this.h.delete(D),this.k?.id===m.id&&(this.k=void 0),E.push(m))}if(h.value.visibleEditors){this.l=h.value.visibleEditors.map(m=>this.h.get(m)).filter(m=>!!m);const D=new Set;this.l.forEach(m=>D.add(m.id));for(const m of this.h.values()){const p=D.has(m.id);m._acceptVisibility(p)}this.l=[...this.h.values()].map(m=>m).filter(m=>m.visible),this.o.fire(this.visibleNotebookEditors)}h.value.newActiveEditor===null?this.k=void 0:h.value.newActiveEditor&&(this.h.get(h.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${h.value.newActiveEditor}`),this.k=this.h.get(h.value.newActiveEditor)),h.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(h){const E=v.$ZM.String.with("notebookType","A notebook type"),D=new v.$2M("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[E,new v.$ZM("data","Bytes to convert to data",p=>p instanceof Uint8Array,p=>T.$fe.wrap(p))],new v.$1M("Notebook Data",p=>S.NotebookData.to(p.value))),m=new v.$2M("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[E,new v.$ZM("NotebookData","Notebook data to convert to bytes",p=>!0,p=>new l.$wv(S.NotebookData.from(p)))],new v.$1M("Bytes",p=>p.buffer));h.registerApiCommand(D),h.registerApiCommand(m)}}e.$afc=c}),define(ke[361],Se([1,0,16,21,43,34,23,38,36]),function(me,e,C,T,f,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ec=void 0;class g{constructor($,v,S){this.k=$,this.l=v,this.o=S,this.e=!1,this.f=0,this.g=!1,this.a=$.filePattern,this.b=$.includePattern&&R.$Cj($.includePattern),this.c=$.maxResults||void 0,this.d=$.exists,this.h=new Set,this.j=$.excludePattern&&R.$Cj($.excludePattern)}cancel(){this.g=!0,this.h.forEach($=>$.cancel()),this.h=new Set}search($){const v=this.k.folderQueries||[];return new Promise((S,w)=>{const l=o=>{this.f++,$(o)};if(this.g)return S({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(o=>{const i=o.toString(),n=C.$mc(i);this.j&&this.j(i,n)||this.v(l,{base:o,basename:n})}),Promise.all(v.map(o=>this.p(o,l))).then(o=>{S({limitHit:this.e,stats:o[0]||void 0})},o=>{w(new Error((0,f.$Gi)(o)))})})}async p($,v){const S=new T.$2d,w=this.q($),l=this.r(),o=new y.$eJ(this.k,$),i=!o.hasSiblingExcludeClauses();let n;try{this.h.add(S),n=b.$Nd.create();const r=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},w,S.token),a=n.elapsed(),t=b.$Nd.create();return this.g&&!this.e||(r&&r.forEach(s=>{const d=C.$fc.relative($.folder.path,s.path);if(i){const c=C.$mc(s.path);this.v(v,{base:$.folder,relativePath:d,basename:c});return}this.s(l,$.folder,d,v)}),this.g&&!this.e)?null:(this.u(l,o,v),{providerTime:a,postProcessTime:t.elapsed()})}finally{S.dispose(),this.h.delete(S)}}q($){const v=(0,y.$dJ)(this.k.includePattern,$.includePattern),S=(0,y.$dJ)(this.k.excludePattern,$.excludePattern);return{folder:$.folder,excludes:S,includes:v,useIgnoreFiles:!$.disregardIgnoreFiles,useGlobalIgnoreFiles:!$.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!$.disregardParentIgnoreFiles,followSymlinks:!$.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const $={rootEntries:[],pathToEntries:Object.create(null)};return $.pathToEntries["."]=$.rootEntries,$}s({pathToEntries:$},v,S,w){if(S===this.a){const o=C.$mc(this.a);this.v(w,{base:v,relativePath:this.a,basename:o})}function l(o){const i=C.$mc(o),n=C.$lc(o);let r=$[n];r||(r=$[n]=[],l(n)),r.push({base:v,relativePath:o,basename:i})}l(S)}u({rootEntries:$,pathToEntries:v},S,w){const l=this,o=this.a;function i(n){const r=(0,y.$gJ)(()=>n.map(a=>a.basename));for(let a=0,t=n.length;a<t;a++){const s=n[a],{relativePath:d,basename:c}=s;if(S.matchesExcludesSync(d,c,o!==c?r:void 0))continue;const u=v[d];if(u)i(u);else{if(d===o)continue;l.v(w,s)}if(l.e)break}}i($)}v($,v){(!this.b||v.relativePath&&this.b(v.relativePath,v.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||$(v))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch($,v,S,w){const l=this.c($.cacheKey),o=new g($,v,l&&l.token);let i=0;const n=r=>{i+=r.length,S(r.map(a=>this.d(a)))};return this.e(o,A.a,n,w).then(r=>({limitHit:r.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:r.stats}}))}clearCache($){this.c($)?.cancel()}c($){if($)return this.b.has($)||this.b.set($,new T.$2d),this.b.get($)}d($){return $.relativePath?{resource:L.$zg($.base,$.relativePath)}:{resource:$.base}}e($,v,S,w){const l=w.onCancellationRequested(()=>{$.cancel()}),o=n=>{n&&(i.push(n),v>0&&i.length>=v&&(S(i),i=[]))};let i=[];return $.search(o).then(n=>(i.length&&S(i),l.dispose(),n),n=>(i.length&&S(i),l.dispose(),Promise.reject(n)))}}e.$5ec=A}),define(ke[362],Se([1,0,19,73,34,102,28,17,16,23,13,18,2,99,236,44,14,40,145,357,36]),function(me,e,C,T,f,R,L,b,y,g,A,I,$,v,S,w,l,o,i,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eK=e.$dK=void 0;let a=class{constructor(p,k,P,z,j){this.a=p,this.b=k,this.c=P,this.d=z,this.e=j}text(p,k,P={}){p=this.f(p,P);const z=this.a.getValue(),j=k&&k.some(O=>!this.a.getValue({resource:O}).search.useRipgrep);return{...this.h(k?.map(o.$ei),P),type:2,contentPattern:p,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:z.search.usePCRE2||j||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}f(p,k){const P=this.a.getValue();p.isRegExp&&(p.pattern=p.pattern.replace(/\r?\n/g,"\\n"));const z={...p,wordSeparators:P.editor.wordSeparators};return this.j(p,k)&&(z.isCaseSensitive=!0),this.k(p)&&(z.isMultiline=!0),k.notebookSearchConfig?.includeMarkupInput&&(z.notebookInfo||(z.notebookInfo={}),z.notebookInfo.isInNotebookMarkdownInput=k.notebookSearchConfig.includeMarkupInput),k.notebookSearchConfig?.includeMarkupPreview&&(z.notebookInfo||(z.notebookInfo={}),z.notebookInfo.isInNotebookMarkdownPreview=k.notebookSearchConfig.includeMarkupPreview),k.notebookSearchConfig?.includeCodeInput&&(z.notebookInfo||(z.notebookInfo={}),z.notebookInfo.isInNotebookCellInput=k.notebookSearchConfig.includeCodeInput),k.notebookSearchConfig?.includeOutput&&(z.notebookInfo||(z.notebookInfo={}),z.notebookInfo.isInNotebookCellOutput=k.notebookSearchConfig.includeOutput),z}file(p,k={}){return{...this.h(p,k),type:1,filePattern:k.filePattern?k.filePattern.trim():k.filePattern,exists:k.exists,sortByScore:k.sortByScore,cacheKey:k.cacheKey}}g(p,k){return p?(p=Array.isArray(p)?p.map(u):u(p),k?this.parseSearchPaths(p):{pattern:s(...Array.isArray(p)?p:[p])}):{}}h(p=[],k={}){const P=this.g(k.includePattern,k.expandPatterns),z=this.g(k.excludePattern,k.expandPatterns),j=p.length>1,M=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(N=>this.q(N,k,z)):p.map(N=>this.r(N,k,z,j))).filter(N=>!!N),O={_reason:k._reason,folderQueries:M,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:k.extraFileResources,excludePattern:z.pattern,includePattern:P.pattern,onlyOpenEditors:k.onlyOpenEditors,maxResults:k.maxResults};if(k.onlyOpenEditors){const N=C.$Gb(C.$Qb(this.c.groups.map(ce=>ce.editors.map(J=>J.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const W=N.filter(ce=>(0,r.$7I)(O,ce.fsPath)),X=this.i(W);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(X)),{...O,...X}}const F=k.extraFileResources&&k.extraFileResources.filter(N=>(0,r.$7I)(O,N.fsPath));return O.extraFileResources=F&&F.length?F:void 0,O}i(p){const k=[],P=new L.$zc,z={};let j=!1;return p.forEach(M=>{if(M.scheme===b.Schemas.walkThrough)return;if((0,g.$Dg)(M)){const F=this.b.getWorkspaceFolder(M)?.uri??M.with({path:y.$lc(M.fsPath)});let N=P.get(F);N||(j=!0,N={folder:F,includePattern:{}},k.push(N),P.set(F,N));const W=y.$kc(F.fsPath,M.fsPath);(0,I.$Nf)(N.includePattern)[W.replace(/\\/g,"/")]=!0}else M.fsPath&&(j=!0,z[M.fsPath]=!0)}),{folderQueries:k,includePattern:z,usingSearchPaths:!0,excludePattern:j?void 0:{"**/*":!0}}}j(p,k){if(k.isSmartCase){if(p.isRegExp){if(A.$tf(p.pattern,!0))return!0}else if(A.$tf(p.pattern))return!0}return!!p.isCaseSensitive}k(p){return p.isMultiline||p.isRegExp&&(0,v.$CB)(p.pattern)||p.pattern.indexOf(`
`)>=0?!0:!!p.isMultiline}parseSearchPaths(p){const k=X=>y.$hc(X)||/^\.\.?([\/\\]|$)/.test(X),z=(Array.isArray(p)?p:d(p)).map(X=>{const ce=this.e.resolvedUserHome;return ce?(0,R.$Bv)(X,ce.scheme===b.Schemas.file?ce.fsPath:ce.path):X}),j=T.$J(z,X=>k(X)?"searchPaths":"exprSegments"),M=(j.exprSegments||[]).map(X=>A.$Oe(X,"/")).map(X=>A.$Oe(X,"\\")).map(X=>(X[0]==="."&&(X="*"+X),c(X))),O={},F=this.m(j.searchPaths||[]);F&&F.length&&(O.searchPaths=F);const N=C.$Qb(M),W=s(...N);return W&&(O.pattern=W),O}l(p,k){return k.disregardExcludeSettings?void 0:(0,r.$6I)(p,!k.disregardSearchExcludeSettings)}m(p){if(!p||!p.length)return[];const k=p.flatMap(z=>{let{pathPortion:j,globPortion:M}=t(z);return M&&(M=h(M)),this.n(j).flatMap(F=>this.o(F,M))}),P=new Map;return k.forEach(z=>{const j=z.searchPath.toString(),M=P.get(j);M?z.pattern&&(M.pattern=M.pattern||{},M.pattern[z.pattern]=!0):P.set(j,{searchPath:z.searchPath,pattern:z.pattern?s(z.pattern):void 0})}),Array.from(P.values())}n(p){if(y.$hc(p)){const k=this.b.getWorkspace().folders;return k[0]&&k[0].uri.scheme!==b.Schemas.file?[{searchPath:k[0].uri.with({path:p})}]:[{searchPath:$.URI.file(y.$gc(p))}]}if(this.b.getWorkbenchState()===2){const k=this.b.getWorkspace().folders[0].uri;if(p=u(p),p.startsWith("../")||p===".."){const z=y.$fc.resolve(k.path,p);return[{searchPath:k.with({path:z})}]}const P=h(p);return[{searchPath:k,pattern:P}]}else{if(p==="./"||p===".\\")return[];{const k=p.replace(/^\.[\/\\]/,""),z=this.b.getWorkspace().folders.map(j=>{const M=k.match(new RegExp(`^${A.$Je(j.name)}(?:/(.*)|$)`));return M?{match:M,folder:j}:null}).filter(I.$Kf);if(z.length)return z.map(j=>{const M=j.match[1];return{searchPath:j.folder.uri,pattern:M&&h(M)}});{const j=p.match(/\.[\/\\](.+)[\/\\]?/),M=j?j[1]:p,O=S.localize(0,null,M);throw new Error(O)}}}}o(p,k){const P=p.pattern&&k?`${p.pattern}/${k}`:p.pattern||k,z=[{searchPath:p.searchPath,pattern:P}];return P&&!P.endsWith("**")&&z.push({searchPath:p.searchPath,pattern:P+"/**"}),z}q(p,k,P){const z=this.r((0,o.$ei)(p.searchPath),k,P,!1);return z?{...z,includePattern:p.pattern}:null}r(p,k,P,z){let j;const M=$.URI.isUri(p)?p:p.uri;if(P.searchPaths){const X=P.searchPaths.filter(ce=>(0,g.$sg)(ce.searchPath,M))[0];if(X&&!X.pattern)return null;X&&(j=X.pattern)}const O=this.a.getValue({resource:M}),N={...this.l(O,k)||{},...j||{}},W=$.URI.isUri(p)?(0,g.$wg)(p):p.name;return{folder:M,folderName:z?W:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:O.files&&O.files.encoding,disregardIgnoreFiles:typeof k.disregardIgnoreFiles=="boolean"?k.disregardIgnoreFiles:!O.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof k.disregardGlobalIgnoreFiles=="boolean"?k.disregardGlobalIgnoreFiles:!O.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof k.disregardParentIgnoreFiles=="boolean"?k.disregardParentIgnoreFiles:!O.search.useParentIgnoreFiles,ignoreSymlinks:typeof k.ignoreSymlinks=="boolean"?k.ignoreSymlinks:!O.search.followSymlinks}}};e.$dK=a,e.$dK=a=He([Be(0,w.$pi),Be(1,o.$5h),Be(2,i.$GC),Be(3,l.$dj),Be(4,n.$bK)],a);function t(m){const p=m.match(/[\*\{\}\(\)\[\]\?]/);if(p){const k=p.index,P=m.substr(0,k).match(/[/|\\][^/\\]*$/);if(P){let z=m.substr(0,P.index);return z.match(/[/\\]/)||(z+="/"),{pathPortion:z,globPortion:m.substr((P.index||0)+1)}}}return{pathPortion:m}}function s(...m){return m.length?m.reduce((p,k)=>(p[k]=!0,p),Object.create(null)):void 0}function d(m){return f.$Aj(m,",").map(p=>p.trim()).filter(p=>!!p.length)}function c(m){return[`**/${m}/**`,`**/${m}`].map(k=>k.replace(/\*\*\/\*\*/g,"**"))}function u(m){return m.replace(/\\/g,"/")}function h(m){return u(m).replace(/^\.\//,"").replace(/\/+$/g,"")}function E(m){return m.replace(/([?*[\]])/g,"[$1]")}function D(m,p){m=C.$Lb(m,z=>z.toString());const k=[],P=p.getWorkspace();return m&&m.forEach(z=>{let j;if(p.getWorkbenchState()===2)j=(0,g.$Bg)(P.folders[0].uri,z),j&&j!=="."&&(j="./"+j);else{const M=p.getWorkspaceFolder(z);if(M){const O=M.name;if(P.folders.filter(N=>N.name===O).length===1){const N=(0,g.$Bg)(M.uri,z);N===""?j=`./${M.name}`:j=`./${M.name}/${N}`}else j=z.fsPath}}j&&k.push(E(j))}),k}e.$eK=D}),define(ke[363],Se([1,0,23,2,21,8,5,362,36,40]),function(me,e,C,T,f,R,L,b,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5qb=e.$4qb=void 0;const A=7e3;function I(w,l){const o=l.activationEvents;if(!o)return Promise.resolve(void 0);const i=[],n=[];for(const c of o)if(/^workspaceContains:/.test(c)){const u=c.substr(18);u.indexOf("*")>=0||u.indexOf("?")>=0||w.forceUsingSearch?n.push(u):i.push(u)}if(i.length===0&&n.length===0)return Promise.resolve(void 0);let r;const a=new Promise((c,u)=>{r=c}),t=c=>r({activationEvent:c}),s=Promise.all(i.map(c=>$(w,c,t))).then(()=>{}),d=v(w,l.identifier,n,t);return Promise.all([s,d]).then(()=>{r(void 0)}),a}e.$4qb=I;async function $(w,l,o){for(const i of w.folders)if(await w.exists(C.$zg(T.URI.revive(i),l))){o(`workspaceContains:${l}`);return}}async function v(w,l,o,i){if(o.length===0)return Promise.resolve(void 0);const n=new f.$2d,r=w.checkExists(w.folders,o,n.token),a=setTimeout(async()=>{n.cancel(),w.logService.info(`Not activating extension '${l.value}': Timed out while searching for 'workspaceContains' pattern ${o.join(",")}`)},A);let t=!1;try{t=await r}catch(s){R.$3(s)||R.$Z(s)}n.dispose(),clearTimeout(a),t&&i(`workspaceContains:${o.join(",")}`)}function S(w,l,o,i){const n=w.get(L.$Uh),r=w.get(y.$XI),t=n.createInstance(b.$dK).file(l.map(s=>(0,g.$ei)(T.URI.revive(s))),{_reason:"checkExists",includePattern:o,exists:!0});return r.fileSearch(t,i).then(s=>!!s.limitHit,s=>R.$3(s)?!1:Promise.reject(s))}e.$5qb=S}),define(ke[47],Se([1,0,212,16,56,23,12,3,77,2,14,6,42,293,118,41,25,147,8,26,22,272,7,64,5,27,92,20,107,72,46,4,363,117,274,17,115,38,11,116]),function(me,e,C,T,f,R,L,b,y,g,A,I,$,v,S,w,l,o,i,n,r,a,t,s,d,c,u,h,E,D,m,p,k,P,z,j,M,O,F,N){"use strict";var W;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kec=e.$Jec=e.$Iec=e.$Hec=e.$Gec=void 0,e.$Gec=(0,d.$Vh)("IHostUtils");let X=W=class extends b.$Rc{constructor(q,U,ne,be,H,x,Y,$e,ie,fe,te,de){super(),this.X=de,this.a=this.B(new p.$Rd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=U,this.g=ne,this.f=Y,this.j=be,this.m=H,this.s=x,this.t=ie,this.u=fe,this.w=te,this.y=this.g.getProxy(I.$zK.MainThreadWorkspace),this.z=this.g.getProxy(I.$zK.MainThreadTelemetry),this.C=this.g.getProxy(I.$zK.MainThreadExtensionService),this.D=new L.$Wg,this.F=new L.$Wg,this.G=new L.$Wg,this.H=new L.$Wg,this.I=new Ee(this.f.extensions.activationEvents),this.L=new o.$W5b(this.I,this.f.extensions.allExtensions);const pe=new n.$am(this.f.extensions.myExtensions);this.J=new o.$W5b(this.I,oe(this.L,pe)),F.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Q(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Q(this.J)}`)),this.M=new S.$rec(this.g,this.s),this.N=new P.$zec(this.g),this.O=$e,this.h=q.createChild(new E.$Th([S.$sec,this.M],[P.$Aec,this.N])),this.P=this.B(new v.$qec(this.J,this.L,{onExtensionActivationError:(Pe,B,Z)=>{this.C.$onExtensionActivationError(Pe,i.$2(B),Z)},actualActivateExtension:async(Pe,B)=>{if(o.$W5b.isHostExtension(Pe,this.J,this.L))return await this.C.$activateExtension(Pe,B),new v.$pec;const Z=this.J.getExtensionDescription(Pe);return this.db(Z,B)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),f.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(q){i.$Z(q)}}async Y(){this.O.onWillDeactivateAll();let q=[];try{q=this.J.getAllExtensionDescriptions().map(H=>H.identifier).filter(H=>this.isActivated(H)).map(H=>this.cb(H))}catch{}await Promise.all(q)}terminate(q,U=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${q}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(be=>{this.s.error(be)}),this.g.dispose();const ne=this.Y();Promise.race([(0,L.$Yg)(5e3),ne]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${U}`):this.s.info(`Extension host exiting with code ${U}`),this.s.flush(),this.s.dispose(),this.c.exit(U)})}isActivated(q){return this.G.isOpen()?this.P.isActivated(q):!1}async getExtension(q){const U=await this.C.$getExtension(q);return U&&{...U,identifier:new n.$_l(U.identifier.value),extensionLocation:g.URI.revive(U.extensionLocation)}}Z(q,U){return this.P.activateByEvent(q,U)}$(q,U){return this.P.activateById(q,U)}activateByIdWithErrors(q,U){return this.$(q,U).then(()=>{const ne=this.P.getActivatedExtension(q);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(q=>this.J)}getExtensionExports(q){if(this.G.isOpen())return this.P.getActivatedExtension(q).exports;try{return this.P.getActivatedExtension(q).exports}catch{return null}}async ab(q){if(q.scheme===j.Schemas.file&&this.c.fsRealpath){const U=await this.c.fsRealpath(q.fsPath);return g.URI.file(U)}return q}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(q=>new _(q))),this.Q}async bb(q){const U=y.$2h.forUris(ne=>R.$qg.ignorePathCasing(ne));return await Promise.all(q.map(async ne=>{if(this.ub(ne)){const be=await this.ab(ne.extensionLocation);U.set(be,ne)}})),U}cb(q){let U=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(q))return U;const ne=this.P.getActivatedExtension(q);if(!ne)return U;try{typeof ne.module.deactivate=="function"&&(U=Promise.resolve(ne.module.deactivate()).then(void 0,be=>(this.s.error(be),Promise.resolve(void 0))))}catch(be){this.s.error(`An error occurred when deactivating the extension '${q.value}':`),this.s.error(be)}try{(0,b.$Mc)(ne.subscriptions)}catch(be){this.s.error(`An error occurred when deactivating the subscriptions for extension '${q.value}':`),this.s.error(be)}return U}async db(q,U){return this.f.remote.isRemote?this.C.$onWillActivateExtension(q.identifier):await this.C.$onWillActivateExtension(q.identifier),this.fb(q,U).then(ne=>{const be=ne.activationTimes;return this.C.$onDidActivateExtension(q.identifier,be.codeLoadingTime,be.activateCallTime,be.activateResolvedTime,U),this.eb(q,U,"success",be),ne},ne=>{throw this.eb(q,U,"failure"),ne})}eb(q,U,ne,be){const H=J(q,U);this.z.$publicLog2("extensionActivationTimes",{...H,...be||{},outcome:ne})}fb(q,U){const ne=J(q,U);this.z.$publicLog2("activatePlugin",ne);const be=this.ub(q);if(!be)return Promise.resolve(new v.$oec(v.$lec.NONE));this.s.info(`ExtensionService#_doActivateExtension ${q.identifier.value}, startup: ${U.startup}, activationEvent: '${U.activationEvent}'${q.identifier.value!==U.extensionId.value?`, root cause: ${U.extensionId.value}`:""}`),this.s.flush();const H=new v.$mec(U.startup);return Promise.all([this.vb(q,(0,R.$zg)(q.extensionLocation,be),H),this.gb(q)]).then(x=>(f.mark(`code/extHost/willActivateExtension/${q.identifier.value}`),W.hb(this.s,q.identifier,x[0],x[1],H))).then(x=>(f.mark(`code/extHost/didActivateExtension/${q.identifier.value}`),x))}gb(q){const U=new a.$uec(q,this.M),ne=new a.$tec(q.identifier.value,!1,this.M),be=new z.$Bec(q,this.N),H=q.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,x=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${q.identifier.value}`),Promise.all([U.whenReady,ne.whenReady,this.O.whenReady]).then(()=>{const Y=this;let $e,ie;const fe=(0,l.$MF)(q,"ipc")?this.f.messagePorts?.get(n.$_l.toKey(q.identifier)):void 0;return Object.freeze({globalState:U,workspaceState:ne,secrets:be,subscriptions:[],get extensionUri(){return q.extensionLocation},get extensionPath(){return q.extensionLocation.fsPath},asAbsolutePath(te){return T.$ic(q.extensionLocation.fsPath,te)},get storagePath(){return Y.O.workspaceValue(q)?.fsPath},get globalStoragePath(){return Y.O.globalValue(q).fsPath},get logPath(){return T.$ic(Y.f.logsLocation.fsPath,q.identifier.value)},get logUri(){return g.URI.joinPath(Y.f.logsLocation,q.identifier.value)},get storageUri(){return Y.O.workspaceValue(q)},get globalStorageUri(){return Y.O.globalValue(q)},get extensionMode(){return H},get extension(){return $e===void 0&&($e=new G(Y,q.identifier,q,x,!1)),$e},get extensionRuntime(){return(0,l.$NF)(q,"extensionRuntime"),Y.extensionRuntime},get environmentVariableCollection(){return Y.u.getEnvironmentVariableCollection(q)},get messagePassingProtocol(){if(!ie){if(!fe)return;const te=p.Event.buffer(p.Event.fromDOMEventEmitter(fe,"message",de=>de.data));fe.start(),ie={onDidReceiveMessage:te,postMessage:fe.postMessage.bind(fe)}}return ie}})})}static hb(q,U,ne,be,H){return ne=ne||{activate:void 0,deactivate:void 0},this.ib(q,U,ne,be,H).then(x=>new v.$nec(!1,null,H.build(),ne,x,be.subscriptions))}static ib(q,U,ne,be,H){if(typeof ne.activate=="function")try{H.activateCallStart(),q.trace(`ExtensionService#_callActivateOptional ${U.value}`);const x=typeof global=="object"?global:self,Y=ne.activate.apply(x,[be]);return H.activateCallStop(),H.activateResolveStart(),Promise.resolve(Y).then($e=>(H.activateResolveStop(),$e))}catch(x){return Promise.reject(x)}else return Promise.resolve(ne)}jb(q,U){this.$(q.identifier,{startup:!1,extensionId:q.identifier,activationEvent:U}).then(void 0,ne=>{this.s.error(ne)})}kb(q,U=0){const be=Date.now();(0,F.$B)(()=>{for(let H=U;H<q.length;H+=1){const x=q[H];for(const Y of x.activationEvents??[])if(Y==="onStartupFinished")if(Date.now()-be>50){this.kb(q,H);break}else this.jb(x,Y)}})}lb(){this.C.$setPerformanceMarks(f.getMarks()),this.m.getConfigProvider().then(q=>{const U=q.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ne=this.J.getAllExtensionDescriptions();if(U)this.kb(ne);else for(const be of ne)if(be.activationEvents)for(const H of be.activationEvents)H==="onStartupFinished"&&this.jb(be,H)})}mb(){const q=this.Z("*",!0).then(void 0,x=>{this.s.error(x)});this.B(this.j.onDidChangeWorkspace(x=>this.nb(x.added)));const U=this.j.workspace?this.j.workspace.folders:[],ne=this.nb(U),be=this.pb(),H=Promise.all([be,q,ne]).then(()=>{});return Promise.race([H,(0,L.$Yg)(1e4)]).then(()=>{this.lb()}),H}nb(q){return q.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(U=>this.ob(q,U))).then(()=>{})}async ob(q,U){if(this.isActivated(U.identifier))return;const ne=!this.f.remote.isRemote&&!!this.f.remote.authority,be={logService:this.s,folders:q.map(x=>x.uri),forceUsingSearch:ne||!this.c.fsExists,exists:x=>this.c.fsExists(x.fsPath),checkExists:(x,Y,$e)=>this.y.$checkExists(x,Y,$e)},H=await(0,k.$4qb)(be,U);if(H)return this.$(U.identifier,{startup:!0,extensionId:U.identifier,activationEvent:H.activationEvent}).then(void 0,x=>this.s.error(x))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(q){throw console.error(q),q}}async qb(){const{extensionDevelopmentLocationURI:q,extensionTestsLocationURI:U}=this.f.environment;if(!q||!U)throw new Error(C.localize(0,null));const ne=await this.vb(null,U,new v.$mec(!1));if(!ne||typeof ne.run!="function")throw new Error(C.localize(1,null,U.toString()));return new Promise((be,H)=>{const x=(ie,fe)=>{ie?(F.$t&&this.s.error("Test runner called back with error",ie),H(ie)):(F.$t&&(fe?this.s.info(`Test runner called back with ${fe} failures.`):this.s.info("Test runner called back with successful outcome.")),be(typeof fe=="number"&&fe>0?1:0))},Y=(0,R.$ng)(U),$e=ne.run(Y,x);$e&&$e.then&&$e.then(()=>{F.$t&&this.s.info("Test runner finished successfully."),be(0)}).catch(ie=>{F.$t&&this.s.error("Test runner finished with error",ie),H(ie instanceof Error&&ie.stack?ie.stack:String(ie))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,L.$Yg)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(q,U){return this.R[q]=U,(0,b.$Pc)(()=>{delete this.R[q]})}async getRemoteExecServer(q){const{resolver:U}=await this.sb(q);return U?.resolveExecServer?.(q,{resolveAttempt:0})}async sb(q){const U=q.indexOf("+");if(U===-1)throw new t.$HK("Not an authority that can be resolved!",s.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ne=q.substr(0,U);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ne}`,!1),{authorityPrefix:ne,resolver:this.R[ne]}}async $resolveAuthority(q,U){const ne=O.$Nd.create(!1),be=()=>`[resolveAuthority(${(0,s.$Zk)(q)},${U})][${ne.elapsed()}ms] `,H=ae=>this.s.info(`${be()}${ae}`),x=ae=>this.s.warn(`${be()}${ae}`),Y=(ae,ee=void 0)=>this.s.error(`${be()}${ae}`,ee),$e=ae=>{if(ae instanceof t.$HK)return{type:"error",error:{code:ae._code,message:ae._message,detail:ae._detail}};throw ae},ie=async ae=>{H(`activating resolver for ${ae}...`);const{resolver:ee,authorityPrefix:ge}=await this.sb(ae);if(!ee)throw Y(`no resolver for ${ge}`),new t.$HK(`No remote extension installed to resolve ${ge}.`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:ee,authorityPrefix:ge,remoteAuthority:ae}},fe=q.split(/@|%40/g).reverse();H(`activating remote resolvers ${fe.join(" -> ")}`);let te;try{te=await Promise.all(fe.map(ie)).catch(async ae=>{if(!(ae instanceof t.$HK)||ae._code!==s.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw ae;return x(`resolving nested authorities failed: ${ae.message}`),[await ie(q)]})}catch(ae){return $e(ae)}const de=new L.$9g;de.cancelAndSet(()=>H("waiting..."),1e3);let pe,Pe;for(const[ae,{authorityPrefix:ee,resolver:ge,remoteAuthority:ye}]of te.entries())try{if(ae===te.length-1)H("invoking final resolve()..."),f.mark(`code/extHost/willResolveAuthority/${ee}`),pe=await ge.resolve(ye,{resolveAttempt:U,execServer:Pe}),f.mark(`code/extHost/didResolveAuthorityOK/${ee}`),H("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(ge,t.$GK.isManagedResolvedAuthority(pe)?pe:void 0));else{if(H(`invoking resolveExecServer() for ${ye}`),f.mark(`code/extHost/willResolveExecServer/${ee}`),Pe=await ge.resolveExecServer?.(ye,{resolveAttempt:U,execServer:Pe}),!Pe)throw new t.$HK(`Exec server was not available for ${ye}`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);f.mark(`code/extHost/didResolveExecServerOK/${ee}`)}}catch(ze){return f.mark(`code/extHost/didResolveAuthorityError/${ee}`),Y("returned an error",ze),de.dispose(),$e(ze)}de.dispose();const B={environmentTunnels:pe.environmentTunnels,features:pe.tunnelFeatures},Z={extensionHostEnv:pe.extensionHostEnv,isTrusted:pe.isTrusted,authenticationSession:pe.authenticationSessionForInitializingExtensions?{id:pe.authenticationSessionForInitializingExtensions.id,providerId:pe.authenticationSessionForInitializingExtensions.providerId}:void 0};H(`returned ${t.$GK.isManagedResolvedAuthority(pe)?"managed authority":`${pe.host}:${pe.port}`}`);let re;if(t.$GK.isManagedResolvedAuthority(pe)){const ae=U;this.X.setFactory(ae,pe.makeConnection),re={authority:q,connectTo:new s.$Wk(ae),connectionToken:pe.connectionToken}}else re={authority:q,connectTo:new s.$Xk(pe.host,pe.port),connectionToken:pe.connectionToken};return{type:"ok",value:{authority:re,options:Z,tunnelInformation:B}}}async $getCanonicalURI(q,U){this.s.info(`$getCanonicalURI invoked for authority (${(0,s.$Zk)(q)})`);const{resolver:ne}=await this.sb(q);if(!ne)return null;const be=g.URI.revive(U);if(typeof ne.getCanonicalURI>"u")return be;const H=await(0,L.$Qg)(()=>ne.getCanonicalURI(be));return H||be}$startExtensionHost(q){q.toAdd.forEach(be=>be.extensionLocation=g.URI.revive(be.extensionLocation));const{globalRegistry:U,myExtensions:ne}=ce(this.I,this.L,this.J,q);return this.L.set(U.getAllExtensionDescriptions()),this.J.set(ne),F.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Q(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Q(this.J)}`)),this.rb()}$activateByEvent(q,U){return U===1?this.D.wait().then(ne=>this.Z(q,!1)):this.G.wait().then(ne=>this.Z(q,!1))}async $activate(q,U){return await this.G.wait(),this.J.getExtensionDescription(q)?(await this.$(q,U),!0):!1}async $deltaExtensions(q){q.toAdd.forEach(x=>x.extensionLocation=g.URI.revive(x.extensionLocation));const{globalRegistry:U,myExtensions:ne}=ce(this.I,this.L,this.J,q),be=await this.bb(ne);return(await this.getExtensionPathIndex()).setSearchTree(be),this.L.set(U.getAllExtensionDescriptions()),this.J.set(ne),F.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Q(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Q(this.J)}`)),Promise.resolve(void 0)}async $test_latency(q){return q}async $test_up(q){return q.byteLength}async $test_down(q){const U=r.$fe.alloc(q),ne=Math.random()%256;for(let be=0;be<q;be++)U.writeUInt8(ne,be);return U}async $updateRemoteConnectionData(q){this.W=q,this.a.fire()}};e.$Hec=X,e.$Hec=X=W=He([Be(0,d.$Uh),Be(1,e.$Gec),Be(2,h.$BM),Be(3,w.$7dc),Be(4,$.$0dc),Be(5,A.$dj),Be(6,c.$RM),Be(7,u.$aec),Be(8,D.$Pwb),Be(9,m.$vec),Be(10,M.$Dec),Be(11,N.$Eec)],X);function ce(he,q,U,ne){he.addActivationEvents(ne.addActivationEvents);const be=new o.$W5b(he,q.getAllExtensionDescriptions());be.deltaExtensions(ne.toAdd,ne.toRemove);const H=new n.$am(U.getAllExtensionDescriptions().map(Y=>Y.identifier));for(const Y of ne.myToRemove)H.delete(Y);for(const Y of ne.myToAdd)H.add(Y);const x=oe(be,H);return{globalRegistry:be,myExtensions:x}}function J(he,q){return{id:he.identifier.value,name:he.name,extensionVersion:he.version,publisherDisplayName:he.publisher,activationEvents:he.activationEvents?he.activationEvents.join(","):null,isBuiltin:he.isBuiltin,reason:q.activationEvent,reasonId:q.extensionId.value}}function Q(he){return he.getAllExtensionDescriptions().map(q=>q.identifier.value).join(",")}e.$Iec=(0,d.$Vh)("IExtHostExtensionService");class G{#e;#t;#i;constructor(q,U,ne,be,H){this.#e=q,this.#t=U,this.#i=ne.identifier,this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=T.$gc((0,R.$ng)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=be,this.isFromDifferentExtensionHost=H}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Jec=G;function oe(he,q){return he.getAllExtensionDescriptions().filter(U=>q.has(U.identifier))}class _{constructor(q){this.a=q}setSearchTree(q){this.a=q}findSubstr(q){return this.a.findSubstr(q)}forEach(q){return this.a.forEach(q)}}e.$Kec=_;class Ee{constructor(q){this.a=new n.$bm,this.addActivationEvents(q)}readActivationEvents(q){return this.a.get(q.identifier)??[]}addActivationEvents(q){for(const U of Object.keys(q))this.a.set(U,q[U])}}}),define(ke[364],Se([1,0,56,2,6,42,25,26,20,27,5,47,14,13]),function(me,e,C,T,f,R,L,b,y,g,A,I,$,v){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Sfc=void 0;let w=class{constructor(r,a,t,s,d,c,u){this.c=r,this.d=a,this.e=t,this.f=s,this.g=d,this.h=c,this.i=u,this.a=new Map,this.b=[]}async install(){this.j(),C.mark("code/extHost/willWaitForConfig");const r=await this.f.getConfigProvider();C.mark("code/extHost/didWaitForConfig");const a=await this.g.getExtensionPathIndex();this.register(new o(this.c,a,this.d,r,this.i)),this.register(this.e.createInstance(l)),this.h.remote.isRemote&&this.register(this.e.createInstance(i,a,this.h.environment.appUriScheme))}register(r){if("nodeModuleName"in r)if(Array.isArray(r.nodeModuleName))for(const a of r.nodeModuleName)this.a.set(a,r);else this.a.set(r.nodeModuleName,r);typeof r.alternativeModuleName=="function"&&this.b.push(a=>r.alternativeModuleName(a))}};e.$Sfc=w,e.$Sfc=w=He([Be(2,A.$Uh),Be(3,R.$0dc),Be(4,I.$Iec),Be(5,g.$RM),Be(6,$.$dj)],w);let l=class{static{S=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(r){if(r.environment.appRoot&&S.a.size){const a=(0,v.$Je)(this.c(r.environment.appRoot.fsPath)),t="[a-z0-9_.-]",s=`@${t}+\\/${t}+|${t}+`,d="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${a}/${d}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(r){if(!this.b)return;const a=this.b.exec(this.c(r));if(!a)return;const[,t,s,d]=a,c=S.a.get(s);if(c!==void 0)return console.warn(`${s} as been renamed to ${c}, please update your imports`),t+c+d}c(r){return r.replace(/\\/g,"/")}};l=S=He([Be(0,g.$RM)],l);class o{constructor(r,a,t,s,d){this.c=r,this.d=a,this.e=t,this.f=s,this.g=d,this.nodeModuleName="vscode",this.a=new b.$bm}load(r,a){const t=this.d.findSubstr(a);if(t){let s=this.a.get(t.identifier);return s||(s=this.c(t,this.e,this.f),this.a.set(t.identifier,s)),s}if(!this.b){let s="";this.d.forEach((d,c)=>s+=`	${c} -> ${d.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${a}. These are the extension path mappings: 
${s}`),this.b=this.c(L.$HF,this.e,this.f)}return this.b}}let i=class{constructor(r,a,t){this.e=r,this.f=a,this.nodeModuleName=["open","opn"],this.d=t.getProxy(f.$zK.MainThreadTelemetry);const s=t.getProxy(f.$zK.MainThreadWindow);this.c=(d,c)=>{const u=T.URI.parse(d);return c?this.g(d,c):u.scheme==="http"||u.scheme==="https"?s.$openUri(u,d,{allowTunneling:!0}):u.scheme==="mailto"||u.scheme===this.f?s.$openUri(u,d,{}):this.g(d,c)}}load(r,a,t){const s=this.e.findSubstr(a);return s&&(this.a=s.identifier.value,this.h()),this.b=t(r),this.c}g(r,a){return this.i(),this.b(r,a)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=He([Be(2,y.$BM)],i)}),define(ke[58],Se([1,0,48,3,16,49,5,69,70,47,7,41,290,42]),function(me,e,C,T,f,R,L,b,y,g,A,I,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mec=e.$Lec=void 0,e.$Lec=(0,L.$Vh)("IExtHostVariableResolverProvider");class S extends $.$CN{constructor(o,i,n,r,a,t,s){function d(){if(n){const c=n.activeEditor();if(c)return c.document.uri;const u=r.tabGroups.all.find(h=>h.isActive)?.activeTab;if(u!==void 0){if(u.input instanceof A.$hM||u.input instanceof A.$mM)return u.input.modified;if(u.input instanceof A.$gM||u.input instanceof A.$lM||u.input instanceof A.$jM)return u.input.uri}}}super({getFolderUri:c=>{const u=t.folders.filter(h=>h.name===c);if(u&&u.length>0)return u[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(c,u)=>a.getConfiguration(void 0,c).get(u),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const c=d();if(c)return f.$gc(c.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const c=d();if(c){const u=i.getWorkspaceFolder(c);if(u)return f.$gc(u.uri.fsPath)}}},getSelectedText:()=>{if(n){const c=n.activeEditor();if(c&&!c.selection.isEmpty)return c.document.getText(c.selection)}},getLineNumber:()=>{if(n){const c=n.activeEditor();if(c)return String(c.selection.end.line+1)}},getExtension:c=>o.getExtension(c)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(R.env))}}let w=class extends T.$Rc{constructor(o,i,n,r,a){super(),this.b=o,this.c=i,this.g=n,this.h=r,this.j=a,this.a=new C.$U(async()=>{const t=await this.h.getConfigProvider(),d={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async c=>{d.folders=await this.c.getWorkspaceFolders2()||[]})),new S(this.b,this.c,this.g,this.j,t,d,this.m())})}getResolver(){return this.a.value}m(){}};e.$Mec=w,e.$Mec=w=He([Be(0,g.$Iec),Be(1,I.$7dc),Be(2,b.$MM),Be(3,v.$0dc),Be(4,y.$jec)],w)}),define(ke[96],Se([1,0,12,4,2,5,6,70,47,20,7,41,142,282,42,58]),function(me,e,C,T,f,R,L,b,y,g,A,I,$,v,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rec=e.$Qec=e.$Pec=e.$Oec=e.$Nec=void 0,e.$Nec=(0,R.$Vh)("IExtHostDebugService");let l=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(s,d,c,u,h,E){this.E=d,this.F=c,this.G=u,this.H=h,this.I=E,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new T.$Rd,this.n=new T.$Rd,this.o=new T.$Rd,this.u=new T.$Rd,this.k=s.getProxy(L.$zK.MainThreadDebugService),this.y=new T.$Rd,this.A=new T.$Rd,this.v=new i(this.k),this.w=new Map,this.F.getExtensionRegistry().then(D=>{D.onDidChange(m=>{this.J(D)}),this.J(D)})}asDebugSourceUri(s,d){const c=s;if(typeof c.sourceReference=="number"&&c.sourceReference>0){let u=`debug:${encodeURIComponent(c.path||"")}`,h="?";return d&&(u+=`${h}session=${encodeURIComponent(d.id)}`,h="&"),u+=`${h}ref=${c.sourceReference}`,f.URI.parse(u)}else{if(c.path)return f.URI.file(c.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(s){const d=[];for(const c of s.getAllExtensionDescriptions())if(c.contributes){const u=c.contributes.debuggers;if(u&&u.length>0)for(const h of u)(0,v.$jF)(h)&&d.push(h.type)}this.k.$registerDebugTypes(d)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const s=[];return this.w.forEach(d=>s.push(d)),s}addBreakpoints(s){const d=s.filter(h=>{const E=h.id;return this.w.has(E)?!1:(this.w.set(E,h),!0)});this.U(d,[],[]);const c=[],u=new Map;for(const h of d)if(h instanceof A.$AL){let E=u.get(h.location.uri.toString());E||(E={type:"sourceMulti",uri:h.location.uri,lines:[]},u.set(h.location.uri.toString(),E),c.push(E)),E.lines.push({id:h.id,enabled:h.enabled,condition:h.condition,hitCondition:h.hitCondition,logMessage:h.logMessage,line:h.location.range.start.line,character:h.location.range.start.character})}else h instanceof A.$BL&&c.push({type:"function",id:h.id,enabled:h.enabled,hitCondition:h.hitCondition,logMessage:h.logMessage,condition:h.condition,functionName:h.functionName});return this.k.$registerBreakpoints(c)}removeBreakpoints(s){const d=s.filter(E=>this.w.delete(E.id));this.U([],d,[]);const c=d.filter(E=>E instanceof A.$AL).map(E=>E.id),u=d.filter(E=>E instanceof A.$BL).map(E=>E.id),h=d.filter(E=>E instanceof A.$CL).map(E=>E.id);return this.k.$unregisterBreakpoints(c,u,h)}startDebugging(s,d,c){return this.k.$startDebugging(s?s.uri:void 0,d,{parentSessionID:c.parentSession?c.parentSession.id:void 0,lifecycleManagedByParent:c.lifecycleManagedByParent,repl:c.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:c.noDebug,compact:c.compact,suppressSaveBeforeStart:c.suppressSaveBeforeStart,suppressDebugStatusbar:c.suppressDebugStatusbar??c.debugUI?.simple,suppressDebugToolbar:c.suppressDebugToolbar??c.debugUI?.simple,suppressDebugView:c.suppressDebugView??c.debugUI?.simple})}stopDebugging(s){return this.k.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,d,c){if(!d)return new A.$BK(()=>{});const u=this.d++;return this.f.push({type:s,handle:u,provider:d}),this.k.$registerDebugConfigurationProvider(s,c,!!d.provideDebugConfigurations,!!d.resolveDebugConfiguration,!!d.resolveDebugConfigurationWithSubstitutedVariables,u),new A.$BK(()=>{this.f=this.f.filter(h=>h.provider!==d),this.k.$unregisterDebugConfigurationProvider(u)})}registerDebugAdapterDescriptorFactory(s,d,c){if(!c)return new A.$BK(()=>{});if(!this.Q(s,d))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${d}' debugger.`);if(this.N(d))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const u=this.g++;return this.h.push({type:d,handle:u,factory:c}),this.k.$registerDebugAdapterDescriptorFactory(d,u),new A.$BK(()=>{this.h=this.h.filter(h=>h.factory!==c),this.k.$unregisterDebugAdapterDescriptorFactory(u)})}registerDebugAdapterTrackerFactory(s,d){if(!d)return new A.$BK(()=>{});const c=this.i++;return this.j.push({type:s,handle:c,factory:d}),new A.$BK(()=>{this.j=this.j.filter(u=>u.factory!==d)})}async $runInTerminal(s,d){return Promise.resolve(void 0)}async $substituteVariables(s,d){let c;const u=await this.W(s);return u&&(c={uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(c,d)}K(s,d){if(s.type==="implementation")return new r(s.implementation)}L(){}async $startDASession(s,d){const c=this,u=await this.V(d);return this.S(this.N(u.type),u).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}' (extension might have failed to activate)`);const E=this.M(h),D=this.K(E,u);if(!D)throw new Error(`Couldn't create a debug adapter for type '${u.type}'.`);const m=D;return this.B.set(s,m),this.R(u).then(p=>(p&&this.C.set(s,p),m.onMessage(async k=>{if(k.type==="request"&&k.command==="handshake"){const P=k,z={type:"response",seq:0,command:P.command,request_seq:P.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const j=await this.D.sign(P.arguments.value);z.body={signature:j},m.sendResponse(z)}else throw new Error("no signer")}catch(j){z.success=!1,z.message=j.message,m.sendResponse(z)}}else p&&p.onDidSendMessage&&p.onDidSendMessage(k),k=(0,v.$oF)(k,!0),c.k.$acceptDAMessage(s,k)}),m.onError(k=>{p&&p.onError&&p.onError(k),this.k.$acceptDAError(s,k.name,k.message,k.stack)}),m.onExit(k=>{p&&p.onExit&&p.onExit(k??void 0,void 0),this.k.$acceptDAExit(s,k??void 0,void 0)}),p&&p.onWillStartSession&&p.onWillStartSession(),m.startSession()))})}$sendDAMessage(s,d){d=(0,v.$nF)(d,!1);const c=this.C.get(s);c&&c.onWillReceiveMessage&&c.onWillReceiveMessage(d),this.B.get(s)?.sendMessage(d)}$stopDASession(s){const d=this.C.get(s);this.C.delete(s),d&&d.onWillStopSession&&d.onWillStopSession();const c=this.B.get(s);return this.B.delete(s),c?c.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const d=[],c=[],u=[];if(s.added)for(const h of s.added){const E=h.id;if(E&&!this.w.has(E)){let D;if(h.type==="function")D=new A.$BL(h.functionName,h.enabled,h.condition,h.hitCondition,h.logMessage);else if(h.type==="data")D=new A.$CL(h.label,h.dataId,h.canPersist,h.enabled,h.hitCondition,h.condition,h.logMessage);else{const m=f.URI.revive(h.uri);D=new A.$AL(new A.$NK(m,new A.$CK(h.line,h.character)),h.enabled,h.condition,h.hitCondition,h.logMessage)}(0,A.$yL)(D,E),this.w.set(E,D),d.push(D)}}if(s.removed)for(const h of s.removed){const E=this.w.get(h);E&&(this.w.delete(h),c.push(E))}if(s.changed){for(const h of s.changed)if(h.id){const E=this.w.get(h.id);if(E){if(E instanceof A.$BL&&h.type==="function"){const D=E;D.enabled=h.enabled,D.condition=h.condition,D.hitCondition=h.hitCondition,D.logMessage=h.logMessage,D.functionName=h.functionName}else if(E instanceof A.$AL&&h.type==="source"){const D=E;D.enabled=h.enabled,D.condition=h.condition,D.hitCondition=h.hitCondition,D.logMessage=h.logMessage,D.location=new A.$NK(f.URI.revive(h.uri),new A.$CK(h.line,h.character))}u.push(E)}}}this.U(d,c,u)}async $acceptStackFrameFocus(s){let d;const c=s.sessionId?await this.V(s.sessionId):void 0;if(!c)throw new Error("no DebugSession found for debug focus context");s.kind==="thread"?d=new A.$IL(c,s.threadId):d=new A.$HL(c,s.threadId,s.frameId),this.z=d,this.A.fire(this.z)}$provideDebugConfigurations(s,d,c){return(0,C.$Qg)(async()=>{const u=this.P(s);if(!u)throw new Error("no DebugConfigurationProvider found");if(!u.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const h=await this.W(d);return u.provideDebugConfigurations(h,c)}).then(u=>{if(!u)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return u})}$resolveDebugConfiguration(s,d,c,u){return(0,C.$Qg)(async()=>{const h=this.P(s);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const E=await this.W(d);return h.resolveDebugConfiguration(E,c,u)})}$resolveDebugConfigurationWithSubstitutedVariables(s,d,c,u){return(0,C.$Qg)(async()=>{const h=this.P(s);if(!h)throw new Error("no DebugConfigurationProvider found");if(!h.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const E=await this.W(d);return h.resolveDebugConfigurationWithSubstitutedVariables(E,c,u)})}async $provideDebugAdapter(s,d){const c=this.O(s);if(!c)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const u=await this.V(d);return this.S(c,u).then(h=>{if(!h)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}'`);return this.M(h)})}async $acceptDebugSessionStarted(s){const d=await this.V(s);this.m.fire(d)}async $acceptDebugSessionTerminated(s){const d=await this.V(s);d&&(this.n.fire(d),this.l.delete(d.id))}async $acceptDebugSessionActiveChanged(s){this.q=s?await this.V(s):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(s,d){(await this.V(s))?._acceptNameChanged(d)}async $acceptDebugSessionCustomEvent(s,d){const u={session:await this.V(s),event:d.event,body:d.body};this.u.fire(u)}M(s){if(s instanceof A.$DL)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof A.$EL)return{type:"server",port:s.port,host:s.host};if(s instanceof A.$FL)return{type:"pipeServer",path:s.path};if(s instanceof A.$GL)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}N(s){const d=this.h.filter(c=>c.type===s);if(d.length>0)return d[0].factory}O(s){const d=this.h.filter(c=>c.handle===s);if(d.length>0)return d[0].factory}P(s){const d=this.f.filter(c=>c.handle===s);if(d.length>0)return d[0].provider}Q(s,d){if(s.contributes){const c=s.contributes.debuggers;if(c&&c.length>0){for(const u of c)if(u.label&&u.type&&u.type===d)return!0}}return!1}R(s){const c=s.configuration.type,u=this.j.filter(h=>h.type===c||h.type==="*").map(h=>(0,C.$Qg)(()=>h.factory.createDebugAdapterTracker(s)).then(E=>E,E=>null));return Promise.race([Promise.all(u).then(h=>{const E=h.filter(D=>!!D);if(E.length>0)return new n(E)}),new Promise(h=>setTimeout(()=>h(void 0),1e3))]).catch(h=>{})}async S(s,d){const c=d.configuration.debugServer;if(typeof c=="number")return Promise.resolve(new A.$EL(c));if(s){const h=await this.F.getExtensionRegistry();return(0,C.$Qg)(()=>s.createDebugAdapterDescriptor(d,this.T(d,h))).then(E=>{if(E)return E})}const u=await this.F.getExtensionRegistry();return Promise.resolve(this.T(d,u))}T(s,d){}U(s,d,c){(s.length>0||d.length>0||c.length>0)&&this.y.fire(Object.freeze({added:s,removed:d,changed:c}))}async V(s){if(s)if(typeof s=="string"){const d=this.l.get(s);if(d)return d}else{let d=this.l.get(s.id);if(!d){const c=await this.W(s.folderUri),u=s.parent?this.l.get(s.parent):void 0;d=new o(this.k,s.id,s.type,s.name,c,s.configuration,u),this.l.set(d.id,d),this.k.$sessionCached(d.id)}return d}throw new Error("cannot find session")}W(s){if(s){const d=f.URI.revive(s);return this.E.resolveWorkspaceFolder(d)}return Promise.resolve(void 0)}};e.$Oec=l,e.$Oec=l=He([Be(0,g.$BM),Be(1,I.$7dc),Be(2,y.$Iec),Be(3,S.$0dc),Be(4,b.$jec),Be(5,w.$Lec)],l);class o{constructor(s,d,c,u,h,E,D){this.d=s,this.f=d,this.g=c,this.h=u,this.i=h,this.j=E,this.k=D}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(s){this.h=s,this.d.$setDebugSessionName(this.f,s)}get parentSession(){return this.k}_acceptNameChanged(s){this.h=s}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(s,d){return this.d.$customDebugAdapterRequest(this.f,s,d)}getDebugProtocolBreakpoint(s){return this.d.$getDebugProtocolBreakpoint(this.f,s.id)}}e.$Pec=o;class i{constructor(s){this.value=Object.freeze({append(d){s.$appendDebugConsole(d)},appendLine(d){this.append(d+`
`)}})}}e.$Qec=i;class n{constructor(s){this.d=s}onWillStartSession(){this.d.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.d.forEach(d=>d.onWillReceiveMessage?d.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.d.forEach(d=>d.onDidSendMessage?d.onDidSendMessage(s):void 0)}onWillStopSession(){this.d.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.d.forEach(d=>d.onError?d.onError(s):void 0)}onExit(s,d){this.d.forEach(c=>c.onExit?c.onExit(s,d):void 0)}}class r extends $.$$cb{constructor(s){super(),this.h=s,s.onDidSendMessage(d=>{this.acceptMessage(d)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.h.handleMessage(s)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let a=class extends l{constructor(s,d,c,u,h,E){super(s,d,c,u,h,E)}};e.$Rec=a,e.$Rec=a=He([Be(0,g.$BM),Be(1,I.$7dc),Be(2,y.$Iec),Be(3,S.$0dc),Be(4,b.$jec),Be(5,w.$Lec)],a)}),define(ke[365],Se([1,0,8,56,2,6,353,14,106,107,27,248,20,66,47,90]),function(me,e,C,T,f,R,L,b,y,g,A,I,$,v,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ufc=e.$Tfc=void 0;class l{static async installEarlyHandler(n){Error.stackTraceLimit=100;const r=n.get(b.$dj),t=n.get($.$BM).getProxy(R.$zK.MainThreadErrors);C.setUnexpectedErrorHandler(s=>{r.error(s);const d=C.$2(s);t.$onUnexpectedError(d)})}static async installFullHandler(n){const r=n.get(b.$dj),a=n.get($.$BM),t=n.get(S.$Iec),s=n.get(w.$VM),d=a.getProxy(R.$zK.MainThreadExtensionService),c=a.getProxy(R.$zK.MainThreadErrors),u=await t.getExtensionPathIndex(),h=new WeakMap;function E(p,k){if(h.has(p))return h.get(p).stack;let P="",z,j;for(const O of k)P+=`
	at ${O.toString()}`,j=O.getFileName(),!z&&j&&(z=u.findSubstr(f.URI.file(j)));const M=`${p.name||"Error"}: ${p.message||""}${P}`;return h.set(p,{extensionIdentifier:z?.identifier,stack:M}),M}const D=Symbol("prepareStackTrace wrapped");let m=E;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return m},set(p){if(p===E||!p||p[D]){m=p||E;return}m=function(k,P){return E(k,P),p.call(Error,k,P)},Object.assign(m,{[D]:!0})}}),C.setUnexpectedErrorHandler(p=>{r.error(p);const k=C.$2(p),P=h.get(p);if(!P?.extensionIdentifier){c.$onUnexpectedError(k);return}d.$onExtensionRuntimeError(P.extensionIdentifier,k);const z=s.onExtensionError(P.extensionIdentifier,p);r.trace("forwarded error to extension?",z,P)})}}e.$Tfc=l;class o{constructor(n,r,a,t,s){this.a=a,this.b=new L.$55b(n,null,t),r=o.e(r,this.b);const d=new g.$Th(...(0,y.$Dr)());d.set(A.$RM,{_serviceBrand:void 0,...r,messagePorts:s}),d.set($.$BM,new $.$CM(this.b)),d.set(v.$4dc,new v.$5dc(t)),d.set(S.$Gec,a);const c=new I.$jq(d,!0);c.invokeFunction(l.installEarlyHandler),this.d=c.invokeFunction(u=>u.get(b.$dj)),T.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",r),this.c=c.invokeFunction(u=>u.get(S.$Iec)),this.c.initialize(),c.invokeFunction(l.installFullHandler)}async asBrowserUri(n){const r=this.b.getProxy(R.$zK.MainThreadExtensionService);return f.URI.revive(await r.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,r){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=f.URI.revive(r.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=f.URI.revive(r.transformIncomingURIs(n.environment.appRoot));const a=n.environment.extensionDevelopmentLocationURI;return a&&(n.environment.extensionDevelopmentLocationURI=a.map(t=>f.URI.revive(r.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=f.URI.revive(r.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=f.URI.revive(r.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=f.URI.revive(r.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=f.URI.revive(r.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=f.URI.revive(r.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=f.URI.revive(r.transformIncomingURIs(n.logsLocation)),n.workspace=r.transformIncomingURIs(n.workspace),n}}e.$Ufc=o}),define(ke[366],Se([1,0,12,11,223,242,140,96,70,47,20,46,7,58,41,283,284,42]),function(me,e,C,T,f,R,L,b,y,g,A,I,$,v,S,w,l,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5fc=void 0;let i=class extends b.$Oec{constructor(s,d,c,u,h,E,D){super(s,d,c,u,E,D),this.Z=h,this.X=new a}K(s,d){switch(s.type){case"server":return new w.$Zfc(s);case"pipeServer":return new w.$1fc(s);case"executable":return new w.$2fc(s,d.type)}return super.K(s,d)}T(s,d){const c=w.$2fc.platformAdapterExecutable(d.getAllExtensionDescriptions(),s.type);if(c)return new $.$DL(c.command,c.args,c.options)}L(){return new L.$T9b}async $runInTerminal(s,d){if(s.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(M=>{this.X.onTerminalClosed(M)}));const c=await this.G.getConfigProvider(),u=this.Z.getDefaultShell(!0),h=this.Z.getDefaultShellArgs(!0),E=s.title||f.localize(0,null),D=JSON.stringify({shell:u,shellArgs:h});let m=await this.X.checkout(D,E),p,k=!1;if(m)p=s.cwd;else{const M={shellPath:u,shellArgs:h,cwd:s.cwd,name:E,iconPath:new $.$vL("debug")};k=!0,m=this.Z.createTerminalFromOptions(M,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(m,D)}m.show(!0);const P=await m.processId;k?await new Promise(M=>setTimeout(M,1e3)):c.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(u.indexOf("powershell")>=0||u.indexOf("pwsh")>=0||u.indexOf("cmd.exe")>=0?m.sendText("cls"):u.indexOf("bash")>=0?m.sendText("clear"):T.$i?m.sendText("cls"):m.sendText("clear"));const z=(0,l.$4fc)(u,s.args,!!s.argsCanBeInterpretedByShell,p,s.env);m.sendText(z);const j=this.onDidTerminateDebugSession(M=>{M.id===d&&(this.X.free(m),j.dispose())});return P}else if(s.kind==="external")return r(s,await this.G.getConfigProvider());return super.$runInTerminal(s,d)}};e.$5fc=i,e.$5fc=i=He([Be(0,A.$BM),Be(1,S.$7dc),Be(2,g.$Iec),Be(3,o.$0dc),Be(4,I.$vec),Be(5,y.$jec),Be(6,v.$Lec)],i);let n;function r(t,s){if(!n)if(T.$i)n=new R.$F8b;else if(T.$j)n=new R.$G8b;else if(T.$k)n=new R.$H8b;else throw new Error("external terminals not supported on this platform");const d=s.getConfiguration("terminal");return n.runInTerminal(t.title,t.cwd,t.args,t.env||{},d.external||{})}class a{constructor(){this.b=new Map}static{this.a=1e3}async checkout(s,d){const u=[...this.b.entries()].map(([h,E])=>(0,C.$Lg)(async D=>{if(h.name!==d||E.lastUsedAt!==-1&&await(0,l.$3fc)(await h.processId))return null;const m=Date.now();return E.lastUsedAt+a.a>m||D.isCancellationRequested||E.config!==s?null:(E.lastUsedAt=m,h)}));return await(0,C.$3g)(u,h=>!!h)}insert(s,d){this.b.set(s,{lastUsedAt:Date.now(),config:d})}free(s){const d=this.b.get(s);d&&(d.lastUsedAt=-1)}onTerminalClosed(s){this.b.delete(s)}}}),define(ke[367],Se([1,0,16,2,104,41,69,42,40,46,20,27,95,17,14,91,23,63,58]),function(me,e,C,T,f,R,L,b,y,g,A,I,$,v,S,w,l,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wfc=void 0;let n=class extends $.$yfc{constructor(a,t,s,d,c,u,h,E,D){super(a,t,s,d,c,u,h,E),this.B=s,this.C=D,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(v.Schemas.vscodeRemote,{scheme:v.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(v.Schemas.file,{scheme:v.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(a,t){const s=t;if(!t.execution&&s._id===void 0)throw new Error("Tasks to execute must include an execution");if(s._id!==void 0){const d=$.TaskHandleDTO.from(s,this.B),c=await this.a.$getTaskExecution(d);if(c.task===void 0)throw new Error("Task from execution DTO is undefined");const u=await this.y(c,t);return this.a.$executeTask(d).catch(()=>{}),u}else{const d=$.TaskDTO.from(t,a);if(d===void 0)return Promise.reject(new Error("Task is not valid"));$.CustomExecutionDTO.is(d.execution)&&await this.x(d,t,!1);const c=await this.y(await this.a.$getTaskExecution(d),t);return this.a.$executeTask(d).catch(()=>{}),c}}u(a,t,s,d){const c=[];if(d)for(const u of d){this.z(u,s),(!u.definition||!a[u.definition.type])&&this.f.warn(`The task [${u.source}, ${u.name}] uses an undefined task type. The task will be ignored in the future.`);const h=$.TaskDTO.from(u,s.extension);h&&(c.push(h),$.CustomExecutionDTO.is(h.execution)&&t.push(this.x(h,u,!0)))}return{tasks:c,extension:s.extension}}async v(a){return a}async F(a){let t=a&&a.length>0?a[0]:void 0;if(!t){const s=T.URI.file((0,o.homedir)());t=new y.$di({uri:s,name:l.$wg(s),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(a,t){const s=T.URI.revive(a),d={process:void 0,variables:Object.create(null)},c=await this.b.resolveWorkspaceFolder(s),u=await this.b.getWorkspaceFolders2()??[],h=await this.C.getResolver(),E=c?{uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(u);for(const D of t.variables)d.variables[D]=await h.resolveAsync(E,D);if(t.process!==void 0){let D;if(t.process.path!==void 0){D=t.process.path.split(C.$sc);for(let m=0;m<D.length;m++)D[m]=await h.resolveAsync(E,D[m])}d.process=await f.win32.findExecutable(await h.resolveAsync(E,t.process.name),t.process.cwd!==void 0?await h.resolveAsync(E,t.process.cwd):void 0,D)}return d}async $jsonTasksSupported(){return!0}async $findExecutable(a,t,s){return f.win32.findExecutable(a,t,s)}};e.$Wfc=n,e.$Wfc=n=He([Be(0,A.$BM),Be(1,I.$RM),Be(2,R.$7dc),Be(3,L.$MM),Be(4,b.$0dc),Be(5,g.$vec),Be(6,S.$dj),Be(7,w.$Odc),Be(8,i.$Lec)],n)}),define(ke[368],Se([1,0,63,58]),function(me,e,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cgc=void 0;class f extends T.$Mec{m(){return(0,C.homedir)()}}e.$Cgc=f}),define(ke[156],Se([1,0,19,12,21,43,17,16,23,2,36]),function(me,e,C,T,f,R,L,b,y,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ec=e.$8ec=e.$7ec=e.$6ec=void 0;class I{constructor(i,n,r,a){this.d=i,this.e=n,this.f=r,this.g=a,this.a=null,this.b=!1,this.c=0}search(i,n){const r=this.d.folderQueries||[],a=new f.$2d(n);return new Promise((t,s)=>{this.a=new v(i);let d=!1;const c=(u,h)=>{if(!d&&!this.b){const E=this.h(u);w(u)&&typeof this.d.maxResults=="number"&&this.c+E>this.d.maxResults&&(this.b=!0,d=!0,a.cancel(),u=this.j(u,this.d.maxResults-this.c));const D=this.h(u);this.c+=D,(D>0||!w(u))&&this.a.add(u,h)}};Promise.all(r.map((u,h)=>this.k(u,E=>c(E,h),a.token))).then(u=>{a.dispose(),this.a.flush();const h=u.some(E=>!!E&&!!E.limitHit);t({limitHit:this.b||h,messages:(0,C.$Qb)(u.map(E=>E?.message?Array.isArray(E.message)?E.message:[E.message]:[])),stats:{type:this.g}})},u=>{a.dispose();const h=(0,R.$Gi)(u);s(new Error(h))})})}h(i){return w(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,n){const r=Array.isArray(i.ranges)?i.ranges:[i.ranges],a=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:r.slice(0,n),preview:{matches:a.slice(0,n),text:i.preview.text},uri:i.uri}}async k(i,n,r){const a=new A.$eJ(this.d,i),t=[],s={report:u=>{if(!this.l(u))return;const h=i.folder.scheme===L.Schemas.file?(0,A.$fJ)(()=>this.f.readdir(y.$yg(u.uri))):void 0,E=y.$Bg(i.folder,u.uri);if(E){const D=a.includedInQuery(E,b.$mc(E),h);(0,T.$Kg)(D)?t.push(D.then(m=>{m&&n(u)})):D&&n(u)}}},d=this.n(i),c=await this.e.provideTextSearchResults($(this.d.contentPattern),d,s,r);return t.length&&await Promise.all(t),c}l(i){if(w(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const n=(0,A.$dJ)(this.d.includePattern,i.includePattern),r=(0,A.$dJ)(this.d.excludePattern,i.excludePattern),a={folder:g.URI.from(i.folder),excludes:r,includes:n,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.f.toCanonicalName(i.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return a.usePCRE2=this.d.usePCRE2,a}}e.$6ec=I;function $(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class v{constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new l(512,n=>this.g(n))}add(i,n){this.d&&(this.b!==n||!y.$sg(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:i.uri,results:[]}),this.d.results.push(S(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$7ec=v;function S(o){return w(o)?{preview:{matches:(0,C.$1b)(o.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:o.preview.text},ranges:(0,C.$1b)(o.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function w(o){return!!o.preview}e.$8ec=w;class l{static{this.a=4e3}static{this.b=50}constructor(i,n){this.g=i,this.h=n,this.c=0,this.d=[],this.e=0}addItem(i,n){i&&this.j(i,n)}addItems(i,n){i&&this.k(i,n)}j(i,n){this.d.push(i),this.e+=n,this.l()}k(i,n){this.d=this.d.concat(i),this.e+=n,this.l()}l(){this.c<l.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},l.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$9ec=l}),define(ke[97],Se([1,0,3,6,5,361,20,66,14,2,156]),function(me,e,C,T,f,R,L,b,y,g,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ec=e.$$ec=e.$0ec=void 0,e.$0ec=(0,f.$Vh)("IExtHostSearch");let I=class{constructor(w,l,o){this.k=w,this.l=l,this.n=o,this.c=this.k.getProxy(T.$zK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new R.$5ec}o(w){return this.l.transformOutgoingScheme(w)}registerTextSearchProvider(w,l){if(this.g.has(w))throw new Error(`a text search provider for the scheme '${w}' is already registered`);this.g.add(w);const o=this.d++;return this.e.set(o,l),this.c.$registerTextSearchProvider(o,this.o(w)),(0,C.$Pc)(()=>{this.g.delete(w),this.e.delete(o),this.c.$unregisterProvider(o)})}registerFileSearchProvider(w,l){if(this.i.has(w))throw new Error(`a file search provider for the scheme '${w}' is already registered`);this.i.add(w);const o=this.d++;return this.h.set(o,l),this.c.$registerFileSearchProvider(o,this.o(w)),(0,C.$Pc)(()=>{this.i.delete(w),this.h.delete(o),this.c.$unregisterProvider(o)})}$provideFileSearchResults(w,l,o,i){const n=$(o),r=this.h.get(w);if(r)return this.j.fileSearch(n,r,a=>{this.c.$handleFileMatch(w,l,a.map(t=>t.resource))},i);throw new Error("unknown provider: "+w)}async doInternalFileSearchWithCustomCallback(w,l,o){return{messages:[]}}$clearCache(w){return this.j.clearCache(w),Promise.resolve(void 0)}$provideTextSearchResults(w,l,o,i){const n=this.e.get(w);if(!n||!n.provideTextSearchResults)throw new Error(`Unknown provider ${w}`);const r=$(o);return this.q(r,n).search(t=>this.c.$handleTextMatch(w,l,t),i)}$enableExtensionHostSearch(){}q(w,l){return new A.$6ec(w,l,{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}};e.$$ec=I,e.$$ec=I=He([Be(0,L.$BM),Be(1,b.$4dc),Be(2,y.$dj)],I);function $(S){return{...S,folderQueries:S.folderQueries&&S.folderQueries.map(v),extraFileResources:S.extraFileResources&&S.extraFileResources.map(w=>g.URI.revive(w))}}e.$_ec=$;function v(S){return{...S,folder:g.URI.revive(S.folder)}}}),define(ke[369],Se([1,0,21,8,4,3,17,39,2,133,191,172,79,26,31,14,137,65,87,267,6,305,313,91,306,307,308,309,310,311,312,288,35,314,42,344,96,151,316,317,318,294,319,69,70,320,47,321,71,322,57,27,323,324,325,326,327,328,115,116,329,360,296,273,297,330,331,154,332,298,333,334,20,335,97,117,336,337,338,118,92,95,90,46,339,340,285,341,299,72,15,7,342,66,343,93,345,346,153,41,281,114,25,94]),function(me,e,C,T,f,R,L,b,y,g,A,I,$,v,S,w,l,o,i,n,r,a,t,s,d,c,u,h,E,D,m,p,k,P,z,j,M,O,F,N,W,X,ce,J,Q,G,oe,_,Ee,he,q,U,ne,be,H,x,Y,$e,ie,fe,te,de,pe,Pe,B,Z,re,ae,ee,ge,ye,ze,We,et,Ye,rt,nt,Ae,Ne,Ve,Le,Xe,le,ue,Ie,Ke,Ge,_e,st,lt,wt,Ue,Kt,Ht,Et,Ut,Ot,Gt,Bt,Dt,Mt,Wt,tt,Vt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ofc=void 0;function qt(ut){const mt=ut.get(U.$RM),Nt=ut.get(q.$Ldc),Pt=ut.get(Ee.$_dc),At=ut.get(oe.$Iec),gt=ut.get(Dt.$7dc),St=ut.get(le.$VM),Rt=ut.get(z.$0dc),It=ut.get(Ht.$4dc),Je=ut.get(We.$BM),zt=ut.get(Ve.$sec),Jt=ut.get(Le.$aec),Me=ut.get(w.$ej),Fe=ut.get(w.$dj),Ce=ut.get(lt.$Pwb),se=ut.get(s.$Odc),Te=ut.get(Bt.$Nfc),qe=ut.get(rt.$Aec),xe=ut.get(Q.$jec),Qe=ut.get(fe.$Eec);Je.set(r.$AK.ExtHostFileSystemInfo,Nt),Je.set(r.$AK.ExtHostLogLevelServiceShape,Me),Je.set(r.$AK.ExtHostWorkspace,gt),Je.set(r.$AK.ExtHostConfiguration,Rt),Je.set(r.$AK.ExtHostExtensionService,At),Je.set(r.$AK.ExtHostStorage,zt),Je.set(r.$AK.ExtHostTunnelService,Ce),Je.set(r.$AK.ExtHostWindow,Te),Je.set(r.$AK.ExtHostSecretState,qe),Je.set(r.$AK.ExtHostTelemetry,St),Je.set(r.$AK.ExtHostEditorTabs,xe),Je.set(r.$AK.ExtHostManagedSockets,Qe);const ot=Je.set(r.$AK.ExtHostDecorations,ut.get(O.$Tec)),pt=Je.set(r.$AK.ExtHostDocumentsAndEditors,ut.get(J.$MM)),bt=Je.set(r.$AK.ExtHostCommands,ut.get(k.$XM)),vt=Je.set(r.$AK.ExtHostTerminalService,ut.get(ue.$vec)),ht=Je.set(r.$AK.ExtHostDebugService,ut.get(M.$Nec)),Lt=Je.set(r.$AK.ExtHostSearch,ut.get(Ye.$0ec)),Qt=Je.set(r.$AK.ExtHostTask,ut.get(Xe.$Afc)),Xt=Je.set(r.$AK.ExtHostOutputService,ut.get(ae.$nfc)),si=Je.set(r.$AK.ExtHostLocalization,ut.get(ie.$Dec)),Si=Je.set(r.$AK.ExtHostUrls,new Et.$Kfc(Je)),Ct=Je.set(r.$AK.ExtHostDocuments,new ce.$Jdc(Je,pt)),Yi=Je.set(r.$AK.ExtHostDocumentContentProviders,new W.$Vec(Je,pt,Fe)),ln=Je.set(r.$AK.ExtHostDocumentSaveParticipant,new X.$Wec(Fe,Ct,Je.getProxy(r.$zK.MainThreadBulkEdits))),kt=Je.set(r.$AK.ExtHostNotebook,new de.$afc(Je,bt,pt,Ct,Pt,Lt)),mi=Je.set(r.$AK.ExtHostNotebookDocuments,new Pe.$hfc(kt)),$i=Je.set(r.$AK.ExtHostNotebookEditors,new B.$ifc(Fe,kt)),oi=Je.set(r.$AK.ExtHostNotebookKernels,new Z.$jfc(Je,mt,kt,bt,Fe)),Di=Je.set(r.$AK.ExtHostNotebookRenderers,new re.$lfc(Je,kt)),Ci=Je.set(r.$AK.ExtHostNotebookDocumentSaveParticipant,new pe.$gfc(Fe,kt,Je.getProxy(r.$zK.MainThreadBulkEdits))),Ft=Je.set(r.$AK.ExtHostEditors,new Ke.$1dc(Je,pt)),bi=Je.set(r.$AK.ExtHostTreeViews,new st.$Ifc(Je.getProxy(r.$zK.MainThreadTreeViews),bt,Fe)),Ii=Je.set(r.$AK.ExtHostEditorInsets,new p.$2dc(Je.getProxy(r.$zK.MainThreadEditorInsets),Ft,mt.remote)),ai=Je.set(r.$AK.ExtHostDiagnostics,new F.$Ndc(Je,Fe,Nt,pt)),ci=Je.set(r.$AK.ExtHostLanguages,new $e.$efc(Je,Ct,bt.converter,It)),dt=Je.set(r.$AK.ExtHostLanguageFeatures,new Y.$Rdc(Je,It,Ct,bt,ai,Fe,se,St)),Pi=Je.set(r.$AK.ExtHostFileSystem,new _.$Yec(Je,dt)),xt=Je.set(r.$AK.ExtHostFileSystemEventService,new he.$Zec(Je,Fe,pt)),ni=Je.set(r.$AK.ExtHostQuickOpen,(0,ze.$rfc)(Je,gt,bt)),hi=Je.set(r.$AK.ExtHostSCM,new et.$tfc(Je,bt,Ct,Fe)),Xi=Je.set(r.$AK.ExtHostQuickDiff,new ye.$qfc(Je,It)),Ai=Je.set(r.$AK.ExtHostShare,new nt.$ufc(Je,It)),Ri=Je.set(r.$AK.ExtHostComments,(0,P.$3dc)(Je,bt,Ct)),Li=Je.set(r.$AK.ExtHostProgress,new ge.$pfc(Je.getProxy(r.$zK.MainThreadProgress))),xi=Je.set(r.$AK.ExtHosLabelService,new x.$dfc(Je)),Mi=Je.set(r.$AK.ExtHostTheming,new Ge.$Ffc(Je)),ui=Je.set(r.$AK.ExtHostAuthentication,new d.$Tdc(Je)),_i=Je.set(r.$AK.ExtHostTimeline,new _e.$Hfc(Je,bt)),Fi=Je.set(r.$AK.ExtHostWebviews,new Ut.$eec(Je,mt.remote,gt,Fe,se)),Ti=Je.set(r.$AK.ExtHostWebviewPanels,new Ot.$hec(Je,Fi,gt)),Ni=Je.set(r.$AK.ExtHostCustomEditors,new j.$iec(Je,Ct,Jt,Fi,Ti)),Oi=Je.set(r.$AK.ExtHostWebviewViews,new Gt.$Lfc(Je,Fi)),di=Je.set(r.$AK.ExtHostTesting,new Ie.$Bfc(Je,bt,pt)),hn=Je.set(r.$AK.ExtHostUriOpeners,new Kt.$Jfc(Je)),en=Je.set(r.$AK.ExtHostProfileContentHandlers,new ee.$ofc(Je));Je.set(r.$AK.ExtHostInteractive,new be.$bfc(Je,kt,pt,bt,Fe));const zi=Je.set(r.$AK.ExtHostInlineChat,new ne.$1ec(Je,bt,Ct,Fe)),pi=Je.set(r.$AK.ExtHostChatProvider,new E.$Wdc(Je,Fe)),tn=Je.set(r.$AK.ExtHostChatAgents2,new h.$Xdc(Je,pi,Fe)),nn=Je.set(r.$AK.ExtHostChatVariables,new D.$Ydc(Je)),wi=Je.set(r.$AK.ExtHostChat,new u.$Vdc(Je)),vi=Je.set(r.$AK.ExtHostAiRelatedInformation,new a.$Idc(Je)),rn=Je.set(r.$AK.ExtHostAiEmbeddingVector,new G.$Xec(Je)),_t=Je.set(r.$AK.ExtHostIssueReporter,new H.$cfc(Je)),fi=Je.set(r.$AK.ExtHostStatusBar,new Ne.$xfc(Je,bt.converter)),dn=Je.set(r.$AK.ExtHostSpeech,new Ae.$vfc(Je)),Zt=Object.values(r.$AK);Je.assertRegistered(Zt);const yi=new c.$Udc(Je,pt),sn=new m.$Zdc(Je),Ei=new te.$ffc(Je,Fe),ji=new N.$Uec(Je);return t.$Sdc.register(bt),function(je,ti,Ui){const $t=function(){let we=!je.isUnderDevelopment;function De(){we||(Fe.info(`Extension '${je.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),we=!0)}return function Oe(at){if(Array.isArray(at))at.forEach(Oe);else if(typeof at=="string")De();else{const yt=at;typeof yt.scheme>"u"&&De(),typeof yt.exclusive=="boolean"&&(0,tt.$NF)(je,"documentFiltersExclusive")}return at}}(),fn={getSession(we,De,Oe){return ui.getSession(je,we,De,Oe)},getSessions(we,De){return(0,tt.$NF)(je,"authGetSessions"),ui.getSessions(je,we,De)},async hasSession(we,De){return(0,tt.$NF)(je,"authSession"),!!await ui.getSession(je,we,De,{silent:!0})},get onDidChangeSessions(){return ui.onDidChangeSessions},registerAuthenticationProvider(we,De,Oe,at){return ui.registerAuthenticationProvider(we,De,Oe,at)}},gn={registerCommand(we,De,Oe){return bt.registerCommand(!0,we,De,Oe,void 0,je)},registerTextEditorCommand(we,De,Oe){return bt.registerCommand(!0,we,(...at)=>{const yt=Ft.getActiveTextEditor();if(!yt){Fe.warn("Cannot execute "+we+" because there is no active text editor.");return}return yt.edit(Tt=>{De.apply(Oe,[yt,Tt,...at])}).then(Tt=>{Tt||Fe.warn("Edits from command "+we+" were not applied.")},Tt=>{Fe.warn("An error occurred while running command "+we,Tt)})},void 0,void 0,je)},registerDiffInformationCommand:(we,De,Oe)=>((0,tt.$NF)(je,"diffCommand"),bt.registerCommand(!0,we,async(...at)=>{const yt=pt.activeEditor(!0);if(!yt){Fe.warn("Cannot execute "+we+" because there is no active text editor.");return}const Tt=await Ft.getDiffInformation(yt.id);De.apply(Oe,[Tt,...at])},void 0,void 0,je)),executeCommand(we,...De){return bt.executeCommand(we,...De)},getCommands(we=!1){return bt.getCommands(we)}},ki={get machineId(){return mt.telemetryInfo.machineId},get sessionId(){return mt.telemetryInfo.sessionId},get language(){return mt.environment.appLanguage},get appName(){return mt.environment.appName},get appRoot(){return mt.environment.appRoot?.fsPath??""},get appHost(){return mt.environment.appHost},get uriScheme(){return mt.environment.appUriScheme},get clipboard(){return sn.value},get shell(){return vt.getDefaultShell(!1)},get onDidChangeShell(){return vt.onDidChangeShell},get isTelemetryEnabled(){return St.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return St.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,tt.$NF)(je,"telemetry"),St.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,tt.$NF)(je,"telemetry"),St.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,le.$UM)(mt.telemetryInfo.firstSessionDate)},createTelemetryLogger(we,De){return le.$TM.validateSender(we),St.instantiateLogger(je,we,De)},openExternal(we,De){return Te.openUri(we,{allowTunneling:!!mt.remote.authority,allowContributedOpeners:De?.allowContributedOpeners})},async asExternalUri(we){if(we.scheme===mt.environment.appUriScheme)return Si.createAppUri(we);try{return await Te.asExternalUri(we,{allowTunneling:!!mt.remote.authority})}catch(De){if((0,l.$QU)(we,L.Schemas.http)||(0,l.$QU)(we,L.Schemas.https))return we;throw De}},get remoteName(){return(0,o.$2k)(mt.remote.authority)},get remoteAuthority(){return(0,tt.$NF)(je,"resolvers"),mt.remote.authority},get uiKind(){return mt.uiKind},get logLevel(){return Fe.getLevel()},get onDidChangeLogLevel(){return Fe.onDidChangeLogLevel},registerIssueUriRequestHandler(we){return(0,tt.$NF)(je,"handleIssueUri"),_t.registerIssueUriRequestHandler(je,we)},registerIssueDataProvider(we){return(0,tt.$NF)(je,"handleIssueUri"),_t.registerIssueDataProvider(je,we)},get appQuality(){return(0,tt.$NF)(je,"resolvers"),mt.quality},get appCommit(){return(0,tt.$NF)(je,"resolvers"),mt.commit}};mt.environment.extensionTestsLocationURI||Object.freeze(ki);const on={createTestController(we,De,Oe){return di.createTestController(je,we,De,Oe)},createTestObserver(){return(0,tt.$NF)(je,"testObserver"),di.createTestObserver()},runTests(we){return(0,tt.$NF)(je,"testObserver"),di.runTests(we)},get onDidChangeTestResults(){return(0,tt.$NF)(je,"testObserver"),di.onResultsChanged},get testResults(){return(0,tt.$NF)(je,"testObserver"),di.results}},gi=mt.remote.isRemote?Ue.ExtensionKind.Workspace:Ue.ExtensionKind.UI,an={getExtension(we,De){(0,tt.$MF)(je,"extensionsAny")||(De=!1);const Oe=ti.mine.getExtensionDescription(we);if(Oe)return new oe.$Jec(At,je.identifier,Oe,gi,!1);if(De){const at=ti.all.getExtensionDescription(we);if(at)return new oe.$Jec(At,je.identifier,at,gi,!0)}},get all(){const we=[];for(const De of ti.mine.getAllExtensionDescriptions())we.push(new oe.$Jec(At,je.identifier,De,gi,!1));return we},get allAcrossExtensionHosts(){(0,tt.$NF)(je,"extensionsAny");const we=new v.$am(ti.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),De=[];for(const Oe of ti.all.getAllExtensionDescriptions()){const at=!we.has(Oe.identifier);De.push(new oe.$Jec(At,je.identifier,Oe,gi,at))}return De},get onDidChange(){return(0,tt.$MF)(je,"extensionsAny")?f.Event.any(ti.mine.onDidChange,ti.all.onDidChange):ti.mine.onDidChange}},mn={createDiagnosticCollection(we){return ai.createDiagnosticCollection(je.identifier,we)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:we=>ai.getDiagnostics(we),getLanguages(){return ci.getLanguages()},setTextDocumentLanguage(we,De){return ci.changeLanguage(we.uri,De)},match(we,De){const Oe=Ct.getDocumentData(De.uri)?.notebook;return(0,A.$LE)(wt.LanguageSelector.from(we),De.uri,De.languageId,!0,Oe?.uri,Oe?.notebookType)},registerCodeActionsProvider(we,De,Oe){return dt.registerCodeActionProvider(je,$t(we),De,Oe)},registerDocumentPasteEditProvider(we,De,Oe){return(0,tt.$NF)(je,"documentPaste"),dt.registerDocumentPasteEditProvider(je,$t(we),De,Oe)},registerCodeLensProvider(we,De){return dt.registerCodeLensProvider(je,$t(we),De)},registerDefinitionProvider(we,De){return dt.registerDefinitionProvider(je,$t(we),De)},registerDeclarationProvider(we,De){return dt.registerDeclarationProvider(je,$t(we),De)},registerImplementationProvider(we,De){return dt.registerImplementationProvider(je,$t(we),De)},registerTypeDefinitionProvider(we,De){return dt.registerTypeDefinitionProvider(je,$t(we),De)},registerHoverProvider(we,De){return dt.registerHoverProvider(je,$t(we),De,je.identifier)},registerEvaluatableExpressionProvider(we,De){return dt.registerEvaluatableExpressionProvider(je,$t(we),De,je.identifier)},registerInlineValuesProvider(we,De){return dt.registerInlineValuesProvider(je,$t(we),De,je.identifier)},registerDocumentHighlightProvider(we,De){return dt.registerDocumentHighlightProvider(je,$t(we),De)},registerLinkedEditingRangeProvider(we,De){return dt.registerLinkedEditingRangeProvider(je,$t(we),De)},registerReferenceProvider(we,De){return dt.registerReferenceProvider(je,$t(we),De)},registerRenameProvider(we,De){return dt.registerRenameProvider(je,$t(we),De)},registerDocumentSymbolProvider(we,De,Oe){return dt.registerDocumentSymbolProvider(je,$t(we),De,Oe)},registerWorkspaceSymbolProvider(we){return dt.registerWorkspaceSymbolProvider(je,we)},registerDocumentFormattingEditProvider(we,De){return dt.registerDocumentFormattingEditProvider(je,$t(we),De)},registerDocumentRangeFormattingEditProvider(we,De){return dt.registerDocumentRangeFormattingEditProvider(je,$t(we),De)},registerOnTypeFormattingEditProvider(we,De,Oe,...at){return dt.registerOnTypeFormattingEditProvider(je,$t(we),De,[Oe].concat(at))},registerDocumentSemanticTokensProvider(we,De,Oe){return dt.registerDocumentSemanticTokensProvider(je,$t(we),De,Oe)},registerDocumentRangeSemanticTokensProvider(we,De,Oe){return dt.registerDocumentRangeSemanticTokensProvider(je,$t(we),De,Oe)},registerSignatureHelpProvider(we,De,Oe,...at){return typeof Oe=="object"?dt.registerSignatureHelpProvider(je,$t(we),De,Oe):dt.registerSignatureHelpProvider(je,$t(we),De,typeof Oe>"u"?[]:[Oe,...at])},registerCompletionItemProvider(we,De,...Oe){return dt.registerCompletionItemProvider(je,$t(we),De,Oe)},registerInlineCompletionItemProvider(we,De,Oe){return De.handleDidShowCompletionItem&&(0,tt.$NF)(je,"inlineCompletionsAdditions"),De.handleDidPartiallyAcceptCompletionItem&&(0,tt.$NF)(je,"inlineCompletionsAdditions"),Oe&&(0,tt.$NF)(je,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider(je,$t(we),De,Oe)},registerDocumentLinkProvider(we,De){return dt.registerDocumentLinkProvider(je,$t(we),De)},registerColorProvider(we,De){return dt.registerColorProvider(je,$t(we),De)},registerFoldingRangeProvider(we,De){return dt.registerFoldingRangeProvider(je,$t(we),De)},registerSelectionRangeProvider(we,De){return dt.registerSelectionRangeProvider(je,we,De)},registerCallHierarchyProvider(we,De){return dt.registerCallHierarchyProvider(je,we,De)},registerTypeHierarchyProvider(we,De){return dt.registerTypeHierarchyProvider(je,we,De)},setLanguageConfiguration:(we,De)=>dt.setLanguageConfiguration(je,we,De),getTokenInformationAtPosition(we,De){return(0,tt.$NF)(je,"tokenInformation"),ci.tokenAtPosition(we,De)},registerInlayHintsProvider(we,De){return dt.registerInlayHintsProvider(je,we,De)},createLanguageStatusItem(we,De){return ci.createLanguageStatusItem(je,we,De)},registerDocumentDropEditProvider(we,De,Oe){return dt.registerDocumentOnDropEditProvider(je,we,De,(0,tt.$MF)(je,"dropMetadata")?Oe:void 0)}},$n={get activeTextEditor(){return Ft.getActiveTextEditor()},get visibleTextEditors(){return Ft.getVisibleTextEditors()},get activeTerminal(){return vt.activeTerminal},get terminals(){return vt.terminals},async showTextDocument(we,De,Oe){const at=await(y.URI.isUri(we)?Promise.resolve(Bi.openTextDocument(we)):Promise.resolve(we));return Ft.showTextDocument(at,De,Oe)},createTextEditorDecorationType(we){return Ft.createTextEditorDecorationType(je,we)},onDidChangeActiveTextEditor(we,De,Oe){return Ft.onDidChangeActiveTextEditor(we,De,Oe)},onDidChangeVisibleTextEditors(we,De,Oe){return Ft.onDidChangeVisibleTextEditors(we,De,Oe)},onDidChangeTextEditorSelection(we,De,Oe){return Ft.onDidChangeTextEditorSelection(we,De,Oe)},onDidChangeTextEditorOptions(we,De,Oe){return Ft.onDidChangeTextEditorOptions(we,De,Oe)},onDidChangeTextEditorVisibleRanges(we,De,Oe){return Ft.onDidChangeTextEditorVisibleRanges(we,De,Oe)},onDidChangeTextEditorViewColumn(we,De,Oe){return Ft.onDidChangeTextEditorViewColumn(we,De,Oe)},onDidCloseTerminal(we,De,Oe){return vt.onDidCloseTerminal(we,De,Oe)},onDidOpenTerminal(we,De,Oe){return vt.onDidOpenTerminal(we,De,Oe)},onDidChangeActiveTerminal(we,De,Oe){return vt.onDidChangeActiveTerminal(we,De,Oe)},onDidChangeTerminalDimensions(we,De,Oe){return(0,tt.$NF)(je,"terminalDimensions"),vt.onDidChangeTerminalDimensions(we,De,Oe)},onDidChangeTerminalState(we,De,Oe){return vt.onDidChangeTerminalState(we,De,Oe)},onDidWriteTerminalData(we,De,Oe){return(0,tt.$NF)(je,"terminalDataWriteEvent"),vt.onDidWriteTerminalData(we,De,Oe)},onDidExecuteTerminalCommand(we,De,Oe){return(0,tt.$NF)(je,"terminalExecuteCommandEvent"),vt.onDidExecuteTerminalCommand(we,De,Oe)},get state(){return Te.getState(je)},onDidChangeWindowState(we,De,Oe){return Te.onDidChangeWindowState(we,De,Oe)},showInformationMessage(we,...De){return Ei.showMessage(je,b.default.Info,we,De[0],De.slice(1))},showWarningMessage(we,...De){return Ei.showMessage(je,b.default.Warning,we,De[0],De.slice(1))},showErrorMessage(we,...De){return Ei.showMessage(je,b.default.Error,we,De[0],De.slice(1))},showQuickPick(we,De,Oe){return ni.showQuickPick(je,we,De,Oe)},showWorkspaceFolderPick(we){return ni.showWorkspaceFolderPick(we)},showInputBox(we,De){return ni.showInput(we,De)},showOpenDialog(we){return ji.showOpenDialog(je,we)},showSaveDialog(we){return ji.showSaveDialog(we)},createStatusBarItem(we,De,Oe){let at,yt,Tt;return typeof we=="string"?(at=we,yt=De,Tt=Oe):(yt=we,Tt=De),fi.createStatusBarEntry(je,at,yt,Tt)},setStatusBarMessage(we,De){return fi.setStatusBarMessage(we,De)},withScmProgress(we){return se.report("window.withScmProgress",je,"Use 'withProgress' instead."),Li.withProgress(je,{location:Ue.ProgressLocation.SourceControl},(De,Oe)=>we({report(at){}}))},withProgress(we,De){return Li.withProgress(je,we,De)},createOutputChannel(we,De){return Xt.createOutputChannel(we,De,je)},createWebviewPanel(we,De,Oe,at){return Ti.createWebviewPanel(je,we,De,Oe,at)},createWebviewTextEditorInset(we,De,Oe,at){return(0,tt.$NF)(je,"editorInsets"),Ii.createWebviewEditorInset(we,De,Oe,at,je)},createTerminal(we,De,Oe){return typeof we=="object"?"pty"in we?vt.createExtensionTerminal(we):vt.createTerminalFromOptions(we):vt.createTerminal(we,De,Oe)},registerTerminalLinkProvider(we){return vt.registerLinkProvider(we)},registerTerminalProfileProvider(we,De){return vt.registerProfileProvider(je,we,De)},registerTerminalQuickFixProvider(we,De){return(0,tt.$NF)(je,"terminalQuickFixProvider"),vt.registerTerminalQuickFixProvider(we,je.identifier.value,De)},registerTreeDataProvider(we,De){return bi.registerTreeDataProvider(we,De,je)},createTreeView(we,De){return bi.createTreeView(we,De,je)},registerWebviewPanelSerializer:(we,De)=>Ti.registerWebviewPanelSerializer(je,we,De),registerCustomEditorProvider:(we,De,Oe={})=>Ni.registerCustomEditorProvider(je,we,De,Oe),registerFileDecorationProvider(we){return ot.registerFileDecorationProvider(we,je)},registerUriHandler(we){return Si.registerUriHandler(je,we)},createQuickPick(){return ni.createQuickPick(je)},createInputBox(){return ni.createInputBox(je)},get activeColorTheme(){return Mi.activeColorTheme},onDidChangeActiveColorTheme(we,De,Oe){return Mi.onDidChangeActiveColorTheme(we,De,Oe)},registerWebviewViewProvider(we,De,Oe){return Oi.registerWebviewViewProvider(je,we,De,Oe?.webviewOptions)},get activeNotebookEditor(){return kt.activeNotebookEditor},onDidChangeActiveNotebookEditor(we,De,Oe){return kt.onDidChangeActiveNotebookEditor(we,De,Oe)},get visibleNotebookEditors(){return kt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return kt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(we,De,Oe){return $i.onDidChangeNotebookEditorSelection(we,De,Oe)},onDidChangeNotebookEditorVisibleRanges(we,De,Oe){return $i.onDidChangeNotebookEditorVisibleRanges(we,De,Oe)},showNotebookDocument(we,De){return kt.showNotebookDocument(we,De)},registerExternalUriOpener(we,De,Oe){return(0,tt.$NF)(je,"externalUriOpener"),hn.registerExternalUriOpener(je.identifier,we,De,Oe)},registerProfileContentHandler(we,De){return(0,tt.$NF)(je,"profileContentHandlers"),en.registrProfileContentHandler(je,we,De)},registerQuickDiffProvider(we,De,Oe,at){return(0,tt.$NF)(je,"quickDiffProvider"),Xi.registerQuickDiffProvider($t(we),De,Oe,at)},get tabGroups(){return xe.tabGroups},registerShareProvider(we,De){return(0,tt.$NF)(je,"shareProvider"),Ai.registerShareProvider($t(we),De)}},Bi={get rootPath(){return se.report("workspace.rootPath",je,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),gt.getPath()},set rootPath(we){throw new T.$8("rootPath")},getWorkspaceFolder(we){return gt.getWorkspaceFolder(we)},get workspaceFolders(){return gt.getWorkspaceFolders()},get name(){return gt.name},set name(we){throw new T.$8("name")},get workspaceFile(){return gt.workspaceFile},set workspaceFile(we){throw new T.$8("workspaceFile")},updateWorkspaceFolders:(we,De,...Oe)=>gt.updateWorkspaceFolders(je,we,De||0,...Oe),onDidChangeWorkspaceFolders:function(we,De,Oe){return gt.onDidChangeWorkspace(we,De,Oe)},asRelativePath:(we,De)=>gt.getRelativePath(we,De),findFiles:(we,De,Oe,at)=>gt.findFiles(we,De,Oe,je.identifier,at),findTextInFiles:(we,De,Oe,at)=>{(0,tt.$NF)(je,"findTextInFiles");let yt,Tt;return typeof De=="object"?(yt=De,Tt=Oe):(yt={},Tt=De,at=Oe),gt.findTextInFiles(we,yt||{},Tt,je.identifier,at)},save:we=>((0,tt.$NF)(je,"saveEditor"),gt.save(we)),saveAs:we=>((0,tt.$NF)(je,"saveEditor"),gt.saveAs(we)),saveAll:we=>gt.saveAll(we),applyEdit(we,De){return yi.applyWorkspaceEdit(we,je,De)},createFileSystemWatcher:(we,De,Oe,at)=>{let yt;return typeof De=="boolean"?yt={ignoreCreateEvents:!!De,ignoreChangeEvents:!!Oe,ignoreDeleteEvents:!!at,correlate:!1}:De&&((0,tt.$NF)(je,"createFileSystemWatcher"),yt={...De,correlate:!0}),xt.createFileSystemWatcher(gt,je,we,yt)},get textDocuments(){return Ct.getAllDocumentData().map(we=>we.document)},set textDocuments(we){throw new T.$8("textDocuments")},openTextDocument(we){let De;const Oe=we;if(typeof we=="string")De=Promise.resolve(y.URI.file(we));else if(y.URI.isUri(we))De=Promise.resolve(we);else if(!Oe||typeof Oe=="object")De=Ct.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return De.then(at=>Ct.ensureDocumentData(at).then(yt=>yt.document))},onDidOpenTextDocument:(we,De,Oe)=>Ct.onDidAddDocument(we,De,Oe),onDidCloseTextDocument:(we,De,Oe)=>Ct.onDidRemoveDocument(we,De,Oe),onDidChangeTextDocument:(we,De,Oe)=>Ct.onDidChangeDocument(we,De,Oe),onDidSaveTextDocument:(we,De,Oe)=>Ct.onDidSaveDocument(we,De,Oe),onWillSaveTextDocument:(we,De,Oe)=>ln.getOnWillSaveTextDocumentEvent(je)(we,De,Oe),get notebookDocuments(){return kt.notebookDocuments.map(we=>we.apiNotebook)},async openNotebookDocument(we,De){let Oe;if(y.URI.isUri(we))Oe=we,await kt.openNotebookDocument(we);else if(typeof we=="string")Oe=y.URI.revive(await kt.createNotebookDocument({viewType:we,content:De}));else throw new Error("Invalid arguments");return kt.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(we,De,Oe){return mi.onDidSaveNotebookDocument(we,De,Oe)},onDidChangeNotebookDocument(we,De,Oe){return mi.onDidChangeNotebookDocument(we,De,Oe)},onWillSaveNotebookDocument(we,De,Oe){return Ci.getOnWillSaveNotebookDocumentEvent(je)(we,De,Oe)},get onDidOpenNotebookDocument(){return kt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return kt.onDidCloseNotebookDocument},registerNotebookSerializer(we,De,Oe,at){return kt.registerNotebookSerializer(je,we,De,Oe,(0,tt.$MF)(je,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(we,De,Oe)=>Ui.onDidChangeConfiguration(we,De,Oe),getConfiguration(we,De){return De=arguments.length===1?void 0:De,Ui.getConfiguration(we,De,je)},registerTextDocumentContentProvider(we,De){return Yi.registerTextDocumentContentProvider(we,De)},registerTaskProvider:(we,De)=>(se.report("window.registerTaskProvider",je,"Use the corresponding function on the 'tasks' namespace instead"),Qt.registerTaskProvider(je,we,De)),registerFileSystemProvider(we,De,Oe){return(0,R.$Oc)(Pi.registerFileSystemProvider(je,we,De,Oe),Pt.addFileSystemProvider(we,De,Oe))},get fs(){return Pt.value},registerFileSearchProvider:(we,De)=>((0,tt.$NF)(je,"fileSearchProvider"),Lt.registerFileSearchProvider(we,De)),registerTextSearchProvider:(we,De)=>((0,tt.$NF)(je,"textSearchProvider"),Lt.registerTextSearchProvider(we,De)),registerRemoteAuthorityResolver:(we,De)=>((0,tt.$NF)(je,"resolvers"),At.registerRemoteAuthorityResolver(we,De)),registerResourceLabelFormatter:we=>((0,tt.$NF)(je,"resolvers"),xi.$registerResourceLabelFormatter(we)),getRemoteExecServer:we=>((0,tt.$NF)(je,"resolvers"),At.getRemoteExecServer(we)),onDidCreateFiles:(we,De,Oe)=>xt.onDidCreateFile(we,De,Oe),onDidDeleteFiles:(we,De,Oe)=>xt.onDidDeleteFile(we,De,Oe),onDidRenameFiles:(we,De,Oe)=>xt.onDidRenameFile(we,De,Oe),onWillCreateFiles:(we,De,Oe)=>xt.getOnWillCreateFileEvent(je)(we,De,Oe),onWillDeleteFiles:(we,De,Oe)=>xt.getOnWillDeleteFileEvent(je)(we,De,Oe),onWillRenameFiles:(we,De,Oe)=>xt.getOnWillRenameFileEvent(je)(we,De,Oe),openTunnel:we=>((0,tt.$NF)(je,"tunnels"),Ce.openTunnel(je,we).then(De=>{if(!De)throw new Error("cannot open tunnel");return De})),get tunnels(){return(0,tt.$NF)(je,"tunnels"),Ce.getTunnels()},onDidChangeTunnels:(we,De,Oe)=>((0,tt.$NF)(je,"tunnels"),Ce.onDidChangeTunnels(we,De,Oe)),registerPortAttributesProvider:(we,De)=>((0,tt.$NF)(je,"portsAttributes"),Ce.registerPortsAttributesProvider(we,De)),registerTunnelProvider:(we,De)=>((0,tt.$NF)(je,"tunnelFactory"),Ce.registerTunnelProvider(we,De)),registerTimelineProvider:(we,De)=>((0,tt.$NF)(je,"timeline"),_i.registerTimelineProvider(we,De,je.identifier,bt.converter)),get isTrusted(){return gt.trusted},requestWorkspaceTrust:we=>((0,tt.$NF)(je,"workspaceTrust"),gt.requestWorkspaceTrust(we)),onDidGrantWorkspaceTrust:(we,De,Oe)=>gt.onDidGrantWorkspaceTrust(we,De,Oe),registerEditSessionIdentityProvider:(we,De)=>((0,tt.$NF)(je,"editSessionIdentityProvider"),gt.registerEditSessionIdentityProvider(we,De)),onWillCreateEditSessionIdentity:(we,De,Oe)=>((0,tt.$NF)(je,"editSessionIdentityProvider"),gt.getOnWillCreateEditSessionIdentityEvent(je)(we,De,Oe)),registerCanonicalUriProvider:(we,De)=>((0,tt.$NF)(je,"canonicalUriProvider"),gt.registerCanonicalUriProvider(we,De)),getCanonicalUri:(we,De,Oe)=>((0,tt.$NF)(je,"canonicalUriProvider"),gt.provideCanonicalUri(we,De,Oe))},cn={get inputBox(){return se.report("scm.inputBox",je,"Use 'SourceControl.inputBox' instead"),hi.getLastInputBox(je)},createSourceControl(we,De,Oe){return hi.createSourceControl(je,we,De,Oe)},registerSourceControlInputBoxValueProvider(we){return(0,tt.$NF)(je,"scmInputBoxValueProvider"),hi.registerSourceControlInputBoxValueProvider(je,we)}},Wi={createCommentController(we,De){return Ri.createCommentController(je,we,De)}},Vi={get activeDebugSession(){return ht.activeDebugSession},get activeDebugConsole(){return ht.activeDebugConsole},get breakpoints(){return ht.breakpoints},get stackFrameFocus(){return ht.stackFrameFocus},onDidStartDebugSession(we,De,Oe){return ht.onDidStartDebugSession(we,De,Oe)},onDidTerminateDebugSession(we,De,Oe){return ht.onDidTerminateDebugSession(we,De,Oe)},onDidChangeActiveDebugSession(we,De,Oe){return ht.onDidChangeActiveDebugSession(we,De,Oe)},onDidReceiveDebugSessionCustomEvent(we,De,Oe){return ht.onDidReceiveDebugSessionCustomEvent(we,De,Oe)},onDidChangeBreakpoints(we,De,Oe){return ht.onDidChangeBreakpoints(we,De,Oe)},onDidChangeStackFrameFocus(we,De,Oe){return(0,tt.$NF)(je,"debugFocus"),ht.onDidChangeStackFrameFocus(we,De,Oe)},registerDebugConfigurationProvider(we,De,Oe){return ht.registerDebugConfigurationProvider(we,De,Oe||Mt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(we,De){return ht.registerDebugAdapterDescriptorFactory(je,we,De)},registerDebugAdapterTrackerFactory(we,De){return ht.registerDebugAdapterTrackerFactory(we,De)},startDebugging(we,De,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?ht.startDebugging(we,De,{parentSession:Oe}):ht.startDebugging(we,De,Oe||{})},stopDebugging(we){return ht.stopDebugging(we)},addBreakpoints(we){return ht.addBreakpoints(we)},removeBreakpoints(we){return ht.removeBreakpoints(we)},asDebugSourceUri(we,De){return ht.asDebugSourceUri(we,De)}},qi={registerTaskProvider:(we,De)=>Qt.registerTaskProvider(je,we,De),fetchTasks:we=>Qt.fetchTasks(we),executeTask:we=>Qt.executeTask(je,we),get taskExecutions(){return Qt.taskExecutions},onDidStartTask:(we,De,Oe)=>Qt.onDidStartTask(we,De,Oe),onDidEndTask:(we,De,Oe)=>Qt.onDidEndTask(we,De,Oe),onDidStartTaskProcess:(we,De,Oe)=>Qt.onDidStartTaskProcess(we,De,Oe),onDidEndTaskProcess:(we,De,Oe)=>Qt.onDidEndTaskProcess(we,De,Oe)},li={createNotebookController(we,De,Oe,at,yt){return oi.createNotebookController(je,we,De,Oe,at,(0,tt.$MF)(je,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(we,De)=>kt.registerNotebookCellStatusBarItemProvider(je,we,De),createRendererMessaging(we){return Di.createRendererMessaging(je,we)},createNotebookControllerDetectionTask(we){return(0,tt.$NF)(je,"notebookKernelSource"),oi.createNotebookControllerDetectionTask(je,we)},registerKernelSourceActionProvider(we,De){return(0,tt.$NF)(je,"notebookKernelSource"),oi.registerKernelSourceActionProvider(je,we,De)},onDidChangeNotebookCellExecutionState(we,De,Oe){return(0,tt.$NF)(je,"notebookCellExecutionState"),oi.onDidChangeNotebookCellExecutionState(we,De,Oe)}},Ki={t(...we){if(typeof we[0]=="string"){const De=we.shift(),Oe=!we||typeof we[0]!="object"?we:we[0];return si.getMessage(je.identifier.value,{message:De,args:Oe})}return si.getMessage(je.identifier.value,we[0])},get bundle(){return si.getBundle(je.identifier.value)},get uri(){return si.getBundleUri(je.identifier.value)}},Hi={_version:1,registerInteractiveEditorSessionProvider(we,De){return(0,tt.$NF)(je,"interactive"),zi.registerProvider(je,we,De)},registerInteractiveSessionProvider(we,De){return(0,tt.$NF)(je,"interactive"),wi.registerChatProvider(je,we,De)},sendInteractiveRequestToProvider(we,De){return(0,tt.$NF)(je,"interactive"),wi.sendInteractiveRequestToProvider(we,De)},get onDidPerformUserAction(){return(0,tt.$NF)(je,"interactiveUserActions"),wi.onDidPerformUserAction},transferChatSession(we,De){return(0,tt.$NF)(je,"interactive"),wi.transferChatSession(we,De)}},Gi={getRelatedInformation(we,De){return(0,tt.$NF)(je,"aiRelatedInformation"),vi.getRelatedInformation(je,we,De)},registerRelatedInformationProvider(we,De){return(0,tt.$NF)(je,"aiRelatedInformation"),vi.registerRelatedInformationProvider(je,we,De)},registerEmbeddingVectorProvider(we,De){return(0,tt.$NF)(je,"aiRelatedInformation"),rn.registerEmbeddingVectorProvider(je,we,De)}},Ji={registerChatResponseProvider(we,De,Oe){return(0,tt.$NF)(je,"chatProvider"),pi.registerProvider(je.identifier,we,De,Oe)},requestChatAccess(we){return(0,tt.$NF)(je,"chatRequestAccess"),pi.requestChatResponseProvider(je.identifier,we)},registerVariable(we,De,Oe){return(0,tt.$NF)(je,"chatVariables"),nn.registerVariableResolver(je,we,De,Oe)},registerMappedEditsProvider(we,De){return(0,tt.$NF)(je,"mappedEditsProvider"),dt.registerMappedEditsProvider(je,we,De)},createChatAgent(we,De){return(0,tt.$NF)(je,"chatAgents2"),tn.createChatAgent(je,we,De)}},un={registerSpeechProvider(we,De){return(0,tt.$NF)(je,"speech"),dn.registerProvider(je.identifier,we,De)}};return{version:mt.version,ai:Gi,authentication:fn,commands:gn,comments:Wi,chat:Ji,debug:Vi,env:ki,extensions:an,interactive:Hi,l10n:Ki,languages:mn,notebooks:li,scm:cn,speech:un,tasks:qi,tests:on,window:$n,workspace:Bi,Breakpoint:Ue.$zL,TerminalOutputAnchor:Ue.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Ue.ChatAgentResultFeedbackKind,ChatMessage:Ue.$qM,ChatMessageRole:Ue.ChatMessageRole,ChatVariableLevel:Ue.ChatVariableLevel,CallHierarchyIncomingCall:Ue.$YK,CallHierarchyItem:Ue.$XK,CallHierarchyOutgoingCall:Ue.$ZK,CancellationError:T.$4,CancellationTokenSource:C.$2d,CandidatePortSource:r.CandidatePortSource,CodeAction:Ue.$UK,CodeActionKind:Ue.$VK,CodeActionTriggerKind:Ue.CodeActionTriggerKind,CodeLens:Ue.$1K,Color:Ue.$bL,ColorInformation:Ue.$cL,ColorPresentation:Ue.$dL,ColorThemeKind:Ue.ColorThemeKind,CommentMode:Ue.CommentMode,CommentState:Ue.CommentState,CommentThreadCollapsibleState:Ue.CommentThreadCollapsibleState,CommentThreadState:Ue.CommentThreadState,CompletionItem:Ue.$8K,CompletionItemKind:Ue.CompletionItemKind,CompletionItemTag:Ue.CompletionItemTag,CompletionList:Ue.$9K,CompletionTriggerKind:Ue.CompletionTriggerKind,ConfigurationTarget:Ue.ConfigurationTarget,CustomExecution:Ue.$lL,DebugAdapterExecutable:Ue.$DL,DebugAdapterInlineImplementation:Ue.$GL,DebugAdapterNamedPipeServer:Ue.$FL,DebugAdapterServer:Ue.$EL,DebugConfigurationProviderTriggerKind:Mt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Ue.DebugConsoleMode,DecorationRangeBehavior:Ue.DecorationRangeBehavior,Diagnostic:Ue.$PK,DiagnosticRelatedInformation:Ue.$OK,DiagnosticSeverity:Ue.DiagnosticSeverity,DiagnosticTag:Ue.DiagnosticTag,Disposable:Ue.$BK,DocumentHighlight:Ue.$RK,DocumentHighlightKind:Ue.DocumentHighlightKind,DocumentLink:Ue.$aL,DocumentSymbol:Ue.$TK,EndOfLine:Ue.EndOfLine,EnvironmentVariableMutatorType:Ue.EnvironmentVariableMutatorType,EvaluatableExpression:Ue.$JL,InlineValueText:Ue.$KL,InlineValueVariableLookup:Ue.$LL,InlineValueEvaluatableExpression:Ue.$ML,InlineCompletionTriggerKind:Ue.InlineCompletionTriggerKind,EventEmitter:f.$Rd,ExtensionKind:Ue.ExtensionKind,ExtensionMode:Ue.ExtensionMode,ExternalUriOpenerPriority:Ue.ExternalUriOpenerPriority,FileChangeType:Ue.FileChangeType,FileDecoration:Ue.$WL,FileDecoration2:Ue.$WL,FileSystemError:Ue.$OL,FileType:S.FileType,FilePermission:S.FilePermission,FoldingRange:Ue.$PL,FoldingRangeKind:Ue.FoldingRangeKind,FunctionBreakpoint:Ue.$BL,InlineCompletionItem:Ue.$0K,InlineCompletionList:Ue.$$K,Hover:Ue.$QK,IndentAction:I.IndentAction,Location:Ue.$NK,MarkdownString:Ue.$2K,OverviewRulerLane:$.OverviewRulerLane,ParameterInformation:Ue.$3K,PortAutoForwardAction:Ue.PortAutoForwardAction,Position:Ue.$CK,ProcessExecution:Ue.$jL,ProgressLocation:Ue.ProgressLocation,QuickInputButtons:Ue.$VL,Range:Ue.$DK,RelativePattern:Ue.$xL,Selection:Ue.$EK,SelectionRange:Ue.$WK,SemanticTokens:Ue.$SL,SemanticTokensBuilder:Ue.$RL,SemanticTokensEdit:Ue.$TL,SemanticTokensEdits:Ue.$UL,SemanticTokensLegend:Ue.$QL,ShellExecution:Ue.$kL,ShellQuoting:Ue.ShellQuoting,SignatureHelp:Ue.$5K,SignatureHelpTriggerKind:Ue.SignatureHelpTriggerKind,SignatureInformation:Ue.$4K,SnippetString:Ue.$MK,SourceBreakpoint:Ue.$AL,StandardTokenType:Ue.StandardTokenType,StatusBarAlignment:Ue.StatusBarAlignment,SymbolInformation:Ue.$SK,SymbolKind:Ue.SymbolKind,SymbolTag:Ue.SymbolTag,Task:Ue.$mL,TaskGroup:Ue.$iL,TaskPanelKind:Ue.TaskPanelKind,TaskRevealKind:Ue.TaskRevealKind,TaskScope:Ue.TaskScope,TerminalLink:Ue.$eL,TerminalQuickFixExecuteTerminalCommand:Ue.$gL,TerminalQuickFixOpener:Ue.$fL,TerminalLocation:Ue.TerminalLocation,TerminalProfile:Ue.$hL,TerminalExitReason:Ue.TerminalExitReason,TextDocumentSaveReason:Ue.TextDocumentSaveReason,TextEdit:Ue.$IK,SnippetTextEdit:Ue.$KK,TextEditorCursorStyle:g.TextEditorCursorStyle,TextEditorLineNumbersStyle:Ue.TextEditorLineNumbersStyle,TextEditorRevealType:Ue.TextEditorRevealType,TextEditorSelectionChangeKind:Ue.TextEditorSelectionChangeKind,SyntaxTokenType:Ue.SyntaxTokenType,TextDocumentChangeReason:Ue.TextDocumentChangeReason,ThemeColor:Ue.$wL,ThemeIcon:Ue.$vL,TreeItem:Ue.$nL,TreeItemCheckboxState:Ue.TreeItemCheckboxState,TreeItemCollapsibleState:Ue.TreeItemCollapsibleState,TypeHierarchyItem:Ue.$fM,UIKind:Wt.UIKind,Uri:y.URI,ViewColumn:Ue.ViewColumn,WorkspaceEdit:Ue.$LK,DocumentDropEdit:Ue.$tL,DocumentPasteEdit:Ue.$uL,InlayHint:Ue.$7K,InlayHintLabelPart:Ue.$6K,InlayHintKind:Ue.InlayHintKind,RemoteAuthorityResolverError:Ue.$HK,ResolvedAuthority:Ue.$FK,ManagedResolvedAuthority:Ue.$GK,SourceControlInputBoxValidationType:Ue.SourceControlInputBoxValidationType,ExtensionRuntime:Ue.ExtensionRuntime,TimelineItem:Ue.$7L,NotebookRange:Ue.$YL,NotebookCellKind:Ue.NotebookCellKind,NotebookCellExecutionState:Ue.NotebookCellExecutionState,NotebookCellData:Ue.$ZL,NotebookData:Ue.$1L,NotebookRendererScript:Ue.$5L,NotebookCellStatusBarAlignment:Ue.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Ue.NotebookEditorRevealType,NotebookCellOutput:Ue.$3L,NotebookCellOutputItem:Ue.$2L,NotebookCellStatusBarItem:Ue.$4L,NotebookControllerAffinity:Ue.NotebookControllerAffinity,NotebookControllerAffinity2:Ue.NotebookControllerAffinity2,NotebookEdit:Ue.$JK,NotebookKernelSourceAction:Ue.$6L,PortAttributes:Ue.$9L,LinkedEditingRanges:Ue.$8L,TestResultState:Ue.TestResultState,TestRunRequest:Ue.$0L,TestMessage:Ue.$$L,TestMessage2:Ue.$$L,TestTag:Ue.$_L,TestRunProfileKind:Ue.TestRunProfileKind,TextSearchCompleteMessageType:Vt.TextSearchCompleteMessageType,DataTransfer:Ue.$sL,DataTransferItem:Ue.$oL,CoveredCount:Ue.$aM,FileCoverage:Ue.$bM,StatementCoverage:Ue.$cM,BranchCoverage:Ue.$dM,FunctionCoverage:Ue.$eM,WorkspaceTrustState:Ue.WorkspaceTrustState,LanguageStatusSeverity:Ue.LanguageStatusSeverity,QuickPickItemKind:Ue.QuickPickItemKind,InputBoxValidationSeverity:Ue.InputBoxValidationSeverity,TabInputText:Ue.$gM,TabInputTextDiff:Ue.$hM,TabInputTextMerge:Ue.$iM,TabInputCustom:Ue.$jM,TabInputNotebook:Ue.$lM,TabInputNotebookDiff:Ue.$mM,TabInputWebview:Ue.$kM,TabInputTerminal:Ue.$nM,TabInputInteractiveWindow:Ue.$oM,TabInputChat:Ue.$pM,TelemetryTrustedValue:i.$po,LogLevel:w.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Ue.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:Ue.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:Ue.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Ue.$HL,ThreadFocus:Ue.$IL,RelatedInformationType:Ue.RelatedInformationType,SpeechToTextStatus:Ue.SpeechToTextStatus}}}e.$Ofc=qt}),define(ke[370],Se([1,0,106,154,41,151,42,35,69,46,95,96,97,118,72,91,153,71,57,117,90,70,152,14,58,115,116]),function(me,e,C,T,f,R,L,b,y,g,A,I,$,v,S,w,l,o,i,n,r,a,t,s,d,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,C.$Cr)(c.$Dec,c.$Cec,1),(0,C.$Cr)(s.$ej,t.$Pfc,1),(0,C.$Cr)(w.$Odc,w.$Pdc,1),(0,C.$Cr)(b.$XM,b.$WM,0),(0,C.$Cr)(L.$0dc,L.$8dc,0),(0,C.$Cr)(o.$_dc,o.$$dc,0),(0,C.$Cr)(I.$Nec,I.$Rec,0),(0,C.$Cr)(R.$Tec,R.$Sec,0),(0,C.$Cr)(y.$MM,y.$LM,0),(0,C.$Cr)(u.$Eec,u.$Fec,0),(0,C.$Cr)(i.$Ldc,i.$Kdc,0),(0,C.$Cr)(T.$nfc,T.$mfc,1),(0,C.$Cr)($.$0ec,$.$$ec,0),(0,C.$Cr)(v.$sec,v.$rec,0),(0,C.$Cr)(A.$Afc,A.$zfc,0),(0,C.$Cr)(g.$vec,g.$yec,0),(0,C.$Cr)(S.$Pwb,S.$Qwb,0),(0,C.$Cr)(l.$Nfc,l.$Mfc,0),(0,C.$Cr)(f.$7dc,f.$6dc,0),(0,C.$Cr)(n.$Aec,n.$zec,0),(0,C.$Cr)(r.$VM,r.$SM,0),(0,C.$Cr)(a.$jec,a.$kec,0),(0,C.$Cr)(d.$Lec,d.$Mec,0)}),define(ke[119],Se([1,0,19,14,36,94]),function(me,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8fc=e.$7fc=e.$6fc=void 0;function L(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.$6fc=L;function b(I,$,v,S){const w=(0,C.$1b)(v,y),l=new f.$3I($,w,S),o=l.preview.matches;return{ranges:(0,C.$1b)(w,g),uri:I,preview:{text:l.preview.text,matches:(0,C.$1b)(o,g)}}}e.$7fc=b;function y(I){return new f.$4I(I.start.line,I.start.character,I.end.line,I.end.character)}function g(I){return new R.$RI(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let A=class{constructor($,v){this.a=$,this.b=v}appendLine($){this.b.debug(`${this.a}#search`,$)}};e.$8fc=A,e.$8fc=A=He([Be(1,T.$dj)],A)}),define(ke[371],Se([1,0,50,16,76,33,11,13,119,372]),function(me,e,C,T,f,R,L,b,y,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$fc=e.$0fc=e.$9fc=void 0;const A=g.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(n,r,a,t){const s=$(n,r,a,t),d=r.folder.fsPath;return{cmd:C.spawn(A,s.args,{cwd:d}),rgDiskPath:A,siblingClauses:s.siblingClauses,rgArgs:s,cwd:d}}e.$9fc=I;function $(n,r,a,t){const s=["--files","--hidden","--case-sensitive","--no-require-git"];S([r],a,!1).forEach(c=>{const u=(0,y.$6fc)(c);if(s.push("-g",u),L.$j){const h=(0,f.$vl)(u);h!==u&&s.push("-g",h)}});const d=v([r],t,void 0,!1);return d.globArgs.forEach(c=>{const u=`!${(0,y.$6fc)(c)}`;if(s.push("-g",u),L.$j){const h=(0,f.$vl)(u);h!==u&&s.push("-g",h)}}),r.disregardIgnoreFiles!==!1?s.push("--no-ignore"):r.disregardParentIgnoreFiles!==!1&&s.push("--no-ignore-parent"),r.ignoreSymlinks||s.push("--follow"),n.exists&&s.push("--quiet"),s.push("--no-config"),r.disregardGlobalIgnoreFiles&&s.push("--no-ignore-global"),{args:s,siblingClauses:d.siblingClauses}}function v(n,r,a,t=!0){const s=[];let d={};return n.forEach(c=>{const u=Object.assign({},c.excludePattern||{},r||{}),h=w(u,t?c.folder.fsPath:void 0,a);s.push(...h.globArgs),h.siblingClauses&&(d=Object.assign(d,h.siblingClauses))}),{globArgs:s,siblingClauses:d}}function S(n,r,a=!0){const t=[];return n.forEach(s=>{const d=Object.assign({},r||{},s.includePattern||{}),c=w(d,a?s.folder.fsPath:void 0);t.push(...c.globArgs)}),t}function w(n,r,a){const t=[],s={};return Object.keys(n).forEach(d=>{if(a&&a.has(d)||!d)return;const c=n[d];d=o(r?l(r,d):d),d.startsWith("\\\\")?d="\\\\"+d.substr(2).replace(/\\/g,"/"):d=d.replace(/\\/g,"/"),typeof c=="boolean"&&c?(d.startsWith("\\\\")&&(d+="**"),t.push(i(d))):c&&c.when&&(s[d]=c)}),{globArgs:t,siblingClauses:s}}function l(n,r){return T.$hc(r)?r:T.$ic(n,r)}e.$0fc=l;function o(n){return n=b.$Oe(n,"\\"),b.$Oe(n,"/")}function i(n){return R.$Xf(n).toLowerCase()==="c:/"?n.replace(/^c:[/\\]/i,"/"):n}e.$$fc=i}),define(ke[373],Se([1,0,50,55,16,374,19,43,34,76,33,11,38,13,18,30,36,371,130]),function(me,e,C,T,f,R,L,b,y,g,A,I,$,v,S,w,l,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$agc=e.$_fc=void 0;const n=new Set;process.on("exit",()=>{n.forEach(d=>d())});class r{constructor(c){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=c,this.b=c.filePattern||"",this.d=c.includePattern&&y.$Cj(c.includePattern),this.f=c.maxResults||null,this.g=!!c.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,i.$Eq)(this.b).normalizedLowercase),this.u=c.excludePattern&&y.$Cj(c.excludePattern),this.t=new Map,c.folderQueries.forEach(u=>{const h=Object.assign({},u.excludePattern||{},this.a.excludePattern||{}),E=u.folder.fsPath;c.folderQueries.map(D=>D.folder.fsPath).filter(D=>D!==E).forEach(D=>{(0,A.$2f)(D,E)&&(h[f.$kc(E,D)]=!0)}),this.t.set(E,new t(h,E))})}cancel(){this.l=!0,n.forEach(c=>c())}walk(c,u,h,E,D){if(this.m=$.$Nd.create(!1),this.l)return D(null,this.j);u.forEach(m=>{const p=f.$mc(m.fsPath);this.u&&this.u(m.fsPath,p)||this.J(h,{relativePath:m.fsPath,searchPath:void 0})}),this.r=$.$Nd.create(!1),this.w(c,(m,p)=>{this.x(this.y,this,m,h,E,k=>{if(k){const P=(0,b.$Gi)(k);console.error(P),this.q.push(P),p(k,void 0)}else p(null,void 0)})},(m,p)=>{this.m.stop();const k=m?L.$Gb(m)[0]:null;D(k,this.j)})}w(c,u,h){const E=new Array(c.length),D=new Array(c.length);let m=!1,p=0;if(c.length===0)return h(null,[]);c.forEach((k,P)=>{u(k,(z,j)=>{if(z?(m=!0,E[P]=null,D[P]=z):(E[P]=j,D[P]=null),++p===c.length)return h(m?D:null,E)})})}x(c,u,...h){try{c.apply(u,h)}catch(E){h[h.length-1](E)}}y(c,u,h,E){const D=c.folder.fsPath,m=I.$j,p=()=>M&&M.kill();n.add(p);let k=W=>{n.delete(p),k=()=>{},E(W)},P="";const z=this.D(),j=(0,o.$9fc)(this.a,c,this.a.includePattern,this.t.get(c.folder.fsPath).expression),M=j.cmd,O=!Object.keys(j.siblingClauses).length,F=j.rgArgs.args.map(W=>W.match(/^-/)?W:`'${W}'`).join(" ");let N=`${j.rgDiskPath} ${F}
 - cwd: ${j.cwd}`;j.rgArgs.siblingClauses&&(N+=`
 - Sibling clauses: ${JSON.stringify(j.rgArgs.siblingClauses)}`),h({message:N}),this.s=0,this.z(M,"utf8",h,(W,X,ce)=>{if(W){k(W);return}if(this.j){k();return}const Q=(P+(m?g.$ul(X||""):X)).split(`
`);if(ce){const G=Q.length;Q[G-1]=Q[G-1].trim(),Q[G-1]||Q.pop()}else P=Q.pop()||"";if(Q.length&&Q[0].indexOf(`
`)!==-1){k(new Error("Splitting up files failed"));return}if(this.s+=Q.length,O){for(const G of Q)if(this.J(u,{base:D,relativePath:G,searchPath:this.N(c,G)}),this.j){p();break}(ce||this.j)&&k();return}this.G(c,z,D,Q,u),ce&&(this.H(z,D,u),k())})}spawnFindCmd(c){const u=this.t.get(c.folder.fsPath),h=u.getBasenameTerms(),E=u.getPathTerms(),D=["-L","."];if(h.length||E.length){D.push("-not","(","(");for(const m of h)D.push("-name",m),D.push("-o");for(const m of E)D.push("-path",m),D.push("-o");D.pop(),D.push(")","-prune",")")}return D.push("-type","f"),C.spawn("find",D,{cwd:c.folder.fsPath})}readStdout(c,u,h){let E="";this.z(c,u,()=>{},(D,m,p)=>{if(D){h(D);return}E+=m,p&&h(null,E)})}z(c,u,h,E){let D=(k,P,z)=>{(k||z)&&(D=()=>{},this.r?.stop()),E(k,P,z)},m=!1;c.stdout?(this.A(c.stdout,u,D),c.stdout.once("data",()=>m=!0)):h({message:"stdout is null"});let p;c.stderr?p=this.B(c.stderr):h({message:"stderr is null"}),c.on("error",k=>{D(k)}),c.on("close",k=>{let P;!m&&(P=this.C(p,u))&&s(P)?D(new Error(`command failed with error code ${k}: ${this.C(p,u)}`)):(this.g&&k===0&&(this.j=!0),D(null,"",!0))})}A(c,u,h){const E=new R.StringDecoder(u);return c.on("data",D=>{h(null,E.write(D))}),E}B(c){const u=[];return c.on("data",h=>{u.push(h)}),u}C(c,u){const h=new R.StringDecoder(u);return c.map(E=>h.write(E)).join("")}D(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}G(c,{pathToEntries:u},h,E,D){E.indexOf(this.b)!==-1&&this.J(D,{base:h,relativePath:this.b,searchPath:this.N(c,this.b)});const m=p=>{const k=f.$mc(p),P=f.$lc(p);let z=u[P];z||(z=u[P]=[],m(P)),z.push({base:h,relativePath:p,basename:k,searchPath:this.N(c,p)})};E.forEach(m)}H({rootEntries:c,pathToEntries:u},h,E){const D=this,m=this.t.get(h),p=this.b;function k(P){D.o++;const z=(0,l.$gJ)(()=>P.map(j=>j.basename));for(let j=0,M=P.length;j<M;j++){const O=P[j],{relativePath:F,basename:N}=O;if(m.test(F,N,p!==N?z:void 0))continue;const W=u[F];if(W)k(W);else{if(D.p++,F===p)continue;D.J(E,O)}if(D.j)break}}k(c)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(c,u,h,E,D){const m=c.folder,p=(0,l.$gJ)(()=>h);this.w(h,(k,P)=>{if(this.l||this.j)return P(null);const z=u?[u,k].join(f.sep):k;if(this.t.get(c.folder.fsPath).test(z,k,this.a.filePattern!==k?p:void 0))return P(null);const j=[m.fsPath,z].join(f.sep);T.lstat(j,(M,O)=>{if(M||this.l||this.j)return P(null);this.L(j,O,(F,N)=>F||this.l||this.j?P(null):N.isDirectory()?(this.o++,this.M(j,O,(W,X)=>W||this.l||this.j||(X=X||"",this.v[X])?P(null):(this.v[X]=!0,w.Promises.readdir(j).then(ce=>{if(this.l||this.j)return P(null);this.I(c,z,ce,E,J=>P(J||null))},ce=>{P(null)})))):(this.p++,z===this.b||this.h&&S.$Gf(N.size)&&N.size>this.h||this.J(E,{base:m.fsPath,relativePath:z,searchPath:this.N(c,z)}),P(null,void 0)))})},k=>{const P=k&&L.$Gb(k);return D(P&&P.length>0?P[0]:void 0)})}J(c,u){this.K(u)&&(!this.d||this.d(u.relativePath,f.$mc(u.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||c(u))}K(c){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,l.$bJ)(c,this.c)}return!0}L(c,u,h){return u.isSymbolicLink()?T.stat(c,h):h(null,u)}M(c,u,h){return u.isSymbolicLink()?T.realpath(c,(E,D)=>E?h(E):h(null,D)):h(null,c)}N(c,u){return c.folderName?f.$ic(c.folderName,u):u}}e.$_fc=r;class a{constructor(c){this.a=c.folderQueries,this.b=c.extraFileResources||[],this.c=new r(c)}search(c,u,h){this.c.walk(this.a,this.b,c,u,(E,D)=>{h(E,{limitHit:D,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$agc=a;class t{constructor(c,u){this.expression=c,this.c=u,this.d(c)}d(c){let u,h;Object.keys(c).filter(E=>c[E]).forEach(E=>{f.$hc(E)?(u=u||y.$xj(),u[E]=c[E]):(h=h||y.$xj(),h[E]=c[E])}),this.a=u&&y.$Cj(u,{trimForExclusions:!0}),this.b=h&&y.$Cj(h,{trimForExclusions:!0})}test(c,u,h){return this.b&&this.b(c,u,h)||this.a&&this.a(f.$ic(this.c,c),u,h)}getBasenameTerms(){const c=[];return this.a&&c.push(...y.$Ej(this.a)),this.b&&c.push(...y.$Ej(this.b)),c}getPathTerms(){const c=[];return this.a&&c.push(...y.$Fj(this.a)),this.b&&c.push(...y.$Fj(this.b)),c}}function s(d){const c=d.trim().split(`
`),u=c[0].trim();if(u.startsWith("Error parsing regex"))return u;if(u.startsWith("regex parse error"))return v.$uf(c[c.length-1].trim());if(u.startsWith("error parsing glob")||u.startsWith("unsupported encoding"))return u.charAt(0).toUpperCase()+u.substr(1);if(u==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(u.startsWith("Literal "))return u}}),define(ke[375],Se([1,0,98,22,186,21]),function(me,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6C=e.$5C=e.$4C=e.$3C=e.$2C=e.$1C=e.$ZC=e.$YC=e.$XC=e.DecodeStreamErrorKind=e.$WC=e.$VC=e.$UC=e.$TC=e.$SC=e.$RC=e.$QC=e.$PC=void 0,e.$PC="utf8",e.$QC="utf8bom",e.$RC="utf16be",e.$SC="utf16le";function L(u){return[e.$PC,e.$QC,e.$RC,e.$SC].some(h=>h===u)}e.$TC=L,e.$UC=[254,255],e.$VC=[255,254],e.$WC=[239,187,191];const b=512,y=512,g=512*8,A=512*128;var I;(function(u){u[u.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(I||(e.DecodeStreamErrorKind=I={}));class $ extends Error{constructor(h,E){super(h),this.decodeStreamErrorKind=E}}e.$XC=$;class v{static async create(h){let E;if(h!==e.$PC)E=(await(0,f.$OC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(o(h));else{const D=new TextDecoder;E={write(m){return D.decode(m,{stream:!0})},end(){return D.decode()}}}return new v(E)}constructor(h){this.a=h}write(h){return this.a.write(h)}end(){return this.a.end()}}function S(u,h){const E=h.minBytesRequiredForDetection??h.guessEncoding?g:y;return new Promise((D,m)=>{const p=(0,C.$6d)(O=>O.join("")),k=[];let P=0,z;const j=new R.$2d,M=async()=>{try{const O=await c({buffer:T.$fe.concat(k),bytesRead:P},h.guessEncoding);if(O.seemsBinary&&h.acceptTextOnly)throw new $("Stream is binary but only text is accepted for decoding",1);O.encoding=await h.overwriteEncoding(O.encoding),z=await v.create(O.encoding);const F=z.write(T.$fe.concat(k).buffer);p.write(F),k.length=0,P=0,D({stream:p,detected:O})}catch(O){j.cancel(),p.destroy(),m(O)}};(0,C.$0d)(u,{onData:async O=>{z?p.write(z.write(O.buffer)):(k.push(O),P+=O.byteLength,P>=E&&(u.pause(),await M(),setTimeout(()=>u.resume())))},onError:O=>p.error(O),onEnd:async()=>{z||await M(),p.end(z?.end())}},j.token)})}e.$YC=S;async function w(u,h,E){const m=(await(0,f.$OC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(o(h),E);let p=!1,k=!1;return{read(){if(k)return null;const P=u.read();if(typeof P!="string"){if(k=!0,!p&&E?.addBOM)switch(h){case e.$PC:case e.$QC:return T.$fe.wrap(Uint8Array.from(e.$WC));case e.$RC:return T.$fe.wrap(Uint8Array.from(e.$UC));case e.$SC:return T.$fe.wrap(Uint8Array.from(e.$VC))}const z=m.end();return z&&z.length>0?(p=!0,T.$fe.wrap(z)):null}return p=!0,T.$fe.wrap(m.write(P))}}}e.$ZC=w;async function l(u){return(await(0,f.$OC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(o(u))}e.$1C=l;function o(u){return u===e.$QC||u===null?e.$PC:u}e.$2C=o;function i(u,h){if(!u||h<e.$UC.length)return null;const E=u.readUInt8(0),D=u.readUInt8(1);if(E===e.$UC[0]&&D===e.$UC[1])return e.$RC;if(E===e.$VC[0]&&D===e.$VC[1])return e.$SC;if(h<e.$WC.length)return null;const m=u.readUInt8(2);return E===e.$WC[0]&&D===e.$WC[1]&&m===e.$WC[2]?e.$QC:null}e.$3C=i;const n=["ascii","utf-16","utf-32"];async function r(u){const h=await(0,f.$OC)("jschardet","dist/jschardet.min.js"),E=u.slice(0,A),D=s(E.buffer),m=h.detect(D);if(!m||!m.encoding)return null;const p=m.encoding.toLowerCase();return 0<=n.indexOf(p)?null:t(m.encoding)}const a={ibm866:"cp866",big5:"cp950"};function t(u){const h=u.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return a[h]||h}function s(u){let h="";for(let E=0;E<u.length;E++)h+=String.fromCharCode(u[E]);return h}function d(u){switch(u){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const h=u.match(/windows(\d+)/);return h?"windows-"+h[1]:u}}}e.$4C=d;function c({buffer:u,bytesRead:h},E){let D=i(u,h),m=!1;if(D!==e.$RC&&D!==e.$SC&&u){let p=!0,k=!0,P=!1;for(let z=0;z<h&&z<b;z++){const j=z%2===1,M=u.readUInt8(z)===0;if(M&&(P=!0),p&&(j&&!M||!j&&M)&&(p=!1),k&&(j&&M||!j&&!M)&&(k=!1),M&&!p&&!k)break}P&&(p?D=e.$SC:k?D=e.$RC:m=!0)}return E&&!m&&!D&&u?r(u.slice(0,h)).then(p=>({seemsBinary:!1,encoding:p})):{seemsBinary:m,encoding:D}}e.$5C=c,e.$6C={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ke[157],Se([1,0,375,30,156]),function(me,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$igc=void 0;class R extends f.$6ec{constructor(b,y,g=T,A="searchProcess"){super(b,y,{readdir:I=>g.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,C.$4C)(I)},A)}}e.$igc=R}),define(ke[158],Se([1,0,50,391,374,19,73,34,16,13,2,36,94,392,372,119]),function(me,e,C,T,f,R,L,b,y,g,A,I,$,v,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hgc=e.$ggc=e.$fgc=e.$egc=e.$dgc=e.$cgc=e.$bgc=void 0;const l=S.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class o{constructor(k){this.a=k}provideTextSearchResults(k,P,z,j){return this.a.appendLine(`provideTextSearchResults ${k.pattern}, ${JSON.stringify({...P,folder:P.folder.toString()})}`),new Promise((M,O)=>{j.onCancellationRequested(()=>G());const F=s(k,P),N=P.folder.fsPath,W=F.map(q=>q.match(/^-/)?q:`'${q}'`).join(" ");this.a.appendLine(`${l} ${W}
 - cwd: ${N}`);let X=C.spawn(l,F,{cwd:N});X.on("error",q=>{console.error(q),this.a.appendLine("Error: "+(q&&q.message)),O((0,I.$0I)(new I.$8I(q&&q.message,I.SearchErrorCode.rgProcessError)))});let ce=!1;const J=new r(P.maxResults,N,P.previewOptions);J.on("result",q=>{ce=!0,_="",z.report(q)});let Q=!1;const G=()=>{Q=!0,X?.kill(),J?.cancel()};let oe=!1;J.on("hitLimit",()=>{oe=!0,G()});let _="";X.stdout.on("data",q=>{J.handleData(q),ce||(_+=q)});let Ee=!1;X.stdout.once("data",()=>Ee=!0);let he="";X.stderr.on("data",q=>{const U=q.toString();this.a.appendLine(U),he.length+U.length<1e6&&(he+=U)}),X.on("close",()=>{if(this.a.appendLine(Ee?"Got data from stdout":"No data from stdout"),this.a.appendLine(ce?"Got result from parser":"No result from parser"),_&&this.a.appendLine(`Got data without result: ${_}`),this.a.appendLine(""),Q)M({limitHit:oe});else{J.flush(),X=null;let q;he&&!Ee&&(q=i(he))?O((0,I.$0I)(new I.$8I(q.message,q.code))):M({limitHit:oe})}})})}}e.$bgc=o;function i(p){const k=p.split(`
`),P=k[0].trim();if(k.some(j=>j.startsWith("regex parse error")))return new I.$8I(n(k),I.SearchErrorCode.regexParseError);const z=P.match(/grep config error: unknown encoding: (.*)/);if(z)return new I.$8I(`Unknown encoding: ${z[1]}`,I.SearchErrorCode.unknownEncoding);if(P.startsWith("error parsing glob"))return new I.$8I(P.charAt(0).toUpperCase()+P.substr(1),I.SearchErrorCode.globParseError);if(P.startsWith("the literal"))return new I.$8I(P.charAt(0).toUpperCase()+P.substr(1),I.SearchErrorCode.invalidLiteral);if(P.startsWith("PCRE2: error compiling pattern"))return new I.$8I(P,I.SearchErrorCode.regexParseError)}function n(p){const k=["Regex parse error"],P=p.filter(z=>z.startsWith("PCRE2:"));if(P.length>=1){const z=P[0].replace("PCRE2:","");if(z.indexOf(":")!==-1&&z.split(":").length>=2){const j=z.split(":")[1];k.push(":"+j)}}return k.join("")}class r extends T.EventEmitter{constructor(k,P,z){super(),this.g=k,this.h=P,this.j=z,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new f.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(k,P){return super.on(k,P),this}handleData(k){if(this.b)return;const P=typeof k=="string"?k:this.d.write(k);this.k(P)}k(k){let P=k.indexOf(`
`);const z=this.a+k;if(P>=0)P+=this.a.length;else{this.a=z;return}let j=0;for(;P>=0;)this.m(z.substring(j,P).trim()),j=P+1,P=z.indexOf(`
`,j);this.a=z.substring(j)}m(k){if(this.b||!k)return;let P;try{P=JSON.parse(k)}catch{throw new Error(`malformed line from rg: ${k}`)}if(P.type==="match"){const z=a(P.data.path),j=A.URI.file(y.$ic(this.h,z)),M=this.n(P.data,j);this.p(M),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(P.type==="context"){const z=a(P.data.path),j=A.URI.file(y.$ic(this.h,z));this.o(P.data,j).forEach(O=>this.p(O))}}n(k,P){const z=k.line_number-1,j=a(k.lines),M=Buffer.from(j);let O=0,F=0,N=z;k.submatches.length===0&&k.submatches.push(j.length?{start:0,end:1,match:{text:j[0]}}:{start:0,end:0,match:{text:""}});const W=(0,R.$Gb)(k.submatches.map((X,ce)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const J=a(X.match),Q=M.slice(O,X.start).toString(),G=t(Q),oe=G.numLines>0?G.lastLineLength:G.lastLineLength+F,_=t(J),Ee=G.numLines+N,he=_.numLines+Ee,q=_.numLines>0?_.lastLineLength:_.lastLineLength+oe;return O=X.end,F=q,N=he,new $.$RI(Ee,oe,he,q)}));return(0,w.$7fc)(P,j,W,this.j)}o(k,P){const z=a(k.lines),j=k.line_number;return z.replace(/\r?\n$/,"").split(`
`).map((M,O)=>({text:M,uri:P,lineNumber:j+O}))}p(k){this.emit("result",k)}}e.$cgc=r;function a(p){return p.bytes?Buffer.from(p.bytes,"base64").toString():p.text}function t(p){const k=/\n/g;let P=0,z=-1,j;for(;j=k.exec(p);)P++,z=j.index;const M=z>=0?p.length-z-1:p.length;return{numLines:P,lastLineLength:M}}function s(p,k){const P=["--hidden","--no-require-git"];P.push(p.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:z,otherIncludes:j}=(0,L.$J)(k.includes,O=>O.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(j&&j.length){const O=new Set;j.forEach(F=>{O.add(F)}),P.push("-g","!*"),O.forEach(F=>{d(F).map(w.$6fc).forEach(N=>{P.push("-g",N)})})}z&&z.length&&z.forEach(O=>{P.push("-g",O)}),k.excludes.map(w.$6fc).forEach(O=>P.push("-g",`!${O}`)),k.maxFileSize&&P.push("--max-filesize",k.maxFileSize+""),k.useIgnoreFiles?k.useParentIgnoreFiles||P.push("--no-ignore-parent"):P.push("--no-ignore"),k.followSymlinks&&P.push("--follow"),k.encoding&&k.encoding!=="utf8"&&P.push("--encoding",k.encoding),p.pattern==="--"&&(p.isRegExp=!0,p.pattern="\\-\\-"),p.isMultiline&&!p.isRegExp&&(p.pattern=(0,g.$Je)(p.pattern),p.isRegExp=!0),k.usePCRE2&&P.push("--pcre2"),P.push("--crlf"),p.isRegExp&&(p.pattern=c(p.pattern),P.push("--engine","auto"));let M;if(p.isWordMatch){const F=(0,g.$Re)(p.pattern,!!p.isRegExp,{wholeWord:p.isWordMatch}).source.replace(/\\\//g,"/");P.push("--regexp",F)}else if(p.isRegExp){let O=h(p.pattern);O=E(O),P.push("--regexp",O)}else M=p.pattern,P.push("--fixed-strings");return P.push("--no-config"),k.useGlobalIgnoreFiles||P.push("--no-ignore-global"),P.push("--json"),p.isMultiline&&P.push("--multiline"),k.beforeContext&&P.push("--before-context",k.beforeContext+""),k.afterContext&&P.push("--after-context",k.afterContext+""),P.push("--"),M&&P.push(M),P.push("."),P}e.$dgc=s;function d(p){return m(p).flatMap(P=>{const z=(0,b.$Aj)(P,"/");return z.map((j,M)=>z.slice(0,M+1).join("/"))})}function c(p){const k=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;p.match(k);)p=p.replace(k,"$1\\x{$2}");const P=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;p.match(P);)p=p.replace(P,"$1\\x{$2}");return p}e.$egc=c;const u=p=>p.type==="Assertion"&&p.kind==="lookbehind";function h(p){let k;try{k=new v.RegExpParser().parsePattern(p)}catch{return p}let P="",z=0;const j=(F,N,W)=>{P+=p.slice(z,F)+W,z=N},M=[];return new v.RegExpVisitor({onCharacterEnter(F){if(F.raw!=="\\n")return;const N=M[0];if(!N)j(F.start,F.end,"\\r?\\n");else if(!M.some(u))if(N.type==="CharacterClass")if(N.negate){const W=p.slice(N.start+2,F.start)+p.slice(F.end,N.end-1);N.parent?.type==="Quantifier"?j(N.start,N.end,W?`[^${W}]`:"."):j(N.start,N.end,"(?!\\r?\\n"+(W?`|[${W}]`:"")+")")}else{const W=p.slice(N.start+1,F.start)+p.slice(F.end,N.end-1);j(N.start,N.end,W===""?"\\r?\\n":`(?:[${W}]|\\r?\\n)`)}else N.type==="Quantifier"&&j(F.start,F.end,"(?:\\r?\\n)")},onQuantifierEnter(F){M.unshift(F)},onQuantifierLeave(){M.shift()},onCharacterClassRangeEnter(F){M.unshift(F)},onCharacterClassRangeLeave(){M.shift()},onCharacterClassEnter(F){M.unshift(F)},onCharacterClassLeave(){M.shift()},onAssertionEnter(F){u(F)&&M.push(F)},onAssertionLeave(F){M[0]===F&&M.shift()}}).visit(k),P+=p.slice(z),P}e.$fgc=h;function E(p){return p.replace(/\n/g,"\\r?\\n")}e.$ggc=E;function D(p){let k=!1,P=!1,z="",j="";for(let M=0;M<p.length;M++){const O=p[M];switch(O){case"\\":P?(k?j+="\\"+O:z+="\\"+O,P=!1):P=!0;break;case"{":if(P)k?j+=O:z+=O,P=!1;else{if(k)return{strInBraces:z+"{"+j+"{"+p.substring(M+1)};k=!0}break;case"}":if(P)k?j+=O:z+=O,P=!1;else{if(k)return{fixedStart:z,strInBraces:j,fixedEnd:p.substring(M+1)};z+=O}break;default:k?j+=(P?"\\":"")+O:z+=(P?"\\":"")+O,P=!1;break}}return{strInBraces:z+(k?"{"+j:"")}}function m(p){const{fixedStart:k,strInBraces:P,fixedEnd:z}=D(p);if(k===void 0||z===void 0)return[P];let j=(0,b.$Aj)(P,",");j.length||(j=[""]);const M=m(z);return j.flatMap(O=>{const F=k+O;return M.map(N=>F+N)})}e.$hgc=m}),define(ke[376],Se([1,0,21,158,85,17]),function(me,e,C,T,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lgc=void 0;class L{constructor(g){this.b=g,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(g,A,I,$){const v=new T.$bgc(this.b);if(A.folder.scheme===R.Schemas.vscodeUserData){const S={...A,folder:A.folder.with({scheme:R.Schemas.file})},w=new f.$$u(l=>I.report({...l,uri:l.uri.with({scheme:A.folder.scheme})}));return this.c($,l=>v.provideTextSearchResults(g,S,w,l))}else return this.c($,S=>v.provideTextSearchResults(g,A,I,S))}async c(g,A){const I=b(g);this.a.add(I);const $=await A(I.token);return this.a.delete(I),$}d(){this.a.forEach(g=>g.cancel())}}e.$lgc=L;function b(y){const g=new C.$2d;return y.onCancellationRequested(()=>g.cancel()),g}}),define(ke[377],Se([1,0,30,158,157]),function(me,e,C,T,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jgc=void 0;class R{constructor(y){this.a=y}search(y,g,A){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(v){A({message:v})}},$=new f.$igc(this.a,new T.$bgc(I),C);return new Promise((v,S)=>$.search(w=>{g(w.map(L))},y).then(w=>v({limitHit:w.limitHit,type:"success",stats:w.stats}),S))}}e.$jgc=R;function L(b){return{path:b.resource&&b.resource.fsPath,results:b.results,numMatches:(b.results||[]).reduce((y,g)=>{if(g.ranges){const A=g;return y+(Array.isArray(A.ranges)?A.ranges.length:1)}else return y+1},0)}}}),define(ke[378],Se([1,0,19,12,8,4,130,16,38,2,31,36,373,377]),function(me,e,C,T,f,R,L,b,y,g,A,I,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kgc=void 0;class S{static{this.a=512}constructor(r="searchProcess"){this.d=r,this.b=Object.create(null)}fileSearch(r){let a;const t=o(r),s=new R.$Rd({onDidAddFirstListener:()=>{a=(0,T.$Lg)(d=>this.doFileSearchWithEngine($.$agc,t,c=>s.fire(c),d)),a.then(d=>s.fire(d),d=>s.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return s.event}textSearch(r){let a;const t=o(r),s=new R.$Rd({onDidAddFirstListener:()=>{a=(0,T.$Lg)(d=>this.f(t,c=>s.fire(c),d)),a.then(d=>s.fire(d),d=>s.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return s.event}f(r,a,t){return r.maxFileSize=this.g().maxFileSize,new v.$jgc(r).search(t,a,a)}g(){return{maxFileSize:16*A.$Mk.GB}}doFileSearch(r,a,t){return this.doFileSearchWithEngine($.$agc,r,a,t)}doFileSearchWithEngine(r,a,t,s,d=S.a){let c=0;const u=E=>{Array.isArray(E)?(c+=E.length,t(E.map(D=>this.h(D)))):E.relativePath?(c++,t(this.h(E))):t(E)};if(a.sortByScore){let E=this.l(a,u,s);if(!E){const D=a.maxResults?Object.assign({},a,{maxResults:null}):a,m=new r(D);E=this.j(m,a,t,u,s)}return new Promise((D,m)=>{E.then(([p,k])=>{const P=k.map(z=>this.h(z));this.o(P,t,d),D(p)},m)})}const h=new r(a);return this.r(h,u,d,s).then(E=>({limitHit:E.limitHit,type:"success",stats:{detailStats:E.stats,type:this.d,fromCache:!1,resultCount:c,sortingTime:void 0}}))}h(r){return{path:r.base?(0,b.$ic)(r.base,r.relativePath):r.relativePath}}j(r,a,t,s,d){const c=new R.$Rd;let u=(0,T.$Lg)(E=>{let D=[];const m=p=>{Array.isArray(p)?D=p:(s(p),c.fire(p))};return this.r(r,m,-1,E).then(p=>[p,D])}),h;if(a.cacheKey){h=this.k(a.cacheKey);const E={promise:u,event:c.event,resolved:!1};h.resultsToSearchCache[a.filePattern||""]=E,u.then(()=>{E.resolved=!0},D=>{delete h.resultsToSearchCache[a.filePattern||""]}),u=this.s(u)}return u.then(([E,D])=>{const m=h?h.scorerCache:Object.create(null),p=(typeof a.maxResults!="number"||a.maxResults>0)&&y.$Nd.create(!1);return this.n(a,D,m,d).then(k=>{const P=p?p.elapsed():-1;return[{type:"success",stats:{detailStats:E.stats,sortingTime:P,fromCache:!1,type:this.d,workspaceFolderCount:a.folderQueries.length,resultCount:k.length},messages:E.messages,limitHit:E.limitHit||typeof a.maxResults=="number"&&D.length>a.maxResults},k]})})}k(r){const a=this.b[r];return a||(this.b[r]=new w)}l(r,a,t){const s=r.cacheKey&&this.b[r.cacheKey];if(!s)return;const d=this.q(s,r.filePattern||"",a,t);if(d)return d.then(([c,u,h])=>{const E=y.$Nd.create(!1);return this.n(r,u,s.scorerCache,t).then(D=>{const m=E.elapsed(),p={fromCache:!0,detailStats:h,type:this.d,resultCount:u.length,sortingTime:m};return[{type:"success",limitHit:c.limitHit||typeof r.maxResults=="number"&&u.length>r.maxResults,stats:p},D]})})}n(r,a,t,s){const d=(0,L.$Eq)(r.filePattern||""),c=(h,E)=>(0,L.$Dq)(h,E,d,!0,l,t),u=typeof r.maxResults=="number"?r.maxResults:Number.MAX_VALUE;return C.$Fb(a,c,u,1e4,s)}o(r,a,t){if(t&&t>0)for(let s=0;s<r.length;s+=t)a(r.slice(s,s+t));else a(r)}q(r,a,t,s){const d=y.$Nd.create(!1),c=a.indexOf(b.sep)>=0;let u;for(const m in r.resultsToSearchCache)if(a.startsWith(m)){if(c&&m.indexOf(b.sep)<0&&m!=="")continue;const p=r.resultsToSearchCache[m];u={promise:this.s(p.promise),event:p.event,resolved:p.resolved};break}if(!u)return null;const h=d.elapsed(),E=y.$Nd.create(!1),D=u.event(t);return s&&s.onCancellationRequested(()=>{D.dispose()}),u.promise.then(([m,p])=>{if(s&&s.isCancellationRequested)throw(0,f.$5)();const k=[],P=(0,L.$Eq)(a).normalizedLowercase;for(const z of p)(0,I.$bJ)(z,P)&&k.push(z);return[m,k,{cacheWasResolved:u.resolved,cacheLookupTime:h,cacheFilterTime:E.elapsed(),cacheEntryCount:p.length}]})}r(r,a,t,s){return new Promise((d,c)=>{let u=[];s?.onCancellationRequested(()=>r.cancel()),r.search(h=>{h&&(t?(u.push(h),t>0&&u.length>=t&&(a(u),u=[])):a(h))},h=>{a(h)},(h,E)=>{u.length&&a(u),h?c(h):d(E)})})}clearCache(r){return delete this.b[r],Promise.resolve(void 0)}s(r){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(a,t){return r.then(a,t)}catch(a){return this.then(void 0,a)}finally(a){return r.finally(a)}}}}e.$kgc=S;class w{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const l=new class{getItemLabel(n){return(0,b.$mc)(n.relativePath)}getItemDescription(n){return(0,b.$lc)(n.relativePath)}getItemPath(n){return n.relativePath}};function o(n){return{...n,folderQueries:n.folderQueries&&n.folderQueries.map(i),extraFileResources:n.extraFileResources&&n.extraFileResources.map(r=>g.URI.revive(r))}}function i(n){return{...n,folder:g.URI.revive(n.folder)}}}),define(ke[379],Se([1,0,3,17,2,30,14,27,20,97,66,36,378,376,119,157]),function(me,e,C,T,f,R,L,b,y,g,A,I,$,v,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mgc=void 0;let l=class extends g.$$ec{constructor(i,n,r,a){super(i,r,a),this.s=R,this.t=-1,this.v=null,this.w=!1,this.x=new C.$Qc;const t=new S.$8fc("RipgrepSearchUD",this.n);this.x.add(this.registerTextSearchProvider(T.Schemas.vscodeUserData,new v.$lgc(t))),n.remote.isRemote&&n.remote.authority&&this.y()}dispose(){this.x.dispose()}$enableExtensionHostSearch(){this.y()}y(){if(this.w)return;this.w=!0;const i=new S.$8fc("RipgrepSearchEH",this.n);this.x.add(this.registerTextSearchProvider(T.Schemas.file,new v.$lgc(i))),this.x.add(this.z(T.Schemas.file,new $.$kgc("fileSearchProvider")))}z(i,n){const r=this.d++;return this.v=n,this.t=r,this.c.$registerFileSearchProvider(r,this.o(i)),(0,C.$Pc)(()=>{this.v=null,this.c.$unregisterProvider(r)})}$provideFileSearchResults(i,n,r,a){const t=(0,g.$_ec)(r);return i===this.t?this.A(i,n,t,a):super.$provideFileSearchResults(i,n,r,a)}doInternalFileSearchWithCustomCallback(i,n,r){const a=t=>{if((0,I.$aJ)(t)&&(t=[t]),Array.isArray(t)){r(t.map(s=>f.URI.file(s.path)));return}t.message&&this.n.debug("ExtHostSearch",t.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(i,a,n)}async A(i,n,r,a){return this.doInternalFileSearchWithCustomCallback(r,a,t=>{this.c.$handleFileMatch(i,n,t)})}$clearCache(i){return this.v?.clearCache(i),super.$clearCache(i)}q(i,n){return new w.$igc(i,n,void 0,"textSearchProvider")}};e.$mgc=l,e.$mgc=l=He([Be(0,y.$BM),Be(1,b.$RM),Be(2,A.$4dc),Be(3,L.$dj)],l)}),define(ke[120],Se([1,0,393,62,63,394,22,8,4,3,16,11,32,81,82]),function(me,e,C,T,f,R,L,b,y,g,A,I,$,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=void 0;class w{traceSocketEvent(p,k){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,p,k)}constructor(p,k=""){this.f=!0,this.debugLabel=k,this.socket=p,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,b.$Z)(P)}},this.socket.on("error",this.a),this.b=P=>{this.traceSocketEvent("close",{hadError:P}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(p){const k=P=>{this.traceSocketEvent("read",P),p(L.$fe.wrap(P))};return this.socket.on("data",k),{dispose:()=>this.socket.off("data",k)}}onClose(p){const k=P=>{p({type:0,hadError:P,error:void 0})};return this.socket.on("close",k),{dispose:()=>this.socket.off("close",k)}}onEnd(p){const k=()=>{p()};return this.socket.on("end",k),{dispose:()=>this.socket.off("end",k)}}write(p){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",p),this.socket.write(p.buffer,k=>{if(k){if(k.code==="EPIPE")return;(0,b.$Z)(k)}})}catch(k){if(k.code==="EPIPE")return;(0,b.$Z)(k)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((p,k)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),p();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),p()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.$Kh=w;var l;(function(m){m[m.MinHeaderByteSize=2]="MinHeaderByteSize",m[m.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(l||(l={}));var o;(function(m){m[m.PeekHeader=1]="PeekHeader",m[m.ReadHeader=2]="ReadHeader",m[m.ReadBody=3]="ReadBody",m[m.Fin=4]="Fin"})(o||(o={}));class i extends g.$Rc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(p,k){this.socket.traceSocketEvent(p,k)}constructor(p,k,P,z){super(),this.f=this.B(new y.$Rd),this.g=this.B(new y.$Rd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=p,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:k,inflateBytesLength:P?.byteLength||0,recordInflateBytes:z}),this.a=this.B(new n(this,k,P,z,this.f,(j,M)=>this.m(j,M))),this.B(this.a.onError(j=>{console.error(j),(0,b.$Z)(j),this.g.fire({type:0,hadError:!0,error:j})})),this.b=new S.$Fh,this.B(this.socket.onData(j=>this.n(j))),this.B(this.socket.onClose(async j=>{this.a.isProcessingReadQueue()&&await y.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(j)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(p){return this.f.event(p)}onClose(p){return this.g.event(p)}onEnd(p){return this.socket.onEnd(p)}write(p){let k=0;for(;k<p.byteLength;)this.a.writeMessage(p.slice(k,Math.min(k+262144,p.byteLength)),{compressed:!0,opcode:2}),k+=262144}m(p,{compressed:k,opcode:P}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",p);let z=2;p.byteLength<126?z+=0:p.byteLength<2**16?z+=2:z+=8;const j=L.$fe.alloc(z),M=k?64:0,O=P&15;if(j.writeUInt8(128|M|O,0),p.byteLength<126)j.writeUInt8(p.byteLength,1);else if(p.byteLength<2**16){j.writeUInt8(126,1);let F=1;j.writeUInt8(p.byteLength>>>8&255,++F),j.writeUInt8(p.byteLength>>>0&255,++F)}else{j.writeUInt8(127,1);let F=1;j.writeUInt8(0,++F),j.writeUInt8(0,++F),j.writeUInt8(0,++F),j.writeUInt8(0,++F),j.writeUInt8(p.byteLength>>>24&255,++F),j.writeUInt8(p.byteLength>>>16&255,++F),j.writeUInt8(p.byteLength>>>8&255,++F),j.writeUInt8(p.byteLength>>>0&255,++F)}this.socket.write(L.$fe.concat([j,p]))}end(){this.h=!0,this.socket.end()}n(p){if(p.byteLength!==0){for(this.b.acceptChunk(p);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const k=this.b.peek(this.j.readLen),P=k.readUInt8(0),z=(P&128)>>>7,j=(P&64)>>>6,M=P&15,O=k.readUInt8(1),F=(O&128)>>>7,N=O&127;this.j.state=2,this.j.readLen=2+(F?4:0)+(N===126?2:0)+(N===127?8:0),this.j.fin=z,this.j.firstFrameOfMessage&&(this.j.compressed=!!j),this.j.firstFrameOfMessage=!!z,this.j.mask=0,this.j.opcode=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const k=this.b.read(this.j.readLen),P=k.readUInt8(1),z=(P&128)>>>7;let j=P&127,M=1;j===126?j=k.readUInt8(++M)*2**8+k.readUInt8(++M):j===127&&(j=k.readUInt8(++M)*0+k.readUInt8(++M)*0+k.readUInt8(++M)*0+k.readUInt8(++M)*0+k.readUInt8(++M)*2**24+k.readUInt8(++M)*2**16+k.readUInt8(++M)*2**8+k.readUInt8(++M));let O=0;z&&(O=k.readUInt8(++M)*2**24+k.readUInt8(++M)*2**16+k.readUInt8(++M)*2**8+k.readUInt8(++M)),this.j.state=3,this.j.readLen=j,this.j.mask=O,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const k=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",k),t(k,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",k),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(k,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(k,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await y.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Lh=i;class n extends g.$Rc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:L.$fe.alloc(0)}constructor(p,k,P,z,j,M){super(),this.n=p,this.r=j,this.s=M,this.a=this.B(new y.$Rd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new y.$Rd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new y.$Rd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,k?(this.b=this.B(new r(this.n,z,P,{windowBits:15})),this.f=this.B(new a(this.n,{windowBits:15})),this.B(this.b.onError(O=>this.a.fire(O))),this.B(this.f.onError(O=>this.a.fire(O)))):(this.b=null,this.f=null)}writeMessage(p,k){this.g.push({data:p,options:k}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:p,options:k}=this.g.shift();if(this.f&&k.compressed){const P=await this.w(this.f,p);this.s(P,k)}else this.s(p,{...k,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(p,k){return new Promise((P,z)=>{p.write(k),p.flush(j=>P(j))})}acceptFrame(p,k,P){this.h.push({data:p,isCompressed:k,isLastFrameOfMessage:P}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const p=this.h.shift();if(this.b&&p.isCompressed){const k=await this.C(this.b,p.data,p.isLastFrameOfMessage);this.r.fire(k)}else this.r.fire(p.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(p,k,P){return new Promise((z,j)=>{p.write(k),P&&p.write(L.$fe.fromByteArray([0,0,255,255])),p.flush(M=>z(M))})}}class r extends g.$Rc{get recordedInflateBytes(){return this.j?L.$fe.concat(this.f):L.$fe.alloc(0)}constructor(p,k,P,z){super(),this.h=p,this.j=k,this.a=this.B(new y.$Rd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)(z),this.b.on("error",j=>{this.h.traceSocketEvent("zlibInflateError",{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.h.traceSocketEvent("zlibInflateData",j),this.g.push(L.$fe.wrap(j))}),P&&(this.h.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this.b.write(P.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(p){this.j&&this.f.push(p.clone()),this.h.traceSocketEvent("zlibInflateWrite",p),this.b.write(p.buffer)}flush(p){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const k=L.$fe.concat(this.g);this.g.length=0,p(k)})}}class a extends g.$Rc{constructor(p,k){super(),this.g=p,this.a=this.B(new y.$Rd),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",P=>{this.g.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this.a.fire(P)}),this.b.on("data",P=>{this.g.traceSocketEvent("zlibDeflateData",P),this.f.push(L.$fe.wrap(P))})}write(p){this.g.traceSocketEvent("zlibDeflateWrite",p.buffer),this.b.write(p.buffer)}flush(p){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let k=L.$fe.concat(this.f);this.f.length=0,k=k.slice(0,k.byteLength-4),p(k)})}}function t(m,p){if(p===0)return;const k=m.byteLength>>>2;for(let F=0;F<k;F++){const N=m.readUInt32BE(F*4);m.writeUInt32BE(N^p,F*4)}const P=k*4,z=m.byteLength-P,j=p>>>24&255,M=p>>>16&255,O=p>>>8&255;z>=1&&m.writeUInt8(m.readUInt8(P)^j,P),z>=2&&m.writeUInt8(m.readUInt8(P+1)^M,P+1),z>=3&&m.writeUInt8(m.readUInt8(P+2)^O,P+2)}e.$Mh=process.env.XDG_RUNTIME_DIR;const s={[2]:107,[1]:103};function d(){const m=(0,$.$ig)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${m}-sock`;const p=process.platform!=="darwin"&&e.$Mh?e.$Mh:(0,f.tmpdir)(),k=(0,A.$ic)(p,`vscode-ipc-${m}.sock`);return u(k),k}e.$Nh=d;function c(m,p,k){const P=(0,C.createHash)("md5").update(m).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${P}-${k}-${p}-sock`;const z=k.substr(0,4),j=p.substr(0,6),M=P.substr(0,8);let O;return process.platform!=="darwin"&&e.$Mh&&!process.env.VSCODE_PORTABLE?O=(0,A.$ic)(e.$Mh,`vscode-${M}-${z}-${j}.sock`):O=(0,A.$ic)(m,`${z}-${j}.sock`),u(O),O}e.$Oh=c;function u(m){const p=s[I.$u];typeof p=="number"&&m.length>=p&&console.warn(`WARNING: IPC handle "${m}" is longer than ${p} chars, try a shorter --user-data-dir`)}class h extends v.$zh{static b(p){const k=y.Event.fromNodeEventEmitter(p,"connection");return y.Event.map(k,P=>({protocol:new S.$Gh(new w(P,"ipc-server-connection")),onDidClientDisconnect:y.Event.once(y.Event.fromNodeEventEmitter(P,"close"))}))}constructor(p){super(h.b(p)),this.d=p}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Ph=h;function E(m){return new Promise((p,k)=>{const P=(0,T.createServer)();P.on("error",k),P.listen(m,()=>{P.removeListener("error",k),p(new h(P))})})}e.$Qh=E;function D(m,p){return new Promise((k,P)=>{const z=(0,T.createConnection)(m,()=>{z.removeListener("error",P),k(S.$Hh.fromSocket(new w(z,`ipc-client${p}`),p))});z.once("error",P)})}e.$Rh=D}),define(ke[380],Se([1,0,62,63,166,120,12,3,11,44,14,138,257,258,109,88,22]),function(me,e,C,T,f,R,L,b,y,g,A,I,$,v,S,w,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R9b=e.$Q9b=e.$P9b=e.$O9b=void 0;async function o(t,s,d,c,u){let h;for(let E=3;E&&(h?.dispose(),h=await new i(t,s,d,c,u).waitForReady(),!(u&&f.$lg[u]||!f.$lg[h.tunnelLocalPort]));E--);return h}class i extends b.$Rc{constructor(s,d,c,u,h){super(),this.m=d,this.n=h,this.privacy=w.TunnelPrivacyId.Private,this.j=new Map,this.a=s,this.b=C.createServer(),this.c=new L.$Wg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=E=>this.r(E),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=u,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(d=>{d()})}async waitForReady(){const s=this.n??this.tunnelRemotePort,d=(0,w.$kv)(this.m)?"0.0.0.0":"127.0.0.1";let c=await(0,f.$mg)(s,2,1e3,d),u=null;return this.b.listen(c,this.m),await this.c.wait(),u=this.b.address(),u||(c=0,this.b.listen(c,this.m),await this.c.wait(),u=this.b.address()),this.tunnelLocalPort=u.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${u.port}`,this}async r(s){s.pause();const d=(0,w.$iv)(this.tunnelRemoteHost)||(0,w.$kv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,$.$_k)(this.a,d,this.tunnelRemotePort),u=c.getSocket(),h=c.readEntireBuffer();c.dispose(),h.byteLength>0&&s.write(h.buffer),s.on("end",()=>{s.localAddress&&this.j.delete(s.localAddress),u.end()}),s.on("close",()=>u.end()),s.on("error",()=>{s.localAddress&&this.j.delete(s.localAddress),u instanceof R.$Kh?u.socket.destroy():u.end()}),u instanceof R.$Kh?this.t(s,u):this.s(s,u),s.localAddress&&this.j.set(s.localAddress,()=>{s.end(),u.end()})}s(s,d){d.onClose(()=>s.destroy()),d.onEnd(()=>s.end()),d.onData(c=>s.write(c.buffer)),s.on("data",c=>d.write(l.$fe.wrap(c))),s.resume()}t(s,d){const c=d.socket;c.on("end",()=>s.end()),c.on("close",()=>s.end()),c.on("error",()=>{s.destroy()}),c.pipe(s),s.pipe(c)}}e.$O9b=i;let n=class extends w.$nv{constructor(s,d,c,u,h){super(d,h),this.u=s,this.v=c,this.w=u}isPortPrivileged(s){return(0,w.$lv)(s,this.l,y.OS,T.release())}s(s,d,c,u,h,E,D,m){const p=this.r(d,c);if(p)return++p.refcount,p.value;if((0,w.$fv)(s))return this.t(s,d,c,h,E,D,m);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${d}:${c} on local port ${h}.`);const k={commit:this.w.commit,quality:this.w.quality,addressProvider:s,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},P=o(k,u,d,c,h);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(d,c,P),P}}};e.$P9b=n,e.$P9b=n=He([Be(0,v.$6k),Be(1,A.$dj),Be(2,S.$9k),Be(3,I.$vj),Be(4,g.$pi)],n);let r=class extends n{constructor(s,d,c,u,h){super(s,d,c,u,h)}};e.$Q9b=r,e.$Q9b=r=He([Be(0,v.$6k),Be(1,A.$dj),Be(2,S.$9k),Be(3,I.$vj),Be(4,g.$pi)],r);let a=class extends b.$Rc{constructor(s,d,c,u,h){super(),this.b=s,this.c=d,this.f=c,this.g=u,this.h=h,this.a=new Map}async openTunnel(s,d,c,u,h,E,D,m,p){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${u} on local port ${E}.`),!this.a.has(s)){const k=new r(this.b,this.c,this.g,this.f,this.h);this.B(k),this.a.set(s,k),k.onTunnelClosed(async()=>{(await k.tunnels).length===0&&(k.dispose(),this.a.delete(s))})}return this.a.get(s).openTunnel(d,c,u,h,E,D,m,p)}};e.$R9b=a,e.$R9b=a=He([Be(0,v.$6k),Be(1,A.$dj),Be(2,I.$vj),Be(3,S.$9k),Be(4,g.$pi)],a)}),define(ke[381],Se([1,0,120,277,55,35,2,14,40]),function(me,e,C,T,f,R,L,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4M=e.$3M=void 0;class g{constructor($,v,S){this.b=$,this.c=v,this.f=S,this.a=T.createServer((w,l)=>this.h(w,l)),this.g().catch(w=>(v.error(w),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",$=>this.c.error($))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h($,v){const S=(l,o)=>{v.writeHead(l,{"content-type":"application/json"}),v.end(JSON.stringify(o||null),i=>i&&this.c.error(i))},w=[];$.setEncoding("utf8"),$.on("data",l=>w.push(l)),$.on("end",async()=>{try{const l=JSON.parse(w.join(""));let o;switch(l.type){case"open":o=await this.i(l);break;case"openExternal":o=await this.j(l);break;case"status":o=await this.l(l);break;case"extensionManagement":o=await this.k(l);break;default:S(404,`Unknown message type: ${l.type}`);break}S(200,o)}catch(l){const o=l instanceof Error?l.message:JSON.stringify(l);S(500,o),this.c.error("Error while processing pipe request",l)}})}async i($){const{fileURIs:v,folderURIs:S,forceNewWindow:w,diffMode:l,mergeMode:o,addMode:i,forceReuseWindow:n,gotoLineMode:r,waitMarkerFilePath:a,remoteAuthority:t}=$,s=[];if(Array.isArray(S))for(const h of S)try{s.push({folderUri:L.URI.parse(h)})}catch{}if(Array.isArray(v))for(const h of v)try{(0,y.$oi)(h)?s.push({workspaceUri:L.URI.parse(h)}):s.push({fileUri:L.URI.parse(h)})}catch{}const d=a?L.URI.file(a):void 0,u={forceNewWindow:w,diffMode:l,mergeMode:o,addMode:i,gotoLineMode:r,forceReuseWindow:n,preferNewWindow:!n&&!d&&!i,waitMarkerFileURI:d,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",s,u)}async j($){for(const v of $.uris){const S=L.URI.parse(v),w=S.scheme==="file"?S:v;await this.b.executeCommand("_remoteCLI.openExternal",w)}}async k($){const v=w=>w?.map(l=>/\.vsix$/i.test(l)?L.URI.parse(l):l),S={list:$.list,install:v($.install),uninstall:v($.uninstall),force:$.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",S)}async l($){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&f.existsSync(this.f)&&f.unlinkSync(this.f)}}e.$3M=g;let A=class extends g{constructor($,v){super($,v,(0,C.$Nh)())}};e.$4M=A,e.$4M=A=He([Be(0,R.$XM),Be(1,b.$dj)],A)}),define(ke[382],Se([1,0,56,369,364,276,47,349,2,17,7,381,103,347,348]),function(me,e,C,T,f,R,L,b,y,g,A,I,$,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rgc=void 0;class w extends f.$Sfc{j(){const i=this,n=globalThis._VSCODE_NODE_MODULES.module,r=n._load;n._load=function(d,c,u){return d=t(d),i.a.has(d)?i.a.get(d).load(d,y.URI.file((0,$.$bq)(c.filename)),h=>r.apply(this,[h,c,u])):r.apply(this,arguments)};const a=n._resolveLookupPaths;n._resolveLookupPaths=(s,d)=>a.call(this,t(s),d);const t=s=>{for(const d of i.b){const c=d(s);if(c){s=c;break}}return s}}}class l extends L.$Hec{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Node}async tb(){this.h.createInstance(v.$pgc);const i=this.h.invokeFunction(T.$Ofc);if(this.h.createInstance(b.$ogc),this.f.remote.isRemote&&this.f.remote.authority){const a=this.h.createInstance(I.$4M);process.env.VSCODE_IPC_HOOK_CLI=a.ipcHandlePath}this.h.createInstance(S.$qgc),await this.h.createInstance(w,i,{mine:this.J,all:this.L}).install(),C.mark("code/extHost/didInitAPI");const r=await this.m.getConfigProvider();await(0,R.$ngc)(this.j,r,this,this.s,this.z,this.f),C.mark("code/extHost/didInitProxyResolver")}ub(i){return i.main}async vb(i,n,r){if(n.scheme!==g.Schemas.file)throw new Error(`Cannot load URI: '${n}', must be of file-scheme`);let a=null;r.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${n.toString(!0)}`),this.s.flush();const t=i?.identifier.value;i&&await this.w.initializeLocalizedMessages(i);try{t&&C.mark(`code/extHost/willLoadExtensionCode/${t}`),a=me.__$__nodeRequire(n.fsPath)}finally{t&&C.mark(`code/extHost/didLoadExtensionCode/${t}`),r.codeLoadingStop()}return a}async $setRemoteEnvironment(i){if(this.f.remote.isRemote)for(const n in i){const r=i[n];r===null?delete process.env[n]:process.env[n]=r}}}e.$rgc=l}),define(ke[383],Se([1,0,50,22,4,3,123,11,23,2,30,14,256,64,109,88,380,27,20,72,358]),function(me,e,C,T,f,R,L,b,y,g,A,I,$,v,S,w,l,o,i,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zgc=e.$ygc=e.$xgc=e.$wgc=e.$vgc=e.$ugc=e.$tgc=e.$sgc=void 0;function a(p){const k=p.trim().split(`
`),P=[];return k.forEach(j=>{const M=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(j);M&&M.length>=3&&P.push({pid:parseInt(M[1],10),socket:parseInt(M[2],10)})}),P.reduce((j,M)=>(j[M.socket]=M,j),{})}e.$sgc=a;function t(...p){const k=[].concat(...p.map(d));return[...new Map(k.filter(P=>P.st==="0A").map(P=>{const z=P.local_address.split(":");return{socket:parseInt(P.inode,10),ip:s(z[0]),port:parseInt(z[1],16)}}).map(P=>[P.ip+":"+P.port,P])).values()]}e.$tgc=t;function s(p){let k="";if(p.length===8)for(let P=p.length-2;P>=0;P-=2)k+=parseInt(p.substr(P,2),16),P!==0&&(k+=".");else for(let P=0;P<p.length;P+=8){const z=p.substring(P,P+8);let j="";for(let M=8;M>=2;M-=2)j+=z.substring(M-2,M),(M===6||M===2)&&(j=parseInt(j,16).toString(16),k+=`${j}`,j="",P+M!==p.length-6&&(k+=":"))}return k}e.$ugc=s;function d(p){const k=p.trim().split(`
`),P=k.shift().trim().split(/\s+/).filter(j=>j!=="rx_queue"&&j!=="tm->when");return k.map(j=>j.trim().split(/\s+/).reduce((M,O,F)=>(M[P[F]||F]=O,M),{}))}e.$vgc=d;function c(p){return!!p.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||p.indexOf("out/server-main.js")!==-1||p.indexOf("_productName=VSCode")!==-1}function u(p){const k=p.trim().split(`
`),P=[];return k.forEach(z=>{const j=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(z);j&&j.length>=4&&P.push({pid:parseInt(j[1],10),ppid:parseInt(j[2]),cmd:j[3]})}),P}e.$wgc=u;async function h(p,k,P){const z=P.reduce((M,O)=>(M[O.pid]=O,M),{}),j=[];return p.forEach(({socket:M,ip:O,port:F})=>{const N=k[M]?k[M].pid:void 0,W=N?z[N]?.cmd:void 0;N&&W&&!c(W)&&j.push({host:O,port:F,detail:W,pid:N})}),j}e.$xgc=h;function E(p,k,P){const z=new Map,j=u(k);for(const M of p){const O=P.get(M.port);if(O){z.set(M.port,O);continue}const F=j.find(N=>N.cmd.includes(`${M.port}`));if(F){let N=F,W;do W=j.find(X=>X.ppid===N.pid),W&&(N=W);while(W);z.set(M.port,{host:M.ip,port:M.port,pid:N.pid,detail:N.cmd,ppid:N.ppid})}else z.set(M.port,{host:M.ip,port:M.port,ppid:Number.MAX_VALUE})}return z}e.$ygc=E;let D=class extends n.$Qwb{constructor(k,P,z,j){super(k,P,z),this.D=P,this.F=j,this.y=void 0,this.z=new Map,this.C=!1,b.$k&&P.remote.isRemote&&P.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(k){if(k&&this.C)return;this.C=k;let P;this.y&&(P=this.y,await this.a.$onFoundNewCandidates(this.y));const z=new L.$Xl;let j=0;for(;this.C;){const M=new Date().getTime(),O=(await this.I()).filter(W=>(0,w.$iv)(W.host)||(0,w.$kv)(W.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${O.map(W=>W.port).join(", ")}`);const F=new Date().getTime()-M;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${F} ms.`),j++>3&&z.update(F),(!P||JSON.stringify(P)!==JSON.stringify(O))&&(P=O,await this.a.$onFoundNewCandidates(P));const N=this.G(z.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${N} ms.`),await new Promise(W=>setTimeout(()=>W(),N))}}G(k){return Math.max(k*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(k=>k.port).join(", ")}`)}async I(){let k="",P="";try{k=await A.Promises.readFile("/proc/net/tcp","utf8"),P=await A.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const z=t(k,P),j=await new Promise(J=>{(0,C.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(Q,G,oe)=>{J(G)})}),M=a(j),O=await A.Promises.readdir("/proc"),F=[];for(const J of O)try{const Q=Number(J),G=y.$zg(g.URI.file("/proc"),J);if((await A.Promises.stat(G.fsPath)).isDirectory()&&!isNaN(Q)){const _=await A.Promises.readlink(y.$zg(G,"cwd").fsPath),Ee=await A.Promises.readFile(y.$zg(G,"cmdline").fsPath,"utf8");F.push({pid:Q,cwd:_,cmd:Ee})}}catch{}const N=[],W=z.filter(J=>{const Q=M[J.socket];return Q||N.push(J),Q}),X=h(W,M,F);let ce;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${N.length}`),N.length>0){const J=await new Promise(Q=>{(0,C.exec)("ps -F -A -l | grep root",(G,oe,_)=>{Q(oe)})});this.z=E(N,J,this.z),ce=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${ce.map(Q=>Q.port).join(", ")}`)}return X.then(J=>ce?J.concat(ce):J)}w(k){return async P=>{const z=new l.$O9b({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(M,O,F,N){const W=await k.makeConnection();return m.connect(W,O,F,N)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new v.$Wk(0),connectionToken:k.connectionToken})}},signService:this.F},"localhost",P.remoteAddress.host||"localhost",P.remoteAddress.port,P.localAddressPort);await z.waitForReady();const j=new f.$Rd;return{localAddress:(0,r.$ZJ)(z.localAddress)??z.localAddress,remoteAddress:{port:z.tunnelRemotePort,host:z.tunnelRemoteHost},onDidDispose:j.event,dispose:()=>{z.dispose(),j.fire(),j.dispose()}}}}};e.$zgc=D,e.$zgc=D=He([Be(0,i.$BM),Be(1,o.$RM),Be(2,I.$dj),Be(3,S.$9k)],D);class m extends $.$7pb{static connect(k,P,z,j){const M=new R.$Qc,O={onClose:M.add(new f.$Rd),onData:M.add(new f.$Rd),onEnd:M.add(new f.$Rd)};M.add(k.onDidReceiveMessage(N=>O.onData.fire(T.$fe.wrap(N)))),M.add(k.onDidEnd(()=>O.onEnd.fire())),M.add(k.onDidClose(N=>O.onClose.fire({type:0,error:N,hadError:!!N})));const F=new m(k,j,O);return F.B(M),(0,$.$6pb)(F,P,z,j,O)}constructor(k,P,z){super(P,z),this.n=k}write(k){this.n.send(k.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(ke[384],Se([1,0,106,352,367,366,379,382,383,96,47,97,95,46,72,92,351,350,14,368,58,271,105,109,140]),function(me,e,C,T,f,R,L,b,y,g,A,I,$,v,S,w,l,o,i,n,r,a,t,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,C.$Cr)(A.$Iec,b.$rgc,0),(0,C.$Cr)(i.$ej,o.$Bgc,1),(0,C.$Cr)(i.$dj,new t.$Sh(a.$Rfc,[!1],!0)),(0,C.$Cr)(s.$9k,d.$T9b,1),(0,C.$Cr)(w.$aec,l.$Agc,0),(0,C.$Cr)(g.$Nec,R.$5fc,0),(0,C.$Cr)(I.$0ec,L.$mgc,0),(0,C.$Cr)($.$Afc,f.$Wfc,0),(0,C.$Cr)(v.$vec,T.$Vfc,0),(0,C.$Cr)(S.$Pwb,y.$zgc,0),(0,C.$Cr)(r.$Lec,n.$Cgc,0)}),define(ke[395],Se([1,0,62,396,56,8,82,120,254,114,365,22,30,103,12,133,278,292,370,384]),function(me,e,C,T,f,R,L,b,y,g,A,I,$,v,S,w,l,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let h=0;h<process.execArgv.length;h++)process.execArgv[h]==="--inspect-port=0"&&(process.execArgv.splice(h,1),h--)}();const i=T(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const u=globalThis._VSCODE_NODE_MODULES.module,h=u._load;u._load=function(E){if(E==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return h.apply(this,arguments)}})();const n=process.exit.bind(process);function r(u){process.exit=function(h){if(u)n(h);else{const E=new Error("An extension called process.exit() and this was prevented.");console.warn(E.stack)}},process.crash=function(){const h=new Error("An extension called process.crash() and this was prevented.");console.warn(h.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let a=function(u){n()};function t(){const u=(0,o.$Hm)(process.env);if(u.type===3)return new Promise((h,E)=>{const D=m=>{const p=m[0],k=new L.$Ih;p.on("message",P=>k.fire(I.$fe.wrap(P.data))),p.on("close",()=>{a("renderer closed the MessagePort")}),p.start(),h({onMessage:k.event,send:P=>p.postMessage(P.buffer)})};process.parentPort.on("message",m=>D(m.ports))});if(u.type===2)return new Promise((h,E)=>{let D=null;const m=setTimeout(()=>{a("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),p=108e5,k=3e5,P=new S.$$g(()=>a("renderer disconnected for too long (1)"),p),z=new S.$$g(()=>a("renderer disconnected for too long (2)"),k);process.on("message",(M,O)=>{if(M&&M.type==="VSCODE_EXTHOST_IPC_SOCKET"){O.setNoDelay(!0);const F=I.$fe.wrap(Buffer.from(M.initialDataChunk,"base64"));let N;if(M.skipWebSocketFrames)N=new b.$Kh(O,"extHost-socket");else{const W=I.$fe.wrap(Buffer.from(M.inflateBytes,"base64"));N=new b.$Lh(new b.$Kh(O,"extHost-socket"),M.permessageDeflate,W,!1)}D?(P.cancel(),z.cancel(),D.beginAcceptReconnection(N,F),D.endAcceptReconnection(),D.sendResume()):(clearTimeout(m),D=new L.$Jh({socket:N,initialChunk:F}),D.sendResume(),D.onDidDispose(()=>a("renderer disconnected")),h(D),D.onSocketClose(()=>{P.schedule()}))}if(M&&M.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(z.isScheduled())return;P.isScheduled()&&z.schedule()}});const j={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(j)});{const h=u.pipeName;return new Promise((E,D)=>{const m=C.createConnection(h,()=>{m.removeListener("error",D);const p=new L.$Jh({socket:new b.$Kh(m,"extHost-renderer")});p.sendResume(),E(p)});m.once("error",D),m.on("close",()=>{a("renderer closed the socket")})})}}async function s(){const u=await t();return new class{constructor(){this.a=new L.$Ih,this.onMessage=this.a.event,this.b=!1,u.onMessage(h=>{(0,g.$im)(h,2)?(this.b=!0,a("received terminate message from renderer")):this.a.fire(h)})}send(h){this.b||u.send(h)}async drain(){if(u.drain)return u.drain()}}}function d(u){return new Promise(h=>{const E=u.onMessage(D=>{E.dispose();const m=JSON.parse(D.toString()),p=m.commit,k=y.default.commit;if(p&&k&&p!==k&&n(55),m.parentPid){let P=0;setInterval(function(){try{process.kill(m.parentPid,0),P=0}catch(j){j&&j.code==="EPERM"?(P++,P>=3&&a(`parent process ${m.parentPid} does not exist anymore (3 x EPERM): ${j.message} (code: ${j.code}) (errno: ${j.errno})`)):a(`parent process ${m.parentPid} does not exist anymore: ${j.message} (code: ${j.code}) (errno: ${j.errno})`)}},1e3);let z;try{z=globalThis._VSCODE_NODE_MODULES["native-watchdog"],z.start(m.parentPid)}catch(j){(0,R.$Z)(j)}}u.send((0,g.$hm)(0)),h({protocol:u,initData:m})});u.send((0,g.$hm)(1))})}async function c(){const u=[];process.on("unhandledRejection",(P,z)=>{u.push(z),setTimeout(()=>{const j=u.indexOf(z);j>=0&&z.catch(M=>{u.splice(j,1),(0,R.$3)(M)||(console.warn(`rejected promise not handled within 1 second: ${M}`),M&&M.stack&&console.warn(`stack trace: ${M.stack}`),P&&(0,R.$Z)(P))})},1e3)}),process.on("rejectionHandled",P=>{const z=u.indexOf(P);z>=0&&u.splice(z,1)}),process.on("uncaughtException",function(P){(0,R.$Y)(P)||(0,R.$Z)(P)}),f.mark("code/extHost/willConnectToRenderer");const h=await s();f.mark("code/extHost/didConnectToRenderer");const E=await d(h);f.mark("code/extHost/didWaitForInitData");const{initData:D}=E;r(!!D.environment.extensionTestsLocationURI),D.environment.useHostProxy=i.useHostProxy!==void 0?i.useHostProxy!=="false":void 0,D.environment.skipWorkspaceStorageLock=(0,w.boolean)(i.skipWorkspaceStorageLock,!1);const m=new class{constructor(){this.pid=process.pid}exit(z){n(z)}fsExists(z){return $.Promises.exists(z)}fsRealpath(z){return(0,v.$aq)(z)}};let p=null;D.remote.authority&&i.transformURIs&&(p=(0,l.$Gr)(D.remote.authority));const k=new A.$Ufc(E.protocol,D,m,p);a=P=>k.terminate(P)}c().catch(u=>console.log(u))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b3a649fe52c0fb8692c9b28dfe25227c97521884/core/vs/workbench/api/node/extensionHostProcess.js.map
