/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ae=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/errors","vs/base/common/strings","vs/base/common/network","vs/base/common/async","vs/platform/log/common/log","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/path","vs/base/common/platform","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/base/common/severity","vs/workbench/api/common/extHostCommands","vs/base/common/glob","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/lazy","vs/base/common/themables","vs/base/common/extpath","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/core/position","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/arraysFind","vs/workbench/api/worker/extensionHostWorker"],Re=function(we){for(var e=[],y=0,F=we.length;y<F;y++)e[y]=Ae[we[y]];return e};define(Ae[66],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ph=e.$oh=e.$nh=void 0;function y(R){return($,E,f)=>{let P=null,D=null;if(typeof f.value=="function"?(P="value",D=f.value):typeof f.get=="function"&&(P="get",D=f.get),!D)throw new Error("not supported");f[P]=R(D,E)}}function F(R,$,E){let f=null,P=null;if(typeof E.value=="function"?(f="value",P=E.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(f="get",P=E.get),!P)throw new Error("not supported");const D=`$memoize$${$}`;E[f]=function(...u){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,u)}),this[D]}}e.$nh=F;function A(R,$,E){return y((f,P)=>{const D=`$debounce$${P}`,u=`$debounce$result$${P}`;return function(...b){this[u]||(this[u]=E?E():void 0),clearTimeout(this[D]),$&&(this[u]=$(this[u],...b),b=[this[u]]),this[D]=setTimeout(()=>{f.apply(this,b),this[u]=E?E():void 0},R)}})}e.$oh=A;function M(R,$,E){return y((f,P)=>{const D=`$throttle$timer$${P}`,u=`$throttle$result$${P}`,b=`$throttle$lastRun$${P}`,v=`$throttle$pending$${P}`;return function(...g){if(this[u]||(this[u]=E?E():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),$&&(this[u]=$(this[u],...g)),this[v])return;const t=this[b]+R;t<=Date.now()?(this[b]=Date.now(),f.apply(this,[this[u]]),this[u]=E?E():void 0):(this[v]=!0,this[D]=setTimeout(()=>{this[v]=!1,this[b]=Date.now(),f.apply(this,[this[u]]),this[u]=E?E():void 0},t-Date.now()))}})}e.$ph=M}),define(Ae[89],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HM=e.$GM=void 0;class y{constructor(A){this.a=A,this.b=0}nextId(){return this.a+ ++this.b}}e.$GM=y,e.$HM=new y("id#")}),define(Ae[119],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var y;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(y||(e.ScanError=y={}));var F;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(F||(e.SyntaxKind=F={}));var A;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(A||(e.ParseErrorCode=A={}));var M;(function(n){n.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function R(n,s=!1){let a=0;const d=n.length;let p="",m=0,S=16,k=0;function h(N){let C=0,T=0;for(;C<N;){const G=n.charCodeAt(a);if(G>=48&&G<=57)T=T*16+G-48;else if(G>=65&&G<=70)T=T*16+G-65+10;else if(G>=97&&G<=102)T=T*16+G-97+10;else break;a++,C++}return C<N&&(T=-1),T}function w(N){a=N,p="",m=0,S=16,k=0}function I(){const N=a;if(n.charCodeAt(a)===48)a++;else for(a++;a<n.length&&f(n.charCodeAt(a));)a++;if(a<n.length&&n.charCodeAt(a)===46)if(a++,a<n.length&&f(n.charCodeAt(a)))for(a++;a<n.length&&f(n.charCodeAt(a));)a++;else return k=3,n.substring(N,a);let C=a;if(a<n.length&&(n.charCodeAt(a)===69||n.charCodeAt(a)===101))if(a++,(a<n.length&&n.charCodeAt(a)===43||n.charCodeAt(a)===45)&&a++,a<n.length&&f(n.charCodeAt(a))){for(a++;a<n.length&&f(n.charCodeAt(a));)a++;C=a}else k=3;return n.substring(N,C)}function L(){let N="",C=a;for(;;){if(a>=d){N+=n.substring(C,a),k=2;break}const T=n.charCodeAt(a);if(T===34){N+=n.substring(C,a),a++;break}if(T===92){if(N+=n.substring(C,a),a++,a>=d){k=2;break}switch(n.charCodeAt(a++)){case 34:N+='"';break;case 92:N+="\\";break;case 47:N+="/";break;case 98:N+="\b";break;case 102:N+="\f";break;case 110:N+=`
`;break;case 114:N+="\r";break;case 116:N+="	";break;case 117:{const de=h(4);de>=0?N+=String.fromCharCode(de):k=4;break}default:k=5}C=a;continue}if(T>=0&&T<=31)if(E(T)){N+=n.substring(C,a),k=2;break}else k=6;a++}return N}function V(){if(p="",k=0,m=a,a>=d)return m=d,S=17;let N=n.charCodeAt(a);if($(N)){do a++,p+=String.fromCharCode(N),N=n.charCodeAt(a);while($(N));return S=15}if(E(N))return a++,p+=String.fromCharCode(N),N===13&&n.charCodeAt(a)===10&&(a++,p+=`
`),S=14;switch(N){case 123:return a++,S=1;case 125:return a++,S=2;case 91:return a++,S=3;case 93:return a++,S=4;case 58:return a++,S=6;case 44:return a++,S=5;case 34:return a++,p=L(),S=10;case 47:{const C=a-1;if(n.charCodeAt(a+1)===47){for(a+=2;a<d&&!E(n.charCodeAt(a));)a++;return p=n.substring(C,a),S=12}if(n.charCodeAt(a+1)===42){a+=2;const T=d-1;let G=!1;for(;a<T;){if(n.charCodeAt(a)===42&&n.charCodeAt(a+1)===47){a+=2,G=!0;break}a++}return G||(a++,k=1),p=n.substring(C,a),S=13}return p+=String.fromCharCode(N),a++,S=16}case 45:if(p+=String.fromCharCode(N),a++,a===d||!f(n.charCodeAt(a)))return S=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return p+=I(),S=11;default:for(;a<d&&Y(N);)a++,N=n.charCodeAt(a);if(m!==a){switch(p=n.substring(m,a),p){case"true":return S=8;case"false":return S=9;case"null":return S=7}return S=16}return p+=String.fromCharCode(N),a++,S=16}}function Y(N){if($(N)||E(N))return!1;switch(N){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function U(){let N;do N=V();while(N>=12&&N<=15);return N}return{setPosition:w,getPosition:()=>a,scan:s?U:V,getToken:()=>S,getTokenValue:()=>p,getTokenOffset:()=>m,getTokenLength:()=>a-m,getTokenError:()=>k}}e.$1m=R;function $(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function E(n){return n===10||n===13||n===8232||n===8233}function f(n){return n>=48&&n<=57}var P;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(P||(P={}));function D(n,s){const a=[],d=new Object;let p;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function k(h,w,I,L){m.value=h,m.offset=w,m.length=I,m.type=L,m.colonOffset=void 0,p=m}try{c(n,{onObjectBegin:(h,w)=>{if(s<=h)throw d;p=void 0,S=s>h,a.push("")},onObjectProperty:(h,w,I)=>{if(s<w||(k(h,w,I,"property"),a[a.length-1]=h,s<=w+I))throw d},onObjectEnd:(h,w)=>{if(s<=h)throw d;p=void 0,a.pop()},onArrayBegin:(h,w)=>{if(s<=h)throw d;p=void 0,a.push(0)},onArrayEnd:(h,w)=>{if(s<=h)throw d;p=void 0,a.pop()},onLiteralValue:(h,w,I)=>{if(s<w||(k(h,w,I,l(h)),s<=w+I))throw d},onSeparator:(h,w,I)=>{if(s<=w)throw d;if(h===":"&&p&&p.type==="property")p.colonOffset=w,S=!1,p=void 0;else if(h===","){const L=a[a.length-1];typeof L=="number"?a[a.length-1]=L+1:(S=!0,a[a.length-1]=""),p=void 0}}})}catch(h){if(h!==d)throw h}return{path:a,previousNode:p,isAtPropertyKey:S,matches:h=>{let w=0;for(let I=0;w<h.length&&I<a.length;I++)if(h[w]===a[I]||h[w]==="*")w++;else if(h[w]!=="**")return!1;return w===h.length}}}e.$2m=D;function u(n,s=[],a=M.DEFAULT){let d=null,p=[];const m=[];function S(h){Array.isArray(p)?p.push(h):d!==null&&(p[d]=h)}return c(n,{onObjectBegin:()=>{const h={};S(h),m.push(p),p=h,d=null},onObjectProperty:h=>{d=h},onObjectEnd:()=>{p=m.pop()},onArrayBegin:()=>{const h=[];S(h),m.push(p),p=h,d=null},onArrayEnd:()=>{p=m.pop()},onLiteralValue:S,onError:(h,w,I)=>{s.push({error:h,offset:w,length:I})}},a),p[0]}e.$3m=u;function b(n,s=[],a=M.DEFAULT){let d={type:"array",offset:-1,length:-1,children:[],parent:void 0};function p(h){d.type==="property"&&(d.length=h-d.offset,d=d.parent)}function m(h){return d.children.push(h),h}c(n,{onObjectBegin:h=>{d=m({type:"object",offset:h,length:-1,parent:d,children:[]})},onObjectProperty:(h,w,I)=>{d=m({type:"property",offset:w,length:-1,parent:d,children:[]}),d.children.push({type:"string",value:h,offset:w,length:I,parent:d})},onObjectEnd:(h,w)=>{d.length=h+w-d.offset,d=d.parent,p(h+w)},onArrayBegin:(h,w)=>{d=m({type:"array",offset:h,length:-1,parent:d,children:[]})},onArrayEnd:(h,w)=>{d.length=h+w-d.offset,d=d.parent,p(h+w)},onLiteralValue:(h,w,I)=>{m({type:l(h),offset:w,length:I,parent:d,value:h}),p(w+I)},onSeparator:(h,w,I)=>{d.type==="property"&&(h===":"?d.colonOffset=w:h===","&&p(w))},onError:(h,w,I)=>{s.push({error:h,offset:w,length:I})}},a);const k=d.children[0];return k&&delete k.parent,k}e.$4m=b;function v(n,s){if(!n)return;let a=n;for(const d of s)if(typeof d=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let p=!1;for(const m of a.children)if(Array.isArray(m.children)&&m.children[0].value===d){a=m.children[1],p=!0;break}if(!p)return}else{const p=d;if(a.type!=="array"||p<0||!Array.isArray(a.children)||p>=a.children.length)return;a=a.children[p]}return a}e.$5m=v;function g(n){if(!n.parent||!n.parent.children)return[];const s=g(n.parent);if(n.parent.type==="property"){const a=n.parent.children[0].value;s.push(a)}else if(n.parent.type==="array"){const a=n.parent.children.indexOf(n);a!==-1&&s.push(a)}return s}e.$6m=g;function t(n){switch(n.type){case"array":return n.children.map(t);case"object":{const s=Object.create(null);for(const a of n.children){const d=a.children[1];d&&(s[a.children[0].value]=t(d))}return s}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.$7m=t;function i(n,s,a=!1){return s>=n.offset&&s<n.offset+n.length||a&&s===n.offset+n.length}e.$8m=i;function r(n,s,a=!1){if(i(n,s,a)){const d=n.children;if(Array.isArray(d))for(let p=0;p<d.length&&d[p].offset<=s;p++){const m=r(d[p],s,a);if(m)return m}return n}}e.$9m=r;function c(n,s,a=M.DEFAULT){const d=R(n,!1);function p(re){return re?()=>re(d.getTokenOffset(),d.getTokenLength()):()=>!0}function m(re){return re?Pe=>re(Pe,d.getTokenOffset(),d.getTokenLength()):()=>!0}const S=p(s.onObjectBegin),k=m(s.onObjectProperty),h=p(s.onObjectEnd),w=p(s.onArrayBegin),I=p(s.onArrayEnd),L=m(s.onLiteralValue),V=m(s.onSeparator),Y=p(s.onComment),U=m(s.onError),N=a&&a.disallowComments,C=a&&a.allowTrailingComma;function T(){for(;;){const re=d.scan();switch(d.getTokenError()){case 4:G(14);break;case 5:G(15);break;case 3:G(13);break;case 1:N||G(11);break;case 2:G(12);break;case 6:G(16);break}switch(re){case 12:case 13:N?G(10):Y();break;case 16:G(1);break;case 15:case 14:break;default:return re}}}function G(re,Pe=[],se=[]){if(U(re),Pe.length+se.length>0){let Z=d.getToken();for(;Z!==17;){if(Pe.indexOf(Z)!==-1){T();break}else if(se.indexOf(Z)!==-1)break;Z=T()}}}function de(re){const Pe=d.getTokenValue();return re?L(Pe):k(Pe),T(),!0}function me(){switch(d.getToken()){case 11:{let re=0;try{re=JSON.parse(d.getTokenValue()),typeof re!="number"&&(G(2),re=0)}catch{G(2)}L(re);break}case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return T(),!0}function De(){return d.getToken()!==10?(G(3,[],[2,5]),!1):(de(!1),d.getToken()===6?(V(":"),T(),pe()||G(4,[],[2,5])):G(5,[],[2,5]),!0)}function ke(){S(),T();let re=!1;for(;d.getToken()!==2&&d.getToken()!==17;){if(d.getToken()===5){if(re||G(4,[],[]),V(","),T(),d.getToken()===2&&C)break}else re&&G(6,[],[]);De()||G(4,[],[2,5]),re=!0}return h(),d.getToken()!==2?G(7,[2],[]):T(),!0}function le(){w(),T();let re=!1;for(;d.getToken()!==4&&d.getToken()!==17;){if(d.getToken()===5){if(re||G(4,[],[]),V(","),T(),d.getToken()===4&&C)break}else re&&G(6,[],[]);pe()||G(4,[],[4,5]),re=!0}return I(),d.getToken()!==4?G(8,[4],[]):T(),!0}function pe(){switch(d.getToken()){case 3:return le();case 1:return ke();case 10:return de(!0);default:return me()}}return T(),d.getToken()===17?a.allowEmptyContent?!0:(G(4,[],[]),!1):pe()?(d.getToken()!==17&&G(9,[],[]),!0):(G(4,[],[]),!1)}e.$0m=c;function o(n,s){const a=R(n),d=[];let p,m=0,S;do switch(S=a.getPosition(),p=a.scan(),p){case 12:case 13:case 17:m!==S&&d.push(n.substring(m,S)),s!==void 0&&d.push(a.getTokenValue().replace(/[^\r\n]/g,s)),m=a.getPosition();break}while(p!==17);return d.join("")}e.$$m=o;function l(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.$_m=l}),function(we,e){typeof define=="function"&&define.amd?define(Ae[120],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(we=typeof globalThis<"u"?globalThis:we||self,e(we.marked={}))}(this,function(we){"use strict";function e(he,ce){for(var ye=0;ye<ce.length;ye++){var _=ce[ye];_.enumerable=_.enumerable||!1,_.configurable=!0,"value"in _&&(_.writable=!0),Object.defineProperty(he,_.key,_)}}function y(he,ce,ye){return ce&&e(he.prototype,ce),ye&&e(he,ye),Object.defineProperty(he,"prototype",{writable:!1}),he}function F(he,ce){if(he){if(typeof he=="string")return A(he,ce);var ye=Object.prototype.toString.call(he).slice(8,-1);if(ye==="Object"&&he.constructor&&(ye=he.constructor.name),ye==="Map"||ye==="Set")return Array.from(he);if(ye==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ye))return A(he,ce)}}function A(he,ce){(ce==null||ce>he.length)&&(ce=he.length);for(var ye=0,_=new Array(ce);ye<ce;ye++)_[ye]=he[ye];return _}function M(he,ce){var ye=typeof Symbol<"u"&&he[Symbol.iterator]||he["@@iterator"];if(ye)return(ye=ye.call(he)).next.bind(ye);if(Array.isArray(he)||(ye=F(he))||ce&&he&&typeof he.length=="number"){ye&&(he=ye);var _=0;return function(){return _>=he.length?{done:!0}:{done:!1,value:he[_++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}we.defaults=R();function $(he){we.defaults=he}var E=/[&<>"']/,f=/[&<>"']/g,P=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(ce){return u[ce]};function v(he,ce){if(ce){if(E.test(he))return he.replace(f,b)}else if(P.test(he))return he.replace(D,b);return he}var g=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(he){return he.replace(g,function(ce,ye){return ye=ye.toLowerCase(),ye==="colon"?":":ye.charAt(0)==="#"?ye.charAt(1)==="x"?String.fromCharCode(parseInt(ye.substring(2),16)):String.fromCharCode(+ye.substring(1)):""})}var i=/(^|[^\[])\^/g;function r(he,ce){he=typeof he=="string"?he:he.source,ce=ce||"";var ye={replace:function(fe,te){return te=te.source||te,te=te.replace(i,"$1"),he=he.replace(fe,te),ye},getRegex:function(){return new RegExp(he,ce)}};return ye}var c=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function l(he,ce,ye){if(he){var _;try{_=decodeURIComponent(t(ye)).replace(c,"").toLowerCase()}catch{return null}if(_.indexOf("javascript:")===0||_.indexOf("vbscript:")===0||_.indexOf("data:")===0)return null}ce&&!o.test(ye)&&(ye=p(ce,ye));try{ye=encodeURI(ye).replace(/%25/g,"%")}catch{return null}return ye}var n={},s=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,d=/^([^:]+:\/*[^/]*)[\s\S]*$/;function p(he,ce){n[" "+he]||(s.test(he)?n[" "+he]=he+"/":n[" "+he]=h(he,"/",!0)),he=n[" "+he];var ye=he.indexOf(":")===-1;return ce.substring(0,2)==="//"?ye?ce:he.replace(a,"$1")+ce:ce.charAt(0)==="/"?ye?ce:he.replace(d,"$1")+ce:he+ce}var m={exec:function(){}};function S(he){for(var ce=1,ye,_;ce<arguments.length;ce++){ye=arguments[ce];for(_ in ye)Object.prototype.hasOwnProperty.call(ye,_)&&(he[_]=ye[_])}return he}function k(he,ce){var ye=he.replace(/\|/g,function(te,ae,$e){for(var Ie=!1,O=ae;--O>=0&&$e[O]==="\\";)Ie=!Ie;return Ie?"|":" |"}),_=ye.split(/ \|/),fe=0;if(_[0].trim()||_.shift(),_.length>0&&!_[_.length-1].trim()&&_.pop(),_.length>ce)_.splice(ce);else for(;_.length<ce;)_.push("");for(;fe<_.length;fe++)_[fe]=_[fe].trim().replace(/\\\|/g,"|");return _}function h(he,ce,ye){var _=he.length;if(_===0)return"";for(var fe=0;fe<_;){var te=he.charAt(_-fe-1);if(te===ce&&!ye)fe++;else if(te!==ce&&ye)fe++;else break}return he.slice(0,_-fe)}function w(he,ce){if(he.indexOf(ce[1])===-1)return-1;for(var ye=he.length,_=0,fe=0;fe<ye;fe++)if(he[fe]==="\\")fe++;else if(he[fe]===ce[0])_++;else if(he[fe]===ce[1]&&(_--,_<0))return fe;return-1}function I(he){he&&he.sanitize&&!he.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function L(he,ce){if(ce<1)return"";for(var ye="";ce>1;)ce&1&&(ye+=he),ce>>=1,he+=he;return ye+he}function V(he,ce,ye,_){var fe=ce.href,te=ce.title?v(ce.title):null,ae=he[1].replace(/\\([\[\]])/g,"$1");if(he[0].charAt(0)!=="!"){_.state.inLink=!0;var $e={type:"link",raw:ye,href:fe,title:te,text:ae,tokens:_.inlineTokens(ae)};return _.state.inLink=!1,$e}return{type:"image",raw:ye,href:fe,title:te,text:v(ae)}}function Y(he,ce){var ye=he.match(/^(\s+)(?:```)/);if(ye===null)return ce;var _=ye[1];return ce.split(`
`).map(function(fe){var te=fe.match(/^\s+/);if(te===null)return fe;var ae=te[0];return ae.length>=_.length?fe.slice(_.length):fe}).join(`
`)}var U=function(){function he(ye){this.options=ye||we.defaults}var ce=he.prototype;return ce.space=function(_){var fe=this.rules.block.newline.exec(_);if(fe&&fe[0].length>0)return{type:"space",raw:fe[0]}},ce.code=function(_){var fe=this.rules.block.code.exec(_);if(fe){var te=fe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:fe[0],codeBlockStyle:"indented",text:this.options.pedantic?te:h(te,`
`)}}},ce.fences=function(_){var fe=this.rules.block.fences.exec(_);if(fe){var te=fe[0],ae=Y(te,fe[3]||"");return{type:"code",raw:te,lang:fe[2]?fe[2].trim():fe[2],text:ae}}},ce.heading=function(_){var fe=this.rules.block.heading.exec(_);if(fe){var te=fe[2].trim();if(/#$/.test(te)){var ae=h(te,"#");(this.options.pedantic||!ae||/ $/.test(ae))&&(te=ae.trim())}return{type:"heading",raw:fe[0],depth:fe[1].length,text:te,tokens:this.lexer.inline(te)}}},ce.hr=function(_){var fe=this.rules.block.hr.exec(_);if(fe)return{type:"hr",raw:fe[0]}},ce.blockquote=function(_){var fe=this.rules.block.blockquote.exec(_);if(fe){var te=fe[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:fe[0],tokens:this.lexer.blockTokens(te,[]),text:te}}},ce.list=function(_){var fe=this.rules.block.list.exec(_);if(fe){var te,ae,$e,Ie,O,W,H,J,q,x,ue,Ne,Be=fe[1].trim(),Ye=Be.length>1,Je={type:"list",raw:"",ordered:Ye,start:Ye?+Be.slice(0,-1):"",loose:!1,items:[]};Be=Ye?"\\d{1,9}\\"+Be.slice(-1):"\\"+Be,this.options.pedantic&&(Be=Ye?Be:"[*+-]");for(var tt=new RegExp("^( {0,3}"+Be+")((?:[	 ][^\\n]*)?(?:\\n|$))");_&&(Ne=!1,!(!(fe=tt.exec(_))||this.rules.block.hr.test(_)));){if(te=fe[0],_=_.substring(te.length),J=fe[2].split(`
`,1)[0],q=_.split(`
`,1)[0],this.options.pedantic?(Ie=2,ue=J.trimLeft()):(Ie=fe[2].search(/[^ ]/),Ie=Ie>4?1:Ie,ue=J.slice(Ie),Ie+=fe[1].length),W=!1,!J&&/^ *$/.test(q)&&(te+=q+`
`,_=_.substring(q.length+1),Ne=!0),!Ne)for(var _e=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),et=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),rt=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:```|~~~)"),nt=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}#");_&&(x=_.split(`
`,1)[0],J=x,this.options.pedantic&&(J=J.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(rt.test(J)||nt.test(J)||_e.test(J)||et.test(_)));){if(J.search(/[^ ]/)>=Ie||!J.trim())ue+=`
`+J.slice(Ie);else if(!W)ue+=`
`+J;else break;!W&&!J.trim()&&(W=!0),te+=x+`
`,_=_.substring(x.length+1)}Je.loose||(H?Je.loose=!0:/\n *\n *$/.test(te)&&(H=!0)),this.options.gfm&&(ae=/^\[[ xX]\] /.exec(ue),ae&&($e=ae[0]!=="[ ] ",ue=ue.replace(/^\[[ xX]\] +/,""))),Je.items.push({type:"list_item",raw:te,task:!!ae,checked:$e,loose:!1,text:ue}),Je.raw+=te}Je.items[Je.items.length-1].raw=te.trimRight(),Je.items[Je.items.length-1].text=ue.trimRight(),Je.raw=Je.raw.trimRight();var ze=Je.items.length;for(O=0;O<ze;O++){this.lexer.state.top=!1,Je.items[O].tokens=this.lexer.blockTokens(Je.items[O].text,[]);var dt=Je.items[O].tokens.filter(function(Q){return Q.type==="space"}),X=dt.every(function(Q){for(var Ee=Q.raw.split(""),je=0,He=M(Ee),Xe;!(Xe=He()).done;){var st=Xe.value;if(st===`
`&&(je+=1),je>1)return!0}return!1});!Je.loose&&dt.length&&X&&(Je.loose=!0,Je.items[O].loose=!0)}return Je}},ce.html=function(_){var fe=this.rules.block.html.exec(_);if(fe){var te={type:"html",raw:fe[0],pre:!this.options.sanitizer&&(fe[1]==="pre"||fe[1]==="script"||fe[1]==="style"),text:fe[0]};if(this.options.sanitize){var ae=this.options.sanitizer?this.options.sanitizer(fe[0]):v(fe[0]);te.type="paragraph",te.text=ae,te.tokens=this.lexer.inline(ae)}return te}},ce.def=function(_){var fe=this.rules.block.def.exec(_);if(fe){fe[3]&&(fe[3]=fe[3].substring(1,fe[3].length-1));var te=fe[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:te,raw:fe[0],href:fe[2],title:fe[3]}}},ce.table=function(_){var fe=this.rules.block.table.exec(_);if(fe){var te={type:"table",header:k(fe[1]).map(function(H){return{text:H}}),align:fe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:fe[3]&&fe[3].trim()?fe[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(te.header.length===te.align.length){te.raw=fe[0];var ae=te.align.length,$e,Ie,O,W;for($e=0;$e<ae;$e++)/^ *-+: *$/.test(te.align[$e])?te.align[$e]="right":/^ *:-+: *$/.test(te.align[$e])?te.align[$e]="center":/^ *:-+ *$/.test(te.align[$e])?te.align[$e]="left":te.align[$e]=null;for(ae=te.rows.length,$e=0;$e<ae;$e++)te.rows[$e]=k(te.rows[$e],te.header.length).map(function(H){return{text:H}});for(ae=te.header.length,Ie=0;Ie<ae;Ie++)te.header[Ie].tokens=this.lexer.inline(te.header[Ie].text);for(ae=te.rows.length,Ie=0;Ie<ae;Ie++)for(W=te.rows[Ie],O=0;O<W.length;O++)W[O].tokens=this.lexer.inline(W[O].text);return te}}},ce.lheading=function(_){var fe=this.rules.block.lheading.exec(_);if(fe)return{type:"heading",raw:fe[0],depth:fe[2].charAt(0)==="="?1:2,text:fe[1],tokens:this.lexer.inline(fe[1])}},ce.paragraph=function(_){var fe=this.rules.block.paragraph.exec(_);if(fe){var te=fe[1].charAt(fe[1].length-1)===`
`?fe[1].slice(0,-1):fe[1];return{type:"paragraph",raw:fe[0],text:te,tokens:this.lexer.inline(te)}}},ce.text=function(_){var fe=this.rules.block.text.exec(_);if(fe)return{type:"text",raw:fe[0],text:fe[0],tokens:this.lexer.inline(fe[0])}},ce.escape=function(_){var fe=this.rules.inline.escape.exec(_);if(fe)return{type:"escape",raw:fe[0],text:v(fe[1])}},ce.tag=function(_){var fe=this.rules.inline.tag.exec(_);if(fe)return!this.lexer.state.inLink&&/^<a /i.test(fe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(fe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(fe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(fe[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:fe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):v(fe[0]):fe[0]}},ce.link=function(_){var fe=this.rules.inline.link.exec(_);if(fe){var te=fe[2].trim();if(!this.options.pedantic&&/^</.test(te)){if(!/>$/.test(te))return;var ae=h(te.slice(0,-1),"\\");if((te.length-ae.length)%2===0)return}else{var $e=w(fe[2],"()");if($e>-1){var Ie=fe[0].indexOf("!")===0?5:4,O=Ie+fe[1].length+$e;fe[2]=fe[2].substring(0,$e),fe[0]=fe[0].substring(0,O).trim(),fe[3]=""}}var W=fe[2],H="";if(this.options.pedantic){var J=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(W);J&&(W=J[1],H=J[3])}else H=fe[3]?fe[3].slice(1,-1):"";return W=W.trim(),/^</.test(W)&&(this.options.pedantic&&!/>$/.test(te)?W=W.slice(1):W=W.slice(1,-1)),V(fe,{href:W&&W.replace(this.rules.inline._escapes,"$1"),title:H&&H.replace(this.rules.inline._escapes,"$1")},fe[0],this.lexer)}},ce.reflink=function(_,fe){var te;if((te=this.rules.inline.reflink.exec(_))||(te=this.rules.inline.nolink.exec(_))){var ae=(te[2]||te[1]).replace(/\s+/g," ");if(ae=fe[ae.toLowerCase()],!ae||!ae.href){var $e=te[0].charAt(0);return{type:"text",raw:$e,text:$e}}return V(te,ae,te[0],this.lexer)}},ce.emStrong=function(_,fe,te){te===void 0&&(te="");var ae=this.rules.inline.emStrong.lDelim.exec(_);if(ae&&!(ae[3]&&te.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var $e=ae[1]||ae[2]||"";if(!$e||$e&&(te===""||this.rules.inline.punctuation.exec(te))){var Ie=ae[0].length-1,O,W,H=Ie,J=0,q=ae[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(q.lastIndex=0,fe=fe.slice(-1*_.length+Ie);(ae=q.exec(fe))!=null;)if(O=ae[1]||ae[2]||ae[3]||ae[4]||ae[5]||ae[6],!!O){if(W=O.length,ae[3]||ae[4]){H+=W;continue}else if((ae[5]||ae[6])&&Ie%3&&!((Ie+W)%3)){J+=W;continue}if(H-=W,!(H>0)){if(W=Math.min(W,W+H+J),Math.min(Ie,W)%2){var x=_.slice(1,Ie+ae.index+W);return{type:"em",raw:_.slice(0,Ie+ae.index+W+1),text:x,tokens:this.lexer.inlineTokens(x)}}var ue=_.slice(2,Ie+ae.index+W-1);return{type:"strong",raw:_.slice(0,Ie+ae.index+W+1),text:ue,tokens:this.lexer.inlineTokens(ue)}}}}}},ce.codespan=function(_){var fe=this.rules.inline.code.exec(_);if(fe){var te=fe[2].replace(/\n/g," "),ae=/[^ ]/.test(te),$e=/^ /.test(te)&&/ $/.test(te);return ae&&$e&&(te=te.substring(1,te.length-1)),te=v(te,!0),{type:"codespan",raw:fe[0],text:te}}},ce.br=function(_){var fe=this.rules.inline.br.exec(_);if(fe)return{type:"br",raw:fe[0]}},ce.del=function(_){var fe=this.rules.inline.del.exec(_);if(fe)return{type:"del",raw:fe[0],text:fe[2],tokens:this.lexer.inlineTokens(fe[2])}},ce.autolink=function(_,fe){var te=this.rules.inline.autolink.exec(_);if(te){var ae,$e;return te[2]==="@"?(ae=v(this.options.mangle?fe(te[1]):te[1]),$e="mailto:"+ae):(ae=v(te[1]),$e=ae),{type:"link",raw:te[0],text:ae,href:$e,tokens:[{type:"text",raw:ae,text:ae}]}}},ce.url=function(_,fe){var te;if(te=this.rules.inline.url.exec(_)){var ae,$e;if(te[2]==="@")ae=v(this.options.mangle?fe(te[0]):te[0]),$e="mailto:"+ae;else{var Ie;do Ie=te[0],te[0]=this.rules.inline._backpedal.exec(te[0])[0];while(Ie!==te[0]);ae=v(te[0]),te[1]==="www."?$e="http://"+ae:$e=ae}return{type:"link",raw:te[0],text:ae,href:$e,tokens:[{type:"text",raw:ae,text:ae}]}}},ce.inlineText=function(_,fe){var te=this.rules.inline.text.exec(_);if(te){var ae;return this.lexer.state.inRawBlock?ae=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(te[0]):v(te[0]):te[0]:ae=v(this.options.smartypants?fe(te[0]):te[0]),{type:"text",raw:te[0],text:ae}}},he}(),N={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:m,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};N._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,N._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,N.def=r(N.def).replace("label",N._label).replace("title",N._title).getRegex(),N.bullet=/(?:[*+-]|\d{1,9}[.)])/,N.listItemStart=r(/^( *)(bull) */).replace("bull",N.bullet).getRegex(),N.list=r(N.list).replace(/bull/g,N.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+N.def.source+")").getRegex(),N._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",N._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,N.html=r(N.html,"i").replace("comment",N._comment).replace("tag",N._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),N.paragraph=r(N._paragraph).replace("hr",N.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",N._tag).getRegex(),N.blockquote=r(N.blockquote).replace("paragraph",N.paragraph).getRegex(),N.normal=S({},N),N.gfm=S({},N.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),N.gfm.table=r(N.gfm.table).replace("hr",N.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",N._tag).getRegex(),N.gfm.paragraph=r(N._paragraph).replace("hr",N.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",N.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",N._tag).getRegex(),N.pedantic=S({},N.normal,{html:r(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",N._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:m,paragraph:r(N.normal._paragraph).replace("hr",N.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",N.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var C={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:m,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:m,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};C._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",C.punctuation=r(C.punctuation).replace(/punctuation/g,C._punctuation).getRegex(),C.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,C.escapedEmSt=/\\\*|\\_/g,C._comment=r(N._comment).replace("(?:-->|$)","-->").getRegex(),C.emStrong.lDelim=r(C.emStrong.lDelim).replace(/punct/g,C._punctuation).getRegex(),C.emStrong.rDelimAst=r(C.emStrong.rDelimAst,"g").replace(/punct/g,C._punctuation).getRegex(),C.emStrong.rDelimUnd=r(C.emStrong.rDelimUnd,"g").replace(/punct/g,C._punctuation).getRegex(),C._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,C._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,C._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,C.autolink=r(C.autolink).replace("scheme",C._scheme).replace("email",C._email).getRegex(),C._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,C.tag=r(C.tag).replace("comment",C._comment).replace("attribute",C._attribute).getRegex(),C._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,C._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,C._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,C.link=r(C.link).replace("label",C._label).replace("href",C._href).replace("title",C._title).getRegex(),C.reflink=r(C.reflink).replace("label",C._label).replace("ref",N._label).getRegex(),C.nolink=r(C.nolink).replace("ref",N._label).getRegex(),C.reflinkSearch=r(C.reflinkSearch,"g").replace("reflink",C.reflink).replace("nolink",C.nolink).getRegex(),C.normal=S({},C),C.pedantic=S({},C.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:r(/^!?\[(label)\]\((.*?)\)/).replace("label",C._label).getRegex(),reflink:r(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",C._label).getRegex()}),C.gfm=S({},C.normal,{escape:r(C.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),C.gfm.url=r(C.gfm.url,"i").replace("email",C.gfm._extended_email).getRegex(),C.breaks=S({},C.gfm,{br:r(C.br).replace("{2,}","*").getRegex(),text:r(C.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function T(he){return he.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function G(he){var ce="",ye,_,fe=he.length;for(ye=0;ye<fe;ye++)_=he.charCodeAt(ye),Math.random()>.5&&(_="x"+_.toString(16)),ce+="&#"+_+";";return ce}var de=function(){function he(ye){this.tokens=[],this.tokens.links=Object.create(null),this.options=ye||we.defaults,this.options.tokenizer=this.options.tokenizer||new U,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var _={block:N.normal,inline:C.normal};this.options.pedantic?(_.block=N.pedantic,_.inline=C.pedantic):this.options.gfm&&(_.block=N.gfm,this.options.breaks?_.inline=C.breaks:_.inline=C.gfm),this.tokenizer.rules=_}he.lex=function(_,fe){var te=new he(fe);return te.lex(_)},he.lexInline=function(_,fe){var te=new he(fe);return te.inlineTokens(_)};var ce=he.prototype;return ce.lex=function(_){_=_.replace(/\r\n|\r/g,`
`),this.blockTokens(_,this.tokens);for(var fe;fe=this.inlineQueue.shift();)this.inlineTokens(fe.src,fe.tokens);return this.tokens},ce.blockTokens=function(_,fe){var te=this;fe===void 0&&(fe=[]),this.options.pedantic?_=_.replace(/\t/g,"    ").replace(/^ +$/gm,""):_=_.replace(/^( *)(\t+)/gm,function(H,J,q){return J+"    ".repeat(q.length)});for(var ae,$e,Ie,O;_;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(H){return(ae=H.call({lexer:te},_,fe))?(_=_.substring(ae.raw.length),fe.push(ae),!0):!1}))){if(ae=this.tokenizer.space(_)){_=_.substring(ae.raw.length),ae.raw.length===1&&fe.length>0?fe[fe.length-1].raw+=`
`:fe.push(ae);continue}if(ae=this.tokenizer.code(_)){_=_.substring(ae.raw.length),$e=fe[fe.length-1],$e&&($e.type==="paragraph"||$e.type==="text")?($e.raw+=`
`+ae.raw,$e.text+=`
`+ae.text,this.inlineQueue[this.inlineQueue.length-1].src=$e.text):fe.push(ae);continue}if(ae=this.tokenizer.fences(_)){_=_.substring(ae.raw.length),fe.push(ae);continue}if(ae=this.tokenizer.heading(_)){_=_.substring(ae.raw.length),fe.push(ae);continue}if(ae=this.tokenizer.hr(_)){_=_.substring(ae.raw.length),fe.push(ae);continue}if(ae=this.tokenizer.blockquote(_)){_=_.substring(ae.raw.length),fe.push(ae);continue}if(ae=this.tokenizer.list(_)){_=_.substring(ae.raw.length),fe.push(ae);continue}if(ae=this.tokenizer.html(_)){_=_.substring(ae.raw.length),fe.push(ae);continue}if(ae=this.tokenizer.def(_)){_=_.substring(ae.raw.length),$e=fe[fe.length-1],$e&&($e.type==="paragraph"||$e.type==="text")?($e.raw+=`
`+ae.raw,$e.text+=`
`+ae.raw,this.inlineQueue[this.inlineQueue.length-1].src=$e.text):this.tokens.links[ae.tag]||(this.tokens.links[ae.tag]={href:ae.href,title:ae.title});continue}if(ae=this.tokenizer.table(_)){_=_.substring(ae.raw.length),fe.push(ae);continue}if(ae=this.tokenizer.lheading(_)){_=_.substring(ae.raw.length),fe.push(ae);continue}if(Ie=_,this.options.extensions&&this.options.extensions.startBlock&&function(){var H=1/0,J=_.slice(1),q=void 0;te.options.extensions.startBlock.forEach(function(x){q=x.call({lexer:this},J),typeof q=="number"&&q>=0&&(H=Math.min(H,q))}),H<1/0&&H>=0&&(Ie=_.substring(0,H+1))}(),this.state.top&&(ae=this.tokenizer.paragraph(Ie))){$e=fe[fe.length-1],O&&$e.type==="paragraph"?($e.raw+=`
`+ae.raw,$e.text+=`
`+ae.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=$e.text):fe.push(ae),O=Ie.length!==_.length,_=_.substring(ae.raw.length);continue}if(ae=this.tokenizer.text(_)){_=_.substring(ae.raw.length),$e=fe[fe.length-1],$e&&$e.type==="text"?($e.raw+=`
`+ae.raw,$e.text+=`
`+ae.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=$e.text):fe.push(ae);continue}if(_){var W="Infinite loop on byte: "+_.charCodeAt(0);if(this.options.silent){console.error(W);break}else throw new Error(W)}}return this.state.top=!0,fe},ce.inline=function(_,fe){return fe===void 0&&(fe=[]),this.inlineQueue.push({src:_,tokens:fe}),fe},ce.inlineTokens=function(_,fe){var te=this;fe===void 0&&(fe=[]);var ae,$e,Ie,O=_,W,H,J;if(this.tokens.links){var q=Object.keys(this.tokens.links);if(q.length>0)for(;(W=this.tokenizer.rules.inline.reflinkSearch.exec(O))!=null;)q.includes(W[0].slice(W[0].lastIndexOf("[")+1,-1))&&(O=O.slice(0,W.index)+"["+L("a",W[0].length-2)+"]"+O.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(W=this.tokenizer.rules.inline.blockSkip.exec(O))!=null;)O=O.slice(0,W.index)+"["+L("a",W[0].length-2)+"]"+O.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(W=this.tokenizer.rules.inline.escapedEmSt.exec(O))!=null;)O=O.slice(0,W.index)+"++"+O.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;_;)if(H||(J=""),H=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ue){return(ae=ue.call({lexer:te},_,fe))?(_=_.substring(ae.raw.length),fe.push(ae),!0):!1}))){if(ae=this.tokenizer.escape(_)){_=_.substring(ae.raw.length),fe.push(ae);continue}if(ae=this.tokenizer.tag(_)){_=_.substring(ae.raw.length),$e=fe[fe.length-1],$e&&ae.type==="text"&&$e.type==="text"?($e.raw+=ae.raw,$e.text+=ae.text):fe.push(ae);continue}if(ae=this.tokenizer.link(_)){_=_.substring(ae.raw.length),fe.push(ae);continue}if(ae=this.tokenizer.reflink(_,this.tokens.links)){_=_.substring(ae.raw.length),$e=fe[fe.length-1],$e&&ae.type==="text"&&$e.type==="text"?($e.raw+=ae.raw,$e.text+=ae.text):fe.push(ae);continue}if(ae=this.tokenizer.emStrong(_,O,J)){_=_.substring(ae.raw.length),fe.push(ae);continue}if(ae=this.tokenizer.codespan(_)){_=_.substring(ae.raw.length),fe.push(ae);continue}if(ae=this.tokenizer.br(_)){_=_.substring(ae.raw.length),fe.push(ae);continue}if(ae=this.tokenizer.del(_)){_=_.substring(ae.raw.length),fe.push(ae);continue}if(ae=this.tokenizer.autolink(_,G)){_=_.substring(ae.raw.length),fe.push(ae);continue}if(!this.state.inLink&&(ae=this.tokenizer.url(_,G))){_=_.substring(ae.raw.length),fe.push(ae);continue}if(Ie=_,this.options.extensions&&this.options.extensions.startInline&&function(){var ue=1/0,Ne=_.slice(1),Be=void 0;te.options.extensions.startInline.forEach(function(Ye){Be=Ye.call({lexer:this},Ne),typeof Be=="number"&&Be>=0&&(ue=Math.min(ue,Be))}),ue<1/0&&ue>=0&&(Ie=_.substring(0,ue+1))}(),ae=this.tokenizer.inlineText(Ie,T)){_=_.substring(ae.raw.length),ae.raw.slice(-1)!=="_"&&(J=ae.raw.slice(-1)),H=!0,$e=fe[fe.length-1],$e&&$e.type==="text"?($e.raw+=ae.raw,$e.text+=ae.text):fe.push(ae);continue}if(_){var x="Infinite loop on byte: "+_.charCodeAt(0);if(this.options.silent){console.error(x);break}else throw new Error(x)}}return fe},y(he,null,[{key:"rules",get:function(){return{block:N,inline:C}}}]),he}(),me=function(){function he(ye){this.options=ye||we.defaults}var ce=he.prototype;return ce.code=function(_,fe,te){var ae=(fe||"").match(/\S*/)[0];if(this.options.highlight){var $e=this.options.highlight(_,ae);$e!=null&&$e!==_&&(te=!0,_=$e)}return _=_.replace(/\n$/,"")+`
`,ae?'<pre><code class="'+this.options.langPrefix+v(ae,!0)+'">'+(te?_:v(_,!0))+`</code></pre>
`:"<pre><code>"+(te?_:v(_,!0))+`</code></pre>
`},ce.blockquote=function(_){return`<blockquote>
`+_+`</blockquote>
`},ce.html=function(_){return _},ce.heading=function(_,fe,te,ae){if(this.options.headerIds){var $e=this.options.headerPrefix+ae.slug(te);return"<h"+fe+' id="'+$e+'">'+_+"</h"+fe+`>
`}return"<h"+fe+">"+_+"</h"+fe+`>
`},ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ce.list=function(_,fe,te){var ae=fe?"ol":"ul",$e=fe&&te!==1?' start="'+te+'"':"";return"<"+ae+$e+`>
`+_+"</"+ae+`>
`},ce.listitem=function(_){return"<li>"+_+`</li>
`},ce.checkbox=function(_){return"<input "+(_?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ce.paragraph=function(_){return"<p>"+_+`</p>
`},ce.table=function(_,fe){return fe&&(fe="<tbody>"+fe+"</tbody>"),`<table>
<thead>
`+_+`</thead>
`+fe+`</table>
`},ce.tablerow=function(_){return`<tr>
`+_+`</tr>
`},ce.tablecell=function(_,fe){var te=fe.header?"th":"td",ae=fe.align?"<"+te+' align="'+fe.align+'">':"<"+te+">";return ae+_+("</"+te+`>
`)},ce.strong=function(_){return"<strong>"+_+"</strong>"},ce.em=function(_){return"<em>"+_+"</em>"},ce.codespan=function(_){return"<code>"+_+"</code>"},ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},ce.del=function(_){return"<del>"+_+"</del>"},ce.link=function(_,fe,te){if(_=l(this.options.sanitize,this.options.baseUrl,_),_===null)return te;var ae='<a href="'+v(_)+'"';return fe&&(ae+=' title="'+fe+'"'),ae+=">"+te+"</a>",ae},ce.image=function(_,fe,te){if(_=l(this.options.sanitize,this.options.baseUrl,_),_===null)return te;var ae='<img src="'+_+'" alt="'+te+'"';return fe&&(ae+=' title="'+fe+'"'),ae+=this.options.xhtml?"/>":">",ae},ce.text=function(_){return _},he}(),De=function(){function he(){}var ce=he.prototype;return ce.strong=function(_){return _},ce.em=function(_){return _},ce.codespan=function(_){return _},ce.del=function(_){return _},ce.html=function(_){return _},ce.text=function(_){return _},ce.link=function(_,fe,te){return""+te},ce.image=function(_,fe,te){return""+te},ce.br=function(){return""},he}(),ke=function(){function he(){this.seen={}}var ce=he.prototype;return ce.serialize=function(_){return _.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ce.getNextSafeSlug=function(_,fe){var te=_,ae=0;if(this.seen.hasOwnProperty(te)){ae=this.seen[_];do ae++,te=_+"-"+ae;while(this.seen.hasOwnProperty(te))}return fe||(this.seen[_]=ae,this.seen[te]=0),te},ce.slug=function(_,fe){fe===void 0&&(fe={});var te=this.serialize(_);return this.getNextSafeSlug(te,fe.dryrun)},he}(),le=function(){function he(ye){this.options=ye||we.defaults,this.options.renderer=this.options.renderer||new me,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new De,this.slugger=new ke}he.parse=function(_,fe){var te=new he(fe);return te.parse(_)},he.parseInline=function(_,fe){var te=new he(fe);return te.parseInline(_)};var ce=he.prototype;return ce.parse=function(_,fe){fe===void 0&&(fe=!0);var te="",ae,$e,Ie,O,W,H,J,q,x,ue,Ne,Be,Ye,Je,tt,_e,et,rt,nt,ze=_.length;for(ae=0;ae<ze;ae++){if(ue=_[ae],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ue.type]&&(nt=this.options.extensions.renderers[ue.type].call({parser:this},ue),nt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ue.type))){te+=nt||"";continue}switch(ue.type){case"space":continue;case"hr":{te+=this.renderer.hr();continue}case"heading":{te+=this.renderer.heading(this.parseInline(ue.tokens),ue.depth,t(this.parseInline(ue.tokens,this.textRenderer)),this.slugger);continue}case"code":{te+=this.renderer.code(ue.text,ue.lang,ue.escaped);continue}case"table":{for(q="",J="",O=ue.header.length,$e=0;$e<O;$e++)J+=this.renderer.tablecell(this.parseInline(ue.header[$e].tokens),{header:!0,align:ue.align[$e]});for(q+=this.renderer.tablerow(J),x="",O=ue.rows.length,$e=0;$e<O;$e++){for(H=ue.rows[$e],J="",W=H.length,Ie=0;Ie<W;Ie++)J+=this.renderer.tablecell(this.parseInline(H[Ie].tokens),{header:!1,align:ue.align[Ie]});x+=this.renderer.tablerow(J)}te+=this.renderer.table(q,x);continue}case"blockquote":{x=this.parse(ue.tokens),te+=this.renderer.blockquote(x);continue}case"list":{for(Ne=ue.ordered,Be=ue.start,Ye=ue.loose,O=ue.items.length,x="",$e=0;$e<O;$e++)tt=ue.items[$e],_e=tt.checked,et=tt.task,Je="",tt.task&&(rt=this.renderer.checkbox(_e),Ye?tt.tokens.length>0&&tt.tokens[0].type==="paragraph"?(tt.tokens[0].text=rt+" "+tt.tokens[0].text,tt.tokens[0].tokens&&tt.tokens[0].tokens.length>0&&tt.tokens[0].tokens[0].type==="text"&&(tt.tokens[0].tokens[0].text=rt+" "+tt.tokens[0].tokens[0].text)):tt.tokens.unshift({type:"text",text:rt}):Je+=rt),Je+=this.parse(tt.tokens,Ye),x+=this.renderer.listitem(Je,et,_e);te+=this.renderer.list(x,Ne,Be);continue}case"html":{te+=this.renderer.html(ue.text);continue}case"paragraph":{te+=this.renderer.paragraph(this.parseInline(ue.tokens));continue}case"text":{for(x=ue.tokens?this.parseInline(ue.tokens):ue.text;ae+1<ze&&_[ae+1].type==="text";)ue=_[++ae],x+=`
`+(ue.tokens?this.parseInline(ue.tokens):ue.text);te+=fe?this.renderer.paragraph(x):x;continue}default:{var dt='Token with "'+ue.type+'" type was not found.';if(this.options.silent){console.error(dt);return}else throw new Error(dt)}}}return te},ce.parseInline=function(_,fe){fe=fe||this.renderer;var te="",ae,$e,Ie,O=_.length;for(ae=0;ae<O;ae++){if($e=_[ae],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[$e.type]&&(Ie=this.options.extensions.renderers[$e.type].call({parser:this},$e),Ie!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes($e.type))){te+=Ie||"";continue}switch($e.type){case"escape":{te+=fe.text($e.text);break}case"html":{te+=fe.html($e.text);break}case"link":{te+=fe.link($e.href,$e.title,this.parseInline($e.tokens,fe));break}case"image":{te+=fe.image($e.href,$e.title,$e.text);break}case"strong":{te+=fe.strong(this.parseInline($e.tokens,fe));break}case"em":{te+=fe.em(this.parseInline($e.tokens,fe));break}case"codespan":{te+=fe.codespan($e.text);break}case"br":{te+=fe.br();break}case"del":{te+=fe.del(this.parseInline($e.tokens,fe));break}case"text":{te+=fe.text($e.text);break}default:{var W='Token with "'+$e.type+'" type was not found.';if(this.options.silent){console.error(W);return}else throw new Error(W)}}}return te},he}();function pe(he,ce,ye){if(typeof he>"u"||he===null)throw new Error("marked(): input parameter is undefined or null");if(typeof he!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(he)+", string expected");if(typeof ce=="function"&&(ye=ce,ce=null),ce=S({},pe.defaults,ce||{}),I(ce),ye){var _=ce.highlight,fe;try{fe=de.lex(he,ce)}catch(O){return ye(O)}var te=function(W){var H;if(!W)try{ce.walkTokens&&pe.walkTokens(fe,ce.walkTokens),H=le.parse(fe,ce)}catch(J){W=J}return ce.highlight=_,W?ye(W):ye(null,H)};if(!_||_.length<3||(delete ce.highlight,!fe.length))return te();var ae=0;pe.walkTokens(fe,function(O){O.type==="code"&&(ae++,setTimeout(function(){_(O.text,O.lang,function(W,H){if(W)return te(W);H!=null&&H!==O.text&&(O.text=H,O.escaped=!0),ae--,ae===0&&te()})},0))}),ae===0&&te();return}function $e(O){if(O.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+v(O.message+"",!0)+"</pre>";throw O}try{var Ie=de.lex(he,ce);if(ce.walkTokens){if(ce.async)return Promise.all(pe.walkTokens(Ie,ce.walkTokens)).then(function(){return le.parse(Ie,ce)}).catch($e);pe.walkTokens(Ie,ce.walkTokens)}return le.parse(Ie,ce)}catch(O){$e(O)}}pe.options=pe.setOptions=function(he){return S(pe.defaults,he),$(pe.defaults),pe},pe.getDefaults=R,pe.defaults=we.defaults,pe.use=function(){for(var he=arguments.length,ce=new Array(he),ye=0;ye<he;ye++)ce[ye]=arguments[ye];var _=S.apply(void 0,[{}].concat(ce)),fe=pe.defaults.extensions||{renderers:{},childTokens:{}},te;ce.forEach(function(ae){if(ae.extensions&&(te=!0,ae.extensions.forEach(function(Ie){if(!Ie.name)throw new Error("extension name required");if(Ie.renderer){var O=fe.renderers?fe.renderers[Ie.name]:null;O?fe.renderers[Ie.name]=function(){for(var W=arguments.length,H=new Array(W),J=0;J<W;J++)H[J]=arguments[J];var q=Ie.renderer.apply(this,H);return q===!1&&(q=O.apply(this,H)),q}:fe.renderers[Ie.name]=Ie.renderer}if(Ie.tokenizer){if(!Ie.level||Ie.level!=="block"&&Ie.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");fe[Ie.level]?fe[Ie.level].unshift(Ie.tokenizer):fe[Ie.level]=[Ie.tokenizer],Ie.start&&(Ie.level==="block"?fe.startBlock?fe.startBlock.push(Ie.start):fe.startBlock=[Ie.start]:Ie.level==="inline"&&(fe.startInline?fe.startInline.push(Ie.start):fe.startInline=[Ie.start]))}Ie.childTokens&&(fe.childTokens[Ie.name]=Ie.childTokens)})),ae.renderer&&function(){var Ie=pe.defaults.renderer||new me,O=function(J){var q=Ie[J];Ie[J]=function(){for(var x=arguments.length,ue=new Array(x),Ne=0;Ne<x;Ne++)ue[Ne]=arguments[Ne];var Be=ae.renderer[J].apply(Ie,ue);return Be===!1&&(Be=q.apply(Ie,ue)),Be}};for(var W in ae.renderer)O(W);_.renderer=Ie}(),ae.tokenizer&&function(){var Ie=pe.defaults.tokenizer||new U,O=function(J){var q=Ie[J];Ie[J]=function(){for(var x=arguments.length,ue=new Array(x),Ne=0;Ne<x;Ne++)ue[Ne]=arguments[Ne];var Be=ae.tokenizer[J].apply(Ie,ue);return Be===!1&&(Be=q.apply(Ie,ue)),Be}};for(var W in ae.tokenizer)O(W);_.tokenizer=Ie}(),ae.walkTokens){var $e=pe.defaults.walkTokens;_.walkTokens=function(Ie){var O=[];return O.push(ae.walkTokens.call(this,Ie)),$e&&(O=O.concat($e.call(this,Ie))),O}}te&&(_.extensions=fe),pe.setOptions(_)})},pe.walkTokens=function(he,ce){for(var ye=[],_=function(){var $e=te.value;switch(ye=ye.concat(ce.call(pe,$e)),$e.type){case"table":{for(var Ie=M($e.header),O;!(O=Ie()).done;){var W=O.value;ye=ye.concat(pe.walkTokens(W.tokens,ce))}for(var H=M($e.rows),J;!(J=H()).done;)for(var q=J.value,x=M(q),ue;!(ue=x()).done;){var Ne=ue.value;ye=ye.concat(pe.walkTokens(Ne.tokens,ce))}break}case"list":{ye=ye.concat(pe.walkTokens($e.items,ce));break}default:pe.defaults.extensions&&pe.defaults.extensions.childTokens&&pe.defaults.extensions.childTokens[$e.type]?pe.defaults.extensions.childTokens[$e.type].forEach(function(Be){ye=ye.concat(pe.walkTokens($e[Be],ce))}):$e.tokens&&(ye=ye.concat(pe.walkTokens($e.tokens,ce)))}},fe=M(he),te;!(te=fe()).done;)_();return ye},pe.parseInline=function(he,ce){if(typeof he>"u"||he===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof he!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(he)+", string expected");ce=S({},pe.defaults,ce||{}),I(ce);try{var ye=de.lexInline(he,ce);return ce.walkTokens&&pe.walkTokens(ye,ce.walkTokens),le.parseInline(ye,ce)}catch(_){if(_.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+v(_.message+"",!0)+"</pre>";throw _}},pe.Parser=le,pe.parser=le.parse,pe.Renderer=me,pe.TextRenderer=De,pe.Lexer=de,pe.lexer=de.lex,pe.Tokenizer=U,pe.Slugger=ke,pe.parse=pe;var re=pe.options,Pe=pe.setOptions,se=pe.use,Z=pe.walkTokens,j=pe.parseInline,ie=pe,ve=le.parse,ne=de.lex;we.Lexer=de,we.Parser=le,we.Renderer=me,we.Slugger=ke,we.TextRenderer=De,we.Tokenizer=U,we.getDefaults=R,we.lexer=ne,we.marked=pe,we.options=re,we.parse=ie,we.parseInline=j,we.parser=ve,we.setOptions=Pe,we.use=se,we.walkTokens=Z,Object.defineProperty(we,"__esModule",{value:!0})}),define(Ae[121],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yl=e.$Xl=e.$Wl=e.rot=e.$Ul=void 0;function y($,E,f){return Math.min(Math.max($,E),f)}e.$Ul=y;function F($,E){return(E+$%E)%E}e.rot=F;class A{constructor(){this.a=0}getNext(){return this.a++}}e.$Wl=A;class M{constructor(){this.a=1,this.b=0}update(E){return this.b=this.b+(E-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Xl=M;class R{constructor(E){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(E),this.c.fill(0,0,E)}update(E){const f=this.c[this.d];return this.c[this.d]=E,this.d=(this.d+1)%this.c.length,this.e-=f,this.e+=E,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Yl=R}),function(){function we(A){const M=[];typeof A=="number"&&M.push("code/timeOrigin",A);function R(E){M.push(E,Date.now())}function $(){const E=[];for(let f=0;f<M.length;f+=2)E.push({name:M[f],startTime:M[f+1]});return E}return{mark:R,getMarks:$}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?we():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const R of performance.getEntriesByType("mark"))M.push({name:R.name,startTime:Math.round(A+R.startTime)});return M}};if(typeof process=="object"){const A=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return we(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),we()}function y(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=y(F))}(),function(we,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var y=e();for(var F in y)(typeof exports=="object"?exports:we)[F]=y[F]}}(typeof self<"u"?self:this,function(){return function(we){var e={};function y(F){if(e[F])return e[F].exports;var A=e[F]={i:F,l:!1,exports:{}};return we[F].call(A.exports,A,A.exports,y),A.l=!0,A.exports}return y.m=we,y.c=e,y.d=function(F,A,M){y.o(F,A)||Object.defineProperty(F,A,{enumerable:!0,get:M})},y.r=function(F){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(F,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(F,"__esModule",{value:!0})},y.t=function(F,A){if(1&A&&(F=y(F)),8&A||4&A&&typeof F=="object"&&F&&F.__esModule)return F;var M=Object.create(null);if(y.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:F}),2&A&&typeof F!="string")for(var R in F)y.d(M,R,function($){return F[$]}.bind(null,R));return M},y.n=function(F){var A=F&&F.__esModule?function(){return F.default}:function(){return F};return y.d(A,"a",A),A},y.o=function(F,A){return Object.prototype.hasOwnProperty.call(F,A)},y.p="",y(y.s=0)}([function(we,e,y){(function(F){var A;e=we.exports=se,A=typeof F=="object"&&F.env&&F.env.NODE_DEBUG&&/\bsemver\b/i.test(F.env.NODE_DEBUG)?function(){var q=Array.prototype.slice.call(arguments,0);q.unshift("SEMVER"),console.log.apply(console,q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,$=e.re=[],E=e.src=[],f=0,P=f++;E[P]="0|[1-9]\\d*";var D=f++;E[D]="[0-9]+";var u=f++;E[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=f++;E[b]="("+E[P]+")\\.("+E[P]+")\\.("+E[P]+")";var v=f++;E[v]="("+E[D]+")\\.("+E[D]+")\\.("+E[D]+")";var g=f++;E[g]="(?:"+E[P]+"|"+E[u]+")";var t=f++;E[t]="(?:"+E[D]+"|"+E[u]+")";var i=f++;E[i]="(?:-("+E[g]+"(?:\\."+E[g]+")*))";var r=f++;E[r]="(?:-?("+E[t]+"(?:\\."+E[t]+")*))";var c=f++;E[c]="[0-9A-Za-z-]+";var o=f++;E[o]="(?:\\+("+E[c]+"(?:\\."+E[c]+")*))";var l=f++,n="v?"+E[b]+E[i]+"?"+E[o]+"?";E[l]="^"+n+"$";var s="[v=\\s]*"+E[v]+E[r]+"?"+E[o]+"?",a=f++;E[a]="^"+s+"$";var d=f++;E[d]="((?:<|>)?=?)";var p=f++;E[p]=E[D]+"|x|X|\\*";var m=f++;E[m]=E[P]+"|x|X|\\*";var S=f++;E[S]="[v=\\s]*("+E[m]+")(?:\\.("+E[m]+")(?:\\.("+E[m]+")(?:"+E[i]+")?"+E[o]+"?)?)?";var k=f++;E[k]="[v=\\s]*("+E[p]+")(?:\\.("+E[p]+")(?:\\.("+E[p]+")(?:"+E[r]+")?"+E[o]+"?)?)?";var h=f++;E[h]="^"+E[d]+"\\s*"+E[S]+"$";var w=f++;E[w]="^"+E[d]+"\\s*"+E[k]+"$";var I=f++;E[I]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var L=f++;E[L]="(?:~>?)";var V=f++;E[V]="(\\s*)"+E[L]+"\\s+",$[V]=new RegExp(E[V],"g");var Y=f++;E[Y]="^"+E[L]+E[S]+"$";var U=f++;E[U]="^"+E[L]+E[k]+"$";var N=f++;E[N]="(?:\\^)";var C=f++;E[C]="(\\s*)"+E[N]+"\\s+",$[C]=new RegExp(E[C],"g");var T=f++;E[T]="^"+E[N]+E[S]+"$";var G=f++;E[G]="^"+E[N]+E[k]+"$";var de=f++;E[de]="^"+E[d]+"\\s*("+s+")$|^$";var me=f++;E[me]="^"+E[d]+"\\s*("+n+")$|^$";var De=f++;E[De]="(\\s*)"+E[d]+"\\s*("+s+"|"+E[S]+")",$[De]=new RegExp(E[De],"g");var ke=f++;E[ke]="^\\s*("+E[S]+")\\s+-\\s+("+E[S]+")\\s*$";var le=f++;E[le]="^\\s*("+E[k]+")\\s+-\\s+("+E[k]+")\\s*$";var pe=f++;E[pe]="(<|>)?=?\\s*\\*";for(var re=0;re<35;re++)A(re,E[re]),$[re]||($[re]=new RegExp(E[re]));function Pe(q,x){if(q instanceof se)return q;if(typeof q!="string"||q.length>M||!(x?$[a]:$[l]).test(q))return null;try{return new se(q,x)}catch{return null}}function se(q,x){if(q instanceof se){if(q.loose===x)return q;q=q.version}else if(typeof q!="string")throw new TypeError("Invalid Version: "+q);if(q.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof se))return new se(q,x);A("SemVer",q,x),this.loose=x;var ue=q.trim().match(x?$[a]:$[l]);if(!ue)throw new TypeError("Invalid Version: "+q);if(this.raw=q,this.major=+ue[1],this.minor=+ue[2],this.patch=+ue[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");ue[4]?this.prerelease=ue[4].split(".").map(function(Ne){if(/^[0-9]+$/.test(Ne)){var Be=+Ne;if(Be>=0&&Be<R)return Be}return Ne}):this.prerelease=[],this.build=ue[5]?ue[5].split("."):[],this.format()}e.parse=Pe,e.valid=function(q,x){var ue=Pe(q,x);return ue?ue.version:null},e.clean=function(q,x){var ue=Pe(q.trim().replace(/^[=v]+/,""),x);return ue?ue.version:null},e.SemVer=se,se.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},se.prototype.toString=function(){return this.version},se.prototype.compare=function(q){return A("SemVer.compare",this.version,this.loose,q),q instanceof se||(q=new se(q,this.loose)),this.compareMain(q)||this.comparePre(q)},se.prototype.compareMain=function(q){return q instanceof se||(q=new se(q,this.loose)),j(this.major,q.major)||j(this.minor,q.minor)||j(this.patch,q.patch)},se.prototype.comparePre=function(q){if(q instanceof se||(q=new se(q,this.loose)),this.prerelease.length&&!q.prerelease.length)return-1;if(!this.prerelease.length&&q.prerelease.length)return 1;if(!this.prerelease.length&&!q.prerelease.length)return 0;var x=0;do{var ue=this.prerelease[x],Ne=q.prerelease[x];if(A("prerelease compare",x,ue,Ne),ue===void 0&&Ne===void 0)return 0;if(Ne===void 0)return 1;if(ue===void 0)return-1;if(ue!==Ne)return j(ue,Ne)}while(++x)},se.prototype.inc=function(q,x){switch(q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",x);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",x);break;case"prepatch":this.prerelease.length=0,this.inc("patch",x),this.inc("pre",x);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",x),this.inc("pre",x);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ue=this.prerelease.length;--ue>=0;)typeof this.prerelease[ue]=="number"&&(this.prerelease[ue]++,ue=-2);ue===-1&&this.prerelease.push(0)}x&&(this.prerelease[0]===x?isNaN(this.prerelease[1])&&(this.prerelease=[x,0]):this.prerelease=[x,0]);break;default:throw new Error("invalid increment argument: "+q)}return this.format(),this.raw=this.version,this},e.inc=function(q,x,ue,Ne){typeof ue=="string"&&(Ne=ue,ue=void 0);try{return new se(q,ue).inc(x,Ne).version}catch{return null}},e.diff=function(q,x){if(he(q,x))return null;var ue=Pe(q),Ne=Pe(x);if(ue.prerelease.length||Ne.prerelease.length){for(var Be in ue)if((Be==="major"||Be==="minor"||Be==="patch")&&ue[Be]!==Ne[Be])return"pre"+Be;return"prerelease"}for(var Be in ue)if((Be==="major"||Be==="minor"||Be==="patch")&&ue[Be]!==Ne[Be])return Be},e.compareIdentifiers=j;var Z=/^[0-9]+$/;function j(q,x){var ue=Z.test(q),Ne=Z.test(x);return ue&&Ne&&(q=+q,x=+x),ue&&!Ne?-1:Ne&&!ue?1:q<x?-1:q>x?1:0}function ie(q,x,ue){return new se(q,ue).compare(new se(x,ue))}function ve(q,x,ue){return ie(q,x,ue)>0}function ne(q,x,ue){return ie(q,x,ue)<0}function he(q,x,ue){return ie(q,x,ue)===0}function ce(q,x,ue){return ie(q,x,ue)!==0}function ye(q,x,ue){return ie(q,x,ue)>=0}function _(q,x,ue){return ie(q,x,ue)<=0}function fe(q,x,ue,Ne){var Be;switch(x){case"===":typeof q=="object"&&(q=q.version),typeof ue=="object"&&(ue=ue.version),Be=q===ue;break;case"!==":typeof q=="object"&&(q=q.version),typeof ue=="object"&&(ue=ue.version),Be=q!==ue;break;case"":case"=":case"==":Be=he(q,ue,Ne);break;case"!=":Be=ce(q,ue,Ne);break;case">":Be=ve(q,ue,Ne);break;case">=":Be=ye(q,ue,Ne);break;case"<":Be=ne(q,ue,Ne);break;case"<=":Be=_(q,ue,Ne);break;default:throw new TypeError("Invalid operator: "+x)}return Be}function te(q,x){if(q instanceof te){if(q.loose===x)return q;q=q.value}if(!(this instanceof te))return new te(q,x);A("comparator",q,x),this.loose=x,this.parse(q),this.semver===ae?this.value="":this.value=this.operator+this.semver.version,A("comp",this)}e.rcompareIdentifiers=function(q,x){return j(x,q)},e.major=function(q,x){return new se(q,x).major},e.minor=function(q,x){return new se(q,x).minor},e.patch=function(q,x){return new se(q,x).patch},e.compare=ie,e.compareLoose=function(q,x){return ie(q,x,!0)},e.rcompare=function(q,x,ue){return ie(x,q,ue)},e.sort=function(q,x){return q.sort(function(ue,Ne){return e.compare(ue,Ne,x)})},e.rsort=function(q,x){return q.sort(function(ue,Ne){return e.rcompare(ue,Ne,x)})},e.gt=ve,e.lt=ne,e.eq=he,e.neq=ce,e.gte=ye,e.lte=_,e.cmp=fe,e.Comparator=te;var ae={};function $e(q,x){if(q instanceof $e)return q.loose===x?q:new $e(q.raw,x);if(q instanceof te)return new $e(q.value,x);if(!(this instanceof $e))return new $e(q,x);if(this.loose=x,this.raw=q,this.set=q.split(/\s*\|\|\s*/).map(function(ue){return this.parseRange(ue.trim())},this).filter(function(ue){return ue.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+q);this.format()}function Ie(q){return!q||q.toLowerCase()==="x"||q==="*"}function O(q,x,ue,Ne,Be,Ye,Je,tt,_e,et,rt,nt,ze){return((x=Ie(ue)?"":Ie(Ne)?">="+ue+".0.0":Ie(Be)?">="+ue+"."+Ne+".0":">="+x)+" "+(tt=Ie(_e)?"":Ie(et)?"<"+(+_e+1)+".0.0":Ie(rt)?"<"+_e+"."+(+et+1)+".0":nt?"<="+_e+"."+et+"."+rt+"-"+nt:"<="+tt)).trim()}function W(q,x){for(var ue=0;ue<q.length;ue++)if(!q[ue].test(x))return!1;if(x.prerelease.length){for(ue=0;ue<q.length;ue++)if(A(q[ue].semver),q[ue].semver!==ae&&q[ue].semver.prerelease.length>0){var Ne=q[ue].semver;if(Ne.major===x.major&&Ne.minor===x.minor&&Ne.patch===x.patch)return!0}return!1}return!0}function H(q,x,ue){try{x=new $e(x,ue)}catch{return!1}return x.test(q)}function J(q,x,ue,Ne){var Be,Ye,Je,tt,_e;switch(q=new se(q,Ne),x=new $e(x,Ne),ue){case">":Be=ve,Ye=_,Je=ne,tt=">",_e=">=";break;case"<":Be=ne,Ye=ye,Je=ve,tt="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(H(q,x,Ne))return!1;for(var et=0;et<x.set.length;++et){var rt=x.set[et],nt=null,ze=null;if(rt.forEach(function(dt){dt.semver===ae&&(dt=new te(">=0.0.0")),nt=nt||dt,ze=ze||dt,Be(dt.semver,nt.semver,Ne)?nt=dt:Je(dt.semver,ze.semver,Ne)&&(ze=dt)}),nt.operator===tt||nt.operator===_e||(!ze.operator||ze.operator===tt)&&Ye(q,ze.semver)||ze.operator===_e&&Je(q,ze.semver))return!1}return!0}te.prototype.parse=function(q){var x=this.loose?$[de]:$[me],ue=q.match(x);if(!ue)throw new TypeError("Invalid comparator: "+q);this.operator=ue[1],this.operator==="="&&(this.operator=""),ue[2]?this.semver=new se(ue[2],this.loose):this.semver=ae},te.prototype.toString=function(){return this.value},te.prototype.test=function(q){return A("Comparator.test",q,this.loose),this.semver===ae||(typeof q=="string"&&(q=new se(q,this.loose)),fe(q,this.operator,this.semver,this.loose))},te.prototype.intersects=function(q,x){if(!(q instanceof te))throw new TypeError("a Comparator is required");var ue;if(this.operator==="")return ue=new $e(q.value,x),H(this.value,ue,x);if(q.operator==="")return ue=new $e(this.value,x),H(q.semver,ue,x);var Ne=!(this.operator!==">="&&this.operator!==">"||q.operator!==">="&&q.operator!==">"),Be=!(this.operator!=="<="&&this.operator!=="<"||q.operator!=="<="&&q.operator!=="<"),Ye=this.semver.version===q.semver.version,Je=!(this.operator!==">="&&this.operator!=="<="||q.operator!==">="&&q.operator!=="<="),tt=fe(this.semver,"<",q.semver,x)&&(this.operator===">="||this.operator===">")&&(q.operator==="<="||q.operator==="<"),_e=fe(this.semver,">",q.semver,x)&&(this.operator==="<="||this.operator==="<")&&(q.operator===">="||q.operator===">");return Ne||Be||Ye&&Je||tt||_e},e.Range=$e,$e.prototype.format=function(){return this.range=this.set.map(function(q){return q.join(" ").trim()}).join("||").trim(),this.range},$e.prototype.toString=function(){return this.range},$e.prototype.parseRange=function(q){var x=this.loose;q=q.trim(),A("range",q,x);var ue=x?$[le]:$[ke];q=q.replace(ue,O),A("hyphen replace",q),q=q.replace($[De],"$1$2$3"),A("comparator trim",q,$[De]),q=(q=(q=q.replace($[V],"$1~")).replace($[C],"$1^")).split(/\s+/).join(" ");var Ne=x?$[de]:$[me],Be=q.split(" ").map(function(Ye){return function(Je,tt){return A("comp",Je),Je=function(_e,et){return _e.trim().split(/\s+/).map(function(rt){return function(nt,ze){A("caret",nt,ze);var dt=ze?$[G]:$[T];return nt.replace(dt,function(X,Q,Ee,je,He){var Xe;return A("caret",nt,X,Q,Ee,je,He),Ie(Q)?Xe="":Ie(Ee)?Xe=">="+Q+".0.0 <"+(+Q+1)+".0.0":Ie(je)?Xe=Q==="0"?">="+Q+"."+Ee+".0 <"+Q+"."+(+Ee+1)+".0":">="+Q+"."+Ee+".0 <"+(+Q+1)+".0.0":He?(A("replaceCaret pr",He),He.charAt(0)!=="-"&&(He="-"+He),Xe=Q==="0"?Ee==="0"?">="+Q+"."+Ee+"."+je+He+" <"+Q+"."+Ee+"."+(+je+1):">="+Q+"."+Ee+"."+je+He+" <"+Q+"."+(+Ee+1)+".0":">="+Q+"."+Ee+"."+je+He+" <"+(+Q+1)+".0.0"):(A("no pr"),Xe=Q==="0"?Ee==="0"?">="+Q+"."+Ee+"."+je+" <"+Q+"."+Ee+"."+(+je+1):">="+Q+"."+Ee+"."+je+" <"+Q+"."+(+Ee+1)+".0":">="+Q+"."+Ee+"."+je+" <"+(+Q+1)+".0.0"),A("caret return",Xe),Xe})}(rt,et)}).join(" ")}(Je,tt),A("caret",Je),Je=function(_e,et){return _e.trim().split(/\s+/).map(function(rt){return function(nt,ze){var dt=ze?$[U]:$[Y];return nt.replace(dt,function(X,Q,Ee,je,He){var Xe;return A("tilde",nt,X,Q,Ee,je,He),Ie(Q)?Xe="":Ie(Ee)?Xe=">="+Q+".0.0 <"+(+Q+1)+".0.0":Ie(je)?Xe=">="+Q+"."+Ee+".0 <"+Q+"."+(+Ee+1)+".0":He?(A("replaceTilde pr",He),He.charAt(0)!=="-"&&(He="-"+He),Xe=">="+Q+"."+Ee+"."+je+He+" <"+Q+"."+(+Ee+1)+".0"):Xe=">="+Q+"."+Ee+"."+je+" <"+Q+"."+(+Ee+1)+".0",A("tilde return",Xe),Xe})}(rt,et)}).join(" ")}(Je,tt),A("tildes",Je),Je=function(_e,et){return A("replaceXRanges",_e,et),_e.split(/\s+/).map(function(rt){return function(nt,ze){nt=nt.trim();var dt=ze?$[w]:$[h];return nt.replace(dt,function(X,Q,Ee,je,He,Xe){A("xRange",nt,X,Q,Ee,je,He,Xe);var st=Ie(Ee),vt=st||Ie(je),Dt=vt||Ie(He);return Q==="="&&Dt&&(Q=""),st?X=Q===">"||Q==="<"?"<0.0.0":"*":Q&&Dt?(vt&&(je=0),Dt&&(He=0),Q===">"?(Q=">=",vt?(Ee=+Ee+1,je=0,He=0):Dt&&(je=+je+1,He=0)):Q==="<="&&(Q="<",vt?Ee=+Ee+1:je=+je+1),X=Q+Ee+"."+je+"."+He):vt?X=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Dt&&(X=">="+Ee+"."+je+".0 <"+Ee+"."+(+je+1)+".0"),A("xRange return",X),X})}(rt,et)}).join(" ")}(Je,tt),A("xrange",Je),Je=function(_e,et){return A("replaceStars",_e,et),_e.trim().replace($[pe],"")}(Je,tt),A("stars",Je),Je}(Ye,x)}).join(" ").split(/\s+/);return this.loose&&(Be=Be.filter(function(Ye){return!!Ye.match(Ne)})),Be=Be.map(function(Ye){return new te(Ye,x)})},$e.prototype.intersects=function(q,x){if(!(q instanceof $e))throw new TypeError("a Range is required");return this.set.some(function(ue){return ue.every(function(Ne){return q.set.some(function(Be){return Be.every(function(Ye){return Ne.intersects(Ye,x)})})})})},e.toComparators=function(q,x){return new $e(q,x).set.map(function(ue){return ue.map(function(Ne){return Ne.value}).join(" ").trim().split(" ")})},$e.prototype.test=function(q){if(!q)return!1;typeof q=="string"&&(q=new se(q,this.loose));for(var x=0;x<this.set.length;x++)if(W(this.set[x],q))return!0;return!1},e.satisfies=H,e.maxSatisfying=function(q,x,ue){var Ne=null,Be=null;try{var Ye=new $e(x,ue)}catch{return null}return q.forEach(function(Je){Ye.test(Je)&&(Ne&&Be.compare(Je)!==-1||(Be=new se(Ne=Je,ue)))}),Ne},e.minSatisfying=function(q,x,ue){var Ne=null,Be=null;try{var Ye=new $e(x,ue)}catch{return null}return q.forEach(function(Je){Ye.test(Je)&&(Ne&&Be.compare(Je)!==1||(Be=new se(Ne=Je,ue)))}),Ne},e.validRange=function(q,x){try{return new $e(q,x).range||"*"}catch{return null}},e.ltr=function(q,x,ue){return J(q,x,"<",ue)},e.gtr=function(q,x,ue){return J(q,x,">",ue)},e.outside=J,e.prerelease=function(q,x){var ue=Pe(q,x);return ue&&ue.prerelease.length?ue.prerelease:null},e.intersects=function(q,x,ue){return q=new $e(q,ue),x=new $e(x,ue),q.intersects(x)},e.coerce=function(q){if(q instanceof se)return q;if(typeof q!="string")return null;var x=q.match($[I]);return x==null?null:Pe((x[1]||"0")+"."+(x[2]||"0")+"."+(x[3]||"0"))}}).call(this,y(1))},function(we,e){var y,F,A=we.exports={};function M(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function $(t){if(y===setTimeout)return setTimeout(t,0);if((y===M||!y)&&setTimeout)return y=setTimeout,setTimeout(t,0);try{return y(t,0)}catch{try{return y.call(null,t,0)}catch{return y.call(this,t,0)}}}(function(){try{y=typeof setTimeout=="function"?setTimeout:M}catch{y=M}try{F=typeof clearTimeout=="function"?clearTimeout:R}catch{F=R}})();var E,f=[],P=!1,D=-1;function u(){P&&E&&(P=!1,E.length?f=E.concat(f):D=-1,f.length&&b())}function b(){if(!P){var t=$(u);P=!0;for(var i=f.length;i;){for(E=f,f=[];++D<i;)E&&E[D].run();D=-1,i=f.length}E=null,P=!1,function(r){if(F===clearTimeout)return clearTimeout(r);if((F===R||!F)&&clearTimeout)return F=clearTimeout,clearTimeout(r);try{F(r)}catch{try{return F.call(null,r)}catch{return F.call(this,r)}}}(t)}}function v(t,i){this.fun=t,this.array=i}function g(){}A.nextTick=function(t){var i=new Array(arguments.length-1);if(arguments.length>1)for(var r=1;r<arguments.length;r++)i[r-1]=arguments[r];f.push(new v(t,i)),f.length!==1||P||$(b)},v.prototype.run=function(){this.fun.apply(null,this.array)},A.title="browser",A.browser=!0,A.env={},A.argv=[],A.version="",A.versions={},A.on=g,A.addListener=g,A.once=g,A.off=g,A.removeListener=g,A.removeAllListeners=g,A.emit=g,A.prependListener=g,A.prependOnceListener=g,A.listeners=function(t){return[]},A.binding=function(t){throw new Error("process.binding is not supported")},A.cwd=function(){return"/"},A.chdir=function(t){throw new Error("process.chdir is not supported")},A.umask=function(){return 0}}])}),define(Ae[122],Re([1,0,11,6]),function(we,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=void 0;function A(o){const l=o;return l?typeof l.read=="function":!1}e.$3d=A;function M(o){const l=o;return l?[l.on,l.pause,l.resume,l.destroy].every(n=>typeof n=="function"):!1}e.$4d=M;function R(o){const l=o;return l?M(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.$5d=R;function $(o,l){return new E(o,l)}e.$6d=$;class E{constructor(l,n){this.e=l,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(l){if(!this.a.destroyed){if(this.a.flowing)this.g(l);else if(this.b.data.push(l),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(l){this.a.destroyed||(this.a.flowing?this.h(l):this.b.error.push(l))}end(l){this.a.destroyed||(typeof l<"u"&&this.write(l),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(l){this.c.data.slice(0).forEach(n=>n(l))}h(l){this.c.error.length===0?(0,y.$Z)(l):this.c.error.slice(0).forEach(n=>n(l))}i(){this.c.end.slice(0).forEach(l=>l())}on(l,n){if(!this.a.destroyed)switch(l){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(l,n){if(this.a.destroyed)return;let s;switch(l){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const a=s.indexOf(n);a>=0&&s.splice(a,1)}}j(){if(this.b.data.length>0){const l=this.e(this.b.data);this.g(l),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const l of this.b.error)this.h(l);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function f(o,l){const n=[];let s;for(;(s=o.read())!==null;)n.push(s);return l(n)}e.$7d=f;function P(o,l,n){const s=[];let a;for(;(a=o.read())!==null&&s.length<n;)s.push(a);return a===null&&s.length>0?l(s):{read:()=>{if(s.length>0)return s.shift();if(typeof a<"u"){const d=a;return a=void 0,d}return o.read()}}}e.$8d=P;function D(o,l){return new Promise((n,s)=>{const a=[];u(o,{onData:d=>{l&&a.push(d)},onError:d=>{l?s(d):n(void 0)},onEnd:()=>{n(l?l(a):void 0)}})})}e.$9d=D;function u(o,l,n){o.on("error",s=>{n?.isCancellationRequested||l.onError(s)}),o.on("end",()=>{n?.isCancellationRequested||l.onEnd()}),o.on("data",s=>{n?.isCancellationRequested||l.onData(s)})}e.$0d=u;function b(o,l){return new Promise((n,s)=>{const a=new F.$Qc,d=[],p=k=>{if(d.push(k),d.length>l)return a.dispose(),o.pause(),n({stream:o,buffer:d,ended:!1})},m=k=>(a.dispose(),s(k)),S=()=>(a.dispose(),n({stream:o,buffer:d,ended:!0}));a.add((0,F.$Pc)(()=>o.removeListener("error",m))),o.on("error",m),a.add((0,F.$Pc)(()=>o.removeListener("end",S))),o.on("end",S),a.add((0,F.$Pc)(()=>o.removeListener("data",p))),o.on("data",p)})}e.$$d=b;function v(o,l){const n=$(l);return n.end(o),n}e.$_d=v;function g(){const o=$(()=>{throw new Error("not supported")});return o.end(),o}e.$ae=g;function t(o){let l=!1;return{read:()=>l?null:(l=!0,o)}}e.$be=t;function i(o,l,n){const s=$(n);return u(o,{onData:a=>s.write(l.data(a)),onError:a=>s.error(l.error?l.error(a):a),onEnd:()=>s.end()}),s}e.$ce=i;function r(o,l,n){let s=!1;return{read:()=>{const a=l.read();return s?a:(s=!0,a!==null?n([o,a]):o)}}}e.$de=r;function c(o,l,n){let s=!1;const a=$(n);return u(l,{onData:d=>s?a.write(d):(s=!0,a.write(n([o,d]))),onError:d=>a.error(d),onEnd:()=>{s||(s=!0,a.write(o)),a.end()}}),a}e.$ee=c}),define(Ae[24],Re([1,0,44,122]),function(we,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=void 0;const A=typeof Buffer<"u",M=new y.$U(()=>new Uint8Array(256));let R,$;class E{static alloc(I){return A?new E(Buffer.allocUnsafe(I)):new E(new Uint8Array(I))}static wrap(I){return A&&!Buffer.isBuffer(I)&&(I=Buffer.from(I.buffer,I.byteOffset,I.byteLength)),new E(I)}static fromString(I,L){return!(L?.dontUseNodeBuffer||!1)&&A?new E(Buffer.from(I)):(R||(R=new TextEncoder),new E(R.encode(I)))}static fromByteArray(I){const L=E.alloc(I.length);for(let V=0,Y=I.length;V<Y;V++)L.buffer[V]=I[V];return L}static concat(I,L){if(typeof L>"u"){L=0;for(let U=0,N=I.length;U<N;U++)L+=I[U].byteLength}const V=E.alloc(L);let Y=0;for(let U=0,N=I.length;U<N;U++){const C=I[U];V.set(C,Y),Y+=C.byteLength}return V}constructor(I){this.buffer=I,this.byteLength=this.buffer.byteLength}clone(){const I=E.alloc(this.byteLength);return I.set(this),I}toString(){return A?this.buffer.toString():($||($=new TextDecoder),$.decode(this.buffer))}slice(I,L){return new E(this.buffer.subarray(I,L))}set(I,L){if(I instanceof E)this.buffer.set(I.buffer,L);else if(I instanceof Uint8Array)this.buffer.set(I,L);else if(I instanceof ArrayBuffer)this.buffer.set(new Uint8Array(I),L);else if(ArrayBuffer.isView(I))this.buffer.set(new Uint8Array(I.buffer,I.byteOffset,I.byteLength),L);else throw new Error("Unknown argument 'array'")}readUInt32BE(I){return u(this.buffer,I)}writeUInt32BE(I,L){b(this.buffer,I,L)}readUInt32LE(I){return v(this.buffer,I)}writeUInt32LE(I,L){g(this.buffer,I,L)}readUInt8(I){return t(this.buffer,I)}writeUInt8(I,L){i(this.buffer,I,L)}indexOf(I,L=0){return f(this.buffer,I instanceof E?I.buffer:I,L)}}e.$fe=E;function f(w,I,L=0){const V=I.byteLength,Y=w.byteLength;if(V===0)return 0;if(V===1)return w.indexOf(I[0]);if(V>Y-L)return-1;const U=M.value;U.fill(I.length);for(let G=0;G<I.length;G++)U[I[G]]=I.length-G-1;let N=L+I.length-1,C=N,T=-1;for(;N<Y;)if(w[N]===I[C]){if(C===0){T=N;break}N--,C--}else N+=Math.max(I.length-C,U[w[N]]),C=I.length-1;return T}e.$ge=f;function P(w,I){return w[I+0]<<0>>>0|w[I+1]<<8>>>0}e.$he=P;function D(w,I,L){w[L+0]=I&255,I=I>>>8,w[L+1]=I&255}e.$ie=D;function u(w,I){return w[I]*2**24+w[I+1]*2**16+w[I+2]*2**8+w[I+3]}e.$je=u;function b(w,I,L){w[L+3]=I,I=I>>>8,w[L+2]=I,I=I>>>8,w[L+1]=I,I=I>>>8,w[L]=I}e.$ke=b;function v(w,I){return w[I+0]<<0>>>0|w[I+1]<<8>>>0|w[I+2]<<16>>>0|w[I+3]<<24>>>0}e.$le=v;function g(w,I,L){w[L+0]=I&255,I=I>>>8,w[L+1]=I&255,I=I>>>8,w[L+2]=I&255,I=I>>>8,w[L+3]=I&255}e.$me=g;function t(w,I){return w[I]}e.$ne=t;function i(w,I,L){w[L]=I}e.$oe=i;function r(w){return F.$7d(w,I=>E.concat(I))}e.$pe=r;function c(w){return F.$be(w)}e.$qe=c;function o(w){return F.$9d(w,I=>E.concat(I))}e.$re=o;async function l(w){return w.ended?E.concat(w.buffer):E.concat([...w.buffer,await o(w.stream)])}e.$se=l;function n(w){return F.$_d(w,I=>E.concat(I))}e.$te=n;function s(w){return F.$ce(w,{data:I=>typeof I=="string"?E.fromString(I):E.wrap(I)},I=>E.concat(I))}e.$ue=s;function a(w){return F.$6d(I=>E.concat(I),w)}e.$ve=a;function d(w,I){return F.$de(w,I,L=>E.concat(L))}e.$we=d;function p(w,I){return F.$ee(w,I,L=>E.concat(L))}e.$xe=p;function m(w){let I=0,L=0,V=0;const Y=new Uint8Array(Math.floor(w.length/4*3)),U=C=>{switch(L){case 3:Y[V++]=I|C,L=0;break;case 2:Y[V++]=I|C>>>2,I=C<<6,L=3;break;case 1:Y[V++]=I|C>>>4,I=C<<4,L=2;break;default:I=C<<2,L=1}};for(let C=0;C<w.length;C++){const T=w.charCodeAt(C);if(T>=65&&T<=90)U(T-65);else if(T>=97&&T<=122)U(T-97+26);else if(T>=48&&T<=57)U(T-48+52);else if(T===43||T===45)U(62);else if(T===47||T===95)U(63);else{if(T===61)break;throw new SyntaxError(`Unexpected base64 character ${w[C]}`)}}const N=V;for(;L>0;)U(0);return E.wrap(Y).slice(0,N)}e.$ye=m;const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function h({buffer:w},I=!0,L=!1){const V=L?k:S;let Y="";const U=w.byteLength%3;let N=0;for(;N<w.byteLength-U;N+=3){const C=w[N+0],T=w[N+1],G=w[N+2];Y+=V[C>>>2],Y+=V[(C<<4|T>>>4)&63],Y+=V[(T<<2|G>>>6)&63],Y+=V[G&63]}if(U===1){const C=w[N+0];Y+=V[C>>>2],Y+=V[C<<4&63],I&&(Y+="==")}else if(U===2){const C=w[N+0],T=w[N+1];Y+=V[C>>>2],Y+=V[(C<<4|T>>>4)&63],Y+=V[T<<2&63],I&&(Y+="=")}return Y}e.$ze=h}),define(Ae[123],Re([1,0,28,12]),function(we,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.FuzzyScore=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.or=void 0;function A(...te){return function(ae,$e){for(let Ie=0,O=te.length;Ie<O;Ie++){const W=te[Ie](ae,$e);if(W)return W}return null}}e.or=A,e.$Ij=M.bind(void 0,!1),e.$Jj=M.bind(void 0,!0);function M(te,ae,$e){if(!$e||$e.length<ae.length)return null;let Ie;return te?Ie=F.$7e($e,ae):Ie=$e.indexOf(ae)===0,Ie?ae.length>0?[{start:0,end:ae.length}]:[]:null}function R(te,ae){const $e=ae.toLowerCase().indexOf(te.toLowerCase());return $e===-1?null:[{start:$e,end:$e+te.length}]}e.$Kj=R;function $(te,ae){return E(te.toLowerCase(),ae.toLowerCase(),0,0)}e.$Lj=$;function E(te,ae,$e,Ie){if($e===te.length)return[];if(Ie===ae.length)return null;if(te[$e]===ae[Ie]){let O=null;return(O=E(te,ae,$e+1,Ie+1))?i({start:Ie,end:Ie+1},O):null}return E(te,ae,$e,Ie+1)}function f(te){return 97<=te&&te<=122}function P(te){return 65<=te&&te<=90}e.$Mj=P;function D(te){return 48<=te&&te<=57}function u(te){return te===32||te===9||te===10||te===13}const b=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(te=>b.add(te.charCodeAt(0)));function v(te){return u(te)||b.has(te)}function g(te,ae){return te===ae||v(te)&&v(ae)}function t(te){return f(te)||P(te)||D(te)}function i(te,ae){return ae.length===0?ae=[te]:te.end===ae[0].start?ae[0].start=te.start:ae.unshift(te),ae}function r(te,ae){for(let $e=ae;$e<te.length;$e++){const Ie=te.charCodeAt($e);if(P(Ie)||D(Ie)||$e>0&&!t(te.charCodeAt($e-1)))return $e}return te.length}function c(te,ae,$e,Ie){if($e===te.length)return[];if(Ie===ae.length)return null;if(te[$e]!==ae[Ie].toLowerCase())return null;{let O=null,W=Ie+1;for(O=c(te,ae,$e+1,Ie+1);!O&&(W=r(ae,W))<ae.length;)O=c(te,ae,$e+1,W),W++;return O===null?null:i({start:Ie,end:Ie+1},O)}}function o(te){let ae=0,$e=0,Ie=0,O=0,W=0;for(let ue=0;ue<te.length;ue++)W=te.charCodeAt(ue),P(W)&&ae++,f(W)&&$e++,t(W)&&Ie++,D(W)&&O++;const H=ae/te.length,J=$e/te.length,q=Ie/te.length,x=O/te.length;return{upperPercent:H,lowerPercent:J,alphaPercent:q,numericPercent:x}}function l(te){const{upperPercent:ae,lowerPercent:$e}=te;return $e===0&&ae>.6}function n(te){const{upperPercent:ae,lowerPercent:$e,alphaPercent:Ie,numericPercent:O}=te;return $e>.2&&ae<.8&&Ie>.6&&O<.2}function s(te){let ae=0,$e=0,Ie=0,O=0;for(let W=0;W<te.length;W++)Ie=te.charCodeAt(W),P(Ie)&&ae++,f(Ie)&&$e++,u(Ie)&&O++;return(ae===0||$e===0)&&O===0?te.length<=30:ae<=5}function a(te,ae){if(!ae||(ae=ae.trim(),ae.length===0)||!s(te)||ae.length>60)return null;const $e=o(ae);if(!n($e)){if(!l($e))return null;ae=ae.toLowerCase()}let Ie=null,O=0;for(te=te.toLowerCase();O<ae.length&&(Ie=c(te,ae,0,O))===null;)O=r(ae,O+1);return Ie}e.$Nj=a;function d(te,ae,$e=!1){if(!ae||ae.length===0)return null;let Ie=null,O=0;for(te=te.toLowerCase(),ae=ae.toLowerCase();O<ae.length&&(Ie=p(te,ae,0,O,$e))===null;)O=m(ae,O+1);return Ie}e.$Oj=d;function p(te,ae,$e,Ie,O){if($e===te.length)return[];if(Ie===ae.length)return null;if(g(te.charCodeAt($e),ae.charCodeAt(Ie))){let W=null,H=Ie+1;if(W=p(te,ae,$e+1,Ie+1,O),!O)for(;!W&&(H=m(ae,H))<ae.length;)W=p(te,ae,$e+1,H,O),H++;return W?te.charCodeAt($e)!==ae.charCodeAt(Ie)?W:i({start:Ie,end:Ie+1},W):null}else return null}function m(te,ae){for(let $e=ae;$e<te.length;$e++)if(v(te.charCodeAt($e))||$e>0&&v(te.charCodeAt($e-1)))return $e;return te.length}const S=A(e.$Jj,a,R),k=A(e.$Jj,a,$),h=new y.$Cc(1e4);function w(te,ae,$e=!1){if(typeof te!="string"||typeof ae!="string")return null;let Ie=h.get(te);Ie||(Ie=new RegExp(F.$Pe(te),"i"),h.set(te,Ie));const O=Ie.exec(ae);return O?[{start:O.index,end:O.index+O[0].length}]:$e?k(te,ae):S(te,ae)}e.$Pj=w;function I(te,ae){const $e=ve(te,te.toLowerCase(),0,ae,ae.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return $e?V($e):null}e.$Qj=I;function L(te,ae,$e,Ie,O,W){const H=Math.min(13,te.length);for(;$e<H;$e++){const J=ve(te,ae,$e,Ie,O,W,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(J)return J}return[0,W]}e.$Rj=L;function V(te){if(typeof te>"u")return[];const ae=[],$e=te[1];for(let Ie=te.length-1;Ie>1;Ie--){const O=te[Ie]+$e,W=ae[ae.length-1];W&&W.end===O?W.end=O+1:ae.push({start:O,end:O+1})}return ae}e.$Sj=V;const Y=128;function U(){const te=[],ae=[];for(let $e=0;$e<=Y;$e++)ae[$e]=0;for(let $e=0;$e<=Y;$e++)te.push(ae.slice(0));return te}function N(te){const ae=[];for(let $e=0;$e<=te;$e++)ae[$e]=0;return ae}const C=N(2*Y),T=N(2*Y),G=U(),de=U(),me=U(),De=!1;function ke(te,ae,$e,Ie,O){function W(J,q,x=" "){for(;J.length<q;)J=x+J;return J}let H=` |   |${Ie.split("").map(J=>W(J,3)).join("|")}
`;for(let J=0;J<=$e;J++)J===0?H+=" |":H+=`${ae[J-1]}|`,H+=te[J].slice(0,O+1).map(q=>W(q.toString(),3)).join("|")+`
`;return H}function le(te,ae,$e,Ie){te=te.substr(ae),$e=$e.substr(Ie),console.log(ke(de,te,te.length,$e,$e.length)),console.log(ke(me,te,te.length,$e,$e.length)),console.log(ke(G,te,te.length,$e,$e.length))}function pe(te,ae){if(ae<0||ae>=te.length)return!1;const $e=te.codePointAt(ae);switch($e){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!F.$mf($e)}}function re(te,ae){if(ae<0||ae>=te.length)return!1;switch(te.charCodeAt(ae)){case 32:case 9:return!0;default:return!1}}function Pe(te,ae,$e){return ae[te]!==$e[te]}function se(te,ae,$e,Ie,O,W,H=!1){for(;ae<$e&&O<W;)te[ae]===Ie[O]&&(H&&(C[ae]=O),ae+=1),O+=1;return ae===$e}e.$Tj=se;var Z;(function(te){te[te.Diag=1]="Diag",te[te.Left=2]="Left",te[te.LeftLeft=3]="LeftLeft"})(Z||(Z={}));var j;(function(te){te.Default=[-100,0];function ae($e){return!$e||$e.length===2&&$e[0]===-100&&$e[1]===0}te.isDefault=ae})(j||(e.FuzzyScore=j={}));class ie{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(ae,$e){this.firstMatchCanBeWeak=ae,this.boostFullMatch=$e}}e.$Uj=ie;function ve(te,ae,$e,Ie,O,W,H=ie.default){const J=te.length>Y?Y:te.length,q=Ie.length>Y?Y:Ie.length;if($e>=J||W>=q||J-$e>q-W||!se(ae,$e,J,O,W,q,!0))return;ne(J,q,$e,W,ae,O);let x=1,ue=1,Ne=$e,Be=W;const Ye=[!1];for(x=1,Ne=$e;Ne<J;x++,Ne++){const rt=C[Ne],nt=T[Ne],ze=Ne+1<J?T[Ne+1]:q;for(ue=rt-W+1,Be=rt;Be<ze;ue++,Be++){let dt=Number.MIN_SAFE_INTEGER,X=!1;Be<=nt&&(dt=he(te,ae,Ne,$e,Ie,O,Be,q,W,G[x-1][ue-1]===0,Ye));let Q=0;dt!==Number.MAX_SAFE_INTEGER&&(X=!0,Q=dt+de[x-1][ue-1]);const Ee=Be>rt,je=Ee?de[x][ue-1]+(G[x][ue-1]>0?-5:0):0,He=Be>rt+1&&G[x][ue-1]>0,Xe=He?de[x][ue-2]+(G[x][ue-2]>0?-5:0):0;if(He&&(!Ee||Xe>=je)&&(!X||Xe>=Q))de[x][ue]=Xe,me[x][ue]=3,G[x][ue]=0;else if(Ee&&(!X||je>=Q))de[x][ue]=je,me[x][ue]=2,G[x][ue]=0;else if(X)de[x][ue]=Q,me[x][ue]=1,G[x][ue]=G[x-1][ue-1]+1;else throw new Error("not possible")}}if(De&&le(te,$e,Ie,W),!Ye[0]&&!H.firstMatchCanBeWeak)return;x--,ue--;const Je=[de[x][ue],W];let tt=0,_e=0;for(;x>=1;){let rt=ue;do{const nt=me[x][rt];if(nt===3)rt=rt-2;else if(nt===2)rt=rt-1;else break}while(rt>=1);tt>1&&ae[$e+x-1]===O[W+ue-1]&&!Pe(rt+W-1,Ie,O)&&tt+1>G[x][rt]&&(rt=ue),rt===ue?tt++:tt=1,_e||(_e=rt),x--,ue=rt-1,Je.push(ue)}q===J&&H.boostFullMatch&&(Je[0]+=2);const et=_e-J;return Je[0]-=et,Je}e.$Vj=ve;function ne(te,ae,$e,Ie,O,W){let H=te-1,J=ae-1;for(;H>=$e&&J>=Ie;)O[H]===W[J]&&(T[H]=J,H--),J--}function he(te,ae,$e,Ie,O,W,H,J,q,x,ue){if(ae[$e]!==W[H])return Number.MIN_SAFE_INTEGER;let Ne=1,Be=!1;return H===$e-Ie?Ne=te[$e]===O[H]?7:5:Pe(H,O,W)&&(H===0||!Pe(H-1,O,W))?(Ne=te[$e]===O[H]?7:5,Be=!0):pe(W,H)&&(H===0||!pe(W,H-1))?Ne=5:(pe(W,H-1)||re(W,H-1))&&(Ne=5,Be=!0),Ne>1&&$e===Ie&&(ue[0]=!0),Be||(Be=Pe(H,O,W)||pe(W,H-1)||re(W,H-1)),$e===Ie?H>q&&(Ne-=Be?3:5):x?Ne+=Be?2:0:Ne+=Be?0:1,H+1===J&&(Ne-=Be?3:5),Ne}function ce(te,ae,$e,Ie,O,W,H){return _(te,ae,$e,Ie,O,W,!0,H)}e.$Wj=ce;function ye(te,ae,$e,Ie,O,W,H){return _(te,ae,$e,Ie,O,W,!1,H)}e.$Xj=ye;function _(te,ae,$e,Ie,O,W,H,J){let q=ve(te,ae,$e,Ie,O,W,J);if(q&&!H)return q;if(te.length>=3){const x=Math.min(7,te.length-1);for(let ue=$e+1;ue<x;ue++){const Ne=fe(te,ue);if(Ne){const Be=ve(Ne,Ne.toLowerCase(),$e,Ie,O,W,J);Be&&(Be[0]-=3,(!q||Be[0]>q[0])&&(q=Be))}}}return q}function fe(te,ae){if(ae+1>=te.length)return;const $e=te[ae],Ie=te[ae+1];if($e!==Ie)return te.slice(0,ae)+Ie+$e+te.slice(ae+2)}}),define(Ae[31],Re([1,0,12]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(F||(F={})),function(A){const M="error",R="warning",$="warn",E="info",f="ignore";function P(u){return u?y.$6e(M,u)?A.Error:y.$6e(R,u)||y.$6e($,u)?A.Warning:y.$6e(E,u)?A.Info:A.Ignore:A.Ignore}A.fromValue=P;function D(u){switch(u){case A.Error:return M;case A.Warning:return R;case A.Info:return E;default:return f}}A.toString=D}(F||(F={})),e.default=F}),define(Ae[124],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Od=void 0,e.$Od=Symbol("MicrotaskDelay")}),define(Ae[50],Re([1,0,18,12]),function(we,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=void 0;class A{constructor(){this.b="",this.c=0}reset(b){return this.b=b,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(b){const v=b.charCodeAt(0),g=this.b.charCodeAt(this.c);return v-g}value(){return this.b[this.c]}}e.$Xh=A;class M{constructor(b=!0){this.e=b}reset(b){return this.b=b,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let b=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(b)this.c++;else break;else b=!1;return this}cmp(b){return this.e?(0,F.$Ze)(b,this.b,0,b.length,this.c,this.d):(0,F.$2e)(b,this.b,0,b.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Yh=M;class R{constructor(b=!0,v=!0){this.f=b,this.g=v}reset(b){this.d=0,this.e=0,this.b=b,this.c=b.length;for(let v=b.length-1;v>=0;v--,this.c--){const g=this.b.charCodeAt(v);if(!(g===47||this.f&&g===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let b=!0;for(;this.e<this.c;this.e++){const v=this.b.charCodeAt(this.e);if(v===47||this.f&&v===92)if(b)this.d++;else break;else b=!1}return this}cmp(b){return this.g?(0,F.$Ze)(b,this.b,0,b.length,this.d,this.e):(0,F.$2e)(b,this.b,0,b.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Zh=R;var $;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})($||($={}));class E{constructor(b,v){this.f=b,this.g=v,this.d=[],this.e=0}reset(b){return this.c=b,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(b)),this.b.reset(b.path),this.b.value()&&this.d.push(3)),this.g(b)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(b){if(this.d[this.e]===1)return(0,F.$1e)(b,this.c.scheme);if(this.d[this.e]===2)return(0,F.$1e)(b,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(b);if(this.d[this.e]===4)return(0,F.$Ye)(b,this.c.query);if(this.d[this.e]===5)return(0,F.$Ye)(b,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$1h=E;class f{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const b=this.right;return this.right=b.left,b.left=this,this.updateHeight(),b.updateHeight(),b}rotateRight(){const b=this.left;return this.left=b.right,b.right=this,this.updateHeight(),b.updateHeight(),b}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(u){u[u.Left=-1]="Left",u[u.Mid=0]="Mid",u[u.Right=1]="Right"})(P||(P={}));class D{static forUris(b=()=>!1,v=()=>!1){return new D(new E(b,v))}static forPaths(b=!1){return new D(new R(void 0,!b))}static forStrings(){return new D(new A)}static forConfigKeys(){return new D(new M)}constructor(b){this.b=b}clear(){this.c=void 0}fill(b,v){if(v){const g=v.slice(0);(0,y.$Wb)(g);for(const t of g)this.set(t,b)}else{const g=b.slice(0);(0,y.$Wb)(g);for(const t of g)this.set(t[0],t[1])}}set(b,v){const g=this.b.reset(b);let t;this.c||(this.c=new f,this.c.segment=g.value());const i=[];for(t=this.c;;){const c=g.cmp(t.segment);if(c>0)t.left||(t.left=new f,t.left.segment=g.value()),i.push([-1,t]),t=t.left;else if(c<0)t.right||(t.right=new f,t.right.segment=g.value()),i.push([1,t]),t=t.right;else if(g.hasNext())g.next(),t.mid||(t.mid=new f,t.mid.segment=g.value()),i.push([0,t]),t=t.mid;else break}const r=t.value;t.value=v,t.key=b;for(let c=i.length-1;c>=0;c--){const o=i[c][1];o.updateHeight();const l=o.balanceFactor();if(l<-1||l>1){const n=i[c][0],s=i[c+1][0];if(n===1&&s===1)i[c][1]=o.rotateLeft();else if(n===-1&&s===-1)i[c][1]=o.rotateRight();else if(n===1&&s===-1)o.right=i[c+1][1]=i[c+1][1].rotateRight(),i[c][1]=o.rotateLeft();else if(n===-1&&s===1)o.left=i[c+1][1]=i[c+1][1].rotateLeft(),i[c][1]=o.rotateRight();else throw new Error;if(c>0)switch(i[c-1][0]){case-1:i[c-1][1].left=i[c][1];break;case 1:i[c-1][1].right=i[c][1];break;case 0:i[c-1][1].mid=i[c][1];break}else this.c=i[0][1]}}return r}get(b){return this.d(b)?.value}d(b){const v=this.b.reset(b);let g=this.c;for(;g;){const t=v.cmp(g.segment);if(t>0)g=g.left;else if(t<0)g=g.right;else if(v.hasNext())v.next(),g=g.mid;else break}return g}has(b){const v=this.d(b);return!(v?.value===void 0&&v?.mid===void 0)}delete(b){return this.e(b,!1)}deleteSuperstr(b){return this.e(b,!0)}e(b,v){const g=this.b.reset(b),t=[];let i=this.c;for(;i;){const r=g.cmp(i.segment);if(r>0)t.push([-1,i]),i=i.left;else if(r<0)t.push([1,i]),i=i.right;else if(g.hasNext())g.next(),t.push([0,i]),i=i.mid;else break}if(i){if(v?(i.left=void 0,i.mid=void 0,i.right=void 0,i.height=1):(i.key=void 0,i.value=void 0),!i.mid&&!i.value)if(i.left&&i.right){const r=this.f(i.right);if(r.key){const{key:c,value:o,segment:l}=r;this.e(r.key,!1),i.key=c,i.value=o,i.segment=l}}else{const r=i.left??i.right;if(t.length>0){const[c,o]=t[t.length-1];switch(c){case-1:o.left=r;break;case 0:o.mid=r;break;case 1:o.right=r;break}}else this.c=r}for(let r=t.length-1;r>=0;r--){const c=t[r][1];c.updateHeight();const o=c.balanceFactor();if(o>1?(c.right.balanceFactor()>=0||(c.right=c.right.rotateRight()),t[r][1]=c.rotateLeft()):o<-1&&(c.left.balanceFactor()<=0||(c.left=c.left.rotateLeft()),t[r][1]=c.rotateRight()),r>0)switch(t[r-1][0]){case-1:t[r-1][1].left=t[r][1];break;case 1:t[r-1][1].right=t[r][1];break;case 0:t[r-1][1].mid=t[r][1];break}else this.c=t[0][1]}}}f(b){for(;b.left;)b=b.left;return b}findSubstr(b){const v=this.b.reset(b);let g=this.c,t;for(;g;){const i=v.cmp(g.segment);if(i>0)g=g.left;else if(i<0)g=g.right;else if(v.hasNext())v.next(),t=g.value||t,g=g.mid;else break}return g&&g.value||t}findSuperstr(b){return this.g(b,!1)}g(b,v){const g=this.b.reset(b);let t=this.c;for(;t;){const i=g.cmp(t.segment);if(i>0)t=t.left;else if(i<0)t=t.right;else if(g.hasNext())g.next(),t=t.mid;else return t.mid?this.h(t.mid):v?t.value:void 0}}hasElementOrSubtree(b){return this.g(b,!0)!==void 0}forEach(b){for(const[v,g]of this)b(g,v)}*[Symbol.iterator](){yield*this.h(this.c)}h(b){const v=[];return this.j(b,v),v[Symbol.iterator]()}j(b,v){b&&(b.left&&this.j(b.left,v),b.value&&v.push([b.key,b.value]),b.mid&&this.j(b.mid,v),b.right&&this.j(b.right,v))}_isBalanced(){const b=v=>{if(!v)return!0;const g=v.balanceFactor();return g<-1||g>1?!1:b(v.left)&&b(v.right)};return b(this.c)}}e.$2h=D}),define(Ae[45],Re([1,0,90]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$2j=e.ThemeColor=void 0;var F;(function(R){function $(E){return E&&typeof E=="object"&&typeof E.id=="string"}R.isThemeColor=$})(F||(e.ThemeColor=F={}));function A(R){return{id:R}}e.$2j=A;var M;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const $=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function E(r){const c=$.exec(r.id);if(!c)return E(y.$1j.error);const[,o,l]=c,n=["codicon","codicon-"+o];return l&&n.push("codicon-modifier-"+l.substring(1)),n}R.asClassNameArray=E;function f(r){return E(r).join(" ")}R.asClassName=f;function P(r){return"."+E(r).join(".")}R.asCSSSelector=P;function D(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color>"u"||F.isThemeColor(r.color))}R.isThemeIcon=D;const u=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function b(r){const c=u.exec(r);if(!c)return;const[,o]=c;return{id:o}}R.fromString=b;function v(r){return{id:r}}R.fromId=v;function g(r,c){let o=r.id;const l=o.lastIndexOf("~");return l!==-1&&(o=o.substring(0,l)),c&&(o=`${o}~${c}`),{id:o}}R.modify=g;function t(r){const c=r.id.lastIndexOf("~");if(c!==-1)return r.id.substring(c+1)}R.getModifier=t;function i(r,c){return r.id===c.id&&r.color?.id===c.color?.id}R.isEqual=i})(M||(e.ThemeIcon=M={}))}),define(Ae[125],Re([1,0,123,12,45]),function(we,e,y,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=void 0;const M="$(",R=new RegExp(`\\$\\(${A.ThemeIcon.iconNameExpression}(?:${A.ThemeIcon.iconModifierExpression})?\\)`,"g"),$=new RegExp(`(\\\\)?${R.source}`,"g");function E(i){return i.replace($,(r,c)=>c?r:`\\${r}`)}e.$3j=E;const f=new RegExp(`\\\\${R.source}`,"g");function P(i){return i.replace(f,r=>`\\${r}`)}e.$4j=P;const D=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function u(i){return i.indexOf(M)===-1?i:i.replace(D,(r,c,o,l)=>o?r:c||l||"")}e.$5j=u;function b(i){return i?i.replace(/\$\((.*?)\)/g,(r,c)=>` ${c} `).trim():""}e.$6j=b;const v=new RegExp(`\\$\\(${A.ThemeIcon.iconNameCharacter}+\\)`,"g");function g(i){v.lastIndex=0;let r="";const c=[];let o=0;for(;;){const l=v.lastIndex,n=v.exec(i),s=i.substring(l,n?.index);if(s.length>0){r+=s;for(let a=0;a<s.length;a++)c.push(o)}if(!n)break;o+=n[0].length}return{text:r,iconOffsets:c}}e.$7j=g;function t(i,r,c=!1){const{text:o,iconOffsets:l}=r;if(!l||l.length===0)return(0,y.$Pj)(i,o,c);const n=(0,F.$Ne)(o," "),s=o.length-n.length,a=(0,y.$Pj)(i,n,c);if(a)for(const d of a){const p=l[d.start+s]+s;d.start+=p,d.end+=p}return a}e.$8j=t}),define(Ae[38],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ig=e.$hg=void 0;const y=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(A){return y.test(A)}e.$hg=F,e.$ig=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function($){for(let E=0;E<$.length;E++)$[E]=Math.floor(Math.random()*256);return $};const M=new Uint8Array(16),R=[];for(let $=0;$<256;$++)R.push($.toString(16).padStart(2,"0"));return function(){A(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let E=0,f="";return f+=R[M[E++]],f+=R[M[E++]],f+=R[M[E++]],f+=R[M[E++]],f+="-",f+=R[M[E++]],f+=R[M[E++]],f+="-",f+=R[M[E++]],f+=R[M[E++]],f+="-",f+=R[M[E++]],f+=R[M[E++]],f+="-",f+=R[M[E++]],f+=R[M[E++]],f+=R[M[E++]],f+=R[M[E++]],f+=R[M[E++]],f+=R[M[E++]],f}}()}),define(Ae[126],Re([1,0,18,67,38]),function(we,e,y,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9s=e.$8s=e.$7s=e.$6s=e.$5s=void 0;function M(D){return{asString:async()=>D,asFile:()=>{},value:typeof D=="string"?D:void 0}}e.$5s=M;function R(D,u,b){const v={id:(0,A.$ig)(),name:D,uri:u,data:b};return{asString:async()=>"",asFile:()=>v,value:void 0}}e.$6s=R;class ${constructor(){this.a=new Map}get size(){let u=0;for(const b of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const b=[...this.a.keys()];return F.Iterable.some(this,([v,g])=>g.asFile())&&b.push("files"),P(E(u),b)}get(u){return this.a.get(this.b(u))?.[0]}append(u,b){const v=this.a.get(u);v?v.push(b):this.a.set(this.b(u),[b])}replace(u,b){this.a.set(this.b(u),[b])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,b]of this.a)for(const v of b)yield[u,v]}b(u){return E(u)}}e.$7s=$;function E(D){return D.toLowerCase()}function f(D,u){return P(E(D),u.map(E))}e.$8s=f;function P(D,u){if(D==="*/*")return u.length>0;if(u.includes(D))return!0;const b=D.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!b)return!1;const[v,g,t]=b;return t==="*"?u.some(i=>i.startsWith(g+"/")):!1}e.$9s=Object.freeze({create:D=>(0,y.$Lb)(D.map(u=>u.toString())).join(`\r
`),split:D=>D.split(`\r
`),parse:D=>e.$9s.split(D).filter(u=>!u.startsWith("#"))})}),define(Ae[127],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_s=e.StringEOL=void 0;var y;(function(A){A[A.Unknown=0]="Unknown",A[A.Invalid=3]="Invalid",A[A.LF=1]="LF",A[A.CRLF=2]="CRLF"})(y||(e.StringEOL=y={}));function F(A){let M=0,R=0,$=0,E=0;for(let f=0,P=A.length;f<P;f++){const D=A.charCodeAt(f);D===13?(M===0&&(R=f),M++,f+1<P&&A.charCodeAt(f+1)===10?(E|=2,f++):E|=3,$=f+1):D===10&&(E|=1,M===0&&(R=f),M++,$=f+1)}return M===0&&(R=A.length),[M,R,A.length-$,E]}e.$_s=F}),define(Ae[128],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9r=void 0,e.$9r={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ae[129],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=e.$vt=e.IndentAction=void 0;var y;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(y||(e.IndentAction=y={}));class F{constructor($){if(this.e=null,this.f=!1,this.open=$.open,this.close=$.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray($.notIn))for(let E=0,f=$.notIn.length;E<f;E++)switch($.notIn[E]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK($){switch($){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose($,E){if($.getTokenCount()===0)return!0;const f=$.findTokenIndexAtOffset(E-2),P=$.getStandardTokenType(f);return this.isOK(P)}g($,E){for(let f=$;f<=E;f++){const P=String.fromCharCode(f);if(!this.open.includes(P)&&!this.close.includes(P))return P}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$vt=F;class A{constructor($){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of $)M(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),M(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),M(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),M(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&M(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.$wt=A;function M(R,$,E){R.has($)?R.get($).push(E):R.set($,[E])}}),define(Ae[130],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AB=e.$zB=e.$yB=e.$xB=e.$wB=e.$vB=e.$uB=e.$tB=e.$sB=e.NodeColor=e.$rB=void 0;class y{constructor(t,i){this.piece=t,this.color=i,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$sB)return A(this.right);let t=this;for(;t.parent!==e.$sB&&t.parent.left!==t;)t=t.parent;return t.parent===e.$sB?e.$sB:t.parent}prev(){if(this.left!==e.$sB)return M(this.left);let t=this;for(;t.parent!==e.$sB&&t.parent.right!==t;)t=t.parent;return t.parent===e.$sB?e.$sB:t.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$rB=y;var F;(function(g){g[g.Black=0]="Black",g[g.Red=1]="Red"})(F||(e.NodeColor=F={})),e.$sB=new y(null,0),e.$sB.parent=e.$sB,e.$sB.left=e.$sB,e.$sB.right=e.$sB,e.$sB.color=0;function A(g){for(;g.left!==e.$sB;)g=g.left;return g}e.$tB=A;function M(g){for(;g.right!==e.$sB;)g=g.right;return g}e.$uB=M;function R(g){return g===e.$sB?0:g.size_left+g.piece.length+R(g.right)}function $(g){return g===e.$sB?0:g.lf_left+g.piece.lineFeedCnt+$(g.right)}function E(){e.$sB.parent=e.$sB}function f(g,t){const i=t.right;i.size_left+=t.size_left+(t.piece?t.piece.length:0),i.lf_left+=t.lf_left+(t.piece?t.piece.lineFeedCnt:0),t.right=i.left,i.left!==e.$sB&&(i.left.parent=t),i.parent=t.parent,t.parent===e.$sB?g.root=i:t.parent.left===t?t.parent.left=i:t.parent.right=i,i.left=t,t.parent=i}e.$vB=f;function P(g,t){const i=t.left;t.left=i.right,i.right!==e.$sB&&(i.right.parent=t),i.parent=t.parent,t.size_left-=i.size_left+(i.piece?i.piece.length:0),t.lf_left-=i.lf_left+(i.piece?i.piece.lineFeedCnt:0),t.parent===e.$sB?g.root=i:t===t.parent.right?t.parent.right=i:t.parent.left=i,i.right=t,t.parent=i}e.$wB=P;function D(g,t){let i,r;if(t.left===e.$sB?(r=t,i=r.right):t.right===e.$sB?(r=t,i=r.left):(r=A(t.right),i=r.right),r===g.root){g.root=i,i.color=0,t.detach(),E(),g.root.parent=e.$sB;return}const c=r.color===1;if(r===r.parent.left?r.parent.left=i:r.parent.right=i,r===t?(i.parent=r.parent,v(g,i)):(r.parent===t?i.parent=r:i.parent=r.parent,v(g,i),r.left=t.left,r.right=t.right,r.parent=t.parent,r.color=t.color,t===g.root?g.root=r:t===t.parent.left?t.parent.left=r:t.parent.right=r,r.left!==e.$sB&&(r.left.parent=r),r.right!==e.$sB&&(r.right.parent=r),r.size_left=t.size_left,r.lf_left=t.lf_left,v(g,r)),t.detach(),i.parent.left===i){const l=R(i),n=$(i);if(l!==i.parent.size_left||n!==i.parent.lf_left){const s=l-i.parent.size_left,a=n-i.parent.lf_left;i.parent.size_left=l,i.parent.lf_left=n,b(g,i.parent,s,a)}}if(v(g,i.parent),c){E();return}let o;for(;i!==g.root&&i.color===0;)i===i.parent.left?(o=i.parent.right,o.color===1&&(o.color=0,i.parent.color=1,f(g,i.parent),o=i.parent.right),o.left.color===0&&o.right.color===0?(o.color=1,i=i.parent):(o.right.color===0&&(o.left.color=0,o.color=1,P(g,o),o=i.parent.right),o.color=i.parent.color,i.parent.color=0,o.right.color=0,f(g,i.parent),i=g.root)):(o=i.parent.left,o.color===1&&(o.color=0,i.parent.color=1,P(g,i.parent),o=i.parent.left),o.left.color===0&&o.right.color===0?(o.color=1,i=i.parent):(o.left.color===0&&(o.right.color=0,o.color=1,f(g,o),o=i.parent.left),o.color=i.parent.color,i.parent.color=0,o.left.color=0,P(g,i.parent),i=g.root));i.color=0,E()}e.$xB=D;function u(g,t){for(v(g,t);t!==g.root&&t.parent.color===1;)if(t.parent===t.parent.parent.left){const i=t.parent.parent.right;i.color===1?(t.parent.color=0,i.color=0,t.parent.parent.color=1,t=t.parent.parent):(t===t.parent.right&&(t=t.parent,f(g,t)),t.parent.color=0,t.parent.parent.color=1,P(g,t.parent.parent))}else{const i=t.parent.parent.left;i.color===1?(t.parent.color=0,i.color=0,t.parent.parent.color=1,t=t.parent.parent):(t===t.parent.left&&(t=t.parent,P(g,t)),t.parent.color=0,t.parent.parent.color=1,f(g,t.parent.parent))}g.root.color=0}e.$yB=u;function b(g,t,i,r){for(;t!==g.root&&t!==e.$sB;)t.parent.left===t&&(t.parent.size_left+=i,t.parent.lf_left+=r),t=t.parent}e.$zB=b;function v(g,t){let i=0,r=0;if(t!==g.root){for(;t!==g.root&&t===t.parent.right;)t=t.parent;if(t!==g.root)for(t=t.parent,i=R(t.left)-t.size_left,r=$(t.left)-t.lf_left,t.size_left+=i,t.lf_left+=r;t!==g.root&&(i!==0||r!==0);)t.parent.left===t&&(t.parent.size_left+=i,t.parent.lf_left+=r),t=t.parent}}e.$AB=v}),define(Ae[91],Re([1,0,131,29,92,130,93]),function(we,e,y,F,A,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LB=e.$KB=e.$JB=e.$IB=e.$HB=void 0;const $=65535;function E(i){let r;return i[i.length-1]<65536?r=new Uint16Array(i.length):r=new Uint32Array(i.length),r.set(i,0),r}class f{constructor(r,c,o,l,n){this.lineStarts=r,this.cr=c,this.lf=o,this.crlf=l,this.isBasicASCII=n}}function P(i,r=!0){const c=[0];let o=1;for(let l=0,n=i.length;l<n;l++){const s=i.charCodeAt(l);s===13?l+1<n&&i.charCodeAt(l+1)===10?(c[o++]=l+2,l++):c[o++]=l+1:s===10&&(c[o++]=l+1)}return r?E(c):c}e.$HB=P;function D(i,r){i.length=0,i[0]=0;let c=1,o=0,l=0,n=0,s=!0;for(let d=0,p=r.length;d<p;d++){const m=r.charCodeAt(d);m===13?d+1<p&&r.charCodeAt(d+1)===10?(n++,i[c++]=d+2,d++):(o++,i[c++]=d+1):m===10?(l++,i[c++]=d+1):s&&m!==9&&(m<32||m>126)&&(s=!1)}const a=new f(E(i),o,l,n,s);return i.length=0,a}e.$IB=D;class u{constructor(r,c,o,l,n){this.bufferIndex=r,this.start=c,this.end=o,this.lineFeedCnt=l,this.length=n}}e.$JB=u;class b{constructor(r,c){this.buffer=r,this.lineStarts=c}}e.$KB=b;class v{constructor(r,c){this.a=[],this.c=r,this.d=c,this.b=0,r.root!==M.$sB&&r.iterate(r.root,o=>(o!==M.$sB&&this.a.push(o.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class g{constructor(r){this.a=r,this.b=[]}get(r){for(let c=this.b.length-1;c>=0;c--){const o=this.b[c];if(o.nodeStartOffset<=r&&o.nodeStartOffset+o.node.piece.length>=r)return o}return null}get2(r){for(let c=this.b.length-1;c>=0;c--){const o=this.b[c];if(o.nodeStartLineNumber&&o.nodeStartLineNumber<r&&o.nodeStartLineNumber+o.node.piece.lineFeedCnt>=r)return o}return null}set(r){this.b.length>=this.a&&this.b.shift(),this.b.push(r)}validate(r){let c=!1;const o=this.b;for(let l=0;l<o.length;l++){const n=o[l];if(n.node.parent===null||n.nodeStartOffset>=r){o[l]=null,c=!0;continue}}if(c){const l=[];for(const n of o)n!==null&&l.push(n);this.b=l}}}class t{constructor(r,c,o){this.create(r,c,o)}create(r,c,o){this.a=[new b("",[0])],this.g={line:0,column:0},this.root=M.$sB,this.b=1,this.c=0,this.d=c,this.e=c.length,this.f=o;let l=null;for(let n=0,s=r.length;n<s;n++)if(r[n].buffer.length>0){r[n].lineStarts||(r[n].lineStarts=P(r[n].buffer));const a=new u(n+1,{line:0,column:0},{line:r[n].lineStarts.length-1,column:r[n].buffer.length-r[n].lineStarts[r[n].lineStarts.length-1]},r[n].lineStarts.length-1,r[n].buffer.length);this.a.push(r[n]),l=this.S(l,a)}this.h=new g(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(r){const c=$,o=c-Math.floor(c/3),l=o*2;let n="",s=0;const a=[];if(this.iterate(this.root,d=>{const p=this.R(d),m=p.length;if(s<=o||s+m<l)return n+=p,s+=m,!0;const S=n.replace(/\r\n|\r|\n/g,r);return a.push(new b(S,P(S))),n=p,s=m,!0}),s>0){const d=n.replace(/\r\n|\r|\n/g,r);a.push(new b(d,P(d)))}this.create(a,r,!0)}getEOL(){return this.d}setEOL(r){this.d=r,this.e=this.d.length,this.normalizeEOL(r)}createSnapshot(r){return new v(this,r)}equal(r){if(this.getLength()!==r.getLength()||this.getLineCount()!==r.getLineCount())return!1;let c=0;return this.iterate(this.root,l=>{if(l===M.$sB)return!0;const n=this.R(l),s=n.length,a=r.G(c),d=r.G(c+s),p=r.getValueInRange2(a,d);return c+=s,n===p})}getOffsetAt(r,c){let o=0,l=this.root;for(;l!==M.$sB;)if(l.left!==M.$sB&&l.lf_left+1>=r)l=l.left;else if(l.lf_left+l.piece.lineFeedCnt+1>=r){o+=l.size_left;const n=this.B(l,r-l.lf_left-2);return o+=n+c-1}else r-=l.lf_left+l.piece.lineFeedCnt,o+=l.size_left+l.piece.length,l=l.right;return o}getPositionAt(r){r=Math.floor(r),r=Math.max(0,r);let c=this.root,o=0;const l=r;for(;c!==M.$sB;)if(c.size_left!==0&&c.size_left>=r)c=c.left;else if(c.size_left+c.piece.length>=r){const n=this.A(c,r-c.size_left);if(o+=c.lf_left+n.index,n.index===0){const s=this.getOffsetAt(o+1,1),a=l-s;return new y.$ys(o+1,a+1)}return new y.$ys(o+1,n.remainder+1)}else if(r-=c.size_left+c.piece.length,o+=c.lf_left+c.piece.lineFeedCnt,c.right===M.$sB){const n=this.getOffsetAt(o+1,1),s=l-r-n;return new y.$ys(o+1,s+1)}else c=c.right;return new y.$ys(1,1)}getValueInRange(r,c){if(r.startLineNumber===r.endLineNumber&&r.startColumn===r.endColumn)return"";const o=this.H(r.startLineNumber,r.startColumn),l=this.H(r.endLineNumber,r.endColumn),n=this.getValueInRange2(o,l);return c?c!==this.d||!this.f?n.replace(/\r\n|\r|\n/g,c):c===this.getEOL()&&this.f?n:n.replace(/\r\n|\r|\n/g,c):n}getValueInRange2(r,c){if(r.node===c.node){const a=r.node,d=this.a[a.piece.bufferIndex].buffer,p=this.u(a.piece.bufferIndex,a.piece.start);return d.substring(p+r.remainder,p+c.remainder)}let o=r.node;const l=this.a[o.piece.bufferIndex].buffer,n=this.u(o.piece.bufferIndex,o.piece.start);let s=l.substring(n+r.remainder,n+o.piece.length);for(o=o.next();o!==M.$sB;){const a=this.a[o.piece.bufferIndex].buffer,d=this.u(o.piece.bufferIndex,o.piece.start);if(o===c.node){s+=a.substring(d,d+c.remainder);break}else s+=a.substr(d,o.piece.length);o=o.next()}return s}getLinesContent(){const r=[];let c=0,o="",l=!1;return this.iterate(this.root,n=>{if(n===M.$sB)return!0;const s=n.piece;let a=s.length;if(a===0)return!0;const d=this.a[s.bufferIndex].buffer,p=this.a[s.bufferIndex].lineStarts,m=s.start.line,S=s.end.line;let k=p[m]+s.start.column;if(l&&(d.charCodeAt(k)===10&&(k++,a--),r[c++]=o,o="",l=!1,a===0))return!0;if(m===S)return!this.f&&d.charCodeAt(k+a-1)===13?(l=!0,o+=d.substr(k,a-1)):o+=d.substr(k,a),!0;o+=this.f?d.substring(k,Math.max(k,p[m+1]-this.e)):d.substring(k,p[m+1]).replace(/(\r\n|\r|\n)$/,""),r[c++]=o;for(let h=m+1;h<S;h++)o=this.f?d.substring(p[h],p[h+1]-this.e):d.substring(p[h],p[h+1]).replace(/(\r\n|\r|\n)$/,""),r[c++]=o;return!this.f&&d.charCodeAt(p[S]+s.end.column-1)===13?(l=!0,s.end.column===0?c--:o=d.substr(p[S],s.end.column-1)):o=d.substr(p[S],s.end.column),!0}),l&&(r[c++]=o,o=""),r[c++]=o,r}getLength(){return this.c}getLineCount(){return this.b}getLineContent(r){return this.j.lineNumber===r?this.j.value:(this.j.lineNumber=r,r===this.b?this.j.value=this.getLineRawContent(r):this.f?this.j.value=this.getLineRawContent(r,this.e):this.j.value=this.getLineRawContent(r).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(r){if(r.remainder===r.node.piece.length){const c=r.node.next();if(!c)return 0;const o=this.a[c.piece.bufferIndex],l=this.u(c.piece.bufferIndex,c.piece.start);return o.buffer.charCodeAt(l)}else{const c=this.a[r.node.piece.bufferIndex],l=this.u(r.node.piece.bufferIndex,r.node.piece.start)+r.remainder;return c.buffer.charCodeAt(l)}}getLineCharCode(r,c){const o=this.H(r,c+1);return this.l(o)}getLineLength(r){if(r===this.getLineCount()){const c=this.getOffsetAt(r,1);return this.getLength()-c}return this.getOffsetAt(r+1,1)-this.getOffsetAt(r,1)-this.e}getCharCode(r){const c=this.G(r);return this.l(c)}findMatchesInNode(r,c,o,l,n,s,a,d,p,m,S){const k=this.a[r.piece.bufferIndex],h=this.u(r.piece.bufferIndex,r.piece.start),w=this.u(r.piece.bufferIndex,n),I=this.u(r.piece.bufferIndex,s);let L;const V={line:0,column:0};let Y,U;c._wordSeparators?(Y=k.buffer.substring(w,I),U=N=>N+w,c.reset(0)):(Y=k.buffer,U=N=>N,c.reset(w));do if(L=c.next(Y),L){if(U(L.index)>=I)return m;this.s(r,U(L.index)-h,V);const N=this.t(r.piece.bufferIndex,n,V),C=V.line===n.line?V.column-n.column+l:V.column+1,T=C+L[0].length;if(S[m++]=(0,R.$DB)(new F.$zs(o+N,C,o+N,T),L,d),U(L.index)+L[0].length>=I||m>=p)return m}while(L);return m}findMatchesLineByLine(r,c,o,l){const n=[];let s=0;const a=new R.$GB(c.wordSeparators,c.regex);let d=this.H(r.startLineNumber,r.startColumn);if(d===null)return[];const p=this.H(r.endLineNumber,r.endColumn);if(p===null)return[];let m=this.s(d.node,d.remainder);const S=this.s(p.node,p.remainder);if(d.node===p.node)return this.findMatchesInNode(d.node,a,r.startLineNumber,r.startColumn,m,S,c,o,l,s,n),n;let k=r.startLineNumber,h=d.node;for(;h!==p.node;){const I=this.t(h.piece.bufferIndex,m,h.piece.end);if(I>=1){const V=this.a[h.piece.bufferIndex].lineStarts,Y=this.u(h.piece.bufferIndex,h.piece.start),U=V[m.line+I],N=k===r.startLineNumber?r.startColumn:1;if(s=this.findMatchesInNode(h,a,k,N,m,this.s(h,U-Y),c,o,l,s,n),s>=l)return n;k+=I}const L=k===r.startLineNumber?r.startColumn-1:0;if(k===r.endLineNumber){const V=this.getLineContent(k).substring(L,r.endColumn-1);return s=this.n(c,a,V,r.endLineNumber,L,s,n,o,l),n}if(s=this.n(c,a,this.getLineContent(k).substr(L),k,L,s,n,o,l),s>=l)return n;k++,d=this.H(k,1),h=d.node,m=this.s(d.node,d.remainder)}if(k===r.endLineNumber){const I=k===r.startLineNumber?r.startColumn-1:0,L=this.getLineContent(k).substring(I,r.endColumn-1);return s=this.n(c,a,L,r.endLineNumber,I,s,n,o,l),n}const w=k===r.startLineNumber?r.startColumn:1;return s=this.findMatchesInNode(p.node,a,k,w,m,S,c,o,l,s,n),n}n(r,c,o,l,n,s,a,d,p){const m=r.wordSeparators;if(!d&&r.simpleSearch){const k=r.simpleSearch,h=k.length,w=o.length;let I=-h;for(;(I=o.indexOf(k,I+h))!==-1;)if((!m||(0,R.$FB)(m,o,w,I,h))&&(a[s++]=new A.$Qu(new F.$zs(l,I+1+n,l,I+1+h+n),null),s>=p))return s;return s}let S;c.reset(0);do if(S=c.next(o),S&&(a[s++]=(0,R.$DB)(new F.$zs(l,S.index+1+n,l,S.index+1+S[0].length+n),S,d),s>=p))return s;while(S);return s}insert(r,c,o=!1){if(this.f=this.f&&o,this.j.lineNumber=0,this.j.value="",this.root!==M.$sB){const{node:l,remainder:n,nodeStartOffset:s}=this.G(r),a=l.piece,d=a.bufferIndex,p=this.s(l,n);if(l.piece.bufferIndex===0&&a.end.line===this.g.line&&a.end.column===this.g.column&&s+a.length===r&&c.length<$){this.F(l,c),this.y();return}if(s===r)this.o(c,l),this.h.validate(r);else if(s+l.piece.length>r){const m=[];let S=new u(a.bufferIndex,p,a.end,this.t(a.bufferIndex,p,a.end),this.u(d,a.end)-this.u(d,p));if(this.K()&&this.M(c)&&this.I(l,n)===10){const I={line:S.start.line+1,column:0};S=new u(S.bufferIndex,I,S.end,this.t(S.bufferIndex,I,S.end),S.length-1),c+=`
`}if(this.K()&&this.L(c))if(this.I(l,n-1)===13){const I=this.s(l,n-1);this.C(l,I),c="\r"+c,l.piece.length===0&&m.push(l)}else this.C(l,p);else this.C(l,p);const k=this.w(c);S.length>0&&this.S(l,S);let h=l;for(let w=0;w<k.length;w++)h=this.S(h,k[w]);this.v(m)}else this.q(c,l)}else{const l=this.w(c);let n=this.T(null,l[0]);for(let s=1;s<l.length;s++)n=this.S(n,l[s])}this.y()}delete(r,c){if(this.j.lineNumber=0,this.j.value="",c<=0||this.root===M.$sB)return;const o=this.G(r),l=this.G(r+c),n=o.node,s=l.node;if(n===s){const k=this.s(n,o.remainder),h=this.s(n,l.remainder);if(o.nodeStartOffset===r){if(c===n.piece.length){const w=n.next();(0,M.$xB)(this,n),this.N(w),this.y();return}this.D(n,h),this.h.validate(r),this.N(n),this.y();return}if(o.nodeStartOffset+n.piece.length===r+c){this.C(n,k),this.O(n),this.y();return}this.E(n,k,h),this.y();return}const a=[],d=this.s(n,o.remainder);this.C(n,d),this.h.validate(r),n.piece.length===0&&a.push(n);const p=this.s(s,l.remainder);this.D(s,p),s.piece.length===0&&a.push(s);const m=n.next();for(let k=m;k!==M.$sB&&k!==s;k=k.next())a.push(k);const S=n.piece.length===0?n.prev():n;this.v(a),this.O(S),this.y()}o(r,c){const o=[];if(this.K()&&this.M(r)&&this.L(c)){const s=c.piece,a={line:s.start.line+1,column:0},d=new u(s.bufferIndex,a,s.end,this.t(s.bufferIndex,a,s.end),s.length-1);c.piece=d,r+=`
`,(0,M.$zB)(this,c,-1,-1),c.piece.length===0&&o.push(c)}const l=this.w(r);let n=this.T(c,l[l.length-1]);for(let s=l.length-2;s>=0;s--)n=this.T(n,l[s]);this.N(n),this.v(o)}q(r,c){this.Q(r,c)&&(r+=`
`);const o=this.w(r),l=this.S(c,o[0]);let n=l;for(let s=1;s<o.length;s++)n=this.S(n,o[s]);this.N(l)}s(r,c,o){const l=r.piece,n=r.piece.bufferIndex,s=this.a[n].lineStarts,d=s[l.start.line]+l.start.column+c;let p=l.start.line,m=l.end.line,S=0,k=0,h=0;for(;p<=m&&(S=p+(m-p)/2|0,h=s[S],S!==m);)if(k=s[S+1],d<h)m=S-1;else if(d>=k)p=S+1;else break;return o?(o.line=S,o.column=d-h,null):{line:S,column:d-h}}t(r,c,o){if(o.column===0)return o.line-c.line;const l=this.a[r].lineStarts;if(o.line===l.length-1)return o.line-c.line;const n=l[o.line+1],s=l[o.line]+o.column;if(n>s+1)return o.line-c.line;const a=s-1;return this.a[r].buffer.charCodeAt(a)===13?o.line-c.line+1:o.line-c.line}u(r,c){return this.a[r].lineStarts[c.line]+c.column}v(r){for(let c=0;c<r.length;c++)(0,M.$xB)(this,r[c])}w(r){if(r.length>$){const m=[];for(;r.length>$;){const k=r.charCodeAt($-1);let h;k===13||k>=55296&&k<=56319?(h=r.substring(0,$-1),r=r.substring($-1)):(h=r.substring(0,$),r=r.substring($));const w=P(h);m.push(new u(this.a.length,{line:0,column:0},{line:w.length-1,column:h.length-w[w.length-1]},w.length-1,h.length)),this.a.push(new b(h,w))}const S=P(r);return m.push(new u(this.a.length,{line:0,column:0},{line:S.length-1,column:r.length-S[S.length-1]},S.length-1,r.length)),this.a.push(new b(r,S)),m}let c=this.a[0].buffer.length;const o=P(r,!1);let l=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===c&&c!==0&&this.L(r)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},l=this.g;for(let m=0;m<o.length;m++)o[m]+=c+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(o.slice(1)),this.a[0].buffer+="_"+r,c+=1}else{if(c!==0)for(let m=0;m<o.length;m++)o[m]+=c;this.a[0].lineStarts=this.a[0].lineStarts.concat(o.slice(1)),this.a[0].buffer+=r}const n=this.a[0].buffer.length,s=this.a[0].lineStarts.length-1,a=n-this.a[0].lineStarts[s],d={line:s,column:a},p=new u(0,l,d,this.t(0,l,d),n-c);return this.g=d,[p]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(r,c=0){let o=this.root,l="";const n=this.h.get2(r);if(n){o=n.node;const s=this.B(o,r-n.nodeStartLineNumber-1),a=this.a[o.piece.bufferIndex].buffer,d=this.u(o.piece.bufferIndex,o.piece.start);if(n.nodeStartLineNumber+o.piece.lineFeedCnt===r)l=a.substring(d+s,d+o.piece.length);else{const p=this.B(o,r-n.nodeStartLineNumber);return a.substring(d+s,d+p-c)}}else{let s=0;const a=r;for(;o!==M.$sB;)if(o.left!==M.$sB&&o.lf_left>=r-1)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt>r-1){const d=this.B(o,r-o.lf_left-2),p=this.B(o,r-o.lf_left-1),m=this.a[o.piece.bufferIndex].buffer,S=this.u(o.piece.bufferIndex,o.piece.start);return s+=o.size_left,this.h.set({node:o,nodeStartOffset:s,nodeStartLineNumber:a-(r-1-o.lf_left)}),m.substring(S+d,S+p-c)}else if(o.lf_left+o.piece.lineFeedCnt===r-1){const d=this.B(o,r-o.lf_left-2),p=this.a[o.piece.bufferIndex].buffer,m=this.u(o.piece.bufferIndex,o.piece.start);l=p.substring(m+d,m+o.piece.length);break}else r-=o.lf_left+o.piece.lineFeedCnt,s+=o.size_left+o.piece.length,o=o.right}for(o=o.next();o!==M.$sB;){const s=this.a[o.piece.bufferIndex].buffer;if(o.piece.lineFeedCnt>0){const a=this.B(o,0),d=this.u(o.piece.bufferIndex,o.piece.start);return l+=s.substring(d,d+a-c),l}else{const a=this.u(o.piece.bufferIndex,o.piece.start);l+=s.substr(a,o.piece.length)}o=o.next()}return l}y(){let r=this.root,c=1,o=0;for(;r!==M.$sB;)c+=r.lf_left+r.piece.lineFeedCnt,o+=r.size_left+r.piece.length,r=r.right;this.b=c,this.c=o,this.h.validate(this.c)}A(r,c){const o=r.piece,l=this.s(r,c),n=l.line-o.start.line;if(this.u(o.bufferIndex,o.end)-this.u(o.bufferIndex,o.start)===c){const s=this.t(r.piece.bufferIndex,o.start,l);if(s!==n)return{index:s,remainder:0}}return{index:n,remainder:l.column}}B(r,c){if(c<0)return 0;const o=r.piece,l=this.a[o.bufferIndex].lineStarts,n=o.start.line+c+1;return n>o.end.line?l[o.end.line]+o.end.column-l[o.start.line]-o.start.column:l[n]-l[o.start.line]-o.start.column}C(r,c){const o=r.piece,l=o.lineFeedCnt,n=this.u(o.bufferIndex,o.end),s=c,a=this.u(o.bufferIndex,s),d=this.t(o.bufferIndex,o.start,s),p=d-l,m=a-n,S=o.length+m;r.piece=new u(o.bufferIndex,o.start,s,d,S),(0,M.$zB)(this,r,m,p)}D(r,c){const o=r.piece,l=o.lineFeedCnt,n=this.u(o.bufferIndex,o.start),s=c,a=this.t(o.bufferIndex,s,o.end),d=this.u(o.bufferIndex,s),p=a-l,m=n-d,S=o.length+m;r.piece=new u(o.bufferIndex,s,o.end,a,S),(0,M.$zB)(this,r,m,p)}E(r,c,o){const l=r.piece,n=l.start,s=l.end,a=l.length,d=l.lineFeedCnt,p=c,m=this.t(l.bufferIndex,l.start,p),S=this.u(l.bufferIndex,c)-this.u(l.bufferIndex,n);r.piece=new u(l.bufferIndex,l.start,p,m,S),(0,M.$zB)(this,r,S-a,m-d);const k=new u(l.bufferIndex,o,s,this.t(l.bufferIndex,o,s),this.u(l.bufferIndex,s)-this.u(l.bufferIndex,o)),h=this.S(r,k);this.N(h)}F(r,c){this.Q(c,r)&&(c+=`
`);const o=this.K()&&this.L(c)&&this.M(r),l=this.a[0].buffer.length;this.a[0].buffer+=c;const n=P(c,!1);for(let h=0;h<n.length;h++)n[h]+=l;if(o){const h=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:l-h}}this.a[0].lineStarts=this.a[0].lineStarts.concat(n.slice(1));const s=this.a[0].lineStarts.length-1,a=this.a[0].buffer.length-this.a[0].lineStarts[s],d={line:s,column:a},p=r.piece.length+c.length,m=r.piece.lineFeedCnt,S=this.t(0,r.piece.start,d),k=S-m;r.piece=new u(r.piece.bufferIndex,r.piece.start,d,S,p),this.g=d,(0,M.$zB)(this,r,c.length,k)}G(r){let c=this.root;const o=this.h.get(r);if(o)return{node:o.node,nodeStartOffset:o.nodeStartOffset,remainder:r-o.nodeStartOffset};let l=0;for(;c!==M.$sB;)if(c.size_left>r)c=c.left;else if(c.size_left+c.piece.length>=r){l+=c.size_left;const n={node:c,remainder:r-c.size_left,nodeStartOffset:l};return this.h.set(n),n}else r-=c.size_left+c.piece.length,l+=c.size_left+c.piece.length,c=c.right;return null}H(r,c){let o=this.root,l=0;for(;o!==M.$sB;)if(o.left!==M.$sB&&o.lf_left>=r-1)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt>r-1){const n=this.B(o,r-o.lf_left-2),s=this.B(o,r-o.lf_left-1);return l+=o.size_left,{node:o,remainder:Math.min(n+c-1,s),nodeStartOffset:l}}else if(o.lf_left+o.piece.lineFeedCnt===r-1){const n=this.B(o,r-o.lf_left-2);if(n+c-1<=o.piece.length)return{node:o,remainder:n+c-1,nodeStartOffset:l};c-=o.piece.length-n;break}else r-=o.lf_left+o.piece.lineFeedCnt,l+=o.size_left+o.piece.length,o=o.right;for(o=o.next();o!==M.$sB;){if(o.piece.lineFeedCnt>0){const n=this.B(o,0),s=this.J(o);return{node:o,remainder:Math.min(c-1,n),nodeStartOffset:s}}else if(o.piece.length>=c-1){const n=this.J(o);return{node:o,remainder:c-1,nodeStartOffset:n}}else c-=o.piece.length;o=o.next()}return null}I(r,c){if(r.piece.lineFeedCnt<1)return-1;const o=this.a[r.piece.bufferIndex],l=this.u(r.piece.bufferIndex,r.piece.start)+c;return o.buffer.charCodeAt(l)}J(r){if(!r)return 0;let c=r.size_left;for(;r!==this.root;)r.parent.right===r&&(c+=r.parent.size_left+r.parent.piece.length),r=r.parent;return c}K(){return!(this.f&&this.d===`
`)}L(r){if(typeof r=="string")return r.charCodeAt(0)===10;if(r===M.$sB||r.piece.lineFeedCnt===0)return!1;const c=r.piece,o=this.a[c.bufferIndex].lineStarts,l=c.start.line,n=o[l]+c.start.column;return l===o.length-1||o[l+1]>n+1?!1:this.a[c.bufferIndex].buffer.charCodeAt(n)===10}M(r){return typeof r=="string"?r.charCodeAt(r.length-1)===13:r===M.$sB||r.piece.lineFeedCnt===0?!1:this.I(r,r.piece.length-1)===13}N(r){if(this.K()&&this.L(r)){const c=r.prev();this.M(c)&&this.P(c,r)}}O(r){if(this.K()&&this.M(r)){const c=r.next();this.L(c)&&this.P(r,c)}}P(r,c){const o=[],l=this.a[r.piece.bufferIndex].lineStarts;let n;r.piece.end.column===0?n={line:r.piece.end.line-1,column:l[r.piece.end.line]-l[r.piece.end.line-1]-1}:n={line:r.piece.end.line,column:r.piece.end.column-1};const s=r.piece.length-1,a=r.piece.lineFeedCnt-1;r.piece=new u(r.piece.bufferIndex,r.piece.start,n,a,s),(0,M.$zB)(this,r,-1,-1),r.piece.length===0&&o.push(r);const d={line:c.piece.start.line+1,column:0},p=c.piece.length-1,m=this.t(c.piece.bufferIndex,d,c.piece.end);c.piece=new u(c.piece.bufferIndex,d,c.piece.end,m,p),(0,M.$zB)(this,c,-1,-1),c.piece.length===0&&o.push(c);const S=this.w(`\r
`);this.S(r,S[0]);for(let k=0;k<o.length;k++)(0,M.$xB)(this,o[k])}Q(r,c){if(this.K()&&this.M(r)){const o=c.next();if(this.L(o)){if(r+=`
`,o.piece.length===1)(0,M.$xB)(this,o);else{const l=o.piece,n={line:l.start.line+1,column:0},s=l.length-1,a=this.t(l.bufferIndex,n,l.end);o.piece=new u(l.bufferIndex,n,l.end,a,s),(0,M.$zB)(this,o,-1,-1)}return!0}}return!1}iterate(r,c){if(r===M.$sB)return c(M.$sB);const o=this.iterate(r.left,c);return o&&c(r)&&this.iterate(r.right,c)}R(r){if(r===M.$sB)return"";const c=this.a[r.piece.bufferIndex],o=r.piece,l=this.u(o.bufferIndex,o.start),n=this.u(o.bufferIndex,o.end);return c.buffer.substring(l,n)}getPieceContent(r){const c=this.a[r.bufferIndex],o=this.u(r.bufferIndex,r.start),l=this.u(r.bufferIndex,r.end);return c.buffer.substring(o,l)}S(r,c){const o=new M.$rB(c,1);if(o.left=M.$sB,o.right=M.$sB,o.parent=M.$sB,o.size_left=0,o.lf_left=0,this.root===M.$sB)this.root=o,o.color=0;else if(r.right===M.$sB)r.right=o,o.parent=r;else{const n=(0,M.$tB)(r.right);n.left=o,o.parent=n}return(0,M.$yB)(this,o),o}T(r,c){const o=new M.$rB(c,1);if(o.left=M.$sB,o.right=M.$sB,o.parent=M.$sB,o.size_left=0,o.lf_left=0,this.root===M.$sB)this.root=o,o.color=0;else if(r.left===M.$sB)r.left=o,o.parent=r;else{const l=(0,M.$uB)(r.left);l.right=o,o.parent=l}return(0,M.$yB)(this,o),o}U(r){let c="";return this.iterate(r,o=>(c+=this.R(o),!0)),c}}e.$LB=t}),define(Ae[132],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S7=e.$R7=void 0;class y{constructor(){this.a=new Map}removeDragOperationTransfer(M){if(M&&this.a.has(M)){const R=this.a.get(M);return this.a.delete(M),R}}addDragOperationTransfer(M,R){this.a.set(M,R)}}e.$R7=y;class F{constructor(M){this.identifier=M}}e.$S7=F}),define(Ae[133],Re([9,10]),function(we,e){return we.create("vs/base/common/actions",e)}),define(Ae[134],Re([1,0,5,6,133]),function(we,e,y,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=void 0;class M extends F.$Rc{constructor(u,b="",v="",g=!0,t){super(),this.h=this.B(new y.$Rd),this.onDidChange=this.h.event,this.w=!0,this.j=u,this.m=b,this.u=v,this.w=g,this.C=t}get id(){return this.j}get label(){return this.m}set label(u){this.D(u)}D(u){this.m!==u&&(this.m=u,this.h.fire({label:u}))}get tooltip(){return this.n||""}set tooltip(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.h.fire({tooltip:u}))}get class(){return this.u}set class(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.h.fire({class:u}))}get enabled(){return this.w}set enabled(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.h.fire({enabled:u}))}get checked(){return this.z}set checked(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.h.fire({checked:u}))}async run(u,b){this.C&&await this.C(u)}}e.$Ai=M;class R extends F.$Rc{constructor(){super(...arguments),this.f=this.B(new y.$Rd),this.onWillRun=this.f.event,this.m=this.B(new y.$Rd),this.onDidRun=this.m.event}async run(u,b){if(!u.enabled)return;this.f.fire({action:u});let v;try{await this.u(u,b)}catch(g){v=g}this.m.fire({action:u,error:v})}async u(u,b){await u.run(b)}}e.$Bi=R;class ${constructor(){this.id=$.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let b=[];for(const v of u)v.length&&(b.length?b=[...b,new $,...v]:b=v);return b}static{this.ID="vs.actions.separator"}async run(){}}e.$Ci=$;class E{get actions(){return this.a}constructor(u,b,v,g){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=b,this.class=g,this.a=v}async run(){}}e.$Di=E;class f extends M{static{this.ID="vs.actions.empty"}constructor(){super(f.ID,A.localize(0,null),void 0,!1)}}e.$Ei=f;function P(D){return{id:D.id,label:D.label,class:void 0,enabled:D.enabled??!0,checked:D.checked??!1,run:async(...u)=>D.run(...u),tooltip:D.label}}e.$Fi=P}),define(Ae[135],Re([9,10]),function(we,e){return we.create("vs/base/common/date",e)}),define(Ae[136],Re([1,0,135]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$km=e.$jm=void 0;const F=60,A=F*60,M=A*24,R=M*7,$=M*30,E=M*365;function f(D,u,b,v){typeof D!="number"&&(D=D.getTime());const g=Math.round((new Date().getTime()-D)/1e3);if(g<-30)return(0,y.localize)(0,null,f(new Date().getTime()+g*1e3,!1));if(!v&&g<30)return(0,y.localize)(1,null);let t;return g<F?(t=g,u?t===1?b?(0,y.localize)(2,null,t):(0,y.localize)(3,null,t):b?(0,y.localize)(4,null,t):(0,y.localize)(5,null,t):t===1?b?(0,y.localize)(6,null,t):(0,y.localize)(7,null,t):b?(0,y.localize)(8,null,t):(0,y.localize)(9,null,t)):g<A?(t=Math.floor(g/F),u?t===1?b?(0,y.localize)(10,null,t):(0,y.localize)(11,null,t):b?(0,y.localize)(12,null,t):(0,y.localize)(13,null,t):t===1?b?(0,y.localize)(14,null,t):(0,y.localize)(15,null,t):b?(0,y.localize)(16,null,t):(0,y.localize)(17,null,t)):g<M?(t=Math.floor(g/A),u?t===1?b?(0,y.localize)(18,null,t):(0,y.localize)(19,null,t):b?(0,y.localize)(20,null,t):(0,y.localize)(21,null,t):t===1?b?(0,y.localize)(22,null,t):(0,y.localize)(23,null,t):b?(0,y.localize)(24,null,t):(0,y.localize)(25,null,t)):g<R?(t=Math.floor(g/M),u?t===1?(0,y.localize)(26,null,t):(0,y.localize)(27,null,t):t===1?(0,y.localize)(28,null,t):(0,y.localize)(29,null,t)):g<$?(t=Math.floor(g/R),u?t===1?b?(0,y.localize)(30,null,t):(0,y.localize)(31,null,t):b?(0,y.localize)(32,null,t):(0,y.localize)(33,null,t):t===1?b?(0,y.localize)(34,null,t):(0,y.localize)(35,null,t):b?(0,y.localize)(36,null,t):(0,y.localize)(37,null,t)):g<E?(t=Math.floor(g/$),u?t===1?b?(0,y.localize)(38,null,t):(0,y.localize)(39,null,t):b?(0,y.localize)(40,null,t):(0,y.localize)(41,null,t):t===1?b?(0,y.localize)(42,null,t):(0,y.localize)(43,null,t):b?(0,y.localize)(44,null,t):(0,y.localize)(45,null,t)):(t=Math.floor(g/E),u?t===1?b?(0,y.localize)(46,null,t):(0,y.localize)(47,null,t):b?(0,y.localize)(48,null,t):(0,y.localize)(49,null,t):t===1?b?(0,y.localize)(50,null,t):(0,y.localize)(51,null,t):b?(0,y.localize)(52,null,t):(0,y.localize)(53,null,t))}e.$jm=f;function P(D){return D.getFullYear()+"-"+String(D.getMonth()+1).padStart(2,"0")+"-"+String(D.getDate()).padStart(2,"0")+"T"+String(D.getHours()).padStart(2,"0")+":"+String(D.getMinutes()).padStart(2,"0")+":"+String(D.getSeconds()).padStart(2,"0")+"."+(D.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$km=P}),define(Ae[137],Re([9,10]),function(we,e){return we.create("vs/base/common/errorMessage",e)}),define(Ae[39],Re([1,0,18,16,137]),function(we,e,y,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=e.$Gi=void 0;function M(D,u){return u&&(D.stack||D.stacktrace)?A.localize(0,null,$(D),R(D.stack)||R(D.stacktrace)):$(D)}function R(D){return Array.isArray(D)?D.join(`
`):D}function $(D){return D.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${D.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?A.localize(1,null,D.message):D.message||A.localize(2,null)}function E(D=null,u=!1){if(!D)return A.localize(3,null);if(Array.isArray(D)){const b=y.$Gb(D),v=E(b[0],u);return b.length>1?A.localize(4,null,v,b.length):v}if(F.$Cf(D))return D;if(D.detail){const b=D.detail;if(b.error)return M(b.error,u);if(b.exception)return M(b.exception,u)}return D.stack?M(D,u):D.message?D.message:A.localize(5,null)}e.$Gi=E;function f(D){const u=D;return u instanceof Error&&Array.isArray(u.actions)}e.$Hi=f;function P(D,u){let b;return typeof D=="string"?b=new Error(D):b=D,b.actions=u,b}e.$Ii=P}),define(Ae[138],Re([1,0,44,20]),function(we,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=e.$yq=e.$xq=e.$wq=e.$vq=e.$uq=e.$tq=e.$sq=e.$rq=e.$qq=e.$pq=e.$oq=e.$nq=void 0;const A=new y.$U(()=>{const k=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:k,collatorIsNumeric:k.resolvedOptions().numeric}}),M=new y.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new y.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function $(k,h,w=!1){const I=k||"",L=h||"",V=A.value.collator.compare(I,L);return A.value.collatorIsNumeric&&V===0&&I!==L?I<L?-1:1:V}e.$nq=$;function E(k,h){const w=M.value.collator;return k=k||"",h=h||"",o(w,k,h)}e.$oq=E;function f(k,h){const w=M.value.collator;return k=k||"",h=h||"",a(k,h)||o(w,k,h)}e.$pq=f;function P(k,h){const w=M.value.collator;return k=k||"",h=h||"",s(k,h)||o(w,k,h)}e.$qq=P;function D(k,h){return k=k||"",h=h||"",k===h?0:k<h?-1:1}e.$rq=D;function u(k,h){const[w,I]=r(k),[L,V]=r(h);let Y=A.value.collator.compare(I,V);if(Y===0){if(A.value.collatorIsNumeric&&I!==V)return I<V?-1:1;if(Y=A.value.collator.compare(w,L),A.value.collatorIsNumeric&&Y===0&&w!==L)return w<L?-1:1}return Y}e.$sq=u;function b(k,h){k=k||"",h=h||"";const w=c(k),I=c(h),L=M.value.collator,V=R.value.collator;return o(V,w,I)||o(L,k,h)}e.$tq=b;function v(k,h){k=k||"",h=h||"";const w=c(k),I=c(h),L=M.value.collator,V=R.value.collator;return o(V,w,I)||a(k,h)||o(L,k,h)}e.$uq=v;function g(k,h){k=k||"",h=h||"";const w=c(k),I=c(h),L=M.value.collator,V=R.value.collator;return o(V,w,I)||s(k,h)||o(L,k,h)}e.$vq=g;function t(k,h){k=k||"",h=h||"";const w=c(k).toLowerCase(),I=c(h).toLowerCase();return w!==I?w<I?-1:1:k!==h?k<h?-1:1:0}e.$wq=t;const i=/^(.*?)(\.([^.]*))?$/;function r(k,h=!1){const w=k?i.exec(k):[];let I=[w&&w[1]||"",w&&w[3]||""];return h&&(!I[0]&&I[1]||I[0]&&I[0].charAt(0)===".")&&(I=[I[0]+"."+I[1],""]),I}function c(k){const h=k?i.exec(k):[];return h&&h[1]&&h[1].charAt(0)!=="."&&h[3]||""}function o(k,h,w){const I=k.compare(h,w);return I!==0?I:h.length!==w.length?h.length<w.length?-1:1:0}function l(k){const h=k.charAt(0);return h.toLocaleUpperCase()!==h}function n(k){const h=k.charAt(0);return h.toLocaleLowerCase()!==h}function s(k,h){return l(k)&&n(h)?-1:n(k)&&l(h)?1:0}function a(k,h){return n(k)&&l(h)?-1:l(k)&&n(h)?1:0}function d(k,h,w=!1){return w||(k=k&&k.toLowerCase(),h=h&&h.toLowerCase()),k===h?0:k<h?-1:1}function p(k,h,w=!1){const I=k.split(F.sep),L=h.split(F.sep),V=I.length-1,Y=L.length-1;let U,N;for(let C=0;;C++){if(U=V===C,N=Y===C,U&&N)return $(I[C],L[C],w);if(U)return-1;if(N)return 1;const T=d(I[C],L[C],w);if(T!==0)return T}}e.$xq=p;function m(k,h,w){const I=k.toLowerCase(),L=h.toLowerCase(),V=S(k,h,w);if(V)return V;const Y=I.endsWith(w),U=L.endsWith(w);if(Y!==U)return Y?-1:1;const N=$(I,L);return N!==0?N:I.localeCompare(L)}e.$yq=m;function S(k,h,w){const I=k.toLowerCase(),L=h.toLowerCase(),V=I.startsWith(w),Y=L.startsWith(w);if(V!==Y)return V?-1:1;if(V&&Y){if(I.length<L.length)return-1;if(I.length>L.length)return 1}return 0}e.$zq=S}),define(Ae[46],Re([1,0,20,21,12,16]),function(we,e,y,F,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=void 0;function R(m){return m===47||m===92}e.$Uf=R;function $(m){return m.replace(/[\\/]/g,y.$fc.sep)}e.$Vf=$;function E(m){return m.indexOf("/")===-1&&(m=$(m)),/^[a-zA-Z]:(\/|$)/.test(m)&&(m="/"+m),m}e.$Wf=E;function f(m,S=y.$fc.sep){if(!m)return"";const k=m.length,h=m.charCodeAt(0);if(R(h)){if(R(m.charCodeAt(1))&&!R(m.charCodeAt(2))){let I=3;const L=I;for(;I<k&&!R(m.charCodeAt(I));I++);if(L!==I&&!R(m.charCodeAt(I+1))){for(I+=1;I<k;I++)if(R(m.charCodeAt(I)))return m.slice(0,I+1).replace(/[\\/]/g,S)}}return S}else if(i(h)&&m.charCodeAt(1)===58)return R(m.charCodeAt(2))?m.slice(0,2)+S:m.slice(0,2);let w=m.indexOf("://");if(w!==-1){for(w+=3;w<k;w++)if(R(m.charCodeAt(w)))return m.slice(0,w+1)}return""}e.$Xf=f;function P(m){if(!F.$i||!m||m.length<5)return!1;let S=m.charCodeAt(0);if(S!==92||(S=m.charCodeAt(1),S!==92))return!1;let k=2;const h=k;for(;k<m.length&&(S=m.charCodeAt(k),S!==92);k++);return!(h===k||(S=m.charCodeAt(k+1),isNaN(S)||S===92))}e.$Yf=P;const D=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(m,S=F.$i){const k=S?D:u;return!(!m||m.length===0||/^\s+$/.test(m)||(k.lastIndex=0,k.test(m))||S&&b.test(m)||m==="."||m===".."||S&&m[m.length-1]==="."||S&&m.length!==m.trim().length||m.length>255)}e.$Zf=v;function g(m,S,k){const h=m===S;return!k||h?h:!m||!S?!1:(0,A.$6e)(m,S)}e.$1f=g;function t(m,S,k,h=y.sep){if(m===S)return!0;if(!m||!S||S.length>m.length)return!1;if(k){if(!(0,A.$7e)(m,S))return!1;if(S.length===m.length)return!0;let I=S.length;return S.charAt(S.length-1)===h&&I--,m.charAt(I)===h}return S.charAt(S.length-1)!==h&&(S+=h),m.indexOf(S)===0}e.$2f=t;function i(m){return m>=65&&m<=90||m>=97&&m<=122}e.$3f=i;function r(m,S){return F.$i&&m.endsWith(":")&&(m+=y.sep),(0,y.$hc)(m)||(m=(0,y.$ic)(S,m)),m=(0,y.$gc)(m),F.$i?(m=(0,A.$Oe)(m,y.sep),m.endsWith(":")&&(m+=y.sep)):(m=(0,A.$Oe)(m,y.sep),m||(m=y.sep)),m}e.$4f=r;function c(m){const S=(0,y.$gc)(m);return F.$i?m.length>3?!1:o(S)&&(m.length===2||S.charCodeAt(2)===92):S===y.$fc.sep}e.$5f=c;function o(m,S=F.$i){return S?i(m.charCodeAt(0))&&m.charCodeAt(1)===58:!1}e.$6f=o;function l(m,S=F.$i){return o(m,S)?m[0]:void 0}e.$7f=l;function n(m,S,k){return S.length>m.length?-1:m===S?0:(k&&(m=m.toLowerCase(),S=S.toLowerCase()),m.indexOf(S))}e.$8f=n;function s(m){const S=m.split(":");let k,h,w;for(const I of S){const L=Number(I);(0,M.$Gf)(L)?h===void 0?h=L:w===void 0&&(w=L):k=k?[k,I].join(":"):I}if(!k)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:k,line:h!==void 0?h:void 0,column:w!==void 0?w:h!==void 0?1:void 0}}e.$9f=s;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",d="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function p(m,S,k=8){let h="";for(let I=0;I<k;I++){let L;I===0&&F.$i&&!S&&(k===3||k===4)?L=d:L=a,h+=L.charAt(Math.floor(Math.random()*L.length))}let w;return S?w=`${S}-${h}`:w=h,m?(0,y.$ic)(m,w):w}e.$0f=p}),define(Ae[68],Re([1,0,20]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=e.$Yr=e.$Xr=e.$Wr=e.$Vr=void 0,e.$Vr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const F={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(P){const D=(0,y.$nc)(P),u=F[D.toLowerCase()];return u!==void 0?u:R(P)}e.$Wr=M;function R(P){const D=(0,y.$nc)(P);return A[D.toLowerCase()]}e.$Xr=R;function $(P){for(const D in A)if(A[D]===P)return D}e.$Yr=$;const E=/^(.+)\/(.+?)(;.+)?$/;function f(P,D){const u=E.exec(P);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:D?void 0:P}e.$Zr=f}),define(Ae[51],Re([1,0,24,2]),function(we,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sh=e.$rh=e.$qh=void 0;function A(E){return JSON.stringify(E,R)}e.$qh=A;function M(E){let f=JSON.parse(E);return f=$(f),f}e.$rh=M;function R(E,f){return f instanceof RegExp?{$mid:2,source:f.source,flags:f.flags}:f}function $(E,f=0){if(!E||f>200)return E;if(typeof E=="object"){switch(E.$mid){case 1:return F.URI.revive(E);case 2:return new RegExp(E.source,E.flags);case 17:return new Date(E.source)}if(E instanceof y.$fe||E instanceof Uint8Array)return E;if(Array.isArray(E))for(let P=0;P<E.length;++P)E[P]=$(E[P],f+1);else for(const P in E)Object.hasOwnProperty.call(E,P)&&(E[P]=$(E[P],f+1))}return E}e.$sh=$}),define(Ae[13],Re([1,0,11,21,2]),function(we,e,y,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.Schemas=void 0;var M;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm"})(M||(e.Schemas=M={})),e.$$f="vscode-tkn",e.$_f="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(P){this.d=P}setDelegate(P){this.e=P}setServerRootPath(P){this.f=`${P}/${M.vscodeRemoteResource}`}set(P,D,u){this.a[P]=D,this.b[P]=u}setConnectionToken(P,D){this.c[P]=D}getPreferredWebSchema(){return this.d}rewrite(P){if(this.e)try{return this.e(P)}catch(t){return y.$Z(t),P}const D=P.authority;let u=this.a[D];u&&u.indexOf(":")!==-1&&u.indexOf("[")===-1&&(u=`[${u}]`);const b=this.b[D],v=this.c[D];let g=`path=${encodeURIComponent(P.path)}`;return typeof v=="string"&&(g+=`&${e.$_f}=${encodeURIComponent(v)}`),A.URI.from({scheme:F.$o?this.d:M.vscodeRemoteResource,authority:`${u}:${b}`,path:this.f,query:g})}}e.$ag=new R,e.$bg="vs/../../extensions",e.$cg="vs/../../node_modules",e.$dg="vs/../../node_modules.asar",e.$eg="vs/../../node_modules.asar.unpacked",e.$fg="vscode-app";class ${static{this.a=e.$fg}asBrowserUri(P){const D=this.b(P,we);return this.uriToBrowserUri(D)}uriToBrowserUri(P){return P.scheme===M.vscodeRemote?e.$ag.rewrite(P):P.scheme===M.file&&(F.$m||F.$q===`${M.vscodeFileResource}://${$.a}`)?P.with({scheme:M.vscodeFileResource,authority:P.authority||$.a,query:null,fragment:null}):P}asFileUri(P){const D=this.b(P,we);return this.uriToFileUri(D)}uriToFileUri(P){return P.scheme===M.vscodeFileResource?P.with({scheme:M.file,authority:P.authority!==$.a?P.authority:null,query:null,fragment:null}):P}b(P,D){return A.URI.isUri(P)?P:A.URI.parse(D.toUrl(P))}}e.$gg=new $;var E;(function(f){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(P.get("3"));const D="vscode-coi";function u(v){let g;typeof v=="string"?g=new URL(v).searchParams:v instanceof URL?g=v.searchParams:A.URI.isUri(v)&&(g=new URL(v.toString(!0)).searchParams);const t=g?.get(D);if(t)return P.get(t)}f.getHeadersFromQuery=u;function b(v,g,t){if(!globalThis.crossOriginIsolated)return;const i=g&&t?"3":t?"2":"1";v instanceof URLSearchParams?v.set(D,i):v[D]=i}f.addSearchParam=b})(E||(e.COI=E={}))}),define(Ae[25],Re([1,0,46,13,20,21,12,2]),function(we,e,y,F,A,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jg=e.DataUri=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=void 0;function E(b){return(0,$.$vc)(b,!0)}e.$ng=E;class f{constructor(v){this.a=v}compare(v,g,t=!1){return v===g?0:(0,R.$Ye)(this.getComparisonKey(v,t),this.getComparisonKey(g,t))}isEqual(v,g,t=!1){return v===g?!0:!v||!g?!1:this.getComparisonKey(v,t)===this.getComparisonKey(g,t)}getComparisonKey(v,g=!1){return v.with({path:this.a(v)?v.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(v){return this.a(v)}isEqualOrParent(v,g,t=!1){if(v.scheme===g.scheme){if(v.scheme===F.Schemas.file)return y.$2f(E(v),E(g),this.a(v))&&v.query===g.query&&(t||v.fragment===g.fragment);if((0,e.$Eg)(v.authority,g.authority))return y.$2f(v.path,g.path,this.a(v),"/")&&v.query===g.query&&(t||v.fragment===g.fragment)}return!1}joinPath(v,...g){return $.URI.joinPath(v,...g)}basenameOrAuthority(v){return(0,e.$wg)(v)||v.authority}basename(v){return A.$fc.basename(v.path)}extname(v){return A.$fc.extname(v.path)}dirname(v){if(v.path.length===0)return v;let g;return v.scheme===F.Schemas.file?g=$.URI.file(A.$lc(E(v))).path:(g=A.$fc.dirname(v.path),v.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),g="/")),v.with({path:g})}normalizePath(v){if(!v.path.length)return v;let g;return v.scheme===F.Schemas.file?g=$.URI.file(A.$gc(E(v))).path:g=A.$fc.normalize(v.path),v.with({path:g})}relativePath(v,g){if(v.scheme!==g.scheme||!(0,e.$Eg)(v.authority,g.authority))return;if(v.scheme===F.Schemas.file){const r=A.$kc(E(v),E(g));return M.$i?y.$Vf(r):r}let t=v.path||"/";const i=g.path||"/";if(this.a(v)){let r=0;for(const c=Math.min(t.length,i.length);r<c&&!(t.charCodeAt(r)!==i.charCodeAt(r)&&t.charAt(r).toLowerCase()!==i.charAt(r).toLowerCase());r++);t=i.substr(0,r)+t.substr(r)}return A.$fc.relative(t,i)}resolvePath(v,g){if(v.scheme===F.Schemas.file){const t=$.URI.file(A.$jc(E(v),g));return v.with({authority:t.authority,path:t.path})}return g=y.$Wf(g),v.with({path:A.$fc.resolve(v.path,g)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,g){return v===g||v!==void 0&&g!==void 0&&(0,R.$6e)(v,g)}hasTrailingPathSeparator(v,g=A.sep){if(v.scheme===F.Schemas.file){const t=E(v);return t.length>y.$Xf(t).length&&t[t.length-1]===g}else{const t=v.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,g=A.sep){return(0,e.$Fg)(v,g)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,g=A.sep){let t=!1;if(v.scheme===F.Schemas.file){const i=E(v);t=i!==void 0&&i.length===y.$Xf(i).length&&i[i.length-1]===g}else{g="/";const i=v.path;t=i.length===1&&i.charCodeAt(i.length-1)===47}return!t&&!(0,e.$Fg)(v,g)?v.with({path:v.path+"/"}):v}}e.$og=f,e.$pg=new f(()=>!1),e.$qg=new f(b=>b.scheme===F.Schemas.file?!M.$k:!0),e.$rg=new f(b=>!0),e.$sg=e.$pg.isEqual.bind(e.$pg),e.$tg=e.$pg.isEqualOrParent.bind(e.$pg),e.$ug=e.$pg.getComparisonKey.bind(e.$pg),e.$vg=e.$pg.basenameOrAuthority.bind(e.$pg),e.$wg=e.$pg.basename.bind(e.$pg),e.$xg=e.$pg.extname.bind(e.$pg),e.$yg=e.$pg.dirname.bind(e.$pg),e.$zg=e.$pg.joinPath.bind(e.$pg),e.$Ag=e.$pg.normalizePath.bind(e.$pg),e.$Bg=e.$pg.relativePath.bind(e.$pg),e.$Cg=e.$pg.resolvePath.bind(e.$pg),e.$Dg=e.$pg.isAbsolutePath.bind(e.$pg),e.$Eg=e.$pg.isEqualAuthority.bind(e.$pg),e.$Fg=e.$pg.hasTrailingPathSeparator.bind(e.$pg),e.$Gg=e.$pg.removeTrailingPathSeparator.bind(e.$pg),e.$Hg=e.$pg.addTrailingPathSeparator.bind(e.$pg);function P(b,v){const g=[];for(let t=0;t<b.length;t++){const i=v(b[t]);b.some((r,c)=>c===t?!1:(0,e.$tg)(i,v(r)))||g.push(b[t])}return g}e.$Ig=P;var D;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function v(g){const t=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(c=>{const[o,l]=c.split(":");o&&l&&t.set(o,l)});const r=g.path.substring(0,g.path.indexOf(";"));return r&&t.set(b.META_DATA_MIME,r),t}b.parseMetaData=v})(D||(e.DataUri=D={}));function u(b,v,g){if(v){let t=b.path;return t&&t[0]!==A.$fc.sep&&(t=A.$fc.sep+t),b.with({scheme:g,authority:v,path:t})}return b.with({scheme:g})}e.$Jg=u}),define(Ae[14],Re([1,0,19,11,5,6,25,21,124]),function(we,e,y,F,A,M,R,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=e.$lh=e.$kh=e.$jh=e.Promises=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=void 0;function f(ve){return!!ve&&typeof ve.then=="function"}e.$Kg=f;function P(ve){const ne=new y.$2d,he=ve(ne.token),ce=new Promise((ye,_)=>{const fe=ne.token.onCancellationRequested(()=>{fe.dispose(),ne.dispose(),_(new F.$4)});Promise.resolve(he).then(te=>{fe.dispose(),ne.dispose(),ye(te)},te=>{fe.dispose(),ne.dispose(),_(te)})});return new class{cancel(){ne.cancel()}then(ye,_){return ce.then(ye,_)}catch(ye){return this.then(void 0,ye)}finally(ye){return ce.finally(ye)}}}e.$Lg=P;function D(ve,ne,he){return new Promise((ce,ye)=>{const _=ne.onCancellationRequested(()=>{_.dispose(),ce(he)});ve.then(ce,ye).finally(()=>_.dispose())})}e.$Mg=D;function u(ve,ne){return new Promise((he,ce)=>{const ye=ne.onCancellationRequested(()=>{ye.dispose(),ce(new F.$4)});ve.then(he,ce).finally(()=>ye.dispose())})}e.$Ng=u;async function b(ve){let ne=-1;const he=ve.map((ce,ye)=>ce.then(_=>(ne=ye,_)));try{return await Promise.race(he)}finally{ve.forEach((ce,ye)=>{ye!==ne&&ce.cancel()})}}e.$Og=b;function v(ve,ne,he){let ce;const ye=setTimeout(()=>{ce?.(void 0),he?.()},ne);return Promise.race([ve.finally(()=>clearTimeout(ye)),new Promise(_=>ce=_)])}e.$Pg=v;function g(ve){return new Promise((ne,he)=>{const ce=ve();f(ce)?ce.then(ne,he):ne(ce)})}e.$Qg=g;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(ne){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=ne,!this.b){const he=()=>{if(this.b=null,this.f)return;const ce=this.queue(this.d);return this.d=null,ce};this.b=new Promise(ce=>{this.a.then(he,he).then(ce)})}return new Promise((he,ce)=>{this.b.then(he,ce)})}return this.a=ne(),new Promise((he,ce)=>{this.a.then(ye=>{this.a=null,he(ye)},ye=>{this.a=null,ce(ye)})})}dispose(){this.f=!0}}e.$Rg=t;class i{constructor(){this.a=Promise.resolve(null)}queue(ne){return this.a=this.a.then(()=>ne(),()=>ne())}}e.$Sg=i;class r{constructor(){this.a=new Map}queue(ne,he){const ye=(this.a.get(ne)??Promise.resolve()).catch(()=>{}).then(he).finally(()=>{this.a.get(ne)===ye&&this.a.delete(ne)});return this.a.set(ne,ye),ye}}e.$Tg=r;const c=(ve,ne)=>{let he=!0;const ce=setTimeout(()=>{he=!1,ne()},ve);return{isTriggered:()=>he,dispose:()=>{clearTimeout(ce),he=!1}}},o=ve=>{let ne=!0;return queueMicrotask(()=>{ne&&(ne=!1,ve())}),{isTriggered:()=>ne,dispose:()=>{ne=!1}}};class l{constructor(ne){this.defaultDelay=ne,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(ne,he=this.defaultDelay){this.g=ne,this.h(),this.b||(this.b=new Promise((ye,_)=>{this.d=ye,this.f=_}).then(()=>{if(this.b=null,this.d=null,this.g){const ye=this.g;return this.g=null,ye()}}));const ce=()=>{this.a=null,this.d?.(null)};return this.a=he===E.$Od?o(ce):c(he,ce),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new F.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Ug=l;class n{constructor(ne){this.a=new l(ne),this.b=new t}trigger(ne,he){return this.a.trigger(()=>this.b.queue(ne),he)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Vg=n;class s{constructor(){this.a=!1,this.b=new Promise((ne,he)=>{this.d=ne})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Wg=s;class a extends s{constructor(ne){super(),this.f=setTimeout(()=>this.open(),ne)}open(){clearTimeout(this.f),super.open()}}e.$Xg=a;function d(ve,ne){return ne?new Promise((he,ce)=>{const ye=setTimeout(()=>{_.dispose(),he()},ve),_=ne.onCancellationRequested(()=>{clearTimeout(ye),_.dispose(),ce(new F.$4)})}):P(he=>d(ve,he))}e.$Yg=d;function p(ve,ne=0,he){const ce=setTimeout(()=>{ve(),he&&ye.dispose()},ne),ye=(0,M.$Pc)(()=>{clearTimeout(ce),he?.deleteAndLeak(ye)});return he?.add(ye),ye}e.$Zg=p;function m(ve){const ne=[];let he=0;const ce=ve.length;function ye(){return he<ce?ve[he++]():null}function _(fe){fe!=null&&ne.push(fe);const te=ye();return te?te.then(_):Promise.resolve(ne)}return Promise.resolve(null).then(_)}e.$1g=m;function S(ve,ne=ce=>!!ce,he=null){let ce=0;const ye=ve.length,_=()=>{if(ce>=ye)return Promise.resolve(he);const fe=ve[ce++];return Promise.resolve(fe()).then(ae=>ne(ae)?Promise.resolve(ae):_())};return _()}e.$2g=S;function k(ve,ne=ce=>!!ce,he=null){if(ve.length===0)return Promise.resolve(he);let ce=ve.length;const ye=()=>{ce=-1;for(const _ of ve)_.cancel?.()};return new Promise((_,fe)=>{for(const te of ve)te.then(ae=>{--ce>=0&&ne(ae)?(ye(),_(ae)):ce===0&&_(he)}).catch(ae=>{--ce>=0&&(ye(),fe(ae))})})}e.$3g=k;class h{constructor(ne){this.a=0,this.d=ne,this.f=[],this.b=0,this.g=new A.$Rd}get onDrained(){return this.g.event}get size(){return this.a}queue(ne){return this.a++,new Promise((he,ce)=>{this.f.push({factory:ne,c:he,e:ce}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const ne=this.f.shift();this.b++;const he=ne.factory();he.then(ne.c,ne.e),he.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$4g=h;class w extends h{constructor(){super(1)}}e.$5g=w;class I{constructor(){this.a=new De,this.b=0}queue(ne){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,ne())):this.a.run(this.b++,ne())}}e.$6g=I;class L{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const ne=new pe;return this.b.add(ne),ne.p}g(){for(const[,ne]of this.a)if(ne.size>0)return!1;return!0}queueFor(ne,he=R.$pg){const ce=he.getComparisonKey(ne);let ye=this.a.get(ce);if(!ye){ye=new w;const _=this.f++,fe=A.Event.once(ye.onDrained)(()=>{ye?.dispose(),this.a.delete(ce),this.h(),this.d?.deleteAndDispose(_),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$1c),this.d.set(_,fe),this.a.set(ce,ye)}return ye}h(){this.g()&&this.j()}j(){for(const ne of this.b)ne.complete();this.b.clear()}dispose(){for(const[,ne]of this.a)ne.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$7g=L;class V{constructor(ne,he){this.a=-1,typeof ne=="function"&&typeof he=="number"&&this.setIfNotSet(ne,he)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(ne,he){this.cancel(),this.a=setTimeout(()=>{this.a=-1,ne()},he)}setIfNotSet(ne,he){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,ne()},he))}}e.$8g=V;class Y{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(ne,he,ce=globalThis){this.cancel();const ye=ce.setInterval(()=>{ne()},he);this.d=(0,M.$Pc)(()=>{ce.clearInterval(ye),this.d=void 0})}dispose(){this.cancel()}}e.$9g=Y;class U{constructor(ne,he){this.b=-1,this.a=ne,this.d=he,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(ne=this.d){this.cancel(),this.b=setTimeout(this.f,ne)}get delay(){return this.d}set delay(ne){this.d=ne}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$0g=U;class N{constructor(ne,he){he%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${he}ms is not a multiple of 1000ms.`),this.a=ne,this.b=he,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(ne=this.b){ne%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ne}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(ne/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$$g=N;class C extends U{constructor(ne,he){super(ne,he),this.j=[]}work(ne){this.j.push(ne),this.isScheduled()||this.schedule()}h(){const ne=this.j;this.j=[],this.a?.(ne)}dispose(){this.j=[],super.dispose()}}e.$_g=C;class T extends M.$Rc{constructor(ne,he){super(),this.g=ne,this.h=he,this.a=[],this.b=this.B(new M.$Sc),this.f=!1}get pending(){return this.a.length}work(ne){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+ne.length>this.g.maxBufferedWork)return!1}else if(this.pending+ne.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const he of ne)this.a.push(he);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new U(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$ah=T,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$ch=(ve,ne)=>{(0,$.$B)(()=>{if(he)return;const ce=Date.now()+15;ne(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ce-Date.now())}}))});let he=!1;return{dispose(){he||(he=!0)}}}:e.$ch=(ve,ne,he)=>{const ce=ve.requestIdleCallback(ne,typeof he=="number"?{timeout:he}:void 0);let ye=!1;return{dispose(){ye||(ye=!0,ve.cancelIdleCallback(ce))}}},e.$bh=ve=>(0,e.$ch)(globalThis,ve)}();class G{constructor(ne,he){this.g=!1,this.d=()=>{try{this.j=he()}catch(ce){this.l=ce}finally{this.g=!0}},this.f=(0,e.$ch)(ne,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$dh=G;class de extends G{constructor(ne){super(globalThis,ne)}}e.$eh=de;async function me(ve,ne,he){let ce;for(let ye=0;ye<he;ye++)try{return await ve()}catch(_){ce=_,await d(ne)}throw ce}e.$fh=me;class De{isRunning(ne){return typeof ne=="number"?this.a?.taskId===ne:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(ne,he,ce){return this.a={taskId:ne,cancel:()=>ce?.(),promise:he},he.then(()=>this.d(ne),()=>this.d(ne)),he}d(ne){this.a&&ne===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const ne=this.b;this.b=void 0,ne.run().then(ne.promiseResolve,ne.promiseReject)}}queue(ne){if(this.b)this.b.run=ne;else{let he,ce;const ye=new Promise((_,fe)=>{he=_,ce=fe});this.b={run:ne,promise:ye,promiseResolve:he,promiseReject:ce}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$gh=De;class ke{constructor(ne,he=()=>Date.now()){this.d=ne,this.f=he,this.a=0,this.b=0}increment(){const ne=this.f();return ne-this.a>this.d&&(this.a=ne,this.b=0),this.b++,this.b}}e.$hh=ke;var le;(function(ve){ve[ve.Resolved=0]="Resolved",ve[ve.Rejected=1]="Rejected"})(le||(le={}));class pe{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((ne,he)=>{this.a=ne,this.b=he})}complete(ne){return new Promise(he=>{this.a(ne),this.d={outcome:0,value:ne},he()})}error(ne){return new Promise(he=>{this.b(ne),this.d={outcome:1,value:ne},he()})}cancel(){return this.error(new F.$4)}}e.$ih=pe;var re;(function(ve){async function ne(ce){let ye;const _=await Promise.all(ce.map(fe=>fe.then(te=>te,te=>{ye||(ye=te)})));if(typeof ye<"u")throw ye;return _}ve.settled=ne;function he(ce){return new Promise(async(ye,_)=>{try{await ce(ye,_)}catch(fe){_(fe)}})}ve.withAsyncBody=he})(re||(e.Promises=re={}));var Pe;(function(ve){ve[ve.Initial=0]="Initial",ve[ve.DoneOK=1]="DoneOK",ve[ve.DoneError=2]="DoneError"})(Pe||(Pe={}));class se{static fromArray(ne){return new se(he=>{he.emitMany(ne)})}static fromPromise(ne){return new se(async he=>{he.emitMany(await ne)})}static fromPromises(ne){return new se(async he=>{await Promise.all(ne.map(async ce=>he.emitOne(await ce)))})}static merge(ne){return new se(async he=>{await Promise.all(ne.map(async ce=>{for await(const ye of ce)he.emitOne(ye)}))})}static{this.EMPTY=se.fromArray([])}constructor(ne){this.a=0,this.b=[],this.d=null,this.f=new A.$Rd,queueMicrotask(async()=>{const he={emitOne:ce=>this.g(ce),emitMany:ce=>this.h(ce),reject:ce=>this.k(ce)};try{await Promise.resolve(ne(he)),this.j()}catch(ce){this.k(ce)}finally{he.emitOne=void 0,he.emitMany=void 0,he.reject=void 0}})}[Symbol.asyncIterator](){let ne=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(ne<this.b.length)return{done:!1,value:this.b[ne++]};if(this.a===1)return{done:!0,value:void 0};await A.Event.toPromise(this.f.event)}while(!0)}}}static map(ne,he){return new se(async ce=>{for await(const ye of ne)ce.emitOne(he(ye))})}map(ne){return se.map(this,ne)}static filter(ne,he){return new se(async ce=>{for await(const ye of ne)he(ye)&&ce.emitOne(ye)})}filter(ne){return se.filter(this,ne)}static coalesce(ne){return se.filter(ne,he=>!!he)}coalesce(){return se.coalesce(this)}static async toPromise(ne){const he=[];for await(const ce of ne)he.push(ce);return he}toPromise(){return se.toPromise(this)}g(ne){this.a===0&&(this.b.push(ne),this.f.fire())}h(ne){this.a===0&&(this.b=this.b.concat(ne),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(ne){this.a===0&&(this.a=2,this.d=ne,this.f.fire())}}e.$jh=se;class Z extends se{constructor(ne,he){super(he),this.l=ne}cancel(){this.l.cancel()}}e.$kh=Z;function j(ve){const ne=new y.$2d,he=ve(ne.token);return new Z(ne,async ce=>{const ye=ne.token.onCancellationRequested(()=>{ye.dispose(),ne.dispose(),ce.reject(new F.$4)});try{for await(const _ of he){if(ne.token.isCancellationRequested)return;ce.emitOne(_)}ye.dispose(),ne.dispose()}catch(_){ye.dispose(),ne.dispose(),ce.reject(_)}})}e.$lh=j;class ie{constructor(){this.a=new pe,this.b=new se(ce=>{if(ne){ce.reject(ne);return}return he&&ce.emitMany(he),this.d=ye=>ce.reject(ye),this.f=ye=>ce.emitOne(ye),this.a.p});let ne,he;this.f=ce=>{he||(he=[]),he.push(ce)},this.d=ce=>{ne||(ne=ce)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(ne){this.d(ne),this.a.complete()}emitOne(ne){this.f(ne)}}e.$mh=ie}),define(Ae[33],Re([1,0,18,14,46,28,20,21,12]),function(we,e,y,F,A,M,R,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=void 0;function f(){return Object.create(null)}e.$xj=f,e.$yj="**",e.$zj="/";const P="[/\\\\]",D="[^/\\\\]",u=/\//g;function b(me,De){switch(me){case 0:return"";case 1:return`${D}*?`;default:return`(?:${P}|${D}+${P}${De?`|${P}${D}+`:""})*?`}}function v(me,De){if(!me)return[];const ke=[];let le=!1,pe=!1,re="";for(const Pe of me){switch(Pe){case De:if(!le&&!pe){ke.push(re),re="";continue}break;case"{":le=!0;break;case"}":le=!1;break;case"[":pe=!0;break;case"]":pe=!1;break}re+=Pe}return re&&ke.push(re),ke}e.$Aj=v;function g(me){if(!me)return"";let De="";const ke=v(me,e.$zj);if(ke.every(le=>le===e.$yj))De=".*";else{let le=!1;ke.forEach((pe,re)=>{if(pe===e.$yj){if(le)return;De+=b(2,re===ke.length-1)}else{let Pe=!1,se="",Z=!1,j="";for(const ie of pe){if(ie!=="}"&&Pe){se+=ie;continue}if(Z&&(ie!=="]"||!j)){let ve;ie==="-"?ve=ie:(ie==="^"||ie==="!")&&!j?ve="^":ie===e.$zj?ve="":ve=(0,E.$Je)(ie),j+=ve;continue}switch(ie){case"{":Pe=!0;continue;case"[":Z=!0;continue;case"}":{const ne=`(?:${v(se,",").map(he=>g(he)).join("|")})`;De+=ne,Pe=!1,se="";break}case"]":{De+="["+j+"]",Z=!1,j="";break}case"?":De+=D;continue;case"*":De+=b(1);continue;default:De+=(0,E.$Je)(ie)}}re<ke.length-1&&(ke[re+1]!==e.$yj||re+2<ke.length)&&(De+=P)}le=pe===e.$yj})}return De}const t=/^\*\*\/\*\.[\w\.-]+$/,i=/^\*\*\/([\w\.-]+)\/?$/,r=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,c=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new M.$Cc(1e4),s=function(){return!1},a=function(){return null};function d(me,De){if(!me)return a;let ke;typeof me!="string"?ke=me.pattern:ke=me,ke=ke.trim();const le=`${ke}_${!!De.trimForExclusions}`;let pe=n.get(le);if(pe)return p(pe,me);let re;return t.test(ke)?pe=S(ke.substr(4),ke):(re=i.exec(m(ke,De)))?pe=k(re[1],ke):(De.trimForExclusions?c:r).test(ke)?pe=h(ke,De):(re=o.exec(m(ke,De)))?pe=w(re[1].substr(1),ke,!0):(re=l.exec(m(ke,De)))?pe=w(re[1],ke,!1):pe=I(ke),n.set(le,pe),p(pe,me)}function p(me,De){if(typeof De=="string")return me;const ke=function(le,pe){return(0,A.$2f)(le,De.base,!$.$k)?me((0,E.$Ne)(le.substr(De.base.length),R.sep),pe):null};return ke.allBasenames=me.allBasenames,ke.allPaths=me.allPaths,ke.basenames=me.basenames,ke.patterns=me.patterns,ke}function m(me,De){return De.trimForExclusions&&me.endsWith("/**")?me.substr(0,me.length-2):me}function S(me,De){return function(ke,le){return typeof ke=="string"&&ke.endsWith(me)?De:null}}function k(me,De){const ke=`/${me}`,le=`\\${me}`,pe=function(Pe,se){return typeof Pe!="string"?null:se?se===me?De:null:Pe===me||Pe.endsWith(ke)||Pe.endsWith(le)?De:null},re=[me];return pe.basenames=re,pe.patterns=[De],pe.allBasenames=re,pe}function h(me,De){const ke=G(me.slice(1,-1).split(",").map(se=>d(se,De)).filter(se=>se!==a),me),le=ke.length;if(!le)return a;if(le===1)return ke[0];const pe=function(se,Z){for(let j=0,ie=ke.length;j<ie;j++)if(ke[j](se,Z))return me;return null},re=ke.find(se=>!!se.allBasenames);re&&(pe.allBasenames=re.allBasenames);const Pe=ke.reduce((se,Z)=>Z.allPaths?se.concat(Z.allPaths):se,[]);return Pe.length&&(pe.allPaths=Pe),pe}function w(me,De,ke){const le=R.sep===R.$fc.sep,pe=le?me:me.replace(u,R.sep),re=R.sep+pe,Pe=R.$fc.sep+me;let se;return ke?se=function(Z,j){return typeof Z=="string"&&(Z===pe||Z.endsWith(re)||!le&&(Z===me||Z.endsWith(Pe)))?De:null}:se=function(Z,j){return typeof Z=="string"&&(Z===pe||!le&&Z===me)?De:null},se.allPaths=[(ke?"*/":"./")+me],se}function I(me){try{const De=new RegExp(`^${g(me)}$`);return function(ke){return De.lastIndex=0,typeof ke=="string"&&De.test(ke)?me:null}}catch{return a}}function L(me,De,ke){return!me||typeof De!="string"?!1:V(me)(De,void 0,ke)}e.$Bj=L;function V(me,De={}){if(!me)return s;if(typeof me=="string"||Y(me)){const ke=d(me,De);if(ke===a)return s;const le=function(pe,re){return!!ke(pe,re)};return ke.allBasenames&&(le.allBasenames=ke.allBasenames),ke.allPaths&&(le.allPaths=ke.allPaths),le}return C(me,De)}e.$Cj=V;function Y(me){const De=me;return De?typeof De.base=="string"&&typeof De.pattern=="string":!1}e.$Dj=Y;function U(me){return me.allBasenames||[]}e.$Ej=U;function N(me){return me.allPaths||[]}e.$Fj=N;function C(me,De){const ke=G(Object.getOwnPropertyNames(me).map(se=>T(se,me[se],De)).filter(se=>se!==a)),le=ke.length;if(!le)return a;if(!ke.some(se=>!!se.requiresSiblings)){if(le===1)return ke[0];const se=function(ie,ve){let ne;for(let he=0,ce=ke.length;he<ce;he++){const ye=ke[he](ie,ve);if(typeof ye=="string")return ye;(0,F.$Kg)(ye)&&(ne||(ne=[]),ne.push(ye))}return ne?(async()=>{for(const he of ne){const ce=await he;if(typeof ce=="string")return ce}return null})():null},Z=ke.find(ie=>!!ie.allBasenames);Z&&(se.allBasenames=Z.allBasenames);const j=ke.reduce((ie,ve)=>ve.allPaths?ie.concat(ve.allPaths):ie,[]);return j.length&&(se.allPaths=j),se}const pe=function(se,Z,j){let ie,ve;for(let ne=0,he=ke.length;ne<he;ne++){const ce=ke[ne];ce.requiresSiblings&&j&&(Z||(Z=(0,R.$mc)(se)),ie||(ie=Z.substr(0,Z.length-(0,R.$nc)(se).length)));const ye=ce(se,Z,ie,j);if(typeof ye=="string")return ye;(0,F.$Kg)(ye)&&(ve||(ve=[]),ve.push(ye))}return ve?(async()=>{for(const ne of ve){const he=await ne;if(typeof he=="string")return he}return null})():null},re=ke.find(se=>!!se.allBasenames);re&&(pe.allBasenames=re.allBasenames);const Pe=ke.reduce((se,Z)=>Z.allPaths?se.concat(Z.allPaths):se,[]);return Pe.length&&(pe.allPaths=Pe),pe}function T(me,De,ke){if(De===!1)return a;const le=d(me,ke);if(le===a)return a;if(typeof De=="boolean")return le;if(De){const pe=De.when;if(typeof pe=="string"){const re=(Pe,se,Z,j)=>{if(!j||!le(Pe,se))return null;const ie=pe.replace("$(basename)",()=>Z),ve=j(ie);return(0,F.$Kg)(ve)?ve.then(ne=>ne?me:null):ve?me:null};return re.requiresSiblings=!0,re}}return le}function G(me,De){const ke=me.filter(se=>!!se.basenames);if(ke.length<2)return me;const le=ke.reduce((se,Z)=>{const j=Z.basenames;return j?se.concat(j):se},[]);let pe;if(De){pe=[];for(let se=0,Z=le.length;se<Z;se++)pe.push(De)}else pe=ke.reduce((se,Z)=>{const j=Z.patterns;return j?se.concat(j):se},[]);const re=function(se,Z){if(typeof se!="string")return null;if(!Z){let ie;for(ie=se.length;ie>0;ie--){const ve=se.charCodeAt(ie-1);if(ve===47||ve===92)break}Z=se.substr(ie)}const j=le.indexOf(Z);return j!==-1?pe[j]:null};re.basenames=le,re.patterns=pe,re.allBasenames=le;const Pe=me.filter(se=>!se.basenames);return Pe.push(re),Pe}function de(me,De){return(0,y.$tb)(me,De,(ke,le)=>typeof ke=="string"&&typeof le=="string"?ke===le:typeof ke!="string"&&typeof le!="string"?ke.base===le.base&&ke.pattern===le.pattern:!1)}e.$Gj=de}),define(Ae[52],Re([1,0,11,125,25,12,2]),function(we,e,y,F,A,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.MarkdownStringTextNewlineStyle=void 0;var $;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})($||(e.MarkdownStringTextNewlineStyle=$={}));class E{constructor(i="",r=!1){if(this.value=i,typeof this.value!="string")throw(0,y.$6)("value");typeof r=="boolean"?(this.isTrusted=r,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=r.isTrusted??void 0,this.supportThemeIcons=r.supportThemeIcons??!1,this.supportHtml=r.supportHtml??!1)}appendText(i,r=0){return this.value+=u(this.supportThemeIcons?(0,F.$3j)(i):i).replace(/([ \t]+)/g,(c,o)=>"&nbsp;".repeat(o.length)).replace(/\>/gm,"\\>").replace(/\n/g,r===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,r){return this.value+="\n```",this.value+=i,this.value+=`
`,this.value+=r,this.value+="\n```\n",this}appendLink(i,r,c){return this.value+="[",this.value+=this.c(r,"]"),this.value+="](",this.value+=this.c(String(i),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(i,r){const c=new RegExp((0,M.$Je)(r),"g");return i.replace(c,(o,l)=>i.charAt(l-1)!=="\\"?`\\${o}`:o)}}e.$9j=E;function f(t){return P(t)?!t.value:Array.isArray(t)?t.every(f):!0}e.$0j=f;function P(t){return t instanceof E?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.$$j=P;function D(t,i){return t===i?!0:!t||!i?!1:t.value===i.value&&t.isTrusted===i.isTrusted&&t.supportThemeIcons===i.supportThemeIcons&&t.supportHtml===i.supportHtml&&(t.baseUri===i.baseUri||!!t.baseUri&&!!i.baseUri&&(0,A.$sg)(R.URI.from(t.baseUri),R.URI.from(i.baseUri)))}e.$_j=D;function u(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$ak=u;function b(t){return t.replace(/"/g,"&quot;")}e.$bk=b;function v(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$ck=v;function g(t){const i=[],r=t.split("|").map(o=>o.trim());t=r[0];const c=r[1];if(c){const o=/height=(\d+)/.exec(c),l=/width=(\d+)/.exec(c),n=o?o[1]:"",s=l?l[1]:"",a=isFinite(parseInt(s)),d=isFinite(parseInt(n));a&&i.push(`width="${s}"`),d&&i.push(`height="${n}"`)}return{href:t,dimensions:i}}e.$dk=g}),define(Ae[94],Re([1,0,18,46,20,21,25,12]),function(we,e,y,F,A,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hv=e.$Gv=e.$Fv=e.$Ev=e.$Dv=e.$Cv=e.$Bv=e.$Av=e.$zv=e.$yv=void 0;function E(d,p){const{os:m,tildify:S,relative:k}=p;if(k){const I=f(d,k,m);if(typeof I=="string")return I}let h=d.fsPath;if(m===1&&!M.$i?h=h.replace(/\//g,"\\"):m!==1&&M.$i&&(h=h.replace(/\\/g,"/")),m!==1&&S?.userHome){const I=S.userHome.fsPath;let L;d.scheme!==S.userHome.scheme&&d.path[0]===A.$fc.sep&&d.path[1]!==A.$fc.sep?L=S.userHome.with({path:d.path}).fsPath:L=h,h=u(L,I,m)}return(m===1?A.$ec:A.$fc).normalize(P(h,m===1))}e.$yv=E;function f(d,p,m){const S=m===1?A.$ec:A.$fc,k=m===3?R.$pg:R.$rg,h=p.getWorkspace(),w=(0,y.$Nb)(h.folders);if(!w)return;d.scheme!==w.uri.scheme&&d.path[0]===A.$fc.sep&&d.path[1]!==A.$fc.sep&&(d=w.uri.with({path:d.path}));const I=p.getWorkspaceFolder(d);if(!I)return;let L;if(k.isEqual(I.uri,d)?L="":L=k.relativePath(I.uri,d)??"",L&&(L=S.normalize(L)),h.folders.length>1&&!p.noPrefix){const V=I.name?I.name:k.basenameOrAuthority(I.uri);L=L?`${V} \u2022 ${L}`:V}return L}function P(d,p=M.$i){return(0,F.$6f)(d,p)?d.charAt(0).toUpperCase()+d.slice(1):d}e.$zv=P;let D=Object.create(null);function u(d,p,m=M.OS){if(m===1||!d||!p)return d;let S=D.original===p?D.normalized:void 0;S||(S=p,M.$i&&(S=(0,F.$Vf)(S)),S=`${(0,$.$Oe)(S,A.$fc.sep)}${A.$fc.sep}`,D={original:p,normalized:S});let k=d;return M.$i&&(k=(0,F.$Vf)(k)),(m===3?k.startsWith(S):(0,$.$7e)(k,S))?`~/${k.substr(S.length)}`:d}e.$Av=u;function b(d,p){return d.replace(/^~($|\/|\\)/,`${p}$1`)}e.$Bv=b;const v="\u2026",g="\\\\",t="~";function i(d,p=A.sep){const m=new Array(d.length);let S=!1;for(let k=0;k<d.length;k++){const h=d[k];if(h===""){m[k]=`.${p}`;continue}if(!h){m[k]=h;continue}S=!0;let w="",I=h;I.indexOf(g)===0?(w=I.substr(0,I.indexOf(g)+g.length),I=I.substr(I.indexOf(g)+g.length)):I.indexOf(p)===0?(w=I.substr(0,I.indexOf(p)+p.length),I=I.substr(I.indexOf(p)+p.length)):I.indexOf(t)===0&&(w=I.substr(0,I.indexOf(t)+t.length),I=I.substr(I.indexOf(t)+t.length));const L=I.split(p);for(let V=1;S&&V<=L.length;V++)for(let Y=L.length-V;S&&Y>=0;Y--){S=!1;let U=L.slice(Y,Y+V).join(p);for(let N=0;!S&&N<d.length;N++)if(N!==k&&d[N]&&d[N].indexOf(U)>-1){const C=Y+V===L.length,T=Y>0&&d[N].indexOf(p)>-1?p+U:U,G=d[N].endsWith(T);S=!C||G}if(!S){let N="";(L[0].endsWith(":")||w!=="")&&(Y===1&&(Y=0,V++,U=L[0]+p+U),Y>0&&(N=L[0]+p),N=w+N),Y>0&&(N=N+v+p),N=N+U,Y+V<L.length&&(N=N+p+v),m[k]=N}}S&&(m[k]=h)}return m}e.$Cv=i;var r;(function(d){d[d.TEXT=0]="TEXT",d[d.VARIABLE=1]="VARIABLE",d[d.SEPARATOR=2]="SEPARATOR"})(r||(r={}));function c(d,p=Object.create(null)){const m=[];let S=!1,k="";for(const h of d)if(h==="$"||S&&h==="{")k&&m.push({value:k,type:r.TEXT}),k="",S=!0;else if(h==="}"&&S){const w=p[k];if(typeof w=="string")w.length&&m.push({value:w,type:r.VARIABLE});else if(w){const I=m[m.length-1];(!I||I.type!==r.SEPARATOR)&&m.push({value:w.label,type:r.SEPARATOR})}k="",S=!1}else k+=h;return k&&!S&&m.push({value:k,type:r.TEXT}),m.filter((h,w)=>{if(h.type===r.SEPARATOR){const I=m[w-1],L=m[w+1];return[I,L].every(V=>V&&(V.type===r.VARIABLE||V.type===r.TEXT)&&V.value.length>0)}return!0}).map(h=>h.value).join("")}e.$Dv=c;function o(d,p){return M.$j||p?d.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$j?"&":"&&"):d.replace(/&&|&/g,m=>m==="&"?"&&":"&")}e.$Ev=o;function l(d,p){return M.$j||p?d.replace(/\(&&\w\)|&&/g,""):M.$i?d.replace(/&&|&/g,m=>m==="&"?"&&":"&"):d.replace(/&&/g,"_")}e.$Fv=l;function n(d){return d.replace(/&/g,"&&")}e.$Gv=n;function s(d){if(d.endsWith("]")){const p=d.lastIndexOf(" [",d.length-2);if(p!==-1){const m=a(d.substring(0,p));return{name:m.name,parentPath:m.parentPath+d.substring(p)}}}return a(d)}e.$Hv=s;function a(d){const p=d.indexOf("/")!==-1?A.$fc:A.$ec,m=p.basename(d),S=p.dirname(d);return m.length?{name:m,parentPath:S}:{name:S,parentPath:""}}}),define(Ae[139],Re([1,0,24,2]),function(we,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=e.$Um=e.$Tm=e.$Sm=e.$Rm=void 0;function A(D){return D.toJSON()}class M{constructor(u){this.a=u}transformIncoming(u){const b=this.a.transformIncoming(u);return b===u?u:A(F.URI.from(b))}transformOutgoing(u){const b=this.a.transformOutgoing(u);return b===u?u:A(F.URI.from(b))}transformOutgoingURI(u){const b=this.a.transformOutgoing(u);return b===u?u:F.URI.from(b)}transformOutgoingScheme(u){return this.a.transformOutgoingScheme(u)}}e.$Rm=M,e.$Sm=new class{transformIncoming(D){return D}transformOutgoing(D){return D}transformOutgoingURI(D){return D}transformOutgoingScheme(D){return D}};function R(D,u,b){if(!D||b>200)return null;if(typeof D=="object"){if(D instanceof F.URI)return u.transformOutgoing(D);for(const v in D)if(Object.hasOwnProperty.call(D,v)){const g=R(D[v],u,b+1);g!==null&&(D[v]=g)}}return null}function $(D,u){const b=R(D,u,0);return b===null?D:b}e.$Tm=$;function E(D,u,b,v){if(!D||v>200)return null;if(typeof D=="object"){if(D.$mid===1)return b?F.URI.revive(u.transformIncoming(D)):u.transformIncoming(D);if(D instanceof y.$fe)return null;for(const g in D)if(Object.hasOwnProperty.call(D,g)){const t=E(D[g],u,b,v+1);t!==null&&(D[g]=t)}}return null}function f(D,u){const b=E(D,u,!1,0);return b===null?D:b}e.$Um=f;function P(D,u){const b=E(D,u,!0,0);return b===null?D:b}e.$Vm=P}),define(Ae[140],Re([1,0,12,21,24]),function(we,e,y,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=e.$Ss=e.$Rs=void 0;let M;function R(){return M||(M=new TextDecoder("UTF-16LE")),M}let $;function E(){return $||($=new TextDecoder("UTF-16BE")),$}let f;function P(){return f||(f=F.$D()?R():E()),f}e.$Rs=P;function D(v,g,t){const i=new Uint16Array(v.buffer,g,t);return t>0&&(i[0]===65279||i[0]===65534)?u(v,g,t):R().decode(i)}e.$Ss=D;function u(v,g,t){const i=[];let r=0;for(let c=0;c<t;c++){const o=A.$he(v,g);g+=2,i[r++]=String.fromCharCode(o)}return i.join("")}class b{constructor(g){this.a=g|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const g=new Uint16Array(this.b.buffer,0,this.d);return P().decode(g)}f(){const g=this.e();this.d=0,this.c===null?this.c=[g]:this.c[this.c.length]=g}appendCharCode(g){const t=this.a-this.d;t<=1&&(t===0||y.$0e(g))&&this.f(),this.b[this.d++]=g}appendASCIICharCode(g){this.d===this.a&&this.f(),this.b[this.d++]=g}appendString(g){const t=g.length;if(this.d+t>=this.a){this.f(),this.c[this.c.length]=g;return}for(let i=0;i<t;i++)this.b[this.d++]=g.charCodeAt(i)}}e.$Ts=b}),define(Ae[141],Re([1,0,24,140]),function(we,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vs=e.$Us=void 0;function A(E){return E.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class M{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(f,P,D,u){this.oldPosition=f,this.oldText=P,this.newPosition=D,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${A(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${A(this.oldText)}")`:`(replace@${this.oldPosition} "${A(this.oldText)}" with "${A(this.newText)}")`}static a(f){return 4+2*f.length}static c(f,P,D){const u=P.length;y.$ke(f,u,D),D+=4;for(let b=0;b<u;b++)y.$ie(f,P.charCodeAt(b),D),D+=2;return D}static d(f,P){const D=y.$je(f,P);return P+=4,(0,F.$Ss)(f,P,D)}writeSize(){return 4+4+M.a(this.oldText)+M.a(this.newText)}write(f,P){return y.$ke(f,this.oldPosition,P),P+=4,y.$ke(f,this.newPosition,P),P+=4,P=M.c(f,this.oldText,P),P=M.c(f,this.newText,P),P}static read(f,P,D){const u=y.$je(f,P);P+=4;const b=y.$je(f,P);P+=4;const v=M.d(f,P);P+=M.a(v);const g=M.d(f,P);return P+=M.a(g),D.push(new M(u,v,b,g)),P}}e.$Us=M;function R(E,f){return E===null||E.length===0?f:new $(E,f).compress()}e.$Vs=R;class ${constructor(f,P){this.a=f,this.c=P,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let f=0,P=0,D=this.n(f),u=this.l(P);for(;f<this.f||P<this.h;){if(D===null){this.k(u),u=this.l(++P);continue}if(u===null){this.m(D),D=this.n(++f);continue}if(u.oldEnd<=D.newPosition){this.k(u),u=this.l(++P);continue}if(D.newEnd<=u.oldPosition){this.m(D),D=this.n(++f);continue}if(u.oldPosition<D.newPosition){const[i,r]=$.r(u,D.newPosition-u.oldPosition);this.k(i),u=r;continue}if(D.newPosition<u.oldPosition){const[i,r]=$.q(D,u.oldPosition-D.newPosition);this.m(i),D=r;continue}let g,t;if(u.oldEnd===D.newEnd)g=D,t=u,D=this.n(++f),u=this.l(++P);else if(u.oldEnd<D.newEnd){const[i,r]=$.q(D,u.oldLength);g=i,t=u,D=r,u=this.l(++P)}else{const[i,r]=$.r(u,D.newLength);g=D,t=i,D=this.n(++f),u=r}this.d[this.e++]=new M(g.oldPosition,g.oldText,t.newPosition,t.newText),this.g+=g.newLength-g.oldLength,this.j+=t.newLength-t.oldLength}const b=$.s(this.d);return $.t(b)}k(f){this.d[this.e++]=$.o(this.g,f),this.j+=f.newLength-f.oldLength}l(f){return f<this.h?this.c[f]:null}m(f){this.d[this.e++]=$.p(this.j,f),this.g+=f.newLength-f.oldLength}n(f){return f<this.f?this.a[f]:null}static o(f,P){return new M(P.oldPosition-f,P.oldText,P.newPosition,P.newText)}static p(f,P){return new M(P.oldPosition,P.oldText,P.newPosition+f,P.newText)}static q(f,P){const D=f.newText.substr(0,P),u=f.newText.substr(P);return[new M(f.oldPosition,f.oldText,f.newPosition,D),new M(f.oldEnd,"",f.newPosition+P,u)]}static r(f,P){const D=f.oldText.substr(0,P),u=f.oldText.substr(P);return[new M(f.oldPosition,D,f.newPosition,f.newText),new M(f.oldPosition+P,u,f.newEnd,"")]}static s(f){if(f.length===0)return f;const P=[];let D=0,u=f[0];for(let b=1;b<f.length;b++){const v=f[b];u.oldEnd===v.oldPosition?u=new M(u.oldPosition,u.oldText+v.oldText,u.newPosition,u.newText+v.newText):(P[D++]=u,u=v)}return P[D++]=u,P}static t(f){if(f.length===0)return f;const P=[];let D=0;for(let u=0;u<f.length;u++){const b=f[u];b.oldText!==b.newText&&(P[D++]=b)}return P}}}),define(Ae[142],Re([1,0,33,20]),function(we,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LE=void 0;function A(M,R,$,E,f,P){if(Array.isArray(M)){let D=0;for(const u of M){const b=A(u,R,$,E,f,P);if(b===10)return b;b>D&&(D=b)}return D}else{if(typeof M=="string")return E?M==="*"?5:M===$?10:0:0;if(M){const{language:D,pattern:u,scheme:b,hasAccessToAllModels:v,notebookType:g}=M;if(!E&&!v)return 0;g&&f&&(R=f);let t=0;if(b)if(b===R.scheme)t=10;else if(b==="*")t=5;else return 0;if(D)if(D===$)t=10;else if(D==="*")t=Math.max(t,5);else return 0;if(g)if(g===P)t=10;else if(g==="*"&&P!==void 0)t=Math.max(t,5);else return 0;if(u){let i;if(typeof u=="string"?i=u:i={...u,base:(0,F.$gc)(u.base)},i===R.fsPath||(0,y.$Bj)(i,R.fsPath))t=10;else return 0}return t}else return 0}}e.$LE=A}),define(Ae[143],Re([1,0,5,12,29,92,91,127,141,6]),function(we,e,y,F,A,M,R,$,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MB=void 0;class P extends f.$Rc{constructor(u,b,v,g,t,i,r){super(),this.m=this.B(new y.$Rd),this.onDidChangeContent=this.m.event,this.f=b,this.j=!i,this.g=g,this.h=t,this.c=new R.$LB(u,v,r)}equals(u){return!(u instanceof P)||this.f!==u.f||this.getEOL()!==u.getEOL()?!1:this.c.equal(u.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(u){return this.c.createSnapshot(u?this.f:"")}getOffsetAt(u,b){return this.c.getOffsetAt(u,b)}getPositionAt(u){return this.c.getPositionAt(u)}getRangeAt(u,b){const v=u+b,g=this.getPositionAt(u),t=this.getPositionAt(v);return new A.$zs(g.lineNumber,g.column,t.lineNumber,t.column)}getValueInRange(u,b=0){if(u.isEmpty())return"";const v=this.n(b);return this.c.getValueInRange(u,v)}getValueLengthInRange(u,b=0){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const v=this.getOffsetAt(u.startLineNumber,u.startColumn),g=this.getOffsetAt(u.endLineNumber,u.endColumn);let t=0;const i=this.n(b),r=this.getEOL();if(i.length!==r.length){const c=i.length-r.length,o=u.endLineNumber-u.startLineNumber;t=c*o}return g-v+t}getCharacterCountInRange(u,b=0){if(this.j){let v=0;const g=u.startLineNumber,t=u.endLineNumber;for(let i=g;i<=t;i++){const r=this.getLineContent(i),c=i===g?u.startColumn-1:0,o=i===t?u.endColumn-1:r.length;for(let l=c;l<o;l++)F.$0e(r.charCodeAt(l))?(v=v+1,l=l+1):v=v+1}return v+=this.n(b).length*(t-g),v}return this.getValueLengthInRange(u,b)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(u){return this.c.getLineContent(u)}getLineCharCode(u,b){return this.c.getLineCharCode(u,b)}getCharCode(u){return this.c.getCharCode(u)}getLineLength(u){return this.c.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const b=F.$Ue(this.getLineContent(u));return b===-1?0:b+1}getLineLastNonWhitespaceColumn(u){const b=F.$We(this.getLineContent(u));return b===-1?0:b+2}n(u){switch(u){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this.c.setEOL(u)}applyEdits(u,b,v){let g=this.g,t=this.h,i=this.j,r=!0,c=[];for(let p=0;p<u.length;p++){const m=u[p];r&&m._isTracked&&(r=!1);const S=m.range;if(m.text){let L=!0;i||(L=!F.$if(m.text),i=L),!g&&L&&(g=F.$hf(m.text)),!t&&L&&(t=F.$kf(m.text))}let k="",h=0,w=0,I=0;if(m.text){let L;[h,w,I,L]=(0,$.$_s)(m.text);const V=this.getEOL();L===0||L===(V===`\r
`?2:1)?k=m.text:k=m.text.replace(/\r\n|\r|\n/g,V)}c[p]={sortIndex:p,identifier:m.identifier||null,range:S,rangeOffset:this.getOffsetAt(S.startLineNumber,S.startColumn),rangeLength:this.getValueLengthInRange(S),text:k,eolCount:h,firstLineLength:w,lastLineLength:I,forceMoveMarkers:!!m.forceMoveMarkers,isAutoWhitespaceEdit:m.isAutoWhitespaceEdit||!1}}c.sort(P.u);let o=!1;for(let p=0,m=c.length-1;p<m;p++){const S=c[p].range.getEndPosition(),k=c[p+1].range.getStartPosition();if(k.isBeforeOrEqual(S)){if(k.isBefore(S))throw new Error("Overlapping ranges are not allowed!");o=!0}}r&&(c=this.s(c));const l=v||b?P._getInverseEditRanges(c):[],n=[];if(b)for(let p=0;p<c.length;p++){const m=c[p],S=l[p];if(m.isAutoWhitespaceEdit&&m.range.isEmpty())for(let k=S.startLineNumber;k<=S.endLineNumber;k++){let h="";k===S.startLineNumber&&(h=this.getLineContent(m.range.startLineNumber),F.$Ue(h)!==-1)||n.push({lineNumber:k,oldContent:h})}}let s=null;if(v){let p=0;s=[];for(let m=0;m<c.length;m++){const S=c[m],k=l[m],h=this.getValueInRange(S.range),w=S.rangeOffset+p;p+=S.text.length-h.length,s[m]={sortIndex:S.sortIndex,identifier:S.identifier,range:k,text:h,textChange:new E.$Us(S.rangeOffset,h,w,S.text)}}o||s.sort((m,S)=>m.sortIndex-S.sortIndex)}this.g=g,this.h=t,this.j=i;const a=this.t(c);let d=null;if(b&&n.length>0){n.sort((p,m)=>m.lineNumber-p.lineNumber),d=[];for(let p=0,m=n.length;p<m;p++){const S=n[p].lineNumber;if(p>0&&n[p-1].lineNumber===S)continue;const k=n[p].oldContent,h=this.getLineContent(S);h.length===0||h===k||F.$Ue(h)!==-1||d.push(S)}}return this.m.fire(),new M.$Uu(s,a,d)}s(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let b=!1;const v=u[0].range,g=u[u.length-1].range,t=new A.$zs(v.startLineNumber,v.startColumn,g.endLineNumber,g.endColumn);let i=v.startLineNumber,r=v.startColumn;const c=[];for(let a=0,d=u.length;a<d;a++){const p=u[a],m=p.range;b=b||p.forceMoveMarkers,c.push(this.getValueInRange(new A.$zs(i,r,m.startLineNumber,m.startColumn))),p.text.length>0&&c.push(p.text),i=m.endLineNumber,r=m.endColumn}const o=c.join(""),[l,n,s]=(0,$.$_s)(o);return{sortIndex:0,identifier:u[0].identifier,range:t,rangeOffset:this.getOffsetAt(t.startLineNumber,t.startColumn),rangeLength:this.getValueLengthInRange(t,0),text:o,eolCount:l,firstLineLength:n,lastLineLength:s,forceMoveMarkers:b,isAutoWhitespaceEdit:!1}}t(u){u.sort(P.w);const b=[];for(let v=0;v<u.length;v++){const g=u[v],t=g.range.startLineNumber,i=g.range.startColumn,r=g.range.endLineNumber,c=g.range.endColumn;if(t===r&&i===c&&g.text.length===0)continue;g.text?(this.c.delete(g.rangeOffset,g.rangeLength),this.c.insert(g.rangeOffset,g.text,!0)):this.c.delete(g.rangeOffset,g.rangeLength);const o=new A.$zs(t,i,r,c);b.push({range:o,rangeLength:g.rangeLength,text:g.text,rangeOffset:g.rangeOffset,forceMoveMarkers:g.forceMoveMarkers})}return b}findMatchesLineByLine(u,b,v,g){return this.c.findMatchesLineByLine(u,b,v,g)}getPieceTree(){return this.c}static _getInverseEditRange(u,b){const v=u.startLineNumber,g=u.startColumn,[t,i,r]=(0,$.$_s)(b);let c;if(b.length>0){const o=t+1;o===1?c=new A.$zs(v,g,v,g+i):c=new A.$zs(v,g,v+o-1,r+1)}else c=new A.$zs(v,g,v,g);return c}static _getInverseEditRanges(u){const b=[];let v=0,g=0,t=null;for(let i=0,r=u.length;i<r;i++){const c=u[i];let o,l;t?t.range.endLineNumber===c.range.startLineNumber?(o=v,l=g+(c.range.startColumn-t.range.endColumn)):(o=v+(c.range.startLineNumber-t.range.endLineNumber),l=c.range.startColumn):(o=c.range.startLineNumber,l=c.range.startColumn);let n;if(c.text.length>0){const s=c.eolCount+1;s===1?n=new A.$zs(o,l,o,l+c.firstLineLength):n=new A.$zs(o,l,o+s-1,c.lastLineLength+1)}else n=new A.$zs(o,l,o,l);v=n.endLineNumber,g=n.endColumn,b.push(n),t=c}return b}static u(u,b){const v=A.$zs.compareRangesUsingEnds(u.range,b.range);return v===0?u.sortIndex-b.sortIndex:v}static w(u,b){const v=A.$zs.compareRangesUsingEnds(u.range,b.range);return v===0?b.sortIndex-u.sortIndex:-v}}e.$MB=P}),define(Ae[144],Re([1,0,12,91,143]),function(we,e,y,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NB=void 0;class M{constructor(E,f,P,D,u,b,v,g,t){this.a=E,this.b=f,this.c=P,this.d=D,this.e=u,this.f=b,this.g=v,this.h=g,this.j=t}k(E){const f=this.c+this.d+this.e,P=this.c+this.e;return f===0?E===1?`
`:`\r
`:P>f/2?`\r
`:`
`}create(E){const f=this.k(E),P=this.a;if(this.j&&(f===`\r
`&&(this.c>0||this.d>0)||f===`
`&&(this.c>0||this.e>0)))for(let u=0,b=P.length;u<b;u++){const v=P[u].buffer.replace(/\r\n|\r|\n/g,f),g=(0,F.$HB)(v);P[u]=new F.$KB(v,g)}const D=new A.$MB(P,this.b,f,this.f,this.g,this.h,this.j);return{textBuffer:D,disposable:D}}getFirstLineText(E){return this.a[0].buffer.substr(0,E).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(E){if(E.length===0)return;this.a.length===0&&y.$qf(E)&&(this.b=y.$pf,E=E.substr(1));const f=E.charCodeAt(E.length-1);f===13||f>=55296&&f<=56319?(this.m(E.substr(0,E.length-1),!1),this.c=!0,this.d=f):(this.m(E,!1),this.c=!1,this.d=f)}m(E,f){!f&&E.length===0||(this.c?this.n(String.fromCharCode(this.d)+E):this.n(E))}n(E){const f=(0,F.$IB)(this.e,E);this.a.push(new F.$KB(E,f.lineStarts)),this.f+=f.cr,this.g+=f.lf,this.h+=f.crlf,f.isBasicASCII||(this.l=!1,this.j||(this.j=y.$hf(E)),this.k||(this.k=y.$kf(E)))}finish(E=!0){return this.o(),new M(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,E)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const E=this.a[this.a.length-1];E.buffer+=String.fromCharCode(this.d);const f=(0,F.$HB)(E.buffer);E.lineStarts=f,this.d===13&&this.f++}}}e.$NB=R}),define(Ae[95],Re([1,0,24,21]),function(we,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$20=e.$10=void 0;var A;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(A||(A={}));function M(D){for(let u=0,b=D.length;u<b;u+=4){const v=D[u+0],g=D[u+1],t=D[u+2],i=D[u+3];D[u+0]=i,D[u+1]=t,D[u+2]=g,D[u+3]=v}}function R(D){const u=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return F.$D()||M(u),y.$fe.wrap(u)}function $(D){const u=D.buffer;if(F.$D()||M(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const b=new Uint8Array(u.byteLength);return b.set(u),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function E(D){const u=new Uint32Array(f(D));let b=0;if(u[b++]=D.id,D.type==="full")u[b++]=1,u[b++]=D.data.length,u.set(D.data,b),b+=D.data.length;else{u[b++]=2,u[b++]=D.deltas.length;for(const v of D.deltas)u[b++]=v.start,u[b++]=v.deleteCount,v.data?(u[b++]=v.data.length,u.set(v.data,b),b+=v.data.length):u[b++]=0}return R(u)}e.$10=E;function f(D){let u=0;if(u+=1+1,D.type==="full")u+=1+D.data.length;else{u+=1,u+=(1+1+1)*D.deltas.length;for(const b of D.deltas)b.data&&(u+=b.data.length)}return u}function P(D){const u=$(D);let b=0;const v=u[b++];if(u[b++]===1){const r=u[b++],c=u.subarray(b,b+r);return b+=r,{id:v,type:"full",data:c}}const t=u[b++],i=[];for(let r=0;r<t;r++){const c=u[b++],o=u[b++],l=u[b++];let n;l>0&&(n=u.subarray(b,b+l),b+=l),i[r]={start:c,deleteCount:o,data:n}}return{id:v,type:"delta",deltas:i}}e.$20=P}),define(Ae[145],Re([9,10]),function(we,e){return we.create("vs/editor/common/config/editorOptions",e)}),define(Ae[146],Re([1,0,18,26,21,128,147,145]),function(we,e,y,F,A,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(E||(e.EditorAutoIndentStrategy=E={})),e.MINIMAP_GUTTER_WIDTH=8;class f{constructor(Q){this.c=Q}hasChanged(Q){return this.c[Q]}}e.ConfigurationChangedEvent=f;class P{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=P;class D{constructor(Q,Ee,je,He){this.id=Q,this.name=Ee,this.defaultValue=je,this.schema=He}applyUpdate(Q,Ee){return b(Q,Ee)}compute(Q,Ee,je){return je}}class u{constructor(Q,Ee){this.newValue=Q,this.didChange=Ee}}e.ApplyUpdateResult=u;function b(X,Q){if(typeof X!="object"||typeof Q!="object"||!X||!Q)return new u(Q,X!==Q);if(Array.isArray(X)||Array.isArray(Q)){const je=Array.isArray(X)&&Array.isArray(Q)&&y.$tb(X,Q);return new u(Q,!je)}let Ee=!1;for(const je in Q)if(Q.hasOwnProperty(je)){const He=b(X[je],Q[je]);He.didChange&&(X[je]=He.newValue,Ee=!0)}return new u(X,Ee)}class v{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,Ee){return b(Q,Ee)}validate(Q){return this.defaultValue}}class g{constructor(Q,Ee,je,He){this.id=Q,this.name=Ee,this.defaultValue=je,this.schema=He}applyUpdate(Q,Ee){return b(Q,Ee)}validate(Q){return typeof Q>"u"?this.defaultValue:Q}compute(Q,Ee,je){return je}}function t(X,Q){return typeof X>"u"?Q:X==="false"?!1:!!X}e.boolean=t;class i extends g{constructor(Q,Ee,je,He=void 0){typeof He<"u"&&(He.type="boolean",He.default=je),super(Q,Ee,je,He)}validate(Q){return t(Q,this.defaultValue)}}function r(X,Q,Ee,je){if(typeof X>"u")return Q;let He=parseInt(X,10);return isNaN(He)?Q:(He=Math.max(Ee,He),He=Math.min(je,He),He|0)}e.clampedInt=r;class c extends g{static clampedInt(Q,Ee,je,He){return r(Q,Ee,je,He)}constructor(Q,Ee,je,He,Xe,st=void 0){typeof st<"u"&&(st.type="integer",st.default=je,st.minimum=He,st.maximum=Xe),super(Q,Ee,je,st),this.minimum=He,this.maximum=Xe}validate(Q){return c.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}function o(X,Q,Ee,je){if(typeof X>"u")return Q;const He=l.float(X,Q);return l.clamp(He,Ee,je)}e.clampedFloat=o;class l extends g{static clamp(Q,Ee,je){return Q<Ee?Ee:Q>je?je:Q}static float(Q,Ee){if(typeof Q=="number")return Q;if(typeof Q>"u")return Ee;const je=parseFloat(Q);return isNaN(je)?Ee:je}constructor(Q,Ee,je,He,Xe){typeof Xe<"u"&&(Xe.type="number",Xe.default=je),super(Q,Ee,je,Xe),this.validationFn=He}validate(Q){return this.validationFn(l.float(Q,this.defaultValue))}}class n extends g{static string(Q,Ee){return typeof Q!="string"?Ee:Q}constructor(Q,Ee,je,He=void 0){typeof He<"u"&&(He.type="string",He.default=je),super(Q,Ee,je,He)}validate(Q){return n.string(Q,this.defaultValue)}}function s(X,Q,Ee,je){return typeof X!="string"?Q:je&&X in je?je[X]:Ee.indexOf(X)===-1?Q:X}e.stringSet=s;class a extends g{constructor(Q,Ee,je,He,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.enum=He,Xe.default=je),super(Q,Ee,je,Xe),this.c=He}validate(Q){return s(Q,this.defaultValue,this.c)}}class d extends D{constructor(Q,Ee,je,He,Xe,st,vt=void 0){typeof vt<"u"&&(vt.type="string",vt.enum=Xe,vt.default=He),super(Q,Ee,je,vt),this.c=Xe,this.d=st}validate(Q){return typeof Q!="string"?this.defaultValue:this.c.indexOf(Q)===-1?this.defaultValue:this.d(Q)}}function p(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class m extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[$.localize(0,null),$.localize(1,null),$.localize(2,null)],default:"auto",tags:["accessibility"],description:$.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,Ee,je){return je===0?Q.accessibilitySupport:je}}class S extends D{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:$.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:$.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{insertSpace:t(Ee.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(Ee.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var k;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(k||(e.TextEditorCursorBlinkingStyle=k={}));function h(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var w;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(w||(e.TextEditorCursorStyle=w={}));function I(X){switch(X){case w.Line:return"line";case w.Block:return"block";case w.Underline:return"underline";case w.LineThin:return"line-thin";case w.BlockOutline:return"block-outline";case w.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=I;function L(X){switch(X){case"line":return w.Line;case"block":return w.Block;case"underline":return w.Underline;case"line-thin":return w.LineThin;case"block-outline":return w.BlockOutline;case"underline-thin":return w.UnderlineThin}}class V extends v{constructor(){super(140)}compute(Q,Ee,je){const He=["monaco-editor"];return Ee.get(39)&&He.push(Ee.get(39)),Q.extraEditorClassName&&He.push(Q.extraEditorClassName),Ee.get(73)==="default"?He.push("mouse-default"):Ee.get(73)==="copy"&&He.push("mouse-copy"),Ee.get(110)&&He.push("showUnused"),Ee.get(138)&&He.push("showDeprecated"),He.join(" ")}}class Y extends i{constructor(){super(37,"emptySelectionClipboard",!0,{description:$.localize(6,null)})}compute(Q,Ee,je){return je&&Q.emptySelectionClipboard}}class U extends D{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:$.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[$.localize(8,null),$.localize(9,null),$.localize(10,null)],description:$.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[$.localize(12,null),$.localize(13,null),$.localize(14,null)],description:$.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:$.localize(16,null),included:A.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:$.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:$.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{cursorMoveOnType:t(Ee.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":s(Ee.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":s(Ee.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(Ee.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(Ee.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(Ee.loop,this.defaultValue.loop)}}}class N extends D{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",N.OFF,{anyOf:[{type:"boolean",description:$.localize(19,null)},{type:"string",description:$.localize(20,null)}],description:$.localize(21,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?N.OFF:Q==="true"?N.ON:Q:Q?N.ON:N.OFF}}e.EditorFontLigatures=N;class C extends D{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",C.OFF,{anyOf:[{type:"boolean",description:$.localize(22,null)},{type:"string",description:$.localize(23,null)}],description:$.localize(24,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?C.OFF:Q==="true"?C.TRANSLATE:Q:Q?C.TRANSLATE:C.OFF}compute(Q,Ee,je){return Q.fontInfo.fontVariationSettings}}e.EditorFontVariations=C;class T extends v{constructor(){super(50)}compute(Q,Ee,je){return Q.fontInfo}}class G extends g{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:$.localize(25,null)})}validate(Q){const Ee=l.float(Q,this.defaultValue);return Ee===0?e.EDITOR_FONT_DEFAULTS.fontSize:l.clamp(Ee,6,100)}compute(Q,Ee,je){return Q.fontInfo.fontSize}}class de extends D{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:de.d,maximum:de.e,errorMessage:$.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:de.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:$.localize(27,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(c.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,de.d,de.e))}}class me extends D{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ee={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[$.localize(28,null),$.localize(29,null),$.localize(30,null)]},je=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:$.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:$.localize(32,null),...Ee},"editor.gotoLocation.multipleTypeDefinitions":{description:$.localize(33,null),...Ee},"editor.gotoLocation.multipleDeclarations":{description:$.localize(34,null),...Ee},"editor.gotoLocation.multipleImplementations":{description:$.localize(35,null),...Ee},"editor.gotoLocation.multipleReferences":{description:$.localize(36,null),...Ee},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:je,description:$.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:je,description:$.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:je,description:$.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:je,description:$.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:je,description:$.localize(41,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{multiple:s(Ee.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ee.multipleDefinitions??s(Ee.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ee.multipleTypeDefinitions??s(Ee.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ee.multipleDeclarations??s(Ee.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ee.multipleImplementations??s(Ee.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ee.multipleReferences??s(Ee.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:n.string(Ee.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:n.string(Ee.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:n.string(Ee.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:n.string(Ee.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:n.string(Ee.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class De extends D{constructor(){const Q={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:$.localize(42,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:$.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:$.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Q.hidingDelay,description:$.localize(45,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:$.localize(46,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{enabled:t(Ee.enabled,this.defaultValue.enabled),delay:c.clampedInt(Ee.delay,this.defaultValue.delay,0,1e4),sticky:t(Ee.sticky,this.defaultValue.sticky),hidingDelay:c.clampedInt(Ee.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:t(Ee.above,this.defaultValue.above)}}}var ke;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(ke||(e.RenderMinimap=ke={}));class le extends v{constructor(){super(143)}compute(Q,Ee,je){return le.computeLayout(Ee,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio,glyphMarginDecorationLaneCount:Q.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Q){const Ee=Q.height/Q.lineHeight,je=Math.floor(Q.paddingTop/Q.lineHeight);let He=Math.floor(Q.paddingBottom/Q.lineHeight);Q.scrollBeyondLastLine&&(He=Math.max(He,Ee-1));const Xe=(je+Q.viewLineCount+He)/(Q.pixelRatio*Q.height),st=Math.floor(Q.viewLineCount/Xe);return{typicalViewportLineCount:Ee,extraLinesBeforeFirstLine:je,extraLinesBeyondLastLine:He,desiredRatio:Xe,minimapLineCount:st}}static c(Q,Ee){const je=Q.outerWidth,He=Q.outerHeight,Xe=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Xe*He),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:He};const st=Ee.stableMinimapLayoutInput,vt=st&&Q.outerHeight===st.outerHeight&&Q.lineHeight===st.lineHeight&&Q.typicalHalfwidthCharacterWidth===st.typicalHalfwidthCharacterWidth&&Q.pixelRatio===st.pixelRatio&&Q.scrollBeyondLastLine===st.scrollBeyondLastLine&&Q.paddingTop===st.paddingTop&&Q.paddingBottom===st.paddingBottom&&Q.minimap.enabled===st.minimap.enabled&&Q.minimap.side===st.minimap.side&&Q.minimap.size===st.minimap.size&&Q.minimap.showSlider===st.minimap.showSlider&&Q.minimap.renderCharacters===st.minimap.renderCharacters&&Q.minimap.maxColumn===st.minimap.maxColumn&&Q.minimap.scale===st.minimap.scale&&Q.verticalScrollbarWidth===st.verticalScrollbarWidth&&Q.isViewportWrapping===st.isViewportWrapping,Dt=Q.lineHeight,Oe=Q.typicalHalfwidthCharacterWidth,Kt=Q.scrollBeyondLastLine,Ht=Q.minimap.renderCharacters;let yt=Xe>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const Ut=Q.minimap.maxColumn,Ot=Q.minimap.size,Gt=Q.minimap.side,jt=Q.verticalScrollbarWidth,St=Q.viewLineCount,Lt=Q.remainingWidth,Vt=Q.isViewportWrapping,Ze=Ht?2:3;let Wt=Math.floor(Xe*He);const qt=Wt/Xe;let ct=!1,gt=!1,Nt=Ze*yt,Pt=yt/Xe,At=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:Jt,extraLinesBeforeFirstLine:Ce,extraLinesBeyondLastLine:Me,desiredRatio:be,minimapLineCount:K}=le.computeContainedMinimapLineCount({viewLineCount:St,scrollBeyondLastLine:Kt,paddingTop:Q.paddingTop,paddingBottom:Q.paddingBottom,height:He,lineHeight:Dt,pixelRatio:Xe});if(St/K>1)ct=!0,gt=!0,yt=1,Nt=1,Pt=yt/Xe;else{let Ue=!1,Qe=yt+1;if(Ot==="fit"){const qe=Math.ceil((Ce+St+Me)*Nt);Vt&&vt&&Lt<=Ee.stableFitRemainingWidth?(Ue=!0,Qe=Ee.stableFitMaxMinimapScale):Ue=qe>Wt}if(Ot==="fill"||Ue){ct=!0;const qe=yt;Nt=Math.min(Dt*Xe,Math.max(1,Math.floor(1/be))),Vt&&vt&&Lt<=Ee.stableFitRemainingWidth&&(Qe=Ee.stableFitMaxMinimapScale),yt=Math.min(Qe,Math.max(1,Math.floor(Nt/Ze))),yt>qe&&(At=Math.min(2,yt/qe)),Pt=yt/Xe/At,Wt=Math.ceil(Math.max(Jt,Ce+St+Me)*Nt),Vt?(Ee.stableMinimapLayoutInput=Q,Ee.stableFitRemainingWidth=Lt,Ee.stableFitMaxMinimapScale=yt):(Ee.stableMinimapLayoutInput=null,Ee.stableFitRemainingWidth=0)}}}const ft=Math.floor(Ut*Pt),kt=Math.min(ft,Math.max(0,Math.floor((Lt-jt-2)*Pt/(Oe+Pt)))+e.MINIMAP_GUTTER_WIDTH);let Rt=Math.floor(Xe*kt);const Ct=Rt/Xe;Rt=Math.floor(Rt*At);const We=Ht?1:2,zt=Gt==="left"?0:je-kt-jt;return{renderMinimap:We,minimapLeft:zt,minimapWidth:kt,minimapHeightIsEditorHeight:ct,minimapIsSampling:gt,minimapScale:yt,minimapLineHeight:Nt,minimapCanvasInnerWidth:Rt,minimapCanvasInnerHeight:Wt,minimapCanvasOuterWidth:Ct,minimapCanvasOuterHeight:qt}}static computeLayout(Q,Ee){const je=Ee.outerWidth|0,He=Ee.outerHeight|0,Xe=Ee.lineHeight|0,st=Ee.lineNumbersDigitCount|0,vt=Ee.typicalHalfwidthCharacterWidth,Dt=Ee.maxDigitWidth,Oe=Ee.pixelRatio,Kt=Ee.viewLineCount,Ht=Q.get(135),yt=Ht==="inherit"?Q.get(134):Ht,Ut=yt==="inherit"?Q.get(130):yt,Ot=Q.get(133),Gt=Ee.isDominatedByLongLines,jt=Q.get(57),St=Q.get(67).renderType!==0,Lt=Q.get(68),Vt=Q.get(104),Ze=Q.get(83),Wt=Q.get(72),qt=Q.get(102),ct=qt.verticalScrollbarSize,gt=qt.verticalHasArrows,Nt=qt.arrowSize,Pt=qt.horizontalScrollbarSize,At=Q.get(43),ft=Q.get(109)!=="never";let kt=Q.get(65);At&&ft&&(kt+=16);let Rt=0;if(St){const pt=Math.max(st,Lt);Rt=Math.round(pt*Dt)}let Ct=0;jt&&(Ct=Xe*Ee.glyphMarginDecorationLaneCount);let We=0,zt=We+Ct,Jt=zt+Rt,Ce=Jt+kt;const Me=je-Ct-Rt-kt;let be=!1,K=!1,Le=-1;yt==="inherit"&&Gt?(be=!0,K=!0):Ut==="on"||Ut==="bounded"?K=!0:Ut==="wordWrapColumn"&&(Le=Ot);const Ue=le.c({outerWidth:je,outerHeight:He,lineHeight:Xe,typicalHalfwidthCharacterWidth:vt,pixelRatio:Oe,scrollBeyondLastLine:Vt,paddingTop:Ze.top,paddingBottom:Ze.bottom,minimap:Wt,verticalScrollbarWidth:ct,viewLineCount:Kt,remainingWidth:Me,isViewportWrapping:K},Ee.memory||new P);Ue.renderMinimap!==0&&Ue.minimapLeft===0&&(We+=Ue.minimapWidth,zt+=Ue.minimapWidth,Jt+=Ue.minimapWidth,Ce+=Ue.minimapWidth);const Qe=Me-Ue.minimapWidth,qe=Math.max(1,Math.floor((Qe-ct-2)/vt)),it=gt?Nt:0;return K&&(Le=Math.max(1,qe),Ut==="bounded"&&(Le=Math.min(Le,Ot))),{width:je,height:He,glyphMarginLeft:We,glyphMarginWidth:Ct,glyphMarginDecorationLaneCount:Ee.glyphMarginDecorationLaneCount,lineNumbersLeft:zt,lineNumbersWidth:Rt,decorationsLeft:Jt,decorationsWidth:kt,contentLeft:Ce,contentWidth:Qe,minimap:Ue,viewportColumn:qe,isWordWrapMinified:be,isViewportWrapping:K,wrappingColumn:Le,verticalScrollbarWidth:ct,horizontalScrollbarHeight:Pt,overviewRuler:{top:it,width:ct,height:He-2*it,right:0}}}}e.EditorLayoutInfoComputer=le;class pe extends D{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[$.localize(47,null),$.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:$.localize(49,null)}})}validate(Q){return s(Q,"simple",["simple","advanced"])}compute(Q,Ee,je){return Ee.get(2)===2?"advanced":je}}class re extends D{constructor(){const Q={enabled:!0};super(64,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:$.localize(50,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:t(Q.enabled,this.defaultValue.enabled)}}}class Pe extends D{constructor(){const Q={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",Q,{"editor.stickyScroll.enabled":{type:"boolean",default:Q.enabled,description:$.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Q.maxLineCount,minimum:1,maximum:10,description:$.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Q.defaultModel,description:$.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Q.scrollWithEditor,description:$.localize(54,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{enabled:t(Ee.enabled,this.defaultValue.enabled),maxLineCount:c.clampedInt(Ee.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:s(Ee.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:t(Ee.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class se extends D{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:$.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[$.localize(56,null),$.localize(57,null,A.$j?"Ctrl+Option":"Ctrl+Alt"),$.localize(58,null,A.$j?"Ctrl+Option":"Ctrl+Alt"),$.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:$.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:$.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:$.localize(62,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return typeof Ee.enabled=="boolean"&&(Ee.enabled=Ee.enabled?"on":"off"),{enabled:s(Ee.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:c.clampedInt(Ee.fontSize,this.defaultValue.fontSize,0,100),fontFamily:n.string(Ee.fontFamily,this.defaultValue.fontFamily),padding:t(Ee.padding,this.defaultValue.padding)}}}class Z extends D{constructor(){super(65,"lineDecorationsWidth",10)}validate(Q){return typeof Q=="string"&&/^\d+(\.\d+)?ch$/.test(Q)?-parseFloat(Q.substring(0,Q.length-2)):c.clampedInt(Q,this.defaultValue,0,1e3)}compute(Q,Ee,je){return je<0?c.clampedInt(-je*Q.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):je}}class j extends l{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>l.clamp(Q,0,150),{markdownDescription:$.localize(63,null)})}compute(Q,Ee,je){return Q.fontInfo.lineHeight}}class ie extends D{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:$.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:$.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[$.localize(66,null),$.localize(67,null),$.localize(68,null)],default:Q.size,description:$.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:$.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:$.localize(71,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:$.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:$.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:$.localize(74,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{enabled:t(Ee.enabled,this.defaultValue.enabled),autohide:t(Ee.autohide,this.defaultValue.autohide),size:s(Ee.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(Ee.side,this.defaultValue.side,["right","left"]),showSlider:s(Ee.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(Ee.renderCharacters,this.defaultValue.renderCharacters),scale:c.clampedInt(Ee.scale,1,1,3),maxColumn:c.clampedInt(Ee.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ve(X){return X==="ctrlCmd"?A.$j?"metaKey":"ctrlKey":"altKey"}class ne extends D{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(76,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{top:c.clampedInt(Ee.top,0,0,1e3),bottom:c.clampedInt(Ee.bottom,0,0,1e3)}}}class he extends D{constructor(){const Q={enabled:!0,cycle:!0};super(85,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:$.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:$.localize(78,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{enabled:t(Ee.enabled,this.defaultValue.enabled),cycle:t(Ee.cycle,this.defaultValue.cycle)}}}class ce extends v{constructor(){super(141)}compute(Q,Ee,je){return Q.pixelRatio}}class ye extends D{constructor(){const Q={other:"on",comments:"off",strings:"off"},Ee=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[$.localize(79,null),$.localize(80,null),$.localize(81,null)]}];super(88,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ee,default:Q.strings,description:$.localize(82,null)},comments:{anyOf:Ee,default:Q.comments,description:$.localize(83,null)},other:{anyOf:Ee,default:Q.other,description:$.localize(84,null)}},default:Q,markdownDescription:$.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const Oe=Q?"on":"off";return{comments:Oe,strings:Oe,other:Oe}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:Ee,comments:je,strings:He}=Q,Xe=["on","inline","off"];let st,vt,Dt;return typeof Ee=="boolean"?st=Ee?"on":"off":st=s(Ee,this.defaultValue.other,Xe),typeof je=="boolean"?vt=je?"on":"off":vt=s(je,this.defaultValue.comments,Xe),typeof He=="boolean"?Dt=He?"on":"off":Dt=s(He,this.defaultValue.strings,Xe),{other:st,comments:vt,strings:Dt}}}var _;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(_||(e.RenderLineNumbersType=_={}));class fe extends D{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[$.localize(86,null),$.localize(87,null),$.localize(88,null),$.localize(89,null)],default:"on",description:$.localize(90,null)})}validate(Q){let Ee=this.defaultValue.renderType,je=this.defaultValue.renderFn;return typeof Q<"u"&&(typeof Q=="function"?(Ee=4,je=Q):Q==="interval"?Ee=3:Q==="relative"?Ee=2:Q==="on"?Ee=1:Ee=0),{renderType:Ee,renderFn:je}}}function te(X){const Q=X.get(97);return Q==="editable"?X.get(90):Q!=="on"}e.filterValidationDecorations=te;class ae extends D{constructor(){const Q=[],Ee={type:"number",description:$.localize(91,null)};super(101,"rulers",Q,{type:"array",items:{anyOf:[Ee,{type:["object"],properties:{column:Ee,color:{type:"string",description:$.localize(92,null),format:"color-hex"}}}]},default:Q,description:$.localize(93,null)})}validate(Q){if(Array.isArray(Q)){const Ee=[];for(const je of Q)if(typeof je=="number")Ee.push({column:c.clampedInt(je,0,0,1e4),color:null});else if(je&&typeof je=="object"){const He=je;Ee.push({column:c.clampedInt(He.column,0,0,1e4),color:He.color})}return Ee.sort((je,He)=>je.column-He.column),Ee}return this.defaultValue}}class $e extends D{constructor(){super(91,"readOnlyMessage",void 0)}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:Q}}function Ie(X,Q){if(typeof X!="string")return Q;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class O extends D{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(94,null),$.localize(95,null),$.localize(96,null)],default:"auto",description:$.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(98,null),$.localize(99,null),$.localize(100,null)],default:"auto",description:$.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:$.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:$.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:$.localize(104,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:Q.ignoreHorizontalScrollbarInContentHeight,description:$.localize(105,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q,je=c.clampedInt(Ee.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),He=c.clampedInt(Ee.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:c.clampedInt(Ee.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(Ee.vertical,this.defaultValue.vertical),horizontal:Ie(Ee.horizontal,this.defaultValue.horizontal),useShadows:t(Ee.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(Ee.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(Ee.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(Ee.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(Ee.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:je,horizontalSliderSize:c.clampedInt(Ee.horizontalSliderSize,je,0,1e3),verticalScrollbarSize:He,verticalSliderSize:c.clampedInt(Ee.verticalSliderSize,He,0,1e3),scrollByPage:t(Ee.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:t(Ee.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class W extends D{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:$.localize(106,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:$.localize(107,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:$.localize(108,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:$.localize(109,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:$.localize(110,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:$.localize(111,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:$.localize(112,null)}})}applyUpdate(Q,Ee){let je=!1;Ee.allowedCharacters&&Q&&(F.$en(Q.allowedCharacters,Ee.allowedCharacters)||(Q={...Q,allowedCharacters:Ee.allowedCharacters},je=!0)),Ee.allowedLocales&&Q&&(F.$en(Q.allowedLocales,Ee.allowedLocales)||(Q={...Q,allowedLocales:Ee.allowedLocales},je=!0));const He=super.applyUpdate(Q,Ee);return je?new u(He.newValue,!0):He}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{nonBasicASCII:x(Ee.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(Ee.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(Ee.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:x(Ee.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:x(Ee.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Q.allowedLocales,this.defaultValue.allowedLocales)}}c(Q,Ee){if(typeof Q!="object"||!Q)return Ee;const je={};for(const[He,Xe]of Object.entries(Q))Xe===!0&&(je[He]=!0);return je}}class H extends D{constructor(){const Q={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:$.localize(113,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Q.showToolbar,enum:["always","onHover"],enumDescriptions:[$.localize(114,null),$.localize(115,null)],description:$.localize(116,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Q.suppressSuggestions,description:$.localize(117,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{enabled:t(Ee.enabled,this.defaultValue.enabled),mode:s(Ee.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:s(Ee.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:t(Ee.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(Ee.keepOnBlur,this.defaultValue.keepOnBlur)}}}class J extends D{constructor(){const Q={enabled:M.$9r.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:M.$9r.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:$.localize(118,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:$.localize(119,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{enabled:t(Ee.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(Ee.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class q extends D{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(120,null),$.localize(121,null),$.localize(122,null)],default:Q.bracketPairs,description:$.localize(123,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(124,null),$.localize(125,null),$.localize(126,null)],default:Q.bracketPairsHorizontal,description:$.localize(127,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:$.localize(128,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:$.localize(129,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[$.localize(130,null),$.localize(131,null),$.localize(132,null)],default:Q.highlightActiveIndentation,description:$.localize(133,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{bracketPairs:x(Ee.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:x(Ee.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(Ee.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(Ee.indentation,this.defaultValue.indentation),highlightActiveIndentation:x(Ee.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function x(X,Q,Ee){const je=Ee.indexOf(X);return je===-1?Q:Ee[je]}class ue extends D{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[$.localize(134,null),$.localize(135,null)],default:Q.insertMode,description:$.localize(136,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:$.localize(137,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:$.localize(138,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:$.localize(139,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[$.localize(140,null),$.localize(141,null),$.localize(142,null),$.localize(143,null)],default:Q.selectionMode,markdownDescription:$.localize(144,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:$.localize(145,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:$.localize(146,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:$.localize(147,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:$.localize(148,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:$.localize(149,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:$.localize(150,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:$.localize(151,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:$.localize(152,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:$.localize(153,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:$.localize(154,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:$.localize(155,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:$.localize(156,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:$.localize(157,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:$.localize(158,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:$.localize(159,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:$.localize(160,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:$.localize(161,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:$.localize(162,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:$.localize(163,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:$.localize(164,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:$.localize(165,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:$.localize(166,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:$.localize(167,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:$.localize(168,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:$.localize(169,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:$.localize(170,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:$.localize(171,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:$.localize(172,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:$.localize(173,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:$.localize(174,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:$.localize(175,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:$.localize(176,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:$.localize(177,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:$.localize(178,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:$.localize(179,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:$.localize(180,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:$.localize(181,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{insertMode:s(Ee.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(Ee.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(Ee.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(Ee.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(Ee.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:s(Ee.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(Ee.showIcons,this.defaultValue.showIcons),showStatusBar:t(Ee.showStatusBar,this.defaultValue.showStatusBar),preview:t(Ee.preview,this.defaultValue.preview),previewMode:s(Ee.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(Ee.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(Ee.showMethods,this.defaultValue.showMethods),showFunctions:t(Ee.showFunctions,this.defaultValue.showFunctions),showConstructors:t(Ee.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(Ee.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(Ee.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(Ee.showFields,this.defaultValue.showFields),showVariables:t(Ee.showVariables,this.defaultValue.showVariables),showClasses:t(Ee.showClasses,this.defaultValue.showClasses),showStructs:t(Ee.showStructs,this.defaultValue.showStructs),showInterfaces:t(Ee.showInterfaces,this.defaultValue.showInterfaces),showModules:t(Ee.showModules,this.defaultValue.showModules),showProperties:t(Ee.showProperties,this.defaultValue.showProperties),showEvents:t(Ee.showEvents,this.defaultValue.showEvents),showOperators:t(Ee.showOperators,this.defaultValue.showOperators),showUnits:t(Ee.showUnits,this.defaultValue.showUnits),showValues:t(Ee.showValues,this.defaultValue.showValues),showConstants:t(Ee.showConstants,this.defaultValue.showConstants),showEnums:t(Ee.showEnums,this.defaultValue.showEnums),showEnumMembers:t(Ee.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(Ee.showKeywords,this.defaultValue.showKeywords),showWords:t(Ee.showWords,this.defaultValue.showWords),showColors:t(Ee.showColors,this.defaultValue.showColors),showFiles:t(Ee.showFiles,this.defaultValue.showFiles),showReferences:t(Ee.showReferences,this.defaultValue.showReferences),showFolders:t(Ee.showFolders,this.defaultValue.showFolders),showTypeParameters:t(Ee.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(Ee.showSnippets,this.defaultValue.showSnippets),showUsers:t(Ee.showUsers,this.defaultValue.showUsers),showIssues:t(Ee.showIssues,this.defaultValue.showIssues)}}}class Ne extends D{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:$.localize(182,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:$.localize(183,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:t(Q.selectSubwords,this.defaultValue.selectSubwords)}}}var Be;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(Be||(e.WrappingIndent=Be={}));class Ye extends D{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[$.localize(184,null),$.localize(185,null),$.localize(186,null),$.localize(187,null)],description:$.localize(188,null),default:"same"}})}validate(Q){switch(Q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Q,Ee,je){return Ee.get(2)===2?0:je}}class Je extends v{constructor(){super(144)}compute(Q,Ee,je){const He=Ee.get(143);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:He.isWordWrapMinified,isViewportWrapping:He.isViewportWrapping,wrappingColumn:He.wrappingColumn}}}class tt extends D{constructor(){const Q={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Q.enabled,markdownDescription:$.localize(189,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:$.localize(190,null),enum:["afterDrop","never"],enumDescriptions:[$.localize(191,null),$.localize(192,null)],default:"afterDrop"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{enabled:t(Ee.enabled,this.defaultValue.enabled),showDropSelector:s(Ee.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class _e extends D{constructor(){const Q={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",Q,{"editor.pasteAs.enabled":{type:"boolean",default:Q.enabled,markdownDescription:$.localize(193,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:$.localize(194,null),enum:["afterPaste","never"],enumDescriptions:[$.localize(195,null),$.localize(196,null)],default:"afterPaste"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{enabled:t(Ee.enabled,this.defaultValue.enabled),showPasteSelector:s(Ee.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const et="Consolas, 'Courier New', monospace",rt="Menlo, Monaco, 'Courier New', monospace",nt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:A.$j?rt:A.$k?nt:et,fontWeight:"normal",fontSize:A.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ze(X){return e.editorOptionsRegistry[X.id]=X,X}var dt;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.ariaRequired=5]="ariaRequired",X[X.autoClosingBrackets=6]="autoClosingBrackets",X[X.autoClosingComments=7]="autoClosingComments",X[X.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",X[X.autoClosingDelete=9]="autoClosingDelete",X[X.autoClosingOvertype=10]="autoClosingOvertype",X[X.autoClosingQuotes=11]="autoClosingQuotes",X[X.autoIndent=12]="autoIndent",X[X.automaticLayout=13]="automaticLayout",X[X.autoSurround=14]="autoSurround",X[X.bracketPairColorization=15]="bracketPairColorization",X[X.guides=16]="guides",X[X.codeLens=17]="codeLens",X[X.codeLensFontFamily=18]="codeLensFontFamily",X[X.codeLensFontSize=19]="codeLensFontSize",X[X.colorDecorators=20]="colorDecorators",X[X.colorDecoratorsLimit=21]="colorDecoratorsLimit",X[X.columnSelection=22]="columnSelection",X[X.comments=23]="comments",X[X.contextmenu=24]="contextmenu",X[X.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",X[X.cursorBlinking=26]="cursorBlinking",X[X.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",X[X.cursorStyle=28]="cursorStyle",X[X.cursorSurroundingLines=29]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",X[X.cursorWidth=31]="cursorWidth",X[X.disableLayerHinting=32]="disableLayerHinting",X[X.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",X[X.domReadOnly=34]="domReadOnly",X[X.dragAndDrop=35]="dragAndDrop",X[X.dropIntoEditor=36]="dropIntoEditor",X[X.emptySelectionClipboard=37]="emptySelectionClipboard",X[X.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",X[X.extraEditorClassName=39]="extraEditorClassName",X[X.fastScrollSensitivity=40]="fastScrollSensitivity",X[X.find=41]="find",X[X.fixedOverflowWidgets=42]="fixedOverflowWidgets",X[X.folding=43]="folding",X[X.foldingStrategy=44]="foldingStrategy",X[X.foldingHighlight=45]="foldingHighlight",X[X.foldingImportsByDefault=46]="foldingImportsByDefault",X[X.foldingMaximumRegions=47]="foldingMaximumRegions",X[X.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=49]="fontFamily",X[X.fontInfo=50]="fontInfo",X[X.fontLigatures=51]="fontLigatures",X[X.fontSize=52]="fontSize",X[X.fontWeight=53]="fontWeight",X[X.fontVariations=54]="fontVariations",X[X.formatOnPaste=55]="formatOnPaste",X[X.formatOnType=56]="formatOnType",X[X.glyphMargin=57]="glyphMargin",X[X.gotoLocation=58]="gotoLocation",X[X.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",X[X.hover=60]="hover",X[X.inDiffEditor=61]="inDiffEditor",X[X.inlineSuggest=62]="inlineSuggest",X[X.letterSpacing=63]="letterSpacing",X[X.lightbulb=64]="lightbulb",X[X.lineDecorationsWidth=65]="lineDecorationsWidth",X[X.lineHeight=66]="lineHeight",X[X.lineNumbers=67]="lineNumbers",X[X.lineNumbersMinChars=68]="lineNumbersMinChars",X[X.linkedEditing=69]="linkedEditing",X[X.links=70]="links",X[X.matchBrackets=71]="matchBrackets",X[X.minimap=72]="minimap",X[X.mouseStyle=73]="mouseStyle",X[X.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=75]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",X[X.multiCursorModifier=77]="multiCursorModifier",X[X.multiCursorPaste=78]="multiCursorPaste",X[X.multiCursorLimit=79]="multiCursorLimit",X[X.occurrencesHighlight=80]="occurrencesHighlight",X[X.overviewRulerBorder=81]="overviewRulerBorder",X[X.overviewRulerLanes=82]="overviewRulerLanes",X[X.padding=83]="padding",X[X.pasteAs=84]="pasteAs",X[X.parameterHints=85]="parameterHints",X[X.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",X[X.quickSuggestions=88]="quickSuggestions",X[X.quickSuggestionsDelay=89]="quickSuggestionsDelay",X[X.readOnly=90]="readOnly",X[X.readOnlyMessage=91]="readOnlyMessage",X[X.renameOnType=92]="renameOnType",X[X.renderControlCharacters=93]="renderControlCharacters",X[X.renderFinalNewline=94]="renderFinalNewline",X[X.renderLineHighlight=95]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=97]="renderValidationDecorations",X[X.renderWhitespace=98]="renderWhitespace",X[X.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",X[X.roundedSelection=100]="roundedSelection",X[X.rulers=101]="rulers",X[X.scrollbar=102]="scrollbar",X[X.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=104]="scrollBeyondLastLine",X[X.scrollPredominantAxis=105]="scrollPredominantAxis",X[X.selectionClipboard=106]="selectionClipboard",X[X.selectionHighlight=107]="selectionHighlight",X[X.selectOnLineNumbers=108]="selectOnLineNumbers",X[X.showFoldingControls=109]="showFoldingControls",X[X.showUnused=110]="showUnused",X[X.snippetSuggestions=111]="snippetSuggestions",X[X.smartSelect=112]="smartSelect",X[X.smoothScrolling=113]="smoothScrolling",X[X.stickyScroll=114]="stickyScroll",X[X.stickyTabStops=115]="stickyTabStops",X[X.stopRenderingLineAfter=116]="stopRenderingLineAfter",X[X.suggest=117]="suggest",X[X.suggestFontSize=118]="suggestFontSize",X[X.suggestLineHeight=119]="suggestLineHeight",X[X.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",X[X.suggestSelection=121]="suggestSelection",X[X.tabCompletion=122]="tabCompletion",X[X.tabIndex=123]="tabIndex",X[X.unicodeHighlighting=124]="unicodeHighlighting",X[X.unusualLineTerminators=125]="unusualLineTerminators",X[X.useShadowDOM=126]="useShadowDOM",X[X.useTabStops=127]="useTabStops",X[X.wordBreak=128]="wordBreak",X[X.wordSeparators=129]="wordSeparators",X[X.wordWrap=130]="wordWrap",X[X.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=133]="wordWrapColumn",X[X.wordWrapOverride1=134]="wordWrapOverride1",X[X.wordWrapOverride2=135]="wordWrapOverride2",X[X.wrappingIndent=136]="wrappingIndent",X[X.wrappingStrategy=137]="wrappingStrategy",X[X.showDeprecated=138]="showDeprecated",X[X.inlayHints=139]="inlayHints",X[X.editorClassName=140]="editorClassName",X[X.pixelRatio=141]="pixelRatio",X[X.tabFocusMode=142]="tabFocusMode",X[X.layoutInfo=143]="layoutInfo",X[X.wrappingInfo=144]="wrappingInfo",X[X.defaultColorDecorators=145]="defaultColorDecorators",X[X.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",X[X.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(dt||(e.EditorOption=dt={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ze(new i(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:$.localize(197,null)})),acceptSuggestionOnEnter:ze(new a(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",$.localize(198,null),""],markdownDescription:$.localize(199,null)})),accessibilitySupport:ze(new m),accessibilityPageSize:ze(new c(3,"accessibilityPageSize",10,1,1073741824,{description:$.localize(200,null),tags:["accessibility"]})),ariaLabel:ze(new n(4,"ariaLabel",$.localize(201,null))),ariaRequired:ze(new i(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:ze(new i(8,"screenReaderAnnounceInlineSuggestion",!0,{description:$.localize(202,null),tags:["accessibility"]})),autoClosingBrackets:ze(new a(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(203,null),$.localize(204,null),""],description:$.localize(205,null)})),autoClosingComments:ze(new a(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(206,null),$.localize(207,null),""],description:$.localize(208,null)})),autoClosingDelete:ze(new a(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",$.localize(209,null),""],description:$.localize(210,null)})),autoClosingOvertype:ze(new a(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",$.localize(211,null),""],description:$.localize(212,null)})),autoClosingQuotes:ze(new a(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(213,null),$.localize(214,null),""],description:$.localize(215,null)})),autoIndent:ze(new d(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],p,{enumDescriptions:[$.localize(216,null),$.localize(217,null),$.localize(218,null),$.localize(219,null),$.localize(220,null)],description:$.localize(221,null)})),automaticLayout:ze(new i(13,"automaticLayout",!1)),autoSurround:ze(new a(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[$.localize(222,null),$.localize(223,null),$.localize(224,null),""],description:$.localize(225,null)})),bracketPairColorization:ze(new J),bracketPairGuides:ze(new q),stickyTabStops:ze(new i(115,"stickyTabStops",!1,{description:$.localize(226,null)})),codeLens:ze(new i(17,"codeLens",!0,{description:$.localize(227,null)})),codeLensFontFamily:ze(new n(18,"codeLensFontFamily","",{description:$.localize(228,null)})),codeLensFontSize:ze(new c(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:$.localize(229,null)})),colorDecorators:ze(new i(20,"colorDecorators",!0,{description:$.localize(230,null)})),colorDecoratorActivatedOn:ze(new a(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[$.localize(231,null),$.localize(232,null),$.localize(233,null)],description:$.localize(234,null)})),colorDecoratorsLimit:ze(new c(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:$.localize(235,null)})),columnSelection:ze(new i(22,"columnSelection",!1,{description:$.localize(236,null)})),comments:ze(new S),contextmenu:ze(new i(24,"contextmenu",!0)),copyWithSyntaxHighlighting:ze(new i(25,"copyWithSyntaxHighlighting",!0,{description:$.localize(237,null)})),cursorBlinking:ze(new d(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],h,{description:$.localize(238,null)})),cursorSmoothCaretAnimation:ze(new a(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[$.localize(239,null),$.localize(240,null),$.localize(241,null)],description:$.localize(242,null)})),cursorStyle:ze(new d(28,"cursorStyle",w.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:$.localize(243,null)})),cursorSurroundingLines:ze(new c(29,"cursorSurroundingLines",0,0,1073741824,{description:$.localize(244,null)})),cursorSurroundingLinesStyle:ze(new a(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[$.localize(245,null),$.localize(246,null)],markdownDescription:$.localize(247,null)})),cursorWidth:ze(new c(31,"cursorWidth",0,0,1073741824,{markdownDescription:$.localize(248,null)})),disableLayerHinting:ze(new i(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:ze(new i(33,"disableMonospaceOptimizations",!1)),domReadOnly:ze(new i(34,"domReadOnly",!1)),dragAndDrop:ze(new i(35,"dragAndDrop",!0,{description:$.localize(249,null)})),emptySelectionClipboard:ze(new Y),dropIntoEditor:ze(new tt),stickyScroll:ze(new Pe),experimentalWhitespaceRendering:ze(new a(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[$.localize(250,null),$.localize(251,null),$.localize(252,null)],description:$.localize(253,null)})),extraEditorClassName:ze(new n(39,"extraEditorClassName","")),fastScrollSensitivity:ze(new l(40,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:$.localize(254,null)})),find:ze(new U),fixedOverflowWidgets:ze(new i(42,"fixedOverflowWidgets",!1)),folding:ze(new i(43,"folding",!0,{description:$.localize(255,null)})),foldingStrategy:ze(new a(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[$.localize(256,null),$.localize(257,null)],description:$.localize(258,null)})),foldingHighlight:ze(new i(45,"foldingHighlight",!0,{description:$.localize(259,null)})),foldingImportsByDefault:ze(new i(46,"foldingImportsByDefault",!1,{description:$.localize(260,null)})),foldingMaximumRegions:ze(new c(47,"foldingMaximumRegions",5e3,10,65e3,{description:$.localize(261,null)})),unfoldOnClickAfterEndOfLine:ze(new i(48,"unfoldOnClickAfterEndOfLine",!1,{description:$.localize(262,null)})),fontFamily:ze(new n(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:$.localize(263,null)})),fontInfo:ze(new T),fontLigatures2:ze(new N),fontSize:ze(new G),fontWeight:ze(new de),fontVariations:ze(new C),formatOnPaste:ze(new i(55,"formatOnPaste",!1,{description:$.localize(264,null)})),formatOnType:ze(new i(56,"formatOnType",!1,{description:$.localize(265,null)})),glyphMargin:ze(new i(57,"glyphMargin",!0,{description:$.localize(266,null)})),gotoLocation:ze(new me),hideCursorInOverviewRuler:ze(new i(59,"hideCursorInOverviewRuler",!1,{description:$.localize(267,null)})),hover:ze(new De),inDiffEditor:ze(new i(61,"inDiffEditor",!1)),letterSpacing:ze(new l(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>l.clamp(X,-5,20),{description:$.localize(268,null)})),lightbulb:ze(new re),lineDecorationsWidth:ze(new Z),lineHeight:ze(new j),lineNumbers:ze(new fe),lineNumbersMinChars:ze(new c(68,"lineNumbersMinChars",5,1,300)),linkedEditing:ze(new i(69,"linkedEditing",!1,{description:$.localize(269,null)})),links:ze(new i(70,"links",!0,{description:$.localize(270,null)})),matchBrackets:ze(new a(71,"matchBrackets","always",["always","near","never"],{description:$.localize(271,null)})),minimap:ze(new ie),mouseStyle:ze(new a(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ze(new l(74,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:$.localize(272,null)})),mouseWheelZoom:ze(new i(75,"mouseWheelZoom",!1,{markdownDescription:$.localize(273,null)})),multiCursorMergeOverlapping:ze(new i(76,"multiCursorMergeOverlapping",!0,{description:$.localize(274,null)})),multiCursorModifier:ze(new d(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ve,{markdownEnumDescriptions:[$.localize(275,null),$.localize(276,null)],markdownDescription:$.localize(277,null)})),multiCursorPaste:ze(new a(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[$.localize(278,null),$.localize(279,null)],markdownDescription:$.localize(280,null)})),multiCursorLimit:ze(new c(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:$.localize(281,null)})),occurrencesHighlight:ze(new a(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[$.localize(282,null),$.localize(283,null),$.localize(284,null)],markdownDescription:$.localize(285,null)})),overviewRulerBorder:ze(new i(81,"overviewRulerBorder",!0,{description:$.localize(286,null)})),overviewRulerLanes:ze(new c(82,"overviewRulerLanes",3,0,3)),padding:ze(new ne),pasteAs:ze(new _e),parameterHints:ze(new he),peekWidgetDefaultFocus:ze(new a(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[$.localize(287,null),$.localize(288,null)],description:$.localize(289,null)})),definitionLinkOpensInPeek:ze(new i(87,"definitionLinkOpensInPeek",!1,{description:$.localize(290,null)})),quickSuggestions:ze(new ye),quickSuggestionsDelay:ze(new c(89,"quickSuggestionsDelay",10,0,1073741824,{description:$.localize(291,null)})),readOnly:ze(new i(90,"readOnly",!1)),readOnlyMessage:ze(new $e),renameOnType:ze(new i(92,"renameOnType",!1,{description:$.localize(292,null),markdownDeprecationMessage:$.localize(293,null)})),renderControlCharacters:ze(new i(93,"renderControlCharacters",!0,{description:$.localize(294,null),restricted:!0})),renderFinalNewline:ze(new a(94,"renderFinalNewline",A.$k?"dimmed":"on",["off","on","dimmed"],{description:$.localize(295,null)})),renderLineHighlight:ze(new a(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",$.localize(296,null)],description:$.localize(297,null)})),renderLineHighlightOnlyWhenFocus:ze(new i(96,"renderLineHighlightOnlyWhenFocus",!1,{description:$.localize(298,null)})),renderValidationDecorations:ze(new a(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ze(new a(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",$.localize(299,null),$.localize(300,null),$.localize(301,null),""],description:$.localize(302,null)})),revealHorizontalRightPadding:ze(new c(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ze(new i(100,"roundedSelection",!0,{description:$.localize(303,null)})),rulers:ze(new ae),scrollbar:ze(new O),scrollBeyondLastColumn:ze(new c(103,"scrollBeyondLastColumn",4,0,1073741824,{description:$.localize(304,null)})),scrollBeyondLastLine:ze(new i(104,"scrollBeyondLastLine",!0,{description:$.localize(305,null)})),scrollPredominantAxis:ze(new i(105,"scrollPredominantAxis",!0,{description:$.localize(306,null)})),selectionClipboard:ze(new i(106,"selectionClipboard",!0,{description:$.localize(307,null),included:A.$k})),selectionHighlight:ze(new i(107,"selectionHighlight",!0,{description:$.localize(308,null)})),selectOnLineNumbers:ze(new i(108,"selectOnLineNumbers",!0)),showFoldingControls:ze(new a(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[$.localize(309,null),$.localize(310,null),$.localize(311,null)],description:$.localize(312,null)})),showUnused:ze(new i(110,"showUnused",!0,{description:$.localize(313,null)})),showDeprecated:ze(new i(138,"showDeprecated",!0,{description:$.localize(314,null)})),inlayHints:ze(new se),snippetSuggestions:ze(new a(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[$.localize(315,null),$.localize(316,null),$.localize(317,null),$.localize(318,null)],description:$.localize(319,null)})),smartSelect:ze(new Ne),smoothScrolling:ze(new i(113,"smoothScrolling",!1,{description:$.localize(320,null)})),stopRenderingLineAfter:ze(new c(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ze(new ue),inlineSuggest:ze(new H),inlineCompletionsAccessibilityVerbose:ze(new i(147,"inlineCompletionsAccessibilityVerbose",!1,{description:$.localize(321,null)})),suggestFontSize:ze(new c(118,"suggestFontSize",0,0,1e3,{markdownDescription:$.localize(322,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ze(new c(119,"suggestLineHeight",0,0,1e3,{markdownDescription:$.localize(323,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ze(new i(120,"suggestOnTriggerCharacters",!0,{description:$.localize(324,null)})),suggestSelection:ze(new a(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[$.localize(325,null),$.localize(326,null),$.localize(327,null)],description:$.localize(328,null)})),tabCompletion:ze(new a(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[$.localize(329,null),$.localize(330,null),$.localize(331,null)],description:$.localize(332,null)})),tabIndex:ze(new c(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:ze(new W),unusualLineTerminators:ze(new a(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[$.localize(333,null),$.localize(334,null),$.localize(335,null)],description:$.localize(336,null)})),useShadowDOM:ze(new i(126,"useShadowDOM",!0)),useTabStops:ze(new i(127,"useTabStops",!0,{description:$.localize(337,null)})),wordBreak:ze(new a(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[$.localize(338,null),$.localize(339,null)],description:$.localize(340,null)})),wordSeparators:ze(new n(129,"wordSeparators",R.$0r,{description:$.localize(341,null)})),wordWrap:ze(new a(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[$.localize(342,null),$.localize(343,null),$.localize(344,null),$.localize(345,null)],description:$.localize(346,null)})),wordWrapBreakAfterCharacters:ze(new n(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ze(new n(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ze(new c(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:$.localize(347,null)})),wordWrapOverride1:ze(new a(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ze(new a(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:ze(new V),defaultColorDecorators:ze(new i(145,"defaultColorDecorators",!1,{markdownDescription:$.localize(348,null)})),pixelRatio:ze(new ce),tabFocusMode:ze(new i(142,"tabFocusMode",!1,{markdownDescription:$.localize(349,null)})),layoutInfo:ze(new le),wrappingInfo:ze(new Je),wrappingIndent:ze(new Ye),wrappingStrategy:ze(new pe)}}),define(Ae[148],Re([9,10]),function(we,e){return we.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ae[149],Re([9,10]),function(we,e){return we.create("vs/platform/contextkey/common/contextkey",e)}),define(Ae[150],Re([9,10]),function(we,e){return we.create("vs/platform/contextkey/common/scanner",e)}),define(Ae[151],Re([9,10]),function(we,e){return we.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ae[152],Re([9,10]),function(we,e){return we.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ae[153],Re([9,10]),function(we,e){return we.create("vs/platform/files/common/files",e)}),define(Ae[154],Re([9,10]),function(we,e){return we.create("vs/platform/markers/common/markers",e)}),define(Ae[155],Re([9,10]),function(we,e){return we.create("vs/platform/theme/common/iconRegistry",e)}),define(Ae[156],Re([9,10]),function(we,e){return we.create("vs/platform/workspace/common/workspace",e)}),define(Ae[157],Re([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Ae[158],Re([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ae[159],Re([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ae[160],Re([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ae[161],Re([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostLogService",e)}),define(Ae[162],Re([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ae[163],Re([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostProgress",e)}),define(Ae[164],Re([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ae[165],Re([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ae[166],Re([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ae[167],Re([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ae[168],Re([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ae[169],Re([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ae[170],Re([9,10]),function(we,e){return we.create("vs/workbench/common/configuration",e)}),define(Ae[171],Re([9,10]),function(we,e){return we.create("vs/workbench/common/editor",e)}),define(Ae[172],Re([9,10]),function(we,e){return we.create("vs/workbench/common/views",e)}),define(Ae[173],Re([9,10]),function(we,e){return we.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ae[174],Re([9,10]),function(we,e){return we.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ae[175],Re([9,10]),function(we,e){return we.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ae[176],Re([9,10]),function(we,e){return we.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ae[177],Re([9,10]),function(we,e){return we.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ae[178],Re([9,10]),function(we,e){return we.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Ae[179],Re([9,10]),function(we,e){return we.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ae[180],Re([9,10]),function(we,e){return we.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ae[181],Re([1,0,11,150]),function(we,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.TokenType=void 0;var A;(function(f){f[f.LParen=0]="LParen",f[f.RParen=1]="RParen",f[f.Neg=2]="Neg",f[f.Eq=3]="Eq",f[f.NotEq=4]="NotEq",f[f.Lt=5]="Lt",f[f.LtEq=6]="LtEq",f[f.Gt=7]="Gt",f[f.GtEq=8]="GtEq",f[f.RegexOp=9]="RegexOp",f[f.RegexStr=10]="RegexStr",f[f.True=11]="True",f[f.False=12]="False",f[f.In=13]="In",f[f.Not=14]="Not",f[f.And=15]="And",f[f.Or=16]="Or",f[f.Str=17]="Str",f[f.QuotedStr=18]="QuotedStr",f[f.Error=19]="Error",f[f.EOF=20]="EOF"})(A||(e.TokenType=A={}));function M(...f){switch(f.length){case 1:return(0,F.localize)(0,null,f[0]);case 2:return(0,F.localize)(1,null,f[0],f[1]);case 3:return(0,F.localize)(2,null,f[0],f[1],f[2]);default:return}}const R=(0,F.localize)(3,null),$=(0,F.localize)(4,null);class E{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,y.$7)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const D=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:D})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const D=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:D})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const D=this.d,u=this.c.substring(this.d,this.e),b={type:19,offset:this.d,lexeme:u};this.g.push({offset:D,lexeme:u,additionalInfo:P}),this.f.push(b)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const D=this.c.substring(this.d,this.e),u=E.b.get(D);u?this.k(u):this.f.push({type:17,lexeme:D,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,D=!1,u=!1;for(;;){if(P>=this.c.length){this.e=P,this.l($);return}const v=this.c.charCodeAt(P);if(D)D=!1;else if(v===47&&!u){P++;break}else v===91?u=!0:v===92?D=!0:v===93&&(u=!1);P++}for(;P<this.c.length&&E.a.has(this.c.charCodeAt(P));)P++;this.e=P;const b=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:b,offset:this.d})}r(){return this.e>=this.c.length}}e.$Qi=E}),define(Ae[182],Re([1,0,25,31,152,294]),function(we,e,y,F,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,$=/^-(\d{4})(\d{2})(\d{2})$/;function E(i){return i=i.trim(),i==="*"||R.test(i)}e.$Ro=E;function f(i){if(!E(i))return null;if(i=i.trim(),i==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const r=i.match(R);return r?{hasCaret:r[1]==="^",hasGreaterEquals:r[1]===">=",majorBase:r[2]==="x"?0:parseInt(r[2],10),majorMustEqual:r[2]!=="x",minorBase:r[4]==="x"?0:parseInt(r[4],10),minorMustEqual:r[4]!=="x",patchBase:r[6]==="x"?0:parseInt(r[6],10),patchMustEqual:r[6]!=="x",preRelease:r[8]||null}:null}e.$So=f;function P(i){if(!i)return null;const r=i.majorBase,c=i.majorMustEqual,o=i.minorBase;let l=i.minorMustEqual;const n=i.patchBase;let s=i.patchMustEqual;i.hasCaret&&(r===0||(l=!1),s=!1);let a=0;if(i.preRelease){const d=$.exec(i.preRelease);if(d){const[,p,m,S]=d;a=Date.UTC(Number(p),Number(m)-1,Number(S))}}return{majorBase:r,majorMustEqual:c,minorBase:o,minorMustEqual:l,patchBase:n,patchMustEqual:s,isMinimum:i.hasGreaterEquals,notBefore:a}}e.$To=P;function D(i,r,c){let o;typeof i=="string"?o=P(f(i)):o=i;let l;r instanceof Date?l=r.getTime():typeof r=="string"&&(l=new Date(r).getTime());let n;if(typeof c=="string"?n=P(f(c)):n=c,!o||!n)return!1;const s=o.majorBase,a=o.minorBase,d=o.patchBase;let p=n.majorBase,m=n.minorBase,S=n.patchBase;const k=n.notBefore;let h=n.majorMustEqual,w=n.minorMustEqual,I=n.patchMustEqual;return n.isMinimum?s>p?!0:s<p?!1:a>m?!0:a<m||l&&l<k?!1:d>=S:(s===1&&p===0&&(!h||!w||!I)&&(p=1,m=0,S=0,h=!0,w=!1,I=!1),s<p?!1:s>p?!h:a<m?!1:a>m?!w:d<S?!1:d>S?!I:!(l&&l<k))}e.$Uo=D;function u(i,r,c,o,l){const n=[];if(typeof o.publisher<"u"&&typeof o.publisher!="string")return n.push([F.default.Error,A.localize(0,null)]),n;if(typeof o.name!="string")return n.push([F.default.Error,A.localize(1,null,"name")]),n;if(typeof o.version!="string")return n.push([F.default.Error,A.localize(2,null,"version")]),n;if(!o.engines)return n.push([F.default.Error,A.localize(3,null,"engines")]),n;if(typeof o.engines.vscode!="string")return n.push([F.default.Error,A.localize(4,null,"engines.vscode")]),n;if(typeof o.extensionDependencies<"u"&&!t(o.extensionDependencies))return n.push([F.default.Error,A.localize(5,null,"extensionDependencies")]),n;if(typeof o.activationEvents<"u"){if(!t(o.activationEvents))return n.push([F.default.Error,A.localize(6,null,"activationEvents")]),n;if(typeof o.main>"u"&&typeof o.browser>"u")return n.push([F.default.Error,A.localize(7,null,"activationEvents","main","browser")]),n}if(typeof o.extensionKind<"u"&&typeof o.main>"u"&&n.push([F.default.Warning,A.localize(8,null,"extensionKind")]),typeof o.main<"u"){if(typeof o.main!="string")return n.push([F.default.Error,A.localize(9,null,"main")]),n;{const d=(0,y.$zg)(c,o.main);(0,y.$tg)(d,c)||n.push([F.default.Warning,A.localize(10,null,d.path,c.path)])}}if(typeof o.browser<"u"){if(typeof o.browser!="string")return n.push([F.default.Error,A.localize(11,null,"browser")]),n;{const d=(0,y.$zg)(c,o.browser);(0,y.$tg)(d,c)||n.push([F.default.Warning,A.localize(12,null,d.path,c.path)])}}if(!M.valid(o.version))return n.push([F.default.Error,A.localize(13,null)]),n;const s=[];if(!b(i,r,o,l,s))for(const d of s)n.push([F.default.Error,d]);return n}e.$Vo=u;function b(i,r,c,o,l){return o||typeof c.main>"u"&&typeof c.browser>"u"?!0:g(i,r,c.engines.vscode,l)}e.$Wo=b;function v(i,r,c){return i==="*"||g(r,c,i)}e.$Xo=v;function g(i,r,c,o=[]){const l=P(f(c));if(!l)return o.push(A.localize(14,null,c)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return o.push(A.localize(15,null,c)),!1}else if(!l.majorMustEqual)return o.push(A.localize(16,null,c)),!1;return D(i,r,l)?!0:(o.push(A.localize(17,null,i,c)),!1)}function t(i){if(!Array.isArray(i))return!1;for(let r=0,c=i.length;r<c;r++)if(typeof i[r]!="string")return!1;return!0}}),define(Ae[69],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sh=void 0;class y{constructor(A,M=[],R=!1){this.ctor=A,this.staticArguments=M,this.supportsDelayedInstantiation=R}}e.$Sh=y}),define(Ae[70],Re([1,0,69]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=e.$Cr=e.InstantiationType=void 0;const F=[];var A;(function($){$[$.Eager=0]="Eager",$[$.Delayed=1]="Delayed"})(A||(e.InstantiationType=A={}));function M($,E,f){E instanceof y.$Sh||(E=new y.$Sh(E,[],!!f)),F.push([$,E])}e.$Cr=M;function R(){return F}e.$Dr=R}),define(Ae[183],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=e.$hq=void 0;class y{constructor(M,R){this.key=M,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$hq=y;class F{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const R of this.a.values())R.outgoing.size===0&&M.push(R);return M}insertEdge(M,R){const $=this.lookupOrInsertNode(M),E=this.lookupOrInsertNode(R);$.outgoing.set(E.key,E),E.incoming.set($.key,$)}removeNode(M){const R=this.b(M);this.a.delete(R);for(const $ of this.a.values())$.outgoing.delete(R),$.incoming.delete(R)}lookupOrInsertNode(M){const R=this.b(M);let $=this.a.get(R);return $||($=new y(R,M),this.a.set(R,$)),$}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[R,$]of this.a)M.push(`${R}
	(-> incoming)[${[...$.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...$.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,R]of this.a){const $=new Set([M]),E=this.c(R,$);if(E)return E}}c(M,R){for(const[$,E]of M.outgoing){if(R.has($))return[...R,$].join(" -> ");R.add($);const f=this.c(E,R);if(f)return f;R.delete($)}}}e.$iq=F}),define(Ae[4],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wh=e.$Vh=e.$Uh=e._util=void 0;var y;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function $(E){return E[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=$})(y||(e._util=y={})),e.$Uh=A("instantiationService");function F(R,$,E){$[y.DI_TARGET]===$?$[y.DI_DEPENDENCIES].push({id:R,index:E}):($[y.DI_DEPENDENCIES]=[{id:R,index:E}],$[y.DI_TARGET]=$)}function A(R){if(y.serviceIds.has(R))return y.serviceIds.get(R);const $=function(E,f,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F($,E,P)};return $.toString=()=>R,y.serviceIds.set(R,$),$}e.$Vh=A;function M(R){return R}e.$Wh=M}),define(Ae[40],Re([1,0,16,2,4]),function(we,e,y,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.ConfigurationTarget=e.$ri=e.$qi=e.$pi=void 0,e.$pi=(0,A.$Vh)("configurationService");function M(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof F.URI)}e.$qi=M;function R(i){return i&&typeof i=="object"&&(!i.overrideIdentifiers||Array.isArray(i.overrideIdentifiers))&&!i.overrideIdentifier&&(!i.resource||i.resource instanceof F.URI)}e.$ri=R;var $;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.USER=2]="USER",i[i.USER_LOCAL=3]="USER_LOCAL",i[i.USER_REMOTE=4]="USER_REMOTE",i[i.WORKSPACE=5]="WORKSPACE",i[i.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",i[i.DEFAULT=7]="DEFAULT",i[i.MEMORY=8]="MEMORY"})($||(e.ConfigurationTarget=$={}));function E(i){switch(i){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$si=E;function f(i){return i.applicationValue!==void 0||i.userValue!==void 0||i.userLocalValue!==void 0||i.userRemoteValue!==void 0||i.workspaceValue!==void 0||i.workspaceFolderValue!==void 0}e.$ti=f;function P(i,r){const c=Object.create(null);for(const o in i)D(c,o,i[o],r);return c}e.$ui=P;function D(i,r,c,o){const l=r.split("."),n=l.pop();let s=i;for(let a=0;a<l.length;a++){const d=l[a];let p=s[d];switch(typeof p){case"undefined":p=s[d]=Object.create(null);break;case"object":break;default:o(`Ignoring ${r} as ${l.slice(0,a+1).join(".")} is ${JSON.stringify(p)}`);return}s=p}if(typeof s=="object"&&s!==null)try{s[n]=c}catch{o(`Ignoring ${r} as ${l.join(".")} is ${JSON.stringify(s)}`)}else o(`Ignoring ${r} as ${l.join(".")} is ${JSON.stringify(s)}`)}e.$vi=D;function u(i,r){const c=r.split(".");b(i,c)}e.$wi=u;function b(i,r){const c=r.shift();if(r.length===0){delete i[c];return}if(Object.keys(i).indexOf(c)!==-1){const o=i[c];typeof o=="object"&&!Array.isArray(o)&&(b(o,r),Object.keys(o).length===0&&delete i[c])}}function v(i,r,c){function o(s,a){let d=s;for(const p of a){if(typeof d!="object"||d===null)return;d=d[p]}return d}const l=r.split("."),n=o(i,l);return typeof n>"u"?c:n}e.$xi=v;function g(i,r,c){Object.keys(r).forEach(o=>{o!=="__proto__"&&(o in i?y.$Ef(i[o])&&y.$Ef(r[o])?g(i[o],r[o],c):c&&(i[o]=r[o]):i[o]=r[o])})}e.$yi=g;function t(i){return i.replace(/[\[\]]/g,"")}e.$zi=t}),define(Ae[34],Re([1,0,21,12,181,4,149,11]),function(we,e,y,F,A,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.ContextKeyExprType=e.$Ri=void 0;const E=new Map;E.set("false",!1),E.set("true",!0),E.set("isMac",y.$j),E.set("isLinux",y.$k),E.set("isWindows",y.$i),E.set("isWeb",y.$o),E.set("isMacNative",y.$j&&!y.$o),E.set("isEdge",y.$H),E.set("isFirefox",y.$F),E.set("isChrome",y.$E),E.set("isSafari",y.$G);function f(Z,j){if(E.get(Z)!==void 0)throw(0,$.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");E.set(Z,j)}e.$Ri=f;const P=Object.prototype.hasOwnProperty;var D;(function(Z){Z[Z.False=0]="False",Z[Z.True=1]="True",Z[Z.Defined=2]="Defined",Z[Z.Not=3]="Not",Z[Z.Equals=4]="Equals",Z[Z.NotEquals=5]="NotEquals",Z[Z.And=6]="And",Z[Z.Regex=7]="Regex",Z[Z.NotRegex=8]="NotRegex",Z[Z.Or=9]="Or",Z[Z.In=10]="In",Z[Z.NotIn=11]="NotIn",Z[Z.Greater=12]="Greater",Z[Z.GreaterEquals=13]="GreaterEquals",Z[Z.Smaller=14]="Smaller",Z[Z.SmallerEquals=15]="SmallerEquals"})(D||(e.ContextKeyExprType=D={}));const u={regexParsingWithErrorRecovery:!0},b=(0,R.localize)(0,null),v=(0,R.localize)(1,null),g=(0,R.localize)(2,null),t=(0,R.localize)(3,null),i=(0,R.localize)(4,null),r=(0,R.localize)(5,null),c=(0,R.localize)(6,null),o=(0,R.localize)(7,null);class l{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(j=u){this.k=j,this.d=new A.$Qi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(j){if(j===""){this.h.push({message:b,offset:0,lexeme:"",additionalInfo:v});return}this.f=this.d.reset(j).scan(),this.g=0,this.h=[];try{const ie=this.l();if(!this.E()){const ve=this.D(),ne=ve.type===17?r:void 0;throw this.h.push({message:i,offset:ve.offset,lexeme:A.$Qi.getLexeme(ve),additionalInfo:ne}),l.c}return ie}catch(ie){if(ie!==l.c)throw ie;return}}l(){return this.m()}m(){const j=[this.o()];for(;this.y(16);){const ie=this.o();j.push(ie)}return j.length===1?j[0]:n.or(...j)}o(){const j=[this.s()];for(;this.y(15);){const ie=this.s();j.push(ie)}return j.length===1?j[0]:n.and(...j)}s(){if(this.y(2)){const j=this.D();switch(j.type){case 11:return this.z(),p.INSTANCE;case 12:return this.z(),m.INSTANCE;case 0:{this.z();const ie=this.l();return this.A(1,t),ie?.negate()}case 17:return this.z(),L.create(j.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",j)}}return this.t()}t(){const j=this.D();switch(j.type){case 11:return this.z(),n.true();case 12:return this.z(),n.false();case 0:{this.z();const ie=this.l();return this.A(1,t),ie}case 17:{const ie=j.lexeme;if(this.z(),this.y(9)){const ne=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ne.type!==10)throw this.B("REGEX",ne);const he=ne.lexeme,ce=he.lastIndexOf("/"),ye=ce===he.length-1?void 0:this.w(he.substring(ce+1));let _;try{_=new RegExp(he.substring(1,ce),ye)}catch{throw this.B("REGEX",ne)}return T.create(ie,_)}switch(ne.type){case 10:case 19:{const he=[ne.lexeme];this.z();let ce=this.D(),ye=0;for(let $e=0;$e<ne.lexeme.length;$e++)ne.lexeme.charCodeAt($e)===40?ye++:ne.lexeme.charCodeAt($e)===41&&ye--;for(;!this.E()&&ce.type!==15&&ce.type!==16;){switch(ce.type){case 0:ye++;break;case 1:ye--;break;case 10:case 18:for(let $e=0;$e<ce.lexeme.length;$e++)ce.lexeme.charCodeAt($e)===40?ye++:ne.lexeme.charCodeAt($e)===41&&ye--}if(ye<0)break;he.push(A.$Qi.getLexeme(ce)),this.z(),ce=this.D()}const _=he.join(""),fe=_.lastIndexOf("/"),te=fe===_.length-1?void 0:this.w(_.substring(fe+1));let ae;try{ae=new RegExp(_.substring(1,fe),te)}catch{throw this.B("REGEX",ne)}return n.regex(ie,ae)}case 18:{const he=ne.lexeme;this.z();let ce=null;if(!(0,F.$Fe)(he)){const ye=he.indexOf("/"),_=he.lastIndexOf("/");if(ye!==_&&ye>=0){const fe=he.slice(ye+1,_),te=he[_+1]==="i"?"i":"";try{ce=new RegExp(fe,te)}catch{throw this.B("REGEX",ne)}}}if(ce===null)throw this.B("REGEX",ne);return T.create(ie,ce)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,g);const ne=this.u();return n.notIn(ie,ne)}switch(this.D().type){case 3:{this.z();const ne=this.u();if(this.x().type===18)return n.equals(ie,ne);switch(ne){case"true":return n.has(ie);case"false":return n.not(ie);default:return n.equals(ie,ne)}}case 4:{this.z();const ne=this.u();if(this.x().type===18)return n.notEquals(ie,ne);switch(ne){case"true":return n.not(ie);case"false":return n.has(ie);default:return n.notEquals(ie,ne)}}case 5:return this.z(),N.create(ie,this.u());case 6:return this.z(),C.create(ie,this.u());case 7:return this.z(),Y.create(ie,this.u());case 8:return this.z(),U.create(ie,this.u());case 13:return this.z(),n.in(ie,this.u());default:return n.has(ie)}}case 20:throw this.h.push({message:c,offset:j.offset,lexeme:"",additionalInfo:o}),l.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const j=this.D();switch(j.type){case 17:case 18:return this.z(),j.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(j){return j.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(j){return this.C(j)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(j,ie){if(this.C(j))return this.z();throw this.B(ie,this.D())}B(j,ie,ve){const ne=(0,R.localize)(8,null,j,A.$Qi.getLexeme(ie)),he=ie.offset,ce=A.$Qi.getLexeme(ie);return this.h.push({message:ne,offset:he,lexeme:ce,additionalInfo:ve}),l.c}C(j){return this.D().type===j}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Si=l;class n{static false(){return p.INSTANCE}static true(){return m.INSTANCE}static has(j){return S.create(j)}static equals(j,ie){return k.create(j,ie)}static notEquals(j,ie){return I.create(j,ie)}static regex(j,ie){return T.create(j,ie)}static in(j,ie){return h.create(j,ie)}static notIn(j,ie){return w.create(j,ie)}static not(j){return L.create(j)}static and(...j){return me.create(j,null,!0)}static or(...j){return De.create(j,null,!0)}static greater(j,ie){return Y.create(j,ie)}static greaterEquals(j,ie){return U.create(j,ie)}static smaller(j,ie){return N.create(j,ie)}static smallerEquals(j,ie){return C.create(j,ie)}static{this.c=new l({regexParsingWithErrorRecovery:!1})}static deserialize(j){return j==null?void 0:this.c.parse(j)}}e.$Ti=n;function s(Z){const j=new l({regexParsingWithErrorRecovery:!1});return Z.map(ie=>(j.parse(ie),j.lexingErrors.length>0?j.lexingErrors.map(ve=>({errorMessage:ve.additionalInfo?(0,R.localize)(9,null,ve.additionalInfo):(0,R.localize)(10,null),offset:ve.offset,length:ve.lexeme.length})):j.parsingErrors.length>0?j.parsingErrors.map(ve=>({errorMessage:ve.additionalInfo?`${ve.message}. ${ve.additionalInfo}`:ve.message,offset:ve.offset,length:ve.lexeme.length})):[]))}e.$Ui=s;function a(Z,j){const ie=Z?Z.substituteConstants():void 0,ve=j?j.substituteConstants():void 0;return!ie&&!ve?!0:!ie||!ve?!1:ie.equals(ve)}e.$Vi=a;function d(Z,j){return Z.cmp(j)}class p{static{this.INSTANCE=new p}constructor(){this.type=0}cmp(j){return this.type-j.type}equals(j){return j.type===this.type}substituteConstants(){return this}evaluate(j){return!1}serialize(){return"false"}keys(){return[]}map(j){return this}negate(){return m.INSTANCE}}e.$Wi=p;class m{static{this.INSTANCE=new m}constructor(){this.type=1}cmp(j){return this.type-j.type}equals(j){return j.type===this.type}substituteConstants(){return this}evaluate(j){return!0}serialize(){return"true"}keys(){return[]}map(j){return this}negate(){return p.INSTANCE}}e.$Xi=m;class S{static create(j,ie=null){const ve=E.get(j);return typeof ve=="boolean"?ve?m.INSTANCE:p.INSTANCE:new S(j,ie)}constructor(j,ie){this.key=j,this.c=ie,this.type=2}cmp(j){return j.type!==this.type?this.type-j.type:le(this.key,j.key)}equals(j){return j.type===this.type?this.key===j.key:!1}substituteConstants(){const j=E.get(this.key);return typeof j=="boolean"?j?m.INSTANCE:p.INSTANCE:this}evaluate(j){return!!j.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(j){return j.mapDefined(this.key)}negate(){return this.c||(this.c=L.create(this.key,this)),this.c}}e.$Yi=S;class k{static create(j,ie,ve=null){if(typeof ie=="boolean")return ie?S.create(j,ve):L.create(j,ve);const ne=E.get(j);return typeof ne=="boolean"?ie===(ne?"true":"false")?m.INSTANCE:p.INSTANCE:new k(j,ie,ve)}constructor(j,ie,ve){this.c=j,this.d=ie,this.f=ve,this.type=4}cmp(j){return j.type!==this.type?this.type-j.type:pe(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){const j=E.get(this.c);if(typeof j=="boolean"){const ie=j?"true":"false";return this.d===ie?m.INSTANCE:p.INSTANCE}return this}evaluate(j){return j.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(j){return j.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$Zi=k;class h{static create(j,ie){return new h(j,ie)}constructor(j,ie){this.d=j,this.f=ie,this.type=10,this.c=null}cmp(j){return j.type!==this.type?this.type-j.type:pe(this.d,this.f,j.d,j.f)}equals(j){return j.type===this.type?this.d===j.d&&this.f===j.f:!1}substituteConstants(){return this}evaluate(j){const ie=j.getValue(this.f),ve=j.getValue(this.d);return Array.isArray(ie)?ie.includes(ve):typeof ve=="string"&&typeof ie=="object"&&ie!==null?P.call(ie,ve):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(j){return j.mapIn(this.d,this.f)}negate(){return this.c||(this.c=w.create(this.d,this.f)),this.c}}e.$1i=h;class w{static create(j,ie){return new w(j,ie)}constructor(j,ie){this.d=j,this.f=ie,this.type=11,this.c=h.create(j,ie)}cmp(j){return j.type!==this.type?this.type-j.type:this.c.cmp(j.c)}equals(j){return j.type===this.type?this.c.equals(j.c):!1}substituteConstants(){return this}evaluate(j){return!this.c.evaluate(j)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(j){return j.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$2i=w;class I{static create(j,ie,ve=null){if(typeof ie=="boolean")return ie?L.create(j,ve):S.create(j,ve);const ne=E.get(j);return typeof ne=="boolean"?ie===(ne?"true":"false")?p.INSTANCE:m.INSTANCE:new I(j,ie,ve)}constructor(j,ie,ve){this.c=j,this.d=ie,this.f=ve,this.type=5}cmp(j){return j.type!==this.type?this.type-j.type:pe(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){const j=E.get(this.c);if(typeof j=="boolean"){const ie=j?"true":"false";return this.d===ie?p.INSTANCE:m.INSTANCE}return this}evaluate(j){return j.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(j){return j.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$3i=I;class L{static create(j,ie=null){const ve=E.get(j);return typeof ve=="boolean"?ve?p.INSTANCE:m.INSTANCE:new L(j,ie)}constructor(j,ie){this.c=j,this.d=ie,this.type=3}cmp(j){return j.type!==this.type?this.type-j.type:le(this.c,j.c)}equals(j){return j.type===this.type?this.c===j.c:!1}substituteConstants(){const j=E.get(this.c);return typeof j=="boolean"?j?p.INSTANCE:m.INSTANCE:this}evaluate(j){return!j.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(j){return j.mapNot(this.c)}negate(){return this.d||(this.d=S.create(this.c,this)),this.d}}e.$4i=L;function V(Z,j){if(typeof Z=="string"){const ie=parseFloat(Z);isNaN(ie)||(Z=ie)}return typeof Z=="string"||typeof Z=="number"?j(Z):p.INSTANCE}class Y{static create(j,ie,ve=null){return V(ie,ne=>new Y(j,ne,ve))}constructor(j,ie,ve){this.c=j,this.d=ie,this.f=ve,this.type=12}cmp(j){return j.type!==this.type?this.type-j.type:pe(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(j){return j.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$5i=Y;class U{static create(j,ie,ve=null){return V(ie,ne=>new U(j,ne,ve))}constructor(j,ie,ve){this.c=j,this.d=ie,this.f=ve,this.type=13}cmp(j){return j.type!==this.type?this.type-j.type:pe(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(j){return j.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$6i=U;class N{static create(j,ie,ve=null){return V(ie,ne=>new N(j,ne,ve))}constructor(j,ie,ve){this.c=j,this.d=ie,this.f=ve,this.type=14}cmp(j){return j.type!==this.type?this.type-j.type:pe(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(j){return j.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$7i=N;class C{static create(j,ie,ve=null){return V(ie,ne=>new C(j,ne,ve))}constructor(j,ie,ve){this.c=j,this.d=ie,this.f=ve,this.type=15}cmp(j){return j.type!==this.type?this.type-j.type:pe(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(j){return j.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}e.$8i=C;class T{static create(j,ie){return new T(j,ie)}constructor(j,ie){this.d=j,this.f=ie,this.type=7,this.c=null}cmp(j){if(j.type!==this.type)return this.type-j.type;if(this.d<j.d)return-1;if(this.d>j.d)return 1;const ie=this.f?this.f.source:"",ve=j.f?j.f.source:"";return ie<ve?-1:ie>ve?1:0}equals(j){if(j.type===this.type){const ie=this.f?this.f.source:"",ve=j.f?j.f.source:"";return this.d===j.d&&ie===ve}return!1}substituteConstants(){return this}evaluate(j){const ie=j.getValue(this.d);return this.f?this.f.test(ie):!1}serialize(){const j=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${j}`}keys(){return[this.d]}map(j){return j.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=G.create(this)),this.c}}e.$9i=T;class G{static create(j){return new G(j)}constructor(j){this.c=j,this.type=8}cmp(j){return j.type!==this.type?this.type-j.type:this.c.cmp(j.c)}equals(j){return j.type===this.type?this.c.equals(j.c):!1}substituteConstants(){return this}evaluate(j){return!this.c.evaluate(j)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(j){return new G(this.c.map(j))}negate(){return this.c}}e.$0i=G;function de(Z){let j=null;for(let ie=0,ve=Z.length;ie<ve;ie++){const ne=Z[ie].substituteConstants();if(Z[ie]!==ne&&j===null){j=[];for(let he=0;he<ie;he++)j[he]=Z[he]}j!==null&&(j[ie]=ne)}return j===null?Z:j}class me{static create(j,ie,ve){return me.d(j,ie,ve)}constructor(j,ie){this.expr=j,this.c=ie,this.type=6}cmp(j){if(j.type!==this.type)return this.type-j.type;if(this.expr.length<j.expr.length)return-1;if(this.expr.length>j.expr.length)return 1;for(let ie=0,ve=this.expr.length;ie<ve;ie++){const ne=d(this.expr[ie],j.expr[ie]);if(ne!==0)return ne}return 0}equals(j){if(j.type===this.type){if(this.expr.length!==j.expr.length)return!1;for(let ie=0,ve=this.expr.length;ie<ve;ie++)if(!this.expr[ie].equals(j.expr[ie]))return!1;return!0}return!1}substituteConstants(){const j=de(this.expr);return j===this.expr?this:me.create(j,this.c,!1)}evaluate(j){for(let ie=0,ve=this.expr.length;ie<ve;ie++)if(!this.expr[ie].evaluate(j))return!1;return!0}static d(j,ie,ve){const ne=[];let he=!1;for(const ce of j)if(ce){if(ce.type===1){he=!0;continue}if(ce.type===0)return p.INSTANCE;if(ce.type===6){ne.push(...ce.expr);continue}ne.push(ce)}if(ne.length===0&&he)return m.INSTANCE;if(ne.length!==0){if(ne.length===1)return ne[0];ne.sort(d);for(let ce=1;ce<ne.length;ce++)ne[ce-1].equals(ne[ce])&&(ne.splice(ce,1),ce--);if(ne.length===1)return ne[0];for(;ne.length>1;){const ce=ne[ne.length-1];if(ce.type!==9)break;ne.pop();const ye=ne.pop(),_=ne.length===0,fe=De.create(ce.expr.map(te=>me.create([te,ye],null,ve)),null,_);fe&&(ne.push(fe),ne.sort(d))}if(ne.length===1)return ne[0];if(ve){for(let ce=0;ce<ne.length;ce++)for(let ye=ce+1;ye<ne.length;ye++)if(ne[ce].negate().equals(ne[ye]))return p.INSTANCE;if(ne.length===1)return ne[0]}return new me(ne,ie)}}serialize(){return this.expr.map(j=>j.serialize()).join(" && ")}keys(){const j=[];for(const ie of this.expr)j.push(...ie.keys());return j}map(j){return new me(this.expr.map(ie=>ie.map(j)),null)}negate(){if(!this.c){const j=[];for(const ie of this.expr)j.push(ie.negate());this.c=De.create(j,this,!0)}return this.c}}e.$$i=me;class De{static create(j,ie,ve){return De.d(j,ie,ve)}constructor(j,ie){this.expr=j,this.c=ie,this.type=9}cmp(j){if(j.type!==this.type)return this.type-j.type;if(this.expr.length<j.expr.length)return-1;if(this.expr.length>j.expr.length)return 1;for(let ie=0,ve=this.expr.length;ie<ve;ie++){const ne=d(this.expr[ie],j.expr[ie]);if(ne!==0)return ne}return 0}equals(j){if(j.type===this.type){if(this.expr.length!==j.expr.length)return!1;for(let ie=0,ve=this.expr.length;ie<ve;ie++)if(!this.expr[ie].equals(j.expr[ie]))return!1;return!0}return!1}substituteConstants(){const j=de(this.expr);return j===this.expr?this:De.create(j,this.c,!1)}evaluate(j){for(let ie=0,ve=this.expr.length;ie<ve;ie++)if(this.expr[ie].evaluate(j))return!0;return!1}static d(j,ie,ve){let ne=[],he=!1;if(j){for(let ce=0,ye=j.length;ce<ye;ce++){const _=j[ce];if(_){if(_.type===0){he=!0;continue}if(_.type===1)return m.INSTANCE;if(_.type===9){ne=ne.concat(_.expr);continue}ne.push(_)}}if(ne.length===0&&he)return p.INSTANCE;ne.sort(d)}if(ne.length!==0){if(ne.length===1)return ne[0];for(let ce=1;ce<ne.length;ce++)ne[ce-1].equals(ne[ce])&&(ne.splice(ce,1),ce--);if(ne.length===1)return ne[0];if(ve){for(let ce=0;ce<ne.length;ce++)for(let ye=ce+1;ye<ne.length;ye++)if(ne[ce].negate().equals(ne[ye]))return m.INSTANCE;if(ne.length===1)return ne[0]}return new De(ne,ie)}}serialize(){return this.expr.map(j=>j.serialize()).join(" || ")}keys(){const j=[];for(const ie of this.expr)j.push(...ie.keys());return j}map(j){return new De(this.expr.map(ie=>ie.map(j)),null)}negate(){if(!this.c){const j=[];for(const ie of this.expr)j.push(ie.negate());for(;j.length>1;){const ie=j.shift(),ve=j.shift(),ne=[];for(const he of se(ie))for(const ce of se(ve))ne.push(me.create([he,ce],null,!1));j.unshift(De.create(ne,null,!1))}this.c=De.create(j,this,!0)}return this.c}}e.$_i=De;class ke extends S{static{this.d=[]}static all(){return ke.d.values()}constructor(j,ie,ve){super(j,null),this.f=ie,typeof ve=="object"?ke.d.push({...ve,key:j}):ve!==!0&&ke.d.push({key:j,description:ve,type:ie!=null?typeof ie:void 0})}bindTo(j){return j.createKey(this.key,this.f)}getValue(j){return j.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(j){return k.create(this.key,j)}notEqualsTo(j){return I.create(this.key,j)}}e.$aj=ke,e.$bj=(0,M.$Vh)("contextKeyService");function le(Z,j){return Z<j?-1:Z>j?1:0}function pe(Z,j,ie,ve){return Z<ie?-1:Z>ie?1:j<ve?-1:j>ve?1:0}function re(Z,j){if(Z.type===0||j.type===1)return!0;if(Z.type===9)return j.type===9?Pe(Z.expr,j.expr):!1;if(j.type===9){for(const ie of j.expr)if(re(Z,ie))return!0;return!1}if(Z.type===6){if(j.type===6)return Pe(j.expr,Z.expr);for(const ie of Z.expr)if(re(ie,j))return!0;return!1}return Z.equals(j)}e.$cj=re;function Pe(Z,j){let ie=0,ve=0;for(;ie<Z.length&&ve<j.length;){const ne=Z[ie].cmp(j[ve]);if(ne<0)return!1;ne===0&&ie++,ve++}return ie===Z.length}function se(Z){return Z.type===9?Z.expr:[Z]}}),define(Ae[184],Re([1,0,4]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$3h=void 0,e.$3h=(0,y.$Vh)("environmentService"),e.$4h=(0,y.$Wh)(e.$3h)}),define(Ae[96],Re([1,0,151,4]),function(we,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$do=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=void 0,e.$4n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$5n=new RegExp(e.$4n),e.$6n="__web_extension",e.$7n="skipWalkthrough",e.$8n="extensionsSync",e.$9n="dependecyOrPackExtensionInstall";function A(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$0n=A;function M(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$$n=M;function R(i,r){switch(i){case 3:return r==="x64"?"win32-x64":r==="arm64"?"win32-arm64":"unknown";case 2:return r==="x64"?"linux-x64":r==="arm64"?"linux-arm64":r==="arm"?"linux-armhf":"unknown";case"alpine":return r==="x64"?"alpine-x64":r==="arm64"?"alpine-arm64":"unknown";case 1:return r==="x64"?"darwin-x64":r==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$_n=R;function $(i,r){return r==="web"&&!i.includes("web")}e.$ao=$;function E(i,r,c){return $(r,c)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===c}e.$bo=E;function f(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.$co=f;var P;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(P||(e.SortBy=P={}));var D;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(D||(e.SortOrder=D={}));var u;(function(i){i.Install="install",i.Uninstall="uninstall"})(u||(e.StatisticType=u={}));var b;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(b||(e.InstallOperation=b={})),e.$do=(0,F.$Vh)("extensionGalleryService");var v;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.Extract="Extract",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));var g;(function(i){i.UnknownError="UnknownError",i.PackageIsInvalidZip="PackageIsInvalidZip",i.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(g||(e.ExtensionSignaturetErrorCode=g={}));class t extends Error{constructor(r,c){super(r),this.code=c,this.name=c}}e.$eo=t,e.$fo=(0,F.$Vh)("extensionManagementService"),e.$go="extensionsIdentifiers/disabled",e.$ho="extensionsIdentifiers/enabled",e.$io=(0,F.$Vh)("IGlobalExtensionEnablementService"),e.$jo=(0,F.$Vh)("IExtensionTipsService"),e.$ko=(0,y.localize)(0,null),e.$lo={value:e.$ko,original:"Extensions"},e.$mo={value:(0,y.localize)(1,null),original:"Preferences"}}),define(Ae[41],Re([1,0,50,20,12,16,2,153,4,21,13,44]),function(we,e,y,F,A,M,R,$,E,f,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.FileKind=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.FileOperationResult=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.FileChangeType=e.$wk=e.FileOperation=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.FileSystemProviderErrorCode=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.FileSystemProviderCapabilities=e.$gk=e.FilePermission=e.FileType=e.$fk=e.$ek=void 0,e.$ek=(0,E.$Vh)("fileService");function u(re){return re.create===!0}e.$fk=u;var b;(function(re){re[re.Unknown=0]="Unknown",re[re.File=1]="File",re[re.Directory=2]="Directory",re[re.SymbolicLink=64]="SymbolicLink"})(b||(e.FileType=b={}));var v;(function(re){re[re.Readonly=1]="Readonly",re[re.Locked=2]="Locked"})(v||(e.FilePermission=v={}));function g(re){const Pe=re;return!!Pe&&typeof Pe.onDidChange=="function"}e.$gk=g;var t;(function(re){re[re.None=0]="None",re[re.FileReadWrite=2]="FileReadWrite",re[re.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",re[re.FileReadStream=16]="FileReadStream",re[re.FileFolderCopy=8]="FileFolderCopy",re[re.PathCaseSensitive=1024]="PathCaseSensitive",re[re.Readonly=2048]="Readonly",re[re.Trash=4096]="Trash",re[re.FileWriteUnlock=8192]="FileWriteUnlock",re[re.FileAtomicRead=16384]="FileAtomicRead",re[re.FileAtomicWrite=32768]="FileAtomicWrite",re[re.FileAtomicDelete=65536]="FileAtomicDelete",re[re.FileClone=131072]="FileClone"})(t||(e.FileSystemProviderCapabilities=t={}));function i(re){return!!(re.capabilities&2)}e.$hk=i;function r(re){return!!(re.capabilities&8)}e.$ik=r;function c(re){return!!(re.capabilities&131072)}e.$jk=c;function o(re){return!!(re.capabilities&4)}e.$kk=o;function l(re){return!!(re.capabilities&16)}e.$lk=l;function n(re){return i(re)?!!(re.capabilities&16384):!1}e.$mk=n;function s(re){return i(re)?!!(re.capabilities&32768):!1}e.$nk=s;function a(re){return!!(re.capabilities&65536)}e.$ok=a;function d(re){return!!(re.capabilities&2048)}e.$pk=d;var p;(function(re){re.FileExists="EntryExists",re.FileNotFound="EntryNotFound",re.FileNotADirectory="EntryNotADirectory",re.FileIsADirectory="EntryIsADirectory",re.FileExceedsStorageQuota="EntryExceedsStorageQuota",re.FileTooLarge="EntryTooLarge",re.FileWriteLocked="EntryWriteLocked",re.NoPermissions="NoPermissions",re.Unavailable="Unavailable",re.Unknown="Unknown"})(p||(e.FileSystemProviderErrorCode=p={}));class m extends Error{static create(Pe,se){const Z=new m(Pe.toString(),se);return h(Z,se),Z}constructor(Pe,se){super(Pe),this.code=se}}e.$qk=m;function S(re,Pe){return m.create(re,Pe)}e.$rk=S;function k(re){return re||S((0,$.localize)(0,null),p.Unknown)}e.$sk=k;function h(re,Pe){return re.name=Pe?`${Pe} (FileSystemError)`:"FileSystemError",re}e.$tk=h;function w(re){if(!re)return p.Unknown;if(re instanceof m)return re.code;const Pe=/^(.+) \(FileSystemError\)$/.exec(re.name);if(!Pe)return p.Unknown;switch(Pe[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}e.$uk=w;function I(re){if(re instanceof C)return re.fileOperationResult;switch(w(re)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 9;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileTooLarge:return 7;default:return 10}}e.$vk=I;var L;(function(re){re[re.CREATE=0]="CREATE",re[re.DELETE=1]="DELETE",re[re.MOVE=2]="MOVE",re[re.COPY=3]="COPY",re[re.WRITE=4]="WRITE"})(L||(e.FileOperation=L={}));class V{constructor(Pe,se,Z){this.resource=Pe,this.operation=se,this.target=Z}isOperation(Pe){return this.operation===Pe}}e.$wk=V;var Y;(function(re){re[re.UPDATED=0]="UPDATED",re[re.ADDED=1]="ADDED",re[re.DELETED=2]="DELETED"})(Y||(e.FileChangeType=Y={}));class U{static{this.a=null}constructor(Pe,se){this.c=se,this.b=void 0,this.d=new D.$U(()=>{const Z=y.$2h.forUris(()=>this.c);return Z.fill(this.rawAdded.map(j=>[j,!0])),Z}),this.f=new D.$U(()=>{const Z=y.$2h.forUris(()=>this.c);return Z.fill(this.rawUpdated.map(j=>[j,!0])),Z}),this.g=new D.$U(()=>{const Z=y.$2h.forUris(()=>this.c);return Z.fill(this.rawDeleted.map(j=>[j,!0])),Z}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Z of Pe){switch(Z.type){case 1:this.rawAdded.push(Z.resource);break;case 0:this.rawUpdated.push(Z.resource);break;case 2:this.rawDeleted.push(Z.resource);break}this.b!==U.a&&(typeof Z.cId=="number"?this.b===void 0?this.b=Z.cId:this.b!==Z.cId&&(this.b=U.a):this.b!==void 0&&(this.b=U.a))}}contains(Pe,...se){return this.h(Pe,{includeChildren:!1},...se)}affects(Pe,...se){return this.h(Pe,{includeChildren:!0},...se)}h(Pe,se,...Z){if(!Pe)return!1;const j=Z.length>0;return!!((!j||Z.includes(1))&&(this.d.value.get(Pe)||se.includeChildren&&this.d.value.findSuperstr(Pe))||(!j||Z.includes(0))&&(this.f.value.get(Pe)||se.includeChildren&&this.f.value.findSuperstr(Pe))||(!j||Z.includes(2))&&(this.g.value.findSubstr(Pe)||se.includeChildren&&this.g.value.findSuperstr(Pe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Pe){return this.b===Pe}hasCorrelation(){return typeof this.b=="number"}}e.$xk=U;function N(re,Pe,se){return!re||!Pe||re===Pe||Pe.length>re.length?!1:(Pe.charAt(Pe.length-1)!==F.sep&&(Pe+=F.sep),se?(0,A.$7e)(re,Pe):re.indexOf(Pe)===0)}e.$yk=N;class C extends Error{constructor(Pe,se,Z){super(Pe),this.fileOperationResult=se,this.options=Z}}e.$zk=C;class T extends C{constructor(Pe,se,Z,j){super(Pe,se,j),this.fileOperationResult=se,this.size=Z}}e.$Ak=T;class G extends C{constructor(Pe,se,Z){super(Pe,2,Z),this.stat=se}}e.$Bk=G;var de;(function(re){re[re.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",re[re.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",re[re.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",re[re.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",re[re.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",re[re.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",re[re.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",re[re.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",re[re.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",re[re.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",re[re.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(de||(e.FileOperationResult=de={})),e.$Ck={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Dk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Ek="files.associations",e.$Fk="files.exclude",e.$Gk="files.readonlyInclude",e.$Hk="files.readonlyExclude",e.$Ik="files.readonlyFromPermissions";var me;(function(re){re[re.FILE=0]="FILE",re[re.FOLDER=1]="FOLDER",re[re.ROOT_FOLDER=2]="ROOT_FOLDER"})(me||(e.FileKind=me={})),e.$Jk="";function De(re){if(!(typeof re.size!="number"||typeof re.mtime!="number"))return re.mtime.toString(29)+re.size.toString(31)}e.$Kk=De;async function ke(re,Pe){if(!Pe.hasProvider(R.URI.from({scheme:re.scheme})))return new Promise(se=>{const Z=Pe.onDidChangeFileSystemProviderRegistrations(j=>{j.scheme===re.scheme&&j.added&&(Z.dispose(),se())})})}e.$Lk=ke;class le{static{this.KB=1024}static{this.MB=le.KB*le.KB}static{this.GB=le.MB*le.KB}static{this.TB=le.GB*le.KB}static formatSize(Pe){return(0,M.$Gf)(Pe)||(Pe=0),Pe<le.KB?(0,$.localize)(1,null,Pe.toFixed(0)):Pe<le.MB?(0,$.localize)(2,null,(Pe/le.KB).toFixed(2)):Pe<le.GB?(0,$.localize)(3,null,(Pe/le.MB).toFixed(2)):Pe<le.TB?(0,$.localize)(4,null,(Pe/le.GB).toFixed(2)):(0,$.localize)(5,null,(Pe/le.TB).toFixed(2))}}e.$Mk=le;function pe(re){const Pe=typeof re=="string"||re?.scheme===P.Schemas.vscodeRemote;return typeof re!="string"&&re?.scheme===P.Schemas.file?1024*le.MB:Pe?10*le.MB:f.$o?50*le.MB:1024*le.MB}e.$Nk=pe}),define(Ae[71],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=void 0;class y{constructor(...A){this.a=new Map;for(const[M,R]of A)this.set(M,R)}set(A,M){const R=this.a.get(A);return this.a.set(A,M),R}has(A){return this.a.has(A)}get(A){return this.a.get(A)}}e.$Th=y}),define(Ae[185],Re([1,0,14,11,6,69,183,4,71,186]),function(we,e,y,F,A,M,R,$,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=e.$jq=void 0;const P=!1;class D extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class u{constructor(t=new E.$Th,i=!1,r,c=P){this.f=t,this.g=i,this.h=r,this.i=c,this.o=new Set,this.f.set($.$Uh,this),this._globalGraph=c?r?._globalGraph??new R.$iq(o=>o):void 0}createChild(t){return new u(t,this.g,this,this.i)}invokeFunction(t,...i){const r=v.traceInvocation(this.i,t);let c=!1;try{return t({get:l=>{if(c)throw(0,F.$7)("service accessor is only valid during the invocation of its target method");const n=this.m(l,r);if(!n)throw new Error(`[invokeFunction] unknown service '${l}'`);return n}},...i)}finally{c=!0,r.stop()}}createInstance(t,...i){let r,c;return t instanceof M.$Sh?(r=v.traceCreation(this.i,t.ctor),c=this.j(t.ctor,t.staticArguments.concat(i),r)):(r=v.traceCreation(this.i,t),c=this.j(t,i,r)),r.stop(),c}j(t,i=[],r){const c=$._util.getServiceDependencies(t).sort((n,s)=>n.index-s.index),o=[];for(const n of c){const s=this.m(n.id,r);s||this.u(`[createInstance] ${t.name} depends on UNKNOWN service ${n.id}.`,!1),o.push(s)}const l=c.length>0?c[0].index:i.length;if(i.length!==l){console.trace(`[createInstance] First service dependency of ${t.name} at position ${l+1} conflicts with ${i.length} static arguments`);const n=l-i.length;n>0?i=i.concat(new Array(n)):i=i.slice(0,l)}return Reflect.construct(t,i.concat(o))}k(t,i){if(this.f.get(t)instanceof M.$Sh)this.f.set(t,i);else if(this.h)this.h.k(t,i);else throw new Error("illegalState - setting UNKNOWN service instance")}l(t){const i=this.f.get(t);return!i&&this.h?this.h.l(t):i}m(t,i){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(t));const r=this.l(t);return r instanceof M.$Sh?this.q(t,r,i.branch(t,!0)):(i.branch(t,!1),r)}q(t,i,r){if(this.o.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this.o.add(t);try{return this.r(t,i,r)}finally{this.o.delete(t)}}r(t,i,r){const c=new R.$iq(n=>n.id.toString());let o=0;const l=[{id:t,desc:i,_trace:r}];for(;l.length;){const n=l.pop();if(c.lookupOrInsertNode(n),o++>1e3)throw new D(c);for(const s of $._util.getServiceDependencies(n.desc.ctor)){const a=this.l(s.id);if(a||this.u(`[createInstance] ${t} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(s.id)),a instanceof M.$Sh){const d={id:s.id,desc:a,_trace:n._trace.branch(s.id,!0)};c.insertEdge(n,d),l.push(d)}}}for(;;){const n=c.roots();if(n.length===0){if(!c.isEmpty())throw new D(c);break}for(const{data:s}of n){if(this.l(s.id)instanceof M.$Sh){const d=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,d)}c.removeNode(s)}}return this.l(t)}s(t,i,r=[],c,o){if(this.f.get(t)instanceof M.$Sh)return this.t(t,i,r,c,o);if(this.h)return this.h.s(t,i,r,c,o);throw new Error(`illegalState - creating UNKNOWN service instance ${i.name}`)}t(t,i,r=[],c,o){if(c){const l=new u(void 0,this.g,this,this.i);l.c=String(t);const n=new Map,s=new y.$eh(()=>{const a=l.j(i,r,o);for(const[d,p]of n){const m=a[d];if(typeof m=="function")for(const S of p)m.apply(a,S)}return n.clear(),a});return new Proxy(Object.create(null),{get(a,d){if(!s.isInitialized&&typeof d=="string"&&(d.startsWith("onDid")||d.startsWith("onWill"))){let S=n.get(d);return S||(S=new f.$2c,n.set(d,S)),(h,w,I)=>{const L=S.push([h,w,I]);return(0,A.$Pc)(L)}}if(d in a)return a[d];const p=s.value;let m=p[d];return typeof m!="function"||(m=m.bind(p),a[d]=m),m},set(a,d,p){return s.value[d]=p,!0},getPrototypeOf(a){return i.prototype}})}else return this.j(i,r,o)}u(t,i){if(i&&console.warn(t),this.g)throw new Error(t)}}e.$jq=u;var b;(function(g){g[g.None=0]="None",g[g.Creation=1]="Creation",g[g.Invocation=2]="Invocation",g[g.Branch=3]="Branch"})(b||(b={}));class v{static{this.all=new Set}static{this.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(t,i){return t?new v(2,i.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(t,i){return t?new v(1,i.name):v.c}static{this.f=0}constructor(t,i){this.type=t,this.name=i,this.g=Date.now(),this.h=[]}branch(t,i){const r=new v(3,t.toString());return this.h.push([t,i,r]),r}stop(){const t=Date.now()-this.g;v.f+=t;let i=!1;function r(o,l){const n=[],s=new Array(o+1).join("	");for(const[a,d,p]of l.h)if(d&&p){i=!0,n.push(`${s}CREATES -> ${a}`);const m=r(o+1,p);m&&n.push(m)}else n.push(`${s}uses -> ${a}`);return n.join(`
`)}const c=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${r(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(t>2||i)&&v.all.add(c.join(`
`))}}e.$kq=v}),define(Ae[15],Re([1,0,39,5,97,6,28,21,25,16,2,34,4]),function(we,e,y,F,A,M,R,$,E,f,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.log=e.$gj=e.LogLevel=e.$fj=e.$ej=e.$dj=void 0,e.$dj=(0,u.$Vh)("logService"),e.$ej=(0,u.$Vh)("loggerService");function b(){return new Date().toISOString()}function v(h){return(0,f.$Gf)(h)}e.$fj=v;var g;(function(h){h[h.Off=0]="Off",h[h.Trace=1]="Trace",h[h.Debug=2]="Debug",h[h.Info=3]="Info",h[h.Warning=4]="Warning",h[h.Error=5]="Error"})(g||(e.LogLevel=g={})),e.$gj=g.Info;function t(h,w,I){switch(w){case g.Trace:h.trace(I);break;case g.Debug:h.debug(I);break;case g.Info:h.info(I);break;case g.Warning:h.warn(I);break;case g.Error:h.error(I);break;case g.Off:break;default:throw new Error(`Invalid log level ${w}`)}}e.log=t;function i(h,w=!1){let I="";for(let L=0;L<h.length;L++){let V=h[L];if(V instanceof Error&&(V=(0,y.$Gi)(V,w)),typeof V=="object")try{V=JSON.stringify(V)}catch{}I+=(L>0?" ":"")+V}return I}class r extends M.$Rc{constructor(){super(...arguments),this.b=e.$gj,this.c=this.B(new F.$Rd),this.onDidChangeLogLevel=this.c.event}setLevel(w){this.b!==w&&(this.b=w,this.c.fire(this.b))}getLevel(){return this.b}f(w){return this.b!==g.Off&&this.b<=w}}e.$ij=r;class c extends r{constructor(w){super(),this.h=w}f(w){return this.h||super.f(w)}trace(w,...I){this.f(g.Trace)&&this.g(g.Trace,i([w,...I],!0))}debug(w,...I){this.f(g.Debug)&&this.g(g.Debug,i([w,...I]))}info(w,...I){this.f(g.Info)&&this.g(g.Info,i([w,...I]))}warn(w,...I){this.f(g.Warning)&&this.g(g.Warning,i([w,...I]))}error(w,...I){if(this.f(g.Error))if(w instanceof Error){const L=Array.prototype.slice.call(arguments);L[0]=w.stack,this.g(g.Error,i(L))}else this.g(g.Error,i([w,...I]))}flush(){}}e.$jj=c;class o extends r{constructor(w=e.$gj){super(),this.setLevel(w),this.g=!$.$i}trace(w,...I){this.f(g.Trace)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,w,...I):console.log(`[main ${b()}]`,w,...I))}debug(w,...I){this.f(g.Debug)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,w,...I):console.log(`[main ${b()}]`,w,...I))}info(w,...I){this.f(g.Info)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,w,...I):console.log(`[main ${b()}]`,w,...I))}warn(w,...I){this.f(g.Warning)&&(this.g?console.warn(`\x1B[93m[main ${b()}]\x1B[0m`,w,...I):console.warn(`[main ${b()}]`,w,...I))}error(w,...I){this.f(g.Error)&&(this.g?console.error(`\x1B[91m[main ${b()}]\x1B[0m`,w,...I):console.error(`[main ${b()}]`,w,...I))}dispose(){}flush(){}}e.$kj=o;class l extends r{constructor(w=e.$gj,I=!0){super(),this.g=I,this.setLevel(w)}trace(w,...I){this.f(g.Trace)&&(this.g?console.log("%cTRACE","color: #888",w,...I):console.log(w,...I))}debug(w,...I){this.f(g.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",w,...I):console.log(w,...I))}info(w,...I){this.f(g.Info)&&(this.g?console.log("%c INFO","color: #33f",w,...I):console.log(w,...I))}warn(w,...I){this.f(g.Warning)&&(this.g?console.log("%c WARN","color: #993",w,...I):console.log(w,...I))}error(w,...I){this.f(g.Error)&&(this.g?console.log("%c  ERR","color: #f33",w,...I):console.error(w,...I))}dispose(){}flush(){}}e.$lj=l;class n extends r{constructor(w,I=e.$gj){super(),this.g=w,this.setLevel(I)}trace(w,...I){this.f(g.Trace)&&this.g.log(g.Trace,[this.h(w),...I])}debug(w,...I){this.f(g.Debug)&&this.g.log(g.Debug,[this.h(w),...I])}info(w,...I){this.f(g.Info)&&this.g.log(g.Info,[this.h(w),...I])}warn(w,...I){this.f(g.Warning)&&this.g.log(g.Warning,[this.h(w),...I])}error(w,...I){this.f(g.Error)&&this.g.log(g.Error,[this.h(w),...I])}h(w){return typeof w=="string"?w:(0,y.$Gi)(w,this.f(g.Trace))}dispose(){}flush(){}}e.$mj=n;class s extends r{constructor(w){super(),this.g=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const I of this.g)I.setLevel(w);super.setLevel(w)}trace(w,...I){for(const L of this.g)L.trace(w,...I)}debug(w,...I){for(const L of this.g)L.debug(w,...I)}info(w,...I){for(const L of this.g)L.info(w,...I)}warn(w,...I){for(const L of this.g)L.warn(w,...I)}error(w,...I){for(const L of this.g)L.error(w,...I)}flush(){for(const w of this.g)w.flush()}dispose(){for(const w of this.g)w.dispose()}}e.$nj=s;class a extends M.$Rc{constructor(w,I,L){if(super(),this.h=w,this.j=I,this.b=new R.$zc,this.c=this.B(new F.$Rd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new F.$Rd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new F.$Rd),this.onDidChangeVisibility=this.g.event,L)for(const V of L)this.b.set(V.resource,{logger:void 0,info:V})}m(w){return(0,f.$Cf)(w)?[...this.b.values()].find(I=>I.info.id===w):this.b.get(w)}getLogger(w){return this.m(w)?.logger}createLogger(w,I){const L=this.n(w),V=(0,f.$Cf)(w)?w:I?.id??(0,A.$Ji)(L.toString()).toString(16);let Y=this.b.get(L)?.logger;const U=I?.logLevel==="always"?g.Trace:I?.logLevel;Y||(Y=this.s(L,U??this.getLogLevel(L)??this.h,{...I,id:V}));const N={logger:Y,info:{resource:L,id:V,logLevel:U,name:I?.name,hidden:I?.hidden,extensionId:I?.extensionId,when:I?.when}};return this.registerLogger(N.info),this.b.set(L,N),Y}n(w){return(0,f.$Cf)(w)?(0,E.$zg)(this.j,`${w}.log`):w}setLogLevel(w,I){if(P.URI.isUri(w)){const L=w,V=I,Y=this.b.get(L);Y&&V!==Y.info.logLevel&&(Y.info.logLevel=V===this.h?void 0:V,Y.logger?.setLevel(V),this.b.set(Y.info.resource,Y),this.f.fire([L,V]))}else{this.h=w;for(const[L,V]of this.b.entries())this.b.get(L)?.info.logLevel===void 0&&V.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(w,I){const L=this.m(w);L&&I!==!L.info.hidden&&(L.info.hidden=!I,this.b.set(L.info.resource,L),this.g.fire([L.info.resource,I]))}getLogLevel(w){let I;return w&&(I=this.b.get(w)?.info.logLevel),I??this.h}registerLogger(w){const I=this.b.get(w.resource);I?I.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this.b.set(w.resource,{info:w,logger:void 0}),this.c.fire({added:[w],removed:[]}))}deregisterLogger(w){const I=this.b.get(w);I&&(I.logger&&I.logger.dispose(),this.b.delete(w),this.c.fire({added:[],removed:[I.info]}))}*getRegisteredLoggers(){for(const w of this.b.values())yield w.info}getRegisteredLogger(w){return this.b.get(w)?.info}dispose(){this.b.forEach(w=>w.logger?.dispose()),this.b.clear(),super.dispose()}}e.$oj=a;class d{constructor(){this.onDidChangeLogLevel=new F.$Rd().event}setLevel(w){}getLevel(){return g.Info}trace(w,...I){}debug(w,...I){}info(w,...I){}warn(w,...I){}error(w,...I){}critical(w,...I){}dispose(){}flush(){}}e.$pj=d;class p extends d{}e.$qj=p;function m(h){if(h.verbose)return g.Trace;if(typeof h.logLevel=="string"){const w=k(h.logLevel.toLowerCase());if(w!==void 0)return w}return e.$gj}e.$rj=m;function S(h){switch(h){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Off:return"off"}}e.$sj=S;function k(h){switch(h){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Error;case"off":return g.Off}}e.$tj=k,e.$uj=new D.$aj("logLevel",S(g.Info))}),define(Ae[187],Re([1,0,6,15]),function(we,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YN=void 0;class A extends y.$Rc{constructor(R,$=[]){super(),this.a=new F.$nj([R,...$]),this.B(R.onDidChangeLogLevel(E=>this.setLevel(E)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...$){this.a.trace(R,...$)}debug(R,...$){this.a.debug(R,...$)}info(R,...$){this.a.info(R,...$)}warn(R,...$){this.a.warn(R,...$)}error(R,...$){this.a.error(R,...$)}flush(){this.a.flush()}}e.$YN=A}),define(Ae[98],Re([1,0,31,154,4]),function(we,e,y,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ft=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(M||(e.MarkerTag=M={}));var R;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(E){function f(v,g){return g-v}E.compare=f;const P=Object.create(null);P[E.Error]=(0,F.localize)(0,null),P[E.Warning]=(0,F.localize)(1,null),P[E.Info]=(0,F.localize)(2,null);function D(v){return P[v]||""}E.toString=D;function u(v){switch(v){case y.default.Error:return E.Error;case y.default.Warning:return E.Warning;case y.default.Info:return E.Info;case y.default.Ignore:return E.Hint}}E.fromSeverity=u;function b(v){switch(v){case E.Error:return y.default.Error;case E.Warning:return y.default.Warning;case E.Info:return y.default.Info;case E.Hint:return y.default.Ignore}}E.toSeverity=b}(R||(e.MarkerSeverity=R={}));var $;(function(E){const f="";function P(u){return D(u,!0)}E.makeKey=P;function D(u,b){const v=[f];return u.source?v.push(u.source.replace("\xA6","\\\xA6")):v.push(f),u.code?typeof u.code=="string"?v.push(u.code.replace("\xA6","\\\xA6")):v.push(u.code.value.replace("\xA6","\\\xA6")):v.push(f),u.severity!==void 0&&u.severity!==null?v.push(R.toString(u.severity)):v.push(f),u.message&&b?v.push(u.message.replace("\xA6","\\\xA6")):v.push(f),u.startLineNumber!==void 0&&u.startLineNumber!==null?v.push(u.startLineNumber.toString()):v.push(f),u.startColumn!==void 0&&u.startColumn!==null?v.push(u.startColumn.toString()):v.push(f),u.endLineNumber!==void 0&&u.endLineNumber!==null?v.push(u.endLineNumber.toString()):v.push(f),u.endColumn!==void 0&&u.endColumn!==null?v.push(u.endColumn.toString()):v.push(f),v.push(f),v.join("\xA6")}E.makeKeyOptionalMessage=D})($||(e.IMarkerData=$={})),e.$ft=(0,A.$Vh)("markerService")}),define(Ae[188],Re([1,0,5,31,4]),function(we,e,y,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8u=e.$7u=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$6u=e.Severity=void 0,e.Severity=F.default,e.$6u=(0,A.$Vh)("notificationService");var M;(function(P){P[P.DEFAULT=0]="DEFAULT",P[P.SILENT=1]="SILENT",P[P.URGENT=2]="URGENT"})(M||(e.NotificationPriority=M={}));var R;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.PROFILE=1]="PROFILE",P[P.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));var $;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})($||(e.NotificationsFilter=$={}));class E{constructor(){this.progress=new f,this.onDidClose=y.Event.None,this.onDidChangeVisibility=y.Event.None}updateSeverity(D){}updateMessage(D){}updateActions(D){}close(){}}e.$7u=E;class f{infinite(){}done(){}total(D){}worked(D){}}e.$8u=f}),define(Ae[99],Re([1,0,12,2,4]),function(we,e,y,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TU=e.$SU=e.$RU=e.$QU=e.$PU=void 0,e.$PU=(0,A.$Vh)("openerService");function M(f,P){return F.URI.isUri(f)?(0,y.$6e)(f.scheme,P):(0,y.$7e)(f,P+":")}e.$QU=M;function R(f,...P){return P.some(D=>M(f,D))}e.$RU=R;function $(f,P){return f.with({fragment:`${P.startLineNumber},${P.startColumn}${P.endLineNumber?`-${P.endLineNumber}${P.endColumn?`,${P.endColumn}`:""}`:""}`})}e.$SU=$;function E(f){let P;const D=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(f.fragment);return D&&(P={startLineNumber:parseInt(D[1]),startColumn:D[2]?parseInt(D[2]):1,endLineNumber:D[4]?parseInt(D[4]):void 0,endColumn:D[4]?D[5]?parseInt(D[5]):1:void 0},f=f.with({fragment:""})),{selection:P,uri:f}}e.$TU=E}),define(Ae[189],Re([1,0,4]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wj=e.$vj=void 0,e.$vj=(0,y.$Vh)("productService"),e.$wj="vscode://schemas/vscode-product"});var Ke=this&&this.__decorate||function(we,e,y,F){var A=arguments.length,M=A<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,y):F,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(we,e,y,F);else for(var $=we.length-1;$>=0;$--)(R=we[$])&&(M=(A<3?R(M):A>3?R(e,y,M):R(e,y))||M);return A>3&&M&&Object.defineProperty(e,y,M),M},Ve=this&&this.__param||function(we,e){return function(y,F){e(y,F,we)}};define(Ae[72],Re([1,0,14,19,6,4]),function(we,e,y,F,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cv=e.$bv=e.$av=e.$_u=e.$$u=e.$0u=e.ProgressLocation=e.$9u=void 0,e.$9u=(0,M.$Vh)("progressService");var R;(function(D){D[D.Explorer=1]="Explorer",D[D.Scm=3]="Scm",D[D.Extensions=5]="Extensions",D[D.Window=10]="Window",D[D.Notification=15]="Notification",D[D.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$0u=Object.freeze({total(){},worked(){},done(){}});class ${static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(u){this.b=u}report(u){this.a=u,this.b(this.a)}}e.$$u=$;class E{get value(){return this.a}constructor(u){this.e=u}report(u){this.b?this.b.push(u):this.b=[u],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const u=this.b.shift();this.a=u,await this.e(this.a)}}finally{this.c=!1;const u=this.d;this.d=void 0,u?.()}}drain(){return this.c?new Promise(u=>{const b=this.d;this.d=()=>{b?.(),u()}}):Promise.resolve()}}e.$_u=E;let f=class extends A.$Rc{constructor(u,b){super(),this.a=new y.$ih,b.withProgress(u,v=>(this.b=v,this.c&&v.report(this.c),this.a.p)),this.B((0,A.$Pc)(()=>this.a.complete()))}report(u){this.b?this.b.report(u):this.c=u}};e.$av=f,e.$av=f=Ke([Ve(1,e.$9u)],f);class P extends A.$Rc{constructor(u){super(),this.g=u,this.a=0,this.b=this.B(new A.$Qc)}start(u){this.stop();const b=++this.a,v=new F.$2d;return this.f=setTimeout(()=>{b===this.a&&(this.c=this.g.show(!0))},u),this.b.add((0,A.$Pc)(()=>clearTimeout(this.f))),this.b.add((0,A.$Pc)(()=>v.cancel())),this.b.add((0,A.$Pc)(()=>this.c?this.c.done():void 0)),{id:b,token:v.token,stop:()=>this.h(b),isCurrent:()=>this.a===b}}stop(){this.h(this.a)}h(u){this.a===u&&this.b.clear()}}e.$bv=P,e.$cv=(0,M.$Vh)("editorProgressService")}),define(Ae[30],Re([1,0,53,16]),function(we,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mn=void 0;class A{constructor(){this.a=new Map}add(R,$){y.ok(F.$Cf(R)),y.ok(F.$Ef($)),y.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,$)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$mn=new A}),define(Ae[73],Re([1,0,5,30]),function(we,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=void 0,e.$nn={JSONContribution:"base.contributions.json"};function A($){return $.length>0&&$.charAt($.length-1)==="#"?$.substring(0,$.length-1):$}class M{constructor(){this.b=new y.$Rd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(E,f){this.a[A(E)]=f,this.b.fire(E)}notifySchemaChanged(E){this.b.fire(E)}getSchemaContributions(){return{schemas:this.a}}}const R=new M;F.$mn.add(e.$nn.JSONContribution,R)}),define(Ae[54],Re([1,0,18,5,16,148,40,73,30]),function(we,e,y,F,A,M,R,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.ConfigurationScope=e.$rn=e.EditPresentationTypes=void 0;var f;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(f||(e.EditPresentationTypes=f={})),e.$rn={Configuration:"base.contributions.configuration"};var P;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.$sn={properties:{},patternProperties:{}},e.$tn={properties:{},patternProperties:{}},e.$un={properties:{},patternProperties:{}},e.$vn={properties:{},patternProperties:{}},e.$wn={properties:{},patternProperties:{}},e.$xn={properties:{},patternProperties:{}},e.$yn="vscode://schemas/settings/resourceLanguage",e.$zn="vscode://schemas/settings/configurationDefaults";const D=E.$mn.as($.$nn.JSONContribution);class u{constructor(){this.h=new Set,this.i=new F.$Rd,this.onDidSchemaChange=this.i.event,this.j=new F.$Rd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},D.registerSchema(e.$yn,this.g),this.v()}registerConfiguration(n,s=!0){this.registerConfigurations([n],s)}registerConfigurations(n,s=!0){const a=new Set;this.n(n,s,a),D.registerSchema(e.$yn,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(n){const s=new Set;this.o(n,s),D.registerSchema(e.$yn,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:n,remove:s}){const a=new Set;this.o(s,a),this.n(n,!1,a),D.registerSchema(e.$yn,this.g),this.i.fire(),this.j.fire({properties:a})}registerDefaultConfigurations(n){const s=new Set;this.k(n,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(n,s){const a=[];for(const{overrides:d,source:p}of n)for(const m in d)if(s.add(m),e.$Bn.test(m)){const S=this.a.get(m),k=S?.valuesSources??new Map;if(p)for(const L of Object.keys(d[m]))k.set(L,p);const h={...S?.value||{},...d[m]};this.a.set(m,{source:p,value:h,valuesSources:k});const w=(0,R.$zi)(m),I={type:"object",default:h,description:M.localize(1,null,w),$ref:e.$yn,defaultDefaultValue:h,source:A.$Cf(p)?void 0:p,defaultValueSource:p};a.push(...g(m)),this.d[m]=I,this.b.properties[m]=I}else{this.a.set(m,{value:d[m],source:p});const S=this.d[m];S&&(this.w(m,S),this.r(m,S))}this.m(a)}deregisterDefaultConfigurations(n){const s=new Set;this.l(n,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(n,s){for(const{overrides:a,source:d}of n)for(const p in a){const m=this.a.get(p),S=A.$Cf(d)?d:d?.id,k=A.$Cf(m?.source)?m?.source:m?.source?.id;if(S===k)if(s.add(p),this.a.delete(p),e.$Bn.test(p))delete this.d[p],delete this.b.properties[p];else{const h=this.d[p];h&&(this.w(p,h),this.r(p,h))}}this.u()}deltaConfiguration(n){let s=!1;const a=new Set;n.removedDefaults&&(this.l(n.removedDefaults,a),s=!0),n.addedDefaults&&(this.k(n.addedDefaults,a),s=!0),n.removedConfigurations&&this.o(n.removedConfigurations,a),n.addedConfigurations&&this.n(n.addedConfigurations,!1,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){this.m(n),this.i.fire()}m(n){for(const s of n)this.h.add(s);this.u()}n(n,s,a){n.forEach(d=>{this.p(d,s,d.extensionInfo,d.restrictedProperties,void 0,a),this.c.push(d),this.q(d)})}o(n,s){const a=d=>{if(d.properties)for(const p in d.properties){s.add(p);const m=this.d[p];m?.policy?.name&&this.e.delete(m.policy.name),delete this.d[p],this.s(p,d.properties[p])}d.allOf?.forEach(p=>a(p))};for(const d of n){a(d);const p=this.c.indexOf(d);p!==-1&&this.c.splice(p,1)}}p(n,s=!0,a,d,p=3,m){p=A.$Lf(n.scope)?p:n.scope;const S=n.properties;if(S)for(const h in S){const w=S[h];if(s&&c(h,w)){delete S[h];continue}if(w.source=a,w.defaultDefaultValue=S[h].default,this.w(h,w),e.$Bn.test(h)?w.scope=void 0:(w.scope=A.$Lf(w.scope)?p:w.scope,w.restricted=A.$Lf(w.restricted)?!!d?.includes(h):w.restricted),S[h].hasOwnProperty("included")&&!S[h].included){this.f[h]=S[h],delete S[h];continue}else this.d[h]=S[h],S[h].policy?.name&&this.e.set(S[h].policy.name,h);!S[h].deprecationMessage&&S[h].markdownDeprecationMessage&&(S[h].deprecationMessage=S[h].markdownDeprecationMessage),m.add(h)}const k=n.allOf;if(k)for(const h of k)this.p(h,s,a,d,p,m)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(n){const s=a=>{const d=a.properties;if(d)for(const m in d)this.r(m,d[m]);a.allOf?.forEach(s)};s(n)}r(n,s){switch(e.$sn.properties[n]=s,s.scope){case 1:e.$tn.properties[n]=s;break;case 2:e.$un.properties[n]=s;break;case 6:e.$vn.properties[n]=s;break;case 3:e.$wn.properties[n]=s;break;case 4:e.$xn.properties[n]=s;break;case 5:e.$xn.properties[n]=s,this.g.properties[n]=s;break}}s(n,s){switch(delete e.$sn.properties[n],s.scope){case 1:delete e.$tn.properties[n];break;case 2:delete e.$un.properties[n];break;case 6:delete e.$vn.properties[n];break;case 3:delete e.$wn.properties[n];break;case 4:case 5:delete e.$xn.properties[n],delete this.g.properties[n];break}}u(){for(const n of this.h.values()){const s=`[${n}]`,a={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$yn};this.w(s,a),e.$sn.properties[s]=a,e.$tn.properties[s]=a,e.$un.properties[s]=a,e.$vn.properties[s]=a,e.$wn.properties[s]=a,e.$xn.properties[s]=a}}v(){const n={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$yn};e.$sn.patternProperties[e.$An]=n,e.$tn.patternProperties[e.$An]=n,e.$un.patternProperties[e.$An]=n,e.$vn.patternProperties[e.$An]=n,e.$wn.patternProperties[e.$An]=n,e.$xn.patternProperties[e.$An]=n,this.i.fire()}w(n,s){const a=this.a.get(n);let d=a?.value,p=a?.source;A.$Jf(d)&&(d=s.defaultDefaultValue,p=void 0),A.$Jf(d)&&(d=i(s.type)),s.default=d,s.defaultValueSource=p}}const b="\\[([^\\]]+)\\]",v=new RegExp(b,"g");e.$An=`^(${b})+$`,e.$Bn=new RegExp(e.$An);function g(l){const n=[];if(e.$Bn.test(l)){let s=v.exec(l);for(;s?.length;){const a=s[1].trim();a&&n.push(a),s=v.exec(l)}}return(0,y.$Lb)(n)}e.$Cn=g;function t(l){return l.reduce((n,s)=>`${n}[${s}]`,"")}e.$Dn=t;function i(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$En=i;const r=new u;E.$mn.add(e.$rn.Configuration,r);function c(l,n){return l.trim()?e.$Bn.test(l)?M.localize(7,null,l):r.getConfigurationProperties()[l]!==void 0?M.localize(8,null,l):n.policy?.name&&r.getPolicyConfigurations().get(n.policy?.name)!==void 0?M.localize(9,null,l,n.policy?.name,r.getPolicyConfigurations().get(n.policy?.name)):null:M.localize(6,null)}e.$Fn=c;function o(){const l=[],n=r.getConfigurationProperties();for(const s of Object.keys(n))l.push([s,n[s].scope]);return l.push(["launch",4]),l.push(["task",4]),l}e.$Gn=o}),define(Ae[190],Re([1,0,18,5,119,6,28,26,16,2,40,54,30]),function(we,e,y,F,A,M,R,$,E,f,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=void 0;function b(s){return Object.isFrozen(s)?s:$.$bn(s)}class v{constructor(a={},d=[],p=[],m){this.b=a,this.c=d,this.d=p,this.raw=m,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const a=this.raw.map(d=>{if(d instanceof v)return d;const p=new g("");return p.parseRaw(d),p.configurationModel});this.f=a.reduce((d,p)=>p===d?p:d.merge(p),a[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(a){return a?(0,P.$xi)(this.contents,a):this.contents}inspect(a,d){const p=this.rawConfiguration.getValue(a),m=d?this.rawConfiguration.getOverrideValue(a,d):void 0,S=d?this.rawConfiguration.override(d).getValue(a):p;return{value:p,override:m,merged:S}}getOverrideValue(a,d){const p=this.i(d);return p?a?(0,P.$xi)(p,a):p:void 0}getKeysForOverrideIdentifier(a){const d=[];for(const p of this.overrides)p.identifiers.includes(a)&&d.push(...p.keys);return y.$Lb(d)}getAllOverrideIdentifiers(){const a=[];for(const d of this.overrides)a.push(...d.identifiers);return y.$Lb(a)}override(a){let d=this.a.get(a);return d||(d=this.g(a),this.a.set(a,d)),d}merge(...a){const d=$.$an(this.contents),p=$.$an(this.overrides),m=[...this.keys],S=this.raw?.length?[...this.raw]:[this];for(const k of a)if(S.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.h(d,k.contents);for(const h of k.overrides){const[w]=p.filter(I=>y.$tb(I.identifiers,h.identifiers));w?(this.h(w.contents,h.contents),w.keys.push(...h.keys),w.keys=y.$Lb(w.keys)):p.push($.$an(h))}for(const h of k.keys)m.indexOf(h)===-1&&m.push(h)}return new v(d,m,p,S.every(k=>k instanceof v)?void 0:S)}g(a){const d=this.i(a);if(!d||typeof d!="object"||!Object.keys(d).length)return this;const p={};for(const m of y.$Lb([...Object.keys(this.contents),...Object.keys(d)])){let S=this.contents[m];const k=d[m];k&&(typeof S=="object"&&typeof k=="object"?(S=$.$an(S),this.h(S,k)):S=k),p[m]=S}return new v(p,this.keys,this.overrides)}h(a,d){for(const p of Object.keys(d)){if(p in a&&E.$Ef(a[p])&&E.$Ef(d[p])){this.h(a[p],d[p]);continue}a[p]=$.$an(d[p])}}i(a){let d=null,p=null;const m=S=>{S&&(p?this.h(p,S):p=$.$an(S))};for(const S of this.overrides)S.identifiers.length===1&&S.identifiers[0]===a?d=S.contents:S.identifiers.includes(a)&&m(S.contents);return m(d),p}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(a,d){this.j(a,d,!0)}setValue(a,d){this.j(a,d,!1)}removeValue(a){const d=this.keys.indexOf(a);d!==-1&&(this.keys.splice(d,1),(0,P.$wi)(this.contents,a),D.$Bn.test(a)&&this.overrides.splice(this.overrides.findIndex(p=>y.$tb(p.identifiers,(0,D.$Cn)(a))),1))}j(a,d,p){(0,P.$vi)(this.contents,a,d,m=>console.error(m)),p=p||this.keys.indexOf(a)===-1,p&&this.keys.push(a),D.$Bn.test(a)&&this.overrides.push({identifiers:(0,D.$Cn)(a),keys:Object.keys(this.contents[a]),contents:(0,P.$ui)(this.contents[a],m=>console.error(m))})}}e.$Hn=v;class g{constructor(a){this.f=a,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new v}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(a,d){if(!E.$Lf(a)){const p=this.g(a);this.parseRaw(p,d)}}reparse(a){this.a&&this.parseRaw(this.a,a)}parseRaw(a,d){this.a=a;const{contents:p,keys:m,overrides:S,restricted:k,hasExcludedProperties:h}=this.h(a,d);this.b=new v(p,m,S,h?[a]:void 0),this.c=k||[]}g(a){let d={},p=null,m=[];const S=[],k=[];function h(I){Array.isArray(m)?m.push(I):p!==null&&(m[p]=I)}const w={onObjectBegin:()=>{const I={};h(I),S.push(m),m=I,p=null},onObjectProperty:I=>{p=I},onObjectEnd:()=>{m=S.pop()},onArrayBegin:()=>{const I=[];h(I),S.push(m),m=I,p=null},onArrayEnd:()=>{m=S.pop()},onLiteralValue:h,onError:(I,L,V)=>{k.push({error:I,offset:L,length:V})}};if(a)try{A.$0m(a,w),d=m[0]||{}}catch(I){console.error(`Error while parsing settings file ${this.f}: ${I}`),this.d=[I]}return d}h(a,d){const p=u.$mn.as(D.$rn.Configuration).getConfigurationProperties(),m=this.i(a,p,!0,d);a=m.raw;const S=(0,P.$ui)(a,w=>console.error(`Conflict in settings file ${this.f}: ${w}`)),k=Object.keys(a),h=this.j(a,w=>console.error(`Conflict in settings file ${this.f}: ${w}`));return{contents:S,keys:k,overrides:h,restricted:m.restricted,hasExcludedProperties:m.hasExcludedProperties}}i(a,d,p,m){let S=!1;if(!m?.scopes&&!m?.skipRestricted&&!m?.exclude?.length)return{raw:a,restricted:[],hasExcludedProperties:S};const k={},h=[];for(const w in a)if(D.$Bn.test(w)&&p){const I=this.i(a[w],d,!1,m);k[w]=I.raw,S=S||I.hasExcludedProperties,h.push(...I.restricted)}else{const I=d[w],L=I?typeof I.scope<"u"?I.scope:3:void 0;I?.restricted&&h.push(w),!m.exclude?.includes(w)&&(m.include?.includes(w)||(L===void 0||m.scopes===void 0||m.scopes.includes(L))&&!(m.skipRestricted&&I?.restricted))?k[w]=a[w]:S=!0}return{raw:k,restricted:h,hasExcludedProperties:S}}j(a,d){const p=[];for(const m of Object.keys(a))if(D.$Bn.test(m)){const S={};for(const k in a[m])S[k]=a[m][k];p.push({identifiers:(0,D.$Cn)(m),keys:Object.keys(S),contents:(0,P.$ui)(S,d)})}return p}}e.$In=g;class t extends M.$Rc{constructor(a,d,p,m){super(),this.c=a,this.f=d,this.g=m,this.b=this.B(new F.$Rd),this.onDidChange=this.b.event,this.a=new g(this.c.toString()),this.B(this.g.watch(p.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(F.Event.any(F.Event.filter(this.g.onDidFilesChange,S=>S.contains(this.c)),F.Event.filter(this.g.onDidRunOperation,S=>(S.isOperation(0)||S.isOperation(3)||S.isOperation(1)||S.isOperation(4))&&p.isEqual(S.resource,a)))(()=>this.b.fire()))}async loadConfiguration(){try{const a=await this.g.readFile(this.c);return this.a.parse(a.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new v}}reparse(a){return a&&(this.f=a),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Jn=t;class i{constructor(a,d,p,m,S,k,h,w,I,L,V,Y,U){this.a=a,this.b=d,this.c=p,this.overrideIdentifiers=m,this.d=S,this.f=k,this.g=h,this.h=w,this.i=I,this.j=L,this.k=V,this.l=Y,this.m=U}get value(){return b(this.c)}n(a,d,p){const m=a.inspect(d,p);return{get value(){return b(m.value)},get override(){return b(m.override)},get merged(){return b(m.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class r{constructor(a,d,p,m,S=new v,k=new v,h=new R.$zc,w=new v,I=new R.$zc){this.c=a,this.d=d,this.f=p,this.g=m,this.h=S,this.i=k,this.j=h,this.l=w,this.m=I,this.a=null,this.b=new R.$zc,this.n=null}getValue(a,d,p){return this.p(a,d,p).getValue(a)}updateValue(a,d,p={}){let m;p.resource?(m=this.m.get(p.resource),m||(m=new v,this.m.set(p.resource,m))):m=this.l,d===void 0?m.removeValue(a):m.setValue(a,d),p.resource||(this.a=null)}inspect(a,d,p){const m=this.p(a,d,p),S=this.t(d.resource,p),k=d.resource?this.m.get(d.resource)||this.l:this.l,h=new Set;for(const w of m.overrides)for(const I of w.identifiers)m.getOverrideValue(a,I)!==void 0&&h.add(I);return new i(a,d,m.getValue(a),h.size?[...h]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,p?this.i:void 0,S||void 0,k)}keys(a){const d=this.t(void 0,a);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:d?d.keys.slice(0):[]}}updateDefaultConfiguration(a){this.c=a,this.a=null,this.b.clear()}updatePolicyConfiguration(a){this.d=a}updateApplicationConfiguration(a){this.f=a,this.a=null,this.b.clear()}updateLocalUserConfiguration(a){this.g=a,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(a){this.h=a,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(a){this.i=a,this.a=null,this.b.clear()}updateFolderConfiguration(a,d){this.j.set(a,d),this.b.delete(a)}deleteFolderConfiguration(a){this.folderConfigurations.delete(a),this.b.delete(a)}compareAndUpdateDefaultConfiguration(a,d){const p=[];if(!d){const{added:m,updated:S,removed:k}=l(this.c,a);d=[...m,...S,...k]}for(const m of d)for(const S of(0,D.$Cn)(m)){const k=this.c.getKeysForOverrideIdentifier(S),h=a.getKeysForOverrideIdentifier(S),w=[...h.filter(I=>k.indexOf(I)===-1),...k.filter(I=>h.indexOf(I)===-1),...k.filter(I=>!$.$en(this.c.override(S).getValue(I),a.override(S).getValue(I)))];p.push([S,w])}return this.updateDefaultConfiguration(a),{keys:d,overrides:p}}compareAndUpdatePolicyConfiguration(a){const{added:d,updated:p,removed:m}=l(this.d,a),S=[...d,...p,...m];return S.length&&this.updatePolicyConfiguration(a),{keys:S,overrides:[]}}compareAndUpdateApplicationConfiguration(a){const{added:d,updated:p,removed:m,overrides:S}=l(this.applicationConfiguration,a),k=[...d,...p,...m];return k.length&&this.updateApplicationConfiguration(a),{keys:k,overrides:S}}compareAndUpdateLocalUserConfiguration(a){const{added:d,updated:p,removed:m,overrides:S}=l(this.localUserConfiguration,a),k=[...d,...p,...m];return k.length&&this.updateLocalUserConfiguration(a),{keys:k,overrides:S}}compareAndUpdateRemoteUserConfiguration(a){const{added:d,updated:p,removed:m,overrides:S}=l(this.remoteUserConfiguration,a),k=[...d,...p,...m];return k.length&&this.updateRemoteUserConfiguration(a),{keys:k,overrides:S}}compareAndUpdateWorkspaceConfiguration(a){const{added:d,updated:p,removed:m,overrides:S}=l(this.workspaceConfiguration,a),k=[...d,...p,...m];return k.length&&this.updateWorkspaceConfiguration(a),{keys:k,overrides:S}}compareAndUpdateFolderConfiguration(a,d){const p=this.folderConfigurations.get(a),{added:m,updated:S,removed:k,overrides:h}=l(p,d),w=[...m,...S,...k];return(w.length||!p)&&this.updateFolderConfiguration(a,d),{keys:w,overrides:h}}compareAndDeleteFolderConfiguration(a){const d=this.folderConfigurations.get(a);if(!d)throw new Error("Unknown folder");this.deleteFolderConfiguration(a);const{added:p,updated:m,removed:S,overrides:k}=l(d,void 0);return{keys:[...p,...m,...S],overrides:k}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(a,d,p){let m=this.q(d,p);return d.overrideIdentifier&&(m=m.override(d.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(a)!==void 0&&(m=m.merge(this.d)),m}q({resource:a},d){let p=this.r();if(d&&a){const m=d.getFolder(a);m&&(p=this.s(m.uri)||p);const S=this.m.get(a);S&&(p=p.merge(S))}return p}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(a){let d=this.b.get(a);if(!d){const p=this.r(),m=this.j.get(a);m?(d=p.merge(m),this.b.set(a,d)):d=p}return d}t(a,d){if(d&&a){const p=d.getFolder(a);if(p)return this.j.get(p.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((a,d)=>{const{contents:p,overrides:m,keys:S}=this.j.get(d);return a.push([d,{contents:p,overrides:m,keys:S}]),a},[])}}allKeys(){const a=new Set;return this.c.keys.forEach(d=>a.add(d)),this.userConfiguration.keys.forEach(d=>a.add(d)),this.i.keys.forEach(d=>a.add(d)),this.j.forEach(d=>d.keys.forEach(p=>a.add(p))),[...a.values()]}u(){const a=new Set;return this.c.getAllOverrideIdentifiers().forEach(d=>a.add(d)),this.userConfiguration.getAllOverrideIdentifiers().forEach(d=>a.add(d)),this.i.getAllOverrideIdentifiers().forEach(d=>a.add(d)),this.j.forEach(d=>d.getAllOverrideIdentifiers().forEach(p=>a.add(p))),[...a.values()]}v(a){const d=new Set;return this.c.getKeysForOverrideIdentifier(a).forEach(p=>d.add(p)),this.userConfiguration.getKeysForOverrideIdentifier(a).forEach(p=>d.add(p)),this.i.getKeysForOverrideIdentifier(a).forEach(p=>d.add(p)),this.j.forEach(p=>p.getKeysForOverrideIdentifier(a).forEach(m=>d.add(m))),[...d.values()]}static parse(a){const d=this.w(a.defaults),p=this.w(a.policy),m=this.w(a.application),S=this.w(a.user),k=this.w(a.workspace),h=a.folders.reduce((w,I)=>(w.set(f.URI.revive(I[0]),this.w(I[1])),w),new R.$zc);return new r(d,p,m,S,new v,k,h,new v,new R.$zc)}static w(a){return new v(a.contents,a.keys,a.overrides)}}e.$Kn=r;function c(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const a=new Set,d=new Map;for(const m of s)m.keys.forEach(S=>a.add(S)),m.overrides.forEach(([S,k])=>{const h=(0,R.$wc)(d,S,new Set);k.forEach(w=>h.add(w))});const p=[];return d.forEach((m,S)=>p.push([S,[...m.values()]])),{keys:[...a.values()],overrides:p}}e.$Ln=c;class o{constructor(a,d,p,m){this.change=a,this.f=d,this.g=p,this.h=m,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const S of a.keys)this.affectedKeys.add(S);for(const[,S]of a.overrides)for(const k of S)this.affectedKeys.add(k);this.d=this.a;for(const S of this.affectedKeys)this.d+=S+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=r.parse(this.f.data)),this.i}affectsConfiguration(a,d){const p=this.a+a,m=this.d.indexOf(p);if(m<0)return!1;const S=m+p.length;if(S>=this.d.length)return!1;const k=this.d.charCodeAt(S);if(k!==this.b&&k!==this.c)return!1;if(d){const h=this.previousConfiguration?this.previousConfiguration.getValue(a,d,this.f?.workspace):void 0,w=this.g.getValue(a,d,this.h);return!$.$en(h,w)}return!0}}e.$Mn=o;function l(s,a){const{added:d,removed:p,updated:m}=n(a?.rawConfiguration,s?.rawConfiguration),S=[],k=s?.getAllOverrideIdentifiers()||[],h=a?.getAllOverrideIdentifiers()||[];if(a){const w=h.filter(I=>!k.includes(I));for(const I of w)S.push([I,a.getKeysForOverrideIdentifier(I)])}if(s){const w=k.filter(I=>!h.includes(I));for(const I of w)S.push([I,s.getKeysForOverrideIdentifier(I)])}if(a&&s){for(const w of k)if(h.includes(w)){const I=n({contents:s.getOverrideValue(void 0,w)||{},keys:s.getKeysForOverrideIdentifier(w)},{contents:a.getOverrideValue(void 0,w)||{},keys:a.getKeysForOverrideIdentifier(w)});S.push([w,[...I.added,...I.removed,...I.updated]])}}return{added:d,removed:p,updated:m,overrides:S}}function n(s,a){const d=s?a?s.keys.filter(S=>a.keys.indexOf(S)===-1):[...s.keys]:[],p=a?s?a.keys.filter(S=>s.keys.indexOf(S)===-1):[...a.keys]:[],m=[];if(s&&a){for(const S of a.keys)if(s.keys.indexOf(S)!==-1){const k=(0,P.$xi)(a.contents,S),h=(0,P.$xi)(s.contents,S);$.$en(k,h)||m.push(S)}}return{added:d,removed:p,updated:m}}}),define(Ae[100],Re([1,0,11,4]),function(we,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.$Yk=e.RemoteAuthorityResolverErrorCode=e.$Xk=e.$Wk=e.RemoteConnectionType=e.$Vk=void 0,e.$Vk=(0,F.$Vh)("remoteAuthorityResolverService");var A;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(A||(e.RemoteConnectionType=A={}));class M{constructor(D){this.id=D,this.type=1}toString(){return`Managed(${this.id})`}}e.$Wk=M;class R{constructor(D,u){this.host=D,this.port=u,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Xk=R;var $;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound",P.InvalidAuthority="InvalidAuthority"})($||(e.RemoteAuthorityResolverErrorCode=$={}));class E extends y.$ab{static isNotAvailable(D){return D instanceof E&&D._code===$.NotAvailable}static isTemporarilyNotAvailable(D){return D instanceof E&&D._code===$.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof E&&D._code===$.NoResolverFound}static isInvalidAuthority(D){return D instanceof E&&D._code===$.InvalidAuthority}static isHandled(D){return D instanceof E&&D.isHandled}constructor(D,u=$.Unknown,b){super(D),this._message=D,this._code=u,this._detail=b,this.isHandled=u===$.NotAvailable&&b===!0,Object.setPrototypeOf(this,E.prototype)}}e.$Yk=E;function f(P){const D=P.indexOf("+");return D===-1?P:P.substring(0,D)}e.$Zk=f}),define(Ae[55],Re([1,0,13]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=void 0;function F(f){return f.scheme===y.Schemas.vscodeRemote?f.authority:void 0}e.$1k=F;function A(f){if(!f)return;const P=f.indexOf("+");return P<0?f:f.substr(0,P)}e.$2k=A;function M(f){return`/${f.quality??"oss"}-${f.commit??"dev"}`}e.$3k=M;function R(f){const{host:P,port:D}=E(f);if(typeof D>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:D}}e.$4k=R;function $(f,P){let{host:D,port:u}=E(f);return typeof u>"u"&&(u=P),{host:D,port:u}}e.$5k=$;function E(f){const P=f.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const D=f.match(/^(\[[0-9a-z:]+\])$/);if(D)return{host:D[1],port:void 0};const u=f.match(/(.*):(\d+)$/);return u?{host:u[1],port:parseInt(u[2],10)}:{host:f,port:void 0}}}),define(Ae[22],Re([1,0,12,4,55]),function(we,e,y,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.TargetPlatform=e.ExtensionType=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=void 0,e.$6l="extensions.user.cache",e.$7l="extensions.builtin.cache",e.$8l="undefined_publisher",e.$9l=["ui","workspace","web"];function M(g){if(typeof g=="object"&&g!==null&&g.supported!==!0)return g.description}e.$0l=M,e.$$l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(R||(e.ExtensionType=R={}));var $;(function(g){g.WIN32_X64="win32-x64",g.WIN32_ARM64="win32-arm64",g.LINUX_X64="linux-x64",g.LINUX_ARM64="linux-arm64",g.LINUX_ARMHF="linux-armhf",g.ALPINE_X64="alpine-x64",g.ALPINE_ARM64="alpine-arm64",g.DARWIN_X64="darwin-x64",g.DARWIN_ARM64="darwin-arm64",g.WEB="web",g.UNIVERSAL="universal",g.UNKNOWN="unknown",g.UNDEFINED="undefined"})($||(e.TargetPlatform=$={}));class E{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,i){if(typeof t>"u"||t===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof t=="string"||typeof i=="string"){const r=typeof t=="string"?t:t.value,c=typeof i=="string"?i:i.value;return y.$6e(r,c)}return t._lower===i._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.$_l=E;class f{get size(){return this.c.size}constructor(t){if(this.c=new Set,t)for(const i of t)this.add(i)}add(t){this.c.add(E.toKey(t))}delete(t){return this.c.delete(E.toKey(t))}has(t){return this.c.has(E.toKey(t))}}e.$am=f;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(t){this.c.delete(E.toKey(t))}get(t){return this.c.get(E.toKey(t))}has(t){return this.c.has(E.toKey(t))}set(t,i){this.c.set(E.toKey(t),i)}values(){return this.c.values()}forEach(t){this.c.forEach(t)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$bm=P;function D(g){return u(g)}e.$cm=D;function u(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}e.$dm=u;function b(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}e.$em=b;function v(g,t){if(t){const i=`onResolveRemoteAuthority:${(0,A.$2k)(t)}`;return!!g.activationEvents?.includes(i)}return!1}e.$fm=v,e.$gm=(0,F.$Vh)("IBuiltinExtensionsScannerService")}),define(Ae[101],Re([1,0,11,22]),function(we,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yF=e.$xF=void 0;class A{constructor(){this.a=new Map,this.b=new WeakMap}register(R,$){this.a.set(R,$)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const $=Object.create(null);for(const E of R){const f=this.readActivationEvents(E);f.length>0&&($[F.$_l.toKey(E.identifier)]=f)}return $}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const $=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let E=0;E<$.length;E++)$[E]==="onUri"&&($[E]=`onUri:${F.$_l.toKey(R.identifier)}`);if(!R.contributes)return $;for(const E in R.contributes){const f=this.a.get(E);if(!f)continue;const P=R.contributes[E],D=Array.isArray(P)?P:[P];try{f(D,$)}catch(u){(0,y.$Z)(u)}}return $}}e.$xF=A,e.$yF=new A}),define(Ae[191],Re([1,0,21,74,38]),function(we,e,y,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$no=void 0;function M(E){if(y.$u===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}function R(E,f,P,D,u,b,v,g,t){const i=Object.create(null);i["common.machineId"]=b,i["common.sqmId"]=v,i.sessionID=(0,A.$ig)()+Date.now(),i.commitHash=D,i.version=u,i["common.platformVersion"]=(E||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),i["common.platform"]=(0,y.$h)(y.$u),i["common.nodePlatform"]=F.$cc,i["common.nodeArch"]=P,i["common.product"]=t||"desktop",g&&(i["common.msftInternal"]=g);let r=0;const c=Date.now();Object.defineProperties(i,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>r++,enumerable:!0}}),y.$l&&(i["common.snap"]="true");const o=M(f);return o&&(i["common.platformDetail"]=o),i}e.$no=R;function $(E){const f=F.env.USERDNSDOMAIN;if(!f)return!1;const P=f.toLowerCase();return E.some(D=>P===D)}e.$oo=$}),define(Ae[192],Re([1,0,4]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=void 0,e.$il=(0,y.$Vh)("telemetryService"),e.$jl=(0,y.$Vh)("customEndpointTelemetryService"),e.$kl="telemetry.currentSessionDate",e.$ll="telemetry.firstSessionDate",e.$ml="telemetry.lastSessionDate",e.$nl="telemetry.machineId",e.$ol="telemetry.sqmId",e.$pl="telemetry",e.$ql="telemetry.telemetryLevel",e.$rl="telemetry.enableCrashReporter",e.$sl="telemetry.enableTelemetry";var F;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(F||(e.TelemetryLevel=F={}));var A;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(A||(e.TelemetryConfiguration=A={}))}),define(Ae[56],Re([1,0,26,16,5,40,55,191,192]),function(we,e,y,F,A,M,R,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=void 0;class f{constructor(p){this.value=p,this.isTrustedTelemetryValue=!0}}e.$po=f;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$qo=P,e.$ro=new P;class D{async publicLog(p,m,S){}async publicLogError(p,m,S){}}e.$so=D,e.$to="telemetry",e.$uo="extensionTelemetryLog",e.$vo={log:()=>null,flush:()=>Promise.resolve(null)};function u(d,p){return A.Event.debounce(p.onDidChangeConfiguration,(S,k)=>{const h=S?new Set([...S.affectedKeys,...k.affectedKeys]):k.affectedKeys;return{...k,affectedKeys:h}},1e3,!0)(S=>{S.source!==7&&d.publicLog2("updateConfiguration",{configurationSource:(0,M.$si)(S.source),configurationKeys:Array.from(S.affectedKeys)})})}e.$wo=u;function b(d,p){return!p.isBuilt&&!p.disableTelemetry?!0:!(p.disableTelemetry||!d.enableTelemetry)}e.$xo=b;function v(d,p){return p.extensionTestsLocationURI?!0:!(p.isBuilt||p.disableTelemetry||d.enableTelemetry&&d.aiConfig?.ariaKey)}e.$yo=v;function g(d){const p=d.getValue(E.$ql),m=d.getValue(E.$rl);if(d.getValue(E.$sl)===!1||m===!1)return 0;switch(p??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$zo=g;function t(d){const p={},m={},S={};c(d,S);for(let k in S){k=k.length>150?k.substr(k.length-149):k;const h=S[k];typeof h=="number"?m[k]=h:typeof h=="boolean"?m[k]=h?1:0:typeof h=="string"?(h.length>8192&&console.warn(`Telemetry property: ${k} has been trimmed to 8192, the original length is ${h.length}`),p[k]=h.substring(0,8191)):typeof h<"u"&&h!==null&&(p[k]=h)}return{properties:p,measurements:m}}e.$Ao=t;const i=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(d){if(!d)return"none";const p=(0,R.$2k)(d);return i.has(p)?p:"other"}e.$Bo=r;function c(d,p,m=0,S){if(d)for(const k of Object.getOwnPropertyNames(d)){const h=d[k],w=S?S+k:k;Array.isArray(h)?p[w]=(0,y.$fn)(h):h instanceof Date?p[w]=h.toISOString():(0,F.$Ef)(h)?m<2?c(h,p,m+1,w+"."):p[w]=(0,y.$fn)(h):p[w]=h}}function o(d,p){const m=d.msftInternalDomains||[],S=p.getValue("telemetry.internalTesting");return(0,$.$oo)(m)||S}e.$Co=o;function l(d){return[d.appRoot,d.extensionsPath,d.userHome.fsPath,d.tmpDir.fsPath,d.userDataPath]}e.$Do=l;function n(d,p){if(!d||!d.includes("/")&&!d.includes("\\"))return d;let m=d;const S=[];for(const I of p)for(;;){const L=I.exec(d);if(!L)break;S.push([L.index,I.lastIndex])}const k=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,h=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let w=0;for(m="";;){const I=h.exec(d);if(!I)break;const L=S.some(([V,Y])=>I.index<Y&&V<h.lastIndex);!k.test(I[0])&&!L&&(m+=d.substring(w,I.index)+"<REDACTED: user-file-path>",w=h.lastIndex)}return w<d.length&&(m+=d.substr(w)),m}function s(d){if(!d)return d;const p=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const m of p)if(m.regex.test(d))return`<REDACTED: ${m.label}>`;return d}function a(d,p){return(0,y.$cn)(d,m=>{if(m instanceof f||Object.hasOwnProperty.call(m,"isTrustedTelemetryValue"))return m.value;if(typeof m=="string"){let S=m.replaceAll("%20"," ");S=n(S,p);for(const k of p)S=S.replace(k,"");return S=s(S),S}})}e.$Eo=a}),define(Ae[193],Re([1,0,12,96,22,21,2,11,74,56]),function(we,e,y,F,A,M,R,$,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=void 0;function P(a,d){return a.uuid&&d.uuid?a.uuid===d.uuid:a.id===d.id?!0:(0,y.$1e)(a.id,d.id)===0}e.$Fo=P;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(d){const p=d.manifest?d.manifest.version:d.version,m=d.manifest?d.targetPlatform:d.properties.targetPlatform;return new u(d.identifier,p,m)}static parse(d){const p=D.exec(d);return p&&p[1]&&p[2]?new u({id:p[1]},p[2],p[4]||void 0):null}constructor(d,p,m="undefined"){this.version=p,this.targetPlatform=m,this.id=d.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(d){return d instanceof u?P(this,d)&&this.version===d.version&&this.targetPlatform===d.targetPlatform:!1}}e.$Go=u;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(a){const d=b.exec(a);return d&&d[1]?[t(d[1]),d[2]]:[t(a),void 0]}e.$Ho=v;function g(a,d){return`${a}.${d}`}e.$Io=g;function t(a){return a.toLowerCase()}e.$Jo=t;function i(a,d){return t(g(a??A.$8l,d))}e.$Ko=i;function r(a,d){const p=[],m=S=>{for(const k of p)if(k.some(h=>P(d(h),d(S))))return k;return null};for(const S of a){const k=m(S);k?k.push(S):p.push([S])}return p}e.$Lo=r;function c(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}e.$Mo=c;function o(a){return{id:new f.$po(a.identifier.id),name:new f.$po(a.name),galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),isSigned:a.isSigned,...a.telemetryData}}e.$No=o,e.$Oo=new A.$_l("pprice.better-merge");function l(a,d){const p=[],m=d.manifest.extensionDependencies?.slice(0)??[];for(;m.length;){const S=m.shift();if(S&&p.every(k=>!P(k.identifier,{id:S}))){const k=a.filter(h=>P(h.identifier,{id:S}));k.length===1&&(p.push(k[0]),m.push(...k[0].manifest.extensionDependencies?.slice(0)??[]))}}return p}e.$Po=l;async function n(a,d){if(!M.$k)return!1;let p;try{p=(await a.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{p=(await a.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){d.debug("Error while getting the os-release file.",(0,$.$9)(S))}}return!!p&&(p.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(a,d){const p=await n(a,d),m=(0,F.$_n)(p?"alpine":M.$u,E.$dc);return d.debug("ComputeTargetPlatform:",m),m}e.$Qo=s}),define(Ae[194],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=e.$ur=e.$tr=e.$sr=e.$rr=e.$qr=void 0;function y(E){return[...E.entries()]}e.$qr=y;function F(E){return E?[...E.entries()]:[]}e.$rr=F;function A(E){return new Map(E)}e.$sr=A;function M(E){return new Map(E??[])}e.$tr=M;function R(E){return Array.from(E.entries()).map(f=>[f[0],y(f[1].map),F(f[1].descriptionMap)])}e.$ur=R;function $(E){return new Map(E.map(f=>[f[0],{map:A(f[1]),descriptionMap:M(f[2])}]))}e.$vr=$}),define(Ae[195],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lqb=void 0;class y{constructor(A){this.b=A,this.a=new Map}dispose(){for(const A of this.a.values())A.dispose()}startBuffering(A,M,R=5){const $=M(E=>{const f=typeof E=="string"?E:E.data;let P=this.a.get(A);if(P){P.data.push(f);return}const D=setTimeout(()=>this.flushBuffer(A),R);P={data:[f],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(A),$.dispose()}},this.a.set(A,P)});return $}stopBuffering(A){this.a.get(A)?.dispose()}flushBuffer(A){const M=this.a.get(A);M&&(this.a.delete(A),this.b(A,M.data.join("")))}}e.$lqb=y}),define(Ae[196],Re([1,0,14,90,45,5,16,2,155,73,30]),function(we,e,y,F,A,M,R,$,E,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hw=e.$gw=e.$fw=e.$ew=e.$dw=e.$cw=e.$bw=e.$aw=e.IconFontDefinition=e.IconContribution=e.$_v=void 0,e.$_v={IconContribution:"base.contributions.icons"};var D;(function(o){function l(n,s){let a=n.defaults;for(;A.ThemeIcon.isThemeIcon(a);){const d=v.getIcon(a.id);if(!d)return;a=d.defaults}return a}o.getDefinition=l})(D||(e.IconContribution=D={}));var u;(function(o){function l(s){return{weight:s.weight,style:s.style,src:s.src.map(a=>({format:a.format,location:a.location.toString()}))}}o.toJSONObject=l;function n(s){const a=d=>(0,R.$Cf)(d)?d:void 0;if(s&&Array.isArray(s.src)&&s.src.every(d=>(0,R.$Cf)(d.format)&&(0,R.$Cf)(d.location)))return{weight:a(s.weight),style:a(s.style),src:s.src.map(d=>({format:d.format,location:$.URI.parse(d.location)}))}}o.fromJSONObject=n})(u||(e.IconFontDefinition=u={}));class b{constructor(){this.a=new M.$Rd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${A.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(l,n,s,a){const d=this.b[l];if(d){if(s&&!d.description){d.description=s,this.d.properties[l].markdownDescription=`${s} $(${l})`;const S=this.e.enum.indexOf(l);S!==-1&&(this.e.enumDescriptions[S]=s),this.a.fire()}return d}const p={id:l,description:s,defaults:n,deprecationMessage:a};this.b[l]=p;const m={$ref:"#/definitions/icons"};return a&&(m.deprecationMessage=a),s&&(m.markdownDescription=`${s}: $(${l})`),this.d.properties[l]=m,this.e.enum.push(l),this.e.enumDescriptions.push(s||""),this.a.fire(),{id:l}}deregisterIcon(l){delete this.b[l],delete this.d.properties[l];const n=this.e.enum.indexOf(l);n!==-1&&(this.e.enum.splice(n,1),this.e.enumDescriptions.splice(n,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(l=>this.b[l])}getIcon(l){return this.b[l]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(l,n){const s=this.f[l];return s||(this.f[l]=n,this.a.fire(),n)}deregisterIconFont(l){delete this.f[l]}getIconFont(l){return this.f[l]}toString(){const l=(d,p)=>d.id.localeCompare(p.id),n=d=>{for(;A.ThemeIcon.isThemeIcon(d.defaults);)d=this.b[d.defaults.id];return`codicon codicon-${d?d.id:""}`},s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const a=Object.keys(this.b).map(d=>this.b[d]);for(const d of a.filter(p=>!!p.description).sort(l))s.push(`|<i class="${n(d)}"></i>|${d.id}|${A.ThemeIcon.isThemeIcon(d.defaults)?d.defaults.id:d.id}|${d.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const d of a.filter(p=>!A.ThemeIcon.isThemeIcon(p.defaults)).sort(l))s.push(`|<i class="${n(d)}"></i>|${d.id}|`);return s.join(`
`)}}const v=new b;P.$mn.add(e.$_v.IconContribution,v);function g(o,l,n,s){return v.registerIcon(o,l,n,s)}e.$aw=g;function t(){return v}e.$bw=t;function i(){const o=(0,F.$Yj)();for(const l in o){const n="\\"+o[l].toString(16);v.registerIcon(l,{fontCharacter:n})}}i(),e.$cw="vscode://schemas/icons";const r=P.$mn.as(f.$nn.JSONContribution);r.registerSchema(e.$cw,v.getIconSchema());const c=new y.$0g(()=>r.notifySchemaChanged(e.$cw),200);v.onDidChange(()=>{c.isScheduled()||c.schedule()}),e.$dw=g("widget-close",F.$1j.close,(0,E.localize)(2,null)),e.$ew=g("goto-previous-location",F.$1j.arrowUp,(0,E.localize)(3,null)),e.$fw=g("goto-next-location",F.$1j.arrowDown,(0,E.localize)(4,null)),e.$gw=A.ThemeIcon.modify(F.$1j.sync,"spin"),e.$hw=A.ThemeIcon.modify(F.$1j.loading,"spin")}),define(Ae[197],Re([1,0,5,40,4,15]),function(we,e,y,F,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nv=e.$mv=e.$lv=e.$kv=e.$jv=e.$iv=e.$hv=e.$gv=e.ProvidedOnAutoForward=e.$fv=e.TunnelPrivacyId=e.TunnelProtocol=e.$ev=e.$dv=void 0,e.$dv=(0,A.$Vh)("tunnelService"),e.$ev=(0,A.$Vh)("sharedTunnelsService");var R;(function(t){t.Http="http",t.Https="https"})(R||(e.TunnelProtocol=R={}));var $;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})($||(e.TunnelPrivacyId=$={}));function E(t){return!!t.forwardPort}e.$fv=E;var f;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(f||(e.ProvidedOnAutoForward=f={}));function P(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(i)return{address:i[1],port:+i[2]}}e.$gv=P,e.$hv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function D(t){return e.$hv.indexOf(t)>=0}e.$iv=D,e.$jv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function u(t){return e.$jv.indexOf(t)>=0}e.$kv=u;function b(t,i,r,c){if(r===1)return!1;if(r===2&&u(i)){const o=/(\d+)\.(\d+)\.(\d+)/g.exec(c);if(o?.length===4&&parseInt(o[1])>=18)return!1}return t<1024}e.$lv=b;class v{constructor(i,r,c){this.remoteAddress=i,this.localAddress=r,this.b=c,this.a=new y.$Rd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$mv=v;let g=class{constructor(i,r){this.j=i,this.k=r,this.a=new y.$Rd,this.onTunnelOpened=this.a.event,this.b=new y.$Rd,this.onTunnelClosed=this.b.event,this.c=new y.$Rd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const i=this.k.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.h=i.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const i=[],r=Array.from(this.e.values());for(const c of r){const o=Array.from(c.values());for(const l of o){const n=await l.value;n&&typeof n!="string"&&i.push(n)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:r}of i.values())await r.then(c=>typeof c!="string"?c?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,r,c,o,l){this.p(i,r,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:r,localAddress:c,privacy:o,protocol:l,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,r){(u(i)||D(i))&&(i=e.$hv[0]);const c=this.r(i,r);if(c)return++c.refcount,c.value}openTunnel(i,r,c,o,l,n=!1,s,a){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${r}:${c} on local port ${l}.`);const d=this.f??i;if(!d)return;if(r||(r="localhost"),o||(o=this.l),this.f&&this.i.has(c)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const p=this.s(d,r,c,o,l,n,s,a);return p?p.then(m=>{if(m){if(typeof m=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(r,c),m}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(r,c);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const S=this.n(m);return(m.tunnelRemoteHost!==r||m.tunnelRemotePort!==c)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&m.privacy!==s&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(S),S}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),p)}n(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const r=this.e.get(i.tunnelRemoteHost);if(r){const c=r.get(i.tunnelRemotePort);c&&(c.refcount--,await this.o(i.tunnelRemoteHost,i.tunnelRemotePort,c))}}}}async o(i,r,c){if(c.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${r}.`);const o=c.value.then(async l=>{l&&typeof l!="string"&&(await l.dispose(!0),this.b.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(r),o}}async closeTunnel(i,r){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${r} `);const c=this.e.get(i);if(c&&c.has(r)){const o=c.get(r);o.refcount=0,await this.o(i,r,o)}}p(i,r,c){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(r,{refcount:1,value:c})}async q(i,r){const c=this.e.get(i);if(c){const o=c.get(r),l=o?await o.value:void 0;(!l||typeof l=="string")&&c.delete(r),c.size===0&&this.e.delete(i)}}r(i,r){const c=[i];D(i)?(c.push(...e.$hv),c.push(...e.$jv)):u(i)&&c.push(...e.$jv);const o=c.map(l=>this.e.get(l));for(const l of o){const n=l?.get(r);if(n)return n}}canTunnel(i){return!!P(i)}t(i,r,c,o,l,n,s){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${r}:${c} on local port ${o}.`);const a=c;this.i.add(a);const d=o===void 0?c:o,p={elevationRequired:l?this.isPortPrivileged(d):!1},m={remoteAddress:{host:r,port:c},localAddressPort:o,privacy:n,public:n?n!==$.Private:void 0,protocol:s},S=i.forwardPort(m,p);return S?(this.p(r,c,S),S.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(a)})):this.i.delete(a),S}};e.$nv=g,e.$nv=g=Ke([Ve(0,M.$dj),Ve(1,F.$pi)],g)}),define(Ae[198],Re([1,0,4]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$ov=void 0,e.$ov=(0,y.$Vh)("editSessionIdentityService");var F;(function(A){A[A.Complete=100]="Complete",A[A.Partial=50]="Partial",A[A.None=0]="None"})(F||(e.EditSessionIdentityMatch=F={}))}),define(Ae[199],Re([1,0,13]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=void 0;function F(E){return E.scheme!==y.Schemas.file&&E.scheme!==y.Schemas.vscodeRemote}e.$9J=F;function A(E){if(E.folders.length)return E.folders.every(f=>F(f.uri))?E.folders[0].uri:void 0;if(E.configuration&&F(E.configuration))return E.configuration}e.$0J=A;function M(E){return A(E)?.scheme}e.$$J=M;function R(E){return A(E)?.authority}e.$_J=R;function $(E){return A(E)!==void 0}e.$aK=$}),define(Ae[47],Re([1,0,156,20,50,25,2,4,13]),function(we,e,y,F,A,M,R,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.WorkbenchState=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=void 0,e.$5h=(0,$.$Vh)("contextService");function f(d){const p=d;return typeof p?.id=="string"&&R.URI.isUri(p.uri)}e.$6h=f;function P(d){return typeof d?.id=="string"&&!f(d)&&!u(d)}e.$7h=P,e.$8h={id:"ext-dev"},e.$9h={id:"empty-window"};function D(d,p){if(typeof d=="string"||typeof d>"u")return typeof d=="string"?{id:(0,F.$mc)(d)}:p?e.$8h:e.$9h;const m=d;return m.configuration?{id:m.id,configPath:m.configuration}:m.folders.length===1?{id:m.id,uri:m.folders[0].uri}:{id:m.id}}e.$0h=D;function u(d){const p=d;return typeof p?.id=="string"&&R.URI.isUri(p.configPath)}e.$$h=u;function b(d){const p=d;if(p?.uri)return{id:p.id,uri:R.URI.revive(p.uri)};const m=d;if(m?.configPath)return{id:m.id,configPath:R.URI.revive(m.configPath)};if(d?.id)return{id:d.id}}e.$_h=b;var v;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(v||(e.WorkbenchState=v={}));function g(d){const p=d;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&Array.isArray(p.folders))}e.$ai=g;function t(d){const p=d;return!!(p&&typeof p=="object"&&R.URI.isUri(p.uri)&&typeof p.name=="string"&&typeof p.toResource=="function")}e.$bi=t;class i{constructor(p,m,S,k,h){this.h=p,this.j=S,this.k=k,this.l=h,this.c=A.$2h.forUris(this.l,()=>!0),this.folders=m}update(p){this.h=p.id,this.k=p.configuration,this.j=p.transient,this.l=p.l,this.folders=p.folders}get folders(){return this.g}set folders(p){this.g=p,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(p){this.k=p}getFolder(p){return p&&this.c.findSubstr(p)||null}n(){this.c=A.$2h.forUris(this.l,()=>!0);for(const p of this.folders)this.c.set(p.uri,p)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$ci=i;class r{constructor(p,m){this.raw=m,this.uri=p.uri,this.index=p.index,this.name=p.name}toResource(p){return(0,M.$zg)(this.uri,p)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$di=r;function c(d){return new r({uri:d,index:0,name:(0,M.$vg)(d)},{uri:d.toString()})}e.$ei=c,e.$fi="code-workspace",e.$gi=`.${e.$fi}`,e.$hi=[{name:(0,y.localize)(0,null),extensions:[e.$fi]}],e.$ii="workspace.json";function o(d,p){return M.$qg.isEqualOrParent(d,p.untitledWorkspacesHome)}e.$ji=o;function l(d){let p;return R.URI.isUri(d)?p=d:p=d.configuration,p?.scheme===E.Schemas.tmp}e.$ki=l,e.$li="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(d){return d.id===e.$li}e.$mi=n;function s(d,p){return!o(d,p)&&!l(d)}e.$ni=s;function a(d){return(typeof d=="string"?(0,F.$nc)(d):(0,M.$xg)(d))===e.$gi}e.$oi=a}),define(Ae[75],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hdc=void 0;class y{static{this.a=!1}constructor(A){this.d=A,this.b=new Map,this.c=1}add(A){const M=this.c++;return this.b.set(M,A),this.e(),M}get(A,M){return this.b.has(A)?this.b.get(A)[M]:void 0}delete(A){this.b.delete(A),this.e()}e(){y.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Hdc=y}),define(Ae[42],Re([1,0,13,25,4]),function(we,e,y,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ldc=e.$Kdc=void 0;class M{constructor(){this.a=new Set(Object.keys(y.Schemas)),this.b=new Map,this.extUri=new F.$og($=>{const E=this.b.get($.scheme);return!(E===void 0||E&1024)})}$acceptProviderInfos($,E){E===null?this.b.delete($.scheme):this.b.set($.scheme,E)}isFreeScheme($){return!this.b.has($)&&!this.a.has($)}getCapabilities($){return this.b.get($)}}e.$Kdc=M,e.$Ldc=(0,A.$Vh)("IExtHostFileSystemInfo")}),define(Ae[27],Re([1,0,4]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RM=void 0,e.$RM=(0,y.$Vh)("IExtHostInitDataService")}),define(Ae[200],Re([1,0,161,15,187,27]),function(we,e,y,F,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rfc=void 0;let R=class extends A.$YN{constructor(E,f,P){const D=P.remote.isRemote?"remoteexthost":E?"workerexthost":"exthost",u=P.remote.isRemote?(0,y.localize)(0,null):E?(0,y.localize)(1,null):(0,y.localize)(2,null);super(f.createLogger(D,{name:u}))}};e.$Rfc=R,e.$Rfc=R=Ke([Ve(1,F.$ej),Ve(2,M.$RM)],R)}),define(Ae[201],Re([1,0,14]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uec=e.$tec=void 0;class F{constructor(R,$,E){this.h=new Map,this.a=R,this.b=$,this.c=E,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(f=>(this.f=f,this)),this.g=this.c.onDidChangeStorage(f=>{f.shared===this.b&&f.key===this.a&&(this.f=f.value)}),this.i=new y.$0g(()=>{const f=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const P of f.values())P.complete()}catch(P){for(const D of f.values())D.error(P)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,$){let E=this.f[R];return typeof E>"u"&&(E=$),E}update(R,$){this.f[R]=$;const E=this.h.get(R);if(E!==void 0)return E.p;const f=new y.$ih;return this.h.set(R,f),this.i.isScheduled()||this.i.schedule(),f.p}dispose(){this.g.dispose()}}e.$tec=F;class A extends F{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,$){super(R.identifier.value,!0,$),this.j=R}}e.$uec=A}),define(Ae[202],Re([1,0,5,2]),function(we,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hfc=void 0;class A{constructor(R){this.c=R,this.a=new y.$Rd,this.onDidSaveNotebookDocument=this.a.event,this.b=new y.$Rd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,$,E,f){const D=this.c.getNotebookDocument(F.URI.revive(R)).acceptModelChanged($.value,E,f);this.b.fire(D)}$acceptDirtyStateChanged(R,$){this.c.getNotebookDocument(F.URI.revive(R)).acceptDirty($)}$acceptModelSaved(R){const $=this.c.getNotebookDocument(F.URI.revive(R));this.a.fire($.apiNotebook)}}e.$hfc=A}),define(Ae[17],Re([1,0,4]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CM=e.$BM=void 0,e.$BM=(0,y.$Vh)("IExtHostRpcService");class F{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.$CM=F}),define(Ae[203],Re([1,0,22,5]),function(we,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bec=void 0;class A{#e;constructor(R,$){this.b=new F.$Rd,this.onDidChange=this.b.event,this.a=y.$_l.toKey(R.identifier),this.#e=$,this.#e.onDidChangePassword(E=>{E.extensionId===this.a&&this.b.fire({key:E.key})})}get(R){return this.#e.get(this.a,R)}store(R,$){return this.#e.store(this.a,R,$)}delete(R){return this.#e.delete(this.a,R)}}e.$Bec=A}),define(Ae[57],Re([1,0,4]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5dc=e.$4dc=void 0,e.$4dc=(0,y.$Vh)("IURITransformerService");class F{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$5dc=F}),define(Ae[204],Re([1,0,24]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fcb=e.$Ecb=void 0;class F{constructor(){this.buffers=[]}add(E){let f=this.buffers.indexOf(E);return f<0&&(f=this.buffers.length,this.buffers.push(E)),f}}function A($,E){if(E.serializeBuffersForPostMessage){const f=new F,D=JSON.stringify($,(b,v)=>{if(v instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:f.add(v)};if(ArrayBuffer.isView(v)){const g=M(v);if(g)return{$$vscode_array_buffer_reference$$:!0,index:f.add(v.buffer),view:{type:g,byteLength:v.byteLength,byteOffset:v.byteOffset}}}return v}),u=f.buffers.map(b=>{const v=new Uint8Array(b);return y.$fe.wrap(v)});return{message:D,buffers:u}}else return{message:JSON.stringify($),buffers:[]}}e.$Ecb=A;function M($){switch($.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R($,E){const f=E.map(u=>{const b=new ArrayBuffer(u.byteLength);return new Uint8Array(b).set(u.buffer),b}),P=E.length?(u,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const v=b,{index:g}=v,t=f[g];if(v.view)switch(v.view.type){case 1:return new Int8Array(t,v.view.byteOffset,v.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,v.view.byteOffset,v.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,v.view.byteOffset,v.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,v.view.byteOffset,v.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,v.view.byteOffset,v.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,v.view.byteOffset,v.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,v.view.byteOffset,v.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,v.view.byteOffset,v.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,v.view.byteOffset,v.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,v.view.byteOffset,v.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,v.view.byteOffset,v.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return b}:void 0;return{message:JSON.parse($,P),arrayBuffers:f}}e.$Fcb=R}),define(Ae[102],Re([1,0,171,16,2,6,4,30,41,13,39,134,31]),function(we,e,y,F,A,M,R,$,E,f,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BE=e.$AE=e.$zE=e.EditorsOrder=e.$yE=e.CloseDirection=e.$xE=e.$wE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$vE=e.$uE=e.$tE=e.$sE=e.$rE=e.$qE=e.$pE=e.$oE=e.EditorInputCapabilities=e.$nE=e.SaveReason=e.Verbosity=e.$mE=e.$lE=e.$kE=e.$jE=e.$iE=e.$hE=e.$gE=e.$fE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$eE=e.$dE=e.$cE=e.$bE=e.$aE=void 0,e.$aE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$bE={id:"default",displayName:(0,y.localize)(0,null),providerDisplayName:(0,y.localize)(1,null)},e.$cE="workbench.editor.sidebysideEditor",e.$dE="workbench.editors.textDiffEditor",e.$eE="workbench.editors.binaryResourceDiffEditor";var b;(function(se){se[se.PROGRAMMATIC=1]="PROGRAMMATIC",se[se.USER=2]="USER",se[se.EDIT=3]="EDIT",se[se.NAVIGATION=4]="NAVIGATION",se[se.JUMP=5]="JUMP"})(b||(e.EditorPaneSelectionChangeReason=b={}));var v;(function(se){se[se.IDENTICAL=1]="IDENTICAL",se[se.SIMILAR=2]="SIMILAR",se[se.DIFFERENT=3]="DIFFERENT"})(v||(e.EditorPaneSelectionCompareResult=v={}));function g(se){const Z=se;return!!Z&&typeof Z.getSelection=="function"&&!!Z.onDidChangeSelection}e.$fE=g;function t(se,Z,j){for(const ie of j.visibleEditorPanes)if(ie.group.id===Z&&se.matches(ie.input))return ie.getViewState()}e.$gE=t;function i(se){if(S(se))return!1;const Z=se;return A.URI.isUri(Z?.resource)}e.$hE=i;function r(se){if(S(se))return!1;const Z=se;return Z?.original!==void 0&&Z.modified!==void 0}e.$iE=r;function c(se){if(S(se))return!1;const Z=se;return Array.isArray(Z?.resources)}e.$jE=c;function o(se){if(S(se)||r(se))return!1;const Z=se;return Z?.primary!==void 0&&Z.secondary!==void 0}e.$kE=o;function l(se){if(S(se))return!1;const Z=se;return Z?Z.resource===void 0||Z.resource.scheme===f.Schemas.untitled||Z.forceUntitled===!0:!1}e.$lE=l;function n(se){if(S(se))return!1;const Z=se;return A.URI.isUri(Z?.base?.resource)&&A.URI.isUri(Z?.input1?.resource)&&A.URI.isUri(Z?.input2?.resource)&&A.URI.isUri(Z?.result?.resource)}e.$mE=n;var s;(function(se){se[se.SHORT=0]="SHORT",se[se.MEDIUM=1]="MEDIUM",se[se.LONG=2]="LONG"})(s||(e.Verbosity=s={}));var a;(function(se){se[se.EXPLICIT=1]="EXPLICIT",se[se.AUTO=2]="AUTO",se[se.FOCUS_CHANGE=3]="FOCUS_CHANGE",se[se.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(a||(e.SaveReason=a={}));class d{constructor(){this.a=new Map}registerSource(Z,j){let ie=this.a.get(Z);return ie||(ie={source:Z,label:j},this.a.set(Z,ie)),ie.source}getSourceLabel(Z){return this.a.get(Z)?.label??Z}}e.$nE=new d;var p;(function(se){se[se.None=0]="None",se[se.Readonly=2]="Readonly",se[se.Untitled=4]="Untitled",se[se.Singleton=8]="Singleton",se[se.RequiresTrust=16]="RequiresTrust",se[se.CanSplitInGroup=32]="CanSplitInGroup",se[se.ForceDescription=64]="ForceDescription",se[se.CanDropIntoEditor=128]="CanDropIntoEditor",se[se.MultipleEditors=256]="MultipleEditors",se[se.Scratchpad=512]="Scratchpad",se[se.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(p||(e.EditorInputCapabilities=p={}));class m extends M.$Rc{}e.$oE=m;function S(se){return se instanceof m}e.$pE=S;function k(se){const Z=se;return A.URI.isUri(Z?.preferredResource)}function h(se){const Z=se;return S(Z?.primary)&&S(Z?.secondary)}e.$qE=h;function w(se){const Z=se;return S(Z?.modified)&&S(Z?.original)}e.$rE=w;function I(se,Z,j,ie,ve){return Pe(ie,[(0,D.$Fi)({id:"workbench.action.openLargeFile",label:(0,y.localize)(2,null),run:()=>{const ne={...j,limits:{size:Number.MAX_VALUE}};se.openEditor(Z,ne)}}),(0,D.$Fi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,y.localize)(3,null),run:()=>ve.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}e.$sE=I;function L(se){return S(se?.editor)}e.$tE=L;function V(se){const Z=se;return L(se)&&Z?.group!==void 0}e.$uE=V;function Y(se){const Z=se;return typeof Z?.groupId=="number"&&S(Z.editor)}e.$vE=Y;var U;(function(se){se[se.UNKNOWN=0]="UNKNOWN",se[se.REPLACE=1]="REPLACE",se[se.MOVE=2]="MOVE",se[se.UNPIN=3]="UNPIN"})(U||(e.EditorCloseContext=U={}));var N;(function(se){se[se.GROUP_ACTIVE=0]="GROUP_ACTIVE",se[se.GROUP_INDEX=1]="GROUP_INDEX",se[se.GROUP_LABEL=2]="GROUP_LABEL",se[se.GROUP_LOCKED=3]="GROUP_LOCKED",se[se.EDITOR_OPEN=4]="EDITOR_OPEN",se[se.EDITOR_CLOSE=5]="EDITOR_CLOSE",se[se.EDITOR_MOVE=6]="EDITOR_MOVE",se[se.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",se[se.EDITOR_LABEL=8]="EDITOR_LABEL",se[se.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",se[se.EDITOR_PIN=10]="EDITOR_PIN",se[se.EDITOR_STICKY=11]="EDITOR_STICKY",se[se.EDITOR_DIRTY=12]="EDITOR_DIRTY",se[se.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(N||(e.GroupModelChangeKind=N={}));var C;(function(se){se[se.PRIMARY=1]="PRIMARY",se[se.SECONDARY=2]="SECONDARY",se[se.BOTH=3]="BOTH",se[se.ANY=4]="ANY"})(C||(e.SideBySideEditor=C={}));class T{getOriginalUri(Z,j){if(!Z)return;if(n(Z))return e.$xE.getOriginalUri(Z.result,j);if(j?.supportSideBySide){const{primary:ve,secondary:ne}=this.a(Z);if(ve&&ne){if(j?.supportSideBySide===C.BOTH)return{primary:this.getOriginalUri(ve,{filterByScheme:j.filterByScheme}),secondary:this.getOriginalUri(ne,{filterByScheme:j.filterByScheme})};if(j?.supportSideBySide===C.ANY)return this.getOriginalUri(ve,{filterByScheme:j.filterByScheme})??this.getOriginalUri(ne,{filterByScheme:j.filterByScheme});Z=j.supportSideBySide===C.PRIMARY?ve:ne}}if(r(Z)||c(Z)||o(Z)||n(Z))return;const ie=k(Z)?Z.preferredResource:Z.resource;return!ie||!j||!j.filterByScheme?ie:this.b(ie,j.filterByScheme)}a(Z){return h(Z)||o(Z)?{primary:Z.primary,secondary:Z.secondary}:w(Z)||r(Z)?{primary:Z.modified,secondary:Z.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(Z,j){if(!Z)return;if(n(Z))return e.$xE.getCanonicalUri(Z.result,j);if(j?.supportSideBySide){const{primary:ve,secondary:ne}=this.a(Z);if(ve&&ne){if(j?.supportSideBySide===C.BOTH)return{primary:this.getCanonicalUri(ve,{filterByScheme:j.filterByScheme}),secondary:this.getCanonicalUri(ne,{filterByScheme:j.filterByScheme})};if(j?.supportSideBySide===C.ANY)return this.getCanonicalUri(ve,{filterByScheme:j.filterByScheme})??this.getCanonicalUri(ne,{filterByScheme:j.filterByScheme});Z=j.supportSideBySide===C.PRIMARY?ve:ne}}if(r(Z)||c(Z)||o(Z)||n(Z))return;const ie=Z.resource;return!ie||!j||!j.filterByScheme?ie:this.b(ie,j.filterByScheme)}b(Z,j){if(Array.isArray(j)){if(j.some(ie=>Z.scheme===ie))return Z}else if(j===Z.scheme)return Z}}var G;(function(se){se[se.UNKNOWN=0]="UNKNOWN",se[se.KEYBOARD=1]="KEYBOARD",se[se.MOUSE=2]="MOUSE"})(G||(e.EditorCloseMethod=G={}));function de(se,Z,j,ie){if(!se.isSticky(Z))return!1;switch(ie.preventPinnedEditorClose){case"keyboardAndMouse":return j===G.MOUSE||j===G.KEYBOARD;case"mouse":return j===G.MOUSE;case"keyboard":return j===G.KEYBOARD}return!1}e.$wE=de,e.$xE=new T;var me;(function(se){se[se.LEFT=0]="LEFT",se[se.RIGHT=1]="RIGHT"})(me||(e.CloseDirection=me={}));class De{constructor(){this.c=new Map,this.d=new Map}start(Z){const j=this.a=Z.get(R.$Uh);for(const[ie,ve]of this.c)this.e(ie,ve,j);this.c.clear()}e(Z,j,ie){const ve=ie.createInstance(j);this.d.set(Z,ve)}registerFileEditorFactory(Z){if(this.b)throw new Error("Can only register one file editor factory.");this.b=Z}getFileEditorFactory(){return(0,F.$Nf)(this.b)}registerEditorSerializer(Z,j){if(this.c.has(Z)||this.d.has(Z))throw new Error(`A editor serializer with type ID '${Z}' was already registered.`);return this.a?this.e(Z,j,this.a):this.c.set(Z,j),(0,M.$Pc)(()=>{this.c.delete(Z),this.d.delete(Z)})}getEditorSerializer(Z){return this.d.get(typeof Z=="string"?Z:Z.typeId)}}$.$mn.add(e.$aE.EditorFactory,new De);async function ke(se,Z,j){return!se||!se.length?[]:await Promise.all(se.map(async ie=>{const ve=A.URI.revive(ie.fileUri);if(!ve){j.info("Cannot resolve the path because it is not valid.",ie);return}if(!await Z.canHandleResource(ve)){j.info("Cannot resolve the path because it cannot be handled",ie);return}let he=ie.exists,ce=ie.type;if(typeof he!="boolean"||typeof ce!="number")try{ce=(await Z.stat(ve)).isDirectory?E.FileType.Directory:E.FileType.Unknown,he=!0}catch(_){j.error(_),he=!1}if(!he&&ie.openOnlyIfExists){j.info("Cannot resolve the path because it does not exist",ie);return}if(ce===E.FileType.Directory){j.info("Cannot resolve the path because it is a directory",ie);return}const ye={...ie.options,pinned:!0};return he?{resource:ve,options:ye}:{resource:ve,options:ye,forceUntitled:!0}}))}e.$yE=ke;var le;(function(se){se[se.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",se[se.SEQUENTIAL=1]="SEQUENTIAL"})(le||(e.EditorsOrder=le={}));function pe(se){const Z=se;if(!Z)return!1;const j=Z;if(j.modified)return pe(j.modified);const ie=Z;return!!(ie.contributionsState&&ie.viewState&&Array.isArray(ie.cursorState))}e.$zE=pe;function re(se){return(0,P.$Hi)(se)}e.$AE=re;function Pe(se,Z,j){const ie=(0,P.$Ii)(se,Z);return ie.forceMessage=j?.forceMessage,ie.forceSeverity=j?.forceSeverity,ie.allowDialog=j?.allowDialog,ie}e.$BE=Pe}),define(Ae[205],Re([1,0,5,172,4,6,28,30,18,26,90,196]),function(we,e,y,F,A,M,R,$,E,f,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KE=e.$JE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$IE=e.$HE=e.ViewContentGroups=e.$GE=e.$FE=e.ViewContainerLocation=e.Extensions=e.$EE=e.$DE=e.$CE=void 0,e.$CE="views",e.$DE=(0,F.localize)(0,null),e.$EE=(0,D.$aw)("default-view-icon",P.$1j.window,(0,F.localize)(1,null));var u;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(u||(e.Extensions=u={}));var b;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(b||(e.ViewContainerLocation=b={})),e.$FE=[0,1,2];function v(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$GE=v;class g extends M.$Rc{constructor(){super(...arguments),this.c=this.B(new y.$Rd),this.onDidRegister=this.c.event,this.f=this.B(new y.$Rd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,E.$Qb)([...this.g.values()])}registerViewContainer(a,d,p){const m=this.get(a.id);if(m)return m;const S=a;return S.openCommandActionDescriptor=p?.doNotRegisterOpenCommand?void 0:S.openCommandActionDescriptor??{id:S.id},(0,R.$wc)(this.g,d,[]).push(S),p?.isDefault&&this.h.push(S),this.c.fire({viewContainer:S,viewContainerLocation:d}),S}deregisterViewContainer(a){for(const d of this.g.keys()){const p=this.g.get(d),m=p?.indexOf(a);if(m!==-1){p?.splice(m,1),p.length===0&&this.g.delete(d),this.f.fire({viewContainer:a,viewContainerLocation:d});return}}}get(a){return this.all.filter(d=>d.id===a)[0]}getViewContainers(a){return[...this.g.get(a)||[]]}getViewContainerLocation(a){return[...this.g.keys()].filter(d=>this.getViewContainers(d).filter(p=>p?.id===a.id).length>0)[0]}getDefaultViewContainer(a){return this.h.find(d=>this.getViewContainerLocation(d)===a)}}$.$mn.add(u.ViewContainersRegistry,new g);var t;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(t||(e.ViewContentGroups=t={}));function i(s,a){const d=s.group??t.More,p=a.group??t.More;return d!==p?d.localeCompare(p):(s.order??5)-(a.order??5)}class r extends M.$Rc{constructor(){super(...arguments),this.c=this.B(new y.$Rd),this.onViewsRegistered=this.c.event,this.f=this.B(new y.$Rd),this.onViewsDeregistered=this.f.event,this.g=this.B(new y.$Rd),this.onDidChangeContainer=this.g.event,this.h=this.B(new y.$Rd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Fc}registerViews(a,d){this.registerViews2([{views:a,viewContainer:d}])}registerViews2(a){a.forEach(({views:d,viewContainer:p})=>this.r(d,p)),this.c.fire(a)}deregisterViews(a,d){const p=this.s(a,d);p.length&&this.f.fire({views:p,viewContainer:d})}moveViews(a,d){for(const p of this.m.keys())if(p!==d){const m=this.s(a,p);m.length&&(this.r(m,d),this.g.fire({views:m,from:p,to:d}))}}getViews(a){return this.m.get(a)||[]}getView(a){for(const d of this.j){const p=(this.m.get(d)||[]).filter(m=>m.id===a)[0];if(p)return p}return null}getViewContainer(a){for(const d of this.j)if((this.m.get(d)||[]).filter(m=>m.id===a)[0])return d;return null}registerViewWelcomeContent(a,d){return this.n.add(a,d),this.h.fire(a),(0,M.$Pc)(()=>{this.n.delete(a,d),this.h.fire(a)})}registerViewWelcomeContent2(a,d){const p=new Map;for(const[m,S]of d)this.n.add(a,S),p.set(m,(0,M.$Pc)(()=>{this.n.delete(a,S),this.h.fire(a)}));return this.h.fire(a),p}getViewWelcomeContent(a){const d=[];return this.n.forEach(a,p=>d.push(p)),d.sort(i)}r(a,d){let p=this.m.get(d);p||(p=[],this.m.set(d,p),this.j.push(d));for(const m of a){if(this.getView(m.id)!==null)throw new Error((0,F.localize)(2,null,m.id));p.push(m)}}s(a,d){const p=this.m.get(d);if(!p)return[];const m=[],S=[];for(const k of p)a.includes(k)?m.push(k):S.push(k);return m.length&&(S.length?this.m.set(d,S):(this.m.delete(d),this.j.splice(this.j.indexOf(d),1))),m}}$.$mn.add(u.ViewsRegistry,new r),e.$HE=(0,A.$Vh)("viewsService"),e.$IE=(0,A.$Vh)("viewDescriptorService");var c;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(c||(e.ViewVisibilityState=c={}));var o;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(o||(e.TreeItemCollapsibleState=o={}));class l{constructor(a,d){this.c=!1,this.d=!1,(0,f.$dn)(this,a),this.d=!!d,this.resolve=async p=>{if(d&&!this.c){const m=await d(p);m&&(this.tooltip=this.tooltip??m.tooltip,this.command=this.command??m.command)}p.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$JE=l;class n extends Error{constructor(a){super((0,F.localize)(3,null,a)),this.name="NoTreeViewError"}static is(a){return a.name==="NoTreeViewError"}}e.$KE=n}),define(Ae[206],Re([1,0,2,29,4]),function(we,e,y,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aF=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$_E=e.$$E=void 0;function M(f){return!!f&&typeof f=="object"&&"uri"in f&&f.uri instanceof y.URI&&"version"in f&&typeof f.version=="number"&&"ranges"in f&&Array.isArray(f.ranges)&&f.ranges.every(F.$zs.isIRange)}e.$$E=M;function R(f){return!!f&&typeof f=="object"&&"documents"in f&&Array.isArray(f.documents)&&f.documents.every(M)}e.$_E=R;var $;(function(f){f[f.Down=0]="Down",f[f.Up=1]="Up"})($||(e.InteractiveSessionVoteDirection=$={}));var E;(function(f){f[f.Action=1]="Action",f[f.Toolbar=2]="Toolbar"})(E||(e.InteractiveSessionCopyKind=E={})),e.$aF=(0,A.$Vh)("IChatService")}),define(Ae[207],Re([1,0,5,14,173]),function(we,e,y,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$cb=void 0;class M{constructor(){this.f=new Map,this.k=[],this.m=new y.$Rd,this.n=new y.$Rd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage($){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=$}onEvent($){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=$}onRequest($){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=$}sendResponse($){$.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${$.command}`)):this.s("response",$)}sendRequest($,E,f,P){const D={command:$};if(E&&Object.keys(E).length>0&&(D.arguments=E),this.s("request",D),typeof P=="number"){const u=setTimeout(()=>{clearTimeout(u);const b=this.f.get(D.seq);if(b){this.f.delete(D.seq);const v={type:"response",seq:0,request_seq:D.seq,success:!1,command:$,message:(0,A.localize)(0,null,P,$)};b(v)}},P)}return f&&this.f.set(D.seq,f),D.seq}acceptMessage($){this.j?this.j($):(this.k.push($),this.k.length===1&&this.q())}o($,E){return $.type!=="event"||E.type!=="event"}async q(){let $;for(;this.k.length;){if((!$||this.o(this.k[0],$))&&await(0,F.$Yg)(0),$=this.k.shift(),!$)return;switch($.type){case"event":this.i?.($);break;case"request":this.g?.($);break;case"response":{const E=$,f=this.f.get(E.request_seq);f&&(this.f.delete(E.request_seq),f(E));break}}}}s($,E){E.type=$,E.seq=this.d++,this.sendMessage(E)}async u(){if(this.f.size===0)return Promise.resolve();const $=new Map;this.f.forEach((E,f)=>$.set(f,E)),await(0,F.$Yg)(500),$.forEach((E,f)=>{E({type:"response",seq:0,request_seq:f,success:!1,command:"canceled",message:"canceled"}),this.f.delete(f)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$$cb=M}),define(Ae[208],Re([1,0,174,34,4]),function(we,e,y,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$lH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$kH=e.MemoryRangeType=e.$jH=e.State=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=void 0,e.$gG="workbench.view.debug",e.$hG="workbench.debug.variablesView",e.$iG="workbench.debug.watchExpressionsView",e.$jG="workbench.debug.callStackView",e.$kG="workbench.debug.loadedScriptsView",e.$lG="workbench.debug.breakPointsView",e.$mG="workbench.debug.disassemblyView",e.$nG="workbench.panel.repl",e.$oG="workbench.panel.repl.view",e.$pG=new F.$aj("debugType",void 0,{type:"string",description:y.localize(0,null)}),e.$qG=new F.$aj("debugConfigurationType",void 0,{type:"string",description:y.localize(1,null)}),e.$rG=new F.$aj("debugState","inactive",{type:"string",description:y.localize(2,null)}),e.$sG="debugUx",e.$tG=new F.$aj(e.$sG,"default",{type:"string",description:y.localize(3,null)}),e.$uG=new F.$aj("hasDebugged",!1,{type:"boolean",description:y.localize(4,null)}),e.$vG=new F.$aj("inDebugMode",!1,{type:"boolean",description:y.localize(5,null)}),e.$wG=new F.$aj("inDebugRepl",!1,{type:"boolean",description:y.localize(6,null)}),e.$xG=new F.$aj("breakpointWidgetVisible",!1,{type:"boolean",description:y.localize(7,null)}),e.$yG=new F.$aj("inBreakpointWidget",!1,{type:"boolean",description:y.localize(8,null)}),e.$zG=new F.$aj("breakpointsFocused",!0,{type:"boolean",description:y.localize(9,null)}),e.$AG=new F.$aj("watchExpressionsFocused",!0,{type:"boolean",description:y.localize(10,null)}),e.$BG=new F.$aj("watchExpressionsExist",!1,{type:"boolean",description:y.localize(11,null)}),e.$CG=new F.$aj("variablesFocused",!0,{type:"boolean",description:y.localize(12,null)}),e.$DG=new F.$aj("expressionSelected",!1,{type:"boolean",description:y.localize(13,null)}),e.$EG=new F.$aj("breakpointInputFocused",!1,{type:"boolean",description:y.localize(14,null)}),e.$FG=new F.$aj("callStackItemType",void 0,{type:"string",description:y.localize(15,null)}),e.$GG=new F.$aj("callStackSessionIsAttach",!1,{type:"boolean",description:y.localize(16,null)}),e.$HG=new F.$aj("callStackItemStopped",!1,{type:"boolean",description:y.localize(17,null)}),e.$IG=new F.$aj("callStackSessionHasOneThread",!1,{type:"boolean",description:y.localize(18,null)}),e.$JG=new F.$aj("watchItemType",void 0,{type:"string",description:y.localize(19,null)}),e.$KG=new F.$aj("canViewMemory",void 0,{type:"boolean",description:y.localize(20,null)}),e.$LG=new F.$aj("breakpointItemType",void 0,{type:"string",description:y.localize(21,null)}),e.$MG=new F.$aj("breakpointSupportsCondition",!1,{type:"boolean",description:y.localize(22,null)}),e.$NG=new F.$aj("loadedScriptsSupported",!1,{type:"boolean",description:y.localize(23,null)}),e.$OG=new F.$aj("loadedScriptsItemType",void 0,{type:"string",description:y.localize(24,null)}),e.$PG=new F.$aj("focusedSessionIsAttach",!1,{type:"boolean",description:y.localize(25,null)}),e.$QG=new F.$aj("focusedSessionIsNoDebug",!1,{type:"boolean",description:y.localize(26,null)}),e.$RG=new F.$aj("stepBackSupported",!1,{type:"boolean",description:y.localize(27,null)}),e.$SG=new F.$aj("restartFrameSupported",!1,{type:"boolean",description:y.localize(28,null)}),e.$TG=new F.$aj("stackFrameSupportsRestart",!1,{type:"boolean",description:y.localize(29,null)}),e.$UG=new F.$aj("jumpToCursorSupported",!1,{type:"boolean",description:y.localize(30,null)}),e.$VG=new F.$aj("stepIntoTargetsSupported",!1,{type:"boolean",description:y.localize(31,null)}),e.$WG=new F.$aj("breakpointsExist",!1,{type:"boolean",description:y.localize(32,null)}),e.$XG=new F.$aj("debuggersAvailable",!1,{type:"boolean",description:y.localize(33,null)}),e.$YG=new F.$aj("debugExtensionAvailable",!0,{type:"boolean",description:y.localize(34,null)}),e.$ZG=new F.$aj("debugProtocolVariableMenuContext",void 0,{type:"string",description:y.localize(35,null)}),e.$1G=new F.$aj("debugSetVariableSupported",!1,{type:"boolean",description:y.localize(36,null)}),e.$2G=new F.$aj("debugSetExpressionSupported",!1,{type:"boolean",description:y.localize(37,null)}),e.$3G=new F.$aj("breakWhenValueChangesSupported",!1,{type:"boolean",description:y.localize(38,null)}),e.$4G=new F.$aj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:y.localize(39,null)}),e.$5G=new F.$aj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:y.localize(40,null)}),e.$6G=new F.$aj("terminateDebuggeeSupported",!1,{type:"boolean",description:y.localize(41,null)}),e.$7G=new F.$aj("suspendDebuggeeSupported",!1,{type:"boolean",description:y.localize(42,null)}),e.$8G=new F.$aj("variableEvaluateNamePresent",!1,{type:"boolean",description:y.localize(43,null)}),e.$9G=new F.$aj("variableIsReadonly",!1,{type:"boolean",description:y.localize(44,null)}),e.$0G=new F.$aj("exceptionWidgetVisible",!1,{type:"boolean",description:y.localize(45,null)}),e.$$G=new F.$aj("multiSessionRepl",!1,{type:"boolean",description:y.localize(46,null)}),e.$_G=new F.$aj("multiSessionDebug",!1,{type:"boolean",description:y.localize(47,null)}),e.$aH=new F.$aj("disassembleRequestSupported",!1,{type:"boolean",description:y.localize(48,null)}),e.$bH=new F.$aj("disassemblyViewFocus",!1,{type:"boolean",description:y.localize(49,null)}),e.$cH=new F.$aj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:y.localize(50,null)}),e.$dH=new F.$aj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:y.localize(51,null)});const M=u=>y.localize(52,null,u);e.$eH=M,e.$fH="editor.contrib.debug",e.$gH="editor.contrib.breakpoint",e.$hH="debug",e.$iH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:y.localize(53,null)};var R;(function(u){u[u.Inactive=0]="Inactive",u[u.Initializing=1]="Initializing",u[u.Stopped=2]="Stopped",u[u.Running=3]="Running"})(R||(e.State=R={}));function $(u){switch(u){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$jH=$;var E;(function(u){u[u.Valid=0]="Valid",u[u.Unreadable=1]="Unreadable",u[u.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$kH="vscode-debug-memory";var f;(function(u){u[u.Initial=1]="Initial",u[u.Dynamic=2]="Dynamic"})(f||(e.DebugConfigurationProviderTriggerKind=f={}));var P;(function(u){u.UnverifiedBreakpoints="unverifiedBreakpoints"})(P||(e.DebuggerString=P={})),e.$lH=(0,A.$Vh)("debugService");var D;(function(u){u[u.CONDITION=0]="CONDITION",u[u.HIT_COUNT=1]="HIT_COUNT",u[u.LOG_MESSAGE=2]="LOG_MESSAGE"})(D||(e.BreakpointWidgetContext=D={}))}),define(Ae[209],Re([1,0,12,2,20,26,13,29,19,18]),function(we,e,y,F,A,M,R,$,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rF=e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=e.$iF=e.$hF=e.$gF=e.$fF=void 0;const P=/{([^}]+)}/g;function D(k,h,w){return k.replace(P,function(I,L){return h&&L.length>0&&L[0]!=="_"?I:w&&w.hasOwnProperty(L)?w[L]:I})}e.$fF=D;function u(k){const h={};for(const w of Object.keys(k))w.startsWith("!")||(h[w]=k[w]);return h}e.$gF=u;function b(k){return k.configuration.request==="attach"&&!v(k)&&(!k.parentSession||b(k.parentSession))}e.$hF=b;function v(k){let h=k.configuration.type;if(h)return h==="vslsShare"&&(h=k.configuration.adapterProxy.configuration.type),(0,y.$6e)(h,"extensionhost")||(0,y.$6e)(h,"pwa-extensionhost")?k:k.parentSession?v(k.parentSession):void 0}e.$iF=v;function g(k){return k.type&&(k.label||k.program||k.runtime)}e.$jF=g;function t(k,h,w){let I,L=0;const V=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let Y=null;for(;Y=V.exec(k);){const U=Y.index+1,N=U+Y[0].length;if(U<=h&&N>=w){I=Y[0],L=U;break}}if(I){const U=/\w+/g;let N=null;for(;(N=U.exec(I))&&!(N.index+1+L+N[0].length>=w););N&&(I=I.substring(0,U.lastIndex))}return I?{start:L,end:L+I.length-1}:{start:0,end:0}}e.$kF=t;async function i(k,h,w,I){if(k.evaluatableExpressionProvider.has(h)){const L=k.evaluatableExpressionProvider.ordered(h),V=(0,f.$Gb)(await Promise.all(L.map(async Y=>{try{return await Y.provideEvaluatableExpression(h,w,I??E.CancellationToken.None)}catch{return}})));if(V.length>0){let Y=V[0].expression;const U=V[0].range;return Y||(Y=h.getLineContent(w.lineNumber).substring(U.startColumn-1,U.endColumn-1)),{range:U,matchingExpression:Y}}}else{const L=h.getLineContent(w.lineNumber),{start:V,end:Y}=t(L,w.column,w.column),U=L.substring(V-1,Y);return{matchingExpression:U,range:new $.$zs(w.lineNumber,V,w.lineNumber,V+U.length)}}return null}e.$lF=i;const r=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function c(k){return!!(k&&k.match(r))}e.$mF=c;function o(k){if(typeof k.path=="string"&&!(typeof k.sourceReference=="number"&&k.sourceReference>0)){if(c(k.path))return F.URI.parse(k.path);if((0,A.$hc)(k.path))return F.URI.file(k.path)}return k.path}function l(k){if(typeof k.path=="object"){const h=F.URI.revive(k.path);if(h)return h.scheme===R.Schemas.file?h.fsPath:h.toString()}return k.path}function n(k,h){const w=h?o:l,I=(0,M.$an)(k);return a(I,(L,V)=>{L&&V&&(V.path=w(V))}),I}e.$nF=n;function s(k,h){const w=h?o:l,I=(0,M.$an)(k);return a(I,(L,V)=>{!L&&V&&(V.path=w(V))}),I}e.$oF=s;function a(k,h){switch(k.type){case"event":{const w=k;switch(w.event){case"output":h(!1,w.body.source);break;case"loadedSource":h(!1,w.body.source);break;case"breakpoint":h(!1,w.body.breakpoint.source);break;default:break}break}case"request":{const w=k;switch(w.command){case"setBreakpoints":h(!0,w.arguments.source);break;case"breakpointLocations":h(!0,w.arguments.source);break;case"source":h(!0,w.arguments.source);break;case"gotoTargets":h(!0,w.arguments.source);break;case"launchVSCode":w.arguments.args.forEach(I=>h(!1,I));break;default:break}break}case"response":{const w=k;if(w.success&&w.body)switch(w.command){case"stackTrace":w.body.stackFrames.forEach(I=>h(!1,I.source));break;case"loadedSources":w.body.sources.forEach(I=>h(!1,I));break;case"scopes":w.body.scopes.forEach(I=>h(!1,I.source));break;case"setFunctionBreakpoints":w.body.breakpoints.forEach(I=>h(!1,I.source));break;case"setBreakpoints":w.body.breakpoints.forEach(I=>h(!1,I.source));break;case"disassemble":w.body?.instructions.forEach(L=>h(!1,L.location));break;default:break}break}}}function d(k){return k.filter(h=>!h.presentation?.hidden).sort((h,w)=>h.presentation?w.presentation?h.presentation.group?w.presentation.group?h.presentation.group!==w.presentation.group?h.presentation.group.localeCompare(w.presentation.group):p(h.presentation.order,w.presentation.order):-1:w.presentation.group?1:p(h.presentation.order,w.presentation.order):-1:w.presentation?1:0)}e.$pF=d;function p(k,h){return typeof k!="number"?typeof h!="number"?0:1:typeof h!="number"?-1:k-h}async function m(k,h){const w=k.getValue("debug.saveBeforeStart",{overrideIdentifier:h.activeTextEditorLanguageId});if(w!=="none"&&(await h.saveAll(),w==="allEditorsInActiveGroup")){const I=h.activeEditorPane;I&&I.input.resource?.scheme===R.Schemas.untitled&&await h.save({editor:I.input,groupId:I.group.id})}await k.reloadConfiguration()}e.$qF=m;const S=(k,h)=>!k||!h?k===h:k.name===h.name&&k.path===h.path&&k.sourceReference===h.sourceReference;e.$rF=S}),define(Ae[76],Re([1,0,24,33,67,68,13,20,21,34]),function(we,e,y,F,A,M,R,$,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FI=e.$EI=e.$DI=e.$CI=e.CellStatusbarAlignment=e.$BI=e.$AI=e.$zI=e.NotebookEditorPriority=e.$yI=e.$xI=e.$wI=e.$vI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$uI=e.$tI=e.$sI=e.$rI=e.CellKind=e.$qI=e.$pI=e.$oI=void 0,e.$oI="workbench.editor.notebook",e.$pI="workbench.editor.notebookTextDiffEditor",e.$qI="workbench.editor.interactive";var P;(function(T){T[T.Markup=1]="Markup",T[T.Code=2]="Code"})(P||(e.CellKind=P={})),e.$rI=["application/json","application/javascript","text/html","image/svg+xml",M.$Vr.latex,M.$Vr.markdown,"image/png","image/jpeg",M.$Vr.text],e.$sI=[M.$Vr.latex,M.$Vr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",M.$Vr.text],e.$tI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$uI="_notAvailable";var D;(function(T){T[T.Running=1]="Running",T[T.Idle=2]="Idle"})(D||(e.NotebookRunState=D={}));var u;(function(T){T[T.Unconfirmed=1]="Unconfirmed",T[T.Pending=2]="Pending",T[T.Executing=3]="Executing"})(u||(e.NotebookCellExecutionState=u={}));var b;(function(T){T[T.Unconfirmed=1]="Unconfirmed",T[T.Pending=2]="Pending",T[T.Executing=3]="Executing"})(b||(e.NotebookExecutionState=b={}));var v;(function(T){T[T.WithHardKernelDependency=0]="WithHardKernelDependency",T[T.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",T[T.Pure=2]="Pure",T[T.Never=3]="Never"})(v||(e.NotebookRendererMatch=v={}));var g;(function(T){T.Always="always",T.Never="never",T.Optional="optional"})(g||(e.RendererMessagingSpec=g={}));var t;(function(T){T[T.ModelChange=1]="ModelChange",T[T.Move=2]="Move",T[T.ChangeCellLanguage=5]="ChangeCellLanguage",T[T.Initialize=6]="Initialize",T[T.ChangeCellMetadata=7]="ChangeCellMetadata",T[T.Output=8]="Output",T[T.OutputItem=9]="OutputItem",T[T.ChangeCellContent=10]="ChangeCellContent",T[T.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",T[T.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",T[T.ChangeCellMime=13]="ChangeCellMime",T[T.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var i;(function(T){T[T.Handle=0]="Handle",T[T.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var r;(function(T){T[T.Replace=1]="Replace",T[T.Output=2]="Output",T[T.Metadata=3]="Metadata",T[T.CellLanguage=4]="CellLanguage",T[T.DocumentMetadata=5]="DocumentMetadata",T[T.Move=6]="Move",T[T.OutputItems=7]="OutputItems",T[T.PartialMetadata=8]="PartialMetadata",T[T.PartialInternalMetadata=9]="PartialInternalMetadata"})(r||(e.CellEditType=r={}));var c;(function(T){T.scheme=R.Schemas.vscodeNotebookCell;const G=["W","X","Y","Z","a","b","c","d","e","f"],de=new RegExp(`^[${G.join("")}]+`),me=7;function De(se,Z){const j=Z.toString(me),ve=`${j.length<G.length?G[j.length-1]:"z"}${j}s${(0,y.$ze)(y.$fe.fromString(se.scheme),!0,!0)}`;return se.with({scheme:T.scheme,fragment:ve})}T.generate=De;function ke(se){if(se.scheme!==T.scheme)return;const Z=se.fragment.indexOf("s");if(Z<0)return;const j=parseInt(se.fragment.substring(0,Z).replace(de,""),me),ie=(0,y.$ye)(se.fragment.substring(Z+1)).toString();if(!isNaN(j))return{handle:j,notebook:se.with({scheme:ie,fragment:null})}}T.parse=ke;function le(se,Z){return se.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${Z??""},${se.scheme!==R.Schemas.file?se.scheme:""}`})}T.generateCellOutputUri=le;function pe(se){if(se.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const Z=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(se.fragment);if(!Z)return;const j=Z[1]&&Z[1]!==""?Z[1]:void 0,ie=Z[2];return{outputId:j,notebook:se.with({scheme:ie||R.Schemas.file,fragment:null})}}T.parseCellOutputUri=pe;function re(se,Z,j){return T.generate(se,Z).with({scheme:j})}T.generateCellPropertyUri=re;function Pe(se,Z){if(se.scheme===Z)return T.parse(se.with({scheme:T.scheme}))}T.parseCellPropertyUri=Pe})(c||(e.CellUri=c={}));const o=T=>E.$i?T.replace(/\//g,"\\"):T;class l{constructor(G=[],de=e.$rI){this.e=de,this.d=[...new Set(G)].map(me=>({pattern:me,matches:F.$Cj(o(me))}))}sort(G){const de=new Map(A.Iterable.map(G,De=>[De,o(De)]));let me=[];for(const{matches:De}of this.d)for(const[ke,le]of de)if(De(le)){me.push(ke),de.delete(ke);break}return de.size&&(me=me.concat([...de.keys()].sort((De,ke)=>this.e.indexOf(De)-this.e.indexOf(ke)))),me}prioritize(G,de){const me=this.f(G);if(me===-1){this.d.unshift({pattern:G,matches:F.$Cj(o(G))});return}const De=new Set(de.map(le=>this.f(le,me)));De.delete(-1);const ke=Array.from(De).sort();this.d.splice(me+1,0,...ke.map(le=>this.d[le]));for(let le=ke.length-1;le>=0;le--)this.d.splice(ke[le],1)}toArray(){return this.d.map(G=>G.pattern)}f(G,de=this.d.length){const me=o(G);for(let De=0;De<de;De++)if(this.d[De].matches(me))return De;return-1}}e.$vI=l;function n(T,G,de,me=(De,ke)=>De===ke){const De=[];function ke(re,Pe,se){if(Pe===0&&se.length===0)return;const Z=De[De.length-1];Z&&Z.start+Z.deleteCount===re?(Z.deleteCount+=Pe,Z.toInsert.push(...se)):De.push({start:re,deleteCount:Pe,toInsert:se})}let le=0,pe=0;for(;;){if(le===T.length){ke(le,0,G.slice(pe));break}if(pe===G.length){ke(le,T.length-le,[]);break}const re=T[le],Pe=G[pe];if(me(re,Pe)){le+=1,pe+=1;continue}de(Pe)?(ke(le,1,[]),le+=1):(ke(le,0,[Pe]),pe+=1)}return De}e.$wI=n,e.$xI=new f.$aj("notebookEditorCursorAtBoundary","none"),e.$yI=new f.$aj("notebookEditorCursorAtLineBoundary","none");var s;(function(T){T.default="default",T.option="option"})(s||(e.NotebookEditorPriority=s={}));function a(T){const G=T;return!!((typeof G.include=="string"||F.$Dj(G.include))&&(typeof G.exclude=="string"||F.$Dj(G.exclude)))}e.$zI=a;function d(T,G,de){if(Array.isArray(T.viewType)&&T.viewType.indexOf(G)>=0||T.viewType===G)return!0;if(T.filenamePattern){const me=a(T.filenamePattern)?T.filenamePattern.include:T.filenamePattern,De=a(T.filenamePattern)?T.filenamePattern.exclude:void 0;if(F.$Bj(me,(0,$.$mc)(de.fsPath).toLowerCase()))return!(De&&F.$Bj(De,(0,$.$mc)(de.fsPath).toLowerCase()))}return!1}e.$AI=d,e.$BI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var p;(function(T){T[T.Left=1]="Left",T[T.Right=2]="Right"})(p||(e.CellStatusbarAlignment=p={}));class m{static{this.d="notebook/"}static create(G){return`${m.d}${G}`}static parse(G){if(G.startsWith(m.d))return G.substring(m.d.length)}}e.$CI=m;function S(T){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(T)}e.$DI=S;const k=new TextDecoder;function h(T){const G=[];let de=!1;for(const le of T)(G.length===0||de)&&(G.push(le),de=!0);let me=L(G);const De=y.$fe.concat(G.map(le=>y.$fe.wrap(le))),ke=C(De);return me=me||ke.byteLength!==De.byteLength,{data:ke,didCompression:me}}e.$EI=h,e.$FI=`${String.fromCharCode(27)}[A`;const w=e.$FI.split("").map(T=>T.charCodeAt(0)),I=10;function L(T){let G=!1;return T.forEach((de,me)=>{if(me===0||de.length<e.$FI.length)return;const De=T[me-1],ke=de.subarray(0,e.$FI.length);if(ke[0]===w[0]&&ke[1]===w[1]&&ke[2]===w[2]){const le=De.lastIndexOf(I);if(le===-1)return;G=!0,T[me-1]=De.subarray(0,le),T[me]=de.subarray(e.$FI.length)}}),G}function V(T){let G=T;do T=G,G=T.replace(/[^\n]\x08/gm,"");while(G.length<T.length);return T}function Y(T){for(T=T.replace(/\r+\n/gm,`
`);T.search(/\r[^$]/g)>-1;){const G=T.match(/^(.*)\r+/m)[1];let de=T.match(/\r+(.*)$/m)[1];de=de+G.slice(de.length,G.length),T=T.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,de)}return T}const U="\b".charCodeAt(0),N="\r".charCodeAt(0);function C(T){return!T.buffer.includes(U)&&!T.buffer.includes(N)?T:y.$fe.fromString(Y(V(k.decode(T.buffer))))}}),define(Ae[7],Re([1,0,18,11,52,28,68,12,16,2,38,22,41,100,76]),function(we,e,y,F,A,M,R,$,E,f,P,D,u,b,v){"use strict";var g,t,i,r,c,o,l,n,s,a,d,p,m,S,k,h,w,I;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$qM=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=e.$fM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.TestRunProfileKind=e.TestResultState=e.$9L=e.$8L=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$7L=e.$6L=e.$5L=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$4L=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$3L=e.$2L=e.$1L=e.$ZL=e.$YL=e.ColorThemeKind=e.$XL=e.$WL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$VL=e.DebugConsoleMode=e.$UL=e.$TL=e.$SL=e.$RL=e.$QL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$PL=e.$OL=e.FileChangeType=e.$NL=e.$ML=e.$LL=e.$KL=e.InlineCompletionTriggerKind=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.ConfigurationTarget=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.$qL=e.$pL=e.$oL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$nL=e.ViewBadge=e.ProgressLocation=e.$mL=e.$lL=e.TaskScope=e.ShellQuoting=e.$kL=e.$jL=e.$iL=e.TaskPanelKind=e.TaskRevealKind=e.$hL=e.TerminalLocation=e.$gL=e.$fL=e.$eL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$dL=e.$cL=e.$bL=e.$aL=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$_K=e.StatusBarAlignment=e.ViewColumn=e.$$K=e.$0K=e.$9K=e.$8K=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$7K=e.$6K=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$5K=e.$4K=e.$3K=e.$2K=e.$1K=e.LanguageStatusSeverity=e.$ZK=e.$YK=e.$XK=e.$WK=e.$VK=e.$UK=e.CodeActionTriggerKind=e.$TK=e.$SK=e.SymbolTag=e.SymbolKind=e.$RK=e.DocumentHighlightKind=e.$QK=e.$PK=e.$OK=e.$NK=e.DiagnosticSeverity=e.DiagnosticTag=e.$MK=e.$LK=e.FileEditType=e.$KK=e.$JK=e.$IK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function L(B){return Object.assign(B,{apply:function(...oe){if(oe.length===0)return Reflect.construct(B,[]);{const Se=oe.length===1?[]:oe[1];return Reflect.construct(B,Se,oe[0].constructor)}},call:function(...oe){if(oe.length===0)return Reflect.construct(B,[]);{const[Se,...Ge]=oe;return Reflect.construct(B,Ge,Se.constructor)}}})}var V;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(V||(e.TerminalOutputAnchor=V={}));var Y;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(Y||(e.TerminalQuickFixType=Y={}));let U=g=class{static from(...z){let oe=z;return new g(function(){if(oe){for(const Se of oe)Se&&typeof Se.dispose=="function"&&Se.dispose();oe=void 0}})}#e;constructor(z){this.#e=z}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$BK=U,e.$BK=U=g=Ke([L],U);let N=t=class{static Min(...z){if(z.length===0)throw new TypeError;let oe=z[0];for(let Se=1;Se<z.length;Se++){const Ge=z[Se];Ge.isBefore(oe)&&(oe=Ge)}return oe}static Max(...z){if(z.length===0)throw new TypeError;let oe=z[0];for(let Se=1;Se<z.length;Se++){const Ge=z[Se];Ge.isAfter(oe)&&(oe=Ge)}return oe}static isPosition(z){if(!z)return!1;if(z instanceof t)return!0;const{line:oe,character:Se}=z;return typeof oe=="number"&&typeof Se=="number"}static of(z){if(z instanceof t)return z;if(this.isPosition(z))return new t(z.line,z.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(z,oe){if(z<0)throw(0,F.$6)("line must be non-negative");if(oe<0)throw(0,F.$6)("character must be non-negative");this.c=z,this.e=oe}isBefore(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<z.e}isBeforeOrEqual(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<=z.e}isAfter(z){return!this.isBeforeOrEqual(z)}isAfterOrEqual(z){return!this.isBefore(z)}isEqual(z){return this.c===z.c&&this.e===z.e}compareTo(z){return this.c<z.c?-1:this.c>z.line?1:this.e<z.e?-1:this.e>z.e?1:0}translate(z,oe=0){if(z===null||oe===null)throw(0,F.$6)();let Se;return typeof z>"u"?Se=0:typeof z=="number"?Se=z:(Se=typeof z.lineDelta=="number"?z.lineDelta:0,oe=typeof z.characterDelta=="number"?z.characterDelta:0),Se===0&&oe===0?this:new t(this.line+Se,this.character+oe)}with(z,oe=this.character){if(z===null||oe===null)throw(0,F.$6)();let Se;return typeof z>"u"?Se=this.line:typeof z=="number"?Se=z:(Se=typeof z.line=="number"?z.line:this.line,oe=typeof z.character=="number"?z.character:this.character),Se===this.line&&oe===this.character?this:new t(Se,oe)}toJSON(){return{line:this.line,character:this.character}}};e.$CK=N,e.$CK=N=t=Ke([L],N);let C=i=class{static isRange(z){return z instanceof i?!0:z?N.isPosition(z.start)&&N.isPosition(z.end):!1}static of(z){if(z instanceof i)return z;if(this.isRange(z))return new i(z.start,z.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(z,oe,Se,Ge){let xe,at;if(typeof z=="number"&&typeof oe=="number"&&typeof Se=="number"&&typeof Ge=="number"?(xe=new N(z,oe),at=new N(Se,Ge)):N.isPosition(z)&&N.isPosition(oe)&&(xe=N.of(z),at=N.of(oe)),!xe||!at)throw new Error("Invalid arguments");xe.isBefore(at)?(this.c=xe,this.e=at):(this.c=at,this.e=xe)}contains(z){return i.isRange(z)?this.contains(z.start)&&this.contains(z.end):N.isPosition(z)?!(N.of(z).isBefore(this.c)||this.e.isBefore(z)):!1}isEqual(z){return this.c.isEqual(z.c)&&this.e.isEqual(z.e)}intersection(z){const oe=N.Max(z.start,this.c),Se=N.Min(z.end,this.e);if(!oe.isAfter(Se))return new i(oe,Se)}union(z){if(this.contains(z))return this;if(z.contains(this))return z;const oe=N.Min(z.start,this.c),Se=N.Max(z.end,this.end);return new i(oe,Se)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(z,oe=this.end){if(z===null||oe===null)throw(0,F.$6)();let Se;return z?N.isPosition(z)?Se=z:(Se=z.start||this.start,oe=z.end||this.end):Se=this.start,Se.isEqual(this.c)&&oe.isEqual(this.end)?this:new i(Se,oe)}toJSON(){return[this.start,this.end]}};e.$DK=C,e.$DK=C=i=Ke([L],C);let T=r=class extends C{static isSelection(z){return z instanceof r?!0:z?C.isRange(z)&&N.isPosition(z.anchor)&&N.isPosition(z.active)&&typeof z.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(z,oe,Se,Ge){let xe,at;if(typeof z=="number"&&typeof oe=="number"&&typeof Se=="number"&&typeof Ge=="number"?(xe=new N(z,oe),at=new N(Se,Ge)):N.isPosition(z)&&N.isPosition(oe)&&(xe=N.of(z),at=N.of(oe)),!xe||!at)throw new Error("Invalid arguments");super(xe,at),this.f=xe,this.g=at}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$EK=T,e.$EK=T=r=Ke([L],T);const G=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,F.$6)("connectionToken")};class de{static isResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.host=="string"&&typeof z.port=="number"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,oe,Se){if(typeof z!="string"||z.length===0)throw(0,F.$6)("host");if(typeof oe!="number"||oe===0||Math.round(oe)!==oe)throw(0,F.$6)("port");typeof Se<"u"&&G(Se),this.host=z,this.port=Math.round(oe),this.connectionToken=Se}}e.$FK=de;class me{static isManagedResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.makeConnection=="function"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,oe){this.makeConnection=z,this.connectionToken=oe,typeof oe<"u"&&G(oe)}}e.$GK=me;class De extends Error{static NotAvailable(z,oe){return new De(z,b.RemoteAuthorityResolverErrorCode.NotAvailable,oe)}static TemporarilyNotAvailable(z){return new De(z,b.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(z,oe=b.RemoteAuthorityResolverErrorCode.Unknown,Se){super(z),this._message=z,this._code=oe,this._detail=Se,Object.setPrototypeOf(this,De.prototype)}}e.$HK=De;var ke;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(ke||(e.EndOfLine=ke={}));var le;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(le||(e.EnvironmentVariableMutatorType=le={}));let pe=c=class{static isTextEdit(z){return z instanceof c?!0:z?C.isRange(z)&&typeof z.newText=="string":!1}static replace(z,oe){return new c(z,oe)}static insert(z,oe){return c.replace(new C(z,z),oe)}static delete(z){return c.replace(z,"")}static setEndOfLine(z){const oe=new c(new C(new N(0,0),new N(0,0)),"");return oe.newEol=z,oe}get range(){return this.c}set range(z){if(z&&!C.isRange(z))throw(0,F.$6)("range");this.c=z}get newText(){return this.e||""}set newText(z){if(z&&typeof z!="string")throw(0,F.$6)("newText");this.e=z}get newEol(){return this.f}set newEol(z){if(z&&typeof z!="number")throw(0,F.$6)("newEol");this.f=z}constructor(z,oe){this.c=z,this.e=oe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$IK=pe,e.$IK=pe=c=Ke([L],pe);let re=o=class{static isNotebookCellEdit(z){return z instanceof o?!0:z?_t.isNotebookRange(z)&&Array.isArray(z.newCells):!1}static replaceCells(z,oe){return new o(z,oe)}static insertCells(z,oe){return new o(new _t(z,z),oe)}static deleteCells(z){return new o(z,[])}static updateCellMetadata(z,oe){const Se=new o(new _t(z,z),[]);return Se.newCellMetadata=oe,Se}static updateNotebookMetadata(z){const oe=new o(new _t(0,0),[]);return oe.newNotebookMetadata=z,oe}constructor(z,oe){this.range=z,this.newCells=oe}};e.$JK=re,e.$JK=re=o=Ke([L],re);class Pe{static isSnippetTextEdit(z){return z instanceof Pe?!0:z?C.isRange(z.range)&&j.isSnippetString(z.snippet):!1}static replace(z,oe){return new Pe(z,oe)}static insert(z,oe){return Pe.replace(new C(z,z),oe)}constructor(z,oe){this.range=z,this.snippet=oe}}e.$KK=Pe;var se;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(se||(e.FileEditType=se={}));let Z=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(z,oe,Se,Ge){this.c.push({_type:1,from:z,to:oe,options:Se,metadata:Ge})}createFile(z,oe,Se){this.c.push({_type:1,from:void 0,to:z,options:oe,metadata:Se})}deleteFile(z,oe,Se){this.c.push({_type:1,from:z,to:void 0,options:oe,metadata:Se})}e(z,oe,Se){this.c.push({_type:3,metadata:Se,uri:z,edit:{editType:5,metadata:oe},notebookMetadata:oe})}f(z,oe,Se,Ge){const xe=oe.start,at=oe.end;(xe!==at||Se.length>0)&&this.c.push({_type:5,uri:z,index:xe,count:at-xe,cells:Se,metadata:Ge})}g(z,oe,Se,Ge){this.c.push({_type:3,metadata:Ge,uri:z,edit:{editType:3,index:oe,metadata:Se}})}replace(z,oe,Se,Ge){this.c.push({_type:2,uri:z,edit:new pe(oe,Se),metadata:Ge})}insert(z,oe,Se,Ge){this.replace(z,new C(oe,oe),Se,Ge)}delete(z,oe,Se){this.replace(z,oe,"",Se)}has(z){return this.c.some(oe=>oe._type===2&&oe.uri.toString()===z.toString())}set(z,oe){if(oe)for(const Se of oe){if(!Se)continue;let Ge,xe;Array.isArray(Se)?(Ge=Se[0],xe=Se[1]):Ge=Se,re.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.g(z,Ge.range.start,Ge.newCellMetadata,xe):Ge.newNotebookMetadata?this.e(z,Ge.newNotebookMetadata,xe):this.f(z,Ge.range,Ge.newCells,xe):Pe.isSnippetTextEdit(Ge)?this.c.push({_type:6,uri:z,range:Ge.range,edit:Ge.snippet,metadata:xe}):this.c.push({_type:2,uri:z,edit:Ge,metadata:xe})}else{for(let Se=0;Se<this.c.length;Se++){const Ge=this.c[Se];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===z.toString()&&(this.c[Se]=void 0);break}}(0,y.$Hb)(this.c)}}get(z){const oe=[];for(const Se of this.c)Se._type===2&&Se.uri.toString()===z.toString()&&oe.push(Se.edit);return oe}entries(){const z=new M.$zc;for(const oe of this.c)if(oe._type===2){let Se=z.get(oe.uri);Se||(Se=[oe.uri,[]],z.set(oe.uri,Se)),Se[1].push(oe.edit)}return[...z.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$LK=Z,e.$LK=Z=Ke([L],Z);let j=l=class{static isSnippetString(z){return z instanceof l?!0:z?typeof z.value=="string":!1}static c(z){return z.replace(/\$|}|\\/g,"\\$&")}constructor(z){this.e=1,this.value=z||""}appendText(z){return this.value+=l.c(z),this}appendTabstop(z=this.e++){return this.value+="$",this.value+=z,this}appendPlaceholder(z,oe=this.e++){if(typeof z=="function"){const Se=new l;Se.e=this.e,z(Se),this.e=Se.e,z=Se.value}else z=l.c(z);return this.value+="${",this.value+=oe,this.value+=":",this.value+=z,this.value+="}",this}appendChoice(z,oe=this.e++){const Se=z.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=oe,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(z,oe){if(typeof oe=="function"){const Se=new l;Se.e=this.e,oe(Se),this.e=Se.e,oe=Se.value}else typeof oe=="string"&&(oe=oe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=z,oe&&(this.value+=":",this.value+=oe),this.value+="}",this}};e.$MK=j,e.$MK=j=l=Ke([L],j);var ie;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(ie||(e.DiagnosticTag=ie={}));var ve;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(ve||(e.DiagnosticSeverity=ve={}));let ne=n=class{static isLocation(z){return z instanceof n?!0:z?C.isRange(z.range)&&f.URI.isUri(z.uri):!1}constructor(z,oe){if(this.uri=z,oe)if(C.isRange(oe))this.range=C.of(oe);else if(N.isPosition(oe))this.range=new C(oe,oe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$NK=ne,e.$NK=ne=n=Ke([L],ne);let he=class{static is(z){return z?typeof z.message=="string"&&z.location&&C.isRange(z.location.range)&&f.URI.isUri(z.location.uri):!1}constructor(z,oe){this.location=z,this.message=oe}static isEqual(z,oe){return z===oe?!0:!z||!oe?!1:z.message===oe.message&&z.location.range.isEqual(oe.location.range)&&z.location.uri.toString()===oe.location.uri.toString()}};e.$OK=he,e.$OK=he=Ke([L],he);let ce=class{constructor(z,oe,Se=ve.Error){if(!C.isRange(z))throw new TypeError("range must be set");if(!oe)throw new TypeError("message must be set");this.range=z,this.message=oe,this.severity=Se}toJSON(){return{severity:ve[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(z,oe){return z===oe?!0:!z||!oe?!1:z.message===oe.message&&z.severity===oe.severity&&z.code===oe.code&&z.severity===oe.severity&&z.source===oe.source&&z.range.isEqual(oe.range)&&(0,y.$tb)(z.tags,oe.tags)&&(0,y.$tb)(z.relatedInformation,oe.relatedInformation,he.isEqual)}};e.$PK=ce,e.$PK=ce=Ke([L],ce);let ye=class{constructor(z,oe){if(!z)throw new Error("Illegal argument, contents must be defined");Array.isArray(z)?this.contents=z:this.contents=[z],this.range=oe}};e.$QK=ye,e.$QK=ye=Ke([L],ye);var _;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(_||(e.DocumentHighlightKind=_={}));let fe=class{constructor(z,oe=_.Text){this.range=z,this.kind=oe}toJSON(){return{range:this.range,kind:_[this.kind]}}};e.$RK=fe,e.$RK=fe=Ke([L],fe);var te;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(te||(e.SymbolKind=te={}));var ae;(function(B){B[B.Deprecated=1]="Deprecated"})(ae||(e.SymbolTag=ae={}));let $e=s=class{static validate(z){if(!z.name)throw new Error("name must not be falsy")}constructor(z,oe,Se,Ge,xe){this.name=z,this.kind=oe,this.containerName=xe,typeof Se=="string"&&(this.containerName=Se),Ge instanceof ne?this.location=Ge:Se instanceof C&&(this.location=new ne(Ge,Se)),s.validate(this)}toJSON(){return{name:this.name,kind:te[this.kind],location:this.location,containerName:this.containerName}}};e.$SK=$e,e.$SK=$e=s=Ke([L],$e);let Ie=a=class{static validate(z){if(!z.name)throw new Error("name must not be falsy");if(!z.range.contains(z.selectionRange))throw new Error("selectionRange must be contained in fullRange");z.children?.forEach(a.validate)}constructor(z,oe,Se,Ge,xe){this.name=z,this.detail=oe,this.kind=Se,this.range=Ge,this.selectionRange=xe,this.children=[],a.validate(this)}};e.$TK=Ie,e.$TK=Ie=a=Ke([L],Ie);var O;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(O||(e.CodeActionTriggerKind=O={}));let W=class{constructor(z,oe){this.title=z,this.kind=oe}};e.$UK=W,e.$UK=W=Ke([L],W);let H=class{static{d=this}static{this.c="."}constructor(z){this.value=z}append(z){return new d(this.value?this.value+d.c+z:z)}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+d.c)}};e.$VK=H,e.$VK=H=d=Ke([L],H),H.Empty=new H(""),H.QuickFix=H.Empty.append("quickfix"),H.Refactor=H.Empty.append("refactor"),H.RefactorExtract=H.Refactor.append("extract"),H.RefactorInline=H.Refactor.append("inline"),H.RefactorMove=H.Refactor.append("move"),H.RefactorRewrite=H.Refactor.append("rewrite"),H.Source=H.Empty.append("source"),H.SourceOrganizeImports=H.Source.append("organizeImports"),H.SourceFixAll=H.Source.append("fixAll"),H.Notebook=H.Empty.append("notebook");let J=class{constructor(z,oe){if(this.range=z,this.parent=oe,oe&&!oe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$WK=J,e.$WK=J=Ke([L],J);class q{constructor(z,oe,Se,Ge,xe,at){this.kind=z,this.name=oe,this.detail=Se,this.uri=Ge,this.range=xe,this.selectionRange=at}}e.$XK=q;class x{constructor(z,oe){this.fromRanges=oe,this.from=z}}e.$YK=x;class ue{constructor(z,oe){this.fromRanges=oe,this.to=z}}e.$ZK=ue;var Ne;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(Ne||(e.LanguageStatusSeverity=Ne={}));let Be=class{constructor(z,oe){this.range=z,this.command=oe}get isResolved(){return!!this.command}};e.$1K=Be,e.$1K=Be=Ke([L],Be);let Ye=p=class{#e;static isMarkdownString(z){return z instanceof p?!0:z&&z.appendCodeblock&&z.appendMarkdown&&z.appendText&&z.value!==void 0}constructor(z,oe=!1){this.#e=new A.$9j(z,{supportThemeIcons:oe})}get value(){return this.#e.value}set value(z){this.#e.value=z}get isTrusted(){return this.#e.isTrusted}set isTrusted(z){this.#e.isTrusted=z}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(z){this.#e.supportThemeIcons=z}get supportHtml(){return this.#e.supportHtml}set supportHtml(z){this.#e.supportHtml=z}get baseUri(){return this.#e.baseUri}set baseUri(z){this.#e.baseUri=z}appendText(z){return this.#e.appendText(z),this}appendMarkdown(z){return this.#e.appendMarkdown(z),this}appendCodeblock(z,oe){return this.#e.appendCodeblock(oe??"",z),this}};e.$2K=Ye,e.$2K=Ye=p=Ke([L],Ye);let Je=class{constructor(z,oe){this.label=z,this.documentation=oe}};e.$3K=Je,e.$3K=Je=Ke([L],Je);let tt=class{constructor(z,oe){this.label=z,this.documentation=oe,this.parameters=[]}};e.$4K=tt,e.$4K=tt=Ke([L],tt);let _e=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$5K=_e,e.$5K=_e=Ke([L],_e);var et;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(et||(e.SignatureHelpTriggerKind=et={}));var rt;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(rt||(e.InlayHintKind=rt={}));let nt=class{constructor(z){this.value=z}};e.$6K=nt,e.$6K=nt=Ke([L],nt);let ze=class{constructor(z,oe,Se){this.position=z,this.label=oe,this.kind=Se}};e.$7K=ze,e.$7K=ze=Ke([L],ze);var dt;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(dt||(e.CompletionTriggerKind=dt={}));var X;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(X||(e.CompletionItemKind=X={}));var Q;(function(B){B[B.Deprecated=1]="Deprecated"})(Q||(e.CompletionItemTag=Q={}));let Ee=class{constructor(z,oe){this.label=z,this.kind=oe}toJSON(){return{label:this.label,kind:this.kind&&X[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$8K=Ee,e.$8K=Ee=Ke([L],Ee);let je=class{constructor(z=[],oe=!1){this.items=z,this.isIncomplete=oe}};e.$9K=je,e.$9K=je=Ke([L],je);let He=class{constructor(z,oe,Se){this.insertText=z,this.range=oe,this.command=Se}};e.$0K=He,e.$0K=He=Ke([L],He);let Xe=class{constructor(z){this.commands=void 0,this.suppressSuggestions=void 0,this.items=z}};e.$$K=Xe,e.$$K=Xe=Ke([L],Xe);var st;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(st||(e.ViewColumn=st={}));var vt;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(vt||(e.StatusBarAlignment=vt={}));function Dt(B,z){return`${D.$_l.toKey(B)}.${z}`}e.$_K=Dt;var Oe;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative"})(Oe||(e.TextEditorLineNumbersStyle=Oe={}));var Kt;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(Kt||(e.TextDocumentSaveReason=Kt={}));var Ht;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Ht||(e.TextEditorRevealType=Ht={}));var yt;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(yt||(e.TextEditorSelectionChangeKind=yt={}));var Ut;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(Ut||(e.TextDocumentChangeReason=Ut={}));var Ot;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(Ot||(e.DecorationRangeBehavior=Ot={})),function(B){function z(oe){switch(oe){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=z}(yt||(e.TextEditorSelectionChangeKind=yt={}));var Gt;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Gt||(e.SyntaxTokenType=Gt={})),function(B){function z(oe){switch(oe){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=z}(Gt||(e.SyntaxTokenType=Gt={}));let jt=class{constructor(z,oe){if(oe&&!f.URI.isUri(oe))throw(0,F.$6)("target");if(!C.isRange(z)||z.isEmpty)throw(0,F.$6)("range");this.range=z,this.target=oe}};e.$aL=jt,e.$aL=jt=Ke([L],jt);let St=class{constructor(z,oe,Se,Ge){this.red=z,this.green=oe,this.blue=Se,this.alpha=Ge}};e.$bL=St,e.$bL=St=Ke([L],St);let Lt=class{constructor(z,oe){if(oe&&!(oe instanceof St))throw(0,F.$6)("color");if(!C.isRange(z)||z.isEmpty)throw(0,F.$6)("range");this.range=z,this.color=oe}};e.$cL=Lt,e.$cL=Lt=Ke([L],Lt);let Vt=class{constructor(z){if(!z||typeof z!="string")throw(0,F.$6)("label");this.label=z}};e.$dL=Vt,e.$dL=Vt=Ke([L],Vt);var Ze;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(Ze||(e.ColorFormat=Ze={}));var Wt;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(Wt||(e.SourceControlInputBoxValidationType=Wt={}));var qt;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(qt||(e.TerminalExitReason=qt={}));class ct{constructor(z,oe,Se){if(this.startIndex=z,this.length=oe,this.tooltip=Se,typeof z!="number"||z<0)throw(0,F.$6)("startIndex");if(typeof oe!="number"||oe<1)throw(0,F.$6)("length");if(Se!==void 0&&typeof Se!="string")throw(0,F.$6)("tooltip")}}e.$eL=ct;class gt{constructor(z){this.uri=z}}e.$fL=gt;class Nt{constructor(z){this.terminalCommand=z}}e.$gL=Nt;var Pt;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(Pt||(e.TerminalLocation=Pt={}));class At{constructor(z){if(this.options=z,typeof z!="object")throw(0,F.$6)("options")}}e.$hL=At;var ft;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(ft||(e.TaskRevealKind=ft={}));var kt;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(kt||(e.TaskPanelKind=kt={}));let Rt=class{static{m=this}static{this.Clean=new m("clean","Clean")}static{this.Build=new m("build","Build")}static{this.Rebuild=new m("rebuild","Rebuild")}static{this.Test=new m("test","Test")}static from(z){switch(z){case"clean":return m.Clean;case"build":return m.Build;case"rebuild":return m.Rebuild;case"test":return m.Test;default:return}}constructor(z,oe){if(this.label=oe,typeof z!="string"||typeof oe!="string")throw(0,F.$6)("name");this.c=z}get id(){return this.c}};e.$iL=Rt,e.$iL=Rt=m=Ke([L],Rt);function Ct(B){let z="";for(let oe=0;oe<B.length;oe++)z+=B[oe].replace(/,/g,",,")+",";return z}let We=class{constructor(z,oe,Se){if(typeof z!="string")throw(0,F.$6)("process");this.e=[],this.c=z,oe!==void 0&&(Array.isArray(oe)?(this.e=oe,this.f=Se):this.f=oe)}get process(){return this.c}set process(z){if(typeof z!="string")throw(0,F.$6)("process");this.c=z}get args(){return this.e}set args(z){Array.isArray(z)||(z=[]),this.e=z}get options(){return this.f}set options(z){this.f=z}computeId(){const z=[];if(z.push("process"),this.c!==void 0&&z.push(this.c),this.e&&this.e.length>0)for(const oe of this.e)z.push(oe);return Ct(z)}};e.$jL=We,e.$jL=We=Ke([L],We);let zt=class{constructor(z,oe,Se){if(this.f=[],Array.isArray(oe)){if(!z)throw(0,F.$6)("command can't be undefined or null");if(typeof z!="string"&&typeof z.value!="string")throw(0,F.$6)("command");this.e=z,this.f=oe,this.g=Se}else{if(typeof z!="string")throw(0,F.$6)("commandLine");this.c=z,this.g=oe}}get commandLine(){return this.c}set commandLine(z){if(typeof z!="string")throw(0,F.$6)("commandLine");this.c=z}get command(){return this.e?this.e:""}set command(z){if(typeof z!="string"&&typeof z.value!="string")throw(0,F.$6)("command");this.e=z}get args(){return this.f}set args(z){this.f=z||[]}get options(){return this.g}set options(z){this.g=z}computeId(){const z=[];if(z.push("shell"),this.c!==void 0&&z.push(this.c),this.e!==void 0&&z.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const oe of this.f)z.push(typeof oe=="string"?oe:oe.value);return Ct(z)}};e.$kL=zt,e.$kL=zt=Ke([L],zt);var Jt;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(Jt||(e.ShellQuoting=Jt={}));var Ce;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(Ce||(e.TaskScope=Ce={}));class Me{constructor(z){this.c=z}computeId(){return"customExecution"+(0,P.$ig)()}set callback(z){this.c=z}get callback(){return this.c}}e.$lL=Me;let be=class{static{S=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(z,oe,Se,Ge,xe,at){this.j=!1,this.k=this.definition=z;let ht;typeof oe=="string"?(this.m=this.name=oe,this.t=this.source=Se,this.execution=Ge,ht=xe,this.j=!0):oe===Ce.Global||oe===Ce.Workspace?(this.target=oe,this.m=this.name=Se,this.t=this.source=Ge,this.execution=xe,ht=at):(this.target=oe,this.m=this.name=Se,this.t=this.source=Ge,this.execution=xe,ht=at),typeof ht=="string"?(this.o=[ht],this.q=!0):Array.isArray(ht)?(this.o=ht,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(z){this.h=z}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof We?this.k={type:S.e,id:this.n.computeId()}:this.n instanceof zt?this.k={type:S.f,id:this.n.computeId()}:this.n instanceof Me?this.k={type:S.c,id:this.n.computeId()}:this.k={type:S.g,id:(0,P.$ig)()}}get definition(){return this.k}set definition(z){if(z==null)throw(0,F.$6)("Kind can't be undefined or null");this.z(),this.k=z}get scope(){return this.l}set target(z){this.z(),this.l=z}get name(){return this.m}set name(z){if(typeof z!="string")throw(0,F.$6)("name");this.z(),this.m=z}get execution(){return this.n}set execution(z){z===null&&(z=void 0),this.z(),this.n=z;const oe=this.k.type;(S.g===oe||S.e===oe||S.f===oe||S.c===oe)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(z){if(Array.isArray(z))this.z(),this.o=z,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(z){z!==!0&&z!==!1&&(z=!1),this.z(),this.r=z}get source(){return this.t}set source(z){if(typeof z!="string"||z.length===0)throw(0,F.$6)("source must be a string of length > 0");this.z(),this.t=z}get group(){return this.u}set group(z){z===null&&(z=void 0),this.z(),this.u=z}get detail(){return this.y}set detail(z){z===null&&(z=void 0),this.y=z}get presentationOptions(){return this.w}set presentationOptions(z){z==null&&(z=Object.create(null)),this.z(),this.w=z}get runOptions(){return this.x}set runOptions(z){z==null&&(z=Object.create(null)),this.z(),this.x=z}};e.$mL=be,e.$mL=be=S=Ke([L],be);var K;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(K||(e.ProgressLocation=K={}));var Le;(function(B){function z(oe){const Se=oe;return(0,E.$Gf)(Se.value)?Se.tooltip&&!(0,E.$Cf)(Se.tooltip)?(console.log("INVALID view badge, invalid tooltip",Se.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Se.value),!1)}B.isViewBadge=z})(Le||(e.ViewBadge=Le={}));let Ue=k=class{static isTreeItem(z,oe){const Se=z;if(Se.checkboxState!==void 0){const Ge=(0,E.$Gf)(Se.checkboxState)?Se.checkboxState:(0,E.$Ef)(Se.checkboxState)&&(0,E.$Gf)(Se.checkboxState.state)?Se.checkboxState.state:void 0,xe=!(0,E.$Gf)(Se.checkboxState)&&(0,E.$Ef)(Se.checkboxState)?Se.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==qe.Checked&&Ge!==qe.Unchecked||xe!==void 0&&!(0,E.$Cf)(xe))return console.log("INVALID tree item, invalid checkboxState",Se.checkboxState),!1}if(z instanceof k)return!0;if(Se.label!==void 0&&!(0,E.$Cf)(Se.label)&&!Se.label?.label)return console.log("INVALID tree item, invalid label",Se.label),!1;if(Se.id!==void 0&&!(0,E.$Cf)(Se.id))return console.log("INVALID tree item, invalid id",Se.id),!1;if(Se.iconPath!==void 0&&!(0,E.$Cf)(Se.iconPath)&&!f.URI.isUri(Se.iconPath)&&(!Se.iconPath||!(0,E.$Cf)(Se.iconPath.id))){const Ge=Se.iconPath;if(!Ge||!(0,E.$Cf)(Ge.light)&&!f.URI.isUri(Ge.light)&&!(0,E.$Cf)(Ge.dark)&&!f.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",Se.iconPath),!1}return Se.description!==void 0&&!(0,E.$Cf)(Se.description)&&typeof Se.description!="boolean"?(console.log("INVALID tree item, invalid description",Se.description),!1):Se.resourceUri!==void 0&&!f.URI.isUri(Se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Se.resourceUri),!1):Se.tooltip!==void 0&&!(0,E.$Cf)(Se.tooltip)&&!(Se.tooltip instanceof Ye)?(console.log("INVALID tree item, invalid tooltip",Se.tooltip),!1):Se.command!==void 0&&!Se.command.command?(console.log("INVALID tree item, invalid command",Se.command),!1):Se.collapsibleState!==void 0&&Se.collapsibleState<Qe.None&&Se.collapsibleState>Qe.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Se.collapsibleState),!1):Se.contextValue!==void 0&&!(0,E.$Cf)(Se.contextValue)?(console.log("INVALID tree item, invalid contextValue",Se.contextValue),!1):Se.accessibilityInformation!==void 0&&!Se.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Se.accessibilityInformation),!1):!0}constructor(z,oe=Qe.None){this.collapsibleState=oe,f.URI.isUri(z)?this.resourceUri=z:this.label=z}};e.$nL=Ue,e.$nL=Ue=k=Ke([L],Ue);var Qe;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(Qe||(e.TreeItemCollapsibleState=Qe={}));var qe;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(qe||(e.TreeItemCheckboxState=qe={}));let it=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(z){this.value=z}};e.$oL=it,e.$oL=it=Ke([L],it);class pt extends it{}e.$pL=pt;class $t extends pt{#e;constructor(z){super(""),this.#e=z}asFile(){return this.#e}}e.$qL=$t;class bt{constructor(z,oe,Se,Ge){this.name=z,this.uri=oe,this._itemId=Se,this.c=Ge}data(){return this.c()}}e.$rL=bt;let ut=class{#e=new Map;constructor(z){for(const[oe,Se]of z??[]){const Ge=this.#e.get(this.#t(oe));Ge?Ge.push(Se):this.#e.set(this.#t(oe),[Se])}}get(z){return this.#e.get(this.#t(z))?.[0]}set(z,oe){this.#e.set(this.#t(z),[oe])}forEach(z,oe){for(const[Se,Ge]of this.#e)for(const xe of Ge)z.call(oe,xe,Se,this)}*[Symbol.iterator](){for(const[z,oe]of this.#e)for(const Se of oe)yield[z,Se]}#t(z){return z.toLowerCase()}};e.$sL=ut,e.$sL=ut=Ke([L],ut);let Mt=class{constructor(z){this.insertText=z}};e.$tL=Mt,e.$tL=Mt=Ke([L],Mt);let Qt=class{constructor(z,oe){this.label=oe,this.insertText=z}};e.$uL=Qt,e.$uL=Qt=Ke([L],Qt);let Xt=class{constructor(z,oe){this.id=z,this.color=oe}static isThemeIcon(z){return typeof z.id!="string"?(console.log("INVALID ThemeIcon, invalid id",z.id),!1):!0}};e.$vL=Xt,e.$vL=Xt=Ke([L],Xt),Xt.File=new Xt("file"),Xt.Folder=new Xt("folder");let si=class{constructor(z){this.id=z}};e.$wL=si,e.$wL=si=Ke([L],si);var ki;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(ki||(e.ConfigurationTarget=ki={}));let It=class{get base(){return this.c}set base(z){this.c=z,this.e=f.URI.file(z)}get baseUri(){return this.e}set baseUri(z){this.e=z,this.c=z.fsPath}constructor(z,oe){if(typeof z!="string"&&(!z||!f.URI.isUri(z)&&!f.URI.isUri(z.uri)))throw(0,F.$6)("base");if(typeof oe!="string")throw(0,F.$6)("pattern");typeof z=="string"?this.baseUri=f.URI.file(z):f.URI.isUri(z)?this.baseUri=z:this.baseUri=z.uri,this.pattern=oe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$xL=It,e.$xL=It=Ke([L],It);const Yi=new WeakMap;function ln(B,z){Yi.set(B,z)}e.$yL=ln;let Et=class{constructor(z,oe,Se,Ge){this.enabled=typeof z=="boolean"?z:!0,typeof oe=="string"&&(this.condition=oe),typeof Se=="string"&&(this.hitCondition=Se),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this.c||(this.c=Yi.get(this)??(0,P.$ig)()),this.c}};e.$zL=Et,e.$zL=Et=Ke([L],Et);let mi=class extends Et{constructor(z,oe,Se,Ge,xe){if(super(oe,Se,Ge,xe),z===null)throw(0,F.$6)("location");this.location=z}};e.$AL=mi,e.$AL=mi=Ke([L],mi);let $i=class extends Et{constructor(z,oe,Se,Ge,xe){super(oe,Se,Ge,xe),this.functionName=z}};e.$BL=$i,e.$BL=$i=Ke([L],$i);let oi=class extends Et{constructor(z,oe,Se,Ge,xe,at,ht){if(super(Ge,xe,at,ht),!oe)throw(0,F.$6)("dataId");this.label=z,this.dataId=oe,this.canPersist=Se}};e.$CL=oi,e.$CL=oi=Ke([L],oi);let Si=class{constructor(z,oe,Se){this.command=z,this.args=oe||[],this.options=Se}};e.$DL=Si,e.$DL=Si=Ke([L],Si);let Ii=class{constructor(z,oe){this.port=z,this.host=oe}};e.$EL=Ii,e.$EL=Ii=Ke([L],Ii);let Ft=class{constructor(z){this.path=z}};e.$FL=Ft,e.$FL=Ft=Ke([L],Ft);let pi=class{constructor(z){this.implementation=z}};e.$GL=pi,e.$GL=pi=Ke([L],pi);let Ci=class{constructor(z,oe,Se){this.session=z,this.threadId=oe,this.frameId=Se}};e.$HL=Ci,e.$HL=Ci=Ke([L],Ci);let ai=class{constructor(z,oe){this.session=z,this.threadId=oe}};e.$IL=ai,e.$IL=ai=Ke([L],ai);let ci=class{constructor(z,oe){this.range=z,this.expression=oe}};e.$JL=ci,e.$JL=ci=Ke([L],ci);var lt;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(lt||(e.InlineCompletionTriggerKind=lt={}));let Pi=class{constructor(z,oe){this.range=z,this.text=oe}};e.$KL=Pi,e.$KL=Pi=Ke([L],Pi);let xt=class{constructor(z,oe,Se=!0){this.range=z,this.variableName=oe,this.caseSensitiveLookup=Se}};e.$LL=xt,e.$LL=xt=Ke([L],xt);let ni=class{constructor(z,oe){this.range=z,this.expression=oe}};e.$ML=ni,e.$ML=ni=Ke([L],ni);let hi=class{constructor(z,oe){this.frameId=z,this.stoppedLocation=oe}};e.$NL=hi,e.$NL=hi=Ke([L],hi);var Xi;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Xi||(e.FileChangeType=Xi={}));let Ai=h=class extends Error{static FileExists(z){return new h(z,u.FileSystemProviderErrorCode.FileExists,h.FileExists)}static FileNotFound(z){return new h(z,u.FileSystemProviderErrorCode.FileNotFound,h.FileNotFound)}static FileNotADirectory(z){return new h(z,u.FileSystemProviderErrorCode.FileNotADirectory,h.FileNotADirectory)}static FileIsADirectory(z){return new h(z,u.FileSystemProviderErrorCode.FileIsADirectory,h.FileIsADirectory)}static NoPermissions(z){return new h(z,u.FileSystemProviderErrorCode.NoPermissions,h.NoPermissions)}static Unavailable(z){return new h(z,u.FileSystemProviderErrorCode.Unavailable,h.Unavailable)}constructor(z,oe=u.FileSystemProviderErrorCode.Unknown,Se){super(f.URI.isUri(z)?z.toString(!0):z),this.code=Se?.name??"Unknown",(0,u.$tk)(this,oe),Object.setPrototypeOf(this,h.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}};e.$OL=Ai,e.$OL=Ai=h=Ke([L],Ai);let Ri=class{constructor(z,oe,Se){this.start=z,this.end=oe,this.kind=Se}};e.$PL=Ri,e.$PL=Ri=Ke([L],Ri);var Mi;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Mi||(e.FoldingRangeKind=Mi={}));var xi;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(xi||(e.CommentThreadCollapsibleState=xi={}));var Li;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(Li||(e.CommentMode=Li={}));var ui;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(ui||(e.CommentState=ui={}));var _i;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(_i||(e.CommentThreadState=_i={}));class Fi{constructor(z,oe=[]){this.tokenTypes=z,this.tokenModifiers=oe}}e.$QL=Fi;function Ti(B){return typeof B>"u"||(0,E.$Df)(B)}class Ni{constructor(z){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,z){this.l=!0;for(let oe=0,Se=z.tokenTypes.length;oe<Se;oe++)this.j.set(z.tokenTypes[oe],oe);for(let oe=0,Se=z.tokenModifiers.length;oe<Se;oe++)this.k.set(z.tokenModifiers[oe],oe)}}push(z,oe,Se,Ge,xe){if(typeof z=="number"&&typeof oe=="number"&&typeof Se=="number"&&typeof Ge=="number"&&(typeof xe=="number"||typeof xe>"u"))return typeof xe>"u"&&(xe=0),this.n(z,oe,Se,Ge,xe);if(C.isRange(z)&&typeof oe=="string"&&Ti(Se))return this.m(z,oe,Se);throw(0,F.$6)()}m(z,oe,Se){if(!this.l)throw new Error("Legend must be provided in constructor");if(z.start.line!==z.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(oe))throw new Error("`tokenType` is not in the provided legend");const Ge=z.start.line,xe=z.start.character,at=z.end.character-z.start.character,ht=this.j.get(oe);let Bt=0;if(Se)for(const Yt of Se){if(!this.k.has(Yt))throw new Error("`tokenModifier` is not in the provided legend");const ei=this.k.get(Yt);Bt|=1<<ei>>>0}this.n(Ge,xe,at,ht,Bt)}n(z,oe,Se,Ge,xe){if(this.f&&(z<this.c||z===this.c&&oe<this.e)){this.f=!1;const Bt=this.g.length/5|0;let Yt=0,ei=0;for(let ii=0;ii<Bt;ii++){let ri=this.g[5*ii],Qi=this.g[5*ii+1];ri===0?(ri=Yt,Qi+=ei):ri+=Yt,this.g[5*ii]=ri,this.g[5*ii+1]=Qi,Yt=ri,ei=Qi}}let at=z,ht=oe;this.f&&this.h>0&&(at-=this.c,at===0&&(ht-=this.e)),this.g[this.h++]=at,this.g[this.h++]=ht,this.g[this.h++]=Se,this.g[this.h++]=Ge,this.g[this.h++]=xe,this.c=z,this.e=oe}static o(z){const oe=[],Se=z.length/5|0;for(let ht=0;ht<Se;ht++)oe[ht]=ht;oe.sort((ht,Bt)=>{const Yt=z[5*ht],ei=z[5*Bt];if(Yt===ei){const ii=z[5*ht+1],ri=z[5*Bt+1];return ii-ri}return Yt-ei});const Ge=new Uint32Array(z.length);let xe=0,at=0;for(let ht=0;ht<Se;ht++){const Bt=5*oe[ht],Yt=z[Bt+0],ei=z[Bt+1],ii=z[Bt+2],ri=z[Bt+3],Qi=z[Bt+4],Sn=Yt-xe,Tn=Sn===0?ei-at:ei,Zi=5*ht;Ge[Zi+0]=Sn,Ge[Zi+1]=Tn,Ge[Zi+2]=ii,Ge[Zi+3]=ri,Ge[Zi+4]=Qi,xe=Yt,at=ei}return Ge}build(z){return this.f?new Oi(new Uint32Array(this.g),z):new Oi(Ni.o(this.g),z)}}e.$RL=Ni;class Oi{constructor(z,oe){this.resultId=oe,this.data=z}}e.$SL=Oi;class di{constructor(z,oe,Se){this.start=z,this.deleteCount=oe,this.data=Se}}e.$TL=di;class hn{constructor(z,oe){this.resultId=oe,this.edits=z}}e.$UL=hn;var en;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(en||(e.DebugConsoleMode=en={}));let zi=class{static{this.Back={iconPath:new Xt("arrow-left")}}constructor(){}};e.$VL=zi,e.$VL=zi=Ke([L],zi);var vi;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(vi||(e.QuickPickItemKind=vi={}));var tn;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(tn||(e.InputBoxValidationSeverity=tn={}));var nn;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(nn||(e.ExtensionKind=nn={}));class bi{static validate(z){if(typeof z.badge=="string"){let oe=(0,$.$df)(z.badge,0);if(oe<z.badge.length&&(oe+=(0,$.$df)(z.badge,oe)),z.badge.length>oe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(z.badge&&!Xt.isThemeIcon(z.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!z.color&&!z.badge&&!z.tooltip)throw new Error("The decoration is empty");return!0}constructor(z,oe,Se){this.badge=z,this.tooltip=oe,this.color=Se}}e.$WL=bi;let wi=class{constructor(z){this.kind=z}};e.$XL=wi,e.$XL=wi=Ke([L],wi);var rn;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(rn||(e.ColorThemeKind=rn={}));class _t{static isNotebookRange(z){return z instanceof _t?!0:z?typeof z.start=="number"&&typeof z.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(z,oe){if(z<0)throw(0,F.$6)("start must be positive");if(oe<0)throw(0,F.$6)("end must be positive");z<=oe?(this.c=z,this.e=oe):(this.c=oe,this.e=z)}with(z){let oe=this.c,Se=this.e;return z.start!==void 0&&(oe=z.start),z.end!==void 0&&(Se=z.end),oe===this.c&&Se===this.e?this:new _t(oe,Se)}}e.$YL=_t;class fi{static validate(z){if(typeof z.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof z.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof z.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(z){return Array.isArray(z)&&z.every(oe=>fi.isNotebookCellData(oe))}static isNotebookCellData(z){return!0}constructor(z,oe,Se,Ge,xe,at,ht){this.kind=z,this.value=oe,this.languageId=Se,this.mime=Ge,this.outputs=xe??[],this.metadata=at,this.executionSummary=ht,fi.validate(this)}}e.$ZL=fi;class dn{constructor(z){this.cells=z}}e.$1L=dn;class Zt{static isNotebookCellOutputItem(z){return z instanceof Zt?!0:z?typeof z.mime=="string"&&z.data instanceof Uint8Array:!1}static error(z){const oe={name:z.name,message:z.message,stack:z.stack};return Zt.json(oe,"application/vnd.code.notebook.error")}static stdout(z){return Zt.text(z,"application/vnd.code.notebook.stdout")}static stderr(z){return Zt.text(z,"application/vnd.code.notebook.stderr")}static bytes(z,oe="application/octet-stream"){return new Zt(z,oe)}static#e=new TextEncoder;static text(z,oe=R.$Vr.text){const Se=Zt.#e.encode(String(z));return new Zt(Se,oe)}static json(z,oe="text/x-json"){const Se=JSON.stringify(z,void 0,"	");return Zt.text(Se,oe)}constructor(z,oe){this.data=z,this.mime=oe;const Se=(0,R.$Zr)(oe,!0);if(!Se)throw new Error(`INVALID mime type: ${oe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}}e.$2L=Zt;class yi{static isNotebookCellOutput(z){return z instanceof yi?!0:!z||typeof z!="object"?!1:typeof z.id=="string"&&Array.isArray(z.items)}static ensureUniqueMimeTypes(z,oe=!1){const Se=new Set,Ge=new Set;for(let xe=0;xe<z.length;xe++){const at=z[xe],ht=(0,R.$Zr)(at.mime);if(!Se.has(ht)||(0,v.$DI)(ht)){Se.add(ht);continue}Ge.add(xe),oe&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ge.size===0?z:z.filter((xe,at)=>!Ge.has(at))}constructor(z,oe,Se){this.items=yi.ensureUniqueMimeTypes(z,!0),typeof oe=="string"?(this.id=oe,this.metadata=Se):(this.id=(0,P.$ig)(),this.metadata=oe??Se)}}e.$3L=yi;var sn;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(sn||(e.NotebookCellKind=sn={}));var Ei;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(Ei||(e.NotebookCellExecutionState=Ei={}));var Bi;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Bi||(e.NotebookCellStatusBarAlignment=Bi={}));var Te;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Te||(e.NotebookEditorRevealType=Te={}));class ti{constructor(z,oe){this.text=z,this.alignment=oe}}e.$4L=ti;var Ui;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(Ui||(e.NotebookControllerAffinity=Ui={}));var mt;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(mt||(e.NotebookControllerAffinity2=mt={}));class fn{constructor(z,oe=[]){this.uri=z,this.provides=(0,y.$2b)(oe)}}e.$5L=fn;class gn{constructor(z){this.label=z}}e.$6L=gn;let Di=class{constructor(z,oe){this.label=z,this.timestamp=oe}};e.$7L=Di,e.$7L=Di=Ke([L],Di);var on;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(on||(e.ExtensionMode=on={}));var gi;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(gi||(e.ExtensionRuntime=gi={}));var an;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(an||(e.StandardTokenType=an={}));class mn{constructor(z,oe){this.ranges=z,this.wordPattern=oe}}e.$8L=mn;class $n{constructor(z){this.c=z}get autoForwardAction(){return this.c}}e.$9L=$n;var ji;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(ji||(e.TestResultState=ji={}));var cn;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(cn||(e.TestRunProfileKind=cn={}));let Vi=class{constructor(z=void 0,oe=void 0,Se=void 0,Ge=!1){this.include=z,this.exclude=oe,this.profile=Se,this.continuous=Ge}};e.$0L=Vi,e.$0L=Vi=Ke([L],Vi);let Wi=w=class{static diff(z,oe,Se){const Ge=new w(z);return Ge.expectedOutput=oe,Ge.actualOutput=Se,Ge}constructor(z){this.message=z}};e.$$L=Wi,e.$$L=Wi=w=Ke([L],Wi);let qi=class{constructor(z){this.id=z}};e.$_L=qi,e.$_L=qi=Ke([L],qi);let li=class{constructor(z,oe){this.covered=z,this.total=oe}};e.$aM=li,e.$aM=li=Ke([L],li);let Ki=I=class{static fromDetails(z,oe){const Se=new li(0,0),Ge=new li(0,0),xe=new li(0,0);for(const ht of oe)if("branches"in ht){Se.total+=1,Se.covered+=ht.executionCount>0?1:0;for(const Bt of ht.branches)Ge.total+=1,Ge.covered+=Bt.executionCount>0?1:0}else xe.total+=1,xe.covered+=ht.executionCount>0?1:0;const at=new I(z,Se,Ge.total>0?Ge:void 0,xe.total>0?xe:void 0);return at.detailedCoverage=oe,at}constructor(z,oe,Se,Ge){this.uri=z,this.statementCoverage=oe,this.branchCoverage=Se,this.functionCoverage=Ge}};e.$bM=Ki,e.$bM=Ki=I=Ke([L],Ki);let Hi=class{constructor(z,oe,Se=[]){this.executionCount=z,this.location=oe,this.branches=Se}};e.$cM=Hi,e.$cM=Hi=Ke([L],Hi);let Gi=class{constructor(z,oe){this.executionCount=z,this.location=oe}};e.$dM=Gi,e.$dM=Gi=Ke([L],Gi);let Ji=class{constructor(z,oe){this.executionCount=z,this.location=oe}};e.$eM=Ji,e.$eM=Ji=Ke([L],Ji);var un;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(un||(e.ExternalUriOpenerPriority=un={}));var ee;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(ee||(e.WorkspaceTrustState=ee={}));var ge;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(ge||(e.PortAutoForwardAction=ge={}));class Fe{constructor(z,oe,Se,Ge,xe,at){this.kind=z,this.name=oe,this.detail=Se,this.uri=Ge,this.range=xe,this.selectionRange=at}}e.$fM=Fe;class ot{constructor(z){this.uri=z}}e.$gM=ot;class wt{constructor(z,oe){this.original=z,this.modified=oe}}e.$hM=wt;class Tt{constructor(z,oe,Se,Ge){this.base=z,this.input1=oe,this.input2=Se,this.result=Ge}}e.$iM=Tt;class In{constructor(z,oe){this.uri=z,this.viewType=oe}}e.$jM=In;class Cn{constructor(z){this.viewType=z}}e.$kM=Cn;class Pn{constructor(z,oe){this.uri=z,this.notebookType=oe}}e.$lM=Pn;class An{constructor(z,oe,Se){this.original=z,this.modified=oe,this.notebookType=Se}}e.$mM=An;class Rn{constructor(){}}e.$nM=Rn;class Mn{constructor(z,oe){this.uri=z,this.inputBoxUri=oe}}e.$oM=Mn;class Ln{constructor(z){this.providerId=z}}e.$pM=Ln;var pn;(function(B){B[B.Down=0]="Down",B[B.Up=1]="Up"})(pn||(e.InteractiveSessionVoteDirection=pn={}));var vn;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(vn||(e.InteractiveSessionCopyKind=vn={}));var bn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted",B[B.Bug=4]="Bug"})(bn||(e.InteractiveEditorResponseFeedbackKind=bn={}));var wn;(function(B){B[B.System=0]="System",B[B.User=1]="User",B[B.Assistant=2]="Assistant",B[B.Function=3]="Function"})(wn||(e.ChatMessageRole=wn={}));var yn;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(yn||(e.ChatVariableLevel=yn={}));class Fn{constructor(z,oe){this.role=z,this.content=oe}}e.$qM=Fn;var En;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful"})(En||(e.ChatAgentResultFeedbackKind=En={}));var Dn;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(Dn||(e.RelatedInformationType=Dn={}));var kn;(function(B){B[B.Started=1]="Started",B[B.Recognizing=2]="Recognizing",B[B.Recognized=3]="Recognized",B[B.Stopped=4]="Stopped"})(kn||(e.SpeechToTextStatus=kn={}))}),define(Ae[103],Re([1,0,53,13,12,295,147,7,18]),function(we,e,y,F,A,M,R,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FM=e.$EM=e.$DM=void 0;const f=new Map;function P(v,g){g?f.set(v,g):f.delete(v)}e.$DM=P;function D(v){return f.get(v)}class u extends M.$2u{constructor(g,t,i,r,c,o,l,n){super(t,i,r,c),this.c=g,this.m=o,this.q=l,this.notebook=n,this.b=!1}dispose(){(0,y.ok)(!this.b),this.b=!0,this.q=!1}equalLines(g){return(0,E.$tb)(this.f,g)}get document(){if(!this.a){const g=this;this.a={get uri(){return g.d},get fileName(){return g.d.fsPath},get isUntitled(){return g.d.scheme===F.Schemas.untitled},get languageId(){return g.m},get version(){return g.h},get isClosed(){return g.b},get isDirty(){return g.q},save(){return g.r()},getText(t){return t?g.s(t):g.getText()},get eol(){return g.g===`
`?$.EndOfLine.LF:$.EndOfLine.CRLF},get lineCount(){return g.f.length},lineAt(t){return g.t(t)},offsetAt(t){return g.u(t)},positionAt(t){return g.v(t)},validateRange(t){return g.w(t)},validatePosition(t){return g.x(t)},getWordRangeAtPosition(t,i){return g.y(t,i)}}}return Object.freeze(this.a)}_acceptLanguageId(g){(0,y.ok)(!this.b),this.m=g}_acceptIsDirty(g){(0,y.ok)(!this.b),this.q=g}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(g){const t=this.w(g);if(t.isEmpty)return"";if(t.isSingleLine)return this.f[t.start.line].substring(t.start.character,t.end.character);const i=this.g,r=t.start.line,c=t.end.line,o=[];o.push(this.f[r].substring(t.start.character));for(let l=r+1;l<c;l++)o.push(this.f[l]);return o.push(this.f[c].substring(0,t.end.character)),o.join(i)}t(g){let t;if(g instanceof $.$CK?t=g.line:typeof g=="number"&&(t=g),typeof t!="number"||t<0||t>=this.f.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new b(t,this.f[t],t===this.f.length-1)}u(g){return g=this.x(g),this.l(),this.j.getPrefixSum(g.line-1)+g.character}v(g){g=Math.floor(g),g=Math.max(0,g),this.l();const t=this.j.getIndexOf(g),i=this.f[t.index].length;return new $.$CK(t.index,Math.min(t.remainder,i))}w(g){if(!(g instanceof $.$DK))throw new Error("Invalid argument");const t=this.x(g.start),i=this.x(g.end);return t===g.start&&i===g.end?g:new $.$DK(t.line,t.character,i.line,i.character)}x(g){if(!(g instanceof $.$CK))throw new Error("Invalid argument");if(this.f.length===0)return g.with(0,0);let{line:t,character:i}=g,r=!1;if(t<0)t=0,i=0,r=!0;else if(t>=this.f.length)t=this.f.length-1,i=this.f[t].length,r=!0;else{const c=this.f[t].length;i<0?(i=0,r=!0):i>c&&(i=c,r=!0)}return r?new $.$CK(t,i):g}y(g,t){const i=this.x(g);if(!t)t=D(this.m);else if((0,A.$Se)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const r=(0,R.$bs)(i.character+1,(0,R.$_r)(t),this.f[i.line],0);if(r)return new $.$DK(i.line,r.startColumn-1,i.line,r.endColumn-1)}}e.$EM=u;class b{constructor(g,t,i){this.a=g,this.b=t,this.c=i}get lineNumber(){return this.a}get text(){return this.b}get range(){return new $.$DK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new $.$DK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$FM=b}),define(Ae[210],Re([1,0,7,17,5]),function(we,e,y,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ffc=void 0;let M=class{constructor($){this.a=new y.$XL(y.ColorThemeKind.Dark),this.b=new A.$Rd}get activeColorTheme(){return this.a}$onColorThemeChange($){let E;switch($){case"light":E=y.ColorThemeKind.Light;break;case"hcDark":E=y.ColorThemeKind.HighContrast;break;case"hcLight":E=y.ColorThemeKind.HighContrastLight;break;default:E=y.ColorThemeKind.Dark}this.a=new y.$XL(E),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Ffc=M,e.$Ffc=M=Ke([Ve(0,F.$BM)],M)}),define(Ae[211],Re([1,0,4]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HI=e.CellExecutionUpdateType=void 0;var F;(function(A){A[A.Output=1]="Output",A[A.OutputItems=2]="OutputItems",A[A.ExecutionState=3]="ExecutionState"})(F||(e.CellExecutionUpdateType=F={})),e.$HI=(0,y.$Vh)("INotebookExecutionService")}),define(Ae[212],Re([1,0,6,29,144,93]),function(we,e,y,F,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VOb=void 0;class R extends y.$Rc{constructor(E,f,P){super(),this._source=E,this.b=f,this.c=P,this.a=void 0}f(E){const f=E.getLineCount();return new F.$zs(1,1,f,this.g(E,f))}g(E,f){if(f<1||f>E.getLineCount())throw new Error("Illegal value for lineNumber");return E.getLineLength(f)+1}get inputTextBuffer(){if(!this.b){const E=new A.$NB;E.acceptChunk(this._source);const f=E.finish(!0),{textBuffer:P,disposable:D}=f.create(1);this.b=P,this.B(D)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(E=>{const f=new A.$NB;f.acceptChunk(E);const P=f.finish(!0),{textBuffer:D,disposable:u}=P.create(1);return this.B(u),D})),this.a}findInInputs(E){const P=new M.$BB(E,!1,!1,null).parseSearchRequest();if(!P)return[];const D=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(D,P,!0,5e3)}findInOutputs(E){const P=new M.$BB(E,!1,!1,null).parseSearchRequest();return P?this.outputTextBuffers.map(D=>{const u=D.findMatchesLineByLine(this.f(D),P,!0,5e3);if(u.length!==0)return{textBuffer:D,matches:u}}).filter(D=>!!D):[]}}e.$VOb=R}),define(Ae[48],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sJ=e.TestPosition=e.TestIdPathParts=void 0;var y;(function(M){M.Delimiter="\0"})(y||(e.TestIdPathParts=y={}));var F;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(F||(e.TestPosition=F={}));class A{static fromExtHostTestItem(R,$,E=R.parent){if(R._isRoot)return new A([$]);const f=[R.id];for(let P=E;P&&P.id!==$;P=P.parent)f.push(P.id);return f.push($),new A(f.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const $=R.indexOf("\0");return $===-1?R:R.slice(0,$)}static fromString(R){return new A(R.split("\0"))}static join(R,$){return new A([...R.path,$])}static joinToString(R,$){return R.toString()+"\0"+$}static parentId(R){const $=R.lastIndexOf("\0");return $===-1?void 0:R.slice(0,$)}static localId(R){const $=R.lastIndexOf("\0");return $===-1?R:R.slice($+1)}static isChild(R,$){return $.startsWith(R)&&$[R.length]==="\0"}static compare(R,$){return R===$?0:A.isChild(R,$)?2:A.isChild($,R)?3:1}constructor(R,$=R.length){if(this.path=R,this.d=$,R.length===0||$<1)throw new Error("cannot create test with empty path")}get rootId(){return new A(this.path,1)}get parentId(){return this.d>1?new A(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new A(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new A(this.path,R)}compare(R){if(typeof R=="string")return A.compare(this.toString(),R);for(let $=0;$<R.d&&$<this.d;$++)if(R.path[$]!==this.path[$])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$sJ=A}),define(Ae[58],Re([1,0,2,29,48]),function(we,e,y,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zJ=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$yJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$xJ=e.$wJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$vJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$uJ=e.$tJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var M;(function(k){k[k.Unset=0]="Unset",k[k.Queued=1]="Queued",k[k.Running=2]="Running",k[k.Passed=3]="Passed",k[k.Failed=4]="Failed",k[k.Skipped=5]="Skipped",k[k.Errored=6]="Errored"})(M||(e.TestResultState=M={}));var R;(function(k){k[k.Run=1]="Run",k[k.Debug=2]="Debug",k[k.Coverage=3]="Coverage"})(R||(e.ExtTestRunProfileKind=R={}));var $;(function(k){k[k.Run=2]="Run",k[k.Debug=4]="Debug",k[k.Coverage=8]="Coverage",k[k.HasNonDefaultProfile=16]="HasNonDefaultProfile",k[k.HasConfigurable=32]="HasConfigurable",k[k.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$tJ=[2,4,8,16,32,64];const E=k=>"runId"in k;e.$uJ=E;var f;(function(k){k.serialize=h=>({range:h.range.toJSON(),uri:h.uri.toJSON()}),k.deserialize=h=>({range:F.$zs.lift(h.range),uri:y.URI.revive(h.uri)})})(f||(e.IRichLocation=f={}));var P;(function(k){k[k.Error=0]="Error",k[k.Output=1]="Output"})(P||(e.TestMessageType=P={}));var D;(function(k){k.serialize=h=>({message:h.message,type:0,expected:h.expected,actual:h.actual,contextValue:h.contextValue,location:h.location&&f.serialize(h.location)}),k.deserialize=h=>({message:h.message,type:0,expected:h.expected,actual:h.actual,contextValue:h.contextValue,location:h.location&&f.deserialize(h.location)})})(D||(e.ITestErrorMessage=D={}));const u=(k,h)=>`${h?"s":"e"}${k}`;e.$vJ=u;var b;(function(k){k.serialize=h=>({message:h.message,type:1,offset:h.offset,length:h.length,location:h.location&&f.serialize(h.location)}),k.deserialize=h=>({message:h.message,type:1,offset:h.offset,length:h.length,location:h.location&&f.deserialize(h.location)})})(b||(e.ITestOutputMessage=b={}));var v;(function(k){k.serialize=h=>h.type===0?D.serialize(h):b.serialize(h),k.deserialize=h=>h.type===0?D.deserialize(h):b.deserialize(h)})(v||(e.ITestMessage=v={}));var g;(function(k){k.serializeWithoutMessages=h=>({state:h.state,duration:h.duration,messages:[]}),k.serialize=h=>({state:h.state,duration:h.duration,messages:h.messages.map(v.serialize)}),k.deserialize=h=>({state:h.state,duration:h.duration,messages:h.messages.map(v.deserialize)})})(g||(e.ITestTaskState=g={}));const t="\0",i=(k,h)=>k+t+h;e.$wJ=i;const r=k=>{const h=k.indexOf(t);return{ctrlId:k.slice(0,h),tagId:k.slice(h+1)}};e.$xJ=r;var c;(function(k){k.serialize=h=>({extId:h.extId,label:h.label,tags:h.tags,busy:h.busy,children:void 0,uri:h.uri?.toJSON(),range:h.range?.toJSON()||null,description:h.description,error:h.error,sortText:h.sortText}),k.deserialize=h=>({extId:h.extId,label:h.label,tags:h.tags,busy:h.busy,children:void 0,uri:h.uri?y.URI.revive(h.uri):void 0,range:h.range?F.$zs.lift(h.range):null,description:h.description,error:h.error,sortText:h.sortText})})(c||(e.ITestItem=c={}));var o;(function(k){k[k.NotExpandable=0]="NotExpandable",k[k.Expandable=1]="Expandable",k[k.BusyExpanding=2]="BusyExpanding",k[k.Expanded=3]="Expanded"})(o||(e.TestItemExpandState=o={}));var l;(function(k){k.serialize=h=>({expand:h.expand,item:c.serialize(h.item)}),k.deserialize=h=>({controllerId:A.$sJ.root(h.item.extId),expand:h.expand,item:c.deserialize(h.item)})})(l||(e.InternalTestItem=l={}));var n;(function(k){k.serialize=h=>{let w;return h.item&&(w={},h.item.label!==void 0&&(w.label=h.item.label),h.item.tags!==void 0&&(w.tags=h.item.tags),h.item.busy!==void 0&&(w.busy=h.item.busy),h.item.uri!==void 0&&(w.uri=h.item.uri?.toJSON()),h.item.range!==void 0&&(w.range=h.item.range?.toJSON()),h.item.description!==void 0&&(w.description=h.item.description),h.item.error!==void 0&&(w.error=h.item.error),h.item.sortText!==void 0&&(w.sortText=h.item.sortText)),{extId:h.extId,expand:h.expand,item:w}},k.deserialize=h=>{let w;return h.item&&(w={},h.item.label!==void 0&&(w.label=h.item.label),h.item.tags!==void 0&&(w.tags=h.item.tags),h.item.busy!==void 0&&(w.busy=h.item.busy),h.item.range!==void 0&&(w.range=h.item.range?F.$zs.lift(h.item.range):null),h.item.description!==void 0&&(w.description=h.item.description),h.item.error!==void 0&&(w.error=h.item.error),h.item.sortText!==void 0&&(w.sortText=h.item.sortText)),{extId:h.extId,expand:h.expand,item:w}}})(n||(e.ITestItemUpdate=n={}));const s=(k,h)=>{h.expand!==void 0&&(k.expand=h.expand),h.item!==void 0&&(k.item=k.item?Object.assign(k.item,h.item):h.item)};e.$yJ=s;var a;(function(k){k.serializeWithoutMessages=h=>({...l.serialize(h),ownComputedState:h.ownComputedState,computedState:h.computedState,tasks:h.tasks.map(g.serializeWithoutMessages)}),k.serialize=h=>({...l.serialize(h),ownComputedState:h.ownComputedState,computedState:h.computedState,tasks:h.tasks.map(g.serialize)}),k.deserialize=h=>({...l.deserialize(h),ownComputedState:h.ownComputedState,computedState:h.computedState,tasks:h.tasks.map(g.deserialize),retired:!0})})(a||(e.TestResultItem=a={}));var d;(function(k){k[k.Function=0]="Function",k[k.Statement=1]="Statement"})(d||(e.DetailType=d={}));var p;(function(k){k[k.Add=0]="Add",k[k.Update=1]="Update",k[k.DocumentSynced=2]="DocumentSynced",k[k.Remove=3]="Remove",k[k.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",k[k.Retire=5]="Retire",k[k.AddTag=6]="AddTag",k[k.RemoveTag=7]="RemoveTag"})(p||(e.TestDiffOpType=p={}));var m;(function(k){k.deserialize=h=>h.op===0?{op:h.op,item:l.deserialize(h.item)}:h.op===1?{op:h.op,item:n.deserialize(h.item)}:h.op===2?{op:h.op,uri:y.URI.revive(h.uri),docv:h.docv}:h,k.serialize=h=>h.op===0?{op:h.op,item:l.serialize(h.item)}:h.op===1?{op:h.op,item:n.serialize(h.item)}:h})(m||(e.TestsDiffOp=m={}));class S{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(h){const w=this.o();for(const I of h)switch(I.op){case 0:this.j(l.deserialize(I.item),w);break;case 1:this.k(n.deserialize(I.item),w);break;case 3:this.l(I.itemId,w);break;case 5:this.m(I.itemId);break;case 4:this.updatePendingRoots(I.amount);break;case 6:this.c.set(I.tag.id,I.tag);break;case 7:this.c.delete(I.id);break}w.complete?.()}j(h,w){const I=A.$sJ.parentId(h.item.extId)?.toString();let L;if(!I)L=this.p(h),this.f.add(L),this.d.set(h.item.extId,L);else if(this.d.has(I)){const V=this.d.get(I);V.children.add(h.item.extId),L=this.p(h,V),this.d.set(h.item.extId,L)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(h)}`);return}return w.add?.(L),h.expand===2&&this.g++,L}k(h,w){const I=this.d.get(h.extId);if(I)return h.expand!==void 0&&(I.expand===2&&this.g--,h.expand===2&&this.g++),(0,e.$yJ)(I,h),w.update?.(I),I}l(h,w){const I=this.d.get(h);if(!I)return;const L=A.$sJ.parentId(I.item.extId)?.toString();L?this.d.get(L).children.delete(I.item.extId):this.f.delete(I);const V=[[h]];for(;V.length;)for(const Y of V.pop()){const U=this.d.get(Y);U&&(V.push(U.children),this.d.delete(Y),w.remove?.(U,U!==I),U.expand===2&&this.g--)}}m(h){}updatePendingRoots(h){this.h+=h}o(){return{}}}e.$zJ=S}),define(Ae[77],Re([1,0,14,5,6,53,58,48]),function(we,e,y,F,A,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vM=e.$uM=e.$tM=e.$sM=e.$rM=e.TestItemEventOp=void 0;var E;(function(r){r[r.Upsert=0]="Upsert",r[r.SetTags=1]="SetTags",r[r.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",r[r.RemoveChild=3]="RemoveChild",r[r.SetProp=4]="SetProp",r[r.Bulk=5]="Bulk",r[r.DocumentSynced=6]="DocumentSynced"})(E||(e.TestItemEventOp=E={}));const f=(r,c)=>r===c,D=Object.entries({range:(r,c)=>r===c?!0:!r||!c?!1:r.equalsRange(c),busy:f,label:f,description:f,error:f,sortText:f,tags:(r,c)=>!(r.length!==c.length||r.some(o=>!c.includes(o)))}),u=(r,c)=>{let o;for(const[l,n]of D)n(r[l],c[l])||(o?o[l]=c[l]:o={[l]:c[l]});return o};class b extends A.$Rc{get root(){return this.s.root}constructor(c){super(),this.s=c,this.f=this.B(new y.$0g(()=>this.flushDiff(),200)),this.g=this.B(new F.$Rd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(c){this.h=c;for(const o of this.tree.values())this.I(o)}get resolveHandler(){return this.h}collectDiff(){const c=this.m;return this.m=[],c}pushDiff(c){switch(c.op){case 2:{for(const o of this.m)if(o.op===2&&o.uri===c.uri){o.docv=c.docv;return}break}case 1:{const o=this.m[this.m.length-1];if(o){if(o.op===1&&o.item.extId===c.item.extId){(0,R.$yJ)(o.item,c.item);return}if(o.op===0&&o.item.item.extId===c.item.extId){(0,R.$yJ)(o.item,c.item);return}}break}}this.m.push(c),this.f.isScheduled()||this.f.schedule()}expand(c,o){const l=this.tree.get(c);if(l){if((l.expandLevels===void 0||o>l.expandLevels)&&(l.expandLevels=o),l.expand===1){const n=this.L(l);return n.isOpen()?this.J(l,o-1):n.wait().then(()=>this.J(l,o-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.J(l,o-1)):this.J(l,o-1)}}dispose(){for(const c of this.tree.values())this.s.getApiFor(c.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(c,o){switch(o.op){case 3:this.N($.$sJ.joinToString(c.fullId,o.id));break;case 0:this.y(o.item,c);break;case 5:for(const l of o.ops)this.u(c,l);break;case 1:this.z(o.new,o.old,c.fullId.toString());break;case 2:this.I(c);break;case 4:this.pushDiff({op:1,item:{extId:c.fullId.toString(),item:o.update}});break;case 6:this.w(c.actual.uri);break;default:(0,M.$4c)(o)}}w(c){c&&this.pushDiff({op:2,uri:c,docv:this.s.getDocumentVersion(c)})}y(c,o){const l=$.$sJ.fromExtHostTestItem(c,this.root.id,o?.actual),n=this.s.getApiFor(c);n.parent&&n.parent!==o?.actual&&this.s.getChildren(n.parent).delete(c.id);let s=this.tree.get(l.toString());if(!s){s={fullId:l,actual:c,expandLevels:o?.expandLevels?o.expandLevels-1:void 0,expand:0},c.tags.forEach(this.C,this),this.tree.set(s.fullId.toString(),s),this.F(c,o),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:s.expand,item:this.s.toITestItem(c)}}),this.H(c,s,o);return}if(s.actual===c){this.G(c,s,o);return}if(s.actual.uri?.toString()!==c.uri?.toString())return this.N(l.toString()),this.y(c,o);const a=this.s.getChildren(s.actual),d=s.actual,p=u(this.s.toITestItem(d),this.s.toITestItem(c));this.s.getApiFor(d).listener=void 0,s.actual=c,s.expand=0,p&&(p.hasOwnProperty("tags")&&(this.z(c.tags,d.tags,l.toString()),delete p.tags),this.u(s,{op:4,update:p})),this.H(c,s,o);for(const[m,S]of a)this.s.getChildren(c).get(S.id)||this.N($.$sJ.joinToString(l,S.id));this.w(s.actual.uri)}z(c,o,l){const n=new Set(o.map(s=>s.id));for(const s of c)n.delete(s.id)||this.C(s);this.pushDiff({op:1,item:{extId:l,item:{tags:c.map(s=>(0,R.$wJ)(this.s.controllerId,s.id))}}}),n.forEach(this.D,this)}C(c){const o=this.j.get(c.id);o?o.refCount++:(this.j.set(c.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$wJ)(this.s.controllerId,c.id)}}))}D(c){const o=this.j.get(c);o&&!--o.refCount&&(this.j.delete(c),this.pushDiff({op:7,id:(0,R.$wJ)(this.s.controllerId,c)}))}F(c,o){this.s.getApiFor(c).parent=o&&o.actual!==this.root?o.actual:void 0}G(c,o,l){this.F(c,l);const n=this.s.getApiFor(c);n.parent=l?.actual,n.listener=s=>this.u(o,s),this.I(o)}H(c,o,l){this.G(c,o,l);for(const[n,s]of this.s.getChildren(c))this.y(s,o)}I(c){let o;this.h?c.resolveBarrier?o=c.resolveBarrier.isOpen()?3:2:o=c.actual.canResolveChildren?1:0:o=0,o!==c.expand&&(c.expand=o,this.pushDiff({op:1,item:{extId:c.fullId.toString(),expand:o}}),o===1&&c.expandLevels!==void 0&&this.L(c))}J(c,o){if(o<0)return;const l=[];for(const[n,s]of this.s.getChildren(c.actual)){const a=this.expand($.$sJ.joinToString(c.fullId,s.id),o);(0,y.$Kg)(a)&&l.push(a)}if(l.length)return Promise.all(l).then(()=>{})}L(c){if(c.resolveBarrier)return c.resolveBarrier;if(!this.h){const s=new y.$Wg;return s.open(),s}c.expand=2,this.M(c);const o=c.resolveBarrier=new y.$Wg,l=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,s)};let n;try{n=this.h(c.actual===this.root?void 0:c.actual)}catch(s){l(s)}return(0,y.$Kg)(n)?n.catch(l).then(()=>{o.open(),this.I(c)}):(o.open(),this.I(c)),c.resolveBarrier}M(c){this.pushDiff({op:1,item:{extId:c.fullId.toString(),expand:c.expand}})}N(c){const o=this.tree.get(c);if(!o)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:c});const l=[o];for(;l.length;){const n=l.pop();if(n){this.s.getApiFor(n.actual).listener=void 0;for(const s of n.actual.tags)this.D(s.id);this.tree.delete(n.fullId.toString());for(const[s,a]of this.s.getChildren(n.actual))l.push(this.tree.get($.$sJ.joinToString(n.fullId,a.id)))}}}flushDiff(){const c=this.collectDiff();c.length&&this.g.fire(c)}}e.$rM=b;class v extends Error{constructor(c){super(`Attempted to insert a duplicate test item ID ${c}`)}}e.$sM=v;class g extends Error{constructor(c){super(`TestItem with ID "${c}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$tM=g;class t extends Error{constructor(c,o,l){super(`TestItem with ID "${c}" is from controller "${o}" and cannot be added as a child of an item from controller "${l}".`)}}e.$uM=t;const i=(r,c,o)=>{let l=new Map;return{get size(){return l.size},forEach(n,s){for(const a of l.values())n.call(s,a,this)},[Symbol.iterator](){return l.entries()},replace(n){const s=new Map,a=new Set(l.keys()),d={op:5,ops:[]};for(const p of n){if(!(p instanceof o))throw new g(p.id);const m=c(p).controllerId;if(m!==r.controllerId)throw new t(p.id,m,r.controllerId);if(s.has(p.id))throw new v(p.id);s.set(p.id,p),a.delete(p.id),d.ops.push({op:0,item:p})}for(const p of a.keys())d.ops.push({op:3,id:p});r.listener?.(d),l=s},add(n){if(!(n instanceof o))throw new g(n.id);l.set(n.id,n),r.listener?.({op:0,item:n})},delete(n){l.delete(n)&&r.listener?.({op:3,id:n})},get(n){return l.get(n)},toJSON(){return Array.from(l.values())}}};e.$vM=i}),define(Ae[104],Re([1,0,77]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xM=e.$wM=void 0;const F=new WeakMap,A=(R,$)=>{const E={controllerId:$};return F.set(R,E),E};e.$wM=A;const M=R=>{const $=F.get(R);if(!$)throw new y.$tM(R?.id||"<unknown>");return $};e.$xM=M}),define(Ae[78],Re([1,0,13,2]),function(we,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0tb=e.$9tb=e.$8tb=e.$7tb=e.$6tb=void 0,e.$6tb="vscode-cdn.net",e.$7tb=`vscode-resource.${e.$6tb}`,e.$8tb=`'self' https://*.${e.$6tb}`;function A($,E){return $.scheme===y.Schemas.http||$.scheme===y.Schemas.https?$:(E&&E.authority&&E.isRemote&&$.scheme===y.Schemas.file&&($=F.URI.from({scheme:y.Schemas.vscodeRemote,authority:E.authority,path:$.path})),F.URI.from({scheme:y.Schemas.https,authority:`${$.scheme}+${M($.authority)}.${e.$7tb}`,path:$.path,fragment:$.fragment,query:$.query}))}e.$9tb=A;function M($){return $.replace(/./g,E=>{const f=E.charCodeAt(0);return f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57?E:"-"+f.toString(16).padStart(4,"0")})}function R($){return $.replace(/-([0-9a-f]{4})/g,(E,f)=>String.fromCharCode(parseInt(f,16)))}e.$0tb=R}),define(Ae[213],Re([1,0,5,6,78]),function(we,e,y,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2dc=void 0;class M{constructor($,E,f){this.d=$,this.e=E,this.f=f,this.a=0,this.b=new F.$Qc,this.c=new Map,this.b.add(E.onDidChangeVisibleTextEditors(()=>{const P=E.getVisibleTextEditors();for(const D of this.c.values())P.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this.c.forEach($=>$.inset.dispose()),this.b.dispose()}createWebviewEditorInset($,E,f,P,D){let u;for(const c of this.e.getVisibleTextEditors(!0))if(c.value===$){u=c;break}if(!u)throw new Error("not a visible editor");const b=this,v=this.a++,g=new y.$Rd,t=new y.$Rd,i=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(c){return(0,A.$9tb)(c,b.f)}get cspSource(){return A.$8tb}set options(c){this.b=c,b.d.$setOptions(v,c)}get options(){return this.b}set html(c){this.a=c,b.d.$setHtml(v,c)}get html(){return this.a}get onDidReceiveMessage(){return g.event}postMessage(c){return b.d.$postMessage(v,c)}},r=new class{constructor(){this.editor=$,this.line=E,this.height=f,this.webview=i,this.onDidDispose=t.event}dispose(){b.c.has(v)&&(b.c.delete(v),b.d.$disposeEditorInset(v),t.fire(),t.dispose(),g.dispose())}};return this.d.$createEditorInset(v,u.id,u.value.document.uri,E+1,f,P||{},D.identifier,D.extensionLocation),this.c.set(v,{editor:$,inset:r,onDidReceiveMessage:g}),r}$onDidDispose($){const E=this.c.get($);E&&E.inset.dispose()}$onDidReceiveMessage($,E){this.c.get($)?.onDidReceiveMessage.fire(E)}}e.$2dc=M}),define(Ae[214],Re([1,0,4]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oN=e.VariableKind=e.$nN=void 0,e.$nN=(0,y.$Vh)("configurationResolverService");var F;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator"})(F||(e.VariableKind=F={}));class A extends Error{constructor(R,$){super($),this.variable=R}}e.$oN=A}),define(Ae[215],Re([1,0,20,74,16,26,21,94,177,214,12]),function(we,e,y,F,A,M,R,$,E,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CN=void 0;class D{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(b,v,g,t){this.h=new Map,this.a=b,this.b=v,this.g=g,t&&(this.c=t.then(i=>this.i(i)))}i(b){if(R.$i){const v=Object.create(null);return Object.keys(b).forEach(g=>{v[g.toLowerCase()]=b[g]}),v}return b}resolveWithEnvironment(b,v,g){return this.l({env:this.i(b),userHome:void 0},v?v.uri:void 0,g)}async resolveAsync(b,v){const g={env:await this.c,userHome:await this.g};return this.l(g,b?b.uri:void 0,v)}async j(b,v,g,t){const i=M.$an(v);R.$i&&i.windows?Object.keys(i.windows).forEach(c=>i[c]=i.windows[c]):R.$j&&i.osx?Object.keys(i.osx).forEach(c=>i[c]=i.osx[c]):R.$k&&i.linux&&Object.keys(i.linux).forEach(c=>i[c]=i.linux[c]),delete i.windows,delete i.osx,delete i.linux;const r={env:await this.c,userHome:await this.g};return this.l(r,b?b.uri:void 0,i,g,t)}async resolveAnyAsync(b,v,g){return this.j(b,v,g)}async resolveAnyMap(b,v,g){const t=new Map;return{newConfig:await this.j(b,v,g,t),resolvedVariables:t}}resolveWithInteractionReplace(b,v,g,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,v,g,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,v){if(this.h.has(b))throw new Error("Variable "+b+" is contributed twice.");this.h.set(b,v)}async l(b,v,g,t,i){if(A.$Cf(g))return this.m(b,v,g,t,i);if(Array.isArray(g))return Promise.all(g.map(r=>this.l(b,v,r,t,i)));if(A.$Ef(g)){const r=Object.create(null),c=await Promise.all(Object.keys(g).map(async o=>[await this.m(b,v,o,t,i),await this.l(b,v,g[o],t,i)]));for(const[o,l]of c)r[o]=l;return r}return g}m(b,v,g,t,i){return(0,P.$Xe)(g,D.VARIABLE_REGEXP,async(r,c)=>{if(c.includes(D.VARIABLE_LHS))return r;let o=await this.o(b,r,c,v,t);return i?.set(c,o),o!==r&&A.$Cf(o)&&o.match(D.VARIABLE_REGEXP)&&(o=await this.m(b,v,o,t,i)),o})}n(b){return this.b?this.b.getUriLabel(b,{noPrefix:!0}):b.fsPath}async o(b,v,g,t,i){let r;const c=g.split(":");c.length>1&&(g=c[0],r=c[1]);const o=s=>{const a=this.a.getFilePath();if(a)return(0,$.$zv)(a);throw new f.$oN(s,(0,E.localize)(0,null,v))},l=s=>{const a=o(s);if(this.a.getWorkspaceFolderPathForFile){const d=this.a.getWorkspaceFolderPathForFile();if(d)return(0,$.$zv)(d)}throw new f.$oN(s,(0,E.localize)(1,null,v,y.$mc(a)))},n=s=>{if(r){const a=this.a.getFolderUri(r);if(a)return a;throw new f.$oN(s,(0,E.localize)(2,null,v,r))}if(t)return t;throw this.a.getWorkspaceFolderCount()>1?new f.$oN(s,(0,E.localize)(3,null,v)):new f.$oN(s,(0,E.localize)(4,null,v))};switch(g){case"env":if(r){if(b.env){const s=b.env[R.$i?r.toLowerCase():r];if(A.$Cf(s))return s}return""}throw new f.$oN(f.VariableKind.Env,(0,E.localize)(5,null,v));case"config":if(r){const s=this.a.getConfigurationValue(t,r);if(A.$Lf(s))throw new f.$oN(f.VariableKind.Config,(0,E.localize)(6,null,v,r));if(A.$Ef(s))throw new f.$oN(f.VariableKind.Config,(0,E.localize)(7,null,v,r));return s}throw new f.$oN(f.VariableKind.Config,(0,E.localize)(8,null,v));case"command":return this.p(f.VariableKind.Command,v,r,i,"command");case"input":return this.p(f.VariableKind.Input,v,r,i,"input");case"extensionInstallFolder":if(r){const s=await this.a.getExtension(r);if(!s)throw new f.$oN(f.VariableKind.ExtensionInstallFolder,(0,E.localize)(9,null,v,r));return this.n(s.extensionLocation)}throw new f.$oN(f.VariableKind.ExtensionInstallFolder,(0,E.localize)(10,null,v));default:switch(g){case"workspaceRoot":case"workspaceFolder":return(0,$.$zv)(this.n(n(f.VariableKind.WorkspaceFolder)));case"cwd":return t||r?(0,$.$zv)(this.n(n(f.VariableKind.Cwd))):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,$.$zv)(y.$mc(this.n(n(f.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(b.userHome)return b.userHome;throw new f.$oN(f.VariableKind.UserHome,(0,E.localize)(11,null,v))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new f.$oN(f.VariableKind.LineNumber,(0,E.localize)(12,null,v))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new f.$oN(f.VariableKind.SelectedText,(0,E.localize)(13,null,v))}case"file":return o(f.VariableKind.File);case"fileWorkspaceFolder":return l(f.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return y.$mc(l(f.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return t||r?y.$kc(this.n(n(f.VariableKind.RelativeFile)),o(f.VariableKind.RelativeFile)):o(f.VariableKind.RelativeFile);case"relativeFileDirname":{const s=y.$lc(o(f.VariableKind.RelativeFileDirname));if(t||r){const a=y.$kc(this.n(n(f.VariableKind.RelativeFileDirname)),s);return a.length===0?".":a}return s}case"fileDirname":return y.$lc(o(f.VariableKind.FileDirname));case"fileExtname":return y.$nc(o(f.VariableKind.FileExtname));case"fileBasename":return y.$mc(o(f.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=y.$mc(o(f.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-y.$nc(s).length)}case"fileDirnameBasename":return y.$mc(y.$lc(o(f.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||v}case"execInstallFolder":{const s=this.a.getAppRoot();return s||v}case"pathSeparator":return y.sep;default:try{const s=r?`${g}:${r}`:g;return this.p(f.VariableKind.Unknown,v,s,i,void 0)}catch{return v}}}}p(b,v,g,t,i){if(g&&t){const r=i===void 0?t[g]:t[i+":"+g];if(typeof r=="string")return r;throw new f.$oN(b,(0,E.localize)(14,null,v))}return v}}e.$CN=D}),define(Ae[105],Re([1,0,4,102]),function(we,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JC=e.$IC=e.OpenEditorContext=e.GroupsOrder=e.$HC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$GC=void 0,e.$GC=(0,y.$Vh)("editorGroupsService");var A;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(A||(e.GroupDirection=A={}));var M;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(M||(e.GroupOrientation=M={}));var R;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var $;(function(v){v[v.MAXIMIZE=0]="MAXIMIZE",v[v.EXPAND=1]="EXPAND",v[v.EVEN=2]="EVEN"})($||(e.GroupsArrangement=$={}));var E;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(E||(e.MergeGroupMode=E={}));function f(v){const g=v;return(0,F.$pE)(g?.editor)&&(0,F.$pE)(g?.replacement)}e.$HC=f;var P;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(P||(e.GroupsOrder=P={}));var D;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(D||(e.OpenEditorContext=D={}));function u(v){const g=v;return!!g&&typeof g.id=="number"&&Array.isArray(g.editors)}e.$IC=u;function b(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$JC=b}),define(Ae[216],Re([1,0,4,105]),function(we,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NC=e.$MC=e.$LC=e.$KC=void 0,e.$KC=(0,y.$Vh)("editorService"),e.$LC=-1,e.$MC=-2;function A(M){const R=M;return typeof M=="number"||(0,F.$IC)(R)}e.$NC=A}),define(Ae[217],Re([1,0,4,184]),function(we,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WJ=void 0,e.$WJ=(0,y.$Wh)(F.$3h)}),define(Ae[106],Re([1,0,22,5,20,6]),function(we,e,y,F,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z5b=e.$Y5b=e.$X5b=e.$W5b=e.$V5b=void 0;class R{constructor(i,r){this.versionId=i,this.removedDueToLooping=r}}e.$V5b=R;class ${static isHostExtension(i,r,c){if(r.getExtensionDescription(i))return!1;const o=c.getExtensionDescription(i);return o?!!((o.main||o.browser)&&o.api==="none"):!1}constructor(i,r){this.j=i,this.c=new F.$Rd,this.onDidChange=this.c.event,this.d=0,this.e=r,this.k()}k(){this.e.sort(v),this.f=new y.$bm,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const r=this.j.readActivationEvents(i);for(const c of r)this.h.has(c)||this.h.set(c,[]),this.h.get(c).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,r){this.e=g(this.e,r),this.e=this.e.concat(i);const c=$.l(this.e);return this.e=g(this.e,c.map(o=>o.identifier)),this.k(),this.d++,this.c.fire(void 0),new R(this.d,c)}static l(i){const r=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(s){this.d.has(s)||(this.d.add(s),this.e.push(s))}addArc(s,a){this.addNode(s),this.addNode(a),this.c.has(s)?this.c.get(s).push(a):this.c.set(s,[a])}getArcs(s){return this.c.has(s)?this.c.get(s):[]}hasOnlyGoodArcs(s,a){const d=r.getArcs(s);for(let p=0;p<d.length;p++)if(!a.has(d[p]))return!1;return!0}getNodes(){return this.e}},c=new y.$bm;for(const s of i)if(c.set(s.identifier,s),s.extensionDependencies)for(const a of s.extensionDependencies)r.addArc(y.$_l.toKey(s.identifier),y.$_l.toKey(a));const o=new Set;r.getNodes().filter(s=>r.getArcs(s).length===0).forEach(s=>o.add(s));const l=r.getNodes().filter(s=>!o.has(s));let n;do{n=!1;for(let s=0;s<l.length;s++){const a=l[s];r.hasOnlyGoodArcs(a,o)&&(l.splice(s,1),s--,o.add(a),n=!0)}}while(n);return l.map(s=>c.get(s))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const r=this.h.get(i);return r?r.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const r=this.f.get(i);return r||void 0}getExtensionDescriptionByUUID(i){for(const r of this.g)if(r.uuid===i)return r}getExtensionDescriptionByIdOrUUID(i,r){return this.getExtensionDescription(i)??(r?this.getExtensionDescriptionByUUID(r):void 0)}}e.$W5b=$;class E{constructor(i,r){this.versionId=i,this.extensions=r}}e.$X5b=E;class f{constructor(i){this.d=new u,this.c=new $(i,[])}async acquireLock(i){const r=await this.d.acquire(i);return new P(this,r)}deltaExtensions(i,r,c){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(r,c)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,r){return this.c.getExtensionDescriptionByIdOrUUID(i,r)}}e.$Y5b=f;class P extends M.$Rc{constructor(i,r){super(),this.f=i,this.c=!1,this.B(r)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$Z5b=P;class D{constructor(i){this.name=i,this.promise=new Promise((r,c)=>{this.c=r})}resolve(i){this.c(i)}}class u{constructor(){this.c=[],this.d=!1}async acquire(i){const r=new D(i);return this.c.push(r),this.e(),r.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let r=!0;const c=setTimeout(()=>{r&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),o=()=>{r&&(clearTimeout(c),r=!1,this.d=!1,this.e())};i.resolve((0,M.$Pc)(o))}}var b;(function(t){t[t.Builtin=0]="Builtin",t[t.User=1]="User",t[t.Dev=2]="Dev"})(b||(b={}));function v(t,i){const r=t.isBuiltin?0:t.isUnderDevelopment?2:1,c=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(r!==c)return r-c;const o=A.$fc.basename(t.extensionLocation.path),l=A.$fc.basename(i.extensionLocation.path);return o<l?-1:o>l?1:0}function g(t,i){const r=new y.$am(i);return t.filter(c=>!r.has(c.identifier))}}),define(Ae[79],Re([1,0,24]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$im=e.$hm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var F;(function(f){f[f.Desktop=1]="Desktop",f[f.Web=2]="Web"})(F||(e.UIKind=F={}));var A;(function(f){f[f.VersionMismatch=55]="VersionMismatch",f[f.UnexpectedError=81]="UnexpectedError"})(A||(e.ExtensionHostExitCode=A={}));var M;(function(f){f[f.Initialized=0]="Initialized",f[f.Ready=1]="Ready",f[f.Terminate=2]="Terminate"})(M||(e.MessageType=M={}));function R(f){const P=y.$fe.alloc(1);switch(f){case 0:P.writeUInt8(1,0);break;case 1:P.writeUInt8(2,0);break;case 2:P.writeUInt8(3,0);break}return P}e.$hm=R;function $(f,P){if(f.byteLength!==1)return!1;switch(f.readUInt8(0)){case 1:return P===0;case 2:return P===1;case 3:return P===2;default:return!1}}e.$im=$;var E;(function(f){f.Start="START_NATIVE_LOG",f.End="END_NATIVE_LOG"})(E||(e.NativeLogMarkers=E={}))}),define(Ae[59],Re([1,0,4,5,15,27,79,55,56,26,2,6,165]),function(we,e,y,F,A,M,R,$,E,f,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VM=e.$UM=e.$TM=e.$SM=void 0;let b=class extends D.$Rc{constructor(i,r){super(),this.s=i,this.t=r,this.a=this.B(new F.$Rd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new F.$Rd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=P.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=r.createLogger(this.m,{id:E.$uo,name:(0,u.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(r.onDidChangeLogLevel(c=>{(0,A.$fj)(c)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===A.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(i,r,c){const o=this.getTelemetryDetails(),l=new v(r,c,i,this.n,this.j,this.getBuiltInCommonProperties(i),{isUsageEnabled:o.isUsageEnabled,isErrorsEnabled:o.isErrorsEnabled}),n=this.r.get(i.identifier.value)??[];return this.r.set(i.identifier.value,[...n,l]),l.apiTelemetryLogger}$initializeTelemetryLevel(i,r,c){this.f=i,this.g=r,this.c=c??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(i){const r=Object.create(null);switch(r["common.extname"]=`${i.publisher}.${i.name}`,r["common.extversion"]=i.version,r["common.vscodemachineid"]=this.s.telemetryInfo.machineId,r["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,r["common.vscodeversion"]=this.s.version,r["common.isnewappinstall"]=g(this.s.telemetryInfo.firstSessionDate),r["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:r["common.uikind"]="web";break;case R.UIKind.Desktop:r["common.uikind"]="desktop";break;default:r["common.uikind"]="unknown"}return r["common.remotename"]=(0,$.$2k)((0,E.$Bo)(this.s.remote.authority)),r}$onDidChangeTelemetryLevel(i){this.h=this.getTelemetryConfiguration(),this.f=i;const r=this.getTelemetryDetails();this.r.forEach((c,o)=>{const l=c.filter(n=>!n.isDisposed);l.length===0?this.r.delete(o):this.r.set(o,l)}),this.r.forEach(c=>{for(const o of c)o.updateTelemetryEnablements(r.isUsageEnabled,r.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(i,r){const o=this.r.get(i.value)?.filter(n=>!n.isDisposed);if(!o)return this.r.delete(i.value),!1;let l=!1;for(const n of o)n.ignoreUnhandledExtHostErrors||(n.logError(r),l=!0);return l}};e.$SM=b,e.$SM=b=Ke([Ve(0,M.$RM),Ve(1,A.$ej)],b);class v{static validateSender(i){if(typeof i!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof i.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof i.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof i.flush<"u"&&typeof i.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(i,r,c,o,l,n,s){this.g=c,this.h=o,this.i=l,this.j=n,this.a=new F.$Rd,this.ignoreUnhandledExtHostErrors=r?.ignoreUnhandledErrors??!1,this.b=r?.ignoreBuiltInCommonProperties??!1,this.c=r?.additionalCommonProperties,this.f=i,this.d={isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}}updateTelemetryEnablements(i,r){this.e&&(this.d={isUsageEnabled:i,isErrorsEnabled:r},this.a.fire(this.e))}mixInCommonPropsAndCleanData(i){let r="properties"in i?i.properties??{}:i;return r=(0,E.$Eo)(r,[]),this.c&&(r=(0,f.$dn)(r,this.c)),this.b||(r=(0,f.$dn)(r,this.j)),"properties"in i?i.properties=r:i=r,i}k(i,r){this.f&&(this.g.publisher==="vscode"?i=this.g.name+"/"+i:i=this.g.identifier.value+"/"+i,r=this.mixInCommonPropsAndCleanData(r||{}),this.i||this.f?.sendEventData(i,r),this.h.trace(i,r))}logUsage(i,r){this.d.isUsageEnabled&&this.k(i,r)}logError(i,r){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof i=="string")this.k(i,r);else{const c={name:i.name,message:i.message,stack:i.stack,cause:i.cause},o=(0,E.$Eo)(c,[]),l=new Error(o.message,{cause:o.cause});l.stack=o.stack,l.name=o.name,r=this.mixInCommonPropsAndCleanData(r||{}),this.i||this.f.sendErrorData(l,r),this.h.trace("exception",r)}}get apiTelemetryLogger(){if(!this.e){const i=this,r={logUsage:i.logUsage.bind(i),get isUsageEnabled(){return i.d.isUsageEnabled},get isErrorsEnabled(){return i.d.isErrorsEnabled},logError:i.logError.bind(i),dispose:i.dispose.bind(i),onDidChangeEnableStates:i.a.event.bind(i)};this.e=Object.freeze(r)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let i=this.f;this.f=void 0,Promise.resolve(i.flush()).then(i=void 0),this.e=void 0}else this.f=void 0}}e.$TM=v;function g(t){const i=Date.now()-new Date(t).getTime();return isNaN(i)?!1:i<1e3*60*60*24}e.$UM=g,e.$VM=(0,y.$Vh)("IExtHostTelemetry")}),define(Ae[23],Re([1,0,5,2,193,101,22,4]),function(we,e,y,F,A,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SF=e.$RF=e.$QF=e.ActivationKind=e.$PF=e.$OF=e.$NF=e.$MF=e.$LF=e.ExtensionHostStartup=e.$KF=e.$JF=e.$IF=e.$HF=void 0,e.$HF=Object.freeze({identifier:new R.$_l("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$IF="extensions.webWorker",e.$JF=(0,$.$Vh)("extensionService");class E{constructor(l){this.dependency=l}}e.$KF=E;var f;(function(o){o[o.EagerAutoStart=1]="EagerAutoStart",o[o.EagerManualStart=2]="EagerManualStart",o[o.Lazy=3]="Lazy"})(f||(e.ExtensionHostStartup=f={}));class P{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(l,n,s){this.c=l,this.d=n.slice(0),this.e=s.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:M.$yF.createActivationEventsMap(this.d)}}set(l,n,s){if(this.c>l)throw new Error(`ExtensionHostExtensions: invalid versionId ${l} (current: ${this.c})`);const a=[],d=[],p=[],m=[],S=D(this.d),k=D(n),h=(Y,U)=>Y.extensionLocation.toString()===U.extensionLocation.toString()||Y.isBuiltin===U.isBuiltin||Y.isUserBuiltin===U.isUserBuiltin||Y.isUnderDevelopment===U.isUnderDevelopment;for(const Y of this.d){const U=k.get(Y.identifier);if(!U){a.push(Y.identifier),S.delete(Y.identifier);continue}if(!h(Y,U)){a.push(Y.identifier),S.delete(Y.identifier);continue}}for(const Y of n){const U=S.get(Y.identifier);if(!U){d.push(Y);continue}if(!h(U,Y)){a.push(U.identifier),S.delete(U.identifier);continue}}const w=new R.$am(this.e),I=new R.$am(s);for(const Y of this.e)I.has(Y)||p.push(Y);for(const Y of s)w.has(Y)||m.push(Y);const L=M.$yF.createActivationEventsMap(d),V={versionId:l,toRemove:a,toAdd:d,addActivationEvents:L,myToRemove:p,myToAdd:m};return this.delta(V),V}delta(l){if(this.c>=l.versionId)return null;const{toRemove:n,toAdd:s,myToRemove:a,myToAdd:d}=l,p=new R.$am(n),m=new R.$am(a);for(let S=0;S<this.d.length;S++)p.has(this.d[S].identifier)&&(this.d.splice(S,1),S--);for(let S=0;S<this.e.length;S++)m.has(this.e[S])&&(this.e.splice(S,1),S--);for(const S of s)this.d.push(S);for(const S of d)this.e.push(S);return this.f=null,l}containsExtension(l){for(const n of this.e)if(R.$_l.equals(n,l))return!0;return!1}containsActivationEvent(l){return this.f||(this.f=this.g()),this.f.has(l)}g(){const l=new Set;for(const n of this.d){if(!this.containsExtension(n.identifier))continue;const s=M.$yF.readActivationEvents(n);for(const a of s)l.add(a)}return l}}e.$LF=P;function D(o){const l=new R.$bm;for(const n of o)l.set(n.identifier,n);return l}function u(o,l){return o.enabledApiProposals?o.enabledApiProposals.includes(l):!1}e.$MF=u;function b(o,l){if(!u(o,l))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${l}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${l}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.$NF=b;class v{constructor(l,n,s,a){this.codeLoadingTime=l,this.activateCallTime=n,this.activateResolvedTime=s,this.activationReason=a}}e.$OF=v;class g{constructor(l,n){this.description=l,this.value=n}}e.$PF=g;var t;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(t||(e.ActivationKind=t={}));function i(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,A.$Ko)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation,targetPlatform:o.targetPlatform,validations:[],isValid:!0}}e.$QF=i;function r(o,l){return{identifier:new R.$_l((0,A.$Io)(o.manifest.publisher,o.manifest.name)),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!l,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid,targetPlatform:o.targetPlatform}}e.$RF=r;class c{constructor(){this.onDidRegisterExtensions=y.Event.None,this.onDidChangeExtensionsStatus=y.Event.None,this.onDidChangeExtensions=y.Event.None,this.onWillActivateByEvent=y.Event.None,this.onDidChangeResponsiveChange=y.Event.None,this.onWillStop=y.Event.None,this.extensions=[]}activateByEvent(l){return Promise.resolve(void 0)}activateById(l,n){return Promise.resolve(void 0)}activationEventIsDone(l){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(l){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(l,n){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(l){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$SF=c}),define(Ae[218],Re([1,0,11,106,22,23,15,14]),function(we,e,y,F,A,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qec=e.$pec=e.$oec=e.$nec=e.$mec=e.$lec=void 0;class E{static{this.NONE=new E(!1,-1,-1,-1)}constructor(i,r,c,o){this.startup=i,this.codeLoadingTime=r,this.activateCallTime=c,this.activateResolvedTime=o}}e.$lec=E;class f{constructor(i){this.a=i,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(i,r){return i===-1||r===-1?-1:r-i}build(){return new E(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$mec=f;class P{constructor(i,r,c,o,l,n){this.activationFailed=i,this.activationFailedError=r,this.activationTimes=c,this.module=o,this.exports=l,this.subscriptions=n}}e.$nec=P;class D extends P{constructor(i){super(!1,null,i,{activate:void 0,deactivate:void 0},void 0,[])}}e.$oec=D;class u extends P{constructor(){super(!1,null,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$pec=u;class b extends P{constructor(i){super(!0,i,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let v=class{constructor(i,r,c,o){this.g=o,this.a=i,this.b=r,this.c=c,this.d=new A.$bm,this.f=Object.create(null)}dispose(){for(const[i,r]of this.d)r.dispose()}async waitForActivatingExtensions(){const i=[];for(const[r,c]of this.d)i.push(c.wait());await Promise.all(i)}isActivated(i){const r=this.d.get(i);return!!(r&&r.value)}getActivatedExtension(i){const r=this.d.get(i);if(!r||!r.value)throw new Error(`Extension '${i.value}' is not known or not activated`);return r.value}async activateByEvent(i,r){if(this.f[i])return;const c=this.a.getExtensionDescriptionsForActivationEvent(i);await this.h(c.map(o=>({id:o.identifier,reason:{startup:r,extensionId:o.identifier,activationEvent:i}}))),this.f[i]=!0}activateById(i,r){const c=this.a.getExtensionDescription(i);if(!c)throw new Error(`Extension '${i}' is not known`);return this.h([{id:c.identifier,reason:r}])}async h(i){const r=i.filter(c=>!this.isActivated(c.id)).map(c=>this.j(c));await Promise.all(r.map(c=>c.wait()))}j(i){if(this.d.has(i.id))return this.d.get(i.id);if(this.l(i.id))return this.k(i,null,[],null);const r=this.a.getExtensionDescription(i.id);if(!r){const l=new Error(`Cannot activate unknown extension '${i.id.value}'`),n=this.k(i,null,[],new b(l));return this.c.onExtensionActivationError(i.id,l,new M.$KF(i.id.value)),n}const c=[],o=typeof r.extensionDependencies>"u"?[]:r.extensionDependencies;for(const l of o){if(this.m(l))continue;const n=this.d.get(l);if(n){c.push(n);continue}if(this.l(l)){c.push(this.j({id:this.b.getExtensionDescription(l).identifier,reason:i.reason}));continue}const s=this.a.getExtensionDescription(l);if(s){if(!s.main&&!s.browser)continue;c.push(this.j({id:s.identifier,reason:i.reason}));continue}const a=r.displayName||r.identifier.value,d=new Error(`Cannot activate the '${a}' extension because it depends on unknown extension '${l}'`),p=this.k(i,r.displayName,[],new b(d));return this.c.onExtensionActivationError(r.identifier,d,new M.$KF(l)),p}return this.k(i,r.displayName,c,null)}k(i,r,c,o){const l=new g(i.id,r,i.reason,c,o,this.c,this.g);return this.d.set(i.id,l),l}l(i){return F.$W5b.isHostExtension(i,this.a,this.b)}m(i){const r=this.b.getExtensionDescription(i);return r?!r.main&&!r.browser:!1}};e.$qec=v,e.$qec=v=Ke([Ve(3,R.$dj)],v);let g=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(i,r,c,o,l,n,s){this.c=i,this.d=r,this.f=c,this.g=o,this.h=l,this.j=n,this.k=s,this.a=new $.$Wg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let i=0;i<this.g.length;i++){const r=this.g[i];if(r.value&&!r.value.activationFailed){this.g.splice(i,1),i--;continue}if(r.value&&r.value.activationFailed){const c=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${r.friendlyName}' failed to activate`);c.detail=r.value.activationFailedError,this.h=new b(c),this.j.onExtensionActivationError(this.c,c,null);return}}this.g.length>0&&await Promise.race(this.g.map(i=>i.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(i){const r=new Error;if(i&&i.name&&(r.name=i.name),i&&i.message?r.message=`Activating extension '${this.c.value}' failed: ${i.message}.`:r.message=`Activating extension '${this.c.value}' failed: ${i}.`,i&&i.stack&&(r.stack=i.stack),this.h=new b(r),this.b&&y.$3(i))return;this.j.onExtensionActivationError(this.c,r,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(i)}}};g=Ke([Ve(6,R.$dj)],g)}),define(Ae[8],Re([1,0,18,24,126,219,52,28,120,51,68,26,16,2,29,80,98,104,102,76,48,58,216,7,23]),function(we,e,y,F,A,M,R,$,E,f,P,D,u,b,v,g,t,i,r,c,o,l,n,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$AM=e.$zM=e.MarkdownString=e.$yM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var d;(function(Ce){function Me(K){const{selectionStartLineNumber:Le,selectionStartColumn:Ue,positionLineNumber:Qe,positionColumn:qe}=K,it=new s.$CK(Le-1,Ue-1),pt=new s.$CK(Qe-1,qe-1);return new s.$EK(it,pt)}Ce.to=Me;function be(K){const{anchor:Le,active:Ue}=K;return{selectionStartLineNumber:Le.line+1,selectionStartColumn:Le.character+1,positionLineNumber:Ue.line+1,positionColumn:Ue.character+1}}Ce.from=be})(d||(e.Selection=d={}));var p;(function(Ce){function Me(K){if(!K)return;const{start:Le,end:Ue}=K;return{startLineNumber:Le.line+1,startColumn:Le.character+1,endLineNumber:Ue.line+1,endColumn:Ue.character+1}}Ce.from=Me;function be(K){if(!K)return;const{startLineNumber:Le,startColumn:Ue,endLineNumber:Qe,endColumn:qe}=K;return new s.$DK(Le-1,Ue-1,Qe-1,qe-1)}Ce.to=be})(p||(e.Range=p={}));var m;(function(Ce){function Me(be){switch(be){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Ce.to=Me})(m||(e.TokenType=m={}));var S;(function(Ce){function Me(K){return new s.$CK(K.lineNumber-1,K.column-1)}Ce.to=Me;function be(K){return{lineNumber:K.line+1,column:K.character+1}}Ce.from=be})(S||(e.Position=S={}));var k;(function(Ce){function Me(Le,Ue,Qe){return(0,y.$Gb)((0,y.$2b)(Le).map(qe=>be(qe,Ue,Qe)))}Ce.from=Me;function be(Le,Ue,Qe){if(typeof Le=="string")return{$serialized:!0,language:Le,isBuiltin:Qe?.isBuiltin};if(Le)return{$serialized:!0,language:Le.language,scheme:K(Le.scheme,Ue),pattern:X.from(Le.pattern)??void 0,exclusive:Le.exclusive,notebookType:Le.notebookType,isBuiltin:Qe?.isBuiltin}}function K(Le,Ue){return Ue&&typeof Le=="string"?Ue.transformOutgoingScheme(Le):Le}})(k||(e.DocumentSelector=k={}));var h;(function(Ce){function Me(K){switch(K){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Ce.from=Me;function be(K){switch(K){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Ce.to=be})(h||(e.DiagnosticTag=h={}));var w;(function(Ce){function Me(K){let Le;return K.code&&((0,u.$Cf)(K.code)||(0,u.$Gf)(K.code)?Le=String(K.code):Le={value:String(K.code.value),target:K.code.target}),{...p.from(K.range),message:K.message,source:K.source,code:Le,severity:L.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(I.from),tags:Array.isArray(K.tags)?(0,y.$Gb)(K.tags.map(h.from)):void 0}}Ce.from=Me;function be(K){const Le=new s.$PK(p.to(K),K.message,L.to(K.severity));return Le.source=K.source,Le.code=(0,u.$Cf)(K.code)?K.code:K.code?.value,Le.relatedInformation=K.relatedInformation&&K.relatedInformation.map(I.to),Le.tags=K.tags&&(0,y.$Gb)(K.tags.map(h.to)),Le}Ce.to=be})(w||(e.Diagnostic=w={}));var I;(function(Ce){function Me(K){return{...p.from(K.location.range),message:K.message,resource:K.location.uri}}Ce.from=Me;function be(K){return new s.$OK(new s.$NK(K.resource,p.to(K)),K.message)}Ce.to=be})(I||(e.DiagnosticRelatedInformation=I={}));var L;(function(Ce){function Me(K){switch(K){case s.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Ce.from=Me;function be(K){switch(K){case t.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Ce.to=be})(L||(e.DiagnosticSeverity=L={}));var V;(function(Ce){function Me(K){return typeof K=="number"&&K>=s.ViewColumn.One?K-1:K===s.ViewColumn.Beside?n.$MC:n.$LC}Ce.from=Me;function be(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}Ce.to=be})(V||(e.ViewColumn=V={}));function Y(Ce){return typeof Ce.range<"u"}function U(Ce){return Ce.length===0?!0:!!Y(Ce[0])}e.$yM=U;var N;(function(Ce){function Me(qe){return qe.map(Ce.from)}Ce.fromMany=Me;function be(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function K(qe){let it;if(be(qe)){const{language:ut,value:Mt}=qe;it={value:"```"+ut+`
`+Mt+"\n```\n"}}else s.$2K.isMarkdownString(qe)?it={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?it={value:qe}:it={value:""};const pt=Object.create(null);it.uris=pt;const $t=ut=>{try{let Mt=b.URI.parse(ut,!0);Mt=Mt.with({query:Le(Mt.query,pt)}),pt[ut]=Mt}catch{}return""},bt=new E.marked.Renderer;return bt.link=$t,bt.image=ut=>typeof ut=="string"?$t(R.$dk(ut).href):"",(0,E.marked)(it.value,{renderer:bt}),it}Ce.from=K;function Le(qe,it){if(!qe)return qe;let pt;try{pt=(0,f.$rh)(qe)}catch{}if(!pt)return qe;let $t=!1;return pt=(0,D.$cn)(pt,bt=>{if(b.URI.isUri(bt)){const ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return it[ut]=bt,$t=!0,ut}else return}),$t?JSON.stringify(pt):qe}function Ue(qe){const it=new s.$2K(qe.value,qe.supportThemeIcons);return it.isTrusted=qe.isTrusted,it.supportHtml=qe.supportHtml,it.baseUri=qe.baseUri?b.URI.from(qe.baseUri):void 0,it}Ce.to=Ue;function Qe(qe){if(qe)return typeof qe=="string"?qe:Ce.from(qe)}Ce.fromStrict=Qe})(N||(e.MarkdownString=N={}));function C(Ce){return U(Ce)?Ce.map(Me=>({range:p.from(Me.range),hoverMessage:Array.isArray(Me.hoverMessage)?N.fromMany(Me.hoverMessage):Me.hoverMessage?N.from(Me.hoverMessage):void 0,renderOptions:Me.renderOptions})):Ce.map(Me=>({range:p.from(Me)}))}e.$zM=C;function T(Ce){return typeof Ce>"u"?Ce:typeof Ce=="string"?b.URI.file(Ce):Ce}e.$AM=T;var G;(function(Ce){function Me(be){return typeof be>"u"?be:{contentText:be.contentText,contentIconPath:be.contentIconPath?T(be.contentIconPath):void 0,border:be.border,borderColor:be.borderColor,fontStyle:be.fontStyle,fontWeight:be.fontWeight,textDecoration:be.textDecoration,color:be.color,backgroundColor:be.backgroundColor,margin:be.margin,width:be.width,height:be.height}}Ce.from=Me})(G||(e.ThemableDecorationAttachmentRenderOptions=G={}));var de;(function(Ce){function Me(be){return typeof be>"u"?be:{backgroundColor:be.backgroundColor,outline:be.outline,outlineColor:be.outlineColor,outlineStyle:be.outlineStyle,outlineWidth:be.outlineWidth,border:be.border,borderColor:be.borderColor,borderRadius:be.borderRadius,borderSpacing:be.borderSpacing,borderStyle:be.borderStyle,borderWidth:be.borderWidth,fontStyle:be.fontStyle,fontWeight:be.fontWeight,textDecoration:be.textDecoration,cursor:be.cursor,color:be.color,opacity:be.opacity,letterSpacing:be.letterSpacing,gutterIconPath:be.gutterIconPath?T(be.gutterIconPath):void 0,gutterIconSize:be.gutterIconSize,overviewRulerColor:be.overviewRulerColor,before:be.before?G.from(be.before):void 0,after:be.after?G.from(be.after):void 0}}Ce.from=Me})(de||(e.ThemableDecorationRenderOptions=de={}));var me;(function(Ce){function Me(be){if(typeof be>"u")return be;switch(be){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Ce.from=Me})(me||(e.DecorationRangeBehavior=me={}));var De;(function(Ce){function Me(be){return{isWholeLine:be.isWholeLine,rangeBehavior:be.rangeBehavior?me.from(be.rangeBehavior):void 0,overviewRulerLane:be.overviewRulerLane,light:be.light?de.from(be.light):void 0,dark:be.dark?de.from(be.dark):void 0,backgroundColor:be.backgroundColor,outline:be.outline,outlineColor:be.outlineColor,outlineStyle:be.outlineStyle,outlineWidth:be.outlineWidth,border:be.border,borderColor:be.borderColor,borderRadius:be.borderRadius,borderSpacing:be.borderSpacing,borderStyle:be.borderStyle,borderWidth:be.borderWidth,fontStyle:be.fontStyle,fontWeight:be.fontWeight,textDecoration:be.textDecoration,cursor:be.cursor,color:be.color,opacity:be.opacity,letterSpacing:be.letterSpacing,gutterIconPath:be.gutterIconPath?T(be.gutterIconPath):void 0,gutterIconSize:be.gutterIconSize,overviewRulerColor:be.overviewRulerColor,before:be.before?G.from(be.before):void 0,after:be.after?G.from(be.after):void 0}}Ce.from=Me})(De||(e.DecorationRenderOptions=De={}));var ke;(function(Ce){function Me(K){return{text:K.newText,eol:K.newEol&&et.from(K.newEol),range:p.from(K.range)}}Ce.from=Me;function be(K){const Le=new s.$IK(p.to(K.range),K.text);return Le.newEol=typeof K.eol>"u"?void 0:et.to(K.eol),Le}Ce.to=be})(ke||(e.TextEdit=ke={}));var le;(function(Ce){function Me(K,Le){const Ue={edits:[]};if(K instanceof s.$LK){const Qe=new $.$Ac;for(const qe of K._allEntries())qe._type===1&&b.URI.isUri(qe.to)&&qe.from===void 0&&Qe.add(qe.to);for(const qe of K._allEntries())if(qe._type===1){let it;qe.options?.contents&&(ArrayBuffer.isView(qe.options.contents)?it={type:"base64",value:(0,F.$ze)(F.$fe.wrap(qe.options.contents))}:it={type:"dataTransferItem",id:qe.options.contents._itemId}),Ue.edits.push({oldResource:qe.from,newResource:qe.to,options:{...qe.options,contents:it},metadata:qe.metadata})}else qe._type===2?Ue.edits.push({resource:qe.uri,textEdit:ke.from(qe.edit),versionId:Qe.has(qe.uri)?void 0:Le?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===6?Ue.edits.push({resource:qe.uri,textEdit:{range:p.from(qe.range),text:qe.edit.value,insertAsSnippet:!0},versionId:Qe.has(qe.uri)?void 0:Le?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===3?Ue.edits.push({metadata:qe.metadata,resource:qe.uri,cellEdit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Le?.getNotebookDocumentVersion(qe.uri)}):qe._type===5&&Ue.edits.push({metadata:qe.metadata,resource:qe.uri,notebookVersionId:Le?.getNotebookDocumentVersion(qe.uri),cellEdit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(Dt.from)}})}return Ue}Ce.from=Me;function be(K){const Le=new s.$LK,Ue=new $.$zc;for(const Qe of K.edits)if(Qe.textEdit){const qe=Qe,it=b.URI.revive(qe.resource),pt=p.to(qe.textEdit.range),$t=qe.textEdit.text,bt=qe.textEdit.insertAsSnippet;let ut;bt?ut=s.$KK.replace(pt,new s.$MK($t)):ut=s.$IK.replace(pt,$t);const Mt=Ue.get(it);Mt?Mt.push(ut):Ue.set(it,[ut])}else Le.renameFile(b.URI.revive(Qe.oldResource),b.URI.revive(Qe.newResource),Qe.options);for(const[Qe,qe]of Ue)Le.set(Qe,qe);return Le}Ce.to=be})(le||(e.WorkspaceEdit=le={}));var pe;(function(Ce){const Me=Object.create(null);Me[s.SymbolKind.File]=0,Me[s.SymbolKind.Module]=1,Me[s.SymbolKind.Namespace]=2,Me[s.SymbolKind.Package]=3,Me[s.SymbolKind.Class]=4,Me[s.SymbolKind.Method]=5,Me[s.SymbolKind.Property]=6,Me[s.SymbolKind.Field]=7,Me[s.SymbolKind.Constructor]=8,Me[s.SymbolKind.Enum]=9,Me[s.SymbolKind.Interface]=10,Me[s.SymbolKind.Function]=11,Me[s.SymbolKind.Variable]=12,Me[s.SymbolKind.Constant]=13,Me[s.SymbolKind.String]=14,Me[s.SymbolKind.Number]=15,Me[s.SymbolKind.Boolean]=16,Me[s.SymbolKind.Array]=17,Me[s.SymbolKind.Object]=18,Me[s.SymbolKind.Key]=19,Me[s.SymbolKind.Null]=20,Me[s.SymbolKind.EnumMember]=21,Me[s.SymbolKind.Struct]=22,Me[s.SymbolKind.Event]=23,Me[s.SymbolKind.Operator]=24,Me[s.SymbolKind.TypeParameter]=25;function be(Le){return typeof Me[Le]=="number"?Me[Le]:6}Ce.from=be;function K(Le){for(const Ue in Me)if(Me[Ue]===Le)return Number(Ue);return s.SymbolKind.Property}Ce.to=K})(pe||(e.SymbolKind=pe={}));var re;(function(Ce){function Me(K){switch(K){case s.SymbolTag.Deprecated:return 1}}Ce.from=Me;function be(K){switch(K){case 1:return s.SymbolTag.Deprecated}}Ce.to=be})(re||(e.SymbolTag=re={}));var Pe;(function(Ce){function Me(K){return{name:K.name,kind:pe.from(K.kind),tags:K.tags&&K.tags.map(re.from),containerName:K.containerName,location:ve.from(K.location)}}Ce.from=Me;function be(K){const Le=new s.$SK(K.name,pe.to(K.kind),K.containerName,ve.to(K.location));return Le.tags=K.tags&&K.tags.map(re.to),Le}Ce.to=be})(Pe||(e.WorkspaceSymbol=Pe={}));var se;(function(Ce){function Me(K){const Le={name:K.name||"!!MISSING: name!!",detail:K.detail,range:p.from(K.range),selectionRange:p.from(K.selectionRange),kind:pe.from(K.kind),tags:K.tags?.map(re.from)??[]};return K.children&&(Le.children=K.children.map(Me)),Le}Ce.from=Me;function be(K){const Le=new s.$TK(K.name,K.detail,pe.to(K.kind),p.to(K.range),p.to(K.selectionRange));return(0,y.$Kb)(K.tags)&&(Le.tags=K.tags.map(re.to)),K.children&&(Le.children=K.children.map(be)),Le}Ce.to=be})(se||(e.DocumentSymbol=se={}));var Z;(function(Ce){function Me(K){const Le=new s.$XK(pe.to(K.kind),K.name,K.detail||"",b.URI.revive(K.uri),p.to(K.range),p.to(K.selectionRange));return Le._sessionId=K._sessionId,Le._itemId=K._itemId,Le}Ce.to=Me;function be(K,Le,Ue){if(Le=Le??K._sessionId,Ue=Ue??K._itemId,Le===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:Ue,name:K.name,detail:K.detail,kind:pe.from(K.kind),uri:K.uri,range:p.from(K.range),selectionRange:p.from(K.selectionRange),tags:K.tags?.map(re.from)}}Ce.from=be})(Z||(e.CallHierarchyItem=Z={}));var j;(function(Ce){function Me(be){return new s.$YK(Z.to(be.from),be.fromRanges.map(K=>p.to(K)))}Ce.to=Me})(j||(e.CallHierarchyIncomingCall=j={}));var ie;(function(Ce){function Me(be){return new s.$ZK(Z.to(be.to),be.fromRanges.map(K=>p.to(K)))}Ce.to=Me})(ie||(e.CallHierarchyOutgoingCall=ie={}));var ve;(function(Ce){function Me(K){return{range:K.range&&p.from(K.range),uri:K.uri}}Ce.from=Me;function be(K){return new s.$NK(b.URI.revive(K.uri),p.to(K.range))}Ce.to=be})(ve||(e.location=ve={}));var ne;(function(Ce){function Me(K){const Le=K,Ue=K;return{originSelectionRange:Le.originSelectionRange?p.from(Le.originSelectionRange):void 0,uri:Le.targetUri?Le.targetUri:Ue.uri,range:p.from(Le.targetRange?Le.targetRange:Ue.range),targetSelectionRange:Le.targetSelectionRange?p.from(Le.targetSelectionRange):void 0}}Ce.from=Me;function be(K){return{targetUri:b.URI.revive(K.uri),targetRange:p.to(K.range),targetSelectionRange:K.targetSelectionRange?p.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?p.to(K.originSelectionRange):void 0}}Ce.to=be})(ne||(e.DefinitionLink=ne={}));var he;(function(Ce){function Me(K){return{range:p.from(K.range),contents:N.fromMany(K.contents)}}Ce.from=Me;function be(K){return new s.$QK(K.contents.map(N.to),p.to(K.range))}Ce.to=be})(he||(e.Hover=he={}));var ce;(function(Ce){function Me(K){return{range:p.from(K.range),expression:K.expression}}Ce.from=Me;function be(K){return new s.$JL(p.to(K.range),K.expression)}Ce.to=be})(ce||(e.EvaluatableExpression=ce={}));var ye;(function(Ce){function Me(K){if(K instanceof s.$KL)return{type:"text",range:p.from(K.range),text:K.text};if(K instanceof s.$LL)return{type:"variable",range:p.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof s.$ML)return{type:"expression",range:p.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}Ce.from=Me;function be(K){switch(K.type){case"text":return{range:p.to(K.range),text:K.text};case"variable":return{range:p.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:p.to(K.range),expression:K.expression}}}Ce.to=be})(ye||(e.InlineValue=ye={}));var _;(function(Ce){function Me(K){return{frameId:K.frameId,stoppedLocation:p.from(K.stoppedLocation)}}Ce.from=Me;function be(K){return new s.$NL(K.frameId,p.to(K.stoppedLocation))}Ce.to=be})(_||(e.InlineValueContext=_={}));var fe;(function(Ce){function Me(K){return{range:p.from(K.range),kind:K.kind}}Ce.from=Me;function be(K){return new s.$RK(p.to(K.range),K.kind)}Ce.to=be})(fe||(e.DocumentHighlight=fe={}));var te;(function(Ce){function Me(be){switch(be){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Ce.to=Me})(te||(e.CompletionTriggerKind=te={}));var ae;(function(Ce){function Me(be){return{triggerKind:te.to(be.triggerKind),triggerCharacter:be.triggerCharacter}}Ce.to=Me})(ae||(e.CompletionContext=ae={}));var $e;(function(Ce){function Me(K){switch(K){case s.CompletionItemTag.Deprecated:return 1}}Ce.from=Me;function be(K){switch(K){case 1:return s.CompletionItemTag.Deprecated}}Ce.to=be})($e||(e.CompletionItemTag=$e={}));var Ie;(function(Ce){const Me=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function be(Ue){return Me.get(Ue)??9}Ce.from=be;const K=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Le(Ue){return K.get(Ue)??s.CompletionItemKind.Property}Ce.to=Le})(Ie||(e.CompletionItemKind=Ie={}));var O;(function(Ce){function Me(be,K){const Le=new s.$8K(be.label);return Le.insertText=be.insertText,Le.kind=Ie.to(be.kind),Le.tags=be.tags?.map($e.to),Le.detail=be.detail,Le.documentation=R.$$j(be.documentation)?N.to(be.documentation):be.documentation,Le.sortText=be.sortText,Le.filterText=be.filterText,Le.preselect=be.preselect,Le.commitCharacters=be.commitCharacters,v.$zs.isIRange(be.range)?Le.range=p.to(be.range):typeof be.range=="object"&&(Le.range={inserting:p.to(be.range.insert),replacing:p.to(be.range.replace)}),Le.keepWhitespace=typeof be.insertTextRules>"u"?!1:!!(be.insertTextRules&1),typeof be.insertTextRules<"u"&&be.insertTextRules&4?Le.insertText=new s.$MK(be.insertText):(Le.insertText=be.insertText,Le.textEdit=Le.range instanceof s.$DK?new s.$IK(Le.range,Le.insertText):void 0),be.additionalTextEdits&&be.additionalTextEdits.length>0&&(Le.additionalTextEdits=be.additionalTextEdits.map(Ue=>ke.to(Ue))),Le.command=K&&be.command?K.fromInternal(be.command):void 0,Le}Ce.to=Me})(O||(e.CompletionItem=O={}));var W;(function(Ce){function Me(K){if(typeof K.label!="string"&&!Array.isArray(K.label))throw new TypeError("Invalid label");return{label:K.label,documentation:N.fromStrict(K.documentation)}}Ce.from=Me;function be(K){return{label:K.label,documentation:R.$$j(K.documentation)?N.to(K.documentation):K.documentation}}Ce.to=be})(W||(e.ParameterInformation=W={}));var H;(function(Ce){function Me(K){return{label:K.label,documentation:N.fromStrict(K.documentation),parameters:Array.isArray(K.parameters)?K.parameters.map(W.from):[],activeParameter:K.activeParameter}}Ce.from=Me;function be(K){return{label:K.label,documentation:R.$$j(K.documentation)?N.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(W.to):[],activeParameter:K.activeParameter}}Ce.to=be})(H||(e.SignatureInformation=H={}));var J;(function(Ce){function Me(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(H.from):[]}}Ce.from=Me;function be(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(H.to):[]}}Ce.to=be})(J||(e.SignatureHelp=J={}));var q;(function(Ce){function Me(be,K){const Le=new s.$7K(S.to(K.position),typeof K.label=="string"?K.label:K.label.map(x.to.bind(void 0,be)),K.kind&&ue.to(K.kind));return Le.textEdits=K.textEdits&&K.textEdits.map(ke.to),Le.tooltip=R.$$j(K.tooltip)?N.to(K.tooltip):K.tooltip,Le.paddingLeft=K.paddingLeft,Le.paddingRight=K.paddingRight,Le}Ce.to=Me})(q||(e.InlayHint=q={}));var x;(function(Ce){function Me(be,K){const Le=new s.$6K(K.label);return Le.tooltip=R.$$j(K.tooltip)?N.to(K.tooltip):K.tooltip,g.Command.is(K.command)&&(Le.command=be.fromInternal(K.command)),K.location&&(Le.location=ve.to(K.location)),Le}Ce.to=Me})(x||(e.InlayHintLabelPart=x={}));var ue;(function(Ce){function Me(K){return K}Ce.from=Me;function be(K){return K}Ce.to=be})(ue||(e.InlayHintKind=ue={}));var Ne;(function(Ce){function Me(K){return{range:p.from(K.range),url:K.target,tooltip:K.tooltip}}Ce.from=Me;function be(K){let Le;if(K.url)try{Le=typeof K.url=="string"?b.URI.parse(K.url,!0):b.URI.revive(K.url)}catch{}return new s.$aL(p.to(K.range),Le)}Ce.to=be})(Ne||(e.DocumentLink=Ne={}));var Be;(function(Ce){function Me(K){const Le=new s.$dL(K.label);return K.textEdit&&(Le.textEdit=ke.to(K.textEdit)),K.additionalTextEdits&&(Le.additionalTextEdits=K.additionalTextEdits.map(Ue=>ke.to(Ue))),Le}Ce.to=Me;function be(K){return{label:K.label,textEdit:K.textEdit?ke.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Le=>ke.from(Le)):void 0}}Ce.from=be})(Be||(e.ColorPresentation=Be={}));var Ye;(function(Ce){function Me(K){return new s.$bL(K[0],K[1],K[2],K[3])}Ce.to=Me;function be(K){return[K.red,K.green,K.blue,K.alpha]}Ce.from=be})(Ye||(e.Color=Ye={}));var Je;(function(Ce){function Me(K){return{range:p.from(K.range)}}Ce.from=Me;function be(K){return new s.$WK(p.to(K.range))}Ce.to=be})(Je||(e.SelectionRange=Je={}));var tt;(function(Ce){function Me(be){switch(be){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Ce.to=Me})(tt||(e.TextDocumentSaveReason=tt={}));var _e;(function(Ce){function Me(K){switch(K){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Ce.from=Me;function be(K){switch(K){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Ce.to=be})(_e||(e.TextEditorLineNumbersStyle=_e={}));var et;(function(Ce){function Me(K){if(K===s.EndOfLine.CRLF)return 1;if(K===s.EndOfLine.LF)return 0}Ce.from=Me;function be(K){if(K===1)return s.EndOfLine.CRLF;if(K===0)return s.EndOfLine.LF}Ce.to=be})(et||(e.EndOfLine=et={}));var rt;(function(Ce){function Me(be){if(typeof be=="object")return be.viewId;switch(be){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ce.from=Me})(rt||(e.ProgressLocation=rt={}));var nt;(function(Ce){function Me(K){const Le={start:K.start+1,end:K.end+1};return K.kind&&(Le.kind=ze.from(K.kind)),Le}Ce.from=Me;function be(K){const Le={start:K.start-1,end:K.end-1};return K.kind&&(Le.kind=ze.to(K.kind)),Le}Ce.to=be})(nt||(e.FoldingRange=nt={}));var ze;(function(Ce){function Me(K){if(K)switch(K){case s.FoldingRangeKind.Comment:return g.$ot.Comment;case s.FoldingRangeKind.Imports:return g.$ot.Imports;case s.FoldingRangeKind.Region:return g.$ot.Region}}Ce.from=Me;function be(K){if(K)switch(K.value){case g.$ot.Comment.value:return s.FoldingRangeKind.Comment;case g.$ot.Imports.value:return s.FoldingRangeKind.Imports;case g.$ot.Region.value:return s.FoldingRangeKind.Region}}Ce.to=be})(ze||(e.FoldingRangeKind=ze={}));var dt;(function(Ce){function Me(be){if(be)return{pinned:typeof be.preview=="boolean"?!be.preview:void 0,inactive:be.background,preserveFocus:be.preserveFocus,selection:typeof be.selection=="object"?p.from(be.selection):void 0,override:typeof be.override=="boolean"?r.$bE.id:void 0}}Ce.from=Me})(dt||(e.TextEditorOpenOptions=dt={}));var X;(function(Ce){function Me(Ue){return Ue instanceof s.$xL?Ue.toJSON():typeof Ue=="string"?Ue:be(Ue)||K(Ue)?new s.$xL(Ue.baseUri??Ue.base,Ue.pattern).toJSON():Ue}Ce.from=Me;function be(Ue){const Qe=Ue;return Qe?b.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function K(Ue){const Qe=Ue;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function Le(Ue){return typeof Ue=="string"?Ue:new s.$xL(b.URI.revive(Ue.baseUri),Ue.pattern)}Ce.to=Le})(X||(e.GlobPattern=X={}));var Q;(function(Ce){function Me(be){if(be){if(Array.isArray(be))return be.map(Me);if(typeof be=="string")return be;{const K=be;return{language:K.language,scheme:K.scheme,pattern:X.from(K.pattern),exclusive:K.exclusive,notebookType:K.notebookType}}}else return}Ce.from=Me})(Q||(e.LanguageSelector=Q={}));var Ee;(function(Ce){function Me(K){return!!K&&typeof K=="object"&&"documents"in K&&Array.isArray(K.documents)&&K.documents.every(Le=>Array.isArray(Le)&&Le.every(Ue=>Ue&&typeof Ue=="object"&&"uri"in Ue&&b.URI.isUri(Ue.uri)&&"version"in Ue&&typeof Ue.version=="number"&&"ranges"in Ue&&Array.isArray(Ue.ranges)&&Ue.ranges.every(Qe=>Qe instanceof s.$DK)))}Ce.is=Me;function be(K){return{documents:K.documents.map(Le=>Le.map(Ue=>({uri:b.URI.from(Ue.uri),version:Ue.version,ranges:Ue.ranges.map(Qe=>p.from(Qe))})))}}Ce.from=be})(Ee||(e.MappedEditsContext=Ee={}));var je;(function(Ce){function Me(K){return{start:K.start,end:K.end}}Ce.from=Me;function be(K){return new s.$YL(K.start,K.end)}Ce.to=be})(je||(e.NotebookRange=je={}));var He;(function(Ce){function Me(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}Ce.to=Me;function be(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}Ce.from=be})(He||(e.NotebookCellExecutionSummary=He={}));var Xe;(function(Ce){function Me(be){if(be===c.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(be===c.NotebookCellExecutionState.Pending)return;if(be===c.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${be}`)}Ce.to=Me})(Xe||(e.NotebookCellExecutionState=Xe={}));var st;(function(Ce){function Me(K){switch(K){case s.NotebookCellKind.Markup:return c.CellKind.Markup;case s.NotebookCellKind.Code:default:return c.CellKind.Code}}Ce.from=Me;function be(K){switch(K){case c.CellKind.Markup:return s.NotebookCellKind.Markup;case c.CellKind.Code:default:return s.NotebookCellKind.Code}}Ce.to=be})(st||(e.NotebookCellKind=st={}));var vt;(function(Ce){function Me(K){const Le={metadata:K.metadata??Object.create(null),cells:[]};for(const Ue of K.cells)s.$ZL.validate(Ue),Le.cells.push(Dt.from(Ue));return Le}Ce.from=Me;function be(K){const Le=new s.$1L(K.cells.map(Dt.to));return(0,u.$Pf)(K.metadata)||(Le.metadata=K.metadata),Le}Ce.to=be})(vt||(e.NotebookData=vt={}));var Dt;(function(Ce){function Me(K){return{cellKind:st.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:He.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(Kt.from):[]}}Ce.from=Me;function be(K){return new s.$ZL(st.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(Kt.to):void 0,K.metadata,K.internalMetadata?He.to(K.internalMetadata):void 0)}Ce.to=be})(Dt||(e.NotebookCellData=Dt={}));var Oe;(function(Ce){function Me(K){return{mime:K.mime,valueBytes:F.$fe.wrap(K.data)}}Ce.from=Me;function be(K){return new s.$2L(K.valueBytes.buffer,K.mime)}Ce.to=be})(Oe||(e.NotebookCellOutputItem=Oe={}));var Kt;(function(Ce){function Me(K){return{outputId:K.id,items:K.items.map(Oe.from),metadata:K.metadata}}Ce.from=Me;function be(K){const Le=K.items.map(Oe.to);return new s.$3L(Le,K.outputId,K.metadata)}Ce.to=be})(Kt||(e.NotebookCellOutput=Kt={}));var Ht;(function(Ce){function Me(Le){return K(Le)?{include:X.from(Le.include)??void 0,exclude:X.from(Le.exclude)??void 0}:X.from(Le)??void 0}Ce.from=Me;function be(Le){return K(Le)?{include:X.to(Le.include),exclude:X.to(Le.exclude)}:X.to(Le)}Ce.to=be;function K(Le){const Ue=Le;return Ue?!(0,u.$Lf)(Ue.include)&&!(0,u.$Lf)(Ue.exclude):!1}})(Ht||(e.NotebookExclusiveDocumentPattern=Ht={}));var yt;(function(Ce){function Me(be,K,Le){const Ue=typeof be.command=="string"?{title:"",command:be.command}:be.command;return{alignment:be.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(Ue,Le),text:be.text,tooltip:be.tooltip,accessibilityInformation:be.accessibilityInformation,priority:be.priority}}Ce.from=Me})(yt||(e.NotebookStatusBarItem=yt={}));var Ut;(function(Ce){function Me(be,K,Le){const Ue=typeof be.command=="string"?{title:"",command:be.command}:be.command;return{command:K.toInternal(Ue,Le),label:be.label,description:be.description,detail:be.detail,documentation:be.documentation}}Ce.from=Me})(Ut||(e.NotebookKernelSourceAction=Ut={}));var Ot;(function(Ce){function Me(be){return{transientOutputs:be?.transientOutputs??!1,transientCellMetadata:be?.transientCellMetadata??{},transientDocumentMetadata:be?.transientDocumentMetadata??{},cellContentMetadata:be?.cellContentMetadata??{}}}Ce.from=Me})(Ot||(e.NotebookDocumentContentOptions=Ot={}));var Gt;(function(Ce){function Me(K){return{uri:K.uri,provides:K.provides}}Ce.from=Me;function be(K){return new s.$5L(b.URI.revive(K.uri),K.provides)}Ce.to=be})(Gt||(e.NotebookRendererScript=Gt={}));var jt;(function(Ce){function Me(K){return{message:N.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,contextValue:K.contextValue,location:K.location&&{range:p.from(K.location.range),uri:K.location.uri}}}Ce.from=Me;function be(K){const Le=new s.$$L(typeof K.message=="string"?K.message:N.to(K.message));return Le.actualOutput=K.actual,Le.expectedOutput=K.expected,Le.contextValue=K.contextValue,Le.location=K.location?ve.to(K.location):void 0,Le}Ce.to=be})(jt||(e.TestMessage=jt={}));var St;(function(Ce){Ce.namespace=l.$wJ,Ce.denamespace=l.$xJ})(St||(e.TestTag=St={}));var Lt;(function(Ce){function Me(K){const Le=(0,i.$xM)(K).controllerId;return{extId:o.$sJ.fromExtHostTestItem(K,Le).toString(),label:K.label,uri:b.URI.revive(K.uri),busy:K.busy,tags:K.tags.map(Ue=>St.namespace(Le,Ue.id)),range:v.$zs.lift(p.from(K.range)),description:K.description||null,sortText:K.sortText||null,error:K.error&&N.fromStrict(K.error)||null}}Ce.from=Me;function be(K){return{parent:void 0,error:void 0,id:o.$sJ.fromString(K.extId).localId,label:K.label,uri:b.URI.revive(K.uri),tags:(K.tags||[]).map(Le=>{const{tagId:Ue}=St.denamespace(Le);return new s.$_L(Ue)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:p.to(K.range||void 0),canResolveChildren:!1,busy:K.busy,description:K.description||void 0,sortText:K.sortText||void 0}}Ce.toPlain=be})(Lt||(e.TestItem=Lt={})),function(Ce){function Me(K){return{id:K.id}}Ce.from=Me;function be(K){return new s.$_L(K.id)}Ce.to=be}(St||(e.TestTag=St={}));var Vt;(function(Ce){const Me=(K,Le)=>{const Ue=[];for(const[qe,it]of Le)o.$sJ.compare(it.item.extId,qe)===2&&(Le.delete(qe),Ue.push(it));const Qe={...Lt.toPlain(K.item),parent:void 0,taskStates:K.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(it=>it.type===0).map(jt.to)})),children:Ue.map(qe=>Me(qe,Le))};for(const qe of Qe.children)qe.parent=Qe;return Qe};function be(K){const Le=[],Ue=new Map;for(const Qe of K.items){Ue.set(Qe.item.extId,Qe);const qe=o.$sJ.root(Qe.item.extId);K.request.targets.some(it=>it.controllerId===qe&&it.testIds.includes(Qe.item.extId))&&Le.push(Qe)}return{completedAt:K.completedAt,results:Le.map(Qe=>Me(Qe,Ue))}}Ce.to=be})(Vt||(e.TestResults=Vt={}));var Ze;(function(Ce){function Me(Ue){return{covered:Ue.covered,total:Ue.covered}}function be(Ue){return"line"in Ue?S.from(Ue):p.from(Ue)}function K(Ue){return"branches"in Ue?{count:Ue.executionCount,location:be(Ue.location),type:1,branches:Ue.branches.length?Ue.branches.map(Qe=>({count:Qe.executionCount,location:Qe.location&&be(Qe.location)})):void 0}:{type:0,count:Ue.executionCount,location:be(Ue.location)}}Ce.fromDetailed=K;function Le(Ue){return{uri:Ue.uri,statement:Me(Ue.statementCoverage),branch:Ue.branchCoverage&&Me(Ue.branchCoverage),function:Ue.functionCoverage&&Me(Ue.functionCoverage),details:Ue.detailedCoverage?.map(K)}}Ce.fromFile=Le})(Ze||(e.TestCoverage=Ze={}));var Wt;(function(Ce){function Me(be){switch(be){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Ce.to=Me})(Wt||(e.CodeActionTriggerKind=Wt={}));var qt;(function(Ce){function Me(K){const Le=new s.$fM(pe.to(K.kind),K.name,K.detail||"",b.URI.revive(K.uri),p.to(K.range),p.to(K.selectionRange));return Le._sessionId=K._sessionId,Le._itemId=K._itemId,Le}Ce.to=Me;function be(K,Le,Ue){if(Le=Le??K._sessionId,Ue=Ue??K._itemId,Le===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:Ue,kind:pe.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:p.from(K.range),selectionRange:p.from(K.selectionRange),tags:K.tags?.map(re.from)}}Ce.from=be})(qt||(e.TypeHierarchyItem=qt={}));var ct;(function(Ce){function Me(be){if(be)return{value:be.value,tooltip:be.tooltip}}Ce.from=Me})(ct||(e.ViewBadge=ct={}));var gt;(function(Ce){function Me(Ue,Qe,qe){const it=Qe.fileData;return it?new s.$qL(new s.$rL(it.name,b.URI.revive(it.uri),it.id,(0,M.$cb)(()=>qe(it.id)))):Ue===P.$Vr.uriList&&Qe.uriListData?new s.$pL(Le(Qe.uriListData)):new s.$pL(Qe.asString)}Ce.to=Me;async function be(Ue,Qe){const qe=await Qe.asString();if(Ue===P.$Vr.uriList)return{asString:qe,fileData:void 0,uriListData:K(qe)};const it=Qe.asFile();return{asString:qe,fileData:it?{name:it.name,uri:it.uri,id:it._itemId??it.id}:void 0}}Ce.from=be;function K(Ue){return A.$9s.split(Ue).map(Qe=>{if(Qe.startsWith("#"))return Qe;try{return b.URI.parse(Qe)}catch{}return Qe})}function Le(Ue){return A.$9s.create(Ue.map(Qe=>typeof Qe=="string"?Qe:b.URI.revive(Qe)))}})(gt||(e.DataTransferItem=gt={}));var Nt;(function(Ce){function Me(K,Le){const Ue=K.items.map(([Qe,qe])=>[Qe,gt.to(Qe,qe,Le)]);return new s.$sL(Ue)}Ce.toDataTransfer=Me;async function be(K){const Le={items:[]},Ue=[];for(const[Qe,qe]of K)Ue.push((async()=>{Le.items.push([Qe,await gt.from(Qe,qe)])})());return await Promise.all(Ue),Le}Ce.from=be})(Nt||(e.DataTransfer=Nt={}));var Pt;(function(Ce){function Me(be){return{kind:"reply",message:be.message,title:be.title,tooltip:be.tooltip}}Ce.from=Me})(Pt||(e.ChatReplyFollowup=Pt={}));var At;(function(Ce){function Me(be){return typeof be=="string"?{title:be,message:be,kind:"reply"}:"commandId"in be?{kind:"command",title:be.title??"",commandId:be.commandId??"",when:be.when??"",args:be.args}:Pt.from(be)}Ce.from=Me})(At||(e.ChatFollowup=At={}));var ft;(function(Ce){function Me(K){const Le=new s.$qM(kt.to(K.role),K.content);return Le.name=K.name,Le}Ce.to=Me;function be(K){return{role:kt.from(K.role),content:K.content,name:K.name}}Ce.from=be})(ft||(e.ChatMessage=ft={}));var kt;(function(Ce){function Me(K){switch(K){case 0:return s.ChatMessageRole.System;case 1:return s.ChatMessageRole.User;case 2:return s.ChatMessageRole.Assistant;case 3:return s.ChatMessageRole.Function}}Ce.to=Me;function be(K){switch(K){case s.ChatMessageRole.System:return 0;case s.ChatMessageRole.Assistant:return 2;case s.ChatMessageRole.Function:return 3;case s.ChatMessageRole.User:default:return 1}}Ce.from=be})(kt||(e.ChatMessageRole=kt={}));var Rt;(function(Ce){function Me(Le){const Ue={};for(const Qe of Object.keys(Le))Ue[Qe]=Le[Qe].map(Ce.to);return Ue}Ce.objectTo=Me;function be(Le){return{level:Ct.to(Le.level),value:Le.value,description:Le.description}}Ce.to=be;function K(Le){return{level:Ct.from(Le.level),value:Le.value,description:Le.description}}Ce.from=K})(Rt||(e.ChatVariable=Rt={}));var Ct;(function(Ce){function Me(K){switch(K){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Ce.to=Me;function be(K){switch(K){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Ce.from=be})(Ct||(e.ChatVariableLevel=Ct={}));var We;(function(Ce){function Me(be){switch(be){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return s.InteractiveEditorResponseFeedbackKind.Bug}}Ce.to=Me})(We||(e.InteractiveEditorResponseFeedbackKind=We={}));var zt;(function(Ce){function Me(be,K){return"placeholder"in K&&"resolvedContent"in K?{placeholder:K.placeholder,kind:"asyncContent"}:"markdownContent"in K?((0,a.$NF)(be,"chatAgents2Additions"),{content:N.from(K.markdownContent),kind:"content"}):"content"in K?typeof K.content=="string"?{content:K.content,kind:"content"}:((0,a.$NF)(be,"chatAgents2Additions"),{content:N.from(K.content),kind:"content"}):"documents"in K?{documents:K.documents.map(Le=>({uri:Le.uri,version:Le.version,ranges:Le.ranges.map(Ue=>p.from(Ue))})),kind:"usedContext"}:"reference"in K?{reference:"uri"in K.reference?{uri:K.reference.uri,range:p.from(K.reference.range)}:K.reference,kind:"reference"}:"inlineReference"in K?{inlineReference:"uri"in K.inlineReference?{uri:K.inlineReference.uri,range:p.from(K.inlineReference.range)}:K.inlineReference,name:K.title,kind:"inlineReference"}:"agentName"in K?((0,a.$NF)(be,"chatAgents2Additions"),{agentName:K.agentName,command:K.command,kind:"agentDetection"}):{treeData:K.treeData,kind:"treeData"}}Ce.from=Me})(zt||(e.ChatResponseProgress=zt={}));var Jt;(function(Ce){function Me(be,K,Le){return"terminalCommand"in be?{terminalCommand:be.terminalCommand}:"uri"in be?{uri:be.uri}:K.toInternal(be,Le)}Ce.from=Me})(Jt||(e.TerminalQuickFix=Jt={}))}),define(Ae[220],Re([1,0,2,11,7,8,186]),function(we,e,y,F,A,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wec=void 0;class ${constructor(f,P,D,u={timeout:1500,errors:3}){this.c=f,this.d=P,this.f=D,this.g=u,this.a=new R.$2c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(f){return(P,D,u)=>{const v={dispose:this.a.push([P,D,f])};return Array.isArray(u)&&u.push(v),v}}async $participateInSave(f,P){const D=y.URI.revive(f);let u=!1;const b=setTimeout(()=>u=!0,this.g.timeout),v=[];try{for(const g of[...this.a]){if(u)break;const t=this.d.getDocument(D),i=await this.h(g,{document:t,reason:M.TextDocumentSaveReason.to(P)});v.push(i)}}finally{clearTimeout(b)}return v}h([f,P,D],u){const b=this.b.get(f);return typeof b=="number"&&b>this.g.errors?Promise.resolve(!1):this.i(D,f,P,u).then(()=>!0,v=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' threw ERROR`),this.c.error(v),!(v instanceof Error)||v.message!=="concurrent_edits"){const g=this.b.get(f);this.b.set(f,g?g+1:1),typeof g=="number"&&g>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(f,P,D,u){const b=[],v=Date.now(),{document:g,reason:t}=u,{version:i}=g,r=Object.freeze({document:g,reason:t,waitUntil(c){if(Object.isFrozen(b))throw(0,F.$7)("waitUntil can not be called async");b.push(Promise.resolve(c))}});try{P.apply(D,[r])}catch(c){return Promise.reject(c)}return Object.freeze(b),new Promise((c,o)=>{const l=setTimeout(()=>o(new Error("timeout")),this.g.timeout);return Promise.all(b).then(n=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${f.identifier.value}' finished after ${Date.now()-v}ms`),clearTimeout(l),c(n)}).catch(n=>{clearTimeout(l),o(n)})}).then(c=>{const o={edits:[]};for(const l of c)if(Array.isArray(l)&&l.every(n=>n instanceof A.$IK))for(const{newText:n,newEol:s,range:a}of l)o.edits.push({resource:g.uri,versionId:void 0,textEdit:{range:a&&M.Range.from(a),text:n,eol:s&&M.EndOfLine.from(s)}});if(o.edits.length!==0)return i===g.version?this.f.$tryApplyWorkspaceEdit(o):Promise.reject(new Error("concurrent_edits"))})}}e.$Wec=$}),define(Ae[221],Re([1,0,13,2,8,7,76]),function(we,e,y,F,A,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ec=e.$2ec=void 0;class ${constructor(D,u,b,v){this.start=D,this.deletedCount=u,this.deletedItems=b,this.items=v}asApiEvent(){return{range:new M.$YL(this.start,this.start+this.deletedCount),addedCells:this.items.map(D=>D.apiCell),removedCells:this.deletedItems}}}class E{static asModelAddData(D,u){return{EOL:u.eol,lines:u.source,languageId:u.language,uri:u.uri,isDirty:!1,versionId:1,notebook:D}}constructor(D,u,b){this.notebook=D,this.h=u,this.j=b,this.handle=b.handle,this.uri=F.URI.revive(b.uri),this.cellKind=b.cellKind,this.a=b.outputs.map(A.NotebookCellOutput.to),this.e=b.internalMetadata??{},this.b=Object.freeze(b.metadata??{}),this.d=Object.freeze(A.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const D=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const b={get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:A.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return D.g},set mime(v){D.g=v},get outputs(){return D.a.slice(0)},get metadata(){return D.b},get executionSummary(){return D.d}};this.f=Object.freeze(b)}return this.f}setOutputs(D){this.a=D.map(A.NotebookCellOutput.to)}setOutputItems(D,u,b){const v=b.map(A.NotebookCellOutputItem.to),g=this.a.find(t=>t.id===D);if(g&&(u||(g.items.length=0),g.items.push(...v),g.items.length>1&&g.items.every(t=>R.$DI(t.mime)))){const t=new Map,i=[];g.items.forEach(r=>{let c;t.has(r.mime)?c=t.get(r.mime):(c=[],t.set(r.mime,c),i.push(r.mime)),c.push(r.data)}),g.items.length=0,i.forEach(r=>{const c=R.$EI(t.get(r));g.items.push({mime:r,data:c.data.buffer})})}}setMetadata(D){this.b=Object.freeze(D)}setInternalMetadata(D){this.e=D,this.d=Object.freeze(A.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.$2ec=E;class f{static{this.a=0}constructor(D,u,b,v,g){this.k=D,this.l=u,this.m=b,this.uri=v,this.handle=f.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=g.viewType,this.f=Object.freeze(g.metadata??Object.create(null)),this.r([[0,0,g.cells]],!0,void 0),this.g=g.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const D=this,u={get uri(){return D.uri},get version(){return D.g},get notebookType(){return D.d},get isDirty(){return D.h},get isUntitled(){return D.uri.scheme===y.Schemas.untitled},get isClosed(){return D.j},get metadata(){return D.f},get cellCount(){return D.b.length},cellAt(b){return b=D.n(b),D.b[b].apiCell},getCells(b){return(b?D.p(b):D.b).map(g=>g.apiCell)},save(){return D.q()}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(D){D.metadata&&(this.f=Object.freeze({...this.f,...D.metadata}))}acceptDirty(D){this.h=D}acceptModelChanged(D,u,b){this.g=D.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:b});const v={notebook:this.apiNotebook,metadata:b,cellChanges:[],contentChanges:[]},g=[];for(const i of D.rawEvents)i.kind===R.NotebookCellsChangeType.ModelChange?this.r(i.changes,!1,v.contentChanges):i.kind===R.NotebookCellsChangeType.Move?this.s(i.index,i.length,i.newIdx,v.contentChanges):i.kind===R.NotebookCellsChangeType.Output?(this.t(i.index,i.outputs),g.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===R.NotebookCellsChangeType.OutputItem?(this.u(i.index,i.outputId,i.append,i.outputItems),g.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(i.index,i.language),g.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document})):i.kind===R.NotebookCellsChangeType.ChangeCellContent?g.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document}):i.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(i.index,i.mime):i.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(i.index,i.metadata),g.push({cell:this.b[i.index].apiCell,metadata:this.b[i.index].apiCell.metadata})):i.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(i.index,i.internalMetadata),g.push({cell:this.b[i.index].apiCell,executionSummary:this.b[i.index].apiCell.executionSummary}));const t=new Map;for(let i=0;i<g.length;i++){const r=g[i],c=t.get(r.cell);if(c===void 0){const o=v.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...r});t.set(r.cell,o-1)}else v.cellChanges[c]={...v.cellChanges[c],...r}}return Object.freeze(v),Object.freeze(v.cellChanges),Object.freeze(v.contentChanges),v}n(D){return D=D|0,D<0?0:D>=this.b.length?this.b.length-1:D}o(D){let u=D.start|0,b=D.end|0;return u<0&&(u=0),b>this.b.length&&(b=this.b.length),D.with({start:u,end:b})}p(D){D=this.o(D);const u=[];for(let b=D.start;b<D.end;b++)u.push(this.b[b]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(D,u,b){if(this.j)return;const v=[],g=[],t=[];if(D.reverse().forEach(i=>{const c=i[2].map(n=>{const s=new E(this,this.l,n);return u||g.push(E.asModelAddData(this.apiNotebook,n)),s}),o=new $(i[0],i[1],[],c),l=this.b.splice(i[0],i[1],...c);for(const n of l)t.push(n.uri),o.deletedItems.push(n.apiCell);v.push(o)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:g,removedDocuments:t}),b)for(const i of v)b.push(i.asApiEvent())}s(D,u,b,v){const g=this.b.splice(D,u);this.b.splice(b,0,...g);const t=[new $(D,u,g.map(i=>i.apiCell),[]),new $(b,0,[],g)];for(const i of t)v.push(i.asApiEvent())}t(D,u){this.b[D].setOutputs(u)}u(D,u,b,v){this.b[D].setOutputItems(u,b,v)}v(D,u){const b=this.b[D];b.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(b.uri,u)}w(D,u){const b=this.b[D];b.apiCell.mime=u}x(D,u){this.b[D].setMetadata(u)}y(D,u){this.b[D].setInternalMetadata(u)}getCellFromApiCell(D){return this.b.find(u=>u.apiCell===D)}getCellFromIndex(D){return this.b[D]}getCell(D){return this.b.find(u=>u.handle===D)}getCellIndex(D){return this.b.indexOf(D)}}e.$3ec=f}),define(Ae[222],Re([1,0,5,2,8,7]),function(we,e,y,F,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gfc=void 0;class R{constructor(E,f,P,D={timeout:1500,errors:3}){this.b=E,this.c=f,this.d=P,this.f=D,this.a=new y.$Td}dispose(){}getOnWillSaveNotebookDocumentEvent(E){return(f,P,D)=>{const u=function(v){f.call(P,v)};return u.extension=E,this.a.event(u,void 0,D)}}async $participateInSave(E,f,P){const D=F.URI.revive(E),u=this.c.getNotebookDocument(D);if(!u)throw new Error("Unable to resolve notebook document");const b=[];if(await this.a.fireAsync({notebook:u.apiNotebook,reason:A.TextDocumentSaveReason.to(f)},P,async(g,t)=>{const i=Date.now(),r=await await Promise.resolve(g);Date.now()-i>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!P.isCancellationRequested&&r&&(r instanceof M.$LK?b.push(r):this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data"))}),P.isCancellationRequested)return!1;if(b.length===0)return!0;const v={edits:[]};for(const g of b){const{edits:t}=A.WorkspaceEdit.from(g);v.edits=v.edits.concat(t)}return this.d.$tryApplyWorkspaceEdit(v)}}e.$gfc=R}),define(Ae[107],Re([1,0,11,8,7]),function(we,e,y,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ec=void 0;class M{static{this.apiEditorsToExtHost=new WeakMap}constructor($,E,f,P,D,u){this.id=$,this.f=E,this.notebookData=f,this.a=[],this.b=[],this.d=!1,this.a=D,this.b=P,this.c=u}get apiEditor(){if(!this.e){const $=this;this.e={get notebook(){return $.notebookData.apiNotebook},get selection(){return $.a[0]},set selection(E){this.selections=[E]},get selections(){return $.a},set selections(E){if(!Array.isArray(E)||!E.every(A.$YL.isNotebookRange))throw(0,y.$6)("selections");$.a=E,$.g(E)},get visibleRanges(){return $.b},revealRange(E,f){$.f.$tryRevealRange($.id,F.NotebookRange.from(E),f??A.NotebookEditorRevealType.Default)},get viewColumn(){return $.c}},M.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility($){this.d=$}_acceptVisibleRanges($){this.b=$}_acceptSelections($){this.a=$}g($){this.f.$trySetSelections(this.id,$.map(F.NotebookRange.from))}_acceptViewColumn($){this.c=$}}e.$4ec=M}),define(Ae[223],Re([1,0,11,5,15,8]),function(we,e,y,F,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ifc=void 0;let R=class{constructor(E,f){this.c=E,this.d=f,this.a=new F.$Rd({onListenerError:y.$1}),this.b=new F.$Rd({onListenerError:y.$1}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(E,f){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",E,f);const P=this.d.getEditorById(E);f.visibleRanges&&P._acceptVisibleRanges(f.visibleRanges.ranges.map(M.NotebookRange.to)),f.selections&&P._acceptSelections(f.selections.selections.map(M.NotebookRange.to)),f.visibleRanges&&this.b.fire({notebookEditor:P.apiEditor,visibleRanges:P.apiEditor.visibleRanges}),f.selections&&this.a.fire(Object.freeze({notebookEditor:P.apiEditor,selections:P.apiEditor.selections}))}$acceptEditorViewColumns(E){for(const f in E)this.d.getEditorById(f)._acceptViewColumn(M.ViewColumn.to(E[f]))}};e.$ifc=R,e.$ifc=R=Ke([Ve(0,A.$dj)],R)}),define(Ae[224],Re([1,0,8,72,163,19,66,11]),function(we,e,y,F,A,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pfc=void 0;class E{constructor(u){this.b=0,this.c=new Map,this.a=u}async withProgress(u,b,v){const g=this.b++,{title:t,location:i,cancellable:r}=b,c={label:(0,A.localize)(0,null,u.displayName||u.name),id:u.identifier.value};return this.a.$startProgress(g,{location:y.ProgressLocation.from(i),title:t,source:c,cancellable:r},u.isUnderDevelopment?void 0:u.identifier.value).catch($.$1),this.d(g,v,!!r)}d(u,b,v){let g;v&&(g=new M.$2d,this.c.set(u,g));const t=r=>{this.a.$progressEnd(r),this.c.delete(r),g?.dispose()};let i;try{i=b(new P(this.a,u),v&&g?g.token:M.CancellationToken.None)}catch(r){throw t(u),r}return i.then(r=>t(u),r=>t(u)),i}$acceptProgressCanceled(u){const b=this.c.get(u);b&&(b.cancel(),this.c.delete(u))}}e.$pfc=E;function f(D,u){return D.message=u.message,typeof u.increment=="number"&&(typeof D.increment=="number"?D.increment+=u.increment:D.increment=u.increment),D}class P extends F.$$u{constructor(u,b){super(v=>this.throttledReport(v)),this.c=u,this.d=b}throttledReport(u){this.c.$progressReport(this.d,u)}}Ke([(0,R.$ph)(100,(D,u)=>f(D,u),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(Ae[108],Re([1,0,29,104,48,77,58,8,2]),function(we,e,y,F,A,M,R,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QM=e.$PM=e.$OM=e.$NM=void 0;const f=(c,o,l,n)=>{let s=o;return{enumerable:!0,configurable:!1,get(){return s},set(a){if(!l(s,a)){const d=s;s=a,c.listener?.(n(a,d))}}}},P=(c,o)=>c===o,D={range:(c,o)=>c===o?!0:!c||!o?!1:c.isEqual(o),label:P,description:P,sortText:P,busy:P,error:P,canResolveChildren:P,tags:(c,o)=>!(c.length!==o.length||c.some(l=>!o.find(n=>l.id===n.id)))},u=c=>o=>({op:4,update:c(o)}),b=(c,o)=>({range:(()=>{let l;const n=u(s=>({range:y.$zs.lift($.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return l},set(s){c.listener?.({op:6}),D.range(l,s)||(l=s,c.listener?.(n(s)))}}})(),label:f(c,o,D.label,u(l=>({label:l}))),description:f(c,void 0,D.description,u(l=>({description:l}))),sortText:f(c,void 0,D.sortText,u(l=>({sortText:l}))),canResolveChildren:f(c,!1,D.canResolveChildren,l=>({op:2,state:l})),busy:f(c,!1,D.busy,u(l=>({busy:l}))),error:f(c,void 0,D.error,u(l=>({error:$.MarkdownString.fromStrict(l)||null}))),tags:f(c,[],D.tags,(l,n)=>({op:1,new:l.map($.TestTag.from),old:n.map($.TestTag.from)}))}),v=c=>{const o=A.$sJ.fromString(c.extId),l=new t(o.controllerId,o.localId,c.label,E.URI.revive(c.uri)||void 0);return l.range=$.Range.to(c.range||void 0),l.description=c.description||void 0,l.sortText=c.sortText||void 0,l.tags=c.tags.map(n=>$.TestTag.to({id:(0,R.$xJ)(n).tagId})),l},g=c=>{let o;for(const l of c.tests){const n=v(l.item);(0,F.$xM)(n).parent=o,o=n}return o};e.$NM=g;class t{constructor(o,l,n,s){if(l.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(l)} symbol`);const a=(0,F.$wM)(this,o);Object.defineProperties(this,{id:{value:l,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof i?void 0:a.parent}},children:{value:(0,M.$vM)(a,F.$xM,t),enumerable:!0,writable:!1},...b(a,n)})}}e.$OM=t;class i extends t{constructor(o,l){super(o,o,l,void 0),this._isRoot=!0}}e.$PM=i;class r extends M.$rM{constructor(o,l,n){super({controllerId:o,getDocumentVersion:s=>s&&n.getDocument(s)?.version,getApiFor:F.$xM,getChildren:s=>s.children,root:new i(o,l),toITestItem:$.TestItem.from})}}e.$QM=r}),define(Ae[109],Re([1,0,53,11,89,8,7]),function(we,e,y,F,A,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KM=e.$JM=e.$IM=void 0;class ${static{this.c=new A.$GM("TextEditorDecorationType")}constructor(u,b,v){const g=$.c.nextId();u.$registerTextEditorDecorationType(b.identifier,g,M.DecorationRenderOptions.from(v)),this.value=Object.freeze({key:g,dispose(){u.$removeTextEditorDecorationType(g)}})}}e.$IM=$;class E{constructor(u,b){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=b.undoStopBefore,this.f=b.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,b){this.k();let v=null;if(u instanceof R.$CK)v=new R.$DK(u,u);else if(u instanceof R.$DK)v=u;else throw new Error("Unrecognized location");this.l(v,b,!1)}insert(u,b){this.k(),this.l(new R.$DK(u,u),b,!0)}delete(u){this.k();let b=null;if(u instanceof R.$DK)b=u;else throw new Error("Unrecognized location");this.l(b,null,!0)}l(u,b,v){const g=this.c.validateRange(u);this.g.push({range:g,text:b,forceMoveMarkers:v})}setEndOfLine(u){if(this.k(),u!==R.EndOfLine.LF&&u!==R.EndOfLine.CRLF)throw(0,F.$6)("endOfLine");this.h=u}}class f{constructor(u,b,v,g){this.c=u,this.d=b,this._accept(v),this.e=g;const t=this;this.value={get tabSize(){return t.f},set tabSize(i){t.m(i)},get indentSize(){return t.g},set indentSize(i){t.o(i)},get insertSpaces(){return t.h},set insertSpaces(i){t.q(i)},get cursorStyle(){return t.j},set cursorStyle(i){t.s(i)},get lineNumbers(){return t.k},set lineNumbers(i){t.t(i)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.insertSpaces,this.j=u.cursorStyle,this.k=M.TextEditorLineNumbersStyle.to(u.lineNumbers)}l(u){if(u==="auto")return"auto";if(typeof u=="number"){const b=Math.floor(u);return b>0?b:null}if(typeof u=="string"){const b=parseInt(u,10);return isNaN(b)?null:b>0?b:null}return null}m(u){const b=this.l(u);if(b!==null){if(typeof b=="number"){if(this.f===b)return;this.f=b}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:b}))}}n(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const b=Math.floor(u);return b>0?b:null}if(typeof u=="string"){const b=parseInt(u,10);return isNaN(b)?null:b>0?b:null}return null}o(u){const b=this.n(u);if(b!==null){if(typeof b=="number"){if(this.g===b)return;this.g=b}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:b}))}}p(u){return u==="auto"?"auto":u==="false"?!1:!!u}q(u){const b=this.p(u);if(typeof b=="boolean"){if(this.h===b)return;this.h=b}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:b}))}s(u){this.j!==u&&(this.j=u,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}t(u){this.k!==u&&(this.k=u,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:M.TextEditorLineNumbersStyle.from(u)})))}assign(u){const b={};let v=!1;if(typeof u.tabSize<"u"){const g=this.l(u.tabSize);g==="auto"?(v=!0,b.tabSize=g):typeof g=="number"&&this.f!==g&&(this.f=g,v=!0,b.tabSize=g)}if(typeof u.indentSize<"u"){const g=this.n(u.indentSize);g==="tabSize"?(v=!0,b.indentSize=g):typeof g=="number"&&this.g!==g&&(this.g=g,v=!0,b.indentSize=g)}if(typeof u.insertSpaces<"u"){const g=this.p(u.insertSpaces);g==="auto"?(v=!0,b.insertSpaces=g):this.h!==g&&(this.h=g,v=!0,b.insertSpaces=g)}typeof u.cursorStyle<"u"&&this.j!==u.cursorStyle&&(this.j=u.cursorStyle,v=!0,b.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.k!==u.lineNumbers&&(this.k=u.lineNumbers,v=!0,b.lineNumbers=M.TextEditorLineNumbersStyle.from(u.lineNumbers)),v&&this.u("setOptions",this.c.$trySetOptions(this.d,b))}u(u,b){b.catch(v=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn(v)})}}e.$JM=f;class P{constructor(u,b,v,g,t,i,r,c){this.id=u,this.j=b,this.k=v,this.g=!1,this.h=new Set,this.c=t,this.d=new f(this.j,this.id,i,v),this.e=r,this.f=c;const o=this;this.value=Object.freeze({get document(){return g.value},set document(l){throw new F.$8("document")},get selection(){return o.c&&o.c[0]},set selection(l){if(!(l instanceof R.$EK))throw(0,F.$6)("selection");o.c=[l],o.l()},get selections(){return o.c},set selections(l){if(!Array.isArray(l)||l.some(n=>!(n instanceof R.$EK)))throw(0,F.$6)("selections");o.c=l,o.l()},get visibleRanges(){return o.e},set visibleRanges(l){throw new F.$8("visibleRanges")},get options(){return o.d.value},set options(l){o.g||o.d.assign(l)},get viewColumn(){return o.f},set viewColumn(l){throw new F.$8("viewColumn")},edit(l,n={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new E(g.value,n);return l(s),o.m(s)},insertSnippet(l,n,s={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!n||Array.isArray(n)&&n.length===0)a=o.c.map(d=>M.Range.from(d));else if(n instanceof R.$CK){const{lineNumber:d,column:p}=M.Position.from(n);a=[{startLineNumber:d,startColumn:p,endLineNumber:d,endColumn:p}]}else if(n instanceof R.$DK)a=[M.Range.from(n)];else{a=[];for(const d of n)if(d instanceof R.$DK)a.push(M.Range.from(d));else{const{lineNumber:p,column:m}=M.Position.from(d);a.push({startLineNumber:p,startColumn:m,endLineNumber:p,endColumn:m})}}return b.$tryInsertSnippet(u,g.value.version,l.value,a,s)},setDecorations(l,n){const s=n.length===0;s&&!o.h.has(l.key)||(s?o.h.delete(l.key):o.h.add(l.key),o.n(()=>{if(M.$yM(n))return b.$trySetDecorations(u,l.key,M.$zM(n));{const a=new Array(4*n.length);for(let d=0,p=n.length;d<p;d++){const m=n[d];a[4*d]=m.start.line+1,a[4*d+1]=m.start.character+1,a[4*d+2]=m.end.line+1,a[4*d+3]=m.end.character+1}return b.$trySetDecorationsFast(u,l.key,a)}}))},revealRange(l,n){o.n(()=>b.$tryRevealRange(u,M.Range.from(l),n||R.TextEditorRevealType.Default))},show(l){b.$tryShowEditor(u,M.ViewColumn.from(l))},hide(){b.$tryHideEditor(u)}})}dispose(){(0,y.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,y.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,y.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,y.ok)(!this.g),this.f=u}_acceptSelections(u){(0,y.ok)(!this.g),this.c=u}async l(){const u=this.c.map(M.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const b=u.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const v=b.edits.map(t=>t.range);v.sort((t,i)=>t.end.line===i.end.line?t.end.character===i.end.character?t.start.line===i.start.line?t.start.character-i.start.character:t.start.line-i.start.line:t.end.character-i.end.character:t.end.line-i.end.line);for(let t=0,i=v.length-1;t<i;t++){const r=v[t].end;if(v[t+1].start.isBefore(r))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const g=b.edits.map(t=>({range:M.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,b.documentVersionId,g,{setEndOfLine:typeof b.setEndOfLine=="number"?M.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this.k.warn(b),null))}}e.$KM=P}),define(Ae[225],Re([1,0,167,25,2,5,6,205,14,7,16,18,8,52,19,132,23]),function(we,e,y,F,A,M,R,$,E,f,P,D,u,b,v,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ifc=void 0;function i(o,l){if((0,P.$Cf)(o))return{label:o};if(o&&typeof o=="object"&&typeof o.label=="string"){let n;return Array.isArray(o.highlights)&&(n=o.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),n=n.length?n:void 0),{label:o.label,highlights:n}}}class r extends R.$Rc{constructor(l,n,s){super(),this.f=l,this.g=n,this.h=s,this.a=new Map,this.b=new g.$R7;function a(d){return d&&d.$treeViewId&&(d.$treeItemHandle||d.$selectedTreeItems||d.$focusedTreeItem)}n.registerArgumentProcessor({processArgument:d=>a(d)?this.r(d):Array.isArray(d)&&d.length>0?d.map(p=>a(p)?this.r(p):p):d})}registerTreeDataProvider(l,n,s){const a=this.createTreeView(l,{treeDataProvider:n},s);return{dispose:()=>a.dispose()}}createTreeView(l,n,s){if(!n||!n.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=n.dragAndDropController?.dropMimeTypes??[],d=n.dragAndDropController?.dragMimeTypes??[],p=!!n.dragAndDropController?.handleDrag,m=!!n.dragAndDropController?.handleDrop,S=this.m(l,n,s),k={showCollapseAll:!!n.showCollapseAll,canSelectMany:!!n.canSelectMany,dropMimeTypes:a,dragMimeTypes:d,hasHandleDrag:p,hasHandleDrop:m,manuallyManageCheckboxes:!!n.manageCheckboxStateManually},h=this.f.$registerTreeViewDataProvider(l,k),w={get onDidCollapseElement(){return S.onDidCollapseElement},get onDidExpandElement(){return S.onDidExpandElement},get selection(){return S.selectedElements},get onDidChangeSelection(){return S.onDidChangeSelection},get activeItem(){return(0,t.$NF)(s,"treeViewActiveItem"),S.focusedElement},get onDidChangeActiveItem(){return(0,t.$NF)(s,"treeViewActiveItem"),S.onDidChangeActiveItem},get visible(){return S.visible},get onDidChangeVisibility(){return S.onDidChangeVisibility},get onDidChangeCheckboxState(){return S.onDidChangeCheckboxState},get message(){return S.message},set message(I){(0,b.$$j)(I)&&(0,t.$NF)(s,"treeViewMarkdownMessage"),S.message=I},get title(){return S.title},set title(I){S.title=I},get description(){return S.description},set description(I){S.description=I},get badge(){return S.badge},set badge(I){I!==void 0&&f.ViewBadge.isViewBadge(I)?S.badge={value:Math.floor(Math.abs(I.value)),tooltip:I.tooltip}:I===void 0&&(S.badge=void 0)},reveal:(I,L)=>S.reveal(I,L),dispose:async()=>{await h,this.a.delete(l),S.dispose()}};return this.B(w),w}$getChildren(l,n){const s=this.a.get(l);return s?s.getChildren(n):Promise.reject(new $.$KE(l))}async $handleDrop(l,n,s,a,d,p,m,S){const k=this.a.get(l);if(!k)return Promise.reject(new $.$KE(l));const h=u.DataTransfer.toDataTransfer(s,async w=>(await this.f.$resolveDropFileData(l,n,w)).buffer);return m===l&&S&&await this.j(h,k,S,d,p),k.onDrop(h,a,d)}async j(l,n,s,a,d){const p=this.b.removeDragOperationTransfer(d);if(p)(await p)?.forEach((m,S)=>{m&&l.set(S,m)});else if(d&&n.handleDrag){const m=n.handleDrag(s,l,a);this.b.addDragOperationTransfer(d,m),await m}return l}async $handleDrag(l,n,s,a){const d=this.a.get(l);if(!d)return Promise.reject(new $.$KE(l));const p=await this.j(new f.$sL,d,n,a,s);if(!(!p||a.isCancellationRequested))return u.DataTransfer.from(p)}async $hasResolve(l){const n=this.a.get(l);if(!n)throw new $.$KE(l);return n.hasResolve}$resolve(l,n,s){const a=this.a.get(l);if(!a)throw new $.$KE(l);return a.resolveTreeItem(n,s)}$setExpanded(l,n,s){const a=this.a.get(l);if(!a)throw new $.$KE(l);a.setExpanded(n,s)}$setSelectionAndFocus(l,n,s){const a=this.a.get(l);if(!a)throw new $.$KE(l);a.setSelectionAndFocus(n,s)}$setVisible(l,n){const s=this.a.get(l);if(!s){if(!n)return;throw new $.$KE(l)}s.setVisible(n)}$changeCheckboxState(l,n){const s=this.a.get(l);if(!s)throw new $.$KE(l);s.setCheckboxState(n)}m(l,n,s){const a=this.B(new c(l,n,this.f,this.g.converter,this.h,s));return this.a.set(l,a),a}r(l){const n=this.a.get(l.$treeViewId);return n&&"$treeItemHandle"in l?n.getExtensionElement(l.$treeItemHandle):n&&"$focusedTreeItem"in l&&l.$focusedTreeItem?n.focusedElement:null}}e.$Ifc=r;class c extends R.$Rc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(l=>this.getExtensionElement(l)).filter(l=>!(0,P.$Lf)(l))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(l,n,s,a,d,p){if(super(),this.I=l,this.J=s,this.L=a,this.M=d,this.N=p,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new M.$Rd),this.onDidExpandElement=this.u.event,this.w=this.B(new M.$Rd),this.onDidCollapseElement=this.w.event,this.y=this.B(new M.$Rd),this.onDidChangeSelection=this.y.event,this.z=this.B(new M.$Rd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new M.$Rd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new M.$Rd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new M.$Rd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new v.$2d,p.contributes&&p.contributes.views)for(const h in p.contributes.views)for(const w of p.contributes.views[h])w.id===l&&(this.P=w.name);this.f=n.treeDataProvider,this.g=n.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(h=>this.F.fire({message:!1,element:h})));let m,S;const k=M.Event.debounce(this.F.event,(h,w)=>(h||(h={message:!1,elements:[]}),w.element!==!1&&(m||(m=new Promise(I=>S=I),this.G=this.G.then(()=>m)),Array.isArray(w.element)?h.elements.push(...w.element):h.elements.push(w.element)),w.message&&(h.message=!0),h),200,!0);this.B(k(({message:h,elements:w})=>{w.length&&(this.H=this.H.then(()=>{const I=S;return m=null,this.$(w).then(()=>I())})),h&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(l){const n=l?this.getExtensionElement(l):void 0;if(l&&!n)return this.M.error(`No tree item with id '${l}' found.`),Promise.resolve([]);let s=this.X(l);return s||(s=await this.Y(n)),s?s.map(a=>a.item):void 0}getExtensionElement(l){return this.j.get(l)}reveal(l,n){n=n||{select:!0,focus:!1};const s=(0,P.$Lf)(n.select)?!0:n.select,a=(0,P.$Lf)(n.focus)?!1:n.focus,d=(0,P.$Lf)(n.expand)?!1:n.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):l?this.G.then(()=>this.S(l)).then(p=>this.W(l,p[p.length-1]).then(m=>this.J.$reveal(this.I,{item:m.item,parentChain:p.map(S=>S.item)},{select:s,focus:a,expand:d})),p=>this.M.error(p)):this.J.$reveal(this.I,void 0,{select:s,focus:a,expand:d})}get message(){return this.O}set message(l){this.O=l,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(l){this.P=l,this.J.$setTitle(this.I,l,this.Q)}get description(){return this.Q}set description(l){this.Q=l,this.J.$setTitle(this.I,this.P,l)}get badge(){return this.R}set badge(l){this.R?.value===l?.value&&this.R?.tooltip===l?.tooltip||(this.R=u.ViewBadge.from(l),this.J.$setBadge(this.I,l))}setExpanded(l,n){const s=this.getExtensionElement(l);s&&(n?this.u.fire(Object.freeze({element:s})):this.w.fire(Object.freeze({element:s})))}setSelectionAndFocus(l,n){const s=!(0,D.$tb)(this.s,l);this.s=l;const a=this.t!==n;this.t=n,s&&this.y.fire(Object.freeze({selection:this.selectedElements})),a&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(l){l!==this.r&&(this.r=l,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(l){const n=(await Promise.all(l.map(async s=>{const a=this.getExtensionElement(s.treeItemHandle);return a?{extensionItem:a,treeItem:await this.f.getTreeItem(a),newState:s.newState?f.TreeItemCheckboxState.Checked:f.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);n.forEach(s=>{s.treeItem.checkboxState=s.newState?f.TreeItemCheckboxState.Checked:f.TreeItemCheckboxState.Unchecked}),this.D.fire({items:n.map(s=>[s.extensionItem,s.newState])})}async handleDrag(l,n,s){const a=[];for(const d of l){const p=this.getExtensionElement(d);p&&a.push(p)}if(!(!this.g?.handleDrag||a.length===0))return await this.g.handleDrag(a,n,s),n}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(l,n,s){const a=n?this.getExtensionElement(n):void 0;if(!(!a&&n||!this.g?.handleDrop))return(0,E.$Qg)(()=>this.g?.handleDrop?this.g.handleDrop(a,l,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(l,n){if(!this.f.resolveTreeItem)return;const s=this.j.get(l);if(s){const a=this.m.get(s);if(a){const d=await this.f.resolveTreeItem(a.extensionItem,s,n)??a.extensionItem;return this.hb(d),a.item.tooltip=this.eb(d.tooltip),a.item.command=this.fb(a.disposableStore,d.command),a.item}}}S(l){return this.U(l).then(n=>n?this.S(n).then(s=>this.W(n,s[s.length-1]).then(a=>(s.push(a),s))):Promise.resolve([]))}U(l){const n=this.m.get(l);return n?Promise.resolve(n.parent?this.j.get(n.parent.item.handle):void 0):(0,E.$Qg)(()=>this.f.getParent(l))}W(l,n){const s=this.m.get(l);return s?Promise.resolve(s):(0,E.$Qg)(()=>this.f.getTreeItem(l)).then(a=>this.kb(l,a,n,!0)).then(a=>this.getChildren(n?n.item.handle:void 0).then(()=>{const d=this.getExtensionElement(a);if(d){const p=this.m.get(d);if(p)return Promise.resolve(p)}throw new Error(`Cannot resolve tree item for element ${a} from extension ${this.N.identifier.value}`)}))}X(l){if(l){let n;if(typeof l=="string"){const s=this.getExtensionElement(l);n=s?this.m.get(s):void 0}else n=l;return n&&n.children||void 0}return this.h}async Y(l){this.rb(l);const n=new v.$2d(this.Z.token);try{const s=l?this.m.get(l):void 0,a=await this.f.getChildren(l);if(n.token.isCancellationRequested)return;const d=await Promise.all((0,D.$Gb)(a||[]).map(async p=>{const m=await this.f.getTreeItem(p);return m&&!n.token.isCancellationRequested?this.db(p,m,s):null}));return n.token.isCancellationRequested?void 0:(0,D.$Gb)(d)}finally{n.dispose()}}$(l){if(l.some(s=>!s))return this.Z.dispose(!0),this.Z=new v.$2d,this.tb(),this.J.$refresh(this.I);{const s=this.ab(l);if(s.length)return this.bb(s)}return Promise.resolve(void 0)}ab(l){const n=new Set,s=l.map(d=>this.m.get(d));for(const d of s)if(d&&!n.has(d.item.handle)){let p=d;for(;p&&p.parent&&s.findIndex(m=>p&&p.parent&&m&&m.item.handle===p.parent.item.handle)===-1;){const m=this.j.get(p.parent.item.handle);p=m?this.m.get(m):void 0}p&&!p.parent&&n.add(d.item.handle)}const a=[];return n.forEach(d=>{const p=this.j.get(d);if(p){const m=this.m.get(p);m&&(!m.parent||!n.has(m.parent.item.handle))&&a.push(d)}}),a}bb(l){const n={};return Promise.all(l.map(s=>this.cb(s).then(a=>{a&&(n[s]=a.item)}))).then(()=>Object.keys(n).length?this.J.$refresh(this.I,n):void 0)}cb(l){const n=this.getExtensionElement(l);if(n){const s=this.m.get(n);if(s)return this.rb(n),(0,E.$Qg)(()=>this.f.getTreeItem(n)).then(a=>{if(a){const d=this.ib(n,a,s.parent);return this.pb(n,d,s,s.parent),s.dispose(),d}return null})}return Promise.resolve(null)}db(l,n,s){const a=this.ib(l,n,s);if(n.id&&this.j.has(a.item.handle))throw new Error((0,y.localize)(0,null,n.id));return this.ob(l,a),this.qb(a,s),a}eb(l){return f.$2K.isMarkdownString(l)?u.MarkdownString.from(l):l}fb(l,n){return n?{...this.L.toInternal(n,l),originalId:n.command}:void 0}gb(l){if(l.checkboxState===void 0)return;let n,s,a;return typeof l.checkboxState=="number"?n=l.checkboxState:(n=l.checkboxState.state,s=l.checkboxState.tooltip,a=l.checkboxState.accessibilityInformation),{isChecked:n===f.TreeItemCheckboxState.Checked,tooltip:s,accessibilityInformation:a}}hb(l){if(!f.$nL.isTreeItem(l,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(l,n,s){this.hb(n);const a=this.B(new R.$Qc),d=this.kb(l,n,s),p=this.lb(n);return{item:{handle:d,parentHandle:s?s.item.handle:void 0,label:i(n.label,this.N),description:n.description,resourceUri:n.resourceUri,tooltip:this.eb(n.tooltip),command:this.fb(a,n.command),contextValue:n.contextValue,icon:p,iconDark:this.mb(n)||p,themeIcon:this.jb(n),collapsibleState:(0,P.$Lf)(n.collapsibleState)?f.TreeItemCollapsibleState.None:n.collapsibleState,accessibilityInformation:n.accessibilityInformation,checkbox:this.gb(n)},extensionItem:n,parent:s,children:void 0,disposableStore:a,dispose(){a.dispose()}}}jb(l){return l.iconPath instanceof f.$vL?l.iconPath:void 0}kb(l,{id:n,label:s,resourceUri:a},d,p){if(n)return`${c.b}/${n}`;const m=i(s,this.N),S=d?d.item.handle:c.a;let k=m?m.label:a?(0,F.$wg)(a):"";k=k.indexOf("/")!==-1?k.replace("/","//"):k;const h=this.m.has(l)?this.m.get(l).item.handle:void 0,w=this.X(d)||[];let I,L=0;do{if(I=`${S}/${L}:${k}`,p||!this.j.has(I)||h===I)break;L++}while(L<=w.length);return I}lb(l){if(l.iconPath&&!(l.iconPath instanceof f.$vL))return typeof l.iconPath=="string"||A.URI.isUri(l.iconPath)?this.nb(l.iconPath):this.nb(l.iconPath.light)}mb(l){if(l.iconPath&&!(l.iconPath instanceof f.$vL)&&l.iconPath.dark)return this.nb(l.iconPath.dark)}nb(l){return A.URI.isUri(l)?l:A.URI.file(l)}ob(l,n){this.j.set(n.item.handle,l),this.m.set(l,n)}pb(l,n,s,a){this.j.delete(n.item.handle),this.m.delete(l),n.item.handle!==s.item.handle&&this.j.delete(s.item.handle),this.ob(l,n);const d=this.X(a)||[],p=d.filter(m=>m.item.handle===s.item.handle)[0];p&&d.splice(d.indexOf(p),1,n)}qb(l,n){n?(n.children||(n.children=[]),n.children.push(l)):(this.h||(this.h=[]),this.h.push(l))}rb(l){if(l){const n=this.m.get(l);if(n){if(n.children)for(const s of n.children){const a=this.j.get(s.item.handle);a&&this.sb(a)}n.children=void 0}}else this.tb()}sb(l){const n=this.m.get(l);if(n){if(n.children)for(const s of n.children){const a=this.j.get(s.item.handle);a&&this.sb(a)}this.m.delete(l),this.j.delete(n.item.handle),n.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(l=>l.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ae[226],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmInputBoxActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxActionButton.d.ts",scmInputBoxValueProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxValueProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ae[227],Re([1,0,179,11,31,96,73,30,22,226,189,101]),function(we,e,y,F,A,M,R,$,E,f,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=void 0;const u=$.$mn.as(R.$nn.JSONContribution);class b{constructor(l,n,s){this.a=l,this.b=n,this.c=s}d(l,n){this.a({type:l,message:n,extensionId:this.b.identifier,extensionPointId:this.c})}error(l){this.d(A.default.Error,l)}warn(l){this.d(A.default.Warning,l)}info(l){this.d(A.default.Info,l)}}e.$TF=b;class v{static a(l){const n=new E.$am;for(let s=0,a=l.length;s<a;s++)n.add(l[s].description.identifier);return n}static compute(l,n){if(!l||!l.length)return new v(n,[]);if(!n||!n.length)return new v([],l);const s=this.a(l),a=this.a(n),d=n.filter(m=>!s.has(m.description.identifier)),p=l.filter(m=>!a.has(m.description.identifier));return new v(d,p)}constructor(l,n){this.added=l,this.removed=n}}e.$UF=v;class g{constructor(l,n){this.name=l,this.defaultExtensionKind=n,this.a=null,this.b=null,this.c=null}setHandler(l){if(this.a!==null)throw new Error("Handler already set!");this.a=l,this.d()}acceptUsers(l){this.c=v.compute(this.b,l),this.b=l,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(l){(0,F.$Z)(l)}}}e.$VF=g;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[y.localize(0,null),y.localize(1,null)]},i="vscode://schemas/vscode-extensions";e.$WF={properties:{engines:{type:"object",description:y.localize(2,null),properties:{vscode:{type:"string",description:y.localize(3,null),default:"^1.22.0"}}},publisher:{description:y.localize(4,null),type:"string"},displayName:{description:y.localize(5,null),type:"string"},categories:{description:y.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:E.$$l},{type:"string",const:"Languages",deprecationMessage:y.localize(7,null)}]}},galleryBanner:{type:"object",description:y.localize(8,null),properties:{color:{description:y.localize(9,null),type:"string"},theme:{description:y.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:y.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:y.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:y.localize(13,null)},enabledApiProposals:{markdownDescription:y.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(f.allApiProposals),markdownEnumDescriptions:Object.values(f.allApiProposals)}},api:{markdownDescription:y.localize(15,null),type:"string",enum:["none"],enumDescriptions:[y.localize(16,null)]},activationEvents:{description:y.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:y.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:y.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:y.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:y.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:y.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:y.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:y.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:y.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:y.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:y.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:y.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:y.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:y.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:y.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:y.localize(32,null)},{label:"onUri",body:"onUri",description:y.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:y.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:y.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:y.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:y.localize(37,null)},{label:"onRenderer",description:y.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:y.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:y.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:y.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:y.localize(42,null)},{label:"*",description:y.localize(43,null),body:"*"}]}},badges:{type:"array",description:y.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:y.localize(45,null)},href:{type:"string",description:y.localize(46,null)},description:{type:"string",description:y.localize(47,null)}}}},markdown:{type:"string",description:y.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:y.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:y.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$4n}},extensionPack:{description:y.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$4n}},extensionKind:{description:y.localize(52,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:y.localize(53,null)},{body:["workspace"],description:y.localize(54,null)},{body:["ui","workspace"],description:y.localize(55,null)},{body:["workspace","ui"],description:y.localize(56,null)},{body:[],description:y.localize(57,null)}]},capabilities:{description:y.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:y.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:y.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[y.localize(61,null),y.localize(62,null),y.localize(63,null)]},description:{type:"string",markdownDescription:y.localize(64,null)}}},untrustedWorkspaces:{description:y.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:y.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[y.localize(67,null),y.localize(68,null),y.localize(69,null)]},restrictedConfigurations:{description:y.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:y.localize(71,null)}}}}},sponsor:{description:y.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:y.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:y.localize(74,null),type:"string"},"vscode:uninstall":{description:y.localize(75,null),type:"string"}}},icon:{type:"string",description:y.localize(76,null)},l10n:{type:"string",description:y.localize(77,null)},pricing:{type:"string",markdownDescription:y.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class r{constructor(){this.a=new Map}registerExtensionPoint(l){if(this.a.has(l.extensionPoint))throw new Error("Duplicate extension point: "+l.extensionPoint);const n=new g(l.extensionPoint,l.defaultExtensionKind);return this.a.set(l.extensionPoint,n),l.activationEventsGenerator&&D.$yF.register(l.extensionPoint,l.activationEventsGenerator),e.$WF.properties.contributes.properties[l.extensionPoint]=l.jsonSchema,u.registerSchema(i,e.$WF),n}getExtensionPoints(){return Array.from(this.a.values())}}e.$XF=r;const c={ExtensionsRegistry:"ExtensionsRegistry"};$.$mn.add(c.ExtensionsRegistry,new r),e.$YF=$.$mn.as(c.ExtensionsRegistry),u.registerSchema(i,e.$WF),u.registerSchema(P.$wj,{properties:{extensionEnabledApiProposals:{description:y.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(f.allApiProposals),markdownEnumDescriptions:Object.values(f.allApiProposals)}}]}}}})}),define(Ae[228],Re([1,0,175,16,26,227,34,5]),function(we,e,y,F,A,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8F=void 0;const E={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:y.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:y.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:y.localize(2,null),default:""}}};var f;(function(u){function b(v,g,t){if(!v)return;const i=F.$Cf(v.type)?v.type:void 0;if(!i||i.length===0){t.error(y.localize(3,null));return}const r=[];if(Array.isArray(v.required))for(const c of v.required)F.$Cf(c)&&r.push(c);return{extensionId:g.value,taskType:i,required:r,properties:v.properties?A.$an(v.properties):{},when:v.when?R.$Ti.deserialize(v.when):void 0}}u.from=b})(f||(f={}));const P=M.$YF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,b)=>{for(const v of u)v.type&&b.push(`onTaskType:${v.type}`)},jsonSchema:{description:y.localize(4,null),type:"array",items:E}});class D{constructor(){this.d=new $.$Rd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((b,v)=>{P.setHandler((g,t)=>{this.c=void 0;try{for(const i of t.removed){const r=i.value;for(const c of r)this.a&&c.type&&this.a[c.type]&&delete this.a[c.type]}for(const i of t.added){const r=i.value;for(const c of r){const o=f.from(c,i.description.identifier,i.collector);o&&(this.a[o.taskType]=o)}}(t.removed.length>0||t.added.length>0)&&this.d.fire()}catch{}b(void 0)})})}onReady(){return this.b}get(b){return this.a[b]}all(){return Object.keys(this.a).map(b=>this.a[b])}getJsonSchema(){if(this.c===void 0){const b=[];for(const v of this.all()){const g={type:"object",additionalProperties:!1};v.required.length>0&&(g.required=v.required.slice(0)),v.properties!==void 0?g.properties=A.$an(v.properties):g.properties=Object.create(null),g.properties.type={type:"string",enum:[v.taskType]},b.push(g)}this.c={oneOf:b}}return this.c}}e.$8F=new D}),define(Ae[229],Re([1,0,176,16,25,26,34,228]),function(we,e,y,F,A,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$fG=e.JsonSchemaVersion=e.ExecutionEngine=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$_F=e.ShellQuoting=e.$$F=e.$0F=e.$9F=void 0,e.$9F="settings",e.$0F=new R.$aj("taskRunning",!1,y.localize(0,null)),e.$$F={value:y.localize(1,null),original:"Tasks"};var E;(function(C){C[C.Escape=1]="Escape",C[C.Strong=2]="Strong",C[C.Weak=3]="Weak"})(E||(e.ShellQuoting=E={})),e.$_F="$customized",function(C){function T(G){if(!G)return C.Strong;switch(G.toLowerCase()){case"escape":return C.Escape;case"strong":return C.Strong;case"weak":return C.Weak;default:return C.Strong}}C.from=T}(E||(e.ShellQuoting=E={}));var f;(function(C){C.defaults={cwd:"${workspaceFolder}"}})(f||(e.CommandOptions=f={}));var P;(function(C){C[C.Always=1]="Always",C[C.Silent=2]="Silent",C[C.Never=3]="Never"})(P||(e.RevealKind=P={})),function(C){function T(G){switch(G.toLowerCase()){case"always":return C.Always;case"silent":return C.Silent;case"never":return C.Never;default:return C.Always}}C.fromString=T}(P||(e.RevealKind=P={}));var D;(function(C){C[C.Never=1]="Never",C[C.OnProblem=2]="OnProblem",C[C.Always=3]="Always"})(D||(e.RevealProblemKind=D={})),function(C){function T(G){switch(G.toLowerCase()){case"always":return C.Always;case"never":return C.Never;case"onproblem":return C.OnProblem;default:return C.OnProblem}}C.fromString=T}(D||(e.RevealProblemKind=D={}));var u;(function(C){C[C.Shared=1]="Shared",C[C.Dedicated=2]="Dedicated",C[C.New=3]="New"})(u||(e.PanelKind=u={})),function(C){function T(G){switch(G.toLowerCase()){case"shared":return C.Shared;case"dedicated":return C.Dedicated;case"new":return C.New;default:return C.Shared}}C.fromString=T}(u||(e.PanelKind=u={}));var b;(function(C){C.defaults={echo:!0,reveal:P.Always,revealProblems:D.Never,focus:!1,panel:u.Shared,showReuseMessage:!0,clear:!1}})(b||(e.PresentationOptions=b={}));var v;(function(C){C[C.Shell=1]="Shell",C[C.Process=2]="Process",C[C.CustomExecution=3]="CustomExecution"})(v||(e.RuntimeType=v={})),function(C){function T(de){switch(de.toLowerCase()){case"shell":return C.Shell;case"process":return C.Process;case"customExecution":return C.CustomExecution;default:return C.Process}}C.fromString=T;function G(de){switch(de){case C.Shell:return"shell";case C.Process:return"process";case C.CustomExecution:return"customExecution";default:return"process"}}C.toString=G}(v||(e.RuntimeType=v={}));var g;(function(C){function T(G){return F.$Cf(G)?G:G.value}C.value=T})(g||(e.CommandString=g={}));var t;(function(C){C.Clean={_id:"clean",isDefault:!1},C.Build={_id:"build",isDefault:!1},C.Rebuild={_id:"rebuild",isDefault:!1},C.Test={_id:"test",isDefault:!1};function T(de){return de===C.Clean._id||de===C.Build._id||de===C.Rebuild._id||de===C.Test._id}C.is=T;function G(de){if(de!==void 0)return F.$Cf(de)?T(de)?{_id:de,isDefault:!1}:void 0:de}C.from=G})(t||(e.TaskGroup=t={}));var i;(function(C){C[C.Global=1]="Global",C[C.Workspace=2]="Workspace",C[C.Folder=3]="Folder"})(i||(e.TaskScope=i={}));var r;(function(C){C.Workspace="workspace",C.Extension="extension",C.InMemory="inMemory",C.WorkspaceFile="workspaceFile",C.User="user";function T(G){switch(G){case C.User:return 2;case C.WorkspaceFile:return 5;default:return 6}}C.toConfigurationTarget=T})(r||(e.TaskSourceKind=r={}));var c;(function(C){C.parallel="parallel",C.sequence="sequence"})(c||(e.DependsOrder=c={}));var o;(function(C){C[C.default=1]="default",C[C.folderOpen=2]="folderOpen"})(o||(e.RunOnOptions=o={}));var l;(function(C){C.defaults={reevaluateOnRerun:!0,runOn:o.default,instanceLimit:1}})(l||(e.RunOptions=l={}));class n{constructor(T,G,de,me,De,ke){this._label="",this._id=T,G&&(this._label=G),de&&(this.type=de),this.runOptions=me,this.configurationProperties=De,this._source=ke}getDefinition(T){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const T={folder:this.d(),id:this._id};return JSON.stringify(T)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(T,G=!1){if(T===void 0)return!1;if(F.$Cf(T))return T===this._label||T===this.configurationProperties.identifier||G&&T===this._id;const de=this.getDefinition(!0);return de!==void 0&&de._key===T._key}getQualifiedLabel(){const T=this.getWorkspaceFolder();return T?`${this._label} (${T.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(T){this.c===void 0&&(this.c=[]),T&&(this.c=this.c.concat(T))}get taskLoadMessages(){return this.c}}e.$aG=n;class s extends n{constructor(T,G,de,me,De,ke,le,pe){super(T,de,void 0,le,pe,G),this.command={},this._source=G,this.hasDefinedMatchers=ke,De&&(this.command=De)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(T=!1){if(T&&this._source.customizes!==void 0)return this._source.customizes;{let G;switch(this.command?this.command.runtime:void 0){case v.Shell:G="shell";break;case v.Process:G="process";break;case v.CustomExecution:G="customExecution";break;case void 0:G="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:G,_key:this._id,id:this._id}}}static is(T){return T instanceof s}getMapKey(){const T=this._source.config.workspaceFolder;return T?`${T.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===r.User?e.$9F:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const T=this.d();if(!T)return;let G=this.configurationProperties.identifier;this._source.kind!==r.Workspace&&(G+=this._source.kind);const de={type:e.$_F,folder:T,id:G};return JSON.stringify(de)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?A.$wg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(T){return new s(T._id,T._source,T._label,T.type,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.$bG=s;class a extends n{constructor(T,G,de,me,De,ke,le){super(T,de,me,ke,le,G),this._source=G,this.configures=De}static is(T){return T instanceof a}f(T){return T}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?A.$wg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===r.User?e.$9F:this._source.config.workspaceFolder?.uri.toString()}getKey(){const T=this.d();if(!T)return;let G=this.configurationProperties.identifier;this._source.kind!==r.Workspace&&(G+=this._source.kind);const de={type:e.$_F,folder:T,id:G};return JSON.stringify(de)}}e.$cG=a;class d extends n{constructor(T,G,de,me,De,ke,le,pe,re){super(T,de,me,pe,re,G),this.defines=De,this.hasDefinedMatchers=le,this.command=ke,this.icon=re.icon,this.hide=re.hide}clone(){return new d(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(T){return T instanceof d}getMapKey(){const T=this._source.workspaceFolder;return T?`${this._source.scope.toString()}|${T.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const T={type:"contributed",scope:this._source.scope,id:this._id};return T.folder=this.d(),JSON.stringify(T)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(T){return new d(T._id,T._source,T._label,T.type,T.defines,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.$dG=d;class p extends n{constructor(T,G,de,me,De,ke){super(T,de,me,De,ke,G),this._source=G}clone(){return new p(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(T){return T instanceof p}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(T){return new p(T._id,T._source,T._label,T.type,T.runOptions,T.configurationProperties)}}e.$eG=p;var m;(function(C){C[C.Process=1]="Process",C[C.Terminal=2]="Terminal"})(m||(e.ExecutionEngine=m={})),function(C){C._default=C.Terminal}(m||(e.ExecutionEngine=m={}));var S;(function(C){C[C.V0_1_0=1]="V0_1_0",C[C.V2_0_0=2]="V2_0_0"})(S||(e.JsonSchemaVersion=S={}));class k{constructor(T){this.c=new Map;for(let G=0;G<T.length;G++)this.c.set(T[G].uri.toString(),G)}compare(T,G){const de=T.getWorkspaceFolder(),me=G.getWorkspaceFolder();if(de&&me){let De=this.c.get(de.uri.toString());De=De===void 0?0:De+1;let ke=this.c.get(me.uri.toString());return ke=ke===void 0?0:ke+1,De===ke?T._label.localeCompare(G._label):De-ke}else return!de&&me?-1:de&&!me?1:0}}e.$fG=k;var h;(function(C){C.DependsOnStarted="dependsOnStarted",C.AcquiredInput="acquiredInput",C.Start="start",C.ProcessStarted="processStarted",C.Active="active",C.Inactive="inactive",C.Changed="changed",C.Terminated="terminated",C.ProcessEnded="processEnded",C.End="end"})(h||(e.TaskEventKind=h={}));var w;(function(C){C.SingleRun="singleRun",C.Background="background"})(w||(e.TaskRunType=w={}));var I;(function(C){C[C.System=0]="System",C[C.User=1]="User",C[C.FolderOpen=2]="FolderOpen",C[C.ConfigurationChange=3]="ConfigurationChange",C[C.Reconnect=4]="Reconnect"})(I||(e.TaskRunSource=I={}));var L;(function(C){function T(pe){return{taskId:pe._id,taskName:pe.configurationProperties.name,runType:pe.configurationProperties.isBackground?"background":"singleRun",group:pe.configurationProperties.group,__task:pe}}function G(pe,re,Pe){return{...T(pe),kind:"start",terminalId:re,resolvedVariables:Pe}}C.start=G;function de(pe,re,Pe){return{...T(pe),kind:"processStarted",terminalId:re,processId:Pe}}C.processStarted=de;function me(pe,re,Pe){return{...T(pe),kind:"processEnded",terminalId:re,exitCode:Pe}}C.processEnded=me;function De(pe,re,Pe){return{...T(pe),kind:"terminated",exitReason:Pe,terminalId:re}}C.terminated=De;function ke(pe,re,Pe){return{...T(re),kind:pe,terminalId:Pe}}C.general=ke;function le(){return{kind:"changed"}}C.changed=le})(L||(e.TaskEvent=L={}));var V;(function(C){function T(de){const me=Object.keys(de).sort();let De="";for(const ke of me){let le=de[ke];le instanceof Object?le=T(le):typeof le=="string"&&(le=le.replace(/,/g,",,")),De+=ke+","+le+","}return De}function G(de){const De={_key:T(de),type:de.taskType};return Object.assign(De,de),De}C.create=G})(V||(e.KeyedTaskIdentifier=V={}));var Y;(function(C){C.AutoDetect="task.autoDetect",C.SaveBeforeRun="task.saveBeforeRun",C.ShowDecorations="task.showDecorations",C.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",C.SlowProviderWarning="task.slowProviderWarning",C.QuickOpenHistory="task.quickOpen.history",C.QuickOpenDetail="task.quickOpen.detail",C.QuickOpenSkip="task.quickOpen.skip",C.QuickOpenShowAll="task.quickOpen.showAll",C.AllowAutomaticTasks="task.allowAutomaticTasks",C.Reconnection="task.reconnection",C.VerboseLogging="task.verboseLogging"})(Y||(e.TaskSettingId=Y={}));var U;(function(C){C.Tasks="tasks",C.SuppressTaskName="tasks.suppressTaskName",C.Windows="tasks.windows",C.Osx="tasks.osx",C.Linux="tasks.linux",C.ShowOutput="tasks.showOutput",C.IsShellCommand="tasks.isShellCommand",C.ServiceTestSetting="tasks.service.testSetting"})(U||(e.TasksSchemaProperties=U={}));var N;(function(C){function T(G,de){const me=$.$8F.get(G.type);if(me===void 0){const pe=M.$an(G);return delete pe._key,V.create(pe)}const De=Object.create(null);De.type=me.taskType;const ke=new Set;me.required.forEach(pe=>ke.add(pe));const le=me.properties;for(const pe of Object.keys(le)){const re=G[pe];if(re!=null)De[pe]=re;else if(ke.has(pe)){const Pe=le[pe];if(Pe.default!==void 0)De[pe]=M.$an(Pe.default);else switch(Pe.type){case"boolean":De[pe]=!1;break;case"number":case"integer":De[pe]=0;break;case"string":De[pe]="";break;default:de.error(y.localize(2,null,JSON.stringify(G,void 0,0),pe));return}}}return V.create(De)}C.createTaskIdentifier=T})(N||(e.TaskDefinition=N={}))}),define(Ae[230],Re([1,0,11]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$25b=e.$15b=void 0;class F{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,$)=>{this.b=R,this.d=$,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,y.$Z)(R))}then(R,$){return this.j().then(R,$)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$15b=F;class A extends F{constructor(){super(),this.h=!0,this.i=new y.$4}}e.$25b=A}),define(Ae[49],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wv=e.$vv=e.$uv=e.$tv=void 0;class y{static{this.count=0}constructor(E){this._proxyIdentifierBrand=void 0,this.sid=E,this.nid=++y.count}}e.$tv=y;const F=[];function A($){const E=new y($);return F[E.nid]=E,E}e.$uv=A;function M($){return F[$].sid}e.$vv=M;class R{constructor(E){this.value=E}}e.$wv=R}),define(Ae[3],Re([1,0,49]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AK=e.$zK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$yK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var F;(function(g){g[g.Default=0]="Default",g[g.InCenter=1]="InCenter",g[g.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",g[g.AtTop=3]="AtTop"})(F||(e.TextEditorRevealType=F={}));var A;(function(g){g[g.UnknownInput=0]="UnknownInput",g[g.TextInput=1]="TextInput",g[g.TextDiffInput=2]="TextDiffInput",g[g.TextMergeInput=3]="TextMergeInput",g[g.NotebookInput=4]="NotebookInput",g[g.NotebookDiffInput=5]="NotebookDiffInput",g[g.CustomEditorInput=6]="CustomEditorInput",g[g.WebviewEditorInput=7]="WebviewEditorInput",g[g.TerminalEditorInput=8]="TerminalEditorInput",g[g.InteractiveEditorInput=9]="InteractiveEditorInput",g[g.ChatEditorInput=10]="ChatEditorInput"})(A||(e.TabInputKind=A={}));var M;(function(g){g[g.TAB_OPEN=0]="TAB_OPEN",g[g.TAB_CLOSE=1]="TAB_CLOSE",g[g.TAB_UPDATE=2]="TAB_UPDATE",g[g.TAB_MOVE=3]="TAB_MOVE"})(M||(e.TabModelOperationKind=M={}));var R;(function(g){g[g.Editable=0]="Editable",g[g.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var $;(function(g){g[g.Int8Array=1]="Int8Array",g[g.Uint8Array=2]="Uint8Array",g[g.Uint8ClampedArray=3]="Uint8ClampedArray",g[g.Int16Array=4]="Int16Array",g[g.Uint16Array=5]="Uint16Array",g[g.Int32Array=6]="Int32Array",g[g.Uint32Array=7]="Uint32Array",g[g.Float32Array=8]="Float32Array",g[g.Float64Array=9]="Float64Array",g[g.BigInt64Array=10]="BigInt64Array",g[g.BigUint64Array=11]="BigUint64Array"})($||(e.WebviewMessageArrayBufferViewType=$={}));var E;(function(g){g[g.Text=1]="Text",g[g.Error=2]="Error",g[g.Rich=3]="Rich"})(E||(e.CellOutputKind=E={}));var f;(function(g){g[g.Default=0]="Default",g[g.InCenter=1]="InCenter",g[g.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",g[g.AtTop=3]="AtTop"})(f||(e.NotebookEditorRevealType=f={}));var P;(function(g){g[g.None=0]="None",g[g.Process=1]="Process",g[g.Output=2]="Output"})(P||(e.CandidatePortSource=P={}));class D{static{this.a=0}static mixin(t){return t._id=D.a++,t}}e.$yK=D;var u;(function(g){g.label="a",g.kind="b",g.detail="c",g.documentation="d",g.sortText="e",g.filterText="f",g.preselect="g",g.insertText="h",g.insertTextRules="i",g.range="j",g.commitCharacters="k",g.additionalTextEdits="l",g.kindModifier="m",g.commandIdent="n",g.commandId="o",g.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var b;(function(g){g.defaultRanges="a",g.completions="b",g.isIncomplete="c",g.duration="d"})(b||(e.ISuggestResultDtoField=b={}));var v;(function(g){g[g.Workspace=0]="Workspace",g[g.TextDocument=1]="TextDocument"})(v||(e.ExtHostTestingResource=v={})),e.$zK={MainThreadAuthentication:(0,y.$uv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.$uv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,y.$uv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,y.$uv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,y.$uv)("MainThreadChatVariables"),MainThreadClipboard:(0,y.$uv)("MainThreadClipboard"),MainThreadCommands:(0,y.$uv)("MainThreadCommands"),MainThreadComments:(0,y.$uv)("MainThreadComments"),MainThreadConfiguration:(0,y.$uv)("MainThreadConfiguration"),MainThreadConsole:(0,y.$uv)("MainThreadConsole"),MainThreadDebugService:(0,y.$uv)("MainThreadDebugService"),MainThreadDecorations:(0,y.$uv)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.$uv)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.$uv)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.$uv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.$uv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.$uv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.$uv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.$uv)("MainThreadEditorTabs"),MainThreadErrors:(0,y.$uv)("MainThreadErrors"),MainThreadTreeViews:(0,y.$uv)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.$uv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,y.$uv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.$uv)("MainThreadLanguages"),MainThreadLogger:(0,y.$uv)("MainThreadLogger"),MainThreadMessageService:(0,y.$uv)("MainThreadMessageService"),MainThreadOutputService:(0,y.$uv)("MainThreadOutputService"),MainThreadProgress:(0,y.$uv)("MainThreadProgress"),MainThreadQuickDiff:(0,y.$uv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,y.$uv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.$uv)("MainThreadStatusBar"),MainThreadSecretState:(0,y.$uv)("MainThreadSecretState"),MainThreadStorage:(0,y.$uv)("MainThreadStorage"),MainThreadSpeech:(0,y.$uv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,y.$uv)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.$uv)("MainThreadTerminalService"),MainThreadWebviews:(0,y.$uv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.$uv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.$uv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.$uv)("MainThreadCustomEditors"),MainThreadUrls:(0,y.$uv)("MainThreadUrls"),MainThreadUriOpeners:(0,y.$uv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,y.$uv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,y.$uv)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.$uv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,y.$uv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,y.$uv)("MainThreadExtensionService"),MainThreadSCM:(0,y.$uv)("MainThreadSCM"),MainThreadSearch:(0,y.$uv)("MainThreadSearch"),MainThreadShare:(0,y.$uv)("MainThreadShare"),MainThreadTask:(0,y.$uv)("MainThreadTask"),MainThreadWindow:(0,y.$uv)("MainThreadWindow"),MainThreadLabelService:(0,y.$uv)("MainThreadLabelService"),MainThreadNotebook:(0,y.$uv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.$uv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.$uv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.$uv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.$uv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.$uv)("MainThreadInteractive"),MainThreadChat:(0,y.$uv)("MainThreadChat"),MainThreadInlineChat:(0,y.$uv)("MainThreadInlineChatShape"),MainThreadTheming:(0,y.$uv)("MainThreadTheming"),MainThreadTunnelService:(0,y.$uv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,y.$uv)("MainThreadManagedSockets"),MainThreadTimeline:(0,y.$uv)("MainThreadTimeline"),MainThreadTesting:(0,y.$uv)("MainThreadTesting"),MainThreadLocalization:(0,y.$uv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,y.$uv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,y.$uv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,y.$uv)("MainThreadIssueReporter")},e.$AK={ExtHostCommands:(0,y.$uv)("ExtHostCommands"),ExtHostConfiguration:(0,y.$uv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.$uv)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.$uv)("ExtHostDebugService"),ExtHostDecorations:(0,y.$uv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.$uv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.$uv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.$uv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.$uv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.$uv)("ExtHostEditors"),ExtHostTreeViews:(0,y.$uv)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.$uv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.$uv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.$uv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.$uv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.$uv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.$uv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,y.$uv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,y.$uv)("ExtHostStatusBar"),ExtHostShare:(0,y.$uv)("ExtHostShare"),ExtHostExtensionService:(0,y.$uv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,y.$uv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,y.$uv)("ExtHostTerminalService"),ExtHostSCM:(0,y.$uv)("ExtHostSCM"),ExtHostSearch:(0,y.$uv)("ExtHostSearch"),ExtHostTask:(0,y.$uv)("ExtHostTask"),ExtHostWorkspace:(0,y.$uv)("ExtHostWorkspace"),ExtHostWindow:(0,y.$uv)("ExtHostWindow"),ExtHostWebviews:(0,y.$uv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.$uv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.$uv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.$uv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.$uv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.$uv)("ExtHostEditorTabs"),ExtHostProgress:(0,y.$uv)("ExtHostProgress"),ExtHostComments:(0,y.$uv)("ExtHostComments"),ExtHostSecretState:(0,y.$uv)("ExtHostSecretState"),ExtHostStorage:(0,y.$uv)("ExtHostStorage"),ExtHostUrls:(0,y.$uv)("ExtHostUrls"),ExtHostUriOpeners:(0,y.$uv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,y.$uv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,y.$uv)("ExtHostOutputService"),ExtHosLabelService:(0,y.$uv)("ExtHostLabelService"),ExtHostNotebook:(0,y.$uv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.$uv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.$uv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.$uv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.$uv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,y.$uv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,y.$uv)("ExtHostInteractive"),ExtHostInlineChat:(0,y.$uv)("ExtHostInlineChatShape"),ExtHostChat:(0,y.$uv)("ExtHostChat"),ExtHostChatAgents2:(0,y.$uv)("ExtHostChatAgents"),ExtHostChatVariables:(0,y.$uv)("ExtHostChatVariables"),ExtHostChatProvider:(0,y.$uv)("ExtHostChatProvider"),ExtHostSpeech:(0,y.$uv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,y.$uv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,y.$uv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,y.$uv)("ExtHostTheming"),ExtHostTunnelService:(0,y.$uv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,y.$uv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,y.$uv)("ExtHostAuthentication"),ExtHostTimeline:(0,y.$uv)("ExtHostTimeline"),ExtHostTesting:(0,y.$uv)("ExtHostTesting"),ExtHostTelemetry:(0,y.$uv)("ExtHostTelemetry"),ExtHostLocalization:(0,y.$uv)("ExtHostLocalization"),ExtHostIssueReporter:(0,y.$uv)("ExtHostIssueReporter")}}),define(Ae[231],Re([1,0,3,7]),function(we,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Idc=void 0;class A{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(y.$zK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,$,E){if(this.a.size===0)throw new Error("No related information providers registered");const f=this.a.get(R);if(!f)throw new Error("related information provider not found");return await f.provideRelatedInformation($,E)??[]}getRelatedInformation(R,$,E){return this.c.$getAiRelatedInformation($,E)}registerRelatedInformationProvider(R,$,E){const f=this.b;return this.b++,this.a.set(f,E),this.c.$registerAiRelatedInformationProvider(f,$),new F.$BK(()=>{this.c.$unregisterAiRelatedInformationProvider(f),this.a.delete(f)})}}e.$Idc=A}),define(Ae[81],Re([1,0,4,15,3,17]),function(we,e,y,F,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qdc=e.$Pdc=e.$Odc=void 0,e.$Odc=(0,y.$Vh)("IExtHostApiDeprecationService");let R=class{constructor(E,f){this.c=f,this.a=new Set,this.b=E.getProxy(A.$zK.MainThreadTelemetry)}report(E,f,P){const D=this.d(E,f);this.a.has(D)||(this.a.add(D),f.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${E}' is deprecated. ${P}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:f.identifier.value,apiId:E}))}d(E,f){return`${E}-${f.identifier.value}`}};e.$Pdc=R,e.$Pdc=R=Ke([Ve(0,M.$BM),Ve(1,F.$dj)],R),e.$Qdc=Object.freeze(new class{report($,E,f){}})}),define(Ae[232],Re([1,0,5,3,7,22]),function(we,e,y,F,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tdc=void 0;class R{constructor(f){this.b=new Map,this.c=[],this.d=new y.$Rd,this.onDidChangeSessions=this.d.event,this.f=new $,this.g=new $,this.a=f.getProxy(F.$zK.MainThreadAuthentication)}$setProviders(f){return this.c=f,Promise.resolve()}async getSession(f,P,D,u={}){const b=M.$_l.toKey(f.identifier),v=[...D].sort().join(" ");return await this.f.getOrCreate(`${b} ${P} ${v}`,async()=>{await this.a.$ensureProvider(P);const g=f.displayName||f.name;return this.a.$getSession(P,D,b,g,u)})}async getSessions(f,P,D){const u=M.$_l.toKey(f.identifier),b=[...D].sort().join(" ");return await this.g.getOrCreate(`${u} ${b}`,async()=>{await this.a.$ensureProvider(P);const v=f.displayName||f.name;return this.a.$getSessions(P,D,u,v)})}async removeSession(f,P){const D=this.b.get(f);return D?D.provider.removeSession(P):this.a.$removeSession(f,P)}registerAuthenticationProvider(f,P,D,u){if(this.b.get(f))throw new Error(`An authentication provider with id '${f}' is already registered.`);this.b.set(f,{label:P,provider:D,options:u??{supportsMultipleAccounts:!1}}),this.c.find(v=>v.id===f)||this.c.push({id:f,label:P});const b=D.onDidChangeSessions(v=>{this.a.$sendDidChangeSessions(f,{added:v.added??[],changed:v.changed??[],removed:v.removed??[]})});return this.a.$registerAuthenticationProvider(f,P,u?.supportsMultipleAccounts??!1),new A.$BK(()=>{b.dispose(),this.b.delete(f);const v=this.c.findIndex(g=>g.id===f);v>-1&&this.c.splice(v),this.a.$unregisterAuthenticationProvider(f)})}$createSession(f,P,D){const u=this.b.get(f);if(u)return Promise.resolve(u.provider.createSession(P,D));throw new Error(`Unable to find authentication provider with handle: ${f}`)}$removeSession(f,P){const D=this.b.get(f);if(D)return Promise.resolve(D.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${f}`)}$getSessions(f,P){const D=this.b.get(f);if(D)return Promise.resolve(D.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${f}`)}$onDidChangeAuthenticationSessions(f,P){return this.d.fire({provider:{id:f,label:P}}),Promise.resolve()}}e.$Tdc=R;class ${constructor(){this.a=new Map}getOrCreate(f,P){const D=this.a.get(f);if(D)return D;const u=P().finally(()=>this.a.delete(f));return this.a.set(f,u),u}}}),define(Ae[233],Re([1,0,3,17,8]),function(we,e,y,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Udc=void 0;let M=class{constructor($,E){this.a=$.getProxy(y.$zK.MainThreadBulkEdits),this.b={getTextDocumentVersion:f=>E.getDocument(f)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,E,f){const P=A.WorkspaceEdit.from($,this.b);return this.a.$tryApplyWorkspaceEdit(P,void 0,f?.isRefactoring??!1)}};e.$Udc=M,e.$Udc=M=Ke([Ve(0,F.$BM)],M)}),define(Ae[234],Re([1,0,5,67,6,3,8]),function(we,e,y,F,A,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vdc=void 0;class ${static{this.a=0}constructor(P,D){this.extension=P,this.provider=D,this.handle=$.a++}}class E{static{this.a=0}constructor(P){this.b=new Map,this.c=new Map,this.d=new y.$Rd,this.onDidPerformUserAction=this.d.event,this.e=P.getProxy(M.$zK.MainThreadChat)}registerChatProvider(P,D,u){const b=new $(P,u);return this.b.set(b.handle,b),this.e.$registerChatProvider(b.handle,D),(0,A.$Pc)(()=>{this.e.$unregisterChatProvider(b.handle),this.b.delete(b.handle)})}transferChatSession(P,D){const u=F.Iterable.find(this.c.keys(),b=>this.c.get(b)===P)??0;typeof u=="number"&&this.e.$transferChatSession(u,D)}sendInteractiveRequestToProvider(P,D){this.e.$sendRequestToProvider(P,D)}async $prepareChat(P,D){const u=this.b.get(P);if(!u)return;const b=await u.provider.prepareSession(D);if(!b)return;const v=E.a++;return this.c.set(v,b),{id:v,requesterUsername:b.requester?.name,requesterAvatarIconUri:b.requester?.icon,responderUsername:b.responder?.name,responderAvatarIconUri:b.responder?.icon,inputPlaceholder:b.inputPlaceholder}}async $provideWelcomeMessage(P,D){const u=this.b.get(P);if(!u||!u.provider.provideWelcomeMessage)return;const b=await u.provider.provideWelcomeMessage(D);if(b)return b.map(v=>typeof v=="string"?v:Array.isArray(v)?v.map(g=>R.ChatReplyFollowup.from(g)):R.MarkdownString.from(v))}async $provideSampleQuestions(P,D){const u=this.b.get(P);if(!u||!u.provider.provideSampleQuestions)return;const b=await u.provider.provideSampleQuestions(D);if(b)return b?.map(v=>R.ChatReplyFollowup.from(v))}$releaseSession(P){this.c.delete(P)}async $onDidPerformUserAction(P){this.d.fire(P)}}e.$Vdc=E}),define(Ae[235],Re([1,0,14,19,39,5,60,16,2,157,72,3,8,7,206,23]),function(we,e,y,F,A,M,R,$,E,f,P,D,u,b,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xdc=void 0;class t{static{this.a=0}constructor(c,o,l){this.i=o,this.j=l,this.b=new Map,this.g=new Map,this.h=new Map,this.d=c.getProxy(D.$zK.MainThreadChatAgents2)}createChatAgent(c,o,l){const n=t.a++,s=new i(c,o,this.d,n,l);return this.b.set(n,s),this.d.$registerAgent(n,o,{}),s.apiAgent}async $invokeAgent(c,o,l,n,s,a){this.g.delete(o);const d=this.b.get(c);if(!d)throw new Error(`[CHAT](${c}) CANNOT invoke agent because the agent is not registered`);let p=!1;function m(){if(p)throw new Error("Only valid while executing the command")}const S=new y.$ih;a.onCancellationRequested(()=>S.complete()),setTimeout(()=>S.complete(),10*1e3),this.i.allowListExtensionWhile(d.extension.identifier,S.p);const k=n.command?await d.validateSlashCommand(n.command):void 0,h=R.$Nd.create(!1);let w;try{const I=d.invoke({prompt:n.message,variables:u.ChatVariable.objectTo(n.variables),slashCommand:k},{history:s.history.map(u.ChatMessage.to)},new P.$$u(L=>{m(),typeof w>"u"&&"content"in L&&(w=h.elapsed());const V=u.ChatResponseProgress.from(d.extension,L);if("placeholder"in L&&"resolvedContent"in L){const Y=Promise.all([this.d.$handleProgressChunk(l,V),L.resolvedContent]);(0,y.$Mg)(Y,a).then(U=>{if(!U)return;const[N,C]=U,T=u.ChatResponseProgress.from(d.extension,C);this.d.$handleProgressChunk(l,T,N??void 0)})}else this.d.$handleProgressChunk(l,V)}),a);return await(0,y.$Mg)(Promise.resolve(I).then(L=>{if(L){this.g.set(o,L);let V=this.h.get(o);V||(V=new Map,this.h.set(o,V)),V.set(l,L);const Y={firstProgress:w,totalElapsed:h.elapsed()};return{errorDetails:L.errorDetails,timings:Y}}else this.g.delete(o)}),a)}catch(I){return this.j.error(I,d.extension),{errorDetails:{message:(0,f.localize)(0,null,(0,A.$Gi)(I)),responseIsIncomplete:!0}}}finally{p=!0,S.complete()}}$releaseSession(c){this.g.delete(c),this.h.delete(c)}async $provideSlashCommands(c,o){const l=this.b.get(c);return l?l.provideSlashCommand(o):[]}$provideFollowups(c,o,l){const n=this.b.get(c);if(!n)return Promise.resolve([]);const s=this.g.get(o);return s?n.provideFollowups(s,l):Promise.resolve([])}$acceptFeedback(c,o,l,n,s){const a=this.b.get(c);if(!a)return;const d=this.h.get(o)?.get(l);if(!d)return;let p;switch(n){case v.InteractiveSessionVoteDirection.Down:p=b.ChatAgentResultFeedbackKind.Unhelpful;break;case v.InteractiveSessionVoteDirection.Up:p=b.ChatAgentResultFeedbackKind.Helpful;break}a.acceptFeedback(Object.freeze(s?{result:d,kind:p,reportIssue:s}:{result:d,kind:p}))}$acceptAction(c,o,l,n){const s=this.b.get(c);if(!s)return;const a=this.h.get(o)?.get(l);a&&n.action.kind!=="vote"&&s.acceptAction(Object.freeze({action:n.action,result:a}))}}e.$Xdc=t;class i{constructor(c,o,l,n,s){this.extension=c,this.s=o,this.t=l,this.u=n,this.w=s,this.o=new M.$Rd,this.q=new M.$Rd}acceptFeedback(c){this.o.fire(c)}acceptAction(c){this.q.fire(c)}async validateSlashCommand(c){this.b||(await this.provideSlashCommand(F.CancellationToken.None),(0,$.$Mf)(this.b));const o=this.b.find(l=>l.name===c);if(!o)throw new Error(`Unknown slashCommand: ${c}`);return o}async provideSlashCommand(c){if(!this.a)return[];const o=await this.a.provideSlashCommands(c);return o?(this.b=o,o.map(l=>({name:l.name,description:l.description,followupPlaceholder:l.followupPlaceholder,shouldRepopulate:l.shouldRepopulate,sampleRequest:l.sampleRequest}))):[]}async provideFollowups(c,o){if(!this.d)return[];const l=await this.d.provideFollowups(c,o);return l?l.map(n=>u.ChatFollowup.from(n)):[]}get apiAgent(){let c=!1,o=!1;const l=()=>{c||o||(o=!0,queueMicrotask(()=>{this.t.$updateAgent(this.u,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof E.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof b.$vL?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.d!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:u.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:u.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.r}),o=!1}))},n=this;return{get name(){return n.s},get description(){return n.g??""},set description(s){n.g=s,l()},get fullName(){return n.h??n.extension.displayName??n.extension.name},set fullName(s){n.h=s,l()},get iconPath(){return n.i},set iconPath(s){n.i=s,l()},get slashCommandProvider(){return n.a},set slashCommandProvider(s){n.a=s,l()},get followupProvider(){return n.d},set followupProvider(s){n.d=s,l()},get isDefault(){return(0,g.$NF)(n.extension,"defaultChatAgent"),n.j},set isDefault(s){(0,g.$NF)(n.extension,"defaultChatAgent"),n.j=s,l()},get helpTextPrefix(){return(0,g.$NF)(n.extension,"defaultChatAgent"),n.k},set helpTextPrefix(s){if((0,g.$NF)(n.extension,"defaultChatAgent"),!n.j)throw new Error("helpTextPrefix is only available on the default chat agent");n.k=s,l()},get helpTextPostfix(){return(0,g.$NF)(n.extension,"defaultChatAgent"),n.l},set helpTextPostfix(s){if((0,g.$NF)(n.extension,"defaultChatAgent"),!n.j)throw new Error("helpTextPostfix is only available on the default chat agent");n.l=s,l()},get isSecondary(){return(0,g.$NF)(n.extension,"defaultChatAgent"),n.n},set isSecondary(s){(0,g.$NF)(n.extension,"defaultChatAgent"),n.n=s,l()},get sampleRequest(){return n.m},set sampleRequest(s){n.m=s,l()},get supportIssueReporting(){return(0,g.$NF)(n.extension,"chatAgents2Additions"),n.r},set supportIssueReporting(s){(0,g.$NF)(n.extension,"chatAgents2Additions"),n.r=s,l()},get onDidReceiveFeedback(){return n.o.event},onDidPerformAction:(0,g.$MF)(this.extension,"chatAgents2Additions")?this.q.event:void 0,dispose(){c=!0,n.a=void 0,n.d=void 0,n.o.dispose(),n.t.$unregisterAgent(n.u)}}}invoke(c,o,l,n){return this.w(c,o,l,n)}}}),define(Ae[236],Re([1,0,19,6,3,8,72,22,14,5]),function(we,e,y,F,A,M,R,$,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wdc=void 0;class P{constructor(v,g){this.stream=new E.$mh,this.stream=g??new E.$mh;const t=this;this.apiObj={option:v,response:t.stream.asyncIterable}}}class D{constructor(v,g){this.a=new f.$Rd,this.b=new Map,this.c=new E.$mh,this.d=!1;const t=this;this.apiObject={result:v,response:t.c.asyncIterable,onDidStartResponseStream:t.a.event,cancel(){g.cancel()}},v.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,i]of this.b)i.stream.resolve();else this.c.resolve()})}handleFragment(v){if(this.d)return;let g=this.b.get(v.index);g||(this.b.size===0?g=new P(v.index,this.c):g=new P(v.index),this.b.set(v.index,g),this.a.fire(g.apiObj)),g.stream.emitOne(v.part)}}class u{static{this.a=1}constructor(v,g){this.d=g,this.c=new Map,this.e=new Map,this.f=new $.$bm,this.b=v.getProxy(A.$zK.MainThreadChatProvider)}registerProvider(v,g,t,i){const r=u.a++;return this.c.set(r,{extension:v,provider:t}),this.b.$registerProvider(r,g,{extension:v,displayName:i.name??v.value}),(0,F.$Pc)(()=>{this.b.$unregisterProvider(r),this.c.delete(r)})}async $provideChatResponse(v,g,t,i,r){const c=this.c.get(v);if(!c)return;const o=new R.$$u(async l=>{if(r.isCancellationRequested){this.d.warn(`[CHAT](${c.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(g,{index:l.index,part:l.part})});return c.provider.provideChatResponse(t.map(M.ChatMessage.to),i,o,r)}allowListExtensionWhile(v,g){this.f.set(v,g),g.finally(()=>this.f.delete(v))}async requestChatResponseProvider(v,g){if(!this.f.has(v))throw new Error("Extension is NOT allowed to make chat requests");const t=this;return{get isRevoked(){return!t.f.has(v)},makeRequest(i,r,c){if(!t.f.has(v))throw new Error("Access to chat has been revoked");const o=new y.$2d(c),l=Math.random()*1e6|0,n=t.b.$fetchResponse(v,g,l,i.map(M.ChatMessage.from),r??{},o.token),s=new D(n,o);return t.e.set(l,{res:s}),n.finally(()=>{t.e.delete(l)}),s.apiObject}}}async $handleResponseFragment(v,g){const t=this.e.get(v);t&&t.res.handleFragment(g)}}e.$Wdc=u}),define(Ae[237],Re([1,0,6,3,11,8]),function(we,e,y,F,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ydc=void 0;class R{static{this.a=0}constructor(E){this.b=new Map,this.c=E.getProxy(F.$zK.MainThreadChatVariables)}async $resolveVariable(E,f,P){const D=this.b.get(E);if(D)try{const u=await D.resolver.resolve(D.data.name,{message:f},P);if(u)return u.map(M.ChatVariable.from)}catch(u){(0,A.$1)(u)}}registerVariableResolver(E,f,P,D){const u=R.a++;return this.b.set(u,{extension:E.identifier,data:{name:f,description:P},resolver:D}),this.c.$registerVariable(u,{name:f,description:P}),(0,y.$Pc)(()=>{this.b.delete(u),this.c.$unregisterVariable(u)})}}e.$Ydc=R}),define(Ae[238],Re([1,0,3]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zdc=void 0;class F{constructor(M){const R=M.getProxy(y.$zK.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText($){return R.$writeText($)}})}}e.$Zdc=F}),define(Ae[32],Re([1,0,16,7,8,26,3,18,15,51,29,131,2,6,4,17,108,24,49,39,60,56,59]),function(we,e,y,F,A,M,R,$,E,f,P,D,u,b,v,g,t,i,r,c,o,l,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2M=e.$1M=e.$ZM=e.$YM=e.$XM=e.$WM=void 0;let s=class{#e;#t;#i;constructor(k,h,w){this.b=new Map,this.c=new Map,this.#e=k.getProxy(R.$zK.MainThreadCommands),this.d=h,this.#i=w,this.#t=k.getProxy(R.$zK.MainThreadTelemetry),this.converter=new a(this,I=>{const L=this.c.get(I);return L?.result===p.Void?L:void 0},h),this.f=[{processArgument(I){return(0,f.$sh)(I)}},{processArgument(I){return(0,M.$cn)(I,function(L){if(P.$zs.isIRange(L))return A.Range.to(L);if(D.$ys.isIPosition(L))return A.Position.to(L);if(P.$zs.isIRange(L.range)&&u.URI.isUri(L.uri))return A.location.to(L);if(L instanceof i.$fe)return L.buffer.buffer;if(!Array.isArray(L))return L})}}]}registerArgumentProcessor(k){this.f.push(k)}registerApiCommand(k){const h=this.registerCommand(!1,k.id,async(...w)=>{const I=k.args.map((V,Y)=>{if(!V.validate(w[Y]))throw new Error(`Invalid argument '${V.name}' when running '${k.id}', received: ${typeof w[Y]=="object"?JSON.stringify(w[Y],null,"	"):w[Y]} `);return V.convert(w[Y])}),L=await this.executeCommand(k.internalId,...I);return k.result.convert(L,w,this.converter)},void 0,{description:k.description,args:k.args,returns:k.result.description});return this.c.set(k.id,k),new F.$BK(()=>{h.dispose(),this.c.delete(k.id)})}registerCommand(k,h,w,I,L,V){if(this.d.trace("ExtHostCommands#registerCommand",h),!h.trim().length)throw new Error("invalid id");if(this.b.has(h))throw new Error(`command '${h}' already exists`);return this.b.set(h,{callback:w,thisArg:I,metadata:L,extension:V}),k&&this.#e.$registerCommand(h),new F.$BK(()=>{this.b.delete(h)&&k&&this.#e.$unregisterCommand(h)})}executeCommand(k,...h){return this.d.trace("ExtHostCommands#executeCommand",k),this.g(k,h,!0)}async g(k,h,w){if(this.b.has(k))return this.#e.$fireCommandActivationEvent(k),this.h(k,h,!1);{let I=!1;const L=(0,M.$cn)(h,function(V){if(V instanceof F.$CK)return A.Position.from(V);if(V instanceof F.$DK)return A.Range.from(V);if(V instanceof F.$NK)return A.location.from(V);if(F.$YL.isNotebookRange(V))return A.NotebookRange.from(V);if(V instanceof ArrayBuffer)return I=!0,i.$fe.wrap(new Uint8Array(V));if(V instanceof Uint8Array)return I=!0,i.$fe.wrap(V);if(V instanceof i.$fe)return I=!0,V;if(!Array.isArray(V))return V});try{const V=await this.#e.$executeCommand(k,I?new r.$wv(L):L,w);return(0,f.$sh)(V)}catch(V){if(V instanceof Error&&V.message==="$executeCommand:retry")return this.g(k,h,!1);throw V}}}async h(k,h,w){const I=this.b.get(k);if(!I)throw new Error("Unknown command");const{callback:L,thisArg:V,metadata:Y}=I;if(Y?.args)for(let N=0;N<Y.args.length;N++)try{(0,y.$Tf)(h[N],Y.args[N].constraint)}catch{throw new Error(`Running the contributed command: '${k}' failed. Illegal argument '${Y.args[N].name}' - ${Y.args[N].description}`)}const U=o.$Nd.create();try{return await L.apply(V,h)}catch(N){if(k===this.converter.delegatingCommandId){const C=this.converter.getActualCommand(...h);C&&(k=C.command)}if(this.d.error(N,k,I.extension?.identifier),!w)throw N;if(I.extension?.identifier){const C=this.#i.onExtensionError(I.extension.identifier,N);this.d.trace("forwarded error to extension?",C,I.extension?.identifier)}throw new class extends Error{constructor(){super((0,c.$Gi)(N)),this.id=k,this.source=I.extension?.displayName??I.extension?.name}}}finally{this.j(I,k,U.elapsed())}}j(k,h,w){k.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:k.extension.identifier.value,id:new l.$po(h),duration:w})}$executeContributedCommand(k,...h){this.d.trace("ExtHostCommands#$executeContributedCommand",k);const w=this.b.get(k);return w?(h=h.map(I=>this.f.reduce((L,V)=>V.processArgument(L,w.extension?.identifier),I)),this.h(k,h,!0)):Promise.reject(new Error(`Contributed command '${k}' does not exist.`))}getCommands(k=!1){return this.d.trace("ExtHostCommands#getCommands",k),this.#e.$getCommands().then(h=>(k&&(h=h.filter(w=>w[0]!=="_")),h))}$getContributedCommandMetadata(){const k=Object.create(null);for(const[h,w]of this.b){const{metadata:I}=w;I&&(k[h]=I)}return Promise.resolve(k)}};e.$WM=s,e.$WM=s=Ke([Ve(0,g.$BM),Ve(1,E.$dj),Ve(2,n.$VM)],s),e.$XM=(0,v.$Vh)("IExtHostCommands");class a{constructor(k,h,w){this.d=k,this.f=h,this.g=w,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(k,h){if(!k)return;const w={$ident:void 0,id:k.command,title:k.title,tooltip:k.tooltip};if(!k.command)return w;const I=this.f(k.command);if(I)w.id=I.internalId,w.arguments=I.args.map((L,V)=>L.convert(k.arguments&&k.arguments[V]));else if((0,$.$Kb)(k.arguments)){const L=`${k.command} /${++this.c}`;this.b.set(L,k),h.add((0,b.$Pc)(()=>{this.b.delete(L),this.g.trace("CommandsConverter#DISPOSE",L)})),w.$ident=L,w.id=this.delegatingCommandId,w.arguments=[L],this.g.trace("CommandsConverter#CREATE",k.command,L)}return w}fromInternal(k){return typeof k.$ident=="string"?this.b.get(k.$ident):{command:k.id,title:k.title,arguments:k.arguments}}getActualCommand(...k){return this.b.get(k[0])}h(...k){const h=this.getActualCommand(...k);return this.g.trace("CommandsConverter#EXECUTE",k[0],h?h.command:"MISSING"),h?this.d.executeCommand(h.command,...h.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${k[0]}`)}}e.$YM=a;class d{static{this.Uri=new d("uri","Uri of a text document",k=>u.URI.isUri(k),k=>k)}static{this.Position=new d("position","A position in a text document",k=>F.$CK.isPosition(k),A.Position.from)}static{this.Range=new d("range","A range in a text document",k=>F.$DK.isRange(k),A.Range.from)}static{this.Selection=new d("selection","A selection in a text document",k=>F.$EK.isSelection(k),A.Selection.from)}static{this.Number=new d("number","",k=>typeof k=="number",k=>k)}static{this.String=new d("string","",k=>typeof k=="string",k=>k)}static{this.StringArray=d.Arr(d.String)}static Arr(k){return new d(`${k.name}_array`,`Array of ${k.name}, ${k.description}`,h=>Array.isArray(h)&&h.every(w=>k.validate(w)),h=>h.map(w=>k.convert(w)))}static{this.CallHierarchyItem=new d("item","A call hierarchy item",k=>k instanceof F.$XK,A.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new d("item","A type hierarchy item",k=>k instanceof F.$fM,A.TypeHierarchyItem.from)}static{this.TestItem=new d("testItem","A VS Code TestItem",k=>k instanceof t.$OM,A.TestItem.from)}constructor(k,h,w,I){this.name=k,this.description=h,this.validate=w,this.convert=I}optional(){return new d(this.name,`(optional) ${this.description}`,k=>k==null||this.validate(k),k=>k===void 0?void 0:k===null?null:this.convert(k))}with(k,h){return new d(k??this.name,h??this.description,this.validate,this.convert)}}e.$ZM=d;class p{static{this.Void=new p("no result",k=>k)}constructor(k,h){this.description=k,this.convert=h}}e.$1M=p;class m{constructor(k,h,w,I,L){this.id=k,this.internalId=h,this.description=w,this.args=I,this.result=L}}e.$2M=m}),define(Ae[239],Re([1,0,18,13,2,80,95,34,99,32,8,7]),function(we,e,y,F,A,M,R,$,E,f,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sdc=void 0;const u=[new f.$2M("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[f.$ZM.Uri,f.$ZM.Position],new f.$1M("A promise that resolves to an array of DocumentHighlight-instances.",v(P.DocumentHighlight.to))),new f.$2M("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[f.$ZM.Uri],new f.$1M("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,i)=>{if((0,y.$Jb)(t))return;class r extends D.$SK{static to(o){const l=new r(o.name,P.SymbolKind.to(o.kind),o.containerName||"",new D.$NK(i[0],P.Range.to(o.range)));return l.detail=o.detail,l.range=l.location.range,l.selectionRange=P.Range.to(o.selectionRange),l.children=o.children?o.children.map(r.to):[],l}}return t.map(r.to)})),new f.$2M("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[f.$ZM.Uri,new f.$ZM("options","Formatting options",t=>!0,t=>t)],new f.$1M("A promise that resolves to an array of TextEdits.",v(P.TextEdit.to))),new f.$2M("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[f.$ZM.Uri,f.$ZM.Range,new f.$ZM("options","Formatting options",t=>!0,t=>t)],new f.$1M("A promise that resolves to an array of TextEdits.",v(P.TextEdit.to))),new f.$2M("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[f.$ZM.Uri,f.$ZM.Position,new f.$ZM("ch","Trigger character",t=>typeof t=="string",t=>t),new f.$ZM("options","Formatting options",t=>!0,t=>t)],new f.$1M("A promise that resolves to an array of TextEdits.",v(P.TextEdit.to))),new f.$2M("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[f.$ZM.Uri,f.$ZM.Position],new f.$1M("A promise that resolves to an array of Location or LocationLink instances.",g)),new f.$2M("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[f.$ZM.Uri,f.$ZM.Position],new f.$1M("A promise that resolves to an array of Location or LocationLink instances.",g)),new f.$2M("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[f.$ZM.Uri,f.$ZM.Position],new f.$1M("A promise that resolves to an array of Location or LocationLink instances.",g)),new f.$2M("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[f.$ZM.Uri,f.$ZM.Position],new f.$1M("A promise that resolves to an array of Location or LocationLink instances.",g)),new f.$2M("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[f.$ZM.Uri,f.$ZM.Position],new f.$1M("A promise that resolves to an array of Location-instances.",v(P.location.to))),new f.$2M("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[f.$ZM.Uri,f.$ZM.Position],new f.$1M("A promise that resolves to an array of Hover-instances.",v(P.Hover.to))),new f.$2M("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[f.$ZM.Uri,new f.$ZM("position","A position in a text document",t=>Array.isArray(t)&&t.every(i=>D.$CK.isPosition(i)),t=>t.map(P.Position.from))],new f.$1M("A promise that resolves to an array of ranges.",t=>t.map(i=>{let r;for(const c of i.reverse())r=new D.$WK(P.Range.to(c),r);return r}))),new f.$2M("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[f.$ZM.String.with("query","Search string")],new f.$1M("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(P.WorkspaceSymbol.to))),new f.$2M("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[f.$ZM.Uri,f.$ZM.Position],new f.$1M("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(P.CallHierarchyItem.to))),new f.$2M("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[f.$ZM.CallHierarchyItem],new f.$1M("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(P.CallHierarchyIncomingCall.to))),new f.$2M("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[f.$ZM.CallHierarchyItem],new f.$1M("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(P.CallHierarchyOutgoingCall.to))),new f.$2M("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[f.$ZM.Uri,f.$ZM.Position],new f.$1M("A promise that resolves to a range and placeholder text.",t=>{if(t)return{range:P.Range.to(t.range),placeholder:t.text}})),new f.$2M("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[f.$ZM.Uri,f.$ZM.Position,f.$ZM.String.with("newName","The new symbol name")],new f.$1M("A promise that resolves to a WorkspaceEdit.",t=>{if(t){if(t.rejectReason)throw new Error(t.rejectReason);return P.WorkspaceEdit.to(t)}})),new f.$2M("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[f.$ZM.Uri,f.$ZM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new f.$1M("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(P.DocumentLink.to))),new f.$2M("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[f.$ZM.Uri],new f.$1M("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new D.$QL(t.tokenTypes,t.tokenModifiers)})),new f.$2M("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[f.$ZM.Uri],new f.$1M("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,R.$20)(t);if(i.type==="full")return new D.$SL(i.data,void 0)})),new f.$2M("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[f.$ZM.Uri,f.$ZM.Range.optional()],new f.$1M("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new D.$QL(t.tokenTypes,t.tokenModifiers)})),new f.$2M("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[f.$ZM.Uri,f.$ZM.Range],new f.$1M("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,R.$20)(t);if(i.type==="full")return new D.$SL(i.data,void 0)})),new f.$2M("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[f.$ZM.Uri,f.$ZM.Position,f.$ZM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),f.$ZM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new f.$1M("A promise that resolves to a CompletionList-instance.",(t,i,r)=>{if(!t)return new D.$9K([]);const c=t.suggestions.map(o=>P.CompletionItem.to(o,r));return new D.$9K(c,t.incomplete)})),new f.$2M("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[f.$ZM.Uri,f.$ZM.Position,f.$ZM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new f.$1M("A promise that resolves to SignatureHelp.",t=>{if(t)return P.SignatureHelp.to(t)})),new f.$2M("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[f.$ZM.Uri,f.$ZM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new f.$1M("A promise that resolves to an array of CodeLens-instances.",(t,i,r)=>v(c=>new D.$1K(P.Range.to(c.range),c.command&&r.fromInternal(c.command)))(t))),new f.$2M("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[f.$ZM.Uri,new f.$ZM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>D.$DK.isRange(t),t=>D.$EK.isSelection(t)?P.Selection.from(t):P.Range.from(t)),f.$ZM.String.with("kind","Code action kind to return code actions for").optional(),f.$ZM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new f.$1M("A promise that resolves to an array of Command-instances.",(t,i,r)=>v(c=>{if(c._isSynthetic){if(!c.command)throw new Error("Synthetic code actions must have a command");return r.fromInternal(c.command)}else{const o=new D.$UK(c.title,c.kind?new D.$VK(c.kind):void 0);return c.edit&&(o.edit=P.WorkspaceEdit.to(c.edit)),c.command&&(o.command=r.fromInternal(c.command)),o.isPreferred=c.isPreferred,o}})(t))),new f.$2M("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[f.$ZM.Uri],new f.$1M("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(i=>new D.$cL(P.Range.to(i.range),P.Color.to(i.color))):[])),new f.$2M("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new f.$ZM("color","The color to show and insert",t=>t instanceof D.$bL,P.Color.from),new f.$ZM("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:P.Range.from(t.range)}))],new f.$1M("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(P.ColorPresentation.to):[])),new f.$2M("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[f.$ZM.Uri,f.$ZM.Range],new f.$1M("A promise that resolves to an array of Inlay objects",(t,i,r)=>t.map(P.InlayHint.to.bind(void 0,r)))),new f.$2M("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[f.$ZM.Uri],new f.$1M("A promise that resolves to an array of FoldingRange objects",(t,i)=>{if(t)return t.map(P.FoldingRange.to)})),new f.$2M("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new f.$1M("A promise that resolves to an array of NotebookContentProvider static info objects.",v(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(i=>P.NotebookExclusiveDocumentPattern.to(i))})))),new f.$2M("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[f.$ZM.Uri,f.$ZM.Range,new f.$ZM("context","An InlineValueContext",t=>t&&typeof t.frameId=="number"&&t.stoppedLocation instanceof D.$DK,t=>P.InlineValueContext.from(t))],new f.$1M("A promise that resolves to an array of InlineValue objects",t=>t.map(P.InlineValue.to))),new f.$2M("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new f.$ZM("uriOrString","Uri-instance or string (only http/https)",t=>A.URI.isUri(t)||typeof t=="string"&&(0,E.$RU)(t,F.Schemas.http,F.Schemas.https),t=>t),new f.$ZM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[P.ViewColumn.from(t),void 0]:[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)])).optional(),f.$ZM.String.with("label","").optional()],f.$1M.Void),new f.$2M("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[f.$ZM.Uri.with("resource","Resource to open"),f.$ZM.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new f.$ZM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[P.ViewColumn.from(t),void 0]:[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)])).optional()],f.$1M.Void),new f.$2M("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[f.$ZM.Uri.with("left","Left-hand side resource of the diff editor"),f.$ZM.Uri.with("right","Right-hand side resource of the diff editor"),f.$ZM.String.with("title","Human readable title for the diff editor").optional(),new f.$ZM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)]).optional()],f.$1M.Void),new f.$2M("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[f.$ZM.String.with("title","Human readable title for the changes editor"),new f.$ZM("resourceList","List of resources to compare",t=>{for(const i of t){if(i.length!==3)return!1;const[r,c,o]=i;if(!A.URI.isUri(r)||!A.URI.isUri(c)&&c!==void 0&&c!==null||!A.URI.isUri(o)&&o!==void 0&&o!==null)return!1}return!0},t=>t)],f.$1M.Void),new f.$2M("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[f.$ZM.Uri,f.$ZM.Position],new f.$1M("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new f.$2M("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[f.$ZM.TypeHierarchyItem],new f.$1M("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new f.$2M("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[f.$ZM.TypeHierarchyItem],new f.$1M("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new f.$2M("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[f.$ZM.TestItem],f.$1M.Void),new f.$2M("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[f.$ZM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],f.$1M.Void),new f.$2M("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[f.$ZM.String.with("name","The context key name"),new f.$ZM("value","The context key value",()=>!0,t=>t)],f.$1M.Void),new f.$2M("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[f.$ZM.Uri,f.$ZM.StringArray,new f.$ZM("MappedEditsContext","Mapped Edits Context",t=>P.MappedEditsContext.is(t),t=>P.MappedEditsContext.from(t))],new f.$1M("A promise that resolves to a workspace edit or null",t=>t?P.WorkspaceEdit.to(t):null))];class b{static register(i){u.forEach(i.registerApiCommand,i),this.a(i)}static a(i){i.registerCommand(!1,"_validateWhenClauses",$.$Ui)}}e.$Sdc=b;function v(t){return i=>{if(Array.isArray(i))return i.map(t)}}function g(t){if(!Array.isArray(t))return;const i=[];for(const r of t)M.$kt(r)?i.push(P.DefinitionLink.to(r)):i.push(P.location.to(r));return i}}),define(Ae[240],Re([1,0,14,66,5,6,2,80,22,8,7,3,23]),function(we,e,y,F,A,M,R,$,E,f,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3dc=void 0;function b(v,g,t){const i=v.getProxy(D.$zK.MainThreadComments);class r{static{this.a=0}constructor(){this.b=new Map,this.c=new E.$bm,g.registerArgumentProcessor({processArgument:m=>{if(m&&m.$mid===6){const S=this.b.get(m.handle);return S?S.value:m}else if(m&&m.$mid===7){const S=this.b.get(m.commentControlHandle);if(!S)return m;const k=S.getCommentThread(m.commentThreadHandle);return k?k.value:m}else if(m&&(m.$mid===9||m.$mid===8)){const S=this.b.get(m.thread.commentControlHandle);if(!S)return m;const k=S.getCommentThread(m.thread.commentThreadHandle);return k?m.$mid===8?k.value:{thread:k.value,text:m.text}:m}else if(m&&m.$mid===10){const S=this.b.get(m.thread.commentControlHandle);if(!S)return m;const k=S.getCommentThread(m.thread.commentThreadHandle);if(!k)return m;const h=m.commentUniqueId,w=k.getCommentByUniqueId(h);return w||m}else if(m&&m.$mid===11){const S=this.b.get(m.thread.commentControlHandle);if(!S)return m;const k=S.getCommentThread(m.thread.commentThreadHandle);if(!k)return m;const h=m.text,w=m.commentUniqueId,I=k.getCommentByUniqueId(w);return I?(typeof I.body=="string"?I.body=h:I.body=new P.$2K(h),I):m}return m}})}createCommentController(m,S,k){const h=r.a++,w=new o(m,h,S,k);this.b.set(w.handle,w);const I=this.c.get(m.identifier)||[];return I.push(w),this.c.set(m.identifier,I),w.value}async $createCommentThreadTemplate(m,S,k){const h=this.b.get(m);h&&h.$createCommentThreadTemplate(S,k)}async $updateCommentThreadTemplate(m,S,k){const h=this.b.get(m);h&&h.$updateCommentThreadTemplate(S,k)}$deleteCommentThread(m,S){this.b.get(m)?.$deleteCommentThread(S)}$provideCommentingRanges(m,S,k){const h=this.b.get(m);if(!h||!h.commentingRangeProvider)return Promise.resolve(void 0);const w=t.getDocument(R.URI.revive(S));return(0,y.$Qg)(async()=>{const I=await h.commentingRangeProvider.provideCommentingRanges(w,k);let L;return Array.isArray(I)?L={ranges:I,fileComments:!1}:I?L={ranges:I.ranges||[],fileComments:I.fileComments||!1}:L=I??void 0,L}).then(I=>{let L;return I&&(L={ranges:I.ranges.map(V=>f.Range.from(V)),fileComments:I.fileComments}),L})}$toggleReaction(m,S,k,h,w){const I=this.b.get(m);return!I||!I.reactionHandler?Promise.resolve(void 0):(0,y.$Qg)(()=>{const L=I.getCommentThread(S);if(L){const V=L.getCommentByUniqueId(h.uniqueIdInThread);if(I!==void 0&&V&&I.reactionHandler)return I.reactionHandler(V,s(w))}return Promise.resolve(void 0)})}}class c{static{this.a=0}set threadId(m){this.n=m}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(m){(m===void 0!=(this.p===void 0)||!m||!this.p||!m.isEqual(this.p))&&(this.p=m,this.b.range=m,this.c.fire())}get range(){return this.p}set canReply(m){this.d!==m&&(this.d=m,this.b.canReply=m,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(m){this.e=m,this.b.label=m,this.c.fire()}get contextValue(){return this.f}set contextValue(m){this.f=m,this.b.contextValue=m,this.c.fire()}get comments(){return this.q}set comments(m){this.q=m,this.b.comments=m,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(m){this.g=m,this.b.collapsibleState=m,this.c.fire()}get state(){return this.h}set state(m){this.h=m,this.b.state=m,this.c.fire()}get isDisposed(){return this.j}constructor(m,S,k,h,w,I,L,V){this.m=S,this.n=k,this.o=h,this.p=w,this.q=I,this.extensionDescription=L,this.r=V,this.handle=c.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new A.$Rd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new M.$Sc,this.l.value=new M.$Qc,this.n===void 0&&(this.n=`${m}.${this.handle}`),i.$createCommentThread(S,this.handle,this.n,this.o,f.Range.from(this.p),L.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=I,this.i.push({dispose:()=>{i.$deleteCommentThread(S,this.handle)}});const Y=this;this.value={get uri(){return Y.uri},get range(){return Y.range},set range(U){Y.range=U},get comments(){return Y.comments},set comments(U){Y.comments=U},get collapsibleState(){return Y.collapsibleState},set collapsibleState(U){Y.collapsibleState=U},get canReply(){return Y.canReply},set canReply(U){Y.canReply=U},get contextValue(){return Y.contextValue},set contextValue(U){Y.contextValue=U},get label(){return Y.label},set label(U){Y.label=U},get state(){return Y.state},set state(U){Y.state=U},dispose:()=>{Y.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new M.$Qc);const m=k=>Object.prototype.hasOwnProperty.call(this.b,k),S={};m("range")&&(S.range=f.Range.from(this.p)),m("label")&&(S.label=this.label),m("contextValue")&&(S.contextValue=this.contextValue??null),m("comments")&&(S.comments=this.q.map(k=>l(this,k,this.k,this.extensionDescription))),m("collapsibleState")&&(S.collapseState=a(this.g)),m("canReply")&&(S.canReply=this.canReply),m("state")&&(S.state=d(this.h)),m("isTemplate")&&(S.isTemplate=this.r),this.b={},i.$updateCommentThread(this.m,this.handle,this.n,this.o,S)}getCommentByUniqueId(m){for(const S of this.k){const k=S[0],h=S[1];if(m===h)return k}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(m=>m.dispose())}}Ke([(0,F.$oh)(100)],c.prototype,"eventuallyUpdateCommentThread",null);class o{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(m){this.b=m,i.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(m){this.c=m,i.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!m})}get options(){return this.d}set options(m){this.d=m,i.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(m,S,k,h){this.f=m,this.g=S,this.h=k,this.i=h,this.a=new Map,i.$registerCommentController(this.handle,k,h,this.f.identifier.value);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(I){w.options=I},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(I){w.commentingRangeProvider=I},get reactionHandler(){return w.reactionHandler},set reactionHandler(I){w.reactionHandler=I},createCommentThread(I,L,V){return w.createCommentThread(I,L,V).value},dispose:()=>{w.dispose()}}),this.e=[],this.e.push({dispose:()=>{i.$unregisterCommentController(this.handle)}})}createCommentThread(m,S,k){S===void 0&&(0,u.$NF)(this.f,"fileComments");const h=new c(this.id,this.handle,void 0,m,S,k,this.f,!1);return this.a.set(h.handle,h),h}$createCommentThreadTemplate(m,S){const k=new c(this.id,this.handle,void 0,R.URI.revive(m),f.Range.to(S),[],this.f,!0);return k.collapsibleState=$.CommentThreadCollapsibleState.Expanded,this.a.set(k.handle,k),k}$updateCommentThreadTemplate(m,S){const k=this.a.get(m);k&&(k.range=f.Range.to(S))}$deleteCommentThread(m){this.a.get(m)?.dispose(),this.a.delete(m)}getCommentThread(m){return this.a.get(m)}dispose(){this.a.forEach(m=>{m.dispose()}),this.e.forEach(m=>m.dispose())}}function l(p,m,S,k){let h=S.get(m);return h||(h=++p.commentHandle,S.set(m,h)),m.state!==void 0&&(0,u.$NF)(k,"commentsDraftState"),{mode:m.mode,contextValue:m.contextValue,uniqueIdInThread:h,body:typeof m.body=="string"?m.body:f.MarkdownString.from(m.body),userName:m.author.name,userIconPath:m.author.iconPath,label:m.label,commentReactions:m.reactions?m.reactions.map(w=>n(w)):void 0,state:m.state,timestamp:m.timestamp?.toJSON()}}function n(p){return{label:p.label,iconPath:p.iconPath?f.$AM(p.iconPath):void 0,count:p.count,hasReacted:p.authorHasReacted}}function s(p){return{label:p.label||"",count:p.count||0,iconPath:p.iconPath?R.URI.revive(p.iconPath):"",authorHasReacted:p.hasReacted||!1}}function a(p){if(p!==void 0)switch(p){case P.CommentThreadCollapsibleState.Expanded:return $.CommentThreadCollapsibleState.Expanded;case P.CommentThreadCollapsibleState.Collapsed:return $.CommentThreadCollapsibleState.Collapsed}return $.CommentThreadCollapsibleState.Collapsed}function d(p){if(p!==void 0)switch(p){case P.CommentThreadState.Unresolved:return $.CommentThreadState.Unresolved;case P.CommentThreadState.Resolved:return $.CommentThreadState.Resolved}return $.CommentThreadState.Unresolved}return new r}e.$3dc=b}),define(Ae[241],Re([1,0,26,3,27,17]),function(we,e,y,F,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qfc=void 0;let R=class{constructor(P,D){this.a=P.getProxy(F.$zK.MainThreadConsole),this.b=D.consoleForward.includeStack,this.c=D.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(P,D){const u=this,b=console[P];Object.defineProperty(console,P,{set:()=>{},get:()=>function(){u.e(P,D,b,arguments)}})}e(P,D,u,b){this.a.$logExtensionHostMessage({type:"__$console",severity:D,arguments:E(b,this.b)}),this.c&&this.f(P,u,b)}};e.$Qfc=R,e.$Qfc=R=Ke([Ve(0,M.$BM),Ve(1,A.$RM)],R);const $=1e5;function E(f,P){const D=[];if(f.length)for(let u=0;u<f.length;u++){let b=f[u];if(typeof b>"u")b="undefined";else if(b instanceof Error){const v=b;v.stack?b=v.stack:b=v.toString()}D.push(b)}if(P){const u=new Error().stack;u&&D.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,y.$fn)(D);return u.length>$?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Ae[110],Re([1,0,2,3,7,4,17,15,18,12,20,23]),function(we,e,y,F,A,M,R,$,E,f,P,D){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Tec=e.$Sec=void 0;let b=class{static{u=this}static{this.c=0}static{this.d=250}constructor(g,t){this.h=t,this.f=new Map,this.g=g.getProxy(F.$zK.MainThreadDecorations)}registerFileDecorationProvider(g,t){const i=u.c++;this.f.set(i,{provider:g,extensionDescription:t}),this.g.$registerDecorationProvider(i,t.identifier.value);const r=g.onDidChangeFileDecorations&&g.onDidChangeFileDecorations(c=>{if(!c){this.g.$onDidChange(i,null);return}const o=(0,E.$2b)(c);if(o.length<=u.d){this.g.$onDidChange(i,o);return}this.h.warn("[Decorations] CAPPING events from decorations provider",t.identifier.value,o.length);const l=o.map(a=>({uri:a,rank:(0,f.$Ke)(a.path,"/")})),n=(0,E.$yb)(l,(a,d)=>a.rank-d.rank||(0,f.$Ye)(a.uri.path,d.uri.path)),s=[];e:for(const a of n){let d;for(const p of a){const m=(0,P.$lc)(p.uri.path);if(d!==m&&(d=m,s.push(p.uri)>=u.d))break e}}this.g.$onDidChange(i,s)});return new A.$BK(()=>{r?.dispose(),this.g.$unregisterDecorationProvider(i),this.f.delete(i)})}async $provideDecorations(g,t,i){if(!this.f.has(g))return Object.create(null);const r=Object.create(null),{provider:c,extensionDescription:o}=this.f.get(g);return await Promise.all(t.map(async l=>{try{const{uri:n,id:s}=l,a=await Promise.resolve(c.provideFileDecoration(y.URI.revive(n),i));if(!a)return;try{A.$WL.validate(a),a.badge&&typeof a.badge!="string"&&(0,D.$NF)(o,"codiconDecoration"),r[s]=[a.propagate,a.tooltip,a.badge,a.color]}catch(d){this.h.warn(`INVALID decoration from extension '${o.identifier.value}': ${d}`)}}catch(n){this.h.error(n)}})),r}};e.$Sec=b,e.$Sec=b=u=Ke([Ve(0,R.$BM),Ve(1,$.$dj)],b),e.$Tec=(0,M.$Vh)("IExtHostDecorations")}),define(Ae[242],Re([1,0,158,98,2,3,7,8,5,15,28,42]),function(we,e,y,F,A,M,R,$,E,f,P,D){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ndc=e.$Mdc=void 0;class b{#e;#t;#i;constructor(t,i,r,c,o,l,n,s){this.d=t,this.e=i,this.f=r,this.g=c,this.h=o,this.c=!1,this.f=Math.max(c,r),this.#i=new P.$zc(a=>l.getComparisonKey(a)),this.#e=n,this.#t=s}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(t,i){if(!t){this.clear();return}this.j();let r=[];if(A.URI.isUri(t)){if(!i){this.delete(t);return}this.#i.set(t,i.slice()),r=[t]}else if(Array.isArray(t)){r=[];let l;t=[...t].sort(b.k);for(const n of t){const[s,a]=n;if((!l||s.toString()!==l.toString())&&(l&&this.#i.get(l).length===0&&this.#i.delete(l),l=s,r.push(s),this.#i.set(s,[])),a)this.#i.get(s)?.push(...a);else{const d=this.#i.get(s);d&&(d.length=0)}}}if(this.#t.fire(r),!this.#e)return;const c=[];let o=0;for(const l of r){let n=[];const s=this.#i.get(l);if(s)if(s.length>this.g){n=[];const a=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let d=0;d<4;d++)for(const p of s)if(p.severity===a[d]&&n.push({...$.Diagnostic.from(p),modelVersionId:this.h(l)})===this.g)break e;n.push({severity:F.MarkerSeverity.Info,message:(0,y.localize)(0,null,s.length-this.g),startLineNumber:n[n.length-1].startLineNumber,startColumn:n[n.length-1].startColumn,endLineNumber:n[n.length-1].endLineNumber,endColumn:n[n.length-1].endColumn})}else n=s.map(a=>({...$.Diagnostic.from(a),modelVersionId:this.h(l)}));if(c.push([l,n]),o+=n.length,o>this.f)break}this.#e.$changeMany(this.e,c)}delete(t){this.j(),this.#t.fire([t]),this.#i.delete(t),this.#e?.$changeMany(this.e,[[t,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(t,i){this.j();for(const[r,c]of this)t.call(i,r,c,this)}*[Symbol.iterator](){this.j();for(const t of this.#i.keys())yield[t,this.get(t)]}get(t){this.j();const i=this.#i.get(t);return Array.isArray(i)?Object.freeze(i.slice(0)):[]}has(t){return this.j(),Array.isArray(this.#i.get(t))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(t,i){return t[0].toString()<i[0].toString()?-1:t[0].toString()>i[0].toString()?1:0}}e.$Mdc=b;let v=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*u.d}static _mapper(t){const i=new P.$zc;for(const r of t)i.set(r,r);return{uris:Object.freeze(Array.from(i.values()))}}constructor(t,i,r,c){this.j=i,this.k=r,this.l=c,this.g=new Map,this.h=new E.$Vd({merge:o=>o.flat(),delay:50}),this.onDidChangeDiagnostics=E.Event.map(this.h.event,u._mapper),this.f=t.getProxy(M.$zK.MainThreadDiagnostics)}createDiagnosticCollection(t,i){const{g:r,f:c,h:o,j:l,k:n,l:s}=this,a=new class{$changeMany(m,S){c.$changeMany(m,S),l.trace("[DiagnosticCollection] change many (extension, owner, uris)",t.value,m,S.length===0?"CLEARING":S)}$clear(m){c.$clear(m),l.trace("[DiagnosticCollection] remove all (extension, owner)",t.value,m)}dispose(){c.dispose()}};let d;if(!i)i="_generated_diagnostic_collection_name_#"+u.c++,d=i;else if(!r.has(i))d=i;else{this.j.warn(`DiagnosticCollection with name '${i}' does already exist.`);do d=i+u.c++;while(r.has(d))}return new class extends b{constructor(){super(i,d,u.e,u.d,m=>s.getDocument(m)?.version,n.extUri,a,o),r.set(d,this)}dispose(){super.dispose(),r.delete(d)}}}getDiagnostics(t){if(t)return this.m(t);{const i=new Map,r=[];for(const c of this.g.values())c.forEach((o,l)=>{let n=i.get(o.toString());typeof n>"u"&&(n=r.length,i.set(o.toString(),n),r.push([o,[]])),r[n][1]=r[n][1].concat(...l)});return r}}m(t){let i=[];for(const r of this.g.values())r.has(t)&&(i=i.concat(r.get(t)));return i}$acceptMarkersChange(t){if(!this.n){const i="_generated_mirror",r=new b(i,i,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,c=>{},this.k.extUri,void 0,this.h);this.g.set(i,r),this.n=r}for(const[i,r]of t)this.n.set(A.URI.revive(i),r.map($.Diagnostic.to))}};e.$Ndc=v,e.$Ndc=v=u=Ke([Ve(1,f.$dj),Ve(2,D.$Ldc)],v)}),define(Ae[243],Re([1,0,2,3,23]),function(we,e,y,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uec=void 0;class M{constructor($){this.a=$.getProxy(F.$zK.MainThreadDialogs)}showOpenDialog($,E){return E?.allowUIResources&&(0,A.$NF)($,"showLocal"),this.a.$showOpenDialog(E).then(f=>f?f.map(P=>y.URI.revive(P)):void 0)}showSaveDialog($){return this.a.$showSaveDialog($).then(E=>E?y.URI.revive(E):void 0)}}e.$Uec=M}),define(Ae[244],Re([1,0,11,2,7,3,13,19,12]),function(we,e,y,F,A,M,R,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vec=void 0;class f{static{this.a=0}constructor(D,u,b){this.d=u,this.e=b,this.b=new Map,this.c=D.getProxy(M.$zK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,u){if(Object.keys(R.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const b=f.a++;this.b.set(b,u),this.c.$registerTextContentProvider(b,D);let v;return typeof u.onDidChange=="function"&&(v=u.onDidChange(g=>{if(g.scheme!==D){this.e.warn(`Provider for scheme '${D}' is firing event for schema '${g.scheme}' which will be IGNORED`);return}this.d.getDocument(g)&&this.$provideTextDocumentContent(b,g).then(t=>{if(!t&&typeof t!="string")return;const i=this.d.getDocument(g);if(!i)return;const r=(0,E.$Te)(t);if(!i.equalLines(r))return this.c.$onVirtualDocumentChange(g,t)},y.$Z)})),new A.$BK(()=>{this.b.delete(b)&&this.c.$unregisterTextContentProvider(b),v&&(v.dispose(),v=void 0)})}$provideTextDocumentContent(D,u){const b=this.b.get(D);return b?Promise.resolve(b.provideTextDocumentContent(F.URI.revive(u),$.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$Vec=f}),define(Ae[245],Re([1,0,5,6,2,3,103,8,16,26,7,11]),function(we,e,y,F,A,M,R,$,E,f,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jdc=void 0;class u{constructor(v,g){this.a=new y.$Rd({onListenerError:D.$1}),this.b=new y.$Rd({onListenerError:D.$1}),this.c=new y.$Rd({onListenerError:D.$1}),this.d=new y.$Rd({onListenerError:D.$1}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new F.$Qc,this.h=new Map,this.f=v.getProxy(M.$zK.MainThreadDocuments),this.g=g,this.g.onDidRemoveDocuments(t=>{for(const i of t)this.b.fire(i.document)},void 0,this.e),this.g.onDidAddDocuments(t=>{for(const i of t)this.a.fire(i.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(v){if(!v)return;const g=this.g.getDocument(v);if(g)return g}getDocument(v){const g=this.getDocumentData(v);if(!g?.document)throw new Error(`Unable to retrieve document from URI '${v}'`);return g.document}ensureDocumentData(v){const g=this.g.getDocument(v);if(g)return Promise.resolve(g);let t=this.h.get(v.toString());return t||(t=this.f.$tryOpenDocument(v).then(i=>{this.h.delete(v.toString());const r=A.URI.revive(i);return(0,E.$Nf)(this.g.getDocument(r))},i=>(this.h.delete(v.toString()),Promise.reject(i))),this.h.set(v.toString(),t)),t}createDocumentData(v){return this.f.$tryCreateDocument(v).then(g=>A.URI.revive(g))}$acceptModelLanguageChanged(v,g){const t=A.URI.revive(v),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");this.b.fire(i.document),i._acceptLanguageId(g),this.a.fire(i.document)}$acceptModelSaved(v){const g=A.URI.revive(v),t=this.g.getDocument(g);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged(v,!1),this.d.fire(t.document)}$acceptDirtyStateChanged(v,g){const t=A.URI.revive(v),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");i._acceptIsDirty(g),this.c.fire({document:i.document,contentChanges:[],reason:void 0})}$acceptModelChanged(v,g,t){const i=A.URI.revive(v),r=this.g.getDocument(i);if(!r)throw new Error("unknown document");r._acceptIsDirty(t),r.onEvents(g);let c;g.isUndoing?c=P.TextDocumentChangeReason.Undo:g.isRedoing&&(c=P.TextDocumentChangeReason.Redo),this.c.fire((0,f.$bn)({document:r.document,contentChanges:g.changes.map(o=>({range:$.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:c}))}setWordDefinitionFor(v,g){(0,R.$DM)(v,g)}}e.$Jdc=u}),define(Ae[61],Re([1,0,53,5,6,2,4,3,103,17,109,8,15,28,13,67,44]),function(we,e,y,F,A,M,R,$,E,f,P,D,u,b,v,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MM=e.$LM=void 0;class i{constructor(o){this.value=o,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let r=class{constructor(o,l){this.h=o,this.i=l,this.a=null,this.b=new Map,this.c=new b.$zc,this.d=new F.$Rd,this.e=new F.$Rd,this.f=new F.$Rd,this.g=new F.$Rd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(o){this.acceptDocumentsAndEditorsDelta(o)}acceptDocumentsAndEditorsDelta(o){const l=[],n=[],s=[];if(o.removedDocuments)for(const a of o.removedDocuments){const d=M.URI.revive(a),p=this.c.get(d);p?.unref()&&(this.c.delete(d),l.push(p.value))}if(o.addedDocuments)for(const a of o.addedDocuments){const d=M.URI.revive(a.uri);let p=this.c.get(d);if(p&&d.scheme!==v.Schemas.vscodeNotebookCell&&d.scheme!==v.Schemas.vscodeInteractiveInput)throw new Error(`document '${d} already exists!'`);p||(p=new i(new E.$EM(this.h.getProxy($.$zK.MainThreadDocuments),d,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty,a.notebook)),this.c.set(d,p),n.push(p.value)),p.ref()}if(o.removedEditors)for(const a of o.removedEditors){const d=this.b.get(a);this.b.delete(a),d&&s.push(d)}if(o.addedEditors)for(const a of o.addedEditors){const d=M.URI.revive(a.documentUri);y.ok(this.c.has(d),`document '${d}' does not exist`),y.ok(!this.b.has(a.id),`editor '${a.id}' already exists!`);const p=this.c.get(d).value,m=new P.$KM(a.id,this.h.getProxy($.$zK.MainThreadTextEditors),this.i,new t.$U(()=>p.document),a.selections.map(D.Selection.to),a.options,a.visibleRanges.map(S=>D.Range.to(S)),typeof a.editorPosition=="number"?D.ViewColumn.to(a.editorPosition):void 0);this.b.set(a.id,m)}o.newActiveEditor!==void 0&&(y.ok(o.newActiveEditor===null||this.b.has(o.newActiveEditor),`active editor '${o.newActiveEditor}' does not exist`),this.a=o.newActiveEditor),(0,A.$Mc)(l),(0,A.$Mc)(s),o.removedDocuments&&this.e.fire(l),o.addedDocuments&&this.d.fire(n),(o.removedEditors||o.addedEditors)&&this.f.fire(this.allEditors().map(a=>a.value)),o.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(o){return this.c.get(o)?.value}allDocuments(){return g.Iterable.map(this.c.values(),o=>o.value)}getEditor(o){return this.b.get(o)}activeEditor(o){if(!this.a)return;const l=this.b.get(this.a);return o?l:l?.value}allEditors(){return[...this.b.values()]}};e.$LM=r,e.$LM=r=Ke([Ve(0,f.$BM),Ve(1,u.$dj)],r),e.$MM=(0,R.$Vh)("IExtHostDocumentsAndEditors")}),define(Ae[62],Re([1,0,246,5,16,2,4,3,17,8,7]),function(we,e,y,F,A,M,R,$,E,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kec=e.$jec=void 0,e.$jec=(0,R.$Vh)("IExtHostEditorTabs");class D{constructor(t,i,r){this.e=r,this.d=i,this.acceptDtoUpdate(t)}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.id===t.e()},get label(){return t.b.label},get input(){return t.c},get isDirty(){return t.b.isDirty},get isPinned(){return t.b.isPinned},get isPreview(){return t.b.isPreview},get group(){return t.d.apiObject}};this.a=Object.freeze(i)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(t){this.b=t,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new P.$gM(M.URI.revive(this.b.input.uri));case 2:return new P.$hM(M.URI.revive(this.b.input.original),M.URI.revive(this.b.input.modified));case 3:return new P.$iM(M.URI.revive(this.b.input.base),M.URI.revive(this.b.input.input1),M.URI.revive(this.b.input.input2),M.URI.revive(this.b.input.result));case 6:return new P.$jM(M.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new P.$kM(this.b.input.viewType);case 4:return new P.$lM(M.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new P.$mM(M.URI.revive(this.b.input.original),M.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new P.$nM;case 9:return new P.$oM(M.URI.revive(this.b.input.uri),M.URI.revive(this.b.input.inputBoxUri));case 10:return new P.$pM(this.b.input.providerId);default:return}}}class u{constructor(t,i){this.c=[],this.d="",this.b=t,this.e=i;for(const r of t.tabs)r.isActive&&(this.d=r.id),this.c.push(new D(r,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.groupId===t.e()},get viewColumn(){return f.ViewColumn.to(t.b.viewColumn)},get activeTab(){return t.c.find(r=>r.tabId===t.d)?.apiObject},get tabs(){return Object.freeze(t.c.map(r=>r.apiObject))}};this.a=Object.freeze(i)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(t){this.b=t}acceptTabOperation(t){if(t.kind===0){const r=new D(t.tabDto,this,()=>this.activeTabId());return this.c.splice(t.index,0,r),t.tabDto.isActive&&(this.d=r.tabId),r}else if(t.kind===1){const r=this.c.splice(t.index,1)[0];if(!r)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return r.tabId===this.d&&(this.d=""),r}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const r=this.c.splice(t.oldIndex,1)[0];if(!r)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this.c.splice(t.index,0,r),r}const i=this.c.find(r=>r.tabId===t.tabDto.id);if(!i)throw new Error("INVALID tab");return t.tabDto.isActive?this.d=t.tabDto.id:this.d===t.tabDto.id&&!t.tabDto.isActive&&(this.d=""),i.acceptDtoUpdate(t.tabDto),i}activeTabId(){return this.d}}let b=class{constructor(t){this.b=new F.$Rd,this.c=new F.$Rd,this.e=[],this.a=t.getProxy($.$zK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const t=this,i={onDidChangeTabGroups:t.c.event,onDidChangeTabs:t.b.event,get all(){return Object.freeze(t.e.map(r=>r.apiObject))},get activeTabGroup(){const r=t.d;return(0,A.$Nf)(t.e.find(o=>o.groupId===r)?.apiObject)},close:async(r,c)=>{const o=Array.isArray(r)?r:[r];return o.length?v(o[0])?this.j(o,c):this.i(o,c):!0}};this.f=Object.freeze(i)}return this.f}$acceptEditorTabModel(t){const i=new Set(this.e.map(a=>a.groupId)),r=new Set(t.map(a=>a.groupId)),c=(0,y.$K)(i,r),o=this.e.filter(a=>c.removed.includes(a.groupId)).map(a=>a.apiObject),l=[],n=[];this.e=t.map(a=>{const d=new u(a,()=>this.d);return c.added.includes(d.groupId)?l.push(d.apiObject):n.push(d.apiObject),d});const s=(0,A.$Nf)(t.find(a=>a.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:l,closed:o,changed:n}))}$acceptTabGroupUpdate(t){const i=this.e.find(r=>r.groupId===t.groupId);if(!i)throw new Error("Update Group IPC call received before group creation.");i.acceptGroupDtoUpdate(t),t.isActive&&(this.d=t.groupId),this.c.fire(Object.freeze({changed:[i.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const i=this.e.find(c=>c.groupId===t.groupId);if(!i)throw new Error("Update Tabs IPC call received before group creation.");const r=i.acceptTabOperation(t);switch(t.kind){case 0:this.b.fire(Object.freeze({opened:[r.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[r.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[r.apiObject]}));return}}g(t){for(const i of this.e)for(const r of i.tabs)if(r.apiObject===t)return r}h(t){return this.e.find(i=>i.apiObject===t)}async i(t,i){const r=[];for(const c of t){const o=this.g(c);if(!o)throw new Error("Tab close: Invalid tab not found!");r.push(o.tabId)}return this.a.$closeTab(r,i)}async j(t,i){const r=[];for(const c of t){const o=this.h(c);if(!o)throw new Error("Group close: Invalid group not found!");r.push(o.groupId)}return this.a.$closeGroup(r,i)}};e.$kec=b,e.$kec=b=Ke([Ve(0,E.$BM)],b);function v(g){return g.tabs!==void 0}}),define(Ae[247],Re([1,0,3,7]),function(we,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xec=void 0;class A{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(y.$zK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,$,E){if(this.a.size===0)throw new Error("No embedding vector providers registered");const f=this.a.get(R);if(!f)throw new Error("Embedding vector provider not found");const P=await f.provideEmbeddingVector($,E);if(!P)throw new Error("Embedding vector provider returned undefined");return P}registerEmbeddingVectorProvider(R,$,E){const f=this.b;return this.b++,this.a.set(f,E),this.c.$registerAiEmbeddingVectorProvider($,f),new F.$BK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(f),this.a.delete(f)})}}e.$Xec=A}),define(Ae[248],Re([1,0,2,3,6,7,8,296,12,24,23,52]),function(we,e,y,F,A,M,R,$,E,f,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yec=void 0;class u{constructor(){this.a=[]}add(g){this.b=void 0,this.a.push(g)}delete(g){const t=this.a.indexOf(g);t>=0&&(this.a.splice(t,1),this.b=void 0)}c(){if(!this.b){const g=this.a.sort(),t=[];let i,r,c=14,o=14;for(const l of g){let n=i?(0,E.$8e)(i,l):0;for(n===0?r=1:r=o;n<l.length;n++)n+1===l.length?(c=o,o=9):o+=1,t.push([r,l.toUpperCase().charCodeAt(n),o]),t.push([r,l.toLowerCase().charCodeAt(n),o]),r=o;i=l,o=c}t.push([9,58,10]),t.push([10,47,12]),this.b=new $.$3Y(t)}}provideDocumentLinks(g){this.c();const t=[],i=$.$4Y.computeLinks({getLineContent(r){return g.lineAt(r-1).text},getLineCount(){return g.lineCount}},this.b);for(const r of i){const c=R.DocumentLink.to(r);c.target&&t.push(c)}return t}}class b{constructor(g,t){this.i=t,this.b=new u,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=g.getProxy(F.$zK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(g,t,i,r={}){if(b.j(i),this.d.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(g,"*",this.b));const c=this.h++;this.b.add(t),this.d.add(t),this.c.set(c,i);let o=2;r.isCaseSensitive&&(o+=1024),r.isReadonly&&(o+=2048),typeof i.copy=="function"&&(o+=8),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,P.$NF)(g,"fsChunks"),o+=4);let l;r.isReadonly&&(0,D.$$j)(r.isReadonly)&&((0,P.$NF)(g,"readonlyMessage"),l={value:r.isReadonly.value,isTrusted:r.isReadonly.isTrusted,supportThemeIcons:r.isReadonly.supportThemeIcons,supportHtml:r.isReadonly.supportHtml,baseUri:r.isReadonly.baseUri,uris:r.isReadonly.uris}),this.a.$registerFileSystemProvider(c,t,o,l).catch(s=>{console.error(`FAILED to register filesystem provider of ${g.identifier.value}-extension for the scheme ${t}`),console.error(s)});const n=i.onDidChangeFile(s=>{const a=[];for(const d of s){const{uri:p,type:m}=d;if(p.scheme!==t)continue;let S;switch(m){case M.FileChangeType.Changed:S=0;break;case M.FileChangeType.Created:S=1;break;case M.FileChangeType.Deleted:S=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:p,type:S})}this.a.$onFileSystemChange(c,a)});return(0,A.$Pc)(()=>{n.dispose(),this.b.delete(t),this.d.delete(t),this.c.delete(c),this.a.$unregisterProvider(c)})}static j(g){if(!g)throw new Error("MISSING provider");if(typeof g.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof g.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof g.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof g.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof g.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof g.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof g.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof g.rename!="function")throw new Error("Provider does NOT implement rename")}static k(g){const{type:t,ctime:i,mtime:r,size:c,permissions:o}=g;return{type:t,ctime:i,mtime:r,size:c,permissions:o}}$stat(g,t){return Promise.resolve(this.l(g).stat(y.URI.revive(t))).then(i=>b.k(i))}$readdir(g,t){return Promise.resolve(this.l(g).readDirectory(y.URI.revive(t)))}$readFile(g,t){return Promise.resolve(this.l(g).readFile(y.URI.revive(t))).then(i=>f.$fe.wrap(i))}$writeFile(g,t,i,r){return Promise.resolve(this.l(g).writeFile(y.URI.revive(t),i.buffer,r))}$delete(g,t,i){return Promise.resolve(this.l(g).delete(y.URI.revive(t),i))}$rename(g,t,i,r){return Promise.resolve(this.l(g).rename(y.URI.revive(t),y.URI.revive(i),r))}$copy(g,t,i,r){const c=this.l(g);if(!c.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(c.copy(y.URI.revive(t),y.URI.revive(i),r))}$mkdir(g,t){return Promise.resolve(this.l(g).createDirectory(y.URI.revive(t)))}$watch(g,t,i,r){const c=this.l(g).watch(y.URI.revive(i),r);this.f.set(t,c)}$unwatch(g,t){const i=this.f.get(t);i&&(i.dispose(),this.f.delete(t))}$open(g,t,i){const r=this.l(g);if(!r.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(r.open(y.URI.revive(t),i))}$close(g,t){const i=this.l(g);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(t))}$read(g,t,i,r){const c=this.l(g);if(!c.read)throw new Error('FileSystemProvider does not implement "read"');const o=f.$fe.alloc(r);return Promise.resolve(c.read(t,i,o.buffer,0,r)).then(l=>o.slice(0,l))}$write(g,t,i,r){const c=this.l(g);if(!c.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(c.write(t,i,r.buffer,0,r.byteLength))}l(g){const t=this.c.get(g);if(!t){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return t}}e.$Yec=b}),define(Ae[63],Re([1,0,3,41,7,24,4,17,42,6,14,25,13]),function(we,e,y,F,A,M,R,$,E,f,P,D,u){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$_dc=e.$$dc=void 0;let v=b=class{constructor(t,i){this.b=new Map,this.c=new P.$7g,this.a=t.getProxy(y.$zK.MainThreadFileSystem);const r=this;this.value=Object.freeze({async stat(c){try{let o;const l=r.b.get(c.scheme);return l?(await r.a.$ensureActivation(c.scheme),o=await l.impl.stat(c)):o=await r.a.$stat(c),{type:o.type,ctime:o.ctime,mtime:o.mtime,size:o.size,permissions:o.permissions===F.FilePermission.Readonly?1:void 0}}catch(o){b.e(o)}},async readDirectory(c){try{const o=r.b.get(c.scheme);return o?(await r.a.$ensureActivation(c.scheme),(await o.impl.readDirectory(c)).slice()):await r.a.$readdir(c)}catch(o){return b.e(o)}},async createDirectory(c){try{const o=r.b.get(c.scheme);return o&&!o.isReadonly?(await r.a.$ensureActivation(c.scheme),await r.d(o.impl,o.extUri,c)):await r.a.$mkdir(c)}catch(o){return b.e(o)}},async readFile(c){try{const o=r.b.get(c.scheme);return o?(await r.a.$ensureActivation(c.scheme),(await o.impl.readFile(c)).slice()):(await r.a.$readFile(c)).buffer}catch(o){return b.e(o)}},async writeFile(c,o){try{const l=r.b.get(c.scheme);return l&&!l.isReadonly?(await r.a.$ensureActivation(c.scheme),await r.d(l.impl,l.extUri,l.extUri.dirname(c)),await r.c.queueFor(c).queue(()=>Promise.resolve(l.impl.writeFile(c,o,{create:!0,overwrite:!0})))):await r.a.$writeFile(c,M.$fe.wrap(o))}catch(l){return b.e(l)}},async delete(c,o){try{const l=r.b.get(c.scheme);return l&&!l.isReadonly?(await r.a.$ensureActivation(c.scheme),await l.impl.delete(c,{recursive:!1,...o})):await r.a.$delete(c,{recursive:!1,useTrash:!1,atomic:!1,...o})}catch(l){return b.e(l)}},async rename(c,o,l){try{return await r.a.$rename(c,o,{overwrite:!1,...l})}catch(n){return b.e(n)}},async copy(c,o,l){try{return await r.a.$copy(c,o,{overwrite:!1,...l})}catch(n){return b.e(n)}},isWritableFileSystem(c){const o=i.getCapabilities(c);if(typeof o=="number")return!(o&2048)}})}async d(t,i,r){const c=[];for(;!i.isEqual(r,i.dirname(r));)try{if(!((await t.stat(r)).type&F.FileType.Directory))throw A.$OL.FileExists(`Unable to create folder '${r.scheme===u.Schemas.file?r.fsPath:r.toString(!0)}' that already exists but is not a directory`);break}catch(o){if(F.$uk(o)!==F.FileSystemProviderErrorCode.FileNotFound)throw o;c.push(i.basename(r)),r=i.dirname(r)}for(let o=c.length-1;o>=0;o--){r=i.joinPath(r,c[o]);try{await t.createDirectory(r)}catch(l){if(F.$uk(l)!==F.FileSystemProviderErrorCode.FileExists)throw l}}}static e(t){if(t instanceof A.$OL)throw t;if(t instanceof F.$qk)switch(t.code){case F.FileSystemProviderErrorCode.FileExists:throw A.$OL.FileExists(t.message);case F.FileSystemProviderErrorCode.FileNotFound:throw A.$OL.FileNotFound(t.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw A.$OL.FileNotADirectory(t.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw A.$OL.FileIsADirectory(t.message);case F.FileSystemProviderErrorCode.NoPermissions:throw A.$OL.NoPermissions(t.message);case F.FileSystemProviderErrorCode.Unavailable:throw A.$OL.Unavailable(t.message);default:throw new A.$OL(t.message,t.name)}if(!(t instanceof Error))throw new A.$OL(String(t));if(t.name==="ENOPRO"||t.message.includes("ENOPRO"))throw A.$OL.Unavailable(t.message);switch(t.name){case F.FileSystemProviderErrorCode.FileExists:throw A.$OL.FileExists(t.message);case F.FileSystemProviderErrorCode.FileNotFound:throw A.$OL.FileNotFound(t.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw A.$OL.FileNotADirectory(t.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw A.$OL.FileIsADirectory(t.message);case F.FileSystemProviderErrorCode.NoPermissions:throw A.$OL.NoPermissions(t.message);case F.FileSystemProviderErrorCode.Unavailable:throw A.$OL.Unavailable(t.message);default:throw new A.$OL(t.message,t.name)}}addFileSystemProvider(t,i,r){return this.b.set(t,{impl:i,extUri:r?.isCaseSensitive?D.$pg:D.$rg,isReadonly:!!r?.isReadonly}),(0,f.$Pc)(()=>this.b.delete(t))}getFileSystemProviderExtUri(t){return this.b.get(t)?.extUri??D.$pg}};e.$$dc=v,e.$$dc=v=b=Ke([Ve(0,$.$BM),Ve(1,E.$Ldc)],v),e.$_dc=(0,R.$Vh)("IExtHostConsumerFileSystem")}),define(Ae[249],Re([1,0,5,33,2,3,8,7,44]),function(we,e,y,F,A,M,R,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zec=void 0;class f{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(b,v,g,t,i,r){this.a=Math.random(),this.b=new y.$Rd,this.c=new y.$Rd,this.d=new y.$Rd,this.h=0,r?.ignoreCreateEvents&&(this.h+=1),r?.ignoreChangeEvents&&(this.h+=2),r?.ignoreDeleteEvents&&(this.h+=4);const c=(0,F.$Cj)(i),o=typeof i=="string",l=r?.correlate,n=t(s=>{if(!(typeof s.session=="number"&&s.session!==this.a)&&!(l&&typeof s.session>"u")){if(!r?.ignoreCreateEvents)for(const a of s.created){const d=A.URI.revive(a);c(d.fsPath)&&(!o||v.getWorkspaceFolder(d))&&this.b.fire(d)}if(!r?.ignoreChangeEvents)for(const a of s.changed){const d=A.URI.revive(a);c(d.fsPath)&&(!o||v.getWorkspaceFolder(d))&&this.c.fire(d)}if(!r?.ignoreDeleteEvents)for(const a of s.deleted){const d=A.URI.revive(a);c(d.fsPath)&&(!o||v.getWorkspaceFolder(d))&&this.d.fire(d)}}});this.g=$.$BK.from(this.i(b,g,i,r,r?.correlate),this.b,this.c,this.d,n)}i(b,v,g,t,i){const r=$.$BK.from();if(typeof g=="string")return r;const c=b.getProxy(M.$zK.MainThreadFileSystemEventService);let o=!1;return(g.pattern.includes(F.$yj)||g.pattern.includes(F.$zj))&&(o=!0),c.$watch(v.identifier.value,this.a,g.baseUri,{recursive:o,excludes:t?.excludes??[]},!!i),$.$BK.from({dispose:()=>c.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class P{constructor(b){this.a=b,this.session=this.a.session,this.b=new E.$U(()=>this.a.created.map(A.URI.revive)),this.c=new E.$U(()=>this.a.changed.map(A.URI.revive)),this.d=new E.$U(()=>this.a.deleted.map(A.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class D{constructor(b,v,g){this.j=b,this.k=v,this.l=g,this.a=new y.$Rd,this.b=new y.$Rd,this.c=new y.$Rd,this.d=new y.$Rd,this.g=new y.$Td,this.h=new y.$Td,this.i=new y.$Td,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(b,v,g,t){return new f(this.j,b,v,this.a.event,R.GlobPattern.from(g),t)}$onFileEvent(b){this.a.fire(new P(b))}$onDidRunFileOperation(b,v){switch(b){case 2:this.b.fire(Object.freeze({files:v.map(g=>({oldUri:A.URI.revive(g.source),newUri:A.URI.revive(g.target)}))}));break;case 1:this.d.fire(Object.freeze({files:v.map(g=>A.URI.revive(g.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:v.map(g=>A.URI.revive(g.target))}));break;default:}}getOnWillRenameFileEvent(b){return this.m(b,this.g)}getOnWillCreateFileEvent(b){return this.m(b,this.h)}getOnWillDeleteFileEvent(b){return this.m(b,this.i)}m(b,v){return(g,t,i)=>{const r=function(o){g.call(t,o)};return r.extension=b,v.event(r,void 0,i)}}async $onWillRunFileOperation(b,v,g,t){switch(b){case 2:return await this.n(this.g,{files:v.map(i=>({oldUri:A.URI.revive(i.source),newUri:A.URI.revive(i.target)}))},g,t);case 1:return await this.n(this.i,{files:v.map(i=>A.URI.revive(i.target))},g,t);case 0:case 3:return await this.n(this.h,{files:v.map(i=>A.URI.revive(i.target))},g,t)}}async n(b,v,g,t){const i=new Set,r=[];if(await b.fireAsync(v,t,async(o,l)=>{const n=Date.now(),s=await Promise.resolve(o);s instanceof $.$LK&&(r.push([l.extension,s]),i.add(l.extension.displayName??l.extension.identifier.value)),Date.now()-n>g&&this.k.warn("SLOW file-participant",l.extension.identifier)}),t.isCancellationRequested||r.length===0)return;const c={edits:[]};for(const[,o]of r){const{edits:l}=R.WorkspaceEdit.from(o,{getTextDocumentVersion:n=>this.l.getDocument(n)?.version,getNotebookDocumentVersion:()=>{}});c.edits=c.edits.concat(l)}return{edit:c,extensionNames:Array.from(i)}}}e.$Zec=D}),define(Ae[250],Re([1,0,6,2,3,8,7,32,14]),function(we,e,y,F,A,M,R,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ec=void 0;class f{static{this.a=0}constructor(b,v){this.extension=b,this.provider=v,this.handle=f.a++}}class P{constructor(b){this.session=b,this.responses=[]}}class D{static{this.a=0}constructor(b,v,g,t){this.f=g,this.g=t,this.b=new Map,this.d=new Map,this.e=b.getProxy(A.$zK.MainThreadInlineChat),v.registerApiCommand(new $.$2M("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new $.$ZM("Run arguments","",i=>!0,i=>{if(i)return{initialRange:i.initialRange?M.Range.from(i.initialRange):void 0,initialSelection:i.initialSelection?M.Selection.from(i.initialSelection):void 0,message:i.message,autoSend:i.autoSend,position:i.position?M.Position.from(i.position):void 0}})],$.$1M.Void))}registerProvider(b,v,g){const t=new f(b,v);return this.b.set(t.handle,t),this.e.$registerInteractiveEditorProvider(t.handle,g?.label??b.displayName??b.name,b.identifier.value,typeof v.handleInteractiveEditorResponseFeedback=="function",g?.supportReportIssue??!1),(0,y.$Pc)(()=>{this.e.$unregisterInteractiveEditorProvider(t.handle),this.b.delete(t.handle)})}async $prepareSession(b,v,g,t){const i=this.b.get(b);if(!i){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const r=this.f.getDocument(F.URI.revive(v)),c=M.Selection.to(g),o=await i.provider.prepareInteractiveEditorSession({document:r,selection:c},t);if(!o)return;if(o.wholeRange&&!o.wholeRange.contains(c))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const l=D.a++;return this.d.set(l,new P(o)),{id:l,placeholder:o.placeholder,input:o.input,slashCommands:o.slashCommands?.map(n=>({command:n.command,detail:n.detail,refer:n.refer,executeImmediately:n.executeImmediately})),wholeRange:M.Range.from(o.wholeRange),message:o.message}}async $provideResponse(b,v,g,t){const i=this.b.get(b);if(!i)return;const r=this.d.get(v.id);if(!r)return;const c={prompt:g.prompt,selection:M.Selection.to(g.selection),wholeRange:M.Range.to(g.wholeRange),attempt:g.attempt,live:g.live};let o=!1;const l={report:async p=>{if(!g.live&&p.edits?.length)throw new Error("Progress reporting is only supported for live sessions");o||t.isCancellationRequested||await this.e.$handleProgressChunk(g.requestId,{message:p.message,edits:p.edits?.map(M.TextEdit.from),editsShouldBeInstant:p.editsShouldBeInstant,slashCommand:p.slashCommand?.command,markdownFragment:R.$2K.isMarkdownString(p.content)?p.content.value:p.content})}},n=Promise.resolve(i.provider.provideInteractiveEditorResponse(r.session,c,l,t));let s;try{s=await(0,E.$Mg)(n,t)}finally{o=!0}if(!s)return;const a=r.responses.push(s)-1,d={wholeRange:M.Range.from(s.wholeRange),placeholder:s.placeholder};if(D.h(s)){const{edits:p,contents:m}=s,S=m!==void 0?M.MarkdownString.from(m):void 0;return p instanceof R.$LK?{...d,id:a,type:"bulkEdit",edits:M.WorkspaceEdit.from(p),message:S}:{...d,id:a,type:"editorEdit",edits:p.map(M.TextEdit.from),message:S}}return{...d,id:a,type:"message",message:M.MarkdownString.from(s.contents)}}$handleFeedback(b,v,g,t){const i=this.b.get(b),r=this.d.get(v),c=r?.responses[g];if(i&&c){const o=M.InteractiveEditorResponseFeedbackKind.to(t);i.provider.handleInteractiveEditorResponseFeedback?.(r.session,c,o)}}$releaseSession(b,v){}static h(b){return typeof b=="object"&&typeof b.edits=="object"}}e.$1ec=D}),define(Ae[251],Re([1,0,2,32]),function(we,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bfc=void 0;class A{constructor(R,$,E,f,P){this.a=$,this.b=E,this.c=f;const D=new F.$2M("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.$ZM("showOptions","Show Options",u=>!0,u=>u),new F.$ZM("resource","Interactive resource Uri",u=>!0,u=>u),new F.$ZM("controllerId","Notebook controller Id",u=>!0,u=>u),new F.$ZM("title","Interactive editor title",u=>!0,u=>u)],new F.$1M("Notebook and input URI",u=>{if(P.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const b=this.a.getEditorById(u.notebookEditorId);return P.debug("[ExtHostInteractive] notebook editor found",b.id),{notebookUri:y.URI.revive(u.notebookUri),inputUri:y.URI.revive(u.inputUri),notebookEditor:b.apiEditor}}return P.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:y.URI.revive(u.notebookUri),inputUri:y.URI.revive(u.inputUri)}}));this.c.registerApiCommand(D)}$willAddInteractiveDocument(R,$,E,f){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:$,lines:[""],languageId:E,uri:R,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(y.URI.revive(f))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,$){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$bfc=A}),define(Ae[252],Re([1,0,3,7]),function(we,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cfc=void 0;class A{constructor(R){this.a=new Map,this.b=new Map,this.c=R.getProxy(y.$zK.MainThreadIssueReporter)}async $getIssueReporterUri(R,$){if(this.a.size===0)throw new Error("No issue request handlers registered");const E=this.a.get(R);if(!E)throw new Error("Issue request handler not found");const f=await E.handleIssueUrlRequest();if(!f)throw new Error("Issue request handler returned no result");return f}async $getIssueReporterData(R,$){if(this.b.size===0)throw new Error("No issue request handlers registered");const E=this.b.get(R);if(!E)throw new Error("Issue data provider not found");const f=await E.provideIssueData($);if(!f)throw new Error("Issue data provider returned no result");return f}async $getIssueReporterTemplate(R,$){if(this.b.size===0)throw new Error("No issue request handlers registered");const E=this.b.get(R);if(!E)throw new Error("Issue data provider not found");const f=await E.provideIssueTemplate($);if(!f)throw new Error("Issue template provider returned no result");return f}registerIssueUriRequestHandler(R,$){const E=R.identifier.value;return this.a.set(E,$),this.c.$registerIssueUriRequestHandler(E),new F.$BK(()=>{this.c.$unregisterIssueUriRequestHandler(E),this.a.delete(E)})}registerIssueDataProvider(R,$){const E=R.identifier.value;return this.b.set(E,$),this.c.$registerIssueDataProvider(E),new F.$BK(()=>{this.c.$unregisterIssueDataProvider(E),this.b.delete(E)})}}e.$cfc=A}),define(Ae[253],Re([1,0,6,3]),function(we,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dfc=void 0;class A{constructor(R){this.b=0,this.a=R.getProxy(F.$zK.MainThreadLabelService)}$registerResourceLabelFormatter(R){const $=this.b++;return this.a.$registerResourceLabelFormatter($,R),(0,y.$Pc)(()=>{this.a.$unregisterResourceLabelFormatter($)})}}e.$dfc=A}),define(Ae[254],Re([1,0,2,26,8,7,80,3,12,29,18,16,297,19,22,6,95,89,75,60,11,14,23,160]),function(we,e,y,F,A,M,R,$,E,f,P,D,u,b,v,g,t,i,r,c,o,l,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rdc=void 0;class a{constructor(O,W){this.d=O,this.e=W}async provideDocumentSymbols(O,W){const H=this.d.getDocument(O),J=await this.e.provideDocumentSymbols(H,W);if(!(0,P.$Jb)(J))return J[0]instanceof M.$TK?J.map(A.DocumentSymbol.from):a.f(J)}static f(O){O=O.slice(0).sort((J,q)=>{let x=J.location.range.start.compareTo(q.location.range.start);return x===0&&(x=q.location.range.end.compareTo(J.location.range.end)),x});const W=[],H=[];for(const J of O){const q={name:J.name||"!!MISSING: name!!",kind:A.SymbolKind.from(J.kind),tags:J.tags?.map(A.SymbolTag.from)||[],detail:"",containerName:J.containerName,range:A.Range.from(J.location.range),selectionRange:A.Range.from(J.location.range),children:[]};for(;;){if(H.length===0){H.push(q),W.push(q);break}const x=H[H.length-1];if(f.$zs.containsRange(x.range,q.range)&&!f.$zs.equalsRange(x.range,q.range)){x.children?.push(q),H.push(q);break}H.pop()}}return W}}class d{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(O,W,H){this.g=O,this.h=W,this.j=H,this.e=new r.$Hdc("CodeLens"),this.f=new Map}async provideCodeLenses(O,W){const H=this.g.getDocument(O),J=await this.j.provideCodeLenses(H,W);if(!J||W.isCancellationRequested)return;const q=this.e.add(J),x=new g.$Qc;this.f.set(q,x);const ue={cacheId:q,lenses:[]};for(let Ne=0;Ne<J.length;Ne++)ue.lenses.push({cacheId:[q,Ne],range:A.Range.from(J[Ne].range),command:this.h.toInternal(J[Ne].command,x)});return ue}async resolveCodeLens(O,W){const H=O.cacheId&&this.e.get(...O.cacheId);if(!H)return;let J;if(typeof this.j.resolveCodeLens!="function"||H.isResolved?J=H:J=await this.j.resolveCodeLens(H,W),J||(J=H),W.isCancellationRequested)return;const q=O.cacheId&&this.f.get(O.cacheId[0]);if(q)return O.command=this.h.toInternal(J.command??d.d,q),O}releaseCodeLenses(O){this.f.get(O)?.dispose(),this.f.delete(O),this.e.delete(O)}}function p(Ie){return Array.isArray(Ie)?Ie.map(A.DefinitionLink.from):Ie?[A.DefinitionLink.from(Ie)]:[]}class m{constructor(O,W){this.d=O,this.e=W}async provideDefinition(O,W,H){const J=this.d.getDocument(O),q=A.Position.to(W),x=await this.e.provideDefinition(J,q,H);return p(x)}}class S{constructor(O,W){this.d=O,this.e=W}async provideDeclaration(O,W,H){const J=this.d.getDocument(O),q=A.Position.to(W),x=await this.e.provideDeclaration(J,q,H);return p(x)}}class k{constructor(O,W){this.d=O,this.e=W}async provideImplementation(O,W,H){const J=this.d.getDocument(O),q=A.Position.to(W),x=await this.e.provideImplementation(J,q,H);return p(x)}}class h{constructor(O,W){this.d=O,this.e=W}async provideTypeDefinition(O,W,H){const J=this.d.getDocument(O),q=A.Position.to(W),x=await this.e.provideTypeDefinition(J,q,H);return p(x)}}class w{constructor(O,W){this.d=O,this.e=W}async provideHover(O,W,H){const J=this.d.getDocument(O),q=A.Position.to(W),x=await this.e.provideHover(J,q,H);if(!(!x||(0,P.$Jb)(x.contents)))return x.range||(x.range=J.getWordRangeAtPosition(q)),x.range||(x.range=new M.$DK(q,q)),A.Hover.from(x)}}class I{constructor(O,W){this.d=O,this.e=W}async provideEvaluatableExpression(O,W,H){const J=this.d.getDocument(O),q=A.Position.to(W),x=await this.e.provideEvaluatableExpression(J,q,H);if(x)return A.EvaluatableExpression.from(x)}}class L{constructor(O,W){this.d=O,this.e=W}async provideInlineValues(O,W,H,J){const q=this.d.getDocument(O),x=await this.e.provideInlineValues(q,A.Range.to(W),A.InlineValueContext.to(H),J);if(Array.isArray(x))return x.map(ue=>A.InlineValue.from(ue))}}class V{constructor(O,W){this.d=O,this.e=W}async provideDocumentHighlights(O,W,H){const J=this.d.getDocument(O),q=A.Position.to(W),x=await this.e.provideDocumentHighlights(J,q,H);if(Array.isArray(x))return x.map(A.DocumentHighlight.from)}}class Y{constructor(O,W){this.d=O,this.e=W}async provideLinkedEditingRanges(O,W,H){const J=this.d.getDocument(O),q=A.Position.to(W),x=await this.e.provideLinkedEditingRanges(J,q,H);if(x&&Array.isArray(x.ranges))return{ranges:(0,P.$Gb)(x.ranges.map(A.Range.from)),wordPattern:x.wordPattern}}}class U{constructor(O,W){this.d=O,this.e=W}async provideReferences(O,W,H,J){const q=this.d.getDocument(O),x=A.Position.to(W),ue=await this.e.provideReferences(q,x,H,J);if(Array.isArray(ue))return ue.map(A.location.from)}}class N{static{this.d=1e3}constructor(O,W,H,J,q,x,ue){this.g=O,this.h=W,this.j=H,this.k=J,this.l=q,this.m=x,this.n=ue,this.e=new r.$Hdc("CodeAction"),this.f=new Map}async provideCodeActions(O,W,H,J){const q=this.g.getDocument(O),x=u.$Bs.isISelection(W)?A.Selection.to(W):A.Range.to(W),ue=[];for(const _e of this.j.getDiagnostics(O))if(x.intersection(_e.range)&&ue.push(_e)>N.d)break;const Ne={diagnostics:ue,only:H.only?new M.$VK(H.only):void 0,triggerKind:A.CodeActionTriggerKind.to(H.trigger)},Be=await this.k.provideCodeActions(q,x,Ne,J);if(!(0,P.$Kb)(Be)||J.isCancellationRequested)return;const Ye=this.e.add(Be),Je=new g.$Qc;this.f.set(Ye,Je);const tt=[];for(let _e=0;_e<Be.length;_e++){const et=Be[_e];et&&(N.o(et)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),tt.push({_isSynthetic:!0,title:et.title,command:this.h.toInternal(et,Je)})):(Ne.only&&(et.kind?Ne.only.contains(et.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ne.only.value} 'requested but returned code action is of kind '${et.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ne.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),tt.push({cacheId:[Ye,_e],title:et.title,command:et.command&&this.h.toInternal(et.command,Je),diagnostics:et.diagnostics&&et.diagnostics.map(A.Diagnostic.from),edit:et.edit&&A.WorkspaceEdit.from(et.edit,void 0),kind:et.kind&&et.kind.value,isPreferred:et.isPreferred,isAI:(0,n.$MF)(this.m,"codeActionAI")?et.isAI:!1,disabled:et.disabled?.reason})))}return{cacheId:Ye,actions:tt}}async resolveCodeAction(O,W){const[H,J]=O,q=this.e.get(H,J);if(!q||N.o(q))return{};if(!this.k.resolveCodeAction)return{};const x=await this.k.resolveCodeAction(q,W)??q;let ue;x.edit&&(ue=A.WorkspaceEdit.from(x.edit,void 0));let Ne;if(x.command){const Be=this.f.get(H);Be&&(Ne=this.h.toInternal(x.command,Be))}return{edit:ue,command:Ne}}releaseCodeActions(O){this.f.get(O)?.dispose(),this.f.delete(O),this.e.delete(O)}static o(O){return typeof O.command=="string"&&typeof O.title=="string"}}class C{static toInternalProviderId(O,W){return O+"."+W}constructor(O,W,H,J,q){this.d=O,this.e=W,this.f=H,this.g=J,this.h=q}async prepareDocumentPaste(O,W,H,J){if(!this.f.prepareDocumentPaste)return;const q=this.e.getDocument(O),x=W.map(Be=>A.Range.to(Be)),ue=A.DataTransfer.toDataTransfer(H,()=>{throw new o.$0});if(await this.f.prepareDocumentPaste(q,x,ue,J),J.isCancellationRequested)return;const Ne=Array.from(ue).filter(([,Be])=>!(Be instanceof M.$pL));return A.DataTransfer.from(Ne)}async providePasteEdits(O,W,H,J,q){if(!this.f.provideDocumentPasteEdits)return;const x=this.e.getDocument(W),ue=H.map(Ye=>A.Range.to(Ye)),Ne=A.DataTransfer.toDataTransfer(J,async Ye=>(await this.d.$resolvePasteFileData(this.g,O,Ye)).buffer),Be=await this.f.provideDocumentPasteEdits(x,ue,Ne,q);if(Be)return{label:Be.label??(0,s.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Be.yieldTo?.map(Ye=>"mimeType"in Ye?Ye:{providerId:C.toInternalProviderId(Ye.extensionId,Ye.providerId)}),insertText:typeof Be.insertText=="string"?Be.insertText:{snippet:Be.insertText.value},additionalEdit:Be.additionalEdit?A.WorkspaceEdit.from(Be.additionalEdit,void 0):void 0}}}class T{constructor(O,W){this.d=O,this.e=W}async provideDocumentFormattingEdits(O,W,H){const J=this.d.getDocument(O),q=await this.e.provideDocumentFormattingEdits(J,W,H);if(Array.isArray(q))return q.map(A.TextEdit.from)}}class G{constructor(O,W){this.d=O,this.e=W}async provideDocumentRangeFormattingEdits(O,W,H,J){const q=this.d.getDocument(O),x=A.Range.to(W),ue=await this.e.provideDocumentRangeFormattingEdits(q,x,H,J);if(Array.isArray(ue))return ue.map(A.TextEdit.from)}async provideDocumentRangesFormattingEdits(O,W,H,J){(0,D.$Mf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const q=this.d.getDocument(O),x=W.map(A.Range.to),ue=await this.e.provideDocumentRangesFormattingEdits(q,x,H,J);if(Array.isArray(ue))return ue.map(A.TextEdit.from)}}class de{constructor(O,W){this.d=O,this.e=W,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(O,W,H,J,q){const x=this.d.getDocument(O),ue=A.Position.to(W),Ne=await this.e.provideOnTypeFormattingEdits(x,ue,H,J,q);if(Array.isArray(Ne))return Ne.map(A.TextEdit.from)}}class me{constructor(O,W){this.e=O,this.f=W,this.d=new r.$Hdc("WorkspaceSymbols")}async provideWorkspaceSymbols(O,W){const H=await this.e.provideWorkspaceSymbols(O,W);if(!(0,P.$Kb)(H))return{symbols:[]};const J=this.d.add(H),q={cacheId:J,symbols:[]};for(let x=0;x<H.length;x++){const ue=H[x];if(!ue||!ue.name){this.f.warn("INVALID SymbolInformation",ue);continue}q.symbols.push({...A.WorkspaceSymbol.from(ue),cacheId:[J,x]})}return q}async resolveWorkspaceSymbol(O,W){if(typeof this.e.resolveWorkspaceSymbol!="function"||!O.cacheId)return O;const H=this.d.get(...O.cacheId);if(H){const J=await this.e.resolveWorkspaceSymbol(H,W);return J&&(0,F.$dn)(O,A.WorkspaceSymbol.from(J),!0)}}releaseWorkspaceSymbols(O){this.d.delete(O)}}class De{static supportsResolving(O){return typeof O.prepareRename=="function"}constructor(O,W,H){this.d=O,this.e=W,this.f=H}async provideRenameEdits(O,W,H,J){const q=this.d.getDocument(O),x=A.Position.to(W);try{const ue=await this.e.provideRenameEdits(q,x,H,J);return ue?A.WorkspaceEdit.from(ue):void 0}catch(ue){const Ne=De.g(ue);return Ne?{rejectReason:Ne,edits:void 0}:Promise.reject(ue)}}async resolveRenameLocation(O,W,H){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const J=this.d.getDocument(O),q=A.Position.to(W);try{const x=await this.e.prepareRename(J,q,H);let ue,Ne;if(M.$DK.isRange(x)?(ue=x,Ne=J.getText(x)):(0,D.$Ef)(x)&&(ue=x.range,Ne=x.placeholder),!ue||!Ne)return;if(ue.start.line>q.line||ue.end.line<q.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:A.Range.from(ue),text:Ne}}catch(x){const ue=De.g(x);return ue?{rejectReason:ue,range:void 0,text:void 0}:Promise.reject(x)}}static g(O){return typeof O=="string"?O:O instanceof Error&&typeof O.message=="string"?O.message:void 0}}class ke{constructor(O,W){this.resultId=O,this.tokens=W}}class le{constructor(O,W){this.f=O,this.g=W,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(O,W,H){const J=this.f.getDocument(O),q=W!==0?this.d.get(W):null;let x=typeof q?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(J,q.resultId,H):await this.g.provideDocumentSemanticTokens(J,H);return q&&this.d.delete(W),x?(x=le.h(x),this.o(le.n(q,x),x)):null}async releaseDocumentSemanticColoring(O){this.d.delete(O)}static h(O){return le.j(O)?le.k(O)?O:new M.$SL(new Uint32Array(O.data),O.resultId):le.l(O)?le.m(O)?O:new M.$UL(O.edits.map(W=>new M.$TL(W.start,W.deleteCount,W.data?new Uint32Array(W.data):W.data)),O.resultId):O}static j(O){return O&&!!O.data}static k(O){return O.data instanceof Uint32Array}static l(O){return O&&Array.isArray(O.edits)}static m(O){for(const W of O.edits)if(!(W.data instanceof Uint32Array))return!1;return!0}static n(O,W){if(!le.j(W)||!O||!O.tokens)return W;const H=O.tokens,J=H.length,q=W.data,x=q.length;let ue=0;const Ne=Math.min(J,x);for(;ue<Ne&&H[ue]===q[ue];)ue++;if(ue===J&&ue===x)return new M.$UL([],W.resultId);let Be=0;const Ye=Ne-ue;for(;Be<Ye&&H[J-Be-1]===q[x-Be-1];)Be++;return new M.$UL([{start:ue,deleteCount:J-ue-Be,data:q.subarray(ue,x-Be)}],W.resultId)}o(O,W){if(le.j(O)){const H=this.e++;return this.d.set(H,new ke(O.resultId,O.data)),(0,t.$10)({id:H,type:"full",data:O.data})}if(le.l(O)){const H=this.e++;return le.j(W)?this.d.set(H,new ke(W.resultId,W.data)):this.d.set(H,new ke(O.resultId)),(0,t.$10)({id:H,type:"delta",deltas:(O.edits||[]).map(J=>({start:J.start,deleteCount:J.deleteCount,data:J.data}))})}return null}}class pe{constructor(O,W){this.d=O,this.e=W}async provideDocumentRangeSemanticTokens(O,W,H){const J=this.d.getDocument(O),q=await this.e.provideDocumentRangeSemanticTokens(J,A.Range.to(W),H);return q?this.f(q):null}f(O){return(0,t.$10)({id:0,type:"full",data:O.data})}}class re{static supportsResolving(O){return typeof O.resolveCompletionItem=="function"}constructor(O,W,H,J,q){this.f=O,this.g=W,this.h=H,this.j=J,this.k=q,this.d=new r.$Hdc("CompletionItem"),this.e=new Map}async provideCompletionItems(O,W,H,J){const q=this.f.getDocument(O),x=A.Position.to(W),ue=q.getWordRangeAtPosition(x)||new M.$DK(x,x),Ne=ue.with({end:x}),Be=new c.$Nd,Ye=await this.h.provideCompletionItems(q,x,J,A.CompletionContext.to(H));if(!Ye||J.isCancellationRequested)return;const Je=Array.isArray(Ye)?new M.$9K(Ye):Ye,tt=re.supportsResolving(this.h)?this.d.add(Je.items):this.d.add([]),_e=new g.$Qc;this.e.set(tt,_e);const et=[],rt={x:tt,b:et,a:{replace:A.Range.from(ue),insert:A.Range.from(Ne)},c:Je.isIncomplete||void 0,d:Be.elapsed()};for(let nt=0;nt<Je.items.length;nt++){const ze=Je.items[nt],dt=this.l(ze,[tt,nt],Ne,ue);et.push(dt)}return rt}async resolveCompletionItem(O,W){if(typeof this.h.resolveCompletionItem!="function")return;const H=this.d.get(...O);if(!H)return;const J=this.l(H,O),q=await this.h.resolveCompletionItem(H,W);if(!q)return;const x=this.l(q,O);return(J.h!==x.h||J.i!==x.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(J.n!==x.n||J.o!==x.o||!(0,F.$en)(J.p,x.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...J,d:x.d,c:x.c,l:x.l,h:x.h,i:x.i,n:x.n,o:x.o,p:x.p}}releaseCompletionItems(O){this.e.get(O)?.dispose(),this.e.delete(O),this.d.delete(O)}l(O,W,H,J){const q=this.e.get(W[0]);if(!q)throw Error("DisposableStore is missing...");const x=this.g.toInternal(O.command,q),ue={x:W,a:O.label,b:O.kind!==void 0?A.CompletionItemKind.from(O.kind):void 0,m:O.tags&&O.tags.map(A.CompletionItemTag.from),c:O.detail,d:typeof O.documentation>"u"?void 0:A.MarkdownString.fromStrict(O.documentation),e:O.sortText!==O.label?O.sortText:void 0,f:O.filterText!==O.label?O.filterText:void 0,g:O.preselect||void 0,i:O.keepWhitespace?1:0,k:O.commitCharacters?.join(""),l:O.additionalTextEdits&&O.additionalTextEdits.map(A.TextEdit.from),n:x?.$ident,o:x?.id,p:x?.$ident?void 0:x?.arguments};O.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ue.h=O.textEdit.newText):typeof O.insertText=="string"?ue.h=O.insertText:O.insertText instanceof M.$MK&&(ue.h=O.insertText.value,ue.i|=4);let Ne;return O.textEdit?Ne=O.textEdit.range:O.range&&(Ne=O.range),M.$DK.isRange(Ne)?ue.j=A.Range.from(Ne):Ne&&(!H?.isEqual(Ne.inserting)||!J?.isEqual(Ne.replacing))&&(ue.j={insert:A.Range.from(Ne.inserting),replace:A.Range.from(Ne.replacing)}),ue}}class Pe{async provideInlineCompletions(O,W,H,J){}disposeCompletions(O){}handleDidShowCompletionItem(O,W,H){}handlePartialAccept(O,W,H){}}class se extends Pe{constructor(O,W,H,J){super(),this.f=O,this.g=W,this.h=H,this.j=J,this.d=new Z,this.e=(0,n.$MF)(this.f,"inlineCompletionsAdditions"),this.k={[R.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[R.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,n.$MF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(O,W,H,J){const q=this.g.getDocument(O),x=A.Position.to(W),ue=await this.h.provideInlineCompletionItems(q,x,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:A.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind]},J);if(!ue||J.isCancellationRequested)return;const Ne=Array.isArray(ue)?ue:ue.items,Be=this.e?Array.isArray(ue)?[]:ue.commands||[]:[],Ye=this.e&&!Array.isArray(ue)?ue.enableForwardStability:void 0;let Je;return{pid:this.d.createReferenceId({dispose(){Je?.dispose()},items:Ne}),items:Ne.map((_e,et)=>{let rt;_e.command&&(Je||(Je=new g.$Qc),rt=this.j.toInternal(_e.command,Je));const nt=_e.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:_e.filterText,range:_e.range?A.Range.from(_e.range):void 0,command:rt,idx:et,completeBracketPairs:this.e?_e.completeBracketPairs:!1}}),commands:Be.map(_e=>(Je||(Je=new g.$Qc),this.j.toInternal(_e,Je))),suppressSuggestions:!1,enableForwardStability:Ye}}disposeCompletions(O){this.d.disposeReferenceId(O)?.dispose()}handleDidShowCompletionItem(O,W,H){const J=this.d.get(O)?.items[W];J&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(J,H)}handlePartialAccept(O,W,H){const J=this.d.get(O)?.items[W];J&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(J,H)}}class Z{constructor(){this.d=new Map,this.e=1}createReferenceId(O){const W=this.e++;return this.d.set(W,O),W}disposeReferenceId(O){const W=this.d.get(O);return this.d.delete(O),W}get(O){return this.d.get(O)}}class j{constructor(O,W){this.e=O,this.f=W,this.d=new r.$Hdc("SignatureHelp")}async provideSignatureHelp(O,W,H,J){const q=this.e.getDocument(O),x=A.Position.to(W),ue=this.g(H),Ne=await this.f.provideSignatureHelp(q,x,J,ue);if(Ne){const Be=this.d.add([Ne]);return{...A.SignatureHelp.from(Ne),id:Be}}}g(O){let W;if(O.activeSignatureHelp){const H=A.SignatureHelp.to(O.activeSignatureHelp),J=this.d.get(O.activeSignatureHelp.id,0);J?(W=J,W.activeSignature=H.activeSignature,W.activeParameter=H.activeParameter):W=H}return{...O,activeSignatureHelp:W}}releaseSignatureHelp(O){this.d.delete(O)}}class ie{constructor(O,W,H,J,q){this.f=O,this.g=W,this.h=H,this.j=J,this.k=q,this.d=new r.$Hdc("InlayHints"),this.e=new Map}async provideInlayHints(O,W,H){const J=this.f.getDocument(O),q=A.Range.to(W),x=await this.h.provideInlayHints(J,q,H);if(!Array.isArray(x)||x.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${W}`);return}if(H.isCancellationRequested)return;const ue=this.d.add(x);this.e.set(ue,new g.$Qc);const Ne={hints:[],cacheId:ue};for(let Be=0;Be<x.length;Be++)this.l(x[Be],q)&&Ne.hints.push(this.m(x[Be],[ue,Be]));return this.j.trace(`[InlayHints] ${Ne.hints.length} inlay hints from '${this.k.identifier.value}' for ${W}`),Ne}async resolveInlayHint(O,W){if(typeof this.h.resolveInlayHint!="function")return;const H=this.d.get(...O);if(!H)return;const J=await this.h.resolveInlayHint(H,W);if(J&&this.l(J))return this.m(J,O)}releaseHints(O){this.e.get(O)?.dispose(),this.e.delete(O),this.d.delete(O)}l(O,W){return O.label.length===0||Array.isArray(O.label)&&O.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",O),!1):!(W&&!W.contains(O.position))}m(O,W){const H=this.e.get(W[0]);if(!H)throw Error("DisposableStore is missing...");const J={label:"",cacheId:W,tooltip:A.MarkdownString.fromStrict(O.tooltip),position:A.Position.from(O.position),textEdits:O.textEdits&&O.textEdits.map(A.TextEdit.from),kind:O.kind&&A.InlayHintKind.from(O.kind),paddingLeft:O.paddingLeft,paddingRight:O.paddingRight};return typeof O.label=="string"?J.label=O.label:J.label=O.label.map(q=>{const x={label:q.value};return x.tooltip=A.MarkdownString.fromStrict(q.tooltip),M.$NK.isLocation(q.location)&&(x.location=A.location.from(q.location)),q.command&&(x.command=this.g.toInternal(q.command,H)),x}),J}}class ve{constructor(O,W){this.e=O,this.f=W,this.d=new r.$Hdc("DocumentLink")}async provideLinks(O,W){const H=this.e.getDocument(O),J=await this.f.provideDocumentLinks(H,W);if(!(!Array.isArray(J)||J.length===0)&&!W.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:J.filter(ve.g).map(A.DocumentLink.from)};{const q=this.d.add(J),x={links:[],cacheId:q};for(let ue=0;ue<J.length;ue++){if(!ve.g(J[ue]))continue;const Ne=A.DocumentLink.from(J[ue]);Ne.cacheId=[q,ue],x.links.push(Ne)}return x}}}static g(O){return O.target&&O.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(O,W){if(typeof this.f.resolveDocumentLink!="function")return;const H=this.d.get(...O);if(!H)return;const J=await this.f.resolveDocumentLink(H,W);if(!(!J||!ve.g(J)))return A.DocumentLink.from(J)}releaseLinks(O){this.d.delete(O)}}class ne{constructor(O,W){this.d=O,this.e=W}async provideColors(O,W){const H=this.d.getDocument(O),J=await this.e.provideDocumentColors(H,W);return Array.isArray(J)?J.map(x=>({color:A.Color.from(x.color),range:A.Range.from(x.range)})):[]}async provideColorPresentations(O,W,H){const J=this.d.getDocument(O),q=A.Range.to(W.range),x=A.Color.to(W.color),ue=await this.e.provideColorPresentations(x,{document:J,range:q},H);if(Array.isArray(ue))return ue.map(A.ColorPresentation.from)}}class he{constructor(O,W){this.d=O,this.e=W}async provideFoldingRanges(O,W,H){const J=this.d.getDocument(O),q=await this.e.provideFoldingRanges(J,W,H);if(Array.isArray(q))return q.map(A.FoldingRange.from)}}class ce{constructor(O,W,H){this.d=O,this.e=W,this.f=H}async provideSelectionRanges(O,W,H){const J=this.d.getDocument(O),q=W.map(A.Position.to),x=await this.e.provideSelectionRanges(J,q,H);if(!(0,P.$Kb)(x))return[];if(x.length!==q.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ue=[];for(let Ne=0;Ne<q.length;Ne++){const Be=[];ue.push(Be);let Ye=q[Ne],Je=x[Ne];for(;;){if(!Je.range.contains(Ye))throw new Error("INVALID selection range, must contain the previous range");if(Be.push(A.SelectionRange.from(Je)),!Je.parent)break;Ye=Je.range,Je=Je.parent}}return ue}}class ye{constructor(O,W){this.f=O,this.g=W,this.d=new i.$GM(""),this.e=new Map}async prepareSession(O,W,H){const J=this.f.getDocument(O),q=A.Position.to(W),x=await this.g.prepareCallHierarchy(J,q,H);if(!x)return;const ue=this.d.nextId();return this.e.set(ue,new Map),Array.isArray(x)?x.map(Ne=>this.h(ue,Ne)):[this.h(ue,x)]}async provideCallsTo(O,W,H){const J=this.j(O,W);if(!J)throw new Error("missing call hierarchy item");const q=await this.g.provideCallHierarchyIncomingCalls(J,H);if(q)return q.map(x=>({from:this.h(O,x.from),fromRanges:x.fromRanges.map(ue=>A.Range.from(ue))}))}async provideCallsFrom(O,W,H){const J=this.j(O,W);if(!J)throw new Error("missing call hierarchy item");const q=await this.g.provideCallHierarchyOutgoingCalls(J,H);if(q)return q.map(x=>({to:this.h(O,x.to),fromRanges:x.fromRanges.map(ue=>A.Range.from(ue))}))}releaseSession(O){this.e.delete(O)}h(O,W){const H=this.e.get(O),J=A.CallHierarchyItem.from(W,O,H.size.toString(36));return H.set(J._itemId,W),J}j(O,W){return this.e.get(O)?.get(W)}}class _{constructor(O,W){this.f=O,this.g=W,this.d=new i.$GM(""),this.e=new Map}async prepareSession(O,W,H){const J=this.f.getDocument(O),q=A.Position.to(W),x=await this.g.prepareTypeHierarchy(J,q,H);if(!x)return;const ue=this.d.nextId();return this.e.set(ue,new Map),Array.isArray(x)?x.map(Ne=>this.h(ue,Ne)):[this.h(ue,x)]}async provideSupertypes(O,W,H){const J=this.j(O,W);if(!J)throw new Error("missing type hierarchy item");const q=await this.g.provideTypeHierarchySupertypes(J,H);if(q)return q.map(x=>this.h(O,x))}async provideSubtypes(O,W,H){const J=this.j(O,W);if(!J)throw new Error("missing type hierarchy item");const q=await this.g.provideTypeHierarchySubtypes(J,H);if(q)return q.map(x=>this.h(O,x))}releaseSession(O){this.e.delete(O)}h(O,W){const H=this.e.get(O),J=A.TypeHierarchyItem.from(W,O,H.size.toString(36));return H.set(J._itemId,W),J}j(O,W){return this.e.get(O)?.get(W)}}class fe{static toInternalProviderId(O,W){return O+"."+W}constructor(O,W,H,J,q){this.d=O,this.e=W,this.f=H,this.g=J,this.h=q}async provideDocumentOnDropEdits(O,W,H,J,q){const x=this.e.getDocument(W),ue=A.Position.to(H),Ne=A.DataTransfer.toDataTransfer(J,async Ye=>(await this.d.$resolveDocumentOnDropFileData(this.g,O,Ye)).buffer),Be=await this.f.provideDocumentDropEdits(x,ue,Ne,q);if(Be)return{label:Be.label??(0,s.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Be.yieldTo?.map(Ye=>"mimeType"in Ye?Ye:{providerId:fe.toInternalProviderId(Ye.extensionId,Ye.providerId)}),insertText:typeof Be.insertText=="string"?Be.insertText:{snippet:Be.insertText.value},additionalEdit:Be.additionalEdit?A.WorkspaceEdit.from(Be.additionalEdit,void 0):void 0}}}class te{constructor(O,W){this.d=O,this.e=W}async provideMappedEdits(O,W,H,J){const q=y.URI.revive(O),x=this.d.getDocument(q),ue=H.documents.map(Ye=>Ye.map(Je=>({uri:y.URI.revive(Je.uri),version:Je.version,ranges:Je.ranges.map(tt=>A.Range.to(tt))}))),Ne={documents:ue,selections:ue[0]?.[0]?.ranges??[]},Be=await this.e.provideMappedEdits(x,W,Ne,J);return Be?A.WorkspaceEdit.from(Be):null}}class ae{constructor(O,W){this.adapter=O,this.extension=W}}class $e{static{this.d=0}constructor(O,W,H,J,q,x,ue,Ne){this.g=W,this.h=H,this.j=J,this.k=q,this.l=x,this.m=ue,this.n=Ne,this.f=new Map,this.e=O.getProxy($.$zK.MainThreadLanguageFeatures)}o(O,W){return A.DocumentSelector.from(O,this.g,W)}p(O){return new M.$BK(()=>{this.f.delete(O),this.e.$unregister(O)})}q(){return $e.d++}async s(O,W,H,J,q,x=!1){const ue=this.f.get(O);if(!ue||!(ue.adapter instanceof W))return J;const Ne=Date.now();x||this.l.trace(`[${ue.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const Be=H(ue.adapter,ue.extension);return Promise.resolve(Be).catch(Ye=>{(0,o.$3)(Ye)||(this.l.error(`[${ue.extension.identifier.value}] provider FAILED`),this.l.error(Ye),this.n.onExtensionError(ue.extension.identifier,Ye))}).finally(()=>{x||this.l.trace(`[${ue.extension.identifier.value}] provider DONE after ${Date.now()-Ne}ms`)}),b.CancellationToken.isCancellationToken(q)?(0,l.$Ng)(Be,q):Be}t(O,W){const H=this.q();return this.f.set(H,new ae(O,W)),H}static u(O){return O.displayName||O.name}registerDocumentSymbolProvider(O,W,H,J){const q=this.t(new a(this.h,H),O),x=J&&J.label||$e.u(O);return this.e.$registerDocumentSymbolProvider(q,this.o(W,O),x),this.p(q)}$provideDocumentSymbols(O,W,H){return this.s(O,a,J=>J.provideDocumentSymbols(y.URI.revive(W),H),void 0,H)}registerCodeLensProvider(O,W,H){const J=this.q(),q=typeof H.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(J,new ae(new d(this.h,this.j.converter,H),O)),this.e.$registerCodeLensSupport(J,this.o(W,O),q);let x=this.p(J);if(q!==void 0){const ue=H.onDidChangeCodeLenses(Ne=>this.e.$emitCodeLensEvent(q));x=M.$BK.from(x,ue)}return x}$provideCodeLenses(O,W,H){return this.s(O,d,J=>J.provideCodeLenses(y.URI.revive(W),H),void 0,H)}$resolveCodeLens(O,W,H){return this.s(O,d,J=>J.resolveCodeLens(W,H),void 0,void 0)}$releaseCodeLenses(O,W){this.s(O,d,H=>Promise.resolve(H.releaseCodeLenses(W)),void 0,void 0)}registerDefinitionProvider(O,W,H){const J=this.t(new m(this.h,H),O);return this.e.$registerDefinitionSupport(J,this.o(W,O)),this.p(J)}$provideDefinition(O,W,H,J){return this.s(O,m,q=>q.provideDefinition(y.URI.revive(W),H,J),[],J)}registerDeclarationProvider(O,W,H){const J=this.t(new S(this.h,H),O);return this.e.$registerDeclarationSupport(J,this.o(W,O)),this.p(J)}$provideDeclaration(O,W,H,J){return this.s(O,S,q=>q.provideDeclaration(y.URI.revive(W),H,J),[],J)}registerImplementationProvider(O,W,H){const J=this.t(new k(this.h,H),O);return this.e.$registerImplementationSupport(J,this.o(W,O)),this.p(J)}$provideImplementation(O,W,H,J){return this.s(O,k,q=>q.provideImplementation(y.URI.revive(W),H,J),[],J)}registerTypeDefinitionProvider(O,W,H){const J=this.t(new h(this.h,H),O);return this.e.$registerTypeDefinitionSupport(J,this.o(W,O)),this.p(J)}$provideTypeDefinition(O,W,H,J){return this.s(O,h,q=>q.provideTypeDefinition(y.URI.revive(W),H,J),[],J)}registerHoverProvider(O,W,H,J){const q=this.t(new w(this.h,H),O);return this.e.$registerHoverProvider(q,this.o(W,O)),this.p(q)}$provideHover(O,W,H,J){return this.s(O,w,q=>q.provideHover(y.URI.revive(W),H,J),void 0,J)}registerEvaluatableExpressionProvider(O,W,H,J){const q=this.t(new I(this.h,H),O);return this.e.$registerEvaluatableExpressionProvider(q,this.o(W,O)),this.p(q)}$provideEvaluatableExpression(O,W,H,J){return this.s(O,I,q=>q.provideEvaluatableExpression(y.URI.revive(W),H,J),void 0,J)}registerInlineValuesProvider(O,W,H,J){const q=typeof H.onDidChangeInlineValues=="function"?this.q():void 0,x=this.t(new L(this.h,H),O);this.e.$registerInlineValuesProvider(x,this.o(W,O),q);let ue=this.p(x);if(q!==void 0){const Ne=H.onDidChangeInlineValues(Be=>this.e.$emitInlineValuesEvent(q));ue=M.$BK.from(ue,Ne)}return ue}$provideInlineValues(O,W,H,J,q){return this.s(O,L,x=>x.provideInlineValues(y.URI.revive(W),H,J,q),void 0,q)}registerDocumentHighlightProvider(O,W,H){const J=this.t(new V(this.h,H),O);return this.e.$registerDocumentHighlightProvider(J,this.o(W,O)),this.p(J)}$provideDocumentHighlights(O,W,H,J){return this.s(O,V,q=>q.provideDocumentHighlights(y.URI.revive(W),H,J),void 0,J)}registerLinkedEditingRangeProvider(O,W,H){const J=this.t(new Y(this.h,H),O);return this.e.$registerLinkedEditingRangeProvider(J,this.o(W,O)),this.p(J)}$provideLinkedEditingRanges(O,W,H,J){return this.s(O,Y,async q=>{const x=await q.provideLinkedEditingRanges(y.URI.revive(W),H,J);if(x)return{ranges:x.ranges,wordPattern:x.wordPattern?$e.w(x.wordPattern):void 0}},void 0,J)}registerReferenceProvider(O,W,H){const J=this.t(new U(this.h,H),O);return this.e.$registerReferenceSupport(J,this.o(W,O)),this.p(J)}$provideReferences(O,W,H,J,q){return this.s(O,U,x=>x.provideReferences(y.URI.revive(W),H,J,q),void 0,q)}registerCodeActionProvider(O,W,H,J){const q=new g.$Qc,x=this.t(new N(this.h,this.j.converter,this.k,H,this.l,O,this.m),O);return this.e.$registerQuickFixSupport(x,this.o(W,O),{providedKinds:J?.providedCodeActionKinds?.map(ue=>ue.value),documentation:J?.documentation?.map(ue=>({kind:ue.kind.value,command:this.j.converter.toInternal(ue.command,q)}))},$e.u(O),!!H.resolveCodeAction),q.add(this.p(x)),q}$provideCodeActions(O,W,H,J,q){return this.s(O,N,x=>x.provideCodeActions(y.URI.revive(W),H,J,q),void 0,q)}$resolveCodeAction(O,W,H){return this.s(O,N,J=>J.resolveCodeAction(W,H),{},void 0)}$releaseCodeActions(O,W){this.s(O,N,H=>Promise.resolve(H.releaseCodeActions(W)),void 0,void 0)}registerDocumentFormattingEditProvider(O,W,H){const J=this.t(new T(this.h,H),O);return this.e.$registerDocumentFormattingSupport(J,this.o(W,O),O.identifier,O.displayName||O.name),this.p(J)}$provideDocumentFormattingEdits(O,W,H,J){return this.s(O,T,q=>q.provideDocumentFormattingEdits(y.URI.revive(W),H,J),void 0,J)}registerDocumentRangeFormattingEditProvider(O,W,H){const J=typeof H.provideDocumentRangesFormattingEdits=="function",q=this.t(new G(this.h,H),O);return this.e.$registerRangeFormattingSupport(q,this.o(W,O),O.identifier,O.displayName||O.name,J),this.p(q)}$provideDocumentRangeFormattingEdits(O,W,H,J,q){return this.s(O,G,x=>x.provideDocumentRangeFormattingEdits(y.URI.revive(W),H,J,q),void 0,q)}$provideDocumentRangesFormattingEdits(O,W,H,J,q){return this.s(O,G,x=>x.provideDocumentRangesFormattingEdits(y.URI.revive(W),H,J,q),void 0,q)}registerOnTypeFormattingEditProvider(O,W,H,J){const q=this.t(new de(this.h,H),O);return this.e.$registerOnTypeFormattingSupport(q,this.o(W,O),J,O.identifier),this.p(q)}$provideOnTypeFormattingEdits(O,W,H,J,q,x){return this.s(O,de,ue=>ue.provideOnTypeFormattingEdits(y.URI.revive(W),H,J,q,x),void 0,x)}registerWorkspaceSymbolProvider(O,W){const H=this.t(new me(W,this.l),O);return this.e.$registerNavigateTypeSupport(H,typeof W.resolveWorkspaceSymbol=="function"),this.p(H)}$provideWorkspaceSymbols(O,W,H){return this.s(O,me,J=>J.provideWorkspaceSymbols(W,H),{symbols:[]},H)}$resolveWorkspaceSymbol(O,W,H){return this.s(O,me,J=>J.resolveWorkspaceSymbol(W,H),void 0,void 0)}$releaseWorkspaceSymbols(O,W){this.s(O,me,H=>H.releaseWorkspaceSymbols(W),void 0,void 0)}registerRenameProvider(O,W,H){const J=this.t(new De(this.h,H,this.l),O);return this.e.$registerRenameSupport(J,this.o(W,O),De.supportsResolving(H)),this.p(J)}$provideRenameEdits(O,W,H,J,q){return this.s(O,De,x=>x.provideRenameEdits(y.URI.revive(W),H,J,q),void 0,q)}$resolveRenameLocation(O,W,H,J){return this.s(O,De,q=>q.resolveRenameLocation(y.URI.revive(W),H,J),void 0,J)}registerDocumentSemanticTokensProvider(O,W,H,J){const q=this.t(new le(this.h,H),O),x=typeof H.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(q,this.o(W,O),J,x);let ue=this.p(q);if(x){const Ne=H.onDidChangeSemanticTokens(Be=>this.e.$emitDocumentSemanticTokensEvent(x));ue=M.$BK.from(ue,Ne)}return ue}$provideDocumentSemanticTokens(O,W,H,J){return this.s(O,le,q=>q.provideDocumentSemanticTokens(y.URI.revive(W),H,J),null,J)}$releaseDocumentSemanticTokens(O,W){this.s(O,le,H=>H.releaseDocumentSemanticColoring(W),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(O,W,H,J){const q=this.t(new pe(this.h,H),O);return this.e.$registerDocumentRangeSemanticTokensProvider(q,this.o(W,O),J),this.p(q)}$provideDocumentRangeSemanticTokens(O,W,H,J){return this.s(O,pe,q=>q.provideDocumentRangeSemanticTokens(y.URI.revive(W),H,J),null,J)}registerCompletionItemProvider(O,W,H,J){const q=this.t(new re(this.h,this.j.converter,H,this.m,O),O);return this.e.$registerCompletionsProvider(q,this.o(W,O),J,re.supportsResolving(H),O.identifier),this.p(q)}$provideCompletionItems(O,W,H,J,q){return this.s(O,re,x=>x.provideCompletionItems(y.URI.revive(W),H,J,q),void 0,q)}$resolveCompletionItem(O,W,H){return this.s(O,re,J=>J.resolveCompletionItem(W,H),void 0,H)}$releaseCompletionItems(O,W){this.s(O,re,H=>H.releaseCompletionItems(W),void 0,void 0)}registerInlineCompletionsProvider(O,W,H,J){const q=new se(O,this.h,H,this.j.converter),x=this.t(q,O);return this.e.$registerInlineCompletionsSupport(x,this.o(W,O),q.supportsHandleEvents,v.$_l.toKey(O.identifier.value),J?.yieldTo?.map(ue=>v.$_l.toKey(ue))||[]),this.p(x)}$provideInlineCompletions(O,W,H,J,q){return this.s(O,Pe,x=>x.provideInlineCompletions(y.URI.revive(W),H,J,q),void 0,q)}$handleInlineCompletionDidShow(O,W,H,J){this.s(O,Pe,async q=>{q.handleDidShowCompletionItem(W,H,J)},void 0,void 0)}$handleInlineCompletionPartialAccept(O,W,H,J){this.s(O,Pe,async q=>{q.handlePartialAccept(W,H,J)},void 0,void 0)}$freeInlineCompletionsList(O,W){this.s(O,Pe,async H=>{H.disposeCompletions(W)},void 0,void 0)}registerSignatureHelpProvider(O,W,H,J){const q=Array.isArray(J)?{triggerCharacters:J,retriggerCharacters:[]}:J,x=this.t(new j(this.h,H),O);return this.e.$registerSignatureHelpProvider(x,this.o(W,O),q),this.p(x)}$provideSignatureHelp(O,W,H,J,q){return this.s(O,j,x=>x.provideSignatureHelp(y.URI.revive(W),H,J,q),void 0,q)}$releaseSignatureHelp(O,W){this.s(O,j,H=>H.releaseSignatureHelp(W),void 0,void 0)}registerInlayHintsProvider(O,W,H){const J=typeof H.onDidChangeInlayHints=="function"?this.q():void 0,q=this.t(new ie(this.h,this.j.converter,H,this.l,O),O);this.e.$registerInlayHintsProvider(q,this.o(W,O),typeof H.resolveInlayHint=="function",J,$e.u(O));let x=this.p(q);if(J!==void 0){const ue=H.onDidChangeInlayHints(Ne=>this.e.$emitInlayHintsEvent(J));x=M.$BK.from(x,ue)}return x}$provideInlayHints(O,W,H,J){return this.s(O,ie,q=>q.provideInlayHints(y.URI.revive(W),H,J),void 0,J)}$resolveInlayHint(O,W,H){return this.s(O,ie,J=>J.resolveInlayHint(W,H),void 0,H)}$releaseInlayHints(O,W){this.s(O,ie,H=>H.releaseHints(W),void 0,void 0)}registerDocumentLinkProvider(O,W,H){const J=this.t(new ve(this.h,H),O);return this.e.$registerDocumentLinkProvider(J,this.o(W,O),typeof H.resolveDocumentLink=="function"),this.p(J)}$provideDocumentLinks(O,W,H){return this.s(O,ve,J=>J.provideLinks(y.URI.revive(W),H),void 0,H,W.scheme==="output")}$resolveDocumentLink(O,W,H){return this.s(O,ve,J=>J.resolveLink(W,H),void 0,void 0,!0)}$releaseDocumentLinks(O,W){this.s(O,ve,H=>H.releaseLinks(W),void 0,void 0,!0)}registerColorProvider(O,W,H){const J=this.t(new ne(this.h,H),O);return this.e.$registerDocumentColorProvider(J,this.o(W,O)),this.p(J)}$provideDocumentColors(O,W,H){return this.s(O,ne,J=>J.provideColors(y.URI.revive(W),H),[],H)}$provideColorPresentations(O,W,H,J){return this.s(O,ne,q=>q.provideColorPresentations(y.URI.revive(W),H,J),void 0,J)}registerFoldingRangeProvider(O,W,H){const J=this.q(),q=typeof H.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(J,new ae(new he(this.h,H),O)),this.e.$registerFoldingRangeProvider(J,this.o(W,O),O.identifier,q);let x=this.p(J);if(q!==void 0){const ue=H.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(q));x=M.$BK.from(x,ue)}return x}$provideFoldingRanges(O,W,H,J){return this.s(O,he,q=>q.provideFoldingRanges(y.URI.revive(W),H,J),void 0,J)}registerSelectionRangeProvider(O,W,H){const J=this.t(new ce(this.h,H,this.l),O);return this.e.$registerSelectionRangeProvider(J,this.o(W,O)),this.p(J)}$provideSelectionRanges(O,W,H,J){return this.s(O,ce,q=>q.provideSelectionRanges(y.URI.revive(W),H,J),[],J)}registerCallHierarchyProvider(O,W,H){const J=this.t(new ye(this.h,H),O);return this.e.$registerCallHierarchyProvider(J,this.o(W,O)),this.p(J)}$prepareCallHierarchy(O,W,H,J){return this.s(O,ye,q=>Promise.resolve(q.prepareSession(y.URI.revive(W),H,J)),void 0,J)}$provideCallHierarchyIncomingCalls(O,W,H,J){return this.s(O,ye,q=>q.provideCallsTo(W,H,J),void 0,J)}$provideCallHierarchyOutgoingCalls(O,W,H,J){return this.s(O,ye,q=>q.provideCallsFrom(W,H,J),void 0,J)}$releaseCallHierarchy(O,W){this.s(O,ye,H=>Promise.resolve(H.releaseSession(W)),void 0,void 0)}registerTypeHierarchyProvider(O,W,H){const J=this.t(new _(this.h,H),O);return this.e.$registerTypeHierarchyProvider(J,this.o(W,O)),this.p(J)}$prepareTypeHierarchy(O,W,H,J){return this.s(O,_,q=>Promise.resolve(q.prepareSession(y.URI.revive(W),H,J)),void 0,J)}$provideTypeHierarchySupertypes(O,W,H,J){return this.s(O,_,q=>q.provideSupertypes(W,H,J),void 0,J)}$provideTypeHierarchySubtypes(O,W,H,J){return this.s(O,_,q=>q.provideSubtypes(W,H,J),void 0,J)}$releaseTypeHierarchy(O,W){this.s(O,_,H=>Promise.resolve(H.releaseSession(W)),void 0,void 0)}registerDocumentOnDropEditProvider(O,W,H,J){const q=this.q();this.f.set(q,new ae(new fe(this.e,this.h,H,q,O),O));const x=(0,n.$MF)(O,"dropMetadata")&&J?fe.toInternalProviderId(O.identifier.value,J.id):void 0;return this.e.$registerDocumentOnDropEditProvider(q,this.o(W,O),x,(0,n.$MF)(O,"dropMetadata")?J:void 0),this.p(q)}$provideDocumentOnDropEdits(O,W,H,J,q,x){return this.s(O,fe,ue=>Promise.resolve(ue.provideDocumentOnDropEdits(W,y.URI.revive(H),J,q,x)),void 0,void 0)}registerMappedEditsProvider(O,W,H){const J=this.t(new te(this.h,H),O);return this.e.$registerMappedEditsProvider(J,this.o(W,O)),this.p(J)}$provideMappedEdits(O,W,H,J,q){return this.s(O,te,x=>Promise.resolve(x.provideMappedEdits(W,H,J,q)),null,q)}registerDocumentPasteEditProvider(O,W,H,J){const q=this.q();this.f.set(q,new ae(new C(this.e,this.h,H,q,O),O));const x=C.toInternalProviderId(O.identifier.value,J.id);return this.e.$registerPasteEditProvider(q,this.o(W,O),x,{supportsCopy:!!H.prepareDocumentPaste,supportsPaste:!!H.provideDocumentPasteEdits,copyMimeTypes:J.copyMimeTypes,pasteMimeTypes:J.pasteMimeTypes}),this.p(q)}$prepareDocumentPaste(O,W,H,J,q){return this.s(O,C,x=>x.prepareDocumentPaste(y.URI.revive(W),H,J,q),void 0,q)}$providePasteEdits(O,W,H,J,q,x){return this.s(O,C,ue=>ue.providePasteEdits(W,y.URI.revive(H),J,q,x),void 0,x)}static w(O){return{pattern:O.source,flags:O.flags}}static y(O){return{decreaseIndentPattern:$e.w(O.decreaseIndentPattern),increaseIndentPattern:$e.w(O.increaseIndentPattern),indentNextLinePattern:O.indentNextLinePattern?$e.w(O.indentNextLinePattern):void 0,unIndentedLinePattern:O.unIndentedLinePattern?$e.w(O.unIndentedLinePattern):void 0}}static z(O){return{beforeText:$e.w(O.beforeText),afterText:O.afterText?$e.w(O.afterText):void 0,previousLineText:O.previousLineText?$e.w(O.previousLineText):void 0,action:O.action}}static B(O){return O.map($e.z)}static C(O){return{open:O.open,close:O.close,notIn:O.notIn?O.notIn.map(W=>M.SyntaxTokenType.toString(W)):void 0}}static D(O){return O.map($e.C)}setLanguageConfiguration(O,W,H){const{wordPattern:J}=H;if(J&&(0,E.$Se)(J))throw new Error(`Invalid language configuration: wordPattern '${J}' is not allowed to match the empty string.`);J?this.h.setWordDefinitionFor(W,J):this.h.setWordDefinitionFor(W,void 0),H.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",O,"Do not use."),H.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",O,"Do not use.");const q=this.q(),x={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?$e.w(H.wordPattern):void 0,indentationRules:H.indentationRules?$e.y(H.indentationRules):void 0,onEnterRules:H.onEnterRules?$e.B(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport,autoClosingPairs:H.autoClosingPairs?$e.D(H.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(q,W,x),this.p(q)}$setWordDefinitions(O){for(const W of O)this.h.setWordDefinitionFor(W.languageId,new RegExp(W.regexSource,W.regexFlags))}}e.$Rdc=$e}),define(Ae[255],Re([1,0,3,8,7,31,14,6,23]),function(we,e,y,F,A,M,R,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$efc=void 0;class f{constructor(D,u,b,v){this.c=u,this.d=b,this.e=v,this.b=[],this.f=0,this.g=new Set,this.a=D.getProxy(y.$zK.MainThreadLanguages)}$acceptLanguageIds(D){this.b=D}async getLanguages(){return this.b.slice(0)}async changeLanguage(D,u){await this.a.$changeLanguage(D,u);const b=this.c.getDocumentData(D);if(!b)throw new Error(`document '${D.toString()}' NOT found`);return b.document}async tokenAtPosition(D,u){const b=D.version,v=F.Position.from(u),g=await this.a.$tokensAtPosition(D.uri,v),t={type:A.StandardTokenType.Other,range:D.getWordRangeAtPosition(u)??new A.$DK(u.line,u.character,u.line,u.character)};if(!g)return t;const i={range:F.Range.to(g.range),type:F.TokenType.to(g.type)};return!i.range.contains(u)||b!==D.version?t:i}createLanguageStatusItem(D,u,b){const v=this.f++,g=this.a,t=this.g,i=`${D.identifier.value}/${u}`;if(t.has(i))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);t.add(i);const r={selector:b,id:u,name:D.displayName??D.name,severity:A.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let c;const o=new $.$Qc,l=()=>{if(c?.dispose(),!t.has(i)){console.warn(`LanguageStatusItem (${u}) from ${D.identifier.value} has been disposed and CANNOT be updated anymore`);return}c=(0,R.$Zg)(()=>{o.clear(),this.a.$setLanguageStatus(v,{id:i,name:r.name??D.displayName??D.name,source:D.displayName??D.name,selector:F.DocumentSelector.from(r.selector,this.e),label:r.text,detail:r.detail??"",severity:r.severity===A.LanguageStatusSeverity.Error?M.default.Error:r.severity===A.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:r.command&&this.d.toInternal(r.command,o),accessibilityInfo:r.accessibilityInformation,busy:r.busy})},0)},n={dispose(){o.dispose(),c?.dispose(),g.$removeLanguageStatus(v),t.delete(i)},get id(){return r.id},get name(){return r.name},set name(s){r.name=s,l()},get selector(){return r.selector},set selector(s){r.selector=s,l()},get text(){return r.text},set text(s){r.text=s,l()},set text2(s){(0,E.$NF)(D,"languageStatusText"),r.text=s,l()},get text2(){return(0,E.$NF)(D,"languageStatusText"),r.text},get detail(){return r.detail},set detail(s){r.detail=s,l()},get severity(){return r.severity},set severity(s){r.severity=s,l()},get accessibilityInformation(){return r.accessibilityInformation},set accessibilityInformation(s){r.accessibilityInformation=s,l()},get command(){return r.command},set command(s){r.command=s,l()},get busy(){return r.busy},set busy(s){r.busy=s,l()}};return l(),n}}e.$efc=f}),define(Ae[82],Re([1,0,21,12,2,4,15,3,27,17]),function(we,e,y,F,A,M,R,$,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dec=e.$Cec=void 0;let P=class{constructor(u,b,v){this.f=v,this.d=new Map,this.a=b.getProxy($.$zK.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===y.$g}getMessage(u,b){const{message:v,args:g,comment:t}=b;if(this.c)return(0,F.$He)(v,g??{});let i=v;t&&t.length>0&&(i+=`/${Array.isArray(t)?t.join(""):t}`);const r=this.d.get(u)?.contents[i];return r||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${i}`),(0,F.$He)(r??v,g??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let b;const v=await this.g(u);if(!v){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const g=await this.a.$fetchBundleContents(v),t=JSON.parse(g);b=u.isBuiltin?t.contents?.bundle:t}catch(g){this.f.error(`Failed to load translations for ${u.identifier.value} from ${v}: ${g.message}`);return}b&&this.d.set(u.identifier.value,{contents:b,uri:v})}async g(u){if(u.isBuiltin){const b=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return A.URI.revive(b)}return u.l10n?A.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Cec=P,e.$Cec=P=Ke([Ve(0,E.$RM),Ve(1,f.$BM),Ve(2,R.$dj)],P),e.$Dec=(0,M.$Vh)("IExtHostLocalizationService")}),define(Ae[256],Re([1,0,15,3,27,17,2,51]),function(we,e,y,F,A,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pfc=void 0;let E=class extends y.$oj{constructor(D,u){super(u.logLevel,u.logsLocation,u.loggers.map(b=>(0,$.$sh)(b))),this.r=D.getProxy(F.$zK.MainThreadLogger)}$setLogLevel(D,u){u?this.setLogLevel(R.URI.revive(u),D):this.setLogLevel(D)}setVisibility(D,u){super.setVisibility(D,u),this.r.$setVisibility(D,u)}s(D,u,b){return new f(this.r,D,u,b)}};e.$Pfc=E,e.$Pfc=E=Ke([Ve(0,M.$BM),Ve(1,A.$RM)],E);class f extends y.$jj{constructor(D,u,b,v){super(v?.logLevel==="always"),this.r=D,this.s=u,this.m=!1,this.n=[],this.setLevel(b),this.r.$createLogger(u,v).then(()=>{this.u(this.n),this.m=!0})}g(D,u){const b=[[D,u]];this.m?this.u(b):this.n.push(...b)}u(D){this.r.$log(this.s,D)}flush(){this.r.$flush(this.s)}}}),define(Ae[83],Re([1,0,3,4,6,17,24]),function(we,e,y,F,A,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fec=e.$Eec=void 0,e.$Eec=(0,F.$Vh)("IExtHostManagedSockets");let $=class{constructor(D){this.b=0,this.c=null,this.d=new Map,this.a=D.getProxy(y.$zK.MainThreadManagedSockets)}setFactory(D,u){for(const b of this.d.values())b.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new E(D,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(D){if(!this.c||this.c.socketFactoryId!==D)throw new Error(`No socket factory with id ${D}`);const u=++this.b,b=await this.c.makeConnection(),v=new A.$Qc;return this.d.set(u,new f(u,b,v)),v.add((0,A.$Pc)(()=>this.d.delete(u))),v.add(b.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),v.dispose()})),v.add(b.onDidClose(g=>{this.a.$onDidManagedSocketClose(u,g?.stack??g?.message),v.dispose()})),v.add(b.onDidReceiveMessage(g=>this.a.$onDidManagedSocketHaveData(u,R.$fe.wrap(g)))),u}$remoteSocketWrite(D,u){this.d.get(D)?.actual.send(u.buffer)}$remoteSocketEnd(D){const u=this.d.get(D);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(D){await this.d.get(D)?.actual.drain?.()}};e.$Fec=$,e.$Fec=$=Ke([Ve(0,M.$BM)],$);class E{constructor(D,u){this.socketFactoryId=D,this.makeConnection=u}}class f extends A.$Rc{constructor(D,u,b){super(),this.socketId=D,this.actual=u,this.B(b)}}}),define(Ae[257],Re([1,0,3,15,23]),function(we,e,y,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ffc=void 0;function M($){return $&&$.title}let R=class{constructor(E,f){this.b=f,this.a=E.getProxy(y.$zK.MainThreadMessageService)}showMessage(E,f,P,D,u){const b={source:{identifier:E.identifier,label:E.displayName||E.name}};let v;typeof D=="string"||M(D)?v=[D,...u]:(b.modal=D?.modal,b.useCustom=D?.useCustom,b.detail=D?.detail,v=u),b.useCustom&&(0,A.$NF)(E,"resolvers");const g=[];for(let t=0;t<v.length;t++){const i=v[t];if(typeof i=="string")g.push({title:i,handle:t,isCloseAffordance:!1});else if(typeof i=="object"){const{title:r,isCloseAffordance:c}=i;g.push({title:r,isCloseAffordance:!!c,handle:t})}else this.b.warn("Invalid message item:",i)}return this.a.$showMessage(f,P,b,g).then(t=>{if(typeof t=="number")return v[t]})}};e.$ffc=R,e.$ffc=R=Ke([Ve(1,F.$dj)],R)}),define(Ae[258],Re([1,0,18,14,19,5,6,28,2,22,15,3,32,8,7,78,211,23,49]),function(we,e,y,F,A,M,R,$,E,f,P,D,u,b,v,g,t,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kfc=e.$jfc=void 0;let c=class{constructor(m,S,k,h,w){this.l=S,this.m=k,this.n=h,this.o=w,this.b=new $.$zc,this.c=new $.$zc,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new Map,this.j=0,this.k=new M.$Rd,this.onDidChangeNotebookCellExecutionState=this.k.event,this.a=m.getProxy(D.$zK.MainThreadNotebookKernels);const I=new u.$2M("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.$ZM("options","Select kernel options",L=>!0,L=>{if(L&&"notebookEditor"in L&&"id"in L){const V=this.m.getIdByEditor(L.notebookEditor);return{id:L.id,extension:L.extension,notebookEditorId:V}}else if(L&&"notebookEditor"in L){const V=this.m.getIdByEditor(L.notebookEditor);if(V===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${L.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:V}}return L})],u.$1M.Void);this.n.registerApiCommand(I)}createNotebookController(m,S,k,h,w,I){for(const pe of this.i.values())if(pe.controller.id===S&&f.$_l.equals(m.identifier,pe.extensionId))throw new Error(`notebook controller with id '${S}' ALREADY exist`);const L=this.j++,V=this;this.o.trace(`NotebookController[${L}], CREATED by ${m.identifier.value}, ${S}`);const Y=()=>console.warn(`NO execute handler from notebook controller '${T.id}' of extension: '${m.identifier}'`);let U=!1;const N=new M.$Rd,C=new M.$Rd,T={id:d(m.identifier,S),notebookType:k,extensionId:m.identifier,extensionLocation:m.extensionLocation,label:h||m.identifier.value,preloads:I?I.map(b.NotebookRendererScript.from):[]};let G=w??Y,de;this.a.$addKernel(L,T).catch(pe=>{console.log(pe),U=!0});let me=0;const De=()=>{if(U)return;const pe=++me;Promise.resolve().then(()=>{pe===me&&this.a.$updateKernel(L,T)})},ke=new $.$zc,le={get id(){return S},get notebookType(){return T.notebookType},onDidChangeSelectedNotebooks:N.event,get label(){return T.label},set label(pe){T.label=pe??m.displayName??m.name,De()},get detail(){return T.detail??""},set detail(pe){T.detail=pe,De()},get description(){return T.description??""},set description(pe){T.description=pe,De()},get supportedLanguages(){return T.supportedLanguages},set supportedLanguages(pe){T.supportedLanguages=pe,De()},get supportsExecutionOrder(){return T.supportsExecutionOrder??!1},set supportsExecutionOrder(pe){T.supportsExecutionOrder=pe,De()},get rendererScripts(){return T.preloads?T.preloads.map(b.NotebookRendererScript.to):[]},get executeHandler(){return G},set executeHandler(pe){G=pe??Y},get interruptHandler(){return de},set interruptHandler(pe){de=pe,T.supportsInterrupt=!!pe,De()},createNotebookCellExecution(pe){if(U)throw new Error("notebook controller is DISPOSED");if(!ke.has(pe.notebook.uri))throw V.o.trace(`NotebookController[${L}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ke.keys()).map(re=>re.toString())),new Error(`notebook controller is NOT associated to notebook: ${pe.notebook.uri.toString()}`);return V._createNotebookCellExecution(pe,d(m.identifier,this.id))},createNotebookExecution(pe){if((0,i.$NF)(m,"notebookExecution"),U)throw new Error("notebook controller is DISPOSED");if(!ke.has(pe.uri))throw V.o.trace(`NotebookController[${L}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ke.keys()).map(re=>re.toString())),new Error(`notebook controller is NOT associated to notebook: ${pe.uri.toString()}`);return V._createNotebookExecution(pe,d(m.identifier,this.id))},dispose:()=>{U||(this.o.trace(`NotebookController[${L}], DISPOSED`),U=!0,this.i.delete(L),N.dispose(),C.dispose(),this.a.$removeKernel(L))},updateNotebookAffinity(pe,re){re===v.NotebookControllerAffinity2.Hidden&&(0,i.$NF)(m,"notebookControllerAffinityHidden"),V.a.$updateNotebookPriority(L,pe.uri,re)},onDidReceiveMessage:C.event,postMessage(pe,re){return(0,i.$NF)(m,"notebookMessaging"),V.a.$postMessage(L,re&&V.m.getIdByEditor(re),pe)},asWebviewUri(pe){return(0,i.$NF)(m,"notebookMessaging"),(0,g.$9tb)(pe,V.l.remote)}};return this.i.set(L,{extensionId:m.identifier,controller:le,onDidReceiveMessage:C,onDidChangeSelection:N,associatedNotebooks:ke}),le}getIdByController(m){for(const[S,k]of this.i)if(k.controller===m)return d(k.extensionId,m.id);return null}createNotebookControllerDetectionTask(m,S){const k=this.f++,h=this;this.o.trace(`NotebookControllerDetectionTask[${k}], CREATED by ${m.identifier.value}`),this.a.$addKernelDetectionTask(k,S);const w={dispose:()=>{this.e.delete(k),h.a.$removeKernelDetectionTask(k)}};return this.e.set(k,w),w}registerKernelSourceActionProvider(m,S,k){const h=this.h++,w=typeof k.onDidChangeNotebookKernelSourceActions=="function"?h:void 0,I=this;this.g.set(h,k),this.o.trace(`NotebookKernelSourceActionProvider[${h}], CREATED by ${m.identifier.value}`),this.a.$addKernelSourceActionProvider(h,h,S);let L;return w!==void 0&&(L=k.onDidChangeNotebookKernelSourceActions(V=>this.a.$emitNotebookKernelSourceActionsChangeEvent(w))),{dispose:()=>{this.g.delete(h),I.a.$removeKernelSourceActionProvider(h,h),L?.dispose()}}}async $provideKernelSourceActions(m,S){const k=this.g.get(m);if(k){const h=new R.$Qc;return(await k.provideNotebookKernelSourceActions(S)??[]).map(I=>b.NotebookKernelSourceAction.from(I,this.n.converter,h))}return[]}$acceptNotebookAssociation(m,S,k){const h=this.i.get(m);if(h){const w=this.m.getNotebookDocument(E.URI.revive(S));k?h.associatedNotebooks.set(w.uri,!0):h.associatedNotebooks.delete(w.uri),this.o.trace(`NotebookController[${m}] ASSOCIATE notebook`,w.uri.toString(),k),h.onDidChangeSelection.fire({selected:k,notebook:w.apiNotebook})}}async $executeCells(m,S,k){const h=this.i.get(m);if(!h)return;const w=this.m.getNotebookDocument(E.URI.revive(S)),I=[];for(const L of k){const V=w.getCell(L);V&&I.push(V.apiCell)}try{this.o.trace(`NotebookController[${m}] EXECUTE cells`,w.uri.toString(),I.length),await h.controller.executeHandler.call(h.controller,I,w.apiNotebook,h.controller)}catch(L){this.o.error(`NotebookController[${m}] execute cells FAILED`,L),console.error(L)}}async $cancelCells(m,S,k){const h=this.i.get(m);if(!h)return;const w=this.m.getNotebookDocument(E.URI.revive(S));if(h.controller.interruptHandler)await h.controller.interruptHandler.call(h.controller,w.apiNotebook);else for(const I of k){const L=w.getCell(I);L&&this.b.get(L.uri)?.cancel()}if(h.controller.interruptHandler){const I=this.c.get(w.uri);k.length&&Array.isArray(I)&&I.length&&I.forEach(L=>L.dispose())}}$acceptKernelMessageFromRenderer(m,S,k){const h=this.i.get(m);if(!h)return;const w=this.m.getEditorById(S);h.onDidReceiveMessage.fire(Object.freeze({editor:w.apiEditor,message:k}))}$cellExecutionChanged(m,S,k){const w=this.m.getNotebookDocument(E.URI.revive(m)).getCell(S);if(w){const I=k?b.NotebookCellExecutionState.to(k):v.NotebookCellExecutionState.Idle;I!==void 0&&this.k.fire({cell:w.apiCell,state:I})}}_createNotebookCellExecution(m,S){if(m.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const h=this.m.getNotebookDocument(m.notebook.uri).getCellFromApiCell(m);if(!h)throw new Error("invalid cell");if(this.b.has(h.uri))throw new Error(`duplicate execution for ${h.uri}`);const w=new l(S,h,this.a);this.b.set(h.uri,w);const I=w.onDidChangeState(()=>{w.state===o.Resolved&&(w.dispose(),I.dispose(),this.b.delete(h.uri))});return w.asApiObject()}_createNotebookExecution(m,S){const k=this.m.getNotebookDocument(m.uri),h=m.getCells().find(L=>{const V=k.getCellFromApiCell(L);return V&&this.b.has(V.uri)});if(h)throw new Error(`duplicate cell execution for ${h.document.uri}`);if(this.c.has(k.uri))throw new Error(`duplicate notebook execution for ${k.uri}`);const w=new s(S,k,this.a),I=w.onDidChangeState(()=>{w.state===n.Resolved&&(w.dispose(),I.dispose(),this.c.delete(k.uri))});return this.c.set(k.uri,[w,I]),w.asApiObject()}};e.$jfc=c,e.$jfc=c=Ke([Ve(4,P.$dj)],c);var o;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(o||(o={}));class l extends R.$Rc{static{this.a=0}get state(){return this.f}constructor(m,S,k){super(),this.m=S,this.n=k,this.b=l.a++,this.c=new M.$Rd,this.onDidChangeState=this.c.event,this.f=o.Init,this.g=this.B(new A.$2d),this.h=new a(10,h=>this.s(h)),this.j=S.internalMetadata.executionOrder,this.n.$createExecution(this.b,m,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(m){await this.h.addItem(m)}async s(m){const S=Array.isArray(m)?m:[m];return this.n.$updateExecution(this.b,new r.$wv(S))}t(){if(this.f===o.Init)throw new Error("Must call start before modifying cell output");if(this.f===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(m){let S=this.m;if(m&&(S=this.m.notebook.getCellFromApiCell(m)),!S)throw new Error("INVALID cell");return S.handle}y(m){return m.map(S=>{const k=v.$3L.ensureUniqueMimeTypes(S.items,!0);return k===S.items?b.NotebookCellOutput.from(S):b.NotebookCellOutput.from({items:k,id:S.id,metadata:S.metadata})})}async z(m,S,k){const h=this.w(S),w=this.y((0,y.$2b)(m));return this.r({editType:t.CellExecutionUpdateType.Output,cellHandle:h,append:k,outputs:w})}async C(m,S,k){return m=v.$3L.ensureUniqueMimeTypes((0,y.$2b)(m),!0),this.r({editType:t.CellExecutionUpdateType.OutputItems,items:m.map(b.NotebookCellOutputItem.from),outputId:S.id,append:k})}asApiObject(){const m=this;return Object.freeze({get token(){return m.g.token},get cell(){return m.m.apiCell},get executionOrder(){return m.j},set executionOrder(k){m.j=k,m.s([{editType:t.CellExecutionUpdateType.ExecutionState,executionOrder:m.j}])},start(k){if(m.f===o.Resolved||m.f===o.Started)throw new Error("Cannot call start again");m.f=o.Started,m.c.fire(),m.s({editType:t.CellExecutionUpdateType.ExecutionState,runStartTime:k})},end(k,h){if(m.f===o.Resolved)throw new Error("Cannot call resolve twice");m.f=o.Resolved,m.c.fire(),m.h.flush(),m.n.$completeExecution(m.b,new r.$wv({runEndTime:h,lastRunSuccess:k}))},clearOutput(k){return m.t(),m.z([],k,!1)},appendOutput(k,h){return m.t(),m.z(k,h,!0)},replaceOutput(k,h){return m.t(),m.z(k,h,!1)},appendOutputItems(k,h){return m.t(),m.C(k,h,!0)},replaceOutputItems(k,h){return m.t(),m.C(k,h,!1)}})}}var n;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(n||(n={}));class s extends R.$Rc{static{this.a=0}get state(){return this.f}constructor(m,S,k){super(),this.h=S,this.j=k,this.b=s.a++,this.c=new M.$Rd,this.onDidChangeState=this.c.event,this.f=n.Init,this.g=this.B(new A.$2d),this.j.$createNotebookExecution(this.b,m,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===n.Resolved||this.f===n.Started)throw new Error("Cannot call start again");this.f=n.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===n.Resolved)throw new Error("Cannot call resolve twice");this.f=n.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class a{constructor(m,S){this.e=m,this.f=S,this.a=[],this.b=Date.now()}addItem(m){return this.a.push(m),this.c||(this.c=new F.$ih,this.b=Date.now(),(0,F.$Yg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const m=this.c;this.c=void 0;const S=this.a;return this.a=[],this.f(S).finally(()=>m.complete())}}function d(p,m){return`${p.value}/${m}`}e.$kfc=d}),define(Ae[259],Re([1,0,5,3,107]),function(we,e,y,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lfc=void 0;class M{constructor($,E){this.c=E,this.a=new Map,this.b=$.getProxy(F.$zK.MainThreadNotebookRenderers)}$postRendererMessage($,E,f){const P=this.c.getEditorById($);this.a.get(E)?.fire({editor:P.apiEditor,message:f})}createRendererMessaging($,E){if(!$.contributes?.notebookRenderer?.some(P=>P.id===E))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${E})`);return{onDidReceiveMessage:(P,D,u)=>this.d(E).event(P,D,u),postMessage:(P,D)=>{A.$4ec.apiEditorsToExtHost.has(P)&&([P,D]=[D,P]);const u=D&&A.$4ec.apiEditorsToExtHost.get(D);return this.b.$postMessage(u?.id,E,P)}}}d($){let E=this.a.get($);return E||(E=new y.$Rd({onDidRemoveLastListener:()=>{E?.dispose(),this.a.delete($)}}),this.a.set($,E),E)}}e.$lfc=M}),define(Ae[260],Re([1,0,6,16,2,23,3]),function(we,e,y,F,A,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ofc=void 0;class ${constructor(f){this.b=new Map,this.a=f.getProxy(R.$zK.MainThreadProfileContentHandlers)}registrProfileContentHandler(f,P,D){if((0,M.$NF)(f,"profileContentHandlers"),this.b.has(P))throw new Error(`Handler with id '${P}' already registered`);return this.b.set(P,D),this.a.$registerProfileContentHandler(P,D.name,D.description,f.identifier.value),(0,y.$Pc)(()=>{this.b.delete(P),this.a.$unregisterProfileContentHandler(P)})}async $saveProfile(f,P,D,u){const b=this.b.get(f);if(!b)throw new Error(`Unknown handler with id: ${f}`);return b.saveProfile(P,D,u)}async $readProfile(f,P,D){const u=this.b.get(f);if(!u)throw new Error(`Unknown handler with id: ${f}`);return u.readProfile((0,F.$Cf)(P)?P:A.URI.revive(P),D)}}e.$ofc=$}),define(Ae[261],Re([1,0,2,3,14,8]),function(we,e,y,F,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qfc=void 0;class R{static{this.a=0}constructor(E,f){this.d=f,this.c=new Map,this.b=E.getProxy(F.$zK.MainThreadQuickDiff)}$provideOriginalResource(E,f,P){const D=y.URI.revive(f),u=this.c.get(E);return u?(0,A.$Qg)(()=>u.provideOriginalResource(D,P)).then(b=>b||null):Promise.resolve(null)}registerQuickDiffProvider(E,f,P,D){const u=R.a++;return this.c.set(u,f),this.b.$registerQuickDiffProvider(u,M.DocumentSelector.from(E,this.d),P,D),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$qfc=R}),define(Ae[262],Re([1,0,19,5,6,3,2,7,11,18,31,45,23,8]),function(we,e,y,F,A,M,R,$,E,f,P,D,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rfc=void 0;function v(g,t,i){const r=g.getProxy(M.$zK.MainThreadQuickOpen);class c{constructor(S,k){this.e=new Map,this.f=0,this.a=S,this.b=k}showQuickPick(S,k,h,w=y.CancellationToken.None){this.c=void 0;const I=Promise.resolve(k),L=++this.f,V=r.$show(L,{title:h?.title,placeHolder:h?.placeHolder,matchOnDescription:h?.matchOnDescription,matchOnDetail:h?.matchOnDetail,ignoreFocusLost:h?.ignoreFocusOut,canPickMany:h?.canPickMany},w),Y={},U=V.then(()=>Y);return Promise.race([U,I]).then(N=>{if(N===Y)return;const C=(0,u.$MF)(S,"quickPickItemTooltip");return I.then(T=>{const G=[];for(let de=0;de<T.length;de++){const me=T[de];if(typeof me=="string")G.push({label:me,handle:de});else if(me.kind===$.QuickPickItemKind.Separator)G.push({type:"separator",label:me.label});else{me.tooltip&&!C&&console.warn(`Extension '${S.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${S.identifier.value}`);const De=me.iconPath?a(me.iconPath):void 0;G.push({label:me.label,iconPath:De?.iconPath,iconClass:De?.iconClass,description:me.description,detail:me.detail,picked:me.picked,alwaysShow:me.alwaysShow,tooltip:C?b.MarkdownString.fromStrict(me.tooltip):void 0,handle:de})}}return h&&typeof h.onDidSelectItem=="function"&&(this.c=de=>{h.onDidSelectItem(T[de])}),r.$setItems(L,G),V.then(de=>{if(typeof de=="number")return T[de];if(Array.isArray(de))return de.map(me=>T[me])})})}).then(void 0,N=>{if(!(0,E.$3)(N))return r.$setError(L,N),Promise.reject(N)})}$onItemSelected(S){this.c?.(S)}showInput(S,k=y.CancellationToken.None){return this.d=S?.validateInput,r.$input(S,typeof this.d=="function",k).then(void 0,h=>{if(!(0,E.$3)(h))return Promise.reject(h)})}async $validateInput(S){if(!this.d)return;const k=await this.d(S);if(!k||typeof k=="string")return k;let h;switch(k.severity){case $.InputBoxValidationSeverity.Info:h=P.default.Info;break;case $.InputBoxValidationSeverity.Warning:h=P.default.Warning;break;case $.InputBoxValidationSeverity.Error:h=P.default.Error;break;default:h=k.message?P.default.Error:P.default.Ignore;break}return{content:k.message,severity:h}}async showWorkspaceFolderPick(S,k=y.CancellationToken.None){const h=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[S]);if(!h)return;const w=await this.a.getWorkspaceFolders2();if(w)return w.find(I=>I.uri.toString()===h.uri.toString())}createQuickPick(S){const k=new d(S,()=>this.e.delete(k._id));return this.e.set(k._id,k),k}createInputBox(S){const k=new p(S,()=>this.e.delete(k._id));return this.e.set(k._id,k),k}$onDidChangeValue(S,k){this.e.get(S)?._fireDidChangeValue(k)}$onDidAccept(S){this.e.get(S)?._fireDidAccept()}$onDidChangeActive(S,k){const h=this.e.get(S);h instanceof d&&h._fireDidChangeActive(k)}$onDidChangeSelection(S,k){const h=this.e.get(S);h instanceof d&&h._fireDidChangeSelection(k)}$onDidTriggerButton(S,k){this.e.get(S)?._fireDidTriggerButton(k)}$onDidTriggerItemButton(S,k,h){const w=this.e.get(S);w instanceof d&&w._fireDidTriggerItemButton(k,h)}$onDidHide(S){this.e.get(S)?._fireDidHide()}}class o{static{this.a=1}constructor(S,k){this.x=S,this.y=k,this._id=d.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new F.$Rd,this.q=new F.$Rd,this.r=new F.$Rd,this.s=new F.$Rd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(S){this.b=S,this.z({title:S})}get step(){return this.c}set step(S){this.c=S,this.z({step:S})}get totalSteps(){return this.d}set totalSteps(S){this.d=S,this.z({totalSteps:S})}get enabled(){return this.g}set enabled(S){this.g=S,this.z({enabled:S})}get busy(){return this.j}set busy(S){this.j=S,this.z({busy:S})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(S){this.k=S,this.z({ignoreFocusOut:S})}get value(){return this.l}set value(S){this.l=S,this.z({value:S})}get placeholder(){return this.m}set placeholder(S){this.m=S,this.z({placeholder:S})}get buttons(){return this.n}set buttons(S){this.n=S.slice(),this.o.clear(),S.forEach((k,h)=>{const w=k===$.$VL.Back?-1:h;this.o.set(w,k)}),this.z({buttons:S.map((k,h)=>({...a(k.iconPath),tooltip:k.tooltip,handle:k===$.$VL.Back?-1:h}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(S){this.l=S,this.q.fire(S)}_fireDidTriggerButton(S){const k=this.o.get(S);k&&this.r.fire(k)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,A.$Mc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),r.$dispose(this._id))}z(S){if(!this.v){for(const k of Object.keys(S)){const h=S[k];this.u[k]=h===void 0?null:h}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){r.$createOrUpdate(this.u),this.u={id:this._id}}}function l(m){if(m instanceof $.$vL)return{id:m.id};const S=s(m),k=n(m);return{dark:typeof S=="string"?R.URI.file(S):S,light:typeof k=="string"?R.URI.file(k):k}}function n(m){return typeof m=="object"&&"light"in m?m.light:m}function s(m){return typeof m=="object"&&"dark"in m?m.dark:m}function a(m){const S=l(m);let k,h;return"id"in S?h=D.ThemeIcon.asClassName(S):k=S,{iconPath:k,iconClass:h}}class d extends o{constructor(S,k){super(S.identifier,k),this.O=S,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new F.$Rd,this.L=[],this.M=new F.$Rd,this.N=new F.$Rd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(S){this.B=S.slice(),this.C.clear(),this.D.clear(),S.forEach((w,I)=>{this.C.set(I,w),this.D.set(w,I)});const k=(0,u.$MF)(this.O,"quickPickItemTooltip"),h=[];for(let w=0;w<S.length;w++){const I=S[w];if(I.kind===$.QuickPickItemKind.Separator)h.push({type:"separator",label:I.label});else{I.tooltip&&!k&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const L=I.iconPath?a(I.iconPath):void 0;h.push({handle:w,label:I.label,iconPath:L?.iconPath,iconClass:L?.iconClass,description:I.description,detail:I.detail,picked:I.picked,alwaysShow:I.alwaysShow,tooltip:k?b.MarkdownString.fromStrict(I.tooltip):void 0,buttons:I.buttons?.map((V,Y)=>({...a(V.iconPath),tooltip:V.tooltip,handle:Y}))})}}this.z({items:h})}get canSelectMany(){return this.E}set canSelectMany(S){this.E=S,this.z({canSelectMany:S})}get matchOnDescription(){return this.F}set matchOnDescription(S){this.F=S,this.z({matchOnDescription:S})}get matchOnDetail(){return this.G}set matchOnDetail(S){this.G=S,this.z({matchOnDetail:S})}get sortByLabel(){return this.H}set sortByLabel(S){this.H=S,this.z({sortByLabel:S})}get keepScrollPosition(){return this.I}set keepScrollPosition(S){this.I=S,this.z({keepScrollPosition:S})}get activeItems(){return this.J}set activeItems(S){this.J=S.filter(k=>this.D.has(k)),this.z({activeItems:this.J.map(k=>this.D.get(k))})}get selectedItems(){return this.L}set selectedItems(S){this.L=S.filter(k=>this.D.has(k)),this.z({selectedItems:this.L.map(k=>this.D.get(k))})}_fireDidChangeActive(S){const k=(0,f.$Gb)(S.map(h=>this.C.get(h)));this.J=k,this.K.fire(k)}_fireDidChangeSelection(S){const k=(0,f.$Gb)(S.map(h=>this.C.get(h)));this.L=k,this.M.fire(k)}_fireDidTriggerItemButton(S,k){const h=this.C.get(S);if(!h||!h.buttons||!h.buttons.length)return;const w=h.buttons[k];w&&this.N.fire({button:w,item:h})}}class p extends o{constructor(S,k){super(S.identifier,k),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(S){this.B=S,this.z({password:S})}get prompt(){return this.C}set prompt(S){this.C=S,this.z({prompt:S})}get valueSelection(){return this.D}set valueSelection(S){this.D=S,this.z({valueSelection:S})}get validationMessage(){return this.E}set validationMessage(S){this.E=S,S?typeof S=="string"?this.z({validationMessage:S,severity:P.default.Error}):this.z({validationMessage:S.message,severity:S.severity??P.default.Error}):this.z({validationMessage:void 0,severity:P.default.Ignore})}}return new c(t,i)}e.$rfc=v}),define(Ae[263],Re([1,0,2,5,66,6,14,3,18,138,15,19,22,45,8,23,13,21]),function(we,e,y,F,A,M,R,$,E,f,P,D,u,b,v,g,t,i){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$tfc=e.$sfc=void 0;function c(N){return N instanceof y.URI}function o(N,C){return N.scheme===t.Schemas.file&&C.scheme===t.Schemas.file&&i.$k?N.toString()===C.toString():N.toString().toLowerCase()===C.toString().toLowerCase()}function l(N){if(N)return typeof N.iconPath=="string"?y.URI.file(N.iconPath):y.URI.isUri(N.iconPath)||b.ThemeIcon.isThemeIcon(N.iconPath)?N.iconPath:void 0}function n(N){if(N?.icon){if(y.URI.isUri(N.icon))return N.icon;if(b.ThemeIcon.isThemeIcon(N.icon))return N.icon;{const C=N.icon;return{light:C.light,dark:C.dark}}}else return}function s(N){if(N.icon){if(y.URI.isUri(N.icon))return N.icon;if(b.ThemeIcon.isThemeIcon(N.icon))return N.icon;{const C=N.icon;return{light:C.light,dark:C.dark}}}else return}function a(N){if(N.icon){if(y.URI.isUri(N.icon))return N.icon;if(b.ThemeIcon.isThemeIcon(N.icon))return N.icon;{const C=N.icon;return{light:C.light,dark:C.dark}}}else return}function d(N,C){if(!N.iconPath&&!C.iconPath)return 0;if(N.iconPath){if(!C.iconPath)return 1}else return-1;const T=typeof N.iconPath=="string"?N.iconPath:y.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id,G=typeof C.iconPath=="string"?C.iconPath:y.URI.isUri(C.iconPath)?C.iconPath.fsPath:C.iconPath.id;return(0,f.$xq)(T,G)}function p(N,C){let T=0;if(N.strikeThrough!==C.strikeThrough)return N.strikeThrough?1:-1;if(N.faded!==C.faded)return N.faded?1:-1;if(N.tooltip!==C.tooltip)return(N.tooltip||"").localeCompare(C.tooltip||"");if(T=d(N,C),T!==0)return T;if(N.light&&C.light)T=d(N.light,C.light);else{if(N.light)return 1;if(C.light)return-1}if(T!==0)return T;if(N.dark&&C.dark)T=d(N.dark,C.dark);else{if(N.dark)return 1;if(C.dark)return-1}return T}function m(N,C){if(N.command!==C.command)return N.command<C.command?-1:1;if(N.title!==C.title)return N.title<C.title?-1:1;if(N.tooltip!==C.tooltip){if(N.tooltip!==void 0&&C.tooltip!==void 0)return N.tooltip<C.tooltip?-1:1;if(N.tooltip!==void 0)return 1;if(C.tooltip!==void 0)return-1}if(N.arguments===C.arguments)return 0;if(N.arguments)if(C.arguments){if(N.arguments.length!==C.arguments.length)return N.arguments.length-C.arguments.length}else return 1;else return-1;for(let T=0;T<N.arguments.length;T++){const G=N.arguments[T],de=C.arguments[T];if(G!==de&&!(c(G)&&c(de)&&o(G,de)))return G<de?-1:1}return 0}function S(N,C){let T=(0,f.$xq)(N.resourceUri.fsPath,C.resourceUri.fsPath,!0);if(T!==0)return T;if(N.command&&C.command)T=m(N.command,C.command);else{if(N.command)return 1;if(C.command)return-1}if(T!==0)return T;if(N.decorations&&C.decorations)T=p(N.decorations,C.decorations);else{if(N.decorations)return 1;if(C.decorations)return-1}return T}function k(N,C){for(let T=0;T<N.length;T++)if(N[T]!==C[T])return!1;return!0}function h(N,C){return N.command===C.command&&N.title===C.title&&N.tooltip===C.tooltip&&(N.arguments&&C.arguments?k(N.arguments,C.arguments):N.arguments===C.arguments)}function w(N,C){return(0,E.$tb)(N,C,h)}function I(N,C){return N===C?!0:!N||!C?!1:N.id===C.id&&N.label===C.label&&N.upstream?.id===C.upstream?.id&&N.upstream?.label===C.upstream?.label}class L{#e;#t;get value(){return this.d}set value(C){C=C??"",this.#e.$setInputBoxValue(this.o,C),this.q(C)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(C){this.#e.$setInputBoxPlaceholder(this.o,C),this.f=C}get validateInput(){return(0,g.$NF)(this.m,"scmValidation"),this.g}set validateInput(C){if((0,g.$NF)(this.m,"scmValidation"),C&&typeof C!="function")throw new Error(`[${this.m.identifier.value}]: Invalid SCM input box validation function`);this.g=C,this.#e.$setValidationProviderIsEnabled(this.o,!!C)}get enabled(){return this.h}set enabled(C){C=!!C,this.h!==C&&(this.h=C,this.#e.$setInputBoxEnablement(this.o,C))}get visible(){return this.j}set visible(C){C=!!C,this.j!==C&&(this.j=C,this.#e.$setInputBoxVisibility(this.o,C))}get actionButton(){return(0,g.$NF)(this.m,"scmInputBoxActionButton"),this.k}set actionButton(C){(0,g.$NF)(this.m,"scmInputBoxActionButton"),this.l.value=new M.$Qc,this.k=C;const T=C!==void 0?{command:this.n.converter.toInternal(C.command,this.l.value),icon:n(C),enabled:C.enabled}:void 0;this.#e.$setInputBoxActionButton(this.o,T??null)}get document(){return(0,g.$NF)(this.m,"scmTextDocument"),this.#t.getDocument(this.p)}constructor(C,T,G,de,me,De){this.m=C,this.n=T,this.o=me,this.p=De,this.d="",this.e=new F.$Rd,this.f="",this.h=!0,this.j=!0,this.l=new M.$Sc,this.#t=G,this.#e=de}showValidationMessage(C,T){(0,g.$NF)(this.m,"scmValidation"),this.#e.$showValidationMessage(this.o,C,T)}$onInputBoxValueChange(C){this.q(C)}q(C){this.d=C,this.e.fire(C)}}e.$sfc=L;class V{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(C){this.v=C,this.q.$updateGroupLabel(this.t,this.handle,C)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(C){this.p=C,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(C){this.f=[...C],this.k.fire()}constructor(C,T,G,de,me){this.q=C,this.s=T,this.t=G,this.u=de,this.v=me,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new F.$Rd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new F.$Rd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=V.d++}getResourceState(C){return this.g.get(C)}$executeResourceCommand(C,T){const G=this.h.get(C);return G?(0,R.$Qg)(()=>this.s.executeCommand(G.command,...G.arguments||[],T)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const C=[...this.f].sort(S),G=(0,E.$Cb)(this.o,C,S).map(De=>{const ke=De.toInsert.map(le=>{const pe=this.e++;this.g.set(pe,le);const re=le.resourceUri;let Pe;if(le.command)if(le.command.command==="vscode.open"||le.command.command==="vscode.diff"||le.command.command==="vscode.changes"){const _=new M.$Qc;Pe=this.s.converter.toInternal(le.command,_),this.j.set(pe,_)}else this.h.set(pe,le.command);const se=l(le.decorations),Z=le.decorations&&l(le.decorations.light)||se,j=le.decorations&&l(le.decorations.dark)||se,ie=[Z,j],ve=le.decorations&&le.decorations.tooltip||"",ne=le.decorations&&!!le.decorations.strikeThrough,he=le.decorations&&!!le.decorations.faded,ce=le.contextValue||"";return{rawResource:[pe,re,ie,ve,ne,he,ce,Pe],handle:pe}});return{start:De.start,deleteCount:De.deleteCount,toInsert:ke}}),de=G.map(({start:De,deleteCount:ke,toInsert:le})=>[De,ke,le.map(pe=>pe.rawResource)]),me=G.reverse();for(const{start:De,deleteCount:ke,toInsert:le}of me){const pe=le.map(Pe=>Pe.handle),re=this.n.splice(De,ke,...pe);for(const Pe of re)this.g.delete(Pe),this.h.delete(Pe),this.j.get(Pe)?.dispose(),this.j.delete(Pe)}return this.o=C,de}dispose(){this.l=!0,this.m.fire()}}class Y{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(C){this.g!==C&&(this.g=C,this.#e.$updateSourceControl(this.x,{count:C}))}get quickDiffProvider(){return this.h}set quickDiffProvider(C){this.h=C;let T;(0,g.$MF)(this.y,"quickDiffProvider")&&(T=C?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!C,quickDiffLabel:T})}get historyProvider(){return(0,g.$NF)(this.y,"scmHistoryProvider"),this.j}set historyProvider(C){(0,g.$NF)(this.y,"scmHistoryProvider"),this.j=C,this.k.value=new M.$Qc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!C}),C&&(this.k.value.add(C.onDidChangeCurrentHistoryItemGroup(()=>{I(this.l,C?.currentHistoryItemGroup)||(this.l=C?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l))})),this.k.value.add(C.onDidChangeActionButton(()=>{(0,g.$NF)(this.y,"scmActionButton"),this.m.value=new M.$Qc;const T=C.actionButton!==void 0?{command:this.z.converter.toInternal(C.actionButton.command,this.m.value),description:C.actionButton.description,enabled:C.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,T??null)})))}get commitTemplate(){return this.n}set commitTemplate(C){C!==this.n&&(this.n=C,this.#e.$updateSourceControl(this.x,{commitTemplate:C}))}get acceptInputCommand(){return this.p}set acceptInputCommand(C){this.o.value=new M.$Qc,this.p=C;const T=this.z.converter.toInternal(C,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:T})}get actionButton(){return(0,g.$NF)(this.y,"scmActionButton"),this.s}set actionButton(C){(0,g.$NF)(this.y,"scmActionButton"),this.q.value=new M.$Qc,this.s=C;const T=C!==void 0?{command:this.z.converter.toInternal(C.command,this.q.value),secondaryCommands:C.secondaryCommands?.map(G=>G.map(de=>this.z.converter.toInternal(de,this.q.value))),description:C.description,enabled:C.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:T??null})}get statusBarCommands(){return this.u}set statusBarCommands(C){if(this.u&&C&&w(this.u,C))return;this.t.value=new M.$Qc,this.u=C;const T=(C||[]).map(G=>this.z.converter.toInternal(G,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:T})}get selected(){return this.v}constructor(C,T,G,de,me,De,ke){this.y=C,this.z=de,this.A=me,this.B=De,this.C=ke,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new M.$Sc,this.m=new M.$Sc,this.n=void 0,this.o=new M.$Sc,this.p=void 0,this.q=new M.$Sc,this.t=new M.$Sc,this.u=void 0,this.v=!1,this.w=new F.$Rd,this.onDidChangeSelection=this.w.event,this.x=Y.d++,this.D=new Map,this.E=new Set,this.#e=G;const le=y.URI.from({scheme:t.Schemas.vscodeSourceControl,path:`${me}/scm${this.x}/input`,query:ke?`rootUri=${encodeURIComponent(ke.toString())}`:void 0});this.f=new L(C,de,T,this.#e,this.x,le),this.#e.$registerSourceControl(this.x,me,De,ke,le)}createResourceGroup(C,T){const G=new V(this.#e,this.z,this.x,C,T),de=F.Event.once(G.onDidDispose)(()=>this.D.delete(G));return this.D.set(G,de),this.eventuallyAddResourceGroups(),G}eventuallyAddResourceGroups(){const C=[],T=[];for(const[G,de]of this.D){de.dispose();const me=G.onDidUpdateResourceStates(()=>{this.E.add(G),this.eventuallyUpdateResourceStates()});F.Event.once(G.onDidDispose)(()=>{this.E.delete(G),me.dispose(),this.e.delete(G.handle),this.#e.$unregisterGroup(this.x,G.handle)}),C.push([G.handle,G.id,G.label,G.features]);const De=G._takeResourceStateSnapshot();De.length>0&&T.push([G.handle,De]),this.e.set(G.handle,G)}this.#e.$registerGroups(this.x,C,T),this.D.clear()}eventuallyUpdateResourceStates(){const C=[];this.E.forEach(T=>{const G=T._takeResourceStateSnapshot();G.length!==0&&C.push([T.handle,G])}),C.length>0&&this.#e.$spliceResourceStates(this.x,C),this.E.clear()}getResourceGroup(C){return this.e.get(C)}setSelectionState(C){this.v=C,this.w.fire(C)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(C=>C.dispose()),this.#e.$unregisterSourceControl(this.x)}}Ke([(0,A.$oh)(100)],Y.prototype,"eventuallyAddResourceGroups",null),Ke([(0,A.$oh)(100)],Y.prototype,"eventuallyUpdateResourceStates",null);let U=class{static{r=this}static{this.d=0}static{this.e=0}get onDidChangeActiveProvider(){return this.k.event}constructor(C,T,G,de){this.n=T,this.o=G,this.p=de,this.h=new Map,this.j=new u.$bm,this.k=new F.$Rd,this.l=new Map,this.f=C.getProxy($.$zK.MainThreadSCM),this.g=C.getProxy($.$zK.MainThreadTelemetry),T.registerArgumentProcessor({processArgument:me=>{if(me&&me.$mid===3){const De=this.h.get(me.sourceControlHandle);if(!De)return me;const ke=De.getResourceGroup(me.groupHandle);return ke?ke.getResourceState(me.handle):me}else if(me&&me.$mid===4){const De=this.h.get(me.sourceControlHandle);return De?De.getResourceGroup(me.groupHandle):me}else if(me&&me.$mid===5){const De=this.h.get(me.handle);return De||me}return me}})}createSourceControl(C,T,G,de){this.p.trace("ExtHostSCM#createSourceControl",C.identifier.value,T,G,de),this.g.$publicLog2("api/scm/createSourceControl",{extensionId:C.identifier.value});const me=r.d++,De=new Y(C,this.o,this.f,this.n,T,G,de);this.h.set(me,De);const ke=this.j.get(C.identifier)||[];return ke.push(De),this.j.set(C.identifier,ke),De}registerSourceControlInputBoxValueProvider(C,T){this.p.trace("ExtHostSCM#registerSourceControlInputBoxValueProvider",C.identifier.value,T.label);const G=r.e++;return this.l.set(G,T),this.f.$registerSourceControlInputBoxValueProvider(G,T.label,a(T)),(0,M.$Pc)(()=>{this.f.$unregisterSourceControlInputBoxValueProvider(G),this.l.delete(G)})}async $provideInputBoxValue(C,T,G){const de=this.l.get(C);if(de)return await de.provideValue(T,G,D.CancellationToken.None)??void 0}getLastInputBox(C){this.p.trace("ExtHostSCM#getLastInputBox",C.identifier.value);const T=this.j.get(C.identifier),G=T&&T[T.length-1];return G&&G.inputBox}$provideOriginalResource(C,T,G){const de=y.URI.revive(T);this.p.trace("ExtHostSCM#$provideOriginalResource",C,de.toString());const me=this.h.get(C);return!me||!me.quickDiffProvider||!me.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$Qg)(()=>me.quickDiffProvider.provideOriginalResource(de,G)).then(De=>De||null)}$onInputBoxValueChange(C,T){this.p.trace("ExtHostSCM#$onInputBoxValueChange",C);const G=this.h.get(C);return G&&G.inputBox.$onInputBoxValueChange(T),Promise.resolve(void 0)}$executeResourceCommand(C,T,G,de){this.p.trace("ExtHostSCM#$executeResourceCommand",C,T,G);const me=this.h.get(C);if(!me)return Promise.resolve(void 0);const De=me.getResourceGroup(T);return De?De.$executeResourceCommand(G,de):Promise.resolve(void 0)}$validateInput(C,T,G){this.p.trace("ExtHostSCM#$validateInput",C);const de=this.h.get(C);return!de||!de.inputBox.validateInput?Promise.resolve(void 0):(0,R.$Qg)(()=>de.inputBox.validateInput(T,G)).then(me=>{if(!me)return Promise.resolve(void 0);const De=v.MarkdownString.fromStrict(me.message);return De?Promise.resolve([De,me.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(C){return this.p.trace("ExtHostSCM#$setSelectedSourceControl",C),C!==void 0&&this.h.get(C)?.setSelectionState(!0),this.m!==void 0&&this.h.get(this.m)?.setSelectionState(!1),this.m=C,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(C,T,G){return await this.h.get(C)?.historyProvider?.resolveHistoryItemGroupBase(T,G)??void 0}async $resolveHistoryItemGroupCommonAncestor(C,T,G,de){return await this.h.get(C)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(T,G,de)??void 0}async $provideHistoryItems(C,T,G,de){return(await this.h.get(C)?.historyProvider?.provideHistoryItems(T,G,de))?.map(ke=>({...ke,icon:s(ke)}))??void 0}async $provideHistoryItemChanges(C,T,G){return await this.h.get(C)?.historyProvider?.provideHistoryItemChanges(T,G)??void 0}};e.$tfc=U,e.$tfc=U=r=Ke([Ve(3,P.$dj)],U)}),define(Ae[84],Re([1,0,3,5,4]),function(we,e,y,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aec=e.$zec=void 0;class M{constructor($){this.b=new F.$Rd,this.onDidChangePassword=this.b.event,this.a=$.getProxy(y.$zK.MainThreadSecretState)}async $onDidChangePassword($){this.b.fire($)}get($,E){return this.a.$getPassword($,E)}store($,E,f){return this.a.$setPassword($,E,f)}delete($,E){return this.a.$deletePassword($,E)}}e.$zec=M,e.$Aec=(0,A.$Vh)("IExtHostSecretState")}),define(Ae[264],Re([1,0,3,8,2]),function(we,e,y,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ufc=void 0;class M{static{this.a=0}constructor($,E){this.d=E,this.c=new Map,this.b=$.getProxy(y.$zK.MainThreadShare)}async $provideShare($,E,f){return await this.c.get($)?.provideShare({selection:F.Range.to(E.selection),resourceUri:A.URI.revive(E.resourceUri)},f)??void 0}registerShareProvider($,E){const f=M.a++;return this.c.set(f,E),this.b.$registerShareProvider(f,F.DocumentSelector.from($,this.d),E.id,E.label,E.priority),{dispose:()=>{this.b.$unregisterShareProvider(f),this.c.delete(f)}}}}e.$ufc=M}),define(Ae[265],Re([1,0,19,6,3]),function(we,e,y,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vfc=void 0;class M{static{this.a=1}constructor($){this.c=new Map,this.d=new Map,this.b=$.getProxy(A.$zK.MainThreadSpeech)}async $createSpeechToTextSession($,E){const f=this.c.get($);if(!f)return;const P=new F.$Qc,D=new y.$2d;this.d.set(E,D);const u=P.add(f.provideSpeechToTextSession(D.token));P.add(u.onDidChange(b=>{D.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(E,b)})),P.add(D.token.onCancellationRequested(()=>P.dispose()))}async $cancelSpeechToTextSession($){this.d.get($)?.dispose(!0),this.d.delete($)}registerProvider($,E,f){const P=M.a++;return this.c.set(P,f),this.b.$registerProvider(P,E,{extension:$,displayName:$.value}),(0,F.$Pc)(()=>{this.b.$unregisterProvider(P),this.c.delete(P)})}}e.$vfc=M}),define(Ae[266],Re([1,0,7,3,164,6,8,16]),function(we,e,y,F,A,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xfc=e.$wfc=void 0;class E{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new y.$wL("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new y.$wL("statusBarItem.warningForeground")]])}#e;#t;constructor(u,b,v,g,t,i=y.StatusBarAlignment.Left,r){if(this.i=!1,this.k="",this.q=new M.$Qc,this.#e=u,this.#t=b,t&&g){this.c=(0,y.$_K)(g.identifier,t);const c=v.get(this.c);c&&(i=c.alignLeft?y.StatusBarAlignment.Left:y.StatusBarAlignment.Right,r=c.priority,this.j=!0,this.name=c.name,this.text=c.text,this.tooltip=c.tooltip,this.command=c.command,this.accessibilityInformation=c.accessibilityInformation)}else this.c=String(E.a++);this.e=g,this.f=t,this.g=i,this.h=this.u(r)}u(u){if((0,$.$Gf)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!E.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new M.$Qc,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let b;this.m?b=this.m:b=(0,A.localize)(0,null,this.e.displayName||this.e.name);let v=this.n;this.o&&(v=E.b.get(this.o.id));const g=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,b,this.k,g,this.r?.internal,v,this.o,this.g===y.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$wfc=E;class f{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",y.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,A.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const b={message:u};return this.b.unshift(b),this.c(),new y.$BK(()=>{const v=this.b.indexOf(b);v>=0&&(this.b.splice(v,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class P{constructor(u,b){this.e=new Map,this.a=u.getProxy(F.$zK.MainThreadStatusBar),this.b=b,this.c=new f(this)}$acceptStaticEntries(u){for(const b of u)this.e.set(b.entryId,b)}createStatusBarEntry(u,b,v,g){return new E(this.a,this.b,this.e,u,b,v,g)}setStatusBarMessage(u,b){const v=this.c.setMessage(u);let g;return typeof b=="number"?g=setTimeout(()=>v.dispose(),b):typeof b<"u"&&b.then(()=>v.dispose(),()=>v.dispose()),new y.$BK(()=>{v.dispose(),clearTimeout(g)})}}e.$xfc=P}),define(Ae[85],Re([1,0,3,5,4]),function(we,e,y,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sec=e.$rec=void 0;class M{constructor($,E){this.c=E,this.b=new F.$Rd,this.onDidChangeStorage=this.b.event,this.a=$.getProxy(y.$zK.MainThreadStorage)}registerExtensionStorageKeysToSync($,E){this.a.$registerExtensionStorageKeysToSync($,E)}async initializeExtensionStorage($,E,f){const P=await this.a.$initializeExtensionStorage($,E);let D;return P&&(D=this.d($,E,P)),D||f}setValue($,E,f){return this.a.$setValue($,E,f)}$acceptValue($,E,f){const P=this.d($,E,f);P&&this.b.fire({shared:$,key:E,value:P})}d($,E,f){try{return JSON.parse(f)}catch(P){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${E}, global: ${$}): ${P}`)}}}e.$rec=M,e.$sec=(0,A.$Vh)("IExtHostStorage")}),define(Ae[86],Re([1,0,4,27,15,63,2]),function(we,e,y,F,A,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bec=e.$aec=void 0,e.$aec=(0,y.$Vh)("IExtensionStoragePaths");let $=class{constructor(f,P,D){this.d=P,this.f=D,this.a=f.workspace??void 0,this.b=f.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(f){return R.URI.joinPath(this.b.workspaceStorageHome,f)}async h(){if(!this.a)return Promise.resolve(void 0);const f=this.a.id,P=await this.g(f);try{return await this.f.value.stat(P),this.d.trace("[ExtHostStorage] storage dir already exists",P),P}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",P),await this.f.value.createDirectory(P),await this.f.value.writeFile(R.URI.joinPath(P,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),P}catch(D){this.d.error("[ExtHostStorage]",D);return}}workspaceValue(f){if(this.c)return R.URI.joinPath(this.c,f.identifier.value)}globalValue(f){return R.URI.joinPath(this.b.globalStorageHome,f.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$bec=$,e.$bec=$=Ke([Ve(0,F.$RM),Ve(1,A.$dj),Ve(2,M.$_dc)],$)}),define(Ae[64],Re([1,0,5,3,4,2,17,6,7,166,11,194,19,38,195,45,14,8,32]),function(we,e,y,F,A,M,R,$,E,f,P,D,u,b,v,g,t,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yec=e.$xec=e.$wec=e.$vec=void 0,e.$vec=(0,A.$Vh)("IExtHostTerminalService");class c{constructor(h,w,I,L){this.l=h,this._id=w,this.m=I,this.n=L,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(Y=>this.f=Y);const V=this;this.value={get name(){return V.n||""},get processId(){return V.b},get creationOptions(){return V.m},get exitStatus(){return V.h},get state(){return V.j},get selection(){return V.k},sendText(Y,U=!0){V.q(),V.l.$sendText(V._id,Y,U)},show(Y){V.q(),V.l.$show(V._id,Y)},hide(){V.q(),V.l.$hide(V._id)},dispose(){V.a||(V.a=!0,V.l.$dispose(V._id))},get dimensions(){if(!(V.d===void 0||V.g===void 0))return{columns:V.d,rows:V.g}}}}async create(h,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:h.name,shellPath:h.shellPath??void 0,shellArgs:h.shellArgs??void 0,cwd:h.cwd??w?.cwd??void 0,env:h.env??void 0,icon:p(h.iconPath)??void 0,color:g.ThemeColor.isThemeColor(h.color)?h.color.id:void 0,initialText:h.message??void 0,strictEnv:h.strictEnv??void 0,hideFromUser:h.hideFromUser??void 0,isFeatureTerminal:w?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:w?.useShellEnvironment??void 0,location:w?.location||this.o(h.location,w?.resolvedExtHostIdentifier),isTransient:h.isTransient??void 0})}async createExtensionTerminal(h,w,I,L){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:I,color:g.ThemeColor.isThemeColor(L)?L.id:void 0,location:this.o(h,w),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(h,w){return typeof h=="object"?"parentTerminal"in h&&h.parentTerminal&&w?{parentTerminal:w}:"viewColumn"in h?{viewColumn:i.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus}:void 0:h}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(h){this.n=h}setExitStatus(h,w){this.h=Object.freeze({code:h,reason:w})}setDimensions(h,w){return h===this.d&&w===this.g||h===0||w===0?!1:(this.d=h,this.g=w,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(h){this.k=h}_setProcessId(h){this.f?(this.f(h),this.f=void 0):this.b.then(w=>{w!==h&&(this.b=Promise.resolve(h))})}}e.$wec=c;class o{get onProcessReady(){return this.b.event}constructor(h){this.g=h,this.id=0,this.shouldPersist=!1,this.a=new y.$Rd,this.onProcessData=this.a.event,this.b=new y.$Rd,this.d=new y.$Rd,this.onDidChangeProperty=this.d.event,this.f=new y.$Rd,this.onProcessExit=this.f.event}refreshProperty(h){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${h}`)}updateProperty(h,w){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${h}, value: ${w}`)}async start(){}shutdown(){this.g.close()}input(h){this.g.handleInput?.(h)}resize(h,w){this.g.setDimensions?.({columns:h,rows:w})}clearBuffer(){}async processBinary(h){}acknowledgeDataEvent(h){}async setUnicodeVersion(h){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(h){this.g.onDidWrite(w=>this.a.fire(w)),this.g.onDidClose?.((w=void 0)=>{this.f.fire(w===void 0?void 0:w)}),this.g.onDidOverrideDimensions?.(w=>{w&&this.d.fire({type:"overrideDimensions",value:{cols:w.columns,rows:w.rows}})}),this.g.onDidChangeName?.(w=>{this.d.fire({type:"title",value:w})}),this.g.open(h||void 0),h&&this.g.setDimensions?.(h),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let l=1,n=class extends $.$Rc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(h=>h.value)}constructor(h,w,I){super(),this.Q=w,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new $.$Sc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new y.$Rd,this.onDidCloseTerminal=this.H.event,this.I=new y.$Rd,this.onDidOpenTerminal=this.I.event,this.J=new y.$Rd,this.onDidChangeActiveTerminal=this.J.event,this.L=new y.$Rd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new y.$Rd,this.onDidChangeTerminalState=this.M.event,this.N=new y.$Rd,this.onDidChangeShell=this.N.event,this.O=new y.$Rd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new y.$Rd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=I.getProxy(F.$zK.MainThreadTerminalService),this.y=new v.$lqb(this.a.$sendProcessData),this.a.$registerProcessSupport(h),this.Q.registerArgumentProcessor({processArgument:L=>{const V=Y=>{const U=Y;return this.W(U.instanceId)?.value};switch(L?.$mid){case 15:return V(L);default:{if(Array.isArray(L))for(let Y=0;Y<L.length&&L[Y].$mid===15;Y++)L[Y]=V(L[Y]);return L}}}}),this.B({dispose:()=>{for(const[L,V]of this.g)V.shutdown(!0)}})}getDefaultShell(h){return(h?this.u:this.s)?.path||""}getDefaultShellArgs(h){return(h?this.u:this.s)?.args||[]}createExtensionTerminal(h,w){const I=new c(this.a,(0,b.$ig)(),h,h.name),L=new o(h.pty);return I.createExtensionTerminal(h.location,this.R(h,w).resolvedExtHostIdentifier,p(h.iconPath),m(h.color)).then(V=>{const Y=this.S(V,L);this.h[V]=Y}),this.f.push(I),I.value}R(h,w){if(w=w||{},h.location&&typeof h.location=="object"&&"parentTerminal"in h.location){const I=h.location.parentTerminal;if(I){const L=this.f.find(V=>V.value===I);L&&(w.resolvedExtHostIdentifier=L._id)}}else h.location&&typeof h.location!="object"?w.location=h.location:w.location&&typeof w.location=="object"&&"splitActiveTerminal"in w.location&&(w.location={splitActiveTerminal:!0});return w}attachPtyToTerminal(h,w){if(!this.W(h))throw new Error(`Cannot resolve terminal with id ${h} for virtual process`);const L=new o(w),V=this.S(h,L);this.h[h]=V}async $acceptActiveTerminalChanged(h){const w=this.b;if(h===null){this.b=void 0,w!==this.b&&this.J.fire(this.b);return}const I=this.W(h);I&&(this.b=I,w!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(h,w){const I=this.W(h);I&&this.O.fire({terminal:I.value,data:w})}async $acceptTerminalDimensions(h,w,I){const L=this.W(h);L&&L.setDimensions(w,I)&&this.L.fire({terminal:L.value,dimensions:L.value.dimensions})}async $acceptDidExecuteCommand(h,w){const I=this.W(h);I&&this.P.fire({terminal:I.value,...w})}async $acceptTerminalMaximumDimensions(h,w,I){this.g.get(h)?.resize(w,I)}async $acceptTerminalTitleChange(h,w){const I=this.W(h);I&&(I.name=w)}async $acceptTerminalClosed(h,w,I){const L=this.Y(this.f,h);if(L!==null){const V=this.f.splice(L,1)[0];V.setExitStatus(w,I),this.H.fire(V.value)}}$acceptTerminalOpened(h,w,I,L){if(w){const U=this.Y(this.f,w);if(U!==null){this.f[U]._id=h,this.I.fire(this.terminals[U]),this.f[U].isOpen=!0;return}}const V={name:L.name,shellPath:L.executable,shellArgs:L.args,cwd:typeof L.cwd=="string"?L.cwd:M.URI.revive(L.cwd),env:L.env,hideFromUser:L.hideFromUser},Y=new c(this.a,h,V,I);this.f.push(Y),this.I.fire(Y.value),Y.isOpen=!0}async $acceptTerminalProcessId(h,w){this.W(h)?._setProcessId(w)}async $startExtensionTerminal(h,w){const I=this.W(h);if(!I)return{message:(0,f.localize)(0,null,h)};I.isOpen||await new Promise(V=>{const Y=this.onDidOpenTerminal(async U=>{U===I.value&&(Y.dispose(),V())})});const L=this.g.get(h);L?L.startSendingEvents(w):this.j[h]={initialDimensions:w}}S(h,w){const I=new $.$Qc;I.add(w.onProcessReady(V=>this.a.$sendProcessReady(h,V.pid,V.cwd,V.windowsPty))),I.add(w.onDidChangeProperty(V=>this.a.$sendProcessProperty(h,V))),this.y.startBuffering(h,w.onProcessData),I.add(w.onProcessExit(V=>this.U(h,V))),this.g.set(h,w);const L=this.j[h];return L&&w instanceof o&&(w.startSendingEvents(L.initialDimensions),delete this.j[h]),I}$acceptProcessAckDataEvent(h,w){this.g.get(h)?.acknowledgeDataEvent(w)}$acceptProcessInput(h,w){this.g.get(h)?.input(w)}$acceptTerminalInteraction(h){const w=this.W(h);w?.setInteractedWith()&&this.M.fire(w.value)}$acceptTerminalSelection(h,w){this.W(h)?.setSelection(w)}$acceptProcessResize(h,w,I){try{this.g.get(h)?.resize(w,I)}catch(L){if(L.code!=="EPIPE"&&L.code!=="ERR_IPC_CHANNEL_CLOSED")throw L}}$acceptProcessShutdown(h,w){this.g.get(h)?.shutdown(w)}$acceptProcessRequestInitialCwd(h){this.g.get(h)?.getInitialCwd().then(w=>this.a.$sendProcessProperty(h,{type:"initialCwd",value:w}))}$acceptProcessRequestCwd(h){this.g.get(h)?.getCwd().then(w=>this.a.$sendProcessProperty(h,{type:"cwd",value:w}))}$acceptProcessRequestLatency(h){return Promise.resolve(h)}registerLinkProvider(h){return this.z.add(h),this.z.size===1&&this.a.$startLinkProvider(),new E.$BK(()=>{this.z.delete(h),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(h,w,I){if(this.C.has(w))throw new Error(`Terminal profile provider "${w}" already registered`);return this.C.set(w,I),this.a.$registerProfileProvider(w,h.identifier.value),new E.$BK(()=>{this.C.delete(w),this.a.$unregisterProfileProvider(w)})}registerTerminalQuickFixProvider(h,w,I){if(this.D.has(h))throw new Error(`Terminal quick fix provider "${h}" is already registered`);return this.D.set(h,I),this.a.$registerQuickFixProvider(h,w),new E.$BK(()=>{this.D.delete(h),this.a.$unregisterQuickFixProvider(h)})}async $provideTerminalQuickFixes(h,w){const I=new u.$2d().token;if(I.isCancellationRequested)return;const L=this.D.get(h);if(!L)return;const V=await L.provideTerminalQuickFixes(w,I);if(V===null||Array.isArray(V)&&V.length===0)return;const Y=new $.$Qc;if(this.w.value=Y,!Array.isArray(V))return V?i.TerminalQuickFix.from(V,this.Q.converter,Y):void 0;const U=[];for(const N of V){const C=i.TerminalQuickFix.from(N,this.Q.converter,Y);C&&U.push(C)}return U}async $createContributedProfileTerminal(h,w){const I=new u.$2d().token;let L=await this.C.get(h)?.provideTerminalProfile(I);if(!I.isCancellationRequested){if(L&&!("options"in L)&&(L={options:L}),!L||!("options"in L))throw new Error(`No terminal profile options provided for id "${h}"`);if("pty"in L.options){this.createExtensionTerminal(L.options,w);return}this.createTerminalFromOptions(L.options,w)}}async $provideLinks(h,w){const I=this.W(h);if(!I)return[];this.F.delete(h),this.G.get(h)?.dispose(!0);const V=new u.$2d;this.G.set(h,V);const Y=[],U={terminal:I.value,line:w},N=[];for(const G of this.z)N.push(t.Promises.withAsyncBody(async de=>{V.token.onCancellationRequested(()=>de({provider:G,links:[]}));const me=await G.provideTerminalLinks(U,V.token)||[];V.token.isCancellationRequested||de({provider:G,links:me})}));const C=await Promise.all(N);if(V.token.isCancellationRequested)return[];const T=new Map;for(const G of C)G&&G.links.length>0&&Y.push(...G.links.map(de=>{const me={id:l++,startIndex:de.startIndex,length:de.length,label:de.tooltip};return T.set(me.id,{provider:G.provider,link:de}),me}));return this.F.set(h,T),Y}$activateLink(h,w){const I=this.F.get(h)?.get(w);I&&I.provider.handleTerminalLink(I.link)}U(h,w){this.y.stopBuffering(h),this.g.delete(h),delete this.j[h];const I=this.h[h];I&&(I.dispose(),delete this.h[h]),this.a.$sendProcessExit(h,w)}W(h){return this.X(this.f,h)}X(h,w){const I=this.Y(h,w);return I!==null?h[I]:null}Y(h,w){const I=h.findIndex(L=>L._id===w);return I===-1?null:I}getEnvironmentVariableCollection(h){let w=this.n.get(h.identifier.value);return w||(w=new s,this.$(h.identifier.value,w)),w.getScopedEnvironmentVariableCollection(void 0)}Z(h,w){const I=(0,D.$qr)(w.map),L=(0,D.$rr)(w.descriptionMap);this.a.$setEnvironmentVariableCollection(h,w.persistent,I.length===0?void 0:I,L)}$initEnvironmentVariableCollections(h){h.forEach(w=>{const I=w[0],L=new s(w[1]);this.$(I,L)})}$acceptDefaultProfile(h,w){const I=this.s;this.s=h,this.u=w,I?.path!==h.path&&this.N.fire(h.path)}$(h,w){this.n.set(h,w),w.onDidChangeCollection(()=>{this.Z(h,w)})}};e.$xec=n,e.$xec=n=Ke([Ve(1,r.$XM),Ve(2,R.$BM)],n);class s{get persistent(){return this.b}set persistent(h){this.b=h,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(h){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new y.$Rd,this.map=new Map(h)}getScopedEnvironmentVariableCollection(h){const w=this.h(h);let I=this.a.get(w);return I||(I=new a(this,h),this.a.set(w,I),I.onDidChangeCollection(()=>this.d.fire())),I}replace(h,w,I,L){this.f(h,{value:w,type:E.EnvironmentVariableMutatorType.Replace,options:I??{applyAtProcessCreation:!0},scope:L})}append(h,w,I,L){this.f(h,{value:w,type:E.EnvironmentVariableMutatorType.Append,options:I??{applyAtProcessCreation:!0},scope:L})}prepend(h,w,I,L){this.f(h,{value:w,type:E.EnvironmentVariableMutatorType.Prepend,options:I??{applyAtProcessCreation:!0},scope:L})}f(h,w){if(w.options&&w.options.applyAtProcessCreation===!1&&!w.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const I=this.g(h,w.scope),L=this.map.get(I),V=w.options?{applyAtProcessCreation:w.options.applyAtProcessCreation??!1,applyAtShellIntegration:w.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!L||L.value!==w.value||L.type!==w.type||L.options?.applyAtProcessCreation!==V.applyAtProcessCreation||L.options?.applyAtShellIntegration!==V.applyAtShellIntegration||L.scope?.workspaceFolder?.index!==w.scope?.workspaceFolder?.index){const Y=this.g(h,w.scope),U={variable:h,...w,options:V};this.map.set(Y,U),this.d.fire()}}get(h,w){const I=this.g(h,w),L=this.map.get(I);return L?S(L):void 0}g(h,w){const I=this.h(w);return I.length?`${h}:::${I}`:h}h(h){return this.j(h?.workspaceFolder)??""}j(h){return h?h.uri.toString():void 0}getVariableMap(h){const w=new Map;for(const[I,L]of this.map)this.h(L.scope)===this.h(h)&&w.set(L.variable,S(L));return w}delete(h,w){const I=this.g(h,w);this.map.delete(I),this.d.fire()}clear(h){if(h?.workspaceFolder){for(const[w,I]of this.map)I.scope?.workspaceFolder?.index===h.workspaceFolder.index&&this.map.delete(w);this.k(h)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(h,w){const I=this.h(w),L=this.descriptionMap.get(I);if(!L||L.description!==h){let V;typeof h=="string"?V=h:V=h?.value.split(`

`)[0];const Y={description:V,scope:w};this.descriptionMap.set(I,Y),this.d.fire()}}getDescription(h){const w=this.h(h);return this.descriptionMap.get(w)?.description}k(h){const w=this.h(h);this.descriptionMap.delete(w)}}class a{get persistent(){return this.b.persistent}set persistent(h){this.b.persistent=h}get onDidChangeCollection(){return this.a&&this.a.event}constructor(h,w){this.b=h,this.d=w,this.a=new y.$Rd}getScoped(h){return this.b.getScopedEnvironmentVariableCollection(h)}replace(h,w,I){this.b.replace(h,w,I,this.d)}append(h,w,I){this.b.append(h,w,I,this.d)}prepend(h,w,I){this.b.prepend(h,w,I,this.d)}get(h){return this.b.get(h,this.d)}forEach(h,w){this.b.getVariableMap(this.d).forEach((I,L)=>h.call(w,L,I,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(h){this.b.delete(h,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(h){this.b.setDescription(h,this.d)}get description(){return this.b.getDescription(this.d)}}let d=class extends n{constructor(h,w){super(!1,h,w)}createTerminal(h,w,I){throw new P.$$}createTerminalFromOptions(h,w){throw new P.$$}};e.$yec=d,e.$yec=d=Ke([Ve(0,r.$XM),Ve(1,R.$BM)],d);function p(k){if(!(!k||typeof k=="string"))return"id"in k?{id:k.id,color:k.color}:k}function m(k){return g.ThemeColor.isThemeColor(k)?k:void 0}function S(k){const h={...k};return delete h.scope,h.options=h.options??void 0,delete h.variable,h}}),define(Ae[267],Re([1,0,298,14,24,19,5,219,97,6,26,16,38,3,17,108,8,7,48,77,58,23]),function(we,e,y,F,A,M,R,$,E,f,P,D,u,b,v,g,t,i,r,c,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Efc=e.$Dfc=e.$Cfc=e.$Bfc=void 0;let n=class extends f.$Rc{constructor(U,N,C){super(),this.u=C,this.f=this.B(new R.$Rd),this.g=new Map,this.s=this.B(new R.$Rd),this.onResultsChanged=this.f.event,this.results=[],this.h=U.getProxy(b.$zK.MainThreadTesting),this.m=new I(this.h),this.j=new p(this.h),N.registerArgumentProcessor({processArgument:T=>{switch(T?.$mid){case 16:{const G=T,de=G.tests[G.tests.length-1].item.extId;return this.g.get(r.$sJ.root(de))?.collection.tree.get(de)?.actual??(0,g.$NM)(T)}case 18:{const{extId:G,message:de}=T;return{test:this.g.get(r.$sJ.root(G))?.collection.tree.get(G)?.actual,message:t.TestMessage.to(de)}}default:return T}}}),N.registerCommand(!1,"testing.getExplorerSelection",async()=>{const T=await N.executeCommand("_testing.getExplorerSelection"),G=de=>{const me=this.g.get(r.$sJ.root(de));if(me)return r.$sJ.isRoot(de)?me.controller:me.collection.tree.get(de)?.actual};return{include:T?.include.map(G).filter(D.$Kf)||[],exclude:T?.exclude.map(G).filter(D.$Kf)||[]}})}createTestController(U,N,C,T){if(this.g.has(N))throw new Error(`Attempt to insert a duplicate controller with ID "${N}"`);const G=new f.$Qc,de=G.add(new g.$QM(N,C,this.u));de.root.label=C;const me=new Map,De=new Set,ke=this.h,le={items:de.root.children,get label(){return C},set label(re){C=re,de.root.label=re,ke.$updateController(N,{label:C})},get refreshHandler(){return T},set refreshHandler(re){T=re,ke.$updateController(N,{canRefresh:!!re})},get id(){return N},createRunProfile:(re,Pe,se,Z,j,ie)=>{let ve=(0,E.$Ji)(re);for(;me.has(ve);)ve++;return new L(this.h,me,U,De,this.s.event,N,ve,re,Pe,se,Z,j,ie)},createTestItem(re,Pe,se){return new g.$OM(N,re,Pe,se)},createTestRun:(re,Pe,se=!0)=>this.j.createTestRun(U,N,de,re,Pe,se),invalidateTestResults:re=>{if(re===void 0)this.h.$markTestRetired(void 0);else{const Pe=re instanceof Array?re:[re];this.h.$markTestRetired(Pe.map(se=>r.$sJ.fromExtHostTestItem(se,N).toString()))}},set resolveHandler(re){de.resolveHandler=re},get resolveHandler(){return de.resolveHandler},dispose:()=>{G.dispose()}};ke.$registerTestController(N,C,!!T),G.add((0,f.$Pc)(()=>ke.$unregisterTestController(N)));const pe={controller:le,collection:de,profiles:me,extension:U,activeProfiles:De};return this.g.set(N,pe),G.add((0,f.$Pc)(()=>this.g.delete(N))),G.add(de.onDidGenerateDiff(re=>ke.$publishDiff(N,re.map(o.TestsDiffOp.serialize)))),le}createTestObserver(){return this.m.checkout()}async runTests(U,N=M.CancellationToken.None){const C=m(U);if(!C)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const T=this.g.get(C.controllerId);if(!T)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(G=>r.$sJ.fromExtHostTestItem(G,T.collection.root.id).toString())??[T.collection.root.id],profileGroup:V[C.kind],profileId:C.profileId,controllerId:C.controllerId}],exclude:U.exclude?.map(G=>G.id)},N)}$syncTests(){for(const{collection:U}of this.g.values())U.flushDiff();return Promise.resolve()}$provideFileCoverage(U,N,C){return(0,y.$qb)(this.j.trackers,G=>G.id===U?G.getCoverage(N):void 0)?.provideFileCoverage(C)??Promise.resolve([])}$resolveFileCoverage(U,N,C,T){return(0,y.$qb)(this.j.trackers,de=>de.id===U?de.getCoverage(N):void 0)?.resolveFileCoverage(C,T)??Promise.resolve([])}$configureRunProfile(U,N){this.g.get(U)?.profiles.get(N)?.configureHandler?.()}$setActiveRunProfiles(U){const N=new Map;for(const[C,T]of Object.entries(U)){const G=this.g.get(C);if(!G)continue;const de=new Map,me=T.filter(ke=>!G.activeProfiles.has(ke)),De=[...G.activeProfiles].filter(ke=>!T.includes(ke));for(const ke of me)de.set(ke,!0),G.activeProfiles.add(ke);for(const ke of De)de.set(ke,!1),G.activeProfiles.delete(ke);de.size&&N.set(C,de)}this.s.fire(N)}async $refreshTests(U,N){await this.g.get(U)?.controller.refreshHandler?.(N)}$publishTestResults(U){this.results=Object.freeze(U.map(N=>(0,P.$bn)(t.TestResults.to(N))).concat(this.results).sort((N,C)=>C.completedAt-N.completedAt).slice(0,32)),this.f.fire()}async $expandTest(U,N){const C=this.g.get(r.$sJ.fromString(U).controllerId)?.collection;C&&(await C.expand(U,N<0?1/0:N),C.flushDiff())}$acceptDiff(U){this.m.applyDiff(U.map(o.TestsDiffOp.deserialize))}async $runControllerTests(U,N){return Promise.all(U.map(C=>this.w(C,!1,N)))}async $startContinuousRun(U,N){const C=new M.$2d(N),T=await Promise.all(U.map(G=>this.w(G,!0,C.token)));return!N.isCancellationRequested&&!T.some(G=>G.error)&&await new Promise(G=>N.onCancellationRequested(G)),C.dispose(!0),T}async w(U,N,C){const T=this.g.get(U.controllerId);if(!T)return{};const{collection:G,profiles:de,extension:me}=T,De=de.get(U.profileId);if(!De)return{};const ke=U.testIds.map(Pe=>G.tree.get(Pe)).filter(D.$Kf),le=U.excludeExtIds.map(Pe=>T.collection.tree.get(Pe)).filter(D.$Kf).filter(Pe=>ke.some(se=>se.fullId.compare(Pe.fullId)===2));if(!ke.length)return{};const pe=new i.$0L(ke.some(Pe=>Pe.actual instanceof g.$PM)?void 0:ke.map(Pe=>Pe.actual),le.map(Pe=>Pe.actual),De,N),re=(0,o.$uJ)(U)&&this.j.prepareForMainThreadTestRun(pe,S.fromInternal(U,T.collection),me,C);try{return await De.runHandler(pe,C),{}}catch(Pe){return{error:String(Pe)}}finally{re&&(re.hasRunningTasks&&!C.isCancellationRequested&&await R.Event.toPromise(re.onEnd),re.dispose())}}$cancelExtensionTestRun(U){U===void 0?this.j.cancelAllRuns():this.j.cancelRunById(U)}};e.$Bfc=n,e.$Bfc=n=Ke([Ve(0,v.$BM)],n);const s=1e4;var a;(function(Y){Y[Y.Running=0]="Running",Y[Y.Cancelling=1]="Cancelling",Y[Y.Ended=2]="Ended"})(a||(a={}));class d extends f.$Rc{get hasRunningTasks(){return this.f.size>0}get id(){return this.m.id}constructor(U,N,C){super(),this.m=U,this.s=N,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new R.$Rd),this.onEnd=this.j.event,this.h=this.B(new M.$2d(C));const T=this.B(new F.$0g(()=>this.u(),s));this.B(this.h.token.onCancellationRequested(()=>T.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.u()}getCoverage(U){return this.f.get(U)?.coverage}createRun(U){const N=this.m.id,C=this.m.controllerId,T=(0,u.$ig)(),G=new k(this.s,N,T),de=le=>(pe,...re)=>{if(De){console.warn(`Setting the state of test "${pe.id}" is a no-op after the run ends.`);return}this.m.isIncluded(pe)&&(this.y(pe),le(pe,...re))},me=(le,pe)=>{const re=pe instanceof Array?pe.map(t.TestMessage.from):[t.TestMessage.from(pe)];if(le.uri&&le.range){const Pe={range:t.Range.from(le.range),uri:le.uri};for(const se of re)se.location=se.location||Pe}this.s.$appendTestMessagesInRun(N,T,r.$sJ.fromExtHostTestItem(le,C).toString(),re)};let De=!1;const ke={isPersisted:this.m.isPersisted,token:this.h.token,name:U,get coverageProvider(){return G.coverageProvider},set coverageProvider(le){G.coverageProvider=le},enqueued:de(le=>{this.s.$updateTestStateInRun(N,T,r.$sJ.fromExtHostTestItem(le,C).toString(),1)}),skipped:de(le=>{this.s.$updateTestStateInRun(N,T,r.$sJ.fromExtHostTestItem(le,C).toString(),5)}),started:de(le=>{this.s.$updateTestStateInRun(N,T,r.$sJ.fromExtHostTestItem(le,C).toString(),2)}),errored:de((le,pe,re)=>{me(le,pe),this.s.$updateTestStateInRun(N,T,r.$sJ.fromExtHostTestItem(le,C).toString(),6,re)}),failed:de((le,pe,re)=>{me(le,pe),this.s.$updateTestStateInRun(N,T,r.$sJ.fromExtHostTestItem(le,C).toString(),4,re)}),passed:de((le,pe)=>{this.s.$updateTestStateInRun(N,T,r.$sJ.fromExtHostTestItem(le,this.m.controllerId).toString(),3,pe)}),appendOutput:(le,pe,re)=>{De||(re&&(this.m.isIncluded(re)?this.y(re):re=void 0),this.s.$appendOutputToRun(N,T,A.$fe.fromString(le),pe&&t.location.from(pe),re&&r.$sJ.fromExtHostTestItem(re,C).toString()))},end:()=>{De||(De=!0,this.s.$finishedTestRunTask(N,T),this.f.delete(T),this.f.size||this.w())}};return this.f.set(T,{run:ke,coverage:G}),this.s.$startedTestRunTask(N,{id:T,name:U,running:!0}),ke}u(){for(const{run:U}of this.f.values())U.end()}w(){this.c!==2&&(this.c=2,this.j.fire())}y(U){if(!(U instanceof g.$OM))throw new c.$tM(U.id);if(this.g.has(r.$sJ.fromExtHostTestItem(U,this.m.controllerId).toString()))return;const N=[],C=this.m.colllection.root;for(;;){const T=t.TestItem.from(U);if(N.unshift(T),this.g.has(T.extId)||(this.g.add(T.extId),U===C))break;U=U.parent||C}this.s.$addTestsToRun(this.m.controllerId,this.m.id,N)}dispose(){this.w(),super.dispose()}}class p{get trackers(){return this.c.values()}constructor(U){this.d=U,this.c=new Map}prepareForMainThreadTestRun(U,N,C,T){return this.f(U,N,C,T)}cancelRunById(U){for(const N of this.c.values())if(N.id===U){N.cancel();return}}cancelAllRuns(){for(const U of this.c.values())U.cancel()}createTestRun(U,N,C,T,G,de){const me=this.c.get(T);if(me)return me.createRun(G);const De=S.fromPublic(N,C,T,de),ke=m(T);this.d.$startedExtensionTestRun({controllerId:N,continuous:!!T.continuous,profile:ke&&{group:V[ke.kind],id:ke.profileId},exclude:T.exclude?.map(pe=>r.$sJ.fromExtHostTestItem(pe,C.root.id).toString())??[],id:De.id,include:T.include?.map(pe=>r.$sJ.fromExtHostTestItem(pe,C.root.id).toString())??[C.root.id],persist:de});const le=this.f(T,De,U);return R.Event.once(le.onEnd)(()=>{this.d.$finishedExtensionTestRun(De.id),le.dispose()}),le.createRun(G)}f(U,N,C,T){const G=new d(N,this.d,T);return this.c.set(U,G),R.Event.once(G.onEnd)(()=>this.c.delete(U)),G}}e.$Cfc=p;const m=Y=>{if(Y.profile){if(!(Y.profile instanceof L))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return Y.profile}};class S{static fromPublic(U,N,C,T){return new S(U,(0,u.$ig)(),C.include?.map(G=>r.$sJ.fromExtHostTestItem(G,U).toString())??[U],C.exclude?.map(G=>r.$sJ.fromExtHostTestItem(G,U).toString())??[],T,N)}static fromInternal(U,N){return new S(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,N)}constructor(U,N,C,T,G,de){this.controllerId=U,this.id=N,this.isPersisted=G,this.colllection=de,this.c=C.map(me=>me+"\0"),this.d=T.map(me=>me+"\0")}isIncluded(U){const N=r.$sJ.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const C of this.d)if(N===C||N.startsWith(C))return!1;for(const C of this.c)if(N===C||N.startsWith(C))return!0;return!1}}e.$Dfc=S;class k{set coverageProvider(U){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");U&&(this.c=U,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(U,N,C){this.f=U,this.g=N,this.h=C}async provideFileCoverage(U){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(U))());try{return(await this.d)?.map(t.TestCoverage.fromFile)??[]}catch(N){throw this.d=void 0,N}}async resolveFileCoverage(U,N){const C=await this.d;let T=C?.[U];return!this.c||!C||!T?[]:(T.detailedCoverage||(T=C[U]=await this.c.resolveFileCoverage?.(T,N)??T),T.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class h{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(U){this.h=U,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(U){this.c.add(U)}update(U){Object.assign(U.revived,t.TestItem.toPlain(U.item)),this.c.has(U)||this.d.add(U)}remove(U){if(this.c.has(U)){this.c.delete(U);return}this.d.delete(U);const N=r.$sJ.parentId(U.item.extId);if(N&&this.g.has(N.toString())){this.g.add(U.item.extId);return}this.f.add(U)}getChangeEvent(){const{c:U,d:N,f:C}=this;return{get added(){return[...U].map(T=>T.revived)},get updated(){return[...N].map(T=>T.revived)},get removed(){return[...C].map(T=>T.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class w extends o.$zJ{constructor(){super(...arguments),this.q=new R.$Rd,this.onDidChangeTests=this.q.event}get rootTests(){return this.f}getMirroredTestDataById(U){return this.d.get(U)}getMirroredTestDataByReference(U){return this.d.get(U.id)}p(U,N){return{...U,revived:t.TestItem.toPlain(U.item),depth:N?N.depth+1:0,children:new Set}}o(){return new h(this.q)}}class I{constructor(U){this.d=U}checkout(){this.c||(this.c=this.f());const U=this.c;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(N=>N.revived)},dispose:(0,$.$cb)(()=>{--U.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(U){return this.c?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.c?.tests.apply(U)}f(){const U=new w;return this.d.$subscribeToDiffs(),{observers:0,tests:U}}}class L{#e;#t;#i;#o;#r;get label(){return this.d}set label(U){U!==this.d&&(this.d=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:U}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(U){U!==this.g&&(this.g=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:U}))}get isDefault(){return this.f}set isDefault(U){U!==this.f&&(this.f=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:U?t.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.c}set configureHandler(U){U!==this.c&&(this.c=U,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!U}))}get isSelected(){return(0,l.$NF)(this.#t,"testingActiveProfile"),this.#i.has(this.profileId)}get onDidChangeSelected(){return(0,l.$NF)(this.#t,"testingActiveProfile"),R.Event.chain(this.#o,U=>U.map(N=>N.get(this.controllerId)?.get(this.profileId)).filter(D.$Kf))}constructor(U,N,C,T,G,de,me,De,ke,le,pe=!1,re=void 0,Pe=!1){this.controllerId=de,this.profileId=me,this.d=De,this.kind=ke,this.runHandler=le,this.f=pe,this._tag=re,this.g=Pe,this.#e=U,this.#r=N,this.#t=C,this.#i=T,this.#o=G,N.set(me,this);const se=V[ke];if(typeof se!="number")throw new Error(`Unknown TestRunProfile.group ${ke}`);this.#e.$publishTestRunProfile({profileId:me,controllerId:de,tag:re?t.TestTag.namespace(this.controllerId,re.id):null,label:De,group:se,isDefault:pe,hasConfigurationHandler:!1,supportsContinuousRun:Pe})}dispose(){this.#r?.delete(this.profileId)&&(this.#r=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$Efc=L;const V={[i.TestRunProfileKind.Coverage]:8,[i.TestRunProfileKind.Debug]:4,[i.TestRunProfileKind.Run]:2}}),define(Ae[268],Re([1,0,18,11,5,3,109,8,7]),function(we,e,y,F,A,M,R,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1dc=void 0;class f{constructor(D,u){this.i=u,this.a=new A.$Rd({onListenerError:F.$1}),this.b=new A.$Rd({onListenerError:F.$1}),this.c=new A.$Rd({onListenerError:F.$1}),this.d=new A.$Rd({onListenerError:F.$1}),this.f=new A.$Rd({onListenerError:F.$1}),this.g=new A.$Rd({onListenerError:F.$1}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=D.getProxy(M.$zK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(b=>this.g.fire(b)),this.i.onDidChangeActiveTextEditor(b=>this.f.fire(b))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(D){const u=this.i.allEditors();return D?u:u.map(b=>b.value)}async showTextDocument(D,u,b){let v;typeof u=="number"?v={position:$.ViewColumn.from(u),preserveFocus:b}:typeof u=="object"?v={position:$.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selection:typeof u.selection=="object"?$.Range.from(u.selection):void 0,pinned:typeof u.preview=="boolean"?!u.preview:void 0}:v={preserveFocus:!1};const g=await this.h.$tryShowTextDocument(D.uri,v),t=g&&this.i.getEditor(g);if(t)return t.value;throw g?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}createTextEditorDecorationType(D,u){return new R.$IM(this.h,D,u).value}$acceptEditorPropertiesChanged(D,u){const b=this.i.getEditor(D);if(!b)throw new Error("unknown text editor");if(u.options&&b._acceptOptions(u.options),u.selections){const v=u.selections.selections.map($.Selection.to);b._acceptSelections(v)}if(u.visibleRanges){const v=y.$Gb(u.visibleRanges.map($.Range.to));b._acceptVisibleRanges(v)}if(u.options&&this.b.fire({textEditor:b.value,options:{...u.options,lineNumbers:$.TextEditorLineNumbersStyle.to(u.options.lineNumbers)}}),u.selections){const v=E.TextEditorSelectionChangeKind.fromValue(u.selections.source),g=u.selections.selections.map($.Selection.to);this.a.fire({textEditor:b.value,selections:g,kind:v})}if(u.visibleRanges){const v=y.$Gb(u.visibleRanges.map($.Range.to));this.c.fire({textEditor:b.value,visibleRanges:v})}}$acceptEditorPositionData(D){for(const u in D){const b=this.i.getEditor(u);if(!b)throw new Error("Unknown text editor");const v=$.ViewColumn.to(D[u]);b.value.viewColumn!==v&&(b._acceptViewColumn(v),this.d.fire({textEditor:b.value,viewColumn:v}))}}getDiffInformation(D){return Promise.resolve(this.h.$getDiffInformation(D))}}e.$1dc=f}),define(Ae[269],Re([1,0,2,4,3,6,7,8,22,16]),function(we,e,y,F,A,M,R,$,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hfc=e.$Gfc=void 0,e.$Gfc=(0,F.$Vh)("IExtHostTimeline");class P{constructor(b,v){this.b=new Map,this.c=new Map,this.a=b.getProxy(A.$zK.MainThreadTimeline),v.registerArgumentProcessor({processArgument:(g,t)=>{if(g&&g.$mid===12)if(this.b.get(g.source)&&E.$_l.equals(t,this.b.get(g.source)?.extension)){const i=g.uri===void 0?void 0:y.URI.revive(g.uri);return this.c.get(g.source)?.get(D(i))?.get(g.handle)}else return;return g}})}async $getTimeline(b,v,g,t){return this.b.get(b)?.provider.provideTimeline(y.URI.revive(v),g,t)}registerTimelineProvider(b,v,g,t){const i=new M.$Qc,r=this.d(v.id,t,i).bind(this);let c;v.onDidChange&&(c=v.onDidChange(l=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...l,id:v.id}),this));const o=this.c;return this.f({...v,scheme:b,onDidChange:void 0,async provideTimeline(l,n,s){n?.resetCache&&(i.clear(),o.get(v.id)?.clear());const a=await v.provideTimeline(l,n,s);if(a==null)return;const d=r(l,n);return{...a,source:v.id,items:a.items.map(d)}},dispose(){for(const l of o.values())l.get(v.id)?.clear();c?.dispose(),i.dispose()}},g)}d(b,v,g){return(t,i)=>{let r;if(i?.cacheResults){let c=this.c.get(b);c===void 0&&(c=new Map,this.c.set(b,c));const o=D(t);r=c.get(o),r===void 0&&(r=new Map,c.set(o,r))}return c=>{const{iconPath:o,...l}=c,n=`${b}|${c.id??c.timestamp}`;r?.set(n,c);let s,a,d;c.iconPath&&(o instanceof R.$vL?d={id:o.id,color:o.color}:y.URI.isUri(o)?(s=o,a=o):{light:s,dark:a}=o);let p;return R.$2K.isMarkdownString(l.tooltip)?p=$.MarkdownString.from(l.tooltip):(0,f.$Cf)(l.tooltip)?p=l.tooltip:R.$2K.isMarkdownString(l.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),p=$.MarkdownString.from(l.detail)):(0,f.$Cf)(l.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),p=l.detail),{...l,id:l.id??void 0,handle:n,source:b,command:c.command?v.toInternal(c.command,g):void 0,icon:s,iconDark:a,themeIcon:d,tooltip:p,accessibilityInformation:c.accessibilityInformation}}}}f(b,v){if(this.b.get(b.id))throw new Error(`Timeline Provider ${b.id} already exists.`);return this.a.$registerTimelineProvider({id:b.id,label:b.label,scheme:b.scheme}),this.b.set(b.id,{provider:b,extension:v}),(0,M.$Pc)(()=>{for(const t of this.c.values())t.get(b.id)?.clear();this.b.delete(b.id),this.a.$unregisterTimelineProvider(b.id),b.dispose()})}}e.$Hfc=P;function D(u){return u?.toString()}}),define(Ae[87],Re([1,0,19,5,6,168,4,15,197,3,27,17,7]),function(we,e,y,F,A,M,R,$,E,f,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qwb=e.$Pwb=e.TunnelDtoConverter=void 0;class b extends E.$mv{}var v;(function(t){function i(c){return{remoteAddress:c.remoteAddress,localAddress:c.localAddress,public:!!c.public,privacy:c.privacy??(c.public?E.TunnelPrivacyId.Public:E.TunnelPrivacyId.Private),protocol:c.protocol}}t.fromApiTunnel=i;function r(c){return{remoteAddress:{host:c.tunnelRemoteHost,port:c.tunnelRemotePort},localAddress:c.localAddress,public:c.privacy!==E.TunnelPrivacyId.ConstantPrivate&&c.privacy!==E.TunnelPrivacyId.ConstantPrivate,privacy:c.privacy,protocol:c.protocol}}t.fromServiceTunnel=r})(v||(e.TunnelDtoConverter=v={})),e.$Pwb=(0,R.$Vh)("IExtHostTunnelService");let g=class extends A.$Rc{constructor(i,r,c){super(),this.s=c,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new F.$Rd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=i.getProxy(f.$zK.MainThreadTunnelService)}async openTunnel(i,r){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${i.identifier.value} called openTunnel API for ${r.remoteAddress.host}:${r.remoteAddress.port}.`);const c=await this.a.$openTunnel(r,i.displayName);if(c){const o=new b(c.remoteAddress,c.localAddress,()=>this.a.$closeTunnel(c.remoteAddress));return this.B(o),o}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(i,r){const c=this.u();return this.r.set(c,{selector:i,provider:r}),this.a.$registerPortsAttributesProvider(i,c),new u.$BK(()=>{this.r.delete(c),this.a.$unregisterPortsAttributesProvider(c)})}async $providePortAttributes(i,r,c,o,l){const n=[];for(const a of i){const d=this.r.get(a);if(!d)return[];n.push(...await Promise.all(r.map(async p=>{let m;try{m=await d.provider.providePortAttributes({port:p,pid:c,commandLine:o},l)}catch{m=await d.provider.providePortAttributes(p,c,o,l)}return{providedAttributes:m,port:p}})))}const s=n.filter(a=>!!a.providedAttributes);return s.length>0?s.map(a=>({autoForwardAction:a.providedAttributes.autoForwardAction,port:a.port})):[]}async $registerCandidateFinder(i){}registerTunnelProvider(i,r){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(o,l)=>await i.provideTunnel(o,l,new y.$2d().token)??void 0;const c=r.tunnelFeatures?{elevation:!!r.tunnelFeatures?.elevation,privacyOptions:r.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(c),Promise.resolve((0,A.$Pc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(i,r){if(i){i.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(i.candidatePortSource),i.showCandidatePort&&(this.f=i.showCandidatePort,this.a.$setCandidateFilter());const c=i.tunnelFactory??(r?this.w(r):void 0);if(c){this.b=c;let o=i.tunnelFeatures?.privacyOptions??[];i.tunnelFeatures?.public&&o.length===0&&(o=[{id:"private",label:M.localize(0,null),themeIcon:"lock"},{id:"public",label:M.localize(1,null),themeIcon:"eye"}]);const l=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,public:!!i.tunnelFeatures?.public,privacyOptions:o}:void 0;this.a.$setTunnelProvider(l)}}else this.b=void 0;return(0,A.$Pc)(()=>{this.b=void 0})}w(i){}async $closeTunnel(i,r){if(this.g.has(i.host)){const c=this.g.get(i.host);c.has(i.port)&&(r&&c.get(i.port).disposeListener.dispose(),await c.get(i.port).tunnel.dispose(),c.delete(i.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(i,r){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const c=this.b(i,r);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),c!==void 0){const o=await c;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),o===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(i.remoteAddress.host)||this.g.set(i.remoteAddress.host,new Map);const l=this.B(o.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(o.remoteAddress))));return this.g.get(i.remoteAddress.host).set(i.remoteAddress.port,{tunnel:o,disposeListener:l}),v.fromApiTunnel(o)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(c){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),c instanceof Error)return c.message}}async $applyCandidateFilter(i){const r=await Promise.all(i.map(o=>this.f(o.host,o.port,o.detail??""))),c=i.filter((o,l)=>r[l]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${i.map(o=>o.port).join(", ")} to ${c.map(o=>o.port).join(", ")}`),c}};e.$Qwb=g,e.$Qwb=g=Ke([Ve(0,D.$BM),Ve(1,P.$RM),Ve(2,$.$dj)],g)}),define(Ae[270],Re([1,0,6,13,2,3]),function(we,e,y,F,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jfc=void 0;class R{static{this.a=new Set([F.Schemas.http,F.Schemas.https])}constructor(E){this.c=new Map,this.b=E.getProxy(M.$zK.MainThreadUriOpeners)}registerExternalUriOpener(E,f,P,D){if(this.c.has(f))throw new Error(`Opener with id '${f}' already registered`);const u=D.schemes.find(b=>!R.a.has(b));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(f,P),this.b.$registerUriOpener(f,D.schemes,E,D.label),(0,y.$Pc)(()=>{this.c.delete(f),this.b.$unregisterUriOpener(f)})}async $canOpenUri(E,f,P){const D=this.c.get(E);if(!D)throw new Error(`Unknown opener with id: ${E}`);const u=A.URI.revive(f);return D.canOpenExternalUri(u,P)}async $openUri(E,f,P){const D=this.c.get(E);if(!D)throw new Error(`Unknown opener id: '${E}'`);return D.openExternalUri(A.URI.revive(f.resolvedUri),{sourceUri:A.URI.revive(f.sourceUri)},P)}}e.$Jfc=R}),define(Ae[271],Re([1,0,3,2,6,11,22]),function(we,e,y,F,A,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kfc=void 0;class ${static{this.a=0}constructor(f){this.c=new R.$am,this.d=new Map,this.b=f.getProxy(y.$zK.MainThreadUrls)}registerUriHandler(f,P){const D=f.identifier;if(this.c.has(D))throw new Error(`Protocol handler already registered for extension ${D}`);const u=$.a++;return this.c.add(D),this.d.set(u,P),this.b.$registerUriHandler(u,D,f.displayName||f.name),(0,A.$Pc)(()=>{this.c.delete(D),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(f,P){const D=this.d.get(f);if(!D)return Promise.resolve(void 0);try{D.handleUri(F.URI.revive(P))}catch(u){(0,M.$Z)(u)}return Promise.resolve(void 0)}async createAppUri(f){return F.URI.revive(await this.b.$createAppUri(f))}}e.$Kfc=$}),define(Ae[65],Re([1,0,5,6,13,26,2,182,204,78,3]),function(we,e,y,F,A,M,R,$,E,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gec=e.$fec=e.$eec=e.$dec=e.$cec=void 0;class D{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;constructor(o,l,n,s,a,d,p){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new y.$Rd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new y.$Rd,this._onDidDispose=this.#h.event,this.#e=o,this.#t=l,this.#s=n,this.#o=s,this.#r=a,this.#n=d,this.#l=u(d),this.#d=b(d),this.#i=p}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(o){return this.#u=!0,(0,f.$9tb)(o,this.#o)}get cspSource(){const o=this.#n.extensionLocation;if(o.scheme===A.Schemas.https||o.scheme===A.Schemas.http){let l=o.toString();return l.endsWith("/")||(l+="/"),l+" "+f.$8tb}return f.$8tb}get html(){return this.a(),this.#a}set html(o){this.a(),this.#a!==o&&(this.#a=o,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(o)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(o)))}get options(){return this.a(),this.#s}set options(o){this.a(),M.$en(this.#s,o)||this.#t.$setOptions(this.#e,t(this.#n,this.#r,o)),this.#s=o}async postMessage(o){if(this.#c)return!1;const l=(0,E.$Ecb)(o,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,l.message,...l.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(o){if(!this.#d)return o;const l=this.#n.extensionLocation?.scheme===A.Schemas.vscodeRemote,n=this.#n.extensionLocation.scheme===A.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return o.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,a,d,p,m,S)=>{const k=R.URI.from({scheme:p||"file",path:decodeURIComponent(m)}),h=(0,f.$9tb)(k,{isRemote:l,authority:n}).toString();return`${a}${h}${S}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,a,d,p,m,S)=>{const k=R.URI.from({scheme:p||"file",path:decodeURIComponent(m)}),h=(0,f.$9tb)(k,{isRemote:l,authority:n}).toString();return`${a}${h}${S}`})}}e.$cec=D;function u(c){try{const o=(0,$.$To)((0,$.$So)(c.engines.vscode));return!!o&&o.majorBase>=1&&o.minorBase>=57}catch{return!1}}e.$dec=u;function b(c){try{const o=(0,$.$To)((0,$.$So)(c.engines.vscode));return o?o.majorBase<1||o.majorBase===1&&o.minorBase<60:!1}catch{return!1}}class v extends F.$Rc{constructor(o,l,n,s,a){super(),this.c=l,this.f=n,this.g=s,this.h=a,this.b=new Map,this.a=o.getProxy(P.$zK.MainThreadWebviews)}dispose(){super.dispose();for(const o of this.b.values())o.dispose();this.b.clear()}$onMessage(o,l,n){const s=this.j(o);if(s){const{message:a}=(0,E.$Fcb)(l,n.value);s._onMessageEmitter.fire(a)}}$onMissingCsp(o,l){this.g.warn(`${l} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(o,l,n){const s=new D(o,this.a,i(l),this.c,this.f,n,this.h);this.b.set(o,s);const a=s._onDidDispose(()=>{a.dispose(),this.deleteWebview(o)});return s}deleteWebview(o){this.b.delete(o)}j(o){return this.b.get(o)}}e.$eec=v;function g(c){return{id:c.identifier,location:c.extensionLocation}}e.$fec=g;function t(c,o,l){return{enableCommandUris:l.enableCommandUris,enableScripts:l.enableScripts,enableForms:l.enableForms,portMapping:l.portMapping,localResourceRoots:l.localResourceRoots||r(c,o)}}e.$gec=t;function i(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(o=>R.URI.from(o))}}function r(c,o){return[...(o?.getWorkspaceFolders()||[]).map(l=>l.uri),c.extensionLocation]}}),define(Ae[272],Re([1,0,19,97,6,13,25,2,8,65,75,3,7]),function(we,e,y,F,A,M,R,$,E,f,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iec=void 0;class b{constructor(s,a){this.document=s,this.b=a,this.a=1,this.c=new P.$Hdc("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,a){await this.f(s).undo(),a||this.disposeBackup()}async redo(s,a){await this.f(s).redo(),a||this.disposeBackup()}disposeEdits(s){for(const a of s)this.c.delete(a)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=l(this.document.uri)+this.a++;return(0,R.$zg)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const a=this.c.get(s,0);if(!a)throw new Error("No edit found");return a}}class v{constructor(){this.a=new Map}get(s,a){return this.a.get(this.b(s,a))}add(s,a,d){const p=this.b(s,a.uri);if(this.a.has(p))throw new Error(`Document already exists for viewType:${s} resource:${a.uri}`);const m=new b(a,d);return this.a.set(p,m),m}delete(s,a){const d=this.b(s,a.uri);this.a.delete(d)}b(s,a){return`${s}@@@${a}`}}var g;(function(n){n[n.Text=0]="Text",n[n.Custom=1]="Custom"})(g||(g={}));class t{constructor(){this.a=new Map}addTextProvider(s,a,d){return this.b(0,s,a,d)}addCustomProvider(s,a,d){return this.b(1,s,a,d)}get(s){return this.a.get(s)}b(s,a,d,p){if(this.a.has(a))throw new Error(`Provider for viewType:${a} already registered`);return this.a.set(a,{type:s,extension:d,provider:p}),new u.$BK(()=>this.a.delete(a))}}class i{constructor(s,a,d,p,m){this.d=a,this.f=d,this.g=p,this.h=m,this.b=new t,this.c=new v,this.a=s.getProxy(D.$zK.MainThreadCustomEditors)}registerCustomEditorProvider(s,a,d,p){const m=new A.$Qc;return c(d)?(m.add(this.b.addTextProvider(a,s,d)),this.a.$registerTextEditorProvider((0,f.$fec)(s),a,p.webviewOptions||{},{supportsMove:!!d.moveCustomTextEditor},(0,f.$dec)(s))):(m.add(this.b.addCustomProvider(a,s,d)),r(d)&&m.add(d.onDidChangeCustomDocument(S=>{const k=this.i(a,S.document.uri);if(o(S)){const h=k.addEdit(S);this.a.$onDidEdit(S.document.uri,a,h,S.label)}else this.a.$onContentChange(S.document.uri,a)})),this.a.$registerCustomEditorProvider((0,f.$fec)(s),a,p.webviewOptions||{},!!p.supportsMultipleEditorsPerDocument,(0,f.$dec)(s))),u.$BK.from(m,new u.$BK(()=>{this.a.$unregisterEditorProvider(a)}))}async $createCustomDocument(s,a,d,p,m){const S=this.b.get(a);if(!S)throw new Error(`No provider found for '${a}'`);if(S.type!==1)throw new Error(`Invalid provide type for '${a}'`);const k=$.URI.revive(s),h=await S.provider.openCustomDocument(k,{backupId:d,untitledDocumentData:p?.buffer},m);let w;return r(S.provider)&&this.f&&(w=this.f.workspaceValue(S.extension)??this.f.globalValue(S.extension)),this.c.add(a,h,w),{editable:r(S.provider)}}async $disposeCustomDocument(s,a){const d=this.b.get(a);if(!d)throw new Error(`No provider found for '${a}'`);if(d.type!==1)throw new Error(`Invalid provider type for '${a}'`);const p=$.URI.revive(s),{document:m}=this.i(a,p);this.c.delete(a,m),m.dispose()}async $resolveCustomEditor(s,a,d,p,m,S){const k=this.b.get(d);if(!k)throw new Error(`No provider found for '${d}'`);const h=E.ViewColumn.to(m),w=this.g.createNewWebview(a,p.contentOptions,k.extension),I=this.h.createNewWebviewPanel(a,d,p.title,h,p.options,w,p.active),L=$.URI.revive(s);switch(k.type){case 1:{const{document:V}=this.i(d,L);return k.provider.resolveCustomEditor(V,I,S)}case 0:{const V=this.d.getDocument(L);return k.provider.resolveCustomTextEditor(V,I,S)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,a,d){this.i(a,s).disposeEdits(d)}async $onMoveCustomEditor(s,a,d){const p=this.b.get(d);if(!p)throw new Error(`No provider found for '${d}'`);if(!p.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${d}'`);const m=this.h.getWebviewPanel(s);if(!m)throw new Error("No webview found");const S=$.URI.revive(a),k=this.d.getDocument(S);await p.provider.moveCustomTextEditor(k,m,y.CancellationToken.None)}async $undo(s,a,d,p){return this.i(a,s).undo(d,p)}async $redo(s,a,d,p){return this.i(a,s).redo(d,p)}async $revert(s,a,d){const p=this.i(a,s);await this.j(a).revertCustomDocument(p.document,d),p.disposeBackup()}async $onSave(s,a,d){const p=this.i(a,s);await this.j(a).saveCustomDocument(p.document,d),p.disposeBackup()}async $onSaveAs(s,a,d,p){const m=this.i(a,s);return this.j(a).saveCustomDocumentAs(m.document,$.URI.revive(d),p)}async $backup(s,a,d){const p=this.i(a,s),S=await this.j(a).backupCustomDocument(p.document,{destination:p.getNewBackupUri()},d);return p.updateBackup(S),S.id}i(s,a){const d=this.c.get(s,$.URI.revive(a));if(!d)throw new Error("No custom document found");return d}j(s){const d=this.b.get(s)?.provider;if(!d||!r(d))throw new Error("Custom document is not editable");return d}}e.$iec=i;function r(n){return!!n.onDidChangeCustomDocument}function c(n){return typeof n.resolveCustomTextEditor=="function"}function o(n){return typeof n.undo=="function"&&typeof n.redo=="function"}function l(n){const s=n.scheme===M.Schemas.file||n.scheme===M.Schemas.untitled?n.fsPath:n.toString();return(0,F.$Ji)(s)+""}}),define(Ae[273],Re([1,0,5,6,2,38,8,65,3,7]),function(we,e,y,F,A,M,R,$,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hec=void 0;class P extends F.$Rc{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;#h;constructor(v,g,t,i){super(),this.#s=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new y.$Rd),this.onDidDispose=this.#d.event,this.#h=this.B(new y.$Rd),this.onDidChangeViewState=this.#h.event,this.#e=v,this.#t=g,this.#o=t,this.#i=i.viewType,this.#r=i.panelOptions,this.#s=i.viewColumn,this.#n=i.title,this.#u=i.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#o.dispose(),super.dispose())}get webview(){return this.c(),this.#o}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(v){this.c(),this.#n!==v&&(this.#n=v,this.#t.$setTitle(this.#e,v))}get iconPath(){return this.c(),this.#a}set iconPath(v){this.c(),this.#a!==v&&(this.#a=v,this.#t.$setIconPath(this.#e,A.URI.isUri(v)?{light:v,dark:v}:v))}get options(){return this.#r}get viewColumn(){if(this.c(),!(typeof this.#s=="number"&&this.#s<0))return this.#s}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(v){this.#l||(this.active!==v.active||this.visible!==v.visible||this.viewColumn!==v.viewColumn)&&(this.#u=v.active,this.#c=v.visible,this.#s=v.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(v,g){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof v>"u"?void 0:R.ViewColumn.from(v),preserveFocus:!!g})}c(){if(this.#l)throw new Error("Webview is disposed")}}class D extends F.$Rc{static c(){return(0,M.$ig)()}constructor(v,g,t){super(),this.j=g,this.m=t,this.g=new Map,this.h=new Map,this.f=v.getProxy(E.$zK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(v=>v.dispose()),this.g.clear()}createWebviewPanel(v,g,t,i,r={}){const c=typeof i=="object"?i.viewColumn:i,o={viewColumn:R.ViewColumn.from(c),preserveFocus:typeof i=="object"&&!!i.preserveFocus},l=(0,$.$dec)(v),n=D.c();this.f.$createWebviewPanel((0,$.$fec)(v),n,g,{title:t,panelOptions:u(r),webviewOptions:(0,$.$gec)(v,this.m,r),serializeBuffersForPostMessage:l},o);const s=this.j.createNewWebview(n,r,v);return this.createNewWebviewPanel(n,g,t,c,r,s,!0)}$onDidChangeWebviewPanelViewStates(v){const g=Object.keys(v);g.sort((t,i)=>{const r=v[t],c=v[i];return r.active?1:c.active?-1:+r.visible-+c.visible});for(const t of g){const i=this.getWebviewPanel(t);if(!i)continue;const r=v[t];i._updateViewState({active:r.active,visible:r.visible,viewColumn:R.ViewColumn.to(r.position)})}}async $onDidDisposeWebviewPanel(v){this.getWebviewPanel(v)?.dispose(),this.g.delete(v),this.j.deleteWebview(v)}registerWebviewPanelSerializer(v,g,t){if(this.h.has(g))throw new Error(`Serializer for '${g}' already registered`);return this.h.set(g,{serializer:t,extension:v}),this.f.$registerSerializer(g,{serializeBuffersForPostMessage:(0,$.$dec)(v)}),new f.$BK(()=>{this.h.delete(g),this.f.$unregisterSerializer(g)})}async $deserializeWebviewPanel(v,g,t,i){const r=this.h.get(g);if(!r)throw new Error(`No serializer found for '${g}'`);const{serializer:c,extension:o}=r,l=this.j.createNewWebview(v,t.webviewOptions,o),n=this.createNewWebviewPanel(v,g,t.title,i,t.panelOptions,l,t.active);await c.deserializeWebviewPanel(n,t.state)}createNewWebviewPanel(v,g,t,i,r,c,o){const l=new P(v,this.f,c,{viewType:g,title:t,viewColumn:i,panelOptions:r,active:o});return this.g.set(v,l),l}getWebviewPanel(v){return this.g.get(v)}}e.$hec=D;function u(b){return{enableFindWidget:b.enableFindWidget,retainContextWhenHidden:b.retainContextWhenHidden}}}),define(Ae[274],Re([1,0,5,6,65,8,3,7]),function(we,e,y,F,A,M,R,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lfc=void 0;class E extends F.$Rc{#e;#t;#i;#o;#r;#n;#a;#s;#c;constructor(D,u,b,v,g,t){super(),this.#r=!1,this.#u=this.B(new y.$Rd),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new y.$Rd),this.onDidDispose=this.#l.event,this.#i=b,this.#a=v,this.#e=D,this.#t=u,this.#o=g,this.#n=t}dispose(){this.#r||(this.#r=!0,this.#l.fire(),this.#o.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(D){this.a(),this.#a!==D&&(this.#a=D,this.#t.$setWebviewViewTitle(this.#e,D))}get description(){return this.a(),this.#s}set description(D){this.a(),this.#s!==D&&(this.#s=D,this.#t.$setWebviewViewDescription(this.#e,D))}get visible(){return this.#n}get webview(){return this.#o}get viewType(){return this.#i}_setVisible(D){D===this.#n||this.#r||(this.#n=D,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(D){this.a(),!(D?.value===this.#c?.value&&D?.tooltip===this.#c?.tooltip)&&(this.#c=M.ViewBadge.from(D),this.#t.$setWebviewViewBadge(this.#e,D))}show(D){this.a(),this.#t.$show(this.#e,!!D)}a(){if(this.#r)throw new Error("Webview is disposed")}}class f{constructor(D,u){this.d=u,this.b=new Map,this.c=new Map,this.a=D.getProxy(R.$zK.MainThreadWebviewViews)}registerWebviewViewProvider(D,u,b,v){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:b,extension:D}),this.a.$registerWebviewViewProvider((0,A.$fec)(D),u,{retainContextWhenHidden:v?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,A.$dec)(D)}),new $.$BK(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(D,u,b,v,g){const t=this.b.get(u);if(!t)throw new Error(`No view provider found for '${u}'`);const{provider:i,extension:r}=t,c=this.d.createNewWebview(D,{},r),o=new E(D,this.a,u,b,c,!0);this.c.set(D,o),await i.resolveWebviewView(o,{state:v},g)}async $onDidChangeWebviewViewVisibility(D,u){this.e(D)._setVisible(u)}async $disposeWebviewView(D){const u=this.e(D);this.c.delete(D),u.dispose(),this.d.deleteWebview(D)}e(D){const u=this.c.get(D);if(!u)throw new Error("No webview found");return u}}e.$Lfc=f}),define(Ae[111],Re([1,0,5,3,2,13,12,4,17,23]),function(we,e,y,F,A,M,R,$,E,f){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Nfc=e.$Mfc=void 0;let D=class{static{P=this}static{this.a={focused:!0,active:!0}}getState(b){const v=this.d;return{get focused(){return v.focused},get active(){return(0,f.$NF)(b,"windowActivity"),v.active}}}constructor(b){this.c=new y.$Rd,this.onDidChangeWindowState=this.c.event,this.d=P.a,this.b=b.getProxy(F.$zK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:v,isActive:g})=>{this.onDidChangeWindowProperty("focused",v),this.onDidChangeWindowProperty("active",g)})}$onDidChangeWindowFocus(b){this.onDidChangeWindowProperty("focused",b)}$onDidChangeWindowActive(b){this.onDidChangeWindowProperty("active",b)}onDidChangeWindowProperty(b,v){v!==this.d[b]&&(this.d={...this.d,[b]:v},this.c.fire(this.d))}openUri(b,v){let g;if(typeof b=="string"){g=b;try{b=A.URI.parse(b)}catch{return Promise.reject(`Invalid uri - '${b}'`)}}return(0,R.$Fe)(b.scheme)?Promise.reject("Invalid scheme - cannot be empty"):b.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${b.scheme}'`):this.b.$openUri(b,g,v)}async asExternalUri(b,v){if((0,R.$Fe)(b.scheme))return Promise.reject("Invalid scheme - cannot be empty");const g=await this.b.$asExternalUri(b,v);return A.URI.from(g)}};e.$Mfc=D,e.$Mfc=D=P=Ke([Ve(0,E.$BM)],D),e.$Nfc=(0,$.$Vh)("IExtHostWindow")}),define(Ae[275],Re([1,0,241,27,17]),function(we,e,y,F,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yhc=void 0;let M=class extends y.$Qfc{constructor($,E){super($,E)}f($,E,f){E.apply(console,f)}};e.$Yhc=M,e.$Yhc=M=Ke([Ve(0,A.$BM),Ve(1,F.$RM)],M)}),define(Ae[276],Re([1,0,14,24,19,11,5,6,139,230,49]),function(we,e,y,F,A,M,R,$,E,f,P){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$55b=e.ResponsiveState=e.RequestInitiator=e.$45b=e.$35b=void 0;function u(I,L){try{return JSON.stringify(I,L)}catch{return"null"}}const b="$$ref$$",v={[b]:-1};class g{constructor(L,V){this.jsonString=L,this.referencedBuffers=V}}function t(I,L=null,V=!1){const Y=[];return{jsonString:(V?u:JSON.stringify)(I,(N,C)=>{if(typeof C>"u")return v;if(typeof C=="object"){if(C instanceof F.$fe){const T=Y.push(C)-1;return{[b]:T}}if(L)return L(N,C)}return C}),referencedBuffers:Y}}e.$35b=t;function i(I,L,V){return JSON.parse(I,(Y,U)=>{if(U){const N=U[b];if(typeof N=="number")return L[N];if(V&&U.$mid===1)return V.transformIncoming(U)}return U})}e.$45b=i;function r(I,L){return JSON.stringify(I,L)}function c(I){return I?(L,V)=>V&&V.$mid===1?I.transformOutgoing(V):V:null}var o;(function(I){I[I.LocalSide=0]="LocalSide",I[I.OtherSide=1]="OtherSide"})(o||(e.RequestInitiator=o={}));var l;(function(I){I[I.Responsive=0]="Responsive",I[I.Unresponsive=1]="Unresponsive"})(l||(e.ResponsiveState=l={}));const n=()=>{},s=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class d extends $.$Rc{static{D=s}static{this.a=3*1e3}constructor(L,V=null,Y=null){super(),this[D]=!0,this.b=this.B(new R.$Rd),this.onDidChangeResponsiveState=this.b.event,this.c=L,this.f=V,this.g=Y,this.h=c(this.g),this.j=!1,this.m=[],this.s=[];for(let U=0,N=P.$tv.count;U<N;U++)this.m[U]=null,this.s[U]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new y.$0g(()=>this.H(),1e3)),this.c.onMessage(U=>this.L(U))}dispose(){this.j=!0,Object.keys(this.w).forEach(L=>{const V=this.w[L];delete this.w[L],V.resolveErr(M.$5())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(L){this.z===0&&(this.C=Date.now()+d.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(L){this.C=Date.now()+d.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(L){this.y!==L&&(this.y=L,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(L){return this.g?(0,E.$Um)(L,this.g):L}getProxy(L){const{nid:V,sid:Y}=L;return this.s[V]||(this.s[V]=this.J(V,Y)),this.s[V]}J(L,V){const Y={get:(U,N)=>(typeof N=="string"&&!U[N]&&N.charCodeAt(0)===36&&(U[N]=(...C)=>this.U(L,N,C)),N===a?V:U[N])};return new Proxy(Object.create(null),Y)}set(L,V){return this.m[L.nid]=V,V}assertRegistered(L){for(let V=0,Y=L.length;V<Y;V++){const U=L[V];if(!this.m[U.nid])throw new Error(`Missing proxy instance ${U.sid}`)}}L(L){if(this.j)return;const V=L.byteLength,Y=m.read(L,0),U=Y.readUInt8(),N=Y.readUInt32();switch(U){case 1:case 2:{let{rpcId:C,method:T,args:G}=k.deserializeRequestJSONArgs(Y);this.g&&(G=(0,E.$Um)(G,this.g)),this.M(V,N,C,T,G,U===2);break}case 3:case 4:{let{rpcId:C,method:T,args:G}=k.deserializeRequestMixedArgs(Y);this.g&&(G=(0,E.$Um)(G,this.g)),this.M(V,N,C,T,G,U===4);break}case 5:{this.f?.logIncoming(V,N,0,"ack"),this.G(N);break}case 6:{this.N(V,N);break}case 7:{this.O(V,N,void 0);break}case 9:{let C=k.deserializeReplyOKJSON(Y);this.g&&(C=(0,E.$Um)(C,this.g)),this.O(V,N,C);break}case 10:{const C=k.deserializeReplyOKJSONWithBuffers(Y,this.g);this.O(V,N,C);break}case 8:{const C=k.deserializeReplyOKVSBuffer(Y);this.O(V,N,C);break}case 11:{let C=k.deserializeReplyErrError(Y);this.g&&(C=(0,E.$Um)(C,this.g)),this.P(V,N,C);break}case 12:{this.P(V,N,void 0);break}default:console.error("received unexpected message"),console.error(L)}}M(L,V,Y,U,N,C){this.f?.logIncoming(L,V,1,`receiveRequest ${(0,P.$vv)(Y)}.${U}(`,N);const T=String(V);let G,de;if(C){const De=new A.$2d;N.push(De.token),G=this.Q(Y,U,N),de=()=>De.cancel()}else G=this.Q(Y,U,N),de=n;this.u[T]=de;const me=k.serializeAcknowledged(V);this.f?.logOutgoing(me.byteLength,V,1,"ack"),this.c.send(me),G.then(De=>{delete this.u[T];const ke=k.serializeReplyOK(V,De,this.h);this.f?.logOutgoing(ke.byteLength,V,1,"reply:",De),this.c.send(ke)},De=>{delete this.u[T];const ke=k.serializeReplyErr(V,De);this.f?.logOutgoing(ke.byteLength,V,1,"replyErr:",De),this.c.send(ke)})}N(L,V){this.f?.logIncoming(L,V,1,"receiveCancel");const Y=String(V);this.u[Y]?.()}O(L,V,Y){this.f?.logIncoming(L,V,0,"receiveReply:",Y);const U=String(V);if(!this.w.hasOwnProperty(U))return;const N=this.w[U];delete this.w[U],N.resolveOk(Y)}P(L,V,Y){this.f?.logIncoming(L,V,0,"receiveReplyErr:",Y);const U=String(V);if(!this.w.hasOwnProperty(U))return;const N=this.w[U];delete this.w[U];let C;Y&&(Y.$isError?(C=new Error,C.name=Y.name,C.message=Y.message,C.stack=Y.stack):C=Y),N.resolveErr(C)}Q(L,V,Y){try{return Promise.resolve(this.S(L,V,Y))}catch(U){return Promise.reject(U)}}S(L,V,Y){const U=this.m[L];if(!U)throw new Error("Unknown actor "+(0,P.$vv)(L));const N=U[V];if(typeof N!="function")throw new Error("Unknown method "+V+" on actor "+(0,P.$vv)(L));return N.apply(U,Y)}U(L,V,Y){if(this.j)return new f.$25b;let U=null;if(Y.length>0&&A.CancellationToken.isCancellationToken(Y[Y.length-1])&&(U=Y.pop()),U&&U.isCancellationRequested)return Promise.reject(M.$5());const N=k.serializeRequestArguments(Y,this.h),C=++this.t,T=String(C),G=new f.$15b,de=new $.$Qc;U&&de.add(U.onCancellationRequested(()=>{const De=k.serializeCancel(C);this.f?.logOutgoing(De.byteLength,C,0,"cancel"),this.c.send(k.serializeCancel(C))})),this.w[T]=new p(G,de),this.F(C);const me=k.serializeRequest(C,L,V,N,!!U);return this.f?.logOutgoing(me.byteLength,C,0,`request: ${(0,P.$vv)(L)}.${V}(`,Y),this.c.send(me),G}}e.$55b=d;class p{constructor(L,V){this.a=L,this.b=V}resolveOk(L){this.a.resolveOk(L),this.b.dispose()}resolveErr(L){this.a.resolveErr(L),this.b.dispose()}}class m{static alloc(L,V,Y){const U=new m(F.$fe.alloc(Y+1+4),0);return U.writeUInt8(L),U.writeUInt32(V),U}static read(L,V){return new m(L,V)}get buffer(){return this.a}constructor(L,V){this.a=L,this.b=V}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(L){this.a.writeUInt8(L,this.b),this.b+=1}readUInt8(){const L=this.a.readUInt8(this.b);return this.b+=1,L}writeUInt32(L){this.a.writeUInt32BE(L,this.b),this.b+=4}readUInt32(){const L=this.a.readUInt32BE(this.b);return this.b+=4,L}static sizeShortString(L){return 1+L.byteLength}writeShortString(L){this.a.writeUInt8(L.byteLength,this.b),this.b+=1,this.a.set(L,this.b),this.b+=L.byteLength}readShortString(){const L=this.a.readUInt8(this.b);this.b+=1;const Y=this.a.slice(this.b,this.b+L).toString();return this.b+=L,Y}static sizeLongString(L){return 4+L.byteLength}writeLongString(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}readLongString(){const L=this.a.readUInt32BE(this.b);this.b+=4;const Y=this.a.slice(this.b,this.b+L).toString();return this.b+=L,Y}writeBuffer(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}static sizeVSBuffer(L){return 4+L.byteLength}writeVSBuffer(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}readVSBuffer(){const L=this.a.readUInt32BE(this.b);this.b+=4;const V=this.a.slice(this.b,this.b+L);return this.b+=L,V}static sizeMixedArray(L){let V=0;V+=1;for(let Y=0,U=L.length;Y<U;Y++){const N=L[Y];switch(V+=1,N.type){case 1:V+=this.sizeLongString(N.value);break;case 2:V+=this.sizeVSBuffer(N.value);break;case 3:V+=this.sizeUInt32,V+=this.sizeLongString(N.value);for(let C=0;C<N.buffers.length;++C)V+=this.sizeVSBuffer(N.buffers[C]);break;case 4:break}}return V}writeMixedArray(L){this.a.writeUInt8(L.length,this.b),this.b+=1;for(let V=0,Y=L.length;V<Y;V++){const U=L[V];switch(U.type){case 1:this.writeUInt8(1),this.writeLongString(U.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(U.value);break;case 3:this.writeUInt8(3),this.writeUInt32(U.buffers.length),this.writeLongString(U.value);for(let N=0;N<U.buffers.length;++N)this.writeBuffer(U.buffers[N]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const L=this.a.readUInt8(this.b);this.b+=1;const V=new Array(L);for(let Y=0;Y<L;Y++)switch(this.readUInt8()){case 1:V[Y]=this.readLongString();break;case 2:V[Y]=this.readVSBuffer();break;case 3:{const N=this.readUInt32(),C=this.readLongString(),T=[];for(let G=0;G<N;++G)T.push(this.readVSBuffer());V[Y]=new P.$wv(i(C,T,null));break}case 4:V[Y]=void 0;break}return V}}var S;(function(I){I[I.Simple=0]="Simple",I[I.Mixed=1]="Mixed"})(S||(S={}));class k{static a(L){for(let V=0,Y=L.length;V<Y;V++)if(L[V]instanceof F.$fe||L[V]instanceof P.$wv||typeof L[V]>"u")return!0;return!1}static serializeRequestArguments(L,V){if(this.a(L)){const Y=[];for(let U=0,N=L.length;U<N;U++){const C=L[U];if(C instanceof F.$fe)Y[U]={type:2,value:C};else if(typeof C>"u")Y[U]={type:4};else if(C instanceof P.$wv){const{jsonString:T,referencedBuffers:G}=t(C.value,V);Y[U]={type:3,value:F.$fe.fromString(T),buffers:G}}else Y[U]={type:1,value:F.$fe.fromString(r(C,V))}}return{type:1,args:Y}}return{type:0,args:r(L,V)}}static serializeRequest(L,V,Y,U,N){switch(U.type){case 0:return this.b(L,V,Y,U.args,N);case 1:return this.c(L,V,Y,U.args,N)}}static b(L,V,Y,U,N){const C=F.$fe.fromString(Y),T=F.$fe.fromString(U);let G=0;G+=m.sizeUInt8(),G+=m.sizeShortString(C),G+=m.sizeLongString(T);const de=m.alloc(N?2:1,L,G);return de.writeUInt8(V),de.writeShortString(C),de.writeLongString(T),de.buffer}static deserializeRequestJSONArgs(L){const V=L.readUInt8(),Y=L.readShortString(),U=L.readLongString();return{rpcId:V,method:Y,args:JSON.parse(U)}}static c(L,V,Y,U,N){const C=F.$fe.fromString(Y);let T=0;T+=m.sizeUInt8(),T+=m.sizeShortString(C),T+=m.sizeMixedArray(U);const G=m.alloc(N?4:3,L,T);return G.writeUInt8(V),G.writeShortString(C),G.writeMixedArray(U),G.buffer}static deserializeRequestMixedArgs(L){const V=L.readUInt8(),Y=L.readShortString(),U=L.readMixedArray(),N=new Array(U.length);for(let C=0,T=U.length;C<T;C++){const G=U[C];typeof G=="string"?N[C]=JSON.parse(G):N[C]=G}return{rpcId:V,method:Y,args:N}}static serializeAcknowledged(L){return m.alloc(5,L,0).buffer}static serializeCancel(L){return m.alloc(6,L,0).buffer}static serializeReplyOK(L,V,Y){if(typeof V>"u")return this.d(L);if(V instanceof F.$fe)return this.e(L,V);if(V instanceof P.$wv){const{jsonString:U,referencedBuffers:N}=t(V.value,Y,!0);return this.g(L,U,N)}else return this.f(L,u(V,Y))}static d(L){return m.alloc(7,L,0).buffer}static e(L,V){let Y=0;Y+=m.sizeVSBuffer(V);const U=m.alloc(8,L,Y);return U.writeVSBuffer(V),U.buffer}static deserializeReplyOKVSBuffer(L){return L.readVSBuffer()}static f(L,V){const Y=F.$fe.fromString(V);let U=0;U+=m.sizeLongString(Y);const N=m.alloc(9,L,U);return N.writeLongString(Y),N.buffer}static g(L,V,Y){const U=F.$fe.fromString(V);let N=0;N+=m.sizeUInt32,N+=m.sizeLongString(U);for(const T of Y)N+=m.sizeVSBuffer(T);const C=m.alloc(10,L,N);C.writeUInt32(Y.length),C.writeLongString(U);for(const T of Y)C.writeBuffer(T);return C.buffer}static deserializeReplyOKJSON(L){const V=L.readLongString();return JSON.parse(V)}static deserializeReplyOKJSONWithBuffers(L,V){const Y=L.readUInt32(),U=L.readLongString(),N=[];for(let C=0;C<Y;++C)N.push(L.readVSBuffer());return new P.$wv(i(U,N,V))}static serializeReplyErr(L,V){const Y=V?u(M.$2(V),null):void 0;if(typeof Y!="string")return this.h(L);const U=F.$fe.fromString(Y);let N=0;N+=m.sizeLongString(U);const C=m.alloc(11,L,N);return C.writeLongString(U),C.buffer}static deserializeReplyErrError(L){const V=L.readLongString();return JSON.parse(V)}static h(L){return m.alloc(12,L,0).buffer}}var h;(function(I){I[I.RequestJSONArgs=1]="RequestJSONArgs",I[I.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",I[I.RequestMixedArgs=3]="RequestMixedArgs",I[I.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",I[I.Acknowledged=5]="Acknowledged",I[I.Cancel=6]="Cancel",I[I.ReplyOKEmpty=7]="ReplyOKEmpty",I[I.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",I[I.ReplyOKJSON=9]="ReplyOKJSON",I[I.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",I[I.ReplyErrError=11]="ReplyErrError",I[I.ReplyErrEmpty=12]="ReplyErrEmpty"})(h||(h={}));var w;(function(I){I[I.String=1]="String",I[I.VSBuffer=2]="VSBuffer",I[I.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",I[I.Undefined=4]="Undefined"})(w||(w={}))}),define(Ae[277],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1hc=void 0;const y=function(M){const R=$=>{globalThis.removeEventListener("message",R);const E=$.data;Object.defineProperties(globalThis,{postMessage:{value(f,P){E.postMessage(f,P)}},onmessage:{get(){return E.onmessage},set(f){E.onmessage=f}}}),E.addEventListener("message",f=>{globalThis.dispatchEvent(new MessageEvent("message",{data:f.data,ports:f.ports?[...f.ports]:void 0}))}),E.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};globalThis.addEventListener("message",R)}.toString();class F extends EventTarget{constructor(M,R,$){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const E=`((${y})('${R}'))`,f=new Blob([E],{type:"application/javascript"}),P=URL.createObjectURL(f),D=new MessageChannel,u=P,b={type:"_newWorker",id:u,port:D.port2,url:P,options:$};M(b,[D.port2]),this.postMessage=D.port1.postMessage.bind(D.port1),this.terminate=()=>{M({type:"_terminateWorker",id:u}),URL.revokeObjectURL(P),D.port1.close(),D.port2.close()},Object.defineProperties(this,{onmessage:{get(){return D.port1.onmessage},set(v){D.port1.onmessage=v}},onmessageerror:{get(){return D.port1.onmessageerror},set(v){D.port1.onmessageerror=v}}}),D.port1.addEventListener("messageerror",v=>{const g=new MessageEvent("messageerror",{data:v.data});this.dispatchEvent(g)}),D.port1.addEventListener("message",v=>{const g=new MessageEvent("message",{data:v.data});this.dispatchEvent(g)}),D.port1.start()}}e.$1hc=F}),define(Ae[278],Re([1,0,5,30,34,4]),function(we,e,y,F,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VJ=e.$UJ=e.OutputChannelUpdateMode=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=void 0,e.$KJ="text/x-code-output",e.$LJ="output",e.$MJ="Log",e.$NJ="text/x-code-log-output",e.$OJ="log",e.$PJ="workbench.panel.output",e.$QJ=new A.$aj("inOutput",!1),e.$RJ=new A.$aj("activeLogOutput",!1),e.$SJ=new A.$aj("outputView.scrollLock",!1),e.$TJ=(0,M.$Vh)("outputService");var R;(function(E){E[E.Append=1]="Append",E[E.Replace=2]="Replace",E[E.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$UJ={OutputChannels:"workbench.contributions.outputChannels"};class ${constructor(){this.a=new Map,this.b=new y.$Rd,this.onDidRegisterChannel=this.b.event,this.c=new y.$Rd,this.onDidRemoveChannel=this.c.event}registerChannel(f){this.a.has(f.id)||(this.a.set(f.id,f),this.b.fire(f.id))}getChannels(){const f=[];return this.a.forEach(P=>f.push(P)),f}getChannel(f){return this.a.get(f)}removeChannel(f){this.a.delete(f),this.c.fire(f)}}F.$mn.add(e.$UJ.OutputChannels,new $),e.$VJ=new A.$aj("activeOutputChannel","")}),define(Ae[112],Re([1,0,3,4,17,22,15,278,63,27,42,136,24,16,41,5,6]),function(we,e,y,F,A,M,R,$,E,f,P,D,u,b,v,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nfc=e.$mfc=void 0;class i extends R.$jj{get disposed(){return this.n}constructor(l,n,s,a,d){super(),this.id=l,this.name=n,this.r=s,this.s=a,this.extension=d,this.m=0,this.n=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(p=>this.setLevel(p)))}get logLevel(){return this.getLevel()}appendLine(l){this.append(l+`
`)}append(l){this.info(l)}clear(){const l=this.m;this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Clear,l)}replace(l){const n=this.m;this.info(l),this.s.$update(this.id,$.OutputChannelUpdateMode.Replace,n),this.visible&&this.r.flush()}show(l,n){this.r.flush(),this.s.$reveal(this.id,!!(typeof l=="boolean"?l:n))}hide(){this.s.$close(this.id)}g(l,n){this.m+=u.$fe.fromString(n).byteLength,(0,R.log)(this.r,l,n),this.visible&&(this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class r extends i{appendLine(l){this.append(l)}}let c=class{constructor(l,n,s,a,d,p){this.i=n,this.j=s,this.k=a,this.l=d,this.m=p,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=l.getProxy(y.$zK.MainThreadOutputService),this.b=this.k.extUri.joinPath(n.logsLocation,`output_logging_${(0,D.$km)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(l){this.h=l;for(const[n,s]of this.g)s.visible=n===this.h}createOutputChannel(l,n,s){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");const a=typeof n=="object"&&n.log,d=(0,b.$Cf)(n)?n:void 0;if((0,b.$Cf)(d)&&!d.trim())throw new Error("illegal argument `languageId`. must not be empty");let p;const m=this.i.environment.extensionLogLevel?.find(([k])=>M.$_l.equals(s.identifier,k))?.[1];m&&(p=(0,R.$tj)(m));const S=a?this.o(l,p,s):this.n(l,d,s);return S.then(k=>{this.g.set(k.id,k),k.visible=k.id===this.h}),a?this.r(l,p??this.m.getLevel(),S):this.q(l,S)}async n(l,n,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const a=await this.c,d=this.k.extUri.joinPath(a,`${this.f++}-${l.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),p=this.l.createLogger(d,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),m=await this.a.$register(l,d,n,s.identifier.value);return new i(m,l,p,this.a,s)}async o(l,n,s){const a=await this.p(s),d=l.replace(/[\\/:\*\?"<>\|]/g,""),p=this.k.extUri.joinPath(a,`${d}.log`),m=`${s.identifier.value}.${d}`,S=this.l.createLogger(p,{id:m,name:l,logLevel:n,extensionId:s.identifier.value});return new r(m,l,S,this.a,s)}p(l){let n=this.d.get(l.identifier.value);if(!n){const s=this.k.extUri.joinPath(this.i.logsLocation,l.identifier.value);this.d.set(l.identifier.value,n=(async()=>{try{await this.j.value.createDirectory(s)}catch(a){if((0,v.$uk)(a)!==v.FileSystemProviderErrorCode.FileExists)throw a}return s})())}return n}q(l,n){let s=!1;const a=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return l},append(d){a(),n.then(p=>p.append(d))},appendLine(d){a(),n.then(p=>p.appendLine(d))},clear(){a(),n.then(d=>d.clear())},replace(d){a(),n.then(p=>p.replace(d))},show(d,p){a(),n.then(m=>m.show(d,p))},hide(){a(),n.then(d=>d.hide())},dispose(){s=!0,n.then(d=>d.dispose())}}}r(l,n,s){const a=new t.$Qc,d=()=>{if(a.isDisposed)throw new Error("Channel has been closed")},p=a.add(new g.$Rd);function m(S){n=S,p.fire(S)}return s.then(S=>{a.add(S),S.logLevel!==n&&m(S.logLevel),a.add(S.onDidChangeLogLevel(k=>m(k)))}),{...this.q(l,s),get logLevel(){return n},onDidChangeLogLevel:p.event,trace(S,...k){d(),s.then(h=>h.trace(S,...k))},debug(S,...k){d(),s.then(h=>h.debug(S,...k))},info(S,...k){d(),s.then(h=>h.info(S,...k))},warn(S,...k){d(),s.then(h=>h.warn(S,...k))},error(S,...k){d(),s.then(h=>h.error(S,...k))},dispose(){a.dispose()}}}};e.$mfc=c,e.$mfc=c=Ke([Ve(0,A.$BM),Ve(1,f.$RM),Ve(2,E.$_dc),Ve(3,P.$Ldc),Ve(4,R.$ej),Ve(5,R.$dj)],c),e.$nfc=(0,F.$Vh)("IExtHostOutputService")}),define(Ae[113],Re([1,0,4,14]),function(we,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Am=e.$zm=void 0,e.$zm=(0,y.$Vh)("remoteAgentService"),e.$Am=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(A){let M=1/0;for(let $=0;$<this.maxSampleCount;$++){const E=await A.getRoundTripTime();if(E===void 0)return;M=Math.min(M,E/2),await(0,F.$Yg)(this.sampleDelay)}this.average.push(M),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(M):R=this.initial.reduce(($,E)=>$+E,0)/this.initial.length,this.lastMeasurement={initial:R,current:M,average:this.average.reduce(($,E)=>$+E,0)/this.average.length,high:(()=>typeof R>"u"?!1:M>this.highLatencyMaxThreshold||M>this.highLatencyMinThreshold&&M>R*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Ae[279],Re([1,0,170,54,30,47,40,6,5,113,21,26]),function(we,e,y,F,A,M,R,$,E,f,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=void 0,e.$pH=Object.freeze({id:"application",order:100,title:(0,y.localize)(0,null),type:"object"}),e.$qH=Object.freeze({id:"workbench",order:7,title:(0,y.localize)(1,null),type:"object"}),e.$rH=Object.freeze({id:"security",scope:1,title:(0,y.localize)(2,null),type:"object",order:7}),e.$sH={ConfigurationMigration:"base.contributions.configuration.migration"};class u{constructor(){this.migrations=[],this.a=new E.$Rd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(i){this.migrations.push(...i)}}const b=new u;A.$mn.add(e.$sH.ConfigurationMigration,b);let v=class extends $.$Rc{constructor(i,r){super(),this.a=i,this.b=r,this.B(this.b.onDidChangeWorkspaceFolders(async c=>{for(const o of c.added)await this.f(o,b.migrations)})),this.c(b.migrations),this.B(b.onDidRegisterConfigurationMigration(c=>this.c(c)))}async c(i){await this.f(void 0,i);for(const r of this.b.getWorkspace().folders)await this.f(r,i)}async f(i,r){await Promise.all([r.map(c=>this.g(c,i?.uri))])}async g(i,r){const c=this.a.inspect(i.key,{resource:r}),o=[["userValue",2],["userLocalValue",3],["userRemoteValue",4],["workspaceValue",5],["workspaceFolderValue",6]];for(const[l,n]of o){const s=[];for(const d of c.overrideIdentifiers??[]){const p=await this.h(i,{resource:r,overrideIdentifier:d},l);for(const m of p??[]){let S=s.find(([[k,h]])=>k===m[0]&&(0,D.$en)(h.value,m[1].value));S||s.push(S=[m,[]]),S[1].push(d)}}const a=await this.h(i,{resource:r},l,c);for(const d of a??[])s.push([d,[]]);s.length&&await Promise.allSettled(s.map(async([[d,p],m])=>this.a.updateValue(d,p.value,{resource:r,overrideIdentifiers:m},n)))}}async h(i,r,c,o){const l=(o??this.a.inspect(i.key,r))[c];if(l===void 0)return;const n=a=>this.a.inspect(a,r)[c],s=await i.migrateFn(l,n);return Array.isArray(s)?s:[[i.key,s]]}};e.$tH=v,e.$tH=v=Ke([Ve(0,R.$pi),Ve(1,M.$5h)],v);let g=class extends $.$Rc{constructor(i){super(),(async()=>{if(!P.$i&&(await i.getEnvironment())?.os!==1)return;A.$mn.as(F.$rn.Configuration).registerConfiguration({...e.$rH,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,y.localize)(3,null)},default:[],markdownDescription:(0,y.localize)(4,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,y.localize)(5,null),scope:2}}})})()}};e.$uH=g,e.$uH=g=Ke([Ve(0,f.$zm)],g)}),define(Ae[280],Re([1,0,33,13,20,25,178,279,54,4,30]),function(we,e,y,F,A,M,R,$,E,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ybb=e.$Xbb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$Wbb=e.$Vbb=void 0,e.$Vbb=(0,f.$Vh)("editorResolverService"),e.$Wbb="workbench.editorAssociations";const D=P.$mn.as(E.$rn.Configuration),u={...$.$qH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};D.registerConfiguration(u);var b;(function(i){i.builtin="builtin",i.option="option",i.exclusive="exclusive",i.default="default"})(b||(e.RegisteredEditorPriority=b={}));var v;(function(i){i[i.ABORT=1]="ABORT",i[i.NONE=2]="NONE"})(v||(e.ResolvedStatus=v={}));function g(i){switch(i){case b.exclusive:return 5;case b.default:return 4;case b.builtin:return 3;case b.option:default:return 1}}e.$Xbb=g;function t(i,r){if(new Set([F.Schemas.extension,F.Schemas.webviewPanel,F.Schemas.vscodeWorkspaceTrust,F.Schemas.vscodeSettings]).has(r.scheme))return!1;const l=typeof i=="string"&&i.indexOf(A.$fc.sep)>=0?`${r.scheme}:${r.path}`:(0,M.$wg)(r);return y.$Bj(typeof i=="string"?i.toLowerCase():i,l.toLowerCase())}e.$Ybb=t}),define(Ae[281],Re([1,0,46,13,20,21,25,2,4,199,47,217,113]),function(we,e,y,F,A,M,R,$,E,f,P,D,u){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$cK=e.$bK=void 0,e.$bK=(0,E.$Vh)("pathService");let v=b=class{constructor(t,i,r,c){this.d=t,this.e=i,this.f=r,this.g=c,this.a=(async()=>(await this.e.getEnvironment())?.os||M.OS)(),this.b=(async()=>{const o=await this.e.getEnvironment();return this.c=o?.userHome??t})()}hasValidBasename(t,i,r){return typeof i=="string"||typeof i>"u"?this.a.then(c=>this.h(t,c,i)):this.h(t,i,r)}h(t,i,r){return t.scheme===F.Schemas.file||t.scheme===F.Schemas.vscodeRemote?(0,y.$Zf)(r??(0,R.$wg)(t),i===1):!0}get defaultUriScheme(){return b.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(t,i){if(t.remoteAuthority)return F.Schemas.vscodeRemote;const r=(0,f.$$J)(i.getWorkspace());if(r)return r;const c=i.getWorkspace().folders[0];if(c)return c.uri.scheme;const o=i.getWorkspace().configuration;return o?o.scheme:F.Schemas.file}userHome(t){return t?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(t=>t===1?A.$ec:A.$fc)}async fileURI(t){let i="";if(await this.a===1&&(t=t.replace(/\\/g,"/")),t[0]==="/"&&t[1]==="/"){const c=t.indexOf("/",2);c===-1?(i=t.substring(2),t="/"):(i=t.substring(2,c),t=t.substring(c)||"/")}return $.URI.from({scheme:F.Schemas.file,authority:i,path:t,query:"",fragment:""})}};e.$cK=v,e.$cK=v=b=Ke([Ve(1,u.$zm),Ve(2,D.$WJ),Ve(3,P.$5h)],v)}),define(Ae[114],Re([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$RI=e.$QI=void 0;class y{constructor(R,$){this.line=R,this.character=$}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,$){return new y(0,0)}with(R){return new y(0,0)}}e.$QI=y;class F{constructor(R,$,E,f){this.isEmpty=!1,this.isSingleLine=!1,this.start=new y(R,$),this.end=new y(E,f)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new F(0,0,0,0)}with(R){return new F(0,0,0,0)}}e.$RI=F;var A;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(A||(e.TextSearchCompleteMessageType=A={}))}),define(Ae[43],Re([1,0,18,33,26,46,12,4,20,11,114,14]),function(we,e,y,F,A,M,R,$,E,f,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.SearchErrorCode=e.$7I=e.$6I=e.SearchSortOrder=e.ViewMode=e.$5I=e.$4I=e.$3I=e.$2I=e.SearchCompletionExitCode=e.$1I=e.$ZI=e.$YI=e.QueryType=e.SearchProviderType=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return P.TextSearchCompleteMessageType}}),e.$SI="workbench.view.search",e.$TI="workbench.panel.search",e.$UI="workbench.view.search",e.$VI="search-result",e.$WI="search.exclude";const u="\u27EA ",b=" characters skipped \u27EB",v=(u.length+b.length+5)*2;e.$XI=(0,$.$Vh)("searchService");var g;(function(le){le[le.file=0]="file",le[le.text=1]="text"})(g||(e.SearchProviderType=g={}));var t;(function(le){le[le.File=1]="File",le[le.Text=2]="Text"})(t||(e.QueryType=t={}));function i(le){return!!le.preview}e.$YI=i;function r(le){return!!le.resource}e.$ZI=r;function c(le){return!!le.message}e.$1I=c;var o;(function(le){le[le.Normal=0]="Normal",le[le.NewSearchStarted=1]="NewSearchStarted"})(o||(e.SearchCompletionExitCode=o={}));class l{constructor(pe){this.resource=pe,this.results=[]}}e.$2I=l;class n{constructor(pe,re,Pe,se){this.ranges=re,this.webviewIndex=se;const Z=Array.isArray(re)?re:[re];if(Pe&&Pe.matchLines===1&&s(Z)){pe=(0,R.$vf)(pe,Pe.matchLines);let j="",ie=0,ve=0;const ne=Math.floor(Pe.charsPerLine/5),he=[];for(const ce of Z){const ye=Math.max(ce.startColumn-ne,0),_=ce.startColumn+Pe.charsPerLine;if(ye>ve+ne+v){const fe=u+(ye-ve)+b;j+=fe+pe.slice(ye,_),ie+=ye-(ve+fe.length)}else j+=pe.slice(ve,_);he.push(new d(0,ce.startColumn-ie,ce.endColumn-ie)),ve=_}this.preview={text:j,matches:Array.isArray(this.ranges)?he:he[0]}}else{const j=Array.isArray(re)?re[0].startLineNumber:re.startLineNumber;this.preview={text:pe,matches:(0,y.$1b)(re,ie=>new a(ie.startLineNumber-j,ie.startColumn,ie.endLineNumber-j,ie.endColumn))}}}}e.$3I=n;function s(le){const pe=le[0].startLineNumber;for(const re of le)if(re.startLineNumber!==pe||re.endLineNumber!==pe)return!1;return!0}class a{constructor(pe,re,Pe,se){this.startLineNumber=pe,this.startColumn=re,this.endLineNumber=Pe,this.endColumn=se}}e.$4I=a;class d extends a{constructor(pe,re,Pe){super(pe,re,pe,Pe)}}e.$5I=d;var p;(function(le){le.List="list",le.Tree="tree"})(p||(e.ViewMode=p={}));var m;(function(le){le.Default="default",le.FileNames="fileNames",le.Type="type",le.Modified="modified",le.CountDescending="countDescending",le.CountAscending="countAscending"})(m||(e.SearchSortOrder=m={}));function S(le,pe=!0){const re=le&&le.files&&le.files.exclude,Pe=pe&&le&&le.search&&le.search.exclude;if(!re&&!Pe)return;if(!re||!Pe)return re||Pe;let se=Object.create(null);return se=A.$dn(se,A.$an(re)),se=A.$dn(se,A.$an(Pe),!0),se}e.$6I=S;function k(le,pe){return le.excludePattern&&F.$Bj(le.excludePattern,pe)?!1:le.includePattern||le.usingSearchPaths?le.includePattern&&F.$Bj(le.includePattern,pe)?!0:le.usingSearchPaths?!!le.folderQueries&&le.folderQueries.some(re=>{const Pe=re.folder.fsPath;if(M.$2f(pe,Pe)){const se=E.$kc(Pe,pe);return!re.includePattern||!!F.$Bj(re.includePattern,se)}else return!1}):!1:!0}e.$7I=k;var h;(function(le){le[le.unknownEncoding=1]="unknownEncoding",le[le.regexParseError=2]="regexParseError",le[le.globParseError=3]="globParseError",le[le.invalidLiteral=4]="invalidLiteral",le[le.rgProcessError=5]="rgProcessError",le[le.other=6]="other",le[le.canceled=7]="canceled"})(h||(e.SearchErrorCode=h={}));class w extends Error{constructor(pe,re){super(pe),this.code=re}}e.$8I=w;function I(le){const pe=le.message;if((0,f.$3)(le))return new w(pe,h.canceled);try{const re=JSON.parse(pe);return new w(re.message,re.code)}catch{return new w(pe,h.other)}}e.$9I=I;function L(le){const pe={message:le.message,code:le.code};return new Error(JSON.stringify(pe))}e.$0I=L;function V(le){return le.type==="error"?!0:le.type==="success"}e.$$I=V;function Y(le){return le.type==="success"}e.$_I=Y;function U(le){return!!le.path}e.$aJ=U;function N(le,pe){const re=le.searchPath?le.searchPath:le.relativePath;return(0,R.$sf)(re,pe)}e.$bJ=N;class C{constructor(pe){this.path=pe,this.results=[]}addMatch(pe){this.results.push(pe)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$cJ=C;function T(le,pe){const re={...le||{},...pe||{}};return Object.keys(re).filter(Pe=>{const se=re[Pe];return typeof se=="boolean"&&se})}e.$dJ=T;class G{constructor(pe,re){this.c=null,this.a={...pe.excludePattern||{},...re.excludePattern||{}},this.b=F.$Cj(this.a);let Pe=pe.includePattern;re.includePattern&&(Pe?Pe={...Pe,...re.includePattern}:Pe=re.includePattern),Pe&&(this.c=F.$Cj(Pe))}matchesExcludesSync(pe,re,Pe){return!!(this.b&&this.b(pe,re,Pe))}includedInQuerySync(pe,re,Pe){return!(this.b&&this.b(pe,re,Pe)||this.c&&!this.c(pe,re,Pe))}includedInQuery(pe,re,Pe){const se=this.b(pe,re,Pe),Z=()=>this.c?!!this.c(pe,re,Pe):!0;return(0,D.$Kg)(se)?se.then(j=>j?!1:Z()):Z()}hasSiblingExcludeClauses(){return de(this.a)}}e.$eJ=G;function de(le){for(const pe in le)if(typeof le[pe]!="boolean")return!0;return!1}function me(le){if(!le)return;let pe;return re=>(pe||(pe=(le()||Promise.resolve([])).then(Pe=>Pe?ke(Pe):{})),pe.then(Pe=>!!Pe[re]))}e.$fJ=me;function De(le){if(!le)return;let pe;return re=>{if(!pe){const Pe=le();pe=Pe?ke(Pe):{}}return!!pe[re]}}e.$gJ=De;function ke(le){const pe={};for(const re of le)pe[re]=!0;return pe}}),define(Ae[35],Re([1,0,18,14,19,5,6,50,13,121,25,12,2,169,4,15,188,47,42,27,17,8,7,57,43,3,51]),function(we,e,y,F,A,M,R,$,E,f,P,D,u,b,v,g,t,i,r,c,o,l,n,s,a,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7dc=e.$6dc=void 0;function m(Y,U,N){return new P.$og(C=>w(C,N)).isEqual(Y,U)}function S(Y,U,N){return m(Y.uri,U.uri,N)?0:(0,D.$Ye)(Y.uri.toString(),U.uri.toString())}function k(Y,U,N){return Y.index!==U.index?Y.index<U.index?-1:1:m(Y.uri,U.uri,N)?(0,D.$Ye)(Y.name,U.name):(0,D.$Ye)(Y.uri.toString(),U.uri.toString())}function h(Y,U,N,C){const T=Y.slice(0).sort((de,me)=>N(de,me,C)),G=U.slice(0).sort((de,me)=>N(de,me,C));return(0,y.$Db)(T,G,(de,me)=>N(de,me,C))}function w(Y,U){const N=U.getCapabilities(Y.scheme);return!(N&&N&1024)}class I extends i.$ci{static toExtHostWorkspace(U,N,C,T){if(!U)return{workspace:null,added:[],removed:[]};const{id:G,name:de,folders:me,configuration:De,transient:ke,isUntitled:le}=U,pe=[],re=N;N?me.forEach((j,ie)=>{const ve=u.URI.revive(j.uri),ne=I.o(C||N,ve,T);ne?(ne.name=j.name,ne.index=j.index,pe.push(ne)):pe.push({uri:ve,name:j.name,index:ie})}):pe.push(...me.map(({uri:j,name:ie,index:ve})=>({uri:u.URI.revive(j),name:ie,index:ve}))),pe.sort((j,ie)=>j.index<ie.index?-1:1);const Pe=new I(G,de,pe,!!ke,De?u.URI.revive(De):null,!!le,j=>w(j,T)),{added:se,removed:Z}=h(re?re.workspaceFolders:[],Pe.workspaceFolders,S,T);return{workspace:Pe,added:se,removed:Z}}static o(U,N,C){for(let T=0;T<U.folders.length;T++){const G=U.workspaceFolders[T];if(m(G.uri,N,C))return G}}constructor(U,N,C,T,G,de,me){super(U,C.map(De=>new i.$di(De)),T,G,me),this.t=N,this.u=de,this.q=[],this.s=$.$2h.forUris(me),C.forEach(De=>{this.q.push(De),this.s.set(De.uri,De)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(U,N){return N&&this.s.get(U)&&(U=(0,P.$yg)(U)),this.s.findSubstr(U)}resolveWorkspaceFolder(U){return this.s.get(U)}}let L=class{constructor(U,N,C,T,G){this.c=new M.$Rd,this.onDidChangeWorkspace=this.c.event,this.g=new M.$Rd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new M.$Td,this.B=new Map,this.h=T,this.s=C,this.t=G,this.j=new f.$Wl,this.k=new F.$Wg,this.o=U.getProxy(d.$zK.MainThreadWorkspace),this.q=U.getProxy(d.$zK.MainThreadMessageService);const de=N.workspace;this.l=de?new I(de.id,de.name,[],!!de.transient,de.configuration?u.URI.revive(de.configuration):null,!!de.isUntitled,me=>w(me,C)):void 0}$initializeWorkspace(U,N){this.v=N,this.$acceptWorkspaceData(U),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:E.Schemas.untitled,path:(0,P.$wg)((0,P.$yg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(U,N,C,...T){const G=[];if(Array.isArray(T)&&T.forEach(le=>{u.URI.isUri(le.uri)&&!G.some(pe=>m(pe.uri,le.uri,this.s))&&G.push({uri:le.uri,name:le.name||(0,P.$vg)(le.uri)})}),this.n||[N,C].some(le=>typeof le!="number"||le<0)||C===0&&G.length===0)return!1;const de=this.x?this.x.workspaceFolders:[];if(N+C>de.length)return!1;const me=de.slice(0);me.splice(N,C,...G.map(le=>({uri:le.uri,name:le.name||(0,P.$vg)(le.uri),index:void 0})));for(let le=0;le<me.length;le++){const pe=me[le];if(me.some((re,Pe)=>Pe!==le&&m(pe.uri,re.uri,this.s)))return!1}me.forEach((le,pe)=>le.index=pe);const{added:De,removed:ke}=h(de,me,k,this.s);if(De.length===0&&ke.length===0)return!1;if(this.o){const le=U.displayName||U.name;this.o.$updateWorkspaceFolders(le,N,C,G).then(void 0,pe=>{this.n=void 0;const re={source:{identifier:U.identifier,label:U.displayName||U.name}};this.q.$showMessage(t.Severity.Error,(0,b.localize)(0,null,le,pe.toString()),re,[])})}return this.y(me),!0}getWorkspaceFolder(U,N){if(this.x)return this.x.getWorkspaceFolder(U,N)}async getWorkspaceFolder2(U,N){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(U,N)}async resolveWorkspaceFolder(U){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(U)}getPath(){if(!this.x)return;const{folders:U}=this.x;if(U.length!==0)return U[0].uri.fsPath}getRelativePath(U,N){let C,T="";if(typeof U=="string"?(C=u.URI.file(U),T=U):typeof U<"u"&&(C=U,T=U.fsPath),!C)return T;const G=this.getWorkspaceFolder(C,!0);if(!G)return T;typeof N>"u"&&this.x&&(N=this.x.folders.length>1);let de=(0,P.$Bg)(G.uri,C);return N&&G.name&&(de=`${G.name}/${de}`),de}y(U){this.x&&(this.n=I.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:U,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(U){const{workspace:N,added:C,removed:T}=I.toExtHostWorkspace(U,this.l,this.n,this.s);this.l=N||void 0,this.n=void 0,this.c.fire(Object.freeze({added:C,removed:T}))}findFiles(U,N,C,T,G=A.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${T.value}, entryPoint: findFiles`);let de;if(N===null?de=!1:N&&(typeof N=="string"?de=N:de=N.pattern),G&&G.isCancellationRequested)return Promise.resolve([]);const{includePattern:me,folder:De}=V(l.GlobPattern.from(U));return this.o.$startFileSearch(me??null,De??null,de??null,C??null,G).then(ke=>Array.isArray(ke)?ke.map(le=>u.URI.revive(le)):[])}async findTextInFiles(U,N,C,T,G=A.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${T.value}, entryPoint: findTextInFiles`);const de=this.j.getNext(),me=typeof N.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:N.previewOptions,{includePattern:De,folder:ke}=V(l.GlobPattern.from(N.include)),le=typeof N.exclude=="string"?N.exclude:N.exclude?N.exclude.pattern:void 0,pe={ignoreSymlinks:typeof N.followSymlinks=="boolean"?!N.followSymlinks:void 0,disregardIgnoreFiles:typeof N.useIgnoreFiles=="boolean"?!N.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof N.useGlobalIgnoreFiles=="boolean"?!N.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof N.useParentIgnoreFiles=="boolean"?!N.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof N.useDefaultExcludes=="boolean"?!N.useDefaultExcludes:!0,fileEncoding:N.encoding,maxResults:N.maxResults,previewOptions:me,afterContext:N.afterContext,beforeContext:N.beforeContext,includePattern:De,excludePattern:le},re=!1;if(this.u[de]=Pe=>{if(re)return;const se=u.URI.revive(Pe.resource);Pe.results.forEach(Z=>{const j=(0,p.$sh)(Z);(0,a.$YI)(j)?C({uri:se,preview:{text:j.preview.text,matches:(0,y.$1b)(j.preview.matches,ie=>new n.$DK(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))},ranges:(0,y.$1b)(j.ranges,ie=>new n.$DK(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))}):C({uri:se,text:j.text,lineNumber:j.lineNumber})})},G.isCancellationRequested)return{};try{const Pe=await this.o.$startTextSearch(U,ke??null,pe,de,G);return delete this.u[de],Pe||{}}catch(Pe){throw delete this.u[de],Pe}}$handleTextSearchResult(U,N){this.u[N]?.(U)}async save(U){const N=await this.o.$save(U,{saveAs:!1});return u.URI.revive(N)}async saveAs(U){const N=await this.o.$save(U,{saveAs:!0});return u.URI.revive(N)}saveAll(U){return this.o.$saveAll(U)}resolveProxy(U){return this.o.$resolveProxy(U)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(U){return this.o.$requestWorkspaceTrust(U)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(U,N){if(this.w.has(U))throw new Error(`A provider has already been registered for scheme ${U}`);this.w.set(U,N);const C=this.t.transformOutgoingScheme(U),T=this.z++;return this.o.$registerEditSessionIdentityProvider(T,C),(0,R.$Pc)(()=>{this.w.delete(U),this.o.$unregisterEditSessionIdentityProvider(T)})}async $getEditSessionIdentifier(U,N){this.h.info("Getting edit session identifier for workspaceFolder",U);const C=await this.resolveWorkspaceFolder(u.URI.revive(U));if(!C){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",C);const T=this.w.get(C.uri.scheme);if(this.h.info(`Provider for scheme ${C.uri.scheme} is defined: `,!!T),!T)return;const G=await T.provideEditSessionIdentity(C,N);if(this.h.info("Provider returned edit session identifier: ",G),!!G)return G}async $provideEditSessionIdentityMatch(U,N,C,T){this.h.info("Getting edit session identifier for workspaceFolder",U);const G=await this.resolveWorkspaceFolder(u.URI.revive(U));if(!G){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",G);const de=this.w.get(G.uri.scheme);if(this.h.info(`Provider for scheme ${G.uri.scheme} is defined: `,!!de),!de)return;const me=await de.provideEditSessionIdentityMatch?.(N,C,T);if(this.h.info("Provider returned edit session identifier match result: ",me),!!me)return me}getOnWillCreateEditSessionIdentityEvent(U){return(N,C,T)=>{const G=function(me){N.call(C,me)};return G.extension=U,this.A.event(G,void 0,T)}}async $onWillCreateEditSessionIdentity(U,N,C){const T=await this.resolveWorkspaceFolder(u.URI.revive(U));if(T===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:T},N,async(G,de)=>{const me=Date.now();await Promise.resolve(G),Date.now()-me>C&&this.h.warn("SLOW edit session create-participant",de.extension.identifier)}),N.isCancellationRequested}registerCanonicalUriProvider(U,N){if(this.B.has(U))throw new Error(`A provider has already been registered for scheme ${U}`);this.B.set(U,N);const C=this.t.transformOutgoingScheme(U),T=this.z++;return this.o.$registerCanonicalUriProvider(T,C),(0,R.$Pc)(()=>{this.B.delete(U),this.o.$unregisterCanonicalUriProvider(T)})}async provideCanonicalUri(U,N,C){const T=this.B.get(U.scheme);if(!T)return;const G=await T.provideCanonicalUri?.(u.URI.revive(U),N,C);if(G)return G}async $provideCanonicalUri(U,N,C){return this.provideCanonicalUri(u.URI.revive(U),{targetScheme:N},C)}};e.$6dc=L,e.$6dc=L=Ke([Ve(0,o.$BM),Ve(1,c.$RM),Ve(2,r.$Ldc),Ve(3,g.$dj),Ve(4,s.$4dc)],L),e.$7dc=(0,v.$Vh)("IExtHostWorkspace");function V(Y){let U,N;return Y&&(typeof Y=="string"?U=Y:(U=Y.pattern,N=u.URI.revive(Y.baseUri))),{includePattern:U,folder:N}}}),define(Ae[36],Re([1,0,26,5,35,3,7,190,54,16,14,4,17,15,2]),function(we,e,y,F,A,M,R,$,E,f,P,D,u,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0dc=e.$9dc=e.$8dc=void 0;function g(s,a){if(a){const d=a.split(".");let p=s;for(let m=0;p&&m<d.length;m++)p=p[d[m]];return p}}function t(s){return s instanceof v.URI}function i(s){return s&&s.uri instanceof v.URI&&s.languageId&&typeof s.languageId=="string"}function r(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function c(s){return s&&s.uri instanceof v.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function o(s){if(t(s))return{resource:s};if(i(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(r(s))return{overrideIdentifier:s.languageId};if(c(s))return{resource:s.uri};if(s===null)return{resource:null}}let l=class{constructor(a,d,p){this.a=a.getProxy(M.$zK.MainThreadConfiguration),this.c=d,this.b=p,this.d=new P.$Wg,this.e=null}getConfigProvider(){return this.d.wait().then(a=>this.e)}$initializeConfiguration(a){this.e=new n(this.a,this.c,a,this.b),this.d.open()}$acceptConfigurationChanged(a,d){this.getConfigProvider().then(p=>p.$acceptConfigurationChanged(a,d))}};e.$8dc=l,e.$8dc=l=Ke([Ve(0,u.$BM),Ve(1,A.$7dc),Ve(2,b.$dj)],l);class n{constructor(a,d,p,m){this.a=new F.$Rd,this.b=a,this.f=m,this.c=d,this.e=$.$Kn.parse(p),this.d=this.k(p.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(a,d){const p={data:this.e.toData(),workspace:this.c.workspace};this.e=$.$Kn.parse(a),this.d=this.k(a.configurationScopes),this.a.fire(this.j(d,p))}getConfiguration(a,d,p){const m=o(d)||{},S=this.g(a?g(this.e.getValue(void 0,m,this.c.workspace),a):this.e.getValue(void 0,m,this.c.workspace));a&&this.h(a,m,p?.identifier);function k(w){if(w==null)return null;if(typeof w=="boolean")return w?2:5;switch(w){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const h={has(w){return typeof g(S,w)<"u"},get:(w,I)=>{this.h(a?`${a}.${w}`:w,m,p?.identifier);let L=g(S,w);if(typeof L>"u")L=I;else{let V;const Y=(U,N)=>{if((0,f.$Ef)(U)){let C;const T=()=>{V=V||(0,y.$an)(S),C=C||g(V,N)};return new Proxy(U,{get:(G,de)=>{if(typeof de=="string"&&de.toLowerCase()==="tojson")return T(),()=>C;if(V)return C=C||g(V,N),C[de];const me=G[de];return typeof de=="string"?Y(me,`${N}.${de}`):me},set:(G,de,me)=>(T(),C&&(C[de]=me),!0),deleteProperty:(G,de)=>(T(),C&&delete C[de],!0),defineProperty:(G,de,me)=>(T(),C&&Object.defineProperty(C,de,me),!0)})}return Array.isArray(U)?(0,y.$an)(U):U};L=Y(L,w)}return L},update:(w,I,L,V)=>{w=a?`${a}.${w}`:w;const Y=k(L);return I!==void 0?this.b.$updateConfigurationOption(Y,w,I,m,V):this.b.$removeConfigurationOption(Y,w,m,V)},inspect:w=>{w=a?`${a}.${w}`:w;const I=this.e.inspect(w,m,this.c.workspace);if(I)return{key:w,defaultValue:(0,y.$an)(I.policy?.value??I.default?.value),globalValue:(0,y.$an)(I.user?.value??I.application?.value),workspaceValue:(0,y.$an)(I.workspace?.value),workspaceFolderValue:(0,y.$an)(I.workspaceFolder?.value),defaultLanguageValue:(0,y.$an)(I.default?.override),globalLanguageValue:(0,y.$an)(I.user?.override??I.application?.override),workspaceLanguageValue:(0,y.$an)(I.workspace?.override),workspaceFolderLanguageValue:(0,y.$an)(I.workspaceFolder?.override),languageIds:(0,y.$an)(I.overrideIdentifiers)}}};return typeof S=="object"&&(0,y.$dn)(h,S,!1),Object.freeze(h)}g(a){const d=p=>(0,f.$Ef)(p)?new Proxy(p,{get:(m,S)=>d(m[S]),set:(m,S,k)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(S)}' of object`)},deleteProperty:(m,S)=>{throw new Error(`TypeError: Cannot delete read only property '${String(S)}' of object`)},defineProperty:(m,S)=>{throw new Error(`TypeError: Cannot define property '${String(S)}' for a readonly object`)},setPrototypeOf:m=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):p;return d(a)}h(a,d,p){const m=E.$Bn.test(a)?4:this.d.get(a),S=p?`[${p.value}] `:"";if(m===4){typeof d?.resource>"u"&&this.f.warn(`${S}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(m===3){d?.resource&&this.f.warn(`${S}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(a,d){const p=new $.$Mn(a,d,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(m,S)=>p.affectsConfiguration(m,o(S))})}k(a){return a.reduce((d,p)=>(d.set(p[0],p[1]),d),new Map)}}e.$9dc=n,e.$0dc=(0,D.$Vh)("IExtHostConfiguration")}),define(Ae[115],Re([1,0,2,14,5,3,7,35,61,36,19,64,17,27,4,13,21,15,81,229,11]),function(we,e,y,F,A,M,R,$,E,f,P,D,u,b,v,g,t,i,r,c,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Afc=e.$zfc=e.$yfc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var l;(function(Y){function U(C){if(C!=null)return C}Y.from=U;function N(C){if(C!=null)return C}Y.to=N})(l||(l={}));var n;(function(Y){function U(C){if(C!=null)return C}Y.from=U;function N(C){if(C!=null)return C}Y.to=N})(n||(n={}));var s;(function(Y){function U(C){if(C!=null)return C}Y.from=U;function N(C){if(C!=null)return C}Y.to=N})(s||(s={}));var a;(function(Y){function U(T){if(T){const G=T;return G&&!!G.process}else return!1}Y.is=U;function N(T){if(T==null)return;const G={process:T.process,args:T.args};return T.options&&(G.options=s.from(T.options)),G}Y.from=N;function C(T){if(T!=null)return new R.$jL(T.process,T.args,T.options)}Y.to=C})(a||(a={}));var d;(function(Y){function U(C){if(C!=null)return C}Y.from=U;function N(C){if(C!=null)return C}Y.to=N})(d||(d={}));var p;(function(Y){function U(T){if(T){const G=T;return G&&(!!G.commandLine||!!G.command)}else return!1}Y.is=U;function N(T){if(T==null)return;const G={};return T.commandLine!==void 0?G.commandLine=T.commandLine:(G.command=T.command,G.args=T.args),T.options&&(G.options=d.from(T.options)),G}Y.from=N;function C(T){if(!(T==null||T.command===void 0&&T.commandLine===void 0))return T.commandLine?new R.$kL(T.commandLine,T.options):new R.$kL(T.command,T.args?T.args:[],T.options)}Y.to=C})(p||(p={}));var m;(function(Y){function U(T){if(T){const G=T;return G&&G.customExecution==="customExecution"}else return!1}Y.is=U;function N(T){return{customExecution:"customExecution"}}Y.from=N;function C(T,G){return G.get(T)}Y.to=C})(m||(e.CustomExecutionDTO=m={}));var S;(function(Y){function U(N,C){let T;return N.scope!==void 0&&typeof N.scope!="number"?T=N.scope.uri:N.scope!==void 0&&typeof N.scope=="number"&&(N.scope===R.TaskScope.Workspace&&C&&C.workspaceFile?T=C.workspaceFile:T=c.$9F),{id:N._id,workspaceFolder:T}}Y.from=U})(S||(e.TaskHandleDTO=S={}));var k;(function(Y){function U(N){if(N!=null)return{_id:N.id,isDefault:N.isDefault}}Y.from=U})(k||(k={}));var h;(function(Y){function U(T,G){if(T==null)return[];const de=[];for(const me of T){const De=N(me,G);De&&de.push(De)}return de}Y.fromMany=U;function N(T,G){if(T==null)return;let de;T.execution instanceof R.$jL?de=a.from(T.execution):T.execution instanceof R.$kL?de=p.from(T.execution):T.execution&&T.execution instanceof R.$lL&&(de=m.from(T.execution));const me=l.from(T.definition);let De;return T.scope?typeof T.scope=="number"?De=T.scope:De=T.scope.uri:De=R.TaskScope.Workspace,!me||!De?void 0:{_id:T._id,definition:me,name:T.name,source:{extensionId:G.identifier.value,label:T.source,scope:De},execution:de,isBackground:T.isBackground,group:k.from(T.group),presentationOptions:n.from(T.presentationOptions),problemMatchers:T.problemMatchers,hasDefinedMatchers:T.hasDefinedMatchers,runOptions:T.runOptions?T.runOptions:{reevaluateOnRerun:!0},detail:T.detail}}Y.from=N;async function C(T,G,de){if(T==null)return;let me;a.is(T.execution)?me=a.to(T.execution):p.is(T.execution)?me=p.to(T.execution):m.is(T.execution)&&(me=m.to(T._id,de));const De=l.to(T.definition);let ke;if(T.source&&(T.source.scope!==void 0?typeof T.source.scope=="number"?ke=T.source.scope:ke=await G.resolveWorkspaceFolder(y.URI.revive(T.source.scope)):ke=R.TaskScope.Workspace),!De||!ke)return;const le=new R.$mL(De,ke,T.name,T.source.label,me,T.problemMatchers);return T.isBackground!==void 0&&(le.isBackground=T.isBackground),T.group!==void 0&&(le.group=R.$iL.from(T.group._id),le.group&&T.group.isDefault&&(le.group=new R.$iL(le.group.id,le.group.label),T.group.isDefault===!0&&(le.group.isDefault=T.group.isDefault))),T.presentationOptions&&(le.presentationOptions=n.to(T.presentationOptions)),T._id&&(le._id=T._id),T.detail&&(le.detail=T.detail),le}Y.to=C})(h||(e.TaskDTO=h={}));var w;(function(Y){function U(C){return C}Y.from=U;function N(C){if(C)return Object.assign(Object.create(null),C)}Y.to=N})(w||(w={}));class I{#e;constructor(U,N,C){this._id=N,this.a=C,this.#e=U}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}let L=class{constructor(U,N,C,T,G,de,me,De){this.q=new A.$Rd,this.r=new A.$Rd,this.s=new A.$Rd,this.t=new A.$Rd,this.a=U.getProxy(M.$zK.MainThreadTask),this.b=C,this.c=T,this.d=G,this.e=de,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=me,this.g=De,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(U,N,C){if(!C)return new R.$BK(()=>{});const T=this.w();return this.j.set(T,{type:N,provider:C,extension:U}),this.a.$registerTaskProvider(T,N),new R.$BK(()=>{this.j.delete(T),this.a.$unregisterTaskProvider(T)})}registerTaskSystem(U,N){this.a.$registerTaskSystem(U,N)}fetchTasks(U){return this.a.$fetchTasks(w.from(U)).then(async N=>{const C=[];for(const T of N){const G=await h.to(T,this.b,this.m);G&&C.push(G)}return C})}get taskExecutions(){const U=[];return this.k.forEach(N=>U.push(N)),U}terminateTask(U){if(!(U instanceof I))throw new Error("No valid task execution provided");return this.a.$terminateTask(U._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(U,N,C){const T=this.m.get(U.id);T&&(this.o.set(U.id,T),this.e.attachPtyToTerminal(N,await T.callback(C))),this.p=U.id,this.q.fire({execution:await this.y(U)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(U){const N=await this.y(U);this.l.delete(U.id),this.k.delete(U.id),this.A(U),this.r.fire({execution:N})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(U){const N=await this.y(U.id);this.s.fire({execution:N,processId:U.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(U){const N=await this.y(U.id);this.t.fire({execution:N,exitCode:U.exitCode})}$provideTasks(U,N){const C=this.j.get(U);if(!C)return Promise.reject(new Error("no handler found"));const T=[],G=(0,F.$Qg)(()=>C.provider.provideTasks(P.CancellationToken.None)).then(de=>this.u(N,T,C,de));return new Promise(de=>{G.then(me=>{Promise.all(T).then(()=>{de(me)})})})}async $resolveTask(U,N){const C=this.j.get(U);if(!C)return Promise.reject(new Error("no handler found"));if(N.definition.type!==C.type)throw new Error(`Unexpected: Task of type [${N.definition.type}] cannot be resolved by provider of type [${C.type}].`);const T=await h.to(N,this.b,this.m);if(!T)throw new Error("Unexpected: Task cannot be resolved.");const G=await C.provider.resolveTask(T,P.CancellationToken.None);if(!G)return;this.z(G,C);const de=h.from(G,C.extension);if(!de)throw new Error("Unexpected: Task cannot be resolved.");if(G.definition!==T.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return m.is(de.execution)&&await this.x(de,G,!0),await this.v(de)}w(){return this.h++}async x(U,N,C){const T=await this.a.$createTaskId(U);!C&&!this.m.has(T)&&(this.n.add(T),this.o.set(T,N.execution)),this.m.set(T,N.execution)}async y(U,N){if(typeof U=="string"){const G=this.l.get(U);if(!G)throw new o.$ab("Unexpected: The specified task is missing an execution");return G}const C=this.l.get(U.id);if(C)return C;const T=new Promise((G,de)=>{function me(De,ke,le){le?G(new I(De,ke.id,le)):de("Unexpected: Task does not exist.")}N?me(this,U,N):h.to(U.task,this.b,this.m).then(De=>me(this,U,De))});return this.l.set(U.id,T),T.then(G=>(this.k.set(U.id,G),G),G=>Promise.reject(G))}z(U,N){U._deprecated&&this.g.report("Task.constructor",N.extension,"Use the Task constructor that takes a `scope` instead.")}A(U){this.o.get(U.id)&&this.o.delete(U.id),this.n.has(U.id)&&this.p!==U.id&&(this.m.delete(U.id),this.n.delete(U.id));const C=this.n.values();let T=C.next();for(;!T.done;)!this.o.has(T.value)&&this.p!==T.value&&(this.m.delete(T.value),this.n.delete(T.value)),T=C.next()}};e.$yfc=L,e.$yfc=L=Ke([Ve(0,u.$BM),Ve(1,b.$RM),Ve(2,$.$7dc),Ve(3,E.$MM),Ve(4,f.$0dc),Ve(5,D.$vec),Ve(6,i.$dj),Ve(7,r.$Odc)],L);let V=class extends L{constructor(U,N,C,T,G,de,me,De){super(U,N,C,T,G,de,me,De),this.registerTaskSystem(g.Schemas.vscodeRemote,{scheme:g.Schemas.vscodeRemote,authority:"",platform:t.$h(0)})}async executeTask(U,N){if(!N.execution)throw new Error("Tasks to execute must include an execution");const C=h.from(N,U);if(C===void 0)throw new Error("Task is not valid");if(m.is(C.execution))await this.x(C,N,!1);else throw new o.$$;const T=await this.y(await this.a.$getTaskExecution(C),N);return this.a.$executeTask(C).catch(G=>{throw new Error(G)}),T}u(U,N,C,T){const G=[];if(T)for(const de of T){if(this.z(de,C),!de.definition||!U[de.definition.type]){const De=de.source?de.source:"No task source";this.f.warn(`The task [${De}, ${de.name}] uses an undefined task type. The task will be ignored in the future.`)}const me=h.from(de,C.extension);me&&m.is(me.execution)?(G.push(me),N.push(this.x(me,de,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:G,extension:C.extension}}async v(U){if(m.is(U.execution))return U;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(U,N){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(U,N,C){}};e.$zfc=V,e.$zfc=V=Ke([Ve(0,u.$BM),Ve(1,b.$RM),Ve(2,$.$7dc),Ve(3,E.$MM),Ve(4,f.$0dc),Ve(5,D.$vec),Ve(6,i.$dj),Ve(7,r.$Odc)],V),e.$Afc=(0,v.$Vh)("IExtHostTask")}),define(Ae[282],Re([1,0,43,29]),function(we,e,y,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oJ=e.$nJ=e.$mJ=void 0;function A(R){return"cellResults"in R}e.$mJ=A,e.$nJ="rawCell#";function M(R,$){let E=-1;const f=[];let P=[];return R.forEach(u=>{u.range.startLineNumber!==E&&P.length>0&&(f.push([...P]),P=[]),P.push(u),E=u.range.endLineNumber}),P.length>0&&f.push([...P]),f.map(u=>{const b=[],v=u[0].range.startLineNumber,g=u[u.length-1].range.endLineNumber;for(let t=v;t<=g;t++)b.push($.getLineContent(t));return new y.$3I(b.join(`
`)+`
`,u.map(t=>new F.$zs(t.range.startLineNumber-1,t.range.startColumn-1,t.range.endLineNumber-1,t.range.endColumn-1)))})}e.$oJ=M}),define(Ae[283],Re([1,0,162,24,5,6,28,12,16,2,41,75,3,32,8,7,49,221,107,11,26,13,212,282,280]),function(we,e,y,F,A,M,R,$,E,f,P,D,u,b,v,g,t,i,r,c,o,l,n,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$afc=void 0;class d{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(m=>m.apiEditor)}constructor(m,S,k,h,w,I){this.q=k,this.r=h,this.s=w,this.t=I,this.f=new Map,this.g=new R.$zc,this.h=new Map,this.j=new A.$Rd({onListenerError:c.$1}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new A.$Rd({onListenerError:c.$1}),this.onDidOpenNotebookDocument=this.m.event,this.n=new A.$Rd({onListenerError:c.$1}),this.onDidCloseNotebookDocument=this.n.event,this.o=new A.$Rd({onListenerError:c.$1}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new D.$Hdc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=m.getProxy(u.$zK.MainThreadNotebook),this.c=m.getProxy(u.$zK.MainThreadNotebookDocuments),this.d=m.getProxy(u.$zK.MainThreadNotebookEditors),this.i=S.converter,S.registerArgumentProcessor({processArgument:L=>{if(L&&L.$mid===13){const V=L.notebookEditor?.notebookUri,Y=L.cell.handle,N=this.g.get(V)?.getCell(Y);if(N)return N.apiCell}if(L&&L.$mid===14){const V=L.uri,Y=this.g.get(V);if(Y)return Y.apiNotebook}return L}}),d.B(S)}getEditorById(m){const S=this.h.get(m);if(!S)throw new Error(`unknown text editor: ${m}. known editors: ${[...this.h.keys()]} `);return S}getIdByEditor(m){for(const[S,k]of this.h)if(k.apiEditor===m)return S}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(m,S){const k=this.g.get(m);if(!k&&!S)throw new Error(`NO notebook document for '${m}'`);return k}static u(m,S){if(!S)return;const k=S.filenamePattern.map(h=>v.NotebookExclusiveDocumentPattern.from(h)).filter(h=>h!==void 0);if(S.filenamePattern&&!k){console.warn(`Notebook content provider view options file name pattern is invalid ${S.filenamePattern}`);return}return{extension:m.identifier,providerDisplayName:m.displayName||m.name,displayName:S.displayName,filenamePattern:k,exclusive:S.exclusive||!1}}registerNotebookCellStatusBarItemProvider(m,S,k){const h=d.a++,w=typeof k.onDidChangeCellStatusBarItems=="function"?d.a++:void 0;this.f.set(h,k),this.b.$registerNotebookCellStatusBarItemProvider(h,w,S);let I;return w!==void 0&&(I=k.onDidChangeCellStatusBarItems(L=>this.b.$emitCellStatusBarEvent(w))),new g.$BK(()=>{this.f.delete(h),this.b.$unregisterNotebookCellStatusBarItemProvider(h,w),I?.dispose()})}async createNotebookDocument(m){const S=await this.c.$tryCreateNotebook({viewType:m.viewType,content:m.content&&v.NotebookData.from(m.content)});return f.URI.revive(S)}async openNotebookDocument(m){const S=this.g.get(m);if(S)return S.apiNotebook;const k=await this.c.$tryOpenNotebook(m),h=this.g.get(f.URI.revive(k));return(0,E.$Nf)(h?.apiNotebook)}async showNotebookDocument(m,S){f.URI.isUri(m)&&(m=await this.openNotebookDocument(m));let k;typeof S=="object"?k={position:v.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus,selections:S.selections&&S.selections.map(v.NotebookRange.from),pinned:typeof S.preview=="boolean"?!S.preview:void 0}:k={preserveFocus:!1};const h=await this.d.$tryShowNotebookDocument(m.uri,m.notebookType,k),w=h&&this.h.get(h)?.apiEditor;if(w)return w;throw h?new Error(`Could NOT open editor for "${m.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${m.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(m,S,k,h){const w=this.f.get(m),I=f.URI.revive(S),L=this.g.get(I);if(!L||!w)return;const V=L.getCellFromIndex(k);if(!V)return;const Y=await w.provideCellStatusBarItems(V.apiCell,h);if(!Y)return;const U=new M.$Qc,N=this.p.add([U]),T=(Array.isArray(Y)?Y:[Y]).map(G=>v.NotebookStatusBarItem.from(G,this.i,U));return{cacheId:N,items:T}}$releaseNotebookCellStatusBarItems(m){this.p.delete(m)}registerNotebookSerializer(m,S,k,h,w){if((0,$.$Fe)(S))throw new Error("viewType cannot be empty or just whitespace");const I=this.w++;return this.x.set(I,{viewType:S,serializer:k,options:h}),this.b.$registerNotebookSerializer(I,{id:m.identifier,location:m.extensionLocation},S,v.NotebookDocumentContentOptions.from(h),d.u(m,w)),(0,M.$Pc)(()=>{this.b.$unregisterNotebookSerializer(I)})}async $dataToNotebook(m,S,k){const h=this.x.get(m);if(!h)throw new Error("NO serializer found");const w=await h.serializer.deserializeNotebook(S.buffer,k);return new t.$wv(v.NotebookData.from(w))}async $notebookToData(m,S,k){const h=this.x.get(m);if(!h)throw new Error("NO serializer found");const w=await h.serializer.serializeNotebook(v.NotebookData.to(S.value),k);return F.$fe.wrap(w)}async $saveNotebook(m,S,k,h,w){const I=f.URI.revive(S),L=this.x.get(m);if(!L)throw new Error("NO serializer found");const V=this.g.get(I);if(!V)throw new Error("Document NOT found");if(V.versionId!==k)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(I.scheme))throw new P.$zk((0,y.localize)(0,null,this.z(I)),6);await this.y(I,h);const Y={metadata:(0,o.$in)(V.apiNotebook.metadata,G=>!(L.options?.transientDocumentMetadata??{})[G]),cells:[]};for(const G of V.apiNotebook.getCells()){const de=new g.$ZL(G.kind,G.document.getText(),G.document.languageId,G.mime,L.options?.transientOutputs?[]:[...G.outputs],G.metadata,G.executionSummary);de.metadata=(0,o.$in)(G.metadata,me=>!(L.options?.transientCellMetadata??{})[me]),Y.cells.push(de)}const U=await L.serializer.serializeNotebook(Y,w);await this.s.value.writeFile(I,U);const N=this.s.getFileSystemProviderExtUri(I.scheme),C=await this.s.value.stat(I);return{name:N.basename(I),isFile:(C.type&P.FileType.File)!==0,isDirectory:(C.type&P.FileType.Directory)!==0,isSymbolicLink:(C.type&P.FileType.SymbolicLink)!==0,mtime:C.mtime,ctime:C.ctime,size:C.size,readonly:!!((C.permissions??0)&P.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(I.scheme),locked:!!((C.permissions??0)&P.FilePermission.Locked),etag:P.$Kk({mtime:C.mtime,size:C.size}),children:void 0}}async $searchInNotebooks(m,S,k,h,w){const I=this.x.get(m)?.serializer;if(!I)return{limitHit:!1,results:[]};const L=new R.$Ac;await(async(C,T,G)=>{await Promise.all(C.map(async de=>await Promise.all(de.filenamePatterns.map(me=>{const De={...G,type:1,filePattern:me};return this.t.doInternalFileSearchWithCustomCallback(De,T,ke=>{ke.forEach(le=>{L.has(le)||h.some(re=>de.isFromSettings&&!re.isFromSettings?!1:re.filenamePatterns.some(Pe=>(0,a.$Ybb)(Pe,le)))||L.add(le)})})}))))})(k,w,S);const Y=new R.$zc;let U=!1;const N=Array.from(L).map(async C=>{const T=[];try{if(w.isCancellationRequested)return;if(S.maxResults&&[...Y.values()].reduce((De,ke)=>De+ke.cellResults.length,0)>S.maxResults){U=!0;return}const G=[],de=this.g.get(C);if(de)de.apiNotebook.getCells().forEach(ke=>G.push({input:ke.document.getText(),outputs:ke.outputs.flatMap(le=>le.items.map(pe=>pe.data.toString()))}));else{const De=await this.s.value.readFile(C),ke=F.$fe.fromString(De.toString()),le=await I.deserializeNotebook(ke.buffer,w);if(w.isCancellationRequested)return;v.NotebookData.from(le).cells.forEach(re=>G.push({input:re.source,outputs:re.outputs.flatMap(Pe=>Pe.items.map(se=>se.valueBytes.toString()))}))}if(w.isCancellationRequested)return;G.forEach((De,ke)=>{const le=S.contentPattern.pattern,pe=new n.$VOb(De.input,void 0,De.outputs),re=pe.findInInputs(le),Pe=pe.findInOutputs(le),se=Pe.flatMap(Z=>(0,s.$oJ)(Z.matches,Z.textBuffer)).map((Z,j)=>(Z.webviewIndex=j,Z));if(re.length>0||Pe.length>0){const Z={index:ke,contentResults:(0,s.$oJ)(re,pe.inputTextBuffer),webviewResults:se};T.push(Z)}});const me={resource:C,cellResults:T};Y.set(C,me);return}catch{return}});return await Promise.all(N),{limitHit:U,results:[...Y.values()]}}async y(m,S){const k=await this.s.value.stat(m);if(typeof S?.mtime=="number"&&typeof S.etag=="string"&&S.etag!==P.$Jk&&typeof k.mtime=="number"&&typeof k.size=="number"&&S.mtime<k.mtime&&S.etag!==P.$Kk({mtime:S.mtime,size:k.size}))throw new P.$zk((0,y.localize)(1,null),3,S)}z(m){return m.scheme===l.Schemas.file?m.fsPath:m.toString()}A(m,S,k){if(this.h.has(S))throw new Error(`editor with id ALREADY EXSIST: ${S}`);const h=new r.$4ec(S,this.d,m,k.visibleRanges.map(v.NotebookRange.to),k.selections.map(v.NotebookRange.to),typeof k.viewColumn=="number"?v.ViewColumn.to(k.viewColumn):void 0);this.h.set(S,h)}$acceptDocumentAndEditorsDelta(m){if(m.value.removedDocuments)for(const k of m.value.removedDocuments){const h=f.URI.revive(k),w=this.g.get(h);w&&(w.dispose(),this.g.delete(h),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:w.apiNotebook.getCells().map(I=>I.document.uri)}),this.n.fire(w.apiNotebook));for(const I of this.h.values())I.notebookData.uri.toString()===h.toString()&&this.h.delete(I.id)}if(m.value.addedDocuments){const k=[];for(const h of m.value.addedDocuments){const w=f.URI.revive(h.uri);if(this.g.has(w))throw new Error(`adding EXISTING notebook ${w} `);const I=new i.$3ec(this.c,this.q,this.r,w,h);k.push(...h.cells.map(L=>i.$2ec.asModelAddData(I.apiNotebook,L))),this.g.get(w)?.dispose(),this.g.set(w,I),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:k}),this.m.fire(I.apiNotebook)}}if(m.value.addedEditors)for(const k of m.value.addedEditors){if(this.h.has(k.id))return;const h=f.URI.revive(k.documentUri),w=this.g.get(h);w&&this.A(w,k.id,k)}const S=[];if(m.value.removedEditors)for(const k of m.value.removedEditors){const h=this.h.get(k);h&&(this.h.delete(k),this.k?.id===h.id&&(this.k=void 0),S.push(h))}if(m.value.visibleEditors){this.l=m.value.visibleEditors.map(h=>this.h.get(h)).filter(h=>!!h);const k=new Set;this.l.forEach(h=>k.add(h.id));for(const h of this.h.values()){const w=k.has(h.id);h._acceptVisibility(w)}this.l=[...this.h.values()].map(h=>h).filter(h=>h.visible),this.o.fire(this.visibleNotebookEditors)}m.value.newActiveEditor===null?this.k=void 0:m.value.newActiveEditor&&(this.h.get(m.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${m.value.newActiveEditor}`),this.k=this.h.get(m.value.newActiveEditor)),m.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(m){const S=b.$ZM.String.with("notebookType","A notebook type"),k=new b.$2M("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[S,new b.$ZM("data","Bytes to convert to data",w=>w instanceof Uint8Array,w=>F.$fe.wrap(w))],new b.$1M("Notebook Data",w=>v.NotebookData.to(w.value))),h=new b.$2M("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[S,new b.$ZM("NotebookData","Notebook data to convert to bytes",w=>!0,w=>new t.$wv(v.NotebookData.from(w)))],new b.$1M("Bytes",w=>w.buffer));m.registerApiCommand(k),m.registerApiCommand(h)}}e.$afc=d}),define(Ae[284],Re([1,0,20,19,39,33,25,60,43]),function(we,e,y,F,A,M,R,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ec=void 0;class f{constructor(u,b,v){this.k=u,this.l=b,this.o=v,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&M.$Cj(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&M.$Cj(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const b=this.k.folderQueries||[];return new Promise((v,g)=>{const t=i=>{this.f++,u(i)};if(this.g)return v({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(i=>{const r=i.toString(),c=y.$mc(r);this.j&&this.j(r,c)||this.v(t,{base:i,basename:c})}),Promise.all(b.map(i=>this.p(i,t))).then(i=>{v({limitHit:this.e,stats:i[0]||void 0})},i=>{g(new Error((0,A.$Gi)(i)))})})}async p(u,b){const v=new F.$2d,g=this.q(u),t=this.r(),i=new E.$eJ(this.k,u),r=!i.hasSiblingExcludeClauses();let c;try{this.h.add(v),c=$.$Nd.create();const o=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},g,v.token),l=c.elapsed(),n=$.$Nd.create();return this.g&&!this.e||(o&&o.forEach(s=>{const a=y.$fc.relative(u.folder.path,s.path);if(r){const d=y.$mc(s.path);this.v(b,{base:u.folder,relativePath:a,basename:d});return}this.s(t,u.folder,a,b)}),this.g&&!this.e)?null:(this.u(t,i,b),{providerTime:l,postProcessTime:n.elapsed()})}finally{v.dispose(),this.h.delete(v)}}q(u){const b=(0,E.$dJ)(this.k.includePattern,u.includePattern),v=(0,E.$dJ)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:v,includes:b,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},b,v,g){if(v===this.a){const i=y.$mc(this.a);this.v(g,{base:b,relativePath:this.a,basename:i})}function t(i){const r=y.$mc(i),c=y.$lc(i);let o=u[c];o||(o=u[c]=[],t(c)),o.push({base:b,relativePath:i,basename:r})}t(v)}u({rootEntries:u,pathToEntries:b},v,g){const t=this,i=this.a;function r(c){const o=(0,E.$gJ)(()=>c.map(l=>l.basename));for(let l=0,n=c.length;l<n;l++){const s=c[l],{relativePath:a,basename:d}=s;if(v.matchesExcludesSync(a,d,i!==d?o:void 0))continue;const p=b[a];if(p)r(p);else{if(a===i)continue;t.v(g,s)}if(t.e)break}}r(u)}v(u,b){(!this.b||b.relativePath&&this.b(b.relativePath,b.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(b))}}class P{constructor(){this.b=new Map}static{this.a=512}fileSearch(u,b,v,g){const t=this.c(u.cacheKey),i=new f(u,b,t&&t.token);let r=0;const c=o=>{r+=o.length,v(o.map(l=>this.d(l)))};return this.e(i,P.a,c,g).then(o=>({limitHit:o.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:r,detailStats:o.stats}}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new F.$2d),this.b.get(u)}d(u){return u.relativePath?{resource:R.$zg(u.base,u.relativePath)}:{resource:u.base}}e(u,b,v,g){const t=g.onCancellationRequested(()=>{u.cancel()}),i=c=>{c&&(r.push(c),b>0&&r.length>=b&&(v(r),r=[]))};let r=[];return u.search(i).then(c=>(r.length&&v(r),t.dispose(),c),c=>(r.length&&v(r),t.dispose(),Promise.reject(c)))}}e.$5ec=P}),define(Ae[285],Re([1,0,18,246,33,94,28,13,20,25,12,16,2,93,180,40,15,47,105,281,43]),function(we,e,y,F,A,M,R,$,E,f,P,D,u,b,v,g,t,i,r,c,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eK=e.$dK=void 0;let l=class{constructor(w,I,L,V,Y){this.a=w,this.b=I,this.c=L,this.d=V,this.e=Y}text(w,I,L={}){w=this.f(w,L);const V=this.a.getValue(),Y=I&&I.some(N=>!this.a.getValue({resource:N}).search.useRipgrep);return{...this.h(I?.map(i.$ei),L),type:2,contentPattern:w,previewOptions:L.previewOptions,maxFileSize:L.maxFileSize,usePCRE2:V.search.usePCRE2||Y||!1,beforeContext:L.beforeContext,afterContext:L.afterContext,userDisabledExcludesAndIgnoreFiles:L.disregardExcludeSettings&&L.disregardIgnoreFiles}}f(w,I){const L=this.a.getValue();w.isRegExp&&(w.pattern=w.pattern.replace(/\r?\n/g,"\\n"));const V={...w,wordSeparators:L.editor.wordSeparators};return this.j(w,I)&&(V.isCaseSensitive=!0),this.k(w)&&(V.isMultiline=!0),I.notebookSearchConfig?.includeMarkupInput&&(V.notebookInfo||(V.notebookInfo={}),V.notebookInfo.isInNotebookMarkdownInput=I.notebookSearchConfig.includeMarkupInput),I.notebookSearchConfig?.includeMarkupPreview&&(V.notebookInfo||(V.notebookInfo={}),V.notebookInfo.isInNotebookMarkdownPreview=I.notebookSearchConfig.includeMarkupPreview),I.notebookSearchConfig?.includeCodeInput&&(V.notebookInfo||(V.notebookInfo={}),V.notebookInfo.isInNotebookCellInput=I.notebookSearchConfig.includeCodeInput),I.notebookSearchConfig?.includeOutput&&(V.notebookInfo||(V.notebookInfo={}),V.notebookInfo.isInNotebookCellOutput=I.notebookSearchConfig.includeOutput),V}file(w,I={}){return{...this.h(w,I),type:1,filePattern:I.filePattern?I.filePattern.trim():I.filePattern,exists:I.exists,sortByScore:I.sortByScore,cacheKey:I.cacheKey}}g(w,I){return w?(w=Array.isArray(w)?w.map(p):p(w),I?this.parseSearchPaths(w):{pattern:s(...Array.isArray(w)?w:[w])}):{}}h(w=[],I={}){const L=this.g(I.includePattern,I.expandPatterns),V=this.g(I.excludePattern,I.expandPatterns),Y=w.length>1,U=(L.searchPaths&&L.searchPaths.length?L.searchPaths.map(T=>this.q(T,I,V)):w.map(T=>this.r(T,I,V,Y))).filter(T=>!!T),N={_reason:I._reason,folderQueries:U,usingSearchPaths:!!(L.searchPaths&&L.searchPaths.length),extraFileResources:I.extraFileResources,excludePattern:V.pattern,includePattern:L.pattern,onlyOpenEditors:I.onlyOpenEditors,maxResults:I.maxResults};if(I.onlyOpenEditors){const T=y.$Gb(y.$Qb(this.c.groups.map(me=>me.editors.map(De=>De.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(T));const G=T.filter(me=>(0,o.$7I)(N,me.fsPath)),de=this.i(G);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(de)),{...N,...de}}const C=I.extraFileResources&&I.extraFileResources.filter(T=>(0,o.$7I)(N,T.fsPath));return N.extraFileResources=C&&C.length?C:void 0,N}i(w){const I=[],L=new R.$zc,V={};let Y=!1;return w.forEach(U=>{if(U.scheme===$.Schemas.walkThrough)return;if((0,f.$Dg)(U)){const C=this.b.getWorkspaceFolder(U)?.uri??U.with({path:E.$lc(U.fsPath)});let T=L.get(C);T||(Y=!0,T={folder:C,includePattern:{}},I.push(T),L.set(C,T));const G=E.$kc(C.fsPath,U.fsPath);(0,D.$Nf)(T.includePattern)[G.replace(/\\/g,"/")]=!0}else U.fsPath&&(Y=!0,V[U.fsPath]=!0)}),{folderQueries:I,includePattern:V,usingSearchPaths:!0,excludePattern:Y?void 0:{"**/*":!0}}}j(w,I){if(I.isSmartCase){if(w.isRegExp){if(P.$tf(w.pattern,!0))return!0}else if(P.$tf(w.pattern))return!0}return!!w.isCaseSensitive}k(w){return w.isMultiline||w.isRegExp&&(0,b.$CB)(w.pattern)||w.pattern.indexOf(`
`)>=0?!0:!!w.isMultiline}parseSearchPaths(w){const I=de=>E.$hc(de)||/^\.\.?([\/\\]|$)/.test(de),V=(Array.isArray(w)?w:a(w)).map(de=>{const me=this.e.resolvedUserHome;return me?(0,M.$Bv)(de,me.scheme===$.Schemas.file?me.fsPath:me.path):de}),Y=F.$J(V,de=>I(de)?"searchPaths":"exprSegments"),U=(Y.exprSegments||[]).map(de=>P.$Oe(de,"/")).map(de=>P.$Oe(de,"\\")).map(de=>(de[0]==="."&&(de="*"+de),d(de))),N={},C=this.m(Y.searchPaths||[]);C&&C.length&&(N.searchPaths=C);const T=y.$Qb(U),G=s(...T);return G&&(N.pattern=G),N}l(w,I){return I.disregardExcludeSettings?void 0:(0,o.$6I)(w,!I.disregardSearchExcludeSettings)}m(w){if(!w||!w.length)return[];const I=w.flatMap(V=>{let{pathPortion:Y,globPortion:U}=n(V);return U&&(U=m(U)),this.n(Y).flatMap(C=>this.o(C,U))}),L=new Map;return I.forEach(V=>{const Y=V.searchPath.toString(),U=L.get(Y);U?V.pattern&&(U.pattern=U.pattern||{},U.pattern[V.pattern]=!0):L.set(Y,{searchPath:V.searchPath,pattern:V.pattern?s(V.pattern):void 0})}),Array.from(L.values())}n(w){if(E.$hc(w)){const I=this.b.getWorkspace().folders;return I[0]&&I[0].uri.scheme!==$.Schemas.file?[{searchPath:I[0].uri.with({path:w})}]:[{searchPath:u.URI.file(E.$gc(w))}]}if(this.b.getWorkbenchState()===2){const I=this.b.getWorkspace().folders[0].uri;if(w=p(w),w.startsWith("../")||w===".."){const V=E.$fc.resolve(I.path,w);return[{searchPath:I.with({path:V})}]}const L=m(w);return[{searchPath:I,pattern:L}]}else{if(w==="./"||w===".\\")return[];{const I=w.replace(/^\.[\/\\]/,""),V=this.b.getWorkspace().folders.map(Y=>{const U=I.match(new RegExp(`^${P.$Je(Y.name)}(?:/(.*)|$)`));return U?{match:U,folder:Y}:null}).filter(D.$Kf);if(V.length)return V.map(Y=>{const U=Y.match[1];return{searchPath:Y.folder.uri,pattern:U&&m(U)}});{const Y=w.match(/\.[\/\\](.+)[\/\\]?/),U=Y?Y[1]:w,N=v.localize(0,null,U);throw new Error(N)}}}}o(w,I){const L=w.pattern&&I?`${w.pattern}/${I}`:w.pattern||I,V=[{searchPath:w.searchPath,pattern:L}];return L&&!L.endsWith("**")&&V.push({searchPath:w.searchPath,pattern:L+"/**"}),V}q(w,I,L){const V=this.r((0,i.$ei)(w.searchPath),I,L,!1);return V?{...V,includePattern:w.pattern}:null}r(w,I,L,V){let Y;const U=u.URI.isUri(w)?w:w.uri;if(L.searchPaths){const de=L.searchPaths.filter(me=>(0,f.$sg)(me.searchPath,U))[0];if(de&&!de.pattern)return null;de&&(Y=de.pattern)}const N=this.a.getValue({resource:U}),T={...this.l(N,I)||{},...Y||{}},G=u.URI.isUri(w)?(0,f.$wg)(w):w.name;return{folder:U,folderName:V?G:void 0,excludePattern:Object.keys(T).length>0?T:void 0,fileEncoding:N.files&&N.files.encoding,disregardIgnoreFiles:typeof I.disregardIgnoreFiles=="boolean"?I.disregardIgnoreFiles:!N.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof I.disregardGlobalIgnoreFiles=="boolean"?I.disregardGlobalIgnoreFiles:!N.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof I.disregardParentIgnoreFiles=="boolean"?I.disregardParentIgnoreFiles:!N.search.useParentIgnoreFiles,ignoreSymlinks:typeof I.ignoreSymlinks=="boolean"?I.ignoreSymlinks:!N.search.followSymlinks}}};e.$dK=l,e.$dK=l=Ke([Ve(0,g.$pi),Ve(1,i.$5h),Ve(2,r.$GC),Ve(3,t.$dj),Ve(4,c.$bK)],l);function n(h){const w=h.match(/[\*\{\}\(\)\[\]\?]/);if(w){const I=w.index,L=h.substr(0,I).match(/[/|\\][^/\\]*$/);if(L){let V=h.substr(0,L.index);return V.match(/[/\\]/)||(V+="/"),{pathPortion:V,globPortion:h.substr((L.index||0)+1)}}}return{pathPortion:h}}function s(...h){return h.length?h.reduce((w,I)=>(w[I]=!0,w),Object.create(null)):void 0}function a(h){return A.$Aj(h,",").map(w=>w.trim()).filter(w=>!!w.length)}function d(h){return[`**/${h}/**`,`**/${h}`].map(I=>I.replace(/\*\*\/\*\*/g,"**"))}function p(h){return h.replace(/\\/g,"/")}function m(h){return p(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function S(h){return h.replace(/([?*[\]])/g,"[$1]")}function k(h,w){h=y.$Lb(h,V=>V.toString());const I=[],L=w.getWorkspace();return h&&h.forEach(V=>{let Y;if(w.getWorkbenchState()===2)Y=(0,f.$Bg)(L.folders[0].uri,V),Y&&Y!=="."&&(Y="./"+Y);else{const U=w.getWorkspaceFolder(V);if(U){const N=U.name;if(L.folders.filter(T=>T.name===N).length===1){const T=(0,f.$Bg)(U.uri,V);T===""?Y=`./${U.name}`:Y=`./${U.name}/${T}`}else Y=V.fsPath}}Y&&I.push(S(Y))}),I}e.$eK=k}),define(Ae[286],Re([1,0,25,2,19,11,4,285,43,47]),function(we,e,y,F,A,M,R,$,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5qb=e.$4qb=void 0;const P=7e3;function D(g,t){const i=t.activationEvents;if(!i)return Promise.resolve(void 0);const r=[],c=[];for(const d of i)if(/^workspaceContains:/.test(d)){const p=d.substr(18);p.indexOf("*")>=0||p.indexOf("?")>=0||g.forceUsingSearch?c.push(p):r.push(p)}if(r.length===0&&c.length===0)return Promise.resolve(void 0);let o;const l=new Promise((d,p)=>{o=d}),n=d=>o({activationEvent:d}),s=Promise.all(r.map(d=>u(g,d,n))).then(()=>{}),a=b(g,t.identifier,c,n);return Promise.all([s,a]).then(()=>{o(void 0)}),l}e.$4qb=D;async function u(g,t,i){for(const r of g.folders)if(await g.exists(y.$zg(F.URI.revive(r),t))){i(`workspaceContains:${t}`);return}}async function b(g,t,i,r){if(i.length===0)return Promise.resolve(void 0);const c=new A.$2d,o=g.checkExists(g.folders,i,c.token),l=setTimeout(async()=>{c.cancel(),g.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},P);let n=!1;try{n=await o}catch(s){M.$3(s)||M.$Z(s)}c.dispose(),clearTimeout(l),n&&r(`workspaceContains:${i.join(",")}`)}function v(g,t,i,r){const c=g.get(R.$Uh),o=g.get(E.$XI),n=c.createInstance($.$dK).file(t.map(s=>(0,f.$ei)(F.URI.revive(s))),{_reason:"checkExists",includePattern:i,exists:!0});return o.fileSearch(n,r).then(s=>!!s.limitHit,s=>M.$3(s)?!1:Promise.reject(s))}e.$5qb=v}),define(Ae[37],Re([1,0,159,20,88,25,14,6,50,2,15,3,36,218,85,35,23,106,11,22,24,201,7,100,4,27,86,17,71,87,64,5,286,84,203,13,82,60,21,83]),function(we,e,y,F,A,M,R,$,E,f,P,D,u,b,v,g,t,i,r,c,o,l,n,s,a,d,p,m,S,k,h,w,I,L,V,Y,U,N,C,T){"use strict";var G;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kec=e.$Jec=e.$Iec=e.$Hec=e.$Gec=void 0,e.$Gec=(0,a.$Vh)("IHostUtils");let de=G=class extends $.$Rc{constructor(Z,j,ie,ve,ne,he,ce,ye,_,fe,te,ae){super(),this.X=ae,this.a=this.B(new w.$Rd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=j,this.g=ie,this.f=ce,this.j=ve,this.m=ne,this.s=he,this.t=_,this.u=fe,this.w=te,this.y=this.g.getProxy(D.$zK.MainThreadWorkspace),this.z=this.g.getProxy(D.$zK.MainThreadTelemetry),this.C=this.g.getProxy(D.$zK.MainThreadExtensionService),this.D=new R.$Wg,this.F=new R.$Wg,this.G=new R.$Wg,this.H=new R.$Wg,this.I=new Pe(this.f.extensions.activationEvents),this.L=new i.$W5b(this.I,this.f.extensions.allExtensions);const $e=new c.$am(this.f.extensions.myExtensions);this.J=new i.$W5b(this.I,pe(this.L,$e)),C.$t&&(this.s.info(`Creating extension host with the following global extensions: ${ke(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${ke(this.J)}`)),this.M=new v.$rec(this.g,this.s),this.N=new L.$zec(this.g),this.O=ye,this.h=Z.createChild(new S.$Th([v.$sec,this.M],[L.$Aec,this.N])),this.P=this.B(new b.$qec(this.J,this.L,{onExtensionActivationError:(Ie,O,W)=>{this.C.$onExtensionActivationError(Ie,r.$2(O),W)},actualActivateExtension:async(Ie,O)=>{if(i.$W5b.isHostExtension(Ie,this.J,this.L))return await this.C.$activateExtension(Ie,O),new b.$pec;const W=this.J.getExtensionDescription(Ie);return this.db(W,O)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),A.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(Z){r.$Z(Z)}}async Y(){this.O.onWillDeactivateAll();let Z=[];try{Z=this.J.getAllExtensionDescriptions().map(ne=>ne.identifier).filter(ne=>this.isActivated(ne)).map(ne=>this.cb(ne))}catch{}await Promise.all(Z)}terminate(Z,j=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${Z}`),this.s.flush(),this.u.dispose(),this.P.dispose(),r.setUnexpectedErrorHandler(ve=>{this.s.error(ve)}),this.g.dispose();const ie=this.Y();Promise.race([(0,R.$Yg)(5e3),ie]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${j}`):this.s.info(`Extension host exiting with code ${j}`),this.s.flush(),this.s.dispose(),this.c.exit(j)})}isActivated(Z){return this.G.isOpen()?this.P.isActivated(Z):!1}async getExtension(Z){const j=await this.C.$getExtension(Z);return j&&{...j,identifier:new c.$_l(j.identifier.value),extensionLocation:f.URI.revive(j.extensionLocation)}}Z(Z,j){return this.P.activateByEvent(Z,j)}$(Z,j){return this.P.activateById(Z,j)}activateByIdWithErrors(Z,j){return this.$(Z,j).then(()=>{const ie=this.P.getActivatedExtension(Z);if(ie.activationFailed)return Promise.reject(ie.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(Z=>this.J)}getExtensionExports(Z){if(this.G.isOpen())return this.P.getActivatedExtension(Z).exports;try{return this.P.getActivatedExtension(Z).exports}catch{return null}}async ab(Z){if(Z.scheme===Y.Schemas.file&&this.c.fsRealpath){const j=await this.c.fsRealpath(Z.fsPath);return f.URI.file(j)}return Z}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(Z=>new re(Z))),this.Q}async bb(Z){const j=E.$2h.forUris(ie=>M.$qg.ignorePathCasing(ie));return await Promise.all(Z.map(async ie=>{if(this.ub(ie)){const ve=await this.ab(ie.extensionLocation);j.set(ve,ie)}})),j}cb(Z){let j=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(Z))return j;const ie=this.P.getActivatedExtension(Z);if(!ie)return j;try{typeof ie.module.deactivate=="function"&&(j=Promise.resolve(ie.module.deactivate()).then(void 0,ve=>(this.s.error(ve),Promise.resolve(void 0))))}catch(ve){this.s.error(`An error occurred when deactivating the extension '${Z.value}':`),this.s.error(ve)}try{(0,$.$Mc)(ie.subscriptions)}catch(ve){this.s.error(`An error occurred when deactivating the subscriptions for extension '${Z.value}':`),this.s.error(ve)}return j}async db(Z,j){return this.f.remote.isRemote?this.C.$onWillActivateExtension(Z.identifier):await this.C.$onWillActivateExtension(Z.identifier),this.fb(Z,j).then(ie=>{const ve=ie.activationTimes;return this.C.$onDidActivateExtension(Z.identifier,ve.codeLoadingTime,ve.activateCallTime,ve.activateResolvedTime,j),this.eb(Z,j,"success",ve),ie},ie=>{throw this.eb(Z,j,"failure"),ie})}eb(Z,j,ie,ve){const ne=De(Z,j);this.z.$publicLog2("extensionActivationTimes",{...ne,...ve||{},outcome:ie})}fb(Z,j){const ie=De(Z,j);this.z.$publicLog2("activatePlugin",ie);const ve=this.ub(Z);if(!ve)return Promise.resolve(new b.$oec(b.$lec.NONE));this.s.info(`ExtensionService#_doActivateExtension ${Z.identifier.value}, startup: ${j.startup}, activationEvent: '${j.activationEvent}'${Z.identifier.value!==j.extensionId.value?`, root cause: ${j.extensionId.value}`:""}`),this.s.flush();const ne=new b.$mec(j.startup);return Promise.all([this.vb(Z,(0,M.$zg)(Z.extensionLocation,ve),ne),this.gb(Z)]).then(he=>(A.mark(`code/extHost/willActivateExtension/${Z.identifier.value}`),G.hb(this.s,Z.identifier,he[0],he[1],ne))).then(he=>(A.mark(`code/extHost/didActivateExtension/${Z.identifier.value}`),he))}gb(Z){const j=new l.$uec(Z,this.M),ie=new l.$tec(Z.identifier.value,!1,this.M),ve=new V.$Bec(Z,this.N),ne=Z.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,he=this.f.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${Z.identifier.value}`),Promise.all([j.whenReady,ie.whenReady,this.O.whenReady]).then(()=>{const ce=this;let ye,_;const fe=(0,t.$MF)(Z,"ipc")?this.f.messagePorts?.get(c.$_l.toKey(Z.identifier)):void 0;return Object.freeze({globalState:j,workspaceState:ie,secrets:ve,subscriptions:[],get extensionUri(){return Z.extensionLocation},get extensionPath(){return Z.extensionLocation.fsPath},asAbsolutePath(te){return F.$ic(Z.extensionLocation.fsPath,te)},get storagePath(){return ce.O.workspaceValue(Z)?.fsPath},get globalStoragePath(){return ce.O.globalValue(Z).fsPath},get logPath(){return F.$ic(ce.f.logsLocation.fsPath,Z.identifier.value)},get logUri(){return f.URI.joinPath(ce.f.logsLocation,Z.identifier.value)},get storageUri(){return ce.O.workspaceValue(Z)},get globalStorageUri(){return ce.O.globalValue(Z)},get extensionMode(){return ne},get extension(){return ye===void 0&&(ye=new le(ce,Z.identifier,Z,he,!1)),ye},get extensionRuntime(){return(0,t.$NF)(Z,"extensionRuntime"),ce.extensionRuntime},get environmentVariableCollection(){return ce.u.getEnvironmentVariableCollection(Z)},get messagePassingProtocol(){if(!_){if(!fe)return;const te=w.Event.buffer(w.Event.fromDOMEventEmitter(fe,"message",ae=>ae.data));fe.start(),_={onDidReceiveMessage:te,postMessage:fe.postMessage.bind(fe)}}return _}})})}static hb(Z,j,ie,ve,ne){return ie=ie||{activate:void 0,deactivate:void 0},this.ib(Z,j,ie,ve,ne).then(he=>new b.$nec(!1,null,ne.build(),ie,he,ve.subscriptions))}static ib(Z,j,ie,ve,ne){if(typeof ie.activate=="function")try{ne.activateCallStart(),Z.trace(`ExtensionService#_callActivateOptional ${j.value}`);const he=typeof global=="object"?global:self,ce=ie.activate.apply(he,[ve]);return ne.activateCallStop(),ne.activateResolveStart(),Promise.resolve(ce).then(ye=>(ne.activateResolveStop(),ye))}catch(he){return Promise.reject(he)}else return Promise.resolve(ie)}jb(Z,j){this.$(Z.identifier,{startup:!1,extensionId:Z.identifier,activationEvent:j}).then(void 0,ie=>{this.s.error(ie)})}kb(Z,j=0){const ve=Date.now();(0,C.$B)(()=>{for(let ne=j;ne<Z.length;ne+=1){const he=Z[ne];for(const ce of he.activationEvents??[])if(ce==="onStartupFinished")if(Date.now()-ve>50){this.kb(Z,ne);break}else this.jb(he,ce)}})}lb(){this.C.$setPerformanceMarks(A.getMarks()),this.m.getConfigProvider().then(Z=>{const j=Z.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ie=this.J.getAllExtensionDescriptions();if(j)this.kb(ie);else for(const ve of ie)if(ve.activationEvents)for(const ne of ve.activationEvents)ne==="onStartupFinished"&&this.jb(ve,ne)})}mb(){const Z=this.Z("*",!0).then(void 0,he=>{this.s.error(he)});this.B(this.j.onDidChangeWorkspace(he=>this.nb(he.added)));const j=this.j.workspace?this.j.workspace.folders:[],ie=this.nb(j),ve=this.pb(),ne=Promise.all([ve,Z,ie]).then(()=>{});return Promise.race([ne,(0,R.$Yg)(1e4)]).then(()=>{this.lb()}),ne}nb(Z){return Z.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(j=>this.ob(Z,j))).then(()=>{})}async ob(Z,j){if(this.isActivated(j.identifier))return;const ie=!this.f.remote.isRemote&&!!this.f.remote.authority,ve={logService:this.s,folders:Z.map(he=>he.uri),forceUsingSearch:ie||!this.c.fsExists,exists:he=>this.c.fsExists(he.fsPath),checkExists:(he,ce,ye)=>this.y.$checkExists(he,ce,ye)},ne=await(0,I.$4qb)(ve,j);if(ne)return this.$(j.identifier,{startup:!0,extensionId:j.identifier,activationEvent:ne.activationEvent}).then(void 0,he=>this.s.error(he))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(Z){throw console.error(Z),Z}}async qb(){const{extensionDevelopmentLocationURI:Z,extensionTestsLocationURI:j}=this.f.environment;if(!Z||!j)throw new Error(y.localize(0,null));const ie=await this.vb(null,j,new b.$mec(!1));if(!ie||typeof ie.run!="function")throw new Error(y.localize(1,null,j.toString()));return new Promise((ve,ne)=>{const he=(_,fe)=>{_?(C.$t&&this.s.error("Test runner called back with error",_),ne(_)):(C.$t&&(fe?this.s.info(`Test runner called back with ${fe} failures.`):this.s.info("Test runner called back with successful outcome.")),ve(typeof fe=="number"&&fe>0?1:0))},ce=(0,M.$ng)(j),ye=ie.run(ce,he);ye&&ye.then&&ye.then(()=>{C.$t&&this.s.info("Test runner finished successfully."),ve(0)}).catch(_=>{C.$t&&this.s.error("Test runner finished with error",_),ne(_ instanceof Error&&_.stack?_.stack:String(_))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$Yg)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Z,j){return this.R[Z]=j,(0,$.$Pc)(()=>{delete this.R[Z]})}async getRemoteExecServer(Z){const{resolver:j}=await this.sb(Z);return j?.resolveExecServer?.(Z,{resolveAttempt:0})}async sb(Z){const j=Z.indexOf("+");if(j===-1)throw new n.$HK("Not an authority that can be resolved!",s.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ie=Z.substr(0,j);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ie}`,!1),{authorityPrefix:ie,resolver:this.R[ie]}}async $resolveAuthority(Z,j){const ie=N.$Nd.create(!1),ve=()=>`[resolveAuthority(${(0,s.$Zk)(Z)},${j})][${ie.elapsed()}ms] `,ne=J=>this.s.info(`${ve()}${J}`),he=J=>this.s.warn(`${ve()}${J}`),ce=(J,q=void 0)=>this.s.error(`${ve()}${J}`,q),ye=J=>{if(J instanceof n.$HK)return{type:"error",error:{code:J._code,message:J._message,detail:J._detail}};throw J},_=async J=>{ne(`activating resolver for ${J}...`);const{resolver:q,authorityPrefix:x}=await this.sb(J);if(!q)throw ce(`no resolver for ${x}`),new n.$HK(`No remote extension installed to resolve ${x}.`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:q,authorityPrefix:x,remoteAuthority:J}},fe=Z.split(/@|%40/g).reverse();ne(`activating remote resolvers ${fe.join(" -> ")}`);let te;try{te=await Promise.all(fe.map(_)).catch(async J=>{if(!(J instanceof n.$HK)||J._code!==s.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw J;return he(`resolving nested authorities failed: ${J.message}`),[await _(Z)]})}catch(J){return ye(J)}const ae=new R.$9g;ae.cancelAndSet(()=>ne("waiting..."),1e3);let $e,Ie;for(const[J,{authorityPrefix:q,resolver:x,remoteAuthority:ue}]of te.entries())try{if(J===te.length-1)ne("invoking final resolve()..."),A.mark(`code/extHost/willResolveAuthority/${q}`),$e=await x.resolve(ue,{resolveAttempt:j,execServer:Ie}),A.mark(`code/extHost/didResolveAuthorityOK/${q}`),ne("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(x,n.$GK.isManagedResolvedAuthority($e)?$e:void 0));else{if(ne(`invoking resolveExecServer() for ${ue}`),A.mark(`code/extHost/willResolveExecServer/${q}`),Ie=await x.resolveExecServer?.(ue,{resolveAttempt:j,execServer:Ie}),!Ie)throw new n.$HK(`Exec server was not available for ${ue}`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);A.mark(`code/extHost/didResolveExecServerOK/${q}`)}}catch(Ne){return A.mark(`code/extHost/didResolveAuthorityError/${q}`),ce("returned an error",Ne),ae.dispose(),ye(Ne)}ae.dispose();const O={environmentTunnels:$e.environmentTunnels,features:$e.tunnelFeatures},W={extensionHostEnv:$e.extensionHostEnv,isTrusted:$e.isTrusted,authenticationSession:$e.authenticationSessionForInitializingExtensions?{id:$e.authenticationSessionForInitializingExtensions.id,providerId:$e.authenticationSessionForInitializingExtensions.providerId}:void 0};ne(`returned ${n.$GK.isManagedResolvedAuthority($e)?"managed authority":`${$e.host}:${$e.port}`}`);let H;if(n.$GK.isManagedResolvedAuthority($e)){const J=j;this.X.setFactory(J,$e.makeConnection),H={authority:Z,connectTo:new s.$Wk(J),connectionToken:$e.connectionToken}}else H={authority:Z,connectTo:new s.$Xk($e.host,$e.port),connectionToken:$e.connectionToken};return{type:"ok",value:{authority:H,options:W,tunnelInformation:O}}}async $getCanonicalURI(Z,j){this.s.info(`$getCanonicalURI invoked for authority (${(0,s.$Zk)(Z)})`);const{resolver:ie}=await this.sb(Z);if(!ie)return null;const ve=f.URI.revive(j);if(typeof ie.getCanonicalURI>"u")return ve;const ne=await(0,R.$Qg)(()=>ie.getCanonicalURI(ve));return ne||ve}$startExtensionHost(Z){Z.toAdd.forEach(ve=>ve.extensionLocation=f.URI.revive(ve.extensionLocation));const{globalRegistry:j,myExtensions:ie}=me(this.I,this.L,this.J,Z);return this.L.set(j.getAllExtensionDescriptions()),this.J.set(ie),C.$t&&(this.s.info(`$startExtensionHost: global extensions: ${ke(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${ke(this.J)}`)),this.rb()}$activateByEvent(Z,j){return j===1?this.D.wait().then(ie=>this.Z(Z,!1)):this.G.wait().then(ie=>this.Z(Z,!1))}async $activate(Z,j){return await this.G.wait(),this.J.getExtensionDescription(Z)?(await this.$(Z,j),!0):!1}async $deltaExtensions(Z){Z.toAdd.forEach(he=>he.extensionLocation=f.URI.revive(he.extensionLocation));const{globalRegistry:j,myExtensions:ie}=me(this.I,this.L,this.J,Z),ve=await this.bb(ie);return(await this.getExtensionPathIndex()).setSearchTree(ve),this.L.set(j.getAllExtensionDescriptions()),this.J.set(ie),C.$t&&(this.s.info(`$deltaExtensions: global extensions: ${ke(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${ke(this.J)}`)),Promise.resolve(void 0)}async $test_latency(Z){return Z}async $test_up(Z){return Z.byteLength}async $test_down(Z){const j=o.$fe.alloc(Z),ie=Math.random()%256;for(let ve=0;ve<Z;ve++)j.writeUInt8(ie,ve);return j}async $updateRemoteConnectionData(Z){this.W=Z,this.a.fire()}};e.$Hec=de,e.$Hec=de=G=Ke([Ve(0,a.$Uh),Ve(1,e.$Gec),Ve(2,m.$BM),Ve(3,g.$7dc),Ve(4,u.$0dc),Ve(5,P.$dj),Ve(6,d.$RM),Ve(7,p.$aec),Ve(8,k.$Pwb),Ve(9,h.$vec),Ve(10,U.$Dec),Ve(11,T.$Eec)],de);function me(se,Z,j,ie){se.addActivationEvents(ie.addActivationEvents);const ve=new i.$W5b(se,Z.getAllExtensionDescriptions());ve.deltaExtensions(ie.toAdd,ie.toRemove);const ne=new c.$am(j.getAllExtensionDescriptions().map(ce=>ce.identifier));for(const ce of ie.myToRemove)ne.delete(ce);for(const ce of ie.myToAdd)ne.add(ce);const he=pe(ve,ne);return{globalRegistry:ve,myExtensions:he}}function De(se,Z){return{id:se.identifier.value,name:se.name,extensionVersion:se.version,publisherDisplayName:se.publisher,activationEvents:se.activationEvents?se.activationEvents.join(","):null,isBuiltin:se.isBuiltin,reason:Z.activationEvent,reasonId:Z.extensionId.value}}function ke(se){return se.getAllExtensionDescriptions().map(Z=>Z.identifier.value).join(",")}e.$Iec=(0,a.$Vh)("IExtHostExtensionService");class le{#e;#t;#i;constructor(Z,j,ie,ve,ne){this.#e=Z,this.#t=j,this.#i=ie.identifier,this.id=ie.identifier.value,this.extensionUri=ie.extensionLocation,this.extensionPath=F.$gc((0,M.$ng)(ie.extensionLocation)),this.packageJSON=ie,this.extensionKind=ve,this.isFromDifferentExtensionHost=ne}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Jec=le;function pe(se,Z){return se.getAllExtensionDescriptions().filter(j=>Z.has(j.identifier))}class re{constructor(Z){this.a=Z}setSearchTree(Z){this.a=Z}findSubstr(Z){return this.a.findSubstr(Z)}forEach(Z){return this.a.forEach(Z)}}e.$Kec=re;class Pe{constructor(Z){this.a=new c.$bm,this.addActivationEvents(Z)}readActivationEvents(Z){return this.a.get(Z.identifier)??[]}addActivationEvents(Z){for(const j of Object.keys(Z))this.a.set(j,Z[j])}}}),define(Ae[287],Re([1,0,88,2,3,36,23,22,17,27,4,37,15,12]),function(we,e,y,F,A,M,R,$,E,f,P,D,u,b){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$Sfc=void 0;let g=class{constructor(o,l,n,s,a,d,p){this.c=o,this.d=l,this.e=n,this.f=s,this.g=a,this.h=d,this.i=p,this.a=new Map,this.b=[]}async install(){this.j(),y.mark("code/extHost/willWaitForConfig");const o=await this.f.getConfigProvider();y.mark("code/extHost/didWaitForConfig");const l=await this.g.getExtensionPathIndex();this.register(new i(this.c,l,this.d,o,this.i)),this.register(this.e.createInstance(t)),this.h.remote.isRemote&&this.register(this.e.createInstance(r,l,this.h.environment.appUriScheme))}register(o){if("nodeModuleName"in o)if(Array.isArray(o.nodeModuleName))for(const l of o.nodeModuleName)this.a.set(l,o);else this.a.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this.b.push(l=>o.alternativeModuleName(l))}};e.$Sfc=g,e.$Sfc=g=Ke([Ve(2,P.$Uh),Ve(3,M.$0dc),Ve(4,D.$Iec),Ve(5,f.$RM),Ve(6,u.$dj)],g);let t=class{static{v=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(o){if(o.environment.appRoot&&v.a.size){const l=(0,b.$Je)(this.c(o.environment.appRoot.fsPath)),n="[a-z0-9_.-]",s=`@${n}+\\/${n}+|${n}+`,a="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${l}/${a}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(o){if(!this.b)return;const l=this.b.exec(this.c(o));if(!l)return;const[,n,s,a]=l,d=v.a.get(s);if(d!==void 0)return console.warn(`${s} as been renamed to ${d}, please update your imports`),n+d+a}c(o){return o.replace(/\\/g,"/")}};t=v=Ke([Ve(0,f.$RM)],t);class i{constructor(o,l,n,s,a){this.c=o,this.d=l,this.e=n,this.f=s,this.g=a,this.nodeModuleName="vscode",this.a=new $.$bm}load(o,l){const n=this.d.findSubstr(l);if(n){let s=this.a.get(n.identifier);return s||(s=this.c(n,this.e,this.f),this.a.set(n.identifier,s)),s}if(!this.b){let s="";this.d.forEach((a,d)=>s+=`	${d} -> ${a.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${l}. These are the extension path mappings: 
${s}`),this.b=this.c(R.$HF,this.e,this.f)}return this.b}}let r=class{constructor(o,l,n){this.e=o,this.f=l,this.nodeModuleName=["open","opn"],this.d=n.getProxy(A.$zK.MainThreadTelemetry);const s=n.getProxy(A.$zK.MainThreadWindow);this.c=(a,d)=>{const p=F.URI.parse(a);return d?this.g(a,d):p.scheme==="http"||p.scheme==="https"?s.$openUri(p,a,{allowTunneling:!0}):p.scheme==="mailto"||p.scheme===this.f?s.$openUri(p,a,{}):this.g(a,d)}}load(o,l,n){const s=this.e.findSubstr(l);return s&&(this.a=s.identifier.value,this.h()),this.b=n(o),this.c}g(o,l){return this.i(),this.b(o,l)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};r=Ke([Ve(2,E.$BM)],r)}),define(Ae[116],Re([1,0,44,6,20,74,4,61,62,37,7,35,215,36]),function(we,e,y,F,A,M,R,$,E,f,P,D,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mec=e.$Lec=void 0,e.$Lec=(0,R.$Vh)("IExtHostVariableResolverProvider");class v extends u.$CN{constructor(i,r,c,o,l,n,s){function a(){if(c){const d=c.activeEditor();if(d)return d.document.uri;const p=o.tabGroups.all.find(m=>m.isActive)?.activeTab;if(p!==void 0){if(p.input instanceof P.$hM||p.input instanceof P.$mM)return p.input.modified;if(p.input instanceof P.$gM||p.input instanceof P.$lM||p.input instanceof P.$jM)return p.input.uri}}}super({getFolderUri:d=>{const p=n.folders.filter(m=>m.name===d);if(p&&p.length>0)return p[0].uri},getWorkspaceFolderCount:()=>n.folders.length,getConfigurationValue:(d,p)=>l.getConfiguration(void 0,d).get(p),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const d=a();if(d)return A.$gc(d.fsPath)},getWorkspaceFolderPathForFile:()=>{if(r){const d=a();if(d){const p=r.getWorkspaceFolder(d);if(p)return A.$gc(p.uri.fsPath)}}},getSelectedText:()=>{if(c){const d=c.activeEditor();if(d&&!d.selection.isEmpty)return d.document.getText(d.selection)}},getLineNumber:()=>{if(c){const d=c.activeEditor();if(d)return String(d.selection.end.line+1)}},getExtension:d=>i.getExtension(d)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(M.env))}}let g=class extends F.$Rc{constructor(i,r,c,o,l){super(),this.b=i,this.c=r,this.g=c,this.h=o,this.j=l,this.a=new y.$U(async()=>{const n=await this.h.getConfigProvider(),a={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async d=>{a.folders=await this.c.getWorkspaceFolders2()||[]})),new v(this.b,this.c,this.g,this.j,n,a,this.m())})}getResolver(){return this.a.value}m(){}};e.$Mec=g,e.$Mec=g=Ke([Ve(0,f.$Iec),Ve(1,D.$7dc),Ve(2,$.$MM),Ve(3,b.$0dc),Ve(4,E.$jec)],g)}),define(Ae[117],Re([1,0,14,5,2,4,3,62,37,17,7,35,207,209,36,116]),function(we,e,y,F,A,M,R,$,E,f,P,D,u,b,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rec=e.$Qec=e.$Pec=e.$Oec=e.$Nec=void 0,e.$Nec=(0,M.$Vh)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(s,a,d,p,m,S){this.E=a,this.F=d,this.G=p,this.H=m,this.I=S,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new F.$Rd,this.n=new F.$Rd,this.o=new F.$Rd,this.u=new F.$Rd,this.k=s.getProxy(R.$zK.MainThreadDebugService),this.y=new F.$Rd,this.A=new F.$Rd,this.v=new r(this.k),this.w=new Map,this.F.getExtensionRegistry().then(k=>{k.onDidChange(h=>{this.J(k)}),this.J(k)})}asDebugSourceUri(s,a){const d=s;if(typeof d.sourceReference=="number"&&d.sourceReference>0){let p=`debug:${encodeURIComponent(d.path||"")}`,m="?";return a&&(p+=`${m}session=${encodeURIComponent(a.id)}`,m="&"),p+=`${m}ref=${d.sourceReference}`,A.URI.parse(p)}else{if(d.path)return A.URI.file(d.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(s){const a=[];for(const d of s.getAllExtensionDescriptions())if(d.contributes){const p=d.contributes.debuggers;if(p&&p.length>0)for(const m of p)(0,b.$jF)(m)&&a.push(m.type)}this.k.$registerDebugTypes(a)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const s=[];return this.w.forEach(a=>s.push(a)),s}addBreakpoints(s){const a=s.filter(m=>{const S=m.id;return this.w.has(S)?!1:(this.w.set(S,m),!0)});this.U(a,[],[]);const d=[],p=new Map;for(const m of a)if(m instanceof P.$AL){let S=p.get(m.location.uri.toString());S||(S={type:"sourceMulti",uri:m.location.uri,lines:[]},p.set(m.location.uri.toString(),S),d.push(S)),S.lines.push({id:m.id,enabled:m.enabled,condition:m.condition,hitCondition:m.hitCondition,logMessage:m.logMessage,line:m.location.range.start.line,character:m.location.range.start.character})}else m instanceof P.$BL&&d.push({type:"function",id:m.id,enabled:m.enabled,hitCondition:m.hitCondition,logMessage:m.logMessage,condition:m.condition,functionName:m.functionName});return this.k.$registerBreakpoints(d)}removeBreakpoints(s){const a=s.filter(S=>this.w.delete(S.id));this.U([],a,[]);const d=a.filter(S=>S instanceof P.$AL).map(S=>S.id),p=a.filter(S=>S instanceof P.$BL).map(S=>S.id),m=a.filter(S=>S instanceof P.$CL).map(S=>S.id);return this.k.$unregisterBreakpoints(d,p,m)}startDebugging(s,a,d){return this.k.$startDebugging(s?s.uri:void 0,a,{parentSessionID:d.parentSession?d.parentSession.id:void 0,lifecycleManagedByParent:d.lifecycleManagedByParent,repl:d.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:d.noDebug,compact:d.compact,suppressSaveBeforeStart:d.suppressSaveBeforeStart,suppressDebugStatusbar:d.suppressDebugStatusbar??d.debugUI?.simple,suppressDebugToolbar:d.suppressDebugToolbar??d.debugUI?.simple,suppressDebugView:d.suppressDebugView??d.debugUI?.simple})}stopDebugging(s){return this.k.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,a,d){if(!a)return new P.$BK(()=>{});const p=this.d++;return this.f.push({type:s,handle:p,provider:a}),this.k.$registerDebugConfigurationProvider(s,d,!!a.provideDebugConfigurations,!!a.resolveDebugConfiguration,!!a.resolveDebugConfigurationWithSubstitutedVariables,p),new P.$BK(()=>{this.f=this.f.filter(m=>m.provider!==a),this.k.$unregisterDebugConfigurationProvider(p)})}registerDebugAdapterDescriptorFactory(s,a,d){if(!d)return new P.$BK(()=>{});if(!this.Q(s,a))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${a}' debugger.`);if(this.N(a))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const p=this.g++;return this.h.push({type:a,handle:p,factory:d}),this.k.$registerDebugAdapterDescriptorFactory(a,p),new P.$BK(()=>{this.h=this.h.filter(m=>m.factory!==d),this.k.$unregisterDebugAdapterDescriptorFactory(p)})}registerDebugAdapterTrackerFactory(s,a){if(!a)return new P.$BK(()=>{});const d=this.i++;return this.j.push({type:s,handle:d,factory:a}),new P.$BK(()=>{this.j=this.j.filter(p=>p.factory!==a)})}async $runInTerminal(s,a){return Promise.resolve(void 0)}async $substituteVariables(s,a){let d;const p=await this.W(s);return p&&(d={uri:p.uri,name:p.name,index:p.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(d,a)}K(s,a){if(s.type==="implementation")return new o(s.implementation)}L(){}async $startDASession(s,a){const d=this,p=await this.V(a);return this.S(this.N(p.type),p).then(m=>{if(!m)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${p.type}' (extension might have failed to activate)`);const S=this.M(m),k=this.K(S,p);if(!k)throw new Error(`Couldn't create a debug adapter for type '${p.type}'.`);const h=k;return this.B.set(s,h),this.R(p).then(w=>(w&&this.C.set(s,w),h.onMessage(async I=>{if(I.type==="request"&&I.command==="handshake"){const L=I,V={type:"response",seq:0,command:L.command,request_seq:L.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const Y=await this.D.sign(L.arguments.value);V.body={signature:Y},h.sendResponse(V)}else throw new Error("no signer")}catch(Y){V.success=!1,V.message=Y.message,h.sendResponse(V)}}else w&&w.onDidSendMessage&&w.onDidSendMessage(I),I=(0,b.$oF)(I,!0),d.k.$acceptDAMessage(s,I)}),h.onError(I=>{w&&w.onError&&w.onError(I),this.k.$acceptDAError(s,I.name,I.message,I.stack)}),h.onExit(I=>{w&&w.onExit&&w.onExit(I??void 0,void 0),this.k.$acceptDAExit(s,I??void 0,void 0)}),w&&w.onWillStartSession&&w.onWillStartSession(),h.startSession()))})}$sendDAMessage(s,a){a=(0,b.$nF)(a,!1);const d=this.C.get(s);d&&d.onWillReceiveMessage&&d.onWillReceiveMessage(a),this.B.get(s)?.sendMessage(a)}$stopDASession(s){const a=this.C.get(s);this.C.delete(s),a&&a.onWillStopSession&&a.onWillStopSession();const d=this.B.get(s);return this.B.delete(s),d?d.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const a=[],d=[],p=[];if(s.added)for(const m of s.added){const S=m.id;if(S&&!this.w.has(S)){let k;if(m.type==="function")k=new P.$BL(m.functionName,m.enabled,m.condition,m.hitCondition,m.logMessage);else if(m.type==="data")k=new P.$CL(m.label,m.dataId,m.canPersist,m.enabled,m.hitCondition,m.condition,m.logMessage);else{const h=A.URI.revive(m.uri);k=new P.$AL(new P.$NK(h,new P.$CK(m.line,m.character)),m.enabled,m.condition,m.hitCondition,m.logMessage)}(0,P.$yL)(k,S),this.w.set(S,k),a.push(k)}}if(s.removed)for(const m of s.removed){const S=this.w.get(m);S&&(this.w.delete(m),d.push(S))}if(s.changed){for(const m of s.changed)if(m.id){const S=this.w.get(m.id);if(S){if(S instanceof P.$BL&&m.type==="function"){const k=S;k.enabled=m.enabled,k.condition=m.condition,k.hitCondition=m.hitCondition,k.logMessage=m.logMessage,k.functionName=m.functionName}else if(S instanceof P.$AL&&m.type==="source"){const k=S;k.enabled=m.enabled,k.condition=m.condition,k.hitCondition=m.hitCondition,k.logMessage=m.logMessage,k.location=new P.$NK(A.URI.revive(m.uri),new P.$CK(m.line,m.character))}p.push(S)}}}this.U(a,d,p)}async $acceptStackFrameFocus(s){let a;const d=s.sessionId?await this.V(s.sessionId):void 0;if(!d)throw new Error("no DebugSession found for debug focus context");s.kind==="thread"?a=new P.$IL(d,s.threadId):a=new P.$HL(d,s.threadId,s.frameId),this.z=a,this.A.fire(this.z)}$provideDebugConfigurations(s,a,d){return(0,y.$Qg)(async()=>{const p=this.P(s);if(!p)throw new Error("no DebugConfigurationProvider found");if(!p.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const m=await this.W(a);return p.provideDebugConfigurations(m,d)}).then(p=>{if(!p)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return p})}$resolveDebugConfiguration(s,a,d,p){return(0,y.$Qg)(async()=>{const m=this.P(s);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const S=await this.W(a);return m.resolveDebugConfiguration(S,d,p)})}$resolveDebugConfigurationWithSubstitutedVariables(s,a,d,p){return(0,y.$Qg)(async()=>{const m=this.P(s);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const S=await this.W(a);return m.resolveDebugConfigurationWithSubstitutedVariables(S,d,p)})}async $provideDebugAdapter(s,a){const d=this.O(s);if(!d)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const p=await this.V(a);return this.S(d,p).then(m=>{if(!m)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${p.type}'`);return this.M(m)})}async $acceptDebugSessionStarted(s){const a=await this.V(s);this.m.fire(a)}async $acceptDebugSessionTerminated(s){const a=await this.V(s);a&&(this.n.fire(a),this.l.delete(a.id))}async $acceptDebugSessionActiveChanged(s){this.q=s?await this.V(s):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(s,a){(await this.V(s))?._acceptNameChanged(a)}async $acceptDebugSessionCustomEvent(s,a){const p={session:await this.V(s),event:a.event,body:a.body};this.u.fire(p)}M(s){if(s instanceof P.$DL)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof P.$EL)return{type:"server",port:s.port,host:s.host};if(s instanceof P.$FL)return{type:"pipeServer",path:s.path};if(s instanceof P.$GL)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}N(s){const a=this.h.filter(d=>d.type===s);if(a.length>0)return a[0].factory}O(s){const a=this.h.filter(d=>d.handle===s);if(a.length>0)return a[0].factory}P(s){const a=this.f.filter(d=>d.handle===s);if(a.length>0)return a[0].provider}Q(s,a){if(s.contributes){const d=s.contributes.debuggers;if(d&&d.length>0){for(const p of d)if(p.label&&p.type&&p.type===a)return!0}}return!1}R(s){const d=s.configuration.type,p=this.j.filter(m=>m.type===d||m.type==="*").map(m=>(0,y.$Qg)(()=>m.factory.createDebugAdapterTracker(s)).then(S=>S,S=>null));return Promise.race([Promise.all(p).then(m=>{const S=m.filter(k=>!!k);if(S.length>0)return new c(S)}),new Promise(m=>setTimeout(()=>m(void 0),1e3))]).catch(m=>{})}async S(s,a){const d=a.configuration.debugServer;if(typeof d=="number")return Promise.resolve(new P.$EL(d));if(s){const m=await this.F.getExtensionRegistry();return(0,y.$Qg)(()=>s.createDebugAdapterDescriptor(a,this.T(a,m))).then(S=>{if(S)return S})}const p=await this.F.getExtensionRegistry();return Promise.resolve(this.T(a,p))}T(s,a){}U(s,a,d){(s.length>0||a.length>0||d.length>0)&&this.y.fire(Object.freeze({added:s,removed:a,changed:d}))}async V(s){if(s)if(typeof s=="string"){const a=this.l.get(s);if(a)return a}else{let a=this.l.get(s.id);if(!a){const d=await this.W(s.folderUri),p=s.parent?this.l.get(s.parent):void 0;a=new i(this.k,s.id,s.type,s.name,d,s.configuration,p),this.l.set(a.id,a),this.k.$sessionCached(a.id)}return a}throw new Error("cannot find session")}W(s){if(s){const a=A.URI.revive(s);return this.E.resolveWorkspaceFolder(a)}return Promise.resolve(void 0)}};e.$Oec=t,e.$Oec=t=Ke([Ve(0,f.$BM),Ve(1,D.$7dc),Ve(2,E.$Iec),Ve(3,v.$0dc),Ve(4,$.$jec),Ve(5,g.$Lec)],t);class i{constructor(s,a,d,p,m,S,k){this.d=s,this.f=a,this.g=d,this.h=p,this.i=m,this.j=S,this.k=k}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(s){this.h=s,this.d.$setDebugSessionName(this.f,s)}get parentSession(){return this.k}_acceptNameChanged(s){this.h=s}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(s,a){return this.d.$customDebugAdapterRequest(this.f,s,a)}getDebugProtocolBreakpoint(s){return this.d.$getDebugProtocolBreakpoint(this.f,s.id)}}e.$Pec=i;class r{constructor(s){this.value=Object.freeze({append(a){s.$appendDebugConsole(a)},appendLine(a){this.append(a+`
`)}})}}e.$Qec=r;class c{constructor(s){this.d=s}onWillStartSession(){this.d.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.d.forEach(a=>a.onWillReceiveMessage?a.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.d.forEach(a=>a.onDidSendMessage?a.onDidSendMessage(s):void 0)}onWillStopSession(){this.d.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.d.forEach(a=>a.onError?a.onError(s):void 0)}onExit(s,a){this.d.forEach(d=>d.onExit?d.onExit(s,a):void 0)}}class o extends u.$$cb{constructor(s){super(),this.h=s,s.onDidSendMessage(a=>{this.acceptMessage(a)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.h.handleMessage(s)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let l=class extends t{constructor(s,a,d,p,m,S){super(s,a,d,p,m,S)}};e.$Rec=l,e.$Rec=l=Ke([Ve(0,f.$BM),Ve(1,D.$7dc),Ve(2,E.$Iec),Ve(3,v.$0dc),Ve(4,$.$jec),Ve(5,g.$Lec)],l)}),define(Ae[288],Re([1,0,11,88,2,3,276,15,70,71,27,185,17,57,37,59]),function(we,e,y,F,A,M,R,$,E,f,P,D,u,b,v,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ufc=e.$Tfc=void 0;class t{static async installEarlyHandler(c){Error.stackTraceLimit=100;const o=c.get($.$dj),n=c.get(u.$BM).getProxy(M.$zK.MainThreadErrors);y.setUnexpectedErrorHandler(s=>{o.error(s);const a=y.$2(s);n.$onUnexpectedError(a)})}static async installFullHandler(c){const o=c.get($.$dj),l=c.get(u.$BM),n=c.get(v.$Iec),s=c.get(g.$VM),a=l.getProxy(M.$zK.MainThreadExtensionService),d=l.getProxy(M.$zK.MainThreadErrors),p=await n.getExtensionPathIndex(),m=new WeakMap;function S(w,I){if(m.has(w))return m.get(w).stack;let L="",V,Y;for(const N of I)L+=`
	at ${N.toString()}`,Y=N.getFileName(),!V&&Y&&(V=p.findSubstr(A.URI.file(Y)));const U=`${w.name||"Error"}: ${w.message||""}${L}`;return m.set(w,{extensionIdentifier:V?.identifier,stack:U}),U}const k=Symbol("prepareStackTrace wrapped");let h=S;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return h},set(w){if(w===S||!w||w[k]){h=w||S;return}h=function(I,L){return S(I,L),w.call(Error,I,L)},Object.assign(h,{[k]:!0})}}),y.setUnexpectedErrorHandler(w=>{o.error(w);const I=y.$2(w),L=m.get(w);if(!L?.extensionIdentifier){d.$onUnexpectedError(I);return}a.$onExtensionRuntimeError(L.extensionIdentifier,I);const V=s.onExtensionError(L.extensionIdentifier,w);o.trace("forwarded error to extension?",V,L)})}}e.$Tfc=t;class i{constructor(c,o,l,n,s){this.a=l,this.b=new R.$55b(c,null,n),o=i.e(o,this.b);const a=new f.$Th(...(0,E.$Dr)());a.set(P.$RM,{_serviceBrand:void 0,...o,messagePorts:s}),a.set(u.$BM,new u.$CM(this.b)),a.set(b.$4dc,new b.$5dc(n)),a.set(v.$Gec,l);const d=new D.$jq(a,!0);d.invokeFunction(t.installEarlyHandler),this.d=d.invokeFunction(p=>p.get($.$dj)),F.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",o),this.c=d.invokeFunction(p=>p.get(v.$Iec)),this.c.initialize(),d.invokeFunction(t.installFullHandler)}async asBrowserUri(c){const o=this.b.getProxy(M.$zK.MainThreadExtensionService);return A.URI.revive(await o.$asBrowserUri(c))}terminate(c){this.c.terminate(c)}static e(c,o){c.extensions.allExtensions.forEach(n=>{n.extensionLocation=A.URI.revive(o.transformIncomingURIs(n.extensionLocation))}),c.environment.appRoot=A.URI.revive(o.transformIncomingURIs(c.environment.appRoot));const l=c.environment.extensionDevelopmentLocationURI;return l&&(c.environment.extensionDevelopmentLocationURI=l.map(n=>A.URI.revive(o.transformIncomingURIs(n)))),c.environment.extensionTestsLocationURI=A.URI.revive(o.transformIncomingURIs(c.environment.extensionTestsLocationURI)),c.environment.globalStorageHome=A.URI.revive(o.transformIncomingURIs(c.environment.globalStorageHome)),c.environment.workspaceStorageHome=A.URI.revive(o.transformIncomingURIs(c.environment.workspaceStorageHome)),c.environment.extensionTelemetryLogResource=A.URI.revive(o.transformIncomingURIs(c.environment.extensionTelemetryLogResource)),c.nlsBaseUrl=A.URI.revive(o.transformIncomingURIs(c.nlsBaseUrl)),c.logsLocation=A.URI.revive(o.transformIncomingURIs(c.logsLocation)),c.workspace=o.transformIncomingURIs(c.workspace),c}}e.$Ufc=i}),define(Ae[289],Re([1,0,18,14,19,39,13,20,25,2,43]),function(we,e,y,F,A,M,R,$,E,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ec=e.$8ec=e.$7ec=e.$6ec=void 0;class D{constructor(r,c,o,l){this.d=r,this.e=c,this.f=o,this.g=l,this.a=null,this.b=!1,this.c=0}search(r,c){const o=this.d.folderQueries||[],l=new A.$2d(c);return new Promise((n,s)=>{this.a=new b(r);let a=!1;const d=(p,m)=>{if(!a&&!this.b){const S=this.h(p);g(p)&&typeof this.d.maxResults=="number"&&this.c+S>this.d.maxResults&&(this.b=!0,a=!0,l.cancel(),p=this.j(p,this.d.maxResults-this.c));const k=this.h(p);this.c+=k,(k>0||!g(p))&&this.a.add(p,m)}};Promise.all(o.map((p,m)=>this.k(p,S=>d(S,m),l.token))).then(p=>{l.dispose(),this.a.flush();const m=p.some(S=>!!S&&!!S.limitHit);n({limitHit:this.b||m,messages:(0,y.$Qb)(p.map(S=>S?.message?Array.isArray(S.message)?S.message:[S.message]:[])),stats:{type:this.g}})},p=>{l.dispose();const m=(0,M.$Gi)(p);s(new Error(m))})})}h(r){return g(r)?Array.isArray(r.ranges)?r.ranges.length:1:0}j(r,c){const o=Array.isArray(r.ranges)?r.ranges:[r.ranges],l=Array.isArray(r.preview.matches)?r.preview.matches:[r.preview.matches];return{ranges:o.slice(0,c),preview:{matches:l.slice(0,c),text:r.preview.text},uri:r.uri}}async k(r,c,o){const l=new P.$eJ(this.d,r),n=[],s={report:p=>{if(!this.l(p))return;const m=r.folder.scheme===R.Schemas.file?(0,P.$fJ)(()=>this.f.readdir(E.$yg(p.uri))):void 0,S=E.$Bg(r.folder,p.uri);if(S){const k=l.includedInQuery(S,$.$mc(S),m);(0,F.$Kg)(k)?n.push(k.then(h=>{h&&c(p)})):k&&c(p)}}},a=this.n(r),d=await this.e.provideTextSearchResults(u(this.d.contentPattern),a,s,o);return n.length&&await Promise.all(n),d}l(r){if(g(r)){if(Array.isArray(r.ranges)){if(!Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(r.preview.matches.length!==r.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(r){const c=(0,P.$dJ)(this.d.includePattern,r.includePattern),o=(0,P.$dJ)(this.d.excludePattern,r.excludePattern),l={folder:f.URI.from(r.folder),excludes:o,includes:c,useIgnoreFiles:!r.disregardIgnoreFiles,useGlobalIgnoreFiles:!r.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!r.disregardParentIgnoreFiles,followSymlinks:!r.ignoreSymlinks,encoding:r.fileEncoding&&this.f.toCanonicalName(r.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return l.usePCRE2=this.d.usePCRE2,l}}e.$6ec=D;function u(i){return{isCaseSensitive:i.isCaseSensitive||!1,isRegExp:i.isRegExp||!1,isWordMatch:i.isWordMatch||!1,isMultiline:i.isMultiline||!1,pattern:i.pattern}}class b{constructor(r){this.e=r,this.b=-1,this.d=null,this.a=new t(512,c=>this.g(c))}add(r,c){this.d&&(this.b!==c||!E.$sg(this.c,r.uri))&&(this.f(),this.d=null),this.d||(this.b=c,this.d={resource:r.uri,results:[]}),this.d.results.push(v(r))}f(){const r=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,r)}flush(){this.f(),this.a.flush()}g(r){this.e(r)}}e.$7ec=b;function v(i){return g(i)?{preview:{matches:(0,y.$1b)(i.preview.matches,r=>({startLineNumber:r.start.line,startColumn:r.start.character,endLineNumber:r.end.line,endColumn:r.end.character})),text:i.preview.text},ranges:(0,y.$1b)(i.ranges,r=>({startLineNumber:r.start.line,startColumn:r.start.character,endLineNumber:r.end.line,endColumn:r.end.character}))}:{text:i.text,lineNumber:i.lineNumber}}function g(i){return!!i.preview}e.$8ec=g;class t{static{this.a=4e3}static{this.b=50}constructor(r,c){this.g=r,this.h=c,this.c=0,this.d=[],this.e=0}addItem(r,c){r&&this.j(r,c)}addItems(r,c){r&&this.k(r,c)}j(r,c){this.d.push(r),this.e+=c,this.l()}k(r,c){this.d=this.d.concat(r),this.e+=c,this.l()}l(){this.c<t.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},t.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$9ec=t}),define(Ae[118],Re([1,0,6,3,4,284,17,57,15,2,289]),function(we,e,y,F,A,M,R,$,E,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ec=e.$$ec=e.$0ec=void 0,e.$0ec=(0,A.$Vh)("IExtHostSearch");let D=class{constructor(g,t,i){this.k=g,this.l=t,this.n=i,this.c=this.k.getProxy(F.$zK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new M.$5ec}o(g){return this.l.transformOutgoingScheme(g)}registerTextSearchProvider(g,t){if(this.g.has(g))throw new Error(`a text search provider for the scheme '${g}' is already registered`);this.g.add(g);const i=this.d++;return this.e.set(i,t),this.c.$registerTextSearchProvider(i,this.o(g)),(0,y.$Pc)(()=>{this.g.delete(g),this.e.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProvider(g,t){if(this.i.has(g))throw new Error(`a file search provider for the scheme '${g}' is already registered`);this.i.add(g);const i=this.d++;return this.h.set(i,t),this.c.$registerFileSearchProvider(i,this.o(g)),(0,y.$Pc)(()=>{this.i.delete(g),this.h.delete(i),this.c.$unregisterProvider(i)})}$provideFileSearchResults(g,t,i,r){const c=u(i),o=this.h.get(g);if(o)return this.j.fileSearch(c,o,l=>{this.c.$handleFileMatch(g,t,l.map(n=>n.resource))},r);throw new Error("unknown provider: "+g)}async doInternalFileSearchWithCustomCallback(g,t,i){return{messages:[]}}$clearCache(g){return this.j.clearCache(g),Promise.resolve(void 0)}$provideTextSearchResults(g,t,i,r){const c=this.e.get(g);if(!c||!c.provideTextSearchResults)throw new Error(`Unknown provider ${g}`);const o=u(i);return this.q(o,c).search(n=>this.c.$handleTextMatch(g,t,n),r)}$enableExtensionHostSearch(){}q(g,t){return new P.$6ec(g,t,{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}};e.$$ec=D,e.$$ec=D=Ke([Ve(0,R.$BM),Ve(1,$.$4dc),Ve(2,E.$dj)],D);function u(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(b),extraFileResources:v.extraFileResources&&v.extraFileResources.map(g=>f.URI.revive(g))}}e.$_ec=u;function b(v){return{...v,folder:f.URI.revive(v.folder)}}}),define(Ae[290],Re([1,0,19,11,5,6,13,31,2,146,142,129,92,22,41,15,99,55,56,198,3,231,239,81,232,233,234,235,236,237,238,213,32,240,36,272,117,110,242,243,244,220,245,61,62,247,37,248,63,249,42,27,250,251,252,253,254,255,82,83,257,283,222,202,223,258,259,112,260,224,261,262,17,263,118,84,264,265,266,85,86,115,59,64,267,268,210,269,225,87,8,7,270,57,271,65,273,274,111,35,208,79,23,114]),function(we,e,y,F,A,M,R,$,E,f,P,D,u,b,v,g,t,i,r,c,o,l,n,s,a,d,p,m,S,k,h,w,I,L,V,Y,U,N,C,T,G,de,me,De,ke,le,pe,re,Pe,se,Z,j,ie,ve,ne,he,ce,ye,_,fe,te,ae,$e,Ie,O,W,H,J,q,x,ue,Ne,Be,Ye,Je,tt,_e,et,rt,nt,ze,dt,X,Q,Ee,je,He,Xe,st,vt,Dt,Oe,Kt,Ht,yt,Ut,Ot,Gt,jt,St,Lt,Vt,Ze,Wt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ofc=void 0;function qt(ct){const gt=ct.get(j.$RM),Nt=ct.get(Z.$Ldc),Pt=ct.get(Pe.$_dc),At=ct.get(pe.$Iec),ft=ct.get(St.$7dc),kt=ct.get(X.$VM),Rt=ct.get(V.$0dc),Ct=ct.get(Ht.$4dc),We=ct.get(Be.$BM),zt=ct.get(nt.$sec),Jt=ct.get(ze.$aec),Ce=ct.get(g.$ej),Me=ct.get(g.$dj),be=ct.get(vt.$Pwb),K=ct.get(s.$Odc),Le=ct.get(jt.$Nfc),Ue=ct.get(tt.$Aec),Qe=ct.get(ke.$jec),qe=ct.get(fe.$Eec);We.set(o.$AK.ExtHostFileSystemInfo,Nt),We.set(o.$AK.ExtHostLogLevelServiceShape,Ce),We.set(o.$AK.ExtHostWorkspace,ft),We.set(o.$AK.ExtHostConfiguration,Rt),We.set(o.$AK.ExtHostExtensionService,At),We.set(o.$AK.ExtHostStorage,zt),We.set(o.$AK.ExtHostTunnelService,be),We.set(o.$AK.ExtHostWindow,Le),We.set(o.$AK.ExtHostSecretState,Ue),We.set(o.$AK.ExtHostTelemetry,kt),We.set(o.$AK.ExtHostEditorTabs,Qe),We.set(o.$AK.ExtHostManagedSockets,qe);const it=We.set(o.$AK.ExtHostDecorations,ct.get(N.$Tec)),pt=We.set(o.$AK.ExtHostDocumentsAndEditors,ct.get(De.$MM)),$t=We.set(o.$AK.ExtHostCommands,ct.get(I.$XM)),bt=We.set(o.$AK.ExtHostTerminalService,ct.get(Q.$vec)),ut=We.set(o.$AK.ExtHostDebugService,ct.get(U.$Nec)),Mt=We.set(o.$AK.ExtHostSearch,ct.get(Je.$0ec)),Qt=We.set(o.$AK.ExtHostTask,ct.get(dt.$Afc)),Xt=We.set(o.$AK.ExtHostOutputService,ct.get(J.$nfc)),si=We.set(o.$AK.ExtHostLocalization,ct.get(_.$Dec)),ki=We.set(o.$AK.ExtHostUrls,new yt.$Kfc(We)),It=We.set(o.$AK.ExtHostDocuments,new me.$Jdc(We,pt)),Yi=We.set(o.$AK.ExtHostDocumentContentProviders,new G.$Vec(We,pt,Me)),ln=We.set(o.$AK.ExtHostDocumentSaveParticipant,new de.$Wec(Me,It,We.getProxy(o.$zK.MainThreadBulkEdits))),Et=We.set(o.$AK.ExtHostNotebook,new ae.$afc(We,$t,pt,It,Pt,Mt)),mi=We.set(o.$AK.ExtHostNotebookDocuments,new Ie.$hfc(Et)),$i=We.set(o.$AK.ExtHostNotebookEditors,new O.$ifc(Me,Et)),oi=We.set(o.$AK.ExtHostNotebookKernels,new W.$jfc(We,gt,Et,$t,Me)),Si=We.set(o.$AK.ExtHostNotebookRenderers,new H.$lfc(We,Et)),Ii=We.set(o.$AK.ExtHostNotebookDocumentSaveParticipant,new $e.$gfc(Me,Et,We.getProxy(o.$zK.MainThreadBulkEdits))),Ft=We.set(o.$AK.ExtHostEditors,new je.$1dc(We,pt)),pi=We.set(o.$AK.ExtHostTreeViews,new st.$Ifc(We.getProxy(o.$zK.MainThreadTreeViews),$t,Me)),Ci=We.set(o.$AK.ExtHostEditorInsets,new w.$2dc(We.getProxy(o.$zK.MainThreadEditorInsets),Ft,gt.remote)),ai=We.set(o.$AK.ExtHostDiagnostics,new C.$Ndc(We,Me,Nt,pt)),ci=We.set(o.$AK.ExtHostLanguages,new ye.$efc(We,It,$t.converter,Ct)),lt=We.set(o.$AK.ExtHostLanguageFeatures,new ce.$Rdc(We,Ct,It,$t,ai,Me,K,kt)),Pi=We.set(o.$AK.ExtHostFileSystem,new re.$Yec(We,lt)),xt=We.set(o.$AK.ExtHostFileSystemEventService,new se.$Zec(We,Me,pt)),ni=We.set(o.$AK.ExtHostQuickOpen,(0,Ne.$rfc)(We,ft,$t)),hi=We.set(o.$AK.ExtHostSCM,new Ye.$tfc(We,$t,It,Me)),Xi=We.set(o.$AK.ExtHostQuickDiff,new ue.$qfc(We,Ct)),Ai=We.set(o.$AK.ExtHostShare,new _e.$ufc(We,Ct)),Ri=We.set(o.$AK.ExtHostComments,(0,L.$3dc)(We,$t,It)),Mi=We.set(o.$AK.ExtHostProgress,new x.$pfc(We.getProxy(o.$zK.MainThreadProgress))),xi=We.set(o.$AK.ExtHosLabelService,new he.$dfc(We)),Li=We.set(o.$AK.ExtHostTheming,new He.$Ffc(We)),ui=We.set(o.$AK.ExtHostAuthentication,new a.$Tdc(We)),_i=We.set(o.$AK.ExtHostTimeline,new Xe.$Hfc(We,$t)),Fi=We.set(o.$AK.ExtHostWebviews,new Ut.$eec(We,gt.remote,ft,Me,K)),Ti=We.set(o.$AK.ExtHostWebviewPanels,new Ot.$hec(We,Fi,ft)),Ni=We.set(o.$AK.ExtHostCustomEditors,new Y.$iec(We,It,Jt,Fi,Ti)),Oi=We.set(o.$AK.ExtHostWebviewViews,new Gt.$Lfc(We,Fi)),di=We.set(o.$AK.ExtHostTesting,new Ee.$Bfc(We,$t,pt)),hn=We.set(o.$AK.ExtHostUriOpeners,new Kt.$Jfc(We)),en=We.set(o.$AK.ExtHostProfileContentHandlers,new q.$ofc(We));We.set(o.$AK.ExtHostInteractive,new ve.$bfc(We,Et,pt,$t,Me));const zi=We.set(o.$AK.ExtHostInlineChat,new ie.$1ec(We,$t,It,Me)),vi=We.set(o.$AK.ExtHostChatProvider,new S.$Wdc(We,Me)),tn=We.set(o.$AK.ExtHostChatAgents2,new m.$Xdc(We,vi,Me)),nn=We.set(o.$AK.ExtHostChatVariables,new k.$Ydc(We)),bi=We.set(o.$AK.ExtHostChat,new p.$Vdc(We)),wi=We.set(o.$AK.ExtHostAiRelatedInformation,new l.$Idc(We)),rn=We.set(o.$AK.ExtHostAiEmbeddingVector,new le.$Xec(We)),_t=We.set(o.$AK.ExtHostIssueReporter,new ne.$cfc(We)),fi=We.set(o.$AK.ExtHostStatusBar,new rt.$xfc(We,$t.converter)),dn=We.set(o.$AK.ExtHostSpeech,new et.$vfc(We)),Zt=Object.values(o.$AK);We.assertRegistered(Zt);const yi=new d.$Udc(We,pt),sn=new h.$Zdc(We),Ei=new te.$ffc(We,Me),Bi=new T.$Uec(We);return n.$Sdc.register($t),function(Te,ti,Ui){const mt=function(){let ee=!Te.isUnderDevelopment;function ge(){ee||(Me.info(`Extension '${Te.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ee=!0)}return function Fe(ot){if(Array.isArray(ot))ot.forEach(Fe);else if(typeof ot=="string")ge();else{const wt=ot;typeof wt.scheme>"u"&&ge(),typeof wt.exclusive=="boolean"&&(0,Ze.$NF)(Te,"documentFiltersExclusive")}return ot}}(),fn={getSession(ee,ge,Fe){return ui.getSession(Te,ee,ge,Fe)},getSessions(ee,ge){return(0,Ze.$NF)(Te,"authGetSessions"),ui.getSessions(Te,ee,ge)},async hasSession(ee,ge){return(0,Ze.$NF)(Te,"authSession"),!!await ui.getSession(Te,ee,ge,{silent:!0})},get onDidChangeSessions(){return ui.onDidChangeSessions},registerAuthenticationProvider(ee,ge,Fe,ot){return ui.registerAuthenticationProvider(ee,ge,Fe,ot)}},gn={registerCommand(ee,ge,Fe){return $t.registerCommand(!0,ee,ge,Fe,void 0,Te)},registerTextEditorCommand(ee,ge,Fe){return $t.registerCommand(!0,ee,(...ot)=>{const wt=Ft.getActiveTextEditor();if(!wt){Me.warn("Cannot execute "+ee+" because there is no active text editor.");return}return wt.edit(Tt=>{ge.apply(Fe,[wt,Tt,...ot])}).then(Tt=>{Tt||Me.warn("Edits from command "+ee+" were not applied.")},Tt=>{Me.warn("An error occurred while running command "+ee,Tt)})},void 0,void 0,Te)},registerDiffInformationCommand:(ee,ge,Fe)=>((0,Ze.$NF)(Te,"diffCommand"),$t.registerCommand(!0,ee,async(...ot)=>{const wt=pt.activeEditor(!0);if(!wt){Me.warn("Cannot execute "+ee+" because there is no active text editor.");return}const Tt=await Ft.getDiffInformation(wt.id);ge.apply(Fe,[Tt,...ot])},void 0,void 0,Te)),executeCommand(ee,...ge){return $t.executeCommand(ee,...ge)},getCommands(ee=!1){return $t.getCommands(ee)}},Di={get machineId(){return gt.telemetryInfo.machineId},get sessionId(){return gt.telemetryInfo.sessionId},get language(){return gt.environment.appLanguage},get appName(){return gt.environment.appName},get appRoot(){return gt.environment.appRoot?.fsPath??""},get appHost(){return gt.environment.appHost},get uriScheme(){return gt.environment.appUriScheme},get clipboard(){return sn.value},get shell(){return bt.getDefaultShell(!1)},get onDidChangeShell(){return bt.onDidChangeShell},get isTelemetryEnabled(){return kt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return kt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ze.$NF)(Te,"telemetry"),kt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ze.$NF)(Te,"telemetry"),kt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,X.$UM)(gt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ee,ge){return X.$TM.validateSender(ee),kt.instantiateLogger(Te,ee,ge)},openExternal(ee,ge){return Le.openUri(ee,{allowTunneling:!!gt.remote.authority,allowContributedOpeners:ge?.allowContributedOpeners})},async asExternalUri(ee){if(ee.scheme===gt.environment.appUriScheme)return ki.createAppUri(ee);try{return await Le.asExternalUri(ee,{allowTunneling:!!gt.remote.authority})}catch(ge){if((0,t.$QU)(ee,R.Schemas.http)||(0,t.$QU)(ee,R.Schemas.https))return ee;throw ge}},get remoteName(){return(0,i.$2k)(gt.remote.authority)},get remoteAuthority(){return(0,Ze.$NF)(Te,"resolvers"),gt.remote.authority},get uiKind(){return gt.uiKind},get logLevel(){return Me.getLevel()},get onDidChangeLogLevel(){return Me.onDidChangeLogLevel},registerIssueUriRequestHandler(ee){return(0,Ze.$NF)(Te,"handleIssueUri"),_t.registerIssueUriRequestHandler(Te,ee)},registerIssueDataProvider(ee){return(0,Ze.$NF)(Te,"handleIssueUri"),_t.registerIssueDataProvider(Te,ee)},get appQuality(){return(0,Ze.$NF)(Te,"resolvers"),gt.quality},get appCommit(){return(0,Ze.$NF)(Te,"resolvers"),gt.commit}};gt.environment.extensionTestsLocationURI||Object.freeze(Di);const on={createTestController(ee,ge,Fe){return di.createTestController(Te,ee,ge,Fe)},createTestObserver(){return(0,Ze.$NF)(Te,"testObserver"),di.createTestObserver()},runTests(ee){return(0,Ze.$NF)(Te,"testObserver"),di.runTests(ee)},get onDidChangeTestResults(){return(0,Ze.$NF)(Te,"testObserver"),di.onResultsChanged},get testResults(){return(0,Ze.$NF)(Te,"testObserver"),di.results}},gi=gt.remote.isRemote?Oe.ExtensionKind.Workspace:Oe.ExtensionKind.UI,an={getExtension(ee,ge){(0,Ze.$MF)(Te,"extensionsAny")||(ge=!1);const Fe=ti.mine.getExtensionDescription(ee);if(Fe)return new pe.$Jec(At,Te.identifier,Fe,gi,!1);if(ge){const ot=ti.all.getExtensionDescription(ee);if(ot)return new pe.$Jec(At,Te.identifier,ot,gi,!0)}},get all(){const ee=[];for(const ge of ti.mine.getAllExtensionDescriptions())ee.push(new pe.$Jec(At,Te.identifier,ge,gi,!1));return ee},get allAcrossExtensionHosts(){(0,Ze.$NF)(Te,"extensionsAny");const ee=new b.$am(ti.mine.getAllExtensionDescriptions().map(Fe=>Fe.identifier)),ge=[];for(const Fe of ti.all.getAllExtensionDescriptions()){const ot=!ee.has(Fe.identifier);ge.push(new pe.$Jec(At,Te.identifier,Fe,gi,ot))}return ge},get onDidChange(){return(0,Ze.$MF)(Te,"extensionsAny")?A.Event.any(ti.mine.onDidChange,ti.all.onDidChange):ti.mine.onDidChange}},mn={createDiagnosticCollection(ee){return ai.createDiagnosticCollection(Te.identifier,ee)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:ee=>ai.getDiagnostics(ee),getLanguages(){return ci.getLanguages()},setTextDocumentLanguage(ee,ge){return ci.changeLanguage(ee.uri,ge)},match(ee,ge){const Fe=It.getDocumentData(ge.uri)?.notebook;return(0,P.$LE)(Dt.LanguageSelector.from(ee),ge.uri,ge.languageId,!0,Fe?.uri,Fe?.notebookType)},registerCodeActionsProvider(ee,ge,Fe){return lt.registerCodeActionProvider(Te,mt(ee),ge,Fe)},registerDocumentPasteEditProvider(ee,ge,Fe){return(0,Ze.$NF)(Te,"documentPaste"),lt.registerDocumentPasteEditProvider(Te,mt(ee),ge,Fe)},registerCodeLensProvider(ee,ge){return lt.registerCodeLensProvider(Te,mt(ee),ge)},registerDefinitionProvider(ee,ge){return lt.registerDefinitionProvider(Te,mt(ee),ge)},registerDeclarationProvider(ee,ge){return lt.registerDeclarationProvider(Te,mt(ee),ge)},registerImplementationProvider(ee,ge){return lt.registerImplementationProvider(Te,mt(ee),ge)},registerTypeDefinitionProvider(ee,ge){return lt.registerTypeDefinitionProvider(Te,mt(ee),ge)},registerHoverProvider(ee,ge){return lt.registerHoverProvider(Te,mt(ee),ge,Te.identifier)},registerEvaluatableExpressionProvider(ee,ge){return lt.registerEvaluatableExpressionProvider(Te,mt(ee),ge,Te.identifier)},registerInlineValuesProvider(ee,ge){return lt.registerInlineValuesProvider(Te,mt(ee),ge,Te.identifier)},registerDocumentHighlightProvider(ee,ge){return lt.registerDocumentHighlightProvider(Te,mt(ee),ge)},registerLinkedEditingRangeProvider(ee,ge){return lt.registerLinkedEditingRangeProvider(Te,mt(ee),ge)},registerReferenceProvider(ee,ge){return lt.registerReferenceProvider(Te,mt(ee),ge)},registerRenameProvider(ee,ge){return lt.registerRenameProvider(Te,mt(ee),ge)},registerDocumentSymbolProvider(ee,ge,Fe){return lt.registerDocumentSymbolProvider(Te,mt(ee),ge,Fe)},registerWorkspaceSymbolProvider(ee){return lt.registerWorkspaceSymbolProvider(Te,ee)},registerDocumentFormattingEditProvider(ee,ge){return lt.registerDocumentFormattingEditProvider(Te,mt(ee),ge)},registerDocumentRangeFormattingEditProvider(ee,ge){return lt.registerDocumentRangeFormattingEditProvider(Te,mt(ee),ge)},registerOnTypeFormattingEditProvider(ee,ge,Fe,...ot){return lt.registerOnTypeFormattingEditProvider(Te,mt(ee),ge,[Fe].concat(ot))},registerDocumentSemanticTokensProvider(ee,ge,Fe){return lt.registerDocumentSemanticTokensProvider(Te,mt(ee),ge,Fe)},registerDocumentRangeSemanticTokensProvider(ee,ge,Fe){return lt.registerDocumentRangeSemanticTokensProvider(Te,mt(ee),ge,Fe)},registerSignatureHelpProvider(ee,ge,Fe,...ot){return typeof Fe=="object"?lt.registerSignatureHelpProvider(Te,mt(ee),ge,Fe):lt.registerSignatureHelpProvider(Te,mt(ee),ge,typeof Fe>"u"?[]:[Fe,...ot])},registerCompletionItemProvider(ee,ge,...Fe){return lt.registerCompletionItemProvider(Te,mt(ee),ge,Fe)},registerInlineCompletionItemProvider(ee,ge,Fe){return ge.handleDidShowCompletionItem&&(0,Ze.$NF)(Te,"inlineCompletionsAdditions"),ge.handleDidPartiallyAcceptCompletionItem&&(0,Ze.$NF)(Te,"inlineCompletionsAdditions"),Fe&&(0,Ze.$NF)(Te,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider(Te,mt(ee),ge,Fe)},registerDocumentLinkProvider(ee,ge){return lt.registerDocumentLinkProvider(Te,mt(ee),ge)},registerColorProvider(ee,ge){return lt.registerColorProvider(Te,mt(ee),ge)},registerFoldingRangeProvider(ee,ge){return lt.registerFoldingRangeProvider(Te,mt(ee),ge)},registerSelectionRangeProvider(ee,ge){return lt.registerSelectionRangeProvider(Te,ee,ge)},registerCallHierarchyProvider(ee,ge){return lt.registerCallHierarchyProvider(Te,ee,ge)},registerTypeHierarchyProvider(ee,ge){return lt.registerTypeHierarchyProvider(Te,ee,ge)},setLanguageConfiguration:(ee,ge)=>lt.setLanguageConfiguration(Te,ee,ge),getTokenInformationAtPosition(ee,ge){return(0,Ze.$NF)(Te,"tokenInformation"),ci.tokenAtPosition(ee,ge)},registerInlayHintsProvider(ee,ge){return lt.registerInlayHintsProvider(Te,ee,ge)},createLanguageStatusItem(ee,ge){return ci.createLanguageStatusItem(Te,ee,ge)},registerDocumentDropEditProvider(ee,ge,Fe){return lt.registerDocumentOnDropEditProvider(Te,ee,ge,(0,Ze.$MF)(Te,"dropMetadata")?Fe:void 0)}},$n={get activeTextEditor(){return Ft.getActiveTextEditor()},get visibleTextEditors(){return Ft.getVisibleTextEditors()},get activeTerminal(){return bt.activeTerminal},get terminals(){return bt.terminals},async showTextDocument(ee,ge,Fe){const ot=await(E.URI.isUri(ee)?Promise.resolve(ji.openTextDocument(ee)):Promise.resolve(ee));return Ft.showTextDocument(ot,ge,Fe)},createTextEditorDecorationType(ee){return Ft.createTextEditorDecorationType(Te,ee)},onDidChangeActiveTextEditor(ee,ge,Fe){return Ft.onDidChangeActiveTextEditor(ee,ge,Fe)},onDidChangeVisibleTextEditors(ee,ge,Fe){return Ft.onDidChangeVisibleTextEditors(ee,ge,Fe)},onDidChangeTextEditorSelection(ee,ge,Fe){return Ft.onDidChangeTextEditorSelection(ee,ge,Fe)},onDidChangeTextEditorOptions(ee,ge,Fe){return Ft.onDidChangeTextEditorOptions(ee,ge,Fe)},onDidChangeTextEditorVisibleRanges(ee,ge,Fe){return Ft.onDidChangeTextEditorVisibleRanges(ee,ge,Fe)},onDidChangeTextEditorViewColumn(ee,ge,Fe){return Ft.onDidChangeTextEditorViewColumn(ee,ge,Fe)},onDidCloseTerminal(ee,ge,Fe){return bt.onDidCloseTerminal(ee,ge,Fe)},onDidOpenTerminal(ee,ge,Fe){return bt.onDidOpenTerminal(ee,ge,Fe)},onDidChangeActiveTerminal(ee,ge,Fe){return bt.onDidChangeActiveTerminal(ee,ge,Fe)},onDidChangeTerminalDimensions(ee,ge,Fe){return(0,Ze.$NF)(Te,"terminalDimensions"),bt.onDidChangeTerminalDimensions(ee,ge,Fe)},onDidChangeTerminalState(ee,ge,Fe){return bt.onDidChangeTerminalState(ee,ge,Fe)},onDidWriteTerminalData(ee,ge,Fe){return(0,Ze.$NF)(Te,"terminalDataWriteEvent"),bt.onDidWriteTerminalData(ee,ge,Fe)},onDidExecuteTerminalCommand(ee,ge,Fe){return(0,Ze.$NF)(Te,"terminalExecuteCommandEvent"),bt.onDidExecuteTerminalCommand(ee,ge,Fe)},get state(){return Le.getState(Te)},onDidChangeWindowState(ee,ge,Fe){return Le.onDidChangeWindowState(ee,ge,Fe)},showInformationMessage(ee,...ge){return Ei.showMessage(Te,$.default.Info,ee,ge[0],ge.slice(1))},showWarningMessage(ee,...ge){return Ei.showMessage(Te,$.default.Warning,ee,ge[0],ge.slice(1))},showErrorMessage(ee,...ge){return Ei.showMessage(Te,$.default.Error,ee,ge[0],ge.slice(1))},showQuickPick(ee,ge,Fe){return ni.showQuickPick(Te,ee,ge,Fe)},showWorkspaceFolderPick(ee){return ni.showWorkspaceFolderPick(ee)},showInputBox(ee,ge){return ni.showInput(ee,ge)},showOpenDialog(ee){return Bi.showOpenDialog(Te,ee)},showSaveDialog(ee){return Bi.showSaveDialog(ee)},createStatusBarItem(ee,ge,Fe){let ot,wt,Tt;return typeof ee=="string"?(ot=ee,wt=ge,Tt=Fe):(wt=ee,Tt=ge),fi.createStatusBarEntry(Te,ot,wt,Tt)},setStatusBarMessage(ee,ge){return fi.setStatusBarMessage(ee,ge)},withScmProgress(ee){return K.report("window.withScmProgress",Te,"Use 'withProgress' instead."),Mi.withProgress(Te,{location:Oe.ProgressLocation.SourceControl},(ge,Fe)=>ee({report(ot){}}))},withProgress(ee,ge){return Mi.withProgress(Te,ee,ge)},createOutputChannel(ee,ge){return Xt.createOutputChannel(ee,ge,Te)},createWebviewPanel(ee,ge,Fe,ot){return Ti.createWebviewPanel(Te,ee,ge,Fe,ot)},createWebviewTextEditorInset(ee,ge,Fe,ot){return(0,Ze.$NF)(Te,"editorInsets"),Ci.createWebviewEditorInset(ee,ge,Fe,ot,Te)},createTerminal(ee,ge,Fe){return typeof ee=="object"?"pty"in ee?bt.createExtensionTerminal(ee):bt.createTerminalFromOptions(ee):bt.createTerminal(ee,ge,Fe)},registerTerminalLinkProvider(ee){return bt.registerLinkProvider(ee)},registerTerminalProfileProvider(ee,ge){return bt.registerProfileProvider(Te,ee,ge)},registerTerminalQuickFixProvider(ee,ge){return(0,Ze.$NF)(Te,"terminalQuickFixProvider"),bt.registerTerminalQuickFixProvider(ee,Te.identifier.value,ge)},registerTreeDataProvider(ee,ge){return pi.registerTreeDataProvider(ee,ge,Te)},createTreeView(ee,ge){return pi.createTreeView(ee,ge,Te)},registerWebviewPanelSerializer:(ee,ge)=>Ti.registerWebviewPanelSerializer(Te,ee,ge),registerCustomEditorProvider:(ee,ge,Fe={})=>Ni.registerCustomEditorProvider(Te,ee,ge,Fe),registerFileDecorationProvider(ee){return it.registerFileDecorationProvider(ee,Te)},registerUriHandler(ee){return ki.registerUriHandler(Te,ee)},createQuickPick(){return ni.createQuickPick(Te)},createInputBox(){return ni.createInputBox(Te)},get activeColorTheme(){return Li.activeColorTheme},onDidChangeActiveColorTheme(ee,ge,Fe){return Li.onDidChangeActiveColorTheme(ee,ge,Fe)},registerWebviewViewProvider(ee,ge,Fe){return Oi.registerWebviewViewProvider(Te,ee,ge,Fe?.webviewOptions)},get activeNotebookEditor(){return Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(ee,ge,Fe){return Et.onDidChangeActiveNotebookEditor(ee,ge,Fe)},get visibleNotebookEditors(){return Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ee,ge,Fe){return $i.onDidChangeNotebookEditorSelection(ee,ge,Fe)},onDidChangeNotebookEditorVisibleRanges(ee,ge,Fe){return $i.onDidChangeNotebookEditorVisibleRanges(ee,ge,Fe)},showNotebookDocument(ee,ge){return Et.showNotebookDocument(ee,ge)},registerExternalUriOpener(ee,ge,Fe){return(0,Ze.$NF)(Te,"externalUriOpener"),hn.registerExternalUriOpener(Te.identifier,ee,ge,Fe)},registerProfileContentHandler(ee,ge){return(0,Ze.$NF)(Te,"profileContentHandlers"),en.registrProfileContentHandler(Te,ee,ge)},registerQuickDiffProvider(ee,ge,Fe,ot){return(0,Ze.$NF)(Te,"quickDiffProvider"),Xi.registerQuickDiffProvider(mt(ee),ge,Fe,ot)},get tabGroups(){return Qe.tabGroups},registerShareProvider(ee,ge){return(0,Ze.$NF)(Te,"shareProvider"),Ai.registerShareProvider(mt(ee),ge)}},ji={get rootPath(){return K.report("workspace.rootPath",Te,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(ee){throw new F.$8("rootPath")},getWorkspaceFolder(ee){return ft.getWorkspaceFolder(ee)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(ee){throw new F.$8("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile(ee){throw new F.$8("workspaceFile")},updateWorkspaceFolders:(ee,ge,...Fe)=>ft.updateWorkspaceFolders(Te,ee,ge||0,...Fe),onDidChangeWorkspaceFolders:function(ee,ge,Fe){return ft.onDidChangeWorkspace(ee,ge,Fe)},asRelativePath:(ee,ge)=>ft.getRelativePath(ee,ge),findFiles:(ee,ge,Fe,ot)=>ft.findFiles(ee,ge,Fe,Te.identifier,ot),findTextInFiles:(ee,ge,Fe,ot)=>{(0,Ze.$NF)(Te,"findTextInFiles");let wt,Tt;return typeof ge=="object"?(wt=ge,Tt=Fe):(wt={},Tt=ge,ot=Fe),ft.findTextInFiles(ee,wt||{},Tt,Te.identifier,ot)},save:ee=>((0,Ze.$NF)(Te,"saveEditor"),ft.save(ee)),saveAs:ee=>((0,Ze.$NF)(Te,"saveEditor"),ft.saveAs(ee)),saveAll:ee=>ft.saveAll(ee),applyEdit(ee,ge){return yi.applyWorkspaceEdit(ee,Te,ge)},createFileSystemWatcher:(ee,ge,Fe,ot)=>{let wt;return typeof ge=="boolean"?wt={ignoreCreateEvents:!!ge,ignoreChangeEvents:!!Fe,ignoreDeleteEvents:!!ot,correlate:!1}:ge&&((0,Ze.$NF)(Te,"createFileSystemWatcher"),wt={...ge,correlate:!0}),xt.createFileSystemWatcher(ft,Te,ee,wt)},get textDocuments(){return It.getAllDocumentData().map(ee=>ee.document)},set textDocuments(ee){throw new F.$8("textDocuments")},openTextDocument(ee){let ge;const Fe=ee;if(typeof ee=="string")ge=Promise.resolve(E.URI.file(ee));else if(E.URI.isUri(ee))ge=Promise.resolve(ee);else if(!Fe||typeof Fe=="object")ge=It.createDocumentData(Fe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ge.then(ot=>It.ensureDocumentData(ot).then(wt=>wt.document))},onDidOpenTextDocument:(ee,ge,Fe)=>It.onDidAddDocument(ee,ge,Fe),onDidCloseTextDocument:(ee,ge,Fe)=>It.onDidRemoveDocument(ee,ge,Fe),onDidChangeTextDocument:(ee,ge,Fe)=>It.onDidChangeDocument(ee,ge,Fe),onDidSaveTextDocument:(ee,ge,Fe)=>It.onDidSaveDocument(ee,ge,Fe),onWillSaveTextDocument:(ee,ge,Fe)=>ln.getOnWillSaveTextDocumentEvent(Te)(ee,ge,Fe),get notebookDocuments(){return Et.notebookDocuments.map(ee=>ee.apiNotebook)},async openNotebookDocument(ee,ge){let Fe;if(E.URI.isUri(ee))Fe=ee,await Et.openNotebookDocument(ee);else if(typeof ee=="string")Fe=E.URI.revive(await Et.createNotebookDocument({viewType:ee,content:ge}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Fe).apiNotebook},onDidSaveNotebookDocument(ee,ge,Fe){return mi.onDidSaveNotebookDocument(ee,ge,Fe)},onDidChangeNotebookDocument(ee,ge,Fe){return mi.onDidChangeNotebookDocument(ee,ge,Fe)},onWillSaveNotebookDocument(ee,ge,Fe){return Ii.getOnWillSaveNotebookDocumentEvent(Te)(ee,ge,Fe)},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(ee,ge,Fe,ot){return Et.registerNotebookSerializer(Te,ee,ge,Fe,(0,Ze.$MF)(Te,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(ee,ge,Fe)=>Ui.onDidChangeConfiguration(ee,ge,Fe),getConfiguration(ee,ge){return ge=arguments.length===1?void 0:ge,Ui.getConfiguration(ee,ge,Te)},registerTextDocumentContentProvider(ee,ge){return Yi.registerTextDocumentContentProvider(ee,ge)},registerTaskProvider:(ee,ge)=>(K.report("window.registerTaskProvider",Te,"Use the corresponding function on the 'tasks' namespace instead"),Qt.registerTaskProvider(Te,ee,ge)),registerFileSystemProvider(ee,ge,Fe){return(0,M.$Oc)(Pi.registerFileSystemProvider(Te,ee,ge,Fe),Pt.addFileSystemProvider(ee,ge,Fe))},get fs(){return Pt.value},registerFileSearchProvider:(ee,ge)=>((0,Ze.$NF)(Te,"fileSearchProvider"),Mt.registerFileSearchProvider(ee,ge)),registerTextSearchProvider:(ee,ge)=>((0,Ze.$NF)(Te,"textSearchProvider"),Mt.registerTextSearchProvider(ee,ge)),registerRemoteAuthorityResolver:(ee,ge)=>((0,Ze.$NF)(Te,"resolvers"),At.registerRemoteAuthorityResolver(ee,ge)),registerResourceLabelFormatter:ee=>((0,Ze.$NF)(Te,"resolvers"),xi.$registerResourceLabelFormatter(ee)),getRemoteExecServer:ee=>((0,Ze.$NF)(Te,"resolvers"),At.getRemoteExecServer(ee)),onDidCreateFiles:(ee,ge,Fe)=>xt.onDidCreateFile(ee,ge,Fe),onDidDeleteFiles:(ee,ge,Fe)=>xt.onDidDeleteFile(ee,ge,Fe),onDidRenameFiles:(ee,ge,Fe)=>xt.onDidRenameFile(ee,ge,Fe),onWillCreateFiles:(ee,ge,Fe)=>xt.getOnWillCreateFileEvent(Te)(ee,ge,Fe),onWillDeleteFiles:(ee,ge,Fe)=>xt.getOnWillDeleteFileEvent(Te)(ee,ge,Fe),onWillRenameFiles:(ee,ge,Fe)=>xt.getOnWillRenameFileEvent(Te)(ee,ge,Fe),openTunnel:ee=>((0,Ze.$NF)(Te,"tunnels"),be.openTunnel(Te,ee).then(ge=>{if(!ge)throw new Error("cannot open tunnel");return ge})),get tunnels(){return(0,Ze.$NF)(Te,"tunnels"),be.getTunnels()},onDidChangeTunnels:(ee,ge,Fe)=>((0,Ze.$NF)(Te,"tunnels"),be.onDidChangeTunnels(ee,ge,Fe)),registerPortAttributesProvider:(ee,ge)=>((0,Ze.$NF)(Te,"portsAttributes"),be.registerPortsAttributesProvider(ee,ge)),registerTunnelProvider:(ee,ge)=>((0,Ze.$NF)(Te,"tunnelFactory"),be.registerTunnelProvider(ee,ge)),registerTimelineProvider:(ee,ge)=>((0,Ze.$NF)(Te,"timeline"),_i.registerTimelineProvider(ee,ge,Te.identifier,$t.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:ee=>((0,Ze.$NF)(Te,"workspaceTrust"),ft.requestWorkspaceTrust(ee)),onDidGrantWorkspaceTrust:(ee,ge,Fe)=>ft.onDidGrantWorkspaceTrust(ee,ge,Fe),registerEditSessionIdentityProvider:(ee,ge)=>((0,Ze.$NF)(Te,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(ee,ge)),onWillCreateEditSessionIdentity:(ee,ge,Fe)=>((0,Ze.$NF)(Te,"editSessionIdentityProvider"),ft.getOnWillCreateEditSessionIdentityEvent(Te)(ee,ge,Fe)),registerCanonicalUriProvider:(ee,ge)=>((0,Ze.$NF)(Te,"canonicalUriProvider"),ft.registerCanonicalUriProvider(ee,ge)),getCanonicalUri:(ee,ge,Fe)=>((0,Ze.$NF)(Te,"canonicalUriProvider"),ft.provideCanonicalUri(ee,ge,Fe))},cn={get inputBox(){return K.report("scm.inputBox",Te,"Use 'SourceControl.inputBox' instead"),hi.getLastInputBox(Te)},createSourceControl(ee,ge,Fe){return hi.createSourceControl(Te,ee,ge,Fe)},registerSourceControlInputBoxValueProvider(ee){return(0,Ze.$NF)(Te,"scmInputBoxValueProvider"),hi.registerSourceControlInputBoxValueProvider(Te,ee)}},Vi={createCommentController(ee,ge){return Ri.createCommentController(Te,ee,ge)}},Wi={get activeDebugSession(){return ut.activeDebugSession},get activeDebugConsole(){return ut.activeDebugConsole},get breakpoints(){return ut.breakpoints},get stackFrameFocus(){return ut.stackFrameFocus},onDidStartDebugSession(ee,ge,Fe){return ut.onDidStartDebugSession(ee,ge,Fe)},onDidTerminateDebugSession(ee,ge,Fe){return ut.onDidTerminateDebugSession(ee,ge,Fe)},onDidChangeActiveDebugSession(ee,ge,Fe){return ut.onDidChangeActiveDebugSession(ee,ge,Fe)},onDidReceiveDebugSessionCustomEvent(ee,ge,Fe){return ut.onDidReceiveDebugSessionCustomEvent(ee,ge,Fe)},onDidChangeBreakpoints(ee,ge,Fe){return ut.onDidChangeBreakpoints(ee,ge,Fe)},onDidChangeStackFrameFocus(ee,ge,Fe){return(0,Ze.$NF)(Te,"debugFocus"),ut.onDidChangeStackFrameFocus(ee,ge,Fe)},registerDebugConfigurationProvider(ee,ge,Fe){return ut.registerDebugConfigurationProvider(ee,ge,Fe||Lt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ee,ge){return ut.registerDebugAdapterDescriptorFactory(Te,ee,ge)},registerDebugAdapterTrackerFactory(ee,ge){return ut.registerDebugAdapterTrackerFactory(ee,ge)},startDebugging(ee,ge,Fe){return!Fe||typeof Fe=="object"&&"configuration"in Fe?ut.startDebugging(ee,ge,{parentSession:Fe}):ut.startDebugging(ee,ge,Fe||{})},stopDebugging(ee){return ut.stopDebugging(ee)},addBreakpoints(ee){return ut.addBreakpoints(ee)},removeBreakpoints(ee){return ut.removeBreakpoints(ee)},asDebugSourceUri(ee,ge){return ut.asDebugSourceUri(ee,ge)}},qi={registerTaskProvider:(ee,ge)=>Qt.registerTaskProvider(Te,ee,ge),fetchTasks:ee=>Qt.fetchTasks(ee),executeTask:ee=>Qt.executeTask(Te,ee),get taskExecutions(){return Qt.taskExecutions},onDidStartTask:(ee,ge,Fe)=>Qt.onDidStartTask(ee,ge,Fe),onDidEndTask:(ee,ge,Fe)=>Qt.onDidEndTask(ee,ge,Fe),onDidStartTaskProcess:(ee,ge,Fe)=>Qt.onDidStartTaskProcess(ee,ge,Fe),onDidEndTaskProcess:(ee,ge,Fe)=>Qt.onDidEndTaskProcess(ee,ge,Fe)},li={createNotebookController(ee,ge,Fe,ot,wt){return oi.createNotebookController(Te,ee,ge,Fe,ot,(0,Ze.$MF)(Te,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(ee,ge)=>Et.registerNotebookCellStatusBarItemProvider(Te,ee,ge),createRendererMessaging(ee){return Si.createRendererMessaging(Te,ee)},createNotebookControllerDetectionTask(ee){return(0,Ze.$NF)(Te,"notebookKernelSource"),oi.createNotebookControllerDetectionTask(Te,ee)},registerKernelSourceActionProvider(ee,ge){return(0,Ze.$NF)(Te,"notebookKernelSource"),oi.registerKernelSourceActionProvider(Te,ee,ge)},onDidChangeNotebookCellExecutionState(ee,ge,Fe){return(0,Ze.$NF)(Te,"notebookCellExecutionState"),oi.onDidChangeNotebookCellExecutionState(ee,ge,Fe)}},Ki={t(...ee){if(typeof ee[0]=="string"){const ge=ee.shift(),Fe=!ee||typeof ee[0]!="object"?ee:ee[0];return si.getMessage(Te.identifier.value,{message:ge,args:Fe})}return si.getMessage(Te.identifier.value,ee[0])},get bundle(){return si.getBundle(Te.identifier.value)},get uri(){return si.getBundleUri(Te.identifier.value)}},Hi={_version:1,registerInteractiveEditorSessionProvider(ee,ge){return(0,Ze.$NF)(Te,"interactive"),zi.registerProvider(Te,ee,ge)},registerInteractiveSessionProvider(ee,ge){return(0,Ze.$NF)(Te,"interactive"),bi.registerChatProvider(Te,ee,ge)},sendInteractiveRequestToProvider(ee,ge){return(0,Ze.$NF)(Te,"interactive"),bi.sendInteractiveRequestToProvider(ee,ge)},get onDidPerformUserAction(){return(0,Ze.$NF)(Te,"interactiveUserActions"),bi.onDidPerformUserAction},transferChatSession(ee,ge){return(0,Ze.$NF)(Te,"interactive"),bi.transferChatSession(ee,ge)}},Gi={getRelatedInformation(ee,ge){return(0,Ze.$NF)(Te,"aiRelatedInformation"),wi.getRelatedInformation(Te,ee,ge)},registerRelatedInformationProvider(ee,ge){return(0,Ze.$NF)(Te,"aiRelatedInformation"),wi.registerRelatedInformationProvider(Te,ee,ge)},registerEmbeddingVectorProvider(ee,ge){return(0,Ze.$NF)(Te,"aiRelatedInformation"),rn.registerEmbeddingVectorProvider(Te,ee,ge)}},Ji={registerChatResponseProvider(ee,ge,Fe){return(0,Ze.$NF)(Te,"chatProvider"),vi.registerProvider(Te.identifier,ee,ge,Fe)},requestChatAccess(ee){return(0,Ze.$NF)(Te,"chatRequestAccess"),vi.requestChatResponseProvider(Te.identifier,ee)},registerVariable(ee,ge,Fe){return(0,Ze.$NF)(Te,"chatVariables"),nn.registerVariableResolver(Te,ee,ge,Fe)},registerMappedEditsProvider(ee,ge){return(0,Ze.$NF)(Te,"mappedEditsProvider"),lt.registerMappedEditsProvider(Te,ee,ge)},createChatAgent(ee,ge){return(0,Ze.$NF)(Te,"chatAgents2"),tn.createChatAgent(Te,ee,ge)}},un={registerSpeechProvider(ee,ge){return(0,Ze.$NF)(Te,"speech"),dn.registerProvider(Te.identifier,ee,ge)}};return{version:gt.version,ai:Gi,authentication:fn,commands:gn,comments:Vi,chat:Ji,debug:Wi,env:Di,extensions:an,interactive:Hi,l10n:Ki,languages:mn,notebooks:li,scm:cn,speech:un,tasks:qi,tests:on,window:$n,workspace:ji,Breakpoint:Oe.$zL,TerminalOutputAnchor:Oe.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Oe.ChatAgentResultFeedbackKind,ChatMessage:Oe.$qM,ChatMessageRole:Oe.ChatMessageRole,ChatVariableLevel:Oe.ChatVariableLevel,CallHierarchyIncomingCall:Oe.$YK,CallHierarchyItem:Oe.$XK,CallHierarchyOutgoingCall:Oe.$ZK,CancellationError:F.$4,CancellationTokenSource:y.$2d,CandidatePortSource:o.CandidatePortSource,CodeAction:Oe.$UK,CodeActionKind:Oe.$VK,CodeActionTriggerKind:Oe.CodeActionTriggerKind,CodeLens:Oe.$1K,Color:Oe.$bL,ColorInformation:Oe.$cL,ColorPresentation:Oe.$dL,ColorThemeKind:Oe.ColorThemeKind,CommentMode:Oe.CommentMode,CommentState:Oe.CommentState,CommentThreadCollapsibleState:Oe.CommentThreadCollapsibleState,CommentThreadState:Oe.CommentThreadState,CompletionItem:Oe.$8K,CompletionItemKind:Oe.CompletionItemKind,CompletionItemTag:Oe.CompletionItemTag,CompletionList:Oe.$9K,CompletionTriggerKind:Oe.CompletionTriggerKind,ConfigurationTarget:Oe.ConfigurationTarget,CustomExecution:Oe.$lL,DebugAdapterExecutable:Oe.$DL,DebugAdapterInlineImplementation:Oe.$GL,DebugAdapterNamedPipeServer:Oe.$FL,DebugAdapterServer:Oe.$EL,DebugConfigurationProviderTriggerKind:Lt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Oe.DebugConsoleMode,DecorationRangeBehavior:Oe.DecorationRangeBehavior,Diagnostic:Oe.$PK,DiagnosticRelatedInformation:Oe.$OK,DiagnosticSeverity:Oe.DiagnosticSeverity,DiagnosticTag:Oe.DiagnosticTag,Disposable:Oe.$BK,DocumentHighlight:Oe.$RK,DocumentHighlightKind:Oe.DocumentHighlightKind,DocumentLink:Oe.$aL,DocumentSymbol:Oe.$TK,EndOfLine:Oe.EndOfLine,EnvironmentVariableMutatorType:Oe.EnvironmentVariableMutatorType,EvaluatableExpression:Oe.$JL,InlineValueText:Oe.$KL,InlineValueVariableLookup:Oe.$LL,InlineValueEvaluatableExpression:Oe.$ML,InlineCompletionTriggerKind:Oe.InlineCompletionTriggerKind,EventEmitter:A.$Rd,ExtensionKind:Oe.ExtensionKind,ExtensionMode:Oe.ExtensionMode,ExternalUriOpenerPriority:Oe.ExternalUriOpenerPriority,FileChangeType:Oe.FileChangeType,FileDecoration:Oe.$WL,FileDecoration2:Oe.$WL,FileSystemError:Oe.$OL,FileType:v.FileType,FilePermission:v.FilePermission,FoldingRange:Oe.$PL,FoldingRangeKind:Oe.FoldingRangeKind,FunctionBreakpoint:Oe.$BL,InlineCompletionItem:Oe.$0K,InlineCompletionList:Oe.$$K,Hover:Oe.$QK,IndentAction:D.IndentAction,Location:Oe.$NK,MarkdownString:Oe.$2K,OverviewRulerLane:u.OverviewRulerLane,ParameterInformation:Oe.$3K,PortAutoForwardAction:Oe.PortAutoForwardAction,Position:Oe.$CK,ProcessExecution:Oe.$jL,ProgressLocation:Oe.ProgressLocation,QuickInputButtons:Oe.$VL,Range:Oe.$DK,RelativePattern:Oe.$xL,Selection:Oe.$EK,SelectionRange:Oe.$WK,SemanticTokens:Oe.$SL,SemanticTokensBuilder:Oe.$RL,SemanticTokensEdit:Oe.$TL,SemanticTokensEdits:Oe.$UL,SemanticTokensLegend:Oe.$QL,ShellExecution:Oe.$kL,ShellQuoting:Oe.ShellQuoting,SignatureHelp:Oe.$5K,SignatureHelpTriggerKind:Oe.SignatureHelpTriggerKind,SignatureInformation:Oe.$4K,SnippetString:Oe.$MK,SourceBreakpoint:Oe.$AL,StandardTokenType:Oe.StandardTokenType,StatusBarAlignment:Oe.StatusBarAlignment,SymbolInformation:Oe.$SK,SymbolKind:Oe.SymbolKind,SymbolTag:Oe.SymbolTag,Task:Oe.$mL,TaskGroup:Oe.$iL,TaskPanelKind:Oe.TaskPanelKind,TaskRevealKind:Oe.TaskRevealKind,TaskScope:Oe.TaskScope,TerminalLink:Oe.$eL,TerminalQuickFixExecuteTerminalCommand:Oe.$gL,TerminalQuickFixOpener:Oe.$fL,TerminalLocation:Oe.TerminalLocation,TerminalProfile:Oe.$hL,TerminalExitReason:Oe.TerminalExitReason,TextDocumentSaveReason:Oe.TextDocumentSaveReason,TextEdit:Oe.$IK,SnippetTextEdit:Oe.$KK,TextEditorCursorStyle:f.TextEditorCursorStyle,TextEditorLineNumbersStyle:Oe.TextEditorLineNumbersStyle,TextEditorRevealType:Oe.TextEditorRevealType,TextEditorSelectionChangeKind:Oe.TextEditorSelectionChangeKind,SyntaxTokenType:Oe.SyntaxTokenType,TextDocumentChangeReason:Oe.TextDocumentChangeReason,ThemeColor:Oe.$wL,ThemeIcon:Oe.$vL,TreeItem:Oe.$nL,TreeItemCheckboxState:Oe.TreeItemCheckboxState,TreeItemCollapsibleState:Oe.TreeItemCollapsibleState,TypeHierarchyItem:Oe.$fM,UIKind:Vt.UIKind,Uri:E.URI,ViewColumn:Oe.ViewColumn,WorkspaceEdit:Oe.$LK,DocumentDropEdit:Oe.$tL,DocumentPasteEdit:Oe.$uL,InlayHint:Oe.$7K,InlayHintLabelPart:Oe.$6K,InlayHintKind:Oe.InlayHintKind,RemoteAuthorityResolverError:Oe.$HK,ResolvedAuthority:Oe.$FK,ManagedResolvedAuthority:Oe.$GK,SourceControlInputBoxValidationType:Oe.SourceControlInputBoxValidationType,ExtensionRuntime:Oe.ExtensionRuntime,TimelineItem:Oe.$7L,NotebookRange:Oe.$YL,NotebookCellKind:Oe.NotebookCellKind,NotebookCellExecutionState:Oe.NotebookCellExecutionState,NotebookCellData:Oe.$ZL,NotebookData:Oe.$1L,NotebookRendererScript:Oe.$5L,NotebookCellStatusBarAlignment:Oe.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Oe.NotebookEditorRevealType,NotebookCellOutput:Oe.$3L,NotebookCellOutputItem:Oe.$2L,NotebookCellStatusBarItem:Oe.$4L,NotebookControllerAffinity:Oe.NotebookControllerAffinity,NotebookControllerAffinity2:Oe.NotebookControllerAffinity2,NotebookEdit:Oe.$JK,NotebookKernelSourceAction:Oe.$6L,PortAttributes:Oe.$9L,LinkedEditingRanges:Oe.$8L,TestResultState:Oe.TestResultState,TestRunRequest:Oe.$0L,TestMessage:Oe.$$L,TestMessage2:Oe.$$L,TestTag:Oe.$_L,TestRunProfileKind:Oe.TestRunProfileKind,TextSearchCompleteMessageType:Wt.TextSearchCompleteMessageType,DataTransfer:Oe.$sL,DataTransferItem:Oe.$oL,CoveredCount:Oe.$aM,FileCoverage:Oe.$bM,StatementCoverage:Oe.$cM,BranchCoverage:Oe.$dM,FunctionCoverage:Oe.$eM,WorkspaceTrustState:Oe.WorkspaceTrustState,LanguageStatusSeverity:Oe.LanguageStatusSeverity,QuickPickItemKind:Oe.QuickPickItemKind,InputBoxValidationSeverity:Oe.InputBoxValidationSeverity,TabInputText:Oe.$gM,TabInputTextDiff:Oe.$hM,TabInputTextMerge:Oe.$iM,TabInputCustom:Oe.$jM,TabInputNotebook:Oe.$lM,TabInputNotebookDiff:Oe.$mM,TabInputWebview:Oe.$kM,TabInputTerminal:Oe.$nM,TabInputInteractiveWindow:Oe.$oM,TabInputChat:Oe.$pM,TelemetryTrustedValue:r.$po,LogLevel:g.LogLevel,EditSessionIdentityMatch:c.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Oe.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:Oe.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:Oe.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Oe.$HL,ThreadFocus:Oe.$IL,RelatedInformationType:Oe.RelatedInformationType,SpeechToTextStatus:Oe.SpeechToTextStatus}}}e.$Ofc=qt}),define(Ae[291],Re([1,0,70,112,35,110,36,32,61,64,115,117,118,85,87,81,111,63,42,84,59,62,256,15,116,82,83]),function(we,e,y,F,A,M,R,$,E,f,P,D,u,b,v,g,t,i,r,c,o,l,n,s,a,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,y.$Cr)(d.$Dec,d.$Cec,1),(0,y.$Cr)(s.$ej,n.$Pfc,1),(0,y.$Cr)(g.$Odc,g.$Pdc,1),(0,y.$Cr)($.$XM,$.$WM,0),(0,y.$Cr)(R.$0dc,R.$8dc,0),(0,y.$Cr)(i.$_dc,i.$$dc,0),(0,y.$Cr)(D.$Nec,D.$Rec,0),(0,y.$Cr)(M.$Tec,M.$Sec,0),(0,y.$Cr)(E.$MM,E.$LM,0),(0,y.$Cr)(p.$Eec,p.$Fec,0),(0,y.$Cr)(r.$Ldc,r.$Kdc,0),(0,y.$Cr)(F.$nfc,F.$mfc,1),(0,y.$Cr)(u.$0ec,u.$$ec,0),(0,y.$Cr)(b.$sec,b.$rec,0),(0,y.$Cr)(P.$Afc,P.$zfc,0),(0,y.$Cr)(f.$vec,f.$yec,0),(0,y.$Cr)(v.$Pwb,v.$Qwb,0),(0,y.$Cr)(t.$Nfc,t.$Mfc,0),(0,y.$Cr)(A.$7dc,A.$6dc,0),(0,y.$Cr)(c.$Aec,c.$zec,0),(0,y.$Cr)(o.$VM,o.$SM,0),(0,y.$Cr)(l.$jec,l.$kec,0),(0,y.$Cr)(a.$Lec,a.$Mec,0)}),define(Ae[292],Re([1,0,290,37,2,287,7,14,275]),function(we,e,y,F,A,M,R,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zhc=void 0;class f extends M.$Sfc{j(){}getModule(b,v){for(const g of this.b){const t=g(b);if(t){b=t;break}}if(this.a.has(b))return this.a.get(b).load(b,v,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class P extends F.$Hec{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(E.$Yhc);const b=this.h.invokeFunction(y.$Ofc);this.r=this.h.createInstance(f,b,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(b){return b.browser}async vb(b,v,g){v=v.with({path:D(v.path,".js")});const t=b?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const i=A.URI.revive(await this.C.$asBrowserUri(v)),r=await fetch(i.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),r.status!==200)throw new Error(r.statusText);const c=await r.text(),o=`${v.toString(!0)}#vscode-extension`,l=`${c}
//# sourceURL=${o}`;let n;try{n=new Function("module","exports","require",l)}catch(p){throw console.error(t?`Loading code for extension ${t} failed: ${p.message}`:`Loading code failed: ${p.message}`),console.error(`${v.toString(!0)}${typeof p.line=="number"?` line ${p.line}`:""}${typeof p.column=="number"?` column ${p.column}`:""}`),console.error(p),p}b&&await this.w.initializeLocalizedMessages(b);const s={},a={exports:s},d=p=>{const m=this.r.getModule(p,v);if(m===void 0)throw new Error(`Cannot load module '${p}'`);return m};try{return g.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),n(a,s,d),a.exports!==s?a.exports:s}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),g.codeLoadingStop()}}async $setRemoteEnvironment(b){}async zb(b=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const v=Date.now()+b;for(;Date.now()<v&&!("__jsDebugIsReady"in globalThis);)await(0,$.$Yg)(10)}}e.$Zhc=P;function D(u,b){return u.endsWith(b)?u:u+b}}),define(Ae[293],Re([1,0,69,70,15,37,200,86,292]),function(we,e,y,F,A,M,R,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,F.$Cr)(A.$dj,new y.$Sh(R.$Rfc,[!0],!0)),(0,F.$Cr)(M.$Iec,E.$Zhc,0),(0,F.$Cr)($.$aec,$.$bec,0)}),define(Ae[299],Re([1,0,24,5,79,288,277,20,88,13,2,291,293]),function(we,e,y,F,A,M,R,$,E,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const D=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const u=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function b(n){return/^(file|vscode-remote):/i.test(n)}const v=fetch.bind(self);function g(n){self.fetch=async function(s,a){return s instanceof Request||b(String(s))&&(s=(await n(P.URI.parse(String(s)))).toString(!0)),v(s,a)},self.XMLHttpRequest=class extends XMLHttpRequest{open(s,a,d,p,m){(async()=>(b(a.toString())&&(a=(await n(P.URI.parse(a.toString()))).toString(!0)),super.open(s,a,d??!0,p,m)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const n=self.Worker;Worker=function(s,a){if(/^file:/i.test(s.toString()))s=f.$gg.uriToBrowserUri(P.URI.parse(s.toString())).toString(!0);else if(/^vscode-remote:/i.test(s.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const p=`(${function(h){function w(V){return typeof V=="string"||V instanceof URL?String(V).replace(/^file:\/\//i,"vscode-file://vscode-app"):V}const I=fetch.bind(self);self.fetch=function(V,Y){return V instanceof Request?I(V,Y):I(w(V),Y)},self.XMLHttpRequest=class extends XMLHttpRequest{open(V,Y,U,N,C){return super.open(V,w(Y),U??!0,N,C)}};const L=importScripts.bind(self);self.importScripts=(...V)=>{L(...V.map(w))},L(h)}.toString()}('${s}'))`;a=a||{},a.name=a.name||$.$mc(s.toString());const m=new Blob([p],{type:"application/javascript"}),S=URL.createObjectURL(m);return new n(S,a)}}else self.Worker=class extends R.$1hc{constructor(n,s){super(u,n,{name:$.$mc(n.toString()),...s})}};const t=new class{constructor(){this.pid=void 0}exit(n){D()}};class i{constructor(){const s=new MessageChannel,a=new F.$Rd;let d=!1;u(s.port2,[s.port2]),s.port1.onmessage=p=>{const{data:m}=p;if(!(m instanceof ArrayBuffer)){console.warn("UNKNOWN data received",m);return}const S=y.$fe.wrap(new Uint8Array(m,0,m.byteLength));if((0,A.$im)(S,2)){d=!0,c("received terminate message from renderer");return}a.fire(S)},this.protocol={onMessage:a.event,send:p=>{if(!d){const m=p.buffer.buffer.slice(p.buffer.byteOffset,p.buffer.byteOffset+p.buffer.byteLength);s.port1.postMessage(m,[m])}}}}}function r(n){return new Promise(s=>{const a=n.onMessage(d=>{a.dispose();const p=JSON.parse(d.toString());n.send((0,A.$hm)(0)),s({protocol:n,initData:p})});n.send((0,A.$hm)(1))})}let c=n=>D();function o(n){return!!n&&typeof n=="object"&&n.type==="vscode.init"&&n.data instanceof Map}function l(){E.mark("code/extHost/willConnectToRenderer");const n=new i;return{onmessage(s){o(s)&&r(n.protocol).then(a=>{E.mark("code/extHost/didWaitForInitData");const d=new M.$Ufc(a.protocol,a.initData,t,null,s.data);g(p=>d.asBrowserUri(p)),c=p=>d.terminate(p)})}}}e.create=l})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b3a649fe52c0fb8692c9b28dfe25227c97521884/core/vs/workbench/api/worker/extensionHostWorker.js.map
